/*===========================================================================*/
/*   (Ast/lvtype.scm)                                                        */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/lvtype.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	static obj_t
		BGl_z62lvtypezd2nodez12zd2setzd2exzd21270z70zzast_lvtypez00(obj_t, obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2letzd2var1267za2zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t
		BGl_setzd2variablezd2typez12z12zzast_lvtypez00(BgL_variablez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_z62lvtypezd2nodez12zd2boxzd2set1276za2zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2closure1241z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2sync1245z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2fail1261z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzast_lvtypez00();
	static obj_t BGl_z62lvtypezd2nodez12zd2sequenc1243z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_lvtypezd2nodezd2zzast_lvtypez00(BgL_nodez00_bglt);
	static obj_t BGl_methodzd2initzd2zzast_lvtypez00();
	extern obj_t BGl_externz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl_z62lvtypezd2nodez121232za2zzast_lvtypez00(obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static BgL_nodez00_bglt BGl_z62lvtypezd2nodezb0zzast_lvtypez00(obj_t, obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2jumpzd2ex1272za2zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_lvtypezd2astz12zc0zzast_lvtypez00(obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2app1247z70zzast_lvtypez00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_selectz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2astz12za2zzast_lvtypez00(obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2conditi1259z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_lvtypez00 = BUNSPEC;
	static obj_t BGl_z62lvtypezd2nodez12zd2funcall1251z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2cast1255z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2appzd2ly1249za2zzast_lvtypez00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2setq1257z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2select1263z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_lvtypez00();
	static obj_t BGl_z62lvtypezd2nodez12zd2boxzd2ref1278za2zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_bglt);
	static obj_t BGl_genericzd2initzd2zzast_lvtypez00();
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2extern1253z70zzast_lvtypez00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2makezd2bo1274za2zzast_lvtypez00(obj_t,
		obj_t);
	static bool_t BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00(obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_getzd2typezd2zztype_typeofz00(BgL_nodez00_bglt);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12za2zzast_lvtypez00(obj_t, obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2var1239z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2atom1235z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2kwote1237z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_lvtypez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_lvtypez00();
	static obj_t BGl_importedzd2moduleszd2initz00zzast_lvtypez00();
	static obj_t BGl_z62lvtypezd2nodez12zd2letzd2fun1265za2zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t __cnst[1];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_lvtypezd2nodezd2envz00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1743z00, BGl_z62lvtypezd2nodezb0zzast_lvtypez00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1711z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1744z00,
		BGl_z62lvtypezd2nodez121232za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1714z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1745z00,
		BGl_z62lvtypezd2nodez12zd2atom1235z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1716z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1746z00,
		BGl_z62lvtypezd2nodez12zd2kwote1237z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1717z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1747z00,
		BGl_z62lvtypezd2nodez12zd2var1239z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1718z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1748z00,
		BGl_z62lvtypezd2nodez12zd2closure1241z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1719z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1749z00,
		BGl_z62lvtypezd2nodez12zd2sequenc1243z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1720z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1750z00,
		BGl_z62lvtypezd2nodez12zd2sync1245z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1721z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1751z00,
		BGl_z62lvtypezd2nodez12zd2app1247z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1722z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1752z00,
		BGl_z62lvtypezd2nodez12zd2appzd2ly1249za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1723z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1753z00,
		BGl_z62lvtypezd2nodez12zd2funcall1251z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1724z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1754z00,
		BGl_z62lvtypezd2nodez12zd2extern1253z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1725z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1755z00,
		BGl_z62lvtypezd2nodez12zd2cast1255z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1726z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1756z00,
		BGl_z62lvtypezd2nodez12zd2setq1257z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1727z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1757z00,
		BGl_z62lvtypezd2nodez12zd2conditi1259z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1728z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1758z00,
		BGl_z62lvtypezd2nodez12zd2fail1261z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1729z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1759z00,
		BGl_z62lvtypezd2nodez12zd2select1263z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1730z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1760z00,
		BGl_z62lvtypezd2nodez12zd2letzd2fun1265za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1731z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1761z00,
		BGl_z62lvtypezd2nodez12zd2letzd2var1267za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1732z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1762z00,
		BGl_z62lvtypezd2nodez12zd2setzd2exzd21270z70zzast_lvtypez00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1733z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1763z00,
		BGl_z62lvtypezd2nodez12zd2jumpzd2ex1272za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1734z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1764z00,
		BGl_z62lvtypezd2nodez12zd2makezd2bo1274za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1735z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1765z00,
		BGl_z62lvtypezd2nodez12zd2boxzd2set1276za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1736z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1766z00,
		BGl_z62lvtypezd2nodez12zd2boxzd2ref1278za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_lvtypezd2astz12zd2envz12zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2astza71767za7,
		BGl_z62lvtypezd2astz12za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1768z00,
		BGl_z62lvtypezd2nodez12za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1712z00zzast_lvtypez00,
		BgL_bgl_string1712za700za7za7a1769za7, "lvtype-node!1232", 16);
	      DEFINE_STRING(BGl_string1713z00zzast_lvtypez00,
		BgL_bgl_string1713za700za7za7a1770za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string1715z00zzast_lvtypez00,
		BgL_bgl_string1715za700za7za7a1771za7, "lvtype-node!", 12);
	      DEFINE_STRING(BGl_string1737z00zzast_lvtypez00,
		BgL_bgl_string1737za700za7za7a1772za7, "Unexpected closure", 18);
	      DEFINE_STRING(BGl_string1738z00zzast_lvtypez00,
		BgL_bgl_string1738za700za7za7a1773za7, "ast_lvtype", 10);
	      DEFINE_STRING(BGl_string1739z00zzast_lvtypez00,
		BgL_bgl_string1739za700za7za7a1774za7, "lvtype-node!1232 ", 17);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long
		BgL_checksumz00_1752, char *BgL_fromz00_1753)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_lvtypez00))
				{
					BGl_requirezd2initializa7ationz75zzast_lvtypez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_lvtypez00();
					BGl_cnstzd2initzd2zzast_lvtypez00();
					BGl_importedzd2moduleszd2initz00zzast_lvtypez00();
					BGl_genericzd2initzd2zzast_lvtypez00();
					BGl_methodzd2initzd2zzast_lvtypez00();
					return BGl_toplevelzd2initzd2zzast_lvtypez00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_lvtypez00()
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 16 */
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_lvtype");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_lvtypez00()
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 16 */
			{	/* Ast/lvtype.scm 16 */
				obj_t BgL_cportz00_1737;

				{	/* Ast/lvtype.scm 16 */
					obj_t BgL_startz00_1746;

					BgL_startz00_1746 = BINT(((long) 0));
					{	/* Ast/lvtype.scm 16 */
						obj_t BgL_endz00_1747;

						BgL_endz00_1747 =
							BINT(STRING_LENGTH(BGl_string1739z00zzast_lvtypez00));
						{	/* Ast/lvtype.scm 16 */

							BgL_cportz00_1737 =
								BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
								(BGl_string1739z00zzast_lvtypez00, BgL_startz00_1746,
								BgL_endz00_1747);
				}}}
				{
					long BgL_iz00_1738;

					BgL_iz00_1738 = ((long) 0);
				BgL_loopz00_1739:
					if ((BgL_iz00_1738 == ((long) -1)))
						{	/* Ast/lvtype.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Ast/lvtype.scm 16 */
							{	/* Ast/lvtype.scm 16 */
								obj_t BgL_arg1741z00_1741;

								{	/* Ast/lvtype.scm 16 */

									{	/* Ast/lvtype.scm 16 */
										obj_t BgL_locationz00_1743;

										BgL_locationz00_1743 = BBOOL(((bool_t) 0));
										{	/* Ast/lvtype.scm 16 */

											BgL_arg1741z00_1741 =
												BGl_readz00zz__readerz00(BgL_cportz00_1737,
												BgL_locationz00_1743);
										}
									}
								}
								{	/* Ast/lvtype.scm 16 */
									int BgL_auxz00_1779;

									BgL_auxz00_1779 = (int) (BgL_iz00_1738);
									CNST_TABLE_SET(BgL_auxz00_1779, BgL_arg1741z00_1741);
							}}
							{	/* Ast/lvtype.scm 16 */
								int BgL_auxz00_1744;

								BgL_auxz00_1744 = (int) ((BgL_iz00_1738 - ((long) 1)));
								{
									long BgL_iz00_1784;

									BgL_iz00_1784 = (long) (BgL_auxz00_1744);
									BgL_iz00_1738 = BgL_iz00_1784;
									goto BgL_loopz00_1739;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_lvtypez00()
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 16 */
			return BUNSPEC;
		}
	}



/* lvtype-ast! */
	BGL_EXPORTED_DEF obj_t BGl_lvtypezd2astz12zc0zzast_lvtypez00(obj_t
		BgL_astz00_3)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 31 */
			{
				obj_t BgL_l1219z00_1237;

				BgL_l1219z00_1237 = BgL_astz00_3;
			BgL_zc3anonymousza31317ze3z83_1238:
				if (PAIRP(BgL_l1219z00_1237))
					{	/* Ast/lvtype.scm 32 */
						{	/* Ast/lvtype.scm 33 */
							obj_t BgL_gz00_1240;

							BgL_gz00_1240 = CAR(BgL_l1219z00_1237);
							{	/* Ast/lvtype.scm 33 */
								obj_t BgL_arg1328z00_1241;

								BgL_arg1328z00_1241 =
									(((BgL_sfunz00_bglt) CREF(
											((BgL_sfunz00_bglt)
												(((BgL_variablez00_bglt) CREF(
															((BgL_variablez00_bglt)
																((BgL_globalz00_bglt) BgL_gz00_1240))))->
													BgL_valuez00))))->BgL_bodyz00);
								BGl_lvtypezd2nodez12zc0zzast_lvtypez00(((BgL_nodez00_bglt)
										BgL_arg1328z00_1241));
							}
						}
						{
							obj_t BgL_l1219z00_1796;

							BgL_l1219z00_1796 = CDR(BgL_l1219z00_1237);
							BgL_l1219z00_1237 = BgL_l1219z00_1796;
							goto BgL_zc3anonymousza31317ze3z83_1238;
						}
					}
				else
					{	/* Ast/lvtype.scm 32 */
						((bool_t) 1);
					}
			}
			return BgL_astz00_3;
		}
	}



/* &lvtype-ast! */
	obj_t BGl_z62lvtypezd2astz12za2zzast_lvtypez00(obj_t BgL_envz00_1662,
		obj_t BgL_astz00_1663)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 31 */
			return BGl_lvtypezd2astz12zc0zzast_lvtypez00(BgL_astz00_1663);
		}
	}



/* lvtype-node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_lvtypezd2nodezd2zzast_lvtypez00(BgL_nodez00_bglt BgL_nodez00_4)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 40 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_4);
			return BgL_nodez00_4;
		}
	}



/* &lvtype-node */
	BgL_nodez00_bglt BGl_z62lvtypezd2nodezb0zzast_lvtypez00(obj_t BgL_envz00_1664,
		obj_t BgL_nodez00_1665)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 40 */
			return
				BGl_lvtypezd2nodezd2zzast_lvtypez00(
				((BgL_nodez00_bglt) BgL_nodez00_1665));
		}
	}



/* lvtype-node*! */
	bool_t BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00(obj_t BgL_nodeza2za2_28)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 241 */
			{
				obj_t BgL_l1230z00_1246;

				BgL_l1230z00_1246 = BgL_nodeza2za2_28;
			BgL_zc3anonymousza31336ze3z83_1247:
				if (PAIRP(BgL_l1230z00_1246))
					{	/* Ast/lvtype.scm 242 */
						{	/* Ast/lvtype.scm 242 */
							obj_t BgL_arg1344z00_1249;

							BgL_arg1344z00_1249 = CAR(BgL_l1230z00_1246);
							BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
								((BgL_nodez00_bglt) BgL_arg1344z00_1249));
						}
						{
							obj_t BgL_l1230z00_1807;

							BgL_l1230z00_1807 = CDR(BgL_l1230z00_1246);
							BgL_l1230z00_1246 = BgL_l1230z00_1807;
							goto BgL_zc3anonymousza31336ze3z83_1247;
						}
					}
				else
					{	/* Ast/lvtype.scm 242 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* set-variable-type! */
	obj_t BGl_setzd2variablezd2typez12z12zzast_lvtypez00(BgL_variablez00_bglt
		BgL_variablez00_29, BgL_typez00_bglt BgL_typez00_30)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 247 */
			{	/* Ast/lvtype.scm 248 */
				obj_t BgL_ntypez00_1252;
				BgL_typez00_bglt BgL_otypez00_1253;

				if ((((obj_t) BgL_typez00_30) == BGl_za2_za2z00zztype_cachez00))
					{	/* Ast/lvtype.scm 248 */
						BgL_ntypez00_1252 = BGl_za2objza2z00zztype_cachez00;
					}
				else
					{	/* Ast/lvtype.scm 248 */
						BgL_ntypez00_1252 = ((obj_t) BgL_typez00_30);
					}
				BgL_otypez00_1253 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_29))->BgL_typez00);
				if ((((obj_t) BgL_otypez00_1253) == BGl_za2_za2z00zztype_cachez00))
					{	/* Ast/lvtype.scm 250 */
						return
							((((BgL_variablez00_bglt) CREF(BgL_variablez00_29))->
								BgL_typez00) =
							((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_ntypez00_1252)),
							BUNSPEC);
					}
				else
					{	/* Ast/lvtype.scm 250 */
						return BFALSE;
					}
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_lvtypez00()
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 16 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_lvtypez00()
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 16 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_proc1711z00zzast_lvtypez00, BGl_nodez00zzast_nodez00,
				BGl_string1712z00zzast_lvtypez00);
		}
	}



/* &lvtype-node!1232 */
	obj_t BGl_z62lvtypezd2nodez121232za2zzast_lvtypez00(obj_t BgL_envz00_1667,
		obj_t BgL_nodez00_1668)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 47 */
			{
				BgL_nodez00_bglt BgL_nodez00_1257;

				BgL_nodez00_1257 = ((BgL_nodez00_bglt) BgL_nodez00_1668);
				return
					BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
					BGl_string1713z00zzast_lvtypez00, ((obj_t) BgL_nodez00_1257));
		}}
	}



/* lvtype-node! */
	BGL_EXPORTED_DEF obj_t BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_bglt
		BgL_nodez00_5)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 47 */
			{	/* Ast/lvtype.scm 47 */
				obj_t BgL_method1233z00_1260;

				{	/* Ast/lvtype.scm 47 */
					obj_t BgL_res1707z00_1634;

					{	/* Ast/lvtype.scm 47 */
						long BgL_objzd2classzd2numz00_1607;

						{	/* Ast/lvtype.scm 47 */
							long BgL_res1701z00_1610;

							BgL_res1701z00_1610 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_5));
							BgL_objzd2classzd2numz00_1607 = BgL_res1701z00_1610;
						}
						{	/* Ast/lvtype.scm 47 */
							obj_t BgL_arg1664z00_1608;

							BgL_arg1664z00_1608 =
								PROCEDURE_REF(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
								(int) (((long) 1)));
							{	/* Ast/lvtype.scm 47 */
								int BgL_offsetz00_1612;

								BgL_offsetz00_1612 = (int) (BgL_objzd2classzd2numz00_1607);
								{	/* Ast/lvtype.scm 47 */
									long BgL_offsetz00_1613;

									BgL_offsetz00_1613 =
										((long) (BgL_offsetz00_1612) - OBJECT_TYPE);
									{	/* Ast/lvtype.scm 47 */
										long BgL_modz00_1614;

										{	/* Ast/lvtype.scm 47 */
											int BgL_arg1666z00_1615;

											BgL_arg1666z00_1615 = (int) (((long) 16));
											{	/* Ast/lvtype.scm 47 */
												long BgL_res1704z00_1625;

												{	/* Ast/lvtype.scm 47 */
													long BgL_auxz00_1832;

													BgL_auxz00_1832 = (long) (BgL_arg1666z00_1615);
													BgL_res1704z00_1625 =
														(BgL_offsetz00_1613 / BgL_auxz00_1832);
												}
												BgL_modz00_1614 = BgL_res1704z00_1625;
										}}
										{	/* Ast/lvtype.scm 47 */
											long BgL_restz00_1616;

											{	/* Ast/lvtype.scm 47 */
												int BgL_arg1665z00_1617;

												BgL_arg1665z00_1617 = (int) (((long) 16));
												{	/* Ast/lvtype.scm 47 */
													long BgL_res1706z00_1629;

													{	/* Ast/lvtype.scm 47 */
														long BgL_auxz00_1836;

														BgL_auxz00_1836 = (long) (BgL_arg1665z00_1617);
														BgL_res1706z00_1629 =
															(BgL_offsetz00_1613 % BgL_auxz00_1836);
													}
													BgL_restz00_1616 = BgL_res1706z00_1629;
											}}
											{	/* Ast/lvtype.scm 47 */

												BgL_res1707z00_1634 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_1608,
														(int) (BgL_modz00_1614)), (int) (BgL_restz00_1616));
					}}}}}}}
					BgL_method1233z00_1260 = BgL_res1707z00_1634;
				}
				return
					PROCEDURE_ENTRY(BgL_method1233z00_1260) (BgL_method1233z00_1260,
					((obj_t) BgL_nodez00_5), BEOA);
			}
		}
	}



/* &lvtype-node! */
	obj_t BGl_z62lvtypezd2nodez12za2zzast_lvtypez00(obj_t BgL_envz00_1669,
		obj_t BgL_nodez00_1670)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 47 */
			return
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				((BgL_nodez00_bglt) BgL_nodez00_1670));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_lvtypez00()
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 16 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_atomz00zzast_nodez00,
				BGl_proc1714z00zzast_lvtypez00, BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_kwotez00zzast_nodez00, BGl_proc1716z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_varz00zzast_nodez00,
				BGl_proc1717z00zzast_lvtypez00, BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_closurez00zzast_nodez00, BGl_proc1718z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_sequencez00zzast_nodez00, BGl_proc1719z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_syncz00zzast_nodez00,
				BGl_proc1720z00zzast_lvtypez00, BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_appz00zzast_nodez00,
				BGl_proc1721z00zzast_lvtypez00, BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc1722z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_funcallz00zzast_nodez00, BGl_proc1723z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_externz00zzast_nodez00, BGl_proc1724z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_castz00zzast_nodez00,
				BGl_proc1725z00zzast_lvtypez00, BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_setqz00zzast_nodez00,
				BGl_proc1726z00zzast_lvtypez00, BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc1727z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_failz00zzast_nodez00,
				BGl_proc1728z00zzast_lvtypez00, BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_selectz00zzast_nodez00, BGl_proc1729z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc1730z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc1731z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc1732z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc1733z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc1734z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc1735z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc1736z00zzast_lvtypez00,
				BGl_string1715z00zzast_lvtypez00);
		}
	}



/* &lvtype-node!-box-ref1278 */
	obj_t BGl_z62lvtypezd2nodez12zd2boxzd2ref1278za2zzast_lvtypez00(obj_t
		BgL_envz00_1693, obj_t BgL_nodez00_1694)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 234 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1440;

				BgL_nodez00_1440 = ((BgL_boxzd2refzd2_bglt) BgL_nodez00_1694);
				{	/* Ast/lvtype.scm 236 */
					BgL_varz00_bglt BgL_arg1606z00_1661;

					BgL_arg1606z00_1661 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1440))->BgL_varz00);
					return
						BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
						((BgL_nodez00_bglt) BgL_arg1606z00_1661));
				}
			}
		}
	}



/* &lvtype-node!-box-set1276 */
	obj_t BGl_z62lvtypezd2nodez12zd2boxzd2set1276za2zzast_lvtypez00(obj_t
		BgL_envz00_1695, obj_t BgL_nodez00_1696)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 226 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1433;

				BgL_nodez00_1433 = ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_1696);
				{	/* Ast/lvtype.scm 228 */
					BgL_varz00_bglt BgL_arg1591z00_1437;

					BgL_arg1591z00_1437 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1433))->BgL_varz00);
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
						((BgL_nodez00_bglt) BgL_arg1591z00_1437));
				}
				return
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1433))->BgL_valuez00));
			}
		}
	}



/* &lvtype-node!-make-bo1274 */
	obj_t BGl_z62lvtypezd2nodez12zd2makezd2bo1274za2zzast_lvtypez00(obj_t
		BgL_envz00_1697, obj_t BgL_nodez00_1698)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 219 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1427;

				BgL_nodez00_1427 = ((BgL_makezd2boxzd2_bglt) BgL_nodez00_1698);
				return
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1427))->BgL_valuez00));
			}
		}
	}



/* &lvtype-node!-jump-ex1272 */
	obj_t BGl_z62lvtypezd2nodez12zd2jumpzd2ex1272za2zzast_lvtypez00(obj_t
		BgL_envz00_1699, obj_t BgL_nodez00_1700)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 211 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1420;

				BgL_nodez00_1420 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_1700);
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1420))->BgL_exitz00));
				return
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1420))->
						BgL_valuez00));
			}
		}
	}



/* &lvtype-node!-set-ex-1270 */
	obj_t BGl_z62lvtypezd2nodez12zd2setzd2exzd21270z70zzast_lvtypez00(obj_t
		BgL_envz00_1701, obj_t BgL_nodez00_1702)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 203 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1413;

				BgL_nodez00_1413 = ((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_1702);
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1413))->BgL_bodyz00));
				{	/* Ast/lvtype.scm 206 */
					BgL_varz00_bglt BgL_arg1576z00_1418;

					BgL_arg1576z00_1418 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1413))->BgL_varz00);
					return
						BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
						((BgL_nodez00_bglt) BgL_arg1576z00_1418));
				}
			}
		}
	}



/* &lvtype-node!-let-var1267 */
	obj_t BGl_z62lvtypezd2nodez12zd2letzd2var1267za2zzast_lvtypez00(obj_t
		BgL_envz00_1703, obj_t BgL_nodez00_1704)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 188 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1393;

				BgL_nodez00_1393 = ((BgL_letzd2varzd2_bglt) BgL_nodez00_1704);
				{	/* Ast/lvtype.scm 190 */
					obj_t BgL_g1229z00_1397;

					BgL_g1229z00_1397 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1393))->BgL_bindingsz00);
					{
						obj_t BgL_l1227z00_1399;

						BgL_l1227z00_1399 = BgL_g1229z00_1397;
					BgL_zc3anonymousza31548ze3z83_1400:
						if (PAIRP(BgL_l1227z00_1399))
							{	/* Ast/lvtype.scm 190 */
								{	/* Ast/lvtype.scm 191 */
									obj_t BgL_bindingz00_1402;

									BgL_bindingz00_1402 = CAR(BgL_l1227z00_1399);
									{	/* Ast/lvtype.scm 191 */
										obj_t BgL_varz00_1403;
										obj_t BgL_valz00_1404;

										BgL_varz00_1403 = CAR(BgL_bindingz00_1402);
										BgL_valz00_1404 = CDR(BgL_bindingz00_1402);
										BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
											((BgL_nodez00_bglt) BgL_valz00_1404));
										{	/* Ast/lvtype.scm 194 */
											BgL_typez00_bglt BgL_arg1552z00_1405;

											BgL_arg1552z00_1405 =
												BGl_getzd2typezd2zztype_typeofz00(
												((BgL_nodez00_bglt) BgL_valz00_1404));
											BGl_setzd2variablezd2typez12z12zzast_lvtypez00(
												((BgL_variablez00_bglt) BgL_varz00_1403),
												BgL_arg1552z00_1405);
										}
									}
								}
								{
									obj_t BgL_l1227z00_1908;

									BgL_l1227z00_1908 = CDR(BgL_l1227z00_1399);
									BgL_l1227z00_1399 = BgL_l1227z00_1908;
									goto BgL_zc3anonymousza31548ze3z83_1400;
								}
							}
						else
							{	/* Ast/lvtype.scm 190 */
								((bool_t) 1);
							}
					}
				}
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1393))->BgL_bodyz00));
				{	/* Ast/lvtype.scm 197 */
					bool_t BgL_testz00_1912;

					{	/* Ast/lvtype.scm 197 */
						BgL_typez00_bglt BgL_arg1571z00_1411;

						BgL_arg1571z00_1411 =
							(((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_nodez00_1393)))->BgL_typez00);
						BgL_testz00_1912 =
							(((obj_t) BgL_arg1571z00_1411) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_testz00_1912)
						{
							BgL_typez00_bglt BgL_auxz00_1917;

							{	/* Ast/lvtype.scm 198 */
								BgL_nodez00_bglt BgL_arg1569z00_1410;

								BgL_arg1569z00_1410 =
									(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1393))->
									BgL_bodyz00);
								BgL_auxz00_1917 =
									BGl_getzd2typezd2zztype_typeofz00(BgL_arg1569z00_1410);
							}
							return
								((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_1393)))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_auxz00_1917), BUNSPEC);
						}
					else
						{	/* Ast/lvtype.scm 197 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &lvtype-node!-let-fun1265 */
	obj_t BGl_z62lvtypezd2nodez12zd2letzd2fun1265za2zzast_lvtypez00(obj_t
		BgL_envz00_1705, obj_t BgL_nodez00_1706)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 176 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1374;

				BgL_nodez00_1374 = ((BgL_letzd2funzd2_bglt) BgL_nodez00_1706);
				{	/* Ast/lvtype.scm 178 */
					obj_t BgL_g1226z00_1378;

					BgL_g1226z00_1378 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1374))->BgL_localsz00);
					{
						obj_t BgL_l1224z00_1380;

						BgL_l1224z00_1380 = BgL_g1226z00_1378;
					BgL_zc3anonymousza31512ze3z83_1381:
						if (PAIRP(BgL_l1224z00_1380))
							{	/* Ast/lvtype.scm 178 */
								{	/* Ast/lvtype.scm 179 */
									obj_t BgL_localz00_1383;

									BgL_localz00_1383 = CAR(BgL_l1224z00_1380);
									{	/* Ast/lvtype.scm 179 */
										obj_t BgL_arg1516z00_1384;

										BgL_arg1516z00_1384 =
											(((BgL_sfunz00_bglt) CREF(
													((BgL_sfunz00_bglt)
														(((BgL_variablez00_bglt) CREF(
																	((BgL_variablez00_bglt)
																		((BgL_localz00_bglt) BgL_localz00_1383))))->
															BgL_valuez00))))->BgL_bodyz00);
										BGl_lvtypezd2nodez12zc0zzast_lvtypez00(((BgL_nodez00_bglt)
												BgL_arg1516z00_1384));
									}
								}
								{
									obj_t BgL_l1224z00_1934;

									BgL_l1224z00_1934 = CDR(BgL_l1224z00_1380);
									BgL_l1224z00_1380 = BgL_l1224z00_1934;
									goto BgL_zc3anonymousza31512ze3z83_1381;
								}
							}
						else
							{	/* Ast/lvtype.scm 178 */
								((bool_t) 1);
							}
					}
				}
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1374))->BgL_bodyz00));
				{	/* Ast/lvtype.scm 182 */
					bool_t BgL_testz00_1938;

					{	/* Ast/lvtype.scm 182 */
						BgL_typez00_bglt BgL_arg1547z00_1391;

						BgL_arg1547z00_1391 =
							(((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_nodez00_1374)))->BgL_typez00);
						BgL_testz00_1938 =
							(((obj_t) BgL_arg1547z00_1391) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_testz00_1938)
						{
							BgL_typez00_bglt BgL_auxz00_1943;

							{	/* Ast/lvtype.scm 183 */
								BgL_nodez00_bglt BgL_arg1530z00_1390;

								BgL_arg1530z00_1390 =
									(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1374))->
									BgL_bodyz00);
								BgL_auxz00_1943 =
									BGl_getzd2typezd2zztype_typeofz00(BgL_arg1530z00_1390);
							}
							return
								((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_1374)))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_auxz00_1943), BUNSPEC);
						}
					else
						{	/* Ast/lvtype.scm 182 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &lvtype-node!-select1263 */
	obj_t BGl_z62lvtypezd2nodez12zd2select1263z70zzast_lvtypez00(obj_t
		BgL_envz00_1707, obj_t BgL_nodez00_1708)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 166 */
			{
				BgL_selectz00_bglt BgL_nodez00_1359;

				BgL_nodez00_1359 = ((BgL_selectz00_bglt) BgL_nodez00_1708);
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_selectz00_bglt) CREF(BgL_nodez00_1359))->BgL_testz00));
				{	/* Ast/lvtype.scm 169 */
					obj_t BgL_g1223z00_1364;

					BgL_g1223z00_1364 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1359))->BgL_clausesz00);
					{
						obj_t BgL_l1221z00_1366;

						{	/* Ast/lvtype.scm 169 */
							bool_t BgL_auxz00_1952;

							BgL_l1221z00_1366 = BgL_g1223z00_1364;
						BgL_zc3anonymousza31506ze3z83_1367:
							if (PAIRP(BgL_l1221z00_1366))
								{	/* Ast/lvtype.scm 169 */
									{	/* Ast/lvtype.scm 170 */
										obj_t BgL_clausez00_1369;

										BgL_clausez00_1369 = CAR(BgL_l1221z00_1366);
										{	/* Ast/lvtype.scm 170 */
											obj_t BgL_arg1509z00_1370;

											BgL_arg1509z00_1370 = CDR(BgL_clausez00_1369);
											BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
												((BgL_nodez00_bglt) BgL_arg1509z00_1370));
										}
									}
									{
										obj_t BgL_l1221z00_1959;

										BgL_l1221z00_1959 = CDR(BgL_l1221z00_1366);
										BgL_l1221z00_1366 = BgL_l1221z00_1959;
										goto BgL_zc3anonymousza31506ze3z83_1367;
									}
								}
							else
								{	/* Ast/lvtype.scm 169 */
									BgL_auxz00_1952 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_1952);
						}
					}
				}
			}
		}
	}



/* &lvtype-node!-fail1261 */
	obj_t BGl_z62lvtypezd2nodez12zd2fail1261z70zzast_lvtypez00(obj_t
		BgL_envz00_1709, obj_t BgL_nodez00_1710)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 157 */
			{
				BgL_failz00_bglt BgL_nodez00_1351;

				BgL_nodez00_1351 = ((BgL_failz00_bglt) BgL_nodez00_1710);
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_1351))->BgL_procz00));
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_1351))->BgL_msgz00));
				return
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_1351))->BgL_objz00));
			}
		}
	}



/* &lvtype-node!-conditi1259 */
	obj_t BGl_z62lvtypezd2nodez12zd2conditi1259z70zzast_lvtypez00(obj_t
		BgL_envz00_1711, obj_t BgL_nodez00_1712)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 146 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1341;

				BgL_nodez00_1341 = ((BgL_conditionalz00_bglt) BgL_nodez00_1712);
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1341))->BgL_testz00));
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1341))->BgL_truez00));
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1341))->BgL_falsez00));
				{	/* Ast/lvtype.scm 151 */
					bool_t BgL_testz00_1976;

					{	/* Ast/lvtype.scm 151 */
						BgL_typez00_bglt BgL_arg1493z00_1349;

						BgL_arg1493z00_1349 =
							(((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_nodez00_1341)))->BgL_typez00);
						BgL_testz00_1976 =
							(((obj_t) BgL_arg1493z00_1349) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_testz00_1976)
						{	/* Ast/lvtype.scm 151 */
							return
								((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_1341)))->BgL_typez00) =
								((BgL_typez00_bglt)
									BGl_getzd2typezd2zztype_typeofz00(((BgL_nodez00_bglt)
											BgL_nodez00_1341))), BUNSPEC);
						}
					else
						{	/* Ast/lvtype.scm 151 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &lvtype-node!-setq1257 */
	obj_t BGl_z62lvtypezd2nodez12zd2setq1257z70zzast_lvtypez00(obj_t
		BgL_envz00_1713, obj_t BgL_nodez00_1714)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 138 */
			{
				BgL_setqz00_bglt BgL_nodez00_1334;

				BgL_nodez00_1334 = ((BgL_setqz00_bglt) BgL_nodez00_1714);
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_setqz00_bglt) CREF(BgL_nodez00_1334))->BgL_valuez00));
				{	/* Ast/lvtype.scm 141 */
					BgL_varz00_bglt BgL_arg1482z00_1339;

					BgL_arg1482z00_1339 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1334))->BgL_varz00);
					return
						BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
						((BgL_nodez00_bglt) BgL_arg1482z00_1339));
				}
			}
		}
	}



/* &lvtype-node!-cast1255 */
	obj_t BGl_z62lvtypezd2nodez12zd2cast1255z70zzast_lvtypez00(obj_t
		BgL_envz00_1715, obj_t BgL_nodez00_1716)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 131 */
			{
				BgL_castz00_bglt BgL_nodez00_1328;

				BgL_nodez00_1328 = ((BgL_castz00_bglt) BgL_nodez00_1716);
				return
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_castz00_bglt) CREF(BgL_nodez00_1328))->BgL_argz00));
			}
		}
	}



/* &lvtype-node!-extern1253 */
	obj_t BGl_z62lvtypezd2nodez12zd2extern1253z70zzast_lvtypez00(obj_t
		BgL_envz00_1717, obj_t BgL_nodez00_1718)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 124 */
			{
				BgL_externz00_bglt BgL_nodez00_1322;

				BgL_nodez00_1322 = ((BgL_externz00_bglt) BgL_nodez00_1718);
				{	/* Ast/lvtype.scm 126 */
					obj_t BgL_arg1467z00_1638;

					BgL_arg1467z00_1638 =
						(((BgL_externz00_bglt) CREF(BgL_nodez00_1322))->BgL_exprza2za2);
					return
						BBOOL(BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00
						(BgL_arg1467z00_1638));
				}
			}
		}
	}



/* &lvtype-node!-funcall1251 */
	obj_t BGl_z62lvtypezd2nodez12zd2funcall1251z70zzast_lvtypez00(obj_t
		BgL_envz00_1719, obj_t BgL_nodez00_1720)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 116 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1315;

				BgL_nodez00_1315 = ((BgL_funcallz00_bglt) BgL_nodez00_1720);
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1315))->BgL_funz00));
				{	/* Ast/lvtype.scm 119 */
					obj_t BgL_arg1460z00_1320;

					BgL_arg1460z00_1320 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1315))->BgL_argsz00);
					return
						BBOOL(BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00
						(BgL_arg1460z00_1320));
				}
			}
		}
	}



/* &lvtype-node!-app-ly1249 */
	obj_t BGl_z62lvtypezd2nodez12zd2appzd2ly1249za2zzast_lvtypez00(obj_t
		BgL_envz00_1721, obj_t BgL_nodez00_1722)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 108 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1308;

				BgL_nodez00_1308 = ((BgL_appzd2lyzd2_bglt) BgL_nodez00_1722);
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1308))->BgL_funz00));
				return
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1308))->BgL_argz00));
			}
		}
	}



/* &lvtype-node!-app1247 */
	obj_t BGl_z62lvtypezd2nodez12zd2app1247z70zzast_lvtypez00(obj_t
		BgL_envz00_1723, obj_t BgL_nodez00_1724)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 99 */
			{
				BgL_appz00_bglt BgL_nodez00_1300;

				BgL_nodez00_1300 = ((BgL_appz00_bglt) BgL_nodez00_1724);
				BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00(
					(((BgL_appz00_bglt) CREF(BgL_nodez00_1300))->BgL_argsz00));
				{	/* Ast/lvtype.scm 102 */
					bool_t BgL_testz00_2012;

					{	/* Ast/lvtype.scm 102 */
						BgL_typez00_bglt BgL_arg1447z00_1306;

						BgL_arg1447z00_1306 =
							(((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_nodez00_1300)))->BgL_typez00);
						BgL_testz00_2012 =
							(((obj_t) BgL_arg1447z00_1306) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_testz00_2012)
						{	/* Ast/lvtype.scm 102 */
							return
								((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_1300)))->BgL_typez00) =
								((BgL_typez00_bglt)
									BGl_getzd2typezd2zztype_typeofz00(((BgL_nodez00_bglt)
											BgL_nodez00_1300))), BUNSPEC);
						}
					else
						{	/* Ast/lvtype.scm 102 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &lvtype-node!-sync1245 */
	obj_t BGl_z62lvtypezd2nodez12zd2sync1245z70zzast_lvtypez00(obj_t
		BgL_envz00_1725, obj_t BgL_nodez00_1726)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 88 */
			{
				BgL_syncz00_bglt BgL_nodez00_1290;

				BgL_nodez00_1290 = ((BgL_syncz00_bglt) BgL_nodez00_1726);
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_1290))->BgL_mutexz00));
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_1290))->BgL_prelockz00));
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_1290))->BgL_bodyz00));
				{	/* Ast/lvtype.scm 93 */
					bool_t BgL_testz00_2028;

					{	/* Ast/lvtype.scm 93 */
						BgL_typez00_bglt BgL_arg1441z00_1298;

						BgL_arg1441z00_1298 =
							(((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_nodez00_1290)))->BgL_typez00);
						BgL_testz00_2028 =
							(((obj_t) BgL_arg1441z00_1298) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_testz00_2028)
						{	/* Ast/lvtype.scm 93 */
							return
								((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_1290)))->BgL_typez00) =
								((BgL_typez00_bglt)
									BGl_getzd2typezd2zztype_typeofz00(((BgL_nodez00_bglt)
											BgL_nodez00_1290))), BUNSPEC);
						}
					else
						{	/* Ast/lvtype.scm 93 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &lvtype-node!-sequenc1243 */
	obj_t BGl_z62lvtypezd2nodez12zd2sequenc1243z70zzast_lvtypez00(obj_t
		BgL_envz00_1727, obj_t BgL_nodez00_1728)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 79 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1282;

				BgL_nodez00_1282 = ((BgL_sequencez00_bglt) BgL_nodez00_1728);
				BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00(
					(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1282))->BgL_nodesz00));
				{	/* Ast/lvtype.scm 82 */
					bool_t BgL_testz00_2040;

					{	/* Ast/lvtype.scm 82 */
						BgL_typez00_bglt BgL_arg1385z00_1288;

						BgL_arg1385z00_1288 =
							(((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_nodez00_1282)))->BgL_typez00);
						BgL_testz00_2040 =
							(((obj_t) BgL_arg1385z00_1288) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_testz00_2040)
						{	/* Ast/lvtype.scm 82 */
							return
								((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_1282)))->BgL_typez00) =
								((BgL_typez00_bglt)
									BGl_getzd2typezd2zztype_typeofz00(((BgL_nodez00_bglt)
											BgL_nodez00_1282))), BUNSPEC);
						}
					else
						{	/* Ast/lvtype.scm 82 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &lvtype-node!-closure1241 */
	obj_t BGl_z62lvtypezd2nodez12zd2closure1241z70zzast_lvtypez00(obj_t
		BgL_envz00_1729, obj_t BgL_nodez00_1730)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 73 */
			{
				BgL_closurez00_bglt BgL_nodez00_1277;

				BgL_nodez00_1277 = ((BgL_closurez00_bglt) BgL_nodez00_1730);
				{	/* Ast/lvtype.scm 74 */
					obj_t BgL_arg1374z00_1636;

					BgL_arg1374z00_1636 =
						BGl_shapez00zztools_shapez00(((obj_t) BgL_nodez00_1277));
					return
						BGl_internalzd2errorzd2zztools_errorz00
						(BGl_string1715z00zzast_lvtypez00, BGl_string1737z00zzast_lvtypez00,
						BgL_arg1374z00_1636);
				}
			}
		}
	}



/* &lvtype-node!-var1239 */
	obj_t BGl_z62lvtypezd2nodez12zd2var1239z70zzast_lvtypez00(obj_t
		BgL_envz00_1731, obj_t BgL_nodez00_1732)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 64 */
			{
				BgL_varz00_bglt BgL_nodez00_1269;

				BgL_nodez00_1269 = ((BgL_varz00_bglt) BgL_nodez00_1732);
				{	/* Ast/lvtype.scm 66 */
					bool_t BgL_testz00_2054;

					{	/* Ast/lvtype.scm 66 */
						BgL_typez00_bglt BgL_arg1372z00_1275;

						BgL_arg1372z00_1275 =
							(((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_nodez00_1269)))->BgL_typez00);
						BgL_testz00_2054 =
							(((obj_t) BgL_arg1372z00_1275) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_testz00_2054)
						{	/* Ast/lvtype.scm 66 */
							((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_1269)))->BgL_typez00) =
								((BgL_typez00_bglt) (((BgL_variablez00_bglt)
											CREF((((BgL_varz00_bglt) CREF(BgL_nodez00_1269))->
													BgL_variablez00)))->BgL_typez00)), BUNSPEC);
						}
					else
						{	/* Ast/lvtype.scm 66 */
							BFALSE;
						}
				}
				return ((obj_t) BgL_nodez00_1269);
			}
		}
	}



/* &lvtype-node!-kwote1237 */
	obj_t BGl_z62lvtypezd2nodez12zd2kwote1237z70zzast_lvtypez00(obj_t
		BgL_envz00_1733, obj_t BgL_nodez00_1734)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 58 */
			return ((obj_t) ((BgL_kwotez00_bglt) BgL_nodez00_1734));
		}
	}



/* &lvtype-node!-atom1235 */
	obj_t BGl_z62lvtypezd2nodez12zd2atom1235z70zzast_lvtypez00(obj_t
		BgL_envz00_1735, obj_t BgL_nodez00_1736)
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 52 */
			return ((obj_t) ((BgL_atomz00_bglt) BgL_nodez00_1736));
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_lvtypez00()
	{
		AN_OBJECT;
		{	/* Ast/lvtype.scm 16 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1738z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 216926614),
				BSTRING_TO_STRING(BGl_string1738z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 189813582),
				BSTRING_TO_STRING(BGl_string1738z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1738z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1738z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1738z00zzast_lvtypez00));
			return
				BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 458567972),
				BSTRING_TO_STRING(BGl_string1738z00zzast_lvtypez00));
		}
	}

#ifdef __cplusplus
}
#endif
