/*===========================================================================*/
/*   (Ast/venv.scm)                                                          */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/venv.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_isfunz00_bgl
	{
		struct BgL_nodez00_bgl *BgL_originalzd2bodyzd2;
		obj_t BgL_recursivezd2callszd2;
	}               *BgL_isfunz00_bglt;


	static obj_t BGl_z62globalzd2bucketzd2positionz62zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	static obj_t BGl_za2Genvza2z00zzast_envz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zzast_envz00();
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31329ze3ze1zzast_envz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_userzd2warningzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_z62unbindzd2globalz12za2zzast_envz00(obj_t, obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzast_envz00();
	BGL_EXPORTED_DECL obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	static obj_t BGl_z62restorezd2valuezd2typesz12z70zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt);
	static obj_t BGl_z62getzd2globalzf2modulez42zzast_envz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl_z62alreadyzd2restoredzf3z43zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121285z70zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121288z70zzast_envz00(obj_t,
		obj_t);
	extern obj_t BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_nodez00_bglt);
	static obj_t BGl_z62restorezd2valuezd2typesz121290z70zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121292z70zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121294z70zzast_envz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	static obj_t BGl_z62zc3anonymousza31673ze3ze1zzast_envz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt,
		obj_t);
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2getzd2zz__hashz00(obj_t, obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	BGL_IMPORT int BGl_bigloozd2warningzd2zz__paramz00();
	static obj_t BGl_requirezd2initializa7ationz75zzast_envz00 = BUNSPEC;
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
	extern obj_t BGl_funz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	extern obj_t BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_envz00();
	static obj_t BGl_z62addzd2genvz12za2zzast_envz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_bindzd2globalz12zc0zzast_envz00(obj_t, obj_t, obj_t, BgL_valuez00_bglt,
		obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_envz00();
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	BGL_EXPORTED_DECL obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	static obj_t
		BGl_z62additionalzd2heapzd2restorezd2globalsz12za2zzast_envz00(obj_t);
	extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
	static obj_t BGl_z62findzd2globalzf2modulez42zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62forzd2eachzd2globalz12z70zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62restorezd2globalz12za2zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_isfunz00zzinline_inlinez00;
	static obj_t BGl_z62initializa7ezd2Genvz12z05zzast_envz00(obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_hrtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	static obj_t BGl_z62getzd2genvzb0zzast_envz00(obj_t);
	static BgL_globalz00_bglt BGl_z62bindzd2globalz12za2zzast_envz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BUNSPEC;
	static obj_t BGl_z62findzd2globalzb0zzast_envz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzast_envz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00();
	BGL_EXPORTED_DECL obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_envz00();
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	extern obj_t BGl_valuez00zzast_varz00;
	extern BgL_typez00_bglt BGl_findzd2typezd2zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
	static obj_t BGl_za2restoredza2z00zzast_envz00 = BUNSPEC;
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62setzd2genvz12za2zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2genvzd2zzast_envz00();
	extern obj_t BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00(obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t
		BGl_warningzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt, obj_t);
	static obj_t __cnst[7];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_setzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl_za762setza7d2genvza7121858za7, BGl_z62setzd2genvz12za2zzast_envz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzd2envz00zzast_envz00,
		BgL_bgl_za762findza7d2global1859z00, va_generic_entry,
		BGl_z62findzd2globalzb0zzast_envz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_unbindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl_za762unbindza7d2glob1860z00,
		BGl_z62unbindzd2globalz12za2zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1835z00zzast_envz00,
		BgL_bgl_string1835za700za7za7a1861za7, "~a::~a", 6);
	      DEFINE_STRING(BGl_string1836z00zzast_envz00,
		BgL_bgl_string1836za700za7za7a1862za7, "Cannot find global variable", 27);
	      DEFINE_STRING(BGl_string1837z00zzast_envz00,
		BgL_bgl_string1837za700za7za7a1863za7, "Variable overridden by", 22);
	      DEFINE_STRING(BGl_string1838z00zzast_envz00,
		BgL_bgl_string1838za700za7za7a1864za7, "Duplicate definition", 20);
	      DEFINE_STRING(BGl_string1839z00zzast_envz00,
		BgL_bgl_string1839za700za7za7a1865za7, "eval", 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzd2bucketzd2positionzd2envzd2zzast_envz00,
		BgL_bgl_za762globalza7d2buck1866z00,
		BGl_z62globalzd2bucketzd2positionz62zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1840z00zzast_envz00,
		BgL_bgl_string1840za700za7za7a1867za7, "unbind-global!", 14);
	      DEFINE_STRING(BGl_string1841z00zzast_envz00,
		BgL_bgl_string1841za700za7za7a1868za7, "Can't find global", 17);
	      DEFINE_STRING(BGl_string1843z00zzast_envz00,
		BgL_bgl_string1843za700za7za7a1869za7, "restore-value-types!1285", 24);
	      DEFINE_STRING(BGl_string1845z00zzast_envz00,
		BgL_bgl_string1845za700za7za7a1870za7, "restore-value-types!", 20);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl_za762getza7d2globalza71871za7,
		BGl_z62getzd2globalzf2modulez42zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1849z00zzast_envz00,
		BgL_bgl_string1849za700za7za7a1872za7, "restore-value-types(sfun)", 25);
	      DEFINE_STRING(BGl_string1850z00zzast_envz00,
		BgL_bgl_string1850za700za7za7a1873za7, "Illegal argument", 16);
	      DEFINE_STRING(BGl_string1851z00zzast_envz00,
		BgL_bgl_string1851za700za7za7a1874za7, "restore-value-types", 19);
	      DEFINE_STRING(BGl_string1852z00zzast_envz00,
		BgL_bgl_string1852za700za7za7a1875za7, "Illegal non pair argument", 25);
	      DEFINE_STRING(BGl_string1853z00zzast_envz00,
		BgL_bgl_string1853za700za7za7a1876za7, "ast_env", 7);
	      DEFINE_STRING(BGl_string1854z00zzast_envz00,
		BgL_bgl_string1854za700za7za7a1877za7,
		"eval now read @ get-global/module foreign the-global-environment ", 65);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2genvzd2envz00zzast_envz00,
		BgL_bgl_za762getza7d2genvza7b01878za7, BGl_z62getzd2genvzb0zzast_envz00, 0L,
		BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_alreadyzd2restoredzf3zd2envzf3zzast_envz00,
		BgL_bgl_za762alreadyza7d2res1879z00,
		BGl_z62alreadyzd2restoredzf3z43zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_additionalzd2heapzd2restorezd2globalsz12zd2envz12zzast_envz00,
		BgL_bgl_za762additionalza7d21880z00,
		BGl_z62additionalzd2heapzd2restorezd2globalsz12za2zzast_envz00, 0L, BUNSPEC,
		0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_addzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl_za762addza7d2genvza7121881za7, BGl_z62addzd2genvz12za2zzast_envz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl_za762findza7d2global1882z00,
		BGl_z62findzd2globalzf2modulez42zzast_envz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_initializa7ezd2Genvz12zd2envzb5zzast_envz00,
		BgL_bgl_za762initializa7a7eza71883za7,
		BGl_z62initializa7ezd2Genvz12z05zzast_envz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1834z00zzast_envz00,
		BgL_bgl_za762za7c3anonymousza71884za7,
		BGl_z62zc3anonymousza31329ze3ze1zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1842z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1885z00,
		BGl_z62restorezd2valuezd2typesz121285z70zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1844z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1886z00,
		BGl_z62restorezd2valuezd2typesz121288z70zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1846z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1887z00,
		BGl_z62restorezd2valuezd2typesz121290z70zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1847z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1888z00,
		BGl_z62restorezd2valuezd2typesz121292z70zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1848z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1889z00,
		BGl_z62restorezd2valuezd2typesz121294z70zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
		BgL_bgl_za762restoreza7d2val1890z00,
		BGl_z62restorezd2valuezd2typesz12z70zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_forzd2eachzd2globalz12zd2envzc0zzast_envz00,
		BgL_bgl_za762forza7d2eachza7d21891za7, va_generic_entry,
		BGl_z62forzd2eachzd2globalz12z70zzast_envz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_bindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl_za762bindza7d2global1892z00, BGl_z62bindzd2globalz12za2zzast_envz00,
		0L, BUNSPEC, 6);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_restorezd2globalz12zd2envz12zzast_envz00,
		BgL_bgl_za762restoreza7d2glo1893z00,
		BGl_z62restorezd2globalz12za2zzast_envz00, 0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long
		BgL_checksumz00_2197, char *BgL_fromz00_2198)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_envz00))
				{
					BGl_requirezd2initializa7ationz75zzast_envz00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_envz00();
					BGl_cnstzd2initzd2zzast_envz00();
					BGl_importedzd2moduleszd2initz00zzast_envz00();
					BGl_genericzd2initzd2zzast_envz00();
					BGl_methodzd2initzd2zzast_envz00();
					return BGl_toplevelzd2initzd2zzast_envz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_env");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			{	/* Ast/venv.scm 14 */
				obj_t BgL_cportz00_2183;

				{	/* Ast/venv.scm 14 */
					obj_t BgL_startz00_2192;

					BgL_startz00_2192 = BINT(((long) 0));
					{	/* Ast/venv.scm 14 */
						obj_t BgL_endz00_2193;

						BgL_endz00_2193 =
							BINT(STRING_LENGTH(BGl_string1854z00zzast_envz00));
						{	/* Ast/venv.scm 14 */

							BgL_cportz00_2183 =
								BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
								(BGl_string1854z00zzast_envz00, BgL_startz00_2192,
								BgL_endz00_2193);
				}}}
				{
					long BgL_iz00_2184;

					BgL_iz00_2184 = ((long) 6);
				BgL_loopz00_2185:
					if ((BgL_iz00_2184 == ((long) -1)))
						{	/* Ast/venv.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/venv.scm 14 */
							{	/* Ast/venv.scm 14 */
								obj_t BgL_arg1856z00_2187;

								{	/* Ast/venv.scm 14 */

									{	/* Ast/venv.scm 14 */
										obj_t BgL_locationz00_2189;

										BgL_locationz00_2189 = BBOOL(((bool_t) 0));
										{	/* Ast/venv.scm 14 */

											BgL_arg1856z00_2187 =
												BGl_readz00zz__readerz00(BgL_cportz00_2183,
												BgL_locationz00_2189);
										}
									}
								}
								{	/* Ast/venv.scm 14 */
									int BgL_auxz00_2227;

									BgL_auxz00_2227 = (int) (BgL_iz00_2184);
									CNST_TABLE_SET(BgL_auxz00_2227, BgL_arg1856z00_2187);
							}}
							{	/* Ast/venv.scm 14 */
								int BgL_auxz00_2190;

								BgL_auxz00_2190 = (int) ((BgL_iz00_2184 - ((long) 1)));
								{
									long BgL_iz00_2232;

									BgL_iz00_2232 = (long) (BgL_auxz00_2190);
									BgL_iz00_2184 = BgL_iz00_2232;
									goto BgL_loopz00_2185;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_za2Genvza2z00zzast_envz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BNIL;
			BGl_za2restoredza2z00zzast_envz00 = BNIL;
			return BUNSPEC;
		}
	}



/* set-genv! */
	BGL_EXPORTED_DEF obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_3)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 54 */
			return (BGl_za2Genvza2z00zzast_envz00 = BgL_genvz00_3, BUNSPEC);
		}
	}



/* &set-genv! */
	obj_t BGl_z62setzd2genvz12za2zzast_envz00(obj_t BgL_envz00_2121,
		obj_t BgL_genvz00_2122)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 54 */
			return BGl_setzd2genvz12zc0zzast_envz00(BgL_genvz00_2122);
		}
	}



/* add-genv! */
	BGL_EXPORTED_DEF obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_4)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 63 */
			BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_4,
				BGl_proc1834z00zzast_envz00);
			return (BGl_za2restoredza2z00zzast_envz00 = BNIL, BUNSPEC);
		}
	}



/* &add-genv! */
	obj_t BGl_z62addzd2genvz12za2zzast_envz00(obj_t BgL_envz00_2124,
		obj_t BgL_genvz00_2125)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 63 */
			return BGl_addzd2genvz12zc0zzast_envz00(BgL_genvz00_2125);
		}
	}



/* &<anonymous:1329> */
	obj_t BGl_z62zc3anonymousza31329ze3ze1zzast_envz00(obj_t BgL_envz00_2126,
		obj_t BgL_kz00_2127, obj_t BgL_bucketz00_2128)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 66 */
			{
				obj_t BgL_kz00_1417;
				obj_t BgL_bucketz00_1418;

				{	/* Ast/venv.scm 67 */
					bool_t BgL_auxz00_2238;

					BgL_kz00_1417 = BgL_kz00_2127;
					BgL_bucketz00_1418 = BgL_bucketz00_2128;
					{	/* Ast/venv.scm 67 */
						obj_t BgL_g1279z00_1420;

						BgL_g1279z00_1420 = CDR(BgL_bucketz00_1418);
						{
							obj_t BgL_l1277z00_1422;

							BgL_l1277z00_1422 = BgL_g1279z00_1420;
						BgL_zc3anonymousza31330ze3z83_1423:
							if (PAIRP(BgL_l1277z00_1422))
								{	/* Ast/venv.scm 87 */
									{	/* Ast/venv.scm 68 */
										obj_t BgL_newz00_1425;

										BgL_newz00_1425 = CAR(BgL_l1277z00_1422);
										BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 =
											MAKE_PAIR(BgL_newz00_1425,
											BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00);
										{	/* Ast/venv.scm 69 */
											obj_t BgL_modulez00_1426;

											BgL_modulez00_1426 =
												(((BgL_globalz00_bglt) CREF(
														((BgL_globalz00_bglt) BgL_newz00_1425)))->
												BgL_modulez00);
											{	/* Ast/venv.scm 69 */
												obj_t BgL_idz00_1427;

												BgL_idz00_1427 =
													(((BgL_variablez00_bglt) CREF(
															((BgL_variablez00_bglt)
																((BgL_globalz00_bglt) BgL_newz00_1425))))->
													BgL_idz00);
												{	/* Ast/venv.scm 70 */
													obj_t BgL_bucketz00_1428;

													BgL_bucketz00_1428 =
														BGl_hashtablezd2getzd2zz__hashz00
														(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_1427);
													{	/* Ast/venv.scm 71 */

														if (PAIRP(BgL_bucketz00_1428))
															{	/* Ast/venv.scm 75 */
																bool_t BgL_testz00_2252;

																if (
																	(BgL_modulez00_1426 ==
																		BGl_za2moduleza2z00zzmodule_modulez00))
																	{	/* Ast/venv.scm 75 */
																		BgL_testz00_2252 = ((bool_t) 1);
																	}
																else
																	{	/* Ast/venv.scm 76 */
																		bool_t BgL_testz00_2255;

																		{	/* Ast/venv.scm 77 */
																			obj_t BgL_arg1366z00_1438;

																			{
																				BgL_globalz00_bglt BgL_auxz00_2256;

																				{	/* Ast/venv.scm 77 */
																					obj_t BgL_pairz00_1915;

																					BgL_pairz00_1915 =
																						CDR(BgL_bucketz00_1428);
																					BgL_auxz00_2256 =
																						((BgL_globalz00_bglt)
																						CAR(BgL_pairz00_1915));
																				}
																				BgL_arg1366z00_1438 =
																					(((BgL_globalz00_bglt)
																						CREF(BgL_auxz00_2256))->
																					BgL_modulez00);
																			}
																			BgL_testz00_2255 =
																				(BGl_za2moduleza2z00zzmodule_modulez00
																				== BgL_arg1366z00_1438);
																		}
																		if (BgL_testz00_2255)
																			{	/* Ast/venv.scm 76 */
																				BgL_testz00_2252 = ((bool_t) 0);
																			}
																		else
																			{	/* Ast/venv.scm 76 */
																				BgL_testz00_2252 = ((bool_t) 1);
																			}
																	}
																if (BgL_testz00_2252)
																	{	/* Ast/venv.scm 83 */
																		obj_t BgL_newzd2bucketzd2_1431;

																		BgL_newzd2bucketzd2_1431 =
																			MAKE_PAIR(BgL_newz00_1425,
																			CDR(BgL_bucketz00_1428));
																		SET_CDR(BgL_bucketz00_1428,
																			BgL_newzd2bucketzd2_1431);
																	}
																else
																	{	/* Ast/venv.scm 86 */
																		obj_t BgL_arg1344z00_1433;
																		obj_t BgL_arg1360z00_1434;

																		BgL_arg1344z00_1433 =
																			CDR(BgL_bucketz00_1428);
																		BgL_arg1360z00_1434 =
																			MAKE_PAIR(BgL_newz00_1425,
																			CDR(CDR(BgL_bucketz00_1428)));
																		SET_CDR(BgL_arg1344z00_1433,
																			BgL_arg1360z00_1434);
																	}
															}
														else
															{	/* Ast/venv.scm 74 */
																obj_t BgL_arg1372z00_1440;

																{	/* Ast/venv.scm 74 */
																	obj_t BgL_list1373z00_1441;

																	{	/* Ast/venv.scm 74 */
																		obj_t BgL_arg1374z00_1442;

																		BgL_arg1374z00_1442 =
																			MAKE_PAIR(BgL_newz00_1425, BNIL);
																		BgL_list1373z00_1441 =
																			MAKE_PAIR(BgL_idz00_1427,
																			BgL_arg1374z00_1442);
																	}
																	BgL_arg1372z00_1440 = BgL_list1373z00_1441;
																}
																BGl_hashtablezd2putz12zc0zz__hashz00
																	(BGl_za2Genvza2z00zzast_envz00,
																	BgL_idz00_1427, BgL_arg1372z00_1440);
															}
													}
												}
											}
										}
									}
									{
										obj_t BgL_l1277z00_2273;

										BgL_l1277z00_2273 = CDR(BgL_l1277z00_1422);
										BgL_l1277z00_1422 = BgL_l1277z00_2273;
										goto BgL_zc3anonymousza31330ze3z83_1423;
									}
								}
							else
								{	/* Ast/venv.scm 87 */
									BgL_auxz00_2238 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_2238);
				}
			}
		}
	}



/* additional-heap-restore-globals! */
	BGL_EXPORTED_DEF obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 104 */
			{
				obj_t BgL_l1280z00_1447;

				BgL_l1280z00_1447 =
					BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00;
			BgL_zc3anonymousza31379ze3z83_1448:
				if (PAIRP(BgL_l1280z00_1447))
					{	/* Ast/venv.scm 105 */
						BGl_restorezd2globalz12zc0zzast_envz00(CAR(BgL_l1280z00_1447));
						{
							obj_t BgL_l1280z00_2280;

							BgL_l1280z00_2280 = CDR(BgL_l1280z00_1447);
							BgL_l1280z00_1447 = BgL_l1280z00_2280;
							goto BgL_zc3anonymousza31379ze3z83_1448;
						}
					}
				else
					{	/* Ast/venv.scm 105 */
						((bool_t) 1);
					}
			}
			return BTRUE;
		}
	}



/* &additional-heap-restore-globals! */
	obj_t BGl_z62additionalzd2heapzd2restorezd2globalsz12za2zzast_envz00(obj_t
		BgL_envz00_2129)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 104 */
			return BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
		}
	}



/* restore-global! */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t
		BgL_newz00_6)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 111 */
			BGl_za2restoredza2z00zzast_envz00 =
				MAKE_PAIR(BgL_newz00_6, BGl_za2restoredza2z00zzast_envz00);
			{	/* Ast/venv.scm 114 */
				BgL_typez00_bglt BgL_typez00_1454;

				BgL_typez00_1454 =
					(((BgL_variablez00_bglt) CREF(
							((BgL_variablez00_bglt)
								((BgL_globalz00_bglt) BgL_newz00_6))))->BgL_typez00);
				{	/* Ast/venv.scm 115 */
					BgL_valuez00_bglt BgL_valuez00_1455;

					BgL_valuez00_1455 =
						(((BgL_variablez00_bglt) CREF(
								((BgL_variablez00_bglt)
									((BgL_globalz00_bglt) BgL_newz00_6))))->BgL_valuez00);
					{	/* Ast/venv.scm 116 */
						obj_t BgL_typeidz00_1456;

						BgL_typeidz00_1456 =
							(((BgL_typez00_bglt) CREF(BgL_typez00_1454))->BgL_idz00);
						{	/* Ast/venv.scm 117 */

							{	/* Ast/venv.scm 119 */
								BgL_typez00_bglt BgL_arg1398z00_1457;

								BgL_arg1398z00_1457 =
									BGl_findzd2typezd2zztype_envz00(BgL_typeidz00_1456);
								((((BgL_variablez00_bglt) CREF(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_newz00_6))))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_arg1398z00_1457), BUNSPEC);
							}
							BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_1455);
							{	/* Ast/venv.scm 123 */
								bool_t BgL_testz00_2296;

								{	/* Ast/venv.scm 123 */
									bool_t BgL_testz00_2297;

									{	/* Ast/venv.scm 123 */
										obj_t BgL_arg1454z00_1466;

										BgL_arg1454z00_1466 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										BgL_testz00_2297 =
											(((BgL_backendz00_bglt) CREF(
													((BgL_backendz00_bglt) BgL_arg1454z00_1466)))->
											BgL_qualifiedzd2typeszd2);
									}
									if (BgL_testz00_2297)
										{	/* Ast/venv.scm 123 */
											if (
												((((BgL_globalz00_bglt) CREF(
																((BgL_globalz00_bglt) BgL_newz00_6)))->
														BgL_modulez00) == CNST_TABLE_REF(((long) 1))))
												{	/* Ast/venv.scm 124 */
													BgL_testz00_2296 = ((bool_t) 0);
												}
											else
												{	/* Ast/venv.scm 124 */
													BgL_testz00_2296 = ((bool_t) 1);
												}
										}
									else
										{	/* Ast/venv.scm 123 */
											BgL_testz00_2296 = ((bool_t) 0);
										}
								}
								if (BgL_testz00_2296)
									{	/* Ast/venv.scm 125 */
										obj_t BgL_arg1441z00_1459;
										obj_t BgL_arg1442z00_1460;
										obj_t BgL_arg1447z00_1461;

										BgL_arg1441z00_1459 =
											(((BgL_globalz00_bglt) CREF(
													((BgL_globalz00_bglt) BgL_newz00_6)))->BgL_modulez00);
										BgL_arg1442z00_1460 =
											(((BgL_globalz00_bglt) CREF(
													((BgL_globalz00_bglt) BgL_newz00_6)))->
											BgL_jvmzd2typezd2namez00);
										BgL_arg1447z00_1461 =
											BGl_shapez00zztools_shapez00(BgL_newz00_6);
										{	/* Ast/venv.scm 125 */
											obj_t BgL_list1448z00_1462;

											BgL_list1448z00_1462 =
												MAKE_PAIR(BgL_arg1447z00_1461, BNIL);
											return
												BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00
												(BgL_arg1441z00_1459, BgL_arg1442z00_1460,
												BgL_list1448z00_1462);
										}
									}
								else
									{	/* Ast/venv.scm 123 */
										return BFALSE;
									}
							}
						}
					}
				}
			}
		}
	}



/* &restore-global! */
	obj_t BGl_z62restorezd2globalz12za2zzast_envz00(obj_t BgL_envz00_2130,
		obj_t BgL_newz00_2131)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 111 */
			return BGl_restorezd2globalz12zc0zzast_envz00(BgL_newz00_2131);
		}
	}



/* already-restored? */
	BGL_EXPORTED_DEF obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t
		BgL_funz00_8)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 146 */
			return
				BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_funz00_8,
				BGl_za2restoredza2z00zzast_envz00);
		}
	}



/* &already-restored? */
	obj_t BGl_z62alreadyzd2restoredzf3z43zzast_envz00(obj_t BgL_envz00_2132,
		obj_t BgL_funz00_2133)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 146 */
			return BGl_alreadyzd2restoredzf3z21zzast_envz00(BgL_funz00_2133);
		}
	}



/* get-genv */
	BGL_EXPORTED_DEF obj_t BGl_getzd2genvzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 219 */
			return BGl_za2Genvza2z00zzast_envz00;
		}
	}



/* &get-genv */
	obj_t BGl_z62getzd2genvzb0zzast_envz00(obj_t BgL_envz00_2134)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 219 */
			return BGl_za2Genvza2z00zzast_envz00;
		}
	}



/* initialize-Genv! */
	BGL_EXPORTED_DEF obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 225 */
			return (BGl_za2Genvza2z00zzast_envz00 =
				BGl_makezd2hashtablezd2zz__hashz00(BNIL), BUNSPEC);
		}
	}



/* &initialize-Genv! */
	obj_t BGl_z62initializa7ezd2Genvz12z05zzast_envz00(obj_t BgL_envz00_2135)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 225 */
			return BGl_initializa7ezd2Genvz12z67zzast_envz00();
		}
	}



/* find-global */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzd2zzast_envz00(obj_t BgL_idz00_14,
		obj_t BgL_modulez00_15)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 231 */
			{	/* Ast/venv.scm 233 */
				obj_t BgL_bucketz00_1468;
				obj_t BgL_modulez00_1469;

				BgL_bucketz00_1468 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_14);
				if (NULLP(BgL_modulez00_15))
					{	/* Ast/venv.scm 234 */
						BgL_modulez00_1469 = BNIL;
					}
				else
					{	/* Ast/venv.scm 234 */
						BgL_modulez00_1469 = CAR(BgL_modulez00_15);
					}
				if (PAIRP(BgL_bucketz00_1468))
					{	/* Ast/venv.scm 236 */
						if (NULLP(CDR(BgL_bucketz00_1468)))
							{	/* Ast/venv.scm 238 */
								return BFALSE;
							}
						else
							{	/* Ast/venv.scm 238 */
								if (NULLP(BgL_modulez00_1469))
									{	/* Ast/venv.scm 240 */
										return CAR(CDR(BgL_bucketz00_1468));
									}
								else
									{	/* Ast/venv.scm 243 */
										obj_t BgL_g1101z00_1473;

										BgL_g1101z00_1473 = CDR(BgL_bucketz00_1468);
										{
											obj_t BgL_globalsz00_1475;

											BgL_globalsz00_1475 = BgL_g1101z00_1473;
										BgL_zc3anonymousza31459ze3z83_1476:
											if (NULLP(BgL_globalsz00_1475))
												{	/* Ast/venv.scm 245 */
													return BFALSE;
												}
											else
												{	/* Ast/venv.scm 245 */
													if (
														((((BgL_globalz00_bglt) CREF(
																		((BgL_globalz00_bglt)
																			CAR(BgL_globalsz00_1475))))->
																BgL_modulez00) == BgL_modulez00_1469))
														{	/* Ast/venv.scm 247 */
															return CAR(BgL_globalsz00_1475);
														}
													else
														{
															obj_t BgL_globalsz00_2340;

															BgL_globalsz00_2340 = CDR(BgL_globalsz00_1475);
															BgL_globalsz00_1475 = BgL_globalsz00_2340;
															goto BgL_zc3anonymousza31459ze3z83_1476;
														}
												}
										}
									}
							}
					}
				else
					{	/* Ast/venv.scm 236 */
						return BFALSE;
					}
			}
		}
	}



/* &find-global */
	obj_t BGl_z62findzd2globalzb0zzast_envz00(obj_t BgL_envz00_2136,
		obj_t BgL_idz00_2137, obj_t BgL_modulez00_2138)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 231 */
			return
				BGl_findzd2globalzd2zzast_envz00(BgL_idz00_2137, BgL_modulez00_2138);
		}
	}



/* find-global/module */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_16, obj_t BgL_modulez00_17)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 255 */
			{	/* Ast/venv.scm 256 */
				obj_t BgL_bucketz00_1485;

				BgL_bucketz00_1485 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_16);
				if (PAIRP(BgL_bucketz00_1485))
					{	/* Ast/venv.scm 258 */
						if (NULLP(CDR(BgL_bucketz00_1485)))
							{	/* Ast/venv.scm 260 */
								return BFALSE;
							}
						else
							{	/* Ast/venv.scm 265 */
								obj_t BgL_g1102z00_1489;

								BgL_g1102z00_1489 = CDR(BgL_bucketz00_1485);
								{
									obj_t BgL_globalsz00_1491;

									BgL_globalsz00_1491 = BgL_g1102z00_1489;
								BgL_zc3anonymousza31487ze3z83_1492:
									if (NULLP(BgL_globalsz00_1491))
										{	/* Ast/venv.scm 267 */
											return BFALSE;
										}
									else
										{	/* Ast/venv.scm 267 */
											if (
												((((BgL_globalz00_bglt) CREF(
																((BgL_globalz00_bglt)
																	CAR(BgL_globalsz00_1491))))->BgL_modulez00) ==
													BgL_modulez00_17))
												{	/* Ast/venv.scm 269 */
													return CAR(BgL_globalsz00_1491);
												}
											else
												{
													obj_t BgL_globalsz00_2358;

													BgL_globalsz00_2358 = CDR(BgL_globalsz00_1491);
													BgL_globalsz00_1491 = BgL_globalsz00_2358;
													goto BgL_zc3anonymousza31487ze3z83_1492;
												}
										}
								}
							}
					}
				else
					{	/* Ast/venv.scm 258 */
						return BFALSE;
					}
			}
		}
	}



/* &find-global/module */
	obj_t BGl_z62findzd2globalzf2modulez42zzast_envz00(obj_t BgL_envz00_2139,
		obj_t BgL_idz00_2140, obj_t BgL_modulez00_2141)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 255 */
			return
				BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_2140,
				BgL_modulez00_2141);
		}
	}



/* get-global/module */
	BGL_EXPORTED_DEF obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_18, obj_t BgL_modulez00_19)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 277 */
			{	/* Ast/venv.scm 278 */
				obj_t BgL_globalz00_1500;

				BgL_globalz00_1500 =
					BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_18,
					BgL_modulez00_19);
				{	/* Ast/venv.scm 279 */
					bool_t BgL_testz00_2362;

					if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_1500,
							BGl_globalz00zzast_varz00))
						{	/* Ast/venv.scm 279 */
							BgL_testz00_2362 = ((bool_t) 0);
						}
					else
						{	/* Ast/venv.scm 279 */
							if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
								{	/* Ast/venv.scm 279 */
									BgL_testz00_2362 = ((bool_t) 0);
								}
							else
								{	/* Ast/venv.scm 279 */
									BgL_testz00_2362 = ((bool_t) 1);
								}
						}
					if (BgL_testz00_2362)
						{	/* Ast/venv.scm 282 */
							obj_t BgL_arg1496z00_1502;

							{	/* Ast/venv.scm 282 */
								obj_t BgL_list1497z00_1503;

								{	/* Ast/venv.scm 282 */
									obj_t BgL_arg1500z00_1504;

									BgL_arg1500z00_1504 = MAKE_PAIR(BgL_modulez00_19, BNIL);
									BgL_list1497z00_1503 =
										MAKE_PAIR(BgL_idz00_18, BgL_arg1500z00_1504);
								}
								BgL_arg1496z00_1502 =
									BGl_formatz00zz__r4_output_6_10_3z00
									(BGl_string1835z00zzast_envz00, BgL_list1497z00_1503);
							}
							BGl_internalzd2errorzd2zztools_errorz00(CNST_TABLE_REF(((long)
										2)), BGl_string1836z00zzast_envz00, BgL_arg1496z00_1502);
						}
					else
						{	/* Ast/venv.scm 279 */
							BFALSE;
						}
				}
				return BgL_globalz00_1500;
			}
		}
	}



/* &get-global/module */
	obj_t BGl_z62getzd2globalzf2modulez42zzast_envz00(obj_t BgL_envz00_2142,
		obj_t BgL_idz00_2143, obj_t BgL_modulez00_2144)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 277 */
			return
				BGl_getzd2globalzf2modulez20zzast_envz00(BgL_idz00_2143,
				BgL_modulez00_2144);
		}
	}



/* warning-override-global! */
	obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t BgL_nz00_20,
		obj_t BgL_oz00_21, obj_t BgL_msgz00_22)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 288 */
			{	/* Ast/venv.scm 289 */
				bool_t BgL_testz00_2373;

				{	/* Ast/venv.scm 289 */
					bool_t BgL_testz00_2374;

					{	/* Ast/venv.scm 289 */
						int BgL_arg1547z00_1523;

						BgL_arg1547z00_1523 = BGl_bigloozd2warningzd2zz__paramz00();
						BgL_testz00_2374 = ((long) (BgL_arg1547z00_1523) > ((long) 0));
					}
					if (BgL_testz00_2374)
						{	/* Ast/venv.scm 289 */
							BgL_testz00_2373 =
								CBOOL
								(BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00);
						}
					else
						{	/* Ast/venv.scm 289 */
							BgL_testz00_2373 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2373)
					{	/* Ast/venv.scm 291 */
						obj_t BgL_locz00_1508;
						obj_t BgL_oldz00_1509;
						obj_t BgL_newz00_1510;
						obj_t BgL_msgz00_1511;

						{	/* Ast/venv.scm 291 */
							obj_t BgL_arg1505z00_1512;

							BgL_arg1505z00_1512 =
								(((BgL_globalz00_bglt) CREF(
										((BgL_globalz00_bglt) BgL_oz00_21)))->BgL_srcz00);
							BgL_locz00_1508 =
								BGl_findzd2locationzd2zztools_locationz00(BgL_arg1505z00_1512);
						}
						{	/* Ast/venv.scm 292 */
							obj_t BgL_arg1509z00_1513;

							{	/* Ast/venv.scm 292 */
								obj_t BgL_arg1511z00_1514;
								obj_t BgL_arg1516z00_1515;

								BgL_arg1511z00_1514 =
									(((BgL_variablez00_bglt) CREF(
											((BgL_variablez00_bglt)
												((BgL_globalz00_bglt) BgL_oz00_21))))->BgL_idz00);
								{	/* Ast/venv.scm 292 */
									obj_t BgL_arg1519z00_1516;

									BgL_arg1519z00_1516 =
										(((BgL_globalz00_bglt) CREF(
												((BgL_globalz00_bglt) BgL_oz00_21)))->BgL_modulez00);
									BgL_arg1516z00_1515 = MAKE_PAIR(BgL_arg1519z00_1516, BNIL);
								}
								BgL_arg1509z00_1513 =
									MAKE_PAIR(BgL_arg1511z00_1514, BgL_arg1516z00_1515);
							}
							BgL_oldz00_1509 =
								MAKE_PAIR(CNST_TABLE_REF(((long) 3)), BgL_arg1509z00_1513);
						}
						{	/* Ast/venv.scm 293 */
							obj_t BgL_arg1526z00_1517;

							{	/* Ast/venv.scm 293 */
								obj_t BgL_arg1527z00_1518;
								obj_t BgL_arg1528z00_1519;

								BgL_arg1527z00_1518 =
									(((BgL_variablez00_bglt) CREF(
											((BgL_variablez00_bglt)
												((BgL_globalz00_bglt) BgL_nz00_20))))->BgL_idz00);
								{	/* Ast/venv.scm 293 */
									obj_t BgL_arg1530z00_1520;

									BgL_arg1530z00_1520 =
										(((BgL_globalz00_bglt) CREF(
												((BgL_globalz00_bglt) BgL_nz00_20)))->BgL_modulez00);
									BgL_arg1528z00_1519 = MAKE_PAIR(BgL_arg1530z00_1520, BNIL);
								}
								BgL_arg1526z00_1517 =
									MAKE_PAIR(BgL_arg1527z00_1518, BgL_arg1528z00_1519);
							}
							BgL_newz00_1510 =
								MAKE_PAIR(CNST_TABLE_REF(((long) 3)), BgL_arg1526z00_1517);
						}
						if (PAIRP(BgL_msgz00_22))
							{	/* Ast/venv.scm 294 */
								BgL_msgz00_1511 = CAR(BgL_msgz00_22);
							}
						else
							{	/* Ast/venv.scm 294 */
								BgL_msgz00_1511 = BGl_string1837z00zzast_envz00;
							}
						if (CBOOL(BgL_locz00_1508))
							{	/* Ast/venv.scm 295 */
								return
									BGl_userzd2warningzf2locationz20zztools_errorz00
									(BgL_locz00_1508, BgL_oldz00_1509, BgL_msgz00_1511,
									BgL_newz00_1510);
							}
						else
							{	/* Ast/venv.scm 295 */
								return
									BGl_userzd2warningzd2zztools_errorz00(BgL_oldz00_1509,
									BgL_msgz00_1511, BgL_newz00_1510);
							}
					}
				else
					{	/* Ast/venv.scm 289 */
						return BFALSE;
					}
			}
		}
	}



/* error-rebind-global! */
	obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt
		BgL_oz00_23, obj_t BgL_srcz00_24)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 302 */
			{	/* Ast/venv.scm 304 */
				obj_t BgL_locz00_1525;

				BgL_locz00_1525 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_24);
				if (CBOOL(BgL_locz00_1525))
					{	/* Ast/venv.scm 307 */
						obj_t BgL_arg1549z00_1527;
						obj_t BgL_arg1552z00_1528;

						BgL_arg1549z00_1527 =
							(((BgL_globalz00_bglt) CREF(BgL_oz00_23))->BgL_modulez00);
						BgL_arg1552z00_1528 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_23));
						return
							BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_1525,
							BgL_arg1549z00_1527, BGl_string1838z00zzast_envz00,
							BgL_arg1552z00_1528, BNIL);
					}
				else
					{	/* Ast/venv.scm 308 */
						obj_t BgL_arg1555z00_1530;
						obj_t BgL_arg1557z00_1531;

						BgL_arg1555z00_1530 =
							(((BgL_globalz00_bglt) CREF(BgL_oz00_23))->BgL_modulez00);
						BgL_arg1557z00_1531 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_23));
						return
							BGl_userzd2errorzd2zztools_errorz00(BgL_arg1555z00_1530,
							BGl_string1838z00zzast_envz00, BgL_arg1557z00_1531, BNIL);
					}
			}
		}
	}



/* warning-rebind-global! */
	obj_t BGl_warningzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt
		BgL_oz00_25, obj_t BgL_srcz00_26)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 313 */
			{	/* Ast/venv.scm 315 */
				obj_t BgL_locz00_1534;

				BgL_locz00_1534 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_26);
				if (CBOOL(BgL_locz00_1534))
					{	/* Ast/venv.scm 318 */
						obj_t BgL_arg1569z00_1536;
						obj_t BgL_arg1571z00_1537;

						BgL_arg1569z00_1536 =
							(((BgL_globalz00_bglt) CREF(BgL_oz00_25))->BgL_modulez00);
						BgL_arg1571z00_1537 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_25));
						return
							BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_1534,
							BgL_arg1569z00_1536, BGl_string1838z00zzast_envz00,
							BgL_arg1571z00_1537);
					}
				else
					{	/* Ast/venv.scm 319 */
						obj_t BgL_arg1572z00_1538;
						obj_t BgL_arg1576z00_1539;

						BgL_arg1572z00_1538 =
							(((BgL_globalz00_bglt) CREF(BgL_oz00_25))->BgL_modulez00);
						BgL_arg1576z00_1539 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_25));
						return
							BGl_userzd2warningzd2zztools_errorz00(BgL_arg1572z00_1538,
							BGl_string1838z00zzast_envz00, BgL_arg1576z00_1539);
					}
			}
		}
	}



/* bind-global! */
	BGL_EXPORTED_DEF BgL_globalz00_bglt BGl_bindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_27, obj_t BgL_aliasz00_28, obj_t BgL_modulez00_29,
		BgL_valuez00_bglt BgL_valuez00_30, obj_t BgL_importz00_31,
		obj_t BgL_srcz00_32)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 336 */
			{	/* Ast/venv.scm 339 */
				obj_t BgL_identz00_1540;

				if (CBOOL(BgL_aliasz00_28))
					{	/* Ast/venv.scm 339 */
						BgL_identz00_1540 = BgL_aliasz00_28;
					}
				else
					{	/* Ast/venv.scm 339 */
						BgL_identz00_1540 = BgL_idz00_27;
					}
				{	/* Ast/venv.scm 339 */
					obj_t BgL_oldz00_1541;

					{	/* Ast/venv.scm 340 */
						obj_t BgL_list1634z00_1576;

						BgL_list1634z00_1576 = MAKE_PAIR(BgL_modulez00_29, BNIL);
						BgL_oldz00_1541 =
							BGl_findzd2globalzd2zzast_envz00(BgL_identz00_1540,
							BgL_list1634z00_1576);
					}
					{	/* Ast/venv.scm 340 */

						if (BGl_isazf3zf3zz__objectz00(BgL_oldz00_1541,
								BGl_globalz00zzast_varz00))
							{	/* Ast/venv.scm 341 */
								if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
									{	/* Ast/venv.scm 343 */
										return ((BgL_globalz00_bglt) BgL_oldz00_1541);
									}
								else
									{	/* Ast/venv.scm 343 */
										if (
											(BgL_modulez00_29 ==
												(((BgL_globalz00_bglt) CREF(
															((BgL_globalz00_bglt) BgL_oldz00_1541)))->
													BgL_modulez00)))
											{	/* Ast/venv.scm 345 */
												BGl_warningzd2rebindzd2globalz12z12zzast_envz00(
													((BgL_globalz00_bglt) BgL_oldz00_1541),
													BgL_srcz00_32);
												return ((BgL_globalz00_bglt) BgL_oldz00_1541);
											}
										else
											{	/* Ast/venv.scm 345 */
												return
													((BgL_globalz00_bglt)
													BGl_errorzd2rebindzd2globalz12z12zzast_envz00(
														((BgL_globalz00_bglt) BgL_oldz00_1541),
														BgL_srcz00_32));
											}
									}
							}
						else
							{	/* Ast/venv.scm 350 */
								obj_t BgL_bucketz00_1545;
								BgL_globalz00_bglt BgL_newz00_1546;

								BgL_bucketz00_1545 =
									BGl_hashtablezd2getzd2zz__hashz00
									(BGl_za2Genvza2z00zzast_envz00, BgL_identz00_1540);
								{	/* Ast/venv.scm 351 */
									BgL_globalz00_bglt BgL_new1108z00_1572;

									{	/* Ast/venv.scm 357 */
										BgL_globalz00_bglt BgL_new1107z00_1574;

										BgL_new1107z00_1574 =
											((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
														BgL_globalz00_bgl))));
										{	/* Ast/venv.scm 357 */
											long BgL_arg1633z00_1575;

											{	/* Ast/venv.scm 357 */
												long BgL_res1809z00_2000;

												BgL_res1809z00_2000 =
													BGL_CLASS_INDEX(BGl_globalz00zzast_varz00);
												BgL_arg1633z00_1575 = BgL_res1809z00_2000;
											}
											BGL_OBJECT_CLASS_NUM_SET(
												((BgL_objectz00_bglt) BgL_new1107z00_1574),
												BgL_arg1633z00_1575);
										}
										{	/* Ast/venv.scm 357 */
											BgL_objectz00_bglt BgL_auxz00_2453;

											BgL_auxz00_2453 =
												((BgL_objectz00_bglt) BgL_new1107z00_1574);
											BGL_OBJECT_WIDENING_SET(BgL_auxz00_2453, BFALSE);
										}
										BgL_new1108z00_1572 = BgL_new1107z00_1574;
									}
									((((BgL_variablez00_bglt) CREF(
													((BgL_variablez00_bglt) BgL_new1108z00_1572)))->
											BgL_idz00) = ((obj_t) BgL_identz00_1540), BUNSPEC);
									((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
														BgL_new1108z00_1572)))->BgL_namez00) =
										((obj_t) BFALSE), BUNSPEC);
									((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
														BgL_new1108z00_1572)))->BgL_typez00) =
										((BgL_typez00_bglt) ((BgL_typez00_bglt)
												BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
									((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
														BgL_new1108z00_1572)))->BgL_valuez00) =
										((BgL_valuez00_bglt) BgL_valuez00_30), BUNSPEC);
									((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
														BgL_new1108z00_1572)))->BgL_accessz00) =
										((obj_t) CNST_TABLE_REF(((long) 4))), BUNSPEC);
									((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
														BgL_new1108z00_1572)))->BgL_fastzd2alphazd2) =
										((obj_t) BUNSPEC), BUNSPEC);
									((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
														BgL_new1108z00_1572)))->BgL_removablez00) =
										((obj_t) CNST_TABLE_REF(((long) 5))), BUNSPEC);
									((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
														BgL_new1108z00_1572)))->BgL_occurrencez00) =
										((long) ((long) 0)), BUNSPEC);
									((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
														BgL_new1108z00_1572)))->BgL_occurrencewz00) =
										((long) ((long) 0)), BUNSPEC);
									((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
														BgL_new1108z00_1572)))->BgL_userzf3zf3) =
										((bool_t) ((bool_t) 1)), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1108z00_1572))->
											BgL_modulez00) = ((obj_t) BgL_modulez00_29), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1108z00_1572))->
											BgL_importz00) = ((obj_t) BgL_importz00_31), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1108z00_1572))->
											BgL_evaluablezf3zf3) = ((bool_t) ((bool_t) 1)), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1108z00_1572))->
											BgL_evalzf3zf3) = ((bool_t) ((bool_t) 0)), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1108z00_1572))->
											BgL_libraryz00) = ((obj_t) BFALSE), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1108z00_1572))->
											BgL_pragmaz00) = ((obj_t) BNIL), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1108z00_1572))->
											BgL_srcz00) = ((obj_t) BgL_srcz00_32), BUNSPEC);
									{
										obj_t BgL_auxz00_2486;

										if ((BgL_importz00_31 == CNST_TABLE_REF(((long) 6))))
											{	/* Ast/venv.scm 354 */
												BgL_auxz00_2486 = BGl_string1839z00zzast_envz00;
											}
										else
											{	/* Ast/venv.scm 354 */
												BgL_auxz00_2486 =
													BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
													(BgL_modulez00_29);
											}
										((((BgL_globalz00_bglt) CREF(BgL_new1108z00_1572))->
												BgL_jvmzd2typezd2namez00) =
											((obj_t) BgL_auxz00_2486), BUNSPEC);
									}
									((((BgL_globalz00_bglt) CREF(BgL_new1108z00_1572))->
											BgL_initz00) = ((obj_t) BUNSPEC), BUNSPEC);
									{
										obj_t BgL_auxz00_2493;

										if (CBOOL(BgL_aliasz00_28))
											{	/* Ast/venv.scm 358 */
												BgL_auxz00_2493 = BgL_idz00_27;
											}
										else
											{	/* Ast/venv.scm 358 */
												BgL_auxz00_2493 = BFALSE;
											}
										((((BgL_globalz00_bglt) CREF(BgL_new1108z00_1572))->
												BgL_aliasz00) = ((obj_t) BgL_auxz00_2493), BUNSPEC);
									}
									BgL_newz00_1546 = BgL_new1108z00_1572;
								}
								{	/* Ast/venv.scm 364 */
									bool_t BgL_testz00_2497;

									if (PAIRP(BgL_bucketz00_1545))
										{	/* Ast/venv.scm 364 */
											BgL_testz00_2497 = NULLP(CDR(BgL_bucketz00_1545));
										}
									else
										{	/* Ast/venv.scm 364 */
											BgL_testz00_2497 = ((bool_t) 1);
										}
									if (BgL_testz00_2497)
										{	/* Ast/venv.scm 364 */
											{	/* Ast/venv.scm 366 */
												obj_t BgL_arg1587z00_1548;

												{	/* Ast/venv.scm 366 */
													obj_t BgL_list1588z00_1549;

													{	/* Ast/venv.scm 366 */
														obj_t BgL_arg1591z00_1550;

														BgL_arg1591z00_1550 =
															MAKE_PAIR(((obj_t) BgL_newz00_1546), BNIL);
														BgL_list1588z00_1549 =
															MAKE_PAIR(BgL_identz00_1540, BgL_arg1591z00_1550);
													}
													BgL_arg1587z00_1548 = BgL_list1588z00_1549;
												}
												BGl_hashtablezd2putz12zc0zz__hashz00
													(BGl_za2Genvza2z00zzast_envz00, BgL_identz00_1540,
													BgL_arg1587z00_1548);
											}
											return BgL_newz00_1546;
										}
									else
										{	/* Ast/venv.scm 369 */
											obj_t BgL_oldza2za2_1551;

											BgL_oldza2za2_1551 = CDR(BgL_bucketz00_1545);
											{	/* Ast/venv.scm 369 */
												obj_t BgL_midz00_1552;

												{	/* Ast/venv.scm 371 */
													obj_t BgL_arg1623z00_1568;

													BgL_arg1623z00_1568 =
														(((BgL_globalz00_bglt) CREF(
																((BgL_globalz00_bglt)
																	CAR(BgL_oldza2za2_1551))))->BgL_modulez00);
													BgL_midz00_1552 =
														BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00
														(BgL_arg1623z00_1568);
												}
												{	/* Ast/venv.scm 370 */

													{	/* Ast/venv.scm 373 */
														bool_t BgL_testz00_2511;

														{	/* Ast/venv.scm 373 */
															obj_t BgL_arg1619z00_1566;

															BgL_arg1619z00_1566 =
																(((BgL_globalz00_bglt) CREF(
																		((BgL_globalz00_bglt)
																			CAR(BgL_oldza2za2_1551))))->
																BgL_modulez00);
															BgL_testz00_2511 =
																(BgL_arg1619z00_1566 ==
																BGl_za2moduleza2z00zzmodule_modulez00);
														}
														if (BgL_testz00_2511)
															{	/* Ast/venv.scm 373 */
																{	/* Ast/venv.scm 375 */
																	bool_t BgL_testz00_2516;

																	if ((BgL_identz00_1540 == BgL_midz00_1552))
																		{	/* Ast/venv.scm 375 */
																			BgL_testz00_2516 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 375 */
																			if (CBOOL
																				(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																				{	/* Ast/venv.scm 375 */
																					BgL_testz00_2516 = ((bool_t) 0);
																				}
																			else
																				{	/* Ast/venv.scm 375 */
																					BgL_testz00_2516 = ((bool_t) 1);
																				}
																		}
																	if (BgL_testz00_2516)
																		{	/* Ast/venv.scm 376 */
																			obj_t BgL_arg1595z00_1555;

																			BgL_arg1595z00_1555 =
																				CAR(BgL_oldza2za2_1551);
																			BGl_warningzd2overridezd2globalz12z12zzast_envz00
																				(BgL_arg1595z00_1555,
																				((obj_t) BgL_newz00_1546), BNIL);
																		}
																	else
																		{	/* Ast/venv.scm 375 */
																			BFALSE;
																		}
																}
																{	/* Ast/venv.scm 377 */
																	obj_t BgL_arg1606z00_1558;
																	obj_t BgL_arg1610z00_1559;

																	BgL_arg1606z00_1558 = CDR(BgL_bucketz00_1545);
																	{	/* Ast/venv.scm 377 */
																		obj_t BgL_arg1611z00_1560;

																		BgL_arg1611z00_1560 =
																			CDR(CDR(BgL_bucketz00_1545));
																		BgL_arg1610z00_1559 =
																			MAKE_PAIR(
																			((obj_t) BgL_newz00_1546),
																			BgL_arg1611z00_1560);
																	}
																	SET_CDR(BgL_arg1606z00_1558,
																		BgL_arg1610z00_1559);
																}
																return BgL_newz00_1546;
															}
														else
															{	/* Ast/venv.scm 380 */
																obj_t BgL_newza2za2_1561;

																BgL_newza2za2_1561 =
																	MAKE_PAIR(
																	((obj_t) BgL_newz00_1546),
																	BgL_oldza2za2_1551);
																{	/* Ast/venv.scm 381 */
																	bool_t BgL_testz00_2532;

																	if ((BgL_identz00_1540 == BgL_midz00_1552))
																		{	/* Ast/venv.scm 381 */
																			BgL_testz00_2532 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 381 */
																			if (CBOOL
																				(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																				{	/* Ast/venv.scm 381 */
																					BgL_testz00_2532 = ((bool_t) 0);
																				}
																			else
																				{	/* Ast/venv.scm 381 */
																					BgL_testz00_2532 = ((bool_t) 1);
																				}
																		}
																	if (BgL_testz00_2532)
																		{	/* Ast/venv.scm 382 */
																			obj_t BgL_arg1613z00_1563;

																			BgL_arg1613z00_1563 =
																				CAR(BgL_oldza2za2_1551);
																			BGl_warningzd2overridezd2globalz12z12zzast_envz00
																				(((obj_t) BgL_newz00_1546),
																				BgL_arg1613z00_1563, BNIL);
																		}
																	else
																		{	/* Ast/venv.scm 381 */
																			BFALSE;
																		}
																}
																SET_CDR(BgL_bucketz00_1545, BgL_newza2za2_1561);
																return BgL_newz00_1546;
															}
													}
												}
											}
										}
								}
							}
					}
				}
			}
		}
	}



/* &bind-global! */
	BgL_globalz00_bglt BGl_z62bindzd2globalz12za2zzast_envz00(obj_t
		BgL_envz00_2145, obj_t BgL_idz00_2146, obj_t BgL_aliasz00_2147,
		obj_t BgL_modulez00_2148, obj_t BgL_valuez00_2149, obj_t BgL_importz00_2150,
		obj_t BgL_srcz00_2151)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 336 */
			return
				BGl_bindzd2globalz12zc0zzast_envz00(BgL_idz00_2146, BgL_aliasz00_2147,
				BgL_modulez00_2148, ((BgL_valuez00_bglt) BgL_valuez00_2149),
				BgL_importz00_2150, BgL_srcz00_2151);
		}
	}



/* unbind-global! */
	BGL_EXPORTED_DEF obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_33, obj_t BgL_modulez00_34)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 389 */
			{	/* Ast/venv.scm 390 */
				obj_t BgL_globalz00_1578;

				{	/* Ast/venv.scm 390 */
					obj_t BgL_list1658z00_1596;

					BgL_list1658z00_1596 = MAKE_PAIR(BgL_modulez00_34, BNIL);
					BgL_globalz00_1578 =
						BGl_findzd2globalzd2zzast_envz00(BgL_idz00_33,
						BgL_list1658z00_1596);
				}
				if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_1578,
						BGl_globalz00zzast_varz00))
					{	/* Ast/venv.scm 393 */
						obj_t BgL_bucketz00_1580;

						BgL_bucketz00_1580 =
							BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
							BgL_idz00_33);
						{	/* Ast/venv.scm 394 */
							obj_t BgL_g1109z00_1581;

							BgL_g1109z00_1581 = CDR(BgL_bucketz00_1580);
							{
								obj_t BgL_curz00_1583;
								obj_t BgL_prevz00_1584;

								BgL_curz00_1583 = BgL_g1109z00_1581;
								BgL_prevz00_1584 = BgL_bucketz00_1580;
							BgL_zc3anonymousza31636ze3z83_1585:
								if ((CAR(BgL_curz00_1583) == BgL_globalz00_1578))
									{	/* Ast/venv.scm 397 */
										obj_t BgL_auxz00_2552;

										BgL_auxz00_2552 = CDR(BgL_curz00_1583);
										return SET_CDR(BgL_prevz00_1584, BgL_auxz00_2552);
									}
								else
									{
										obj_t BgL_prevz00_2557;
										obj_t BgL_curz00_2555;

										BgL_curz00_2555 = CDR(BgL_curz00_1583);
										BgL_prevz00_2557 = CDR(BgL_prevz00_1584);
										BgL_prevz00_1584 = BgL_prevz00_2557;
										BgL_curz00_1583 = BgL_curz00_2555;
										goto BgL_zc3anonymousza31636ze3z83_1585;
									}
							}
						}
					}
				else
					{	/* Ast/venv.scm 392 */
						obj_t BgL_arg1652z00_1592;

						{	/* Ast/venv.scm 392 */
							obj_t BgL_arg1656z00_1594;

							{	/* Ast/venv.scm 392 */
								obj_t BgL_arg1657z00_1595;

								BgL_arg1657z00_1595 = MAKE_PAIR(BgL_modulez00_34, BNIL);
								BgL_arg1656z00_1594 =
									MAKE_PAIR(BgL_idz00_33, BgL_arg1657z00_1595);
							}
							BgL_arg1652z00_1592 =
								MAKE_PAIR(CNST_TABLE_REF(((long) 3)), BgL_arg1656z00_1594);
						}
						return
							BGl_userzd2errorzd2zztools_errorz00(BGl_string1840z00zzast_envz00,
							BGl_string1841z00zzast_envz00, BgL_arg1652z00_1592, BNIL);
					}
			}
		}
	}



/* &unbind-global! */
	obj_t BGl_z62unbindzd2globalz12za2zzast_envz00(obj_t BgL_envz00_2152,
		obj_t BgL_idz00_2153, obj_t BgL_modulez00_2154)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 389 */
			return
				BGl_unbindzd2globalz12zc0zzast_envz00(BgL_idz00_2153,
				BgL_modulez00_2154);
		}
	}



/* for-each-global! */
	BGL_EXPORTED_DEF obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t
		BgL_procz00_35, obj_t BgL_envz00_36)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 403 */
			{	/* Ast/venv.scm 404 */
				obj_t BgL_arg1663z00_1597;

				if (NULLP(BgL_envz00_36))
					{	/* Ast/venv.scm 404 */
						BgL_arg1663z00_1597 = BGl_za2Genvza2z00zzast_envz00;
					}
				else
					{	/* Ast/venv.scm 404 */
						BgL_arg1663z00_1597 = CAR(BgL_envz00_36);
					}
				{	/* Ast/venv.scm 405 */
					obj_t BgL_zc3anonymousza31673ze3z83_2155;

					BgL_zc3anonymousza31673ze3z83_2155 =
						MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31673ze3ze1zzast_envz00,
						(int) (((long) 2)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3anonymousza31673ze3z83_2155,
						(int) (((long) 0)), BgL_procz00_35);
					return
						BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_arg1663z00_1597,
						BgL_zc3anonymousza31673ze3z83_2155);
				}
			}
		}
	}



/* &for-each-global! */
	obj_t BGl_z62forzd2eachzd2globalz12z70zzast_envz00(obj_t BgL_envz00_2156,
		obj_t BgL_procz00_2157, obj_t BgL_envz00_2158)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 403 */
			return
				BGl_forzd2eachzd2globalz12z12zzast_envz00(BgL_procz00_2157,
				BgL_envz00_2158);
		}
	}



/* &<anonymous:1673> */
	obj_t BGl_z62zc3anonymousza31673ze3ze1zzast_envz00(obj_t BgL_envz00_2159,
		obj_t BgL_kz00_2161, obj_t BgL_bucketz00_2162)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 405 */
			{	/* Ast/venv.scm 405 */
				obj_t BgL_procz00_2160;

				BgL_procz00_2160 =
					((obj_t) PROCEDURE_REF(BgL_envz00_2159, (int) (((long) 0))));
				{
					obj_t BgL_kz00_1600;
					obj_t BgL_bucketz00_1601;

					{	/* Ast/venv.scm 405 */
						bool_t BgL_auxz00_2578;

						BgL_kz00_1600 = BgL_kz00_2161;
						BgL_bucketz00_1601 = BgL_bucketz00_2162;
						{	/* Ast/venv.scm 405 */
							obj_t BgL_g1284z00_1603;

							BgL_g1284z00_1603 = CDR(BgL_bucketz00_1601);
							{
								obj_t BgL_l1282z00_1605;

								BgL_l1282z00_1605 = BgL_g1284z00_1603;
							BgL_zc3anonymousza31674ze3z83_1606:
								if (PAIRP(BgL_l1282z00_1605))
									{	/* Ast/venv.scm 405 */
										{	/* Ast/venv.scm 405 */
											obj_t BgL_arg1676z00_1608;

											BgL_arg1676z00_1608 = CAR(BgL_l1282z00_1605);
											PROCEDURE_ENTRY(BgL_procz00_2160) (BgL_procz00_2160,
												BgL_arg1676z00_1608, BEOA);
										}
										{
											obj_t BgL_l1282z00_2587;

											BgL_l1282z00_2587 = CDR(BgL_l1282z00_1605);
											BgL_l1282z00_1605 = BgL_l1282z00_2587;
											goto BgL_zc3anonymousza31674ze3z83_1606;
										}
									}
								else
									{	/* Ast/venv.scm 405 */
										BgL_auxz00_2578 = ((bool_t) 1);
									}
							}
						}
						return BBOOL(BgL_auxz00_2578);
					}
				}
			}
		}
	}



/* global-bucket-position */
	BGL_EXPORTED_DEF obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t
		BgL_idz00_37, obj_t BgL_modulez00_38)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 410 */
			{	/* Ast/venv.scm 411 */
				obj_t BgL_bucketz00_1612;

				BgL_bucketz00_1612 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_37);
				if (PAIRP(BgL_bucketz00_1612))
					{	/* Ast/venv.scm 414 */
						obj_t BgL_g1110z00_1614;

						BgL_g1110z00_1614 = CDR(BgL_bucketz00_1612);
						{
							obj_t BgL_globalsz00_1616;
							long BgL_posz00_1617;

							{	/* Ast/venv.scm 414 */
								long BgL_auxz00_2594;

								BgL_globalsz00_1616 = BgL_g1110z00_1614;
								BgL_posz00_1617 = ((long) 0);
							BgL_zc3anonymousza31679ze3z83_1618:
								if (NULLP(BgL_globalsz00_1616))
									{	/* Ast/venv.scm 417 */
										BgL_auxz00_2594 = ((long) -1);
									}
								else
									{	/* Ast/venv.scm 417 */
										if (
											((((BgL_globalz00_bglt) CREF(
															((BgL_globalz00_bglt)
																CAR(BgL_globalsz00_1616))))->BgL_modulez00) ==
												BgL_modulez00_38))
											{	/* Ast/venv.scm 419 */
												BgL_auxz00_2594 = BgL_posz00_1617;
											}
										else
											{
												long BgL_posz00_2604;
												obj_t BgL_globalsz00_2602;

												BgL_globalsz00_2602 = CDR(BgL_globalsz00_1616);
												BgL_posz00_2604 = (BgL_posz00_1617 + ((long) 1));
												BgL_posz00_1617 = BgL_posz00_2604;
												BgL_globalsz00_1616 = BgL_globalsz00_2602;
												goto BgL_zc3anonymousza31679ze3z83_1618;
											}
									}
								return BINT(BgL_auxz00_2594);
							}
						}
					}
				else
					{	/* Ast/venv.scm 412 */
						return BINT(((long) -1));
		}}}
	}



/* &global-bucket-position */
	obj_t BGl_z62globalzd2bucketzd2positionz62zzast_envz00(obj_t BgL_envz00_2163,
		obj_t BgL_idz00_2164, obj_t BgL_modulez00_2165)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 410 */
			return
				BGl_globalzd2bucketzd2positionz00zzast_envz00(BgL_idz00_2164,
				BgL_modulez00_2165);
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_proc1842z00zzast_envz00, BGl_valuez00zzast_varz00,
				BGl_string1843z00zzast_envz00);
		}
	}



/* &restore-value-types!1285 */
	obj_t BGl_z62restorezd2valuezd2typesz121285z70zzast_envz00(obj_t
		BgL_envz00_2167, obj_t BgL_valuez00_2168)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 152 */
			return BUNSPEC;
		}
	}



/* restore-value-types! */
	obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt
		BgL_valuez00_9)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 152 */
			{	/* Ast/venv.scm 152 */
				obj_t BgL_method1286z00_1630;

				{	/* Ast/venv.scm 152 */
					obj_t BgL_res1825z00_2082;

					{	/* Ast/venv.scm 152 */
						long BgL_objzd2classzd2numz00_2055;

						{	/* Ast/venv.scm 152 */
							long BgL_res1819z00_2058;

							BgL_res1819z00_2058 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_valuez00_9));
							BgL_objzd2classzd2numz00_2055 = BgL_res1819z00_2058;
						}
						{	/* Ast/venv.scm 152 */
							obj_t BgL_arg1664z00_2056;

							BgL_arg1664z00_2056 =
								PROCEDURE_REF
								(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
								(int) (((long) 1)));
							{	/* Ast/venv.scm 152 */
								int BgL_offsetz00_2060;

								BgL_offsetz00_2060 = (int) (BgL_objzd2classzd2numz00_2055);
								{	/* Ast/venv.scm 152 */
									long BgL_offsetz00_2061;

									BgL_offsetz00_2061 =
										((long) (BgL_offsetz00_2060) - OBJECT_TYPE);
									{	/* Ast/venv.scm 152 */
										long BgL_modz00_2062;

										{	/* Ast/venv.scm 152 */
											int BgL_arg1666z00_2063;

											BgL_arg1666z00_2063 = (int) (((long) 16));
											{	/* Ast/venv.scm 152 */
												long BgL_res1822z00_2073;

												{	/* Ast/venv.scm 152 */
													long BgL_auxz00_2618;

													BgL_auxz00_2618 = (long) (BgL_arg1666z00_2063);
													BgL_res1822z00_2073 =
														(BgL_offsetz00_2061 / BgL_auxz00_2618);
												}
												BgL_modz00_2062 = BgL_res1822z00_2073;
										}}
										{	/* Ast/venv.scm 152 */
											long BgL_restz00_2064;

											{	/* Ast/venv.scm 152 */
												int BgL_arg1665z00_2065;

												BgL_arg1665z00_2065 = (int) (((long) 16));
												{	/* Ast/venv.scm 152 */
													long BgL_res1824z00_2077;

													{	/* Ast/venv.scm 152 */
														long BgL_auxz00_2622;

														BgL_auxz00_2622 = (long) (BgL_arg1665z00_2065);
														BgL_res1824z00_2077 =
															(BgL_offsetz00_2061 % BgL_auxz00_2622);
													}
													BgL_restz00_2064 = BgL_res1824z00_2077;
											}}
											{	/* Ast/venv.scm 152 */

												BgL_res1825z00_2082 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_2056,
														(int) (BgL_modz00_2062)), (int) (BgL_restz00_2064));
					}}}}}}}
					BgL_method1286z00_1630 = BgL_res1825z00_2082;
				}
				return
					PROCEDURE_ENTRY(BgL_method1286z00_1630) (BgL_method1286z00_1630,
					((obj_t) BgL_valuez00_9), BEOA);
			}
		}
	}



/* &restore-value-types! */
	obj_t BGl_z62restorezd2valuezd2typesz12z70zzast_envz00(obj_t BgL_envz00_2169,
		obj_t BgL_valuez00_2170)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 152 */
			return
				BGl_restorezd2valuezd2typesz12z12zzast_envz00(
				((BgL_valuez00_bglt) BgL_valuez00_2170));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_funz00zzast_varz00, BGl_proc1844z00zzast_envz00,
				BGl_string1845z00zzast_envz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_sfunz00zzast_varz00, BGl_proc1846z00zzast_envz00,
				BGl_string1845z00zzast_envz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc1847z00zzast_envz00,
				BGl_string1845z00zzast_envz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_cfunz00zzast_varz00, BGl_proc1848z00zzast_envz00,
				BGl_string1845z00zzast_envz00);
		}
	}



/* &restore-value-types!1294 */
	obj_t BGl_z62restorezd2valuezd2typesz121294z70zzast_envz00(obj_t
		BgL_envz00_2175, obj_t BgL_valuez00_2176)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 207 */
			{
				BgL_cfunz00_bglt BgL_valuez00_1674;

				{	/* Ast/venv.scm 207 */
					bool_t BgL_auxz00_2640;

					BgL_valuez00_1674 = ((BgL_cfunz00_bglt) BgL_valuez00_2176);
					{

						{	/* Ast/venv.scm 207 */
							obj_t BgL_nextzd2method1293zd2_1688;

							BgL_nextzd2method1293zd2_1688 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								((BgL_objectz00_bglt) BgL_valuez00_1674),
								BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
								BGl_cfunz00zzast_varz00);
							PROCEDURE_ENTRY(BgL_nextzd2method1293zd2_1688)
								(BgL_nextzd2method1293zd2_1688, ((obj_t) BgL_valuez00_1674),
								BEOA);
						}
						{
							obj_t BgL_argsz00_1680;

							BgL_argsz00_1680 =
								(((BgL_cfunz00_bglt) CREF(BgL_valuez00_1674))->
								BgL_argszd2typezd2);
						BgL_zc3anonymousza31713ze3z83_1681:
							if (PAIRP(BgL_argsz00_1680))
								{	/* Ast/venv.scm 211 */
									{	/* Ast/venv.scm 213 */
										BgL_typez00_bglt BgL_arg1715z00_1683;

										{	/* Ast/venv.scm 213 */
											obj_t BgL_arg1716z00_1684;

											BgL_arg1716z00_1684 =
												(((BgL_typez00_bglt) CREF(
														((BgL_typez00_bglt)
															CAR(BgL_argsz00_1680))))->BgL_idz00);
											BgL_arg1715z00_1683 =
												BGl_findzd2typezd2zztype_envz00(BgL_arg1716z00_1684);
										}
										{	/* Ast/venv.scm 213 */
											obj_t BgL_auxz00_2654;

											BgL_auxz00_2654 = ((obj_t) BgL_arg1715z00_1683);
											SET_CAR(BgL_argsz00_1680, BgL_auxz00_2654);
										}
									}
									{
										obj_t BgL_argsz00_2657;

										BgL_argsz00_2657 = CDR(BgL_argsz00_1680);
										BgL_argsz00_1680 = BgL_argsz00_2657;
										goto BgL_zc3anonymousza31713ze3z83_1681;
									}
								}
							else
								{	/* Ast/venv.scm 211 */
									BgL_auxz00_2640 = ((bool_t) 0);
								}
						}
					}
					return BBOOL(BgL_auxz00_2640);
				}
			}
		}
	}



/* &restore-value-types!1292 */
	obj_t BGl_z62restorezd2valuezd2typesz121292z70zzast_envz00(obj_t
		BgL_envz00_2177, obj_t BgL_valuez00_2178)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 200 */
			{
				BgL_sfunz00_bglt BgL_valuez00_1669;

				BgL_valuez00_1669 = ((BgL_sfunz00_bglt) BgL_valuez00_2178);
				{

					{	/* Ast/venv.scm 200 */
						obj_t BgL_nextzd2method1291zd2_1673;

						BgL_nextzd2method1291zd2_1673 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							((BgL_objectz00_bglt) BgL_valuez00_1669),
							BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
							BGl_isfunz00zzinline_inlinez00);
						PROCEDURE_ENTRY(BgL_nextzd2method1291zd2_1673)
							(BgL_nextzd2method1291zd2_1673, ((obj_t) BgL_valuez00_1669),
							BEOA);
					}
					{	/* Ast/venv.scm 202 */
						BgL_nodez00_bglt BgL_arg1710z00_1672;

						{
							BgL_isfunz00_bglt BgL_auxz00_2669;

							{
								obj_t BgL_auxz00_2670;

								{	/* Ast/venv.scm 202 */
									BgL_objectz00_bglt BgL_auxz00_2671;

									BgL_auxz00_2671 = ((BgL_objectz00_bglt) BgL_valuez00_1669);
									BgL_auxz00_2670 = BGL_OBJECT_WIDENING(BgL_auxz00_2671);
								}
								BgL_auxz00_2669 = ((BgL_isfunz00_bglt) BgL_auxz00_2670);
							}
							BgL_arg1710z00_1672 =
								(((BgL_isfunz00_bglt) CREF(BgL_auxz00_2669))->
								BgL_originalzd2bodyzd2);
						}
						return BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_arg1710z00_1672);
					}
				}
			}
		}
	}



/* &restore-value-types!1290 */
	obj_t BGl_z62restorezd2valuezd2typesz121290z70zzast_envz00(obj_t
		BgL_envz00_2179, obj_t BgL_valuez00_2180)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 166 */
			{
				BgL_sfunz00_bglt BgL_valuez00_1640;

				BgL_valuez00_1640 = ((BgL_sfunz00_bglt) BgL_valuez00_2180);
				{

					{	/* Ast/venv.scm 166 */
						obj_t BgL_nextzd2method1289zd2_1668;

						BgL_nextzd2method1289zd2_1668 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							((BgL_objectz00_bglt) BgL_valuez00_1640),
							BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
							BGl_sfunz00zzast_varz00);
						PROCEDURE_ENTRY(BgL_nextzd2method1289zd2_1668)
							(BgL_nextzd2method1289zd2_1668, ((obj_t) BgL_valuez00_1640),
							BEOA);
					}
					{
						obj_t BgL_argsz00_1646;

						BgL_argsz00_1646 =
							(((BgL_sfunz00_bglt) CREF(BgL_valuez00_1640))->BgL_argsz00);
					BgL_zc3anonymousza31692ze3z83_1647:
						if (PAIRP(BgL_argsz00_1646))
							{	/* Ast/venv.scm 172 */
								obj_t BgL_argz00_1649;

								BgL_argz00_1649 = CAR(BgL_argsz00_1646);
								if (BGl_isazf3zf3zz__objectz00(BgL_argz00_1649,
										BGl_typez00zztype_typez00))
									{	/* Ast/venv.scm 175 */
										BgL_typez00_bglt BgL_arg1695z00_1651;

										{	/* Ast/venv.scm 175 */
											obj_t BgL_arg1696z00_1652;

											BgL_arg1696z00_1652 =
												(((BgL_typez00_bglt) CREF(
														((BgL_typez00_bglt) BgL_argz00_1649)))->BgL_idz00);
											BgL_arg1695z00_1651 =
												BGl_findzd2typezd2zztype_envz00(BgL_arg1696z00_1652);
										}
										{	/* Ast/venv.scm 175 */
											obj_t BgL_auxz00_2693;

											BgL_auxz00_2693 = ((obj_t) BgL_arg1695z00_1651);
											SET_CAR(BgL_argsz00_1646, BgL_auxz00_2693);
										}
									}
								else
									{	/* Ast/venv.scm 174 */
										if (BGl_isazf3zf3zz__objectz00(BgL_argz00_1649,
												BGl_localz00zzast_varz00))
											{	/* Ast/venv.scm 177 */
												BgL_typez00_bglt BgL_newzd2typezd2_1654;

												{	/* Ast/venv.scm 177 */
													obj_t BgL_arg1698z00_1655;

													BgL_arg1698z00_1655 =
														(((BgL_typez00_bglt) CREF(
																(((BgL_variablez00_bglt) CREF(
																			((BgL_variablez00_bglt)
																				((BgL_localz00_bglt)
																					BgL_argz00_1649))))->BgL_typez00)))->
														BgL_idz00);
													BgL_newzd2typezd2_1654 =
														BGl_findzd2typezd2zztype_envz00
														(BgL_arg1698z00_1655);
												}
												((((BgL_variablez00_bglt) CREF(
																((BgL_variablez00_bglt)
																	((BgL_localz00_bglt) BgL_argz00_1649))))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_newzd2typezd2_1654), BUNSPEC);
											}
										else
											{	/* Ast/venv.scm 176 */
												BGl_errorz00zz__errorz00(BGl_string1849z00zzast_envz00,
													BGl_string1850z00zzast_envz00,
													BGl_shapez00zztools_shapez00(BgL_argz00_1649));
											}
									}
								{
									obj_t BgL_argsz00_2708;

									BgL_argsz00_2708 = CDR(BgL_argsz00_1646);
									BgL_argsz00_1646 = BgL_argsz00_2708;
									goto BgL_zc3anonymousza31692ze3z83_1647;
								}
							}
						else
							{	/* Ast/venv.scm 171 */
								if (NULLP(BgL_argsz00_1646))
									{	/* Ast/venv.scm 185 */
										obj_t BgL_bodyz00_1660;

										BgL_bodyz00_1660 =
											(((BgL_sfunz00_bglt) CREF(BgL_valuez00_1640))->
											BgL_bodyz00);
										if (BGl_isazf3zf3zz__objectz00(BgL_bodyz00_1660,
												BGl_nodez00zzast_nodez00))
											{	/* Ast/venv.scm 188 */
												BgL_typez00_bglt BgL_tresz00_1662;

												BgL_tresz00_1662 =
													(((BgL_nodez00_bglt) CREF(
															((BgL_nodez00_bglt) BgL_bodyz00_1660)))->
													BgL_typez00);
												BGl_hrtypezd2nodez12zc0zzast_hrtypez00((
														(BgL_nodez00_bglt) BgL_bodyz00_1660));
												{	/* Ast/venv.scm 190 */
													bool_t BgL_testz00_2719;

													{	/* Ast/venv.scm 190 */
														bool_t BgL_res1832z00_2108;

														BgL_res1832z00_2108 =
															BGl_isazf3zf3zz__objectz00(
															((obj_t) BgL_tresz00_1662),
															BGl_typez00zztype_typez00);
														BgL_testz00_2719 = BgL_res1832z00_2108;
													}
													if (BgL_testz00_2719)
														{	/* Ast/venv.scm 191 */
															BgL_typez00_bglt BgL_arg1707z00_1664;

															BgL_arg1707z00_1664 =
																BGl_findzd2typezd2zztype_envz00(
																(((BgL_typez00_bglt) CREF(BgL_tresz00_1662))->
																	BgL_idz00));
															return ((((BgL_nodez00_bglt)
																		CREF(((BgL_nodez00_bglt)
																				BgL_bodyz00_1660)))->BgL_typez00) =
																((BgL_typez00_bglt) BgL_arg1707z00_1664),
																BUNSPEC);
														}
													else
														{	/* Ast/venv.scm 190 */
															return BFALSE;
														}
												}
											}
										else
											{	/* Ast/venv.scm 187 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/venv.scm 184 */
										return
											BGl_errorz00zz__errorz00(BGl_string1851z00zzast_envz00,
											BGl_string1852z00zzast_envz00,
											BGl_shapez00zztools_shapez00(BgL_argsz00_1646));
									}
							}
					}
				}
			}
		}
	}



/* &restore-value-types!1288 */
	obj_t BGl_z62restorezd2valuezd2typesz121288z70zzast_envz00(obj_t
		BgL_envz00_2181, obj_t BgL_valuez00_2182)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 158 */
			{
				BgL_funz00_bglt BgL_valuez00_1631;

				BgL_valuez00_1631 = ((BgL_funz00_bglt) BgL_valuez00_2182);
				{	/* Ast/venv.scm 160 */
					bool_t BgL_testz00_2730;

					{	/* Ast/venv.scm 160 */
						obj_t BgL_arg1690z00_1638;

						BgL_arg1690z00_1638 =
							(((BgL_funz00_bglt) CREF(BgL_valuez00_1631))->
							BgL_predicatezd2ofzd2);
						BgL_testz00_2730 =
							BGl_isazf3zf3zz__objectz00(BgL_arg1690z00_1638,
							BGl_typez00zztype_typez00);
					}
					if (BgL_testz00_2730)
						{
							obj_t BgL_auxz00_2733;

							{	/* Ast/venv.scm 161 */
								obj_t BgL_arg1688z00_1636;

								BgL_arg1688z00_1636 =
									(((BgL_typez00_bglt) CREF(
											((BgL_typez00_bglt)
												(((BgL_funz00_bglt) CREF(BgL_valuez00_1631))->
													BgL_predicatezd2ofzd2))))->BgL_idz00);
								BgL_auxz00_2733 =
									((obj_t)
									BGl_findzd2typezd2zztype_envz00(BgL_arg1688z00_1636));
							}
							return
								((((BgL_funz00_bglt) CREF(BgL_valuez00_1631))->
									BgL_predicatezd2ofzd2) = ((obj_t) BgL_auxz00_2733), BUNSPEC);
						}
					else
						{	/* Ast/venv.scm 160 */
							return BFALSE;
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 122361728),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 216926614),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 458567972),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_hrtypez00(((long) 156957722),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 261574382),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
			return
				BGl_modulezd2initializa7ationz75zzinline_inlinez00(((long) 20504962),
				BSTRING_TO_STRING(BGl_string1853z00zzast_envz00));
		}
	}

#ifdef __cplusplus
}
#endif
