/*===========================================================================*/
/*   (Sync/node.scm)                                                         */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Sync/node.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;


	static obj_t BGl_mpopz00zzsync_nodez00 = BUNSPEC;
	extern obj_t BGl_za2synczd2profilingza2zd2zzengine_paramz00;
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzsync_nodez00();
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_getexitdtopz00zzsync_nodez00 = BUNSPEC;
	static obj_t BGl_methodzd2initzd2zzsync_nodez00();
	static obj_t BGl_exitdzd2mutexzd2profilez00zzsync_nodez00 = BUNSPEC;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl_mpushz00zzsync_nodez00 = BUNSPEC;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_synczd2ze3sequencez31zzsync_nodez00(BgL_syncz00_bglt);
	static obj_t BGl_mulockz00zzsync_nodez00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_failsafezd2synczf3z21zzsync_failsafez00(BgL_syncz00_bglt);
	static obj_t BGl_requirezd2initializa7ationz75zzsync_nodez00 = BUNSPEC;
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzsync_nodez00();
	static obj_t BGl_failsafezd2mutexzd2profilez00zzsync_nodez00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zzsync_nodez00();
	static obj_t BGl_initzd2syncz12zc0zzsync_nodez00(obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_mlockz00zzsync_nodez00 = BUNSPEC;
	static BgL_nodez00_bglt BGl_z62synczd2ze3sequencez53zzsync_nodez00(obj_t,
		obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_mlockprelockz00zzsync_nodez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzsync_nodez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzsync_failsafez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_cplibz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_effectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_localz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	static obj_t BGl_cnstzd2initzd2zzsync_nodez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzsync_nodez00();
	extern BgL_localz00_bglt BGl_makezd2localzd2svarz00zzast_localz00(obj_t,
		BgL_typez00_bglt);
	static obj_t BGl_importedzd2moduleszd2initz00zzsync_nodez00();
	extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t
		BGl_setzd2variablezd2namez12z12zzbackend_cplibz00(BgL_variablez00_bglt);
	static obj_t __cnst[15];


	   
		 
		DEFINE_STRING(BGl_string1791z00zzsync_nodez00,
		BgL_bgl_string1791za700za7za7s1796za7, "sync_node", 9);
	      DEFINE_STRING(BGl_string1792z00zzsync_nodez00,
		BgL_bgl_string1792za700za7za7s1797za7,
		"top tmp value (@ exitd-pop-protect! __bexit) (@ exitd-push-protect! __bexit) $exitd-pop-protect! $exitd-push-protect! $failsafe-mutex-profile $exitd-mutex-profile c $mutex-unlock $mutex-lock-prelock $mutex-lock app $get-exitd-top ",
		230);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_synczd2ze3sequencezd2envze3zzsync_nodez00,
		BgL_bgl_za762syncza7d2za7e3seq1798za7,
		BGl_z62synczd2ze3sequencez53zzsync_nodez00, 0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzsync_nodez00(long
		BgL_checksumz00_2078, char *BgL_fromz00_2079)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzsync_nodez00))
				{
					BGl_requirezd2initializa7ationz75zzsync_nodez00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzsync_nodez00();
					BGl_cnstzd2initzd2zzsync_nodez00();
					BGl_importedzd2moduleszd2initz00zzsync_nodez00();
					return BGl_toplevelzd2initzd2zzsync_nodez00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzsync_nodez00()
	{
		AN_OBJECT;
		{	/* Sync/node.scm 18 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "sync_node");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"sync_node");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "sync_node");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"sync_node");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"sync_node");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"sync_node");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"sync_node");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "sync_node");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzsync_nodez00()
	{
		AN_OBJECT;
		{	/* Sync/node.scm 18 */
			{	/* Sync/node.scm 18 */
				obj_t BgL_cportz00_2065;

				{	/* Sync/node.scm 18 */
					obj_t BgL_startz00_2074;

					BgL_startz00_2074 = BINT(((long) 0));
					{	/* Sync/node.scm 18 */
						obj_t BgL_endz00_2075;

						BgL_endz00_2075 =
							BINT(STRING_LENGTH(BGl_string1792z00zzsync_nodez00));
						{	/* Sync/node.scm 18 */

							BgL_cportz00_2065 =
								BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
								(BGl_string1792z00zzsync_nodez00, BgL_startz00_2074,
								BgL_endz00_2075);
				}}}
				{
					long BgL_iz00_2066;

					BgL_iz00_2066 = ((long) 14);
				BgL_loopz00_2067:
					if ((BgL_iz00_2066 == ((long) -1)))
						{	/* Sync/node.scm 18 */
							return BUNSPEC;
						}
					else
						{	/* Sync/node.scm 18 */
							{	/* Sync/node.scm 18 */
								obj_t BgL_arg1794z00_2069;

								{	/* Sync/node.scm 18 */

									{	/* Sync/node.scm 18 */
										obj_t BgL_locationz00_2071;

										BgL_locationz00_2071 = BBOOL(((bool_t) 0));
										{	/* Sync/node.scm 18 */

											BgL_arg1794z00_2069 =
												BGl_readz00zz__readerz00(BgL_cportz00_2065,
												BgL_locationz00_2071);
										}
									}
								}
								{	/* Sync/node.scm 18 */
									int BgL_auxz00_2103;

									BgL_auxz00_2103 = (int) (BgL_iz00_2066);
									CNST_TABLE_SET(BgL_auxz00_2103, BgL_arg1794z00_2069);
							}}
							{	/* Sync/node.scm 18 */
								int BgL_auxz00_2072;

								BgL_auxz00_2072 = (int) ((BgL_iz00_2066 - ((long) 1)));
								{
									long BgL_iz00_2108;

									BgL_iz00_2108 = (long) (BgL_auxz00_2072);
									BgL_iz00_2066 = BgL_iz00_2108;
									goto BgL_loopz00_2067;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzsync_nodez00()
	{
		AN_OBJECT;
		{	/* Sync/node.scm 18 */
			BGl_mlockz00zzsync_nodez00 = BFALSE;
			BGl_mlockprelockz00zzsync_nodez00 = BFALSE;
			BGl_mulockz00zzsync_nodez00 = BFALSE;
			BGl_mpushz00zzsync_nodez00 = BFALSE;
			BGl_mpopz00zzsync_nodez00 = BFALSE;
			BGl_getexitdtopz00zzsync_nodez00 = BFALSE;
			BGl_exitdzd2mutexzd2profilez00zzsync_nodez00 = BFALSE;
			return (BGl_failsafezd2mutexzd2profilez00zzsync_nodez00 =
				BFALSE, BUNSPEC);
		}
	}



/* init-sync! */
	obj_t BGl_initzd2syncz12zc0zzsync_nodez00(obj_t BgL_locz00_17)
	{
		AN_OBJECT;
		{	/* Sync/node.scm 61 */
			if (CBOOL(BGl_mlockz00zzsync_nodez00))
				{	/* Sync/node.scm 62 */
					return BFALSE;
				}
			else
				{	/* Sync/node.scm 62 */
					BGl_getexitdtopz00zzsync_nodez00 =
						((obj_t)
						BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 0)), BNIL,
							BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
					BGl_mlockz00zzsync_nodez00 =
						((obj_t) BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
									2)), BNIL, BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
					BGl_mlockprelockz00zzsync_nodez00 =
						((obj_t) BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
									3)), BNIL, BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
					BGl_mulockz00zzsync_nodez00 =
						((obj_t) BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
									4)), BNIL, BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
					{	/* Sync/node.scm 67 */
						obj_t BgL_casezd2valuezd2_1573;

						{	/* Sync/node.scm 67 */
							obj_t BgL_arg1361z00_1577;

							BgL_arg1361z00_1577 = BGl_thezd2backendzd2zzbackend_backendz00();
							BgL_casezd2valuezd2_1573 =
								(((BgL_backendz00_bglt) CREF(
										((BgL_backendz00_bglt) BgL_arg1361z00_1577)))->
								BgL_languagez00);
						}
						if ((BgL_casezd2valuezd2_1573 == CNST_TABLE_REF(((long) 5))))
							{	/* Sync/node.scm 67 */
								if (CBOOL(BGl_za2synczd2profilingza2zd2zzengine_paramz00))
									{	/* Sync/node.scm 69 */
										BGl_exitdzd2mutexzd2profilez00zzsync_nodez00 =
											((obj_t)
											BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
														6)), BNIL, BgL_locz00_17,
												CNST_TABLE_REF(((long) 1))));
										BGl_failsafezd2mutexzd2profilez00zzsync_nodez00 =
											((obj_t)
											BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
														7)), BNIL, BgL_locz00_17,
												CNST_TABLE_REF(((long) 1))));
										{	/* Sync/node.scm 74 */
											BgL_variablez00_bglt BgL_arg1344z00_1575;

											{	/* Sync/node.scm 74 */
												BgL_varz00_bglt BgL_oz00_1967;

												BgL_oz00_1967 =
													((BgL_varz00_bglt)
													BGl_exitdzd2mutexzd2profilez00zzsync_nodez00);
												BgL_arg1344z00_1575 =
													(((BgL_varz00_bglt) CREF(BgL_oz00_1967))->
													BgL_variablez00);
											}
											BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
												(BgL_arg1344z00_1575);
										}
										{	/* Sync/node.scm 75 */
											BgL_variablez00_bglt BgL_arg1360z00_1576;

											{	/* Sync/node.scm 75 */
												BgL_varz00_bglt BgL_oz00_1968;

												BgL_oz00_1968 =
													((BgL_varz00_bglt)
													BGl_failsafezd2mutexzd2profilez00zzsync_nodez00);
												BgL_arg1360z00_1576 =
													(((BgL_varz00_bglt) CREF(BgL_oz00_1968))->
													BgL_variablez00);
											}
											BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
												(BgL_arg1360z00_1576);
									}}
								else
									{	/* Sync/node.scm 69 */
										BFALSE;
									}
								BGl_mpushz00zzsync_nodez00 =
									((obj_t)
									BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 8)),
										BNIL, BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
								BGl_mpopz00zzsync_nodez00 =
									((obj_t)
									BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 9)),
										BNIL, BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
							}
						else
							{	/* Sync/node.scm 67 */
								BGl_mpushz00zzsync_nodez00 =
									((obj_t)
									BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
												10)), BNIL, BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
								BGl_mpopz00zzsync_nodez00 =
									((obj_t)
									BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
												11)), BNIL, BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
					}}
					{	/* Sync/node.scm 81 */
						BgL_variablez00_bglt BgL_arg1366z00_1578;

						{	/* Sync/node.scm 81 */
							BgL_varz00_bglt BgL_oz00_1969;

							BgL_oz00_1969 =
								((BgL_varz00_bglt) BGl_getexitdtopz00zzsync_nodez00);
							BgL_arg1366z00_1578 =
								(((BgL_varz00_bglt) CREF(BgL_oz00_1969))->BgL_variablez00);
						}
						BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1366z00_1578);
					}
					{	/* Sync/node.scm 82 */
						BgL_variablez00_bglt BgL_arg1371z00_1579;

						{	/* Sync/node.scm 82 */
							BgL_varz00_bglt BgL_oz00_1970;

							BgL_oz00_1970 = ((BgL_varz00_bglt) BGl_mlockz00zzsync_nodez00);
							BgL_arg1371z00_1579 =
								(((BgL_varz00_bglt) CREF(BgL_oz00_1970))->BgL_variablez00);
						}
						BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1371z00_1579);
					}
					{	/* Sync/node.scm 83 */
						BgL_variablez00_bglt BgL_arg1372z00_1580;

						{	/* Sync/node.scm 83 */
							BgL_varz00_bglt BgL_oz00_1971;

							BgL_oz00_1971 =
								((BgL_varz00_bglt) BGl_mlockprelockz00zzsync_nodez00);
							BgL_arg1372z00_1580 =
								(((BgL_varz00_bglt) CREF(BgL_oz00_1971))->BgL_variablez00);
						}
						BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1372z00_1580);
					}
					{	/* Sync/node.scm 84 */
						BgL_variablez00_bglt BgL_arg1374z00_1581;

						{	/* Sync/node.scm 84 */
							BgL_varz00_bglt BgL_oz00_1972;

							BgL_oz00_1972 = ((BgL_varz00_bglt) BGl_mulockz00zzsync_nodez00);
							BgL_arg1374z00_1581 =
								(((BgL_varz00_bglt) CREF(BgL_oz00_1972))->BgL_variablez00);
						}
						BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1374z00_1581);
					}
					{	/* Sync/node.scm 85 */
						BgL_variablez00_bglt BgL_arg1378z00_1582;

						{	/* Sync/node.scm 85 */
							BgL_varz00_bglt BgL_oz00_1973;

							BgL_oz00_1973 = ((BgL_varz00_bglt) BGl_mpushz00zzsync_nodez00);
							BgL_arg1378z00_1582 =
								(((BgL_varz00_bglt) CREF(BgL_oz00_1973))->BgL_variablez00);
						}
						BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1378z00_1582);
					}
					{	/* Sync/node.scm 86 */
						BgL_variablez00_bglt BgL_arg1379z00_1583;

						{	/* Sync/node.scm 86 */
							BgL_varz00_bglt BgL_oz00_1974;

							BgL_oz00_1974 = ((BgL_varz00_bglt) BGl_mpopz00zzsync_nodez00);
							BgL_arg1379z00_1583 =
								(((BgL_varz00_bglt) CREF(BgL_oz00_1974))->BgL_variablez00);
						}
						return
							BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1379z00_1583);
					}
				}
		}
	}



/* sync->sequence */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_synczd2ze3sequencez31zzsync_nodez00(BgL_syncz00_bglt BgL_nodez00_18)
	{
		AN_OBJECT;
		{	/* Sync/node.scm 111 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1720;
				obj_t BgL_locz00_1721;

				{
					BgL_letzd2varzd2_bglt BgL_nodez00_1710;
					obj_t BgL_locz00_1711;

					{
						BgL_syncz00_bglt BgL_nodez00_1664;

						{
							BgL_syncz00_bglt BgL_nodez00_1592;

							{	/* Sync/node.scm 191 */
								obj_t BgL_arg1385z00_1590;

								BgL_arg1385z00_1590 =
									(((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_18)))->BgL_locz00);
								BGl_initzd2syncz12zc0zzsync_nodez00(BgL_arg1385z00_1590);
							}
							if (CBOOL(BGl_failsafezd2synczf3z21zzsync_failsafez00
									(BgL_nodez00_18)))
								{
									BgL_sequencez00_bglt BgL_auxz00_2190;

									BgL_nodez00_1664 = BgL_nodez00_18;
									{	/* Sync/node.scm 130 */
										BgL_localz00_bglt BgL_tmpz00_1667;

										{	/* Sync/node.scm 130 */
											obj_t BgL_arg1675z00_1707;
											BgL_typez00_bglt BgL_arg1676z00_1708;

											BgL_arg1675z00_1707 =
												BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
														(long) 13)));
											BgL_arg1676z00_1708 =
												(((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
															BgL_nodez00_1664)))->BgL_typez00);
											BgL_tmpz00_1667 =
												BGl_makezd2localzd2svarz00zzast_localz00
												(BgL_arg1675z00_1707, BgL_arg1676z00_1708);
										}
										{	/* Sync/node.scm 130 */
											BgL_nodez00_bglt BgL_lockz00_1668;

											{	/* Sync/node.scm 131 */
												bool_t BgL_testz00_2196;

												{	/* Sync/node.scm 131 */
													BgL_nodez00_bglt BgL_arg1674z00_1706;

													BgL_arg1674z00_1706 =
														(((BgL_syncz00_bglt) CREF(BgL_nodez00_1664))->
														BgL_prelockz00);
													{	/* Sync/node.scm 131 */
														bool_t BgL_res1774z00_1988;

														BgL_res1774z00_1988 =
															BGl_isazf3zf3zz__objectz00(
															((obj_t) BgL_arg1674z00_1706),
															BGl_atomz00zzast_nodez00);
														BgL_testz00_2196 = BgL_res1774z00_1988;
												}}
												if (BgL_testz00_2196)
													{	/* Sync/node.scm 132 */
														obj_t BgL_arg1651z00_1696;
														obj_t BgL_arg1652z00_1697;

														{	/* Sync/node.scm 132 */
															obj_t BgL_arg1656z00_1698;

															{	/* Sync/node.scm 132 */
																BgL_nodez00_bglt BgL_arg1657z00_1699;

																BgL_arg1657z00_1699 =
																	(((BgL_syncz00_bglt) CREF(BgL_nodez00_1664))->
																	BgL_mutexz00);
																BgL_arg1656z00_1698 =
																	MAKE_PAIR(((obj_t) BgL_arg1657z00_1699),
																	BNIL);
															}
															BgL_arg1651z00_1696 =
																MAKE_PAIR(BGl_mlockz00zzsync_nodez00,
																BgL_arg1656z00_1698);
														}
														BgL_arg1652z00_1697 =
															(((BgL_nodez00_bglt) CREF(
																	((BgL_nodez00_bglt) BgL_nodez00_1664)))->
															BgL_locz00);
														BgL_lockz00_1668 =
															BGl_applicationzd2ze3nodez31zzast_appz00
															(BgL_arg1651z00_1696, BNIL, BgL_arg1652z00_1697,
															CNST_TABLE_REF(((long) 12)));
													}
												else
													{	/* Sync/node.scm 133 */
														obj_t BgL_arg1663z00_1700;
														obj_t BgL_arg1669z00_1701;

														{	/* Sync/node.scm 133 */
															obj_t BgL_arg1670z00_1702;

															{	/* Sync/node.scm 133 */
																BgL_nodez00_bglt BgL_arg1671z00_1703;
																obj_t BgL_arg1672z00_1704;

																BgL_arg1671z00_1703 =
																	(((BgL_syncz00_bglt) CREF(BgL_nodez00_1664))->
																	BgL_mutexz00);
																{	/* Sync/node.scm 133 */
																	BgL_nodez00_bglt BgL_arg1673z00_1705;

																	BgL_arg1673z00_1705 =
																		(((BgL_syncz00_bglt)
																			CREF(BgL_nodez00_1664))->BgL_prelockz00);
																	BgL_arg1672z00_1704 =
																		MAKE_PAIR(((obj_t) BgL_arg1673z00_1705),
																		BNIL);
																}
																BgL_arg1670z00_1702 =
																	MAKE_PAIR(
																	((obj_t) BgL_arg1671z00_1703),
																	BgL_arg1672z00_1704);
															}
															BgL_arg1663z00_1700 =
																MAKE_PAIR(BGl_mlockprelockz00zzsync_nodez00,
																BgL_arg1670z00_1702);
														}
														BgL_arg1669z00_1701 =
															(((BgL_nodez00_bglt) CREF(
																	((BgL_nodez00_bglt) BgL_nodez00_1664)))->
															BgL_locz00);
														BgL_lockz00_1668 =
															BGl_applicationzd2ze3nodez31zzast_appz00
															(BgL_arg1663z00_1700, BNIL, BgL_arg1669z00_1701,
															CNST_TABLE_REF(((long) 12)));
											}}
											{	/* Sync/node.scm 131 */
												BgL_nodez00_bglt BgL_unlockz00_1669;

												{	/* Sync/node.scm 134 */
													obj_t BgL_arg1635z00_1691;
													obj_t BgL_arg1643z00_1692;

													{	/* Sync/node.scm 134 */
														obj_t BgL_arg1644z00_1693;

														{	/* Sync/node.scm 134 */
															BgL_nodez00_bglt BgL_arg1647z00_1694;

															BgL_arg1647z00_1694 =
																(((BgL_syncz00_bglt) CREF(BgL_nodez00_1664))->
																BgL_mutexz00);
															BgL_arg1644z00_1693 =
																MAKE_PAIR(((obj_t) BgL_arg1647z00_1694), BNIL);
														}
														BgL_arg1635z00_1691 =
															MAKE_PAIR(BGl_mulockz00zzsync_nodez00,
															BgL_arg1644z00_1693);
													}
													BgL_arg1643z00_1692 =
														(((BgL_nodez00_bglt) CREF(
																((BgL_nodez00_bglt) BgL_nodez00_1664)))->
														BgL_locz00);
													BgL_unlockz00_1669 =
														BGl_applicationzd2ze3nodez31zzast_appz00
														(BgL_arg1635z00_1691, BNIL, BgL_arg1643z00_1692,
														CNST_TABLE_REF(((long) 12)));
												}
												{	/* Sync/node.scm 134 */
													BgL_varz00_bglt BgL_vrefz00_1670;

													{	/* Sync/node.scm 135 */
														BgL_varz00_bglt BgL_new1106z00_1688;

														{	/* Sync/node.scm 136 */
															BgL_varz00_bglt BgL_new1105z00_1689;

															BgL_new1105z00_1689 =
																((BgL_varz00_bglt) BREF(GC_MALLOC(sizeof(struct
																			BgL_varz00_bgl))));
															{	/* Sync/node.scm 136 */
																long BgL_arg1634z00_1690;

																{	/* Sync/node.scm 136 */
																	long BgL_res1775z00_1996;

																	BgL_res1775z00_1996 =
																		BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
																	BgL_arg1634z00_1690 = BgL_res1775z00_1996;
																}
																BGL_OBJECT_CLASS_NUM_SET(
																	((BgL_objectz00_bglt) BgL_new1105z00_1689),
																	BgL_arg1634z00_1690);
															}
															{	/* Sync/node.scm 136 */
																BgL_objectz00_bglt BgL_auxz00_2231;

																BgL_auxz00_2231 =
																	((BgL_objectz00_bglt) BgL_new1105z00_1689);
																BGL_OBJECT_WIDENING_SET(BgL_auxz00_2231,
																	BFALSE);
															}
															BgL_new1106z00_1688 = BgL_new1105z00_1689;
														}
														((((BgL_nodez00_bglt) CREF(
																		((BgL_nodez00_bglt) BgL_new1106z00_1688)))->
																BgL_locz00) =
															((obj_t) (((BgL_nodez00_bglt)
																		CREF(((BgL_nodez00_bglt)
																				BgL_nodez00_1664)))->BgL_locz00)),
															BUNSPEC);
														((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
																			BgL_new1106z00_1688)))->BgL_typez00) =
															((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																		CREF(((BgL_nodez00_bglt)
																				BgL_nodez00_1664)))->BgL_typez00)),
															BUNSPEC);
														((((BgL_varz00_bglt) CREF(BgL_new1106z00_1688))->
																BgL_variablez00) =
															((BgL_variablez00_bglt) ((BgL_variablez00_bglt)
																	BgL_tmpz00_1667)), BUNSPEC);
														BgL_vrefz00_1670 = BgL_new1106z00_1688;
													}
													{	/* Sync/node.scm 135 */
														BgL_letzd2varzd2_bglt BgL_lbodyz00_1671;

														{	/* Sync/node.scm 139 */
															BgL_letzd2varzd2_bglt BgL_new1108z00_1677;

															{	/* Sync/node.scm 140 */
																BgL_letzd2varzd2_bglt BgL_new1107z00_1686;

																BgL_new1107z00_1686 =
																	((BgL_letzd2varzd2_bglt)
																	BREF(GC_MALLOC(sizeof(struct
																				BgL_letzd2varzd2_bgl))));
																{	/* Sync/node.scm 140 */
																	long BgL_arg1633z00_1687;

																	{	/* Sync/node.scm 140 */
																		long BgL_res1776z00_2000;

																		BgL_res1776z00_2000 =
																			BGL_CLASS_INDEX
																			(BGl_letzd2varzd2zzast_nodez00);
																		BgL_arg1633z00_1687 = BgL_res1776z00_2000;
																	}
																	BGL_OBJECT_CLASS_NUM_SET(
																		((BgL_objectz00_bglt) BgL_new1107z00_1686),
																		BgL_arg1633z00_1687);
																}
																{	/* Sync/node.scm 140 */
																	BgL_objectz00_bglt BgL_auxz00_2248;

																	BgL_auxz00_2248 =
																		((BgL_objectz00_bglt) BgL_new1107z00_1686);
																	BGL_OBJECT_WIDENING_SET(BgL_auxz00_2248,
																		BFALSE);
																}
																BgL_new1108z00_1677 = BgL_new1107z00_1686;
															}
															((((BgL_nodez00_bglt) CREF(
																			((BgL_nodez00_bglt)
																				BgL_new1108z00_1677)))->BgL_locz00) =
																((obj_t) (((BgL_nodez00_bglt)
																			CREF(((BgL_nodez00_bglt)
																					BgL_nodez00_1664)))->BgL_locz00)),
																BUNSPEC);
															((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
																				BgL_new1108z00_1677)))->BgL_typez00) =
																((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																			CREF(((BgL_nodez00_bglt)
																					BgL_nodez00_1664)))->BgL_typez00)),
																BUNSPEC);
															((((BgL_nodezf2effectzf2_bglt)
																		CREF(((BgL_nodezf2effectzf2_bglt)
																				BgL_new1108z00_1677)))->
																	BgL_sidezd2effectzd2) =
																((obj_t) BUNSPEC), BUNSPEC);
															((((BgL_nodezf2effectzf2_bglt)
																		CREF(((BgL_nodezf2effectzf2_bglt)
																				BgL_new1108z00_1677)))->BgL_keyz00) =
																((obj_t) BINT(((long) -1))), BUNSPEC);
															{
																obj_t BgL_auxz00_2264;

																{	/* Sync/node.scm 142 */
																	obj_t BgL_arg1620z00_1678;

																	{	/* Sync/node.scm 142 */
																		BgL_nodez00_bglt BgL_arg1623z00_1680;

																		BgL_arg1623z00_1680 =
																			(((BgL_syncz00_bglt)
																				CREF(BgL_nodez00_1664))->BgL_bodyz00);
																		BgL_arg1620z00_1678 =
																			MAKE_PAIR(((obj_t) BgL_tmpz00_1667),
																			((obj_t) BgL_arg1623z00_1680));
																	}
																	{	/* Sync/node.scm 142 */
																		obj_t BgL_list1621z00_1679;

																		BgL_list1621z00_1679 =
																			MAKE_PAIR(BgL_arg1620z00_1678, BNIL);
																		BgL_auxz00_2264 = BgL_list1621z00_1679;
																}}
																((((BgL_letzd2varzd2_bglt)
																			CREF(BgL_new1108z00_1677))->
																		BgL_bindingsz00) =
																	((obj_t) BgL_auxz00_2264), BUNSPEC);
															}
															{
																BgL_nodez00_bglt BgL_auxz00_2271;

																{	/* Sync/node.scm 143 */
																	BgL_sequencez00_bglt BgL_new1110z00_1681;

																	{	/* Sync/node.scm 144 */
																		BgL_sequencez00_bglt BgL_new1109z00_1684;

																		BgL_new1109z00_1684 =
																			((BgL_sequencez00_bglt)
																			BREF(GC_MALLOC(sizeof(struct
																						BgL_sequencez00_bgl))));
																		{	/* Sync/node.scm 144 */
																			long BgL_arg1631z00_1685;

																			{	/* Sync/node.scm 144 */
																				long BgL_res1778z00_2006;

																				{	/* Sync/node.scm 144 */
																					obj_t BgL_classz00_2005;

																					BgL_classz00_2005 =
																						BGl_sequencez00zzast_nodez00;
																					BgL_res1778z00_2006 =
																						BGL_CLASS_INDEX(BgL_classz00_2005);
																				}
																				BgL_arg1631z00_1685 =
																					BgL_res1778z00_2006;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1109z00_1684),
																				BgL_arg1631z00_1685);
																		}
																		{	/* Sync/node.scm 144 */
																			BgL_objectz00_bglt BgL_auxz00_2276;

																			BgL_auxz00_2276 =
																				((BgL_objectz00_bglt)
																				BgL_new1109z00_1684);
																			BGL_OBJECT_WIDENING_SET(BgL_auxz00_2276,
																				BFALSE);
																		}
																		BgL_new1110z00_1681 = BgL_new1109z00_1684;
																	}
																	((((BgL_nodez00_bglt) CREF(
																					((BgL_nodez00_bglt)
																						BgL_new1110z00_1681)))->
																			BgL_locz00) =
																		((obj_t) (((BgL_nodez00_bglt)
																					CREF(((BgL_nodez00_bglt)
																							BgL_nodez00_1664)))->BgL_locz00)),
																		BUNSPEC);
																	((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
																						BgL_new1110z00_1681)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																					CREF(((BgL_nodez00_bglt)
																							BgL_nodez00_1664)))->
																				BgL_typez00)), BUNSPEC);
																	((((BgL_nodezf2effectzf2_bglt)
																				CREF(((BgL_nodezf2effectzf2_bglt)
																						BgL_new1110z00_1681)))->
																			BgL_sidezd2effectzd2) =
																		((obj_t) BUNSPEC), BUNSPEC);
																	((((BgL_nodezf2effectzf2_bglt)
																				CREF(((BgL_nodezf2effectzf2_bglt)
																						BgL_new1110z00_1681)))->
																			BgL_keyz00) =
																		((obj_t) BINT(((long) -1))), BUNSPEC);
																	{
																		obj_t BgL_auxz00_2292;

																		{	/* Sync/node.scm 146 */
																			obj_t BgL_list1624z00_1682;

																			{	/* Sync/node.scm 146 */
																				obj_t BgL_arg1625z00_1683;

																				BgL_arg1625z00_1683 =
																					MAKE_PAIR(
																					((obj_t) BgL_vrefz00_1670), BNIL);
																				BgL_list1624z00_1682 =
																					MAKE_PAIR(
																					((obj_t) BgL_unlockz00_1669),
																					BgL_arg1625z00_1683);
																			}
																			BgL_auxz00_2292 = BgL_list1624z00_1682;
																		}
																		((((BgL_sequencez00_bglt)
																					CREF(BgL_new1110z00_1681))->
																				BgL_nodesz00) =
																			((obj_t) BgL_auxz00_2292), BUNSPEC);
																	}
																	((((BgL_sequencez00_bglt)
																				CREF(BgL_new1110z00_1681))->
																			BgL_unsafez00) =
																		((bool_t) ((bool_t) 0)), BUNSPEC);
																	BgL_auxz00_2271 =
																		((BgL_nodez00_bglt) BgL_new1110z00_1681);
																}
																((((BgL_letzd2varzd2_bglt)
																			CREF(BgL_new1108z00_1677))->BgL_bodyz00) =
																	((BgL_nodez00_bglt) BgL_auxz00_2271),
																	BUNSPEC);
															}
															((((BgL_letzd2varzd2_bglt)
																		CREF(BgL_new1108z00_1677))->
																	BgL_removablezf3zf3) =
																((bool_t) ((bool_t) 1)), BUNSPEC);
															BgL_lbodyz00_1671 = BgL_new1108z00_1677;
														}
														{	/* Sync/node.scm 139 */

															{	/* Sync/node.scm 147 */
																BgL_sequencez00_bglt BgL_new1113z00_1672;

																{	/* Sync/node.scm 148 */
																	BgL_sequencez00_bglt BgL_new1112z00_1675;

																	BgL_new1112z00_1675 =
																		((BgL_sequencez00_bglt)
																		BREF(GC_MALLOC(sizeof(struct
																					BgL_sequencez00_bgl))));
																	{	/* Sync/node.scm 148 */
																		long BgL_arg1619z00_1676;

																		{	/* Sync/node.scm 148 */
																			long BgL_res1780z00_2012;

																			BgL_res1780z00_2012 =
																				BGL_CLASS_INDEX
																				(BGl_sequencez00zzast_nodez00);
																			BgL_arg1619z00_1676 = BgL_res1780z00_2012;
																		}
																		BGL_OBJECT_CLASS_NUM_SET(
																			((BgL_objectz00_bglt)
																				BgL_new1112z00_1675),
																			BgL_arg1619z00_1676);
																	}
																	{	/* Sync/node.scm 148 */
																		BgL_objectz00_bglt BgL_auxz00_2306;

																		BgL_auxz00_2306 =
																			((BgL_objectz00_bglt)
																			BgL_new1112z00_1675);
																		BGL_OBJECT_WIDENING_SET(BgL_auxz00_2306,
																			BFALSE);
																	}
																	BgL_new1113z00_1672 = BgL_new1112z00_1675;
																}
																((((BgL_nodez00_bglt) CREF(
																				((BgL_nodez00_bglt)
																					BgL_new1113z00_1672)))->BgL_locz00) =
																	((obj_t) (((BgL_nodez00_bglt)
																				CREF(((BgL_nodez00_bglt)
																						BgL_nodez00_1664)))->BgL_locz00)),
																	BUNSPEC);
																((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
																					BgL_new1113z00_1672)))->BgL_typez00) =
																	((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																				CREF(((BgL_nodez00_bglt)
																						BgL_nodez00_1664)))->BgL_typez00)),
																	BUNSPEC);
																((((BgL_nodezf2effectzf2_bglt)
																			CREF(((BgL_nodezf2effectzf2_bglt)
																					BgL_new1113z00_1672)))->
																		BgL_sidezd2effectzd2) =
																	((obj_t) BUNSPEC), BUNSPEC);
																((((BgL_nodezf2effectzf2_bglt)
																			CREF(((BgL_nodezf2effectzf2_bglt)
																					BgL_new1113z00_1672)))->BgL_keyz00) =
																	((obj_t) BINT(((long) -1))), BUNSPEC);
																{
																	obj_t BgL_auxz00_2322;

																	{	/* Sync/node.scm 150 */
																		obj_t BgL_arg1613z00_1673;

																		{	/* Sync/node.scm 150 */
																			obj_t BgL_arg1614z00_1674;

																			BgL_arg1614z00_1674 =
																				(((BgL_nodez00_bglt) CREF(
																						((BgL_nodez00_bglt)
																							BgL_nodez00_1664)))->BgL_locz00);
																			BgL_nodez00_1710 = BgL_lbodyz00_1671;
																			BgL_locz00_1711 = BgL_arg1614z00_1674;
																			{	/* Sync/node.scm 122 */
																				bool_t BgL_testz00_2325;

																				if (CBOOL
																					(BGl_failsafezd2mutexzd2profilez00zzsync_nodez00))
																					{	/* Sync/node.scm 122 */
																						BgL_testz00_2325 = ((bool_t) 1);
																					}
																				else
																					{	/* Sync/node.scm 122 */
																						BgL_testz00_2325 = ((bool_t) 0);
																					}
																				if (BgL_testz00_2325)
																					{	/* Sync/node.scm 123 */
																						BgL_nodez00_bglt
																							BgL_arg1679z00_1714;
																						{	/* Sync/node.scm 123 */
																							obj_t BgL_arg1683z00_1717;

																							BgL_arg1683z00_1717 =
																								MAKE_PAIR
																								(BGl_failsafezd2mutexzd2profilez00zzsync_nodez00,
																								BNIL);
																							BgL_arg1679z00_1714 =
																								BGl_applicationzd2ze3nodez31zzast_appz00
																								(BgL_arg1683z00_1717, BNIL,
																								BgL_locz00_1711,
																								CNST_TABLE_REF(((long) 12)));
																						}
																						{	/* Sync/node.scm 123 */
																							obj_t BgL_list1680z00_1715;

																							{	/* Sync/node.scm 123 */
																								obj_t BgL_arg1682z00_1716;

																								BgL_arg1682z00_1716 =
																									MAKE_PAIR(
																									((obj_t) BgL_nodez00_1710),
																									BNIL);
																								BgL_list1680z00_1715 =
																									MAKE_PAIR(((obj_t)
																										BgL_arg1679z00_1714),
																									BgL_arg1682z00_1716);
																							}
																							BgL_arg1613z00_1673 =
																								BgL_list1680z00_1715;
																					}}
																				else
																					{	/* Sync/node.scm 124 */
																						obj_t BgL_list1684z00_1718;

																						BgL_list1684z00_1718 =
																							MAKE_PAIR(
																							((obj_t) BgL_nodez00_1710), BNIL);
																						BgL_arg1613z00_1673 =
																							BgL_list1684z00_1718;
																					}
																			}
																		}
																		BgL_auxz00_2322 =
																			MAKE_PAIR(
																			((obj_t) BgL_lockz00_1668),
																			BgL_arg1613z00_1673);
																	}
																	((((BgL_sequencez00_bglt)
																				CREF(BgL_new1113z00_1672))->
																			BgL_nodesz00) =
																		((obj_t) BgL_auxz00_2322), BUNSPEC);
																}
																((((BgL_sequencez00_bglt)
																			CREF(BgL_new1113z00_1672))->
																		BgL_unsafez00) =
																	((bool_t) ((bool_t) 0)), BUNSPEC);
																BgL_auxz00_2190 = BgL_new1113z00_1672;
															}
														}
													}
												}
											}
										}
									}
									return ((BgL_nodez00_bglt) BgL_auxz00_2190);
								}
							else
								{
									BgL_letzd2varzd2_bglt BgL_auxz00_2342;

									BgL_nodez00_1592 = BgL_nodez00_18;
									{	/* Sync/node.scm 156 */
										BgL_localz00_bglt BgL_tmpz00_1595;

										{	/* Sync/node.scm 156 */
											obj_t BgL_arg1606z00_1661;
											BgL_typez00_bglt BgL_arg1610z00_1662;

											BgL_arg1606z00_1661 =
												BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
														(long) 13)));
											BgL_arg1610z00_1662 =
												(((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
															BgL_nodez00_1592)))->BgL_typez00);
											BgL_tmpz00_1595 =
												BGl_makezd2localzd2svarz00zzast_localz00
												(BgL_arg1606z00_1661, BgL_arg1610z00_1662);
										}
										{	/* Sync/node.scm 156 */
											BgL_localz00_bglt BgL_topz00_1596;

											{	/* Sync/node.scm 157 */
												obj_t BgL_arg1595z00_1660;

												BgL_arg1595z00_1660 =
													BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 14)));
												BgL_topz00_1596 =
													BGl_makezd2localzd2svarz00zzast_localz00
													(BgL_arg1595z00_1660,
													((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00));
											}
											{	/* Sync/node.scm 157 */
												BgL_varz00_bglt BgL_toprefz00_1597;

												{	/* Sync/node.scm 158 */
													BgL_varz00_bglt BgL_new1116z00_1657;

													{	/* Sync/node.scm 159 */
														BgL_varz00_bglt BgL_new1115z00_1658;

														BgL_new1115z00_1658 =
															((BgL_varz00_bglt) BREF(GC_MALLOC(sizeof(struct
																		BgL_varz00_bgl))));
														{	/* Sync/node.scm 159 */
															long BgL_arg1591z00_1659;

															{	/* Sync/node.scm 159 */
																long BgL_res1781z00_2016;

																BgL_res1781z00_2016 =
																	BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
																BgL_arg1591z00_1659 = BgL_res1781z00_2016;
															}
															BGL_OBJECT_CLASS_NUM_SET(
																((BgL_objectz00_bglt) BgL_new1115z00_1658),
																BgL_arg1591z00_1659);
														}
														{	/* Sync/node.scm 159 */
															BgL_objectz00_bglt BgL_auxz00_2356;

															BgL_auxz00_2356 =
																((BgL_objectz00_bglt) BgL_new1115z00_1658);
															BGL_OBJECT_WIDENING_SET(BgL_auxz00_2356, BFALSE);
														}
														BgL_new1116z00_1657 = BgL_new1115z00_1658;
													}
													((((BgL_nodez00_bglt) CREF(
																	((BgL_nodez00_bglt) BgL_new1116z00_1657)))->
															BgL_locz00) =
														((obj_t) (((BgL_nodez00_bglt)
																	CREF(((BgL_nodez00_bglt) BgL_nodez00_1592)))->
																BgL_locz00)), BUNSPEC);
													((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
																		BgL_new1116z00_1657)))->BgL_typez00) =
														((BgL_typez00_bglt) ((BgL_typez00_bglt)
																BGl_za2objza2z00zztype_cachez00)), BUNSPEC);
													((((BgL_varz00_bglt) CREF(BgL_new1116z00_1657))->
															BgL_variablez00) =
														((BgL_variablez00_bglt) ((BgL_variablez00_bglt)
																BgL_topz00_1596)), BUNSPEC);
													BgL_toprefz00_1597 = BgL_new1116z00_1657;
												}
												{	/* Sync/node.scm 158 */
													BgL_nodez00_bglt BgL_gettopz00_1598;

													{	/* Sync/node.scm 162 */
														obj_t BgL_arg1583z00_1655;
														obj_t BgL_arg1587z00_1656;

														BgL_arg1583z00_1655 =
															MAKE_PAIR(BGl_getexitdtopz00zzsync_nodez00, BNIL);
														BgL_arg1587z00_1656 =
															(((BgL_nodez00_bglt) CREF(
																	((BgL_nodez00_bglt) BgL_nodez00_1592)))->
															BgL_locz00);
														BgL_gettopz00_1598 =
															BGl_applicationzd2ze3nodez31zzast_appz00
															(BgL_arg1583z00_1655, BNIL, BgL_arg1587z00_1656,
															CNST_TABLE_REF(((long) 12)));
													}
													{	/* Sync/node.scm 162 */
														BgL_nodez00_bglt BgL_lockz00_1599;

														{	/* Sync/node.scm 163 */
															bool_t BgL_testz00_2373;

															{	/* Sync/node.scm 163 */
																BgL_nodez00_bglt BgL_arg1582z00_1654;

																BgL_arg1582z00_1654 =
																	(((BgL_syncz00_bglt) CREF(BgL_nodez00_1592))->
																	BgL_prelockz00);
																{	/* Sync/node.scm 163 */
																	bool_t BgL_res1782z00_2022;

																	BgL_res1782z00_2022 =
																		BGl_isazf3zf3zz__objectz00(
																		((obj_t) BgL_arg1582z00_1654),
																		BGl_atomz00zzast_nodez00);
																	BgL_testz00_2373 = BgL_res1782z00_2022;
															}}
															if (BgL_testz00_2373)
																{	/* Sync/node.scm 164 */
																	obj_t BgL_arg1530z00_1644;
																	obj_t BgL_arg1547z00_1645;

																	{	/* Sync/node.scm 164 */
																		obj_t BgL_arg1549z00_1646;

																		{	/* Sync/node.scm 164 */
																			BgL_nodez00_bglt BgL_arg1552z00_1647;

																			BgL_arg1552z00_1647 =
																				(((BgL_syncz00_bglt)
																					CREF(BgL_nodez00_1592))->
																				BgL_mutexz00);
																			BgL_arg1549z00_1646 =
																				MAKE_PAIR(((obj_t) BgL_arg1552z00_1647),
																				BNIL);
																		}
																		BgL_arg1530z00_1644 =
																			MAKE_PAIR(BGl_mlockz00zzsync_nodez00,
																			BgL_arg1549z00_1646);
																	}
																	BgL_arg1547z00_1645 =
																		(((BgL_nodez00_bglt) CREF(
																				((BgL_nodez00_bglt)
																					BgL_nodez00_1592)))->BgL_locz00);
																	BgL_lockz00_1599 =
																		BGl_applicationzd2ze3nodez31zzast_appz00
																		(BgL_arg1530z00_1644, BNIL,
																		BgL_arg1547z00_1645,
																		CNST_TABLE_REF(((long) 12)));
																}
															else
																{	/* Sync/node.scm 165 */
																	obj_t BgL_arg1555z00_1648;
																	obj_t BgL_arg1557z00_1649;

																	{	/* Sync/node.scm 165 */
																		obj_t BgL_arg1569z00_1650;

																		{	/* Sync/node.scm 165 */
																			BgL_nodez00_bglt BgL_arg1571z00_1651;
																			obj_t BgL_arg1572z00_1652;

																			BgL_arg1571z00_1651 =
																				(((BgL_syncz00_bglt)
																					CREF(BgL_nodez00_1592))->
																				BgL_mutexz00);
																			{	/* Sync/node.scm 165 */
																				BgL_nodez00_bglt BgL_arg1576z00_1653;

																				BgL_arg1576z00_1653 =
																					(((BgL_syncz00_bglt)
																						CREF(BgL_nodez00_1592))->
																					BgL_prelockz00);
																				BgL_arg1572z00_1652 =
																					MAKE_PAIR(((obj_t)
																						BgL_arg1576z00_1653), BNIL);
																			}
																			BgL_arg1569z00_1650 =
																				MAKE_PAIR(
																				((obj_t) BgL_arg1571z00_1651),
																				BgL_arg1572z00_1652);
																		}
																		BgL_arg1555z00_1648 =
																			MAKE_PAIR
																			(BGl_mlockprelockz00zzsync_nodez00,
																			BgL_arg1569z00_1650);
																	}
																	BgL_arg1557z00_1649 =
																		(((BgL_nodez00_bglt) CREF(
																				((BgL_nodez00_bglt)
																					BgL_nodez00_1592)))->BgL_locz00);
																	BgL_lockz00_1599 =
																		BGl_applicationzd2ze3nodez31zzast_appz00
																		(BgL_arg1555z00_1648, BNIL,
																		BgL_arg1557z00_1649,
																		CNST_TABLE_REF(((long) 12)));
														}}
														{	/* Sync/node.scm 163 */
															BgL_nodez00_bglt BgL_pushz00_1600;

															{	/* Sync/node.scm 166 */
																obj_t BgL_arg1511z00_1638;
																obj_t BgL_arg1516z00_1639;

																{	/* Sync/node.scm 166 */
																	obj_t BgL_arg1519z00_1640;

																	{	/* Sync/node.scm 166 */
																		obj_t BgL_arg1526z00_1641;

																		{	/* Sync/node.scm 166 */
																			BgL_nodez00_bglt BgL_arg1527z00_1642;

																			BgL_arg1527z00_1642 =
																				(((BgL_syncz00_bglt)
																					CREF(BgL_nodez00_1592))->
																				BgL_mutexz00);
																			BgL_arg1526z00_1641 =
																				MAKE_PAIR(((obj_t) BgL_arg1527z00_1642),
																				BNIL);
																		}
																		BgL_arg1519z00_1640 =
																			MAKE_PAIR(
																			((obj_t) BgL_toprefz00_1597),
																			BgL_arg1526z00_1641);
																	}
																	BgL_arg1511z00_1638 =
																		MAKE_PAIR(BGl_mpushz00zzsync_nodez00,
																		BgL_arg1519z00_1640);
																}
																BgL_arg1516z00_1639 =
																	(((BgL_nodez00_bglt) CREF(
																			((BgL_nodez00_bglt) BgL_nodez00_1592)))->
																	BgL_locz00);
																BgL_pushz00_1600 =
																	BGl_applicationzd2ze3nodez31zzast_appz00
																	(BgL_arg1511z00_1638, BNIL,
																	BgL_arg1516z00_1639,
																	CNST_TABLE_REF(((long) 12)));
															}
															{	/* Sync/node.scm 166 */
																BgL_nodez00_bglt BgL_popz00_1601;

																{	/* Sync/node.scm 167 */
																	obj_t BgL_arg1500z00_1635;
																	obj_t BgL_arg1505z00_1636;

																	{	/* Sync/node.scm 167 */
																		obj_t BgL_arg1509z00_1637;

																		BgL_arg1509z00_1637 =
																			MAKE_PAIR(
																			((obj_t) BgL_toprefz00_1597), BNIL);
																		BgL_arg1500z00_1635 =
																			MAKE_PAIR(BGl_mpopz00zzsync_nodez00,
																			BgL_arg1509z00_1637);
																	}
																	BgL_arg1505z00_1636 =
																		(((BgL_nodez00_bglt) CREF(
																				((BgL_nodez00_bglt)
																					BgL_nodez00_1592)))->BgL_locz00);
																	BgL_popz00_1601 =
																		BGl_applicationzd2ze3nodez31zzast_appz00
																		(BgL_arg1500z00_1635, BNIL,
																		BgL_arg1505z00_1636,
																		CNST_TABLE_REF(((long) 12)));
																}
																{	/* Sync/node.scm 167 */
																	BgL_nodez00_bglt BgL_unlockz00_1602;

																	{	/* Sync/node.scm 168 */
																		obj_t BgL_arg1492z00_1631;
																		obj_t BgL_arg1493z00_1632;

																		{	/* Sync/node.scm 168 */
																			obj_t BgL_arg1494z00_1633;

																			{	/* Sync/node.scm 168 */
																				BgL_nodez00_bglt BgL_arg1496z00_1634;

																				BgL_arg1496z00_1634 =
																					(((BgL_syncz00_bglt)
																						CREF(BgL_nodez00_1592))->
																					BgL_mutexz00);
																				BgL_arg1494z00_1633 =
																					MAKE_PAIR(((obj_t)
																						BgL_arg1496z00_1634), BNIL);
																			}
																			BgL_arg1492z00_1631 =
																				MAKE_PAIR(BGl_mulockz00zzsync_nodez00,
																				BgL_arg1494z00_1633);
																		}
																		BgL_arg1493z00_1632 =
																			(((BgL_nodez00_bglt) CREF(
																					((BgL_nodez00_bglt)
																						BgL_nodez00_1592)))->BgL_locz00);
																		BgL_unlockz00_1602 =
																			BGl_applicationzd2ze3nodez31zzast_appz00
																			(BgL_arg1492z00_1631, BNIL,
																			BgL_arg1493z00_1632,
																			CNST_TABLE_REF(((long) 12)));
																	}
																	{	/* Sync/node.scm 168 */
																		BgL_varz00_bglt BgL_vrefz00_1603;

																		{	/* Sync/node.scm 169 */
																			BgL_varz00_bglt BgL_new1118z00_1628;

																			{	/* Sync/node.scm 170 */
																				BgL_varz00_bglt BgL_new1117z00_1629;

																				BgL_new1117z00_1629 =
																					((BgL_varz00_bglt)
																					BREF(GC_MALLOC(sizeof(struct
																								BgL_varz00_bgl))));
																				{	/* Sync/node.scm 170 */
																					long BgL_arg1491z00_1630;

																					{	/* Sync/node.scm 170 */
																						long BgL_res1783z00_2034;

																						BgL_res1783z00_2034 =
																							BGL_CLASS_INDEX
																							(BGl_varz00zzast_nodez00);
																						BgL_arg1491z00_1630 =
																							BgL_res1783z00_2034;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1117z00_1629),
																						BgL_arg1491z00_1630);
																				}
																				{	/* Sync/node.scm 170 */
																					BgL_objectz00_bglt BgL_auxz00_2425;

																					BgL_auxz00_2425 =
																						((BgL_objectz00_bglt)
																						BgL_new1117z00_1629);
																					BGL_OBJECT_WIDENING_SET
																						(BgL_auxz00_2425, BFALSE);
																				}
																				BgL_new1118z00_1628 =
																					BgL_new1117z00_1629;
																			}
																			((((BgL_nodez00_bglt) CREF(
																							((BgL_nodez00_bglt)
																								BgL_new1118z00_1628)))->
																					BgL_locz00) =
																				((obj_t) (((BgL_nodez00_bglt)
																							CREF(((BgL_nodez00_bglt)
																									BgL_nodez00_1592)))->
																						BgL_locz00)), BUNSPEC);
																			((((BgL_nodez00_bglt)
																						CREF(((BgL_nodez00_bglt)
																								BgL_new1118z00_1628)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																							CREF(((BgL_nodez00_bglt)
																									BgL_nodez00_1592)))->
																						BgL_typez00)), BUNSPEC);
																			((((BgL_varz00_bglt)
																						CREF(BgL_new1118z00_1628))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) (
																						(BgL_variablez00_bglt)
																						BgL_tmpz00_1595)), BUNSPEC);
																			BgL_vrefz00_1603 = BgL_new1118z00_1628;
																		}
																		{	/* Sync/node.scm 169 */
																			BgL_letzd2varzd2_bglt BgL_lbodyz00_1604;

																			{	/* Sync/node.scm 173 */
																				BgL_letzd2varzd2_bglt
																					BgL_new1120z00_1616;
																				{	/* Sync/node.scm 174 */
																					BgL_letzd2varzd2_bglt
																						BgL_new1119z00_1626;
																					BgL_new1119z00_1626 =
																						((BgL_letzd2varzd2_bglt)
																						BREF(GC_MALLOC(sizeof(struct
																									BgL_letzd2varzd2_bgl))));
																					{	/* Sync/node.scm 174 */
																						long BgL_arg1485z00_1627;

																						{	/* Sync/node.scm 174 */
																							long BgL_res1784z00_2038;

																							BgL_res1784z00_2038 =
																								BGL_CLASS_INDEX
																								(BGl_letzd2varzd2zzast_nodez00);
																							BgL_arg1485z00_1627 =
																								BgL_res1784z00_2038;
																						}
																						BGL_OBJECT_CLASS_NUM_SET(
																							((BgL_objectz00_bglt)
																								BgL_new1119z00_1626),
																							BgL_arg1485z00_1627);
																					}
																					{	/* Sync/node.scm 174 */
																						BgL_objectz00_bglt BgL_auxz00_2442;

																						BgL_auxz00_2442 =
																							((BgL_objectz00_bglt)
																							BgL_new1119z00_1626);
																						BGL_OBJECT_WIDENING_SET
																							(BgL_auxz00_2442, BFALSE);
																					}
																					BgL_new1120z00_1616 =
																						BgL_new1119z00_1626;
																				}
																				((((BgL_nodez00_bglt) CREF(
																								((BgL_nodez00_bglt)
																									BgL_new1120z00_1616)))->
																						BgL_locz00) =
																					((obj_t) (((BgL_nodez00_bglt)
																								CREF(((BgL_nodez00_bglt)
																										BgL_nodez00_1592)))->
																							BgL_locz00)), BUNSPEC);
																				((((BgL_nodez00_bglt)
																							CREF(((BgL_nodez00_bglt)
																									BgL_new1120z00_1616)))->
																						BgL_typez00) =
																					((BgL_typez00_bglt) ((
																								(BgL_nodez00_bglt)
																								CREF(((BgL_nodez00_bglt)
																										BgL_nodez00_1592)))->
																							BgL_typez00)), BUNSPEC);
																				((((BgL_nodezf2effectzf2_bglt)
																							CREF(((BgL_nodezf2effectzf2_bglt)
																									BgL_new1120z00_1616)))->
																						BgL_sidezd2effectzd2) =
																					((obj_t) BUNSPEC), BUNSPEC);
																				((((BgL_nodezf2effectzf2_bglt)
																							CREF(((BgL_nodezf2effectzf2_bglt)
																									BgL_new1120z00_1616)))->
																						BgL_keyz00) =
																					((obj_t) BINT(((long) -1))), BUNSPEC);
																				{
																					obj_t BgL_auxz00_2458;

																					{	/* Sync/node.scm 176 */
																						obj_t BgL_arg1459z00_1617;

																						{	/* Sync/node.scm 176 */
																							BgL_nodez00_bglt
																								BgL_arg1467z00_1619;
																							BgL_arg1467z00_1619 =
																								(((BgL_syncz00_bglt)
																									CREF(BgL_nodez00_1592))->
																								BgL_bodyz00);
																							BgL_arg1459z00_1617 =
																								MAKE_PAIR(((obj_t)
																									BgL_tmpz00_1595),
																								((obj_t) BgL_arg1467z00_1619));
																						}
																						{	/* Sync/node.scm 176 */
																							obj_t BgL_list1460z00_1618;

																							BgL_list1460z00_1618 =
																								MAKE_PAIR(BgL_arg1459z00_1617,
																								BNIL);
																							BgL_auxz00_2458 =
																								BgL_list1460z00_1618;
																					}}
																					((((BgL_letzd2varzd2_bglt)
																								CREF(BgL_new1120z00_1616))->
																							BgL_bindingsz00) =
																						((obj_t) BgL_auxz00_2458), BUNSPEC);
																				}
																				{
																					BgL_nodez00_bglt BgL_auxz00_2465;

																					{	/* Sync/node.scm 177 */
																						BgL_sequencez00_bglt
																							BgL_new1123z00_1620;
																						{	/* Sync/node.scm 178 */
																							BgL_sequencez00_bglt
																								BgL_new1122z00_1624;
																							BgL_new1122z00_1624 =
																								((BgL_sequencez00_bglt)
																								BREF(GC_MALLOC(sizeof(struct
																											BgL_sequencez00_bgl))));
																							{	/* Sync/node.scm 178 */
																								long BgL_arg1484z00_1625;

																								{	/* Sync/node.scm 178 */
																									long BgL_res1786z00_2044;

																									{	/* Sync/node.scm 178 */
																										obj_t BgL_classz00_2043;

																										BgL_classz00_2043 =
																											BGl_sequencez00zzast_nodez00;
																										BgL_res1786z00_2044 =
																											BGL_CLASS_INDEX
																											(BgL_classz00_2043);
																									}
																									BgL_arg1484z00_1625 =
																										BgL_res1786z00_2044;
																								}
																								BGL_OBJECT_CLASS_NUM_SET(
																									((BgL_objectz00_bglt)
																										BgL_new1122z00_1624),
																									BgL_arg1484z00_1625);
																							}
																							{	/* Sync/node.scm 178 */
																								BgL_objectz00_bglt
																									BgL_auxz00_2470;
																								BgL_auxz00_2470 =
																									((BgL_objectz00_bglt)
																									BgL_new1122z00_1624);
																								BGL_OBJECT_WIDENING_SET
																									(BgL_auxz00_2470, BFALSE);
																							}
																							BgL_new1123z00_1620 =
																								BgL_new1122z00_1624;
																						}
																						((((BgL_nodez00_bglt) CREF(
																										((BgL_nodez00_bglt)
																											BgL_new1123z00_1620)))->
																								BgL_locz00) =
																							((obj_t) (((BgL_nodez00_bglt)
																										CREF(((BgL_nodez00_bglt)
																												BgL_nodez00_1592)))->
																									BgL_locz00)), BUNSPEC);
																						((((BgL_nodez00_bglt)
																									CREF(((BgL_nodez00_bglt)
																											BgL_new1123z00_1620)))->
																								BgL_typez00) =
																							((BgL_typez00_bglt) ((
																										(BgL_nodez00_bglt)
																										CREF(((BgL_nodez00_bglt)
																												BgL_nodez00_1592)))->
																									BgL_typez00)), BUNSPEC);
																						((((BgL_nodezf2effectzf2_bglt)
																									CREF((
																											(BgL_nodezf2effectzf2_bglt)
																											BgL_new1123z00_1620)))->
																								BgL_sidezd2effectzd2) =
																							((obj_t) BUNSPEC), BUNSPEC);
																						((((BgL_nodezf2effectzf2_bglt)
																									CREF((
																											(BgL_nodezf2effectzf2_bglt)
																											BgL_new1123z00_1620)))->
																								BgL_keyz00) =
																							((obj_t) BINT(((long) -1))),
																							BUNSPEC);
																						{
																							obj_t BgL_auxz00_2486;

																							{	/* Sync/node.scm 180 */
																								obj_t BgL_list1468z00_1621;

																								{	/* Sync/node.scm 180 */
																									obj_t BgL_arg1476z00_1622;

																									{	/* Sync/node.scm 180 */
																										obj_t BgL_arg1482z00_1623;

																										BgL_arg1482z00_1623 =
																											MAKE_PAIR(
																											((obj_t)
																												BgL_vrefz00_1603),
																											BNIL);
																										BgL_arg1476z00_1622 =
																											MAKE_PAIR(((obj_t)
																												BgL_unlockz00_1602),
																											BgL_arg1482z00_1623);
																									}
																									BgL_list1468z00_1621 =
																										MAKE_PAIR(
																										((obj_t) BgL_popz00_1601),
																										BgL_arg1476z00_1622);
																								}
																								BgL_auxz00_2486 =
																									BgL_list1468z00_1621;
																							}
																							((((BgL_sequencez00_bglt)
																										CREF(BgL_new1123z00_1620))->
																									BgL_nodesz00) =
																								((obj_t) BgL_auxz00_2486),
																								BUNSPEC);
																						}
																						((((BgL_sequencez00_bglt)
																									CREF(BgL_new1123z00_1620))->
																								BgL_unsafez00) =
																							((bool_t) ((bool_t) 0)), BUNSPEC);
																						BgL_auxz00_2465 =
																							((BgL_nodez00_bglt)
																							BgL_new1123z00_1620);
																					}
																					((((BgL_letzd2varzd2_bglt)
																								CREF(BgL_new1120z00_1616))->
																							BgL_bodyz00) =
																						((BgL_nodez00_bglt)
																							BgL_auxz00_2465), BUNSPEC);
																				}
																				((((BgL_letzd2varzd2_bglt)
																							CREF(BgL_new1120z00_1616))->
																						BgL_removablezf3zf3) =
																					((bool_t) ((bool_t) 1)), BUNSPEC);
																				BgL_lbodyz00_1604 = BgL_new1120z00_1616;
																			}
																			{	/* Sync/node.scm 173 */

																				{	/* Sync/node.scm 181 */
																					BgL_letzd2varzd2_bglt
																						BgL_new1125z00_1605;
																					{	/* Sync/node.scm 182 */
																						BgL_letzd2varzd2_bglt
																							BgL_new1124z00_1614;
																						BgL_new1124z00_1614 =
																							((BgL_letzd2varzd2_bglt)
																							BREF(GC_MALLOC(sizeof(struct
																										BgL_letzd2varzd2_bgl))));
																						{	/* Sync/node.scm 182 */
																							long BgL_arg1454z00_1615;

																							{	/* Sync/node.scm 182 */
																								long BgL_res1788z00_2050;

																								BgL_res1788z00_2050 =
																									BGL_CLASS_INDEX
																									(BGl_letzd2varzd2zzast_nodez00);
																								BgL_arg1454z00_1615 =
																									BgL_res1788z00_2050;
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1124z00_1614),
																								BgL_arg1454z00_1615);
																						}
																						{	/* Sync/node.scm 182 */
																							BgL_objectz00_bglt
																								BgL_auxz00_2502;
																							BgL_auxz00_2502 =
																								((BgL_objectz00_bglt)
																								BgL_new1124z00_1614);
																							BGL_OBJECT_WIDENING_SET
																								(BgL_auxz00_2502, BFALSE);
																						}
																						BgL_new1125z00_1605 =
																							BgL_new1124z00_1614;
																					}
																					((((BgL_nodez00_bglt) CREF(
																									((BgL_nodez00_bglt)
																										BgL_new1125z00_1605)))->
																							BgL_locz00) =
																						((obj_t) (((BgL_nodez00_bglt)
																									CREF(((BgL_nodez00_bglt)
																											BgL_nodez00_1592)))->
																								BgL_locz00)), BUNSPEC);
																					((((BgL_nodez00_bglt)
																								CREF(((BgL_nodez00_bglt)
																										BgL_new1125z00_1605)))->
																							BgL_typez00) =
																						((BgL_typez00_bglt) ((
																									(BgL_nodez00_bglt)
																									CREF(((BgL_nodez00_bglt)
																											BgL_nodez00_1592)))->
																								BgL_typez00)), BUNSPEC);
																					((((BgL_nodezf2effectzf2_bglt)
																								CREF((
																										(BgL_nodezf2effectzf2_bglt)
																										BgL_new1125z00_1605)))->
																							BgL_sidezd2effectzd2) =
																						((obj_t) BUNSPEC), BUNSPEC);
																					((((BgL_nodezf2effectzf2_bglt)
																								CREF((
																										(BgL_nodezf2effectzf2_bglt)
																										BgL_new1125z00_1605)))->
																							BgL_keyz00) =
																						((obj_t) BINT(((long) -1))),
																						BUNSPEC);
																					{
																						obj_t BgL_auxz00_2518;

																						{	/* Sync/node.scm 184 */
																							obj_t BgL_arg1398z00_1606;

																							BgL_arg1398z00_1606 =
																								MAKE_PAIR(
																								((obj_t) BgL_topz00_1596),
																								((obj_t) BgL_gettopz00_1598));
																							{	/* Sync/node.scm 184 */
																								obj_t BgL_list1399z00_1607;

																								BgL_list1399z00_1607 =
																									MAKE_PAIR(BgL_arg1398z00_1606,
																									BNIL);
																								BgL_auxz00_2518 =
																									BgL_list1399z00_1607;
																						}}
																						((((BgL_letzd2varzd2_bglt)
																									CREF(BgL_new1125z00_1605))->
																								BgL_bindingsz00) =
																							((obj_t) BgL_auxz00_2518),
																							BUNSPEC);
																					}
																					{
																						BgL_nodez00_bglt BgL_auxz00_2524;

																						{	/* Sync/node.scm 185 */
																							BgL_sequencez00_bglt
																								BgL_new1128z00_1608;
																							{	/* Sync/node.scm 186 */
																								BgL_sequencez00_bglt
																									BgL_new1126z00_1612;
																								BgL_new1126z00_1612 =
																									((BgL_sequencez00_bglt)
																									BREF(GC_MALLOC(sizeof(struct
																												BgL_sequencez00_bgl))));
																								{	/* Sync/node.scm 186 */
																									long BgL_arg1452z00_1613;

																									{	/* Sync/node.scm 186 */
																										long BgL_res1790z00_2056;

																										{	/* Sync/node.scm 186 */
																											obj_t BgL_classz00_2055;

																											BgL_classz00_2055 =
																												BGl_sequencez00zzast_nodez00;
																											BgL_res1790z00_2056 =
																												BGL_CLASS_INDEX
																												(BgL_classz00_2055);
																										}
																										BgL_arg1452z00_1613 =
																											BgL_res1790z00_2056;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1126z00_1612),
																										BgL_arg1452z00_1613);
																								}
																								{	/* Sync/node.scm 186 */
																									BgL_objectz00_bglt
																										BgL_auxz00_2529;
																									BgL_auxz00_2529 =
																										((BgL_objectz00_bglt)
																										BgL_new1126z00_1612);
																									BGL_OBJECT_WIDENING_SET
																										(BgL_auxz00_2529, BFALSE);
																								}
																								BgL_new1128z00_1608 =
																									BgL_new1126z00_1612;
																							}
																							((((BgL_nodez00_bglt) CREF(
																											((BgL_nodez00_bglt)
																												BgL_new1128z00_1608)))->
																									BgL_locz00) =
																								((obj_t) (((BgL_nodez00_bglt)
																											CREF(((BgL_nodez00_bglt)
																													BgL_nodez00_1592)))->
																										BgL_locz00)), BUNSPEC);
																							((((BgL_nodez00_bglt)
																										CREF(((BgL_nodez00_bglt)
																												BgL_new1128z00_1608)))->
																									BgL_typez00) =
																								((BgL_typez00_bglt) ((
																											(BgL_nodez00_bglt)
																											CREF(((BgL_nodez00_bglt)
																													BgL_nodez00_1592)))->
																										BgL_typez00)), BUNSPEC);
																							((((BgL_nodezf2effectzf2_bglt)
																										CREF((
																												(BgL_nodezf2effectzf2_bglt)
																												BgL_new1128z00_1608)))->
																									BgL_sidezd2effectzd2) =
																								((obj_t) BUNSPEC), BUNSPEC);
																							((((BgL_nodezf2effectzf2_bglt)
																										CREF((
																												(BgL_nodezf2effectzf2_bglt)
																												BgL_new1128z00_1608)))->
																									BgL_keyz00) =
																								((obj_t) BINT(((long) -1))),
																								BUNSPEC);
																							{
																								obj_t BgL_auxz00_2545;

																								{	/* Sync/node.scm 188 */
																									obj_t BgL_arg1441z00_1609;

																									{	/* Sync/node.scm 188 */
																										obj_t BgL_arg1442z00_1610;

																										{	/* Sync/node.scm 188 */
																											obj_t BgL_arg1447z00_1611;

																											BgL_arg1447z00_1611 =
																												(((BgL_nodez00_bglt)
																													CREF((
																															(BgL_nodez00_bglt)
																															BgL_nodez00_1592)))->
																												BgL_locz00);
																											BgL_nodez00_1720 =
																												BgL_lbodyz00_1604;
																											BgL_locz00_1721 =
																												BgL_arg1447z00_1611;
																											{	/* Sync/node.scm 117 */
																												bool_t BgL_testz00_2548;

																												if (CBOOL
																													(BGl_exitdzd2mutexzd2profilez00zzsync_nodez00))
																													{	/* Sync/node.scm 117 */
																														BgL_testz00_2548 =
																															((bool_t) 1);
																													}
																												else
																													{	/* Sync/node.scm 117 */
																														BgL_testz00_2548 =
																															((bool_t) 0);
																													}
																												if (BgL_testz00_2548)
																													{	/* Sync/node.scm 118 */
																														BgL_nodez00_bglt
																															BgL_arg1687z00_1724;
																														{	/* Sync/node.scm 118 */
																															obj_t
																																BgL_arg1690z00_1727;
																															BgL_arg1690z00_1727
																																=
																																MAKE_PAIR
																																(BGl_exitdzd2mutexzd2profilez00zzsync_nodez00,
																																BNIL);
																															BgL_arg1687z00_1724
																																=
																																BGl_applicationzd2ze3nodez31zzast_appz00
																																(BgL_arg1690z00_1727,
																																BNIL,
																																BgL_locz00_1721,
																																CNST_TABLE_REF((
																																		(long)
																																		12)));
																														}
																														{	/* Sync/node.scm 118 */
																															obj_t
																																BgL_list1688z00_1725;
																															{	/* Sync/node.scm 118 */
																																obj_t
																																	BgL_arg1689z00_1726;
																																BgL_arg1689z00_1726
																																	=
																																	MAKE_PAIR((
																																		(obj_t)
																																		BgL_nodez00_1720),
																																	BNIL);
																																BgL_list1688z00_1725
																																	=
																																	MAKE_PAIR((
																																		(obj_t)
																																		BgL_arg1687z00_1724),
																																	BgL_arg1689z00_1726);
																															}
																															BgL_arg1442z00_1610
																																=
																																BgL_list1688z00_1725;
																													}}
																												else
																													{	/* Sync/node.scm 119 */
																														obj_t
																															BgL_list1691z00_1728;
																														BgL_list1691z00_1728
																															=
																															MAKE_PAIR(((obj_t)
																																BgL_nodez00_1720),
																															BNIL);
																														BgL_arg1442z00_1610
																															=
																															BgL_list1691z00_1728;
																													}
																											}
																										}
																										BgL_arg1441z00_1609 =
																											MAKE_PAIR(
																											((obj_t)
																												BgL_pushz00_1600),
																											BgL_arg1442z00_1610);
																									}
																									BgL_auxz00_2545 =
																										MAKE_PAIR(
																										((obj_t) BgL_lockz00_1599),
																										BgL_arg1441z00_1609);
																								}
																								((((BgL_sequencez00_bglt)
																											CREF
																											(BgL_new1128z00_1608))->
																										BgL_nodesz00) =
																									((obj_t) BgL_auxz00_2545),
																									BUNSPEC);
																							}
																							((((BgL_sequencez00_bglt)
																										CREF(BgL_new1128z00_1608))->
																									BgL_unsafez00) =
																								((bool_t) ((bool_t) 0)),
																								BUNSPEC);
																							BgL_auxz00_2524 =
																								((BgL_nodez00_bglt)
																								BgL_new1128z00_1608);
																						}
																						((((BgL_letzd2varzd2_bglt)
																									CREF(BgL_new1125z00_1605))->
																								BgL_bodyz00) =
																							((BgL_nodez00_bglt)
																								BgL_auxz00_2524), BUNSPEC);
																					}
																					((((BgL_letzd2varzd2_bglt)
																								CREF(BgL_new1125z00_1605))->
																							BgL_removablezf3zf3) =
																						((bool_t) ((bool_t) 1)), BUNSPEC);
																					BgL_auxz00_2342 = BgL_new1125z00_1605;
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
									return ((BgL_nodez00_bglt) BgL_auxz00_2342);
								}
						}
					}
				}
			}
		}
	}



/* &sync->sequence */
	BgL_nodez00_bglt BGl_z62synczd2ze3sequencez53zzsync_nodez00(obj_t
		BgL_envz00_2060, obj_t BgL_nodez00_2061)
	{
		AN_OBJECT;
		{	/* Sync/node.scm 111 */
			return
				BGl_synczd2ze3sequencez31zzsync_nodez00(
				((BgL_syncz00_bglt) BgL_nodez00_2061));
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzsync_nodez00()
	{
		AN_OBJECT;
		{	/* Sync/node.scm 18 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzsync_nodez00()
	{
		AN_OBJECT;
		{	/* Sync/node.scm 18 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzsync_nodez00()
	{
		AN_OBJECT;
		{	/* Sync/node.scm 18 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzsync_nodez00()
	{
		AN_OBJECT;
		{	/* Sync/node.scm 18 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 122361728),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztype_toolsz00(((long) 453414928),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 216926614),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 189813582),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 481724379),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long) 504896450),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 458567972),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_localz00(((long) 315247917),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 36886173),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 449859288),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzinline_appz00(((long) 148760855),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzeffect_effectz00(((long) 460136018),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzbackend_cplibz00(((long) 395792377),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
			return
				BGl_modulezd2initializa7ationz75zzsync_failsafez00(((long) 377892095),
				BSTRING_TO_STRING(BGl_string1791z00zzsync_nodez00));
		}
	}

#ifdef __cplusplus
}
#endif
