/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/sexp.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_feffectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_readz00;
		obj_t BgL_writez00;
	}                 *BgL_feffectz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_stringzd2replacezd2zz__r4_strings_6_7z00(obj_t,
		unsigned char, unsigned char);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_applycationzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_ifzd2symzd2zzast_sexpz00();
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzast_sexpz00();
	extern obj_t BGl_privatezd2nodezd2zzast_privatez00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	extern obj_t BGl_castzd2sexpzd2typez00zzast_privatez00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_letzd2symzf3z21zzast_letz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzast_sexpz00();
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62zc3anonymousza32419ze3ze1zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__objectz00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
	static BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t,
		obj_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	extern BgL_jumpzd2exzd2itz00_bglt
		BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
	static obj_t BGl_za2sitesza2z00zzast_sexpz00 = BUNSPEC;
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	static obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_epairifyzd2reczd2zztools_miscz00(obj_t, obj_t);
	extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
	BGL_IMPORT obj_t c_substring(obj_t, long, long);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt, obj_t, obj_t);
	static obj_t BGl_za2ifza2z00zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_typez00_bglt BGl_usezd2typez12zc0zztype_envz00(obj_t, obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t BGl_z62zc3anonymousza31400ze3ze1zzast_sexpz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_letrecza2zd2ze3nodez93zzast_letz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62zc3anonymousza31401ze3ze1zzast_sexpz00(obj_t);
	BGL_IMPORT bool_t BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(obj_t);
	BGL_IMPORT obj_t BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_sexpz00 = BUNSPEC;
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	static bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t);
	static obj_t BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzast_sexpz00();
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_sexpz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern bool_t BGl_privatezd2sexpzf3z21zzast_privatez00(obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_labelszd2symzf3z21zzast_labelsz00(obj_t);
	extern obj_t BGl_labelszd2symzd2zzast_labelsz00();
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_liipz00zzast_sexpz00(obj_t);
	static obj_t BGl_za2cachezd2resza2zd2zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	BGL_IMPORT bool_t bigloo_strncmp(obj_t, obj_t, long);
	static obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2atomz00zztype_typeofz00(obj_t);
	extern BgL_nodez00_bglt BGl_letzd2ze3nodez31zzast_letz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t,
		obj_t);
	extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_exitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_labelsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern bool_t BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_globalz00_bglt);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	extern bool_t BGl_castzd2sexpzf3z21zzast_privatez00(obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzast_sexpz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00();
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt,
		BgL_nodez00_bglt);
	extern obj_t BGl_letzd2symzd2zzast_letz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza31386ze3z83zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	static BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_loopz00zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_labelszd2ze3nodez31zzast_labelsz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2kwotez00zztype_typeofz00(obj_t);
	extern BgL_nodez00_bglt BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	extern BgL_feffectz00_bglt BGl_parsezd2effectzd2zzeffect_feffectz00(obj_t);
	static obj_t BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t __cnst[45];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim3159z00,
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_errorzd2sexpzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762errorza7d2sexpza73160za7,
		BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 3);
	BGL_IMPORT obj_t BGl_expzd2envzd2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2anonymouszd2namezd2envzd2zzast_sexpz00,
		BgL_bgl_za762makeza7d2anonym3161z00, va_generic_entry,
		BGl_z62makezd2anonymouszd2namez62zzast_sexpz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2localzd2envz00zzast_sexpz00,
		BgL_bgl_za762findza7d2localza73162za7, BGl_z62findzd2localzb0zzast_sexpz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_locationzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762locationza7d2za7e3163za7,
		BGl_z62locationzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762sexpza7d2za7e3nod3164za7,
		BGl_z62sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string3123z00zzast_sexpz00,
		BgL_bgl_string3123za700za7za7a3165za7, "Illegal `application' form", 26);
	      DEFINE_STRING(BGl_string3124z00zzast_sexpz00,
		BgL_bgl_string3124za700za7za7a3166za7, "Illegal `case' form", 19);
	      DEFINE_STRING(BGl_string3125z00zzast_sexpz00,
		BgL_bgl_string3125za700za7za7a3167za7, "Illegal `failure' form", 22);
	      DEFINE_STRING(BGl_string3126z00zzast_sexpz00,
		BgL_bgl_string3126za700za7za7a3168za7, "Illegal `lambda' form", 21);
	      DEFINE_STRING(BGl_string3127z00zzast_sexpz00,
		BgL_bgl_string3127za700za7za7a3169za7, "Illegal `define' form", 21);
	      DEFINE_STRING(BGl_string3128z00zzast_sexpz00,
		BgL_bgl_string3128za700za7za7a3170za7, "illegal `define' expression", 27);
	      DEFINE_STRING(BGl_string3129z00zzast_sexpz00,
		BgL_bgl_string3129za700za7za7a3171za7, "Illegal `set!' form", 19);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_topzd2levelzd2sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762topza7d2levelza7d3172za7,
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3130z00zzast_sexpz00,
		BgL_bgl_string3130za700za7za7a3173za7, "Read-only variable", 18);
	      DEFINE_STRING(BGl_string3131z00zzast_sexpz00,
		BgL_bgl_string3131za700za7za7a3174za7, "illegal `set!' expression", 25);
	      DEFINE_STRING(BGl_string3132z00zzast_sexpz00,
		BgL_bgl_string3132za700za7za7a3175za7, "Illegal ->", 10);
	      DEFINE_STRING(BGl_string3133z00zzast_sexpz00,
		BgL_bgl_string3133za700za7za7a3176za7, "Illegal `if' form", 17);
	      DEFINE_STRING(BGl_string3134z00zzast_sexpz00,
		BgL_bgl_string3134za700za7za7a3177za7, "Illegal `quote' expression", 26);
	      DEFINE_STRING(BGl_string3135z00zzast_sexpz00,
		BgL_bgl_string3135za700za7za7a3178za7, "Illegal `@' expression", 22);
	      DEFINE_STRING(BGl_string3136z00zzast_sexpz00,
		BgL_bgl_string3136za700za7za7a3179za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string3137z00zzast_sexpz00,
		BgL_bgl_string3137za700za7za7a3180za7, "Illegal atom in s-expression", 28);
	      DEFINE_STRING(BGl_string3138z00zzast_sexpz00,
		BgL_bgl_string3138za700za7za7a3181za7, "Illegal `()' expression", 23);
	      DEFINE_STRING(BGl_string3139z00zzast_sexpz00,
		BgL_bgl_string3139za700za7za7a3182za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string3140z00zzast_sexpz00,
		BgL_bgl_string3140za700za7za7a3183za7, "Illegal formal argument", 23);
	      DEFINE_STRING(BGl_string3141z00zzast_sexpz00,
		BgL_bgl_string3141za700za7za7a3184za7,
		"Backend (~a) does not support external first class function", 59);
	      DEFINE_STRING(BGl_string3142z00zzast_sexpz00,
		BgL_bgl_string3142za700za7za7a3185za7, "Illegal pragma/effect", 21);
	      DEFINE_STRING(BGl_string3143z00zzast_sexpz00,
		BgL_bgl_string3143za700za7za7a3186za7, "Illegal free-pragma/effect", 26);
	      DEFINE_STRING(BGl_string3144z00zzast_sexpz00,
		BgL_bgl_string3144za700za7za7a3187za7, "Illegal lambda", 14);
	      DEFINE_STRING(BGl_string3145z00zzast_sexpz00,
		BgL_bgl_string3145za700za7za7a3188za7, "Illegal empty sequence", 22);
	      DEFINE_STRING(BGl_string3146z00zzast_sexpz00,
		BgL_bgl_string3146za700za7za7a3189za7, "Illegal mutation", 16);
	      DEFINE_STRING(BGl_string3147z00zzast_sexpz00,
		BgL_bgl_string3147za700za7za7a3190za7, "($1)", 4);
	      DEFINE_STRING(BGl_string3148z00zzast_sexpz00,
		BgL_bgl_string3148za700za7za7a3191za7, "anonymous", 9);
	      DEFINE_STRING(BGl_string3149z00zzast_sexpz00,
		BgL_bgl_string3149za700za7za7a3192za7, "<", 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpza2zd2ze3nodezd2envz41zzast_sexpz00,
		BgL_bgl_za762sexpza7a2za7d2za7e33193z00,
		BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string3150z00zzast_sexpz00,
		BgL_bgl_string3150za700za7za7a3194za7, ":", 1);
	      DEFINE_STRING(BGl_string3151z00zzast_sexpz00,
		BgL_bgl_string3151za700za7za7a3195za7, "./", 2);
	      DEFINE_STRING(BGl_string3152z00zzast_sexpz00,
		BgL_bgl_string3152za700za7za7a3196za7, ">", 1);
	      DEFINE_STRING(BGl_string3153z00zzast_sexpz00,
		BgL_bgl_string3153za700za7za7a3197za7, "-", 1);
	      DEFINE_STRING(BGl_string3154z00zzast_sexpz00,
		BgL_bgl_string3154za700za7za7a3198za7, "ast_sexp", 8);
	      DEFINE_STRING(BGl_string3155z00zzast_sexpz00,
		BgL_bgl_string3155za700za7za7a3199za7,
		"mutex > bdb location pragma::obj (@ __evmeaning_address foreign) (@ define-primop! __evenv) (@ define-primop-ref! __evenv) write car exp app cons :prelock synchronize apply jump-exit set-exit case failure free-pragma/effect free-pragma pragma/effect letrec* labels letrec let define begin -> __r4_control_features_6_9 quote @ eval not bool test set! pragma else (quote ()) lambda value if (value apply app set!) ",
		412);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_ifzd2symzd2envz00zzast_sexpz00,
		BgL_bgl_za762ifza7d2symza7b0za7za73200za7, BGl_z62ifzd2symzb0zzast_sexpz00,
		0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_usezd2variablez12zd2envz12zzast_sexpz00,
		BgL_bgl_za762useza7d2variabl3201z00,
		BGl_z62usezd2variablez12za2zzast_sexpz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim3202z00,
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long
		BgL_checksumz00_4981, char *BgL_fromz00_4982)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_sexpz00))
				{
					BGl_requirezd2initializa7ationz75zzast_sexpz00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
					BGl_cnstzd2initzd2zzast_sexpz00();
					BGl_importedzd2moduleszd2initz00zzast_sexpz00();
					return BGl_toplevelzd2initzd2zzast_sexpz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "ast_sexp");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			{	/* Ast/sexp.scm 14 */
				obj_t BgL_cportz00_4966;

				{	/* Ast/sexp.scm 14 */
					obj_t BgL_startz00_4975;

					BgL_startz00_4975 = BINT(((long) 0));
					{	/* Ast/sexp.scm 14 */
						obj_t BgL_endz00_4976;

						BgL_endz00_4976 =
							BINT(STRING_LENGTH(BGl_string3155z00zzast_sexpz00));
						{	/* Ast/sexp.scm 14 */

							BgL_cportz00_4966 =
								BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
								(BGl_string3155z00zzast_sexpz00, BgL_startz00_4975,
								BgL_endz00_4976);
				}}}
				{
					long BgL_iz00_4967;

					BgL_iz00_4967 = ((long) 44);
				BgL_loopz00_4968:
					if ((BgL_iz00_4967 == ((long) -1)))
						{	/* Ast/sexp.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/sexp.scm 14 */
							{	/* Ast/sexp.scm 14 */
								obj_t BgL_arg3157z00_4970;

								{	/* Ast/sexp.scm 14 */

									{	/* Ast/sexp.scm 14 */
										obj_t BgL_locationz00_4972;

										BgL_locationz00_4972 = BBOOL(((bool_t) 0));
										{	/* Ast/sexp.scm 14 */

											BgL_arg3157z00_4970 =
												BGl_readz00zz__readerz00(BgL_cportz00_4966,
												BgL_locationz00_4972);
										}
									}
								}
								{	/* Ast/sexp.scm 14 */
									int BgL_auxz00_5018;

									BgL_auxz00_5018 = (int) (BgL_iz00_4967);
									CNST_TABLE_SET(BgL_auxz00_5018, BgL_arg3157z00_4970);
							}}
							{	/* Ast/sexp.scm 14 */
								int BgL_auxz00_4973;

								BgL_auxz00_4973 = (int) ((BgL_iz00_4967 - ((long) 1)));
								{
									long BgL_iz00_5023;

									BgL_iz00_5023 = (long) (BgL_auxz00_4973);
									BgL_iz00_4967 = BgL_iz00_5023;
									goto BgL_loopz00_4968;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_za2sitesza2z00zzast_sexpz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2ifza2z00zzast_sexpz00 =
				BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 1)));
			BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BFALSE;
			BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BFALSE;
			return (BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE, BUNSPEC);
		}
	}



/* top-level-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_17,
		obj_t BgL_locz00_18)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 62 */
			return
				((BgL_nodez00_bglt)
				BGl_zc3exitza31386ze3z83zzast_sexpz00(BgL_locz00_18, BgL_expz00_17));
		}
	}



/* <exit:1386> */
	obj_t BGl_zc3exitza31386ze3z83zzast_sexpz00(obj_t BgL_locz00_4964,
		obj_t BgL_expz00_4963)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 63 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1103z00_1579;

			if (SET_EXIT(BgL_an_exit1103z00_1579))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1103z00_1579 = (void *) jmpbuf;
					{	/* Ast/sexp.scm 63 */

						PUSH_EXIT(BgL_an_exit1103z00_1579, ((long) 1));
						{	/* Ast/sexp.scm 63 */
							obj_t BgL_an_exitd1104z00_1580;

							BgL_an_exitd1104z00_1580 = ((obj_t) (&exitd));
							{	/* Ast/sexp.scm 66 */
								obj_t BgL_res1106z00_1583;

								{	/* Ast/sexp.scm 66 */
									obj_t BgL_zc3anonymousza31401ze3z83_4910;
									obj_t BgL_zc3anonymousza31400ze3z83_4911;

									BgL_zc3anonymousza31401ze3z83_4910 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza31401ze3ze1zzast_sexpz00,
										(int) (((long) 0)), (int) (((long) 2)));
									BgL_zc3anonymousza31400ze3z83_4911 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza31400ze3ze1zzast_sexpz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3anonymousza31401ze3z83_4910,
										(int) (((long) 0)), BgL_expz00_4963);
									PROCEDURE_SET(BgL_zc3anonymousza31401ze3z83_4910,
										(int) (((long) 1)), BgL_locz00_4964);
									PROCEDURE_SET(BgL_zc3anonymousza31400ze3z83_4911,
										(int) (((long) 0)), BgL_an_exitd1104z00_1580);
									BgL_res1106z00_1583 =
										BGl_withzd2exceptionzd2handlerz00zz__errorz00
										(BgL_zc3anonymousza31400ze3z83_4911,
										BgL_zc3anonymousza31401ze3z83_4910);
								}
								POP_EXIT();
								return BgL_res1106z00_1583;
							}
						}
					}
				}
		}
	}



/* &top-level-sexp->node */
	BgL_nodez00_bglt BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_4912, obj_t BgL_expz00_4913, obj_t BgL_locz00_4914)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 62 */
			return
				((BgL_nodez00_bglt)
				BGl_zc3exitza31386ze3z83zzast_sexpz00(BgL_locz00_4914,
					BgL_expz00_4913));
		}
	}



/* &<anonymous:1401> */
	BgL_nodez00_bglt BGl_z62zc3anonymousza31401ze3ze1zzast_sexpz00(obj_t
		BgL_envz00_4915)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 68 */
			{	/* Ast/sexp.scm 69 */
				obj_t BgL_expz00_4916;
				obj_t BgL_locz00_4917;

				BgL_expz00_4916 = PROCEDURE_REF(BgL_envz00_4915, (int) (((long) 0)));
				BgL_locz00_4917 = PROCEDURE_REF(BgL_envz00_4915, (int) (((long) 1)));
				{

					return
						BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_4916, BNIL,
						BgL_locz00_4917, CNST_TABLE_REF(((long) 2)));
		}}}
	}



/* &<anonymous:1400> */
	obj_t BGl_z62zc3anonymousza31400ze3ze1zzast_sexpz00(obj_t BgL_envz00_4918,
		obj_t BgL_ez00_4920)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 65 */
			{	/* Ast/sexp.scm 66 */
				obj_t BgL_an_exitd1104z00_4919;

				BgL_an_exitd1104z00_4919 =
					PROCEDURE_REF(BgL_envz00_4918, (int) (((long) 0)));
				{
					obj_t BgL_ez00_1586;

					BgL_ez00_1586 = BgL_ez00_4920;
					BGl_exceptionzd2notifyzd2zz__objectz00(BgL_ez00_1586);
					return
						BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1104z00_4919,
						BUNSPEC);
				}
			}
		}
	}



/* if-sym */
	BGL_EXPORTED_DEF obj_t BGl_ifzd2symzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 84 */
			return BGl_za2ifza2z00zzast_sexpz00;
		}
	}



/* &if-sym */
	obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t BgL_envz00_4921)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 84 */
			return BGl_za2ifza2z00zzast_sexpz00;
		}
	}



/* proc-or-lambda? */
	bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t BgL_ez00_20)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 96 */
			if (SYMBOLP(BgL_ez00_20))
				{	/* Ast/sexp.scm 97 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 97 */
					if (PAIRP(BgL_ez00_20))
						{	/* Ast/sexp.scm 97 */
							if ((CAR(BgL_ez00_20) == CNST_TABLE_REF(((long) 3))))
								{	/* Ast/sexp.scm 97 */
									bool_t BgL_testz00_5067;

									{	/* Ast/sexp.scm 97 */
										obj_t BgL_auxz00_5068;

										BgL_auxz00_5068 = CDR(BgL_ez00_20);
										BgL_testz00_5067 = PAIRP(BgL_auxz00_5068);
									}
									if (BgL_testz00_5067)
										{	/* Ast/sexp.scm 97 */
											return ((bool_t) 1);
										}
									else
										{	/* Ast/sexp.scm 97 */
											return ((bool_t) 0);
										}
								}
							else
								{	/* Ast/sexp.scm 97 */
									return ((bool_t) 0);
								}
						}
					else
						{	/* Ast/sexp.scm 97 */
							return ((bool_t) 0);
						}
				}
		}
	}



/* sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_expz00_21, obj_t BgL_stackz00_22, obj_t BgL_locz00_23,
		obj_t BgL_sitez00_24)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 110 */
		BGl_sexpzd2ze3nodez31zzast_sexpz00:
			{
				obj_t BgL_atomz00_1603;
				obj_t BgL_lz00_1608;
				obj_t BgL_bodyz00_1612;
				obj_t BgL_lz00_1615;
				obj_t BgL_valz00_1616;
				obj_t BgL_bodyz00_1620;
				obj_t BgL_argsz00_1621;
				obj_t BgL_varz00_1626;
				obj_t BgL_bodyz00_1627;
				obj_t BgL_argz00_1628;
				obj_t BgL_varsz00_1630;
				obj_t BgL_bodyz00_1631;
				obj_t BgL_argsz00_1632;
				obj_t BgL_testz00_1634;
				obj_t BgL_proc1z00_1635;
				obj_t BgL_proc2z00_1636;
				obj_t BgL_argsz00_1637;
				obj_t BgL_testz00_1639;
				obj_t BgL_proc1z00_1640;
				obj_t BgL_proc2z00_1641;
				obj_t BgL_argsz00_1642;
				obj_t BgL_effectz00_1646;
				obj_t BgL_restz00_1647;
				obj_t BgL_effectz00_1650;
				obj_t BgL_restz00_1651;

				if (NULLP(BgL_expz00_21))
					{	/* Ast/sexp.scm 115 */
						{	/* Ast/sexp.scm 118 */
							BgL_nodez00_bglt BgL_res2850z00_3468;

							{	/* Ast/sexp.scm 670 */
								obj_t BgL_arg2660z00_3464;
								BgL_nodez00_bglt BgL_arg2661z00_3465;

								BgL_arg2660z00_3464 =
									BGl_shapez00zztools_shapez00
									(BGl_currentzd2functionzd2zztools_errorz00());
								BgL_arg2661z00_3465 =
									BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
									BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
								{	/* Ast/sexp.scm 669 */
									obj_t BgL_list2662z00_3467;

									BgL_list2662z00_3467 =
										MAKE_PAIR(((obj_t) BgL_arg2661z00_3465), BNIL);
									BgL_res2850z00_3468 =
										((BgL_nodez00_bglt)
										BGl_userzd2errorzf2locationz20zztools_errorz00
										(BgL_locz00_23, BgL_arg2660z00_3464,
											BGl_string3138z00zzast_sexpz00, BgL_expz00_21,
											BgL_list2662z00_3467));
							}}
							return BgL_res2850z00_3468;
						}
					}
				else
					{	/* Ast/sexp.scm 115 */
						if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
								BGl_nodez00zzast_nodez00))
							{
								obj_t BgL_auxz00_5084;

								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_externz00zzast_nodez00))
									{	/* Ast/sexp.scm 123 */
										obj_t BgL_l01326z00_2464;

										BgL_l01326z00_2464 =
											(((BgL_externz00_bglt) CREF(
													((BgL_externz00_bglt) BgL_expz00_21)))->
											BgL_exprza2za2);
										{
											obj_t BgL_l1325z00_2466;

											BgL_l1325z00_2466 = BgL_l01326z00_2464;
										BgL_zc3anonymousza32191ze3z83_2467:
											if (NULLP(BgL_l1325z00_2466))
												{	/* Ast/sexp.scm 123 */
													BgL_l01326z00_2464;
												}
											else
												{	/* Ast/sexp.scm 123 */
													{	/* Ast/sexp.scm 123 */
														BgL_nodez00_bglt BgL_arg2193z00_2469;

														{	/* Ast/sexp.scm 123 */
															obj_t BgL_ez00_2470;

															BgL_ez00_2470 = CAR(BgL_l1325z00_2466);
															{	/* Ast/sexp.scm 123 */
																obj_t BgL_arg2194z00_2471;

																BgL_arg2194z00_2471 =
																	(((BgL_nodez00_bglt) CREF(
																			((BgL_nodez00_bglt)
																				((BgL_externz00_bglt)
																					BgL_expz00_21))))->BgL_locz00);
																BgL_arg2193z00_2469 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_2470, BgL_stackz00_22,
																	BgL_arg2194z00_2471,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 123 */
															obj_t BgL_auxz00_5097;

															BgL_auxz00_5097 = ((obj_t) BgL_arg2193z00_2469);
															SET_CAR(BgL_l1325z00_2466, BgL_auxz00_5097);
													}}
													{
														obj_t BgL_l1325z00_5100;

														BgL_l1325z00_5100 = CDR(BgL_l1325z00_2466);
														BgL_l1325z00_2466 = BgL_l1325z00_5100;
														goto BgL_zc3anonymousza32191ze3z83_2467;
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 121 */
										BFALSE;
									}
								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_appz00zzast_nodez00))
									{	/* Ast/sexp.scm 126 */
										obj_t BgL_l01329z00_2476;

										BgL_l01329z00_2476 =
											(((BgL_appz00_bglt) CREF(
													((BgL_appz00_bglt) BgL_expz00_21)))->BgL_argsz00);
										{
											obj_t BgL_l1328z00_2478;

											BgL_l1328z00_2478 = BgL_l01329z00_2476;
										BgL_zc3anonymousza32197ze3z83_2479:
											if (NULLP(BgL_l1328z00_2478))
												{	/* Ast/sexp.scm 126 */
													BgL_l01329z00_2476;
												}
											else
												{	/* Ast/sexp.scm 126 */
													{	/* Ast/sexp.scm 126 */
														BgL_nodez00_bglt BgL_arg2199z00_2481;

														{	/* Ast/sexp.scm 126 */
															obj_t BgL_ez00_2482;

															BgL_ez00_2482 = CAR(BgL_l1328z00_2478);
															{	/* Ast/sexp.scm 126 */
																obj_t BgL_arg2200z00_2483;

																BgL_arg2200z00_2483 =
																	(((BgL_nodez00_bglt) CREF(
																			((BgL_nodez00_bglt)
																				((BgL_appz00_bglt) BgL_expz00_21))))->
																	BgL_locz00);
																BgL_arg2199z00_2481 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_2482, BgL_stackz00_22,
																	BgL_arg2200z00_2483,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 126 */
															obj_t BgL_auxz00_5114;

															BgL_auxz00_5114 = ((obj_t) BgL_arg2199z00_2481);
															SET_CAR(BgL_l1328z00_2478, BgL_auxz00_5114);
													}}
													{
														obj_t BgL_l1328z00_5117;

														BgL_l1328z00_5117 = CDR(BgL_l1328z00_2478);
														BgL_l1328z00_2478 = BgL_l1328z00_5117;
														goto BgL_zc3anonymousza32197ze3z83_2479;
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 124 */
										BFALSE;
									}
								BgL_auxz00_5084 = BgL_expz00_21;
								return ((BgL_nodez00_bglt) BgL_auxz00_5084);
							}
						else
							{	/* Ast/sexp.scm 115 */
								if (PAIRP(BgL_expz00_21))
									{	/* Ast/sexp.scm 115 */
										obj_t BgL_carzd2468zd2_1672;

										BgL_carzd2468zd2_1672 = CAR(BgL_expz00_21);
										if (SYMBOLP(BgL_carzd2468zd2_1672))
											{	/* Ast/sexp.scm 115 */
												bool_t BgL_testz00_5125;

												{	/* Ast/sexp.scm 115 */
													obj_t BgL__ortest_1138z00_2067;

													BgL__ortest_1138z00_2067 =
														BGl_findzd2localzd2zzast_sexpz00
														(BgL_carzd2468zd2_1672, BgL_stackz00_22);
													if (CBOOL(BgL__ortest_1138z00_2067))
														{	/* Ast/sexp.scm 115 */
															BgL_testz00_5125 =
																CBOOL(BgL__ortest_1138z00_2067);
														}
													else
														{	/* Ast/sexp.scm 115 */
															obj_t BgL_gz00_2068;

															BgL_gz00_2068 =
																BGl_findzd2globalzd2zzast_envz00
																(BgL_carzd2468zd2_1672, BNIL);
															if (CBOOL(BgL_gz00_2068))
																{	/* Ast/sexp.scm 115 */
																	if (
																		((((BgL_globalz00_bglt) CREF(
																						((BgL_globalz00_bglt)
																							BgL_gz00_2068)))->
																				BgL_modulez00) ==
																			CNST_TABLE_REF(((long) 14))))
																		{	/* Ast/sexp.scm 115 */
																			BgL_testz00_5125 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/sexp.scm 115 */
																			BgL_testz00_5125 = ((bool_t) 1);
																		}
																}
															else
																{	/* Ast/sexp.scm 115 */
																	BgL_testz00_5125 = ((bool_t) 0);
																}
														}
												}
												if (BgL_testz00_5125)
													{	/* Ast/sexp.scm 115 */
														return
															BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21,
															BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
													}
												else
													{	/* Ast/sexp.scm 115 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 12))))
															{	/* Ast/sexp.scm 115 */
															BgL_tagzd2371zd2_1607:
																{	/* Ast/sexp.scm 166 */
																	obj_t BgL_locz00_2508;

																	BgL_locz00_2508 =
																		BGl_findzd2locationzf2locz20zztools_locationz00
																		(BgL_expz00_21, BgL_locz00_23);
																	{
																		obj_t BgL_namez00_2509;
																		obj_t BgL_modulez00_2510;

																		if (PAIRP(BgL_expz00_21))
																			{	/* Ast/sexp.scm 167 */
																				obj_t BgL_cdrzd27838zd2_2515;

																				BgL_cdrzd27838zd2_2515 =
																					CDR(BgL_expz00_21);
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 12))))
																					{	/* Ast/sexp.scm 167 */
																						if (PAIRP(BgL_cdrzd27838zd2_2515))
																							{	/* Ast/sexp.scm 167 */
																								obj_t BgL_carzd27841zd2_2518;
																								obj_t BgL_cdrzd27842zd2_2519;

																								BgL_carzd27841zd2_2518 =
																									CAR(BgL_cdrzd27838zd2_2515);
																								BgL_cdrzd27842zd2_2519 =
																									CDR(BgL_cdrzd27838zd2_2515);
																								if (SYMBOLP
																									(BgL_carzd27841zd2_2518))
																									{	/* Ast/sexp.scm 167 */
																										if (PAIRP
																											(BgL_cdrzd27842zd2_2519))
																											{	/* Ast/sexp.scm 167 */
																												obj_t
																													BgL_carzd27847zd2_2522;
																												BgL_carzd27847zd2_2522 =
																													CAR
																													(BgL_cdrzd27842zd2_2519);
																												if (SYMBOLP
																													(BgL_carzd27847zd2_2522))
																													{	/* Ast/sexp.scm 167 */
																														if (NULLP(CDR
																																(BgL_cdrzd27842zd2_2519)))
																															{	/* Ast/sexp.scm 167 */
																																BgL_namez00_2509
																																	=
																																	BgL_carzd27841zd2_2518;
																																BgL_modulez00_2510
																																	=
																																	BgL_carzd27847zd2_2522;
																																{	/* Ast/sexp.scm 169 */
																																	obj_t
																																		BgL_globalz00_2527;
																																	BgL_globalz00_2527
																																		=
																																		BGl_findzd2globalzf2modulez20zzast_envz00
																																		(BgL_namez00_2509,
																																		BgL_modulez00_2510);
																																	if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_2527, BGl_globalz00zzast_varz00))
																																		{	/* Ast/sexp.scm 171 */
																																			if (
																																				((((BgL_globalz00_bglt) CREF(((BgL_globalz00_bglt) BgL_globalz00_2527)))->BgL_importz00) == CNST_TABLE_REF(((long) 11))))
																																				{	/* Ast/sexp.scm 174 */
																																					obj_t
																																						BgL_arg2230z00_2530;
																																					{	/* Ast/sexp.scm 174 */
																																						obj_t
																																							BgL_arg2231z00_2531;
																																						BgL_arg2231z00_2531
																																							=
																																							MAKE_PAIR
																																							(BGl_atomz00zzast_nodez00,
																																							BNIL);
																																						BgL_arg2230z00_2530
																																							=
																																							MAKE_PAIR
																																							(CNST_TABLE_REF
																																							(((long) 11)), BgL_arg2231z00_2531);
																																					}
																																					{
																																						obj_t
																																							BgL_locz00_5177;
																																						obj_t
																																							BgL_expz00_5176;
																																						BgL_expz00_5176
																																							=
																																							BgL_arg2230z00_2530;
																																						BgL_locz00_5177
																																							=
																																							BgL_locz00_2508;
																																						BgL_locz00_23
																																							=
																																							BgL_locz00_5177;
																																						BgL_expz00_21
																																							=
																																							BgL_expz00_5176;
																																						goto
																																							BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 173 */
																																					return
																																						BGl_variablezd2ze3nodez31zzast_sexpz00
																																						(BgL_globalz00_2527,
																																						BgL_locz00_2508,
																																						BgL_sitez00_24);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 172 */
																																			BgL_nodez00_bglt
																																				BgL_res2867z00_3532;
																																			{	/* Ast/sexp.scm 670 */
																																				obj_t
																																					BgL_arg2660z00_3528;
																																				BgL_nodez00_bglt
																																					BgL_arg2661z00_3529;
																																				BgL_arg2660z00_3528
																																					=
																																					BGl_shapez00zztools_shapez00
																																					(BGl_currentzd2functionzd2zztools_errorz00
																																					());
																																				BgL_arg2661z00_3529
																																					=
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																					(CNST_TABLE_REF
																																					(((long) 4)), BNIL, BgL_locz00_2508, CNST_TABLE_REF(((long) 2)));
																																				{	/* Ast/sexp.scm 669 */
																																					obj_t
																																						BgL_list2662z00_3531;
																																					BgL_list2662z00_3531
																																						=
																																						MAKE_PAIR
																																						(((obj_t) BgL_arg2661z00_3529), BNIL);
																																					BgL_res2867z00_3532
																																						=
																																						(
																																						(BgL_nodez00_bglt)
																																						BGl_userzd2errorzf2locationz20zztools_errorz00
																																						(BgL_locz00_2508,
																																							BgL_arg2660z00_3528,
																																							BGl_string3136z00zzast_sexpz00,
																																							BgL_expz00_21,
																																							BgL_list2662z00_3531));
																																			}}
																																			return
																																				BgL_res2867z00_3532;
																																		}
																																}
																															}
																														else
																															{	/* Ast/sexp.scm 167 */
																															BgL_tagzd27831zd2_2512:
																																{	/* Ast/sexp.scm 178 */
																																	BgL_nodez00_bglt
																																		BgL_res2868z00_3540;
																																	{	/* Ast/sexp.scm 670 */
																																		obj_t
																																			BgL_arg2660z00_3536;
																																		BgL_nodez00_bglt
																																			BgL_arg2661z00_3537;
																																		BgL_arg2660z00_3536
																																			=
																																			BGl_shapez00zztools_shapez00
																																			(BGl_currentzd2functionzd2zztools_errorz00
																																			());
																																		BgL_arg2661z00_3537
																																			=
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																			(CNST_TABLE_REF
																																			(((long)
																																					4)),
																																			BNIL,
																																			BgL_locz00_2508,
																																			CNST_TABLE_REF
																																			(((long)
																																					2)));
																																		{	/* Ast/sexp.scm 669 */
																																			obj_t
																																				BgL_list2662z00_3539;
																																			BgL_list2662z00_3539
																																				=
																																				MAKE_PAIR
																																				(((obj_t) BgL_arg2661z00_3537), BNIL);
																																			BgL_res2868z00_3540
																																				=
																																				(
																																				(BgL_nodez00_bglt)
																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																				(BgL_locz00_2508,
																																					BgL_arg2660z00_3536,
																																					BGl_string3135z00zzast_sexpz00,
																																					BgL_expz00_21,
																																					BgL_list2662z00_3539));
																																	}}
																																	return
																																		BgL_res2868z00_3540;
																																}
																															}
																													}
																												else
																													{	/* Ast/sexp.scm 167 */
																														goto
																															BgL_tagzd27831zd2_2512;
																													}
																											}
																										else
																											{	/* Ast/sexp.scm 167 */
																												goto
																													BgL_tagzd27831zd2_2512;
																											}
																									}
																								else
																									{	/* Ast/sexp.scm 167 */
																										goto BgL_tagzd27831zd2_2512;
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 167 */
																								goto BgL_tagzd27831zd2_2512;
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 167 */
																						goto BgL_tagzd27831zd2_2512;
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 167 */
																				goto BgL_tagzd27831zd2_2512;
																			}
																	}
																}
															}
														else
															{	/* Ast/sexp.scm 115 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 15))))
																	{	/* Ast/sexp.scm 115 */
																		BgL_lz00_1608 = CDR(BgL_expz00_21);
																	BgL_tagzd2372zd2_1609:
																		{	/* Ast/sexp.scm 181 */
																			bool_t BgL_testz00_5201;

																			if (PAIRP(BgL_lz00_1608))
																				{	/* Ast/sexp.scm 181 */
																					bool_t BgL_testz00_5204;

																					{	/* Ast/sexp.scm 181 */
																						obj_t BgL_auxz00_5205;

																						BgL_auxz00_5205 =
																							CDR(BgL_lz00_1608);
																						BgL_testz00_5204 =
																							PAIRP(BgL_auxz00_5205);
																					}
																					if (BgL_testz00_5204)
																						{
																							obj_t BgL_l1330z00_2537;

																							BgL_l1330z00_2537 = BgL_lz00_1608;
																						BgL_zc3anonymousza32236ze3z83_2538:
																							if (NULLP(BgL_l1330z00_2537))
																								{	/* Ast/sexp.scm 181 */
																									BgL_testz00_5201 =
																										((bool_t) 1);
																								}
																							else
																								{	/* Ast/sexp.scm 181 */
																									bool_t BgL_testz00_5210;

																									{	/* Ast/sexp.scm 181 */
																										obj_t BgL_auxz00_5211;

																										BgL_auxz00_5211 =
																											CAR(BgL_l1330z00_2537);
																										BgL_testz00_5210 =
																											SYMBOLP(BgL_auxz00_5211);
																									}
																									if (BgL_testz00_5210)
																										{
																											obj_t BgL_l1330z00_5214;

																											BgL_l1330z00_5214 =
																												CDR(BgL_l1330z00_2537);
																											BgL_l1330z00_2537 =
																												BgL_l1330z00_5214;
																											goto
																												BgL_zc3anonymousza32236ze3z83_2538;
																										}
																									else
																										{	/* Ast/sexp.scm 181 */
																											BgL_testz00_5201 =
																												((bool_t) 0);
																										}
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 181 */
																							BgL_testz00_5201 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 181 */
																					BgL_testz00_5201 = ((bool_t) 0);
																				}
																			if (BgL_testz00_5201)
																				{	/* Ast/sexp.scm 181 */
																					return
																						BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00
																						(BgL_lz00_1608, BgL_expz00_21,
																						BgL_stackz00_22, BgL_locz00_23,
																						BgL_sitez00_24);
																				}
																			else
																				{	/* Ast/sexp.scm 183 */
																					BgL_nodez00_bglt BgL_res2879z00_3577;

																					{	/* Ast/sexp.scm 670 */
																						obj_t BgL_arg2660z00_3573;
																						BgL_nodez00_bglt
																							BgL_arg2661z00_3574;
																						BgL_arg2660z00_3573 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg2661z00_3574 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_23,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 669 */
																							obj_t BgL_list2662z00_3576;

																							BgL_list2662z00_3576 =
																								MAKE_PAIR(
																								((obj_t) BgL_arg2661z00_3574),
																								BNIL);
																							BgL_res2879z00_3577 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_23,
																									BgL_arg2660z00_3573,
																									BGl_string3132z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list2662z00_3576));
																					}}
																					return BgL_res2879z00_3577;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 115 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 13))))
																			{	/* Ast/sexp.scm 115 */
																			BgL_tagzd2373zd2_1610:
																				{
																					obj_t BgL_valuez00_2546;

																					if (PAIRP(BgL_expz00_21))
																						{	/* Ast/sexp.scm 115 */
																							obj_t BgL_cdrzd27858zd2_2551;

																							BgL_cdrzd27858zd2_2551 =
																								CDR(BgL_expz00_21);
																							if (PAIRP(BgL_cdrzd27858zd2_2551))
																								{	/* Ast/sexp.scm 115 */
																									if (NULLP(CDR
																											(BgL_cdrzd27858zd2_2551)))
																										{	/* Ast/sexp.scm 115 */
																											BgL_valuez00_2546 =
																												CAR
																												(BgL_cdrzd27858zd2_2551);
																											{	/* Ast/sexp.scm 188 */
																												obj_t BgL_locz00_2556;

																												BgL_locz00_2556 =
																													BGl_findzd2locationzf2locz20zztools_locationz00
																													(BgL_expz00_21,
																													BgL_locz00_23);
																												if (NULLP
																													(BgL_valuez00_2546))
																													{	/* Ast/sexp.scm 191 */
																														BgL_atomz00_bglt
																															BgL_new1115z00_2558;
																														{	/* Ast/sexp.scm 192 */
																															BgL_atomz00_bglt
																																BgL_new1114z00_2560;
																															BgL_new1114z00_2560
																																=
																																(
																																(BgL_atomz00_bglt)
																																BREF(GC_MALLOC
																																	(sizeof(struct
																																			BgL_atomz00_bgl))));
																															{	/* Ast/sexp.scm 192 */
																																long
																																	BgL_arg2248z00_2561;
																																{	/* Ast/sexp.scm 192 */
																																	long
																																		BgL_res2881z00_3581;
																																	BgL_res2881z00_3581
																																		=
																																		BGL_CLASS_INDEX
																																		(BGl_atomz00zzast_nodez00);
																																	BgL_arg2248z00_2561
																																		=
																																		BgL_res2881z00_3581;
																																}
																																BGL_OBJECT_CLASS_NUM_SET
																																	(((BgL_objectz00_bglt) BgL_new1114z00_2560), BgL_arg2248z00_2561);
																															}
																															{	/* Ast/sexp.scm 192 */
																																BgL_objectz00_bglt
																																	BgL_auxz00_5246;
																																BgL_auxz00_5246
																																	=
																																	(
																																	(BgL_objectz00_bglt)
																																	BgL_new1114z00_2560);
																																BGL_OBJECT_WIDENING_SET
																																	(BgL_auxz00_5246,
																																	BFALSE);
																															}
																															BgL_new1115z00_2558
																																=
																																BgL_new1114z00_2560;
																														}
																														((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1115z00_2558)))->BgL_locz00) = ((obj_t) BgL_locz00_2556), BUNSPEC);
																														{
																															BgL_typez00_bglt
																																BgL_auxz00_5251;
																															{	/* Ast/sexp.scm 193 */
																																BgL_typez00_bglt
																																	BgL_arg2247z00_2559;
																																BgL_arg2247z00_2559
																																	=
																																	BGl_getzd2typezd2kwotez00zztype_typeofz00
																																	(BgL_valuez00_2546);
																																BgL_auxz00_5251
																																	=
																																	BGl_strictzd2nodezd2typez00zzast_nodez00
																																	(BgL_arg2247z00_2559,
																																	((BgL_typez00_bglt) BGl_za2bnilza2z00zztype_cachez00));
																															}
																															((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1115z00_2558)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_5251), BUNSPEC);
																														}
																														((((BgL_atomz00_bglt) CREF(BgL_new1115z00_2558))->BgL_valuez00) = ((obj_t) BNIL), BUNSPEC);
																														return
																															(
																															(BgL_nodez00_bglt)
																															BgL_new1115z00_2558);
																													}
																												else
																													{	/* Ast/sexp.scm 195 */
																														bool_t
																															BgL_testz00_5259;
																														if (PAIRP
																															(BgL_valuez00_2546))
																															{	/* Ast/sexp.scm 195 */
																																BgL_testz00_5259
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Ast/sexp.scm 195 */
																																if (VECTORP
																																	(BgL_valuez00_2546))
																																	{	/* Ast/sexp.scm 196 */
																																		BgL_testz00_5259
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 196 */
																																		if (BGL_HVECTORP(BgL_valuez00_2546))
																																			{	/* Ast/sexp.scm 197 */
																																				BgL_testz00_5259
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 197 */
																																				if (STRUCTP(BgL_valuez00_2546))
																																					{	/* Ast/sexp.scm 198 */
																																						BgL_testz00_5259
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 198 */
																																						if (SYMBOLP(BgL_valuez00_2546))
																																							{	/* Ast/sexp.scm 199 */
																																								BgL_testz00_5259
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 199 */
																																								BgL_testz00_5259
																																									=
																																									KEYWORDP
																																									(BgL_valuez00_2546);
																																							}
																																					}
																																			}
																																	}
																															}
																														if (BgL_testz00_5259)
																															{	/* Ast/sexp.scm 201 */
																																BgL_kwotez00_bglt
																																	BgL_new1117z00_2563;
																																{	/* Ast/sexp.scm 202 */
																																	BgL_kwotez00_bglt
																																		BgL_new1116z00_2565;
																																	BgL_new1116z00_2565
																																		=
																																		(
																																		(BgL_kwotez00_bglt)
																																		BREF
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_kwotez00_bgl))));
																																	{	/* Ast/sexp.scm 202 */
																																		long
																																			BgL_arg2251z00_2566;
																																		{	/* Ast/sexp.scm 202 */
																																			long
																																				BgL_res2887z00_3596;
																																			BgL_res2887z00_3596
																																				=
																																				BGL_CLASS_INDEX
																																				(BGl_kwotez00zzast_nodez00);
																																			BgL_arg2251z00_2566
																																				=
																																				BgL_res2887z00_3596;
																																		}
																																		BGL_OBJECT_CLASS_NUM_SET
																																			(((BgL_objectz00_bglt) BgL_new1116z00_2565), BgL_arg2251z00_2566);
																																	}
																																	{	/* Ast/sexp.scm 202 */
																																		BgL_objectz00_bglt
																																			BgL_auxz00_5275;
																																		BgL_auxz00_5275
																																			=
																																			(
																																			(BgL_objectz00_bglt)
																																			BgL_new1116z00_2565);
																																		BGL_OBJECT_WIDENING_SET
																																			(BgL_auxz00_5275,
																																			BFALSE);
																																	}
																																	BgL_new1117z00_2563
																																		=
																																		BgL_new1116z00_2565;
																																}
																																((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1117z00_2563)))->BgL_locz00) = ((obj_t) BgL_locz00_2556), BUNSPEC);
																																{
																																	BgL_typez00_bglt
																																		BgL_auxz00_5280;
																																	{	/* Ast/sexp.scm 203 */
																																		BgL_typez00_bglt
																																			BgL_arg2250z00_2564;
																																		BgL_arg2250z00_2564
																																			=
																																			BGl_getzd2typezd2kwotez00zztype_typeofz00
																																			(BgL_valuez00_2546);
																																		BgL_auxz00_5280
																																			=
																																			BGl_strictzd2nodezd2typez00zzast_nodez00
																																			(BgL_arg2250z00_2564,
																																			((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00));
																																	}
																																	((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1117z00_2563)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_5280), BUNSPEC);
																																}
																																((((BgL_kwotez00_bglt) CREF(BgL_new1117z00_2563))->BgL_valuez00) = ((obj_t) BgL_valuez00_2546), BUNSPEC);
																																return
																																	(
																																	(BgL_nodez00_bglt)
																																	BgL_new1117z00_2563);
																															}
																														else
																															{	/* Ast/sexp.scm 205 */
																																bool_t
																																	BgL_testz00_5288;
																																if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_valuez00_2546))
																																	{	/* Ast/sexp.scm 205 */
																																		BgL_testz00_5288
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 205 */
																																		if (STRINGP
																																			(BgL_valuez00_2546))
																																			{	/* Ast/sexp.scm 206 */
																																				BgL_testz00_5288
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 206 */
																																				if (CNSTP(BgL_valuez00_2546))
																																					{	/* Ast/sexp.scm 207 */
																																						BgL_testz00_5288
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 207 */
																																						if (CHARP(BgL_valuez00_2546))
																																							{	/* Ast/sexp.scm 211 */
																																								BgL_testz00_5288
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 211 */
																																								BgL_testz00_5288
																																									=
																																									BOOLEANP
																																									(BgL_valuez00_2546);
																																							}
																																					}
																																			}
																																	}
																																if (BgL_testz00_5288)
																																	{
																																		obj_t
																																			BgL_locz00_5299;
																																		obj_t
																																			BgL_expz00_5298;
																																		BgL_expz00_5298
																																			=
																																			BgL_valuez00_2546;
																																		BgL_locz00_5299
																																			=
																																			BgL_locz00_2556;
																																		BgL_locz00_23
																																			=
																																			BgL_locz00_5299;
																																		BgL_expz00_21
																																			=
																																			BgL_expz00_5298;
																																		goto
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																	}
																																else
																																	{	/* Ast/sexp.scm 215 */
																																		BgL_nodez00_bglt
																																			BgL_res2892z00_3614;
																																		{	/* Ast/sexp.scm 670 */
																																			obj_t
																																				BgL_arg2660z00_3610;
																																			BgL_nodez00_bglt
																																				BgL_arg2661z00_3611;
																																			BgL_arg2660z00_3610
																																				=
																																				BGl_shapez00zztools_shapez00
																																				(BGl_currentzd2functionzd2zztools_errorz00
																																				());
																																			BgL_arg2661z00_3611
																																				=
																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																				(CNST_TABLE_REF
																																				(((long)
																																						4)),
																																				BNIL,
																																				BgL_locz00_2556,
																																				CNST_TABLE_REF
																																				(((long)
																																						2)));
																																			{	/* Ast/sexp.scm 669 */
																																				obj_t
																																					BgL_list2662z00_3613;
																																				BgL_list2662z00_3613
																																					=
																																					MAKE_PAIR
																																					(((obj_t) BgL_arg2661z00_3611), BNIL);
																																				BgL_res2892z00_3614
																																					=
																																					(
																																					(BgL_nodez00_bglt)
																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																					(BgL_locz00_2556,
																																						BgL_arg2660z00_3610,
																																						BGl_string3134z00zzast_sexpz00,
																																						BgL_expz00_21,
																																						BgL_list2662z00_3613));
																																		}}
																																		return
																																			BgL_res2892z00_3614;
																																	}
																															}
																													}
																											}
																										}
																									else
																										{	/* Ast/sexp.scm 115 */
																										BgL_tagzd27853zd2_2548:
																											{	/* Ast/sexp.scm 217 */
																												BgL_nodez00_bglt
																													BgL_res2893z00_3622;
																												{	/* Ast/sexp.scm 670 */
																													obj_t
																														BgL_arg2660z00_3618;
																													BgL_nodez00_bglt
																														BgL_arg2661z00_3619;
																													BgL_arg2660z00_3618 =
																														BGl_shapez00zztools_shapez00
																														(BGl_currentzd2functionzd2zztools_errorz00
																														());
																													BgL_arg2661z00_3619 =
																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																														(CNST_TABLE_REF((
																																(long) 4)),
																														BNIL, BgL_locz00_23,
																														CNST_TABLE_REF((
																																(long) 2)));
																													{	/* Ast/sexp.scm 669 */
																														obj_t
																															BgL_list2662z00_3621;
																														BgL_list2662z00_3621
																															=
																															MAKE_PAIR(((obj_t)
																																BgL_arg2661z00_3619),
																															BNIL);
																														BgL_res2893z00_3622
																															=
																															(
																															(BgL_nodez00_bglt)
																															BGl_userzd2errorzf2locationz20zztools_errorz00
																															(BgL_locz00_23,
																																BgL_arg2660z00_3618,
																																BGl_string3134z00zzast_sexpz00,
																																BgL_expz00_21,
																																BgL_list2662z00_3621));
																												}}
																												return
																													BgL_res2893z00_3622;
																											}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 115 */
																									goto BgL_tagzd27853zd2_2548;
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 115 */
																							goto BgL_tagzd27853zd2_2548;
																						}
																				}
																			}
																		else
																			{	/* Ast/sexp.scm 115 */
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 16))))
																					{	/* Ast/sexp.scm 115 */
																						if (NULLP(CDR(BgL_expz00_21)))
																							{	/* Ast/sexp.scm 115 */
																							BgL_tagzd2374zd2_1611:
																								{
																									obj_t BgL_locz00_5327;
																									obj_t BgL_expz00_5326;

																									BgL_expz00_5326 = BUNSPEC;
																									BgL_locz00_5327 =
																										BGl_findzd2locationzf2locz20zztools_locationz00
																										(BgL_expz00_21,
																										BgL_locz00_23);
																									BgL_locz00_23 =
																										BgL_locz00_5327;
																									BgL_expz00_21 =
																										BgL_expz00_5326;
																									goto
																										BGl_sexpzd2ze3nodez31zzast_sexpz00;
																								}
																							}
																						else
																							{	/* Ast/sexp.scm 115 */
																								obj_t BgL_arg1467z00_1682;

																								BgL_arg1467z00_1682 =
																									CDR(BgL_expz00_21);
																								{
																									BgL_sequencez00_bglt
																										BgL_auxz00_5330;
																									BgL_bodyz00_1612 =
																										BgL_arg1467z00_1682;
																								BgL_tagzd2375zd2_1613:
																									{	/* Ast/sexp.scm 222 */
																										obj_t BgL_locz00_2578;

																										BgL_locz00_2578 =
																											BGl_findzd2locationzf2locz20zztools_locationz00
																											(BgL_expz00_21,
																											BgL_locz00_23);
																										{	/* Ast/sexp.scm 222 */
																											obj_t BgL_nodesz00_2579;

																											BgL_nodesz00_2579 =
																												BGl_sexpza2zd2ze3nodez93zzast_sexpz00
																												(BgL_bodyz00_1612,
																												BgL_stackz00_22,
																												BgL_locz00_2578,
																												BgL_sitez00_24);
																											{	/* Ast/sexp.scm 223 */

																												{	/* Ast/sexp.scm 224 */
																													BgL_sequencez00_bglt
																														BgL_new1119z00_2580;
																													{	/* Ast/sexp.scm 225 */
																														BgL_sequencez00_bglt
																															BgL_new1118z00_2581;
																														BgL_new1118z00_2581
																															=
																															(
																															(BgL_sequencez00_bglt)
																															BREF(GC_MALLOC
																																(sizeof(struct
																																		BgL_sequencez00_bgl))));
																														{	/* Ast/sexp.scm 225 */
																															long
																																BgL_arg2263z00_2582;
																															{	/* Ast/sexp.scm 225 */
																																long
																																	BgL_res2897z00_3633;
																																BgL_res2897z00_3633
																																	=
																																	BGL_CLASS_INDEX
																																	(BGl_sequencez00zzast_nodez00);
																																BgL_arg2263z00_2582
																																	=
																																	BgL_res2897z00_3633;
																															}
																															BGL_OBJECT_CLASS_NUM_SET
																																(((BgL_objectz00_bglt) BgL_new1118z00_2581), BgL_arg2263z00_2582);
																														}
																														{	/* Ast/sexp.scm 225 */
																															BgL_objectz00_bglt
																																BgL_auxz00_5337;
																															BgL_auxz00_5337 =
																																(
																																(BgL_objectz00_bglt)
																																BgL_new1118z00_2581);
																															BGL_OBJECT_WIDENING_SET
																																(BgL_auxz00_5337,
																																BFALSE);
																														}
																														BgL_new1119z00_2580
																															=
																															BgL_new1118z00_2581;
																													}
																													((((BgL_nodez00_bglt)
																																CREF((
																																		(BgL_nodez00_bglt)
																																		BgL_new1119z00_2580)))->
																															BgL_locz00) =
																														((obj_t)
																															BgL_locz00_2578),
																														BUNSPEC);
																													((((BgL_nodez00_bglt)
																																CREF((
																																		(BgL_nodez00_bglt)
																																		BgL_new1119z00_2580)))->
																															BgL_typez00) =
																														((BgL_typez00_bglt)
																															((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt) BgL_new1119z00_2580)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt) BgL_new1119z00_2580)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																													((((BgL_sequencez00_bglt) CREF(BgL_new1119z00_2580))->BgL_nodesz00) = ((obj_t) BgL_nodesz00_2579), BUNSPEC);
																													((((BgL_sequencez00_bglt) CREF(BgL_new1119z00_2580))->BgL_unsafez00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
																													BgL_auxz00_5330 =
																														BgL_new1119z00_2580;
																									}}}}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_5330);
																								}
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 115 */
																						obj_t BgL_carzd2584zd2_1684;

																						BgL_carzd2584zd2_1684 =
																							CAR(BgL_expz00_21);
																						if (
																							(BgL_carzd2584zd2_1684 ==
																								CNST_TABLE_REF(((long) 1))))
																							{	/* Ast/sexp.scm 115 */
																							BgL_tagzd2376zd2_1614:
																								{
																									obj_t BgL_siz00_2583;
																									obj_t BgL_alorsz00_2584;
																									obj_t BgL_sinonz00_2585;
																									obj_t BgL_siz00_2587;
																									obj_t BgL_alorsz00_2588;

																									if (PAIRP(BgL_expz00_21))
																										{	/* Ast/sexp.scm 115 */
																											obj_t
																												BgL_cdrzd27874zd2_2593;
																											BgL_cdrzd27874zd2_2593 =
																												CDR(BgL_expz00_21);
																											if (PAIRP
																												(BgL_cdrzd27874zd2_2593))
																												{	/* Ast/sexp.scm 115 */
																													obj_t
																														BgL_cdrzd27879zd2_2595;
																													BgL_cdrzd27879zd2_2595
																														=
																														CDR
																														(BgL_cdrzd27874zd2_2593);
																													if (PAIRP
																														(BgL_cdrzd27879zd2_2595))
																														{	/* Ast/sexp.scm 115 */
																															obj_t
																																BgL_cdrzd27884zd2_2597;
																															BgL_cdrzd27884zd2_2597
																																=
																																CDR
																																(BgL_cdrzd27879zd2_2595);
																															if (PAIRP
																																(BgL_cdrzd27884zd2_2597))
																																{	/* Ast/sexp.scm 115 */
																																	if (NULLP(CDR
																																			(BgL_cdrzd27884zd2_2597)))
																																		{	/* Ast/sexp.scm 115 */
																																			BgL_siz00_2583
																																				=
																																				CAR
																																				(BgL_cdrzd27874zd2_2593);
																																			BgL_alorsz00_2584
																																				=
																																				CAR
																																				(BgL_cdrzd27879zd2_2595);
																																			BgL_sinonz00_2585
																																				=
																																				CAR
																																				(BgL_cdrzd27884zd2_2597);
																																			{
																																				obj_t
																																					BgL_siz00_2610;
																																				if (PAIRP(BgL_siz00_2583))
																																					{	/* Ast/sexp.scm 115 */
																																						obj_t
																																							BgL_cdrzd27939zd2_2615;
																																						BgL_cdrzd27939zd2_2615
																																							=
																																							CDR
																																							(BgL_siz00_2583);
																																						if (
																																							(CAR
																																								(BgL_siz00_2583)
																																								==
																																								CNST_TABLE_REF
																																								(((long) 1))))
																																							{	/* Ast/sexp.scm 115 */
																																								if (PAIRP(BgL_cdrzd27939zd2_2615))
																																									{	/* Ast/sexp.scm 115 */
																																										obj_t
																																											BgL_cdrzd27942zd2_2618;
																																										BgL_cdrzd27942zd2_2618
																																											=
																																											CDR
																																											(BgL_cdrzd27939zd2_2615);
																																										if (PAIRP(BgL_cdrzd27942zd2_2618))
																																											{	/* Ast/sexp.scm 115 */
																																												obj_t
																																													BgL_cdrzd27945zd2_2620;
																																												BgL_cdrzd27945zd2_2620
																																													=
																																													CDR
																																													(BgL_cdrzd27942zd2_2618);
																																												if ((CAR(BgL_cdrzd27942zd2_2618) == BFALSE))
																																													{	/* Ast/sexp.scm 115 */
																																														if (PAIRP(BgL_cdrzd27945zd2_2620))
																																															{	/* Ast/sexp.scm 115 */
																																																if ((CAR(BgL_cdrzd27945zd2_2620) == BTRUE))
																																																	{	/* Ast/sexp.scm 115 */
																																																		if (NULLP(CDR(BgL_cdrzd27945zd2_2620)))
																																																			{	/* Ast/sexp.scm 115 */
																																																				BgL_siz00_2610
																																																					=
																																																					CAR
																																																					(BgL_cdrzd27939zd2_2615);
																																																			BgL_tagzd27931zd2_2611:
																																																				{	/* Ast/sexp.scm 234 */
																																																					obj_t
																																																						BgL_auxz00_5395;
																																																					BgL_auxz00_5395
																																																						=
																																																						CDR
																																																						(BgL_expz00_21);
																																																					SET_CAR
																																																						(BgL_auxz00_5395,
																																																						BgL_siz00_2610);
																																																				}
																																																				{	/* Ast/sexp.scm 235 */
																																																					obj_t
																																																						BgL_auxz00_5398;
																																																					BgL_auxz00_5398
																																																						=
																																																						CDR
																																																						(CDR
																																																						(BgL_expz00_21));
																																																					SET_CAR
																																																						(BgL_auxz00_5398,
																																																						BgL_sinonz00_2585);
																																																				}
																																																				{	/* Ast/sexp.scm 236 */
																																																					obj_t
																																																						BgL_auxz00_5402;
																																																					BgL_auxz00_5402
																																																						=
																																																						CDR
																																																						(CDR
																																																						(CDR
																																																							(BgL_expz00_21)));
																																																					SET_CAR
																																																						(BgL_auxz00_5402,
																																																						BgL_alorsz00_2584);
																																																				}
																																																				{

																																																					goto
																																																						BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																			BgL_tagzd27932zd2_2612:
																																																				{	/* Ast/sexp.scm 239 */
																																																					bool_t
																																																						BgL_testz00_5408;
																																																					if (SYMBOLP(BgL_siz00_2583))
																																																						{	/* Ast/sexp.scm 239 */
																																																							BgL_testz00_5408
																																																								=
																																																								(
																																																								(bool_t)
																																																								1);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 239 */
																																																							BgL_testz00_5408
																																																								=
																																																								BGl_isazf3zf3zz__objectz00
																																																								(BgL_siz00_2583,
																																																								BGl_atomz00zzast_nodez00);
																																																						}
																																																					if (BgL_testz00_5408)
																																																						{	/* Ast/sexp.scm 240 */
																																																							obj_t
																																																								BgL_locz00_2641;
																																																							BgL_locz00_2641
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 240 */
																																																								obj_t
																																																									BgL_cdlocz00_2642;
																																																								BgL_cdlocz00_2642
																																																									=
																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																									(CDR
																																																									(BgL_expz00_21),
																																																									BgL_locz00_2641);
																																																								{	/* Ast/sexp.scm 241 */
																																																									obj_t
																																																										BgL_cddlocz00_2643;
																																																									BgL_cddlocz00_2643
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(CDR
																																																										(CDR
																																																											(BgL_expz00_21)),
																																																										BgL_locz00_2641);
																																																									{	/* Ast/sexp.scm 242 */
																																																										obj_t
																																																											BgL_cdddlocz00_2644;
																																																										BgL_cdddlocz00_2644
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(CDR
																																																											(CDR
																																																												(CDR
																																																													(BgL_expz00_21))),
																																																											BgL_locz00_2641);
																																																										{	/* Ast/sexp.scm 243 */
																																																											obj_t
																																																												BgL_lzd2sizd2_2645;
																																																											BgL_lzd2sizd2_2645
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_siz00_2583,
																																																												BgL_cdlocz00_2642);
																																																											{	/* Ast/sexp.scm 244 */
																																																												obj_t
																																																													BgL_lzd2alorszd2_2646;
																																																												BgL_lzd2alorszd2_2646
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_alorsz00_2584,
																																																													BgL_cddlocz00_2643);
																																																												{	/* Ast/sexp.scm 245 */
																																																													obj_t
																																																														BgL_lzd2sinonzd2_2647;
																																																													BgL_lzd2sinonzd2_2647
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(BgL_sinonz00_2585,
																																																														BgL_cdddlocz00_2644);
																																																													{	/* Ast/sexp.scm 246 */
																																																														BgL_nodez00_bglt
																																																															BgL_siz00_2648;
																																																														BgL_siz00_2648
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_siz00_2583,
																																																															BgL_stackz00_22,
																																																															BgL_lzd2sizd2_2645,
																																																															CNST_TABLE_REF
																																																															(((long) 2)));
																																																														{	/* Ast/sexp.scm 247 */
																																																															BgL_nodez00_bglt
																																																																BgL_alorsz00_2649;
																																																															BgL_alorsz00_2649
																																																																=
																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																(BgL_alorsz00_2584,
																																																																BgL_stackz00_22,
																																																																BgL_lzd2alorszd2_2646,
																																																																CNST_TABLE_REF
																																																																(((long) 2)));
																																																															{	/* Ast/sexp.scm 248 */
																																																																BgL_nodez00_bglt
																																																																	BgL_sinonz00_2650;
																																																																BgL_sinonz00_2650
																																																																	=
																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																	(BgL_sinonz00_2585,
																																																																	BgL_stackz00_22,
																																																																	BgL_lzd2sinonzd2_2647,
																																																																	CNST_TABLE_REF
																																																																	(((long) 2)));
																																																																{	/* Ast/sexp.scm 249 */

																																																																	{	/* Ast/sexp.scm 250 */
																																																																		BgL_conditionalz00_bglt
																																																																			BgL_new1122z00_2651;
																																																																		{	/* Ast/sexp.scm 251 */
																																																																			BgL_conditionalz00_bglt
																																																																				BgL_new1120z00_2652;
																																																																			BgL_new1120z00_2652
																																																																				=
																																																																				(
																																																																				(BgL_conditionalz00_bglt)
																																																																				BREF
																																																																				(GC_MALLOC
																																																																					(sizeof
																																																																						(struct
																																																																							BgL_conditionalz00_bgl))));
																																																																			{	/* Ast/sexp.scm 251 */
																																																																				long
																																																																					BgL_arg2300z00_2653;
																																																																				{	/* Ast/sexp.scm 251 */
																																																																					long
																																																																						BgL_res2900z00_3669;
																																																																					BgL_res2900z00_3669
																																																																						=
																																																																						BGL_CLASS_INDEX
																																																																						(BGl_conditionalz00zzast_nodez00);
																																																																					BgL_arg2300z00_2653
																																																																						=
																																																																						BgL_res2900z00_3669;
																																																																				}
																																																																				BGL_OBJECT_CLASS_NUM_SET
																																																																					(
																																																																					((BgL_objectz00_bglt) BgL_new1120z00_2652), BgL_arg2300z00_2653);
																																																																			}
																																																																			{	/* Ast/sexp.scm 251 */
																																																																				BgL_objectz00_bglt
																																																																					BgL_auxz00_5435;
																																																																				BgL_auxz00_5435
																																																																					=
																																																																					(
																																																																					(BgL_objectz00_bglt)
																																																																					BgL_new1120z00_2652);
																																																																				BGL_OBJECT_WIDENING_SET
																																																																					(BgL_auxz00_5435,
																																																																					BFALSE);
																																																																			}
																																																																			BgL_new1122z00_2651
																																																																				=
																																																																				BgL_new1120z00_2652;
																																																																		}
																																																																		((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1122z00_2651)))->BgL_locz00) = ((obj_t) BgL_locz00_2641), BUNSPEC);
																																																																		((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1122z00_2651)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																		((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt) BgL_new1122z00_2651)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																		((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt) BgL_new1122z00_2651)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																		((((BgL_conditionalz00_bglt) CREF(BgL_new1122z00_2651))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_siz00_2648), BUNSPEC);
																																																																		((((BgL_conditionalz00_bglt) CREF(BgL_new1122z00_2651))->BgL_truez00) = ((BgL_nodez00_bglt) BgL_alorsz00_2649), BUNSPEC);
																																																																		((((BgL_conditionalz00_bglt) CREF(BgL_new1122z00_2651))->BgL_falsez00) = ((BgL_nodez00_bglt) BgL_sinonz00_2650), BUNSPEC);
																																																																		return
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BgL_new1122z00_2651);
																																																																	}
																																																																}
																																																															}
																																																														}
																																																													}
																																																												}
																																																											}
																																																										}
																																																									}
																																																								}
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 256 */
																																																							obj_t
																																																								BgL_vz00_2657;
																																																							BgL_vz00_2657
																																																								=
																																																								BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																								(BGl_gensymz00zz__r4_symbols_6_4z00
																																																								(CNST_TABLE_REF
																																																									(((long) 8))));
																																																							{	/* Ast/sexp.scm 256 */
																																																								obj_t
																																																									BgL_varz00_2658;
																																																								BgL_varz00_2658
																																																									=
																																																									BGl_makezd2typedzd2identz00zzast_identz00
																																																									(BgL_vz00_2657,
																																																									CNST_TABLE_REF
																																																									(((long) 9)));
																																																								{	/* Ast/sexp.scm 257 */
																																																									obj_t
																																																										BgL_nexpz00_2659;
																																																									{	/* Ast/sexp.scm 258 */
																																																										obj_t
																																																											BgL_arg2311z00_2667;
																																																										{	/* Ast/sexp.scm 258 */
																																																											obj_t
																																																												BgL_arg2312z00_2668;
																																																											{	/* Ast/sexp.scm 258 */
																																																												obj_t
																																																													BgL_arg2313z00_2669;
																																																												{	/* Ast/sexp.scm 258 */
																																																													obj_t
																																																														BgL_arg2314z00_2670;
																																																													BgL_arg2314z00_2670
																																																														=
																																																														MAKE_PAIR
																																																														(BgL_sinonz00_2585,
																																																														BNIL);
																																																													BgL_arg2313z00_2669
																																																														=
																																																														MAKE_PAIR
																																																														(BgL_alorsz00_2584,
																																																														BgL_arg2314z00_2670);
																																																												}
																																																												BgL_arg2312z00_2668
																																																													=
																																																													MAKE_PAIR
																																																													(BgL_vz00_2657,
																																																													BgL_arg2313z00_2669);
																																																											}
																																																											BgL_arg2311z00_2667
																																																												=
																																																												MAKE_PAIR
																																																												(CNST_TABLE_REF
																																																												(((long) 1)), BgL_arg2312z00_2668);
																																																										}
																																																										BgL_nexpz00_2659
																																																											=
																																																											BGl_epairifyzd2reczd2zztools_miscz00
																																																											(BgL_arg2311z00_2667,
																																																											BgL_expz00_21);
																																																									}
																																																									{	/* Ast/sexp.scm 258 */

																																																										{	/* Ast/sexp.scm 259 */
																																																											obj_t
																																																												BgL_arg2304z00_2660;
																																																											{	/* Ast/sexp.scm 259 */
																																																												obj_t
																																																													BgL_arg2305z00_2661;
																																																												obj_t
																																																													BgL_arg2306z00_2662;
																																																												BgL_arg2305z00_2661
																																																													=
																																																													BGl_letzd2symzd2zzast_letz00
																																																													();
																																																												{	/* Ast/sexp.scm 259 */
																																																													obj_t
																																																														BgL_arg2307z00_2663;
																																																													obj_t
																																																														BgL_arg2308z00_2664;
																																																													{	/* Ast/sexp.scm 259 */
																																																														obj_t
																																																															BgL_arg2309z00_2665;
																																																														{	/* Ast/sexp.scm 259 */
																																																															obj_t
																																																																BgL_arg2310z00_2666;
																																																															BgL_arg2310z00_2666
																																																																=
																																																																MAKE_PAIR
																																																																(BgL_siz00_2583,
																																																																BNIL);
																																																															BgL_arg2309z00_2665
																																																																=
																																																																MAKE_PAIR
																																																																(BgL_varz00_2658,
																																																																BgL_arg2310z00_2666);
																																																														}
																																																														BgL_arg2307z00_2663
																																																															=
																																																															MAKE_PAIR
																																																															(BgL_arg2309z00_2665,
																																																															BNIL);
																																																													}
																																																													BgL_arg2308z00_2664
																																																														=
																																																														MAKE_PAIR
																																																														(BgL_nexpz00_2659,
																																																														BNIL);
																																																													BgL_arg2306z00_2662
																																																														=
																																																														MAKE_PAIR
																																																														(BgL_arg2307z00_2663,
																																																														BgL_arg2308z00_2664);
																																																												}
																																																												BgL_arg2304z00_2660
																																																													=
																																																													MAKE_PAIR
																																																													(BgL_arg2305z00_2661,
																																																													BgL_arg2306z00_2662);
																																																											}
																																																											BGl_replacez12z12zztools_miscz00
																																																												(BgL_expz00_21,
																																																												BgL_arg2304z00_2660);
																																																										}
																																																										{

																																																											goto
																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																																										}
																																																									}
																																																								}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 115 */
																																																		goto
																																																			BgL_tagzd27932zd2_2612;
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 115 */
																																																goto
																																																	BgL_tagzd27932zd2_2612;
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 115 */
																																														goto
																																															BgL_tagzd27932zd2_2612;
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 115 */
																																												goto
																																													BgL_tagzd27932zd2_2612;
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 115 */
																																										goto
																																											BgL_tagzd27932zd2_2612;
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 115 */
																																								if ((CAR(BgL_siz00_2583) == CNST_TABLE_REF(((long) 10))))
																																									{	/* Ast/sexp.scm 115 */
																																										if (PAIRP(BgL_cdrzd27939zd2_2615))
																																											{	/* Ast/sexp.scm 115 */
																																												if (NULLP(CDR(BgL_cdrzd27939zd2_2615)))
																																													{
																																														obj_t
																																															BgL_siz00_5480;
																																														BgL_siz00_5480
																																															=
																																															CAR
																																															(BgL_cdrzd27939zd2_2615);
																																														BgL_siz00_2610
																																															=
																																															BgL_siz00_5480;
																																														goto
																																															BgL_tagzd27931zd2_2611;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 115 */
																																														goto
																																															BgL_tagzd27932zd2_2612;
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 115 */
																																												goto
																																													BgL_tagzd27932zd2_2612;
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 115 */
																																										goto
																																											BgL_tagzd27932zd2_2612;
																																									}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 115 */
																																						goto
																																							BgL_tagzd27932zd2_2612;
																																					}
																																			}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 115 */
																																		BgL_tagzd27865zd2_2590:
																																			{	/* Ast/sexp.scm 265 */
																																				BgL_nodez00_bglt
																																					BgL_res2909z00_3713;
																																				{	/* Ast/sexp.scm 670 */
																																					obj_t
																																						BgL_arg2660z00_3709;
																																					BgL_nodez00_bglt
																																						BgL_arg2661z00_3710;
																																					BgL_arg2660z00_3709
																																						=
																																						BGl_shapez00zztools_shapez00
																																						(BGl_currentzd2functionzd2zztools_errorz00
																																						());
																																					BgL_arg2661z00_3710
																																						=
																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																						(CNST_TABLE_REF
																																						(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																					{	/* Ast/sexp.scm 669 */
																																						obj_t
																																							BgL_list2662z00_3712;
																																						BgL_list2662z00_3712
																																							=
																																							MAKE_PAIR
																																							(((obj_t) BgL_arg2661z00_3710), BNIL);
																																						BgL_res2909z00_3713
																																							=
																																							(
																																							(BgL_nodez00_bglt)
																																							BGl_userzd2errorzf2locationz20zztools_errorz00
																																							(BgL_locz00_23,
																																								BgL_arg2660z00_3709,
																																								BGl_string3133z00zzast_sexpz00,
																																								BgL_expz00_21,
																																								BgL_list2662z00_3712));
																																				}}
																																				return
																																					BgL_res2909z00_3713;
																																			}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 115 */
																																	obj_t
																																		BgL_cdrzd27909zd2_2605;
																																	BgL_cdrzd27909zd2_2605
																																		=
																																		CDR
																																		(BgL_cdrzd27874zd2_2593);
																																	if (NULLP(CDR
																																			(BgL_cdrzd27909zd2_2605)))
																																		{	/* Ast/sexp.scm 115 */
																																			BgL_siz00_2587
																																				=
																																				CAR
																																				(BgL_cdrzd27874zd2_2593);
																																			BgL_alorsz00_2588
																																				=
																																				CAR
																																				(BgL_cdrzd27909zd2_2605);
																																			{	/* Ast/sexp.scm 262 */
																																				obj_t
																																					BgL_arg2317z00_2673;
																																				obj_t
																																					BgL_arg2318z00_2674;
																																				BgL_arg2317z00_2673
																																					=
																																					CDR
																																					(CDR
																																					(BgL_expz00_21));
																																				{	/* Ast/sexp.scm 262 */
																																					obj_t
																																						BgL_list2319z00_2675;
																																					BgL_list2319z00_2675
																																						=
																																						MAKE_PAIR
																																						(BUNSPEC,
																																						BNIL);
																																					BgL_arg2318z00_2674
																																						=
																																						BgL_list2319z00_2675;
																																				}
																																				SET_CDR
																																					(BgL_arg2317z00_2673,
																																					BgL_arg2318z00_2674);
																																			}
																																			{

																																				goto
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																			}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 115 */
																																			goto
																																				BgL_tagzd27865zd2_2590;
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 115 */
																															goto
																																BgL_tagzd27865zd2_2590;
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 115 */
																													goto
																														BgL_tagzd27865zd2_2590;
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 115 */
																											goto
																												BgL_tagzd27865zd2_2590;
																										}
																								}
																							}
																						else
																							{	/* Ast/sexp.scm 115 */
																								if (
																									(BgL_carzd2584zd2_1684 ==
																										BGl_za2ifza2z00zzast_sexpz00))
																									{	/* Ast/sexp.scm 115 */
																										goto BgL_tagzd2376zd2_1614;
																									}
																								else
																									{	/* Ast/sexp.scm 115 */
																										obj_t BgL_cdrzd2604zd2_1687;

																										BgL_cdrzd2604zd2_1687 =
																											CDR(BgL_expz00_21);
																										if (
																											(CAR(BgL_expz00_21) ==
																												CNST_TABLE_REF(((long)
																														7))))
																											{	/* Ast/sexp.scm 115 */
																												if (PAIRP
																													(BgL_cdrzd2604zd2_1687))
																													{	/* Ast/sexp.scm 115 */
																														obj_t
																															BgL_carzd2607zd2_1690;
																														obj_t
																															BgL_cdrzd2608zd2_1691;
																														BgL_carzd2607zd2_1690
																															=
																															CAR
																															(BgL_cdrzd2604zd2_1687);
																														BgL_cdrzd2608zd2_1691
																															=
																															CDR
																															(BgL_cdrzd2604zd2_1687);
																														if (PAIRP
																															(BgL_carzd2607zd2_1690))
																															{	/* Ast/sexp.scm 115 */
																																if (
																																	(CAR
																																		(BgL_carzd2607zd2_1690)
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				15))))
																																	{	/* Ast/sexp.scm 115 */
																																		if (PAIRP
																																			(BgL_cdrzd2608zd2_1691))
																																			{	/* Ast/sexp.scm 115 */
																																				if (NULLP(CDR(BgL_cdrzd2608zd2_1691)))
																																					{	/* Ast/sexp.scm 115 */
																																						BgL_lz00_1615
																																							=
																																							CDR
																																							(BgL_carzd2607zd2_1690);
																																						BgL_valz00_1616
																																							=
																																							CAR
																																							(BgL_cdrzd2608zd2_1691);
																																					BgL_tagzd2377zd2_1617:
																																						{	/* Ast/sexp.scm 268 */
																																							bool_t
																																								BgL_testz00_5526;
																																							if (PAIRP(BgL_lz00_1615))
																																								{	/* Ast/sexp.scm 268 */
																																									bool_t
																																										BgL_testz00_5529;
																																									{	/* Ast/sexp.scm 268 */
																																										obj_t
																																											BgL_auxz00_5530;
																																										BgL_auxz00_5530
																																											=
																																											CDR
																																											(BgL_lz00_1615);
																																										BgL_testz00_5529
																																											=
																																											PAIRP
																																											(BgL_auxz00_5530);
																																									}
																																									if (BgL_testz00_5529)
																																										{
																																											obj_t
																																												BgL_l1333z00_2680;
																																											BgL_l1333z00_2680
																																												=
																																												BgL_lz00_1615;
																																										BgL_zc3anonymousza32323ze3z83_2681:
																																											if (NULLP(BgL_l1333z00_2680))
																																												{	/* Ast/sexp.scm 268 */
																																													BgL_testz00_5526
																																														=
																																														(
																																														(bool_t)
																																														1);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 268 */
																																													bool_t
																																														BgL_testz00_5535;
																																													{	/* Ast/sexp.scm 268 */
																																														obj_t
																																															BgL_auxz00_5536;
																																														BgL_auxz00_5536
																																															=
																																															CAR
																																															(BgL_l1333z00_2680);
																																														BgL_testz00_5535
																																															=
																																															SYMBOLP
																																															(BgL_auxz00_5536);
																																													}
																																													if (BgL_testz00_5535)
																																														{
																																															obj_t
																																																BgL_l1333z00_5539;
																																															BgL_l1333z00_5539
																																																=
																																																CDR
																																																(BgL_l1333z00_2680);
																																															BgL_l1333z00_2680
																																																=
																																																BgL_l1333z00_5539;
																																															goto
																																																BgL_zc3anonymousza32323ze3z83_2681;
																																														}
																																													else
																																														{	/* Ast/sexp.scm 268 */
																																															BgL_testz00_5526
																																																=
																																																(
																																																(bool_t)
																																																0);
																																														}
																																												}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 268 */
																																											BgL_testz00_5526
																																												=
																																												(
																																												(bool_t)
																																												0);
																																										}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 268 */
																																									BgL_testz00_5526
																																										=
																																										(
																																										(bool_t)
																																										0);
																																								}
																																							if (BgL_testz00_5526)
																																								{	/* Ast/sexp.scm 268 */
																																									return
																																										BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00
																																										(BgL_lz00_1615,
																																										BgL_valz00_1616,
																																										BgL_expz00_21,
																																										BgL_stackz00_22,
																																										BgL_locz00_23,
																																										BgL_sitez00_24);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 270 */
																																									BgL_nodez00_bglt
																																										BgL_res2920z00_3756;
																																									{	/* Ast/sexp.scm 670 */
																																										obj_t
																																											BgL_arg2660z00_3752;
																																										BgL_nodez00_bglt
																																											BgL_arg2661z00_3753;
																																										BgL_arg2660z00_3752
																																											=
																																											BGl_shapez00zztools_shapez00
																																											(BGl_currentzd2functionzd2zztools_errorz00
																																											());
																																										BgL_arg2661z00_3753
																																											=
																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																											(CNST_TABLE_REF
																																											(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																										{	/* Ast/sexp.scm 669 */
																																											obj_t
																																												BgL_list2662z00_3755;
																																											BgL_list2662z00_3755
																																												=
																																												MAKE_PAIR
																																												(
																																												((obj_t) BgL_arg2661z00_3753), BNIL);
																																											BgL_res2920z00_3756
																																												=
																																												(
																																												(BgL_nodez00_bglt)
																																												BGl_userzd2errorzf2locationz20zztools_errorz00
																																												(BgL_locz00_23,
																																													BgL_arg2660z00_3752,
																																													BGl_string3132z00zzast_sexpz00,
																																													BgL_expz00_21,
																																													BgL_list2662z00_3755));
																																									}}
																																									return
																																										BgL_res2920z00_3756;
																																								}
																																						}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 115 */
																																					BgL_tagzd2378zd2_1618:
																																						{
																																							obj_t
																																								BgL_varz00_2689;
																																							obj_t
																																								BgL_valz00_2690;
																																							if (PAIRP(BgL_expz00_21))
																																								{	/* Ast/sexp.scm 115 */
																																									obj_t
																																										BgL_cdrzd27970zd2_2695;
																																									BgL_cdrzd27970zd2_2695
																																										=
																																										CDR
																																										(BgL_expz00_21);
																																									if (PAIRP(BgL_cdrzd27970zd2_2695))
																																										{	/* Ast/sexp.scm 115 */
																																											obj_t
																																												BgL_cdrzd27974zd2_2697;
																																											BgL_cdrzd27974zd2_2697
																																												=
																																												CDR
																																												(BgL_cdrzd27970zd2_2695);
																																											if (PAIRP(BgL_cdrzd27974zd2_2697))
																																												{	/* Ast/sexp.scm 115 */
																																													if (NULLP(CDR(BgL_cdrzd27974zd2_2697)))
																																														{	/* Ast/sexp.scm 115 */
																																															BgL_varz00_2689
																																																=
																																																CAR
																																																(BgL_cdrzd27970zd2_2695);
																																															BgL_valz00_2690
																																																=
																																																CAR
																																																(BgL_cdrzd27974zd2_2697);
																																															{	/* Ast/sexp.scm 274 */
																																																obj_t
																																																	BgL_locz00_2703;
																																																BgL_locz00_2703
																																																	=
																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																	(BgL_expz00_21,
																																																	BgL_locz00_23);
																																																{	/* Ast/sexp.scm 274 */
																																																	obj_t
																																																		BgL_cdlocz00_2704;
																																																	BgL_cdlocz00_2704
																																																		=
																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																		(CDR
																																																		(BgL_expz00_21),
																																																		BgL_locz00_2703);
																																																	{	/* Ast/sexp.scm 275 */
																																																		obj_t
																																																			BgL_cddlocz00_2705;
																																																		BgL_cddlocz00_2705
																																																			=
																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																			(CDR
																																																			(CDR
																																																				(BgL_expz00_21)),
																																																			BgL_locz00_2703);
																																																		{	/* Ast/sexp.scm 276 */
																																																			obj_t
																																																				BgL_valzd2loczd2_2706;
																																																			BgL_valzd2loczd2_2706
																																																				=
																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																				(BgL_valz00_2690,
																																																				BgL_cddlocz00_2705);
																																																			{	/* Ast/sexp.scm 277 */
																																																				BgL_nodez00_bglt
																																																					BgL_valz00_2707;
																																																				BgL_valz00_2707
																																																					=
																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																					(BgL_valz00_2690,
																																																					BgL_stackz00_22,
																																																					BgL_valzd2loczd2_2706,
																																																					CNST_TABLE_REF
																																																					(((long) 2)));
																																																				{	/* Ast/sexp.scm 278 */

																																																					{	/* Ast/sexp.scm 279 */
																																																						BgL_nodez00_bglt
																																																							BgL_astz00_2708;
																																																						BgL_astz00_2708
																																																							=
																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																							(BgL_varz00_2689,
																																																							BgL_stackz00_22,
																																																							BgL_cdlocz00_2704,
																																																							CNST_TABLE_REF
																																																							(((long) 7)));
																																																						{	/* Ast/sexp.scm 280 */
																																																							bool_t
																																																								BgL_testz00_5575;
																																																							{	/* Ast/sexp.scm 280 */
																																																								bool_t
																																																									BgL_res2921z00_3763;
																																																								BgL_res2921z00_3763
																																																									=
																																																									BGl_isazf3zf3zz__objectz00
																																																									(
																																																									((obj_t) BgL_astz00_2708), BGl_varz00zzast_nodez00);
																																																								BgL_testz00_5575
																																																									=
																																																									BgL_res2921z00_3763;
																																																							}
																																																							if (BgL_testz00_5575)
																																																								{	/* Ast/sexp.scm 282 */
																																																									bool_t
																																																										BgL_testz00_5578;
																																																									{	/* Ast/sexp.scm 282 */
																																																										bool_t
																																																											BgL_testz00_5579;
																																																										{	/* Ast/sexp.scm 282 */
																																																											BgL_variablez00_bglt
																																																												BgL_arg2340z00_2717;
																																																											BgL_arg2340z00_2717
																																																												=
																																																												(
																																																												((BgL_varz00_bglt) CREF(((BgL_varz00_bglt) BgL_astz00_2708)))->BgL_variablez00);
																																																											{	/* Ast/sexp.scm 282 */
																																																												bool_t
																																																													BgL_res2922z00_3765;
																																																												BgL_res2922z00_3765
																																																													=
																																																													BGl_isazf3zf3zz__objectz00
																																																													(
																																																													((obj_t) BgL_arg2340z00_2717), BGl_globalz00zzast_varz00);
																																																												BgL_testz00_5579
																																																													=
																																																													BgL_res2922z00_3765;
																																																											}
																																																										}
																																																										if (BgL_testz00_5579)
																																																											{	/* Ast/sexp.scm 283 */
																																																												BgL_variablez00_bglt
																																																													BgL_arg2339z00_2716;
																																																												BgL_arg2339z00_2716
																																																													=
																																																													(
																																																													((BgL_varz00_bglt) CREF(((BgL_varz00_bglt) BgL_astz00_2708)))->BgL_variablez00);
																																																												BgL_testz00_5578
																																																													=
																																																													BGl_globalzd2readzd2onlyzf3zf3zzast_varz00
																																																													(
																																																													((BgL_globalz00_bglt) BgL_arg2339z00_2716));
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 282 */
																																																												BgL_testz00_5578
																																																													=
																																																													(
																																																													(bool_t)
																																																													0);
																																																											}
																																																									}
																																																									if (BgL_testz00_5578)
																																																										{	/* Ast/sexp.scm 284 */
																																																											BgL_nodez00_bglt
																																																												BgL_res2923z00_3773;
																																																											{	/* Ast/sexp.scm 670 */
																																																												obj_t
																																																													BgL_arg2660z00_3769;
																																																												BgL_nodez00_bglt
																																																													BgL_arg2661z00_3770;
																																																												BgL_arg2660z00_3769
																																																													=
																																																													BGl_shapez00zztools_shapez00
																																																													(BGl_currentzd2functionzd2zztools_errorz00
																																																													());
																																																												BgL_arg2661z00_3770
																																																													=
																																																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																													(CNST_TABLE_REF
																																																													(((long) 4)), BNIL, BgL_cdlocz00_2704, CNST_TABLE_REF(((long) 2)));
																																																												{	/* Ast/sexp.scm 669 */
																																																													obj_t
																																																														BgL_list2662z00_3772;
																																																													BgL_list2662z00_3772
																																																														=
																																																														MAKE_PAIR
																																																														(
																																																														((obj_t) BgL_arg2661z00_3770), BNIL);
																																																													BgL_res2923z00_3773
																																																														=
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BGl_userzd2errorzf2locationz20zztools_errorz00
																																																														(BgL_cdlocz00_2704,
																																																															BgL_arg2660z00_3769,
																																																															BGl_string3130z00zzast_sexpz00,
																																																															BgL_expz00_21,
																																																															BgL_list2662z00_3772));
																																																											}}
																																																											return
																																																												BgL_res2923z00_3773;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 286 */
																																																											BgL_setqz00_bglt
																																																												BgL_new1125z00_2712;
																																																											{	/* Ast/sexp.scm 287 */
																																																												BgL_setqz00_bglt
																																																													BgL_new1124z00_2713;
																																																												BgL_new1124z00_2713
																																																													=
																																																													(
																																																													(BgL_setqz00_bglt)
																																																													BREF
																																																													(GC_MALLOC
																																																														(sizeof
																																																															(struct
																																																																BgL_setqz00_bgl))));
																																																												{	/* Ast/sexp.scm 287 */
																																																													long
																																																														BgL_arg2337z00_2714;
																																																													{	/* Ast/sexp.scm 287 */
																																																														long
																																																															BgL_res2924z00_3775;
																																																														BgL_res2924z00_3775
																																																															=
																																																															BGL_CLASS_INDEX
																																																															(BGl_setqz00zzast_nodez00);
																																																														BgL_arg2337z00_2714
																																																															=
																																																															BgL_res2924z00_3775;
																																																													}
																																																													BGL_OBJECT_CLASS_NUM_SET
																																																														(
																																																														((BgL_objectz00_bglt) BgL_new1124z00_2713), BgL_arg2337z00_2714);
																																																												}
																																																												{	/* Ast/sexp.scm 287 */
																																																													BgL_objectz00_bglt
																																																														BgL_auxz00_5601;
																																																													BgL_auxz00_5601
																																																														=
																																																														(
																																																														(BgL_objectz00_bglt)
																																																														BgL_new1124z00_2713);
																																																													BGL_OBJECT_WIDENING_SET
																																																														(BgL_auxz00_5601,
																																																														BFALSE);
																																																												}
																																																												BgL_new1125z00_2712
																																																													=
																																																													BgL_new1124z00_2713;
																																																											}
																																																											((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1125z00_2712)))->BgL_locz00) = ((obj_t) BgL_locz00_2703), BUNSPEC);
																																																											((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1125z00_2712)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																											((((BgL_setqz00_bglt) CREF(BgL_new1125z00_2712))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_2708)), BUNSPEC);
																																																											((((BgL_setqz00_bglt) CREF(BgL_new1125z00_2712))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_2707), BUNSPEC);
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_new1125z00_2712);
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 291 */
																																																									BgL_nodez00_bglt
																																																										BgL_res2925z00_3785;
																																																									{	/* Ast/sexp.scm 670 */
																																																										obj_t
																																																											BgL_arg2660z00_3781;
																																																										BgL_nodez00_bglt
																																																											BgL_arg2661z00_3782;
																																																										BgL_arg2660z00_3781
																																																											=
																																																											BGl_shapez00zztools_shapez00
																																																											(BGl_currentzd2functionzd2zztools_errorz00
																																																											());
																																																										BgL_arg2661z00_3782
																																																											=
																																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																											(CNST_TABLE_REF
																																																											(((long) 4)), BNIL, BgL_locz00_2703, CNST_TABLE_REF(((long) 2)));
																																																										{	/* Ast/sexp.scm 669 */
																																																											obj_t
																																																												BgL_list2662z00_3784;
																																																											BgL_list2662z00_3784
																																																												=
																																																												MAKE_PAIR
																																																												(
																																																												((obj_t) BgL_arg2661z00_3782), BNIL);
																																																											BgL_res2925z00_3785
																																																												=
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BGl_userzd2errorzf2locationz20zztools_errorz00
																																																												(BgL_locz00_2703,
																																																													BgL_arg2660z00_3781,
																																																													BGl_string3131z00zzast_sexpz00,
																																																													BgL_expz00_21,
																																																													BgL_list2662z00_3784));
																																																									}}
																																																									return
																																																										BgL_res2925z00_3785;
																																																								}
																																																						}
																																																					}
																																																				}
																																																			}
																																																		}
																																																	}
																																																}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 115 */
																																														BgL_tagzd27963zd2_2692:
																																															{	/* Ast/sexp.scm 295 */
																																																obj_t
																																																	BgL_arg2343z00_2720;
																																																BgL_arg2343z00_2720
																																																	=
																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																	(BgL_expz00_21,
																																																	BgL_locz00_23);
																																																{	/* Ast/sexp.scm 294 */
																																																	BgL_nodez00_bglt
																																																		BgL_res2926z00_3793;
																																																	{	/* Ast/sexp.scm 670 */
																																																		obj_t
																																																			BgL_arg2660z00_3789;
																																																		BgL_nodez00_bglt
																																																			BgL_arg2661z00_3790;
																																																		BgL_arg2660z00_3789
																																																			=
																																																			BGl_shapez00zztools_shapez00
																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																			());
																																																		BgL_arg2661z00_3790
																																																			=
																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																			(CNST_TABLE_REF
																																																			(((long) 4)), BNIL, BgL_arg2343z00_2720, CNST_TABLE_REF(((long) 2)));
																																																		{	/* Ast/sexp.scm 669 */
																																																			obj_t
																																																				BgL_list2662z00_3792;
																																																			BgL_list2662z00_3792
																																																				=
																																																				MAKE_PAIR
																																																				(
																																																				((obj_t) BgL_arg2661z00_3790), BNIL);
																																																			BgL_res2926z00_3793
																																																				=
																																																				(
																																																				(BgL_nodez00_bglt)
																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																				(BgL_arg2343z00_2720,
																																																					BgL_arg2660z00_3789,
																																																					BGl_string3129z00zzast_sexpz00,
																																																					BgL_expz00_21,
																																																					BgL_list2662z00_3792));
																																																	}}
																																																	return
																																																		BgL_res2926z00_3793;
																																																}
																																															}
																																														}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 115 */
																																													goto
																																														BgL_tagzd27963zd2_2692;
																																												}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 115 */
																																											goto
																																												BgL_tagzd27963zd2_2692;
																																										}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 115 */
																																									goto
																																										BgL_tagzd27963zd2_2692;
																																								}
																																						}
																																					}
																																			}
																																		else
																																			{	/* Ast/sexp.scm 115 */
																																				goto
																																					BgL_tagzd2378zd2_1618;
																																			}
																																	}
																																else
																																	{	/* Ast/sexp.scm 115 */
																																		goto
																																			BgL_tagzd2378zd2_1618;
																																	}
																															}
																														else
																															{	/* Ast/sexp.scm 115 */
																																goto
																																	BgL_tagzd2378zd2_1618;
																															}
																													}
																												else
																													{	/* Ast/sexp.scm 115 */
																														goto
																															BgL_tagzd2378zd2_1618;
																													}
																											}
																										else
																											{	/* Ast/sexp.scm 115 */
																												if (
																													(CAR(BgL_expz00_21) ==
																														CNST_TABLE_REF((
																																(long) 17))))
																													{	/* Ast/sexp.scm 115 */
																													BgL_tagzd2379zd2_1619:
																														{
																															obj_t
																																BgL_varz00_2721;
																															obj_t
																																BgL_valz00_2722;
																															if (PAIRP
																																(BgL_expz00_21))
																																{	/* Ast/sexp.scm 115 */
																																	obj_t
																																		BgL_cdrzd27988zd2_2727;
																																	BgL_cdrzd27988zd2_2727
																																		=
																																		CDR
																																		(BgL_expz00_21);
																																	if (PAIRP
																																		(BgL_cdrzd27988zd2_2727))
																																		{	/* Ast/sexp.scm 115 */
																																			obj_t
																																				BgL_cdrzd27992zd2_2729;
																																			BgL_cdrzd27992zd2_2729
																																				=
																																				CDR
																																				(BgL_cdrzd27988zd2_2727);
																																			if (PAIRP
																																				(BgL_cdrzd27992zd2_2729))
																																				{	/* Ast/sexp.scm 115 */
																																					if (NULLP(CDR(BgL_cdrzd27992zd2_2729)))
																																						{	/* Ast/sexp.scm 115 */
																																							BgL_varz00_2721
																																								=
																																								CAR
																																								(BgL_cdrzd27988zd2_2727);
																																							BgL_valz00_2722
																																								=
																																								CAR
																																								(BgL_cdrzd27992zd2_2729);
																																							{	/* Ast/sexp.scm 302 */
																																								obj_t
																																									BgL_locz00_2735;
																																								BgL_locz00_2735
																																									=
																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																									(BgL_expz00_21,
																																									BgL_locz00_23);
																																								{	/* Ast/sexp.scm 302 */
																																									obj_t
																																										BgL_cdlocz00_2736;
																																									BgL_cdlocz00_2736
																																										=
																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																										(CDR
																																										(BgL_expz00_21),
																																										BgL_locz00_2735);
																																									{	/* Ast/sexp.scm 303 */
																																										obj_t
																																											BgL_cddlocz00_2737;
																																										BgL_cddlocz00_2737
																																											=
																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																											(CDR
																																											(CDR
																																												(BgL_expz00_21)),
																																											BgL_locz00_2735);
																																										{	/* Ast/sexp.scm 304 */
																																											obj_t
																																												BgL_valzd2loczd2_2738;
																																											BgL_valzd2loczd2_2738
																																												=
																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																												(BgL_valz00_2722,
																																												BgL_cddlocz00_2737);
																																											{	/* Ast/sexp.scm 305 */
																																												BgL_nodez00_bglt
																																													BgL_valz00_2739;
																																												BgL_valz00_2739
																																													=
																																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																																													(BgL_valz00_2722,
																																													BgL_stackz00_22,
																																													BgL_valzd2loczd2_2738,
																																													CNST_TABLE_REF
																																													(((long) 2)));
																																												{	/* Ast/sexp.scm 306 */

																																													{	/* Ast/sexp.scm 307 */
																																														BgL_nodez00_bglt
																																															BgL_astz00_2740;
																																														BgL_astz00_2740
																																															=
																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																															(BgL_varz00_2721,
																																															BgL_stackz00_22,
																																															BgL_cdlocz00_2736,
																																															CNST_TABLE_REF
																																															(((long) 2)));
																																														{	/* Ast/sexp.scm 308 */
																																															bool_t
																																																BgL_testz00_5660;
																																															{	/* Ast/sexp.scm 308 */
																																																bool_t
																																																	BgL_testz00_5661;
																																																{	/* Ast/sexp.scm 308 */
																																																	bool_t
																																																		BgL_res2931z00_3813;
																																																	BgL_res2931z00_3813
																																																		=
																																																		BGl_isazf3zf3zz__objectz00
																																																		(
																																																		((obj_t) BgL_astz00_2740), BGl_varz00zzast_nodez00);
																																																	BgL_testz00_5661
																																																		=
																																																		BgL_res2931z00_3813;
																																																}
																																																if (BgL_testz00_5661)
																																																	{	/* Ast/sexp.scm 308 */
																																																		BgL_variablez00_bglt
																																																			BgL_arg2357z00_2747;
																																																		BgL_arg2357z00_2747
																																																			=
																																																			(
																																																			((BgL_varz00_bglt) CREF(((BgL_varz00_bglt) BgL_astz00_2740)))->BgL_variablez00);
																																																		{	/* Ast/sexp.scm 308 */
																																																			bool_t
																																																				BgL_res2932z00_3816;
																																																			BgL_res2932z00_3816
																																																				=
																																																				BGl_isazf3zf3zz__objectz00
																																																				(
																																																				((obj_t) BgL_arg2357z00_2747), BGl_globalz00zzast_varz00);
																																																			BgL_testz00_5660
																																																				=
																																																				BgL_res2932z00_3816;
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 308 */
																																																		BgL_testz00_5660
																																																			=
																																																			(
																																																			(bool_t)
																																																			0);
																																																	}
																																															}
																																															if (BgL_testz00_5660)
																																																{	/* Ast/sexp.scm 308 */
																																																	{	/* Ast/sexp.scm 310 */
																																																		BgL_variablez00_bglt
																																																			BgL_arg2353z00_2742;
																																																		BgL_arg2353z00_2742
																																																			=
																																																			(
																																																			((BgL_varz00_bglt) CREF(((BgL_varz00_bglt) BgL_astz00_2740)))->BgL_variablez00);
																																																		((((BgL_globalz00_bglt) CREF(((BgL_globalz00_bglt) BgL_arg2353z00_2742)))->BgL_srcz00) = ((obj_t) ((obj_t) BgL_valz00_2739)), BUNSPEC);
																																																	}
																																																	{	/* Ast/sexp.scm 311 */
																																																		BgL_setqz00_bglt
																																																			BgL_new1128z00_2743;
																																																		{	/* Ast/sexp.scm 312 */
																																																			BgL_setqz00_bglt
																																																				BgL_new1126z00_2744;
																																																			BgL_new1126z00_2744
																																																				=
																																																				(
																																																				(BgL_setqz00_bglt)
																																																				BREF
																																																				(GC_MALLOC
																																																					(sizeof
																																																						(struct
																																																							BgL_setqz00_bgl))));
																																																			{	/* Ast/sexp.scm 312 */
																																																				long
																																																					BgL_arg2355z00_2745;
																																																				{	/* Ast/sexp.scm 312 */
																																																					long
																																																						BgL_res2933z00_3821;
																																																					BgL_res2933z00_3821
																																																						=
																																																						BGL_CLASS_INDEX
																																																						(BGl_setqz00zzast_nodez00);
																																																					BgL_arg2355z00_2745
																																																						=
																																																						BgL_res2933z00_3821;
																																																				}
																																																				BGL_OBJECT_CLASS_NUM_SET
																																																					(
																																																					((BgL_objectz00_bglt) BgL_new1126z00_2744), BgL_arg2355z00_2745);
																																																			}
																																																			{	/* Ast/sexp.scm 312 */
																																																				BgL_objectz00_bglt
																																																					BgL_auxz00_5677;
																																																				BgL_auxz00_5677
																																																					=
																																																					(
																																																					(BgL_objectz00_bglt)
																																																					BgL_new1126z00_2744);
																																																				BGL_OBJECT_WIDENING_SET
																																																					(BgL_auxz00_5677,
																																																					BFALSE);
																																																			}
																																																			BgL_new1128z00_2743
																																																				=
																																																				BgL_new1126z00_2744;
																																																		}
																																																		((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1128z00_2743)))->BgL_locz00) = ((obj_t) BgL_locz00_2735), BUNSPEC);
																																																		((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1128z00_2743)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																		((((BgL_setqz00_bglt) CREF(BgL_new1128z00_2743))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_2740)), BUNSPEC);
																																																		((((BgL_setqz00_bglt) CREF(BgL_new1128z00_2743))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_2739), BUNSPEC);
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_new1128z00_2743);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 316 */
																																																	BgL_nodez00_bglt
																																																		BgL_res2934z00_3831;
																																																	{	/* Ast/sexp.scm 670 */
																																																		obj_t
																																																			BgL_arg2660z00_3827;
																																																		BgL_nodez00_bglt
																																																			BgL_arg2661z00_3828;
																																																		BgL_arg2660z00_3827
																																																			=
																																																			BGl_shapez00zztools_shapez00
																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																			());
																																																		BgL_arg2661z00_3828
																																																			=
																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																			(CNST_TABLE_REF
																																																			(((long) 4)), BNIL, BgL_locz00_2735, CNST_TABLE_REF(((long) 2)));
																																																		{	/* Ast/sexp.scm 669 */
																																																			obj_t
																																																				BgL_list2662z00_3830;
																																																			BgL_list2662z00_3830
																																																				=
																																																				MAKE_PAIR
																																																				(
																																																				((obj_t) BgL_arg2661z00_3828), BNIL);
																																																			BgL_res2934z00_3831
																																																				=
																																																				(
																																																				(BgL_nodez00_bglt)
																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																				(BgL_locz00_2735,
																																																					BgL_arg2660z00_3827,
																																																					BGl_string3128z00zzast_sexpz00,
																																																					BgL_expz00_21,
																																																					BgL_list2662z00_3830));
																																																	}}
																																																	return
																																																		BgL_res2934z00_3831;
																																																}
																																														}
																																													}
																																												}
																																											}
																																										}
																																									}
																																								}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 115 */
																																						BgL_tagzd27981zd2_2724:
																																							{	/* Ast/sexp.scm 320 */
																																								obj_t
																																									BgL_arg2360z00_2750;
																																								BgL_arg2360z00_2750
																																									=
																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																									(BgL_expz00_21,
																																									BgL_locz00_23);
																																								{	/* Ast/sexp.scm 319 */
																																									BgL_nodez00_bglt
																																										BgL_res2935z00_3839;
																																									{	/* Ast/sexp.scm 670 */
																																										obj_t
																																											BgL_arg2660z00_3835;
																																										BgL_nodez00_bglt
																																											BgL_arg2661z00_3836;
																																										BgL_arg2660z00_3835
																																											=
																																											BGl_shapez00zztools_shapez00
																																											(BGl_currentzd2functionzd2zztools_errorz00
																																											());
																																										BgL_arg2661z00_3836
																																											=
																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																											(CNST_TABLE_REF
																																											(((long) 4)), BNIL, BgL_arg2360z00_2750, CNST_TABLE_REF(((long) 2)));
																																										{	/* Ast/sexp.scm 669 */
																																											obj_t
																																												BgL_list2662z00_3838;
																																											BgL_list2662z00_3838
																																												=
																																												MAKE_PAIR
																																												(
																																												((obj_t) BgL_arg2661z00_3836), BNIL);
																																											BgL_res2935z00_3839
																																												=
																																												(
																																												(BgL_nodez00_bglt)
																																												BGl_userzd2errorzf2locationz20zztools_errorz00
																																												(BgL_arg2360z00_2750,
																																													BgL_arg2660z00_3835,
																																													BGl_string3127z00zzast_sexpz00,
																																													BgL_expz00_21,
																																													BgL_list2662z00_3838));
																																									}}
																																									return
																																										BgL_res2935z00_3839;
																																								}
																																							}
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 115 */
																																					goto
																																						BgL_tagzd27981zd2_2724;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 115 */
																																			goto
																																				BgL_tagzd27981zd2_2724;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 115 */
																																	goto
																																		BgL_tagzd27981zd2_2724;
																																}
																														}
																													}
																												else
																													{	/* Ast/sexp.scm 115 */
																														obj_t
																															BgL_carzd2717zd2_1701;
																														BgL_carzd2717zd2_1701
																															=
																															CAR
																															(BgL_expz00_21);
																														if (PAIRP
																															(BgL_carzd2717zd2_1701))
																															{	/* Ast/sexp.scm 115 */
																																obj_t
																																	BgL_carzd2720zd2_1703;
																																obj_t
																																	BgL_cdrzd2721zd2_1704;
																																BgL_carzd2720zd2_1703
																																	=
																																	CAR
																																	(BgL_carzd2717zd2_1701);
																																BgL_cdrzd2721zd2_1704
																																	=
																																	CDR
																																	(BgL_carzd2717zd2_1701);
																																{

																																	if (
																																		(BgL_carzd2720zd2_1703
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					18))))
																																		{
																																			obj_t
																																				BgL_auxz00_5718;
																																		BgL_kapzd2722zd2_1705:
																																			if (PAIRP
																																				(BgL_cdrzd2721zd2_1704))
																																				{	/* Ast/sexp.scm 115 */
																																					obj_t
																																						BgL_cdrzd2725zd2_1869;
																																					BgL_cdrzd2725zd2_1869
																																						=
																																						CDR
																																						(BgL_cdrzd2721zd2_1704);
																																					if (PAIRP(BgL_cdrzd2725zd2_1869))
																																						{	/* Ast/sexp.scm 115 */
																																							if (NULLP(CDR(BgL_cdrzd2725zd2_1869)))
																																								{	/* Ast/sexp.scm 115 */
																																									obj_t
																																										BgL_arg1724z00_1872;
																																									obj_t
																																										BgL_arg1727z00_1873;
																																									BgL_arg1724z00_1872
																																										=
																																										CAR
																																										(BgL_cdrzd2725zd2_1869);
																																									BgL_arg1727z00_1873
																																										=
																																										CDR
																																										(BgL_expz00_21);
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_5729;
																																										BgL_bodyz00_1620
																																											=
																																											BgL_arg1724z00_1872;
																																										BgL_argsz00_1621
																																											=
																																											BgL_arg1727z00_1873;
																																									BgL_tagzd2380zd2_1622:
																																										{	/* Ast/sexp.scm 323 */
																																											obj_t
																																												BgL_letzd2partzd2_2751;
																																											BgL_letzd2partzd2_2751
																																												=
																																												CAR
																																												(BgL_expz00_21);
																																											{	/* Ast/sexp.scm 323 */
																																												obj_t
																																													BgL_nexpz00_2752;
																																												{	/* Ast/sexp.scm 324 */
																																													obj_t
																																														BgL_arg2361z00_2753;
																																													obj_t
																																														BgL_arg2362z00_2754;
																																													BgL_arg2361z00_2753
																																														=
																																														CAR
																																														(BgL_letzd2partzd2_2751);
																																													{	/* Ast/sexp.scm 324 */
																																														obj_t
																																															BgL_arg2363z00_2755;
																																														obj_t
																																															BgL_arg2364z00_2756;
																																														BgL_arg2363z00_2755
																																															=
																																															CAR
																																															(CDR
																																															(BgL_letzd2partzd2_2751));
																																														{	/* Ast/sexp.scm 324 */
																																															obj_t
																																																BgL_arg2365z00_2757;
																																															BgL_arg2365z00_2757
																																																=
																																																MAKE_PAIR
																																																(BgL_bodyz00_1620,
																																																BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																(BgL_argsz00_1621,
																																																	BNIL));
																																															BgL_arg2364z00_2756
																																																=
																																																MAKE_PAIR
																																																(BgL_arg2365z00_2757,
																																																BNIL);
																																														}
																																														BgL_arg2362z00_2754
																																															=
																																															MAKE_PAIR
																																															(BgL_arg2363z00_2755,
																																															BgL_arg2364z00_2756);
																																													}
																																													BgL_nexpz00_2752
																																														=
																																														MAKE_PAIR
																																														(BgL_arg2361z00_2753,
																																														BgL_arg2362z00_2754);
																																												}
																																												{	/* Ast/sexp.scm 324 */

																																													BgL_auxz00_5729
																																														=
																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																														(BgL_nexpz00_2752,
																																														BgL_stackz00_22,
																																														BgL_locz00_23,
																																														BgL_sitez00_24);
																																												}
																																											}
																																										}
																																										BgL_auxz00_5718
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_5729);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 115 */
																																									bool_t
																																										BgL_testz00_5741;
																																									{	/* Ast/sexp.scm 115 */
																																										obj_t
																																											BgL_arg1794z00_1964;
																																										BgL_arg1794z00_1964
																																											=
																																											CAR
																																											(BgL_expz00_21);
																																										BgL_testz00_5741
																																											=
																																											CBOOL
																																											(BGl_letzd2symzf3z21zzast_letz00
																																											(BgL_arg1794z00_1964));
																																									}
																																									if (BgL_testz00_5741)
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_5745;
																																										BgL_tagzd2381zd2_1623:
																																											BgL_auxz00_5745 = BGl_letzd2ze3nodez31zzast_letz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																											BgL_auxz00_5718
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_5745);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 115 */
																																											bool_t
																																												BgL_testz00_5749;
																																											{	/* Ast/sexp.scm 115 */
																																												obj_t
																																													BgL_arg1793z00_1963;
																																												BgL_arg1793z00_1963
																																													=
																																													CAR
																																													(BgL_expz00_21);
																																												BgL_testz00_5749
																																													=
																																													CBOOL
																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																													(BgL_arg1793z00_1963));
																																											}
																																											if (BgL_testz00_5749)
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_5753;
																																												BgL_tagzd2383zd2_1625:
																																													BgL_auxz00_5753 = BGl_labelszd2ze3nodez31zzast_labelsz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																													BgL_auxz00_5718
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_5753);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 115 */
																																													obj_t
																																														BgL_carzd2803zd2_1876;
																																													BgL_carzd2803zd2_1876
																																														=
																																														CAR
																																														(BgL_expz00_21);
																																													{	/* Ast/sexp.scm 115 */
																																														obj_t
																																															BgL_cdrzd2808zd2_1877;
																																														BgL_cdrzd2808zd2_1877
																																															=
																																															CDR
																																															(BgL_carzd2803zd2_1876);
																																														if ((CAR(BgL_carzd2803zd2_1876) == CNST_TABLE_REF(((long) 3))))
																																															{	/* Ast/sexp.scm 115 */
																																																obj_t
																																																	BgL_arg1731z00_1879;
																																																obj_t
																																																	BgL_arg1732z00_1880;
																																																obj_t
																																																	BgL_arg1735z00_1881;
																																																BgL_arg1731z00_1879
																																																	=
																																																	CAR
																																																	(BgL_cdrzd2808zd2_1877);
																																																BgL_arg1732z00_1880
																																																	=
																																																	CDR
																																																	(BgL_cdrzd2808zd2_1877);
																																																BgL_arg1735z00_1881
																																																	=
																																																	CDR
																																																	(BgL_expz00_21);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_5766;
																																																	BgL_varsz00_1630
																																																		=
																																																		BgL_arg1731z00_1879;
																																																	BgL_bodyz00_1631
																																																		=
																																																		BgL_arg1732z00_1880;
																																																	BgL_argsz00_1632
																																																		=
																																																		BgL_arg1735z00_1881;
																																																BgL_tagzd2385zd2_1633:
																																																	{	/* Ast/sexp.scm 341 */
																																																		obj_t
																																																			BgL_locz00_2763;
																																																		obj_t
																																																			BgL_nexpz00_2764;
																																																		BgL_locz00_2763
																																																			=
																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																			(BgL_expz00_21,
																																																			BgL_locz00_23);
																																																		{	/* Ast/sexp.scm 342 */
																																																			obj_t
																																																				BgL_arg2369z00_2765;
																																																			obj_t
																																																				BgL_arg2370z00_2766;
																																																			BgL_arg2369z00_2765
																																																				=
																																																				BGl_letzd2symzd2zzast_letz00
																																																				();
																																																			{	/* Ast/sexp.scm 345 */
																																																				obj_t
																																																					BgL_arg2371z00_2767;
																																																				obj_t
																																																					BgL_arg2372z00_2768;
																																																				BgL_arg2371z00_2767
																																																					=
																																																					BGl_loopz00zzast_sexpz00
																																																					(BgL_expz00_21,
																																																					BgL_locz00_23,
																																																					BgL_varsz00_1630,
																																																					BgL_argsz00_1632);
																																																				{	/* Ast/sexp.scm 384 */
																																																					obj_t
																																																						BgL_arg2414z00_2816;
																																																					{	/* Ast/sexp.scm 384 */
																																																						obj_t
																																																							BgL_arg2415z00_2817;
																																																						obj_t
																																																							BgL_arg2416z00_2818;
																																																						BgL_arg2415z00_2817
																																																							=
																																																							BGl_shapez00zztools_shapez00
																																																							(BGl_currentzd2functionzd2zztools_errorz00
																																																							());
																																																						BgL_arg2416z00_2818
																																																							=
																																																							BGl_normaliza7ezd2prognz75zztools_prognz00
																																																							(BgL_bodyz00_1631);
																																																						{	/* Ast/sexp.scm 388 */
																																																							obj_t
																																																								BgL_zc3anonymousza32419ze3z83_4922;
																																																							BgL_zc3anonymousza32419ze3z83_4922
																																																								=
																																																								MAKE_FX_PROCEDURE
																																																								(BGl_z62zc3anonymousza32419ze3ze1zzast_sexpz00,
																																																								(int)
																																																								(((long) 3)), (int) (((long) 1)));
																																																							PROCEDURE_SET
																																																								(BgL_zc3anonymousza32419ze3z83_4922,
																																																								(int)
																																																								(((long) 0)), BgL_locz00_23);
																																																							BgL_arg2414z00_2816
																																																								=
																																																								BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
																																																								(BgL_arg2415z00_2817,
																																																								BgL_varsz00_1630,
																																																								BgL_arg2416z00_2818,
																																																								BgL_zc3anonymousza32419ze3z83_4922);
																																																					}}
																																																					BgL_arg2372z00_2768
																																																						=
																																																						MAKE_PAIR
																																																						(BgL_arg2414z00_2816,
																																																						BNIL);
																																																				}
																																																				BgL_arg2370z00_2766
																																																					=
																																																					MAKE_PAIR
																																																					(BgL_arg2371z00_2767,
																																																					BgL_arg2372z00_2768);
																																																			}
																																																			BgL_nexpz00_2764
																																																				=
																																																				MAKE_PAIR
																																																				(BgL_arg2369z00_2765,
																																																				BgL_arg2370z00_2766);
																																																		}
																																																		BgL_auxz00_5766
																																																			=
																																																			BGl_letzd2ze3nodez31zzast_letz00
																																																			(BgL_nexpz00_2764,
																																																			BgL_stackz00_22,
																																																			BgL_locz00_2763,
																																																			BgL_sitez00_24);
																																																	}
																																																	BgL_auxz00_5718
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_5766);
																																															}}
																																														else
																																															{	/* Ast/sexp.scm 115 */
																																																obj_t
																																																	BgL_cdrzd2831zd2_1883;
																																																BgL_cdrzd2831zd2_1883
																																																	=
																																																	CDR
																																																	(BgL_expz00_21);
																																																{	/* Ast/sexp.scm 115 */
																																																	obj_t
																																																		BgL_cdrzd2837zd2_1884;
																																																	BgL_cdrzd2837zd2_1884
																																																		=
																																																		CDR
																																																		(BgL_carzd2803zd2_1876);
																																																	if ((CAR(BgL_carzd2803zd2_1876) == CNST_TABLE_REF(((long) 1))))
																																																		{	/* Ast/sexp.scm 115 */
																																																			obj_t
																																																				BgL_cdrzd2843zd2_1886;
																																																			BgL_cdrzd2843zd2_1886
																																																				=
																																																				CDR
																																																				(BgL_cdrzd2837zd2_1884);
																																																			{	/* Ast/sexp.scm 115 */
																																																				obj_t
																																																					BgL_carzd2848zd2_1887;
																																																				obj_t
																																																					BgL_cdrzd2849zd2_1888;
																																																				BgL_carzd2848zd2_1887
																																																					=
																																																					CAR
																																																					(BgL_cdrzd2843zd2_1886);
																																																				BgL_cdrzd2849zd2_1888
																																																					=
																																																					CDR
																																																					(BgL_cdrzd2843zd2_1886);
																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2848zd2_1887))
																																																					{	/* Ast/sexp.scm 115 */
																																																						if (PAIRP(BgL_cdrzd2849zd2_1888))
																																																							{	/* Ast/sexp.scm 115 */
																																																								obj_t
																																																									BgL_carzd2856zd2_1891;
																																																								BgL_carzd2856zd2_1891
																																																									=
																																																									CAR
																																																									(BgL_cdrzd2849zd2_1888);
																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2856zd2_1891))
																																																									{	/* Ast/sexp.scm 115 */
																																																										if (NULLP(CDR(BgL_cdrzd2849zd2_1888)))
																																																											{	/* Ast/sexp.scm 115 */
																																																												bool_t
																																																													BgL_testz00_5803;
																																																												{
																																																													obj_t
																																																														BgL_l1349z00_1912;
																																																													BgL_l1349z00_1912
																																																														=
																																																														BgL_cdrzd2831zd2_1883;
																																																												BgL_zc3anonymousza31755ze3z83_1913:
																																																													if (NULLP(BgL_l1349z00_1912))
																																																														{	/* Ast/sexp.scm 115 */
																																																															BgL_testz00_5803
																																																																=
																																																																(
																																																																(bool_t)
																																																																1);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																															bool_t
																																																																BgL_testz00_5806;
																																																															{	/* Ast/sexp.scm 115 */
																																																																bool_t
																																																																	BgL_testz00_5807;
																																																																{	/* Ast/sexp.scm 115 */
																																																																	obj_t
																																																																		BgL_auxz00_5808;
																																																																	BgL_auxz00_5808
																																																																		=
																																																																		CAR
																																																																		(BgL_l1349z00_1912);
																																																																	BgL_testz00_5807
																																																																		=
																																																																		PAIRP
																																																																		(BgL_auxz00_5808);
																																																																}
																																																																if (BgL_testz00_5807)
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		BgL_testz00_5806
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			0);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		BgL_testz00_5806
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																															}
																																																															if (BgL_testz00_5806)
																																																																{
																																																																	obj_t
																																																																		BgL_l1349z00_5811;
																																																																	BgL_l1349z00_5811
																																																																		=
																																																																		CDR
																																																																		(BgL_l1349z00_1912);
																																																																	BgL_l1349z00_1912
																																																																		=
																																																																		BgL_l1349z00_5811;
																																																																	goto
																																																																		BgL_zc3anonymousza31755ze3z83_1913;
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	BgL_testz00_5803
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		0);
																																																																}
																																																														}
																																																												}
																																																												if (BgL_testz00_5803)
																																																													{	/* Ast/sexp.scm 115 */
																																																														obj_t
																																																															BgL_arg1743z00_1895;
																																																														BgL_arg1743z00_1895
																																																															=
																																																															CAR
																																																															(BgL_cdrzd2837zd2_1884);
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_5814;
																																																															BgL_testz00_1634
																																																																=
																																																																BgL_arg1743z00_1895;
																																																															BgL_proc1z00_1635
																																																																=
																																																																BgL_carzd2848zd2_1887;
																																																															BgL_proc2z00_1636
																																																																=
																																																																BgL_carzd2856zd2_1891;
																																																															BgL_argsz00_1637
																																																																=
																																																																BgL_cdrzd2831zd2_1883;
																																																														BgL_tagzd2386zd2_1638:
																																																															{	/* Ast/sexp.scm 395 */
																																																																obj_t
																																																																	BgL_nexpz00_2827;
																																																																{	/* Ast/sexp.scm 395 */
																																																																	obj_t
																																																																		BgL_arg2422z00_2829;
																																																																	{	/* Ast/sexp.scm 395 */
																																																																		obj_t
																																																																			BgL_arg2423z00_2830;
																																																																		{	/* Ast/sexp.scm 395 */
																																																																			obj_t
																																																																				BgL_arg2424z00_2831;
																																																																			obj_t
																																																																				BgL_arg2426z00_2832;
																																																																			BgL_arg2424z00_2831
																																																																				=
																																																																				MAKE_PAIR
																																																																				(BgL_proc1z00_1635,
																																																																				BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																				(BgL_argsz00_1637,
																																																																					BNIL));
																																																																			{	/* Ast/sexp.scm 395 */
																																																																				obj_t
																																																																					BgL_arg2428z00_2834;
																																																																				BgL_arg2428z00_2834
																																																																					=
																																																																					MAKE_PAIR
																																																																					(BgL_proc2z00_1636,
																																																																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																					(BgL_argsz00_1637,
																																																																						BNIL));
																																																																				BgL_arg2426z00_2832
																																																																					=
																																																																					MAKE_PAIR
																																																																					(BgL_arg2428z00_2834,
																																																																					BNIL);
																																																																			}
																																																																			BgL_arg2423z00_2830
																																																																				=
																																																																				MAKE_PAIR
																																																																				(BgL_arg2424z00_2831,
																																																																				BgL_arg2426z00_2832);
																																																																		}
																																																																		BgL_arg2422z00_2829
																																																																			=
																																																																			MAKE_PAIR
																																																																			(BgL_testz00_1634,
																																																																			BgL_arg2423z00_2830);
																																																																	}
																																																																	BgL_nexpz00_2827
																																																																		=
																																																																		MAKE_PAIR
																																																																		(CNST_TABLE_REF
																																																																		(((long) 1)), BgL_arg2422z00_2829);
																																																																}
																																																																BgL_auxz00_5814
																																																																	=
																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																	(BgL_nexpz00_2827,
																																																																	BgL_stackz00_22,
																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																	(BgL_expz00_21,
																																																																		BgL_locz00_23),
																																																																	BgL_sitez00_24);
																																																															}
																																																															BgL_auxz00_5718
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_5814);
																																																													}}
																																																												else
																																																													{	/* Ast/sexp.scm 115 */
																																																														obj_t
																																																															BgL_cdrzd2880zd2_1896;
																																																														BgL_cdrzd2880zd2_1896
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{	/* Ast/sexp.scm 115 */
																																																															obj_t
																																																																BgL_cdrzd2887zd2_1897;
																																																															BgL_cdrzd2887zd2_1897
																																																																=
																																																																CDR
																																																																(CAR
																																																																(BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 115 */
																																																																obj_t
																																																																	BgL_cdrzd2894zd2_1898;
																																																																BgL_cdrzd2894zd2_1898
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd2887zd2_1897);
																																																																{	/* Ast/sexp.scm 115 */
																																																																	obj_t
																																																																		BgL_carzd2900zd2_1899;
																																																																	BgL_carzd2900zd2_1899
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd2894zd2_1898);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2900zd2_1899))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			obj_t
																																																																				BgL_carzd2907zd2_1901;
																																																																			BgL_carzd2907zd2_1901
																																																																				=
																																																																				CAR
																																																																				(CDR
																																																																				(BgL_cdrzd2894zd2_1898));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2907zd2_1901))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd2880zd2_1896))
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							obj_t
																																																																								BgL_arg1747z00_1904;
																																																																							BgL_arg1747z00_1904
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd2887zd2_1897);
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_5841;
																																																																								BgL_testz00_1639
																																																																									=
																																																																									BgL_arg1747z00_1904;
																																																																								BgL_proc1z00_1640
																																																																									=
																																																																									BgL_carzd2900zd2_1899;
																																																																								BgL_proc2z00_1641
																																																																									=
																																																																									BgL_carzd2907zd2_1901;
																																																																								BgL_argsz00_1642
																																																																									=
																																																																									BgL_cdrzd2880zd2_1896;
																																																																							BgL_tagzd2387zd2_1643:
																																																																								{	/* Ast/sexp.scm 401 */
																																																																									obj_t
																																																																										BgL_tmpsz00_2836;
																																																																									if (NULLP(BgL_argsz00_1642))
																																																																										{	/* Ast/sexp.scm 401 */
																																																																											BgL_tmpsz00_2836
																																																																												=
																																																																												BNIL;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 401 */
																																																																											obj_t
																																																																												BgL_head1338z00_2880;
																																																																											{	/* Ast/sexp.scm 401 */
																																																																												obj_t
																																																																													BgL_res2951z00_3895;
																																																																												BgL_res2951z00_3895
																																																																													=
																																																																													MAKE_PAIR
																																																																													(BNIL,
																																																																													BNIL);
																																																																												BgL_head1338z00_2880
																																																																													=
																																																																													BgL_res2951z00_3895;
																																																																											}
																																																																											{
																																																																												obj_t
																																																																													BgL_l1336z00_2882;
																																																																												obj_t
																																																																													BgL_tail1339z00_2883;
																																																																												BgL_l1336z00_2882
																																																																													=
																																																																													BgL_argsz00_1642;
																																																																												BgL_tail1339z00_2883
																																																																													=
																																																																													BgL_head1338z00_2880;
																																																																											BgL_zc3anonymousza32465ze3z83_2884:
																																																																												if (NULLP(BgL_l1336z00_2882))
																																																																													{	/* Ast/sexp.scm 401 */
																																																																														BgL_tmpsz00_2836
																																																																															=
																																																																															CDR
																																																																															(BgL_head1338z00_2880);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 401 */
																																																																														obj_t
																																																																															BgL_newtail1340z00_2886;
																																																																														{	/* Ast/sexp.scm 401 */
																																																																															obj_t
																																																																																BgL_arg2469z00_2888;
																																																																															{	/* Ast/sexp.scm 401 */

																																																																																{	/* Ast/sexp.scm 401 */

																																																																																	BgL_arg2469z00_2888
																																																																																		=
																																																																																		BGl_gensymz00zz__r4_symbols_6_4z00
																																																																																		(BFALSE);
																																																																																}
																																																																															}
																																																																															{	/* Ast/sexp.scm 401 */
																																																																																obj_t
																																																																																	BgL_res2953z00_3902;
																																																																																BgL_res2953z00_3902
																																																																																	=
																																																																																	MAKE_PAIR
																																																																																	(BgL_arg2469z00_2888,
																																																																																	BNIL);
																																																																																BgL_newtail1340z00_2886
																																																																																	=
																																																																																	BgL_res2953z00_3902;
																																																																															}
																																																																														}
																																																																														SET_CDR
																																																																															(BgL_tail1339z00_2883,
																																																																															BgL_newtail1340z00_2886);
																																																																														{
																																																																															obj_t
																																																																																BgL_tail1339z00_5853;
																																																																															obj_t
																																																																																BgL_l1336z00_5851;
																																																																															BgL_l1336z00_5851
																																																																																=
																																																																																CDR
																																																																																(BgL_l1336z00_2882);
																																																																															BgL_tail1339z00_5853
																																																																																=
																																																																																BgL_newtail1340z00_2886;
																																																																															BgL_tail1339z00_2883
																																																																																=
																																																																																BgL_tail1339z00_5853;
																																																																															BgL_l1336z00_2882
																																																																																=
																																																																																BgL_l1336z00_5851;
																																																																															goto
																																																																																BgL_zc3anonymousza32465ze3z83_2884;
																																																																														}
																																																																													}
																																																																											}
																																																																										}
																																																																									{	/* Ast/sexp.scm 401 */
																																																																										obj_t
																																																																											BgL_locz00_2837;
																																																																										BgL_locz00_2837
																																																																											=
																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																											(BgL_expz00_21,
																																																																											BgL_locz00_23);
																																																																										{	/* Ast/sexp.scm 402 */
																																																																											obj_t
																																																																												BgL_nexpz00_2838;
																																																																											{	/* Ast/sexp.scm 403 */
																																																																												obj_t
																																																																													BgL_arg2431z00_2840;
																																																																												obj_t
																																																																													BgL_arg2433z00_2841;
																																																																												BgL_arg2431z00_2840
																																																																													=
																																																																													BGl_letzd2symzd2zzast_letz00
																																																																													();
																																																																												{	/* Ast/sexp.scm 403 */
																																																																													obj_t
																																																																														BgL_arg2434z00_2842;
																																																																													obj_t
																																																																														BgL_arg2436z00_2843;
																																																																													if (NULLP(BgL_tmpsz00_2836))
																																																																														{	/* Ast/sexp.scm 403 */
																																																																															BgL_arg2434z00_2842
																																																																																=
																																																																																BNIL;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 403 */
																																																																															obj_t
																																																																																BgL_head1343z00_2847;
																																																																															{	/* Ast/sexp.scm 403 */
																																																																																obj_t
																																																																																	BgL_arg2449z00_2865;
																																																																																{	/* Ast/sexp.scm 403 */
																																																																																	obj_t
																																																																																		BgL_arg2451z00_2866;
																																																																																	obj_t
																																																																																		BgL_arg2452z00_2867;
																																																																																	BgL_arg2451z00_2866
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_tmpsz00_2836);
																																																																																	BgL_arg2452z00_2867
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_argsz00_1642);
																																																																																	{	/* Ast/sexp.scm 403 */
																																																																																		obj_t
																																																																																			BgL_list2453z00_2868;
																																																																																		{	/* Ast/sexp.scm 403 */
																																																																																			obj_t
																																																																																				BgL_arg2454z00_2869;
																																																																																			BgL_arg2454z00_2869
																																																																																				=
																																																																																				MAKE_PAIR
																																																																																				(BgL_arg2452z00_2867,
																																																																																				BNIL);
																																																																																			BgL_list2453z00_2868
																																																																																				=
																																																																																				MAKE_PAIR
																																																																																				(BgL_arg2451z00_2866,
																																																																																				BgL_arg2454z00_2869);
																																																																																		}
																																																																																		BgL_arg2449z00_2865
																																																																																			=
																																																																																			BgL_list2453z00_2868;
																																																																																	}
																																																																																}
																																																																																{	/* Ast/sexp.scm 403 */
																																																																																	obj_t
																																																																																		BgL_res2956z00_3914;
																																																																																	BgL_res2956z00_3914
																																																																																		=
																																																																																		MAKE_PAIR
																																																																																		(BgL_arg2449z00_2865,
																																																																																		BNIL);
																																																																																	BgL_head1343z00_2847
																																																																																		=
																																																																																		BgL_res2956z00_3914;
																																																																																}
																																																																															}
																																																																															{	/* Ast/sexp.scm 403 */
																																																																																obj_t
																																																																																	BgL_g1347z00_2848;
																																																																																obj_t
																																																																																	BgL_g1348z00_2849;
																																																																																BgL_g1347z00_2848
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_tmpsz00_2836);
																																																																																BgL_g1348z00_2849
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_argsz00_1642);
																																																																																{
																																																																																	obj_t
																																																																																		BgL_ll1341z00_2851;
																																																																																	obj_t
																																																																																		BgL_ll1342z00_2852;
																																																																																	obj_t
																																																																																		BgL_tail1344z00_2853;
																																																																																	BgL_ll1341z00_2851
																																																																																		=
																																																																																		BgL_g1347z00_2848;
																																																																																	BgL_ll1342z00_2852
																																																																																		=
																																																																																		BgL_g1348z00_2849;
																																																																																	BgL_tail1344z00_2853
																																																																																		=
																																																																																		BgL_head1343z00_2847;
																																																																																BgL_zc3anonymousza32438ze3z83_2854:
																																																																																	if (NULLP(BgL_ll1341z00_2851))
																																																																																		{	/* Ast/sexp.scm 403 */
																																																																																			BgL_arg2434z00_2842
																																																																																				=
																																																																																				BgL_head1343z00_2847;
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 403 */
																																																																																			obj_t
																																																																																				BgL_newtail1345z00_2856;
																																																																																			{	/* Ast/sexp.scm 403 */
																																																																																				obj_t
																																																																																					BgL_arg2443z00_2859;
																																																																																				{	/* Ast/sexp.scm 403 */
																																																																																					obj_t
																																																																																						BgL_arg2444z00_2860;
																																																																																					obj_t
																																																																																						BgL_arg2446z00_2861;
																																																																																					BgL_arg2444z00_2860
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_ll1341z00_2851);
																																																																																					BgL_arg2446z00_2861
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_ll1342z00_2852);
																																																																																					{	/* Ast/sexp.scm 403 */
																																																																																						obj_t
																																																																																							BgL_list2447z00_2862;
																																																																																						{	/* Ast/sexp.scm 403 */
																																																																																							obj_t
																																																																																								BgL_arg2448z00_2863;
																																																																																							BgL_arg2448z00_2863
																																																																																								=
																																																																																								MAKE_PAIR
																																																																																								(BgL_arg2446z00_2861,
																																																																																								BNIL);
																																																																																							BgL_list2447z00_2862
																																																																																								=
																																																																																								MAKE_PAIR
																																																																																								(BgL_arg2444z00_2860,
																																																																																								BgL_arg2448z00_2863);
																																																																																						}
																																																																																						BgL_arg2443z00_2859
																																																																																							=
																																																																																							BgL_list2447z00_2862;
																																																																																					}
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 403 */
																																																																																					obj_t
																																																																																						BgL_res2959z00_3925;
																																																																																					BgL_res2959z00_3925
																																																																																						=
																																																																																						MAKE_PAIR
																																																																																						(BgL_arg2443z00_2859,
																																																																																						BNIL);
																																																																																					BgL_newtail1345z00_2856
																																																																																						=
																																																																																						BgL_res2959z00_3925;
																																																																																				}
																																																																																			}
																																																																																			SET_CDR
																																																																																				(BgL_tail1344z00_2853,
																																																																																				BgL_newtail1345z00_2856);
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_tail1344z00_5877;
																																																																																				obj_t
																																																																																					BgL_ll1342z00_5875;
																																																																																				obj_t
																																																																																					BgL_ll1341z00_5873;
																																																																																				BgL_ll1341z00_5873
																																																																																					=
																																																																																					CDR
																																																																																					(BgL_ll1341z00_2851);
																																																																																				BgL_ll1342z00_5875
																																																																																					=
																																																																																					CDR
																																																																																					(BgL_ll1342z00_2852);
																																																																																				BgL_tail1344z00_5877
																																																																																					=
																																																																																					BgL_newtail1345z00_2856;
																																																																																				BgL_tail1344z00_2853
																																																																																					=
																																																																																					BgL_tail1344z00_5877;
																																																																																				BgL_ll1342z00_2852
																																																																																					=
																																																																																					BgL_ll1342z00_5875;
																																																																																				BgL_ll1341z00_2851
																																																																																					=
																																																																																					BgL_ll1341z00_5873;
																																																																																				goto
																																																																																					BgL_zc3anonymousza32438ze3z83_2854;
																																																																																			}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													{	/* Ast/sexp.scm 404 */
																																																																														obj_t
																																																																															BgL_arg2455z00_2870;
																																																																														{	/* Ast/sexp.scm 404 */
																																																																															obj_t
																																																																																BgL_arg2456z00_2871;
																																																																															{	/* Ast/sexp.scm 404 */
																																																																																obj_t
																																																																																	BgL_arg2457z00_2872;
																																																																																{	/* Ast/sexp.scm 404 */
																																																																																	obj_t
																																																																																		BgL_arg2459z00_2873;
																																																																																	obj_t
																																																																																		BgL_arg2460z00_2874;
																																																																																	BgL_arg2459z00_2873
																																																																																		=
																																																																																		MAKE_PAIR
																																																																																		(BgL_proc1z00_1640,
																																																																																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																		(BgL_tmpsz00_2836,
																																																																																			BNIL));
																																																																																	{	/* Ast/sexp.scm 404 */
																																																																																		obj_t
																																																																																			BgL_arg2462z00_2876;
																																																																																		BgL_arg2462z00_2876
																																																																																			=
																																																																																			MAKE_PAIR
																																																																																			(BgL_proc2z00_1641,
																																																																																			BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																			(BgL_tmpsz00_2836,
																																																																																				BNIL));
																																																																																		BgL_arg2460z00_2874
																																																																																			=
																																																																																			MAKE_PAIR
																																																																																			(BgL_arg2462z00_2876,
																																																																																			BNIL);
																																																																																	}
																																																																																	BgL_arg2457z00_2872
																																																																																		=
																																																																																		MAKE_PAIR
																																																																																		(BgL_arg2459z00_2873,
																																																																																		BgL_arg2460z00_2874);
																																																																																}
																																																																																BgL_arg2456z00_2871
																																																																																	=
																																																																																	MAKE_PAIR
																																																																																	(BgL_testz00_1639,
																																																																																	BgL_arg2457z00_2872);
																																																																															}
																																																																															BgL_arg2455z00_2870
																																																																																=
																																																																																MAKE_PAIR
																																																																																(CNST_TABLE_REF
																																																																																(((long) 1)), BgL_arg2456z00_2871);
																																																																														}
																																																																														BgL_arg2436z00_2843
																																																																															=
																																																																															MAKE_PAIR
																																																																															(BgL_arg2455z00_2870,
																																																																															BNIL);
																																																																													}
																																																																													BgL_arg2433z00_2841
																																																																														=
																																																																														MAKE_PAIR
																																																																														(BgL_arg2434z00_2842,
																																																																														BgL_arg2436z00_2843);
																																																																												}
																																																																												BgL_nexpz00_2838
																																																																													=
																																																																													MAKE_PAIR
																																																																													(BgL_arg2431z00_2840,
																																																																													BgL_arg2433z00_2841);
																																																																											}
																																																																											{	/* Ast/sexp.scm 403 */

																																																																												BgL_auxz00_5841
																																																																													=
																																																																													BGl_letzd2ze3nodez31zzast_letz00
																																																																													(BgL_nexpz00_2838,
																																																																													BgL_stackz00_22,
																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																													(BgL_expz00_21,
																																																																														BgL_locz00_2837),
																																																																													BgL_sitez00_24);
																																																																								}}}}
																																																																								BgL_auxz00_5718
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_5841);
																																																																						}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 115 */
																																																																								BgL_tagzd2401zd2_1666:
																																																																									BgL_auxz00_5718 = BGl_privatezd2nodezd2zzast_privatez00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_5896;
																																																																								BgL_tagzd2402zd2_1667:
																																																																									BgL_auxz00_5896 = BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																									BgL_auxz00_5718
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_5896);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							goto
																																																																								BgL_tagzd2401zd2_1666;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_5901;
																																																																							goto
																																																																								BgL_tagzd2402zd2_1667;
																																																																							BgL_auxz00_5718
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_5901);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					goto
																																																																						BgL_tagzd2401zd2_1666;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_5905;
																																																																					goto
																																																																						BgL_tagzd2402zd2_1667;
																																																																					BgL_auxz00_5718
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_5905);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 115 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 115 */
																																																														goto
																																																															BgL_tagzd2401zd2_1666;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_5909;
																																																														goto
																																																															BgL_tagzd2402zd2_1667;
																																																														BgL_auxz00_5718
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_5909);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 115 */
																																																										obj_t
																																																											BgL_cdrzd21163zd2_1923;
																																																										BgL_cdrzd21163zd2_1923
																																																											=
																																																											CDR
																																																											(BgL_expz00_21);
																																																										{	/* Ast/sexp.scm 115 */
																																																											obj_t
																																																												BgL_cdrzd21169zd2_1924;
																																																											BgL_cdrzd21169zd2_1924
																																																												=
																																																												CDR
																																																												(CAR
																																																												(BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 115 */
																																																												obj_t
																																																													BgL_cdrzd21175zd2_1925;
																																																												BgL_cdrzd21175zd2_1925
																																																													=
																																																													CDR
																																																													(BgL_cdrzd21169zd2_1924);
																																																												{	/* Ast/sexp.scm 115 */
																																																													obj_t
																																																														BgL_carzd21180zd2_1926;
																																																													obj_t
																																																														BgL_cdrzd21181zd2_1927;
																																																													BgL_carzd21180zd2_1926
																																																														=
																																																														CAR
																																																														(BgL_cdrzd21175zd2_1925);
																																																													BgL_cdrzd21181zd2_1927
																																																														=
																																																														CDR
																																																														(BgL_cdrzd21175zd2_1925);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21180zd2_1926))
																																																														{	/* Ast/sexp.scm 115 */
																																																															obj_t
																																																																BgL_carzd21186zd2_1929;
																																																															BgL_carzd21186zd2_1929
																																																																=
																																																																CAR
																																																																(BgL_cdrzd21181zd2_1927);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21186zd2_1929))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (NULLP(CDR(BgL_cdrzd21181zd2_1927)))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21163zd2_1923))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					obj_t
																																																																						BgL_arg1765z00_1933;
																																																																					BgL_arg1765z00_1933
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd21169zd2_1924);
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_5928;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_5932;
																																																																							obj_t
																																																																								BgL_proc2z00_5931;
																																																																							obj_t
																																																																								BgL_proc1z00_5930;
																																																																							obj_t
																																																																								BgL_testz00_5929;
																																																																							BgL_testz00_5929
																																																																								=
																																																																								BgL_arg1765z00_1933;
																																																																							BgL_proc1z00_5930
																																																																								=
																																																																								BgL_carzd21180zd2_1926;
																																																																							BgL_proc2z00_5931
																																																																								=
																																																																								BgL_carzd21186zd2_1929;
																																																																							BgL_argsz00_5932
																																																																								=
																																																																								BgL_cdrzd21163zd2_1923;
																																																																							BgL_argsz00_1642
																																																																								=
																																																																								BgL_argsz00_5932;
																																																																							BgL_proc2z00_1641
																																																																								=
																																																																								BgL_proc2z00_5931;
																																																																							BgL_proc1z00_1640
																																																																								=
																																																																								BgL_proc1z00_5930;
																																																																							BgL_testz00_1639
																																																																								=
																																																																								BgL_testz00_5929;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1643;
																																																																						}
																																																																						BgL_auxz00_5718
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_5928);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							goto
																																																																								BgL_tagzd2401zd2_1666;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_5936;
																																																																							goto
																																																																								BgL_tagzd2402zd2_1667;
																																																																							BgL_auxz00_5718
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_5936);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					goto
																																																																						BgL_tagzd2401zd2_1666;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_5940;
																																																																					goto
																																																																						BgL_tagzd2402zd2_1667;
																																																																					BgL_auxz00_5718
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_5940);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			goto
																																																																				BgL_tagzd2401zd2_1666;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_5944;
																																																																			goto
																																																																				BgL_tagzd2402zd2_1667;
																																																																			BgL_auxz00_5718
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_5944);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	goto
																																																																		BgL_tagzd2401zd2_1666;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_5948;
																																																																	goto
																																																																		BgL_tagzd2402zd2_1667;
																																																																	BgL_auxz00_5718
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_5948);
																																																																}
																																																														}
																																																												}
																																																											}
																																																										}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 115 */
																																																										goto
																																																											BgL_tagzd2401zd2_1666;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_5952;
																																																										goto
																																																											BgL_tagzd2402zd2_1667;
																																																										BgL_auxz00_5718
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_5952);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						obj_t
																																																							BgL_cdrzd21494zd2_1941;
																																																						BgL_cdrzd21494zd2_1941
																																																							=
																																																							CDR
																																																							(BgL_expz00_21);
																																																						{	/* Ast/sexp.scm 115 */
																																																							obj_t
																																																								BgL_cdrzd21501zd2_1942;
																																																							BgL_cdrzd21501zd2_1942
																																																								=
																																																								CDR
																																																								(CAR
																																																								(BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 115 */
																																																								obj_t
																																																									BgL_cdrzd21508zd2_1943;
																																																								BgL_cdrzd21508zd2_1943
																																																									=
																																																									CDR
																																																									(BgL_cdrzd21501zd2_1942);
																																																								{	/* Ast/sexp.scm 115 */
																																																									obj_t
																																																										BgL_carzd21514zd2_1944;
																																																									obj_t
																																																										BgL_cdrzd21515zd2_1945;
																																																									BgL_carzd21514zd2_1944
																																																										=
																																																										CAR
																																																										(BgL_cdrzd21508zd2_1943);
																																																									BgL_cdrzd21515zd2_1945
																																																										=
																																																										CDR
																																																										(BgL_cdrzd21508zd2_1943);
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21514zd2_1944))
																																																										{	/* Ast/sexp.scm 115 */
																																																											if (PAIRP(BgL_cdrzd21515zd2_1945))
																																																												{	/* Ast/sexp.scm 115 */
																																																													obj_t
																																																														BgL_carzd21522zd2_1948;
																																																													BgL_carzd21522zd2_1948
																																																														=
																																																														CAR
																																																														(BgL_cdrzd21515zd2_1945);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21522zd2_1948))
																																																														{	/* Ast/sexp.scm 115 */
																																																															if (NULLP(CDR(BgL_cdrzd21515zd2_1945)))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21494zd2_1941))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			obj_t
																																																																				BgL_arg1780z00_1952;
																																																																			BgL_arg1780z00_1952
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd21501zd2_1942);
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_5973;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_5977;
																																																																					obj_t
																																																																						BgL_proc2z00_5976;
																																																																					obj_t
																																																																						BgL_proc1z00_5975;
																																																																					obj_t
																																																																						BgL_testz00_5974;
																																																																					BgL_testz00_5974
																																																																						=
																																																																						BgL_arg1780z00_1952;
																																																																					BgL_proc1z00_5975
																																																																						=
																																																																						BgL_carzd21514zd2_1944;
																																																																					BgL_proc2z00_5976
																																																																						=
																																																																						BgL_carzd21522zd2_1948;
																																																																					BgL_argsz00_5977
																																																																						=
																																																																						BgL_cdrzd21494zd2_1941;
																																																																					BgL_argsz00_1642
																																																																						=
																																																																						BgL_argsz00_5977;
																																																																					BgL_proc2z00_1641
																																																																						=
																																																																						BgL_proc2z00_5976;
																																																																					BgL_proc1z00_1640
																																																																						=
																																																																						BgL_proc1z00_5975;
																																																																					BgL_testz00_1639
																																																																						=
																																																																						BgL_testz00_5974;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1643;
																																																																				}
																																																																				BgL_auxz00_5718
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_5973);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					goto
																																																																						BgL_tagzd2401zd2_1666;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_5981;
																																																																					goto
																																																																						BgL_tagzd2402zd2_1667;
																																																																					BgL_auxz00_5718
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_5981);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			goto
																																																																				BgL_tagzd2401zd2_1666;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_5985;
																																																																			goto
																																																																				BgL_tagzd2402zd2_1667;
																																																																			BgL_auxz00_5718
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_5985);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	goto
																																																																		BgL_tagzd2401zd2_1666;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_5989;
																																																																	goto
																																																																		BgL_tagzd2402zd2_1667;
																																																																	BgL_auxz00_5718
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_5989);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 115 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 115 */
																																																															goto
																																																																BgL_tagzd2401zd2_1666;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_5993;
																																																															goto
																																																																BgL_tagzd2402zd2_1667;
																																																															BgL_auxz00_5718
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_5993);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 115 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 115 */
																																																													goto
																																																														BgL_tagzd2401zd2_1666;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_5997;
																																																													goto
																																																														BgL_tagzd2402zd2_1667;
																																																													BgL_auxz00_5718
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_5997);
																																																												}
																																																										}
																																																								}
																																																							}
																																																						}
																																																					}
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 115 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 115 */
																																																					goto
																																																						BgL_tagzd2401zd2_1666;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_6001;
																																																					goto
																																																						BgL_tagzd2402zd2_1667;
																																																					BgL_auxz00_5718
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6001);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												}
																																										}
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 115 */
																																							bool_t
																																								BgL_testz00_6003;
																																							{	/* Ast/sexp.scm 115 */
																																								obj_t
																																									BgL_arg1805z00_1977;
																																								BgL_arg1805z00_1977
																																									=
																																									CAR
																																									(BgL_expz00_21);
																																								BgL_testz00_6003
																																									=
																																									CBOOL
																																									(BGl_letzd2symzf3z21zzast_letz00
																																									(BgL_arg1805z00_1977));
																																							}
																																							if (BgL_testz00_6003)
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_6007;
																																									goto
																																										BgL_tagzd2381zd2_1623;
																																									BgL_auxz00_5718
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_6007);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 115 */
																																									bool_t
																																										BgL_testz00_6009;
																																									{	/* Ast/sexp.scm 115 */
																																										obj_t
																																											BgL_arg1804z00_1976;
																																										BgL_arg1804z00_1976
																																											=
																																											CAR
																																											(BgL_expz00_21);
																																										BgL_testz00_6009
																																											=
																																											CBOOL
																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																											(BgL_arg1804z00_1976));
																																									}
																																									if (BgL_testz00_6009)
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_6013;
																																											goto
																																												BgL_tagzd2383zd2_1625;
																																											BgL_auxz00_5718
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_6013);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 115 */
																																											obj_t
																																												BgL_carzd21938zd2_1968;
																																											BgL_carzd21938zd2_1968
																																												=
																																												CAR
																																												(BgL_expz00_21);
																																											{	/* Ast/sexp.scm 115 */
																																												obj_t
																																													BgL_cdrzd21943zd2_1969;
																																												BgL_cdrzd21943zd2_1969
																																													=
																																													CDR
																																													(BgL_carzd21938zd2_1968);
																																												if ((CAR(BgL_carzd21938zd2_1968) == CNST_TABLE_REF(((long) 3))))
																																													{	/* Ast/sexp.scm 115 */
																																														obj_t
																																															BgL_arg1799z00_1971;
																																														obj_t
																																															BgL_arg1800z00_1972;
																																														obj_t
																																															BgL_arg1801z00_1973;
																																														BgL_arg1799z00_1971
																																															=
																																															CAR
																																															(BgL_cdrzd21943zd2_1969);
																																														BgL_arg1800z00_1972
																																															=
																																															CDR
																																															(BgL_cdrzd21943zd2_1969);
																																														BgL_arg1801z00_1973
																																															=
																																															CDR
																																															(BgL_expz00_21);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_6024;
																																															{
																																																obj_t
																																																	BgL_argsz00_6027;
																																																obj_t
																																																	BgL_bodyz00_6026;
																																																obj_t
																																																	BgL_varsz00_6025;
																																																BgL_varsz00_6025
																																																	=
																																																	BgL_arg1799z00_1971;
																																																BgL_bodyz00_6026
																																																	=
																																																	BgL_arg1800z00_1972;
																																																BgL_argsz00_6027
																																																	=
																																																	BgL_arg1801z00_1973;
																																																BgL_argsz00_1632
																																																	=
																																																	BgL_argsz00_6027;
																																																BgL_bodyz00_1631
																																																	=
																																																	BgL_bodyz00_6026;
																																																BgL_varsz00_1630
																																																	=
																																																	BgL_varsz00_6025;
																																																goto
																																																	BgL_tagzd2385zd2_1633;
																																															}
																																															BgL_auxz00_5718
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_6024);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 115 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 115 */
																																																goto
																																																	BgL_tagzd2401zd2_1666;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_6031;
																																																goto
																																																	BgL_tagzd2402zd2_1667;
																																																BgL_auxz00_5718
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_6031);
																																															}
																																													}
																																											}
																																										}
																																								}
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 115 */
																																					bool_t
																																						BgL_testz00_6033;
																																					{	/* Ast/sexp.scm 115 */
																																						obj_t
																																							BgL_arg1810z00_1982;
																																						BgL_arg1810z00_1982
																																							=
																																							CAR
																																							(BgL_expz00_21);
																																						BgL_testz00_6033
																																							=
																																							CBOOL
																																							(BGl_letzd2symzf3z21zzast_letz00
																																							(BgL_arg1810z00_1982));
																																					}
																																					if (BgL_testz00_6033)
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_6037;
																																							goto
																																								BgL_tagzd2381zd2_1623;
																																							BgL_auxz00_5718
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_6037);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 115 */
																																							bool_t
																																								BgL_testz00_6039;
																																							{	/* Ast/sexp.scm 115 */
																																								obj_t
																																									BgL_arg1809z00_1981;
																																								BgL_arg1809z00_1981
																																									=
																																									CAR
																																									(BgL_expz00_21);
																																								BgL_testz00_6039
																																									=
																																									CBOOL
																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																									(BgL_arg1809z00_1981));
																																							}
																																							if (BgL_testz00_6039)
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_6043;
																																									goto
																																										BgL_tagzd2383zd2_1625;
																																									BgL_auxz00_5718
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_6043);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 115 */
																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																										{	/* Ast/sexp.scm 115 */
																																											goto
																																												BgL_tagzd2401zd2_1666;
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_6047;
																																											goto
																																												BgL_tagzd2402zd2_1667;
																																											BgL_auxz00_5718
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_6047);
																																										}
																																								}
																																						}
																																				}
																																			return
																																				(
																																				(BgL_nodez00_bglt)
																																				BgL_auxz00_5718);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 115 */
																																			if (CBOOL
																																				(BGl_letzd2symzf3z21zzast_letz00
																																					(BgL_carzd2720zd2_1703)))
																																				{
																																					obj_t
																																						BgL_auxz00_6053;
																																					goto
																																						BgL_kapzd2722zd2_1705;
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_6053);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 115 */
																																					if (
																																						(BgL_carzd2720zd2_1703
																																							==
																																							CNST_TABLE_REF
																																							(((long) 19))))
																																						{
																																							obj_t
																																								BgL_auxz00_6058;
																																							goto
																																								BgL_kapzd2722zd2_1705;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_6058);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 115 */
																																							if ((BgL_carzd2720zd2_1703 == CNST_TABLE_REF(((long) 20))))
																																								{
																																									obj_t
																																										BgL_auxz00_6063;
																																									goto
																																										BgL_kapzd2722zd2_1705;
																																									return
																																										(
																																										(BgL_nodez00_bglt)
																																										BgL_auxz00_6063);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 115 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd2720zd2_1703)))
																																										{
																																											obj_t
																																												BgL_auxz00_6068;
																																											goto
																																												BgL_kapzd2722zd2_1705;
																																											return
																																												(
																																												(BgL_nodez00_bglt)
																																												BgL_auxz00_6068);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 115 */
																																											bool_t
																																												BgL_testz00_6070;
																																											{	/* Ast/sexp.scm 115 */
																																												obj_t
																																													BgL_arg1720z00_1867;
																																												BgL_arg1720z00_1867
																																													=
																																													CAR
																																													(BgL_expz00_21);
																																												BgL_testz00_6070
																																													=
																																													CBOOL
																																													(BGl_letzd2symzf3z21zzast_letz00
																																													(BgL_arg1720z00_1867));
																																											}
																																											if (BgL_testz00_6070)
																																												{	/* Ast/sexp.scm 115 */
																																													goto
																																														BgL_tagzd2381zd2_1623;
																																												}
																																											else
																																												{	/* Ast/sexp.scm 115 */
																																													bool_t
																																														BgL_testz00_6074;
																																													{	/* Ast/sexp.scm 115 */
																																														obj_t
																																															BgL_arg1719z00_1866;
																																														BgL_arg1719z00_1866
																																															=
																																															CAR
																																															(BgL_expz00_21);
																																														BgL_testz00_6074
																																															=
																																															CBOOL
																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																															(BgL_arg1719z00_1866));
																																													}
																																													if (BgL_testz00_6074)
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_6078;
																																															goto
																																																BgL_tagzd2383zd2_1625;
																																															return
																																																(
																																																(BgL_nodez00_bglt)
																																																BgL_auxz00_6078);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 115 */
																																															obj_t
																																																BgL_carzd22243zd2_1713;
																																															obj_t
																																																BgL_cdrzd22244zd2_1714;
																																															BgL_carzd22243zd2_1713
																																																=
																																																CAR
																																																(BgL_expz00_21);
																																															BgL_cdrzd22244zd2_1714
																																																=
																																																CDR
																																																(BgL_expz00_21);
																																															{	/* Ast/sexp.scm 115 */
																																																obj_t
																																																	BgL_cdrzd22248zd2_1715;
																																																BgL_cdrzd22248zd2_1715
																																																	=
																																																	CDR
																																																	(BgL_carzd22243zd2_1713);
																																																if ((CAR(BgL_carzd22243zd2_1713) == CNST_TABLE_REF(((long) 3))))
																																																	{	/* Ast/sexp.scm 115 */
																																																		if (PAIRP(BgL_cdrzd22248zd2_1715))
																																																			{	/* Ast/sexp.scm 115 */
																																																				obj_t
																																																					BgL_carzd22251zd2_1718;
																																																				obj_t
																																																					BgL_cdrzd22252zd2_1719;
																																																				BgL_carzd22251zd2_1718
																																																					=
																																																					CAR
																																																					(BgL_cdrzd22248zd2_1715);
																																																				BgL_cdrzd22252zd2_1719
																																																					=
																																																					CDR
																																																					(BgL_cdrzd22248zd2_1715);
																																																				if (PAIRP(BgL_carzd22251zd2_1718))
																																																					{	/* Ast/sexp.scm 115 */
																																																						if (NULLP(CDR(BgL_carzd22251zd2_1718)))
																																																							{	/* Ast/sexp.scm 115 */
																																																								if (PAIRP(BgL_cdrzd22252zd2_1719))
																																																									{	/* Ast/sexp.scm 115 */
																																																										obj_t
																																																											BgL_carzd22258zd2_1723;
																																																										BgL_carzd22258zd2_1723
																																																											=
																																																											CAR
																																																											(BgL_cdrzd22252zd2_1719);
																																																										if (PAIRP(BgL_carzd22258zd2_1723))
																																																											{	/* Ast/sexp.scm 115 */
																																																												if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd22258zd2_1723))
																																																													{	/* Ast/sexp.scm 115 */
																																																														if (NULLP(CDR(BgL_cdrzd22252zd2_1719)))
																																																															{	/* Ast/sexp.scm 115 */
																																																																if (PAIRP(BgL_cdrzd22244zd2_1714))
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		obj_t
																																																																			BgL_carzd22265zd2_1728;
																																																																		BgL_carzd22265zd2_1728
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd22244zd2_1714);
																																																																		if (PAIRP(BgL_carzd22265zd2_1728))
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				obj_t
																																																																					BgL_cdrzd22289zd2_1730;
																																																																				BgL_cdrzd22289zd2_1730
																																																																					=
																																																																					CDR
																																																																					(CAR
																																																																					(BgL_expz00_21));
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_6117;
																																																																					obj_t
																																																																						BgL_bodyz00_6115;
																																																																					obj_t
																																																																						BgL_varsz00_6113;
																																																																					BgL_varsz00_6113
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd22289zd2_1730);
																																																																					BgL_bodyz00_6115
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd22289zd2_1730);
																																																																					BgL_argsz00_6117
																																																																						=
																																																																						CDR
																																																																						(BgL_expz00_21);
																																																																					BgL_argsz00_1632
																																																																						=
																																																																						BgL_argsz00_6117;
																																																																					BgL_bodyz00_1631
																																																																						=
																																																																						BgL_bodyz00_6115;
																																																																					BgL_varsz00_1630
																																																																						=
																																																																						BgL_varsz00_6113;
																																																																					goto
																																																																						BgL_tagzd2385zd2_1633;
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				if (NULLP(CDR(BgL_cdrzd22244zd2_1714)))
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						obj_t
																																																																							BgL_arg1530z00_1736;
																																																																						BgL_arg1530z00_1736
																																																																							=
																																																																							CAR
																																																																							(BgL_carzd22251zd2_1718);
																																																																						{
																																																																							BgL_castz00_bglt
																																																																								BgL_auxz00_6123;
																																																																							BgL_varz00_1626
																																																																								=
																																																																								BgL_arg1530z00_1736;
																																																																							BgL_bodyz00_1627
																																																																								=
																																																																								BgL_carzd22258zd2_1723;
																																																																							BgL_argz00_1628
																																																																								=
																																																																								BgL_carzd22265zd2_1728;
																																																																						BgL_tagzd2384zd2_1629:
																																																																							{	/* Ast/sexp.scm 336 */
																																																																								BgL_castz00_bglt
																																																																									BgL_new1131z00_2759;
																																																																								{	/* Ast/sexp.scm 337 */
																																																																									BgL_castz00_bglt
																																																																										BgL_new1129z00_2761;
																																																																									BgL_new1129z00_2761
																																																																										=
																																																																										(
																																																																										(BgL_castz00_bglt)
																																																																										BREF
																																																																										(GC_MALLOC
																																																																											(sizeof
																																																																												(struct
																																																																													BgL_castz00_bgl))));
																																																																									{	/* Ast/sexp.scm 337 */
																																																																										long
																																																																											BgL_arg2368z00_2762;
																																																																										{	/* Ast/sexp.scm 337 */
																																																																											long
																																																																												BgL_res2940z00_3860;
																																																																											BgL_res2940z00_3860
																																																																												=
																																																																												BGL_CLASS_INDEX
																																																																												(BGl_castz00zzast_nodez00);
																																																																											BgL_arg2368z00_2762
																																																																												=
																																																																												BgL_res2940z00_3860;
																																																																										}
																																																																										BGL_OBJECT_CLASS_NUM_SET
																																																																											(
																																																																											((BgL_objectz00_bglt) BgL_new1129z00_2761), BgL_arg2368z00_2762);
																																																																									}
																																																																									{	/* Ast/sexp.scm 337 */
																																																																										BgL_objectz00_bglt
																																																																											BgL_auxz00_6128;
																																																																										BgL_auxz00_6128
																																																																											=
																																																																											(
																																																																											(BgL_objectz00_bglt)
																																																																											BgL_new1129z00_2761);
																																																																										BGL_OBJECT_WIDENING_SET
																																																																											(BgL_auxz00_6128,
																																																																											BFALSE);
																																																																									}
																																																																									BgL_new1131z00_2759
																																																																										=
																																																																										BgL_new1129z00_2761;
																																																																								}
																																																																								((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1131z00_2759)))->BgL_locz00) = ((obj_t) BgL_locz00_23), BUNSPEC);
																																																																								{
																																																																									BgL_typez00_bglt
																																																																										BgL_auxz00_6133;
																																																																									{	/* Ast/sexp.scm 338 */
																																																																										obj_t
																																																																											BgL_arg2367z00_2760;
																																																																										BgL_arg2367z00_2760
																																																																											=
																																																																											BGl_castzd2sexpzd2typez00zzast_privatez00
																																																																											(BgL_bodyz00_1627);
																																																																										BgL_auxz00_6133
																																																																											=
																																																																											BGl_usezd2typez12zc0zztype_envz00
																																																																											(BgL_arg2367z00_2760,
																																																																											BgL_locz00_23);
																																																																									}
																																																																									((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1131z00_2759)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_6133), BUNSPEC);
																																																																								}
																																																																								((((BgL_castz00_bglt) CREF(BgL_new1131z00_2759))->BgL_argz00) = ((BgL_nodez00_bglt) BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_argz00_1628, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24)), BUNSPEC);
																																																																								BgL_auxz00_6123
																																																																									=
																																																																									BgL_new1131z00_2759;
																																																																							}
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_6123);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						obj_t
																																																																							BgL_cdrzd22316zd2_1737;
																																																																						BgL_cdrzd22316zd2_1737
																																																																							=
																																																																							CDR
																																																																							(CAR
																																																																							(BgL_expz00_21));
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_6147;
																																																																							obj_t
																																																																								BgL_bodyz00_6145;
																																																																							obj_t
																																																																								BgL_varsz00_6143;
																																																																							BgL_varsz00_6143
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd22316zd2_1737);
																																																																							BgL_bodyz00_6145
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd22316zd2_1737);
																																																																							BgL_argsz00_6147
																																																																								=
																																																																								CDR
																																																																								(BgL_expz00_21);
																																																																							BgL_argsz00_1632
																																																																								=
																																																																								BgL_argsz00_6147;
																																																																							BgL_bodyz00_1631
																																																																								=
																																																																								BgL_bodyz00_6145;
																																																																							BgL_varsz00_1630
																																																																								=
																																																																								BgL_varsz00_6143;
																																																																							goto
																																																																								BgL_tagzd2385zd2_1633;
																																																																						}
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		obj_t
																																																																			BgL_cdrzd22342zd2_1743;
																																																																		BgL_cdrzd22342zd2_1743
																																																																			=
																																																																			CDR
																																																																			(CAR
																																																																			(BgL_expz00_21));
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_6155;
																																																																			obj_t
																																																																				BgL_bodyz00_6153;
																																																																			obj_t
																																																																				BgL_varsz00_6151;
																																																																			BgL_varsz00_6151
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd22342zd2_1743);
																																																																			BgL_bodyz00_6153
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd22342zd2_1743);
																																																																			BgL_argsz00_6155
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			BgL_argsz00_1632
																																																																				=
																																																																				BgL_argsz00_6155;
																																																																			BgL_bodyz00_1631
																																																																				=
																																																																				BgL_bodyz00_6153;
																																																																			BgL_varsz00_1630
																																																																				=
																																																																				BgL_varsz00_6151;
																																																																			goto
																																																																				BgL_tagzd2385zd2_1633;
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 115 */
																																																																obj_t
																																																																	BgL_cdrzd22368zd2_1748;
																																																																BgL_cdrzd22368zd2_1748
																																																																	=
																																																																	CDR
																																																																	(CAR
																																																																	(BgL_expz00_21));
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_6163;
																																																																	obj_t
																																																																		BgL_bodyz00_6161;
																																																																	obj_t
																																																																		BgL_varsz00_6159;
																																																																	BgL_varsz00_6159
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd22368zd2_1748);
																																																																	BgL_bodyz00_6161
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd22368zd2_1748);
																																																																	BgL_argsz00_6163
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	BgL_argsz00_1632
																																																																		=
																																																																		BgL_argsz00_6163;
																																																																	BgL_bodyz00_1631
																																																																		=
																																																																		BgL_bodyz00_6161;
																																																																	BgL_varsz00_1630
																																																																		=
																																																																		BgL_varsz00_6159;
																																																																	goto
																																																																		BgL_tagzd2385zd2_1633;
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 115 */
																																																														obj_t
																																																															BgL_cdrzd22394zd2_1754;
																																																														BgL_cdrzd22394zd2_1754
																																																															=
																																																															CDR
																																																															(CAR
																																																															(BgL_expz00_21));
																																																														{
																																																															obj_t
																																																																BgL_argsz00_6171;
																																																															obj_t
																																																																BgL_bodyz00_6169;
																																																															obj_t
																																																																BgL_varsz00_6167;
																																																															BgL_varsz00_6167
																																																																=
																																																																CAR
																																																																(BgL_cdrzd22394zd2_1754);
																																																															BgL_bodyz00_6169
																																																																=
																																																																CDR
																																																																(BgL_cdrzd22394zd2_1754);
																																																															BgL_argsz00_6171
																																																																=
																																																																CDR
																																																																(BgL_expz00_21);
																																																															BgL_argsz00_1632
																																																																=
																																																																BgL_argsz00_6171;
																																																															BgL_bodyz00_1631
																																																																=
																																																																BgL_bodyz00_6169;
																																																															BgL_varsz00_1630
																																																																=
																																																																BgL_varsz00_6167;
																																																															goto
																																																																BgL_tagzd2385zd2_1633;
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 115 */
																																																												obj_t
																																																													BgL_cdrzd22420zd2_1759;
																																																												BgL_cdrzd22420zd2_1759
																																																													=
																																																													CDR
																																																													(BgL_carzd22243zd2_1713);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_6178;
																																																													obj_t
																																																														BgL_bodyz00_6176;
																																																													obj_t
																																																														BgL_varsz00_6174;
																																																													BgL_varsz00_6174
																																																														=
																																																														CAR
																																																														(BgL_cdrzd22420zd2_1759);
																																																													BgL_bodyz00_6176
																																																														=
																																																														CDR
																																																														(BgL_cdrzd22420zd2_1759);
																																																													BgL_argsz00_6178
																																																														=
																																																														CDR
																																																														(BgL_expz00_21);
																																																													BgL_argsz00_1632
																																																														=
																																																														BgL_argsz00_6178;
																																																													BgL_bodyz00_1631
																																																														=
																																																														BgL_bodyz00_6176;
																																																													BgL_varsz00_1630
																																																														=
																																																														BgL_varsz00_6174;
																																																													goto
																																																														BgL_tagzd2385zd2_1633;
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 115 */
																																																										obj_t
																																																											BgL_cdrzd22446zd2_1764;
																																																										BgL_cdrzd22446zd2_1764
																																																											=
																																																											CDR
																																																											(BgL_carzd22243zd2_1713);
																																																										{
																																																											obj_t
																																																												BgL_argsz00_6185;
																																																											obj_t
																																																												BgL_bodyz00_6183;
																																																											obj_t
																																																												BgL_varsz00_6181;
																																																											BgL_varsz00_6181
																																																												=
																																																												CAR
																																																												(BgL_cdrzd22446zd2_1764);
																																																											BgL_bodyz00_6183
																																																												=
																																																												CDR
																																																												(BgL_cdrzd22446zd2_1764);
																																																											BgL_argsz00_6185
																																																												=
																																																												CDR
																																																												(BgL_expz00_21);
																																																											BgL_argsz00_1632
																																																												=
																																																												BgL_argsz00_6185;
																																																											BgL_bodyz00_1631
																																																												=
																																																												BgL_bodyz00_6183;
																																																											BgL_varsz00_1630
																																																												=
																																																												BgL_varsz00_6181;
																																																											goto
																																																												BgL_tagzd2385zd2_1633;
																																																										}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								obj_t
																																																									BgL_cdrzd22472zd2_1769;
																																																								BgL_cdrzd22472zd2_1769
																																																									=
																																																									CDR
																																																									(BgL_carzd22243zd2_1713);
																																																								{
																																																									obj_t
																																																										BgL_argsz00_6192;
																																																									obj_t
																																																										BgL_bodyz00_6190;
																																																									obj_t
																																																										BgL_varsz00_6188;
																																																									BgL_varsz00_6188
																																																										=
																																																										CAR
																																																										(BgL_cdrzd22472zd2_1769);
																																																									BgL_bodyz00_6190
																																																										=
																																																										CDR
																																																										(BgL_cdrzd22472zd2_1769);
																																																									BgL_argsz00_6192
																																																										=
																																																										CDR
																																																										(BgL_expz00_21);
																																																									BgL_argsz00_1632
																																																										=
																																																										BgL_argsz00_6192;
																																																									BgL_bodyz00_1631
																																																										=
																																																										BgL_bodyz00_6190;
																																																									BgL_varsz00_1630
																																																										=
																																																										BgL_varsz00_6188;
																																																									goto
																																																										BgL_tagzd2385zd2_1633;
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						obj_t
																																																							BgL_cdrzd22498zd2_1775;
																																																						BgL_cdrzd22498zd2_1775
																																																							=
																																																							CDR
																																																							(BgL_carzd22243zd2_1713);
																																																						{
																																																							obj_t
																																																								BgL_argsz00_6199;
																																																							obj_t
																																																								BgL_bodyz00_6197;
																																																							obj_t
																																																								BgL_varsz00_6195;
																																																							BgL_varsz00_6195
																																																								=
																																																								CAR
																																																								(BgL_cdrzd22498zd2_1775);
																																																							BgL_bodyz00_6197
																																																								=
																																																								CDR
																																																								(BgL_cdrzd22498zd2_1775);
																																																							BgL_argsz00_6199
																																																								=
																																																								CDR
																																																								(BgL_expz00_21);
																																																							BgL_argsz00_1632
																																																								=
																																																								BgL_argsz00_6199;
																																																							BgL_bodyz00_1631
																																																								=
																																																								BgL_bodyz00_6197;
																																																							BgL_varsz00_1630
																																																								=
																																																								BgL_varsz00_6195;
																																																							goto
																																																								BgL_tagzd2385zd2_1633;
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{
																																																						obj_t
																																																							BgL_auxz00_6203;
																																																						goto
																																																							BgL_tagzd2401zd2_1666;
																																																						return
																																																							(
																																																							(BgL_nodez00_bglt)
																																																							BgL_auxz00_6203);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						goto
																																																							BgL_tagzd2402zd2_1667;
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 115 */
																																																		obj_t
																																																			BgL_cdrzd22631zd2_1783;
																																																		BgL_cdrzd22631zd2_1783
																																																			=
																																																			CDR
																																																			(BgL_carzd22243zd2_1713);
																																																		if ((CAR(BgL_carzd22243zd2_1713) == CNST_TABLE_REF(((long) 1))))
																																																			{	/* Ast/sexp.scm 115 */
																																																				if (PAIRP(BgL_cdrzd22631zd2_1783))
																																																					{	/* Ast/sexp.scm 115 */
																																																						obj_t
																																																							BgL_cdrzd22636zd2_1786;
																																																						BgL_cdrzd22636zd2_1786
																																																							=
																																																							CDR
																																																							(BgL_cdrzd22631zd2_1783);
																																																						if (PAIRP(BgL_cdrzd22636zd2_1786))
																																																							{	/* Ast/sexp.scm 115 */
																																																								obj_t
																																																									BgL_carzd22640zd2_1788;
																																																								obj_t
																																																									BgL_cdrzd22641zd2_1789;
																																																								BgL_carzd22640zd2_1788
																																																									=
																																																									CAR
																																																									(BgL_cdrzd22636zd2_1786);
																																																								BgL_cdrzd22641zd2_1789
																																																									=
																																																									CDR
																																																									(BgL_cdrzd22636zd2_1786);
																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22640zd2_1788))
																																																									{	/* Ast/sexp.scm 115 */
																																																										if (PAIRP(BgL_cdrzd22641zd2_1789))
																																																											{	/* Ast/sexp.scm 115 */
																																																												obj_t
																																																													BgL_carzd22646zd2_1792;
																																																												BgL_carzd22646zd2_1792
																																																													=
																																																													CAR
																																																													(BgL_cdrzd22641zd2_1789);
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22646zd2_1792))
																																																													{	/* Ast/sexp.scm 115 */
																																																														if (NULLP(CDR(BgL_cdrzd22641zd2_1789)))
																																																															{	/* Ast/sexp.scm 115 */
																																																																bool_t
																																																																	BgL_testz00_6227;
																																																																{
																																																																	obj_t
																																																																		BgL_l1352z00_1813;
																																																																	BgL_l1352z00_1813
																																																																		=
																																																																		BgL_cdrzd22244zd2_1714;
																																																																BgL_zc3anonymousza31681ze3z83_1814:
																																																																	if (NULLP(BgL_l1352z00_1813))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			BgL_testz00_6227
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				1);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			bool_t
																																																																				BgL_testz00_6230;
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				bool_t
																																																																					BgL_testz00_6231;
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					obj_t
																																																																						BgL_auxz00_6232;
																																																																					BgL_auxz00_6232
																																																																						=
																																																																						CAR
																																																																						(BgL_l1352z00_1813);
																																																																					BgL_testz00_6231
																																																																						=
																																																																						PAIRP
																																																																						(BgL_auxz00_6232);
																																																																				}
																																																																				if (BgL_testz00_6231)
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						BgL_testz00_6230
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						BgL_testz00_6230
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																			}
																																																																			if (BgL_testz00_6230)
																																																																				{
																																																																					obj_t
																																																																						BgL_l1352z00_6235;
																																																																					BgL_l1352z00_6235
																																																																						=
																																																																						CDR
																																																																						(BgL_l1352z00_1813);
																																																																					BgL_l1352z00_1813
																																																																						=
																																																																						BgL_l1352z00_6235;
																																																																					goto
																																																																						BgL_zc3anonymousza31681ze3z83_1814;
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					BgL_testz00_6227
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																		}
																																																																}
																																																																if (BgL_testz00_6227)
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_6241;
																																																																		obj_t
																																																																			BgL_proc2z00_6240;
																																																																		obj_t
																																																																			BgL_proc1z00_6239;
																																																																		obj_t
																																																																			BgL_testz00_6237;
																																																																		BgL_testz00_6237
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd22631zd2_1783);
																																																																		BgL_proc1z00_6239
																																																																			=
																																																																			BgL_carzd22640zd2_1788;
																																																																		BgL_proc2z00_6240
																																																																			=
																																																																			BgL_carzd22646zd2_1792;
																																																																		BgL_argsz00_6241
																																																																			=
																																																																			BgL_cdrzd22244zd2_1714;
																																																																		BgL_argsz00_1637
																																																																			=
																																																																			BgL_argsz00_6241;
																																																																		BgL_proc2z00_1636
																																																																			=
																																																																			BgL_proc2z00_6240;
																																																																		BgL_proc1z00_1635
																																																																			=
																																																																			BgL_proc1z00_6239;
																																																																		BgL_testz00_1634
																																																																			=
																																																																			BgL_testz00_6237;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1638;
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		obj_t
																																																																			BgL_cdrzd22671zd2_1797;
																																																																		BgL_cdrzd22671zd2_1797
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			obj_t
																																																																				BgL_cdrzd22679zd2_1798;
																																																																			BgL_cdrzd22679zd2_1798
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				obj_t
																																																																					BgL_cdrzd22687zd2_1799;
																																																																				BgL_cdrzd22687zd2_1799
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd22679zd2_1798);
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					obj_t
																																																																						BgL_carzd22694zd2_1800;
																																																																					BgL_carzd22694zd2_1800
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd22687zd2_1799);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22694zd2_1800))
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							obj_t
																																																																								BgL_carzd22703zd2_1802;
																																																																							BgL_carzd22703zd2_1802
																																																																								=
																																																																								CAR
																																																																								(CDR
																																																																								(BgL_cdrzd22687zd2_1799));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22703zd2_1802))
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22671zd2_1797))
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_6259;
																																																																											obj_t
																																																																												BgL_proc2z00_6258;
																																																																											obj_t
																																																																												BgL_proc1z00_6257;
																																																																											obj_t
																																																																												BgL_testz00_6255;
																																																																											BgL_testz00_6255
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd22679zd2_1798);
																																																																											BgL_proc1z00_6257
																																																																												=
																																																																												BgL_carzd22694zd2_1800;
																																																																											BgL_proc2z00_6258
																																																																												=
																																																																												BgL_carzd22703zd2_1802;
																																																																											BgL_argsz00_6259
																																																																												=
																																																																												BgL_cdrzd22671zd2_1797;
																																																																											BgL_argsz00_1642
																																																																												=
																																																																												BgL_argsz00_6259;
																																																																											BgL_proc2z00_1641
																																																																												=
																																																																												BgL_proc2z00_6258;
																																																																											BgL_proc1z00_1640
																																																																												=
																																																																												BgL_proc1z00_6257;
																																																																											BgL_testz00_1639
																																																																												=
																																																																												BgL_testz00_6255;
																																																																											goto
																																																																												BgL_tagzd2387zd2_1643;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 115 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_6262;
																																																																													goto
																																																																														BgL_tagzd2401zd2_1666;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_6262);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 115 */
																																																																													goto
																																																																														BgL_tagzd2402zd2_1667;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_6266;
																																																																											goto
																																																																												BgL_tagzd2401zd2_1666;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_6266);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 115 */
																																																																											goto
																																																																												BgL_tagzd2402zd2_1667;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_6270;
																																																																									goto
																																																																										BgL_tagzd2401zd2_1666;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_6270);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									goto
																																																																										BgL_tagzd2402zd2_1667;
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 115 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{
																																																																		obj_t
																																																																			BgL_auxz00_6274;
																																																																		goto
																																																																			BgL_tagzd2401zd2_1666;
																																																																		return
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BgL_auxz00_6274);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		goto
																																																																			BgL_tagzd2402zd2_1667;
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 115 */
																																																														obj_t
																																																															BgL_cdrzd22961zd2_1824;
																																																														BgL_cdrzd22961zd2_1824
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{	/* Ast/sexp.scm 115 */
																																																															obj_t
																																																																BgL_cdrzd22968zd2_1825;
																																																															BgL_cdrzd22968zd2_1825
																																																																=
																																																																CDR
																																																																(CAR
																																																																(BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 115 */
																																																																obj_t
																																																																	BgL_cdrzd22975zd2_1826;
																																																																BgL_cdrzd22975zd2_1826
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd22968zd2_1825);
																																																																{	/* Ast/sexp.scm 115 */
																																																																	obj_t
																																																																		BgL_carzd22981zd2_1827;
																																																																	obj_t
																																																																		BgL_cdrzd22982zd2_1828;
																																																																	BgL_carzd22981zd2_1827
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd22975zd2_1826);
																																																																	BgL_cdrzd22982zd2_1828
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd22975zd2_1826);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22981zd2_1827))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			obj_t
																																																																				BgL_carzd22989zd2_1830;
																																																																			BgL_carzd22989zd2_1830
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd22982zd2_1828);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22989zd2_1830))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (NULLP(CDR(BgL_cdrzd22982zd2_1828)))
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22961zd2_1824))
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_6296;
																																																																									obj_t
																																																																										BgL_proc2z00_6295;
																																																																									obj_t
																																																																										BgL_proc1z00_6294;
																																																																									obj_t
																																																																										BgL_testz00_6292;
																																																																									BgL_testz00_6292
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd22968zd2_1825);
																																																																									BgL_proc1z00_6294
																																																																										=
																																																																										BgL_carzd22981zd2_1827;
																																																																									BgL_proc2z00_6295
																																																																										=
																																																																										BgL_carzd22989zd2_1830;
																																																																									BgL_argsz00_6296
																																																																										=
																																																																										BgL_cdrzd22961zd2_1824;
																																																																									BgL_argsz00_1642
																																																																										=
																																																																										BgL_argsz00_6296;
																																																																									BgL_proc2z00_1641
																																																																										=
																																																																										BgL_proc2z00_6295;
																																																																									BgL_proc1z00_1640
																																																																										=
																																																																										BgL_proc1z00_6294;
																																																																									BgL_testz00_1639
																																																																										=
																																																																										BgL_testz00_6292;
																																																																									goto
																																																																										BgL_tagzd2387zd2_1643;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_6299;
																																																																											goto
																																																																												BgL_tagzd2401zd2_1666;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_6299);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 115 */
																																																																											goto
																																																																												BgL_tagzd2402zd2_1667;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_6303;
																																																																									goto
																																																																										BgL_tagzd2401zd2_1666;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_6303);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									goto
																																																																										BgL_tagzd2402zd2_1667;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_6307;
																																																																							goto
																																																																								BgL_tagzd2401zd2_1666;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_6307);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							goto
																																																																								BgL_tagzd2402zd2_1667;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{
																																																																					obj_t
																																																																						BgL_auxz00_6311;
																																																																					goto
																																																																						BgL_tagzd2401zd2_1666;
																																																																					return
																																																																						(
																																																																						(BgL_nodez00_bglt)
																																																																						BgL_auxz00_6311);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					goto
																																																																						BgL_tagzd2402zd2_1667;
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 115 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{
																																																														obj_t
																																																															BgL_auxz00_6315;
																																																														goto
																																																															BgL_tagzd2401zd2_1666;
																																																														return
																																																															(
																																																															(BgL_nodez00_bglt)
																																																															BgL_auxz00_6315);
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 115 */
																																																														goto
																																																															BgL_tagzd2402zd2_1667;
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 115 */
																																																										obj_t
																																																											BgL_cdrzd23297zd2_1842;
																																																										BgL_cdrzd23297zd2_1842
																																																											=
																																																											CDR
																																																											(BgL_expz00_21);
																																																										{	/* Ast/sexp.scm 115 */
																																																											obj_t
																																																												BgL_cdrzd23303zd2_1843;
																																																											BgL_cdrzd23303zd2_1843
																																																												=
																																																												CDR
																																																												(CAR
																																																												(BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 115 */
																																																												obj_t
																																																													BgL_cdrzd23309zd2_1844;
																																																												BgL_cdrzd23309zd2_1844
																																																													=
																																																													CDR
																																																													(BgL_cdrzd23303zd2_1843);
																																																												{	/* Ast/sexp.scm 115 */
																																																													obj_t
																																																														BgL_carzd23314zd2_1845;
																																																													obj_t
																																																														BgL_cdrzd23315zd2_1846;
																																																													BgL_carzd23314zd2_1845
																																																														=
																																																														CAR
																																																														(BgL_cdrzd23309zd2_1844);
																																																													BgL_cdrzd23315zd2_1846
																																																														=
																																																														CDR
																																																														(BgL_cdrzd23309zd2_1844);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23314zd2_1845))
																																																														{	/* Ast/sexp.scm 115 */
																																																															if (PAIRP(BgL_cdrzd23315zd2_1846))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	obj_t
																																																																		BgL_carzd23320zd2_1849;
																																																																	BgL_carzd23320zd2_1849
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd23315zd2_1846);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23320zd2_1849))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (NULLP(CDR(BgL_cdrzd23315zd2_1846)))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd23297zd2_1842))
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_6339;
																																																																							obj_t
																																																																								BgL_proc2z00_6338;
																																																																							obj_t
																																																																								BgL_proc1z00_6337;
																																																																							obj_t
																																																																								BgL_testz00_6335;
																																																																							BgL_testz00_6335
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd23303zd2_1843);
																																																																							BgL_proc1z00_6337
																																																																								=
																																																																								BgL_carzd23314zd2_1845;
																																																																							BgL_proc2z00_6338
																																																																								=
																																																																								BgL_carzd23320zd2_1849;
																																																																							BgL_argsz00_6339
																																																																								=
																																																																								BgL_cdrzd23297zd2_1842;
																																																																							BgL_argsz00_1642
																																																																								=
																																																																								BgL_argsz00_6339;
																																																																							BgL_proc2z00_1641
																																																																								=
																																																																								BgL_proc2z00_6338;
																																																																							BgL_proc1z00_1640
																																																																								=
																																																																								BgL_proc1z00_6337;
																																																																							BgL_testz00_1639
																																																																								=
																																																																								BgL_testz00_6335;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1643;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_6342;
																																																																									goto
																																																																										BgL_tagzd2401zd2_1666;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_6342);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									goto
																																																																										BgL_tagzd2402zd2_1667;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_6346;
																																																																							goto
																																																																								BgL_tagzd2401zd2_1666;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_6346);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							goto
																																																																								BgL_tagzd2402zd2_1667;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{
																																																																					obj_t
																																																																						BgL_auxz00_6350;
																																																																					goto
																																																																						BgL_tagzd2401zd2_1666;
																																																																					return
																																																																						(
																																																																						(BgL_nodez00_bglt)
																																																																						BgL_auxz00_6350);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					goto
																																																																						BgL_tagzd2402zd2_1667;
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{
																																																																			obj_t
																																																																				BgL_auxz00_6354;
																																																																			goto
																																																																				BgL_tagzd2401zd2_1666;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_6354);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			goto
																																																																				BgL_tagzd2402zd2_1667;
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{
																																																																	obj_t
																																																																		BgL_auxz00_6358;
																																																																	goto
																																																																		BgL_tagzd2401zd2_1666;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_6358);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	goto
																																																																		BgL_tagzd2402zd2_1667;
																																																																}
																																																														}
																																																												}
																																																											}
																																																										}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{
																																																										obj_t
																																																											BgL_auxz00_6362;
																																																										goto
																																																											BgL_tagzd2401zd2_1666;
																																																										return
																																																											(
																																																											(BgL_nodez00_bglt)
																																																											BgL_auxz00_6362);
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 115 */
																																																										goto
																																																											BgL_tagzd2402zd2_1667;
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{
																																																								obj_t
																																																									BgL_auxz00_6366;
																																																								goto
																																																									BgL_tagzd2401zd2_1666;
																																																								return
																																																									(
																																																									(BgL_nodez00_bglt)
																																																									BgL_auxz00_6366);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								goto
																																																									BgL_tagzd2402zd2_1667;
																																																							}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{
																																																						obj_t
																																																							BgL_auxz00_6370;
																																																						goto
																																																							BgL_tagzd2401zd2_1666;
																																																						return
																																																							(
																																																							(BgL_nodez00_bglt)
																																																							BgL_auxz00_6370);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						goto
																																																							BgL_tagzd2402zd2_1667;
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															}
																														else
																															{	/* Ast/sexp.scm 115 */
																																if (
																																	(BgL_carzd2717zd2_1701
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				18))))
																																	{	/* Ast/sexp.scm 115 */
																																		goto
																																			BgL_tagzd2381zd2_1623;
																																	}
																																else
																																	{	/* Ast/sexp.scm 115 */
																																		if (CBOOL
																																			(BGl_letzd2symzf3z21zzast_letz00
																																				(BgL_carzd2717zd2_1701)))
																																			{	/* Ast/sexp.scm 115 */
																																				goto
																																					BgL_tagzd2381zd2_1623;
																																			}
																																		else
																																			{	/* Ast/sexp.scm 115 */
																																				if (
																																					(BgL_carzd2717zd2_1701
																																						==
																																						CNST_TABLE_REF
																																						(((long) 19))))
																																					{	/* Ast/sexp.scm 115 */
																																						goto
																																							BgL_tagzd2381zd2_1623;
																																					}
																																				else
																																					{	/* Ast/sexp.scm 115 */
																																						if (
																																							(CAR
																																								(BgL_expz00_21)
																																								==
																																								CNST_TABLE_REF
																																								(((long) 21))))
																																							{	/* Ast/sexp.scm 115 */
																																							BgL_tagzd2382zd2_1624:
																																								return BGl_letrecza2zd2ze3nodez93zzast_letz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																							}
																																						else
																																							{	/* Ast/sexp.scm 115 */
																																								obj_t
																																									BgL_carzd23842zd2_1988;
																																								BgL_carzd23842zd2_1988
																																									=
																																									CAR
																																									(BgL_expz00_21);
																																								if ((BgL_carzd23842zd2_1988 == CNST_TABLE_REF(((long) 20))))
																																									{
																																										BgL_letzd2funzd2_bglt
																																											BgL_auxz00_6391;
																																										goto
																																											BgL_tagzd2383zd2_1625;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_6391);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 115 */
																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd23842zd2_1988)))
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_6396;
																																												goto
																																													BgL_tagzd2383zd2_1625;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_6396);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 115 */
																																												if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																													{	/* Ast/sexp.scm 115 */
																																													BgL_tagzd2388zd2_1644:
																																														{
																																															obj_t
																																																BgL_argsz00_2892;
																																															obj_t
																																																BgL_bodyz00_2893;
																																															if (PAIRP(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 115 */
																																																	obj_t
																																																		BgL_cdrzd28006zd2_2898;
																																																	BgL_cdrzd28006zd2_2898
																																																		=
																																																		CDR
																																																		(BgL_expz00_21);
																																																	if (PAIRP(BgL_cdrzd28006zd2_2898))
																																																		{	/* Ast/sexp.scm 115 */
																																																			BgL_argsz00_2892
																																																				=
																																																				CAR
																																																				(BgL_cdrzd28006zd2_2898);
																																																			BgL_bodyz00_2893
																																																				=
																																																				CDR
																																																				(BgL_cdrzd28006zd2_2898);
																																																			{	/* Ast/sexp.scm 411 */
																																																				obj_t
																																																					BgL_locz00_2902;
																																																				obj_t
																																																					BgL_funz00_2903;
																																																				BgL_locz00_2902
																																																					=
																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																					(BgL_expz00_21,
																																																					BgL_locz00_23);
																																																				BgL_funz00_2903
																																																					=
																																																					BGl_makezd2anonymouszd2namez00zzast_sexpz00
																																																					(BgL_locz00_23,
																																																					BNIL);
																																																				{	/* Ast/sexp.scm 413 */
																																																					obj_t
																																																						BgL_arg2474z00_2904;
																																																					{	/* Ast/sexp.scm 413 */
																																																						obj_t
																																																							BgL_arg2475z00_2905;
																																																						obj_t
																																																							BgL_arg2476z00_2906;
																																																						BgL_arg2475z00_2905
																																																							=
																																																							BGl_labelszd2symzd2zzast_labelsz00
																																																							();
																																																						{	/* Ast/sexp.scm 413 */
																																																							obj_t
																																																								BgL_arg2478z00_2907;
																																																							obj_t
																																																								BgL_arg2479z00_2908;
																																																							{	/* Ast/sexp.scm 413 */
																																																								obj_t
																																																									BgL_arg2480z00_2909;
																																																								{	/* Ast/sexp.scm 413 */
																																																									obj_t
																																																										BgL_arg2481z00_2910;
																																																									{	/* Ast/sexp.scm 413 */
																																																										obj_t
																																																											BgL_arg2482z00_2911;
																																																										BgL_arg2482z00_2911
																																																											=
																																																											MAKE_PAIR
																																																											(BGl_normaliza7ezd2prognz75zztools_prognz00
																																																											(BgL_bodyz00_2893),
																																																											BNIL);
																																																										BgL_arg2481z00_2910
																																																											=
																																																											MAKE_PAIR
																																																											(BgL_argsz00_2892,
																																																											BgL_arg2482z00_2911);
																																																									}
																																																									BgL_arg2480z00_2909
																																																										=
																																																										MAKE_PAIR
																																																										(BgL_funz00_2903,
																																																										BgL_arg2481z00_2910);
																																																								}
																																																								BgL_arg2478z00_2907
																																																									=
																																																									MAKE_PAIR
																																																									(BgL_arg2480z00_2909,
																																																									BNIL);
																																																							}
																																																							BgL_arg2479z00_2908
																																																								=
																																																								MAKE_PAIR
																																																								(BgL_funz00_2903,
																																																								BNIL);
																																																							BgL_arg2476z00_2906
																																																								=
																																																								MAKE_PAIR
																																																								(BgL_arg2478z00_2907,
																																																								BgL_arg2479z00_2908);
																																																						}
																																																						BgL_arg2474z00_2904
																																																							=
																																																							MAKE_PAIR
																																																							(BgL_arg2475z00_2905,
																																																							BgL_arg2476z00_2906);
																																																					}
																																																					{
																																																						obj_t
																																																							BgL_locz00_6419;
																																																						obj_t
																																																							BgL_expz00_6418;
																																																						BgL_expz00_6418
																																																							=
																																																							BgL_arg2474z00_2904;
																																																						BgL_locz00_6419
																																																							=
																																																							BgL_locz00_2902;
																																																						BgL_locz00_23
																																																							=
																																																							BgL_locz00_6419;
																																																						BgL_expz00_21
																																																							=
																																																							BgL_expz00_6418;
																																																						goto
																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																																					}
																																																				}
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 115 */
																																																		BgL_tagzd27999zd2_2895:
																																																			{	/* Ast/sexp.scm 420 */
																																																				obj_t
																																																					BgL_arg2485z00_2914;
																																																				BgL_arg2485z00_2914
																																																					=
																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																					(BgL_expz00_21,
																																																					BgL_locz00_23);
																																																				{	/* Ast/sexp.scm 418 */
																																																					BgL_nodez00_bglt
																																																						BgL_res2960z00_3937;
																																																					{	/* Ast/sexp.scm 670 */
																																																						obj_t
																																																							BgL_arg2660z00_3933;
																																																						BgL_nodez00_bglt
																																																							BgL_arg2661z00_3934;
																																																						BgL_arg2660z00_3933
																																																							=
																																																							BGl_shapez00zztools_shapez00
																																																							(BGl_currentzd2functionzd2zztools_errorz00
																																																							());
																																																						BgL_arg2661z00_3934
																																																							=
																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																							(CNST_TABLE_REF
																																																							(((long) 4)), BNIL, BgL_arg2485z00_2914, CNST_TABLE_REF(((long) 2)));
																																																						{	/* Ast/sexp.scm 669 */
																																																							obj_t
																																																								BgL_list2662z00_3936;
																																																							BgL_list2662z00_3936
																																																								=
																																																								MAKE_PAIR
																																																								(
																																																								((obj_t) BgL_arg2661z00_3934), BNIL);
																																																							BgL_res2960z00_3937
																																																								=
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BGl_userzd2errorzf2locationz20zztools_errorz00
																																																								(BgL_arg2485z00_2914,
																																																									BgL_arg2660z00_3933,
																																																									BGl_string3126z00zzast_sexpz00,
																																																									BgL_expz00_21,
																																																									BgL_list2662z00_3936));
																																																					}}
																																																					return
																																																						BgL_res2960z00_3937;
																																																				}
																																																			}
																																																		}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 115 */
																																																	goto
																																																		BgL_tagzd27999zd2_2895;
																																																}
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 115 */
																																														if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																															{	/* Ast/sexp.scm 115 */
																																															BgL_tagzd2389zd2_1645:
																																																return BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 0), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 115 */
																																																obj_t
																																																	BgL_cdrzd23921zd2_1993;
																																																BgL_cdrzd23921zd2_1993
																																																	=
																																																	CDR
																																																	(BgL_expz00_21);
																																																if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																	{	/* Ast/sexp.scm 115 */
																																																		if (PAIRP(BgL_cdrzd23921zd2_1993))
																																																			{	/* Ast/sexp.scm 115 */
																																																				BgL_effectz00_1646
																																																					=
																																																					CAR
																																																					(BgL_cdrzd23921zd2_1993);
																																																				BgL_restz00_1647
																																																					=
																																																					CDR
																																																					(BgL_cdrzd23921zd2_1993);
																																																			BgL_tagzd2390zd2_1648:
																																																				{	/* Ast/sexp.scm 427 */
																																																					BgL_feffectz00_bglt
																																																						BgL_arg2487z00_2915;
																																																					obj_t
																																																						BgL_arg2488z00_2916;
																																																					BgL_arg2487z00_2915
																																																						=
																																																						BGl_parsezd2effectzd2zzeffect_feffectz00
																																																						(BgL_effectz00_1646);
																																																					{	/* Ast/sexp.scm 428 */
																																																						obj_t
																																																							BgL_arg2489z00_2917;
																																																						BgL_arg2489z00_2917
																																																							=
																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																							(BgL_restz00_1647,
																																																							BNIL);
																																																						BgL_arg2488z00_2916
																																																							=
																																																							MAKE_PAIR
																																																							(CNST_TABLE_REF
																																																							(((long) 6)), BgL_arg2489z00_2917);
																																																					}
																																																					return
																																																						BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																						(
																																																						((bool_t) 0), ((obj_t) BgL_arg2487z00_2915), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg2488z00_2916, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{
																																																						obj_t
																																																							BgL_auxz00_6456;
																																																						goto
																																																							BgL_tagzd2401zd2_1666;
																																																						return
																																																							(
																																																							(BgL_nodez00_bglt)
																																																							BgL_auxz00_6456);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						goto
																																																							BgL_tagzd2402zd2_1667;
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 115 */
																																																		if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																			{	/* Ast/sexp.scm 115 */
																																																			BgL_tagzd2391zd2_1649:
																																																				return BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																					{	/* Ast/sexp.scm 115 */
																																																						if (PAIRP(BgL_cdrzd23921zd2_1993))
																																																							{	/* Ast/sexp.scm 115 */
																																																								BgL_effectz00_1650
																																																									=
																																																									CAR
																																																									(BgL_cdrzd23921zd2_1993);
																																																								BgL_restz00_1651
																																																									=
																																																									CDR
																																																									(BgL_cdrzd23921zd2_1993);
																																																							BgL_tagzd2392zd2_1652:
																																																								{	/* Ast/sexp.scm 435 */
																																																									BgL_feffectz00_bglt
																																																										BgL_arg2490z00_2918;
																																																									obj_t
																																																										BgL_arg2491z00_2919;
																																																									BgL_arg2490z00_2918
																																																										=
																																																										BGl_parsezd2effectzd2zzeffect_feffectz00
																																																										(BgL_effectz00_1650);
																																																									{	/* Ast/sexp.scm 436 */
																																																										obj_t
																																																											BgL_arg2493z00_2920;
																																																										BgL_arg2493z00_2920
																																																											=
																																																											BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																											(BgL_restz00_1651,
																																																											BNIL);
																																																										BgL_arg2491z00_2919
																																																											=
																																																											MAKE_PAIR
																																																											(CNST_TABLE_REF
																																																											(((long) 6)), BgL_arg2493z00_2920);
																																																									}
																																																									return
																																																										BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																										(
																																																										((bool_t) 1), ((obj_t) BgL_arg2490z00_2918), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg2491z00_2919, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{
																																																										obj_t
																																																											BgL_auxz00_6481;
																																																										goto
																																																											BgL_tagzd2401zd2_1666;
																																																										return
																																																											(
																																																											(BgL_nodez00_bglt)
																																																											BgL_auxz00_6481);
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 115 */
																																																										goto
																																																											BgL_tagzd2402zd2_1667;
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																							{	/* Ast/sexp.scm 115 */
																																																							BgL_tagzd2393zd2_1653:
																																																								{
																																																									obj_t
																																																										BgL_procz00_2921;
																																																									obj_t
																																																										BgL_msgz00_2922;
																																																									obj_t
																																																										BgL_objz00_2923;
																																																									if (PAIRP(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 115 */
																																																											obj_t
																																																												BgL_cdrzd28023zd2_2928;
																																																											BgL_cdrzd28023zd2_2928
																																																												=
																																																												CDR
																																																												(BgL_expz00_21);
																																																											if (PAIRP(BgL_cdrzd28023zd2_2928))
																																																												{	/* Ast/sexp.scm 115 */
																																																													obj_t
																																																														BgL_cdrzd28028zd2_2930;
																																																													BgL_cdrzd28028zd2_2930
																																																														=
																																																														CDR
																																																														(BgL_cdrzd28023zd2_2928);
																																																													if (PAIRP(BgL_cdrzd28028zd2_2930))
																																																														{	/* Ast/sexp.scm 115 */
																																																															obj_t
																																																																BgL_cdrzd28033zd2_2932;
																																																															BgL_cdrzd28033zd2_2932
																																																																=
																																																																CDR
																																																																(BgL_cdrzd28028zd2_2930);
																																																															if (PAIRP(BgL_cdrzd28033zd2_2932))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (NULLP(CDR(BgL_cdrzd28033zd2_2932)))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			obj_t
																																																																				BgL_arg2499z00_2935;
																																																																			obj_t
																																																																				BgL_arg2501z00_2936;
																																																																			obj_t
																																																																				BgL_arg2502z00_2937;
																																																																			BgL_arg2499z00_2935
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd28023zd2_2928);
																																																																			BgL_arg2501z00_2936
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd28028zd2_2930);
																																																																			BgL_arg2502z00_2937
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd28033zd2_2932);
																																																																			{
																																																																				BgL_failz00_bglt
																																																																					BgL_auxz00_6504;
																																																																				BgL_procz00_2921
																																																																					=
																																																																					BgL_arg2499z00_2935;
																																																																				BgL_msgz00_2922
																																																																					=
																																																																					BgL_arg2501z00_2936;
																																																																				BgL_objz00_2923
																																																																					=
																																																																					BgL_arg2502z00_2937;
																																																																				{	/* Ast/sexp.scm 441 */
																																																																					obj_t
																																																																						BgL_locz00_2939;
																																																																					BgL_locz00_2939
																																																																						=
																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																						(BgL_expz00_21,
																																																																						BgL_locz00_23);
																																																																					{	/* Ast/sexp.scm 441 */
																																																																						obj_t
																																																																							BgL_cdlocz00_2940;
																																																																						BgL_cdlocz00_2940
																																																																							=
																																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																																							(CDR
																																																																							(BgL_expz00_21),
																																																																							BgL_locz00_2939);
																																																																						{	/* Ast/sexp.scm 442 */
																																																																							obj_t
																																																																								BgL_cddlocz00_2941;
																																																																							BgL_cddlocz00_2941
																																																																								=
																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																								(CDR
																																																																								(CDR
																																																																									(BgL_expz00_21)),
																																																																								BgL_locz00_2939);
																																																																							{	/* Ast/sexp.scm 443 */
																																																																								obj_t
																																																																									BgL_cdddlocz00_2942;
																																																																								BgL_cdddlocz00_2942
																																																																									=
																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																									(CDR
																																																																									(CDR
																																																																										(CDR
																																																																											(BgL_expz00_21))),
																																																																									BgL_locz00_2939);
																																																																								{	/* Ast/sexp.scm 444 */
																																																																									obj_t
																																																																										BgL_loczd2proczd2_2943;
																																																																									BgL_loczd2proczd2_2943
																																																																										=
																																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																																										(BgL_procz00_2921,
																																																																										BgL_cdlocz00_2940);
																																																																									{	/* Ast/sexp.scm 445 */
																																																																										obj_t
																																																																											BgL_loczd2msgzd2_2944;
																																																																										BgL_loczd2msgzd2_2944
																																																																											=
																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																											(BgL_msgz00_2922,
																																																																											BgL_cddlocz00_2941);
																																																																										{	/* Ast/sexp.scm 446 */
																																																																											obj_t
																																																																												BgL_loczd2objzd2_2945;
																																																																											BgL_loczd2objzd2_2945
																																																																												=
																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																												(BgL_objz00_2923,
																																																																												BgL_cdddlocz00_2942);
																																																																											{	/* Ast/sexp.scm 447 */
																																																																												BgL_nodez00_bglt
																																																																													BgL_procz00_2946;
																																																																												BgL_procz00_2946
																																																																													=
																																																																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																													(BgL_procz00_2921,
																																																																													BgL_stackz00_22,
																																																																													BgL_loczd2proczd2_2943,
																																																																													CNST_TABLE_REF
																																																																													(((long) 2)));
																																																																												{	/* Ast/sexp.scm 448 */
																																																																													BgL_nodez00_bglt
																																																																														BgL_msgz00_2947;
																																																																													BgL_msgz00_2947
																																																																														=
																																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																														(BgL_msgz00_2922,
																																																																														BgL_stackz00_22,
																																																																														BgL_loczd2msgzd2_2944,
																																																																														CNST_TABLE_REF
																																																																														(((long) 2)));
																																																																													{	/* Ast/sexp.scm 449 */
																																																																														BgL_nodez00_bglt
																																																																															BgL_objz00_2948;
																																																																														BgL_objz00_2948
																																																																															=
																																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																															(BgL_objz00_2923,
																																																																															BgL_stackz00_22,
																																																																															BgL_loczd2objzd2_2945,
																																																																															CNST_TABLE_REF
																																																																															(((long) 2)));
																																																																														{	/* Ast/sexp.scm 450 */

																																																																															{	/* Ast/sexp.scm 451 */
																																																																																BgL_failz00_bglt
																																																																																	BgL_new1133z00_2949;
																																																																																{	/* Ast/sexp.scm 452 */
																																																																																	BgL_failz00_bglt
																																																																																		BgL_new1132z00_2950;
																																																																																	BgL_new1132z00_2950
																																																																																		=
																																																																																		(
																																																																																		(BgL_failz00_bglt)
																																																																																		BREF
																																																																																		(GC_MALLOC
																																																																																			(sizeof
																																																																																				(struct
																																																																																					BgL_failz00_bgl))));
																																																																																	{	/* Ast/sexp.scm 452 */
																																																																																		long
																																																																																			BgL_arg2504z00_2951;
																																																																																		{	/* Ast/sexp.scm 452 */
																																																																																			long
																																																																																				BgL_res2963z00_3957;
																																																																																			BgL_res2963z00_3957
																																																																																				=
																																																																																				BGL_CLASS_INDEX
																																																																																				(BGl_failz00zzast_nodez00);
																																																																																			BgL_arg2504z00_2951
																																																																																				=
																																																																																				BgL_res2963z00_3957;
																																																																																		}
																																																																																		BGL_OBJECT_CLASS_NUM_SET
																																																																																			(
																																																																																			((BgL_objectz00_bglt) BgL_new1132z00_2950), BgL_arg2504z00_2951);
																																																																																	}
																																																																																	{	/* Ast/sexp.scm 452 */
																																																																																		BgL_objectz00_bglt
																																																																																			BgL_auxz00_6528;
																																																																																		BgL_auxz00_6528
																																																																																			=
																																																																																			(
																																																																																			(BgL_objectz00_bglt)
																																																																																			BgL_new1132z00_2950);
																																																																																		BGL_OBJECT_WIDENING_SET
																																																																																			(BgL_auxz00_6528,
																																																																																			BFALSE);
																																																																																	}
																																																																																	BgL_new1133z00_2949
																																																																																		=
																																																																																		BgL_new1132z00_2950;
																																																																																}
																																																																																((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1133z00_2949)))->BgL_locz00) = ((obj_t) BgL_locz00_2939), BUNSPEC);
																																																																																((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1133z00_2949)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2magicza2z00zztype_cachez00)), BUNSPEC);
																																																																																((((BgL_failz00_bglt) CREF(BgL_new1133z00_2949))->BgL_procz00) = ((BgL_nodez00_bglt) BgL_procz00_2946), BUNSPEC);
																																																																																((((BgL_failz00_bglt) CREF(BgL_new1133z00_2949))->BgL_msgz00) = ((BgL_nodez00_bglt) BgL_msgz00_2947), BUNSPEC);
																																																																																((((BgL_failz00_bglt) CREF(BgL_new1133z00_2949))->BgL_objz00) = ((BgL_nodez00_bglt) BgL_objz00_2948), BUNSPEC);
																																																																																BgL_auxz00_6504
																																																																																	=
																																																																																	BgL_new1133z00_2949;
																																																																				}}}}}}}}}}}}
																																																																				return
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BgL_auxz00_6504);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																		BgL_tagzd28014zd2_2925:
																																																																			{	/* Ast/sexp.scm 459 */
																																																																				obj_t
																																																																					BgL_arg2510z00_2955;
																																																																				BgL_arg2510z00_2955
																																																																					=
																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																					(BgL_expz00_21,
																																																																					BgL_locz00_23);
																																																																				{	/* Ast/sexp.scm 458 */
																																																																					BgL_nodez00_bglt
																																																																						BgL_res2964z00_3967;
																																																																					{	/* Ast/sexp.scm 670 */
																																																																						obj_t
																																																																							BgL_arg2660z00_3963;
																																																																						BgL_nodez00_bglt
																																																																							BgL_arg2661z00_3964;
																																																																						BgL_arg2660z00_3963
																																																																							=
																																																																							BGl_shapez00zztools_shapez00
																																																																							(BGl_currentzd2functionzd2zztools_errorz00
																																																																							());
																																																																						BgL_arg2661z00_3964
																																																																							=
																																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																							(CNST_TABLE_REF
																																																																							(((long) 4)), BNIL, BgL_arg2510z00_2955, CNST_TABLE_REF(((long) 2)));
																																																																						{	/* Ast/sexp.scm 669 */
																																																																							obj_t
																																																																								BgL_list2662z00_3966;
																																																																							BgL_list2662z00_3966
																																																																								=
																																																																								MAKE_PAIR
																																																																								(
																																																																								((obj_t) BgL_arg2661z00_3964), BNIL);
																																																																							BgL_res2964z00_3967
																																																																								=
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																								(BgL_arg2510z00_2955,
																																																																									BgL_arg2660z00_3963,
																																																																									BGl_string3125z00zzast_sexpz00,
																																																																									BgL_expz00_21,
																																																																									BgL_list2662z00_3966));
																																																																					}}
																																																																					return
																																																																						BgL_res2964z00_3967;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	goto
																																																																		BgL_tagzd28014zd2_2925;
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																															goto
																																																																BgL_tagzd28014zd2_2925;
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 115 */
																																																													goto
																																																														BgL_tagzd28014zd2_2925;
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 115 */
																																																											goto
																																																												BgL_tagzd28014zd2_2925;
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																									{	/* Ast/sexp.scm 115 */
																																																									BgL_tagzd2394zd2_1654:
																																																										{
																																																											obj_t
																																																												BgL_testz00_2956;
																																																											obj_t
																																																												BgL_clausesz00_2957;
																																																											if (PAIRP(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 115 */
																																																													obj_t
																																																														BgL_cdrzd28047zd2_2962;
																																																													BgL_cdrzd28047zd2_2962
																																																														=
																																																														CDR
																																																														(BgL_expz00_21);
																																																													if (PAIRP(BgL_cdrzd28047zd2_2962))
																																																														{	/* Ast/sexp.scm 115 */
																																																															BgL_testz00_2956
																																																																=
																																																																CAR
																																																																(BgL_cdrzd28047zd2_2962);
																																																															BgL_clausesz00_2957
																																																																=
																																																																CDR
																																																																(BgL_cdrzd28047zd2_2962);
																																																															{	/* Ast/sexp.scm 470 */
																																																																obj_t
																																																																	BgL_locz00_2966;
																																																																BgL_locz00_2966
																																																																	=
																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																	(BgL_expz00_21,
																																																																	BgL_locz00_23);
																																																																{	/* Ast/sexp.scm 470 */
																																																																	obj_t
																																																																		BgL_cdlocz00_2967;
																																																																	BgL_cdlocz00_2967
																																																																		=
																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																		(CDR
																																																																		(BgL_expz00_21),
																																																																		BgL_locz00_2966);
																																																																	{	/* Ast/sexp.scm 471 */
																																																																		obj_t
																																																																			BgL_cddlocz00_2968;
																																																																		BgL_cddlocz00_2968
																																																																			=
																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																			(CDR
																																																																			(BgL_expz00_21),
																																																																			BgL_locz00_2966);
																																																																		{	/* Ast/sexp.scm 472 */
																																																																			BgL_nodez00_bglt
																																																																				BgL_testz00_2969;
																																																																			{	/* Ast/sexp.scm 475 */
																																																																				obj_t
																																																																					BgL_arg2548z00_2999;
																																																																				BgL_arg2548z00_2999
																																																																					=
																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																					(BgL_testz00_2956,
																																																																					BgL_cdlocz00_2967);
																																																																				BgL_testz00_2969
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_testz00_2956,
																																																																					BgL_stackz00_22,
																																																																					BgL_arg2548z00_2999,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																			{	/* Ast/sexp.scm 473 */

																																																																				{
																																																																					obj_t
																																																																						BgL_clsz00_2972;
																																																																					obj_t
																																																																						BgL_nclausesz00_2973;
																																																																					BgL_clsz00_2972
																																																																						=
																																																																						BgL_clausesz00_2957;
																																																																					BgL_nclausesz00_2973
																																																																						=
																																																																						BNIL;
																																																																				BgL_zc3anonymousza32517ze3z83_2974:
																																																																					if (NULLP(BgL_clsz00_2972))
																																																																						{	/* Ast/sexp.scm 480 */
																																																																							BgL_selectz00_bglt
																																																																								BgL_new1137z00_2976;
																																																																							{	/* Ast/sexp.scm 481 */
																																																																								BgL_selectz00_bglt
																																																																									BgL_new1135z00_2980;
																																																																								BgL_new1135z00_2980
																																																																									=
																																																																									(
																																																																									(BgL_selectz00_bglt)
																																																																									BREF
																																																																									(GC_MALLOC
																																																																										(sizeof
																																																																											(struct
																																																																												BgL_selectz00_bgl))));
																																																																								{	/* Ast/sexp.scm 481 */
																																																																									long
																																																																										BgL_arg2524z00_2981;
																																																																									{	/* Ast/sexp.scm 481 */
																																																																										long
																																																																											BgL_res2971z00_3990;
																																																																										BgL_res2971z00_3990
																																																																											=
																																																																											BGL_CLASS_INDEX
																																																																											(BGl_selectz00zzast_nodez00);
																																																																										BgL_arg2524z00_2981
																																																																											=
																																																																											BgL_res2971z00_3990;
																																																																									}
																																																																									BGL_OBJECT_CLASS_NUM_SET
																																																																										(
																																																																										((BgL_objectz00_bglt) BgL_new1135z00_2980), BgL_arg2524z00_2981);
																																																																								}
																																																																								{	/* Ast/sexp.scm 481 */
																																																																									BgL_objectz00_bglt
																																																																										BgL_auxz00_6573;
																																																																									BgL_auxz00_6573
																																																																										=
																																																																										(
																																																																										(BgL_objectz00_bglt)
																																																																										BgL_new1135z00_2980);
																																																																									BGL_OBJECT_WIDENING_SET
																																																																										(BgL_auxz00_6573,
																																																																										BFALSE);
																																																																								}
																																																																								BgL_new1137z00_2976
																																																																									=
																																																																									BgL_new1135z00_2980;
																																																																							}
																																																																							((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1137z00_2976)))->BgL_locz00) = ((obj_t) BgL_locz00_2966), BUNSPEC);
																																																																							((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt) BgL_new1137z00_2976)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																							((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt) BgL_new1137z00_2976)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																							((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt) BgL_new1137z00_2976)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																							((((BgL_selectz00_bglt) CREF(BgL_new1137z00_2976))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_2969), BUNSPEC);
																																																																							((((BgL_selectz00_bglt) CREF(BgL_new1137z00_2976))->BgL_clausesz00) = ((obj_t) bgl_reverse_bang(BgL_nclausesz00_2973)), BUNSPEC);
																																																																							{
																																																																								BgL_typez00_bglt
																																																																									BgL_auxz00_6589;
																																																																								{	/* Ast/sexp.scm 484 */
																																																																									obj_t
																																																																										BgL_arg2519z00_2977;
																																																																									{	/* Ast/sexp.scm 484 */
																																																																										obj_t
																																																																											BgL_pairz00_3995;
																																																																										{	/* Ast/sexp.scm 484 */
																																																																											obj_t
																																																																												BgL_pairz00_3994;
																																																																											BgL_pairz00_3994
																																																																												=
																																																																												CAR
																																																																												(BgL_clausesz00_2957);
																																																																											BgL_pairz00_3995
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_3994);
																																																																										}
																																																																										BgL_arg2519z00_2977
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_3995);
																																																																									}
																																																																									BgL_auxz00_6589
																																																																										=
																																																																										BGl_getzd2typezd2atomz00zztype_typeofz00
																																																																										(BgL_arg2519z00_2977);
																																																																								}
																																																																								((((BgL_selectz00_bglt) CREF(BgL_new1137z00_2976))->BgL_itemzd2typezd2) = ((BgL_typez00_bglt) BgL_auxz00_6589), BUNSPEC);
																																																																							}
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_new1137z00_2976);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 486 */
																																																																							obj_t
																																																																								BgL_clausez00_2982;
																																																																							BgL_clausez00_2982
																																																																								=
																																																																								CAR
																																																																								(BgL_clsz00_2972);
																																																																							{	/* Ast/sexp.scm 486 */
																																																																								BgL_nodez00_bglt
																																																																									BgL_bodyz00_2983;
																																																																								{	/* Ast/sexp.scm 487 */
																																																																									obj_t
																																																																										BgL_arg2543z00_2995;
																																																																									obj_t
																																																																										BgL_arg2544z00_2996;
																																																																									BgL_arg2543z00_2995
																																																																										=
																																																																										BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																										(CDR
																																																																										(BgL_clausez00_2982));
																																																																									BgL_arg2544z00_2996
																																																																										=
																																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																																										(BgL_clausez00_2982,
																																																																										BgL_cddlocz00_2968);
																																																																									BgL_bodyz00_2983
																																																																										=
																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																										(BgL_arg2543z00_2995,
																																																																										BgL_stackz00_22,
																																																																										BgL_arg2544z00_2996,
																																																																										CNST_TABLE_REF
																																																																										(((long) 2)));
																																																																								}
																																																																								{	/* Ast/sexp.scm 487 */
																																																																									obj_t
																																																																										BgL_nclausez00_2984;
																																																																									{	/* Ast/sexp.scm 491 */
																																																																										obj_t
																																																																											BgL_arg2540z00_2994;
																																																																										BgL_arg2540z00_2994
																																																																											=
																																																																											CAR
																																																																											(BgL_clausez00_2982);
																																																																										BgL_nclausez00_2984
																																																																											=
																																																																											MAKE_PAIR
																																																																											(BgL_arg2540z00_2994,
																																																																											((obj_t) BgL_bodyz00_2983));
																																																																									}
																																																																									{	/* Ast/sexp.scm 491 */

																																																																										{	/* Ast/sexp.scm 493 */
																																																																											bool_t
																																																																												BgL_testz00_6605;
																																																																											if ((CAR(BgL_clausez00_2982) == CNST_TABLE_REF(((long) 5))))
																																																																												{	/* Ast/sexp.scm 493 */
																																																																													if (NULLP(CDR(BgL_clsz00_2972)))
																																																																														{	/* Ast/sexp.scm 494 */
																																																																															BgL_testz00_6605
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 494 */
																																																																															BgL_testz00_6605
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 493 */
																																																																													BgL_testz00_6605
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																											if (BgL_testz00_6605)
																																																																												{	/* Ast/sexp.scm 496 */
																																																																													obj_t
																																																																														BgL_arg2530z00_2986;
																																																																													BgL_arg2530z00_2986
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_2966);
																																																																													{	/* Ast/sexp.scm 495 */
																																																																														BgL_nodez00_bglt
																																																																															BgL_res2973z00_4010;
																																																																														{	/* Ast/sexp.scm 670 */
																																																																															obj_t
																																																																																BgL_arg2660z00_4006;
																																																																															BgL_nodez00_bglt
																																																																																BgL_arg2661z00_4007;
																																																																															BgL_arg2660z00_4006
																																																																																=
																																																																																BGl_shapez00zztools_shapez00
																																																																																(BGl_currentzd2functionzd2zztools_errorz00
																																																																																());
																																																																															BgL_arg2661z00_4007
																																																																																=
																																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																(CNST_TABLE_REF
																																																																																(((long) 4)), BNIL, BgL_arg2530z00_2986, CNST_TABLE_REF(((long) 2)));
																																																																															{	/* Ast/sexp.scm 669 */
																																																																																obj_t
																																																																																	BgL_list2662z00_4009;
																																																																																BgL_list2662z00_4009
																																																																																	=
																																																																																	MAKE_PAIR
																																																																																	(
																																																																																	((obj_t) BgL_arg2661z00_4007), BNIL);
																																																																																BgL_res2973z00_4010
																																																																																	=
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																	(BgL_arg2530z00_2986,
																																																																																		BgL_arg2660z00_4006,
																																																																																		BGl_string3124z00zzast_sexpz00,
																																																																																		BgL_expz00_21,
																																																																																		BgL_list2662z00_4009));
																																																																														}}
																																																																														return
																																																																															BgL_res2973z00_4010;
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 497 */
																																																																													obj_t
																																																																														BgL_arg2533z00_2987;
																																																																													obj_t
																																																																														BgL_arg2534z00_2988;
																																																																													BgL_arg2533z00_2987
																																																																														=
																																																																														CDR
																																																																														(BgL_clsz00_2972);
																																																																													BgL_arg2534z00_2988
																																																																														=
																																																																														MAKE_PAIR
																																																																														(BGl_epairifyz00zztools_miscz00
																																																																														(BgL_nclausez00_2984,
																																																																															BgL_clausez00_2982),
																																																																														BgL_nclausesz00_2973);
																																																																													{
																																																																														obj_t
																																																																															BgL_nclausesz00_6627;
																																																																														obj_t
																																																																															BgL_clsz00_6626;
																																																																														BgL_clsz00_6626
																																																																															=
																																																																															BgL_arg2533z00_2987;
																																																																														BgL_nclausesz00_6627
																																																																															=
																																																																															BgL_arg2534z00_2988;
																																																																														BgL_nclausesz00_2973
																																																																															=
																																																																															BgL_nclausesz00_6627;
																																																																														BgL_clsz00_2972
																																																																															=
																																																																															BgL_clsz00_6626;
																																																																														goto
																																																																															BgL_zc3anonymousza32517ze3z83_2974;
																																																																													}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																														BgL_tagzd28040zd2_2959:
																																																															{	/* Ast/sexp.scm 502 */
																																																																obj_t
																																																																	BgL_arg2552z00_3002;
																																																																BgL_arg2552z00_3002
																																																																	=
																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																	(BgL_expz00_21,
																																																																	BgL_locz00_23);
																																																																{	/* Ast/sexp.scm 501 */
																																																																	BgL_nodez00_bglt
																																																																		BgL_res2974z00_4019;
																																																																	{	/* Ast/sexp.scm 670 */
																																																																		obj_t
																																																																			BgL_arg2660z00_4015;
																																																																		BgL_nodez00_bglt
																																																																			BgL_arg2661z00_4016;
																																																																		BgL_arg2660z00_4015
																																																																			=
																																																																			BGl_shapez00zztools_shapez00
																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																			());
																																																																		BgL_arg2661z00_4016
																																																																			=
																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																			(CNST_TABLE_REF
																																																																			(((long) 4)), BNIL, BgL_arg2552z00_3002, CNST_TABLE_REF(((long) 2)));
																																																																		{	/* Ast/sexp.scm 669 */
																																																																			obj_t
																																																																				BgL_list2662z00_4018;
																																																																			BgL_list2662z00_4018
																																																																				=
																																																																				MAKE_PAIR
																																																																				(
																																																																				((obj_t) BgL_arg2661z00_4016), BNIL);
																																																																			BgL_res2974z00_4019
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																				(BgL_arg2552z00_3002,
																																																																					BgL_arg2660z00_4015,
																																																																					BGl_string3124z00zzast_sexpz00,
																																																																					BgL_expz00_21,
																																																																					BgL_list2662z00_4018));
																																																																	}}
																																																																	return
																																																																		BgL_res2974z00_4019;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 115 */
																																																													goto
																																																														BgL_tagzd28040zd2_2959;
																																																												}
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 115 */
																																																										if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																											{
																																																												BgL_letzd2funzd2_bglt
																																																													BgL_auxz00_6644;
																																																											BgL_tagzd2395zd2_1655:
																																																												BgL_auxz00_6644 = BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																												return
																																																													(
																																																													(BgL_nodez00_bglt)
																																																													BgL_auxz00_6644);
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 115 */
																																																												if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																													{
																																																														BgL_jumpzd2exzd2itz00_bglt
																																																															BgL_auxz00_6651;
																																																													BgL_tagzd2396zd2_1656:
																																																														BgL_auxz00_6651 = BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																														return
																																																															(
																																																															(BgL_nodez00_bglt)
																																																															BgL_auxz00_6651);
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 115 */
																																																														obj_t
																																																															BgL_cdrzd24036zd2_2010;
																																																														BgL_cdrzd24036zd2_2010
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																															{	/* Ast/sexp.scm 115 */
																																																																if (PAIRP(BgL_cdrzd24036zd2_2010))
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		obj_t
																																																																			BgL_cdrzd24038zd2_2013;
																																																																		BgL_cdrzd24038zd2_2013
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd24036zd2_2010);
																																																																		if (PAIRP(BgL_cdrzd24038zd2_2013))
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				if (NULLP(CDR(BgL_cdrzd24038zd2_2013)))
																																																																					{	/* Ast/sexp.scm 115 */
																																																																					BgL_tagzd2397zd2_1657:
																																																																						return BGl_applycationzd2ze3nodez31zzast_applyz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_6670;
																																																																								goto
																																																																									BgL_tagzd2401zd2_1666;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_6670);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 115 */
																																																																								goto
																																																																									BgL_tagzd2402zd2_1667;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_6674;
																																																																						goto
																																																																							BgL_tagzd2401zd2_1666;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_6674);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						goto
																																																																							BgL_tagzd2402zd2_1667;
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{
																																																																				obj_t
																																																																					BgL_auxz00_6678;
																																																																				goto
																																																																					BgL_tagzd2401zd2_1666;
																																																																				return
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BgL_auxz00_6678);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				goto
																																																																					BgL_tagzd2402zd2_1667;
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 115 */
																																																																if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		if (PAIRP(BgL_cdrzd24036zd2_2010))
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				obj_t
																																																																					BgL_cdrzd24083zd2_2023;
																																																																				BgL_cdrzd24083zd2_2023
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd24036zd2_2010);
																																																																				if (PAIRP(BgL_cdrzd24083zd2_2023))
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						obj_t
																																																																							BgL_cdrzd24088zd2_2025;
																																																																						BgL_cdrzd24088zd2_2025
																																																																							=
																																																																							CDR
																																																																							(BgL_cdrzd24083zd2_2023);
																																																																						if ((CAR(BgL_cdrzd24083zd2_2023) == CNST_TABLE_REF(((long) 31))))
																																																																							{	/* Ast/sexp.scm 115 */
																																																																								if (PAIRP(BgL_cdrzd24088zd2_2025))
																																																																									{	/* Ast/sexp.scm 115 */
																																																																										obj_t
																																																																											BgL_arg1849z00_2028;
																																																																										obj_t
																																																																											BgL_arg1850z00_2029;
																																																																										obj_t
																																																																											BgL_arg1851z00_2030;
																																																																										BgL_arg1849z00_2028
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd24036zd2_2010);
																																																																										BgL_arg1850z00_2029
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd24088zd2_2025);
																																																																										BgL_arg1851z00_2030
																																																																											=
																																																																											CDR
																																																																											(BgL_cdrzd24088zd2_2025);
																																																																										return
																																																																											BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																											(BgL_expz00_21,
																																																																											BgL_arg1849z00_2028,
																																																																											BgL_arg1850z00_2029,
																																																																											BgL_arg1851z00_2030,
																																																																											BgL_stackz00_22,
																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																											(BgL_expz00_21,
																																																																												BgL_locz00_23),
																																																																											BgL_sitez00_24);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 115 */
																																																																										obj_t
																																																																											BgL_cdrzd24101zd2_2031;
																																																																										BgL_cdrzd24101zd2_2031
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{	/* Ast/sexp.scm 115 */
																																																																											obj_t
																																																																												BgL_arg1853z00_2032;
																																																																											obj_t
																																																																												BgL_arg1854z00_2033;
																																																																											BgL_arg1853z00_2032
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd24101zd2_2031);
																																																																											BgL_arg1854z00_2033
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd24101zd2_2031);
																																																																											{	/* Ast/sexp.scm 516 */
																																																																												obj_t
																																																																													BgL_arg2555z00_4350;
																																																																												BgL_arg2555z00_4350
																																																																													=
																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																													(BgL_expz00_21,
																																																																													BgL_locz00_23);
																																																																												return
																																																																													BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																													(BgL_expz00_21,
																																																																													BgL_arg1853z00_2032,
																																																																													CNST_TABLE_REF
																																																																													(((long) 4)), BgL_arg1854z00_2033, BgL_stackz00_22, BgL_arg2555z00_4350, BgL_sitez00_24);
																																																																							}}}}
																																																																						else
																																																																							{	/* Ast/sexp.scm 115 */
																																																																								obj_t
																																																																									BgL_cdrzd24116zd2_2034;
																																																																								BgL_cdrzd24116zd2_2034
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									obj_t
																																																																										BgL_arg1855z00_2035;
																																																																									obj_t
																																																																										BgL_arg1856z00_2036;
																																																																									BgL_arg1855z00_2035
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd24116zd2_2034);
																																																																									BgL_arg1856z00_2036
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd24116zd2_2034);
																																																																									{	/* Ast/sexp.scm 516 */
																																																																										obj_t
																																																																											BgL_arg2555z00_4356;
																																																																										BgL_arg2555z00_4356
																																																																											=
																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																											(BgL_expz00_21,
																																																																											BgL_locz00_23);
																																																																										return
																																																																											BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																											(BgL_expz00_21,
																																																																											BgL_arg1855z00_2035,
																																																																											CNST_TABLE_REF
																																																																											(((long) 4)), BgL_arg1856z00_2036, BgL_stackz00_22, BgL_arg2555z00_4356, BgL_sitez00_24);
																																																																					}}}}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						obj_t
																																																																							BgL_cdrzd24131zd2_2038;
																																																																						BgL_cdrzd24131zd2_2038
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							obj_t
																																																																								BgL_arg1858z00_2039;
																																																																							obj_t
																																																																								BgL_arg1859z00_2040;
																																																																							BgL_arg1858z00_2039
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd24131zd2_2038);
																																																																							BgL_arg1859z00_2040
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd24131zd2_2038);
																																																																							{	/* Ast/sexp.scm 516 */
																																																																								obj_t
																																																																									BgL_arg2555z00_4362;
																																																																								BgL_arg2555z00_4362
																																																																									=
																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																									(BgL_expz00_21,
																																																																									BgL_locz00_23);
																																																																								return
																																																																									BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																									(BgL_expz00_21,
																																																																									BgL_arg1858z00_2039,
																																																																									CNST_TABLE_REF
																																																																									(((long) 4)), BgL_arg1859z00_2040, BgL_stackz00_22, BgL_arg2555z00_4362, BgL_sitez00_24);
																																																																			}}}}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_6721;
																																																																						goto
																																																																							BgL_tagzd2401zd2_1666;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_6721);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						goto
																																																																							BgL_tagzd2402zd2_1667;
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				if (NULLP(CDR(BgL_expz00_21)))
																																																																					{	/* Ast/sexp.scm 115 */
																																																																					BgL_tagzd2400zd2_1665:
																																																																						{	/* Ast/sexp.scm 520 */
																																																																							obj_t
																																																																								BgL_arg2556z00_3005;
																																																																							BgL_arg2556z00_3005
																																																																								=
																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																								(BgL_expz00_21,
																																																																								BgL_locz00_23);
																																																																							{	/* Ast/sexp.scm 519 */
																																																																								BgL_nodez00_bglt
																																																																									BgL_res2977z00_4036;
																																																																								{	/* Ast/sexp.scm 670 */
																																																																									obj_t
																																																																										BgL_arg2660z00_4032;
																																																																									BgL_nodez00_bglt
																																																																										BgL_arg2661z00_4033;
																																																																									BgL_arg2660z00_4032
																																																																										=
																																																																										BGl_shapez00zztools_shapez00
																																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																																										());
																																																																									BgL_arg2661z00_4033
																																																																										=
																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																										(CNST_TABLE_REF
																																																																										(((long) 4)), BNIL, BgL_arg2556z00_3005, CNST_TABLE_REF(((long) 2)));
																																																																									{	/* Ast/sexp.scm 669 */
																																																																										obj_t
																																																																											BgL_list2662z00_4035;
																																																																										BgL_list2662z00_4035
																																																																											=
																																																																											MAKE_PAIR
																																																																											(
																																																																											((obj_t) BgL_arg2661z00_4033), BNIL);
																																																																										BgL_res2977z00_4036
																																																																											=
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																											(BgL_arg2556z00_3005,
																																																																												BgL_arg2660z00_4032,
																																																																												BGl_string3123z00zzast_sexpz00,
																																																																												BgL_expz00_21,
																																																																												BgL_list2662z00_4035));
																																																																								}}
																																																																								return
																																																																									BgL_res2977z00_4036;
																																																																							}
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_6741;
																																																																								goto
																																																																									BgL_tagzd2401zd2_1666;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_6741);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 115 */
																																																																								goto
																																																																									BgL_tagzd2402zd2_1667;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_6745;
																																																																						goto
																																																																							BgL_tagzd2401zd2_1666;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_6745);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						goto
																																																																							BgL_tagzd2402zd2_1667;
																																																																					}
																																																																			}
																																																																	}
																																																															}
																																																													}
																																																											}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
										else
											{	/* Ast/sexp.scm 115 */
												if (
													(BgL_carzd2468zd2_1672 ==
														CNST_TABLE_REF(((long) 12))))
													{	/* Ast/sexp.scm 115 */
														goto BgL_tagzd2371zd2_1607;
													}
												else
													{	/* Ast/sexp.scm 115 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 15))))
															{
																obj_t BgL_lz00_6754;

																BgL_lz00_6754 = CDR(BgL_expz00_21);
																BgL_lz00_1608 = BgL_lz00_6754;
																goto BgL_tagzd2372zd2_1609;
															}
														else
															{	/* Ast/sexp.scm 115 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 13))))
																	{	/* Ast/sexp.scm 115 */
																		goto BgL_tagzd2373zd2_1610;
																	}
																else
																	{	/* Ast/sexp.scm 115 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 16))))
																			{	/* Ast/sexp.scm 115 */
																				if (NULLP(CDR(BgL_expz00_21)))
																					{	/* Ast/sexp.scm 115 */
																						goto BgL_tagzd2374zd2_1611;
																					}
																				else
																					{	/* Ast/sexp.scm 115 */
																						obj_t BgL_arg1894z00_2078;

																						BgL_arg1894z00_2078 =
																							CDR(BgL_expz00_21);
																						{
																							BgL_sequencez00_bglt
																								BgL_auxz00_6768;
																							{
																								obj_t BgL_bodyz00_6769;

																								BgL_bodyz00_6769 =
																									BgL_arg1894z00_2078;
																								BgL_bodyz00_1612 =
																									BgL_bodyz00_6769;
																								goto BgL_tagzd2375zd2_1613;
																							}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_6768);
																						}
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 115 */
																				obj_t BgL_carzd24263zd2_2080;

																				BgL_carzd24263zd2_2080 =
																					CAR(BgL_expz00_21);
																				if (
																					(BgL_carzd24263zd2_2080 ==
																						CNST_TABLE_REF(((long) 1))))
																					{	/* Ast/sexp.scm 115 */
																						goto BgL_tagzd2376zd2_1614;
																					}
																				else
																					{	/* Ast/sexp.scm 115 */
																						if (
																							(BgL_carzd24263zd2_2080 ==
																								BGl_za2ifza2z00zzast_sexpz00))
																							{	/* Ast/sexp.scm 115 */
																								goto BgL_tagzd2376zd2_1614;
																							}
																						else
																							{	/* Ast/sexp.scm 115 */
																								obj_t BgL_cdrzd24283zd2_2083;

																								BgL_cdrzd24283zd2_2083 =
																									CDR(BgL_expz00_21);
																								if (
																									(CAR(BgL_expz00_21) ==
																										CNST_TABLE_REF(((long) 7))))
																									{	/* Ast/sexp.scm 115 */
																										if (PAIRP
																											(BgL_cdrzd24283zd2_2083))
																											{	/* Ast/sexp.scm 115 */
																												obj_t
																													BgL_carzd24286zd2_2086;
																												obj_t
																													BgL_cdrzd24287zd2_2087;
																												BgL_carzd24286zd2_2086 =
																													CAR
																													(BgL_cdrzd24283zd2_2083);
																												BgL_cdrzd24287zd2_2087 =
																													CDR
																													(BgL_cdrzd24283zd2_2083);
																												if (PAIRP
																													(BgL_carzd24286zd2_2086))
																													{	/* Ast/sexp.scm 115 */
																														if (
																															(CAR
																																(BgL_carzd24286zd2_2086)
																																==
																																CNST_TABLE_REF((
																																		(long)
																																		15))))
																															{	/* Ast/sexp.scm 115 */
																																if (PAIRP
																																	(BgL_cdrzd24287zd2_2087))
																																	{	/* Ast/sexp.scm 115 */
																																		if (NULLP
																																			(CDR
																																				(BgL_cdrzd24287zd2_2087)))
																																			{
																																				obj_t
																																					BgL_valz00_6799;
																																				obj_t
																																					BgL_lz00_6797;
																																				BgL_lz00_6797
																																					=
																																					CDR
																																					(BgL_carzd24286zd2_2086);
																																				BgL_valz00_6799
																																					=
																																					CAR
																																					(BgL_cdrzd24287zd2_2087);
																																				BgL_valz00_1616
																																					=
																																					BgL_valz00_6799;
																																				BgL_lz00_1615
																																					=
																																					BgL_lz00_6797;
																																				goto
																																					BgL_tagzd2377zd2_1617;
																																			}
																																		else
																																			{	/* Ast/sexp.scm 115 */
																																				goto
																																					BgL_tagzd2378zd2_1618;
																																			}
																																	}
																																else
																																	{	/* Ast/sexp.scm 115 */
																																		goto
																																			BgL_tagzd2378zd2_1618;
																																	}
																															}
																														else
																															{	/* Ast/sexp.scm 115 */
																																goto
																																	BgL_tagzd2378zd2_1618;
																															}
																													}
																												else
																													{	/* Ast/sexp.scm 115 */
																														goto
																															BgL_tagzd2378zd2_1618;
																													}
																											}
																										else
																											{	/* Ast/sexp.scm 115 */
																												goto
																													BgL_tagzd2378zd2_1618;
																											}
																									}
																								else
																									{	/* Ast/sexp.scm 115 */
																										if (
																											(CAR(BgL_expz00_21) ==
																												CNST_TABLE_REF(((long)
																														17))))
																											{	/* Ast/sexp.scm 115 */
																												goto
																													BgL_tagzd2379zd2_1619;
																											}
																										else
																											{	/* Ast/sexp.scm 115 */
																												obj_t
																													BgL_carzd24396zd2_2097;
																												BgL_carzd24396zd2_2097 =
																													CAR(BgL_expz00_21);
																												if (PAIRP
																													(BgL_carzd24396zd2_2097))
																													{	/* Ast/sexp.scm 115 */
																														obj_t
																															BgL_carzd24399zd2_2099;
																														obj_t
																															BgL_cdrzd24400zd2_2100;
																														BgL_carzd24399zd2_2099
																															=
																															CAR
																															(BgL_carzd24396zd2_2097);
																														BgL_cdrzd24400zd2_2100
																															=
																															CDR
																															(BgL_carzd24396zd2_2097);
																														{

																															if (
																																(BgL_carzd24399zd2_2099
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			18))))
																																{
																																	obj_t
																																		BgL_auxz00_6813;
																																BgL_kapzd24401zd2_2101:
																																	if (PAIRP
																																		(BgL_cdrzd24400zd2_2100))
																																		{	/* Ast/sexp.scm 115 */
																																			obj_t
																																				BgL_cdrzd24404zd2_2265;
																																			BgL_cdrzd24404zd2_2265
																																				=
																																				CDR
																																				(BgL_cdrzd24400zd2_2100);
																																			if (PAIRP
																																				(BgL_cdrzd24404zd2_2265))
																																				{	/* Ast/sexp.scm 115 */
																																					if (NULLP(CDR(BgL_cdrzd24404zd2_2265)))
																																						{	/* Ast/sexp.scm 115 */
																																							obj_t
																																								BgL_arg2037z00_2268;
																																							obj_t
																																								BgL_arg2038z00_2269;
																																							BgL_arg2037z00_2268
																																								=
																																								CAR
																																								(BgL_cdrzd24404zd2_2265);
																																							BgL_arg2038z00_2269
																																								=
																																								CDR
																																								(BgL_expz00_21);
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_6824;
																																								{
																																									obj_t
																																										BgL_argsz00_6826;
																																									obj_t
																																										BgL_bodyz00_6825;
																																									BgL_bodyz00_6825
																																										=
																																										BgL_arg2037z00_2268;
																																									BgL_argsz00_6826
																																										=
																																										BgL_arg2038z00_2269;
																																									BgL_argsz00_1621
																																										=
																																										BgL_argsz00_6826;
																																									BgL_bodyz00_1620
																																										=
																																										BgL_bodyz00_6825;
																																									goto
																																										BgL_tagzd2380zd2_1622;
																																								}
																																								BgL_auxz00_6813
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_6824);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 115 */
																																							bool_t
																																								BgL_testz00_6828;
																																							{	/* Ast/sexp.scm 115 */
																																								obj_t
																																									BgL_arg2098z00_2360;
																																								BgL_arg2098z00_2360
																																									=
																																									CAR
																																									(BgL_expz00_21);
																																								BgL_testz00_6828
																																									=
																																									CBOOL
																																									(BGl_letzd2symzf3z21zzast_letz00
																																									(BgL_arg2098z00_2360));
																																							}
																																							if (BgL_testz00_6828)
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_6832;
																																									goto
																																										BgL_tagzd2381zd2_1623;
																																									BgL_auxz00_6813
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_6832);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 115 */
																																									bool_t
																																										BgL_testz00_6834;
																																									{	/* Ast/sexp.scm 115 */
																																										obj_t
																																											BgL_arg2097z00_2359;
																																										BgL_arg2097z00_2359
																																											=
																																											CAR
																																											(BgL_expz00_21);
																																										BgL_testz00_6834
																																											=
																																											CBOOL
																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																											(BgL_arg2097z00_2359));
																																									}
																																									if (BgL_testz00_6834)
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_6838;
																																											goto
																																												BgL_tagzd2383zd2_1625;
																																											BgL_auxz00_6813
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_6838);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 115 */
																																											obj_t
																																												BgL_carzd24482zd2_2272;
																																											BgL_carzd24482zd2_2272
																																												=
																																												CAR
																																												(BgL_expz00_21);
																																											{	/* Ast/sexp.scm 115 */
																																												obj_t
																																													BgL_cdrzd24487zd2_2273;
																																												BgL_cdrzd24487zd2_2273
																																													=
																																													CDR
																																													(BgL_carzd24482zd2_2272);
																																												if ((CAR(BgL_carzd24482zd2_2272) == CNST_TABLE_REF(((long) 3))))
																																													{	/* Ast/sexp.scm 115 */
																																														obj_t
																																															BgL_arg2042z00_2275;
																																														obj_t
																																															BgL_arg2043z00_2276;
																																														obj_t
																																															BgL_arg2045z00_2277;
																																														BgL_arg2042z00_2275
																																															=
																																															CAR
																																															(BgL_cdrzd24487zd2_2273);
																																														BgL_arg2043z00_2276
																																															=
																																															CDR
																																															(BgL_cdrzd24487zd2_2273);
																																														BgL_arg2045z00_2277
																																															=
																																															CDR
																																															(BgL_expz00_21);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_6849;
																																															{
																																																obj_t
																																																	BgL_argsz00_6852;
																																																obj_t
																																																	BgL_bodyz00_6851;
																																																obj_t
																																																	BgL_varsz00_6850;
																																																BgL_varsz00_6850
																																																	=
																																																	BgL_arg2042z00_2275;
																																																BgL_bodyz00_6851
																																																	=
																																																	BgL_arg2043z00_2276;
																																																BgL_argsz00_6852
																																																	=
																																																	BgL_arg2045z00_2277;
																																																BgL_argsz00_1632
																																																	=
																																																	BgL_argsz00_6852;
																																																BgL_bodyz00_1631
																																																	=
																																																	BgL_bodyz00_6851;
																																																BgL_varsz00_1630
																																																	=
																																																	BgL_varsz00_6850;
																																																goto
																																																	BgL_tagzd2385zd2_1633;
																																															}
																																															BgL_auxz00_6813
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_6849);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 115 */
																																														obj_t
																																															BgL_cdrzd24510zd2_2279;
																																														BgL_cdrzd24510zd2_2279
																																															=
																																															CDR
																																															(BgL_expz00_21);
																																														{	/* Ast/sexp.scm 115 */
																																															obj_t
																																																BgL_cdrzd24516zd2_2280;
																																															BgL_cdrzd24516zd2_2280
																																																=
																																																CDR
																																																(BgL_carzd24482zd2_2272);
																																															if ((CAR(BgL_carzd24482zd2_2272) == CNST_TABLE_REF(((long) 1))))
																																																{	/* Ast/sexp.scm 115 */
																																																	obj_t
																																																		BgL_cdrzd24522zd2_2282;
																																																	BgL_cdrzd24522zd2_2282
																																																		=
																																																		CDR
																																																		(BgL_cdrzd24516zd2_2280);
																																																	{	/* Ast/sexp.scm 115 */
																																																		obj_t
																																																			BgL_carzd24527zd2_2283;
																																																		obj_t
																																																			BgL_cdrzd24528zd2_2284;
																																																		BgL_carzd24527zd2_2283
																																																			=
																																																			CAR
																																																			(BgL_cdrzd24522zd2_2282);
																																																		BgL_cdrzd24528zd2_2284
																																																			=
																																																			CDR
																																																			(BgL_cdrzd24522zd2_2282);
																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24527zd2_2283))
																																																			{	/* Ast/sexp.scm 115 */
																																																				if (PAIRP(BgL_cdrzd24528zd2_2284))
																																																					{	/* Ast/sexp.scm 115 */
																																																						obj_t
																																																							BgL_carzd24535zd2_2287;
																																																						BgL_carzd24535zd2_2287
																																																							=
																																																							CAR
																																																							(BgL_cdrzd24528zd2_2284);
																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24535zd2_2287))
																																																							{	/* Ast/sexp.scm 115 */
																																																								if (NULLP(CDR(BgL_cdrzd24528zd2_2284)))
																																																									{	/* Ast/sexp.scm 115 */
																																																										bool_t
																																																											BgL_testz00_6873;
																																																										{
																																																											obj_t
																																																												BgL_l1355z00_2308;
																																																											BgL_l1355z00_2308
																																																												=
																																																												BgL_cdrzd24510zd2_2279;
																																																										BgL_zc3anonymousza32063ze3z83_2309:
																																																											if (NULLP(BgL_l1355z00_2308))
																																																												{	/* Ast/sexp.scm 115 */
																																																													BgL_testz00_6873
																																																														=
																																																														(
																																																														(bool_t)
																																																														1);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 115 */
																																																													bool_t
																																																														BgL_testz00_6876;
																																																													{	/* Ast/sexp.scm 115 */
																																																														bool_t
																																																															BgL_testz00_6877;
																																																														{	/* Ast/sexp.scm 115 */
																																																															obj_t
																																																																BgL_auxz00_6878;
																																																															BgL_auxz00_6878
																																																																=
																																																																CAR
																																																																(BgL_l1355z00_2308);
																																																															BgL_testz00_6877
																																																																=
																																																																PAIRP
																																																																(BgL_auxz00_6878);
																																																														}
																																																														if (BgL_testz00_6877)
																																																															{	/* Ast/sexp.scm 115 */
																																																																BgL_testz00_6876
																																																																	=
																																																																	(
																																																																	(bool_t)
																																																																	0);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 115 */
																																																																BgL_testz00_6876
																																																																	=
																																																																	(
																																																																	(bool_t)
																																																																	1);
																																																															}
																																																													}
																																																													if (BgL_testz00_6876)
																																																														{
																																																															obj_t
																																																																BgL_l1355z00_6881;
																																																															BgL_l1355z00_6881
																																																																=
																																																																CDR
																																																																(BgL_l1355z00_2308);
																																																															BgL_l1355z00_2308
																																																																=
																																																																BgL_l1355z00_6881;
																																																															goto
																																																																BgL_zc3anonymousza32063ze3z83_2309;
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																															BgL_testz00_6873
																																																																=
																																																																(
																																																																(bool_t)
																																																																0);
																																																														}
																																																												}
																																																										}
																																																										if (BgL_testz00_6873)
																																																											{	/* Ast/sexp.scm 115 */
																																																												obj_t
																																																													BgL_arg2052z00_2291;
																																																												BgL_arg2052z00_2291
																																																													=
																																																													CAR
																																																													(BgL_cdrzd24516zd2_2280);
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_6884;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_6888;
																																																														obj_t
																																																															BgL_proc2z00_6887;
																																																														obj_t
																																																															BgL_proc1z00_6886;
																																																														obj_t
																																																															BgL_testz00_6885;
																																																														BgL_testz00_6885
																																																															=
																																																															BgL_arg2052z00_2291;
																																																														BgL_proc1z00_6886
																																																															=
																																																															BgL_carzd24527zd2_2283;
																																																														BgL_proc2z00_6887
																																																															=
																																																															BgL_carzd24535zd2_2287;
																																																														BgL_argsz00_6888
																																																															=
																																																															BgL_cdrzd24510zd2_2279;
																																																														BgL_argsz00_1637
																																																															=
																																																															BgL_argsz00_6888;
																																																														BgL_proc2z00_1636
																																																															=
																																																															BgL_proc2z00_6887;
																																																														BgL_proc1z00_1635
																																																															=
																																																															BgL_proc1z00_6886;
																																																														BgL_testz00_1634
																																																															=
																																																															BgL_testz00_6885;
																																																														goto
																																																															BgL_tagzd2386zd2_1638;
																																																													}
																																																													BgL_auxz00_6813
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_6884);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 115 */
																																																												obj_t
																																																													BgL_cdrzd24559zd2_2292;
																																																												BgL_cdrzd24559zd2_2292
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{	/* Ast/sexp.scm 115 */
																																																													obj_t
																																																														BgL_cdrzd24566zd2_2293;
																																																													BgL_cdrzd24566zd2_2293
																																																														=
																																																														CDR
																																																														(CAR
																																																														(BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 115 */
																																																														obj_t
																																																															BgL_cdrzd24573zd2_2294;
																																																														BgL_cdrzd24573zd2_2294
																																																															=
																																																															CDR
																																																															(BgL_cdrzd24566zd2_2293);
																																																														{	/* Ast/sexp.scm 115 */
																																																															obj_t
																																																																BgL_carzd24579zd2_2295;
																																																															BgL_carzd24579zd2_2295
																																																																=
																																																																CAR
																																																																(BgL_cdrzd24573zd2_2294);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24579zd2_2295))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	obj_t
																																																																		BgL_carzd24586zd2_2297;
																																																																	BgL_carzd24586zd2_2297
																																																																		=
																																																																		CAR
																																																																		(CDR
																																																																		(BgL_cdrzd24573zd2_2294));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24586zd2_2297))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24559zd2_2292))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					obj_t
																																																																						BgL_arg2056z00_2300;
																																																																					BgL_arg2056z00_2300
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd24566zd2_2293);
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_6904;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_6908;
																																																																							obj_t
																																																																								BgL_proc2z00_6907;
																																																																							obj_t
																																																																								BgL_proc1z00_6906;
																																																																							obj_t
																																																																								BgL_testz00_6905;
																																																																							BgL_testz00_6905
																																																																								=
																																																																								BgL_arg2056z00_2300;
																																																																							BgL_proc1z00_6906
																																																																								=
																																																																								BgL_carzd24579zd2_2295;
																																																																							BgL_proc2z00_6907
																																																																								=
																																																																								BgL_carzd24586zd2_2297;
																																																																							BgL_argsz00_6908
																																																																								=
																																																																								BgL_cdrzd24559zd2_2292;
																																																																							BgL_argsz00_1642
																																																																								=
																																																																								BgL_argsz00_6908;
																																																																							BgL_proc2z00_1641
																																																																								=
																																																																								BgL_proc2z00_6907;
																																																																							BgL_proc1z00_1640
																																																																								=
																																																																								BgL_proc1z00_6906;
																																																																							BgL_testz00_1639
																																																																								=
																																																																								BgL_testz00_6905;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1643;
																																																																						}
																																																																						BgL_auxz00_6813
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_6904);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							goto
																																																																								BgL_tagzd2401zd2_1666;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_6912;
																																																																							goto
																																																																								BgL_tagzd2402zd2_1667;
																																																																							BgL_auxz00_6813
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_6912);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					goto
																																																																						BgL_tagzd2401zd2_1666;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_6916;
																																																																					goto
																																																																						BgL_tagzd2402zd2_1667;
																																																																					BgL_auxz00_6813
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_6916);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			goto
																																																																				BgL_tagzd2401zd2_1666;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_6920;
																																																																			goto
																																																																				BgL_tagzd2402zd2_1667;
																																																																			BgL_auxz00_6813
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_6920);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 115 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 115 */
																																																												goto
																																																													BgL_tagzd2401zd2_1666;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_6924;
																																																												goto
																																																													BgL_tagzd2402zd2_1667;
																																																												BgL_auxz00_6813
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_6924);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								obj_t
																																																									BgL_cdrzd24842zd2_2319;
																																																								BgL_cdrzd24842zd2_2319
																																																									=
																																																									CDR
																																																									(BgL_expz00_21);
																																																								{	/* Ast/sexp.scm 115 */
																																																									obj_t
																																																										BgL_cdrzd24848zd2_2320;
																																																									BgL_cdrzd24848zd2_2320
																																																										=
																																																										CDR
																																																										(CAR
																																																										(BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 115 */
																																																										obj_t
																																																											BgL_cdrzd24854zd2_2321;
																																																										BgL_cdrzd24854zd2_2321
																																																											=
																																																											CDR
																																																											(BgL_cdrzd24848zd2_2320);
																																																										{	/* Ast/sexp.scm 115 */
																																																											obj_t
																																																												BgL_carzd24859zd2_2322;
																																																											obj_t
																																																												BgL_cdrzd24860zd2_2323;
																																																											BgL_carzd24859zd2_2322
																																																												=
																																																												CAR
																																																												(BgL_cdrzd24854zd2_2321);
																																																											BgL_cdrzd24860zd2_2323
																																																												=
																																																												CDR
																																																												(BgL_cdrzd24854zd2_2321);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24859zd2_2322))
																																																												{	/* Ast/sexp.scm 115 */
																																																													obj_t
																																																														BgL_carzd24865zd2_2325;
																																																													BgL_carzd24865zd2_2325
																																																														=
																																																														CAR
																																																														(BgL_cdrzd24860zd2_2323);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24865zd2_2325))
																																																														{	/* Ast/sexp.scm 115 */
																																																															if (NULLP(CDR(BgL_cdrzd24860zd2_2323)))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24842zd2_2319))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			obj_t
																																																																				BgL_arg2073z00_2329;
																																																																			BgL_arg2073z00_2329
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd24848zd2_2320);
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_6943;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_6947;
																																																																					obj_t
																																																																						BgL_proc2z00_6946;
																																																																					obj_t
																																																																						BgL_proc1z00_6945;
																																																																					obj_t
																																																																						BgL_testz00_6944;
																																																																					BgL_testz00_6944
																																																																						=
																																																																						BgL_arg2073z00_2329;
																																																																					BgL_proc1z00_6945
																																																																						=
																																																																						BgL_carzd24859zd2_2322;
																																																																					BgL_proc2z00_6946
																																																																						=
																																																																						BgL_carzd24865zd2_2325;
																																																																					BgL_argsz00_6947
																																																																						=
																																																																						BgL_cdrzd24842zd2_2319;
																																																																					BgL_argsz00_1642
																																																																						=
																																																																						BgL_argsz00_6947;
																																																																					BgL_proc2z00_1641
																																																																						=
																																																																						BgL_proc2z00_6946;
																																																																					BgL_proc1z00_1640
																																																																						=
																																																																						BgL_proc1z00_6945;
																																																																					BgL_testz00_1639
																																																																						=
																																																																						BgL_testz00_6944;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1643;
																																																																				}
																																																																				BgL_auxz00_6813
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_6943);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					goto
																																																																						BgL_tagzd2401zd2_1666;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_6951;
																																																																					goto
																																																																						BgL_tagzd2402zd2_1667;
																																																																					BgL_auxz00_6813
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_6951);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			goto
																																																																				BgL_tagzd2401zd2_1666;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_6955;
																																																																			goto
																																																																				BgL_tagzd2402zd2_1667;
																																																																			BgL_auxz00_6813
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_6955);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	goto
																																																																		BgL_tagzd2401zd2_1666;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_6959;
																																																																	goto
																																																																		BgL_tagzd2402zd2_1667;
																																																																	BgL_auxz00_6813
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_6959);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 115 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 115 */
																																																															goto
																																																																BgL_tagzd2401zd2_1666;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_6963;
																																																															goto
																																																																BgL_tagzd2402zd2_1667;
																																																															BgL_auxz00_6813
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_6963);
																																																														}
																																																												}
																																																										}
																																																									}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 115 */
																																																								goto
																																																									BgL_tagzd2401zd2_1666;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_6967;
																																																								goto
																																																									BgL_tagzd2402zd2_1667;
																																																								BgL_auxz00_6813
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_6967);
																																																							}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				obj_t
																																																					BgL_cdrzd25173zd2_2337;
																																																				BgL_cdrzd25173zd2_2337
																																																					=
																																																					CDR
																																																					(BgL_expz00_21);
																																																				{	/* Ast/sexp.scm 115 */
																																																					obj_t
																																																						BgL_cdrzd25180zd2_2338;
																																																					BgL_cdrzd25180zd2_2338
																																																						=
																																																						CDR
																																																						(CAR
																																																						(BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 115 */
																																																						obj_t
																																																							BgL_cdrzd25187zd2_2339;
																																																						BgL_cdrzd25187zd2_2339
																																																							=
																																																							CDR
																																																							(BgL_cdrzd25180zd2_2338);
																																																						{	/* Ast/sexp.scm 115 */
																																																							obj_t
																																																								BgL_carzd25193zd2_2340;
																																																							obj_t
																																																								BgL_cdrzd25194zd2_2341;
																																																							BgL_carzd25193zd2_2340
																																																								=
																																																								CAR
																																																								(BgL_cdrzd25187zd2_2339);
																																																							BgL_cdrzd25194zd2_2341
																																																								=
																																																								CDR
																																																								(BgL_cdrzd25187zd2_2339);
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25193zd2_2340))
																																																								{	/* Ast/sexp.scm 115 */
																																																									if (PAIRP(BgL_cdrzd25194zd2_2341))
																																																										{	/* Ast/sexp.scm 115 */
																																																											obj_t
																																																												BgL_carzd25201zd2_2344;
																																																											BgL_carzd25201zd2_2344
																																																												=
																																																												CAR
																																																												(BgL_cdrzd25194zd2_2341);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25201zd2_2344))
																																																												{	/* Ast/sexp.scm 115 */
																																																													if (NULLP(CDR(BgL_cdrzd25194zd2_2341)))
																																																														{	/* Ast/sexp.scm 115 */
																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd25173zd2_2337))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	obj_t
																																																																		BgL_arg2086z00_2348;
																																																																	BgL_arg2086z00_2348
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd25180zd2_2338);
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_6988;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_6992;
																																																																			obj_t
																																																																				BgL_proc2z00_6991;
																																																																			obj_t
																																																																				BgL_proc1z00_6990;
																																																																			obj_t
																																																																				BgL_testz00_6989;
																																																																			BgL_testz00_6989
																																																																				=
																																																																				BgL_arg2086z00_2348;
																																																																			BgL_proc1z00_6990
																																																																				=
																																																																				BgL_carzd25193zd2_2340;
																																																																			BgL_proc2z00_6991
																																																																				=
																																																																				BgL_carzd25201zd2_2344;
																																																																			BgL_argsz00_6992
																																																																				=
																																																																				BgL_cdrzd25173zd2_2337;
																																																																			BgL_argsz00_1642
																																																																				=
																																																																				BgL_argsz00_6992;
																																																																			BgL_proc2z00_1641
																																																																				=
																																																																				BgL_proc2z00_6991;
																																																																			BgL_proc1z00_1640
																																																																				=
																																																																				BgL_proc1z00_6990;
																																																																			BgL_testz00_1639
																																																																				=
																																																																				BgL_testz00_6989;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1643;
																																																																		}
																																																																		BgL_auxz00_6813
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_6988);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			goto
																																																																				BgL_tagzd2401zd2_1666;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_6996;
																																																																			goto
																																																																				BgL_tagzd2402zd2_1667;
																																																																			BgL_auxz00_6813
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_6996);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	goto
																																																																		BgL_tagzd2401zd2_1666;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_7000;
																																																																	goto
																																																																		BgL_tagzd2402zd2_1667;
																																																																	BgL_auxz00_6813
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_7000);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 115 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 115 */
																																																															goto
																																																																BgL_tagzd2401zd2_1666;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_7004;
																																																															goto
																																																																BgL_tagzd2402zd2_1667;
																																																															BgL_auxz00_6813
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_7004);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 115 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 115 */
																																																													goto
																																																														BgL_tagzd2401zd2_1666;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_7008;
																																																													goto
																																																														BgL_tagzd2402zd2_1667;
																																																													BgL_auxz00_6813
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_7008);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 115 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 115 */
																																																											goto
																																																												BgL_tagzd2401zd2_1666;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_7012;
																																																											goto
																																																												BgL_tagzd2402zd2_1667;
																																																											BgL_auxz00_6813
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_7012);
																																																										}
																																																								}
																																																						}
																																																					}
																																																				}
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 115 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 115 */
																																																			goto
																																																				BgL_tagzd2401zd2_1666;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_7016;
																																																			goto
																																																				BgL_tagzd2402zd2_1667;
																																																			BgL_auxz00_6813
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7016);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										}
																																								}
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 115 */
																																					bool_t
																																						BgL_testz00_7018;
																																					{	/* Ast/sexp.scm 115 */
																																						obj_t
																																							BgL_arg2109z00_2373;
																																						BgL_arg2109z00_2373
																																							=
																																							CAR
																																							(BgL_expz00_21);
																																						BgL_testz00_7018
																																							=
																																							CBOOL
																																							(BGl_letzd2symzf3z21zzast_letz00
																																							(BgL_arg2109z00_2373));
																																					}
																																					if (BgL_testz00_7018)
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_7022;
																																							goto
																																								BgL_tagzd2381zd2_1623;
																																							BgL_auxz00_6813
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_7022);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 115 */
																																							bool_t
																																								BgL_testz00_7024;
																																							{	/* Ast/sexp.scm 115 */
																																								obj_t
																																									BgL_arg2108z00_2372;
																																								BgL_arg2108z00_2372
																																									=
																																									CAR
																																									(BgL_expz00_21);
																																								BgL_testz00_7024
																																									=
																																									CBOOL
																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																									(BgL_arg2108z00_2372));
																																							}
																																							if (BgL_testz00_7024)
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_7028;
																																									goto
																																										BgL_tagzd2383zd2_1625;
																																									BgL_auxz00_6813
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_7028);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 115 */
																																									obj_t
																																										BgL_carzd25617zd2_2364;
																																									BgL_carzd25617zd2_2364
																																										=
																																										CAR
																																										(BgL_expz00_21);
																																									{	/* Ast/sexp.scm 115 */
																																										obj_t
																																											BgL_cdrzd25622zd2_2365;
																																										BgL_cdrzd25622zd2_2365
																																											=
																																											CDR
																																											(BgL_carzd25617zd2_2364);
																																										if ((CAR(BgL_carzd25617zd2_2364) == CNST_TABLE_REF(((long) 3))))
																																											{	/* Ast/sexp.scm 115 */
																																												obj_t
																																													BgL_arg2103z00_2367;
																																												obj_t
																																													BgL_arg2104z00_2368;
																																												obj_t
																																													BgL_arg2105z00_2369;
																																												BgL_arg2103z00_2367
																																													=
																																													CAR
																																													(BgL_cdrzd25622zd2_2365);
																																												BgL_arg2104z00_2368
																																													=
																																													CDR
																																													(BgL_cdrzd25622zd2_2365);
																																												BgL_arg2105z00_2369
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_7039;
																																													{
																																														obj_t
																																															BgL_argsz00_7042;
																																														obj_t
																																															BgL_bodyz00_7041;
																																														obj_t
																																															BgL_varsz00_7040;
																																														BgL_varsz00_7040
																																															=
																																															BgL_arg2103z00_2367;
																																														BgL_bodyz00_7041
																																															=
																																															BgL_arg2104z00_2368;
																																														BgL_argsz00_7042
																																															=
																																															BgL_arg2105z00_2369;
																																														BgL_argsz00_1632
																																															=
																																															BgL_argsz00_7042;
																																														BgL_bodyz00_1631
																																															=
																																															BgL_bodyz00_7041;
																																														BgL_varsz00_1630
																																															=
																																															BgL_varsz00_7040;
																																														goto
																																															BgL_tagzd2385zd2_1633;
																																													}
																																													BgL_auxz00_6813
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_7039);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 115 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 115 */
																																														goto
																																															BgL_tagzd2401zd2_1666;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_7046;
																																														goto
																																															BgL_tagzd2402zd2_1667;
																																														BgL_auxz00_6813
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_7046);
																																													}
																																											}
																																									}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 115 */
																																			bool_t
																																				BgL_testz00_7048;
																																			{	/* Ast/sexp.scm 115 */
																																				obj_t
																																					BgL_arg2114z00_2378;
																																				BgL_arg2114z00_2378
																																					=
																																					CAR
																																					(BgL_expz00_21);
																																				BgL_testz00_7048
																																					=
																																					CBOOL
																																					(BGl_letzd2symzf3z21zzast_letz00
																																					(BgL_arg2114z00_2378));
																																			}
																																			if (BgL_testz00_7048)
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_7052;
																																					goto
																																						BgL_tagzd2381zd2_1623;
																																					BgL_auxz00_6813
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_7052);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 115 */
																																					bool_t
																																						BgL_testz00_7054;
																																					{	/* Ast/sexp.scm 115 */
																																						obj_t
																																							BgL_arg2113z00_2377;
																																						BgL_arg2113z00_2377
																																							=
																																							CAR
																																							(BgL_expz00_21);
																																						BgL_testz00_7054
																																							=
																																							CBOOL
																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																							(BgL_arg2113z00_2377));
																																					}
																																					if (BgL_testz00_7054)
																																						{
																																							BgL_letzd2funzd2_bglt
																																								BgL_auxz00_7058;
																																							goto
																																								BgL_tagzd2383zd2_1625;
																																							BgL_auxz00_6813
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_7058);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 115 */
																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																								{	/* Ast/sexp.scm 115 */
																																									goto
																																										BgL_tagzd2401zd2_1666;
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_7062;
																																									goto
																																										BgL_tagzd2402zd2_1667;
																																									BgL_auxz00_6813
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_7062);
																																								}
																																						}
																																				}
																																		}
																																	return
																																		(
																																		(BgL_nodez00_bglt)
																																		BgL_auxz00_6813);
																																}
																															else
																																{	/* Ast/sexp.scm 115 */
																																	if (CBOOL
																																		(BGl_letzd2symzf3z21zzast_letz00
																																			(BgL_carzd24399zd2_2099)))
																																		{
																																			obj_t
																																				BgL_auxz00_7068;
																																			goto
																																				BgL_kapzd24401zd2_2101;
																																			return (
																																				(BgL_nodez00_bglt)
																																				BgL_auxz00_7068);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 115 */
																																			if (
																																				(BgL_carzd24399zd2_2099
																																					==
																																					CNST_TABLE_REF
																																					(((long) 19))))
																																				{
																																					obj_t
																																						BgL_auxz00_7073;
																																					goto
																																						BgL_kapzd24401zd2_2101;
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_7073);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 115 */
																																					if (
																																						(BgL_carzd24399zd2_2099
																																							==
																																							CNST_TABLE_REF
																																							(((long) 20))))
																																						{
																																							obj_t
																																								BgL_auxz00_7078;
																																							goto
																																								BgL_kapzd24401zd2_2101;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_7078);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 115 */
																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd24399zd2_2099)))
																																								{
																																									obj_t
																																										BgL_auxz00_7083;
																																									goto
																																										BgL_kapzd24401zd2_2101;
																																									return
																																										(
																																										(BgL_nodez00_bglt)
																																										BgL_auxz00_7083);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 115 */
																																									bool_t
																																										BgL_testz00_7085;
																																									{	/* Ast/sexp.scm 115 */
																																										obj_t
																																											BgL_arg2033z00_2263;
																																										BgL_arg2033z00_2263
																																											=
																																											CAR
																																											(BgL_expz00_21);
																																										BgL_testz00_7085
																																											=
																																											CBOOL
																																											(BGl_letzd2symzf3z21zzast_letz00
																																											(BgL_arg2033z00_2263));
																																									}
																																									if (BgL_testz00_7085)
																																										{	/* Ast/sexp.scm 115 */
																																											goto
																																												BgL_tagzd2381zd2_1623;
																																										}
																																									else
																																										{	/* Ast/sexp.scm 115 */
																																											bool_t
																																												BgL_testz00_7089;
																																											{	/* Ast/sexp.scm 115 */
																																												obj_t
																																													BgL_arg2032z00_2262;
																																												BgL_arg2032z00_2262
																																													=
																																													CAR
																																													(BgL_expz00_21);
																																												BgL_testz00_7089
																																													=
																																													CBOOL
																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																													(BgL_arg2032z00_2262));
																																											}
																																											if (BgL_testz00_7089)
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_7093;
																																													goto
																																														BgL_tagzd2383zd2_1625;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_7093);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 115 */
																																													obj_t
																																														BgL_carzd25922zd2_2109;
																																													obj_t
																																														BgL_cdrzd25923zd2_2110;
																																													BgL_carzd25922zd2_2109
																																														=
																																														CAR
																																														(BgL_expz00_21);
																																													BgL_cdrzd25923zd2_2110
																																														=
																																														CDR
																																														(BgL_expz00_21);
																																													{	/* Ast/sexp.scm 115 */
																																														obj_t
																																															BgL_cdrzd25927zd2_2111;
																																														BgL_cdrzd25927zd2_2111
																																															=
																																															CDR
																																															(BgL_carzd25922zd2_2109);
																																														if ((CAR(BgL_carzd25922zd2_2109) == CNST_TABLE_REF(((long) 3))))
																																															{	/* Ast/sexp.scm 115 */
																																																if (PAIRP(BgL_cdrzd25927zd2_2111))
																																																	{	/* Ast/sexp.scm 115 */
																																																		obj_t
																																																			BgL_carzd25930zd2_2114;
																																																		obj_t
																																																			BgL_cdrzd25931zd2_2115;
																																																		BgL_carzd25930zd2_2114
																																																			=
																																																			CAR
																																																			(BgL_cdrzd25927zd2_2111);
																																																		BgL_cdrzd25931zd2_2115
																																																			=
																																																			CDR
																																																			(BgL_cdrzd25927zd2_2111);
																																																		if (PAIRP(BgL_carzd25930zd2_2114))
																																																			{	/* Ast/sexp.scm 115 */
																																																				if (NULLP(CDR(BgL_carzd25930zd2_2114)))
																																																					{	/* Ast/sexp.scm 115 */
																																																						if (PAIRP(BgL_cdrzd25931zd2_2115))
																																																							{	/* Ast/sexp.scm 115 */
																																																								obj_t
																																																									BgL_carzd25937zd2_2119;
																																																								BgL_carzd25937zd2_2119
																																																									=
																																																									CAR
																																																									(BgL_cdrzd25931zd2_2115);
																																																								if (PAIRP(BgL_carzd25937zd2_2119))
																																																									{	/* Ast/sexp.scm 115 */
																																																										if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd25937zd2_2119))
																																																											{	/* Ast/sexp.scm 115 */
																																																												if (NULLP(CDR(BgL_cdrzd25931zd2_2115)))
																																																													{	/* Ast/sexp.scm 115 */
																																																														if (PAIRP(BgL_cdrzd25923zd2_2110))
																																																															{	/* Ast/sexp.scm 115 */
																																																																obj_t
																																																																	BgL_carzd25944zd2_2124;
																																																																BgL_carzd25944zd2_2124
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd25923zd2_2110);
																																																																if (PAIRP(BgL_carzd25944zd2_2124))
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		obj_t
																																																																			BgL_cdrzd25968zd2_2126;
																																																																		BgL_cdrzd25968zd2_2126
																																																																			=
																																																																			CDR
																																																																			(CAR
																																																																			(BgL_expz00_21));
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_7132;
																																																																			obj_t
																																																																				BgL_bodyz00_7130;
																																																																			obj_t
																																																																				BgL_varsz00_7128;
																																																																			BgL_varsz00_7128
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd25968zd2_2126);
																																																																			BgL_bodyz00_7130
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd25968zd2_2126);
																																																																			BgL_argsz00_7132
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			BgL_argsz00_1632
																																																																				=
																																																																				BgL_argsz00_7132;
																																																																			BgL_bodyz00_1631
																																																																				=
																																																																				BgL_bodyz00_7130;
																																																																			BgL_varsz00_1630
																																																																				=
																																																																				BgL_varsz00_7128;
																																																																			goto
																																																																				BgL_tagzd2385zd2_1633;
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		if (NULLP(CDR(BgL_cdrzd25923zd2_2110)))
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				obj_t
																																																																					BgL_arg1933z00_2132;
																																																																				BgL_arg1933z00_2132
																																																																					=
																																																																					CAR
																																																																					(BgL_carzd25930zd2_2114);
																																																																				{
																																																																					BgL_castz00_bglt
																																																																						BgL_auxz00_7138;
																																																																					{
																																																																						obj_t
																																																																							BgL_argz00_7141;
																																																																						obj_t
																																																																							BgL_bodyz00_7140;
																																																																						obj_t
																																																																							BgL_varz00_7139;
																																																																						BgL_varz00_7139
																																																																							=
																																																																							BgL_arg1933z00_2132;
																																																																						BgL_bodyz00_7140
																																																																							=
																																																																							BgL_carzd25937zd2_2119;
																																																																						BgL_argz00_7141
																																																																							=
																																																																							BgL_carzd25944zd2_2124;
																																																																						BgL_argz00_1628
																																																																							=
																																																																							BgL_argz00_7141;
																																																																						BgL_bodyz00_1627
																																																																							=
																																																																							BgL_bodyz00_7140;
																																																																						BgL_varz00_1626
																																																																							=
																																																																							BgL_varz00_7139;
																																																																						goto
																																																																							BgL_tagzd2384zd2_1629;
																																																																					}
																																																																					return
																																																																						(
																																																																						(BgL_nodez00_bglt)
																																																																						BgL_auxz00_7138);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				obj_t
																																																																					BgL_cdrzd25995zd2_2133;
																																																																				BgL_cdrzd25995zd2_2133
																																																																					=
																																																																					CDR
																																																																					(CAR
																																																																					(BgL_expz00_21));
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_7149;
																																																																					obj_t
																																																																						BgL_bodyz00_7147;
																																																																					obj_t
																																																																						BgL_varsz00_7145;
																																																																					BgL_varsz00_7145
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd25995zd2_2133);
																																																																					BgL_bodyz00_7147
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd25995zd2_2133);
																																																																					BgL_argsz00_7149
																																																																						=
																																																																						CDR
																																																																						(BgL_expz00_21);
																																																																					BgL_argsz00_1632
																																																																						=
																																																																						BgL_argsz00_7149;
																																																																					BgL_bodyz00_1631
																																																																						=
																																																																						BgL_bodyz00_7147;
																																																																					BgL_varsz00_1630
																																																																						=
																																																																						BgL_varsz00_7145;
																																																																					goto
																																																																						BgL_tagzd2385zd2_1633;
																																																																				}
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 115 */
																																																																obj_t
																																																																	BgL_cdrzd26021zd2_2139;
																																																																BgL_cdrzd26021zd2_2139
																																																																	=
																																																																	CDR
																																																																	(CAR
																																																																	(BgL_expz00_21));
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_7157;
																																																																	obj_t
																																																																		BgL_bodyz00_7155;
																																																																	obj_t
																																																																		BgL_varsz00_7153;
																																																																	BgL_varsz00_7153
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd26021zd2_2139);
																																																																	BgL_bodyz00_7155
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd26021zd2_2139);
																																																																	BgL_argsz00_7157
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	BgL_argsz00_1632
																																																																		=
																																																																		BgL_argsz00_7157;
																																																																	BgL_bodyz00_1631
																																																																		=
																																																																		BgL_bodyz00_7155;
																																																																	BgL_varsz00_1630
																																																																		=
																																																																		BgL_varsz00_7153;
																																																																	goto
																																																																		BgL_tagzd2385zd2_1633;
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 115 */
																																																														obj_t
																																																															BgL_cdrzd26047zd2_2144;
																																																														BgL_cdrzd26047zd2_2144
																																																															=
																																																															CDR
																																																															(CAR
																																																															(BgL_expz00_21));
																																																														{
																																																															obj_t
																																																																BgL_argsz00_7165;
																																																															obj_t
																																																																BgL_bodyz00_7163;
																																																															obj_t
																																																																BgL_varsz00_7161;
																																																															BgL_varsz00_7161
																																																																=
																																																																CAR
																																																																(BgL_cdrzd26047zd2_2144);
																																																															BgL_bodyz00_7163
																																																																=
																																																																CDR
																																																																(BgL_cdrzd26047zd2_2144);
																																																															BgL_argsz00_7165
																																																																=
																																																																CDR
																																																																(BgL_expz00_21);
																																																															BgL_argsz00_1632
																																																																=
																																																																BgL_argsz00_7165;
																																																															BgL_bodyz00_1631
																																																																=
																																																																BgL_bodyz00_7163;
																																																															BgL_varsz00_1630
																																																																=
																																																																BgL_varsz00_7161;
																																																															goto
																																																																BgL_tagzd2385zd2_1633;
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 115 */
																																																												obj_t
																																																													BgL_cdrzd26073zd2_2150;
																																																												BgL_cdrzd26073zd2_2150
																																																													=
																																																													CDR
																																																													(CAR
																																																													(BgL_expz00_21));
																																																												{
																																																													obj_t
																																																														BgL_argsz00_7173;
																																																													obj_t
																																																														BgL_bodyz00_7171;
																																																													obj_t
																																																														BgL_varsz00_7169;
																																																													BgL_varsz00_7169
																																																														=
																																																														CAR
																																																														(BgL_cdrzd26073zd2_2150);
																																																													BgL_bodyz00_7171
																																																														=
																																																														CDR
																																																														(BgL_cdrzd26073zd2_2150);
																																																													BgL_argsz00_7173
																																																														=
																																																														CDR
																																																														(BgL_expz00_21);
																																																													BgL_argsz00_1632
																																																														=
																																																														BgL_argsz00_7173;
																																																													BgL_bodyz00_1631
																																																														=
																																																														BgL_bodyz00_7171;
																																																													BgL_varsz00_1630
																																																														=
																																																														BgL_varsz00_7169;
																																																													goto
																																																														BgL_tagzd2385zd2_1633;
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 115 */
																																																										obj_t
																																																											BgL_cdrzd26099zd2_2155;
																																																										BgL_cdrzd26099zd2_2155
																																																											=
																																																											CDR
																																																											(BgL_carzd25922zd2_2109);
																																																										{
																																																											obj_t
																																																												BgL_argsz00_7180;
																																																											obj_t
																																																												BgL_bodyz00_7178;
																																																											obj_t
																																																												BgL_varsz00_7176;
																																																											BgL_varsz00_7176
																																																												=
																																																												CAR
																																																												(BgL_cdrzd26099zd2_2155);
																																																											BgL_bodyz00_7178
																																																												=
																																																												CDR
																																																												(BgL_cdrzd26099zd2_2155);
																																																											BgL_argsz00_7180
																																																												=
																																																												CDR
																																																												(BgL_expz00_21);
																																																											BgL_argsz00_1632
																																																												=
																																																												BgL_argsz00_7180;
																																																											BgL_bodyz00_1631
																																																												=
																																																												BgL_bodyz00_7178;
																																																											BgL_varsz00_1630
																																																												=
																																																												BgL_varsz00_7176;
																																																											goto
																																																												BgL_tagzd2385zd2_1633;
																																																										}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								obj_t
																																																									BgL_cdrzd26125zd2_2160;
																																																								BgL_cdrzd26125zd2_2160
																																																									=
																																																									CDR
																																																									(BgL_carzd25922zd2_2109);
																																																								{
																																																									obj_t
																																																										BgL_argsz00_7187;
																																																									obj_t
																																																										BgL_bodyz00_7185;
																																																									obj_t
																																																										BgL_varsz00_7183;
																																																									BgL_varsz00_7183
																																																										=
																																																										CAR
																																																										(BgL_cdrzd26125zd2_2160);
																																																									BgL_bodyz00_7185
																																																										=
																																																										CDR
																																																										(BgL_cdrzd26125zd2_2160);
																																																									BgL_argsz00_7187
																																																										=
																																																										CDR
																																																										(BgL_expz00_21);
																																																									BgL_argsz00_1632
																																																										=
																																																										BgL_argsz00_7187;
																																																									BgL_bodyz00_1631
																																																										=
																																																										BgL_bodyz00_7185;
																																																									BgL_varsz00_1630
																																																										=
																																																										BgL_varsz00_7183;
																																																									goto
																																																										BgL_tagzd2385zd2_1633;
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						obj_t
																																																							BgL_cdrzd26151zd2_2165;
																																																						BgL_cdrzd26151zd2_2165
																																																							=
																																																							CDR
																																																							(BgL_carzd25922zd2_2109);
																																																						{
																																																							obj_t
																																																								BgL_argsz00_7194;
																																																							obj_t
																																																								BgL_bodyz00_7192;
																																																							obj_t
																																																								BgL_varsz00_7190;
																																																							BgL_varsz00_7190
																																																								=
																																																								CAR
																																																								(BgL_cdrzd26151zd2_2165);
																																																							BgL_bodyz00_7192
																																																								=
																																																								CDR
																																																								(BgL_cdrzd26151zd2_2165);
																																																							BgL_argsz00_7194
																																																								=
																																																								CDR
																																																								(BgL_expz00_21);
																																																							BgL_argsz00_1632
																																																								=
																																																								BgL_argsz00_7194;
																																																							BgL_bodyz00_1631
																																																								=
																																																								BgL_bodyz00_7192;
																																																							BgL_varsz00_1630
																																																								=
																																																								BgL_varsz00_7190;
																																																							goto
																																																								BgL_tagzd2385zd2_1633;
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				obj_t
																																																					BgL_cdrzd26177zd2_2171;
																																																				BgL_cdrzd26177zd2_2171
																																																					=
																																																					CDR
																																																					(BgL_carzd25922zd2_2109);
																																																				{
																																																					obj_t
																																																						BgL_argsz00_7201;
																																																					obj_t
																																																						BgL_bodyz00_7199;
																																																					obj_t
																																																						BgL_varsz00_7197;
																																																					BgL_varsz00_7197
																																																						=
																																																						CAR
																																																						(BgL_cdrzd26177zd2_2171);
																																																					BgL_bodyz00_7199
																																																						=
																																																						CDR
																																																						(BgL_cdrzd26177zd2_2171);
																																																					BgL_argsz00_7201
																																																						=
																																																						CDR
																																																						(BgL_expz00_21);
																																																					BgL_argsz00_1632
																																																						=
																																																						BgL_argsz00_7201;
																																																					BgL_bodyz00_1631
																																																						=
																																																						BgL_bodyz00_7199;
																																																					BgL_varsz00_1630
																																																						=
																																																						BgL_varsz00_7197;
																																																					goto
																																																						BgL_tagzd2385zd2_1633;
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 115 */
																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																			{
																																																				obj_t
																																																					BgL_auxz00_7205;
																																																				goto
																																																					BgL_tagzd2401zd2_1666;
																																																				return
																																																					(
																																																					(BgL_nodez00_bglt)
																																																					BgL_auxz00_7205);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				goto
																																																					BgL_tagzd2402zd2_1667;
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 115 */
																																																obj_t
																																																	BgL_cdrzd26310zd2_2179;
																																																BgL_cdrzd26310zd2_2179
																																																	=
																																																	CDR
																																																	(BgL_carzd25922zd2_2109);
																																																if ((CAR(BgL_carzd25922zd2_2109) == CNST_TABLE_REF(((long) 1))))
																																																	{	/* Ast/sexp.scm 115 */
																																																		if (PAIRP(BgL_cdrzd26310zd2_2179))
																																																			{	/* Ast/sexp.scm 115 */
																																																				obj_t
																																																					BgL_cdrzd26315zd2_2182;
																																																				BgL_cdrzd26315zd2_2182
																																																					=
																																																					CDR
																																																					(BgL_cdrzd26310zd2_2179);
																																																				if (PAIRP(BgL_cdrzd26315zd2_2182))
																																																					{	/* Ast/sexp.scm 115 */
																																																						obj_t
																																																							BgL_carzd26319zd2_2184;
																																																						obj_t
																																																							BgL_cdrzd26320zd2_2185;
																																																						BgL_carzd26319zd2_2184
																																																							=
																																																							CAR
																																																							(BgL_cdrzd26315zd2_2182);
																																																						BgL_cdrzd26320zd2_2185
																																																							=
																																																							CDR
																																																							(BgL_cdrzd26315zd2_2182);
																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26319zd2_2184))
																																																							{	/* Ast/sexp.scm 115 */
																																																								if (PAIRP(BgL_cdrzd26320zd2_2185))
																																																									{	/* Ast/sexp.scm 115 */
																																																										obj_t
																																																											BgL_carzd26325zd2_2188;
																																																										BgL_carzd26325zd2_2188
																																																											=
																																																											CAR
																																																											(BgL_cdrzd26320zd2_2185);
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26325zd2_2188))
																																																											{	/* Ast/sexp.scm 115 */
																																																												if (NULLP(CDR(BgL_cdrzd26320zd2_2185)))
																																																													{	/* Ast/sexp.scm 115 */
																																																														bool_t
																																																															BgL_testz00_7229;
																																																														{
																																																															obj_t
																																																																BgL_l1358z00_2209;
																																																															BgL_l1358z00_2209
																																																																=
																																																																BgL_cdrzd25923zd2_2110;
																																																														BgL_zc3anonymousza31995ze3z83_2210:
																																																															if (NULLP(BgL_l1358z00_2209))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	BgL_testz00_7229
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		1);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	bool_t
																																																																		BgL_testz00_7232;
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		bool_t
																																																																			BgL_testz00_7233;
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			obj_t
																																																																				BgL_auxz00_7234;
																																																																			BgL_auxz00_7234
																																																																				=
																																																																				CAR
																																																																				(BgL_l1358z00_2209);
																																																																			BgL_testz00_7233
																																																																				=
																																																																				PAIRP
																																																																				(BgL_auxz00_7234);
																																																																		}
																																																																		if (BgL_testz00_7233)
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				BgL_testz00_7232
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				BgL_testz00_7232
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																	}
																																																																	if (BgL_testz00_7232)
																																																																		{
																																																																			obj_t
																																																																				BgL_l1358z00_7237;
																																																																			BgL_l1358z00_7237
																																																																				=
																																																																				CDR
																																																																				(BgL_l1358z00_2209);
																																																																			BgL_l1358z00_2209
																																																																				=
																																																																				BgL_l1358z00_7237;
																																																																			goto
																																																																				BgL_zc3anonymousza31995ze3z83_2210;
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			BgL_testz00_7229
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																														}
																																																														if (BgL_testz00_7229)
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_7243;
																																																																obj_t
																																																																	BgL_proc2z00_7242;
																																																																obj_t
																																																																	BgL_proc1z00_7241;
																																																																obj_t
																																																																	BgL_testz00_7239;
																																																																BgL_testz00_7239
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd26310zd2_2179);
																																																																BgL_proc1z00_7241
																																																																	=
																																																																	BgL_carzd26319zd2_2184;
																																																																BgL_proc2z00_7242
																																																																	=
																																																																	BgL_carzd26325zd2_2188;
																																																																BgL_argsz00_7243
																																																																	=
																																																																	BgL_cdrzd25923zd2_2110;
																																																																BgL_argsz00_1637
																																																																	=
																																																																	BgL_argsz00_7243;
																																																																BgL_proc2z00_1636
																																																																	=
																																																																	BgL_proc2z00_7242;
																																																																BgL_proc1z00_1635
																																																																	=
																																																																	BgL_proc1z00_7241;
																																																																BgL_testz00_1634
																																																																	=
																																																																	BgL_testz00_7239;
																																																																goto
																																																																	BgL_tagzd2386zd2_1638;
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 115 */
																																																																obj_t
																																																																	BgL_cdrzd26350zd2_2193;
																																																																BgL_cdrzd26350zd2_2193
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{	/* Ast/sexp.scm 115 */
																																																																	obj_t
																																																																		BgL_cdrzd26358zd2_2194;
																																																																	BgL_cdrzd26358zd2_2194
																																																																		=
																																																																		CDR
																																																																		(CAR
																																																																		(BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		obj_t
																																																																			BgL_cdrzd26366zd2_2195;
																																																																		BgL_cdrzd26366zd2_2195
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd26358zd2_2194);
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			obj_t
																																																																				BgL_carzd26373zd2_2196;
																																																																			BgL_carzd26373zd2_2196
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd26366zd2_2195);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26373zd2_2196))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					obj_t
																																																																						BgL_carzd26382zd2_2198;
																																																																					BgL_carzd26382zd2_2198
																																																																						=
																																																																						CAR
																																																																						(CDR
																																																																						(BgL_cdrzd26366zd2_2195));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26382zd2_2198))
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26350zd2_2193))
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_7261;
																																																																									obj_t
																																																																										BgL_proc2z00_7260;
																																																																									obj_t
																																																																										BgL_proc1z00_7259;
																																																																									obj_t
																																																																										BgL_testz00_7257;
																																																																									BgL_testz00_7257
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd26358zd2_2194);
																																																																									BgL_proc1z00_7259
																																																																										=
																																																																										BgL_carzd26373zd2_2196;
																																																																									BgL_proc2z00_7260
																																																																										=
																																																																										BgL_carzd26382zd2_2198;
																																																																									BgL_argsz00_7261
																																																																										=
																																																																										BgL_cdrzd26350zd2_2193;
																																																																									BgL_argsz00_1642
																																																																										=
																																																																										BgL_argsz00_7261;
																																																																									BgL_proc2z00_1641
																																																																										=
																																																																										BgL_proc2z00_7260;
																																																																									BgL_proc1z00_1640
																																																																										=
																																																																										BgL_proc1z00_7259;
																																																																									BgL_testz00_1639
																																																																										=
																																																																										BgL_testz00_7257;
																																																																									goto
																																																																										BgL_tagzd2387zd2_1643;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_7264;
																																																																											goto
																																																																												BgL_tagzd2401zd2_1666;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_7264);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 115 */
																																																																											goto
																																																																												BgL_tagzd2402zd2_1667;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_7268;
																																																																									goto
																																																																										BgL_tagzd2401zd2_1666;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_7268);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									goto
																																																																										BgL_tagzd2402zd2_1667;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_7272;
																																																																							goto
																																																																								BgL_tagzd2401zd2_1666;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_7272);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							goto
																																																																								BgL_tagzd2402zd2_1667;
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 115 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{
																																																																obj_t
																																																																	BgL_auxz00_7276;
																																																																goto
																																																																	BgL_tagzd2401zd2_1666;
																																																																return
																																																																	(
																																																																	(BgL_nodez00_bglt)
																																																																	BgL_auxz00_7276);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 115 */
																																																																goto
																																																																	BgL_tagzd2402zd2_1667;
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 115 */
																																																												obj_t
																																																													BgL_cdrzd26640zd2_2220;
																																																												BgL_cdrzd26640zd2_2220
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{	/* Ast/sexp.scm 115 */
																																																													obj_t
																																																														BgL_cdrzd26647zd2_2221;
																																																													BgL_cdrzd26647zd2_2221
																																																														=
																																																														CDR
																																																														(CAR
																																																														(BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 115 */
																																																														obj_t
																																																															BgL_cdrzd26654zd2_2222;
																																																														BgL_cdrzd26654zd2_2222
																																																															=
																																																															CDR
																																																															(BgL_cdrzd26647zd2_2221);
																																																														{	/* Ast/sexp.scm 115 */
																																																															obj_t
																																																																BgL_carzd26660zd2_2223;
																																																															obj_t
																																																																BgL_cdrzd26661zd2_2224;
																																																															BgL_carzd26660zd2_2223
																																																																=
																																																																CAR
																																																																(BgL_cdrzd26654zd2_2222);
																																																															BgL_cdrzd26661zd2_2224
																																																																=
																																																																CDR
																																																																(BgL_cdrzd26654zd2_2222);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26660zd2_2223))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	obj_t
																																																																		BgL_carzd26668zd2_2226;
																																																																	BgL_carzd26668zd2_2226
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd26661zd2_2224);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26668zd2_2226))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (NULLP(CDR(BgL_cdrzd26661zd2_2224)))
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26640zd2_2220))
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_7298;
																																																																							obj_t
																																																																								BgL_proc2z00_7297;
																																																																							obj_t
																																																																								BgL_proc1z00_7296;
																																																																							obj_t
																																																																								BgL_testz00_7294;
																																																																							BgL_testz00_7294
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd26647zd2_2221);
																																																																							BgL_proc1z00_7296
																																																																								=
																																																																								BgL_carzd26660zd2_2223;
																																																																							BgL_proc2z00_7297
																																																																								=
																																																																								BgL_carzd26668zd2_2226;
																																																																							BgL_argsz00_7298
																																																																								=
																																																																								BgL_cdrzd26640zd2_2220;
																																																																							BgL_argsz00_1642
																																																																								=
																																																																								BgL_argsz00_7298;
																																																																							BgL_proc2z00_1641
																																																																								=
																																																																								BgL_proc2z00_7297;
																																																																							BgL_proc1z00_1640
																																																																								=
																																																																								BgL_proc1z00_7296;
																																																																							BgL_testz00_1639
																																																																								=
																																																																								BgL_testz00_7294;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1643;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_7301;
																																																																									goto
																																																																										BgL_tagzd2401zd2_1666;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_7301);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									goto
																																																																										BgL_tagzd2402zd2_1667;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_7305;
																																																																							goto
																																																																								BgL_tagzd2401zd2_1666;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_7305);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							goto
																																																																								BgL_tagzd2402zd2_1667;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{
																																																																					obj_t
																																																																						BgL_auxz00_7309;
																																																																					goto
																																																																						BgL_tagzd2401zd2_1666;
																																																																					return
																																																																						(
																																																																						(BgL_nodez00_bglt)
																																																																						BgL_auxz00_7309);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					goto
																																																																						BgL_tagzd2402zd2_1667;
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{
																																																																			obj_t
																																																																				BgL_auxz00_7313;
																																																																			goto
																																																																				BgL_tagzd2401zd2_1666;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_7313);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			goto
																																																																				BgL_tagzd2402zd2_1667;
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 115 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{
																																																												obj_t
																																																													BgL_auxz00_7317;
																																																												goto
																																																													BgL_tagzd2401zd2_1666;
																																																												return
																																																													(
																																																													(BgL_nodez00_bglt)
																																																													BgL_auxz00_7317);
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 115 */
																																																												goto
																																																													BgL_tagzd2402zd2_1667;
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								obj_t
																																																									BgL_cdrzd26976zd2_2238;
																																																								BgL_cdrzd26976zd2_2238
																																																									=
																																																									CDR
																																																									(BgL_expz00_21);
																																																								{	/* Ast/sexp.scm 115 */
																																																									obj_t
																																																										BgL_cdrzd26982zd2_2239;
																																																									BgL_cdrzd26982zd2_2239
																																																										=
																																																										CDR
																																																										(CAR
																																																										(BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 115 */
																																																										obj_t
																																																											BgL_cdrzd26988zd2_2240;
																																																										BgL_cdrzd26988zd2_2240
																																																											=
																																																											CDR
																																																											(BgL_cdrzd26982zd2_2239);
																																																										{	/* Ast/sexp.scm 115 */
																																																											obj_t
																																																												BgL_carzd26993zd2_2241;
																																																											obj_t
																																																												BgL_cdrzd26994zd2_2242;
																																																											BgL_carzd26993zd2_2241
																																																												=
																																																												CAR
																																																												(BgL_cdrzd26988zd2_2240);
																																																											BgL_cdrzd26994zd2_2242
																																																												=
																																																												CDR
																																																												(BgL_cdrzd26988zd2_2240);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26993zd2_2241))
																																																												{	/* Ast/sexp.scm 115 */
																																																													if (PAIRP(BgL_cdrzd26994zd2_2242))
																																																														{	/* Ast/sexp.scm 115 */
																																																															obj_t
																																																																BgL_carzd26999zd2_2245;
																																																															BgL_carzd26999zd2_2245
																																																																=
																																																																CAR
																																																																(BgL_cdrzd26994zd2_2242);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26999zd2_2245))
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (NULLP(CDR(BgL_cdrzd26994zd2_2242)))
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26976zd2_2238))
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_7341;
																																																																					obj_t
																																																																						BgL_proc2z00_7340;
																																																																					obj_t
																																																																						BgL_proc1z00_7339;
																																																																					obj_t
																																																																						BgL_testz00_7337;
																																																																					BgL_testz00_7337
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd26982zd2_2239);
																																																																					BgL_proc1z00_7339
																																																																						=
																																																																						BgL_carzd26993zd2_2241;
																																																																					BgL_proc2z00_7340
																																																																						=
																																																																						BgL_carzd26999zd2_2245;
																																																																					BgL_argsz00_7341
																																																																						=
																																																																						BgL_cdrzd26976zd2_2238;
																																																																					BgL_argsz00_1642
																																																																						=
																																																																						BgL_argsz00_7341;
																																																																					BgL_proc2z00_1641
																																																																						=
																																																																						BgL_proc2z00_7340;
																																																																					BgL_proc1z00_1640
																																																																						=
																																																																						BgL_proc1z00_7339;
																																																																					BgL_testz00_1639
																																																																						=
																																																																						BgL_testz00_7337;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1643;
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_7344;
																																																																							goto
																																																																								BgL_tagzd2401zd2_1666;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_7344);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							goto
																																																																								BgL_tagzd2402zd2_1667;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{
																																																																					obj_t
																																																																						BgL_auxz00_7348;
																																																																					goto
																																																																						BgL_tagzd2401zd2_1666;
																																																																					return
																																																																						(
																																																																						(BgL_nodez00_bglt)
																																																																						BgL_auxz00_7348);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					goto
																																																																						BgL_tagzd2402zd2_1667;
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{
																																																																			obj_t
																																																																				BgL_auxz00_7352;
																																																																			goto
																																																																				BgL_tagzd2401zd2_1666;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_7352);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 115 */
																																																																			goto
																																																																				BgL_tagzd2402zd2_1667;
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{
																																																																	obj_t
																																																																		BgL_auxz00_7356;
																																																																	goto
																																																																		BgL_tagzd2401zd2_1666;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_7356);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 115 */
																																																																	goto
																																																																		BgL_tagzd2402zd2_1667;
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 115 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_7360;
																																																															goto
																																																																BgL_tagzd2401zd2_1666;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_7360);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 115 */
																																																															goto
																																																																BgL_tagzd2402zd2_1667;
																																																														}
																																																												}
																																																										}
																																																									}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{
																																																								obj_t
																																																									BgL_auxz00_7364;
																																																								goto
																																																									BgL_tagzd2401zd2_1666;
																																																								return
																																																									(
																																																									(BgL_nodez00_bglt)
																																																									BgL_auxz00_7364);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								goto
																																																									BgL_tagzd2402zd2_1667;
																																																							}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{
																																																						obj_t
																																																							BgL_auxz00_7368;
																																																						goto
																																																							BgL_tagzd2401zd2_1666;
																																																						return
																																																							(
																																																							(BgL_nodez00_bglt)
																																																							BgL_auxz00_7368);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						goto
																																																							BgL_tagzd2402zd2_1667;
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 115 */
																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																			{
																																																				obj_t
																																																					BgL_auxz00_7372;
																																																				goto
																																																					BgL_tagzd2401zd2_1666;
																																																				return
																																																					(
																																																					(BgL_nodez00_bglt)
																																																					BgL_auxz00_7372);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				goto
																																																					BgL_tagzd2402zd2_1667;
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													}
																												else
																													{	/* Ast/sexp.scm 115 */
																														if (
																															(BgL_carzd24396zd2_2097
																																==
																																CNST_TABLE_REF((
																																		(long)
																																		18))))
																															{	/* Ast/sexp.scm 115 */
																																goto
																																	BgL_tagzd2381zd2_1623;
																															}
																														else
																															{	/* Ast/sexp.scm 115 */
																																if (CBOOL
																																	(BGl_letzd2symzf3z21zzast_letz00
																																		(BgL_carzd24396zd2_2097)))
																																	{	/* Ast/sexp.scm 115 */
																																		goto
																																			BgL_tagzd2381zd2_1623;
																																	}
																																else
																																	{	/* Ast/sexp.scm 115 */
																																		if (
																																			(BgL_carzd24396zd2_2097
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						19))))
																																			{	/* Ast/sexp.scm 115 */
																																				goto
																																					BgL_tagzd2381zd2_1623;
																																			}
																																		else
																																			{	/* Ast/sexp.scm 115 */
																																				if (
																																					(CAR
																																						(BgL_expz00_21)
																																						==
																																						CNST_TABLE_REF
																																						(((long) 21))))
																																					{	/* Ast/sexp.scm 115 */
																																						goto
																																							BgL_tagzd2382zd2_1624;
																																					}
																																				else
																																					{	/* Ast/sexp.scm 115 */
																																						obj_t
																																							BgL_carzd27521zd2_2384;
																																						BgL_carzd27521zd2_2384
																																							=
																																							CAR
																																							(BgL_expz00_21);
																																						if (
																																							(BgL_carzd27521zd2_2384
																																								==
																																								CNST_TABLE_REF
																																								(((long) 20))))
																																							{
																																								BgL_letzd2funzd2_bglt
																																									BgL_auxz00_7391;
																																								goto
																																									BgL_tagzd2383zd2_1625;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_7391);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 115 */
																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27521zd2_2384)))
																																									{
																																										BgL_letzd2funzd2_bglt
																																											BgL_auxz00_7396;
																																										goto
																																											BgL_tagzd2383zd2_1625;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_7396);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 115 */
																																										if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																											{	/* Ast/sexp.scm 115 */
																																												goto
																																													BgL_tagzd2388zd2_1644;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 115 */
																																												if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																													{	/* Ast/sexp.scm 115 */
																																														goto
																																															BgL_tagzd2389zd2_1645;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 115 */
																																														obj_t
																																															BgL_cdrzd27600zd2_2389;
																																														BgL_cdrzd27600zd2_2389
																																															=
																																															CDR
																																															(BgL_expz00_21);
																																														if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																															{	/* Ast/sexp.scm 115 */
																																																if (PAIRP(BgL_cdrzd27600zd2_2389))
																																																	{
																																																		obj_t
																																																			BgL_restz00_7415;
																																																		obj_t
																																																			BgL_effectz00_7413;
																																																		BgL_effectz00_7413
																																																			=
																																																			CAR
																																																			(BgL_cdrzd27600zd2_2389);
																																																		BgL_restz00_7415
																																																			=
																																																			CDR
																																																			(BgL_cdrzd27600zd2_2389);
																																																		BgL_restz00_1647
																																																			=
																																																			BgL_restz00_7415;
																																																		BgL_effectz00_1646
																																																			=
																																																			BgL_effectz00_7413;
																																																		goto
																																																			BgL_tagzd2390zd2_1648;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 115 */
																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																			{
																																																				obj_t
																																																					BgL_auxz00_7419;
																																																				goto
																																																					BgL_tagzd2401zd2_1666;
																																																				return
																																																					(
																																																					(BgL_nodez00_bglt)
																																																					BgL_auxz00_7419);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				goto
																																																					BgL_tagzd2402zd2_1667;
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 115 */
																																																if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																	{	/* Ast/sexp.scm 115 */
																																																		goto
																																																			BgL_tagzd2391zd2_1649;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 115 */
																																																		if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																			{	/* Ast/sexp.scm 115 */
																																																				if (PAIRP(BgL_cdrzd27600zd2_2389))
																																																					{
																																																						obj_t
																																																							BgL_restz00_7433;
																																																						obj_t
																																																							BgL_effectz00_7431;
																																																						BgL_effectz00_7431
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27600zd2_2389);
																																																						BgL_restz00_7433
																																																							=
																																																							CDR
																																																							(BgL_cdrzd27600zd2_2389);
																																																						BgL_restz00_1651
																																																							=
																																																							BgL_restz00_7433;
																																																						BgL_effectz00_1650
																																																							=
																																																							BgL_effectz00_7431;
																																																						goto
																																																							BgL_tagzd2392zd2_1652;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{
																																																								obj_t
																																																									BgL_auxz00_7437;
																																																								goto
																																																									BgL_tagzd2401zd2_1666;
																																																								return
																																																									(
																																																									(BgL_nodez00_bglt)
																																																									BgL_auxz00_7437);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								goto
																																																									BgL_tagzd2402zd2_1667;
																																																							}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 115 */
																																																				if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																					{	/* Ast/sexp.scm 115 */
																																																						goto
																																																							BgL_tagzd2393zd2_1653;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 115 */
																																																						if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																							{	/* Ast/sexp.scm 115 */
																																																								goto
																																																									BgL_tagzd2394zd2_1654;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 115 */
																																																								if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																									{
																																																										BgL_letzd2funzd2_bglt
																																																											BgL_auxz00_7451;
																																																										goto
																																																											BgL_tagzd2395zd2_1655;
																																																										return
																																																											(
																																																											(BgL_nodez00_bglt)
																																																											BgL_auxz00_7451);
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 115 */
																																																										if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																											{
																																																												BgL_jumpzd2exzd2itz00_bglt
																																																													BgL_auxz00_7457;
																																																												goto
																																																													BgL_tagzd2396zd2_1656;
																																																												return
																																																													(
																																																													(BgL_nodez00_bglt)
																																																													BgL_auxz00_7457);
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 115 */
																																																												obj_t
																																																													BgL_cdrzd27715zd2_2406;
																																																												BgL_cdrzd27715zd2_2406
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																													{	/* Ast/sexp.scm 115 */
																																																														if (PAIRP(BgL_cdrzd27715zd2_2406))
																																																															{	/* Ast/sexp.scm 115 */
																																																																obj_t
																																																																	BgL_cdrzd27717zd2_2409;
																																																																BgL_cdrzd27717zd2_2409
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd27715zd2_2406);
																																																																if (PAIRP(BgL_cdrzd27717zd2_2409))
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		if (NULLP(CDR(BgL_cdrzd27717zd2_2409)))
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				goto
																																																																					BgL_tagzd2397zd2_1657;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_7474;
																																																																						goto
																																																																							BgL_tagzd2401zd2_1666;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_7474);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						goto
																																																																							BgL_tagzd2402zd2_1667;
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{
																																																																				obj_t
																																																																					BgL_auxz00_7478;
																																																																				goto
																																																																					BgL_tagzd2401zd2_1666;
																																																																				return
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BgL_auxz00_7478);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				goto
																																																																					BgL_tagzd2402zd2_1667;
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 115 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{
																																																																		obj_t
																																																																			BgL_auxz00_7482;
																																																																		goto
																																																																			BgL_tagzd2401zd2_1666;
																																																																		return
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BgL_auxz00_7482);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		goto
																																																																			BgL_tagzd2402zd2_1667;
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 115 */
																																																														if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																															{	/* Ast/sexp.scm 115 */
																																																																if (PAIRP(BgL_cdrzd27715zd2_2406))
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		obj_t
																																																																			BgL_cdrzd27762zd2_2419;
																																																																		BgL_cdrzd27762zd2_2419
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd27715zd2_2406);
																																																																		if (PAIRP(BgL_cdrzd27762zd2_2419))
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				obj_t
																																																																					BgL_cdrzd27767zd2_2421;
																																																																				BgL_cdrzd27767zd2_2421
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd27762zd2_2419);
																																																																				if ((CAR(BgL_cdrzd27762zd2_2419) == CNST_TABLE_REF(((long) 31))))
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						if (PAIRP(BgL_cdrzd27767zd2_2421))
																																																																							{	/* Ast/sexp.scm 115 */
																																																																								obj_t
																																																																									BgL_arg2151z00_2424;
																																																																								obj_t
																																																																									BgL_arg2152z00_2425;
																																																																								obj_t
																																																																									BgL_arg2153z00_2426;
																																																																								BgL_arg2151z00_2424
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd27715zd2_2406);
																																																																								BgL_arg2152z00_2425
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd27767zd2_2421);
																																																																								BgL_arg2153z00_2426
																																																																									=
																																																																									CDR
																																																																									(BgL_cdrzd27767zd2_2421);
																																																																								return
																																																																									BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																									(BgL_expz00_21,
																																																																									BgL_arg2151z00_2424,
																																																																									BgL_arg2152z00_2425,
																																																																									BgL_arg2153z00_2426,
																																																																									BgL_stackz00_22,
																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																									(BgL_expz00_21,
																																																																										BgL_locz00_23),
																																																																									BgL_sitez00_24);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 115 */
																																																																								obj_t
																																																																									BgL_cdrzd27780zd2_2427;
																																																																								BgL_cdrzd27780zd2_2427
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{	/* Ast/sexp.scm 115 */
																																																																									obj_t
																																																																										BgL_arg2154z00_2428;
																																																																									obj_t
																																																																										BgL_arg2155z00_2429;
																																																																									BgL_arg2154z00_2428
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd27780zd2_2427);
																																																																									BgL_arg2155z00_2429
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd27780zd2_2427);
																																																																									{	/* Ast/sexp.scm 516 */
																																																																										obj_t
																																																																											BgL_arg2555z00_4668;
																																																																										BgL_arg2555z00_4668
																																																																											=
																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																											(BgL_expz00_21,
																																																																											BgL_locz00_23);
																																																																										return
																																																																											BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																											(BgL_expz00_21,
																																																																											BgL_arg2154z00_2428,
																																																																											CNST_TABLE_REF
																																																																											(((long) 4)), BgL_arg2155z00_2429, BgL_stackz00_22, BgL_arg2555z00_4668, BgL_sitez00_24);
																																																																					}}}}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						obj_t
																																																																							BgL_cdrzd27795zd2_2430;
																																																																						BgL_cdrzd27795zd2_2430
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{	/* Ast/sexp.scm 115 */
																																																																							obj_t
																																																																								BgL_arg2157z00_2431;
																																																																							obj_t
																																																																								BgL_arg2158z00_2432;
																																																																							BgL_arg2157z00_2431
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd27795zd2_2430);
																																																																							BgL_arg2158z00_2432
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd27795zd2_2430);
																																																																							{	/* Ast/sexp.scm 516 */
																																																																								obj_t
																																																																									BgL_arg2555z00_4674;
																																																																								BgL_arg2555z00_4674
																																																																									=
																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																									(BgL_expz00_21,
																																																																									BgL_locz00_23);
																																																																								return
																																																																									BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																									(BgL_expz00_21,
																																																																									BgL_arg2157z00_2431,
																																																																									CNST_TABLE_REF
																																																																									(((long) 4)), BgL_arg2158z00_2432, BgL_stackz00_22, BgL_arg2555z00_4674, BgL_sitez00_24);
																																																																			}}}}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				obj_t
																																																																					BgL_cdrzd27810zd2_2434;
																																																																				BgL_cdrzd27810zd2_2434
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{	/* Ast/sexp.scm 115 */
																																																																					obj_t
																																																																						BgL_arg2160z00_2435;
																																																																					obj_t
																																																																						BgL_arg2161z00_2436;
																																																																					BgL_arg2160z00_2435
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd27810zd2_2434);
																																																																					BgL_arg2161z00_2436
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd27810zd2_2434);
																																																																					{	/* Ast/sexp.scm 516 */
																																																																						obj_t
																																																																							BgL_arg2555z00_4680;
																																																																						BgL_arg2555z00_4680
																																																																							=
																																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																																							(BgL_expz00_21,
																																																																							BgL_locz00_23);
																																																																						return
																																																																							BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																							(BgL_expz00_21,
																																																																							BgL_arg2160z00_2435,
																																																																							CNST_TABLE_REF
																																																																							(((long) 4)), BgL_arg2161z00_2436, BgL_stackz00_22, BgL_arg2555z00_4680, BgL_sitez00_24);
																																																																	}}}}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{
																																																																				obj_t
																																																																					BgL_auxz00_7525;
																																																																				goto
																																																																					BgL_tagzd2401zd2_1666;
																																																																				return
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BgL_auxz00_7525);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				goto
																																																																					BgL_tagzd2402zd2_1667;
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 115 */
																																																																if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		if (NULLP(CDR(BgL_expz00_21)))
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				goto
																																																																					BgL_tagzd2400zd2_1665;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_7535;
																																																																						goto
																																																																							BgL_tagzd2401zd2_1666;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_7535);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 115 */
																																																																						goto
																																																																							BgL_tagzd2402zd2_1667;
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 115 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{
																																																																				obj_t
																																																																					BgL_auxz00_7539;
																																																																				goto
																																																																					BgL_tagzd2401zd2_1666;
																																																																				return
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BgL_auxz00_7539);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 115 */
																																																																				goto
																																																																					BgL_tagzd2402zd2_1667;
																																																																			}
																																																																	}
																																																															}
																																																													}
																																																											}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
								else
									{	/* Ast/sexp.scm 115 */
										BgL_atomz00_1603 = BgL_expz00_21;
										{	/* Ast/sexp.scm 131 */
											bool_t BgL_testz00_7541;

											if (BGl_isazf3zf3zz__objectz00(BgL_atomz00_1603,
													BGl_localz00zzast_varz00))
												{	/* Ast/sexp.scm 131 */
													BgL_testz00_7541 = ((bool_t) 1);
												}
											else
												{	/* Ast/sexp.scm 131 */
													BgL_testz00_7541 =
														BGl_isazf3zf3zz__objectz00(BgL_atomz00_1603,
														BGl_globalz00zzast_varz00);
												}
											if (BgL_testz00_7541)
												{	/* Ast/sexp.scm 131 */
													return
														BGl_variablezd2ze3nodez31zzast_sexpz00
														(BgL_atomz00_1603, BgL_locz00_23, BgL_sitez00_24);
												}
											else
												{	/* Ast/sexp.scm 133 */
													bool_t BgL_testz00_7546;

													if (STRUCTP(BgL_atomz00_1603))
														{	/* Ast/sexp.scm 133 */
															BgL_testz00_7546 = ((bool_t) 1);
														}
													else
														{	/* Ast/sexp.scm 133 */
															if (VECTORP(BgL_atomz00_1603))
																{	/* Ast/sexp.scm 133 */
																	BgL_testz00_7546 = ((bool_t) 1);
																}
															else
																{	/* Ast/sexp.scm 133 */
																	if (BGL_OBJECTP(BgL_atomz00_1603))
																		{	/* Ast/sexp.scm 133 */
																			BgL_testz00_7546 = ((bool_t) 1);
																		}
																	else
																		{	/* Ast/sexp.scm 133 */
																			BgL_testz00_7546 =
																				PROCEDUREP(BgL_atomz00_1603);
																		}
																}
														}
													if (BgL_testz00_7546)
														{	/* Ast/sexp.scm 134 */
															BgL_nodez00_bglt BgL_res2861z00_3504;

															{	/* Ast/sexp.scm 670 */
																obj_t BgL_arg2660z00_3500;
																BgL_nodez00_bglt BgL_arg2661z00_3501;

																BgL_arg2660z00_3500 =
																	BGl_shapez00zztools_shapez00
																	(BGl_currentzd2functionzd2zztools_errorz00());
																BgL_arg2661z00_3501 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(CNST_TABLE_REF(((long) 4)), BNIL,
																	BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																{	/* Ast/sexp.scm 669 */
																	obj_t BgL_list2662z00_3503;

																	BgL_list2662z00_3503 =
																		MAKE_PAIR(
																		((obj_t) BgL_arg2661z00_3501), BNIL);
																	BgL_res2861z00_3504 =
																		((BgL_nodez00_bglt)
																		BGl_userzd2errorzf2locationz20zztools_errorz00
																		(BgL_locz00_23, BgL_arg2660z00_3500,
																			BGl_string3137z00zzast_sexpz00,
																			BgL_expz00_21, BgL_list2662z00_3503));
															}}
															return BgL_res2861z00_3504;
														}
													else
														{	/* Ast/sexp.scm 133 */
															if (SYMBOLP(BgL_atomz00_1603))
																{	/* Ast/sexp.scm 140 */
																	obj_t BgL_g1112z00_2489;

																	BgL_g1112z00_2489 =
																		BGl_findzd2localzd2zzast_sexpz00
																		(BgL_atomz00_1603, BgL_stackz00_22);
																	if (CBOOL(BgL_g1112z00_2489))
																		{	/* Ast/sexp.scm 140 */
																			return
																				BGl_variablezd2ze3nodez31zzast_sexpz00
																				(BgL_g1112z00_2489, BgL_locz00_23,
																				BgL_sitez00_24);
																		}
																	else
																		{	/* Ast/sexp.scm 144 */
																			obj_t BgL_globalz00_2492;

																			BgL_globalz00_2492 =
																				BGl_findzd2globalzd2zzast_envz00
																				(BgL_atomz00_1603, BNIL);
																			if (BGl_isazf3zf3zz__objectz00
																				(BgL_globalz00_2492,
																					BGl_globalz00zzast_varz00))
																				{	/* Ast/sexp.scm 146 */
																					if (
																						((((BgL_globalz00_bglt) CREF(
																										((BgL_globalz00_bglt)
																											BgL_globalz00_2492)))->
																								BgL_importz00) ==
																							CNST_TABLE_REF(((long) 11))))
																						{	/* Ast/sexp.scm 149 */
																							obj_t BgL_arg2207z00_2495;

																							{	/* Ast/sexp.scm 149 */
																								obj_t BgL_arg2209z00_2496;

																								{	/* Ast/sexp.scm 149 */
																									obj_t BgL_arg2210z00_2497;

																									{	/* Ast/sexp.scm 149 */
																										obj_t BgL_arg2211z00_2498;

																										BgL_arg2211z00_2498 =
																											MAKE_PAIR
																											(BgL_atomz00_1603, BNIL);
																										BgL_arg2210z00_2497 =
																											MAKE_PAIR(CNST_TABLE_REF((
																													(long) 13)),
																											BgL_arg2211z00_2498);
																									}
																									BgL_arg2209z00_2496 =
																										MAKE_PAIR
																										(BgL_arg2210z00_2497, BNIL);
																								}
																								BgL_arg2207z00_2495 =
																									MAKE_PAIR(CNST_TABLE_REF((
																											(long) 11)),
																									BgL_arg2209z00_2496);
																							}
																							{
																								obj_t BgL_expz00_7583;

																								BgL_expz00_7583 =
																									BgL_arg2207z00_2495;
																								BgL_expz00_21 = BgL_expz00_7583;
																								goto
																									BGl_sexpzd2ze3nodez31zzast_sexpz00;
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 148 */
																							return
																								BGl_variablezd2ze3nodez31zzast_sexpz00
																								(BgL_globalz00_2492,
																								BgL_locz00_23, BgL_sitez00_24);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 147 */
																					BgL_nodez00_bglt BgL_res2864z00_3517;

																					{	/* Ast/sexp.scm 670 */
																						obj_t BgL_arg2660z00_3513;
																						BgL_nodez00_bglt
																							BgL_arg2661z00_3514;
																						BgL_arg2660z00_3513 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg2661z00_3514 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_23,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 669 */
																							obj_t BgL_list2662z00_3516;

																							BgL_list2662z00_3516 =
																								MAKE_PAIR(
																								((obj_t) BgL_arg2661z00_3514),
																								BNIL);
																							BgL_res2864z00_3517 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_23,
																									BgL_arg2660z00_3513,
																									BGl_string3136z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list2662z00_3516));
																					}}
																					return BgL_res2864z00_3517;
																				}
																		}
																}
															else
																{	/* Ast/sexp.scm 136 */
																	BgL_atomz00_bglt BgL_new1110z00_2501;

																	{	/* Ast/sexp.scm 137 */
																		BgL_atomz00_bglt BgL_new1109z00_2502;

																		BgL_new1109z00_2502 =
																			((BgL_atomz00_bglt)
																			BREF(GC_MALLOC(sizeof(struct
																						BgL_atomz00_bgl))));
																		{	/* Ast/sexp.scm 137 */
																			long BgL_arg2214z00_2503;

																			{	/* Ast/sexp.scm 137 */
																				long BgL_res2865z00_3519;

																				BgL_res2865z00_3519 =
																					BGL_CLASS_INDEX
																					(BGl_atomz00zzast_nodez00);
																				BgL_arg2214z00_2503 =
																					BgL_res2865z00_3519;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1109z00_2502),
																				BgL_arg2214z00_2503);
																		}
																		{	/* Ast/sexp.scm 137 */
																			BgL_objectz00_bglt BgL_auxz00_7598;

																			BgL_auxz00_7598 =
																				((BgL_objectz00_bglt)
																				BgL_new1109z00_2502);
																			BGL_OBJECT_WIDENING_SET(BgL_auxz00_7598,
																				BFALSE);
																		}
																		BgL_new1110z00_2501 = BgL_new1109z00_2502;
																	}
																	((((BgL_nodez00_bglt) CREF(
																					((BgL_nodez00_bglt)
																						BgL_new1110z00_2501)))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_23), BUNSPEC);
																	((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
																						BgL_new1110z00_2501)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt)
																			BGl_getzd2typezd2atomz00zztype_typeofz00
																			(BgL_atomz00_1603)), BUNSPEC);
																	((((BgL_atomz00_bglt)
																				CREF(BgL_new1110z00_2501))->
																			BgL_valuez00) =
																		((obj_t) BgL_atomz00_1603), BUNSPEC);
																	return ((BgL_nodez00_bglt)
																		BgL_new1110z00_2501);
																}
														}
												}
										}
									}
							}
					}
			}
		}
	}



/* liip */
	obj_t BGl_liipz00zzast_sexpz00(obj_t BgL_argsz00_2806)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 357 */
			if (NULLP(BgL_argsz00_2806))
				{	/* Ast/sexp.scm 358 */
					return CNST_TABLE_REF(((long) 4));
				}
			else
				{	/* Ast/sexp.scm 360 */
					obj_t BgL_arg2408z00_2809;

					{	/* Ast/sexp.scm 360 */
						obj_t BgL_arg2409z00_2810;
						obj_t BgL_arg2410z00_2811;

						BgL_arg2409z00_2810 = CAR(BgL_argsz00_2806);
						BgL_arg2410z00_2811 =
							MAKE_PAIR(BGl_liipz00zzast_sexpz00(CDR(BgL_argsz00_2806)), BNIL);
						BgL_arg2408z00_2809 =
							MAKE_PAIR(BgL_arg2409z00_2810, BgL_arg2410z00_2811);
					}
					return MAKE_PAIR(CNST_TABLE_REF(((long) 32)), BgL_arg2408z00_2809);
		}}
	}



/* loop */
	obj_t BGl_loopz00zzast_sexpz00(obj_t BgL_expz00_4962, obj_t BgL_locz00_4961,
		obj_t BgL_varsz00_2770, obj_t BgL_argsz00_2771)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 342 */
		BGl_loopz00zzast_sexpz00:
			if (NULLP(BgL_varsz00_2770))
				{	/* Ast/sexp.scm 345 */
					if (NULLP(BgL_argsz00_2771))
						{	/* Ast/sexp.scm 346 */
							return BNIL;
						}
					else
						{	/* Ast/sexp.scm 346 */
							return
								BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_4961,
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00()),
								BGl_string3139z00zzast_sexpz00, BgL_expz00_4962, BNIL);
						}
				}
			else
				{	/* Ast/sexp.scm 345 */
					if (PAIRP(BgL_varsz00_2770))
						{	/* Ast/sexp.scm 353 */
							if (BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(CAR
									(BgL_varsz00_2770)))
								{	/* Ast/sexp.scm 363 */
									obj_t BgL_argz00_2780;

									BgL_argz00_2780 =
										BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(CDR
										(BgL_varsz00_2770));
									if (CBOOL(BgL_argz00_2780))
										{
											obj_t BgL_varsz00_7634;

											BgL_varsz00_7634 = BgL_argz00_2780;
											BgL_varsz00_2770 = BgL_varsz00_7634;
											goto BGl_loopz00zzast_sexpz00;
										}
									else
										{
											obj_t BgL_varsz00_7635;

											BgL_varsz00_7635 = BNIL;
											BgL_varsz00_2770 = BgL_varsz00_7635;
											goto BGl_loopz00zzast_sexpz00;
										}
								}
							else
								{	/* Ast/sexp.scm 368 */
									bool_t BgL_testz00_7636;

									{	/* Ast/sexp.scm 368 */
										obj_t BgL_auxz00_7637;

										BgL_auxz00_7637 = CAR(BgL_varsz00_2770);
										BgL_testz00_7636 = SYMBOLP(BgL_auxz00_7637);
									}
									if (BgL_testz00_7636)
										{	/* Ast/sexp.scm 368 */
											if (NULLP(BgL_argsz00_2771))
												{	/* Ast/sexp.scm 374 */
													return
														BGl_userzd2errorzf2locationz20zztools_errorz00
														(BgL_locz00_4961,
														BGl_shapez00zztools_shapez00
														(BGl_currentzd2functionzd2zztools_errorz00()),
														BGl_string3139z00zzast_sexpz00, BgL_expz00_4962,
														BNIL);
												}
											else
												{	/* Ast/sexp.scm 381 */
													obj_t BgL_arg2388z00_2787;
													obj_t BgL_arg2389z00_2788;

													{	/* Ast/sexp.scm 381 */
														obj_t BgL_arg2390z00_2789;
														obj_t BgL_arg2391z00_2790;

														BgL_arg2390z00_2789 = CAR(BgL_varsz00_2770);
														BgL_arg2391z00_2790 = CAR(BgL_argsz00_2771);
														{	/* Ast/sexp.scm 381 */
															obj_t BgL_list2392z00_2791;

															{	/* Ast/sexp.scm 381 */
																obj_t BgL_arg2393z00_2792;

																BgL_arg2393z00_2792 =
																	MAKE_PAIR(BgL_arg2391z00_2790, BNIL);
																BgL_list2392z00_2791 =
																	MAKE_PAIR(BgL_arg2390z00_2789,
																	BgL_arg2393z00_2792);
															}
															BgL_arg2388z00_2787 = BgL_list2392z00_2791;
														}
													}
													BgL_arg2389z00_2788 =
														BGl_loopz00zzast_sexpz00(BgL_expz00_4962,
														BgL_locz00_4961, CDR(BgL_varsz00_2770),
														CDR(BgL_argsz00_2771));
													return MAKE_PAIR(BgL_arg2388z00_2787,
														BgL_arg2389z00_2788);
												}
										}
									else
										{	/* Ast/sexp.scm 368 */
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_4961,
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00()),
												BGl_string3140z00zzast_sexpz00, BgL_expz00_4962, BNIL);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 358 */
							obj_t BgL_arg2401z00_2800;

							{	/* Ast/sexp.scm 358 */
								obj_t BgL_arg2403z00_2802;

								BgL_arg2403z00_2802 =
									BGl_liipz00zzast_sexpz00(BgL_argsz00_2771);
								{	/* Ast/sexp.scm 355 */
									obj_t BgL_list2404z00_2803;

									{	/* Ast/sexp.scm 355 */
										obj_t BgL_arg2405z00_2804;

										BgL_arg2405z00_2804 = MAKE_PAIR(BgL_arg2403z00_2802, BNIL);
										BgL_list2404z00_2803 =
											MAKE_PAIR(BgL_varsz00_2770, BgL_arg2405z00_2804);
									}
									BgL_arg2401z00_2800 = BgL_list2404z00_2803;
								}
							}
							{	/* Ast/sexp.scm 354 */
								obj_t BgL_list2402z00_2801;

								BgL_list2402z00_2801 = MAKE_PAIR(BgL_arg2401z00_2800, BNIL);
								return BgL_list2402z00_2801;
							}
						}
				}
		}
	}



/* &sexp->node */
	BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t BgL_envz00_4923,
		obj_t BgL_expz00_4924, obj_t BgL_stackz00_4925, obj_t BgL_locz00_4926,
		obj_t BgL_sitez00_4927)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 110 */
			return
				BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_4924, BgL_stackz00_4925,
				BgL_locz00_4926, BgL_sitez00_4927);
		}
	}



/* &<anonymous:2419> */
	obj_t BGl_z62zc3anonymousza32419ze3ze1zzast_sexpz00(obj_t BgL_envz00_4928,
		obj_t BgL_objz00_4930, obj_t BgL_procz00_4931, obj_t BgL_msgz00_4932)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 387 */
			{	/* Ast/sexp.scm 388 */
				obj_t BgL_locz00_4929;

				BgL_locz00_4929 = PROCEDURE_REF(BgL_envz00_4928, (int) (((long) 0)));
				{
					obj_t BgL_objz00_2821;
					obj_t BgL_procz00_2822;
					obj_t BgL_msgz00_2823;

					BgL_objz00_2821 = BgL_objz00_4930;
					BgL_procz00_2822 = BgL_procz00_4931;
					BgL_msgz00_2823 = BgL_msgz00_4932;
					return
						BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_4929,
						BgL_objz00_2821, BgL_procz00_2822, BgL_msgz00_2823, BNIL);
				}
			}
		}
	}



/* variable->node */
	BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t BgL_vz00_25,
		obj_t BgL_locz00_26, obj_t BgL_sitez00_27)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 535 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_vz00_25), BgL_locz00_26, BgL_sitez00_27);
			{	/* Ast/sexp.scm 537 */
				bool_t BgL_testz00_7666;

				if ((BgL_sitez00_27 == CNST_TABLE_REF(((long) 33))))
					{	/* Ast/sexp.scm 537 */
						BgL_testz00_7666 = ((bool_t) 0);
					}
				else
					{	/* Ast/sexp.scm 537 */
						BgL_valuez00_bglt BgL_arg2579z00_3027;

						BgL_arg2579z00_3027 =
							(((BgL_variablez00_bglt) CREF(
									((BgL_variablez00_bglt) BgL_vz00_25)))->BgL_valuez00);
						{	/* Ast/sexp.scm 537 */
							bool_t BgL_res3068z00_4687;

							BgL_res3068z00_4687 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg2579z00_3027), BGl_funz00zzast_varz00);
							BgL_testz00_7666 = BgL_res3068z00_4687;
						}
					}
				if (BgL_testz00_7666)
					{	/* Ast/sexp.scm 538 */
						bool_t BgL_testz00_7674;

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_25,
								BGl_globalz00zzast_varz00))
							{	/* Ast/sexp.scm 539 */
								bool_t BgL_testz00_7677;

								{	/* Ast/sexp.scm 539 */
									BgL_valuez00_bglt BgL_arg2575z00_3021;

									BgL_arg2575z00_3021 =
										(((BgL_variablez00_bglt) CREF(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_vz00_25))))->BgL_valuez00);
									{	/* Ast/sexp.scm 539 */
										bool_t BgL_res3070z00_4692;

										BgL_res3070z00_4692 =
											BGl_isazf3zf3zz__objectz00(
											((obj_t) BgL_arg2575z00_3021), BGl_cfunz00zzast_varz00);
										BgL_testz00_7677 = BgL_res3070z00_4692;
									}
								}
								if (BgL_testz00_7677)
									{	/* Ast/sexp.scm 540 */
										bool_t BgL_testz00_7683;

										{	/* Ast/sexp.scm 540 */
											obj_t BgL_arg2572z00_3020;

											BgL_arg2572z00_3020 =
												BGl_thezd2backendzd2zzbackend_backendz00();
											BgL_testz00_7683 =
												(((BgL_backendz00_bglt) CREF(
														((BgL_backendz00_bglt) BgL_arg2572z00_3020)))->
												BgL_foreignzd2closurezd2);
										}
										if (BgL_testz00_7683)
											{	/* Ast/sexp.scm 540 */
												BgL_testz00_7674 = ((bool_t) 0);
											}
										else
											{	/* Ast/sexp.scm 540 */
												if ((BgL_sitez00_27 == CNST_TABLE_REF(((long) 29))))
													{	/* Ast/sexp.scm 541 */
														BgL_testz00_7674 = ((bool_t) 0);
													}
												else
													{	/* Ast/sexp.scm 541 */
														BgL_testz00_7674 = ((bool_t) 1);
													}
											}
									}
								else
									{	/* Ast/sexp.scm 539 */
										BgL_testz00_7674 = ((bool_t) 0);
									}
							}
						else
							{	/* Ast/sexp.scm 538 */
								BgL_testz00_7674 = ((bool_t) 0);
							}
						if (BgL_testz00_7674)
							{	/* Ast/sexp.scm 543 */
								obj_t BgL_arg2559z00_3008;

								{	/* Ast/sexp.scm 543 */
									obj_t BgL_arg2560z00_3009;

									{	/* Ast/sexp.scm 543 */
										obj_t BgL_arg2563z00_3011;

										BgL_arg2563z00_3011 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										BgL_arg2560z00_3009 =
											(((BgL_backendz00_bglt) CREF(
													((BgL_backendz00_bglt) BgL_arg2563z00_3011)))->
											BgL_namez00);
									}
									{	/* Ast/sexp.scm 543 */
										obj_t BgL_list2561z00_3010;

										BgL_list2561z00_3010 = MAKE_PAIR(BgL_arg2560z00_3009, BNIL);
										BgL_arg2559z00_3008 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string3141z00zzast_sexpz00, BgL_list2561z00_3010);
									}
								}
								return
									BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
									(BgL_arg2559z00_3008, BGl_expzd2envzd2zz__r4_numbers_6_5z00,
									BgL_locz00_26);
							}
						else
							{	/* Ast/sexp.scm 544 */
								BgL_closurez00_bglt BgL_new1140z00_3012;

								{	/* Ast/sexp.scm 545 */
									BgL_closurez00_bglt BgL_new1139z00_3014;

									BgL_new1139z00_3014 =
										((BgL_closurez00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_closurez00_bgl))));
									{	/* Ast/sexp.scm 545 */
										long BgL_arg2567z00_3015;

										{	/* Ast/sexp.scm 545 */
											long BgL_res3073z00_4700;

											BgL_res3073z00_4700 =
												BGL_CLASS_INDEX(BGl_closurez00zzast_nodez00);
											BgL_arg2567z00_3015 = BgL_res3073z00_4700;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1139z00_3014),
											BgL_arg2567z00_3015);
									}
									{	/* Ast/sexp.scm 545 */
										BgL_objectz00_bglt BgL_auxz00_7700;

										BgL_auxz00_7700 =
											((BgL_objectz00_bglt) BgL_new1139z00_3014);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_7700, BFALSE);
									}
									BgL_new1140z00_3012 = BgL_new1139z00_3014;
								}
								((((BgL_nodez00_bglt) CREF(
												((BgL_nodez00_bglt) BgL_new1140z00_3012)))->
										BgL_locz00) = ((obj_t) BgL_locz00_26), BUNSPEC);
								{
									BgL_typez00_bglt BgL_auxz00_7705;

									{	/* Ast/sexp.scm 546 */
										BgL_typez00_bglt BgL_arg2564z00_3013;

										BgL_arg2564z00_3013 =
											(((BgL_variablez00_bglt) CREF(
													((BgL_variablez00_bglt) BgL_vz00_25)))->BgL_typez00);
										BgL_auxz00_7705 =
											BGl_strictzd2nodezd2typez00zzast_nodez00(
											((BgL_typez00_bglt)
												BGl_za2procedureza2z00zztype_cachez00),
											BgL_arg2564z00_3013);
									}
									((((BgL_nodez00_bglt) CREF(
													((BgL_nodez00_bglt) BgL_new1140z00_3012)))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_auxz00_7705), BUNSPEC);
								}
								((((BgL_varz00_bglt) CREF(
												((BgL_varz00_bglt) BgL_new1140z00_3012)))->
										BgL_variablez00) =
									((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_25)),
									BUNSPEC);
								return ((BgL_nodez00_bglt) BgL_new1140z00_3012);
							}
					}
				else
					{	/* Ast/sexp.scm 548 */
						BgL_varz00_bglt BgL_new1142z00_3022;

						{	/* Ast/sexp.scm 549 */
							BgL_varz00_bglt BgL_new1141z00_3024;

							BgL_new1141z00_3024 =
								((BgL_varz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_varz00_bgl))));
							{	/* Ast/sexp.scm 549 */
								long BgL_arg2577z00_3025;

								{	/* Ast/sexp.scm 549 */
									long BgL_res3074z00_4705;

									BgL_res3074z00_4705 =
										BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
									BgL_arg2577z00_3025 = BgL_res3074z00_4705;
								}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1141z00_3024),
									BgL_arg2577z00_3025);
							}
							{	/* Ast/sexp.scm 549 */
								BgL_objectz00_bglt BgL_auxz00_7720;

								BgL_auxz00_7720 = ((BgL_objectz00_bglt) BgL_new1141z00_3024);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_7720, BFALSE);
							}
							BgL_new1142z00_3022 = BgL_new1141z00_3024;
						}
						((((BgL_nodez00_bglt) CREF(
										((BgL_nodez00_bglt) BgL_new1142z00_3022)))->BgL_locz00) =
							((obj_t) BgL_locz00_26), BUNSPEC);
						{
							BgL_typez00_bglt BgL_auxz00_7725;

							{	/* Ast/sexp.scm 550 */
								BgL_typez00_bglt BgL_arg2576z00_3023;

								BgL_arg2576z00_3023 =
									(((BgL_variablez00_bglt) CREF(
											((BgL_variablez00_bglt) BgL_vz00_25)))->BgL_typez00);
								BgL_auxz00_7725 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(
									((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00),
									BgL_arg2576z00_3023);
							}
							((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_new1142z00_3022)))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_auxz00_7725), BUNSPEC);
						}
						((((BgL_varz00_bglt) CREF(BgL_new1142z00_3022))->BgL_variablez00) =
							((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_25)),
							BUNSPEC);
						return ((BgL_nodez00_bglt) BgL_new1142z00_3022);
					}
			}
		}
	}



/* call->node */
	BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_28,
		obj_t BgL_stackz00_29, obj_t BgL_locz00_30, obj_t BgL_sitez00_31)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 556 */
			{	/* Ast/sexp.scm 557 */
				obj_t BgL_callerz00_3028;
				obj_t BgL_locz00_3029;

				BgL_callerz00_3028 = CAR(BgL_expz00_28);
				BgL_locz00_3029 =
					BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_28,
					BgL_locz00_30);
				if (SYMBOLP(BgL_callerz00_3028))
					{	/* Ast/sexp.scm 561 */
						obj_t BgL_pidz00_3031;

						BgL_pidz00_3031 =
							BGl_parsezd2idzd2zzast_identz00(BgL_callerz00_3028,
							BgL_locz00_3029);
						{	/* Ast/sexp.scm 561 */
							obj_t BgL_idz00_3032;

							BgL_idz00_3032 = CAR(BgL_pidz00_3031);
							{	/* Ast/sexp.scm 562 */
								obj_t BgL_typez00_3033;

								BgL_typez00_3033 = CDR(BgL_pidz00_3031);
								{	/* Ast/sexp.scm 563 */

									if ((BgL_idz00_3032 == CNST_TABLE_REF(((long) 6))))
										{	/* Ast/sexp.scm 564 */
											return
												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)
													0), BFALSE, ((BgL_typez00_bglt) BgL_typez00_3033),
												BgL_expz00_28, BgL_stackz00_29, BgL_locz00_3029,
												BgL_sitez00_31);
										}
									else
										{	/* Ast/sexp.scm 564 */
											if ((BgL_idz00_3032 == CNST_TABLE_REF(((long) 22))))
												{	/* Ast/sexp.scm 568 */
													bool_t BgL_testz00_7750;

													{	/* Ast/sexp.scm 568 */
														obj_t BgL_auxz00_7751;

														BgL_auxz00_7751 = CDR(BgL_expz00_28);
														BgL_testz00_7750 = PAIRP(BgL_auxz00_7751);
													}
													if (BgL_testz00_7750)
														{	/* Ast/sexp.scm 572 */
															BgL_feffectz00_bglt BgL_arg2584z00_3038;
															obj_t BgL_arg2585z00_3039;

															BgL_arg2584z00_3038 =
																BGl_parsezd2effectzd2zzeffect_feffectz00(CAR(CDR
																	(BgL_expz00_28)));
															{	/* Ast/sexp.scm 573 */
																obj_t BgL_arg2587z00_3041;
																obj_t BgL_arg2588z00_3042;

																{	/* Ast/sexp.scm 573 */
																	obj_t BgL_arg2590z00_3043;

																	BgL_arg2590z00_3043 =
																		MAKE_PAIR(CNST_TABLE_REF(((long) 34)),
																		BNIL);
																	BgL_arg2587z00_3041 =
																		MAKE_PAIR(CNST_TABLE_REF(((long) 35)),
																		BgL_arg2590z00_3043);
																}
																BgL_arg2588z00_3042 =
																	BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																	(CDR(CDR(BgL_expz00_28)), BNIL);
																BgL_arg2585z00_3039 =
																	MAKE_PAIR(BgL_arg2587z00_3041,
																	BgL_arg2588z00_3042);
															}
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 0), ((obj_t) BgL_arg2584z00_3038),
																((BgL_typez00_bglt) BgL_typez00_3033),
																BgL_arg2585z00_3039, BgL_stackz00_29,
																BgL_locz00_3029, BgL_sitez00_31);
														}
													else
														{	/* Ast/sexp.scm 571 */
															obj_t BgL_arg2592z00_3045;

															BgL_arg2592z00_3045 =
																BGl_findzd2locationzf2locz20zztools_locationz00
																(BgL_expz00_28, BgL_locz00_3029);
															{	/* Ast/sexp.scm 569 */
																BgL_nodez00_bglt BgL_res3079z00_4738;

																{	/* Ast/sexp.scm 670 */
																	obj_t BgL_arg2660z00_4734;
																	BgL_nodez00_bglt BgL_arg2661z00_4735;

																	BgL_arg2660z00_4734 =
																		BGl_shapez00zztools_shapez00
																		(BGl_currentzd2functionzd2zztools_errorz00
																		());
																	BgL_arg2661z00_4735 =
																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																		(CNST_TABLE_REF(((long) 4)), BNIL,
																		BgL_arg2592z00_3045,
																		CNST_TABLE_REF(((long) 2)));
																	{	/* Ast/sexp.scm 669 */
																		obj_t BgL_list2662z00_4737;

																		BgL_list2662z00_4737 =
																			MAKE_PAIR(
																			((obj_t) BgL_arg2661z00_4735), BNIL);
																		BgL_res3079z00_4738 =
																			((BgL_nodez00_bglt)
																			BGl_userzd2errorzf2locationz20zztools_errorz00
																			(BgL_arg2592z00_3045, BgL_arg2660z00_4734,
																				BGl_string3142z00zzast_sexpz00,
																				BgL_expz00_28, BgL_list2662z00_4737));
																}}
																return BgL_res3079z00_4738;
															}
														}
												}
											else
												{	/* Ast/sexp.scm 564 */
													if ((BgL_idz00_3032 == CNST_TABLE_REF(((long) 23))))
														{	/* Ast/sexp.scm 564 */
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 1), BFALSE,
																((BgL_typez00_bglt) BgL_typez00_3033),
																BgL_expz00_28, BgL_stackz00_29, BgL_locz00_3029,
																BgL_sitez00_31);
														}
													else
														{	/* Ast/sexp.scm 564 */
															if (
																(BgL_idz00_3032 == CNST_TABLE_REF(((long) 24))))
																{	/* Ast/sexp.scm 578 */
																	bool_t BgL_testz00_7786;

																	{	/* Ast/sexp.scm 578 */
																		obj_t BgL_auxz00_7787;

																		BgL_auxz00_7787 = CDR(BgL_expz00_28);
																		BgL_testz00_7786 = PAIRP(BgL_auxz00_7787);
																	}
																	if (BgL_testz00_7786)
																		{	/* Ast/sexp.scm 582 */
																			BgL_feffectz00_bglt BgL_arg2597z00_3050;
																			obj_t BgL_arg2598z00_3051;

																			BgL_arg2597z00_3050 =
																				BGl_parsezd2effectzd2zzeffect_feffectz00
																				(CAR(CDR(BgL_expz00_28)));
																			{	/* Ast/sexp.scm 583 */
																				obj_t BgL_arg2601z00_3053;
																				obj_t BgL_arg2602z00_3054;

																				{	/* Ast/sexp.scm 583 */
																					obj_t BgL_arg2603z00_3055;

																					BgL_arg2603z00_3055 =
																						MAKE_PAIR(CNST_TABLE_REF(((long)
																								34)), BNIL);
																					BgL_arg2601z00_3053 =
																						MAKE_PAIR(CNST_TABLE_REF(((long)
																								35)), BgL_arg2603z00_3055);
																				}
																				BgL_arg2602z00_3054 =
																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																					(CDR(CDR(BgL_expz00_28)), BNIL);
																				BgL_arg2598z00_3051 =
																					MAKE_PAIR(BgL_arg2601z00_3053,
																					BgL_arg2602z00_3054);
																			}
																			return
																				BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																				(((bool_t) 1),
																				((obj_t) BgL_arg2597z00_3050),
																				((BgL_typez00_bglt) BgL_typez00_3033),
																				BgL_arg2598z00_3051, BgL_stackz00_29,
																				BgL_locz00_3029, BgL_sitez00_31);
																		}
																	else
																		{	/* Ast/sexp.scm 581 */
																			obj_t BgL_arg2605z00_3057;

																			BgL_arg2605z00_3057 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_expz00_28, BgL_locz00_3029);
																			{	/* Ast/sexp.scm 579 */
																				BgL_nodez00_bglt BgL_res3083z00_4763;

																				{	/* Ast/sexp.scm 670 */
																					obj_t BgL_arg2660z00_4759;
																					BgL_nodez00_bglt BgL_arg2661z00_4760;

																					BgL_arg2660z00_4759 =
																						BGl_shapez00zztools_shapez00
																						(BGl_currentzd2functionzd2zztools_errorz00
																						());
																					BgL_arg2661z00_4760 =
																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																						(CNST_TABLE_REF(((long) 4)), BNIL,
																						BgL_arg2605z00_3057,
																						CNST_TABLE_REF(((long) 2)));
																					{	/* Ast/sexp.scm 669 */
																						obj_t BgL_list2662z00_4762;

																						BgL_list2662z00_4762 =
																							MAKE_PAIR(
																							((obj_t) BgL_arg2661z00_4760),
																							BNIL);
																						BgL_res3083z00_4763 =
																							((BgL_nodez00_bglt)
																							BGl_userzd2errorzf2locationz20zztools_errorz00
																							(BgL_arg2605z00_3057,
																								BgL_arg2660z00_4759,
																								BGl_string3143z00zzast_sexpz00,
																								BgL_expz00_28,
																								BgL_list2662z00_4762));
																				}}
																				return BgL_res3083z00_4763;
																			}
																		}
																}
															else
																{	/* Ast/sexp.scm 564 */
																	if (
																		(BgL_idz00_3032 ==
																			CNST_TABLE_REF(((long) 3))))
																		{
																			obj_t BgL_argsz00_3060;
																			obj_t BgL_bodyz00_3061;

																			if (PAIRP(BgL_expz00_28))
																				{	/* Ast/sexp.scm 586 */
																					obj_t BgL_cdrzd28062zd2_3066;

																					BgL_cdrzd28062zd2_3066 =
																						CDR(BgL_expz00_28);
																					if (PAIRP(BgL_cdrzd28062zd2_3066))
																						{	/* Ast/sexp.scm 586 */
																							BgL_argsz00_3060 =
																								CAR(BgL_cdrzd28062zd2_3066);
																							BgL_bodyz00_3061 =
																								CDR(BgL_cdrzd28062zd2_3066);
																							{	/* Ast/sexp.scm 588 */
																								obj_t BgL_locz00_3070;

																								BgL_locz00_3070 =
																									BGl_findzd2locationzf2locz20zztools_locationz00
																									(BgL_expz00_28,
																									BgL_locz00_3029);
																								{	/* Ast/sexp.scm 588 */
																									obj_t BgL_funz00_3071;

																									BgL_funz00_3071 =
																										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																										(BGl_gensymz00zz__r4_symbols_6_4z00
																										(CNST_TABLE_REF(((long)
																													3))));
																									{	/* Ast/sexp.scm 589 */
																										obj_t BgL_tfunz00_3072;

																										if (BGl_bigloozd2typezf3z21zztype_typez00(((BgL_typez00_bglt) BgL_typez00_3033)))
																											{	/* Ast/sexp.scm 591 */
																												obj_t
																													BgL_arg2624z00_3083;
																												BgL_arg2624z00_3083 =
																													(((BgL_typez00_bglt)
																														CREF((
																																(BgL_typez00_bglt)
																																BgL_typez00_3033)))->
																													BgL_idz00);
																												BgL_tfunz00_3072 =
																													BGl_makezd2typedzd2identz00zzast_identz00
																													(BgL_funz00_3071,
																													BgL_arg2624z00_3083);
																											}
																										else
																											{	/* Ast/sexp.scm 590 */
																												BgL_tfunz00_3072 =
																													BgL_funz00_3071;
																											}
																										{	/* Ast/sexp.scm 590 */

																											{	/* Ast/sexp.scm 594 */
																												obj_t
																													BgL_arg2613z00_3073;
																												{	/* Ast/sexp.scm 594 */
																													obj_t
																														BgL_arg2615z00_3074;
																													obj_t
																														BgL_arg2616z00_3075;
																													BgL_arg2615z00_3074 =
																														BGl_labelszd2symzd2zzast_labelsz00
																														();
																													{	/* Ast/sexp.scm 594 */
																														obj_t
																															BgL_arg2617z00_3076;
																														obj_t
																															BgL_arg2618z00_3077;
																														{	/* Ast/sexp.scm 594 */
																															obj_t
																																BgL_arg2619z00_3078;
																															{	/* Ast/sexp.scm 594 */
																																obj_t
																																	BgL_arg2620z00_3079;
																																{	/* Ast/sexp.scm 594 */
																																	obj_t
																																		BgL_arg2621z00_3080;
																																	BgL_arg2621z00_3080
																																		=
																																		MAKE_PAIR
																																		(BGl_normaliza7ezd2prognz75zztools_prognz00
																																		(BgL_bodyz00_3061),
																																		BNIL);
																																	BgL_arg2620z00_3079
																																		=
																																		MAKE_PAIR
																																		(BgL_argsz00_3060,
																																		BgL_arg2621z00_3080);
																																}
																																BgL_arg2619z00_3078
																																	=
																																	MAKE_PAIR
																																	(BgL_tfunz00_3072,
																																	BgL_arg2620z00_3079);
																															}
																															BgL_arg2617z00_3076
																																=
																																MAKE_PAIR
																																(BgL_arg2619z00_3078,
																																BNIL);
																														}
																														BgL_arg2618z00_3077
																															=
																															MAKE_PAIR
																															(BgL_funz00_3071,
																															BNIL);
																														BgL_arg2616z00_3075
																															=
																															MAKE_PAIR
																															(BgL_arg2617z00_3076,
																															BgL_arg2618z00_3077);
																													}
																													BgL_arg2613z00_3073 =
																														MAKE_PAIR
																														(BgL_arg2615z00_3074,
																														BgL_arg2616z00_3075);
																												}
																												return
																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																													(BgL_arg2613z00_3073,
																													BgL_stackz00_29,
																													BgL_locz00_3070,
																													BgL_sitez00_31);
																											}
																										}
																									}
																								}
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 586 */
																						BgL_tagzd28055zd2_3063:
																							{	/* Ast/sexp.scm 600 */
																								BgL_nodez00_bglt
																									BgL_res3085z00_4775;
																								{	/* Ast/sexp.scm 670 */
																									obj_t BgL_arg2660z00_4771;
																									BgL_nodez00_bglt
																										BgL_arg2661z00_4772;
																									BgL_arg2660z00_4771 =
																										BGl_shapez00zztools_shapez00
																										(BGl_currentzd2functionzd2zztools_errorz00
																										());
																									BgL_arg2661z00_4772 =
																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																										(CNST_TABLE_REF(((long) 4)),
																										BNIL, BgL_locz00_3029,
																										CNST_TABLE_REF(((long) 2)));
																									{	/* Ast/sexp.scm 669 */
																										obj_t BgL_list2662z00_4774;

																										BgL_list2662z00_4774 =
																											MAKE_PAIR(
																											((obj_t)
																												BgL_arg2661z00_4772),
																											BNIL);
																										BgL_res3085z00_4775 =
																											((BgL_nodez00_bglt)
																											BGl_userzd2errorzf2locationz20zztools_errorz00
																											(BgL_locz00_3029,
																												BgL_arg2660z00_4771,
																												BGl_string3144z00zzast_sexpz00,
																												BgL_expz00_28,
																												BgL_list2662z00_4774));
																								}}
																								return BgL_res3085z00_4775;
																							}
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 586 */
																					goto BgL_tagzd28055zd2_3063;
																				}
																		}
																	else
																		{	/* Ast/sexp.scm 564 */
																			return
																				BGl_applicationzd2ze3nodez31zzast_appz00
																				(BgL_expz00_28, BgL_stackz00_29,
																				BgL_locz00_3029, BgL_sitez00_31);
																		}
																}
														}
												}
										}
								}
							}
						}
					}
				else
					{	/* Ast/sexp.scm 559 */
						return
							BGl_applicationzd2ze3nodez31zzast_appz00(BgL_expz00_28,
							BgL_stackz00_29, BgL_locz00_3029, BgL_sitez00_31);
					}
			}
		}
	}



/* sexp*->node */
	BGL_EXPORTED_DEF obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t
		BgL_expza2za2_32, obj_t BgL_stackz00_33, obj_t BgL_locz00_34,
		obj_t BgL_sitez00_35)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 608 */
			{
				obj_t BgL_expsz00_3087;
				obj_t BgL_resz00_3088;
				obj_t BgL_locz00_3089;

				BgL_expsz00_3087 = BgL_expza2za2_32;
				BgL_resz00_3088 = BNIL;
				BgL_locz00_3089 = BgL_locz00_34;
			BgL_zc3anonymousza32626ze3z83_3090:
				if (NULLP(BgL_expsz00_3087))
					{	/* Ast/sexp.scm 614 */
						BgL_nodez00_bglt BgL_res3089z00_4792;

						{	/* Ast/sexp.scm 670 */
							obj_t BgL_arg2660z00_4788;
							BgL_nodez00_bglt BgL_arg2661z00_4789;

							BgL_arg2660z00_4788 =
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00());
							BgL_arg2661z00_4789 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
								BNIL, BgL_locz00_3089, CNST_TABLE_REF(((long) 2)));
							{	/* Ast/sexp.scm 669 */
								obj_t BgL_list2662z00_4791;

								BgL_list2662z00_4791 =
									MAKE_PAIR(((obj_t) BgL_arg2661z00_4789), BNIL);
								BgL_res3089z00_4792 =
									((BgL_nodez00_bglt)
									BGl_userzd2errorzf2locationz20zztools_errorz00
									(BgL_locz00_3089, BgL_arg2660z00_4788,
										BGl_string3145z00zzast_sexpz00, BgL_expsz00_3087,
										BgL_list2662z00_4791));
						}}
						return ((obj_t) BgL_res3089z00_4792);
					}
				else
					{	/* Ast/sexp.scm 613 */
						if (NULLP(CDR(BgL_expsz00_3087)))
							{	/* Ast/sexp.scm 616 */
								obj_t BgL_locz00_3093;
								obj_t BgL_nsitez00_3094;

								BgL_locz00_3093 =
									BGl_findzd2locationzf2locz20zztools_locationz00(CAR
									(BgL_expsz00_3087),
									BGl_findzd2locationzf2locz20zztools_locationz00
									(BgL_expsz00_3087, BgL_locz00_3089));
								if ((BgL_sitez00_35 == CNST_TABLE_REF(((long) 33))))
									{	/* Ast/sexp.scm 618 */
										BgL_nsitez00_3094 = CNST_TABLE_REF(((long) 2));
									}
								else
									{	/* Ast/sexp.scm 618 */
										BgL_nsitez00_3094 = BgL_sitez00_35;
									}
								{	/* Ast/sexp.scm 619 */
									obj_t BgL_arg2629z00_3095;

									{	/* Ast/sexp.scm 619 */
										BgL_nodez00_bglt BgL_arg2631z00_3096;

										BgL_arg2631z00_3096 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(CAR(BgL_expsz00_3087),
											BgL_stackz00_33, BgL_locz00_3093, BgL_nsitez00_3094);
										BgL_arg2629z00_3095 =
											MAKE_PAIR(((obj_t) BgL_arg2631z00_3096), BgL_resz00_3088);
									}
									return bgl_reverse_bang(BgL_arg2629z00_3095);
								}
							}
						else
							{	/* Ast/sexp.scm 621 */
								obj_t BgL_locz00_3101;

								BgL_locz00_3101 =
									BGl_findzd2locationzf2locz20zztools_locationz00(CAR
									(BgL_expsz00_3087),
									BGl_findzd2locationzf2locz20zztools_locationz00
									(BgL_expsz00_3087, BgL_locz00_3089));
								{	/* Ast/sexp.scm 623 */
									obj_t BgL_arg2637z00_3102;
									obj_t BgL_arg2638z00_3103;

									BgL_arg2637z00_3102 = CDR(BgL_expsz00_3087);
									{	/* Ast/sexp.scm 624 */
										BgL_nodez00_bglt BgL_arg2640z00_3104;

										{	/* Ast/sexp.scm 624 */
											obj_t BgL_arg2642z00_3105;

											BgL_arg2642z00_3105 = CAR(BgL_expsz00_3087);
											BgL_arg2640z00_3104 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg2642z00_3105,
												BgL_stackz00_33, BgL_locz00_3101,
												CNST_TABLE_REF(((long) 2)));
										}
										BgL_arg2638z00_3103 =
											MAKE_PAIR(((obj_t) BgL_arg2640z00_3104), BgL_resz00_3088);
									}
									{
										obj_t BgL_locz00_7893;
										obj_t BgL_resz00_7892;
										obj_t BgL_expsz00_7891;

										BgL_expsz00_7891 = BgL_arg2637z00_3102;
										BgL_resz00_7892 = BgL_arg2638z00_3103;
										BgL_locz00_7893 = BgL_locz00_3101;
										BgL_locz00_3089 = BgL_locz00_7893;
										BgL_resz00_3088 = BgL_resz00_7892;
										BgL_expsz00_3087 = BgL_expsz00_7891;
										goto BgL_zc3anonymousza32626ze3z83_3090;
									}
								}
							}
					}
			}
		}
	}



/* &sexp*->node */
	obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t BgL_envz00_4935,
		obj_t BgL_expza2za2_4936, obj_t BgL_stackz00_4937, obj_t BgL_locz00_4938,
		obj_t BgL_sitez00_4939)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 608 */
			return
				BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_expza2za2_4936,
				BgL_stackz00_4937, BgL_locz00_4938, BgL_sitez00_4939);
		}
	}



/* find-local */
	BGL_EXPORTED_DEF obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t BgL_namez00_36,
		obj_t BgL_stackz00_37)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 637 */
			{	/* Ast/sexp.scm 638 */
				bool_t BgL_testz00_7895;

				if ((BgL_namez00_36 == BGl_za2cachezd2nameza2zd2zzast_sexpz00))
					{	/* Ast/sexp.scm 638 */
						BgL_testz00_7895 =
							(BgL_stackz00_37 == BGl_za2cachezd2stackza2zd2zzast_sexpz00);
					}
				else
					{	/* Ast/sexp.scm 638 */
						BgL_testz00_7895 = ((bool_t) 0);
					}
				if (BgL_testz00_7895)
					{	/* Ast/sexp.scm 638 */
						return BGl_za2cachezd2resza2zd2zzast_sexpz00;
					}
				else
					{	/* Ast/sexp.scm 638 */
						BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BgL_namez00_36;
						BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BgL_stackz00_37;
						{
							obj_t BgL_stackz00_3112;

							BgL_stackz00_3112 = BgL_stackz00_37;
						BgL_zc3anonymousza32648ze3z83_3113:
							if (NULLP(BgL_stackz00_3112))
								{	/* Ast/sexp.scm 645 */
									BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE;
									return BFALSE;
								}
							else
								{	/* Ast/sexp.scm 645 */
									if (
										((((BgL_variablez00_bglt) CREF(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt)
																CAR(BgL_stackz00_3112)))))->BgL_idz00) ==
											BgL_namez00_36))
										{	/* Ast/sexp.scm 648 */
											BGl_za2cachezd2resza2zd2zzast_sexpz00 =
												CAR(BgL_stackz00_3112);
											return CAR(BgL_stackz00_3112);
										}
									else
										{
											obj_t BgL_stackz00_7909;

											BgL_stackz00_7909 = CDR(BgL_stackz00_3112);
											BgL_stackz00_3112 = BgL_stackz00_7909;
											goto BgL_zc3anonymousza32648ze3z83_3113;
										}
								}
						}
					}
			}
		}
	}



/* &find-local */
	obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t BgL_envz00_4940,
		obj_t BgL_namez00_4941, obj_t BgL_stackz00_4942)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 637 */
			return
				BGl_findzd2localzd2zzast_sexpz00(BgL_namez00_4941, BgL_stackz00_4942);
		}
	}



/* use-variable! */
	BGL_EXPORTED_DEF obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt BgL_varz00_38,
		obj_t BgL_locz00_39, obj_t BgL_sitez00_40)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 657 */
			if ((BgL_sitez00_40 == CNST_TABLE_REF(((long) 7))))
				{	/* Ast/sexp.scm 660 */
					obj_t BgL_vz00_4809;

					BgL_vz00_4809 = CNST_TABLE_REF(((long) 36));
					((((BgL_variablez00_bglt) CREF(BgL_varz00_38))->BgL_accessz00) =
						((obj_t) BgL_vz00_4809), BUNSPEC);
				}
			else
				{	/* Ast/sexp.scm 659 */
					BFALSE;
				}
			{	/* Ast/sexp.scm 661 */
				BgL_valuez00_bglt BgL_valz00_3122;

				BgL_valz00_3122 =
					(((BgL_variablez00_bglt) CREF(BgL_varz00_38))->BgL_valuez00);
				{	/* Ast/sexp.scm 662 */
					bool_t BgL_testz00_7918;

					if ((BgL_sitez00_40 == CNST_TABLE_REF(((long) 7))))
						{	/* Ast/sexp.scm 662 */
							bool_t BgL_res3092z00_4812;

							BgL_res3092z00_4812 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_valz00_3122), BGl_funz00zzast_varz00);
							BgL_testz00_7918 = BgL_res3092z00_4812;
						}
					else
						{	/* Ast/sexp.scm 662 */
							BgL_testz00_7918 = ((bool_t) 0);
						}
					if (BgL_testz00_7918)
						{	/* Ast/sexp.scm 663 */
							obj_t BgL_arg2658z00_3124;

							BgL_arg2658z00_3124 =
								BGl_shapez00zztools_shapez00(((obj_t) BgL_varz00_38));
							{	/* Ast/sexp.scm 663 */
								BgL_nodez00_bglt BgL_res3093z00_4820;

								{	/* Ast/sexp.scm 670 */
									obj_t BgL_arg2660z00_4816;
									BgL_nodez00_bglt BgL_arg2661z00_4817;

									BgL_arg2660z00_4816 =
										BGl_shapez00zztools_shapez00
										(BGl_currentzd2functionzd2zztools_errorz00());
									BgL_arg2661z00_4817 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
												4)), BNIL, BgL_locz00_39, CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 669 */
										obj_t BgL_list2662z00_4819;

										BgL_list2662z00_4819 =
											MAKE_PAIR(((obj_t) BgL_arg2661z00_4817), BNIL);
										BgL_res3093z00_4820 =
											((BgL_nodez00_bglt)
											BGl_userzd2errorzf2locationz20zztools_errorz00
											(BgL_locz00_39, BgL_arg2660z00_4816,
												BGl_string3146z00zzast_sexpz00, BgL_arg2658z00_3124,
												BgL_list2662z00_4819));
								}}
								return ((obj_t) BgL_res3093z00_4820);
							}
						}
					else
						{	/* Ast/sexp.scm 662 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &use-variable! */
	obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t BgL_envz00_4943,
		obj_t BgL_varz00_4944, obj_t BgL_locz00_4945, obj_t BgL_sitez00_4946)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 657 */
			return
				BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_varz00_4944), BgL_locz00_4945,
				BgL_sitez00_4946);
		}
	}



/* error-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_msgz00_41,
		obj_t BgL_expz00_42, obj_t BgL_locz00_43)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 668 */
			{	/* Ast/sexp.scm 670 */
				obj_t BgL_arg2660z00_3126;
				BgL_nodez00_bglt BgL_arg2661z00_3127;

				BgL_arg2660z00_3126 =
					BGl_shapez00zztools_shapez00(BGl_currentzd2functionzd2zztools_errorz00
					());
				BgL_arg2661z00_3127 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)), BNIL,
					BgL_locz00_43, CNST_TABLE_REF(((long) 2)));
				{	/* Ast/sexp.scm 669 */
					obj_t BgL_list2662z00_3128;

					BgL_list2662z00_3128 = MAKE_PAIR(((obj_t) BgL_arg2661z00_3127), BNIL);
					return
						((BgL_nodez00_bglt)
						BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_43,
							BgL_arg2660z00_3126, BgL_msgz00_41, BgL_expz00_42,
							BgL_list2662z00_3128));
				}
			}
		}
	}



/* &error-sexp->node */
	BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_4947, obj_t BgL_msgz00_4948, obj_t BgL_expz00_4949,
		obj_t BgL_locz00_4950)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 668 */
			return
				BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BgL_msgz00_4948,
				BgL_expz00_4949, BgL_locz00_4950);
		}
	}



/* define-primop-ref->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_44, BgL_nodez00_bglt BgL_refz00_45)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 678 */
			{	/* Ast/sexp.scm 679 */
				BgL_nodez00_bglt BgL_funz00_3130;

				BgL_funz00_3130 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 37)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 680 */
					bool_t BgL_testz00_7951;

					{	/* Ast/sexp.scm 680 */
						bool_t BgL_res3094z00_4822;

						BgL_res3094z00_4822 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_3130), BGl_varz00zzast_nodez00);
						BgL_testz00_7951 = BgL_res3094z00_4822;
					}
					if (BgL_testz00_7951)
						{	/* Ast/sexp.scm 681 */
							BgL_appz00_bglt BgL_new1145z00_3132;

							{	/* Ast/sexp.scm 681 */
								BgL_appz00_bglt BgL_new1144z00_3139;

								BgL_new1144z00_3139 =
									((BgL_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 681 */
									long BgL_arg2673z00_3140;

									{	/* Ast/sexp.scm 681 */
										long BgL_res3095z00_4824;

										BgL_res3095z00_4824 =
											BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
										BgL_arg2673z00_3140 = BgL_res3095z00_4824;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1144z00_3139),
										BgL_arg2673z00_3140);
								}
								{	/* Ast/sexp.scm 681 */
									BgL_objectz00_bglt BgL_auxz00_7958;

									BgL_auxz00_7958 = ((BgL_objectz00_bglt) BgL_new1144z00_3139);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_7958, BFALSE);
								}
								BgL_new1145z00_3132 = BgL_new1144z00_3139;
							}
							((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_new1145z00_3132)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
												BgL_new1145z00_3132)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt)
												BgL_new1145z00_3132)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt)
												BgL_new1145z00_3132)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) CREF(BgL_new1145z00_3132))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_3130)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_7973;

								{	/* Ast/sexp.scm 684 */
									BgL_nodez00_bglt BgL_arg2665z00_3133;

									{	/* Ast/sexp.scm 684 */
										obj_t BgL_arg2670z00_3136;

										{	/* Ast/sexp.scm 684 */
											obj_t BgL_arg2671z00_3137;

											{	/* Ast/sexp.scm 684 */
												obj_t BgL_arg2672z00_3138;

												BgL_arg2672z00_3138 =
													(((BgL_variablez00_bglt) CREF(
															((BgL_variablez00_bglt) BgL_globalz00_44)))->
													BgL_idz00);
												BgL_arg2671z00_3137 =
													MAKE_PAIR(BgL_arg2672z00_3138, BNIL);
											}
											BgL_arg2670z00_3136 =
												MAKE_PAIR(CNST_TABLE_REF(((long) 13)),
												BgL_arg2671z00_3137);
										}
										BgL_arg2665z00_3133 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg2670z00_3136,
											BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
									}
									{	/* Ast/sexp.scm 684 */
										obj_t BgL_list2666z00_3134;

										{	/* Ast/sexp.scm 684 */
											obj_t BgL_arg2668z00_3135;

											BgL_arg2668z00_3135 =
												MAKE_PAIR(((obj_t) BgL_refz00_45), BNIL);
											BgL_list2666z00_3134 =
												MAKE_PAIR(
												((obj_t) BgL_arg2665z00_3133), BgL_arg2668z00_3135);
										}
										BgL_auxz00_7973 = BgL_list2666z00_3134;
								}}
								((((BgL_appz00_bglt) CREF(BgL_new1145z00_3132))->BgL_argsz00) =
									((obj_t) BgL_auxz00_7973), BUNSPEC);
							}
							return ((BgL_nodez00_bglt) BgL_new1145z00_3132);
						}
					else
						{	/* Ast/sexp.scm 680 */
							return BgL_funz00_3130;
						}
				}
			}
		}
	}



/* &define-primop-ref->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_4951, obj_t BgL_globalz00_4952, obj_t BgL_refz00_4953)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 678 */
			return
				BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_4952),
				((BgL_nodez00_bglt) BgL_refz00_4953));
		}
	}



/* define-primop->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_46)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 690 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_46), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 692 */
				BgL_nodez00_bglt BgL_funz00_3141;

				BgL_funz00_3141 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 38)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 693 */
					bool_t BgL_testz00_7996;

					{	/* Ast/sexp.scm 693 */
						bool_t BgL_res3097z00_4831;

						BgL_res3097z00_4831 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_3141), BGl_varz00zzast_nodez00);
						BgL_testz00_7996 = BgL_res3097z00_4831;
					}
					if (BgL_testz00_7996)
						{	/* Ast/sexp.scm 694 */
							BgL_appz00_bglt BgL_new1147z00_3143;

							{	/* Ast/sexp.scm 694 */
								BgL_appz00_bglt BgL_new1146z00_3151;

								BgL_new1146z00_3151 =
									((BgL_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 694 */
									long BgL_arg2682z00_3152;

									{	/* Ast/sexp.scm 694 */
										long BgL_res3098z00_4833;

										BgL_res3098z00_4833 =
											BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
										BgL_arg2682z00_3152 = BgL_res3098z00_4833;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1146z00_3151),
										BgL_arg2682z00_3152);
								}
								{	/* Ast/sexp.scm 694 */
									BgL_objectz00_bglt BgL_auxz00_8003;

									BgL_auxz00_8003 = ((BgL_objectz00_bglt) BgL_new1146z00_3151);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_8003, BFALSE);
								}
								BgL_new1147z00_3143 = BgL_new1146z00_3151;
							}
							((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_new1147z00_3143)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
												BgL_new1147z00_3143)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt)
												BgL_new1147z00_3143)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt)
												BgL_new1147z00_3143)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) CREF(BgL_new1147z00_3143))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_3141)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_8018;

								{	/* Ast/sexp.scm 697 */
									BgL_nodez00_bglt BgL_arg2675z00_3144;
									BgL_nodez00_bglt BgL_arg2676z00_3145;

									{	/* Ast/sexp.scm 697 */
										obj_t BgL_arg2679z00_3148;

										{	/* Ast/sexp.scm 697 */
											obj_t BgL_arg2680z00_3149;

											{	/* Ast/sexp.scm 697 */
												obj_t BgL_arg2681z00_3150;

												BgL_arg2681z00_3150 =
													(((BgL_variablez00_bglt) CREF(
															((BgL_variablez00_bglt) BgL_globalz00_46)))->
													BgL_idz00);
												BgL_arg2680z00_3149 =
													MAKE_PAIR(BgL_arg2681z00_3150, BNIL);
											}
											BgL_arg2679z00_3148 =
												MAKE_PAIR(CNST_TABLE_REF(((long) 13)),
												BgL_arg2680z00_3149);
										}
										BgL_arg2675z00_3144 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg2679z00_3148,
											BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
									}
									BgL_arg2676z00_3145 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(
										((obj_t) BgL_globalz00_46), BNIL, BFALSE,
										CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 697 */
										obj_t BgL_list2677z00_3146;

										{	/* Ast/sexp.scm 697 */
											obj_t BgL_arg2678z00_3147;

											BgL_arg2678z00_3147 =
												MAKE_PAIR(((obj_t) BgL_arg2676z00_3145), BNIL);
											BgL_list2677z00_3146 =
												MAKE_PAIR(
												((obj_t) BgL_arg2675z00_3144), BgL_arg2678z00_3147);
										}
										BgL_auxz00_8018 = BgL_list2677z00_3146;
								}}
								((((BgL_appz00_bglt) CREF(BgL_new1147z00_3143))->BgL_argsz00) =
									((obj_t) BgL_auxz00_8018), BUNSPEC);
							}
							return ((BgL_nodez00_bglt) BgL_new1147z00_3143);
						}
					else
						{	/* Ast/sexp.scm 693 */
							return BgL_funz00_3141;
						}
				}
			}
		}
	}



/* &define-primop->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_4954, obj_t BgL_globalz00_4955)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 690 */
			return
				BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_4955));
		}
	}



/* location->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_47)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 704 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_47), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 706 */
				BgL_nodez00_bglt BgL_funz00_3153;

				BgL_funz00_3153 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 39)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 707 */
					bool_t BgL_testz00_8043;

					{	/* Ast/sexp.scm 707 */
						bool_t BgL_res3100z00_4840;

						BgL_res3100z00_4840 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_3153), BGl_varz00zzast_nodez00);
						BgL_testz00_8043 = BgL_res3100z00_4840;
					}
					if (BgL_testz00_8043)
						{	/* Ast/sexp.scm 708 */
							obj_t BgL_exprz00_3155;

							{	/* Ast/sexp.scm 708 */
								bool_t BgL_testz00_8046;

								{	/* Ast/sexp.scm 708 */
									obj_t BgL_arg2690z00_3164;

									BgL_arg2690z00_3164 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									BgL_testz00_8046 =
										(((BgL_backendz00_bglt) CREF(
												((BgL_backendz00_bglt) BgL_arg2690z00_3164)))->
										BgL_pragmazd2supportzd2);
								}
								if (BgL_testz00_8046)
									{	/* Ast/sexp.scm 709 */
										obj_t BgL_arg2688z00_3162;

										{	/* Ast/sexp.scm 709 */
											obj_t BgL_arg2689z00_3163;

											BgL_arg2689z00_3163 =
												MAKE_PAIR(((obj_t) BgL_globalz00_47), BNIL);
											BgL_arg2688z00_3162 =
												MAKE_PAIR(BGl_string3147z00zzast_sexpz00,
												BgL_arg2689z00_3163);
										}
										BgL_exprz00_3155 =
											MAKE_PAIR(CNST_TABLE_REF(((long) 40)),
											BgL_arg2688z00_3162);
									}
								else
									{	/* Ast/sexp.scm 708 */
										BgL_exprz00_3155 = ((obj_t) BgL_globalz00_47);
									}
							}
							{	/* Ast/sexp.scm 711 */
								BgL_appz00_bglt BgL_new1149z00_3156;

								{	/* Ast/sexp.scm 711 */
									BgL_appz00_bglt BgL_new1148z00_3159;

									BgL_new1148z00_3159 =
										((BgL_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_appz00_bgl))));
									{	/* Ast/sexp.scm 711 */
										long BgL_arg2686z00_3160;

										{	/* Ast/sexp.scm 711 */
											long BgL_res3102z00_4845;

											BgL_res3102z00_4845 =
												BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
											BgL_arg2686z00_3160 = BgL_res3102z00_4845;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1148z00_3159),
											BgL_arg2686z00_3160);
									}
									{	/* Ast/sexp.scm 711 */
										BgL_objectz00_bglt BgL_auxz00_8060;

										BgL_auxz00_8060 =
											((BgL_objectz00_bglt) BgL_new1148z00_3159);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_8060, BFALSE);
									}
									BgL_new1149z00_3156 = BgL_new1148z00_3159;
								}
								((((BgL_nodez00_bglt) CREF(
												((BgL_nodez00_bglt) BgL_new1149z00_3156)))->
										BgL_locz00) = ((obj_t) BFALSE), BUNSPEC);
								((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
													BgL_new1149z00_3156)))->BgL_typez00) =
									((BgL_typez00_bglt)
										BGl_strictzd2nodezd2typez00zzast_nodez00(((BgL_typez00_bglt)
												BGl_za2_za2z00zztype_cachez00),
											((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00))),
									BUNSPEC);
								((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt)
													BgL_new1149z00_3156)))->BgL_sidezd2effectzd2) =
									((obj_t) BUNSPEC), BUNSPEC);
								((((BgL_nodezf2effectzf2_bglt) CREF(((BgL_nodezf2effectzf2_bglt)
													BgL_new1149z00_3156)))->BgL_keyz00) =
									((obj_t) BINT(((long) -1))), BUNSPEC);
								((((BgL_appz00_bglt) CREF(BgL_new1149z00_3156))->BgL_funz00) =
									((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_3153)),
									BUNSPEC);
								{
									obj_t BgL_auxz00_8077;

									{	/* Ast/sexp.scm 714 */
										BgL_nodez00_bglt BgL_arg2684z00_3157;

										BgL_arg2684z00_3157 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_exprz00_3155, BNIL,
											BFALSE, CNST_TABLE_REF(((long) 2)));
										{	/* Ast/sexp.scm 714 */
											obj_t BgL_list2685z00_3158;

											BgL_list2685z00_3158 =
												MAKE_PAIR(((obj_t) BgL_arg2684z00_3157), BNIL);
											BgL_auxz00_8077 = BgL_list2685z00_3158;
									}}
									((((BgL_appz00_bglt) CREF(BgL_new1149z00_3156))->
											BgL_argsz00) = ((obj_t) BgL_auxz00_8077), BUNSPEC);
								}
								return ((BgL_nodez00_bglt) BgL_new1149z00_3156);
							}
						}
					else
						{	/* Ast/sexp.scm 707 */
							return BgL_funz00_3153;
						}
				}
			}
		}
	}



/* &location->node */
	BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_4956, obj_t BgL_globalz00_4957)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 704 */
			return
				BGl_locationzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_4957));
		}
	}



/* make-anonymous-name */
	BGL_EXPORTED_DEF obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t
		BgL_locz00_48, obj_t BgL_prefz00_49)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 720 */
			{	/* Ast/sexp.scm 721 */
				obj_t BgL_prefz00_3165;

				{	/* Ast/sexp.scm 721 */
					bool_t BgL_testz00_8086;

					if (PAIRP(BgL_prefz00_49))
						{	/* Ast/sexp.scm 721 */
							obj_t BgL_auxz00_8089;

							BgL_auxz00_8089 = CAR(BgL_prefz00_49);
							BgL_testz00_8086 = STRINGP(BgL_auxz00_8089);
						}
					else
						{	/* Ast/sexp.scm 721 */
							BgL_testz00_8086 = ((bool_t) 0);
						}
					if (BgL_testz00_8086)
						{	/* Ast/sexp.scm 721 */
							BgL_prefz00_3165 = CAR(BgL_prefz00_49);
						}
					else
						{	/* Ast/sexp.scm 721 */
							BgL_prefz00_3165 = BGl_string3148z00zzast_sexpz00;
						}
				}
				{	/* Ast/sexp.scm 724 */
					bool_t BgL_testz00_8093;

					if (STRUCTP(BgL_locz00_48))
						{	/* Ast/sexp.scm 724 */
							BgL_testz00_8093 =
								(STRUCT_KEY(BgL_locz00_48) == CNST_TABLE_REF(((long) 41)));
						}
					else
						{	/* Ast/sexp.scm 724 */
							BgL_testz00_8093 = ((bool_t) 0);
						}
					if (BgL_testz00_8093)
						{	/* Ast/sexp.scm 725 */
							obj_t BgL_filez00_3167;
							obj_t BgL_linez00_3168;
							obj_t BgL_basez00_3169;

							BgL_filez00_3167 =
								BGl_locationzd2fullzd2fnamez00zztools_locationz00
								(BgL_locz00_48);
							BgL_linez00_3168 = STRUCT_REF(BgL_locz00_48, (int) (((long) 2)));
							{	/* Ast/sexp.scm 727 */
								obj_t BgL_arg2710z00_3191;

								BgL_arg2710z00_3191 =
									BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
									(BGl_string3149z00zzast_sexpz00, BgL_prefz00_3165,
										BGl_string3150z00zzast_sexpz00));
								{	/* Ast/sexp.scm 727 */
									obj_t BgL_res3108z00_4868;

									{	/* Ast/sexp.scm 727 */
										obj_t BgL_arg1362z00_4867;

										BgL_arg1362z00_4867 = SYMBOL_TO_STRING(BgL_arg2710z00_3191);
										BgL_res3108z00_4868 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1362z00_4867);
									}
									BgL_basez00_3169 = BgL_res3108z00_4868;
							}}
							{	/* Ast/sexp.scm 729 */
								bool_t BgL_testz00_8106;

								{	/* Ast/sexp.scm 729 */
									bool_t BgL_testz00_8107;

									if (
										((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >=
											((long) 1)))
										{	/* Ast/sexp.scm 730 */
											obj_t BgL_arg2708z00_3189;

											{	/* Ast/sexp.scm 730 */
												obj_t BgL_arg2709z00_3190;

												BgL_arg2709z00_3190 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												BgL_arg2708z00_3189 =
													(((BgL_backendz00_bglt) CREF(
															((BgL_backendz00_bglt) BgL_arg2709z00_3190)))->
													BgL_debugzd2supportzd2);
											}
											BgL_testz00_8107 =
												CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(CNST_TABLE_REF(((long) 42)), BgL_arg2708z00_3189));
										}
									else
										{	/* Ast/sexp.scm 729 */
											BgL_testz00_8107 = ((bool_t) 0);
										}
									if (BgL_testz00_8107)
										{	/* Ast/sexp.scm 729 */
											BgL_testz00_8106 = ((bool_t) 1);
										}
									else
										{	/* Ast/sexp.scm 729 */
											BgL_testz00_8106 =
												(
												(long)
												CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >=
												((long) 1));
								}}
								if (BgL_testz00_8106)
									{	/* Ast/sexp.scm 732 */
										obj_t BgL_filez00_3171;

										if (bigloo_strncmp(BgL_filez00_3167,
												BGl_string3151z00zzast_sexpz00, ((long) 2)))
											{	/* Ast/sexp.scm 732 */
												BgL_filez00_3171 =
													c_substring(BgL_filez00_3167, ((long) 2),
													STRING_LENGTH(BgL_filez00_3167));
											}
										else
											{	/* Ast/sexp.scm 732 */
												BgL_filez00_3171 = BgL_filez00_3167;
											}
										{	/* Ast/sexp.scm 737 */
											obj_t BgL_arg2693z00_3172;

											{	/* Ast/sexp.scm 737 */
												obj_t BgL_arg2694z00_3173;
												obj_t BgL_arg2695z00_3174;

												BgL_arg2694z00_3173 =
													BGl_stringzd2replacezd2zz__r4_strings_6_7z00
													(BgL_filez00_3171, (char) (((unsigned char) '.')),
													(char) (((unsigned char) ',')));
												{	/* Ast/sexp.scm 738 */

													BgL_arg2695z00_3174 =
														BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00
														(BgL_linez00_3168, BINT(((long) 10)));
												}
												{	/* Ast/sexp.scm 736 */
													obj_t BgL_list2696z00_3175;

													{	/* Ast/sexp.scm 736 */
														obj_t BgL_arg2697z00_3176;

														{	/* Ast/sexp.scm 736 */
															obj_t BgL_arg2698z00_3177;

															{	/* Ast/sexp.scm 736 */
																obj_t BgL_arg2699z00_3178;

																{	/* Ast/sexp.scm 736 */
																	obj_t BgL_arg2700z00_3179;

																	{	/* Ast/sexp.scm 736 */
																		obj_t BgL_arg2701z00_3180;

																		BgL_arg2701z00_3180 =
																			MAKE_PAIR(BGl_string3152z00zzast_sexpz00,
																			BNIL);
																		BgL_arg2700z00_3179 =
																			MAKE_PAIR(BgL_arg2695z00_3174,
																			BgL_arg2701z00_3180);
																	}
																	BgL_arg2699z00_3178 =
																		MAKE_PAIR(BGl_string3150z00zzast_sexpz00,
																		BgL_arg2700z00_3179);
																}
																BgL_arg2698z00_3177 =
																	MAKE_PAIR(BgL_arg2694z00_3173,
																	BgL_arg2699z00_3178);
															}
															BgL_arg2697z00_3176 =
																MAKE_PAIR(BGl_string3150z00zzast_sexpz00,
																BgL_arg2698z00_3177);
														}
														BgL_list2696z00_3175 =
															MAKE_PAIR(BgL_basez00_3169, BgL_arg2697z00_3176);
													}
													BgL_arg2693z00_3172 =
														BGl_stringzd2appendzd2zz__r4_strings_6_7z00
														(BgL_list2696z00_3175);
											}}
											return bstring_to_symbol(BgL_arg2693z00_3172);
										}
									}
								else
									{	/* Ast/sexp.scm 729 */
										return
											bstring_to_symbol
											(BGl_stringzd2replacezd2zz__r4_strings_6_7z00
											(string_append(BgL_basez00_3169,
													BGl_string3152z00zzast_sexpz00),
												(char) (((unsigned char) '.')),
												(char) (((unsigned char) ','))));
						}}}
					else
						{	/* Ast/sexp.scm 742 */
							obj_t BgL_arg2712z00_3193;

							{	/* Ast/sexp.scm 742 */
								obj_t BgL_arg2713z00_3194;
								obj_t BgL_arg2714z00_3195;

								{	/* Ast/sexp.scm 742 */
									obj_t BgL_arg2715z00_3196;

									BgL_arg2715z00_3196 =
										BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
										(BGl_string3149z00zzast_sexpz00, BgL_prefz00_3165,
											BGl_string3153z00zzast_sexpz00));
									{	/* Ast/sexp.scm 742 */
										obj_t BgL_res3117z00_4894;

										{	/* Ast/sexp.scm 742 */
											obj_t BgL_arg1362z00_4893;

											BgL_arg1362z00_4893 =
												SYMBOL_TO_STRING(BgL_arg2715z00_3196);
											BgL_res3117z00_4894 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1362z00_4893);
										}
										BgL_arg2713z00_3194 = BgL_res3117z00_4894;
									}
								}
								{	/* Ast/sexp.scm 742 */
									obj_t BgL_res3118z00_4897;

									{	/* Ast/sexp.scm 742 */
										obj_t BgL_symbolz00_4895;

										BgL_symbolz00_4895 = CNST_TABLE_REF(((long) 43));
										{	/* Ast/sexp.scm 742 */
											obj_t BgL_arg1362z00_4896;

											BgL_arg1362z00_4896 =
												SYMBOL_TO_STRING(BgL_symbolz00_4895);
											BgL_res3118z00_4897 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1362z00_4896);
									}}
									BgL_arg2714z00_3195 = BgL_res3118z00_4897;
								}
								BgL_arg2712z00_3193 =
									string_append(BgL_arg2713z00_3194, BgL_arg2714z00_3195);
							}
							return bstring_to_symbol(BgL_arg2712z00_3193);
						}
				}
			}
		}
	}



/* &make-anonymous-name */
	obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t BgL_envz00_4958,
		obj_t BgL_locz00_4959, obj_t BgL_prefz00_4960)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 720 */
			return
				BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_4959,
				BgL_prefz00_4960);
		}
	}



/* synchronize->node */
	BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t
		BgL_expz00_50, obj_t BgL_mutexz00_51, obj_t BgL_prelockz00_52,
		obj_t BgL_bodyz00_53, obj_t BgL_stackz00_54, obj_t BgL_locz00_55,
		obj_t BgL_sitez00_56)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 747 */
			if (SYMBOLP(BgL_mutexz00_51))
				{	/* Ast/sexp.scm 749 */
					BgL_syncz00_bglt BgL_new1151z00_3202;

					{	/* Ast/sexp.scm 750 */
						BgL_syncz00_bglt BgL_new1150z00_3204;

						BgL_new1150z00_3204 =
							((BgL_syncz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_syncz00_bgl))));
						{	/* Ast/sexp.scm 750 */
							long BgL_arg2723z00_3205;

							{	/* Ast/sexp.scm 750 */
								long BgL_res3121z00_4903;

								BgL_res3121z00_4903 = BGL_CLASS_INDEX(BGl_syncz00zzast_nodez00);
								BgL_arg2723z00_3205 = BgL_res3121z00_4903;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1150z00_3204),
								BgL_arg2723z00_3205);
						}
						{	/* Ast/sexp.scm 750 */
							BgL_objectz00_bglt BgL_auxz00_8157;

							BgL_auxz00_8157 = ((BgL_objectz00_bglt) BgL_new1150z00_3204);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_8157, BFALSE);
						}
						BgL_new1151z00_3202 = BgL_new1150z00_3204;
					}
					((((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_new1151z00_3202)))->BgL_locz00) =
						((obj_t) BgL_locz00_55), BUNSPEC);
					((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
										BgL_new1151z00_3202)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt)
								BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
					((((BgL_syncz00_bglt) CREF(BgL_new1151z00_3202))->BgL_mutexz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_mutexz00_51,
								BgL_stackz00_54, BgL_locz00_55, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					((((BgL_syncz00_bglt) CREF(BgL_new1151z00_3202))->BgL_prelockz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_prelockz00_52,
								BgL_stackz00_54, BgL_locz00_55, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					{
						BgL_nodez00_bglt BgL_auxz00_8171;

						{	/* Ast/sexp.scm 754 */
							obj_t BgL_arg2721z00_3203;

							BgL_arg2721z00_3203 =
								BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_53);
							BgL_auxz00_8171 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg2721z00_3203,
								BgL_stackz00_54, BgL_locz00_55, BgL_sitez00_56);
						}
						((((BgL_syncz00_bglt) CREF(BgL_new1151z00_3202))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_auxz00_8171), BUNSPEC);
					}
					return ((BgL_nodez00_bglt) BgL_new1151z00_3202);
				}
			else
				{	/* Ast/sexp.scm 755 */
					obj_t BgL_vz00_3206;

					BgL_vz00_3206 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 44))));
					{	/* Ast/sexp.scm 755 */
						obj_t BgL_varz00_3207;

						BgL_varz00_3207 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_vz00_3206,
							CNST_TABLE_REF(((long) 44)));
						{	/* Ast/sexp.scm 756 */
							obj_t BgL_nexpz00_3208;

							{	/* Ast/sexp.scm 757 */
								obj_t BgL_arg2732z00_3216;

								{	/* Ast/sexp.scm 757 */
									obj_t BgL_arg2733z00_3217;

									BgL_arg2733z00_3217 =
										MAKE_PAIR(BgL_vz00_3206,
										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
										(BgL_bodyz00_53, BNIL));
									BgL_arg2732z00_3216 =
										MAKE_PAIR(CNST_TABLE_REF(((long) 30)), BgL_arg2733z00_3217);
								}
								BgL_nexpz00_3208 =
									BGl_epairifyzd2reczd2zztools_miscz00(BgL_arg2732z00_3216,
									BgL_expz00_50);
							}
							{	/* Ast/sexp.scm 757 */

								{	/* Ast/sexp.scm 758 */
									obj_t BgL_arg2724z00_3209;

									{	/* Ast/sexp.scm 758 */
										obj_t BgL_arg2725z00_3210;
										obj_t BgL_arg2726z00_3211;

										BgL_arg2725z00_3210 = BGl_letzd2symzd2zzast_letz00();
										{	/* Ast/sexp.scm 758 */
											obj_t BgL_arg2727z00_3212;
											obj_t BgL_arg2729z00_3213;

											{	/* Ast/sexp.scm 758 */
												obj_t BgL_arg2730z00_3214;

												{	/* Ast/sexp.scm 758 */
													obj_t BgL_arg2731z00_3215;

													BgL_arg2731z00_3215 =
														MAKE_PAIR(BgL_mutexz00_51, BNIL);
													BgL_arg2730z00_3214 =
														MAKE_PAIR(BgL_varz00_3207, BgL_arg2731z00_3215);
												}
												BgL_arg2727z00_3212 =
													MAKE_PAIR(BgL_arg2730z00_3214, BNIL);
											}
											BgL_arg2729z00_3213 = MAKE_PAIR(BgL_nexpz00_3208, BNIL);
											BgL_arg2726z00_3211 =
												MAKE_PAIR(BgL_arg2727z00_3212, BgL_arg2729z00_3213);
										}
										BgL_arg2724z00_3209 =
											MAKE_PAIR(BgL_arg2725z00_3210, BgL_arg2726z00_3211);
									}
									BGl_replacez12z12zztools_miscz00(BgL_expz00_50,
										BgL_arg2724z00_3209);
								}
								return
									BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_50,
									BgL_stackz00_54, BgL_locz00_55, BgL_sitez00_56);
							}
						}
					}
				}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_prognz00(((long) 301998274),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_dssslz00(((long) 275867955),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 216926614),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 481724379),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 189813582),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 122361728),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 458567972),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_buildz00(((long) 428035925),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_pragmaz00(((long) 28685330),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_labelsz00(((long) 129879154),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 469204197),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_exitz00(((long) 419066125),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 449859288),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 277780830),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 296989457),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_objectz00(((long) 520121496),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 516374368),
				BSTRING_TO_STRING(BGl_string3154z00zzast_sexpz00));
		}
	}

#ifdef __cplusplus
}
#endif
