/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c +rm -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Eval/evaluate_comp.scm -indent -o objs/obj_u/Eval/evaluate_comp.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static obj_t BGl_z62zc3anonymousza32939ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5497z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5499z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33758ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32778ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31798ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62zc3anonymousza32884ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32868ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_litt1394zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31994ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32039ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32887ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5605z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5607z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_symbol5609z00zz__evaluate_compz00 = BUNSPEC;
	extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl_z62zc3anonymousza33125ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_symbol5612z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5615z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5617z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5619z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32162ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
	extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_symbol5621z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5623z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5625z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5627z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5629z00zz__evaluate_compz00 = BUNSPEC;
	extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33216ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32074ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_symbol5631z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5633z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5635z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5637z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5639z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33233ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32164ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5641z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5643z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5645z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_symbol5647z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5649z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33072ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33234ze3ze1zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3anonymousza33056ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33799ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t make_vector(int, obj_t);
	static obj_t BGl_symbol5651z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5653z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5655z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5657z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33502ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5659z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32417ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33057ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long,
		obj_t, obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_symbol5661z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5663z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5665z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5667z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5669z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32167ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5671z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5673z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5675z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32702ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5677z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5679z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33237ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5681z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33270ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33092ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_reset_profilez00zz__evaluate_compz00();
	static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33611ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33433ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33344ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33417ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_labels1421zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33523ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32276ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, long, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32900ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32722ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32706ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33095ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33169ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62run5500z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5502z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5504z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5506z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5508z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31817ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32368ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5510z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5512z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5514z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5516z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5518z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33721ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33454ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_global1388zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5520z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_bindzd2exit1412z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	static obj_t BGl_z62run5522z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5524z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5526z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5528z62zz__evaluate_compz00(obj_t, obj_t);
	extern int bgl_debug();
	static obj_t BGl_z62zc3anonymousza33560ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33633ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32742ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32726ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33366ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t,
		obj_t, obj_t, long, obj_t);
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	static obj_t BGl_z62run5530z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5532z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t create_struct(obj_t, int);
	static obj_t BGl_z62run5534z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5536z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5538z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_get_profilez00zz__evaluate_compz00();
	extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
	static obj_t BGl_zc3exitza33229ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern long bgl_list_length(obj_t);
	static obj_t BGl_z62run5540z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5542z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5544z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5546z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_withzd2handler1417z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5548z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31837ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31748ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5550z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5552z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	static obj_t BGl_z62run5554z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5556z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5558z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33709ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5560z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5562z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5564z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5566z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5568z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32762ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_letza21406z12zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5501z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32746ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31928ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5503z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5505z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5507z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5509z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5570z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5572z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5574z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5576z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5578z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32690ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32674ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5511z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33476ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33549ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33387ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5513z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5515z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	static obj_t BGl_z62main5517z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5519z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5580z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62run5582z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31946ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5521z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5523z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5525z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5527z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5529z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	static obj_t BGl_z62main5531z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31858ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5533z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5535z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5537z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5539z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62zc3anonymousza32871ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33673ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32782ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32928ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33819ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32766ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31948ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5541z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5543z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5545z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5547z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5549z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33747ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33585ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32694ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32678ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5551z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5553z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5555z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5557z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5559z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32203ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62zc3anonymousza32784ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5561z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5563z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5565z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5567z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5569z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3anonymousza32042ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32874ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5571z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62compzd2ev_if1396zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5573z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62compzd2ev_trap1382zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5575z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5577z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5579z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t
		BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long,
		obj_t, obj_t);
	static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza32891ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32859ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31879ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5581z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32133ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static bool_t BGl_zc3lexintzc3zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33783ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32965ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32787ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32698ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_prog21402zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32045ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32877ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32240ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32983ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32894ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
	static obj_t BGl_z62zc3anonymousza31898ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_defglobal1392zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza32314ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_setglobal1390zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33223ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32316ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33699ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33062ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33224ze3ze1zz__evaluate_compz00(obj_t);
	extern obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_symbol5712z00zz__evaluate_compz00 = BUNSPEC;
	static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
	static obj_t BGl_z62zc3anonymousza33152ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_let1404zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5729z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32319ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_recz00zz__evaluate_compz00(obj_t, obj_t, long);
	static obj_t BGl_z62compzd2ev_goto1423zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static bool_t BGl_recz72z72zz__evaluate_compz00(obj_t);
	static obj_t BGl_symbol5731z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5733z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_symbol5735z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33405ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33227ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_ozd2ze3sz31zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3anonymousza33511ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33260ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5587z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5589z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5591z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33601ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32710ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5597z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_synchroniza7e1419z17zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33351ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33424ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t
		BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33441ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_or1398zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_Ez00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33264ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_var1384zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_app1425zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32730ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza32714ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33533ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t string_lt(obj_t, obj_t);
	static obj_t BGl_zc3exitza33217ze3z83zz__evaluate_compz00(obj_t, obj_t, obj_t,
		long, obj_t);
	static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33623ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31914ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_and1400zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long,
		long);
	static obj_t BGl_z62zc3anonymousza32912ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32750ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32734ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32718ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33464ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33359ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62compzd2ev_abs1427zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_letrec1409zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza33732ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31772ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32469ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza31951ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33661ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32770ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32754ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32738ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
	static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
	static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
	static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5498z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32682ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33379ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
	static obj_t BGl_z62comp1378z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32950ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33841ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31881ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33574ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32667ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_setlocal1386zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33397ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33011ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_unwindzd2prote1415z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32790ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31972ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32774ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33649ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33487ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32758ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32105ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62zc3anonymousza32880ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33771ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32937ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31884ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32686ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32017ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32970ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33862ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33684ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32793ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_zc3lexintzd2envz11zz__evaluate_compz00,
		BgL_bgl_za762za7c3lexintza7a1za75739z00,
		BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
	extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
	extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_compilezd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compileza762za7za7_5740z00,
		BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
	extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2statezd2envz00zz__evaluate_compz00,
		BgL_bgl_za762findza7d2stateza75741za7,
		BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0);
	extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5600z00zz__evaluate_compz00,
		BgL_bgl_string5600za700za7za7_5742za7,
		"/tmp/bigloo/runtime/Eval/evaluate_comp.scm", 42);
	      DEFINE_STRING(BGl_string5601z00zz__evaluate_compz00,
		BgL_bgl_string5601za700za7za7_5743za7, "&compile", 8);
	      DEFINE_STRING(BGl_string5602z00zz__evaluate_compz00,
		BgL_bgl_string5602za700za7za7_5744za7, "ev_expr", 7);
	      DEFINE_STRING(BGl_string5603z00zz__evaluate_compz00,
		BgL_bgl_string5603za700za7za7_5745za7, "expecting ~a, got ~a", 20);
	      DEFINE_STRING(BGl_string5604z00zz__evaluate_compz00,
		BgL_bgl_string5604za700za7za7_5746za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string5606z00zz__evaluate_compz00,
		BgL_bgl_string5606za700za7za7_5747za7, "mcell", 5);
	      DEFINE_STRING(BGl_string5608z00zz__evaluate_compz00,
		BgL_bgl_string5608za700za7za7_5748za7, "internal", 8);
	      DEFINE_STRING(BGl_string5610z00zz__evaluate_compz00,
		BgL_bgl_string5610za700za7za7_5749za7, "impossible", 10);
	      DEFINE_STRING(BGl_string5611z00zz__evaluate_compz00,
		BgL_bgl_string5611za700za7za7_5750za7, "procedure", 9);
	      DEFINE_STRING(BGl_string5613z00zz__evaluate_compz00,
		BgL_bgl_string5613za700za7za7_5751za7, "user", 4);
	      DEFINE_STRING(BGl_string5614z00zz__evaluate_compz00,
		BgL_bgl_string5614za700za7za7_5752za7, "invalid byte code", 17);
	      DEFINE_STRING(BGl_string5616z00zz__evaluate_compz00,
		BgL_bgl_string5616za700za7za7_5753za7, "+", 1);
	      DEFINE_STRING(BGl_string5618z00zz__evaluate_compz00,
		BgL_bgl_string5618za700za7za7_5754za7, "number", 6);
	extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string5620z00zz__evaluate_compz00,
		BgL_bgl_string5620za700za7za7_5755za7, "-", 1);
	      DEFINE_STRING(BGl_string5622z00zz__evaluate_compz00,
		BgL_bgl_string5622za700za7za7_5756za7, "*", 1);
	      DEFINE_STRING(BGl_string5624z00zz__evaluate_compz00,
		BgL_bgl_string5624za700za7za7_5757za7, "/", 1);
	      DEFINE_STRING(BGl_string5626z00zz__evaluate_compz00,
		BgL_bgl_string5626za700za7za7_5758za7, "<", 1);
	      DEFINE_STRING(BGl_string5628z00zz__evaluate_compz00,
		BgL_bgl_string5628za700za7za7_5759za7, ">", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5700z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5760z00,
		BGl_z62compzd2ev_letza21406z12zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5701z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5761z00,
		BGl_z62compzd2ev_letrec1409zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5702z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_bin5762z00,
		BGl_z62compzd2ev_bindzd2exit1412z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5703z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_unw5763z00,
		BGl_z62compzd2ev_unwindzd2prote1415z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5704z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_wit5764z00,
		BGl_z62compzd2ev_withzd2handler1417z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5705z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_syn5765z00,
		BGl_z62compzd2ev_synchroniza7e1419z17zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5630z00zz__evaluate_compz00,
		BgL_bgl_string5630za700za7za7_5766za7, "<=", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5706z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lab5767z00,
		BGl_z62compzd2ev_labels1421zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5707z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_got5768z00,
		BGl_z62compzd2ev_goto1423zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5632z00zz__evaluate_compz00,
		BgL_bgl_string5632za700za7za7_5769za7, ">=", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5708z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_app5770z00,
		BGl_z62compzd2ev_app1425zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5709z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_abs5771z00,
		BGl_z62compzd2ev_abs1427zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5634z00zz__evaluate_compz00,
		BgL_bgl_string5634za700za7za7_5772za7, "=", 1);
	      DEFINE_STRING(BGl_string5636z00zz__evaluate_compz00,
		BgL_bgl_string5636za700za7za7_5773za7, "+fx", 3);
	      DEFINE_STRING(BGl_string5638z00zz__evaluate_compz00,
		BgL_bgl_string5638za700za7za7_5774za7, "fixnum", 6);
	extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5640z00zz__evaluate_compz00,
		BgL_bgl_string5640za700za7za7_5775za7, "-fx", 3);
	      DEFINE_STRING(BGl_string5642z00zz__evaluate_compz00,
		BgL_bgl_string5642za700za7za7_5776za7, "*fx", 3);
	      DEFINE_STRING(BGl_string5644z00zz__evaluate_compz00,
		BgL_bgl_string5644za700za7za7_5777za7, "/fx", 3);
	      DEFINE_STRING(BGl_string5646z00zz__evaluate_compz00,
		BgL_bgl_string5646za700za7za7_5778za7, "<fx", 3);
	      DEFINE_STRING(BGl_string5648z00zz__evaluate_compz00,
		BgL_bgl_string5648za700za7za7_5779za7, ">fx", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5721z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75780za7,
		BGl_z62zc3anonymousza32868ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5722z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75781za7,
		BGl_z62zc3anonymousza32871ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5723z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75782za7,
		BGl_z62zc3anonymousza32874ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5724z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75783za7,
		BGl_z62zc3anonymousza32877ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5725z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75784za7,
		BGl_z62zc3anonymousza32880ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5650z00zz__evaluate_compz00,
		BgL_bgl_string5650za700za7za7_5785za7, "<=fx", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5726z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75786za7,
		BGl_z62zc3anonymousza32884ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5727z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75787za7,
		BGl_z62zc3anonymousza32887ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5652z00zz__evaluate_compz00,
		BgL_bgl_string5652za700za7za7_5788za7, ">=fx", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5728z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75789za7,
		BGl_z62zc3anonymousza32891ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5654z00zz__evaluate_compz00,
		BgL_bgl_string5654za700za7za7_5790za7, "=fx", 3);
	      DEFINE_STRING(BGl_string5656z00zz__evaluate_compz00,
		BgL_bgl_string5656za700za7za7_5791za7, "+fl", 3);
	      DEFINE_STRING(BGl_string5658z00zz__evaluate_compz00,
		BgL_bgl_string5658za700za7za7_5792za7, "flonum", 6);
	      DEFINE_STRING(BGl_string5660z00zz__evaluate_compz00,
		BgL_bgl_string5660za700za7za7_5793za7, "-fl", 3);
	      DEFINE_STRING(BGl_string5662z00zz__evaluate_compz00,
		BgL_bgl_string5662za700za7za7_5794za7, "*fl", 3);
	      DEFINE_STRING(BGl_string5664z00zz__evaluate_compz00,
		BgL_bgl_string5664za700za7za7_5795za7, "/fl", 3);
	      DEFINE_STRING(BGl_string5666z00zz__evaluate_compz00,
		BgL_bgl_string5666za700za7za7_5796za7, "<fl", 3);
	      DEFINE_STRING(BGl_string5668z00zz__evaluate_compz00,
		BgL_bgl_string5668za700za7za7_5797za7, ">fl", 3);
	extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_GENERIC(BGl_compzd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compza762za7za7__ev5798z00, BGl_z62compz62zz__evaluate_compz00,
		0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5670z00zz__evaluate_compz00,
		BgL_bgl_string5670za700za7za7_5799za7, "<=fl", 4);
	      DEFINE_STRING(BGl_string5672z00zz__evaluate_compz00,
		BgL_bgl_string5672za700za7za7_5800za7, ">=fl", 4);
	      DEFINE_STRING(BGl_string5674z00zz__evaluate_compz00,
		BgL_bgl_string5674za700za7za7_5801za7, "=fl", 3);
	      DEFINE_STRING(BGl_string5676z00zz__evaluate_compz00,
		BgL_bgl_string5676za700za7za7_5802za7, "car", 3);
	      DEFINE_STRING(BGl_string5678z00zz__evaluate_compz00,
		BgL_bgl_string5678za700za7za7_5803za7, "pair", 4);
	      DEFINE_STRING(BGl_string5680z00zz__evaluate_compz00,
		BgL_bgl_string5680za700za7za7_5804za7, "cdr", 3);
	      DEFINE_STRING(BGl_string5682z00zz__evaluate_compz00,
		BgL_bgl_string5682za700za7za7_5805za7, "cadr", 4);
	      DEFINE_STRING(BGl_string5684z00zz__evaluate_compz00,
		BgL_bgl_string5684za700za7za7_5806za7, "comp1378", 8);
	      DEFINE_STRING(BGl_string5685z00zz__evaluate_compz00,
		BgL_bgl_string5685za700za7za7_5807za7, "internal error: not defined for",
		31);
	      DEFINE_STRING(BGl_string5686z00zz__evaluate_compz00,
		BgL_bgl_string5686za700za7za7_5808za7, "&comp", 5);
	      DEFINE_STRING(BGl_string5688z00zz__evaluate_compz00,
		BgL_bgl_string5688za700za7za7_5809za7, "comp", 4);
	extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;
	extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
	extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5710z00zz__evaluate_compz00,
		BgL_bgl_string5710za700za7za7_5810za7, "internal error", 14);
	      DEFINE_STRING(BGl_string5711z00zz__evaluate_compz00,
		BgL_bgl_string5711za700za7za7_5811za7, "must be dead code", 17);
	      DEFINE_STRING(BGl_string5713z00zz__evaluate_compz00,
		BgL_bgl_string5713za700za7za7_5812za7, "notyet", 6);
	      DEFINE_STRING(BGl_string5714z00zz__evaluate_compz00,
		BgL_bgl_string5714za700za7za7_5813za7, "synchronize", 11);
	      DEFINE_STRING(BGl_string5715z00zz__evaluate_compz00,
		BgL_bgl_string5715za700za7za7_5814za7, "mutex", 5);
	      DEFINE_STRING(BGl_string5716z00zz__evaluate_compz00,
		BgL_bgl_string5716za700za7za7_5815za7, "set!", 4);
	      DEFINE_STRING(BGl_string5717z00zz__evaluate_compz00,
		BgL_bgl_string5717za700za7za7_5816za7, "read-only variable", 18);
	      DEFINE_STRING(BGl_string5718z00zz__evaluate_compz00,
		BgL_bgl_string5718za700za7za7_5817za7,
		"\nRedefinition of compiled variable -- ", 38);
	      DEFINE_STRING(BGl_string5719z00zz__evaluate_compz00,
		BgL_bgl_string5719za700za7za7_5818za7, "Unbound variable", 16);
	extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5720z00zz__evaluate_compz00,
		BgL_bgl_string5720za700za7za7_5819za7, "Uninitialized variable", 22);
	extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5730z00zz__evaluate_compz00,
		BgL_bgl_string5730za700za7za7_5820za7, "get_sp", 6);
	      DEFINE_STRING(BGl_string5732z00zz__evaluate_compz00,
		BgL_bgl_string5732za700za7za7_5821za7, "reset_profile", 13);
	      DEFINE_STRING(BGl_string5734z00zz__evaluate_compz00,
		BgL_bgl_string5734za700za7za7_5822za7, "get_profile", 11);
	      DEFINE_STRING(BGl_string5736z00zz__evaluate_compz00,
		BgL_bgl_string5736za700za7za7_5823za7, "reset_stack", 11);
	      DEFINE_STRING(BGl_string5737z00zz__evaluate_compz00,
		BgL_bgl_string5737za700za7za7_5824za7, "internal error: unknown command",
		31);
	      DEFINE_STRING(BGl_string5738z00zz__evaluate_compz00,
		BgL_bgl_string5738za700za7za7_5825za7, "__evaluate_comp", 15);
	      DEFINE_STRING(BGl_string5588z00zz__evaluate_compz00,
		BgL_bgl_string5588za700za7za7_5826za7, "all", 3);
	      DEFINE_STRING(BGl_string5590z00zz__evaluate_compz00,
		BgL_bgl_string5590za700za7za7_5827za7, "label-tag", 9);
	      DEFINE_STRING(BGl_string5592z00zz__evaluate_compz00,
		BgL_bgl_string5592za700za7za7_5828za7, "bounce", 6);
	      DEFINE_STRING(BGl_string5593z00zz__evaluate_compz00,
		BgL_bgl_string5593za700za7za7_5829za7, "non non non", 11);
	      DEFINE_STRING(BGl_string5594z00zz__evaluate_compz00,
		BgL_bgl_string5594za700za7za7_5830za7, " in ", 4);
	      DEFINE_STRING(BGl_string5595z00zz__evaluate_compz00,
		BgL_bgl_string5595za700za7za7_5831za7, "eval", 4);
	      DEFINE_STRING(BGl_string5596z00zz__evaluate_compz00,
		BgL_bgl_string5596za700za7za7_5832za7, "internal error: not found", 25);
	      DEFINE_STRING(BGl_string5598z00zz__evaluate_compz00,
		BgL_bgl_string5598za700za7za7_5833za7, "at", 2);
	      DEFINE_STRING(BGl_string5599z00zz__evaluate_compz00,
		BgL_bgl_string5599za700za7za7_5834za7, "", 0);
	extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5683z00zz__evaluate_compz00,
		BgL_bgl_za762comp1378za762za7za75835z00,
		BGl_z62comp1378z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5687z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_tra5836z00,
		BGl_z62compzd2ev_trap1382zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5689z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_var5837z00,
		BGl_z62compzd2ev_var1384zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5690z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set5838z00,
		BGl_z62compzd2ev_setlocal1386zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5691z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_glo5839z00,
		BGl_z62compzd2ev_global1388zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5692z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set5840z00,
		BGl_z62compzd2ev_setglobal1390zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5693z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_def5841z00,
		BGl_z62compzd2ev_defglobal1392zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5694z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lit5842z00,
		BGl_z62compzd2ev_litt1394zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5695z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_if15843z00,
		BGl_z62compzd2ev_if1396zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5696z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_or15844z00,
		BGl_z62compzd2ev_or1398zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5697z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_and5845z00,
		BGl_z62compzd2ev_and1400zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5698z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_pro5846z00,
		BGl_z62compzd2ev_prog21402zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5699z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5847z00,
		BGl_z62compzd2ev_let1404zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
	extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long
		BgL_checksumz00_19701, char *BgL_fromz00_19702)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_compz00 =
						BBOOL(((bool_t) 0));
					BGl_cnstzd2initzd2zz__evaluate_compz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
					BGl_genericzd2initzd2zz__evaluate_compz00();
					BGl_methodzd2initzd2zz__evaluate_compz00();
					return BGl_toplevelzd2initzd2zz__evaluate_compz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_symbol5587z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5588z00zz__evaluate_compz00);
			BGl_symbol5589z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5590z00zz__evaluate_compz00);
			BGl_symbol5591z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5592z00zz__evaluate_compz00);
			BGl_symbol5597z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5598z00zz__evaluate_compz00);
			BGl_symbol5605z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5606z00zz__evaluate_compz00);
			BGl_symbol5607z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5608z00zz__evaluate_compz00);
			BGl_symbol5609z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5610z00zz__evaluate_compz00);
			BGl_symbol5612z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5613z00zz__evaluate_compz00);
			BGl_symbol5615z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5616z00zz__evaluate_compz00);
			BGl_symbol5617z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5618z00zz__evaluate_compz00);
			BGl_symbol5619z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5620z00zz__evaluate_compz00);
			BGl_symbol5621z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5622z00zz__evaluate_compz00);
			BGl_symbol5623z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5624z00zz__evaluate_compz00);
			BGl_symbol5625z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5626z00zz__evaluate_compz00);
			BGl_symbol5627z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5628z00zz__evaluate_compz00);
			BGl_symbol5629z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5630z00zz__evaluate_compz00);
			BGl_symbol5631z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5632z00zz__evaluate_compz00);
			BGl_symbol5633z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5634z00zz__evaluate_compz00);
			BGl_symbol5635z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5636z00zz__evaluate_compz00);
			BGl_symbol5637z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5638z00zz__evaluate_compz00);
			BGl_symbol5639z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5640z00zz__evaluate_compz00);
			BGl_symbol5641z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5642z00zz__evaluate_compz00);
			BGl_symbol5643z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5644z00zz__evaluate_compz00);
			BGl_symbol5645z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5646z00zz__evaluate_compz00);
			BGl_symbol5647z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5648z00zz__evaluate_compz00);
			BGl_symbol5649z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5650z00zz__evaluate_compz00);
			BGl_symbol5651z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5652z00zz__evaluate_compz00);
			BGl_symbol5653z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5654z00zz__evaluate_compz00);
			BGl_symbol5655z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5656z00zz__evaluate_compz00);
			BGl_symbol5657z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5658z00zz__evaluate_compz00);
			BGl_symbol5659z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5660z00zz__evaluate_compz00);
			BGl_symbol5661z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5662z00zz__evaluate_compz00);
			BGl_symbol5663z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5664z00zz__evaluate_compz00);
			BGl_symbol5665z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5666z00zz__evaluate_compz00);
			BGl_symbol5667z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5668z00zz__evaluate_compz00);
			BGl_symbol5669z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5670z00zz__evaluate_compz00);
			BGl_symbol5671z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5672z00zz__evaluate_compz00);
			BGl_symbol5673z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5674z00zz__evaluate_compz00);
			BGl_symbol5675z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5676z00zz__evaluate_compz00);
			BGl_symbol5677z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5678z00zz__evaluate_compz00);
			BGl_symbol5679z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5680z00zz__evaluate_compz00);
			BGl_symbol5681z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5682z00zz__evaluate_compz00);
			BGl_symbol5712z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5713z00zz__evaluate_compz00);
			BGl_symbol5729z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5730z00zz__evaluate_compz00);
			BGl_symbol5731z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5732z00zz__evaluate_compz00);
			BGl_symbol5733z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5734z00zz__evaluate_compz00);
			return (BGl_symbol5735z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5736z00zz__evaluate_compz00), BUNSPEC);
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			{	/* Eval/evaluate_comp.scm 114 */
				BGL_LONGLONG_T BgL_arg1458z00_1298;

				{	/* Eval/evaluate_comp.scm 114 */
					BGL_LONGLONG_T BgL_res4143z00_6122;

					BgL_res4143z00_6122 = LONG_TO_LLONG(((long) 0));
					BgL_arg1458z00_1298 = BgL_res4143z00_6122;
				}
				{	/* Eval/evaluate_comp.scm 114 */
					obj_t BgL_list1459z00_1299;

					{	/* Eval/evaluate_comp.scm 114 */
						obj_t BgL_arg1460z00_1300;

						BgL_arg1460z00_1300 =
							MAKE_PAIR(make_bllong(BgL_arg1458z00_1298), BNIL);
						BgL_list1459z00_1299 =
							MAKE_PAIR(BGl_symbol5587z00zz__evaluate_compz00,
							BgL_arg1460z00_1300);
					}
					BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1459z00_1299;
			}}
			BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 = ((long) 8192);
			BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5589z00zz__evaluate_compz00,
				(int) (((long) 0)));
			BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5591z00zz__evaluate_compz00,
				(int) (((long) 0)));
			return BUNSPEC;
		}
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		AN_OBJECT;
		{
			{
				obj_t BgL_headz00_1301;

				BgL_headz00_1301 = MAKE_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_6154;
					obj_t BgL_tailz00_6155;

					BgL_prevz00_6154 = BgL_headz00_1301;
					BgL_tailz00_6155 = BgL_l1z00_1;
				BgL_loopz00_6153:
					if (PAIRP(BgL_tailz00_6155))
						{
							obj_t BgL_newzd2prevzd2_6161;

							BgL_newzd2prevzd2_6161 =
								MAKE_PAIR(CAR(BgL_tailz00_6155), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_6154, BgL_newzd2prevzd2_6161);
							{
								obj_t BgL_tailz00_19773;
								obj_t BgL_prevz00_19772;

								BgL_prevz00_19772 = BgL_newzd2prevzd2_6161;
								BgL_tailz00_19773 = CDR(BgL_tailz00_6155);
								BgL_tailz00_6155 = BgL_tailz00_19773;
								BgL_prevz00_6154 = BgL_prevz00_19772;
								goto BgL_loopz00_6153;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_1301);
			}
		}
	}



/* reset_profile */
	obj_t BGl_reset_profilez00zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 132 */
			{	/* Eval/evaluate_comp.scm 133 */
				BGL_LONGLONG_T BgL_arg1488z00_1329;

				{	/* Eval/evaluate_comp.scm 133 */
					BGL_LONGLONG_T BgL_res4152z00_6172;

					BgL_res4152z00_6172 = LONG_TO_LLONG(((long) 0));
					BgL_arg1488z00_1329 = BgL_res4152z00_6172;
				}
				{	/* Eval/evaluate_comp.scm 133 */
					obj_t BgL_list1489z00_1330;

					{	/* Eval/evaluate_comp.scm 133 */
						obj_t BgL_arg1490z00_1331;

						BgL_arg1490z00_1331 =
							MAKE_PAIR(make_bllong(BgL_arg1488z00_1329), BNIL);
						BgL_list1489z00_1330 =
							MAKE_PAIR(BGl_symbol5587z00zz__evaluate_compz00,
							BgL_arg1490z00_1331);
					}
					return (BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1489z00_1330, BUNSPEC);
				}
			}
		}
	}



/* <lexint */
	bool_t BGl_zc3lexintzc3zz__evaluate_compz00(obj_t BgL_t1z00_4,
		obj_t BgL_t2z00_5)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 135 */
			{	/* Eval/evaluate_comp.scm 142 */
				obj_t BgL_v1z00_1333;
				obj_t BgL_v2z00_1334;

				BgL_v1z00_1333 = CAR(BgL_t1z00_4);
				BgL_v2z00_1334 = CAR(BgL_t2z00_5);
				{	/* Eval/evaluate_comp.scm 143 */
					bool_t BgL_testz00_19782;

					if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_1333))
						{	/* Eval/evaluate_comp.scm 143 */
							BgL_testz00_19782 =
								BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v2z00_1334);
						}
					else
						{	/* Eval/evaluate_comp.scm 143 */
							BgL_testz00_19782 = ((bool_t) 0);
						}
					if (BgL_testz00_19782)
						{	/* Eval/evaluate_comp.scm 143 */
							return
								BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_1333,
								BgL_v2z00_1334);
						}
					else
						{	/* Eval/evaluate_comp.scm 143 */
							return
								string_lt(BGl_ozd2ze3sz31zz__evaluate_compz00(BgL_v1z00_1333),
								BGl_ozd2ze3sz31zz__evaluate_compz00(BgL_v2z00_1334));
						}
				}
			}
		}
	}



/* o->s */
	obj_t BGl_ozd2ze3sz31zz__evaluate_compz00(obj_t BgL_vz00_1339)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 141 */
			if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_1339))
				{	/* Ieee/fixnum.scm 967 */

					return
						BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
						(long) CINT(BgL_vz00_1339), ((long) 10));
				}
			else
				{	/* Eval/evaluate_comp.scm 138 */
					if (SYMBOLP(BgL_vz00_1339))
						{	/* Eval/evaluate_comp.scm 139 */
							obj_t BgL_res4155z00_6179;

							{	/* Eval/evaluate_comp.scm 139 */
								obj_t BgL_arg4009z00_6178;

								BgL_arg4009z00_6178 = SYMBOL_TO_STRING(BgL_vz00_1339);
								BgL_res4155z00_6179 =
									BGl_stringzd2copyzd2zz__r4_strings_6_7z00
									(BgL_arg4009z00_6178);
							}
							return BgL_res4155z00_6179;
						}
					else
						{	/* Eval/evaluate_comp.scm 139 */
							if (STRINGP(BgL_vz00_1339))
								{	/* Eval/evaluate_comp.scm 140 */
									return BgL_vz00_1339;
								}
							else
								{	/* Eval/evaluate_comp.scm 140 */
									return BGl_string5593z00zz__evaluate_compz00;
								}
						}
				}
		}
	}



/* &<lexint */
	obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_17699,
		obj_t BgL_t1z00_17700, obj_t BgL_t2z00_17701)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 135 */
			return
				BBOOL(BGl_zc3lexintzc3zz__evaluate_compz00(BgL_t1z00_17700,
					BgL_t2z00_17701));
		}
	}



/* get_profile */
	obj_t BGl_get_profilez00zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 147 */
			BGl_recz72z72zz__evaluate_compz00
				(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00);
			return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;
		}
	}



/* rec' */
	bool_t BGl_recz72z72zz__evaluate_compz00(obj_t BgL_tz00_1348)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 148 */
			{	/* Eval/evaluate_comp.scm 149 */
				obj_t BgL_auxz00_19805;
				obj_t BgL_auxz00_19803;

				BgL_auxz00_19805 =
					BGl_sortz00zz__r4_vectors_6_8z00
					(BGl_zc3lexintzd2envz11zz__evaluate_compz00, CDR(CDR(BgL_tz00_1348)));
				BgL_auxz00_19803 = CDR(BgL_tz00_1348);
				SET_CDR(BgL_auxz00_19803, BgL_auxz00_19805);
			}
			{	/* Eval/evaluate_comp.scm 150 */
				obj_t BgL_g1283z00_1353;

				BgL_g1283z00_1353 = CDR(CDR(BgL_tz00_1348));
				{
					obj_t BgL_l1281z00_6214;

					BgL_l1281z00_6214 = BgL_g1283z00_1353;
				BgL_zc3anonymousza31504ze3z83_6213:
					if (PAIRP(BgL_l1281z00_6214))
						{	/* Eval/evaluate_comp.scm 150 */
							BGl_recz72z72zz__evaluate_compz00(CAR(BgL_l1281z00_6214));
							{
								obj_t BgL_l1281z00_19816;

								BgL_l1281z00_19816 = CDR(BgL_l1281z00_6214);
								BgL_l1281z00_6214 = BgL_l1281z00_19816;
								goto BgL_zc3anonymousza31504ze3z83_6213;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 150 */
							return ((bool_t) 1);
						}
				}
			}
		}
	}



/* _index */
	obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 163 */
			{	/* Eval/evaluate_comp.scm 164 */
				obj_t BgL__ortest_1078z00_1372;

				{
					obj_t BgL_lz00_19688;
					long BgL_nz00_19689;

					BgL_lz00_19688 = BgL_lz00_9;
					BgL_nz00_19689 = ((long) 0);
				BgL_walkz00_19687:
					if (NULLP(BgL_lz00_19688))
						{	/* Eval/evaluate_comp.scm 158 */
							BgL__ortest_1078z00_1372 = BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 158 */
							if ((BgL_xz00_8 == CAR(BgL_lz00_19688)))
								{	/* Eval/evaluate_comp.scm 159 */
									BgL__ortest_1078z00_1372 = BINT(BgL_nz00_19689);
								}
							else
								{
									long BgL_nz00_19826;
									obj_t BgL_lz00_19824;

									BgL_lz00_19824 = CDR(BgL_lz00_19688);
									BgL_nz00_19826 = (BgL_nz00_19689 + ((long) 1));
									BgL_nz00_19689 = BgL_nz00_19826;
									BgL_lz00_19688 = BgL_lz00_19824;
									goto BgL_walkz00_19687;
								}
						}
				}
				if (CBOOL(BgL__ortest_1078z00_1372))
					{	/* Eval/evaluate_comp.scm 164 */
						return BgL__ortest_1078z00_1372;
					}
				else
					{	/* Eval/evaluate_comp.scm 164 */
						obj_t BgL_arg1517z00_1373;

						{	/* Eval/evaluate_comp.scm 164 */
							obj_t BgL_arg1519z00_1374;

							if (NULLP(BgL_lz00_9))
								{	/* Eval/evaluate_comp.scm 164 */
									BgL_arg1519z00_1374 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_head1286z00_1380;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1529z00_1392;

										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_arg1530z00_1393;

											BgL_arg1530z00_1393 = CAR(BgL_lz00_9);
											if (BGl_isazf3zf3zz__objectz00(BgL_arg1530z00_1393,
													BGl_ev_varz00zz__evaluate_typesz00))
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1529z00_1392 =
														(((BgL_ev_varz00_bglt) CREF(
																((BgL_ev_varz00_bglt) BgL_arg1530z00_1393)))->
														BgL_namez00);
												}
											else
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1529z00_1392 = BgL_arg1530z00_1393;
												}
										}
										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_res4168z00_6279;

											BgL_res4168z00_6279 =
												MAKE_PAIR(BgL_arg1529z00_1392, BNIL);
											BgL_head1286z00_1380 = BgL_res4168z00_6279;
										}
									}
									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_g1289z00_1381;

										BgL_g1289z00_1381 = CDR(BgL_lz00_9);
										{
											obj_t BgL_l1284z00_6315;
											obj_t BgL_tail1287z00_6316;

											BgL_l1284z00_6315 = BgL_g1289z00_1381;
											BgL_tail1287z00_6316 = BgL_head1286z00_1380;
										BgL_zc3anonymousza31524ze3z83_6314:
											if (NULLP(BgL_l1284z00_6315))
												{	/* Eval/evaluate_comp.scm 164 */
													BgL_arg1519z00_1374 = BgL_head1286z00_1380;
												}
											else
												{	/* Eval/evaluate_comp.scm 164 */
													obj_t BgL_newtail1288z00_6323;

													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1527z00_6324;

														BgL_arg1527z00_6324 =
															BGl_lnamez00zz__evaluate_compz00(CAR
															(BgL_l1284z00_6315));
														{	/* Eval/evaluate_comp.scm 164 */
															obj_t BgL_res4174z00_6332;

															BgL_res4174z00_6332 =
																MAKE_PAIR(BgL_arg1527z00_6324, BNIL);
															BgL_newtail1288z00_6323 = BgL_res4174z00_6332;
														}
													}
													SET_CDR(BgL_tail1287z00_6316,
														BgL_newtail1288z00_6323);
													{
														obj_t BgL_tail1287z00_19847;
														obj_t BgL_l1284z00_19845;

														BgL_l1284z00_19845 = CDR(BgL_l1284z00_6315);
														BgL_tail1287z00_19847 = BgL_newtail1288z00_6323;
														BgL_tail1287z00_6316 = BgL_tail1287z00_19847;
														BgL_l1284z00_6315 = BgL_l1284z00_19845;
														goto BgL_zc3anonymousza31524ze3z83_6314;
													}
												}
										}
									}
								}
							{	/* Eval/evaluate_comp.scm 164 */
								obj_t BgL_list1520z00_1375;

								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_arg1521z00_1376;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1522z00_1377;

										BgL_arg1522z00_1377 = MAKE_PAIR(BgL_arg1519z00_1374, BNIL);
										BgL_arg1521z00_1376 =
											MAKE_PAIR(BGl_string5594z00zz__evaluate_compz00,
											BgL_arg1522z00_1377);
									}
									BgL_list1520z00_1375 =
										MAKE_PAIR(BgL_xz00_8, BgL_arg1521z00_1376);
								}
								BgL_arg1517z00_1373 = BgL_list1520z00_1375;
							}
						}
						return
							BGl_errorz00zz__errorz00(BGl_string5595z00zz__evaluate_compz00,
							BGl_string5596z00zz__evaluate_compz00, BgL_arg1517z00_1373);
					}
			}
		}
	}



/* lname */
	obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 188 */
			if (BGl_isazf3zf3zz__objectz00(BgL_vz00_16,
					BGl_ev_varz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 189 */
					return
						(((BgL_ev_varz00_bglt) CREF(
								((BgL_ev_varz00_bglt) BgL_vz00_16)))->BgL_namez00);
				}
			else
				{	/* Eval/evaluate_comp.scm 189 */
					return BgL_vz00_16;
				}
		}
	}



/* loc-type-error */
	obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17,
		obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 193 */
			if (PAIRP(BgL_locz00_20))
				{	/* Eval/evaluate_comp.scm 194 */
					obj_t BgL_cdrzd2194zd2_1419;

					BgL_cdrzd2194zd2_1419 = CDR(BgL_locz00_20);
					if ((CAR(BgL_locz00_20) == BGl_symbol5597z00zz__evaluate_compz00))
						{	/* Eval/evaluate_comp.scm 194 */
							if (PAIRP(BgL_cdrzd2194zd2_1419))
								{	/* Eval/evaluate_comp.scm 194 */
									obj_t BgL_cdrzd2198zd2_1422;

									BgL_cdrzd2198zd2_1422 = CDR(BgL_cdrzd2194zd2_1419);
									if (PAIRP(BgL_cdrzd2198zd2_1422))
										{	/* Eval/evaluate_comp.scm 194 */
											if (NULLP(CDR(BgL_cdrzd2198zd2_1422)))
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19,
														CAR(BgL_cdrzd2194zd2_1419),
														CAR(BgL_cdrzd2198zd2_1422));
												}
											else
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorz00zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 194 */
											return
												BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
												BgL_mz00_18, BgL_vz00_19);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 194 */
									return
										BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
										BgL_mz00_18, BgL_vz00_19);
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 194 */
							return
								BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
								BgL_mz00_18, BgL_vz00_19);
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 194 */
					return
						BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18,
						BgL_vz00_19);
				}
		}
	}



/* make-state */
	obj_t BGl_makezd2statezd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 206 */
			{	/* Eval/evaluate_comp.scm 207 */
				obj_t BgL_stkz00_1436;

				BgL_stkz00_1436 =
					make_vector(
					(int) (((long) 8192)), BGl_string5599z00zz__evaluate_compz00);
				VECTOR_SET(BgL_stkz00_1436, (int) (((long) 0)), BINT(((long) 2)));
				return BgL_stkz00_1436;
			}
		}
	}



/* find-state */
	BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 211 */
			{	/* Eval/evaluate_comp.scm 212 */
				obj_t BgL_sz00_1437;

				{	/* Eval/evaluate_comp.scm 212 */
					obj_t BgL_auxz00_19883;

					BgL_auxz00_19883 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_1437 = BGL_ENV_EVSTATE(BgL_auxz00_19883);
				}
				if (VECTORP(BgL_sz00_1437))
					{	/* Eval/evaluate_comp.scm 213 */
						return BgL_sz00_1437;
					}
				else
					{	/* Eval/evaluate_comp.scm 214 */
						obj_t BgL_statez00_1439;

						BgL_statez00_1439 = BGl_makezd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 215 */
							obj_t BgL_auxz00_19889;

							BgL_auxz00_19889 = BGL_CURRENT_DYNAMIC_ENV();
							BGL_ENV_EVSTATE_SET(BgL_auxz00_19889, BgL_statez00_1439);
						}
						return BgL_statez00_1439;
					}
			}
		}
	}



/* &find-state */
	obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_17702)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 211 */
			return BGl_findzd2statezd2zz__evaluate_compz00();
		}
	}



/* compile */
	BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_34)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 273 */
			return BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);
		}
	}



/* &compile */
	obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_17703,
		obj_t BgL_ez00_17704)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 273 */
			{	/* Eval/evaluate_comp.scm 274 */
				BgL_ev_exprz00_bglt BgL_auxz00_19894;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_17704,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 274 */
						BgL_auxz00_19894 = ((BgL_ev_exprz00_bglt) BgL_ez00_17704);
					}
				else
					{
						obj_t BgL_auxz00_19898;

						BgL_auxz00_19898 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5600z00zz__evaluate_compz00, BINT(((long) 7006)),
							BGl_string5601z00zz__evaluate_compz00,
							BGl_string5602z00zz__evaluate_compz00, BgL_ez00_17704);
						FAILURE(BgL_auxz00_19898, BFALSE, BFALSE);
					}
				return BGl_compilez00zz__evaluate_compz00(BgL_auxz00_19894);
			}
		}
	}



/* global-fun-value */
	obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_43)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 332 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 335 */
					obj_t BgL_gz00_1489;

					{	/* Eval/evaluate_comp.scm 335 */
						obj_t BgL_arg1626z00_1490;
						obj_t BgL_arg1627z00_1491;

						BgL_arg1626z00_1490 =
							(((BgL_ev_globalz00_bglt) CREF(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_modz00);
						BgL_arg1627z00_1491 =
							(((BgL_ev_globalz00_bglt) CREF(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_namez00);
						BgL_gz00_1489 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg1626z00_1490, BgL_arg1627z00_1491);
					}
					if (CBOOL(BgL_gz00_1489))
						{	/* Eval/evaluate_comp.scm 336 */
							return VECTOR_REF(BgL_gz00_1489, (int) (((long) 2)));
						}
					else
						{	/* Eval/evaluate_comp.scm 336 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 333 */
					return BFALSE;
				}
		}
	}



/* push-boxes-args-on-sp */
	obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t
		BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85,
		obj_t BgL_locz00_86)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 616 */
			{
				obj_t BgL_lz00_1508;
				obj_t BgL_bsz00_1509;
				long BgL_spz00_1510;

				BgL_lz00_1508 = BgL_argsz00_83;
				BgL_bsz00_1509 = BgL_boxesz00_84;
				BgL_spz00_1510 = BgL_spz00_85;
			BgL_zc3anonymousza31638ze3z83_1511:
				if (NULLP(BgL_lz00_1508))
					{	/* Eval/evaluate_comp.scm 618 */
						if (NULLP(BgL_bsz00_1509))
							{	/* Eval/evaluate_comp.scm 619 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 622 */
								obj_t BgL_arg1641z00_1514;

								{	/* Eval/evaluate_comp.scm 622 */
									long BgL_arg1642z00_1515;
									long BgL_arg1643z00_1516;

									BgL_arg1642z00_1515 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1643z00_1516 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 621 */
										obj_t BgL_list1644z00_1517;

										{	/* Eval/evaluate_comp.scm 621 */
											obj_t BgL_arg1645z00_1518;

											BgL_arg1645z00_1518 =
												MAKE_PAIR(BINT(BgL_arg1643z00_1516), BNIL);
											BgL_list1644z00_1517 =
												MAKE_PAIR(BINT(BgL_arg1642z00_1515),
												BgL_arg1645z00_1518);
										}
										BgL_arg1641z00_1514 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5603z00zz__evaluate_compz00,
											BgL_list1644z00_1517);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5595z00zz__evaluate_compz00,
									BGl_string5604z00zz__evaluate_compz00, BgL_arg1641z00_1514);
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 618 */
						if (NULLP(BgL_bsz00_1509))
							{	/* Eval/evaluate_comp.scm 626 */
								obj_t BgL_arg1647z00_1520;

								{	/* Eval/evaluate_comp.scm 626 */
									long BgL_arg1648z00_1521;
									long BgL_arg1649z00_1522;

									BgL_arg1648z00_1521 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1649z00_1522 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 625 */
										obj_t BgL_list1650z00_1523;

										{	/* Eval/evaluate_comp.scm 625 */
											obj_t BgL_arg1651z00_1524;

											BgL_arg1651z00_1524 =
												MAKE_PAIR(BINT(BgL_arg1649z00_1522), BNIL);
											BgL_list1650z00_1523 =
												MAKE_PAIR(BINT(BgL_arg1648z00_1521),
												BgL_arg1651z00_1524);
										}
										BgL_arg1647z00_1520 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5603z00zz__evaluate_compz00,
											BgL_list1650z00_1523);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5595z00zz__evaluate_compz00,
									BGl_string5604z00zz__evaluate_compz00, BgL_arg1647z00_1520);
							}
						else
							{	/* Eval/evaluate_comp.scm 623 */
								{	/* Eval/evaluate_comp.scm 629 */
									obj_t BgL_arg1652z00_1525;

									{	/* Eval/evaluate_comp.scm 629 */
										obj_t BgL_vz00_1526;

										{	/* Eval/evaluate_comp.scm 629 */
											obj_t BgL_fun1654z00_1528;

											BgL_fun1654z00_1528 = CAR(BgL_lz00_1508);
											BgL_vz00_1526 =
												PROCEDURE_ENTRY(BgL_fun1654z00_1528)
												(BgL_fun1654z00_1528, BgL_sz00_82, BEOA);
										}
										if (CBOOL(CAR(BgL_bsz00_1509)))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_6409;

												BgL_newz00_6409 =
													create_struct(BGl_symbol5605z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_auxz00_19947;

													BgL_auxz00_19947 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_6409, BgL_auxz00_19947,
														BgL_vz00_1526);
												}
												BgL_arg1652z00_1525 = BgL_newz00_6409;
											}
										else
											{	/* Eval/evaluate_comp.scm 630 */
												BgL_arg1652z00_1525 = BgL_vz00_1526;
											}
									}
									VECTOR_SET(BgL_sz00_82,
										(int) (BgL_spz00_1510), BgL_arg1652z00_1525);
								}
								{
									long BgL_spz00_19956;
									obj_t BgL_bsz00_19954;
									obj_t BgL_lz00_19952;

									BgL_lz00_19952 = CDR(BgL_lz00_1508);
									BgL_bsz00_19954 = CDR(BgL_bsz00_1509);
									BgL_spz00_19956 = (BgL_spz00_1510 + ((long) 1));
									BgL_spz00_1510 = BgL_spz00_19956;
									BgL_bsz00_1509 = BgL_bsz00_19954;
									BgL_lz00_1508 = BgL_lz00_19952;
									goto BgL_zc3anonymousza31638ze3z83_1511;
								}
							}
					}
			}
		}
	}



/* sub-stk */
	obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88,
		obj_t BgL_l2z00_89)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 638 */
		BGl_subzd2stkzd2zz__evaluate_compz00:
			if (NULLP(BgL_l1z00_88))
				{	/* Eval/evaluate_comp.scm 639 */
					return BgL_l2z00_89;
				}
			else
				{	/* Eval/evaluate_comp.scm 639 */
					if ((CAR(BgL_l1z00_88) == CAR(BgL_l2z00_89)))
						{
							obj_t BgL_l2z00_19966;
							obj_t BgL_l1z00_19964;

							BgL_l1z00_19964 = CDR(BgL_l1z00_88);
							BgL_l2z00_19966 = CDR(BgL_l2z00_89);
							BgL_l2z00_89 = BgL_l2z00_19966;
							BgL_l1z00_88 = BgL_l1z00_19964;
							goto BGl_subzd2stkzd2zz__evaluate_compz00;
						}
					else
						{	/* Eval/evaluate_comp.scm 640 */
							return
								BGl_errorz00zz__errorz00(BGl_string5595z00zz__evaluate_compz00,
								BGl_symbol5607z00zz__evaluate_compz00,
								BGl_symbol5609z00zz__evaluate_compz00);
						}
				}
		}
	}



/* catch-trampoline */
	obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93,
		obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 662 */
			{	/* Eval/evaluate_comp.scm 663 */
				obj_t BgL_savedzd2bpzd2_1546;

				BgL_savedzd2bpzd2_1546 = VECTOR_REF(BgL_sz00_94, (int) (((long) 0)));
				VECTOR_SET(BgL_sz00_94, (int) (((long) 0)), BgL_bpz00_95);
				{
					obj_t BgL_fz00_1548;

					BgL_fz00_1548 = BgL_fz00_93;
				BgL_zc3anonymousza31670ze3z83_1549:
					{	/* Eval/evaluate_comp.scm 666 */
						obj_t BgL_rz00_1550;

						BgL_rz00_1550 =
							PROCEDURE_ENTRY(BgL_fz00_1548) (BgL_fz00_1548, BgL_sz00_94, BEOA);
						{	/* Eval/evaluate_comp.scm 667 */
							bool_t BgL_testz00_19977;

							if (PROCEDUREP(BgL_rz00_1550))
								{	/* Eval/evaluate_comp.scm 667 */
									obj_t BgL_arg1673z00_1553;

									BgL_arg1673z00_1553 = PROCEDURE_ATTR(BgL_rz00_1550);
									if (STRUCTP(BgL_arg1673z00_1553))
										{	/* Eval/evaluate_comp.scm 647 */
											BgL_testz00_19977 =
												(STRUCT_KEY(BgL_arg1673z00_1553) ==
												BGl_symbol5591z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 647 */
											BgL_testz00_19977 = ((bool_t) 0);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 667 */
									BgL_testz00_19977 = ((bool_t) 0);
								}
							if (BgL_testz00_19977)
								{
									obj_t BgL_fz00_19985;

									BgL_fz00_19985 = BgL_rz00_1550;
									BgL_fz00_1548 = BgL_fz00_19985;
									goto BgL_zc3anonymousza31670ze3z83_1549;
								}
							else
								{	/* Eval/evaluate_comp.scm 667 */
									VECTOR_SET(BgL_sz00_94,
										(int) (((long) 0)), BgL_savedzd2bpzd2_1546);
									return BgL_rz00_1550;
								}
						}
					}
				}
			}
		}
	}



/* comp-with-push */
	obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117,
		obj_t BgL_stkz00_118)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 681 */
			if (NULLP(BgL_eza2za2_117))
				{	/* Eval/evaluate_comp.scm 683 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 685 */
					obj_t BgL_arg1684z00_1565;
					obj_t BgL_arg1685z00_1566;

					{	/* Eval/evaluate_comp.scm 685 */
						obj_t BgL_arg1686z00_1567;

						BgL_arg1686z00_1567 = CAR(BgL_eza2za2_117);
						BgL_arg1684z00_1565 =
							BGl_compz00zz__evaluate_compz00(
							((BgL_ev_exprz00_bglt) BgL_arg1686z00_1567), BgL_stkz00_118);
					}
					{	/* Eval/evaluate_comp.scm 686 */
						obj_t BgL_arg1687z00_1568;
						obj_t BgL_arg1688z00_1569;

						BgL_arg1687z00_1568 = CDR(BgL_eza2za2_117);
						{	/* Eval/evaluate_comp.scm 686 */
							obj_t BgL_arg1689z00_1570;

							BgL_arg1689z00_1570 = MAKE_PAIR(BFALSE, BNIL);
							BgL_arg1688z00_1569 =
								BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_118,
								BgL_arg1689z00_1570);
						}
						BgL_arg1685z00_1566 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1687z00_1568,
							BgL_arg1688z00_1569);
					}
					return MAKE_PAIR(BgL_arg1684z00_1565, BgL_arg1685z00_1566);
				}
		}
	}



/* rec */
	obj_t BGl_recz00zz__evaluate_compz00(obj_t BgL_stkz00_19669,
		obj_t BgL_lz00_1572, long BgL_iz00_1573)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 689 */
			if (NULLP(BgL_lz00_1572))
				{	/* Eval/evaluate_comp.scm 690 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 690 */
					if ((BgL_iz00_1573 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 691 */
							return
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1572,
								BgL_stkz00_19669);
						}
					else
						{	/* Eval/evaluate_comp.scm 692 */
							obj_t BgL_arg1694z00_1577;
							obj_t BgL_arg1695z00_1578;

							{	/* Eval/evaluate_comp.scm 692 */
								obj_t BgL_arg1696z00_1579;

								BgL_arg1696z00_1579 = CAR(BgL_lz00_1572);
								BgL_arg1694z00_1577 =
									BGl_compz00zz__evaluate_compz00(
									((BgL_ev_exprz00_bglt) BgL_arg1696z00_1579),
									BgL_stkz00_19669);
							}
							BgL_arg1695z00_1578 =
								BGl_recz00zz__evaluate_compz00(BgL_stkz00_19669,
								CDR(BgL_lz00_1572), (BgL_iz00_1573 - ((long) 1)));
							return MAKE_PAIR(BgL_arg1694z00_1577, BgL_arg1695z00_1578);
						}
				}
		}
	}



/* subr-call-with-push */
	obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122,
		obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125,
		obj_t BgL_siza7eza7_126)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 695 */
			{	/* Eval/evaluate_comp.scm 697 */
				obj_t BgL_argsz00_1583;

				if (NULLP(BgL_argsz00_124))
					{	/* Eval/evaluate_comp.scm 697 */
						BgL_argsz00_1583 = BNIL;
					}
				else
					{	/* Eval/evaluate_comp.scm 697 */
						obj_t BgL_head1335z00_1588;

						{	/* Eval/evaluate_comp.scm 697 */
							obj_t BgL_res4207z00_6528;

							BgL_res4207z00_6528 = MAKE_PAIR(BNIL, BNIL);
							BgL_head1335z00_1588 = BgL_res4207z00_6528;
						}
						{
							obj_t BgL_l1333z00_6562;
							obj_t BgL_tail1336z00_6563;

							BgL_l1333z00_6562 = BgL_argsz00_124;
							BgL_tail1336z00_6563 = BgL_head1335z00_1588;
						BgL_zc3anonymousza31701ze3z83_6561:
							if (NULLP(BgL_l1333z00_6562))
								{	/* Eval/evaluate_comp.scm 697 */
									BgL_argsz00_1583 = CDR(BgL_head1335z00_1588);
								}
							else
								{	/* Eval/evaluate_comp.scm 697 */
									obj_t BgL_newtail1337z00_6570;

									{	/* Eval/evaluate_comp.scm 697 */
										obj_t BgL_arg1705z00_6571;

										{	/* Eval/evaluate_comp.scm 697 */
											obj_t BgL_az00_6572;

											BgL_az00_6572 = CAR(BgL_l1333z00_6562);
											BgL_arg1705z00_6571 =
												PROCEDURE_ENTRY(BgL_az00_6572) (BgL_az00_6572,
												BgL_sz00_122, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 697 */
											obj_t BgL_res4213z00_6580;

											BgL_res4213z00_6580 =
												MAKE_PAIR(BgL_arg1705z00_6571, BNIL);
											BgL_newtail1337z00_6570 = BgL_res4213z00_6580;
										}
									}
									SET_CDR(BgL_tail1336z00_6563, BgL_newtail1337z00_6570);
									{
										obj_t BgL_tail1336z00_20025;
										obj_t BgL_l1333z00_20023;

										BgL_l1333z00_20023 = CDR(BgL_l1333z00_6562);
										BgL_tail1336z00_20025 = BgL_newtail1337z00_6570;
										BgL_tail1336z00_6563 = BgL_tail1336z00_20025;
										BgL_l1333z00_6562 = BgL_l1333z00_20023;
										goto BgL_zc3anonymousza31701ze3z83_6561;
									}
								}
						}
					}
				{	/* Eval/evaluate_comp.scm 698 */
					long BgL_arg1699z00_1584;

					BgL_arg1699z00_1584 =
						((long) CINT(BgL_bpz00_125) + (long) CINT(BgL_siza7eza7_126));
					VECTOR_SET(BgL_sz00_122,
						(int) (((long) 0)), BINT(BgL_arg1699z00_1584));
				}
				{	/* Eval/evaluate_comp.scm 699 */
					obj_t BgL_za2za2resza2za2z00_1585;

					BgL_za2za2resza2za2z00_1585 = apply(BgL_fz00_123, BgL_argsz00_1583);
					VECTOR_SET(BgL_sz00_122, (int) (((long) 0)), BgL_bpz00_125);
					return BgL_za2za2resza2za2z00_1585;
				}
			}
		}
	}



/* push-nargs-on-sp */
	obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t
		BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132,
		obj_t BgL_spz00_133)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 708 */
			{	/* Eval/evaluate_comp.scm 709 */
				long BgL_g1147z00_1609;

				BgL_g1147z00_1609 = (((long) -1) - (long) CINT(BgL_arityz00_130));
				{
					obj_t BgL_lz00_1611;
					obj_t BgL_spz00_1612;
					long BgL_nz00_1613;

					BgL_lz00_1611 = BgL_argsz00_132;
					BgL_spz00_1612 = BgL_spz00_133;
					BgL_nz00_1613 = BgL_g1147z00_1609;
				BgL_zc3anonymousza31713ze3z83_1614:
					if ((BgL_nz00_1613 == ((long) 0)))
						{
							obj_t BgL_lz00_6691;
							obj_t BgL_rz00_6692;

							BgL_lz00_6691 = BgL_lz00_1611;
							BgL_rz00_6692 = BNIL;
						BgL_rec2z00_6690:
							if (NULLP(BgL_lz00_6691))
								{	/* Eval/evaluate_comp.scm 712 */
									return
										VECTOR_SET(BgL_sz00_131,
										CINT(BgL_spz00_1612), bgl_reverse_bang(BgL_rz00_6692));
								}
							else
								{	/* Eval/evaluate_comp.scm 714 */
									obj_t BgL_arg1719z00_6701;
									obj_t BgL_arg1720z00_6702;

									BgL_arg1719z00_6701 = CDR(BgL_lz00_6691);
									{	/* Eval/evaluate_comp.scm 714 */
										obj_t BgL_arg1721z00_6703;

										{	/* Eval/evaluate_comp.scm 714 */
											obj_t BgL_fun1722z00_6704;

											BgL_fun1722z00_6704 = CAR(BgL_lz00_6691);
											BgL_arg1721z00_6703 =
												PROCEDURE_ENTRY(BgL_fun1722z00_6704)
												(BgL_fun1722z00_6704, BgL_sz00_131, BEOA);
										}
										BgL_arg1720z00_6702 =
											MAKE_PAIR(BgL_arg1721z00_6703, BgL_rz00_6692);
									}
									{
										obj_t BgL_rz00_20053;
										obj_t BgL_lz00_20052;

										BgL_lz00_20052 = BgL_arg1719z00_6701;
										BgL_rz00_20053 = BgL_arg1720z00_6702;
										BgL_rz00_6692 = BgL_rz00_20053;
										BgL_lz00_6691 = BgL_lz00_20052;
										goto BgL_rec2z00_6690;
									}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 710 */
							{	/* Eval/evaluate_comp.scm 715 */
								obj_t BgL_arg1723z00_1628;

								{	/* Eval/evaluate_comp.scm 715 */
									obj_t BgL_fun1724z00_1629;

									BgL_fun1724z00_1629 = CAR(BgL_lz00_1611);
									BgL_arg1723z00_1628 =
										PROCEDURE_ENTRY(BgL_fun1724z00_1629) (BgL_fun1724z00_1629,
										BgL_sz00_131, BEOA);
								}
								VECTOR_SET(BgL_sz00_131,
									CINT(BgL_spz00_1612), BgL_arg1723z00_1628);
							}
							{	/* Eval/evaluate_comp.scm 716 */
								obj_t BgL_arg1727z00_1630;
								long BgL_arg1728z00_1631;
								long BgL_arg1730z00_1632;

								BgL_arg1727z00_1630 = CDR(BgL_lz00_1611);
								BgL_arg1728z00_1631 =
									((long) CINT(BgL_spz00_1612) + ((long) 1));
								BgL_arg1730z00_1632 = (BgL_nz00_1613 - ((long) 1));
								{
									long BgL_nz00_20068;
									obj_t BgL_spz00_20066;
									obj_t BgL_lz00_20065;

									BgL_lz00_20065 = BgL_arg1727z00_1630;
									BgL_spz00_20066 = BINT(BgL_arg1728z00_1631);
									BgL_nz00_20068 = BgL_arg1730z00_1632;
									BgL_nz00_1613 = BgL_nz00_20068;
									BgL_spz00_1612 = BgL_spz00_20066;
									BgL_lz00_1611 = BgL_lz00_20065;
									goto BgL_zc3anonymousza31713ze3z83_1614;
								}
							}
						}
				}
			}
		}
	}



/* need-shift */
	bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134,
		obj_t BgL_stkz00_135)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 759 */
			{
				obj_t BgL_lz00_1635;
				obj_t BgL_stkz00_1636;

				BgL_lz00_1635 = BgL_argsz00_134;
				BgL_stkz00_1636 = BgL_stkz00_135;
			BgL_zc3anonymousza31731ze3z83_1637:
				{	/* Eval/evaluate_comp.scm 763 */
					bool_t BgL_testz00_20069;

					if (NULLP(BgL_lz00_1635))
						{	/* Eval/evaluate_comp.scm 763 */
							BgL_testz00_20069 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 763 */
							BgL_testz00_20069 = NULLP(BgL_stkz00_1636);
						}
					if (BgL_testz00_20069)
						{	/* Eval/evaluate_comp.scm 763 */
							return ((bool_t) 0);
						}
					else
						{	/* Eval/evaluate_comp.scm 765 */
							bool_t BgL_testz00_20073;

							{	/* Eval/evaluate_comp.scm 765 */
								obj_t BgL_g1340z00_1642;

								BgL_g1340z00_1642 = CDR(BgL_lz00_1635);
								{
									obj_t BgL_l1338z00_1644;

									{	/* Eval/evaluate_comp.scm 765 */
										obj_t BgL_auxz00_20075;

										BgL_l1338z00_1644 = BgL_g1340z00_1642;
									BgL_zc3anonymousza31737ze3z83_1645:
										if (NULLP(BgL_l1338z00_1644))
											{	/* Eval/evaluate_comp.scm 765 */
												BgL_auxz00_20075 = BFALSE;
											}
										else
											{	/* Eval/evaluate_comp.scm 765 */
												obj_t BgL__ortest_1341z00_1647;

												{	/* Eval/evaluate_comp.scm 765 */
													obj_t BgL_ez00_1649;

													BgL_ez00_1649 = CAR(BgL_l1338z00_1644);
													{	/* Eval/evaluate_comp.scm 765 */
														obj_t BgL_arg1741z00_1650;
														obj_t BgL_arg1743z00_1651;

														BgL_arg1741z00_1650 = CAR(BgL_stkz00_1636);
														BgL_arg1743z00_1651 =
															BGl_usez00zz__evaluate_usez00(
															((BgL_ev_exprz00_bglt) BgL_ez00_1649), BNIL);
														BgL__ortest_1341z00_1647 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(BgL_arg1741z00_1650, BgL_arg1743z00_1651);
													}
												}
												if (CBOOL(BgL__ortest_1341z00_1647))
													{	/* Eval/evaluate_comp.scm 765 */
														BgL_auxz00_20075 = BgL__ortest_1341z00_1647;
													}
												else
													{
														obj_t BgL_l1338z00_20085;

														BgL_l1338z00_20085 = CDR(BgL_l1338z00_1644);
														BgL_l1338z00_1644 = BgL_l1338z00_20085;
														goto BgL_zc3anonymousza31737ze3z83_1645;
													}
											}
										BgL_testz00_20073 = CBOOL(BgL_auxz00_20075);
									}
								}
							}
							if (BgL_testz00_20073)
								{	/* Eval/evaluate_comp.scm 765 */
									return ((bool_t) 1);
								}
							else
								{
									obj_t BgL_stkz00_20090;
									obj_t BgL_lz00_20088;

									BgL_lz00_20088 = CDR(BgL_lz00_1635);
									BgL_stkz00_20090 = CDR(BgL_stkz00_1636);
									BgL_stkz00_1636 = BgL_stkz00_20090;
									BgL_lz00_1635 = BgL_lz00_20088;
									goto BgL_zc3anonymousza31731ze3z83_1637;
								}
						}
				}
			}
		}
	}



/* comp-old-call */
	obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_ez00_136, obj_t BgL_stkz00_137)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 769 */
			{	/* Eval/evaluate_comp.scm 771 */
				long BgL_siza7eza7_1656;
				long BgL_nbargsz00_1657;
				obj_t BgL_fz00_1658;
				obj_t BgL_symbzd2funzd2_1659;

				BgL_siza7eza7_1656 = bgl_list_length(BgL_stkz00_137);
				BgL_nbargsz00_1657 =
					bgl_list_length(
					(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00));
				BgL_fz00_1658 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_funz00),
					BgL_stkz00_137);
				BgL_symbzd2funzd2_1659 =
					BGl_uncompilez00zz__evaluate_uncompz00((((BgL_ev_appz00_bglt)
							CREF(BgL_ez00_136))->BgL_funz00));
				if (CBOOL((((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_tailzf3zf3)))
					{	/* Eval/evaluate_comp.scm 773 */
						if (BGl_needzd2shiftzd2zz__evaluate_compz00(
								(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
								BgL_stkz00_137))
							{	/* Eval/evaluate_comp.scm 780 */
								bool_t BgL_testz00_20105;

								{	/* Eval/evaluate_comp.scm 780 */
									int BgL_arg1796z00_1732;

									BgL_arg1796z00_1732 = bgl_debug();
									BgL_testz00_20105 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1796z00_1732),
										BINT(((long) 0)));
								}
								if (BgL_testz00_20105)
									{	/* Eval/evaluate_comp.scm 780 */
										obj_t BgL_argsz00_1663;

										BgL_argsz00_1663 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
											BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 780 */
											obj_t BgL_zc3anonymousza31748ze3z83_17705;

											BgL_zc3anonymousza31748ze3z83_17705 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza31748ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3anonymousza31748ze3z83_17705,
												(int) (((long) 0)), BgL_fz00_1658);
											PROCEDURE_SET(BgL_zc3anonymousza31748ze3z83_17705,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3anonymousza31748ze3z83_17705,
												(int) (((long) 2)), BgL_symbzd2funzd2_1659);
											PROCEDURE_SET(BgL_zc3anonymousza31748ze3z83_17705,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1657));
											PROCEDURE_SET(BgL_zc3anonymousza31748ze3z83_17705,
												(int) (((long) 4)), BgL_argsz00_1663);
											PROCEDURE_SET(BgL_zc3anonymousza31748ze3z83_17705,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1656));
											return BgL_zc3anonymousza31748ze3z83_17705;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 780 */
										obj_t BgL_argsz00_1699;

										BgL_argsz00_1699 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
											BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 780 */
											obj_t BgL_zc3anonymousza31772ze3z83_17706;

											BgL_zc3anonymousza31772ze3z83_17706 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza31772ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_17706,
												(int) (((long) 0)), BgL_fz00_1658);
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_17706,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_17706,
												(int) (((long) 2)), BgL_symbzd2funzd2_1659);
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_17706,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1657));
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_17706,
												(int) (((long) 4)), BgL_argsz00_1699);
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_17706,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1656));
											return BgL_zc3anonymousza31772ze3z83_17706;
										}
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 788 */
								bool_t BgL_testz00_20150;

								{	/* Eval/evaluate_comp.scm 788 */
									int BgL_arg1834z00_1797;

									BgL_arg1834z00_1797 = bgl_debug();
									BgL_testz00_20150 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1834z00_1797),
										BINT(((long) 0)));
								}
								if (BgL_testz00_20150)
									{	/* Eval/evaluate_comp.scm 788 */
										obj_t BgL_argsz00_1734;

										BgL_argsz00_1734 =
											BGl_recz00zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
											BgL_siza7eza7_1656);
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_zc3anonymousza31798ze3z83_17707;

											BgL_zc3anonymousza31798ze3z83_17707 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza31798ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3anonymousza31798ze3z83_17707,
												(int) (((long) 0)), BgL_fz00_1658);
											PROCEDURE_SET(BgL_zc3anonymousza31798ze3z83_17707,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3anonymousza31798ze3z83_17707,
												(int) (((long) 2)), BgL_symbzd2funzd2_1659);
											PROCEDURE_SET(BgL_zc3anonymousza31798ze3z83_17707,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1657));
											PROCEDURE_SET(BgL_zc3anonymousza31798ze3z83_17707,
												(int) (((long) 4)), BgL_argsz00_1734);
											return BgL_zc3anonymousza31798ze3z83_17707;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 788 */
										obj_t BgL_argsz00_1767;

										BgL_argsz00_1767 =
											BGl_recz00zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
											BgL_siza7eza7_1656);
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_zc3anonymousza31817ze3z83_17708;

											BgL_zc3anonymousza31817ze3z83_17708 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza31817ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3anonymousza31817ze3z83_17708,
												(int) (((long) 0)), BgL_fz00_1658);
											PROCEDURE_SET(BgL_zc3anonymousza31817ze3z83_17708,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3anonymousza31817ze3z83_17708,
												(int) (((long) 2)), BgL_symbzd2funzd2_1659);
											PROCEDURE_SET(BgL_zc3anonymousza31817ze3z83_17708,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1657));
											PROCEDURE_SET(BgL_zc3anonymousza31817ze3z83_17708,
												(int) (((long) 4)), BgL_argsz00_1767);
											return BgL_zc3anonymousza31817ze3z83_17708;
										}
									}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 774 */
						bool_t BgL_testz00_20189;

						{	/* Eval/evaluate_comp.scm 774 */
							int BgL_arg1874z00_1863;

							BgL_arg1874z00_1863 = bgl_debug();
							BgL_testz00_20189 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1874z00_1863),
								BINT(((long) 0)));
						}
						if (BgL_testz00_20189)
							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_argsz00_1800;

								BgL_argsz00_1800 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 774 */
									obj_t BgL_zc3anonymousza31837ze3z83_17709;

									BgL_zc3anonymousza31837ze3z83_17709 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza31837ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3anonymousza31837ze3z83_17709,
										(int) (((long) 0)), BgL_fz00_1658);
									PROCEDURE_SET(BgL_zc3anonymousza31837ze3z83_17709,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3anonymousza31837ze3z83_17709,
										(int) (((long) 2)), BgL_symbzd2funzd2_1659);
									PROCEDURE_SET(BgL_zc3anonymousza31837ze3z83_17709,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1657));
									PROCEDURE_SET(BgL_zc3anonymousza31837ze3z83_17709,
										(int) (((long) 4)), BgL_argsz00_1800);
									PROCEDURE_SET(BgL_zc3anonymousza31837ze3z83_17709,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1656));
									return BgL_zc3anonymousza31837ze3z83_17709;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_argsz00_1833;

								BgL_argsz00_1833 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 774 */
									obj_t BgL_zc3anonymousza31858ze3z83_17710;

									BgL_zc3anonymousza31858ze3z83_17710 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza31858ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3anonymousza31858ze3z83_17710,
										(int) (((long) 0)), BgL_fz00_1658);
									PROCEDURE_SET(BgL_zc3anonymousza31858ze3z83_17710,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3anonymousza31858ze3z83_17710,
										(int) (((long) 2)), BgL_symbzd2funzd2_1659);
									PROCEDURE_SET(BgL_zc3anonymousza31858ze3z83_17710,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1657));
									PROCEDURE_SET(BgL_zc3anonymousza31858ze3z83_17710,
										(int) (((long) 4)), BgL_argsz00_1833);
									PROCEDURE_SET(BgL_zc3anonymousza31858ze3z83_17710,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1656));
									return BgL_zc3anonymousza31858ze3z83_17710;
								}
							}
					}
			}
		}
	}



/* &<anonymous:1748> */
	obj_t BGl_z62zc3anonymousza31748ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17711, obj_t BgL_sz00_17718)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 780 */
			{	/* Eval/evaluate_comp.scm 780 */
				obj_t BgL_fz00_17712;
				BgL_ev_appz00_bglt BgL_i1155z00_17713;
				obj_t BgL_symbzd2funzd2_17714;
				long BgL_nbargsz00_17715;
				obj_t BgL_argsz00_17716;
				long BgL_siza7eza7_17717;

				BgL_fz00_17712 = PROCEDURE_REF(BgL_envz00_17711, (int) (((long) 0)));
				BgL_i1155z00_17713 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_17711, (int) (((long) 1))));
				BgL_symbzd2funzd2_17714 =
					PROCEDURE_REF(BgL_envz00_17711, (int) (((long) 2)));
				BgL_nbargsz00_17715 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17711, (int) (((long) 3))));
				BgL_argsz00_17716 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17711, (int) (((long) 4))));
				BgL_siza7eza7_17717 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17711, (int) (((long) 5))));
				{
					obj_t BgL_sz00_1664;

					BgL_sz00_1664 = BgL_sz00_17718;
					{	/* Eval/evaluate_comp.scm 780 */
						obj_t BgL_bpz00_1666;

						BgL_bpz00_1666 = VECTOR_REF(BgL_sz00_1664, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 780 */
							obj_t BgL_fz00_1667;

							BgL_fz00_1667 =
								PROCEDURE_ENTRY(BgL_fz00_17712) (BgL_fz00_17712, BgL_sz00_1664,
								BEOA);
							if (PROCEDUREP(BgL_fz00_1667))
								{	/* Eval/evaluate_comp.scm 780 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 780 */
									BGl_evtypezd2errorzd2zz__everrorz00(
										(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17713))->
											BgL_locz00), BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_1667);
								}
							{	/* Eval/evaluate_comp.scm 780 */
								obj_t BgL_ufz00_1670;

								BgL_ufz00_1670 = PROCEDURE_ATTR(BgL_fz00_1667);
								{	/* Eval/evaluate_comp.scm 780 */
									bool_t BgL_testz00_20261;

									if (STRUCTP(BgL_ufz00_1670))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20261 =
												(STRUCT_KEY(BgL_ufz00_1670) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20261 = ((bool_t) 0);
										}
									if (BgL_testz00_20261)
										{	/* Eval/evaluate_comp.scm 780 */
											obj_t BgL_arityz00_1672;
											obj_t BgL_runz00_1673;
											obj_t BgL_sfz00_1674;

											BgL_arityz00_1672 =
												STRUCT_REF(BgL_ufz00_1670, (int) (((long) 0)));
											BgL_runz00_1673 =
												STRUCT_REF(BgL_ufz00_1670, (int) (((long) 1)));
											BgL_sfz00_1674 =
												STRUCT_REF(BgL_ufz00_1670, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 780 */
												long BgL_spz00_1675;

												BgL_spz00_1675 =
													((long) CINT(BgL_bpz00_1666) + BgL_siza7eza7_17717);
												if (
													((long) CINT(BgL_arityz00_1672) ==
														BgL_nbargsz00_17715))
													{	/* Eval/evaluate_comp.scm 780 */
														{
															obj_t BgL_lz00_6766;
															long BgL_spz00_6767;

															BgL_lz00_6766 = BgL_argsz00_17716;
															BgL_spz00_6767 = BgL_spz00_1675;
														BgL_recz00_6765:
															if (NULLP(BgL_lz00_6766))
																{	/* Eval/evaluate_comp.scm 704 */
																	((bool_t) 0);
																}
															else
																{	/* Eval/evaluate_comp.scm 704 */
																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_arg1708z00_6774;

																		{	/* Eval/evaluate_comp.scm 705 */
																			obj_t BgL_fun1709z00_6775;

																			BgL_fun1709z00_6775 = CAR(BgL_lz00_6766);
																			BgL_arg1708z00_6774 =
																				PROCEDURE_ENTRY(BgL_fun1709z00_6775)
																				(BgL_fun1709z00_6775, BgL_sz00_1664,
																				BEOA);
																		}
																		VECTOR_SET(BgL_sz00_1664,
																			(int) (BgL_spz00_6767),
																			BgL_arg1708z00_6774);
																	}
																	{
																		long BgL_spz00_20288;
																		obj_t BgL_lz00_20286;

																		BgL_lz00_20286 = CDR(BgL_lz00_6766);
																		BgL_spz00_20288 =
																			(BgL_spz00_6767 + ((long) 1));
																		BgL_spz00_6767 = BgL_spz00_20288;
																		BgL_lz00_6766 = BgL_lz00_20286;
																		goto BgL_recz00_6765;
																	}
																}
														}
														{	/* Eval/evaluate_comp.scm 784 */
															long BgL_arg1754z00_1677;

															BgL_arg1754z00_1677 =
																(BgL_spz00_1675 + BgL_nbargsz00_17715);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_sz00_1664, (long) CINT(BgL_bpz00_1666),
																BgL_sz00_1664, BINT(BgL_spz00_1675),
																BINT(BgL_arg1754z00_1677));
													}}
												else
													{	/* Eval/evaluate_comp.scm 780 */
														bool_t BgL_testz00_20295;

														if (((long) CINT(BgL_arityz00_1672) >= ((long) 0)))
															{	/* Eval/evaluate_comp.scm 780 */
																BgL_testz00_20295 = ((bool_t) 1);
															}
														else
															{	/* Eval/evaluate_comp.scm 780 */
																BgL_testz00_20295 =
																	(
																	(long) CINT(BgL_arityz00_1672) <
																	(((long) -1) - BgL_nbargsz00_17715));
															}
														if (BgL_testz00_20295)
															{	/* Eval/evaluate_comp.scm 780 */
																BGl_evarityzd2errorzd2zz__everrorz00(
																	(((BgL_ev_appz00_bglt)
																			CREF(BgL_i1155z00_17713))->BgL_locz00),
																	STRUCT_REF(BgL_ufz00_1670,
																		(int) (((long) 3))),
																	(int) (BgL_nbargsz00_17715),
																	CINT(BgL_arityz00_1672));
															}
														else
															{	/* Eval/evaluate_comp.scm 780 */
																BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																	(BgL_arityz00_1672, BgL_sz00_1664,
																	BgL_argsz00_17716, BINT(BgL_spz00_1675));
																{	/* Eval/evaluate_comp.scm 786 */
																	long BgL_arg1758z00_1681;

																	BgL_arg1758z00_1681 =
																		(BgL_spz00_1675 +
																		(((long) 0) -
																			(long) CINT(BgL_arityz00_1672)));
																	BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																		(BgL_sz00_1664, (long) CINT(BgL_bpz00_1666),
																		BgL_sz00_1664, BINT(BgL_spz00_1675),
																		BINT(BgL_arg1758z00_1681));
													}}}
												{	/* Eval/evaluate_comp.scm 780 */
													obj_t BgL_z12denvz12_1685;

													BgL_z12denvz12_1685 = BGL_CURRENT_DYNAMIC_ENV();
													{	/* Eval/evaluate_comp.scm 780 */
														obj_t BgL_auxz00_20318;

														BgL_auxz00_20318 =
															(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17713))->
															BgL_locz00);
														BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_1685,
															BgL_auxz00_20318);
													}
													if (
														(((long) CINT(BgL_bpz00_1666) +
																(long) CINT(BgL_sfz00_1674)) <
															(long) (VECTOR_LENGTH(BgL_sz00_1664))))
														{	/* Eval/evaluate_comp.scm 780 */
															return BgL_runz00_1673;
														}
													else
														{	/* Eval/evaluate_comp.scm 780 */
															obj_t BgL_nsz00_1688;

															BgL_nsz00_1688 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 780 */
																long BgL_arg1764z00_1690;

																BgL_arg1764z00_1690 =
																	(
																	(long) CINT(BgL_bpz00_1666) +
																	BgL_nbargsz00_17715);
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1688, ((long) 2), BgL_sz00_1664,
																	BgL_bpz00_1666, BINT(BgL_arg1764z00_1690));
															}
															VECTOR_SET(BgL_nsz00_1688,
																(int) (((long) 1)), BgL_sz00_1664);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1685,
																BgL_nsz00_1688);
															{	/* Eval/evaluate_comp.scm 780 */
																obj_t BgL_ez00_1691;

																BgL_ez00_1691 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_1691, BgL_sz00_1664);
																{	/* Eval/evaluate_comp.scm 780 */
																	obj_t BgL_____rz00_1692;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_6832;

																		BgL_savedzd2bpzd2_6832 =
																			VECTOR_REF(BgL_nsz00_1688,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_1688,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_6839;

																			BgL_fz00_6839 = BgL_runz00_1673;
																		BgL_recz00_6838:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_6840;

																				BgL_rz00_6840 =
																					PROCEDURE_ENTRY(BgL_fz00_6839)
																					(BgL_fz00_6839, BgL_nsz00_1688, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_20347;

																					if (PROCEDUREP(BgL_rz00_6840))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_6845;

																							BgL_arg1673z00_6845 =
																								PROCEDURE_ATTR(BgL_rz00_6840);
																							if (STRUCTP(BgL_arg1673z00_6845))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_20347 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_6845) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_20347 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_20347 = ((bool_t) 0);
																						}
																					if (BgL_testz00_20347)
																						{
																							obj_t BgL_fz00_20355;

																							BgL_fz00_20355 = BgL_rz00_6840;
																							BgL_fz00_6839 = BgL_fz00_20355;
																							goto BgL_recz00_6838;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_1688,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_6832);
																							BgL_____rz00_1692 = BgL_rz00_6840;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_1691);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1685,
																		BgL_sz00_1664);
																	return BgL_____rz00_1692;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 780 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1667,
													(int) (BgL_nbargsz00_17715)))
												{	/* Eval/evaluate_comp.scm 780 */
													{	/* Eval/evaluate_comp.scm 780 */
														obj_t BgL_auxz00_20365;
														obj_t BgL_auxz00_20363;

														BgL_auxz00_20365 =
															(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17713))->
															BgL_locz00);
														BgL_auxz00_20363 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_20363,
															BgL_auxz00_20365);
													}
													return
														BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
														(BgL_sz00_1664, BgL_fz00_1667, BgL_argsz00_17716,
														BgL_bpz00_1666, BINT(BgL_siza7eza7_17717));
												}
											else
												{	/* Eval/evaluate_comp.scm 780 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17713))->
															BgL_locz00), BgL_symbzd2funzd2_17714,
														(int) (BgL_nbargsz00_17715),
														PROCEDURE_ARITY(BgL_fz00_1667));
		}}}}}}}}}
	}



/* &<anonymous:1772> */
	obj_t BGl_z62zc3anonymousza31772ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17719, obj_t BgL_sz00_17726)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 780 */
			{	/* Eval/evaluate_comp.scm 780 */
				obj_t BgL_fz00_17720;
				BgL_ev_appz00_bglt BgL_i1155z00_17721;
				obj_t BgL_symbzd2funzd2_17722;
				long BgL_nbargsz00_17723;
				obj_t BgL_argsz00_17724;
				long BgL_siza7eza7_17725;

				BgL_fz00_17720 = PROCEDURE_REF(BgL_envz00_17719, (int) (((long) 0)));
				BgL_i1155z00_17721 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_17719, (int) (((long) 1))));
				BgL_symbzd2funzd2_17722 =
					PROCEDURE_REF(BgL_envz00_17719, (int) (((long) 2)));
				BgL_nbargsz00_17723 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17719, (int) (((long) 3))));
				BgL_argsz00_17724 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17719, (int) (((long) 4))));
				BgL_siza7eza7_17725 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17719, (int) (((long) 5))));
				{
					obj_t BgL_sz00_1700;

					BgL_sz00_1700 = BgL_sz00_17726;
					{	/* Eval/evaluate_comp.scm 780 */
						obj_t BgL_bpz00_1702;

						BgL_bpz00_1702 = VECTOR_REF(BgL_sz00_1700, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 780 */
							obj_t BgL_fz00_1703;

							BgL_fz00_1703 =
								PROCEDURE_ENTRY(BgL_fz00_17720) (BgL_fz00_17720, BgL_sz00_1700,
								BEOA);
							if (PROCEDUREP(BgL_fz00_1703))
								{	/* Eval/evaluate_comp.scm 780 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 780 */
									BGl_evtypezd2errorzd2zz__everrorz00(
										(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17721))->
											BgL_locz00), BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_1703);
								}
							{	/* Eval/evaluate_comp.scm 780 */
								obj_t BgL_ufz00_1706;

								BgL_ufz00_1706 = PROCEDURE_ATTR(BgL_fz00_1703);
								{	/* Eval/evaluate_comp.scm 780 */
									bool_t BgL_testz00_20401;

									if (STRUCTP(BgL_ufz00_1706))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20401 =
												(STRUCT_KEY(BgL_ufz00_1706) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20401 = ((bool_t) 0);
										}
									if (BgL_testz00_20401)
										{	/* Eval/evaluate_comp.scm 780 */
											obj_t BgL_arityz00_1708;
											obj_t BgL_runz00_1709;
											obj_t BgL_sfz00_1710;

											BgL_arityz00_1708 =
												STRUCT_REF(BgL_ufz00_1706, (int) (((long) 0)));
											BgL_runz00_1709 =
												STRUCT_REF(BgL_ufz00_1706, (int) (((long) 1)));
											BgL_sfz00_1710 =
												STRUCT_REF(BgL_ufz00_1706, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 780 */
												long BgL_spz00_1711;

												BgL_spz00_1711 =
													((long) CINT(BgL_bpz00_1702) + BgL_siza7eza7_17725);
												if (
													((long) CINT(BgL_arityz00_1708) ==
														BgL_nbargsz00_17723))
													{	/* Eval/evaluate_comp.scm 780 */
														{
															obj_t BgL_lz00_6889;
															long BgL_spz00_6890;

															BgL_lz00_6889 = BgL_argsz00_17724;
															BgL_spz00_6890 = BgL_spz00_1711;
														BgL_recz00_6888:
															if (NULLP(BgL_lz00_6889))
																{	/* Eval/evaluate_comp.scm 704 */
																	((bool_t) 0);
																}
															else
																{	/* Eval/evaluate_comp.scm 704 */
																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_arg1708z00_6897;

																		{	/* Eval/evaluate_comp.scm 705 */
																			obj_t BgL_fun1709z00_6898;

																			BgL_fun1709z00_6898 = CAR(BgL_lz00_6889);
																			BgL_arg1708z00_6897 =
																				PROCEDURE_ENTRY(BgL_fun1709z00_6898)
																				(BgL_fun1709z00_6898, BgL_sz00_1700,
																				BEOA);
																		}
																		VECTOR_SET(BgL_sz00_1700,
																			(int) (BgL_spz00_6890),
																			BgL_arg1708z00_6897);
																	}
																	{
																		long BgL_spz00_20428;
																		obj_t BgL_lz00_20426;

																		BgL_lz00_20426 = CDR(BgL_lz00_6889);
																		BgL_spz00_20428 =
																			(BgL_spz00_6890 + ((long) 1));
																		BgL_spz00_6890 = BgL_spz00_20428;
																		BgL_lz00_6889 = BgL_lz00_20426;
																		goto BgL_recz00_6888;
																	}
																}
														}
														{	/* Eval/evaluate_comp.scm 784 */
															long BgL_arg1779z00_1713;

															BgL_arg1779z00_1713 =
																(BgL_spz00_1711 + BgL_nbargsz00_17723);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_sz00_1700, (long) CINT(BgL_bpz00_1702),
																BgL_sz00_1700, BINT(BgL_spz00_1711),
																BINT(BgL_arg1779z00_1713));
													}}
												else
													{	/* Eval/evaluate_comp.scm 780 */
														bool_t BgL_testz00_20435;

														if (((long) CINT(BgL_arityz00_1708) >= ((long) 0)))
															{	/* Eval/evaluate_comp.scm 780 */
																BgL_testz00_20435 = ((bool_t) 1);
															}
														else
															{	/* Eval/evaluate_comp.scm 780 */
																BgL_testz00_20435 =
																	(
																	(long) CINT(BgL_arityz00_1708) <
																	(((long) -1) - BgL_nbargsz00_17723));
															}
														if (BgL_testz00_20435)
															{	/* Eval/evaluate_comp.scm 780 */
																BGl_evarityzd2errorzd2zz__everrorz00(
																	(((BgL_ev_appz00_bglt)
																			CREF(BgL_i1155z00_17721))->BgL_locz00),
																	STRUCT_REF(BgL_ufz00_1706,
																		(int) (((long) 3))),
																	(int) (BgL_nbargsz00_17723),
																	CINT(BgL_arityz00_1708));
															}
														else
															{	/* Eval/evaluate_comp.scm 780 */
																BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																	(BgL_arityz00_1708, BgL_sz00_1700,
																	BgL_argsz00_17724, BINT(BgL_spz00_1711));
																{	/* Eval/evaluate_comp.scm 786 */
																	long BgL_arg1784z00_1717;

																	BgL_arg1784z00_1717 =
																		(BgL_spz00_1711 +
																		(((long) 0) -
																			(long) CINT(BgL_arityz00_1708)));
																	BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																		(BgL_sz00_1700, (long) CINT(BgL_bpz00_1702),
																		BgL_sz00_1700, BINT(BgL_spz00_1711),
																		BINT(BgL_arg1784z00_1717));
													}}}
												{	/* Eval/evaluate_comp.scm 780 */
													obj_t BgL_z12denvz12_1721;

													BgL_z12denvz12_1721 = BGL_CURRENT_DYNAMIC_ENV();
													if (
														(((long) CINT(BgL_bpz00_1702) +
																(long) CINT(BgL_sfz00_1710)) <
															(long) (VECTOR_LENGTH(BgL_sz00_1700))))
														{	/* Eval/evaluate_comp.scm 780 */
															return BgL_runz00_1709;
														}
													else
														{	/* Eval/evaluate_comp.scm 780 */
															obj_t BgL_nsz00_1723;

															BgL_nsz00_1723 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 780 */
																long BgL_arg1791z00_1725;

																BgL_arg1791z00_1725 =
																	(
																	(long) CINT(BgL_bpz00_1702) +
																	BgL_nbargsz00_17723);
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1723, ((long) 2), BgL_sz00_1700,
																	BgL_bpz00_1702, BINT(BgL_arg1791z00_1725));
															}
															VECTOR_SET(BgL_nsz00_1723,
																(int) (((long) 1)), BgL_sz00_1700);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1721,
																BgL_nsz00_1723);
															{	/* Eval/evaluate_comp.scm 780 */
																obj_t BgL_ez00_1726;

																BgL_ez00_1726 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_1726, BgL_sz00_1700);
																{	/* Eval/evaluate_comp.scm 780 */
																	obj_t BgL_____rz00_1727;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_6955;

																		BgL_savedzd2bpzd2_6955 =
																			VECTOR_REF(BgL_nsz00_1723,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_1723,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_6962;

																			BgL_fz00_6962 = BgL_runz00_1709;
																		BgL_recz00_6961:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_6963;

																				BgL_rz00_6963 =
																					PROCEDURE_ENTRY(BgL_fz00_6962)
																					(BgL_fz00_6962, BgL_nsz00_1723, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_20484;

																					if (PROCEDUREP(BgL_rz00_6963))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_6968;

																							BgL_arg1673z00_6968 =
																								PROCEDURE_ATTR(BgL_rz00_6963);
																							if (STRUCTP(BgL_arg1673z00_6968))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_20484 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_6968) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_20484 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_20484 = ((bool_t) 0);
																						}
																					if (BgL_testz00_20484)
																						{
																							obj_t BgL_fz00_20492;

																							BgL_fz00_20492 = BgL_rz00_6963;
																							BgL_fz00_6962 = BgL_fz00_20492;
																							goto BgL_recz00_6961;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_1723,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_6955);
																							BgL_____rz00_1727 = BgL_rz00_6963;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_1726);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1721,
																		BgL_sz00_1700);
																	return BgL_____rz00_1727;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 780 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1703,
													(int) (BgL_nbargsz00_17723)))
												{	/* Eval/evaluate_comp.scm 780 */
													return
														BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
														(BgL_sz00_1700, BgL_fz00_1703, BgL_argsz00_17724,
														BgL_bpz00_1702, BINT(BgL_siza7eza7_17725));
												}
											else
												{	/* Eval/evaluate_comp.scm 780 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17721))->
															BgL_locz00), BgL_symbzd2funzd2_17722,
														(int) (BgL_nbargsz00_17723),
														PROCEDURE_ARITY(BgL_fz00_1703));
		}}}}}}}}}
	}



/* &<anonymous:1798> */
	obj_t BGl_z62zc3anonymousza31798ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17727, obj_t BgL_sz00_17733)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 788 */
			{	/* Eval/evaluate_comp.scm 788 */
				obj_t BgL_fz00_17728;
				BgL_ev_appz00_bglt BgL_i1155z00_17729;
				obj_t BgL_symbzd2funzd2_17730;
				long BgL_nbargsz00_17731;
				obj_t BgL_argsz00_17732;

				BgL_fz00_17728 = PROCEDURE_REF(BgL_envz00_17727, (int) (((long) 0)));
				BgL_i1155z00_17729 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_17727, (int) (((long) 1))));
				BgL_symbzd2funzd2_17730 =
					PROCEDURE_REF(BgL_envz00_17727, (int) (((long) 2)));
				BgL_nbargsz00_17731 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17727, (int) (((long) 3))));
				BgL_argsz00_17732 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17727, (int) (((long) 4))));
				{
					obj_t BgL_sz00_1735;

					BgL_sz00_1735 = BgL_sz00_17733;
					{	/* Eval/evaluate_comp.scm 788 */
						obj_t BgL_bpz00_1737;

						BgL_bpz00_1737 = VECTOR_REF(BgL_sz00_1735, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 788 */
							obj_t BgL_fz00_1738;

							BgL_fz00_1738 =
								PROCEDURE_ENTRY(BgL_fz00_17728) (BgL_fz00_17728, BgL_sz00_1735,
								BEOA);
							if (PROCEDUREP(BgL_fz00_1738))
								{	/* Eval/evaluate_comp.scm 788 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 788 */
									BGl_evtypezd2errorzd2zz__everrorz00(
										(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17729))->
											BgL_locz00), BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_1738);
								}
							{	/* Eval/evaluate_comp.scm 788 */
								obj_t BgL_ufz00_1741;

								BgL_ufz00_1741 = PROCEDURE_ATTR(BgL_fz00_1738);
								{	/* Eval/evaluate_comp.scm 788 */
									bool_t BgL_testz00_20530;

									if (STRUCTP(BgL_ufz00_1741))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20530 =
												(STRUCT_KEY(BgL_ufz00_1741) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20530 = ((bool_t) 0);
										}
									if (BgL_testz00_20530)
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_arityz00_1743;
											obj_t BgL_runz00_1744;
											obj_t BgL_sfz00_1745;

											BgL_arityz00_1743 =
												STRUCT_REF(BgL_ufz00_1741, (int) (((long) 0)));
											BgL_runz00_1744 =
												STRUCT_REF(BgL_ufz00_1741, (int) (((long) 1)));
											BgL_sfz00_1745 =
												STRUCT_REF(BgL_ufz00_1741, (int) (((long) 2)));
											if (
												((long) CINT(BgL_arityz00_1743) == BgL_nbargsz00_17731))
												{
													obj_t BgL_lz00_7011;
													obj_t BgL_spz00_7012;

													{	/* Eval/evaluate_comp.scm 703 */
														bool_t BgL_auxz00_20544;

														BgL_lz00_7011 = BgL_argsz00_17732;
														BgL_spz00_7012 = BgL_bpz00_1737;
													BgL_recz00_7010:
														if (NULLP(BgL_lz00_7011))
															{	/* Eval/evaluate_comp.scm 704 */
																BgL_auxz00_20544 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 704 */
																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_arg1708z00_7019;

																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_fun1709z00_7020;

																		BgL_fun1709z00_7020 = CAR(BgL_lz00_7011);
																		BgL_arg1708z00_7019 =
																			PROCEDURE_ENTRY(BgL_fun1709z00_7020)
																			(BgL_fun1709z00_7020, BgL_sz00_1735,
																			BEOA);
																	}
																	VECTOR_SET(BgL_sz00_1735,
																		CINT(BgL_spz00_7012), BgL_arg1708z00_7019);
																}
																{	/* Eval/evaluate_comp.scm 706 */
																	obj_t BgL_arg1710z00_7021;
																	long BgL_arg1712z00_7022;

																	BgL_arg1710z00_7021 = CDR(BgL_lz00_7011);
																	BgL_arg1712z00_7022 =
																		((long) CINT(BgL_spz00_7012) + ((long) 1));
																	{
																		obj_t BgL_spz00_20558;
																		obj_t BgL_lz00_20557;

																		BgL_lz00_20557 = BgL_arg1710z00_7021;
																		BgL_spz00_20558 = BINT(BgL_arg1712z00_7022);
																		BgL_spz00_7012 = BgL_spz00_20558;
																		BgL_lz00_7011 = BgL_lz00_20557;
																		goto BgL_recz00_7010;
																	}
																}
															}
														BBOOL(BgL_auxz00_20544);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 788 */
													bool_t BgL_testz00_20561;

													if (((long) CINT(BgL_arityz00_1743) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 788 */
															BgL_testz00_20561 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 788 */
															BgL_testz00_20561 =
																(
																(long) CINT(BgL_arityz00_1743) <
																(((long) -1) - BgL_nbargsz00_17731));
														}
													if (BgL_testz00_20561)
														{	/* Eval/evaluate_comp.scm 788 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		CREF(BgL_i1155z00_17729))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_1741, (int) (((long) 3))),
																(int) (BgL_nbargsz00_17731),
																CINT(BgL_arityz00_1743));
														}
													else
														{	/* Eval/evaluate_comp.scm 788 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_1743, BgL_sz00_1735,
																BgL_argsz00_17732, BgL_bpz00_1737);
														}
												}
											{	/* Eval/evaluate_comp.scm 788 */
												obj_t BgL_z12denvz12_1753;

												BgL_z12denvz12_1753 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 788 */
													obj_t BgL_auxz00_20576;

													BgL_auxz00_20576 =
														(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17729))->
														BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_1753,
														BgL_auxz00_20576);
												}
												if (
													(((long) CINT(BgL_bpz00_1737) +
															(long) CINT(BgL_sfz00_1745)) <
														(long) (VECTOR_LENGTH(BgL_sz00_1735))))
													{	/* Eval/evaluate_comp.scm 788 */
														return BgL_runz00_1744;
													}
												else
													{	/* Eval/evaluate_comp.scm 788 */
														obj_t BgL_nsz00_1756;

														BgL_nsz00_1756 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 788 */
															long BgL_arg1810z00_1758;

															BgL_arg1810z00_1758 =
																(
																(long) CINT(BgL_bpz00_1737) +
																BgL_nbargsz00_17731);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_1756, ((long) 2), BgL_sz00_1735,
																BgL_bpz00_1737, BINT(BgL_arg1810z00_1758));
														}
														VECTOR_SET(BgL_nsz00_1756,
															(int) (((long) 1)), BgL_sz00_1735);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1753,
															BgL_nsz00_1756);
														{	/* Eval/evaluate_comp.scm 788 */
															obj_t BgL_ez00_1759;

															BgL_ez00_1759 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_1759, BgL_sz00_1735);
															{	/* Eval/evaluate_comp.scm 788 */
																obj_t BgL_____rz00_1760;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_7068;

																	BgL_savedzd2bpzd2_7068 =
																		VECTOR_REF(BgL_nsz00_1756,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_1756,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_7075;

																		BgL_fz00_7075 = BgL_runz00_1744;
																	BgL_recz00_7074:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_7076;

																			BgL_rz00_7076 =
																				PROCEDURE_ENTRY(BgL_fz00_7075)
																				(BgL_fz00_7075, BgL_nsz00_1756, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_20605;

																				if (PROCEDUREP(BgL_rz00_7076))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_7081;

																						BgL_arg1673z00_7081 =
																							PROCEDURE_ATTR(BgL_rz00_7076);
																						if (STRUCTP(BgL_arg1673z00_7081))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20605 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_7081) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20605 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_20605 = ((bool_t) 0);
																					}
																				if (BgL_testz00_20605)
																					{
																						obj_t BgL_fz00_20613;

																						BgL_fz00_20613 = BgL_rz00_7076;
																						BgL_fz00_7075 = BgL_fz00_20613;
																						goto BgL_recz00_7074;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_1756,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_7068);
																						BgL_____rz00_1760 = BgL_rz00_7076;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_1759);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1753,
																	BgL_sz00_1735);
																return BgL_____rz00_1760;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 788 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1738,
													(int) (BgL_nbargsz00_17731)))
												{	/* Eval/evaluate_comp.scm 788 */
													{	/* Eval/evaluate_comp.scm 788 */
														obj_t BgL_auxz00_20623;
														obj_t BgL_auxz00_20621;

														BgL_auxz00_20623 =
															(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17729))->
															BgL_locz00);
														BgL_auxz00_20621 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_20621,
															BgL_auxz00_20623);
													}
													return
														BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
														(BgL_sz00_1735, BgL_fz00_1738, BgL_argsz00_17732,
														BgL_bpz00_1737, BINT(BgL_nbargsz00_17731));
												}
											else
												{	/* Eval/evaluate_comp.scm 788 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17729))->
															BgL_locz00), BgL_symbzd2funzd2_17730,
														(int) (BgL_nbargsz00_17731),
														PROCEDURE_ARITY(BgL_fz00_1738));
		}}}}}}}}}
	}



/* &<anonymous:1817> */
	obj_t BGl_z62zc3anonymousza31817ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17734, obj_t BgL_sz00_17740)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 788 */
			{	/* Eval/evaluate_comp.scm 788 */
				obj_t BgL_fz00_17735;
				BgL_ev_appz00_bglt BgL_i1155z00_17736;
				obj_t BgL_symbzd2funzd2_17737;
				long BgL_nbargsz00_17738;
				obj_t BgL_argsz00_17739;

				BgL_fz00_17735 = PROCEDURE_REF(BgL_envz00_17734, (int) (((long) 0)));
				BgL_i1155z00_17736 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_17734, (int) (((long) 1))));
				BgL_symbzd2funzd2_17737 =
					PROCEDURE_REF(BgL_envz00_17734, (int) (((long) 2)));
				BgL_nbargsz00_17738 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17734, (int) (((long) 3))));
				BgL_argsz00_17739 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17734, (int) (((long) 4))));
				{
					obj_t BgL_sz00_1768;

					BgL_sz00_1768 = BgL_sz00_17740;
					{	/* Eval/evaluate_comp.scm 788 */
						obj_t BgL_bpz00_1770;

						BgL_bpz00_1770 = VECTOR_REF(BgL_sz00_1768, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 788 */
							obj_t BgL_fz00_1771;

							BgL_fz00_1771 =
								PROCEDURE_ENTRY(BgL_fz00_17735) (BgL_fz00_17735, BgL_sz00_1768,
								BEOA);
							if (PROCEDUREP(BgL_fz00_1771))
								{	/* Eval/evaluate_comp.scm 788 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 788 */
									BGl_evtypezd2errorzd2zz__everrorz00(
										(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17736))->
											BgL_locz00), BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_1771);
								}
							{	/* Eval/evaluate_comp.scm 788 */
								obj_t BgL_ufz00_1774;

								BgL_ufz00_1774 = PROCEDURE_ATTR(BgL_fz00_1771);
								{	/* Eval/evaluate_comp.scm 788 */
									bool_t BgL_testz00_20656;

									if (STRUCTP(BgL_ufz00_1774))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20656 =
												(STRUCT_KEY(BgL_ufz00_1774) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20656 = ((bool_t) 0);
										}
									if (BgL_testz00_20656)
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_arityz00_1776;
											obj_t BgL_runz00_1777;
											obj_t BgL_sfz00_1778;

											BgL_arityz00_1776 =
												STRUCT_REF(BgL_ufz00_1774, (int) (((long) 0)));
											BgL_runz00_1777 =
												STRUCT_REF(BgL_ufz00_1774, (int) (((long) 1)));
											BgL_sfz00_1778 =
												STRUCT_REF(BgL_ufz00_1774, (int) (((long) 2)));
											if (
												((long) CINT(BgL_arityz00_1776) == BgL_nbargsz00_17738))
												{
													obj_t BgL_lz00_7125;
													obj_t BgL_spz00_7126;

													{	/* Eval/evaluate_comp.scm 703 */
														bool_t BgL_auxz00_20670;

														BgL_lz00_7125 = BgL_argsz00_17739;
														BgL_spz00_7126 = BgL_bpz00_1770;
													BgL_recz00_7124:
														if (NULLP(BgL_lz00_7125))
															{	/* Eval/evaluate_comp.scm 704 */
																BgL_auxz00_20670 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 704 */
																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_arg1708z00_7133;

																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_fun1709z00_7134;

																		BgL_fun1709z00_7134 = CAR(BgL_lz00_7125);
																		BgL_arg1708z00_7133 =
																			PROCEDURE_ENTRY(BgL_fun1709z00_7134)
																			(BgL_fun1709z00_7134, BgL_sz00_1768,
																			BEOA);
																	}
																	VECTOR_SET(BgL_sz00_1768,
																		CINT(BgL_spz00_7126), BgL_arg1708z00_7133);
																}
																{	/* Eval/evaluate_comp.scm 706 */
																	obj_t BgL_arg1710z00_7135;
																	long BgL_arg1712z00_7136;

																	BgL_arg1710z00_7135 = CDR(BgL_lz00_7125);
																	BgL_arg1712z00_7136 =
																		((long) CINT(BgL_spz00_7126) + ((long) 1));
																	{
																		obj_t BgL_spz00_20684;
																		obj_t BgL_lz00_20683;

																		BgL_lz00_20683 = BgL_arg1710z00_7135;
																		BgL_spz00_20684 = BINT(BgL_arg1712z00_7136);
																		BgL_spz00_7126 = BgL_spz00_20684;
																		BgL_lz00_7125 = BgL_lz00_20683;
																		goto BgL_recz00_7124;
																	}
																}
															}
														BBOOL(BgL_auxz00_20670);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 788 */
													bool_t BgL_testz00_20687;

													if (((long) CINT(BgL_arityz00_1776) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 788 */
															BgL_testz00_20687 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 788 */
															BgL_testz00_20687 =
																(
																(long) CINT(BgL_arityz00_1776) <
																(((long) -1) - BgL_nbargsz00_17738));
														}
													if (BgL_testz00_20687)
														{	/* Eval/evaluate_comp.scm 788 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		CREF(BgL_i1155z00_17736))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_1774, (int) (((long) 3))),
																(int) (BgL_nbargsz00_17738),
																CINT(BgL_arityz00_1776));
														}
													else
														{	/* Eval/evaluate_comp.scm 788 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_1776, BgL_sz00_1768,
																BgL_argsz00_17739, BgL_bpz00_1770);
														}
												}
											{	/* Eval/evaluate_comp.scm 788 */
												obj_t BgL_z12denvz12_1786;

												BgL_z12denvz12_1786 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_1770) +
															(long) CINT(BgL_sfz00_1778)) <
														(long) (VECTOR_LENGTH(BgL_sz00_1768))))
													{	/* Eval/evaluate_comp.scm 788 */
														return BgL_runz00_1777;
													}
												else
													{	/* Eval/evaluate_comp.scm 788 */
														obj_t BgL_nsz00_1788;

														BgL_nsz00_1788 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 788 */
															long BgL_arg1829z00_1790;

															BgL_arg1829z00_1790 =
																(
																(long) CINT(BgL_bpz00_1770) +
																BgL_nbargsz00_17738);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_1788, ((long) 2), BgL_sz00_1768,
																BgL_bpz00_1770, BINT(BgL_arg1829z00_1790));
														}
														VECTOR_SET(BgL_nsz00_1788,
															(int) (((long) 1)), BgL_sz00_1768);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1786,
															BgL_nsz00_1788);
														{	/* Eval/evaluate_comp.scm 788 */
															obj_t BgL_ez00_1791;

															BgL_ez00_1791 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_1791, BgL_sz00_1768);
															{	/* Eval/evaluate_comp.scm 788 */
																obj_t BgL_____rz00_1792;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_7182;

																	BgL_savedzd2bpzd2_7182 =
																		VECTOR_REF(BgL_nsz00_1788,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_1788,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_7189;

																		BgL_fz00_7189 = BgL_runz00_1777;
																	BgL_recz00_7188:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_7190;

																			BgL_rz00_7190 =
																				PROCEDURE_ENTRY(BgL_fz00_7189)
																				(BgL_fz00_7189, BgL_nsz00_1788, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_20728;

																				if (PROCEDUREP(BgL_rz00_7190))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_7195;

																						BgL_arg1673z00_7195 =
																							PROCEDURE_ATTR(BgL_rz00_7190);
																						if (STRUCTP(BgL_arg1673z00_7195))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20728 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_7195) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20728 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_20728 = ((bool_t) 0);
																					}
																				if (BgL_testz00_20728)
																					{
																						obj_t BgL_fz00_20736;

																						BgL_fz00_20736 = BgL_rz00_7190;
																						BgL_fz00_7189 = BgL_fz00_20736;
																						goto BgL_recz00_7188;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_1788,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_7182);
																						BgL_____rz00_1792 = BgL_rz00_7190;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_1791);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1786,
																	BgL_sz00_1768);
																return BgL_____rz00_1792;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 788 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1771,
													(int) (BgL_nbargsz00_17738)))
												{	/* Eval/evaluate_comp.scm 788 */
													return
														BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
														(BgL_sz00_1768, BgL_fz00_1771, BgL_argsz00_17739,
														BgL_bpz00_1770, BINT(BgL_nbargsz00_17738));
												}
											else
												{	/* Eval/evaluate_comp.scm 788 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17736))->
															BgL_locz00), BgL_symbzd2funzd2_17737,
														(int) (BgL_nbargsz00_17738),
														PROCEDURE_ARITY(BgL_fz00_1771));
		}}}}}}}}}
	}



/* &<anonymous:1837> */
	obj_t BGl_z62zc3anonymousza31837ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17741, obj_t BgL_sz00_17748)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 774 */
			{	/* Eval/evaluate_comp.scm 774 */
				obj_t BgL_fz00_17742;
				BgL_ev_appz00_bglt BgL_i1155z00_17743;
				obj_t BgL_symbzd2funzd2_17744;
				long BgL_nbargsz00_17745;
				obj_t BgL_argsz00_17746;
				long BgL_siza7eza7_17747;

				BgL_fz00_17742 = PROCEDURE_REF(BgL_envz00_17741, (int) (((long) 0)));
				BgL_i1155z00_17743 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_17741, (int) (((long) 1))));
				BgL_symbzd2funzd2_17744 =
					PROCEDURE_REF(BgL_envz00_17741, (int) (((long) 2)));
				BgL_nbargsz00_17745 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17741, (int) (((long) 3))));
				BgL_argsz00_17746 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17741, (int) (((long) 4))));
				BgL_siza7eza7_17747 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17741, (int) (((long) 5))));
				{
					obj_t BgL_sz00_1801;

					BgL_sz00_1801 = BgL_sz00_17748;
					{	/* Eval/evaluate_comp.scm 774 */
						obj_t BgL_bpz00_1803;

						BgL_bpz00_1803 = VECTOR_REF(BgL_sz00_1801, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 774 */
							obj_t BgL_fz00_1804;

							BgL_fz00_1804 =
								PROCEDURE_ENTRY(BgL_fz00_17742) (BgL_fz00_17742, BgL_sz00_1801,
								BEOA);
							if (PROCEDUREP(BgL_fz00_1804))
								{	/* Eval/evaluate_comp.scm 774 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 774 */
									BGl_evtypezd2errorzd2zz__everrorz00(
										(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17743))->
											BgL_locz00), BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_1804);
								}
							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_ufz00_1807;

								BgL_ufz00_1807 = PROCEDURE_ATTR(BgL_fz00_1804);
								{	/* Eval/evaluate_comp.scm 774 */
									bool_t BgL_testz00_20777;

									if (STRUCTP(BgL_ufz00_1807))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20777 =
												(STRUCT_KEY(BgL_ufz00_1807) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20777 = ((bool_t) 0);
										}
									if (BgL_testz00_20777)
										{	/* Eval/evaluate_comp.scm 774 */
											obj_t BgL_arityz00_1809;
											obj_t BgL_runz00_1810;
											obj_t BgL_sfz00_1811;

											BgL_arityz00_1809 =
												STRUCT_REF(BgL_ufz00_1807, (int) (((long) 0)));
											BgL_runz00_1810 =
												STRUCT_REF(BgL_ufz00_1807, (int) (((long) 1)));
											BgL_sfz00_1811 =
												STRUCT_REF(BgL_ufz00_1807, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 774 */
												long BgL_spz00_1812;

												BgL_spz00_1812 =
													((long) CINT(BgL_bpz00_1803) + BgL_siza7eza7_17747);
												if (
													((long) CINT(BgL_arityz00_1809) ==
														BgL_nbargsz00_17745))
													{
														obj_t BgL_lz00_7238;
														long BgL_spz00_7239;

														{	/* Eval/evaluate_comp.scm 703 */
															bool_t BgL_auxz00_20793;

															BgL_lz00_7238 = BgL_argsz00_17746;
															BgL_spz00_7239 = BgL_spz00_1812;
														BgL_recz00_7237:
															if (NULLP(BgL_lz00_7238))
																{	/* Eval/evaluate_comp.scm 704 */
																	BgL_auxz00_20793 = ((bool_t) 0);
																}
															else
																{	/* Eval/evaluate_comp.scm 704 */
																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_arg1708z00_7246;

																		{	/* Eval/evaluate_comp.scm 705 */
																			obj_t BgL_fun1709z00_7247;

																			BgL_fun1709z00_7247 = CAR(BgL_lz00_7238);
																			BgL_arg1708z00_7246 =
																				PROCEDURE_ENTRY(BgL_fun1709z00_7247)
																				(BgL_fun1709z00_7247, BgL_sz00_1801,
																				BEOA);
																		}
																		VECTOR_SET(BgL_sz00_1801,
																			(int) (BgL_spz00_7239),
																			BgL_arg1708z00_7246);
																	}
																	{
																		long BgL_spz00_20805;
																		obj_t BgL_lz00_20803;

																		BgL_lz00_20803 = CDR(BgL_lz00_7238);
																		BgL_spz00_20805 =
																			(BgL_spz00_7239 + ((long) 1));
																		BgL_spz00_7239 = BgL_spz00_20805;
																		BgL_lz00_7238 = BgL_lz00_20803;
																		goto BgL_recz00_7237;
																	}
																}
															BBOOL(BgL_auxz00_20793);
														}
													}
												else
													{	/* Eval/evaluate_comp.scm 774 */
														bool_t BgL_testz00_20808;

														if (((long) CINT(BgL_arityz00_1809) >= ((long) 0)))
															{	/* Eval/evaluate_comp.scm 774 */
																BgL_testz00_20808 = ((bool_t) 1);
															}
														else
															{	/* Eval/evaluate_comp.scm 774 */
																BgL_testz00_20808 =
																	(
																	(long) CINT(BgL_arityz00_1809) <
																	(((long) -1) - BgL_nbargsz00_17745));
															}
														if (BgL_testz00_20808)
															{	/* Eval/evaluate_comp.scm 774 */
																BGl_evarityzd2errorzd2zz__everrorz00(
																	(((BgL_ev_appz00_bglt)
																			CREF(BgL_i1155z00_17743))->BgL_locz00),
																	STRUCT_REF(BgL_ufz00_1807,
																		(int) (((long) 3))),
																	(int) (BgL_nbargsz00_17745),
																	CINT(BgL_arityz00_1809));
															}
														else
															{	/* Eval/evaluate_comp.scm 774 */
																BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																	(BgL_arityz00_1809, BgL_sz00_1801,
																	BgL_argsz00_17746, BINT(BgL_spz00_1812));
															}
													}
												{	/* Eval/evaluate_comp.scm 774 */
													obj_t BgL_z12denvz12_1819;

													BgL_z12denvz12_1819 = BGL_CURRENT_DYNAMIC_ENV();
													{	/* Eval/evaluate_comp.scm 774 */
														obj_t BgL_auxz00_20824;

														BgL_auxz00_20824 =
															(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17743))->
															BgL_locz00);
														BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_1819,
															BgL_auxz00_20824);
													}
													if (
														((BgL_spz00_1812 +
																(long) CINT(BgL_sfz00_1811)) <
															(long) (VECTOR_LENGTH(BgL_sz00_1801))))
														{	/* Eval/evaluate_comp.scm 774 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_1810, BgL_sz00_1801,
																BINT(BgL_spz00_1812));
														}
													else
														{	/* Eval/evaluate_comp.scm 774 */
															obj_t BgL_nsz00_1822;

															BgL_nsz00_1822 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 774 */
																long BgL_arg1850z00_1824;

																BgL_arg1850z00_1824 =
																	(BgL_spz00_1812 + BgL_nbargsz00_17745);
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1822, ((long) 2), BgL_sz00_1801,
																	BINT(BgL_spz00_1812),
																	BINT(BgL_arg1850z00_1824));
															}
															VECTOR_SET(BgL_nsz00_1822,
																(int) (((long) 1)), BgL_sz00_1801);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1819,
																BgL_nsz00_1822);
															{	/* Eval/evaluate_comp.scm 774 */
																obj_t BgL_ez00_1825;

																BgL_ez00_1825 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_1825, BgL_sz00_1801);
																{	/* Eval/evaluate_comp.scm 774 */
																	obj_t BgL_____rz00_1826;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_7294;

																		BgL_savedzd2bpzd2_7294 =
																			VECTOR_REF(BgL_nsz00_1822,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_1822,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_7301;

																			BgL_fz00_7301 = BgL_runz00_1810;
																		BgL_recz00_7300:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_7302;

																				BgL_rz00_7302 =
																					PROCEDURE_ENTRY(BgL_fz00_7301)
																					(BgL_fz00_7301, BgL_nsz00_1822, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_20854;

																					if (PROCEDUREP(BgL_rz00_7302))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_7307;

																							BgL_arg1673z00_7307 =
																								PROCEDURE_ATTR(BgL_rz00_7302);
																							if (STRUCTP(BgL_arg1673z00_7307))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_20854 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_7307) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_20854 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_20854 = ((bool_t) 0);
																						}
																					if (BgL_testz00_20854)
																						{
																							obj_t BgL_fz00_20862;

																							BgL_fz00_20862 = BgL_rz00_7302;
																							BgL_fz00_7301 = BgL_fz00_20862;
																							goto BgL_recz00_7300;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_1822,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_7294);
																							BgL_____rz00_1826 = BgL_rz00_7302;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_1825);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1819,
																		BgL_sz00_1801);
																	return BgL_____rz00_1826;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 774 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1804,
													(int) (BgL_nbargsz00_17745)))
												{	/* Eval/evaluate_comp.scm 774 */
													{	/* Eval/evaluate_comp.scm 774 */
														obj_t BgL_auxz00_20872;
														obj_t BgL_auxz00_20870;

														BgL_auxz00_20872 =
															(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17743))->
															BgL_locz00);
														BgL_auxz00_20870 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_20870,
															BgL_auxz00_20872);
													}
													return
														BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
														(BgL_sz00_1801, BgL_fz00_1804, BgL_argsz00_17746,
														BgL_bpz00_1803, BINT(BgL_siza7eza7_17747));
												}
											else
												{	/* Eval/evaluate_comp.scm 774 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17743))->
															BgL_locz00), BgL_symbzd2funzd2_17744,
														(int) (BgL_nbargsz00_17745),
														PROCEDURE_ARITY(BgL_fz00_1804));
		}}}}}}}}}
	}



/* &<anonymous:1858> */
	obj_t BGl_z62zc3anonymousza31858ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17749, obj_t BgL_sz00_17756)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 774 */
			{	/* Eval/evaluate_comp.scm 774 */
				obj_t BgL_fz00_17750;
				BgL_ev_appz00_bglt BgL_i1155z00_17751;
				obj_t BgL_symbzd2funzd2_17752;
				long BgL_nbargsz00_17753;
				obj_t BgL_argsz00_17754;
				long BgL_siza7eza7_17755;

				BgL_fz00_17750 = PROCEDURE_REF(BgL_envz00_17749, (int) (((long) 0)));
				BgL_i1155z00_17751 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_17749, (int) (((long) 1))));
				BgL_symbzd2funzd2_17752 =
					PROCEDURE_REF(BgL_envz00_17749, (int) (((long) 2)));
				BgL_nbargsz00_17753 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17749, (int) (((long) 3))));
				BgL_argsz00_17754 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17749, (int) (((long) 4))));
				BgL_siza7eza7_17755 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17749, (int) (((long) 5))));
				{
					obj_t BgL_sz00_1834;

					BgL_sz00_1834 = BgL_sz00_17756;
					{	/* Eval/evaluate_comp.scm 774 */
						obj_t BgL_bpz00_1836;

						BgL_bpz00_1836 = VECTOR_REF(BgL_sz00_1834, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 774 */
							obj_t BgL_fz00_1837;

							BgL_fz00_1837 =
								PROCEDURE_ENTRY(BgL_fz00_17750) (BgL_fz00_17750, BgL_sz00_1834,
								BEOA);
							if (PROCEDUREP(BgL_fz00_1837))
								{	/* Eval/evaluate_comp.scm 774 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 774 */
									BGl_evtypezd2errorzd2zz__everrorz00(
										(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17751))->
											BgL_locz00), BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_1837);
								}
							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_ufz00_1840;

								BgL_ufz00_1840 = PROCEDURE_ATTR(BgL_fz00_1837);
								{	/* Eval/evaluate_comp.scm 774 */
									bool_t BgL_testz00_20908;

									if (STRUCTP(BgL_ufz00_1840))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20908 =
												(STRUCT_KEY(BgL_ufz00_1840) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_20908 = ((bool_t) 0);
										}
									if (BgL_testz00_20908)
										{	/* Eval/evaluate_comp.scm 774 */
											obj_t BgL_arityz00_1842;
											obj_t BgL_runz00_1843;
											obj_t BgL_sfz00_1844;

											BgL_arityz00_1842 =
												STRUCT_REF(BgL_ufz00_1840, (int) (((long) 0)));
											BgL_runz00_1843 =
												STRUCT_REF(BgL_ufz00_1840, (int) (((long) 1)));
											BgL_sfz00_1844 =
												STRUCT_REF(BgL_ufz00_1840, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 774 */
												long BgL_spz00_1845;

												BgL_spz00_1845 =
													((long) CINT(BgL_bpz00_1836) + BgL_siza7eza7_17755);
												if (
													((long) CINT(BgL_arityz00_1842) ==
														BgL_nbargsz00_17753))
													{
														obj_t BgL_lz00_7351;
														long BgL_spz00_7352;

														{	/* Eval/evaluate_comp.scm 703 */
															bool_t BgL_auxz00_20924;

															BgL_lz00_7351 = BgL_argsz00_17754;
															BgL_spz00_7352 = BgL_spz00_1845;
														BgL_recz00_7350:
															if (NULLP(BgL_lz00_7351))
																{	/* Eval/evaluate_comp.scm 704 */
																	BgL_auxz00_20924 = ((bool_t) 0);
																}
															else
																{	/* Eval/evaluate_comp.scm 704 */
																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_arg1708z00_7359;

																		{	/* Eval/evaluate_comp.scm 705 */
																			obj_t BgL_fun1709z00_7360;

																			BgL_fun1709z00_7360 = CAR(BgL_lz00_7351);
																			BgL_arg1708z00_7359 =
																				PROCEDURE_ENTRY(BgL_fun1709z00_7360)
																				(BgL_fun1709z00_7360, BgL_sz00_1834,
																				BEOA);
																		}
																		VECTOR_SET(BgL_sz00_1834,
																			(int) (BgL_spz00_7352),
																			BgL_arg1708z00_7359);
																	}
																	{
																		long BgL_spz00_20936;
																		obj_t BgL_lz00_20934;

																		BgL_lz00_20934 = CDR(BgL_lz00_7351);
																		BgL_spz00_20936 =
																			(BgL_spz00_7352 + ((long) 1));
																		BgL_spz00_7352 = BgL_spz00_20936;
																		BgL_lz00_7351 = BgL_lz00_20934;
																		goto BgL_recz00_7350;
																	}
																}
															BBOOL(BgL_auxz00_20924);
														}
													}
												else
													{	/* Eval/evaluate_comp.scm 774 */
														bool_t BgL_testz00_20939;

														if (((long) CINT(BgL_arityz00_1842) >= ((long) 0)))
															{	/* Eval/evaluate_comp.scm 774 */
																BgL_testz00_20939 = ((bool_t) 1);
															}
														else
															{	/* Eval/evaluate_comp.scm 774 */
																BgL_testz00_20939 =
																	(
																	(long) CINT(BgL_arityz00_1842) <
																	(((long) -1) - BgL_nbargsz00_17753));
															}
														if (BgL_testz00_20939)
															{	/* Eval/evaluate_comp.scm 774 */
																BGl_evarityzd2errorzd2zz__everrorz00(
																	(((BgL_ev_appz00_bglt)
																			CREF(BgL_i1155z00_17751))->BgL_locz00),
																	STRUCT_REF(BgL_ufz00_1840,
																		(int) (((long) 3))),
																	(int) (BgL_nbargsz00_17753),
																	CINT(BgL_arityz00_1842));
															}
														else
															{	/* Eval/evaluate_comp.scm 774 */
																BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																	(BgL_arityz00_1842, BgL_sz00_1834,
																	BgL_argsz00_17754, BINT(BgL_spz00_1845));
															}
													}
												{	/* Eval/evaluate_comp.scm 774 */
													obj_t BgL_z12denvz12_1852;

													BgL_z12denvz12_1852 = BGL_CURRENT_DYNAMIC_ENV();
													if (
														((BgL_spz00_1845 +
																(long) CINT(BgL_sfz00_1844)) <
															(long) (VECTOR_LENGTH(BgL_sz00_1834))))
														{	/* Eval/evaluate_comp.scm 774 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_1843, BgL_sz00_1834,
																BINT(BgL_spz00_1845));
														}
													else
														{	/* Eval/evaluate_comp.scm 774 */
															obj_t BgL_nsz00_1854;

															BgL_nsz00_1854 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 774 */
																long BgL_arg1869z00_1856;

																BgL_arg1869z00_1856 =
																	(BgL_spz00_1845 + BgL_nbargsz00_17753);
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1854, ((long) 2), BgL_sz00_1834,
																	BINT(BgL_spz00_1845),
																	BINT(BgL_arg1869z00_1856));
															}
															VECTOR_SET(BgL_nsz00_1854,
																(int) (((long) 1)), BgL_sz00_1834);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1852,
																BgL_nsz00_1854);
															{	/* Eval/evaluate_comp.scm 774 */
																obj_t BgL_ez00_1857;

																BgL_ez00_1857 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_1857, BgL_sz00_1834);
																{	/* Eval/evaluate_comp.scm 774 */
																	obj_t BgL_____rz00_1858;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_7407;

																		BgL_savedzd2bpzd2_7407 =
																			VECTOR_REF(BgL_nsz00_1854,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_1854,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_7414;

																			BgL_fz00_7414 = BgL_runz00_1843;
																		BgL_recz00_7413:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_7415;

																				BgL_rz00_7415 =
																					PROCEDURE_ENTRY(BgL_fz00_7414)
																					(BgL_fz00_7414, BgL_nsz00_1854, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_20982;

																					if (PROCEDUREP(BgL_rz00_7415))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_7420;

																							BgL_arg1673z00_7420 =
																								PROCEDURE_ATTR(BgL_rz00_7415);
																							if (STRUCTP(BgL_arg1673z00_7420))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_20982 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_7420) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_20982 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_20982 = ((bool_t) 0);
																						}
																					if (BgL_testz00_20982)
																						{
																							obj_t BgL_fz00_20990;

																							BgL_fz00_20990 = BgL_rz00_7415;
																							BgL_fz00_7414 = BgL_fz00_20990;
																							goto BgL_recz00_7413;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_1854,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_7407);
																							BgL_____rz00_1858 = BgL_rz00_7415;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_1857);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1852,
																		BgL_sz00_1834);
																	return BgL_____rz00_1858;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 774 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1837,
													(int) (BgL_nbargsz00_17753)))
												{	/* Eval/evaluate_comp.scm 774 */
													return
														BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
														(BgL_sz00_1834, BgL_fz00_1837, BgL_argsz00_17754,
														BgL_bpz00_1836, BINT(BgL_siza7eza7_17755));
												}
											else
												{	/* Eval/evaluate_comp.scm 774 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_i1155z00_17751))->
															BgL_locz00), BgL_symbzd2funzd2_17752,
														(int) (BgL_nbargsz00_17753),
														PROCEDURE_ARITY(BgL_fz00_1837));
		}}}}}}}}}
	}



/* comp-call0 */
	obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138,
		BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140,
		obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143,
		long BgL_siza7eza7_144)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_1867;

				BgL_cfunz00_1867 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139,
					((long) 0), BgL_locz00_138, BgL_symbzd2funzd2_140);
				if (CBOOL(BgL_cfunz00_1867))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_testz00_21007;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg1882z00_1880;

							BgL_arg1882z00_1880 = bgl_debug();
							BgL_testz00_21007 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1882z00_1880),
								BINT(((long) 0)));
						}
						if (BgL_testz00_21007)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza31879ze3z83_17757;

								BgL_zc3anonymousza31879ze3z83_17757 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza31879ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3anonymousza31879ze3z83_17757,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3anonymousza31879ze3z83_17757,
									(int) (((long) 1)), BgL_locz00_138);
								PROCEDURE_SET(BgL_zc3anonymousza31879ze3z83_17757,
									(int) (((long) 2)), BgL_cfunz00_1867);
								return BgL_zc3anonymousza31879ze3z83_17757;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza31881ze3z83_17758;

								BgL_zc3anonymousza31881ze3z83_17758 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza31881ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_zc3anonymousza31881ze3z83_17758,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3anonymousza31881ze3z83_17758,
									(int) (((long) 1)), BgL_cfunz00_1867);
								return BgL_zc3anonymousza31881ze3z83_17758;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_142))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21032;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg1912z00_1943;

									BgL_arg1912z00_1943 = bgl_debug();
									BgL_testz00_21032 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1912z00_1943),
										BINT(((long) 0)));
								}
								if (BgL_testz00_21032)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31884ze3z83_17759;

										BgL_zc3anonymousza31884ze3z83_17759 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31884ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3anonymousza31884ze3z83_17759,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3anonymousza31884ze3z83_17759,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3anonymousza31884ze3z83_17759,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3anonymousza31884ze3z83_17759,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3anonymousza31884ze3z83_17759;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31898ze3z83_17760;

										BgL_zc3anonymousza31898ze3z83_17760 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31898ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3anonymousza31898ze3z83_17760,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3anonymousza31898ze3z83_17760,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3anonymousza31898ze3z83_17760,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3anonymousza31898ze3z83_17760,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3anonymousza31898ze3z83_17760;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21061;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg1944z00_2006;

									BgL_arg1944z00_2006 = bgl_debug();
									BgL_testz00_21061 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1944z00_2006),
										BINT(((long) 0)));
								}
								if (BgL_testz00_21061)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31914ze3z83_17761;

										BgL_zc3anonymousza31914ze3z83_17761 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31914ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3anonymousza31914ze3z83_17761,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3anonymousza31914ze3z83_17761,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3anonymousza31914ze3z83_17761,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3anonymousza31914ze3z83_17761,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3anonymousza31914ze3z83_17761;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31928ze3z83_17762;

										BgL_zc3anonymousza31928ze3z83_17762 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31928ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3anonymousza31928ze3z83_17762,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3anonymousza31928ze3z83_17762,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3anonymousza31928ze3z83_17762,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3anonymousza31928ze3z83_17762,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3anonymousza31928ze3z83_17762;
									}
							}
					}
			}
		}
	}



/* &<anonymous:1879> */
	obj_t BGl_z62zc3anonymousza31879ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17763, obj_t BgL_sz00_17767)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				long BgL_siza7eza7_17764;
				obj_t BgL_locz00_17765;
				obj_t BgL_cfunz00_17766;

				BgL_siza7eza7_17764 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17763, (int) (((long) 0))));
				BgL_locz00_17765 = PROCEDURE_REF(BgL_envz00_17763, (int) (((long) 1)));
				BgL_cfunz00_17766 = PROCEDURE_REF(BgL_envz00_17763, (int) (((long) 2)));
				{
					obj_t BgL_sz00_1869;

					BgL_sz00_1869 = BgL_sz00_17767;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_1871;

						BgL_bpz00_1871 = VECTOR_REF(BgL_sz00_1869, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */

							{	/* Eval/evaluate_comp.scm 889 */
								long BgL_nbpz00_1872;

								BgL_nbpz00_1872 =
									((long) CINT(BgL_bpz00_1871) + BgL_siza7eza7_17764);
								VECTOR_SET(BgL_sz00_1869,
									(int) (((long) 0)), BINT(BgL_nbpz00_1872));
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_auxz00_21104;

									BgL_auxz00_21104 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_21104,
										BgL_locz00_17765);
								}
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_rz00_1874;

									BgL_rz00_1874 =
										PROCEDURE_ENTRY(BgL_cfunz00_17766) (BgL_cfunz00_17766,
										BEOA);
									VECTOR_SET(BgL_sz00_1869, (int) (((long) 0)), BgL_bpz00_1871);
									return BgL_rz00_1874;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:1881> */
	obj_t BGl_z62zc3anonymousza31881ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17768, obj_t BgL_sz00_17771)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				long BgL_siza7eza7_17769;
				obj_t BgL_cfunz00_17770;

				BgL_siza7eza7_17769 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17768, (int) (((long) 0))));
				BgL_cfunz00_17770 = PROCEDURE_REF(BgL_envz00_17768, (int) (((long) 1)));
				{
					obj_t BgL_sz00_1875;

					BgL_sz00_1875 = BgL_sz00_17771;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_1877;

						BgL_bpz00_1877 = VECTOR_REF(BgL_sz00_1875, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */

							{	/* Eval/evaluate_comp.scm 889 */
								long BgL_nbpz00_1878;

								BgL_nbpz00_1878 =
									((long) CINT(BgL_bpz00_1877) + BgL_siza7eza7_17769);
								VECTOR_SET(BgL_sz00_1875,
									(int) (((long) 0)), BINT(BgL_nbpz00_1878));
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_rz00_1879;

									BgL_rz00_1879 =
										PROCEDURE_ENTRY(BgL_cfunz00_17770) (BgL_cfunz00_17770,
										BEOA);
									VECTOR_SET(BgL_sz00_1875, (int) (((long) 0)), BgL_bpz00_1877);
									return BgL_rz00_1879;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:1884> */
	obj_t BGl_z62zc3anonymousza31884ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17772, obj_t BgL_sz00_17777)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17773;
				obj_t BgL_locz00_17774;
				obj_t BgL_symbzd2funzd2_17775;
				long BgL_siza7eza7_17776;

				BgL_funz00_17773 = PROCEDURE_REF(BgL_envz00_17772, (int) (((long) 0)));
				BgL_locz00_17774 = PROCEDURE_REF(BgL_envz00_17772, (int) (((long) 1)));
				BgL_symbzd2funzd2_17775 =
					PROCEDURE_REF(BgL_envz00_17772, (int) (((long) 2)));
				BgL_siza7eza7_17776 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17772, (int) (((long) 3))));
				{
					obj_t BgL_sz00_1882;

					BgL_sz00_1882 = BgL_sz00_17777;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_1884;

						BgL_bpz00_1884 = VECTOR_REF(BgL_sz00_1882, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_1885;

							BgL_fz00_1885 =
								PROCEDURE_ENTRY(BgL_funz00_17773) (BgL_funz00_17773,
								BgL_sz00_1882, BEOA);
							if (PROCEDUREP(BgL_fz00_1885))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17774,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_1885);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_1887;

								BgL_ufz00_1887 = PROCEDURE_ATTR(BgL_fz00_1885);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_21148;

									if (STRUCTP(BgL_ufz00_1887))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21148 =
												(STRUCT_KEY(BgL_ufz00_1887) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21148 = ((bool_t) 0);
										}
									if (BgL_testz00_21148)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_1889;
											obj_t BgL_runz00_1890;
											obj_t BgL_sfz00_1891;

											BgL_arityz00_1889 =
												STRUCT_REF(BgL_ufz00_1887, (int) (((long) 0)));
											BgL_runz00_1890 =
												STRUCT_REF(BgL_ufz00_1887, (int) (((long) 1)));
											BgL_sfz00_1891 =
												STRUCT_REF(BgL_ufz00_1887, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_1889) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 889 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_1889))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_1889))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1889z00_1897;

																		BgL_arg1889z00_1897 =
																			(
																			(long) CINT(BgL_bpz00_1884) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1882,
																			(int) (BgL_arg1889z00_1897), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_17774,
																		STRUCT_REF(BgL_ufz00_1887,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_1889));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_17774, STRUCT_REF(BgL_ufz00_1887,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_1889));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_1901;

												BgL_z12denvz12_1901 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_1901,
													BgL_locz00_17774);
												if ((((long) CINT(BgL_bpz00_1884) +
															(long) CINT(BgL_sfz00_1891)) <
														(long) (VECTOR_LENGTH(BgL_sz00_1882))))
													{	/* Eval/evaluate_comp.scm 889 */
														return BgL_runz00_1890;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_1903;

														BgL_nsz00_1903 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg1894z00_1905;

															BgL_arg1894z00_1905 =
																((long) CINT(BgL_bpz00_1884) + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_1903, ((long) 2), BgL_sz00_1882,
																BgL_bpz00_1884, BINT(BgL_arg1894z00_1905));
														}
														VECTOR_SET(BgL_nsz00_1903,
															(int) (((long) 1)), BgL_sz00_1882);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1901,
															BgL_nsz00_1903);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_1906;

															BgL_ez00_1906 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_1906, BgL_sz00_1882);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_1907;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_7525;

																	BgL_savedzd2bpzd2_7525 =
																		VECTOR_REF(BgL_nsz00_1903,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_1903,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_7532;

																		BgL_fz00_7532 = BgL_runz00_1890;
																	BgL_recz00_7531:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_7533;

																			BgL_rz00_7533 =
																				PROCEDURE_ENTRY(BgL_fz00_7532)
																				(BgL_fz00_7532, BgL_nsz00_1903, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_21208;

																				if (PROCEDUREP(BgL_rz00_7533))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_7538;

																						BgL_arg1673z00_7538 =
																							PROCEDURE_ATTR(BgL_rz00_7533);
																						if (STRUCTP(BgL_arg1673z00_7538))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21208 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_7538) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21208 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_21208 = ((bool_t) 0);
																					}
																				if (BgL_testz00_21208)
																					{
																						obj_t BgL_fz00_21216;

																						BgL_fz00_21216 = BgL_rz00_7533;
																						BgL_fz00_7532 = BgL_fz00_21216;
																						goto BgL_recz00_7531;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_1903,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_7525);
																						BgL_____rz00_1907 = BgL_rz00_7533;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_1906);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1901,
																	BgL_sz00_1882);
																return BgL_____rz00_1907;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1885,
													(int) (((long) 0))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_1909;

													BgL_nbpz00_1909 =
														((long) CINT(BgL_bpz00_1884) + BgL_siza7eza7_17776);
													VECTOR_SET(BgL_sz00_1882,
														(int) (((long) 0)), BINT(BgL_nbpz00_1909));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_auxz00_21229;

														BgL_auxz00_21229 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_21229,
															BgL_locz00_17774);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_1911;

														BgL_rz00_1911 =
															PROCEDURE_ENTRY(BgL_fz00_1885) (BgL_fz00_1885,
															BEOA);
														VECTOR_SET(BgL_sz00_1882, (int) (((long) 0)),
															BgL_bpz00_1884);
														return BgL_rz00_1911;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17774, BgL_symbzd2funzd2_17775,
														(int) (((long) 0)), PROCEDURE_ARITY(BgL_fz00_1885));
		}}}}}}}}}
	}



/* &<anonymous:1898> */
	obj_t BGl_z62zc3anonymousza31898ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17778, obj_t BgL_sz00_17783)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17779;
				obj_t BgL_locz00_17780;
				obj_t BgL_symbzd2funzd2_17781;
				long BgL_siza7eza7_17782;

				BgL_funz00_17779 = PROCEDURE_REF(BgL_envz00_17778, (int) (((long) 0)));
				BgL_locz00_17780 = PROCEDURE_REF(BgL_envz00_17778, (int) (((long) 1)));
				BgL_symbzd2funzd2_17781 =
					PROCEDURE_REF(BgL_envz00_17778, (int) (((long) 2)));
				BgL_siza7eza7_17782 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17778, (int) (((long) 3))));
				{
					obj_t BgL_sz00_1913;

					BgL_sz00_1913 = BgL_sz00_17783;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_1915;

						BgL_bpz00_1915 = VECTOR_REF(BgL_sz00_1913, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_1916;

							BgL_fz00_1916 =
								PROCEDURE_ENTRY(BgL_funz00_17779) (BgL_funz00_17779,
								BgL_sz00_1913, BEOA);
							if (PROCEDUREP(BgL_fz00_1916))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17780,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_1916);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_1918;

								BgL_ufz00_1918 = PROCEDURE_ATTR(BgL_fz00_1916);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_21259;

									if (STRUCTP(BgL_ufz00_1918))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21259 =
												(STRUCT_KEY(BgL_ufz00_1918) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21259 = ((bool_t) 0);
										}
									if (BgL_testz00_21259)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_1920;
											obj_t BgL_runz00_1921;
											obj_t BgL_sfz00_1922;

											BgL_arityz00_1920 =
												STRUCT_REF(BgL_ufz00_1918, (int) (((long) 0)));
											BgL_runz00_1921 =
												STRUCT_REF(BgL_ufz00_1918, (int) (((long) 1)));
											BgL_sfz00_1922 =
												STRUCT_REF(BgL_ufz00_1918, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_1920) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 889 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_1920))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_1920))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1903z00_1928;

																		BgL_arg1903z00_1928 =
																			(
																			(long) CINT(BgL_bpz00_1915) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1913,
																			(int) (BgL_arg1903z00_1928), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_17780,
																		STRUCT_REF(BgL_ufz00_1918,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_1920));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_17780, STRUCT_REF(BgL_ufz00_1918,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_1920));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_1932;

												BgL_z12denvz12_1932 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_1915) +
															(long) CINT(BgL_sfz00_1922)) <
														(long) (VECTOR_LENGTH(BgL_sz00_1913))))
													{	/* Eval/evaluate_comp.scm 889 */
														return BgL_runz00_1921;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_1934;

														BgL_nsz00_1934 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg1908z00_1936;

															BgL_arg1908z00_1936 =
																((long) CINT(BgL_bpz00_1915) + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_1934, ((long) 2), BgL_sz00_1913,
																BgL_bpz00_1915, BINT(BgL_arg1908z00_1936));
														}
														VECTOR_SET(BgL_nsz00_1934,
															(int) (((long) 1)), BgL_sz00_1913);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1932,
															BgL_nsz00_1934);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_1937;

															BgL_ez00_1937 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_1937, BgL_sz00_1913);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_1938;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_7630;

																	BgL_savedzd2bpzd2_7630 =
																		VECTOR_REF(BgL_nsz00_1934,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_1934,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_7637;

																		BgL_fz00_7637 = BgL_runz00_1921;
																	BgL_recz00_7636:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_7638;

																			BgL_rz00_7638 =
																				PROCEDURE_ENTRY(BgL_fz00_7637)
																				(BgL_fz00_7637, BgL_nsz00_1934, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_21318;

																				if (PROCEDUREP(BgL_rz00_7638))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_7643;

																						BgL_arg1673z00_7643 =
																							PROCEDURE_ATTR(BgL_rz00_7638);
																						if (STRUCTP(BgL_arg1673z00_7643))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21318 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_7643) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21318 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_21318 = ((bool_t) 0);
																					}
																				if (BgL_testz00_21318)
																					{
																						obj_t BgL_fz00_21326;

																						BgL_fz00_21326 = BgL_rz00_7638;
																						BgL_fz00_7637 = BgL_fz00_21326;
																						goto BgL_recz00_7636;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_1934,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_7630);
																						BgL_____rz00_1938 = BgL_rz00_7638;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_1937);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1932,
																	BgL_sz00_1913);
																return BgL_____rz00_1938;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1916,
													(int) (((long) 0))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_1940;

													BgL_nbpz00_1940 =
														((long) CINT(BgL_bpz00_1915) + BgL_siza7eza7_17782);
													VECTOR_SET(BgL_sz00_1913,
														(int) (((long) 0)), BINT(BgL_nbpz00_1940));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_1941;

														BgL_rz00_1941 =
															PROCEDURE_ENTRY(BgL_fz00_1916) (BgL_fz00_1916,
															BEOA);
														VECTOR_SET(BgL_sz00_1913, (int) (((long) 0)),
															BgL_bpz00_1915);
														return BgL_rz00_1941;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17780, BgL_symbzd2funzd2_17781,
														(int) (((long) 0)), PROCEDURE_ARITY(BgL_fz00_1916));
		}}}}}}}}}
	}



/* &<anonymous:1914> */
	obj_t BGl_z62zc3anonymousza31914ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17784, obj_t BgL_sz00_17789)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17785;
				obj_t BgL_locz00_17786;
				obj_t BgL_symbzd2funzd2_17787;
				long BgL_siza7eza7_17788;

				BgL_funz00_17785 = PROCEDURE_REF(BgL_envz00_17784, (int) (((long) 0)));
				BgL_locz00_17786 = PROCEDURE_REF(BgL_envz00_17784, (int) (((long) 1)));
				BgL_symbzd2funzd2_17787 =
					PROCEDURE_REF(BgL_envz00_17784, (int) (((long) 2)));
				BgL_siza7eza7_17788 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17784, (int) (((long) 3))));
				{
					obj_t BgL_sz00_1945;

					BgL_sz00_1945 = BgL_sz00_17789;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_1947;

						BgL_bpz00_1947 = VECTOR_REF(BgL_sz00_1945, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_1948;

							BgL_fz00_1948 =
								PROCEDURE_ENTRY(BgL_funz00_17785) (BgL_funz00_17785,
								BgL_sz00_1945, BEOA);
							if (PROCEDUREP(BgL_fz00_1948))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17786,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_1948);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_1950;

								BgL_ufz00_1950 = PROCEDURE_ATTR(BgL_fz00_1948);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_21366;

									if (STRUCTP(BgL_ufz00_1950))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21366 =
												(STRUCT_KEY(BgL_ufz00_1950) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21366 = ((bool_t) 0);
										}
									if (BgL_testz00_21366)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_1952;
											obj_t BgL_runz00_1953;
											obj_t BgL_sfz00_1954;

											BgL_arityz00_1952 =
												STRUCT_REF(BgL_ufz00_1950, (int) (((long) 0)));
											BgL_runz00_1953 =
												STRUCT_REF(BgL_ufz00_1950, (int) (((long) 1)));
											BgL_sfz00_1954 =
												STRUCT_REF(BgL_ufz00_1950, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_spz00_1955;

												BgL_spz00_1955 =
													((long) CINT(BgL_bpz00_1947) + BgL_siza7eza7_17788);
												if (((long) CINT(BgL_arityz00_1952) == ((long) 0)))
													{	/* Eval/evaluate_comp.scm 889 */
														BUNSPEC;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														if (INTEGERP(BgL_arityz00_1952))
															{	/* Eval/evaluate_comp.scm 889 */
																switch ((long) CINT(BgL_arityz00_1952))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg1919z00_1960;

																			BgL_arg1919z00_1960 =
																				(BgL_spz00_1955 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1945,
																				(int) (BgL_arg1919z00_1960), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_17786,
																			STRUCT_REF(BgL_ufz00_1950,
																				(int) (((long) 3))), (int) (((long) 0)),
																			CINT(BgL_arityz00_1952));
															}}
														else
															{	/* Eval/evaluate_comp.scm 889 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_17786, STRUCT_REF(BgL_ufz00_1950,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_1952));
													}}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_z12denvz12_1964;

													BgL_z12denvz12_1964 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_1964,
														BgL_locz00_17786);
													if (((BgL_spz00_1955 + (long) CINT(BgL_sfz00_1954)) <
															(long) (VECTOR_LENGTH(BgL_sz00_1945))))
														{	/* Eval/evaluate_comp.scm 889 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_1953, BgL_sz00_1945,
																BINT(BgL_spz00_1955));
														}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_nsz00_1966;

															BgL_nsz00_1966 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 889 */
																long BgL_arg1924z00_1968;

																BgL_arg1924z00_1968 =
																	(BgL_spz00_1955 + ((long) 0));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1966, ((long) 2), BgL_sz00_1945,
																	BINT(BgL_spz00_1955),
																	BINT(BgL_arg1924z00_1968));
															}
															VECTOR_SET(BgL_nsz00_1966,
																(int) (((long) 1)), BgL_sz00_1945);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1964,
																BgL_nsz00_1966);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_ez00_1969;

																BgL_ez00_1969 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_1969, BgL_sz00_1945);
																{	/* Eval/evaluate_comp.scm 889 */
																	obj_t BgL_____rz00_1970;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_7733;

																		BgL_savedzd2bpzd2_7733 =
																			VECTOR_REF(BgL_nsz00_1966,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_1966,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_7740;

																			BgL_fz00_7740 = BgL_runz00_1953;
																		BgL_recz00_7739:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_7741;

																				BgL_rz00_7741 =
																					PROCEDURE_ENTRY(BgL_fz00_7740)
																					(BgL_fz00_7740, BgL_nsz00_1966, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_21428;

																					if (PROCEDUREP(BgL_rz00_7741))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_7746;

																							BgL_arg1673z00_7746 =
																								PROCEDURE_ATTR(BgL_rz00_7741);
																							if (STRUCTP(BgL_arg1673z00_7746))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_21428 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_7746) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_21428 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_21428 = ((bool_t) 0);
																						}
																					if (BgL_testz00_21428)
																						{
																							obj_t BgL_fz00_21436;

																							BgL_fz00_21436 = BgL_rz00_7741;
																							BgL_fz00_7740 = BgL_fz00_21436;
																							goto BgL_recz00_7739;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_1966,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_7733);
																							BgL_____rz00_1970 = BgL_rz00_7741;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_1969);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1964,
																		BgL_sz00_1945);
																	return BgL_____rz00_1970;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1948,
													(int) (((long) 0))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_1972;

													BgL_nbpz00_1972 =
														((long) CINT(BgL_bpz00_1947) + BgL_siza7eza7_17788);
													VECTOR_SET(BgL_sz00_1945,
														(int) (((long) 0)), BINT(BgL_nbpz00_1972));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_auxz00_21449;

														BgL_auxz00_21449 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_21449,
															BgL_locz00_17786);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_1974;

														BgL_rz00_1974 =
															PROCEDURE_ENTRY(BgL_fz00_1948) (BgL_fz00_1948,
															BEOA);
														VECTOR_SET(BgL_sz00_1945, (int) (((long) 0)),
															BgL_bpz00_1947);
														return BgL_rz00_1974;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17786, BgL_symbzd2funzd2_17787,
														(int) (((long) 0)), PROCEDURE_ARITY(BgL_fz00_1948));
		}}}}}}}}}
	}



/* &<anonymous:1928> */
	obj_t BGl_z62zc3anonymousza31928ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17790, obj_t BgL_sz00_17795)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17791;
				obj_t BgL_locz00_17792;
				obj_t BgL_symbzd2funzd2_17793;
				long BgL_siza7eza7_17794;

				BgL_funz00_17791 = PROCEDURE_REF(BgL_envz00_17790, (int) (((long) 0)));
				BgL_locz00_17792 = PROCEDURE_REF(BgL_envz00_17790, (int) (((long) 1)));
				BgL_symbzd2funzd2_17793 =
					PROCEDURE_REF(BgL_envz00_17790, (int) (((long) 2)));
				BgL_siza7eza7_17794 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17790, (int) (((long) 3))));
				{
					obj_t BgL_sz00_1976;

					BgL_sz00_1976 = BgL_sz00_17795;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_1978;

						BgL_bpz00_1978 = VECTOR_REF(BgL_sz00_1976, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_1979;

							BgL_fz00_1979 =
								PROCEDURE_ENTRY(BgL_funz00_17791) (BgL_funz00_17791,
								BgL_sz00_1976, BEOA);
							if (PROCEDUREP(BgL_fz00_1979))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17792,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_1979);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_1981;

								BgL_ufz00_1981 = PROCEDURE_ATTR(BgL_fz00_1979);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_21479;

									if (STRUCTP(BgL_ufz00_1981))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21479 =
												(STRUCT_KEY(BgL_ufz00_1981) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21479 = ((bool_t) 0);
										}
									if (BgL_testz00_21479)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_1983;
											obj_t BgL_runz00_1984;
											obj_t BgL_sfz00_1985;

											BgL_arityz00_1983 =
												STRUCT_REF(BgL_ufz00_1981, (int) (((long) 0)));
											BgL_runz00_1984 =
												STRUCT_REF(BgL_ufz00_1981, (int) (((long) 1)));
											BgL_sfz00_1985 =
												STRUCT_REF(BgL_ufz00_1981, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_spz00_1986;

												BgL_spz00_1986 =
													((long) CINT(BgL_bpz00_1978) + BgL_siza7eza7_17794);
												if (((long) CINT(BgL_arityz00_1983) == ((long) 0)))
													{	/* Eval/evaluate_comp.scm 889 */
														BUNSPEC;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														if (INTEGERP(BgL_arityz00_1983))
															{	/* Eval/evaluate_comp.scm 889 */
																switch ((long) CINT(BgL_arityz00_1983))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg1933z00_1991;

																			BgL_arg1933z00_1991 =
																				(BgL_spz00_1986 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1976,
																				(int) (BgL_arg1933z00_1991), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_17792,
																			STRUCT_REF(BgL_ufz00_1981,
																				(int) (((long) 3))), (int) (((long) 0)),
																			CINT(BgL_arityz00_1983));
															}}
														else
															{	/* Eval/evaluate_comp.scm 889 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_17792, STRUCT_REF(BgL_ufz00_1981,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_1983));
													}}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_z12denvz12_1995;

													BgL_z12denvz12_1995 = BGL_CURRENT_DYNAMIC_ENV();
													if (
														((BgL_spz00_1986 +
																(long) CINT(BgL_sfz00_1985)) <
															(long) (VECTOR_LENGTH(BgL_sz00_1976))))
														{	/* Eval/evaluate_comp.scm 889 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_1984, BgL_sz00_1976,
																BINT(BgL_spz00_1986));
														}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_nsz00_1997;

															BgL_nsz00_1997 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 889 */
																long BgL_arg1940z00_1999;

																BgL_arg1940z00_1999 =
																	(BgL_spz00_1986 + ((long) 0));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1997, ((long) 2), BgL_sz00_1976,
																	BINT(BgL_spz00_1986),
																	BINT(BgL_arg1940z00_1999));
															}
															VECTOR_SET(BgL_nsz00_1997,
																(int) (((long) 1)), BgL_sz00_1976);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1995,
																BgL_nsz00_1997);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_ez00_2000;

																BgL_ez00_2000 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2000, BgL_sz00_1976);
																{	/* Eval/evaluate_comp.scm 889 */
																	obj_t BgL_____rz00_2001;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_7837;

																		BgL_savedzd2bpzd2_7837 =
																			VECTOR_REF(BgL_nsz00_1997,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_1997,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_7844;

																			BgL_fz00_7844 = BgL_runz00_1984;
																		BgL_recz00_7843:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_7845;

																				BgL_rz00_7845 =
																					PROCEDURE_ENTRY(BgL_fz00_7844)
																					(BgL_fz00_7844, BgL_nsz00_1997, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_21540;

																					if (PROCEDUREP(BgL_rz00_7845))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_7850;

																							BgL_arg1673z00_7850 =
																								PROCEDURE_ATTR(BgL_rz00_7845);
																							if (STRUCTP(BgL_arg1673z00_7850))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_21540 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_7850) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_21540 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_21540 = ((bool_t) 0);
																						}
																					if (BgL_testz00_21540)
																						{
																							obj_t BgL_fz00_21548;

																							BgL_fz00_21548 = BgL_rz00_7845;
																							BgL_fz00_7844 = BgL_fz00_21548;
																							goto BgL_recz00_7843;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_1997,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_7837);
																							BgL_____rz00_2001 = BgL_rz00_7845;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_2000);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_1995,
																		BgL_sz00_1976);
																	return BgL_____rz00_2001;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1979,
													(int) (((long) 0))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2003;

													BgL_nbpz00_2003 =
														((long) CINT(BgL_bpz00_1978) + BgL_siza7eza7_17794);
													VECTOR_SET(BgL_sz00_1976,
														(int) (((long) 0)), BINT(BgL_nbpz00_2003));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2004;

														BgL_rz00_2004 =
															PROCEDURE_ENTRY(BgL_fz00_1979) (BgL_fz00_1979,
															BEOA);
														VECTOR_SET(BgL_sz00_1976, (int) (((long) 0)),
															BgL_bpz00_1978);
														return BgL_rz00_2004;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17792, BgL_symbzd2funzd2_17793,
														(int) (((long) 0)), PROCEDURE_ARITY(BgL_fz00_1979));
		}}}}}}}}}
	}



/* comp-call1 */
	obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145,
		BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147,
		obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150,
		long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2007;

				BgL_cfunz00_2007 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146,
					((long) 1), BgL_locz00_145, BgL_symbzd2funzd2_147);
				if (CBOOL(BgL_cfunz00_2007))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_testz00_21572;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg1949z00_2022;

							BgL_arg1949z00_2022 = bgl_debug();
							BgL_testz00_21572 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1949z00_2022),
								BINT(((long) 0)));
						}
						if (BgL_testz00_21572)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza31946ze3z83_17796;

								BgL_zc3anonymousza31946ze3z83_17796 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza31946ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3anonymousza31946ze3z83_17796,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3anonymousza31946ze3z83_17796,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3anonymousza31946ze3z83_17796,
									(int) (((long) 2)), BgL_locz00_145);
								PROCEDURE_SET(BgL_zc3anonymousza31946ze3z83_17796,
									(int) (((long) 3)), BgL_cfunz00_2007);
								return BgL_zc3anonymousza31946ze3z83_17796;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza31948ze3z83_17797;

								BgL_zc3anonymousza31948ze3z83_17797 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza31948ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3anonymousza31948ze3z83_17797,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3anonymousza31948ze3z83_17797,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3anonymousza31948ze3z83_17797,
									(int) (((long) 2)), BgL_cfunz00_2007);
								return BgL_zc3anonymousza31948ze3z83_17797;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_149))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21601;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg1992z00_2097;

									BgL_arg1992z00_2097 = bgl_debug();
									BgL_testz00_21601 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1992z00_2097),
										BINT(((long) 0)));
								}
								if (BgL_testz00_21601)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31951ze3z83_17798;

										BgL_zc3anonymousza31951ze3z83_17798 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31951ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3anonymousza31951ze3z83_17798,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3anonymousza31951ze3z83_17798,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3anonymousza31951ze3z83_17798,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3anonymousza31951ze3z83_17798,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3anonymousza31951ze3z83_17798,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3anonymousza31951ze3z83_17798;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31972ze3z83_17799;

										BgL_zc3anonymousza31972ze3z83_17799 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31972ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3anonymousza31972ze3z83_17799,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3anonymousza31972ze3z83_17799,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3anonymousza31972ze3z83_17799,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3anonymousza31972ze3z83_17799,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3anonymousza31972ze3z83_17799,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3anonymousza31972ze3z83_17799;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21634;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2037z00_2172;

									BgL_arg2037z00_2172 = bgl_debug();
									BgL_testz00_21634 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2037z00_2172),
										BINT(((long) 0)));
								}
								if (BgL_testz00_21634)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31994ze3z83_17800;

										BgL_zc3anonymousza31994ze3z83_17800 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31994ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3anonymousza31994ze3z83_17800,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3anonymousza31994ze3z83_17800,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3anonymousza31994ze3z83_17800,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3anonymousza31994ze3z83_17800,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3anonymousza31994ze3z83_17800,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3anonymousza31994ze3z83_17800;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32017ze3z83_17801;

										BgL_zc3anonymousza32017ze3z83_17801 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32017ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3anonymousza32017ze3z83_17801,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3anonymousza32017ze3z83_17801,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3anonymousza32017ze3z83_17801,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3anonymousza32017ze3z83_17801,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3anonymousza32017ze3z83_17801,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3anonymousza32017ze3z83_17801;
									}
							}
					}
			}
		}
	}



/* &<anonymous:1946> */
	obj_t BGl_z62zc3anonymousza31946ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17802, obj_t BgL_sz00_17807)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_17803;
				long BgL_siza7eza7_17804;
				obj_t BgL_locz00_17805;
				obj_t BgL_cfunz00_17806;

				BgL_a1z00_17803 = PROCEDURE_REF(BgL_envz00_17802, (int) (((long) 0)));
				BgL_siza7eza7_17804 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17802, (int) (((long) 1))));
				BgL_locz00_17805 = PROCEDURE_REF(BgL_envz00_17802, (int) (((long) 2)));
				BgL_cfunz00_17806 = PROCEDURE_REF(BgL_envz00_17802, (int) (((long) 3)));
				{
					obj_t BgL_sz00_2009;

					BgL_sz00_2009 = BgL_sz00_17807;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2011;

						BgL_bpz00_2011 = VECTOR_REF(BgL_sz00_2009, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_a1z00_2012;

							BgL_a1z00_2012 =
								PROCEDURE_ENTRY(BgL_a1z00_17803) (BgL_a1z00_17803,
								BgL_sz00_2009, BEOA);
							{	/* Eval/evaluate_comp.scm 889 */
								long BgL_nbpz00_2013;

								BgL_nbpz00_2013 =
									((long) CINT(BgL_bpz00_2011) + BgL_siza7eza7_17804);
								VECTOR_SET(BgL_sz00_2009,
									(int) (((long) 0)), BINT(BgL_nbpz00_2013));
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_auxz00_21687;

									BgL_auxz00_21687 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_21687,
										BgL_locz00_17805);
								}
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_rz00_2015;

									BgL_rz00_2015 =
										PROCEDURE_ENTRY(BgL_cfunz00_17806) (BgL_cfunz00_17806,
										BgL_a1z00_2012, BEOA);
									VECTOR_SET(BgL_sz00_2009, (int) (((long) 0)), BgL_bpz00_2011);
									return BgL_rz00_2015;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:1948> */
	obj_t BGl_z62zc3anonymousza31948ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17808, obj_t BgL_sz00_17812)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_17809;
				long BgL_siza7eza7_17810;
				obj_t BgL_cfunz00_17811;

				BgL_a1z00_17809 = PROCEDURE_REF(BgL_envz00_17808, (int) (((long) 0)));
				BgL_siza7eza7_17810 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17808, (int) (((long) 1))));
				BgL_cfunz00_17811 = PROCEDURE_REF(BgL_envz00_17808, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2016;

					BgL_sz00_2016 = BgL_sz00_17812;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2018;

						BgL_bpz00_2018 = VECTOR_REF(BgL_sz00_2016, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_a1z00_2019;

							BgL_a1z00_2019 =
								PROCEDURE_ENTRY(BgL_a1z00_17809) (BgL_a1z00_17809,
								BgL_sz00_2016, BEOA);
							{	/* Eval/evaluate_comp.scm 889 */
								long BgL_nbpz00_2020;

								BgL_nbpz00_2020 =
									((long) CINT(BgL_bpz00_2018) + BgL_siza7eza7_17810);
								VECTOR_SET(BgL_sz00_2016,
									(int) (((long) 0)), BINT(BgL_nbpz00_2020));
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_rz00_2021;

									BgL_rz00_2021 =
										PROCEDURE_ENTRY(BgL_cfunz00_17811) (BgL_cfunz00_17811,
										BgL_a1z00_2019, BEOA);
									VECTOR_SET(BgL_sz00_2016, (int) (((long) 0)), BgL_bpz00_2018);
									return BgL_rz00_2021;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:1951> */
	obj_t BGl_z62zc3anonymousza31951ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17813, obj_t BgL_sz00_17819)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17814;
				obj_t BgL_a1z00_17815;
				obj_t BgL_locz00_17816;
				obj_t BgL_symbzd2funzd2_17817;
				long BgL_siza7eza7_17818;

				BgL_funz00_17814 = PROCEDURE_REF(BgL_envz00_17813, (int) (((long) 0)));
				BgL_a1z00_17815 = PROCEDURE_REF(BgL_envz00_17813, (int) (((long) 1)));
				BgL_locz00_17816 = PROCEDURE_REF(BgL_envz00_17813, (int) (((long) 2)));
				BgL_symbzd2funzd2_17817 =
					PROCEDURE_REF(BgL_envz00_17813, (int) (((long) 3)));
				BgL_siza7eza7_17818 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17813, (int) (((long) 4))));
				{
					obj_t BgL_sz00_2024;

					BgL_sz00_2024 = BgL_sz00_17819;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2026;

						BgL_bpz00_2026 = VECTOR_REF(BgL_sz00_2024, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2027;
							obj_t BgL_a1z00_2028;

							BgL_fz00_2027 =
								PROCEDURE_ENTRY(BgL_funz00_17814) (BgL_funz00_17814,
								BgL_sz00_2024, BEOA);
							BgL_a1z00_2028 =
								PROCEDURE_ENTRY(BgL_a1z00_17815) (BgL_a1z00_17815,
								BgL_sz00_2024, BEOA);
							if (PROCEDUREP(BgL_fz00_2027))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17816,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2027);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2030;

								BgL_ufz00_2030 = PROCEDURE_ATTR(BgL_fz00_2027);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_21745;

									if (STRUCTP(BgL_ufz00_2030))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21745 =
												(STRUCT_KEY(BgL_ufz00_2030) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21745 = ((bool_t) 0);
										}
									if (BgL_testz00_21745)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2032;
											obj_t BgL_runz00_2033;
											obj_t BgL_sfz00_2034;

											BgL_arityz00_2032 =
												STRUCT_REF(BgL_ufz00_2030, (int) (((long) 0)));
											BgL_runz00_2033 =
												STRUCT_REF(BgL_ufz00_2030, (int) (((long) 1)));
											BgL_sfz00_2034 =
												STRUCT_REF(BgL_ufz00_2030, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_2032) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg1955z00_2037;

													BgL_arg1955z00_2037 =
														((long) CINT(BgL_bpz00_2026) + ((long) 0));
													VECTOR_SET(BgL_sz00_2024,
														(int) (BgL_arg1955z00_2037), BgL_a1z00_2028);
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_2032))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_2032))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1958z00_2041;
																		obj_t BgL_arg1960z00_2042;

																		BgL_arg1958z00_2041 =
																			(
																			(long) CINT(BgL_bpz00_2026) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list1961z00_2043;

																			BgL_list1961z00_2043 =
																				MAKE_PAIR(BgL_a1z00_2028, BNIL);
																			BgL_arg1960z00_2042 =
																				BgL_list1961z00_2043;
																		}
																		VECTOR_SET(BgL_sz00_2024,
																			(int) (BgL_arg1958z00_2041),
																			BgL_arg1960z00_2042);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1962z00_2044;

																		BgL_arg1962z00_2044 =
																			(
																			(long) CINT(BgL_bpz00_2026) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2024,
																			(int) (BgL_arg1962z00_2044),
																			BgL_a1z00_2028);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1963z00_2045;

																		BgL_arg1963z00_2045 =
																			(
																			(long) CINT(BgL_bpz00_2026) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2024,
																			(int) (BgL_arg1963z00_2045), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_17816,
																		STRUCT_REF(BgL_ufz00_2030,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_2032));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_17816, STRUCT_REF(BgL_ufz00_2030,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_2032));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_2049;

												BgL_z12denvz12_2049 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_2049,
													BgL_locz00_17816);
												if ((((long) CINT(BgL_bpz00_2026) +
															(long) CINT(BgL_sfz00_2034)) <
														(long) (VECTOR_LENGTH(BgL_sz00_2024))))
													{	/* Eval/evaluate_comp.scm 889 */
														return BgL_runz00_2033;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_2051;

														BgL_nsz00_2051 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg1968z00_2053;

															BgL_arg1968z00_2053 =
																((long) CINT(BgL_bpz00_2026) + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_2051, ((long) 2), BgL_sz00_2024,
																BgL_bpz00_2026, BINT(BgL_arg1968z00_2053));
														}
														VECTOR_SET(BgL_nsz00_2051,
															(int) (((long) 1)), BgL_sz00_2024);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2049,
															BgL_nsz00_2051);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_2054;

															BgL_ez00_2054 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_2054, BgL_sz00_2024);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_2055;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_7984;

																	BgL_savedzd2bpzd2_7984 =
																		VECTOR_REF(BgL_nsz00_2051,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_2051,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_7991;

																		BgL_fz00_7991 = BgL_runz00_2033;
																	BgL_recz00_7990:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_7992;

																			BgL_rz00_7992 =
																				PROCEDURE_ENTRY(BgL_fz00_7991)
																				(BgL_fz00_7991, BgL_nsz00_2051, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_21818;

																				if (PROCEDUREP(BgL_rz00_7992))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_7997;

																						BgL_arg1673z00_7997 =
																							PROCEDURE_ATTR(BgL_rz00_7992);
																						if (STRUCTP(BgL_arg1673z00_7997))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21818 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_7997) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21818 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_21818 = ((bool_t) 0);
																					}
																				if (BgL_testz00_21818)
																					{
																						obj_t BgL_fz00_21826;

																						BgL_fz00_21826 = BgL_rz00_7992;
																						BgL_fz00_7991 = BgL_fz00_21826;
																						goto BgL_recz00_7990;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_2051,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_7984);
																						BgL_____rz00_2055 = BgL_rz00_7992;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2054);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2049,
																	BgL_sz00_2024);
																return BgL_____rz00_2055;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2027,
													(int) (((long) 1))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2057;

													BgL_nbpz00_2057 =
														((long) CINT(BgL_bpz00_2026) + BgL_siza7eza7_17818);
													VECTOR_SET(BgL_sz00_2024,
														(int) (((long) 0)), BINT(BgL_nbpz00_2057));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_auxz00_21839;

														BgL_auxz00_21839 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_21839,
															BgL_locz00_17816);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2059;

														BgL_rz00_2059 =
															PROCEDURE_ENTRY(BgL_fz00_2027) (BgL_fz00_2027,
															BgL_a1z00_2028, BEOA);
														VECTOR_SET(BgL_sz00_2024, (int) (((long) 0)),
															BgL_bpz00_2026);
														return BgL_rz00_2059;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17816, BgL_symbzd2funzd2_17817,
														(int) (((long) 1)), PROCEDURE_ARITY(BgL_fz00_2027));
		}}}}}}}}}
	}



/* &<anonymous:1972> */
	obj_t BGl_z62zc3anonymousza31972ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17820, obj_t BgL_sz00_17826)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17821;
				obj_t BgL_a1z00_17822;
				obj_t BgL_locz00_17823;
				obj_t BgL_symbzd2funzd2_17824;
				long BgL_siza7eza7_17825;

				BgL_funz00_17821 = PROCEDURE_REF(BgL_envz00_17820, (int) (((long) 0)));
				BgL_a1z00_17822 = PROCEDURE_REF(BgL_envz00_17820, (int) (((long) 1)));
				BgL_locz00_17823 = PROCEDURE_REF(BgL_envz00_17820, (int) (((long) 2)));
				BgL_symbzd2funzd2_17824 =
					PROCEDURE_REF(BgL_envz00_17820, (int) (((long) 3)));
				BgL_siza7eza7_17825 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17820, (int) (((long) 4))));
				{
					obj_t BgL_sz00_2061;

					BgL_sz00_2061 = BgL_sz00_17826;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2063;

						BgL_bpz00_2063 = VECTOR_REF(BgL_sz00_2061, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2064;
							obj_t BgL_a1z00_2065;

							BgL_fz00_2064 =
								PROCEDURE_ENTRY(BgL_funz00_17821) (BgL_funz00_17821,
								BgL_sz00_2061, BEOA);
							BgL_a1z00_2065 =
								PROCEDURE_ENTRY(BgL_a1z00_17822) (BgL_a1z00_17822,
								BgL_sz00_2061, BEOA);
							if (PROCEDUREP(BgL_fz00_2064))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17823,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2064);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2067;

								BgL_ufz00_2067 = PROCEDURE_ATTR(BgL_fz00_2064);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_21876;

									if (STRUCTP(BgL_ufz00_2067))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21876 =
												(STRUCT_KEY(BgL_ufz00_2067) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_21876 = ((bool_t) 0);
										}
									if (BgL_testz00_21876)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2069;
											obj_t BgL_runz00_2070;
											obj_t BgL_sfz00_2071;

											BgL_arityz00_2069 =
												STRUCT_REF(BgL_ufz00_2067, (int) (((long) 0)));
											BgL_runz00_2070 =
												STRUCT_REF(BgL_ufz00_2067, (int) (((long) 1)));
											BgL_sfz00_2071 =
												STRUCT_REF(BgL_ufz00_2067, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_2069) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg1976z00_2074;

													BgL_arg1976z00_2074 =
														((long) CINT(BgL_bpz00_2063) + ((long) 0));
													VECTOR_SET(BgL_sz00_2061,
														(int) (BgL_arg1976z00_2074), BgL_a1z00_2065);
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_2069))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_2069))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1978z00_2078;
																		obj_t BgL_arg1979z00_2079;

																		BgL_arg1978z00_2078 =
																			(
																			(long) CINT(BgL_bpz00_2063) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list1980z00_2080;

																			BgL_list1980z00_2080 =
																				MAKE_PAIR(BgL_a1z00_2065, BNIL);
																			BgL_arg1979z00_2079 =
																				BgL_list1980z00_2080;
																		}
																		VECTOR_SET(BgL_sz00_2061,
																			(int) (BgL_arg1978z00_2078),
																			BgL_arg1979z00_2079);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1981z00_2081;

																		BgL_arg1981z00_2081 =
																			(
																			(long) CINT(BgL_bpz00_2063) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2061,
																			(int) (BgL_arg1981z00_2081),
																			BgL_a1z00_2065);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1984z00_2082;

																		BgL_arg1984z00_2082 =
																			(
																			(long) CINT(BgL_bpz00_2063) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2061,
																			(int) (BgL_arg1984z00_2082), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_17823,
																		STRUCT_REF(BgL_ufz00_2067,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_2069));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_17823, STRUCT_REF(BgL_ufz00_2067,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_2069));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_2086;

												BgL_z12denvz12_2086 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_2063) +
															(long) CINT(BgL_sfz00_2071)) <
														(long) (VECTOR_LENGTH(BgL_sz00_2061))))
													{	/* Eval/evaluate_comp.scm 889 */
														return BgL_runz00_2070;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_2088;

														BgL_nsz00_2088 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg1989z00_2090;

															BgL_arg1989z00_2090 =
																((long) CINT(BgL_bpz00_2063) + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_2088, ((long) 2), BgL_sz00_2061,
																BgL_bpz00_2063, BINT(BgL_arg1989z00_2090));
														}
														VECTOR_SET(BgL_nsz00_2088,
															(int) (((long) 1)), BgL_sz00_2061);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2086,
															BgL_nsz00_2088);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_2091;

															BgL_ez00_2091 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_2091, BgL_sz00_2061);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_2092;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_8109;

																	BgL_savedzd2bpzd2_8109 =
																		VECTOR_REF(BgL_nsz00_2088,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_2088,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_8116;

																		BgL_fz00_8116 = BgL_runz00_2070;
																	BgL_recz00_8115:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_8117;

																			BgL_rz00_8117 =
																				PROCEDURE_ENTRY(BgL_fz00_8116)
																				(BgL_fz00_8116, BgL_nsz00_2088, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_21948;

																				if (PROCEDUREP(BgL_rz00_8117))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_8122;

																						BgL_arg1673z00_8122 =
																							PROCEDURE_ATTR(BgL_rz00_8117);
																						if (STRUCTP(BgL_arg1673z00_8122))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21948 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_8122) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21948 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_21948 = ((bool_t) 0);
																					}
																				if (BgL_testz00_21948)
																					{
																						obj_t BgL_fz00_21956;

																						BgL_fz00_21956 = BgL_rz00_8117;
																						BgL_fz00_8116 = BgL_fz00_21956;
																						goto BgL_recz00_8115;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_2088,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_8109);
																						BgL_____rz00_2092 = BgL_rz00_8117;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2091);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2086,
																	BgL_sz00_2061);
																return BgL_____rz00_2092;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2064,
													(int) (((long) 1))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2094;

													BgL_nbpz00_2094 =
														((long) CINT(BgL_bpz00_2063) + BgL_siza7eza7_17825);
													VECTOR_SET(BgL_sz00_2061,
														(int) (((long) 0)), BINT(BgL_nbpz00_2094));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2095;

														BgL_rz00_2095 =
															PROCEDURE_ENTRY(BgL_fz00_2064) (BgL_fz00_2064,
															BgL_a1z00_2065, BEOA);
														VECTOR_SET(BgL_sz00_2061, (int) (((long) 0)),
															BgL_bpz00_2063);
														return BgL_rz00_2095;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17823, BgL_symbzd2funzd2_17824,
														(int) (((long) 1)), PROCEDURE_ARITY(BgL_fz00_2064));
		}}}}}}}}}
	}



/* &<anonymous:1994> */
	obj_t BGl_z62zc3anonymousza31994ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17827, obj_t BgL_sz00_17833)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17828;
				obj_t BgL_a1z00_17829;
				obj_t BgL_locz00_17830;
				obj_t BgL_symbzd2funzd2_17831;
				long BgL_siza7eza7_17832;

				BgL_funz00_17828 = PROCEDURE_REF(BgL_envz00_17827, (int) (((long) 0)));
				BgL_a1z00_17829 = PROCEDURE_REF(BgL_envz00_17827, (int) (((long) 1)));
				BgL_locz00_17830 = PROCEDURE_REF(BgL_envz00_17827, (int) (((long) 2)));
				BgL_symbzd2funzd2_17831 =
					PROCEDURE_REF(BgL_envz00_17827, (int) (((long) 3)));
				BgL_siza7eza7_17832 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17827, (int) (((long) 4))));
				{
					obj_t BgL_sz00_2099;

					BgL_sz00_2099 = BgL_sz00_17833;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2101;

						BgL_bpz00_2101 = VECTOR_REF(BgL_sz00_2099, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2102;
							obj_t BgL_a1z00_2103;

							BgL_fz00_2102 =
								PROCEDURE_ENTRY(BgL_funz00_17828) (BgL_funz00_17828,
								BgL_sz00_2099, BEOA);
							BgL_a1z00_2103 =
								PROCEDURE_ENTRY(BgL_a1z00_17829) (BgL_a1z00_17829,
								BgL_sz00_2099, BEOA);
							if (PROCEDUREP(BgL_fz00_2102))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17830,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2102);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2105;

								BgL_ufz00_2105 = PROCEDURE_ATTR(BgL_fz00_2102);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_22003;

									if (STRUCTP(BgL_ufz00_2105))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22003 =
												(STRUCT_KEY(BgL_ufz00_2105) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22003 = ((bool_t) 0);
										}
									if (BgL_testz00_22003)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2107;
											obj_t BgL_runz00_2108;
											obj_t BgL_sfz00_2109;

											BgL_arityz00_2107 =
												STRUCT_REF(BgL_ufz00_2105, (int) (((long) 0)));
											BgL_runz00_2108 =
												STRUCT_REF(BgL_ufz00_2105, (int) (((long) 1)));
											BgL_sfz00_2109 =
												STRUCT_REF(BgL_ufz00_2105, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_spz00_2110;

												BgL_spz00_2110 =
													((long) CINT(BgL_bpz00_2101) + BgL_siza7eza7_17832);
												if (((long) CINT(BgL_arityz00_2107) == ((long) 1)))
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg1999z00_2112;

														BgL_arg1999z00_2112 = (BgL_spz00_2110 + ((long) 0));
														VECTOR_SET(BgL_sz00_2099,
															(int) (BgL_arg1999z00_2112), BgL_a1z00_2103);
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														if (INTEGERP(BgL_arityz00_2107))
															{	/* Eval/evaluate_comp.scm 889 */
																switch ((long) CINT(BgL_arityz00_2107))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2001z00_2116;
																			obj_t BgL_arg2003z00_2117;

																			BgL_arg2001z00_2116 =
																				(BgL_spz00_2110 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2004z00_2118;

																				BgL_list2004z00_2118 =
																					MAKE_PAIR(BgL_a1z00_2103, BNIL);
																				BgL_arg2003z00_2117 =
																					BgL_list2004z00_2118;
																			}
																			VECTOR_SET(BgL_sz00_2099,
																				(int) (BgL_arg2001z00_2116),
																				BgL_arg2003z00_2117);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2005z00_2119;

																			BgL_arg2005z00_2119 =
																				(BgL_spz00_2110 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2099,
																				(int) (BgL_arg2005z00_2119),
																				BgL_a1z00_2103);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2007z00_2120;

																			BgL_arg2007z00_2120 =
																				(BgL_spz00_2110 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2099,
																				(int) (BgL_arg2007z00_2120), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_17830,
																			STRUCT_REF(BgL_ufz00_2105,
																				(int) (((long) 3))), (int) (((long) 1)),
																			CINT(BgL_arityz00_2107));
															}}
														else
															{	/* Eval/evaluate_comp.scm 889 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_17830, STRUCT_REF(BgL_ufz00_2105,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_2107));
													}}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_z12denvz12_2124;

													BgL_z12denvz12_2124 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_2124,
														BgL_locz00_17830);
													if (((BgL_spz00_2110 + (long) CINT(BgL_sfz00_2109)) <
															(long) (VECTOR_LENGTH(BgL_sz00_2099))))
														{	/* Eval/evaluate_comp.scm 889 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_2108, BgL_sz00_2099,
																BINT(BgL_spz00_2110));
														}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_nsz00_2126;

															BgL_nsz00_2126 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 889 */
																long BgL_arg2012z00_2128;

																BgL_arg2012z00_2128 =
																	(BgL_spz00_2110 + ((long) 1));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_2126, ((long) 2), BgL_sz00_2099,
																	BINT(BgL_spz00_2110),
																	BINT(BgL_arg2012z00_2128));
															}
															VECTOR_SET(BgL_nsz00_2126,
																(int) (((long) 1)), BgL_sz00_2099);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2124,
																BgL_nsz00_2126);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_ez00_2129;

																BgL_ez00_2129 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2129, BgL_sz00_2099);
																{	/* Eval/evaluate_comp.scm 889 */
																	obj_t BgL_____rz00_2130;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_8232;

																		BgL_savedzd2bpzd2_8232 =
																			VECTOR_REF(BgL_nsz00_2126,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_2126,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_8239;

																			BgL_fz00_8239 = BgL_runz00_2108;
																		BgL_recz00_8238:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_8240;

																				BgL_rz00_8240 =
																					PROCEDURE_ENTRY(BgL_fz00_8239)
																					(BgL_fz00_8239, BgL_nsz00_2126, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_22075;

																					if (PROCEDUREP(BgL_rz00_8240))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_8245;

																							BgL_arg1673z00_8245 =
																								PROCEDURE_ATTR(BgL_rz00_8240);
																							if (STRUCTP(BgL_arg1673z00_8245))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_22075 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_8245) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_22075 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_22075 = ((bool_t) 0);
																						}
																					if (BgL_testz00_22075)
																						{
																							obj_t BgL_fz00_22083;

																							BgL_fz00_22083 = BgL_rz00_8240;
																							BgL_fz00_8239 = BgL_fz00_22083;
																							goto BgL_recz00_8238;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_2126,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_8232);
																							BgL_____rz00_2130 = BgL_rz00_8240;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_2129);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2124,
																		BgL_sz00_2099);
																	return BgL_____rz00_2130;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2102,
													(int) (((long) 1))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2132;

													BgL_nbpz00_2132 =
														((long) CINT(BgL_bpz00_2101) + BgL_siza7eza7_17832);
													VECTOR_SET(BgL_sz00_2099,
														(int) (((long) 0)), BINT(BgL_nbpz00_2132));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_auxz00_22096;

														BgL_auxz00_22096 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_22096,
															BgL_locz00_17830);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2134;

														BgL_rz00_2134 =
															PROCEDURE_ENTRY(BgL_fz00_2102) (BgL_fz00_2102,
															BgL_a1z00_2103, BEOA);
														VECTOR_SET(BgL_sz00_2099, (int) (((long) 0)),
															BgL_bpz00_2101);
														return BgL_rz00_2134;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17830, BgL_symbzd2funzd2_17831,
														(int) (((long) 1)), PROCEDURE_ARITY(BgL_fz00_2102));
		}}}}}}}}}
	}



/* &<anonymous:2017> */
	obj_t BGl_z62zc3anonymousza32017ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17834, obj_t BgL_sz00_17840)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17835;
				obj_t BgL_a1z00_17836;
				obj_t BgL_locz00_17837;
				obj_t BgL_symbzd2funzd2_17838;
				long BgL_siza7eza7_17839;

				BgL_funz00_17835 = PROCEDURE_REF(BgL_envz00_17834, (int) (((long) 0)));
				BgL_a1z00_17836 = PROCEDURE_REF(BgL_envz00_17834, (int) (((long) 1)));
				BgL_locz00_17837 = PROCEDURE_REF(BgL_envz00_17834, (int) (((long) 2)));
				BgL_symbzd2funzd2_17838 =
					PROCEDURE_REF(BgL_envz00_17834, (int) (((long) 3)));
				BgL_siza7eza7_17839 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17834, (int) (((long) 4))));
				{
					obj_t BgL_sz00_2136;

					BgL_sz00_2136 = BgL_sz00_17840;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2138;

						BgL_bpz00_2138 = VECTOR_REF(BgL_sz00_2136, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2139;
							obj_t BgL_a1z00_2140;

							BgL_fz00_2139 =
								PROCEDURE_ENTRY(BgL_funz00_17835) (BgL_funz00_17835,
								BgL_sz00_2136, BEOA);
							BgL_a1z00_2140 =
								PROCEDURE_ENTRY(BgL_a1z00_17836) (BgL_a1z00_17836,
								BgL_sz00_2136, BEOA);
							if (PROCEDUREP(BgL_fz00_2139))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17837,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2139);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2142;

								BgL_ufz00_2142 = PROCEDURE_ATTR(BgL_fz00_2139);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_22133;

									if (STRUCTP(BgL_ufz00_2142))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22133 =
												(STRUCT_KEY(BgL_ufz00_2142) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22133 = ((bool_t) 0);
										}
									if (BgL_testz00_22133)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2144;
											obj_t BgL_runz00_2145;
											obj_t BgL_sfz00_2146;

											BgL_arityz00_2144 =
												STRUCT_REF(BgL_ufz00_2142, (int) (((long) 0)));
											BgL_runz00_2145 =
												STRUCT_REF(BgL_ufz00_2142, (int) (((long) 1)));
											BgL_sfz00_2146 =
												STRUCT_REF(BgL_ufz00_2142, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_spz00_2147;

												BgL_spz00_2147 =
													((long) CINT(BgL_bpz00_2138) + BgL_siza7eza7_17839);
												if (((long) CINT(BgL_arityz00_2144) == ((long) 1)))
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2021z00_2149;

														BgL_arg2021z00_2149 = (BgL_spz00_2147 + ((long) 0));
														VECTOR_SET(BgL_sz00_2136,
															(int) (BgL_arg2021z00_2149), BgL_a1z00_2140);
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														if (INTEGERP(BgL_arityz00_2144))
															{	/* Eval/evaluate_comp.scm 889 */
																switch ((long) CINT(BgL_arityz00_2144))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2023z00_2153;
																			obj_t BgL_arg2024z00_2154;

																			BgL_arg2023z00_2153 =
																				(BgL_spz00_2147 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2025z00_2155;

																				BgL_list2025z00_2155 =
																					MAKE_PAIR(BgL_a1z00_2140, BNIL);
																				BgL_arg2024z00_2154 =
																					BgL_list2025z00_2155;
																			}
																			VECTOR_SET(BgL_sz00_2136,
																				(int) (BgL_arg2023z00_2153),
																				BgL_arg2024z00_2154);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2027z00_2156;

																			BgL_arg2027z00_2156 =
																				(BgL_spz00_2147 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2136,
																				(int) (BgL_arg2027z00_2156),
																				BgL_a1z00_2140);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2028z00_2157;

																			BgL_arg2028z00_2157 =
																				(BgL_spz00_2147 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2136,
																				(int) (BgL_arg2028z00_2157), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_17837,
																			STRUCT_REF(BgL_ufz00_2142,
																				(int) (((long) 3))), (int) (((long) 1)),
																			CINT(BgL_arityz00_2144));
															}}
														else
															{	/* Eval/evaluate_comp.scm 889 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_17837, STRUCT_REF(BgL_ufz00_2142,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_2144));
													}}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_z12denvz12_2161;

													BgL_z12denvz12_2161 = BGL_CURRENT_DYNAMIC_ENV();
													if (
														((BgL_spz00_2147 +
																(long) CINT(BgL_sfz00_2146)) <
															(long) (VECTOR_LENGTH(BgL_sz00_2136))))
														{	/* Eval/evaluate_comp.scm 889 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_2145, BgL_sz00_2136,
																BINT(BgL_spz00_2147));
														}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_nsz00_2163;

															BgL_nsz00_2163 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 889 */
																long BgL_arg2033z00_2165;

																BgL_arg2033z00_2165 =
																	(BgL_spz00_2147 + ((long) 1));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_2163, ((long) 2), BgL_sz00_2136,
																	BINT(BgL_spz00_2147),
																	BINT(BgL_arg2033z00_2165));
															}
															VECTOR_SET(BgL_nsz00_2163,
																(int) (((long) 1)), BgL_sz00_2136);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2161,
																BgL_nsz00_2163);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_ez00_2166;

																BgL_ez00_2166 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2166, BgL_sz00_2136);
																{	/* Eval/evaluate_comp.scm 889 */
																	obj_t BgL_____rz00_2167;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_8356;

																		BgL_savedzd2bpzd2_8356 =
																			VECTOR_REF(BgL_nsz00_2163,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_2163,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_8363;

																			BgL_fz00_8363 = BgL_runz00_2145;
																		BgL_recz00_8362:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_8364;

																				BgL_rz00_8364 =
																					PROCEDURE_ENTRY(BgL_fz00_8363)
																					(BgL_fz00_8363, BgL_nsz00_2163, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_22204;

																					if (PROCEDUREP(BgL_rz00_8364))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_8369;

																							BgL_arg1673z00_8369 =
																								PROCEDURE_ATTR(BgL_rz00_8364);
																							if (STRUCTP(BgL_arg1673z00_8369))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_22204 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_8369) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_22204 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_22204 = ((bool_t) 0);
																						}
																					if (BgL_testz00_22204)
																						{
																							obj_t BgL_fz00_22212;

																							BgL_fz00_22212 = BgL_rz00_8364;
																							BgL_fz00_8363 = BgL_fz00_22212;
																							goto BgL_recz00_8362;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_2163,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_8356);
																							BgL_____rz00_2167 = BgL_rz00_8364;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_2166);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2161,
																		BgL_sz00_2136);
																	return BgL_____rz00_2167;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2139,
													(int) (((long) 1))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2169;

													BgL_nbpz00_2169 =
														((long) CINT(BgL_bpz00_2138) + BgL_siza7eza7_17839);
													VECTOR_SET(BgL_sz00_2136,
														(int) (((long) 0)), BINT(BgL_nbpz00_2169));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2170;

														BgL_rz00_2170 =
															PROCEDURE_ENTRY(BgL_fz00_2139) (BgL_fz00_2139,
															BgL_a1z00_2140, BEOA);
														VECTOR_SET(BgL_sz00_2136, (int) (((long) 0)),
															BgL_bpz00_2138);
														return BgL_rz00_2170;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17837, BgL_symbzd2funzd2_17838,
														(int) (((long) 1)), PROCEDURE_ARITY(BgL_fz00_2139));
		}}}}}}}}}
	}



/* comp-call2 */
	obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153,
		BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155,
		obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158,
		long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2173;

				BgL_cfunz00_2173 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154,
					((long) 2), BgL_locz00_153, BgL_symbzd2funzd2_155);
				if (CBOOL(BgL_cfunz00_2173))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_testz00_22237;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg2043z00_2190;

							BgL_arg2043z00_2190 = bgl_debug();
							BgL_testz00_22237 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2043z00_2190),
								BINT(((long) 0)));
						}
						if (BgL_testz00_22237)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32039ze3z83_17841;

								BgL_zc3anonymousza32039ze3z83_17841 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32039ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3anonymousza32039ze3z83_17841,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3anonymousza32039ze3z83_17841,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3anonymousza32039ze3z83_17841,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3anonymousza32039ze3z83_17841,
									(int) (((long) 3)), BgL_locz00_153);
								PROCEDURE_SET(BgL_zc3anonymousza32039ze3z83_17841,
									(int) (((long) 4)), BgL_cfunz00_2173);
								return BgL_zc3anonymousza32039ze3z83_17841;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32042ze3z83_17842;

								BgL_zc3anonymousza32042ze3z83_17842 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32042ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3anonymousza32042ze3z83_17842,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3anonymousza32042ze3z83_17842,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3anonymousza32042ze3z83_17842,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3anonymousza32042ze3z83_17842,
									(int) (((long) 3)), BgL_cfunz00_2173);
								return BgL_zc3anonymousza32042ze3z83_17842;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_157))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_22270;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2103z00_2281;

									BgL_arg2103z00_2281 = bgl_debug();
									BgL_testz00_22270 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2103z00_2281),
										BINT(((long) 0)));
								}
								if (BgL_testz00_22270)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32045ze3z83_17843;

										BgL_zc3anonymousza32045ze3z83_17843 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32045ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3anonymousza32045ze3z83_17843,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3anonymousza32045ze3z83_17843,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3anonymousza32045ze3z83_17843,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3anonymousza32045ze3z83_17843,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3anonymousza32045ze3z83_17843,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3anonymousza32045ze3z83_17843,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3anonymousza32045ze3z83_17843;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32074ze3z83_17844;

										BgL_zc3anonymousza32074ze3z83_17844 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32074ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3anonymousza32074ze3z83_17844,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3anonymousza32074ze3z83_17844,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3anonymousza32074ze3z83_17844,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3anonymousza32074ze3z83_17844,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3anonymousza32074ze3z83_17844,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3anonymousza32074ze3z83_17844,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3anonymousza32074ze3z83_17844;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_22307;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2160z00_2372;

									BgL_arg2160z00_2372 = bgl_debug();
									BgL_testz00_22307 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2160z00_2372),
										BINT(((long) 0)));
								}
								if (BgL_testz00_22307)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32105ze3z83_17845;

										BgL_zc3anonymousza32105ze3z83_17845 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32105ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3anonymousza32105ze3z83_17845,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3anonymousza32105ze3z83_17845,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3anonymousza32105ze3z83_17845,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3anonymousza32105ze3z83_17845,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3anonymousza32105ze3z83_17845,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3anonymousza32105ze3z83_17845,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3anonymousza32105ze3z83_17845;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32133ze3z83_17846;

										BgL_zc3anonymousza32133ze3z83_17846 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32133ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3anonymousza32133ze3z83_17846,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3anonymousza32133ze3z83_17846,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3anonymousza32133ze3z83_17846,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3anonymousza32133ze3z83_17846,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3anonymousza32133ze3z83_17846,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3anonymousza32133ze3z83_17846,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3anonymousza32133ze3z83_17846;
									}
							}
					}
			}
		}
	}



/* &<anonymous:2039> */
	obj_t BGl_z62zc3anonymousza32039ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17847, obj_t BgL_sz00_17853)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_17848;
				obj_t BgL_a2z00_17849;
				long BgL_siza7eza7_17850;
				obj_t BgL_locz00_17851;
				obj_t BgL_cfunz00_17852;

				BgL_a1z00_17848 = PROCEDURE_REF(BgL_envz00_17847, (int) (((long) 0)));
				BgL_a2z00_17849 = PROCEDURE_REF(BgL_envz00_17847, (int) (((long) 1)));
				BgL_siza7eza7_17850 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17847, (int) (((long) 2))));
				BgL_locz00_17851 = PROCEDURE_REF(BgL_envz00_17847, (int) (((long) 3)));
				BgL_cfunz00_17852 = PROCEDURE_REF(BgL_envz00_17847, (int) (((long) 4)));
				{
					obj_t BgL_sz00_2175;

					BgL_sz00_2175 = BgL_sz00_17853;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2177;

						BgL_bpz00_2177 = VECTOR_REF(BgL_sz00_2175, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_a1z00_2178;
							obj_t BgL_a2z00_2179;

							BgL_a1z00_2178 =
								PROCEDURE_ENTRY(BgL_a1z00_17848) (BgL_a1z00_17848,
								BgL_sz00_2175, BEOA);
							BgL_a2z00_2179 =
								PROCEDURE_ENTRY(BgL_a2z00_17849) (BgL_a2z00_17849,
								BgL_sz00_2175, BEOA);
							{	/* Eval/evaluate_comp.scm 889 */
								long BgL_nbpz00_2180;

								BgL_nbpz00_2180 =
									((long) CINT(BgL_bpz00_2177) + BgL_siza7eza7_17850);
								VECTOR_SET(BgL_sz00_2175,
									(int) (((long) 0)), BINT(BgL_nbpz00_2180));
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_auxz00_22370;

									BgL_auxz00_22370 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_22370,
										BgL_locz00_17851);
								}
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_rz00_2182;

									BgL_rz00_2182 =
										PROCEDURE_ENTRY(BgL_cfunz00_17852) (BgL_cfunz00_17852,
										BgL_a1z00_2178, BgL_a2z00_2179, BEOA);
									VECTOR_SET(BgL_sz00_2175, (int) (((long) 0)), BgL_bpz00_2177);
									return BgL_rz00_2182;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2042> */
	obj_t BGl_z62zc3anonymousza32042ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17854, obj_t BgL_sz00_17859)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_17855;
				obj_t BgL_a2z00_17856;
				long BgL_siza7eza7_17857;
				obj_t BgL_cfunz00_17858;

				BgL_a1z00_17855 = PROCEDURE_REF(BgL_envz00_17854, (int) (((long) 0)));
				BgL_a2z00_17856 = PROCEDURE_REF(BgL_envz00_17854, (int) (((long) 1)));
				BgL_siza7eza7_17857 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17854, (int) (((long) 2))));
				BgL_cfunz00_17858 = PROCEDURE_REF(BgL_envz00_17854, (int) (((long) 3)));
				{
					obj_t BgL_sz00_2183;

					BgL_sz00_2183 = BgL_sz00_17859;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2185;

						BgL_bpz00_2185 = VECTOR_REF(BgL_sz00_2183, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_a1z00_2186;
							obj_t BgL_a2z00_2187;

							BgL_a1z00_2186 =
								PROCEDURE_ENTRY(BgL_a1z00_17855) (BgL_a1z00_17855,
								BgL_sz00_2183, BEOA);
							BgL_a2z00_2187 =
								PROCEDURE_ENTRY(BgL_a2z00_17856) (BgL_a2z00_17856,
								BgL_sz00_2183, BEOA);
							{	/* Eval/evaluate_comp.scm 889 */
								long BgL_nbpz00_2188;

								BgL_nbpz00_2188 =
									((long) CINT(BgL_bpz00_2185) + BgL_siza7eza7_17857);
								VECTOR_SET(BgL_sz00_2183,
									(int) (((long) 0)), BINT(BgL_nbpz00_2188));
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_rz00_2189;

									BgL_rz00_2189 =
										PROCEDURE_ENTRY(BgL_cfunz00_17858) (BgL_cfunz00_17858,
										BgL_a1z00_2186, BgL_a2z00_2187, BEOA);
									VECTOR_SET(BgL_sz00_2183, (int) (((long) 0)), BgL_bpz00_2185);
									return BgL_rz00_2189;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2045> */
	obj_t BGl_z62zc3anonymousza32045ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17860, obj_t BgL_sz00_17867)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17861;
				obj_t BgL_a1z00_17862;
				obj_t BgL_a2z00_17863;
				obj_t BgL_locz00_17864;
				obj_t BgL_symbzd2funzd2_17865;
				long BgL_siza7eza7_17866;

				BgL_funz00_17861 = PROCEDURE_REF(BgL_envz00_17860, (int) (((long) 0)));
				BgL_a1z00_17862 = PROCEDURE_REF(BgL_envz00_17860, (int) (((long) 1)));
				BgL_a2z00_17863 = PROCEDURE_REF(BgL_envz00_17860, (int) (((long) 2)));
				BgL_locz00_17864 = PROCEDURE_REF(BgL_envz00_17860, (int) (((long) 3)));
				BgL_symbzd2funzd2_17865 =
					PROCEDURE_REF(BgL_envz00_17860, (int) (((long) 4)));
				BgL_siza7eza7_17866 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17860, (int) (((long) 5))));
				{
					obj_t BgL_sz00_2192;

					BgL_sz00_2192 = BgL_sz00_17867;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2194;

						BgL_bpz00_2194 = VECTOR_REF(BgL_sz00_2192, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2195;
							obj_t BgL_a1z00_2196;
							obj_t BgL_a2z00_2197;

							BgL_fz00_2195 =
								PROCEDURE_ENTRY(BgL_funz00_17861) (BgL_funz00_17861,
								BgL_sz00_2192, BEOA);
							BgL_a1z00_2196 =
								PROCEDURE_ENTRY(BgL_a1z00_17862) (BgL_a1z00_17862,
								BgL_sz00_2192, BEOA);
							BgL_a2z00_2197 =
								PROCEDURE_ENTRY(BgL_a2z00_17863) (BgL_a2z00_17863,
								BgL_sz00_2192, BEOA);
							if (PROCEDUREP(BgL_fz00_2195))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17864,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2195);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2199;

								BgL_ufz00_2199 = PROCEDURE_ATTR(BgL_fz00_2195);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_22442;

									if (STRUCTP(BgL_ufz00_2199))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22442 =
												(STRUCT_KEY(BgL_ufz00_2199) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22442 = ((bool_t) 0);
										}
									if (BgL_testz00_22442)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2201;
											obj_t BgL_runz00_2202;
											obj_t BgL_sfz00_2203;

											BgL_arityz00_2201 =
												STRUCT_REF(BgL_ufz00_2199, (int) (((long) 0)));
											BgL_runz00_2202 =
												STRUCT_REF(BgL_ufz00_2199, (int) (((long) 1)));
											BgL_sfz00_2203 =
												STRUCT_REF(BgL_ufz00_2199, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_2201) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2049z00_2206;

														BgL_arg2049z00_2206 =
															((long) CINT(BgL_bpz00_2194) + ((long) 0));
														VECTOR_SET(BgL_sz00_2192,
															(int) (BgL_arg2049z00_2206), BgL_a1z00_2196);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2050z00_2207;

														BgL_arg2050z00_2207 =
															((long) CINT(BgL_bpz00_2194) + ((long) 1));
														VECTOR_SET(BgL_sz00_2192,
															(int) (BgL_arg2050z00_2207), BgL_a2z00_2197);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_2201))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_2201))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2052z00_2211;
																		obj_t BgL_arg2053z00_2212;

																		BgL_arg2052z00_2211 =
																			(
																			(long) CINT(BgL_bpz00_2194) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2054z00_2213;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2056z00_2214;

																				BgL_arg2056z00_2214 =
																					MAKE_PAIR(BgL_a2z00_2197, BNIL);
																				BgL_list2054z00_2213 =
																					MAKE_PAIR(BgL_a1z00_2196,
																					BgL_arg2056z00_2214);
																			}
																			BgL_arg2053z00_2212 =
																				BgL_list2054z00_2213;
																		}
																		VECTOR_SET(BgL_sz00_2192,
																			(int) (BgL_arg2052z00_2211),
																			BgL_arg2053z00_2212);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2057z00_2215;

																		BgL_arg2057z00_2215 =
																			(
																			(long) CINT(BgL_bpz00_2194) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2192,
																			(int) (BgL_arg2057z00_2215),
																			BgL_a1z00_2196);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2058z00_2216;
																		obj_t BgL_arg2060z00_2217;

																		BgL_arg2058z00_2216 =
																			(
																			(long) CINT(BgL_bpz00_2194) + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2061z00_2218;

																			BgL_list2061z00_2218 =
																				MAKE_PAIR(BgL_a2z00_2197, BNIL);
																			BgL_arg2060z00_2217 =
																				BgL_list2061z00_2218;
																		}
																		VECTOR_SET(BgL_sz00_2192,
																			(int) (BgL_arg2058z00_2216),
																			BgL_arg2060z00_2217);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2062z00_2219;

																		BgL_arg2062z00_2219 =
																			(
																			(long) CINT(BgL_bpz00_2194) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2192,
																			(int) (BgL_arg2062z00_2219),
																			BgL_a1z00_2196);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2063z00_2220;

																		BgL_arg2063z00_2220 =
																			(
																			(long) CINT(BgL_bpz00_2194) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2192,
																			(int) (BgL_arg2063z00_2220),
																			BgL_a2z00_2197);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2064z00_2221;

																		BgL_arg2064z00_2221 =
																			(
																			(long) CINT(BgL_bpz00_2194) + ((long) 2));
																		VECTOR_SET(BgL_sz00_2192,
																			(int) (BgL_arg2064z00_2221), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_17864,
																		STRUCT_REF(BgL_ufz00_2199,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_2201));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_17864, STRUCT_REF(BgL_ufz00_2199,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_2201));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_2225;

												BgL_z12denvz12_2225 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_2225,
													BgL_locz00_17864);
												if ((((long) CINT(BgL_bpz00_2194) +
															(long) CINT(BgL_sfz00_2203)) <
														(long) (VECTOR_LENGTH(BgL_sz00_2192))))
													{	/* Eval/evaluate_comp.scm 889 */
														return BgL_runz00_2202;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_2227;

														BgL_nsz00_2227 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2070z00_2229;

															BgL_arg2070z00_2229 =
																((long) CINT(BgL_bpz00_2194) + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_2227, ((long) 2), BgL_sz00_2192,
																BgL_bpz00_2194, BINT(BgL_arg2070z00_2229));
														}
														VECTOR_SET(BgL_nsz00_2227,
															(int) (((long) 1)), BgL_sz00_2192);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2225,
															BgL_nsz00_2227);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_2230;

															BgL_ez00_2230 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_2230, BgL_sz00_2192);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_2231;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_8529;

																	BgL_savedzd2bpzd2_8529 =
																		VECTOR_REF(BgL_nsz00_2227,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_2227,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_8536;

																		BgL_fz00_8536 = BgL_runz00_2202;
																	BgL_recz00_8535:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_8537;

																			BgL_rz00_8537 =
																				PROCEDURE_ENTRY(BgL_fz00_8536)
																				(BgL_fz00_8536, BgL_nsz00_2227, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_22533;

																				if (PROCEDUREP(BgL_rz00_8537))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_8542;

																						BgL_arg1673z00_8542 =
																							PROCEDURE_ATTR(BgL_rz00_8537);
																						if (STRUCTP(BgL_arg1673z00_8542))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_22533 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_8542) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_22533 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_22533 = ((bool_t) 0);
																					}
																				if (BgL_testz00_22533)
																					{
																						obj_t BgL_fz00_22541;

																						BgL_fz00_22541 = BgL_rz00_8537;
																						BgL_fz00_8536 = BgL_fz00_22541;
																						goto BgL_recz00_8535;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_2227,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_8529);
																						BgL_____rz00_2231 = BgL_rz00_8537;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2230);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2225,
																	BgL_sz00_2192);
																return BgL_____rz00_2231;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2195,
													(int) (((long) 2))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2233;

													BgL_nbpz00_2233 =
														((long) CINT(BgL_bpz00_2194) + BgL_siza7eza7_17866);
													VECTOR_SET(BgL_sz00_2192,
														(int) (((long) 0)), BINT(BgL_nbpz00_2233));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_auxz00_22554;

														BgL_auxz00_22554 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_22554,
															BgL_locz00_17864);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2235;

														BgL_rz00_2235 =
															PROCEDURE_ENTRY(BgL_fz00_2195) (BgL_fz00_2195,
															BgL_a1z00_2196, BgL_a2z00_2197, BEOA);
														VECTOR_SET(BgL_sz00_2192, (int) (((long) 0)),
															BgL_bpz00_2194);
														return BgL_rz00_2235;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17864, BgL_symbzd2funzd2_17865,
														(int) (((long) 2)), PROCEDURE_ARITY(BgL_fz00_2195));
		}}}}}}}}}
	}



/* &<anonymous:2074> */
	obj_t BGl_z62zc3anonymousza32074ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17868, obj_t BgL_sz00_17875)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17869;
				obj_t BgL_a1z00_17870;
				obj_t BgL_a2z00_17871;
				obj_t BgL_locz00_17872;
				obj_t BgL_symbzd2funzd2_17873;
				long BgL_siza7eza7_17874;

				BgL_funz00_17869 = PROCEDURE_REF(BgL_envz00_17868, (int) (((long) 0)));
				BgL_a1z00_17870 = PROCEDURE_REF(BgL_envz00_17868, (int) (((long) 1)));
				BgL_a2z00_17871 = PROCEDURE_REF(BgL_envz00_17868, (int) (((long) 2)));
				BgL_locz00_17872 = PROCEDURE_REF(BgL_envz00_17868, (int) (((long) 3)));
				BgL_symbzd2funzd2_17873 =
					PROCEDURE_REF(BgL_envz00_17868, (int) (((long) 4)));
				BgL_siza7eza7_17874 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17868, (int) (((long) 5))));
				{
					obj_t BgL_sz00_2237;

					BgL_sz00_2237 = BgL_sz00_17875;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2239;

						BgL_bpz00_2239 = VECTOR_REF(BgL_sz00_2237, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2240;
							obj_t BgL_a1z00_2241;
							obj_t BgL_a2z00_2242;

							BgL_fz00_2240 =
								PROCEDURE_ENTRY(BgL_funz00_17869) (BgL_funz00_17869,
								BgL_sz00_2237, BEOA);
							BgL_a1z00_2241 =
								PROCEDURE_ENTRY(BgL_a1z00_17870) (BgL_a1z00_17870,
								BgL_sz00_2237, BEOA);
							BgL_a2z00_2242 =
								PROCEDURE_ENTRY(BgL_a2z00_17871) (BgL_a2z00_17871,
								BgL_sz00_2237, BEOA);
							if (PROCEDUREP(BgL_fz00_2240))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17872,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2240);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2244;

								BgL_ufz00_2244 = PROCEDURE_ATTR(BgL_fz00_2240);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_22598;

									if (STRUCTP(BgL_ufz00_2244))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22598 =
												(STRUCT_KEY(BgL_ufz00_2244) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22598 = ((bool_t) 0);
										}
									if (BgL_testz00_22598)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2246;
											obj_t BgL_runz00_2247;
											obj_t BgL_sfz00_2248;

											BgL_arityz00_2246 =
												STRUCT_REF(BgL_ufz00_2244, (int) (((long) 0)));
											BgL_runz00_2247 =
												STRUCT_REF(BgL_ufz00_2244, (int) (((long) 1)));
											BgL_sfz00_2248 =
												STRUCT_REF(BgL_ufz00_2244, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_2246) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2078z00_2251;

														BgL_arg2078z00_2251 =
															((long) CINT(BgL_bpz00_2239) + ((long) 0));
														VECTOR_SET(BgL_sz00_2237,
															(int) (BgL_arg2078z00_2251), BgL_a1z00_2241);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2079z00_2252;

														BgL_arg2079z00_2252 =
															((long) CINT(BgL_bpz00_2239) + ((long) 1));
														VECTOR_SET(BgL_sz00_2237,
															(int) (BgL_arg2079z00_2252), BgL_a2z00_2242);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_2246))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_2246))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2081z00_2256;
																		obj_t BgL_arg2082z00_2257;

																		BgL_arg2081z00_2256 =
																			(
																			(long) CINT(BgL_bpz00_2239) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2083z00_2258;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2086z00_2259;

																				BgL_arg2086z00_2259 =
																					MAKE_PAIR(BgL_a2z00_2242, BNIL);
																				BgL_list2083z00_2258 =
																					MAKE_PAIR(BgL_a1z00_2241,
																					BgL_arg2086z00_2259);
																			}
																			BgL_arg2082z00_2257 =
																				BgL_list2083z00_2258;
																		}
																		VECTOR_SET(BgL_sz00_2237,
																			(int) (BgL_arg2081z00_2256),
																			BgL_arg2082z00_2257);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2087z00_2260;

																		BgL_arg2087z00_2260 =
																			(
																			(long) CINT(BgL_bpz00_2239) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2237,
																			(int) (BgL_arg2087z00_2260),
																			BgL_a1z00_2241);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2088z00_2261;
																		obj_t BgL_arg2089z00_2262;

																		BgL_arg2088z00_2261 =
																			(
																			(long) CINT(BgL_bpz00_2239) + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2090z00_2263;

																			BgL_list2090z00_2263 =
																				MAKE_PAIR(BgL_a2z00_2242, BNIL);
																			BgL_arg2089z00_2262 =
																				BgL_list2090z00_2263;
																		}
																		VECTOR_SET(BgL_sz00_2237,
																			(int) (BgL_arg2088z00_2261),
																			BgL_arg2089z00_2262);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2092z00_2264;

																		BgL_arg2092z00_2264 =
																			(
																			(long) CINT(BgL_bpz00_2239) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2237,
																			(int) (BgL_arg2092z00_2264),
																			BgL_a1z00_2241);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2093z00_2265;

																		BgL_arg2093z00_2265 =
																			(
																			(long) CINT(BgL_bpz00_2239) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2237,
																			(int) (BgL_arg2093z00_2265),
																			BgL_a2z00_2242);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2095z00_2266;

																		BgL_arg2095z00_2266 =
																			(
																			(long) CINT(BgL_bpz00_2239) + ((long) 2));
																		VECTOR_SET(BgL_sz00_2237,
																			(int) (BgL_arg2095z00_2266), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_17872,
																		STRUCT_REF(BgL_ufz00_2244,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_2246));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_17872, STRUCT_REF(BgL_ufz00_2244,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_2246));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_2270;

												BgL_z12denvz12_2270 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_2239) +
															(long) CINT(BgL_sfz00_2248)) <
														(long) (VECTOR_LENGTH(BgL_sz00_2237))))
													{	/* Eval/evaluate_comp.scm 889 */
														return BgL_runz00_2247;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_2272;

														BgL_nsz00_2272 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2100z00_2274;

															BgL_arg2100z00_2274 =
																((long) CINT(BgL_bpz00_2239) + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_2272, ((long) 2), BgL_sz00_2237,
																BgL_bpz00_2239, BINT(BgL_arg2100z00_2274));
														}
														VECTOR_SET(BgL_nsz00_2272,
															(int) (((long) 1)), BgL_sz00_2237);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2270,
															BgL_nsz00_2272);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_2275;

															BgL_ez00_2275 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_2275, BgL_sz00_2237);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_2276;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_8680;

																	BgL_savedzd2bpzd2_8680 =
																		VECTOR_REF(BgL_nsz00_2272,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_2272,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_8687;

																		BgL_fz00_8687 = BgL_runz00_2247;
																	BgL_recz00_8686:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_8688;

																			BgL_rz00_8688 =
																				PROCEDURE_ENTRY(BgL_fz00_8687)
																				(BgL_fz00_8687, BgL_nsz00_2272, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_22688;

																				if (PROCEDUREP(BgL_rz00_8688))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_8693;

																						BgL_arg1673z00_8693 =
																							PROCEDURE_ATTR(BgL_rz00_8688);
																						if (STRUCTP(BgL_arg1673z00_8693))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_22688 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_8693) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_22688 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_22688 = ((bool_t) 0);
																					}
																				if (BgL_testz00_22688)
																					{
																						obj_t BgL_fz00_22696;

																						BgL_fz00_22696 = BgL_rz00_8688;
																						BgL_fz00_8687 = BgL_fz00_22696;
																						goto BgL_recz00_8686;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_2272,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_8680);
																						BgL_____rz00_2276 = BgL_rz00_8688;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2275);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2270,
																	BgL_sz00_2237);
																return BgL_____rz00_2276;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2240,
													(int) (((long) 2))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2278;

													BgL_nbpz00_2278 =
														((long) CINT(BgL_bpz00_2239) + BgL_siza7eza7_17874);
													VECTOR_SET(BgL_sz00_2237,
														(int) (((long) 0)), BINT(BgL_nbpz00_2278));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2279;

														BgL_rz00_2279 =
															PROCEDURE_ENTRY(BgL_fz00_2240) (BgL_fz00_2240,
															BgL_a1z00_2241, BgL_a2z00_2242, BEOA);
														VECTOR_SET(BgL_sz00_2237, (int) (((long) 0)),
															BgL_bpz00_2239);
														return BgL_rz00_2279;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17872, BgL_symbzd2funzd2_17873,
														(int) (((long) 2)), PROCEDURE_ARITY(BgL_fz00_2240));
		}}}}}}}}}
	}



/* &<anonymous:2105> */
	obj_t BGl_z62zc3anonymousza32105ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17876, obj_t BgL_sz00_17883)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17877;
				obj_t BgL_a1z00_17878;
				obj_t BgL_a2z00_17879;
				obj_t BgL_locz00_17880;
				obj_t BgL_symbzd2funzd2_17881;
				long BgL_siza7eza7_17882;

				BgL_funz00_17877 = PROCEDURE_REF(BgL_envz00_17876, (int) (((long) 0)));
				BgL_a1z00_17878 = PROCEDURE_REF(BgL_envz00_17876, (int) (((long) 1)));
				BgL_a2z00_17879 = PROCEDURE_REF(BgL_envz00_17876, (int) (((long) 2)));
				BgL_locz00_17880 = PROCEDURE_REF(BgL_envz00_17876, (int) (((long) 3)));
				BgL_symbzd2funzd2_17881 =
					PROCEDURE_REF(BgL_envz00_17876, (int) (((long) 4)));
				BgL_siza7eza7_17882 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17876, (int) (((long) 5))));
				{
					obj_t BgL_sz00_2283;

					BgL_sz00_2283 = BgL_sz00_17883;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2285;

						BgL_bpz00_2285 = VECTOR_REF(BgL_sz00_2283, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2286;
							obj_t BgL_a1z00_2287;
							obj_t BgL_a2z00_2288;

							BgL_fz00_2286 =
								PROCEDURE_ENTRY(BgL_funz00_17877) (BgL_funz00_17877,
								BgL_sz00_2283, BEOA);
							BgL_a1z00_2287 =
								PROCEDURE_ENTRY(BgL_a1z00_17878) (BgL_a1z00_17878,
								BgL_sz00_2283, BEOA);
							BgL_a2z00_2288 =
								PROCEDURE_ENTRY(BgL_a2z00_17879) (BgL_a2z00_17879,
								BgL_sz00_2283, BEOA);
							if (PROCEDUREP(BgL_fz00_2286))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17880,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2286);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2290;

								BgL_ufz00_2290 = PROCEDURE_ATTR(BgL_fz00_2286);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_22750;

									if (STRUCTP(BgL_ufz00_2290))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22750 =
												(STRUCT_KEY(BgL_ufz00_2290) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22750 = ((bool_t) 0);
										}
									if (BgL_testz00_22750)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2292;
											obj_t BgL_runz00_2293;
											obj_t BgL_sfz00_2294;

											BgL_arityz00_2292 =
												STRUCT_REF(BgL_ufz00_2290, (int) (((long) 0)));
											BgL_runz00_2293 =
												STRUCT_REF(BgL_ufz00_2290, (int) (((long) 1)));
											BgL_sfz00_2294 =
												STRUCT_REF(BgL_ufz00_2290, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_spz00_2295;

												BgL_spz00_2295 =
													((long) CINT(BgL_bpz00_2285) + BgL_siza7eza7_17882);
												if (((long) CINT(BgL_arityz00_2292) == ((long) 2)))
													{	/* Eval/evaluate_comp.scm 889 */
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2109z00_2297;

															BgL_arg2109z00_2297 =
																(BgL_spz00_2295 + ((long) 0));
															VECTOR_SET(BgL_sz00_2283,
																(int) (BgL_arg2109z00_2297), BgL_a1z00_2287);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2110z00_2298;

															BgL_arg2110z00_2298 =
																(BgL_spz00_2295 + ((long) 1));
															VECTOR_SET(BgL_sz00_2283,
																(int) (BgL_arg2110z00_2298), BgL_a2z00_2288);
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														if (INTEGERP(BgL_arityz00_2292))
															{	/* Eval/evaluate_comp.scm 889 */
																switch ((long) CINT(BgL_arityz00_2292))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2112z00_2302;
																			obj_t BgL_arg2113z00_2303;

																			BgL_arg2112z00_2302 =
																				(BgL_spz00_2295 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2114z00_2304;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2116z00_2305;

																					BgL_arg2116z00_2305 =
																						MAKE_PAIR(BgL_a2z00_2288, BNIL);
																					BgL_list2114z00_2304 =
																						MAKE_PAIR(BgL_a1z00_2287,
																						BgL_arg2116z00_2305);
																				}
																				BgL_arg2113z00_2303 =
																					BgL_list2114z00_2304;
																			}
																			VECTOR_SET(BgL_sz00_2283,
																				(int) (BgL_arg2112z00_2302),
																				BgL_arg2113z00_2303);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2117z00_2306;

																			BgL_arg2117z00_2306 =
																				(BgL_spz00_2295 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2283,
																				(int) (BgL_arg2117z00_2306),
																				BgL_a1z00_2287);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2118z00_2307;
																			obj_t BgL_arg2120z00_2308;

																			BgL_arg2118z00_2307 =
																				(BgL_spz00_2295 + ((long) 1));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2121z00_2309;

																				BgL_list2121z00_2309 =
																					MAKE_PAIR(BgL_a2z00_2288, BNIL);
																				BgL_arg2120z00_2308 =
																					BgL_list2121z00_2309;
																			}
																			VECTOR_SET(BgL_sz00_2283,
																				(int) (BgL_arg2118z00_2307),
																				BgL_arg2120z00_2308);
																		} break;
																	case ((long) -3):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2122z00_2310;

																			BgL_arg2122z00_2310 =
																				(BgL_spz00_2295 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2283,
																				(int) (BgL_arg2122z00_2310),
																				BgL_a1z00_2287);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2123z00_2311;

																			BgL_arg2123z00_2311 =
																				(BgL_spz00_2295 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2283,
																				(int) (BgL_arg2123z00_2311),
																				BgL_a2z00_2288);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2124z00_2312;

																			BgL_arg2124z00_2312 =
																				(BgL_spz00_2295 + ((long) 2));
																			VECTOR_SET(BgL_sz00_2283,
																				(int) (BgL_arg2124z00_2312), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_17880,
																			STRUCT_REF(BgL_ufz00_2290,
																				(int) (((long) 3))), (int) (((long) 2)),
																			CINT(BgL_arityz00_2292));
															}}
														else
															{	/* Eval/evaluate_comp.scm 889 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_17880, STRUCT_REF(BgL_ufz00_2290,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_2292));
													}}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_z12denvz12_2316;

													BgL_z12denvz12_2316 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_2316,
														BgL_locz00_17880);
													if (((BgL_spz00_2295 + (long) CINT(BgL_sfz00_2294)) <
															(long) (VECTOR_LENGTH(BgL_sz00_2283))))
														{	/* Eval/evaluate_comp.scm 889 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_2293, BgL_sz00_2283,
																BINT(BgL_spz00_2295));
														}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_nsz00_2318;

															BgL_nsz00_2318 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 889 */
																long BgL_arg2129z00_2320;

																BgL_arg2129z00_2320 =
																	(BgL_spz00_2295 + ((long) 2));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_2318, ((long) 2), BgL_sz00_2283,
																	BINT(BgL_spz00_2295),
																	BINT(BgL_arg2129z00_2320));
															}
															VECTOR_SET(BgL_nsz00_2318,
																(int) (((long) 1)), BgL_sz00_2283);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2316,
																BgL_nsz00_2318);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_ez00_2321;

																BgL_ez00_2321 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2321, BgL_sz00_2283);
																{	/* Eval/evaluate_comp.scm 889 */
																	obj_t BgL_____rz00_2322;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_8829;

																		BgL_savedzd2bpzd2_8829 =
																			VECTOR_REF(BgL_nsz00_2318,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_2318,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_8836;

																			BgL_fz00_8836 = BgL_runz00_2293;
																		BgL_recz00_8835:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_8837;

																				BgL_rz00_8837 =
																					PROCEDURE_ENTRY(BgL_fz00_8836)
																					(BgL_fz00_8836, BgL_nsz00_2318, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_22836;

																					if (PROCEDUREP(BgL_rz00_8837))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_8842;

																							BgL_arg1673z00_8842 =
																								PROCEDURE_ATTR(BgL_rz00_8837);
																							if (STRUCTP(BgL_arg1673z00_8842))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_22836 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_8842) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_22836 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_22836 = ((bool_t) 0);
																						}
																					if (BgL_testz00_22836)
																						{
																							obj_t BgL_fz00_22844;

																							BgL_fz00_22844 = BgL_rz00_8837;
																							BgL_fz00_8836 = BgL_fz00_22844;
																							goto BgL_recz00_8835;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_2318,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_8829);
																							BgL_____rz00_2322 = BgL_rz00_8837;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_2321);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2316,
																		BgL_sz00_2283);
																	return BgL_____rz00_2322;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2286,
													(int) (((long) 2))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2324;

													BgL_nbpz00_2324 =
														((long) CINT(BgL_bpz00_2285) + BgL_siza7eza7_17882);
													VECTOR_SET(BgL_sz00_2283,
														(int) (((long) 0)), BINT(BgL_nbpz00_2324));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_auxz00_22857;

														BgL_auxz00_22857 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_22857,
															BgL_locz00_17880);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2326;

														BgL_rz00_2326 =
															PROCEDURE_ENTRY(BgL_fz00_2286) (BgL_fz00_2286,
															BgL_a1z00_2287, BgL_a2z00_2288, BEOA);
														VECTOR_SET(BgL_sz00_2283, (int) (((long) 0)),
															BgL_bpz00_2285);
														return BgL_rz00_2326;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17880, BgL_symbzd2funzd2_17881,
														(int) (((long) 2)), PROCEDURE_ARITY(BgL_fz00_2286));
		}}}}}}}}}
	}



/* &<anonymous:2133> */
	obj_t BGl_z62zc3anonymousza32133ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17884, obj_t BgL_sz00_17891)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17885;
				obj_t BgL_a1z00_17886;
				obj_t BgL_a2z00_17887;
				obj_t BgL_locz00_17888;
				obj_t BgL_symbzd2funzd2_17889;
				long BgL_siza7eza7_17890;

				BgL_funz00_17885 = PROCEDURE_REF(BgL_envz00_17884, (int) (((long) 0)));
				BgL_a1z00_17886 = PROCEDURE_REF(BgL_envz00_17884, (int) (((long) 1)));
				BgL_a2z00_17887 = PROCEDURE_REF(BgL_envz00_17884, (int) (((long) 2)));
				BgL_locz00_17888 = PROCEDURE_REF(BgL_envz00_17884, (int) (((long) 3)));
				BgL_symbzd2funzd2_17889 =
					PROCEDURE_REF(BgL_envz00_17884, (int) (((long) 4)));
				BgL_siza7eza7_17890 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17884, (int) (((long) 5))));
				{
					obj_t BgL_sz00_2328;

					BgL_sz00_2328 = BgL_sz00_17891;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2330;

						BgL_bpz00_2330 = VECTOR_REF(BgL_sz00_2328, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2331;
							obj_t BgL_a1z00_2332;
							obj_t BgL_a2z00_2333;

							BgL_fz00_2331 =
								PROCEDURE_ENTRY(BgL_funz00_17885) (BgL_funz00_17885,
								BgL_sz00_2328, BEOA);
							BgL_a1z00_2332 =
								PROCEDURE_ENTRY(BgL_a1z00_17886) (BgL_a1z00_17886,
								BgL_sz00_2328, BEOA);
							BgL_a2z00_2333 =
								PROCEDURE_ENTRY(BgL_a2z00_17887) (BgL_a2z00_17887,
								BgL_sz00_2328, BEOA);
							if (PROCEDUREP(BgL_fz00_2331))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17888,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2331);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2335;

								BgL_ufz00_2335 = PROCEDURE_ATTR(BgL_fz00_2331);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_22901;

									if (STRUCTP(BgL_ufz00_2335))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22901 =
												(STRUCT_KEY(BgL_ufz00_2335) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_22901 = ((bool_t) 0);
										}
									if (BgL_testz00_22901)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2337;
											obj_t BgL_runz00_2338;
											obj_t BgL_sfz00_2339;

											BgL_arityz00_2337 =
												STRUCT_REF(BgL_ufz00_2335, (int) (((long) 0)));
											BgL_runz00_2338 =
												STRUCT_REF(BgL_ufz00_2335, (int) (((long) 1)));
											BgL_sfz00_2339 =
												STRUCT_REF(BgL_ufz00_2335, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_spz00_2340;

												BgL_spz00_2340 =
													((long) CINT(BgL_bpz00_2330) + BgL_siza7eza7_17890);
												if (((long) CINT(BgL_arityz00_2337) == ((long) 2)))
													{	/* Eval/evaluate_comp.scm 889 */
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2137z00_2342;

															BgL_arg2137z00_2342 =
																(BgL_spz00_2340 + ((long) 0));
															VECTOR_SET(BgL_sz00_2328,
																(int) (BgL_arg2137z00_2342), BgL_a1z00_2332);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2138z00_2343;

															BgL_arg2138z00_2343 =
																(BgL_spz00_2340 + ((long) 1));
															VECTOR_SET(BgL_sz00_2328,
																(int) (BgL_arg2138z00_2343), BgL_a2z00_2333);
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														if (INTEGERP(BgL_arityz00_2337))
															{	/* Eval/evaluate_comp.scm 889 */
																switch ((long) CINT(BgL_arityz00_2337))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2140z00_2347;
																			obj_t BgL_arg2141z00_2348;

																			BgL_arg2140z00_2347 =
																				(BgL_spz00_2340 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2142z00_2349;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2143z00_2350;

																					BgL_arg2143z00_2350 =
																						MAKE_PAIR(BgL_a2z00_2333, BNIL);
																					BgL_list2142z00_2349 =
																						MAKE_PAIR(BgL_a1z00_2332,
																						BgL_arg2143z00_2350);
																				}
																				BgL_arg2141z00_2348 =
																					BgL_list2142z00_2349;
																			}
																			VECTOR_SET(BgL_sz00_2328,
																				(int) (BgL_arg2140z00_2347),
																				BgL_arg2141z00_2348);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2145z00_2351;

																			BgL_arg2145z00_2351 =
																				(BgL_spz00_2340 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2328,
																				(int) (BgL_arg2145z00_2351),
																				BgL_a1z00_2332);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2146z00_2352;
																			obj_t BgL_arg2147z00_2353;

																			BgL_arg2146z00_2352 =
																				(BgL_spz00_2340 + ((long) 1));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2148z00_2354;

																				BgL_list2148z00_2354 =
																					MAKE_PAIR(BgL_a2z00_2333, BNIL);
																				BgL_arg2147z00_2353 =
																					BgL_list2148z00_2354;
																			}
																			VECTOR_SET(BgL_sz00_2328,
																				(int) (BgL_arg2146z00_2352),
																				BgL_arg2147z00_2353);
																		} break;
																	case ((long) -3):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2149z00_2355;

																			BgL_arg2149z00_2355 =
																				(BgL_spz00_2340 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2328,
																				(int) (BgL_arg2149z00_2355),
																				BgL_a1z00_2332);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2150z00_2356;

																			BgL_arg2150z00_2356 =
																				(BgL_spz00_2340 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2328,
																				(int) (BgL_arg2150z00_2356),
																				BgL_a2z00_2333);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2151z00_2357;

																			BgL_arg2151z00_2357 =
																				(BgL_spz00_2340 + ((long) 2));
																			VECTOR_SET(BgL_sz00_2328,
																				(int) (BgL_arg2151z00_2357), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_17888,
																			STRUCT_REF(BgL_ufz00_2335,
																				(int) (((long) 3))), (int) (((long) 2)),
																			CINT(BgL_arityz00_2337));
															}}
														else
															{	/* Eval/evaluate_comp.scm 889 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_17888, STRUCT_REF(BgL_ufz00_2335,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_2337));
													}}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_z12denvz12_2361;

													BgL_z12denvz12_2361 = BGL_CURRENT_DYNAMIC_ENV();
													if (
														((BgL_spz00_2340 +
																(long) CINT(BgL_sfz00_2339)) <
															(long) (VECTOR_LENGTH(BgL_sz00_2328))))
														{	/* Eval/evaluate_comp.scm 889 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_2338, BgL_sz00_2328,
																BINT(BgL_spz00_2340));
														}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_nsz00_2363;

															BgL_nsz00_2363 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 889 */
																long BgL_arg2157z00_2365;

																BgL_arg2157z00_2365 =
																	(BgL_spz00_2340 + ((long) 2));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_2363, ((long) 2), BgL_sz00_2328,
																	BINT(BgL_spz00_2340),
																	BINT(BgL_arg2157z00_2365));
															}
															VECTOR_SET(BgL_nsz00_2363,
																(int) (((long) 1)), BgL_sz00_2328);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2361,
																BgL_nsz00_2363);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_ez00_2366;

																BgL_ez00_2366 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2366, BgL_sz00_2328);
																{	/* Eval/evaluate_comp.scm 889 */
																	obj_t BgL_____rz00_2367;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_8979;

																		BgL_savedzd2bpzd2_8979 =
																			VECTOR_REF(BgL_nsz00_2363,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_2363,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_8986;

																			BgL_fz00_8986 = BgL_runz00_2338;
																		BgL_recz00_8985:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_8987;

																				BgL_rz00_8987 =
																					PROCEDURE_ENTRY(BgL_fz00_8986)
																					(BgL_fz00_8986, BgL_nsz00_2363, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_22986;

																					if (PROCEDUREP(BgL_rz00_8987))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_8992;

																							BgL_arg1673z00_8992 =
																								PROCEDURE_ATTR(BgL_rz00_8987);
																							if (STRUCTP(BgL_arg1673z00_8992))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_22986 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_8992) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_22986 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_22986 = ((bool_t) 0);
																						}
																					if (BgL_testz00_22986)
																						{
																							obj_t BgL_fz00_22994;

																							BgL_fz00_22994 = BgL_rz00_8987;
																							BgL_fz00_8986 = BgL_fz00_22994;
																							goto BgL_recz00_8985;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_2363,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_8979);
																							BgL_____rz00_2367 = BgL_rz00_8987;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_2366);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2361,
																		BgL_sz00_2328);
																	return BgL_____rz00_2367;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2331,
													(int) (((long) 2))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2369;

													BgL_nbpz00_2369 =
														((long) CINT(BgL_bpz00_2330) + BgL_siza7eza7_17890);
													VECTOR_SET(BgL_sz00_2328,
														(int) (((long) 0)), BINT(BgL_nbpz00_2369));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2370;

														BgL_rz00_2370 =
															PROCEDURE_ENTRY(BgL_fz00_2331) (BgL_fz00_2331,
															BgL_a1z00_2332, BgL_a2z00_2333, BEOA);
														VECTOR_SET(BgL_sz00_2328, (int) (((long) 0)),
															BgL_bpz00_2330);
														return BgL_rz00_2370;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17888, BgL_symbzd2funzd2_17889,
														(int) (((long) 2)), PROCEDURE_ARITY(BgL_fz00_2331));
		}}}}}}}}}
	}



/* comp-call3 */
	obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162,
		BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164,
		obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167,
		long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170,
		obj_t BgL_a3z00_171)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2373;

				BgL_cfunz00_2373 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163,
					((long) 3), BgL_locz00_162, BgL_symbzd2funzd2_164);
				if (CBOOL(BgL_cfunz00_2373))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_testz00_23020;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg2165z00_2392;

							BgL_arg2165z00_2392 = bgl_debug();
							BgL_testz00_23020 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2165z00_2392),
								BINT(((long) 0)));
						}
						if (BgL_testz00_23020)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32162ze3z83_17892;

								BgL_zc3anonymousza32162ze3z83_17892 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32162ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3anonymousza32162ze3z83_17892,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3anonymousza32162ze3z83_17892,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3anonymousza32162ze3z83_17892,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3anonymousza32162ze3z83_17892,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3anonymousza32162ze3z83_17892,
									(int) (((long) 4)), BgL_locz00_162);
								PROCEDURE_SET(BgL_zc3anonymousza32162ze3z83_17892,
									(int) (((long) 5)), BgL_cfunz00_2373);
								return BgL_zc3anonymousza32162ze3z83_17892;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32164ze3z83_17893;

								BgL_zc3anonymousza32164ze3z83_17893 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32164ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3anonymousza32164ze3z83_17893,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3anonymousza32164ze3z83_17893,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3anonymousza32164ze3z83_17893,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3anonymousza32164ze3z83_17893,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3anonymousza32164ze3z83_17893,
									(int) (((long) 4)), BgL_cfunz00_2373);
								return BgL_zc3anonymousza32164ze3z83_17893;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_166))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_23057;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2238z00_2503;

									BgL_arg2238z00_2503 = bgl_debug();
									BgL_testz00_23057 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2238z00_2503),
										BINT(((long) 0)));
								}
								if (BgL_testz00_23057)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32167ze3z83_17894;

										BgL_zc3anonymousza32167ze3z83_17894 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32167ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3anonymousza32167ze3z83_17894,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3anonymousza32167ze3z83_17894,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3anonymousza32167ze3z83_17894,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3anonymousza32167ze3z83_17894,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3anonymousza32167ze3z83_17894,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3anonymousza32167ze3z83_17894,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3anonymousza32167ze3z83_17894,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3anonymousza32167ze3z83_17894;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32203ze3z83_17895;

										BgL_zc3anonymousza32203ze3z83_17895 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32203ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3anonymousza32203ze3z83_17895,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3anonymousza32203ze3z83_17895,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3anonymousza32203ze3z83_17895,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3anonymousza32203ze3z83_17895,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3anonymousza32203ze3z83_17895,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3anonymousza32203ze3z83_17895,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3anonymousza32203ze3z83_17895,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3anonymousza32203ze3z83_17895;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_23098;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2312z00_2614;

									BgL_arg2312z00_2614 = bgl_debug();
									BgL_testz00_23098 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2312z00_2614),
										BINT(((long) 0)));
								}
								if (BgL_testz00_23098)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32240ze3z83_17896;

										BgL_zc3anonymousza32240ze3z83_17896 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32240ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3anonymousza32240ze3z83_17896,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3anonymousza32240ze3z83_17896,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3anonymousza32240ze3z83_17896,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3anonymousza32240ze3z83_17896,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3anonymousza32240ze3z83_17896,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3anonymousza32240ze3z83_17896,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3anonymousza32240ze3z83_17896,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3anonymousza32240ze3z83_17896;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32276ze3z83_17897;

										BgL_zc3anonymousza32276ze3z83_17897 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32276ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3anonymousza32276ze3z83_17897,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3anonymousza32276ze3z83_17897,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3anonymousza32276ze3z83_17897,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3anonymousza32276ze3z83_17897,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3anonymousza32276ze3z83_17897,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3anonymousza32276ze3z83_17897,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3anonymousza32276ze3z83_17897,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3anonymousza32276ze3z83_17897;
									}
							}
					}
			}
		}
	}



/* &<anonymous:2162> */
	obj_t BGl_z62zc3anonymousza32162ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17898, obj_t BgL_sz00_17905)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_17899;
				obj_t BgL_a2z00_17900;
				obj_t BgL_a3z00_17901;
				long BgL_siza7eza7_17902;
				obj_t BgL_locz00_17903;
				obj_t BgL_cfunz00_17904;

				BgL_a1z00_17899 = PROCEDURE_REF(BgL_envz00_17898, (int) (((long) 0)));
				BgL_a2z00_17900 = PROCEDURE_REF(BgL_envz00_17898, (int) (((long) 1)));
				BgL_a3z00_17901 = PROCEDURE_REF(BgL_envz00_17898, (int) (((long) 2)));
				BgL_siza7eza7_17902 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17898, (int) (((long) 3))));
				BgL_locz00_17903 = PROCEDURE_REF(BgL_envz00_17898, (int) (((long) 4)));
				BgL_cfunz00_17904 = PROCEDURE_REF(BgL_envz00_17898, (int) (((long) 5)));
				{
					obj_t BgL_sz00_2375;

					BgL_sz00_2375 = BgL_sz00_17905;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2377;

						BgL_bpz00_2377 = VECTOR_REF(BgL_sz00_2375, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_a1z00_2378;
							obj_t BgL_a2z00_2379;
							obj_t BgL_a3z00_2380;

							BgL_a1z00_2378 =
								PROCEDURE_ENTRY(BgL_a1z00_17899) (BgL_a1z00_17899,
								BgL_sz00_2375, BEOA);
							BgL_a2z00_2379 =
								PROCEDURE_ENTRY(BgL_a2z00_17900) (BgL_a2z00_17900,
								BgL_sz00_2375, BEOA);
							BgL_a3z00_2380 =
								PROCEDURE_ENTRY(BgL_a3z00_17901) (BgL_a3z00_17901,
								BgL_sz00_2375, BEOA);
							{	/* Eval/evaluate_comp.scm 889 */
								long BgL_nbpz00_2381;

								BgL_nbpz00_2381 =
									((long) CINT(BgL_bpz00_2377) + BgL_siza7eza7_17902);
								VECTOR_SET(BgL_sz00_2375,
									(int) (((long) 0)), BINT(BgL_nbpz00_2381));
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_auxz00_23171;

									BgL_auxz00_23171 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_23171,
										BgL_locz00_17903);
								}
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_rz00_2383;

									BgL_rz00_2383 =
										PROCEDURE_ENTRY(BgL_cfunz00_17904) (BgL_cfunz00_17904,
										BgL_a1z00_2378, BgL_a2z00_2379, BgL_a3z00_2380, BEOA);
									VECTOR_SET(BgL_sz00_2375, (int) (((long) 0)), BgL_bpz00_2377);
									return BgL_rz00_2383;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2164> */
	obj_t BGl_z62zc3anonymousza32164ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17906, obj_t BgL_sz00_17912)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_17907;
				obj_t BgL_a2z00_17908;
				obj_t BgL_a3z00_17909;
				long BgL_siza7eza7_17910;
				obj_t BgL_cfunz00_17911;

				BgL_a1z00_17907 = PROCEDURE_REF(BgL_envz00_17906, (int) (((long) 0)));
				BgL_a2z00_17908 = PROCEDURE_REF(BgL_envz00_17906, (int) (((long) 1)));
				BgL_a3z00_17909 = PROCEDURE_REF(BgL_envz00_17906, (int) (((long) 2)));
				BgL_siza7eza7_17910 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17906, (int) (((long) 3))));
				BgL_cfunz00_17911 = PROCEDURE_REF(BgL_envz00_17906, (int) (((long) 4)));
				{
					obj_t BgL_sz00_2384;

					BgL_sz00_2384 = BgL_sz00_17912;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2386;

						BgL_bpz00_2386 = VECTOR_REF(BgL_sz00_2384, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_a1z00_2387;
							obj_t BgL_a2z00_2388;
							obj_t BgL_a3z00_2389;

							BgL_a1z00_2387 =
								PROCEDURE_ENTRY(BgL_a1z00_17907) (BgL_a1z00_17907,
								BgL_sz00_2384, BEOA);
							BgL_a2z00_2388 =
								PROCEDURE_ENTRY(BgL_a2z00_17908) (BgL_a2z00_17908,
								BgL_sz00_2384, BEOA);
							BgL_a3z00_2389 =
								PROCEDURE_ENTRY(BgL_a3z00_17909) (BgL_a3z00_17909,
								BgL_sz00_2384, BEOA);
							{	/* Eval/evaluate_comp.scm 889 */
								long BgL_nbpz00_2390;

								BgL_nbpz00_2390 =
									((long) CINT(BgL_bpz00_2386) + BgL_siza7eza7_17910);
								VECTOR_SET(BgL_sz00_2384,
									(int) (((long) 0)), BINT(BgL_nbpz00_2390));
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_rz00_2391;

									BgL_rz00_2391 =
										PROCEDURE_ENTRY(BgL_cfunz00_17911) (BgL_cfunz00_17911,
										BgL_a1z00_2387, BgL_a2z00_2388, BgL_a3z00_2389, BEOA);
									VECTOR_SET(BgL_sz00_2384, (int) (((long) 0)), BgL_bpz00_2386);
									return BgL_rz00_2391;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2167> */
	obj_t BGl_z62zc3anonymousza32167ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17913, obj_t BgL_sz00_17921)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17914;
				obj_t BgL_a1z00_17915;
				obj_t BgL_a2z00_17916;
				obj_t BgL_a3z00_17917;
				obj_t BgL_locz00_17918;
				obj_t BgL_symbzd2funzd2_17919;
				long BgL_siza7eza7_17920;

				BgL_funz00_17914 = PROCEDURE_REF(BgL_envz00_17913, (int) (((long) 0)));
				BgL_a1z00_17915 = PROCEDURE_REF(BgL_envz00_17913, (int) (((long) 1)));
				BgL_a2z00_17916 = PROCEDURE_REF(BgL_envz00_17913, (int) (((long) 2)));
				BgL_a3z00_17917 = PROCEDURE_REF(BgL_envz00_17913, (int) (((long) 3)));
				BgL_locz00_17918 = PROCEDURE_REF(BgL_envz00_17913, (int) (((long) 4)));
				BgL_symbzd2funzd2_17919 =
					PROCEDURE_REF(BgL_envz00_17913, (int) (((long) 5)));
				BgL_siza7eza7_17920 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17913, (int) (((long) 6))));
				{
					obj_t BgL_sz00_2394;

					BgL_sz00_2394 = BgL_sz00_17921;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2396;

						BgL_bpz00_2396 = VECTOR_REF(BgL_sz00_2394, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2397;
							obj_t BgL_a1z00_2398;
							obj_t BgL_a2z00_2399;
							obj_t BgL_a3z00_2400;

							BgL_fz00_2397 =
								PROCEDURE_ENTRY(BgL_funz00_17914) (BgL_funz00_17914,
								BgL_sz00_2394, BEOA);
							BgL_a1z00_2398 =
								PROCEDURE_ENTRY(BgL_a1z00_17915) (BgL_a1z00_17915,
								BgL_sz00_2394, BEOA);
							BgL_a2z00_2399 =
								PROCEDURE_ENTRY(BgL_a2z00_17916) (BgL_a2z00_17916,
								BgL_sz00_2394, BEOA);
							BgL_a3z00_2400 =
								PROCEDURE_ENTRY(BgL_a3z00_17917) (BgL_a3z00_17917,
								BgL_sz00_2394, BEOA);
							if (PROCEDUREP(BgL_fz00_2397))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17918,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2397);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2402;

								BgL_ufz00_2402 = PROCEDURE_ATTR(BgL_fz00_2397);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_23257;

									if (STRUCTP(BgL_ufz00_2402))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_23257 =
												(STRUCT_KEY(BgL_ufz00_2402) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_23257 = ((bool_t) 0);
										}
									if (BgL_testz00_23257)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2404;
											obj_t BgL_runz00_2405;
											obj_t BgL_sfz00_2406;

											BgL_arityz00_2404 =
												STRUCT_REF(BgL_ufz00_2402, (int) (((long) 0)));
											BgL_runz00_2405 =
												STRUCT_REF(BgL_ufz00_2402, (int) (((long) 1)));
											BgL_sfz00_2406 =
												STRUCT_REF(BgL_ufz00_2402, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_2404) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2171z00_2409;

														BgL_arg2171z00_2409 =
															((long) CINT(BgL_bpz00_2396) + ((long) 0));
														VECTOR_SET(BgL_sz00_2394,
															(int) (BgL_arg2171z00_2409), BgL_a1z00_2398);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2172z00_2410;

														BgL_arg2172z00_2410 =
															((long) CINT(BgL_bpz00_2396) + ((long) 1));
														VECTOR_SET(BgL_sz00_2394,
															(int) (BgL_arg2172z00_2410), BgL_a2z00_2399);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2173z00_2411;

														BgL_arg2173z00_2411 =
															((long) CINT(BgL_bpz00_2396) + ((long) 2));
														VECTOR_SET(BgL_sz00_2394,
															(int) (BgL_arg2173z00_2411), BgL_a3z00_2400);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_2404))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_2404))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2175z00_2415;
																		obj_t BgL_arg2176z00_2416;

																		BgL_arg2175z00_2415 =
																			(
																			(long) CINT(BgL_bpz00_2396) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2177z00_2417;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2178z00_2418;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2179z00_2419;

																					BgL_arg2179z00_2419 =
																						MAKE_PAIR(BgL_a3z00_2400, BNIL);
																					BgL_arg2178z00_2418 =
																						MAKE_PAIR(BgL_a2z00_2399,
																						BgL_arg2179z00_2419);
																				}
																				BgL_list2177z00_2417 =
																					MAKE_PAIR(BgL_a1z00_2398,
																					BgL_arg2178z00_2418);
																			}
																			BgL_arg2176z00_2416 =
																				BgL_list2177z00_2417;
																		}
																		VECTOR_SET(BgL_sz00_2394,
																			(int) (BgL_arg2175z00_2415),
																			BgL_arg2176z00_2416);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2180z00_2420;

																		BgL_arg2180z00_2420 =
																			(
																			(long) CINT(BgL_bpz00_2396) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2394,
																			(int) (BgL_arg2180z00_2420),
																			BgL_a1z00_2398);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2181z00_2421;
																		obj_t BgL_arg2182z00_2422;

																		BgL_arg2181z00_2421 =
																			(
																			(long) CINT(BgL_bpz00_2396) + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2183z00_2423;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2184z00_2424;

																				BgL_arg2184z00_2424 =
																					MAKE_PAIR(BgL_a3z00_2400, BNIL);
																				BgL_list2183z00_2423 =
																					MAKE_PAIR(BgL_a2z00_2399,
																					BgL_arg2184z00_2424);
																			}
																			BgL_arg2182z00_2422 =
																				BgL_list2183z00_2423;
																		}
																		VECTOR_SET(BgL_sz00_2394,
																			(int) (BgL_arg2181z00_2421),
																			BgL_arg2182z00_2422);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2185z00_2425;

																		BgL_arg2185z00_2425 =
																			(
																			(long) CINT(BgL_bpz00_2396) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2394,
																			(int) (BgL_arg2185z00_2425),
																			BgL_a1z00_2398);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2186z00_2426;

																		BgL_arg2186z00_2426 =
																			(
																			(long) CINT(BgL_bpz00_2396) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2394,
																			(int) (BgL_arg2186z00_2426),
																			BgL_a2z00_2399);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2188z00_2427;
																		obj_t BgL_arg2189z00_2428;

																		BgL_arg2188z00_2427 =
																			(
																			(long) CINT(BgL_bpz00_2396) + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2190z00_2429;

																			BgL_list2190z00_2429 =
																				MAKE_PAIR(BgL_a3z00_2400, BNIL);
																			BgL_arg2189z00_2428 =
																				BgL_list2190z00_2429;
																		}
																		VECTOR_SET(BgL_sz00_2394,
																			(int) (BgL_arg2188z00_2427),
																			BgL_arg2189z00_2428);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2191z00_2430;

																		BgL_arg2191z00_2430 =
																			(
																			(long) CINT(BgL_bpz00_2396) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2394,
																			(int) (BgL_arg2191z00_2430),
																			BgL_a1z00_2398);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2192z00_2431;

																		BgL_arg2192z00_2431 =
																			(
																			(long) CINT(BgL_bpz00_2396) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2394,
																			(int) (BgL_arg2192z00_2431),
																			BgL_a2z00_2399);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2193z00_2432;

																		BgL_arg2193z00_2432 =
																			(
																			(long) CINT(BgL_bpz00_2396) + ((long) 2));
																		VECTOR_SET(BgL_sz00_2394,
																			(int) (BgL_arg2193z00_2432),
																			BgL_a3z00_2400);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2194z00_2433;

																		BgL_arg2194z00_2433 =
																			(
																			(long) CINT(BgL_bpz00_2396) + ((long) 3));
																		VECTOR_SET(BgL_sz00_2394,
																			(int) (BgL_arg2194z00_2433), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_17918,
																		STRUCT_REF(BgL_ufz00_2402,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_2404));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_17918, STRUCT_REF(BgL_ufz00_2402,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_2404));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_2437;

												BgL_z12denvz12_2437 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_2437,
													BgL_locz00_17918);
												if ((((long) CINT(BgL_bpz00_2396) +
															(long) CINT(BgL_sfz00_2406)) <
														(long) (VECTOR_LENGTH(BgL_sz00_2394))))
													{	/* Eval/evaluate_comp.scm 889 */
														return BgL_runz00_2405;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_2439;

														BgL_nsz00_2439 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2199z00_2441;

															BgL_arg2199z00_2441 =
																((long) CINT(BgL_bpz00_2396) + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_2439, ((long) 2), BgL_sz00_2394,
																BgL_bpz00_2396, BINT(BgL_arg2199z00_2441));
														}
														VECTOR_SET(BgL_nsz00_2439,
															(int) (((long) 1)), BgL_sz00_2394);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2437,
															BgL_nsz00_2439);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_2442;

															BgL_ez00_2442 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_2442, BgL_sz00_2394);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_2443;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_9184;

																	BgL_savedzd2bpzd2_9184 =
																		VECTOR_REF(BgL_nsz00_2439,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_2439,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_9191;

																		BgL_fz00_9191 = BgL_runz00_2405;
																	BgL_recz00_9190:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_9192;

																			BgL_rz00_9192 =
																				PROCEDURE_ENTRY(BgL_fz00_9191)
																				(BgL_fz00_9191, BgL_nsz00_2439, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_23371;

																				if (PROCEDUREP(BgL_rz00_9192))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_9197;

																						BgL_arg1673z00_9197 =
																							PROCEDURE_ATTR(BgL_rz00_9192);
																						if (STRUCTP(BgL_arg1673z00_9197))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_23371 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_9197) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_23371 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_23371 = ((bool_t) 0);
																					}
																				if (BgL_testz00_23371)
																					{
																						obj_t BgL_fz00_23379;

																						BgL_fz00_23379 = BgL_rz00_9192;
																						BgL_fz00_9191 = BgL_fz00_23379;
																						goto BgL_recz00_9190;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_2439,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_9184);
																						BgL_____rz00_2443 = BgL_rz00_9192;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2442);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2437,
																	BgL_sz00_2394);
																return BgL_____rz00_2443;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2397,
													(int) (((long) 3))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2445;

													BgL_nbpz00_2445 =
														((long) CINT(BgL_bpz00_2396) + BgL_siza7eza7_17920);
													VECTOR_SET(BgL_sz00_2394,
														(int) (((long) 0)), BINT(BgL_nbpz00_2445));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_auxz00_23392;

														BgL_auxz00_23392 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_23392,
															BgL_locz00_17918);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2447;

														BgL_rz00_2447 =
															PROCEDURE_ENTRY(BgL_fz00_2397) (BgL_fz00_2397,
															BgL_a1z00_2398, BgL_a2z00_2399, BgL_a3z00_2400,
															BEOA);
														VECTOR_SET(BgL_sz00_2394, (int) (((long) 0)),
															BgL_bpz00_2396);
														return BgL_rz00_2447;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17918, BgL_symbzd2funzd2_17919,
														(int) (((long) 3)), PROCEDURE_ARITY(BgL_fz00_2397));
		}}}}}}}}}
	}



/* &<anonymous:2203> */
	obj_t BGl_z62zc3anonymousza32203ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17922, obj_t BgL_sz00_17930)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17923;
				obj_t BgL_a1z00_17924;
				obj_t BgL_a2z00_17925;
				obj_t BgL_a3z00_17926;
				obj_t BgL_locz00_17927;
				obj_t BgL_symbzd2funzd2_17928;
				long BgL_siza7eza7_17929;

				BgL_funz00_17923 = PROCEDURE_REF(BgL_envz00_17922, (int) (((long) 0)));
				BgL_a1z00_17924 = PROCEDURE_REF(BgL_envz00_17922, (int) (((long) 1)));
				BgL_a2z00_17925 = PROCEDURE_REF(BgL_envz00_17922, (int) (((long) 2)));
				BgL_a3z00_17926 = PROCEDURE_REF(BgL_envz00_17922, (int) (((long) 3)));
				BgL_locz00_17927 = PROCEDURE_REF(BgL_envz00_17922, (int) (((long) 4)));
				BgL_symbzd2funzd2_17928 =
					PROCEDURE_REF(BgL_envz00_17922, (int) (((long) 5)));
				BgL_siza7eza7_17929 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17922, (int) (((long) 6))));
				{
					obj_t BgL_sz00_2449;

					BgL_sz00_2449 = BgL_sz00_17930;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2451;

						BgL_bpz00_2451 = VECTOR_REF(BgL_sz00_2449, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2452;
							obj_t BgL_a1z00_2453;
							obj_t BgL_a2z00_2454;
							obj_t BgL_a3z00_2455;

							BgL_fz00_2452 =
								PROCEDURE_ENTRY(BgL_funz00_17923) (BgL_funz00_17923,
								BgL_sz00_2449, BEOA);
							BgL_a1z00_2453 =
								PROCEDURE_ENTRY(BgL_a1z00_17924) (BgL_a1z00_17924,
								BgL_sz00_2449, BEOA);
							BgL_a2z00_2454 =
								PROCEDURE_ENTRY(BgL_a2z00_17925) (BgL_a2z00_17925,
								BgL_sz00_2449, BEOA);
							BgL_a3z00_2455 =
								PROCEDURE_ENTRY(BgL_a3z00_17926) (BgL_a3z00_17926,
								BgL_sz00_2449, BEOA);
							if (PROCEDUREP(BgL_fz00_2452))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17927,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2452);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2457;

								BgL_ufz00_2457 = PROCEDURE_ATTR(BgL_fz00_2452);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_23443;

									if (STRUCTP(BgL_ufz00_2457))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_23443 =
												(STRUCT_KEY(BgL_ufz00_2457) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_23443 = ((bool_t) 0);
										}
									if (BgL_testz00_23443)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2459;
											obj_t BgL_runz00_2460;
											obj_t BgL_sfz00_2461;

											BgL_arityz00_2459 =
												STRUCT_REF(BgL_ufz00_2457, (int) (((long) 0)));
											BgL_runz00_2460 =
												STRUCT_REF(BgL_ufz00_2457, (int) (((long) 1)));
											BgL_sfz00_2461 =
												STRUCT_REF(BgL_ufz00_2457, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_2459) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2207z00_2464;

														BgL_arg2207z00_2464 =
															((long) CINT(BgL_bpz00_2451) + ((long) 0));
														VECTOR_SET(BgL_sz00_2449,
															(int) (BgL_arg2207z00_2464), BgL_a1z00_2453);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2209z00_2465;

														BgL_arg2209z00_2465 =
															((long) CINT(BgL_bpz00_2451) + ((long) 1));
														VECTOR_SET(BgL_sz00_2449,
															(int) (BgL_arg2209z00_2465), BgL_a2z00_2454);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2210z00_2466;

														BgL_arg2210z00_2466 =
															((long) CINT(BgL_bpz00_2451) + ((long) 2));
														VECTOR_SET(BgL_sz00_2449,
															(int) (BgL_arg2210z00_2466), BgL_a3z00_2455);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_2459))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_2459))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2212z00_2470;
																		obj_t BgL_arg2213z00_2471;

																		BgL_arg2212z00_2470 =
																			(
																			(long) CINT(BgL_bpz00_2451) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2214z00_2472;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2215z00_2473;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2216z00_2474;

																					BgL_arg2216z00_2474 =
																						MAKE_PAIR(BgL_a3z00_2455, BNIL);
																					BgL_arg2215z00_2473 =
																						MAKE_PAIR(BgL_a2z00_2454,
																						BgL_arg2216z00_2474);
																				}
																				BgL_list2214z00_2472 =
																					MAKE_PAIR(BgL_a1z00_2453,
																					BgL_arg2215z00_2473);
																			}
																			BgL_arg2213z00_2471 =
																				BgL_list2214z00_2472;
																		}
																		VECTOR_SET(BgL_sz00_2449,
																			(int) (BgL_arg2212z00_2470),
																			BgL_arg2213z00_2471);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2217z00_2475;

																		BgL_arg2217z00_2475 =
																			(
																			(long) CINT(BgL_bpz00_2451) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2449,
																			(int) (BgL_arg2217z00_2475),
																			BgL_a1z00_2453);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2218z00_2476;
																		obj_t BgL_arg2219z00_2477;

																		BgL_arg2218z00_2476 =
																			(
																			(long) CINT(BgL_bpz00_2451) + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2220z00_2478;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2221z00_2479;

																				BgL_arg2221z00_2479 =
																					MAKE_PAIR(BgL_a3z00_2455, BNIL);
																				BgL_list2220z00_2478 =
																					MAKE_PAIR(BgL_a2z00_2454,
																					BgL_arg2221z00_2479);
																			}
																			BgL_arg2219z00_2477 =
																				BgL_list2220z00_2478;
																		}
																		VECTOR_SET(BgL_sz00_2449,
																			(int) (BgL_arg2218z00_2476),
																			BgL_arg2219z00_2477);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2222z00_2480;

																		BgL_arg2222z00_2480 =
																			(
																			(long) CINT(BgL_bpz00_2451) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2449,
																			(int) (BgL_arg2222z00_2480),
																			BgL_a1z00_2453);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2223z00_2481;

																		BgL_arg2223z00_2481 =
																			(
																			(long) CINT(BgL_bpz00_2451) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2449,
																			(int) (BgL_arg2223z00_2481),
																			BgL_a2z00_2454);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2224z00_2482;
																		obj_t BgL_arg2225z00_2483;

																		BgL_arg2224z00_2482 =
																			(
																			(long) CINT(BgL_bpz00_2451) + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2226z00_2484;

																			BgL_list2226z00_2484 =
																				MAKE_PAIR(BgL_a3z00_2455, BNIL);
																			BgL_arg2225z00_2483 =
																				BgL_list2226z00_2484;
																		}
																		VECTOR_SET(BgL_sz00_2449,
																			(int) (BgL_arg2224z00_2482),
																			BgL_arg2225z00_2483);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2227z00_2485;

																		BgL_arg2227z00_2485 =
																			(
																			(long) CINT(BgL_bpz00_2451) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2449,
																			(int) (BgL_arg2227z00_2485),
																			BgL_a1z00_2453);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2228z00_2486;

																		BgL_arg2228z00_2486 =
																			(
																			(long) CINT(BgL_bpz00_2451) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2449,
																			(int) (BgL_arg2228z00_2486),
																			BgL_a2z00_2454);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2229z00_2487;

																		BgL_arg2229z00_2487 =
																			(
																			(long) CINT(BgL_bpz00_2451) + ((long) 2));
																		VECTOR_SET(BgL_sz00_2449,
																			(int) (BgL_arg2229z00_2487),
																			BgL_a3z00_2455);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2230z00_2488;

																		BgL_arg2230z00_2488 =
																			(
																			(long) CINT(BgL_bpz00_2451) + ((long) 3));
																		VECTOR_SET(BgL_sz00_2449,
																			(int) (BgL_arg2230z00_2488), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_17927,
																		STRUCT_REF(BgL_ufz00_2457,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_2459));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_17927, STRUCT_REF(BgL_ufz00_2457,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_2459));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_2492;

												BgL_z12denvz12_2492 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_2451) +
															(long) CINT(BgL_sfz00_2461)) <
														(long) (VECTOR_LENGTH(BgL_sz00_2449))))
													{	/* Eval/evaluate_comp.scm 889 */
														return BgL_runz00_2460;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_2494;

														BgL_nsz00_2494 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2235z00_2496;

															BgL_arg2235z00_2496 =
																((long) CINT(BgL_bpz00_2451) + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_2494, ((long) 2), BgL_sz00_2449,
																BgL_bpz00_2451, BINT(BgL_arg2235z00_2496));
														}
														VECTOR_SET(BgL_nsz00_2494,
															(int) (((long) 1)), BgL_sz00_2449);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2492,
															BgL_nsz00_2494);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_2497;

															BgL_ez00_2497 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_2497, BgL_sz00_2449);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_2498;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_9367;

																	BgL_savedzd2bpzd2_9367 =
																		VECTOR_REF(BgL_nsz00_2494,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_2494,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_9374;

																		BgL_fz00_9374 = BgL_runz00_2460;
																	BgL_recz00_9373:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_9375;

																			BgL_rz00_9375 =
																				PROCEDURE_ENTRY(BgL_fz00_9374)
																				(BgL_fz00_9374, BgL_nsz00_2494, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_23556;

																				if (PROCEDUREP(BgL_rz00_9375))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_9380;

																						BgL_arg1673z00_9380 =
																							PROCEDURE_ATTR(BgL_rz00_9375);
																						if (STRUCTP(BgL_arg1673z00_9380))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_23556 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_9380) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_23556 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_23556 = ((bool_t) 0);
																					}
																				if (BgL_testz00_23556)
																					{
																						obj_t BgL_fz00_23564;

																						BgL_fz00_23564 = BgL_rz00_9375;
																						BgL_fz00_9374 = BgL_fz00_23564;
																						goto BgL_recz00_9373;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_2494,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_9367);
																						BgL_____rz00_2498 = BgL_rz00_9375;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2497);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2492,
																	BgL_sz00_2449);
																return BgL_____rz00_2498;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2452,
													(int) (((long) 3))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2500;

													BgL_nbpz00_2500 =
														((long) CINT(BgL_bpz00_2451) + BgL_siza7eza7_17929);
													VECTOR_SET(BgL_sz00_2449,
														(int) (((long) 0)), BINT(BgL_nbpz00_2500));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2501;

														BgL_rz00_2501 =
															PROCEDURE_ENTRY(BgL_fz00_2452) (BgL_fz00_2452,
															BgL_a1z00_2453, BgL_a2z00_2454, BgL_a3z00_2455,
															BEOA);
														VECTOR_SET(BgL_sz00_2449, (int) (((long) 0)),
															BgL_bpz00_2451);
														return BgL_rz00_2501;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17927, BgL_symbzd2funzd2_17928,
														(int) (((long) 3)), PROCEDURE_ARITY(BgL_fz00_2452));
		}}}}}}}}}
	}



/* &<anonymous:2240> */
	obj_t BGl_z62zc3anonymousza32240ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17931, obj_t BgL_sz00_17939)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17932;
				obj_t BgL_a1z00_17933;
				obj_t BgL_a2z00_17934;
				obj_t BgL_a3z00_17935;
				obj_t BgL_locz00_17936;
				obj_t BgL_symbzd2funzd2_17937;
				long BgL_siza7eza7_17938;

				BgL_funz00_17932 = PROCEDURE_REF(BgL_envz00_17931, (int) (((long) 0)));
				BgL_a1z00_17933 = PROCEDURE_REF(BgL_envz00_17931, (int) (((long) 1)));
				BgL_a2z00_17934 = PROCEDURE_REF(BgL_envz00_17931, (int) (((long) 2)));
				BgL_a3z00_17935 = PROCEDURE_REF(BgL_envz00_17931, (int) (((long) 3)));
				BgL_locz00_17936 = PROCEDURE_REF(BgL_envz00_17931, (int) (((long) 4)));
				BgL_symbzd2funzd2_17937 =
					PROCEDURE_REF(BgL_envz00_17931, (int) (((long) 5)));
				BgL_siza7eza7_17938 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17931, (int) (((long) 6))));
				{
					obj_t BgL_sz00_2505;

					BgL_sz00_2505 = BgL_sz00_17939;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2507;

						BgL_bpz00_2507 = VECTOR_REF(BgL_sz00_2505, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2508;
							obj_t BgL_a1z00_2509;
							obj_t BgL_a2z00_2510;
							obj_t BgL_a3z00_2511;

							BgL_fz00_2508 =
								PROCEDURE_ENTRY(BgL_funz00_17932) (BgL_funz00_17932,
								BgL_sz00_2505, BEOA);
							BgL_a1z00_2509 =
								PROCEDURE_ENTRY(BgL_a1z00_17933) (BgL_a1z00_17933,
								BgL_sz00_2505, BEOA);
							BgL_a2z00_2510 =
								PROCEDURE_ENTRY(BgL_a2z00_17934) (BgL_a2z00_17934,
								BgL_sz00_2505, BEOA);
							BgL_a3z00_2511 =
								PROCEDURE_ENTRY(BgL_a3z00_17935) (BgL_a3z00_17935,
								BgL_sz00_2505, BEOA);
							if (PROCEDUREP(BgL_fz00_2508))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17936,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2508);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2513;

								BgL_ufz00_2513 = PROCEDURE_ATTR(BgL_fz00_2508);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_23625;

									if (STRUCTP(BgL_ufz00_2513))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_23625 =
												(STRUCT_KEY(BgL_ufz00_2513) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_23625 = ((bool_t) 0);
										}
									if (BgL_testz00_23625)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2515;
											obj_t BgL_runz00_2516;
											obj_t BgL_sfz00_2517;

											BgL_arityz00_2515 =
												STRUCT_REF(BgL_ufz00_2513, (int) (((long) 0)));
											BgL_runz00_2516 =
												STRUCT_REF(BgL_ufz00_2513, (int) (((long) 1)));
											BgL_sfz00_2517 =
												STRUCT_REF(BgL_ufz00_2513, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_spz00_2518;

												BgL_spz00_2518 =
													((long) CINT(BgL_bpz00_2507) + BgL_siza7eza7_17938);
												if (((long) CINT(BgL_arityz00_2515) == ((long) 3)))
													{	/* Eval/evaluate_comp.scm 889 */
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2244z00_2520;

															BgL_arg2244z00_2520 =
																(BgL_spz00_2518 + ((long) 0));
															VECTOR_SET(BgL_sz00_2505,
																(int) (BgL_arg2244z00_2520), BgL_a1z00_2509);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2245z00_2521;

															BgL_arg2245z00_2521 =
																(BgL_spz00_2518 + ((long) 1));
															VECTOR_SET(BgL_sz00_2505,
																(int) (BgL_arg2245z00_2521), BgL_a2z00_2510);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2246z00_2522;

															BgL_arg2246z00_2522 =
																(BgL_spz00_2518 + ((long) 2));
															VECTOR_SET(BgL_sz00_2505,
																(int) (BgL_arg2246z00_2522), BgL_a3z00_2511);
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														if (INTEGERP(BgL_arityz00_2515))
															{	/* Eval/evaluate_comp.scm 889 */
																switch ((long) CINT(BgL_arityz00_2515))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2248z00_2526;
																			obj_t BgL_arg2249z00_2527;

																			BgL_arg2248z00_2526 =
																				(BgL_spz00_2518 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2250z00_2528;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2251z00_2529;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2252z00_2530;

																						BgL_arg2252z00_2530 =
																							MAKE_PAIR(BgL_a3z00_2511, BNIL);
																						BgL_arg2251z00_2529 =
																							MAKE_PAIR(BgL_a2z00_2510,
																							BgL_arg2252z00_2530);
																					}
																					BgL_list2250z00_2528 =
																						MAKE_PAIR(BgL_a1z00_2509,
																						BgL_arg2251z00_2529);
																				}
																				BgL_arg2249z00_2527 =
																					BgL_list2250z00_2528;
																			}
																			VECTOR_SET(BgL_sz00_2505,
																				(int) (BgL_arg2248z00_2526),
																				BgL_arg2249z00_2527);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2253z00_2531;

																			BgL_arg2253z00_2531 =
																				(BgL_spz00_2518 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2505,
																				(int) (BgL_arg2253z00_2531),
																				BgL_a1z00_2509);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2254z00_2532;
																			obj_t BgL_arg2255z00_2533;

																			BgL_arg2254z00_2532 =
																				(BgL_spz00_2518 + ((long) 1));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2256z00_2534;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2257z00_2535;

																					BgL_arg2257z00_2535 =
																						MAKE_PAIR(BgL_a3z00_2511, BNIL);
																					BgL_list2256z00_2534 =
																						MAKE_PAIR(BgL_a2z00_2510,
																						BgL_arg2257z00_2535);
																				}
																				BgL_arg2255z00_2533 =
																					BgL_list2256z00_2534;
																			}
																			VECTOR_SET(BgL_sz00_2505,
																				(int) (BgL_arg2254z00_2532),
																				BgL_arg2255z00_2533);
																		} break;
																	case ((long) -3):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2258z00_2536;

																			BgL_arg2258z00_2536 =
																				(BgL_spz00_2518 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2505,
																				(int) (BgL_arg2258z00_2536),
																				BgL_a1z00_2509);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2259z00_2537;

																			BgL_arg2259z00_2537 =
																				(BgL_spz00_2518 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2505,
																				(int) (BgL_arg2259z00_2537),
																				BgL_a2z00_2510);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2260z00_2538;
																			obj_t BgL_arg2261z00_2539;

																			BgL_arg2260z00_2538 =
																				(BgL_spz00_2518 + ((long) 2));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2262z00_2540;

																				BgL_list2262z00_2540 =
																					MAKE_PAIR(BgL_a3z00_2511, BNIL);
																				BgL_arg2261z00_2539 =
																					BgL_list2262z00_2540;
																			}
																			VECTOR_SET(BgL_sz00_2505,
																				(int) (BgL_arg2260z00_2538),
																				BgL_arg2261z00_2539);
																		} break;
																	case ((long) -4):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2263z00_2541;

																			BgL_arg2263z00_2541 =
																				(BgL_spz00_2518 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2505,
																				(int) (BgL_arg2263z00_2541),
																				BgL_a1z00_2509);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2264z00_2542;

																			BgL_arg2264z00_2542 =
																				(BgL_spz00_2518 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2505,
																				(int) (BgL_arg2264z00_2542),
																				BgL_a2z00_2510);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2265z00_2543;

																			BgL_arg2265z00_2543 =
																				(BgL_spz00_2518 + ((long) 2));
																			VECTOR_SET(BgL_sz00_2505,
																				(int) (BgL_arg2265z00_2543),
																				BgL_a3z00_2511);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2267z00_2544;

																			BgL_arg2267z00_2544 =
																				(BgL_spz00_2518 + ((long) 3));
																			VECTOR_SET(BgL_sz00_2505,
																				(int) (BgL_arg2267z00_2544), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_17936,
																			STRUCT_REF(BgL_ufz00_2513,
																				(int) (((long) 3))), (int) (((long) 3)),
																			CINT(BgL_arityz00_2515));
															}}
														else
															{	/* Eval/evaluate_comp.scm 889 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_17936, STRUCT_REF(BgL_ufz00_2513,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_2515));
													}}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_z12denvz12_2548;

													BgL_z12denvz12_2548 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_2548,
														BgL_locz00_17936);
													if (((BgL_spz00_2518 + (long) CINT(BgL_sfz00_2517)) <
															(long) (VECTOR_LENGTH(BgL_sz00_2505))))
														{	/* Eval/evaluate_comp.scm 889 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_2516, BgL_sz00_2505,
																BINT(BgL_spz00_2518));
														}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_nsz00_2550;

															BgL_nsz00_2550 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 889 */
																long BgL_arg2272z00_2552;

																BgL_arg2272z00_2552 =
																	(BgL_spz00_2518 + ((long) 3));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_2550, ((long) 2), BgL_sz00_2505,
																	BINT(BgL_spz00_2518),
																	BINT(BgL_arg2272z00_2552));
															}
															VECTOR_SET(BgL_nsz00_2550,
																(int) (((long) 1)), BgL_sz00_2505);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2548,
																BgL_nsz00_2550);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_ez00_2553;

																BgL_ez00_2553 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2553, BgL_sz00_2505);
																{	/* Eval/evaluate_comp.scm 889 */
																	obj_t BgL_____rz00_2554;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_9548;

																		BgL_savedzd2bpzd2_9548 =
																			VECTOR_REF(BgL_nsz00_2550,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_2550,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_9555;

																			BgL_fz00_9555 = BgL_runz00_2516;
																		BgL_recz00_9554:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_9556;

																				BgL_rz00_9556 =
																					PROCEDURE_ENTRY(BgL_fz00_9555)
																					(BgL_fz00_9555, BgL_nsz00_2550, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_23729;

																					if (PROCEDUREP(BgL_rz00_9556))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_9561;

																							BgL_arg1673z00_9561 =
																								PROCEDURE_ATTR(BgL_rz00_9556);
																							if (STRUCTP(BgL_arg1673z00_9561))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_23729 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_9561) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_23729 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_23729 = ((bool_t) 0);
																						}
																					if (BgL_testz00_23729)
																						{
																							obj_t BgL_fz00_23737;

																							BgL_fz00_23737 = BgL_rz00_9556;
																							BgL_fz00_9555 = BgL_fz00_23737;
																							goto BgL_recz00_9554;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_2550,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_9548);
																							BgL_____rz00_2554 = BgL_rz00_9556;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_2553);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2548,
																		BgL_sz00_2505);
																	return BgL_____rz00_2554;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2508,
													(int) (((long) 3))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2556;

													BgL_nbpz00_2556 =
														((long) CINT(BgL_bpz00_2507) + BgL_siza7eza7_17938);
													VECTOR_SET(BgL_sz00_2505,
														(int) (((long) 0)), BINT(BgL_nbpz00_2556));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_auxz00_23750;

														BgL_auxz00_23750 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_23750,
															BgL_locz00_17936);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2558;

														BgL_rz00_2558 =
															PROCEDURE_ENTRY(BgL_fz00_2508) (BgL_fz00_2508,
															BgL_a1z00_2509, BgL_a2z00_2510, BgL_a3z00_2511,
															BEOA);
														VECTOR_SET(BgL_sz00_2505, (int) (((long) 0)),
															BgL_bpz00_2507);
														return BgL_rz00_2558;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17936, BgL_symbzd2funzd2_17937,
														(int) (((long) 3)), PROCEDURE_ARITY(BgL_fz00_2508));
		}}}}}}}}}
	}



/* &<anonymous:2276> */
	obj_t BGl_z62zc3anonymousza32276ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17940, obj_t BgL_sz00_17948)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17941;
				obj_t BgL_a1z00_17942;
				obj_t BgL_a2z00_17943;
				obj_t BgL_a3z00_17944;
				obj_t BgL_locz00_17945;
				obj_t BgL_symbzd2funzd2_17946;
				long BgL_siza7eza7_17947;

				BgL_funz00_17941 = PROCEDURE_REF(BgL_envz00_17940, (int) (((long) 0)));
				BgL_a1z00_17942 = PROCEDURE_REF(BgL_envz00_17940, (int) (((long) 1)));
				BgL_a2z00_17943 = PROCEDURE_REF(BgL_envz00_17940, (int) (((long) 2)));
				BgL_a3z00_17944 = PROCEDURE_REF(BgL_envz00_17940, (int) (((long) 3)));
				BgL_locz00_17945 = PROCEDURE_REF(BgL_envz00_17940, (int) (((long) 4)));
				BgL_symbzd2funzd2_17946 =
					PROCEDURE_REF(BgL_envz00_17940, (int) (((long) 5)));
				BgL_siza7eza7_17947 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17940, (int) (((long) 6))));
				{
					obj_t BgL_sz00_2560;

					BgL_sz00_2560 = BgL_sz00_17948;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2562;

						BgL_bpz00_2562 = VECTOR_REF(BgL_sz00_2560, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2563;
							obj_t BgL_a1z00_2564;
							obj_t BgL_a2z00_2565;
							obj_t BgL_a3z00_2566;

							BgL_fz00_2563 =
								PROCEDURE_ENTRY(BgL_funz00_17941) (BgL_funz00_17941,
								BgL_sz00_2560, BEOA);
							BgL_a1z00_2564 =
								PROCEDURE_ENTRY(BgL_a1z00_17942) (BgL_a1z00_17942,
								BgL_sz00_2560, BEOA);
							BgL_a2z00_2565 =
								PROCEDURE_ENTRY(BgL_a2z00_17943) (BgL_a2z00_17943,
								BgL_sz00_2560, BEOA);
							BgL_a3z00_2566 =
								PROCEDURE_ENTRY(BgL_a3z00_17944) (BgL_a3z00_17944,
								BgL_sz00_2560, BEOA);
							if (PROCEDUREP(BgL_fz00_2563))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17945,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2563);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2568;

								BgL_ufz00_2568 = PROCEDURE_ATTR(BgL_fz00_2563);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_23801;

									if (STRUCTP(BgL_ufz00_2568))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_23801 =
												(STRUCT_KEY(BgL_ufz00_2568) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_23801 = ((bool_t) 0);
										}
									if (BgL_testz00_23801)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2570;
											obj_t BgL_runz00_2571;
											obj_t BgL_sfz00_2572;

											BgL_arityz00_2570 =
												STRUCT_REF(BgL_ufz00_2568, (int) (((long) 0)));
											BgL_runz00_2571 =
												STRUCT_REF(BgL_ufz00_2568, (int) (((long) 1)));
											BgL_sfz00_2572 =
												STRUCT_REF(BgL_ufz00_2568, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_spz00_2573;

												BgL_spz00_2573 =
													((long) CINT(BgL_bpz00_2562) + BgL_siza7eza7_17947);
												if (((long) CINT(BgL_arityz00_2570) == ((long) 3)))
													{	/* Eval/evaluate_comp.scm 889 */
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2280z00_2575;

															BgL_arg2280z00_2575 =
																(BgL_spz00_2573 + ((long) 0));
															VECTOR_SET(BgL_sz00_2560,
																(int) (BgL_arg2280z00_2575), BgL_a1z00_2564);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2281z00_2576;

															BgL_arg2281z00_2576 =
																(BgL_spz00_2573 + ((long) 1));
															VECTOR_SET(BgL_sz00_2560,
																(int) (BgL_arg2281z00_2576), BgL_a2z00_2565);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2282z00_2577;

															BgL_arg2282z00_2577 =
																(BgL_spz00_2573 + ((long) 2));
															VECTOR_SET(BgL_sz00_2560,
																(int) (BgL_arg2282z00_2577), BgL_a3z00_2566);
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														if (INTEGERP(BgL_arityz00_2570))
															{	/* Eval/evaluate_comp.scm 889 */
																switch ((long) CINT(BgL_arityz00_2570))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2284z00_2581;
																			obj_t BgL_arg2285z00_2582;

																			BgL_arg2284z00_2581 =
																				(BgL_spz00_2573 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2286z00_2583;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2287z00_2584;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2288z00_2585;

																						BgL_arg2288z00_2585 =
																							MAKE_PAIR(BgL_a3z00_2566, BNIL);
																						BgL_arg2287z00_2584 =
																							MAKE_PAIR(BgL_a2z00_2565,
																							BgL_arg2288z00_2585);
																					}
																					BgL_list2286z00_2583 =
																						MAKE_PAIR(BgL_a1z00_2564,
																						BgL_arg2287z00_2584);
																				}
																				BgL_arg2285z00_2582 =
																					BgL_list2286z00_2583;
																			}
																			VECTOR_SET(BgL_sz00_2560,
																				(int) (BgL_arg2284z00_2581),
																				BgL_arg2285z00_2582);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2289z00_2586;

																			BgL_arg2289z00_2586 =
																				(BgL_spz00_2573 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2560,
																				(int) (BgL_arg2289z00_2586),
																				BgL_a1z00_2564);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2292z00_2587;
																			obj_t BgL_arg2293z00_2588;

																			BgL_arg2292z00_2587 =
																				(BgL_spz00_2573 + ((long) 1));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2294z00_2589;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2295z00_2590;

																					BgL_arg2295z00_2590 =
																						MAKE_PAIR(BgL_a3z00_2566, BNIL);
																					BgL_list2294z00_2589 =
																						MAKE_PAIR(BgL_a2z00_2565,
																						BgL_arg2295z00_2590);
																				}
																				BgL_arg2293z00_2588 =
																					BgL_list2294z00_2589;
																			}
																			VECTOR_SET(BgL_sz00_2560,
																				(int) (BgL_arg2292z00_2587),
																				BgL_arg2293z00_2588);
																		} break;
																	case ((long) -3):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2296z00_2591;

																			BgL_arg2296z00_2591 =
																				(BgL_spz00_2573 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2560,
																				(int) (BgL_arg2296z00_2591),
																				BgL_a1z00_2564);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2297z00_2592;

																			BgL_arg2297z00_2592 =
																				(BgL_spz00_2573 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2560,
																				(int) (BgL_arg2297z00_2592),
																				BgL_a2z00_2565);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2298z00_2593;
																			obj_t BgL_arg2299z00_2594;

																			BgL_arg2298z00_2593 =
																				(BgL_spz00_2573 + ((long) 2));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2300z00_2595;

																				BgL_list2300z00_2595 =
																					MAKE_PAIR(BgL_a3z00_2566, BNIL);
																				BgL_arg2299z00_2594 =
																					BgL_list2300z00_2595;
																			}
																			VECTOR_SET(BgL_sz00_2560,
																				(int) (BgL_arg2298z00_2593),
																				BgL_arg2299z00_2594);
																		} break;
																	case ((long) -4):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2301z00_2596;

																			BgL_arg2301z00_2596 =
																				(BgL_spz00_2573 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2560,
																				(int) (BgL_arg2301z00_2596),
																				BgL_a1z00_2564);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2302z00_2597;

																			BgL_arg2302z00_2597 =
																				(BgL_spz00_2573 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2560,
																				(int) (BgL_arg2302z00_2597),
																				BgL_a2z00_2565);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2303z00_2598;

																			BgL_arg2303z00_2598 =
																				(BgL_spz00_2573 + ((long) 2));
																			VECTOR_SET(BgL_sz00_2560,
																				(int) (BgL_arg2303z00_2598),
																				BgL_a3z00_2566);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2304z00_2599;

																			BgL_arg2304z00_2599 =
																				(BgL_spz00_2573 + ((long) 3));
																			VECTOR_SET(BgL_sz00_2560,
																				(int) (BgL_arg2304z00_2599), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_17945,
																			STRUCT_REF(BgL_ufz00_2568,
																				(int) (((long) 3))), (int) (((long) 3)),
																			CINT(BgL_arityz00_2570));
															}}
														else
															{	/* Eval/evaluate_comp.scm 889 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_17945, STRUCT_REF(BgL_ufz00_2568,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_2570));
													}}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_z12denvz12_2603;

													BgL_z12denvz12_2603 = BGL_CURRENT_DYNAMIC_ENV();
													if (
														((BgL_spz00_2573 +
																(long) CINT(BgL_sfz00_2572)) <
															(long) (VECTOR_LENGTH(BgL_sz00_2560))))
														{	/* Eval/evaluate_comp.scm 889 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_2571, BgL_sz00_2560,
																BINT(BgL_spz00_2573));
														}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_nsz00_2605;

															BgL_nsz00_2605 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 889 */
																long BgL_arg2309z00_2607;

																BgL_arg2309z00_2607 =
																	(BgL_spz00_2573 + ((long) 3));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_2605, ((long) 2), BgL_sz00_2560,
																	BINT(BgL_spz00_2573),
																	BINT(BgL_arg2309z00_2607));
															}
															VECTOR_SET(BgL_nsz00_2605,
																(int) (((long) 1)), BgL_sz00_2560);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2603,
																BgL_nsz00_2605);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_ez00_2608;

																BgL_ez00_2608 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2608, BgL_sz00_2560);
																{	/* Eval/evaluate_comp.scm 889 */
																	obj_t BgL_____rz00_2609;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_9730;

																		BgL_savedzd2bpzd2_9730 =
																			VECTOR_REF(BgL_nsz00_2605,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_2605,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_9737;

																			BgL_fz00_9737 = BgL_runz00_2571;
																		BgL_recz00_9736:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_9738;

																				BgL_rz00_9738 =
																					PROCEDURE_ENTRY(BgL_fz00_9737)
																					(BgL_fz00_9737, BgL_nsz00_2605, BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_23904;

																					if (PROCEDUREP(BgL_rz00_9738))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_9743;

																							BgL_arg1673z00_9743 =
																								PROCEDURE_ATTR(BgL_rz00_9738);
																							if (STRUCTP(BgL_arg1673z00_9743))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_23904 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_9743) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_23904 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_23904 = ((bool_t) 0);
																						}
																					if (BgL_testz00_23904)
																						{
																							obj_t BgL_fz00_23912;

																							BgL_fz00_23912 = BgL_rz00_9738;
																							BgL_fz00_9737 = BgL_fz00_23912;
																							goto BgL_recz00_9736;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_2605,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_9730);
																							BgL_____rz00_2609 = BgL_rz00_9738;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_2608);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2603,
																		BgL_sz00_2560);
																	return BgL_____rz00_2609;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2563,
													(int) (((long) 3))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2611;

													BgL_nbpz00_2611 =
														((long) CINT(BgL_bpz00_2562) + BgL_siza7eza7_17947);
													VECTOR_SET(BgL_sz00_2560,
														(int) (((long) 0)), BINT(BgL_nbpz00_2611));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2612;

														BgL_rz00_2612 =
															PROCEDURE_ENTRY(BgL_fz00_2563) (BgL_fz00_2563,
															BgL_a1z00_2564, BgL_a2z00_2565, BgL_a3z00_2566,
															BEOA);
														VECTOR_SET(BgL_sz00_2560, (int) (((long) 0)),
															BgL_bpz00_2562);
														return BgL_rz00_2612;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17945, BgL_symbzd2funzd2_17946,
														(int) (((long) 3)), PROCEDURE_ARITY(BgL_fz00_2563));
		}}}}}}}}}
	}



/* comp-call4 */
	obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172,
		BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174,
		obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177,
		long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180,
		obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2615;

				BgL_cfunz00_2615 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173,
					((long) 4), BgL_locz00_172, BgL_symbzd2funzd2_174);
				if (CBOOL(BgL_cfunz00_2615))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_testz00_23939;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg2317z00_2636;

							BgL_arg2317z00_2636 = bgl_debug();
							BgL_testz00_23939 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2317z00_2636),
								BINT(((long) 0)));
						}
						if (BgL_testz00_23939)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32314ze3z83_17949;

								BgL_zc3anonymousza32314ze3z83_17949 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32314ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3anonymousza32314ze3z83_17949,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3anonymousza32314ze3z83_17949,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3anonymousza32314ze3z83_17949,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3anonymousza32314ze3z83_17949,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3anonymousza32314ze3z83_17949,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3anonymousza32314ze3z83_17949,
									(int) (((long) 5)), BgL_locz00_172);
								PROCEDURE_SET(BgL_zc3anonymousza32314ze3z83_17949,
									(int) (((long) 6)), BgL_cfunz00_2615);
								return BgL_zc3anonymousza32314ze3z83_17949;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32316ze3z83_17950;

								BgL_zc3anonymousza32316ze3z83_17950 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32316ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3anonymousza32316ze3z83_17950,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3anonymousza32316ze3z83_17950,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3anonymousza32316ze3z83_17950,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3anonymousza32316ze3z83_17950,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3anonymousza32316ze3z83_17950,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3anonymousza32316ze3z83_17950,
									(int) (((long) 5)), BgL_cfunz00_2615);
								return BgL_zc3anonymousza32316ze3z83_17950;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_176))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_23980;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2415z00_2771;

									BgL_arg2415z00_2771 = bgl_debug();
									BgL_testz00_23980 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2415z00_2771),
										BINT(((long) 0)));
								}
								if (BgL_testz00_23980)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32319ze3z83_17951;

										BgL_zc3anonymousza32319ze3z83_17951 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32319ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3anonymousza32319ze3z83_17951,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3anonymousza32319ze3z83_17951,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3anonymousza32319ze3z83_17951,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3anonymousza32319ze3z83_17951,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3anonymousza32319ze3z83_17951,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3anonymousza32319ze3z83_17951,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3anonymousza32319ze3z83_17951,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3anonymousza32319ze3z83_17951,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3anonymousza32319ze3z83_17951;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32368ze3z83_17952;

										BgL_zc3anonymousza32368ze3z83_17952 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32368ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3anonymousza32368ze3z83_17952,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3anonymousza32368ze3z83_17952,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3anonymousza32368ze3z83_17952,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3anonymousza32368ze3z83_17952,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3anonymousza32368ze3z83_17952,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3anonymousza32368ze3z83_17952,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3anonymousza32368ze3z83_17952,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3anonymousza32368ze3z83_17952,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3anonymousza32368ze3z83_17952;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_24025;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2522z00_2906;

									BgL_arg2522z00_2906 = bgl_debug();
									BgL_testz00_24025 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2522z00_2906),
										BINT(((long) 0)));
								}
								if (BgL_testz00_24025)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32417ze3z83_17953;

										BgL_zc3anonymousza32417ze3z83_17953 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32417ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3anonymousza32417ze3z83_17953,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3anonymousza32417ze3z83_17953,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3anonymousza32417ze3z83_17953,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3anonymousza32417ze3z83_17953,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3anonymousza32417ze3z83_17953,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3anonymousza32417ze3z83_17953,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3anonymousza32417ze3z83_17953,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3anonymousza32417ze3z83_17953,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3anonymousza32417ze3z83_17953;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32469ze3z83_17954;

										BgL_zc3anonymousza32469ze3z83_17954 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32469ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3anonymousza32469ze3z83_17954,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3anonymousza32469ze3z83_17954,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3anonymousza32469ze3z83_17954,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3anonymousza32469ze3z83_17954,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3anonymousza32469ze3z83_17954,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3anonymousza32469ze3z83_17954,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3anonymousza32469ze3z83_17954,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3anonymousza32469ze3z83_17954,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3anonymousza32469ze3z83_17954;
									}
							}
					}
			}
		}
	}



/* &<anonymous:2314> */
	obj_t BGl_z62zc3anonymousza32314ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17955, obj_t BgL_sz00_17963)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_17956;
				obj_t BgL_a2z00_17957;
				obj_t BgL_a3z00_17958;
				obj_t BgL_a4z00_17959;
				long BgL_siza7eza7_17960;
				obj_t BgL_locz00_17961;
				obj_t BgL_cfunz00_17962;

				BgL_a1z00_17956 = PROCEDURE_REF(BgL_envz00_17955, (int) (((long) 0)));
				BgL_a2z00_17957 = PROCEDURE_REF(BgL_envz00_17955, (int) (((long) 1)));
				BgL_a3z00_17958 = PROCEDURE_REF(BgL_envz00_17955, (int) (((long) 2)));
				BgL_a4z00_17959 = PROCEDURE_REF(BgL_envz00_17955, (int) (((long) 3)));
				BgL_siza7eza7_17960 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17955, (int) (((long) 4))));
				BgL_locz00_17961 = PROCEDURE_REF(BgL_envz00_17955, (int) (((long) 5)));
				BgL_cfunz00_17962 = PROCEDURE_REF(BgL_envz00_17955, (int) (((long) 6)));
				{
					obj_t BgL_sz00_2617;

					BgL_sz00_2617 = BgL_sz00_17963;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2619;

						BgL_bpz00_2619 = VECTOR_REF(BgL_sz00_2617, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_a1z00_2620;
							obj_t BgL_a2z00_2621;
							obj_t BgL_a3z00_2622;
							obj_t BgL_a4z00_2623;

							BgL_a1z00_2620 =
								PROCEDURE_ENTRY(BgL_a1z00_17956) (BgL_a1z00_17956,
								BgL_sz00_2617, BEOA);
							BgL_a2z00_2621 =
								PROCEDURE_ENTRY(BgL_a2z00_17957) (BgL_a2z00_17957,
								BgL_sz00_2617, BEOA);
							BgL_a3z00_2622 =
								PROCEDURE_ENTRY(BgL_a3z00_17958) (BgL_a3z00_17958,
								BgL_sz00_2617, BEOA);
							BgL_a4z00_2623 =
								PROCEDURE_ENTRY(BgL_a4z00_17959) (BgL_a4z00_17959,
								BgL_sz00_2617, BEOA);
							{	/* Eval/evaluate_comp.scm 889 */
								long BgL_nbpz00_2624;

								BgL_nbpz00_2624 =
									((long) CINT(BgL_bpz00_2619) + BgL_siza7eza7_17960);
								VECTOR_SET(BgL_sz00_2617,
									(int) (((long) 0)), BINT(BgL_nbpz00_2624));
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_auxz00_24108;

									BgL_auxz00_24108 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_24108,
										BgL_locz00_17961);
								}
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_rz00_2626;

									BgL_rz00_2626 =
										PROCEDURE_ENTRY(BgL_cfunz00_17962) (BgL_cfunz00_17962,
										BgL_a1z00_2620, BgL_a2z00_2621, BgL_a3z00_2622,
										BgL_a4z00_2623, BEOA);
									VECTOR_SET(BgL_sz00_2617, (int) (((long) 0)), BgL_bpz00_2619);
									return BgL_rz00_2626;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2316> */
	obj_t BGl_z62zc3anonymousza32316ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17964, obj_t BgL_sz00_17971)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_17965;
				obj_t BgL_a2z00_17966;
				obj_t BgL_a3z00_17967;
				obj_t BgL_a4z00_17968;
				long BgL_siza7eza7_17969;
				obj_t BgL_cfunz00_17970;

				BgL_a1z00_17965 = PROCEDURE_REF(BgL_envz00_17964, (int) (((long) 0)));
				BgL_a2z00_17966 = PROCEDURE_REF(BgL_envz00_17964, (int) (((long) 1)));
				BgL_a3z00_17967 = PROCEDURE_REF(BgL_envz00_17964, (int) (((long) 2)));
				BgL_a4z00_17968 = PROCEDURE_REF(BgL_envz00_17964, (int) (((long) 3)));
				BgL_siza7eza7_17969 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17964, (int) (((long) 4))));
				BgL_cfunz00_17970 = PROCEDURE_REF(BgL_envz00_17964, (int) (((long) 5)));
				{
					obj_t BgL_sz00_2627;

					BgL_sz00_2627 = BgL_sz00_17971;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2629;

						BgL_bpz00_2629 = VECTOR_REF(BgL_sz00_2627, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_a1z00_2630;
							obj_t BgL_a2z00_2631;
							obj_t BgL_a3z00_2632;
							obj_t BgL_a4z00_2633;

							BgL_a1z00_2630 =
								PROCEDURE_ENTRY(BgL_a1z00_17965) (BgL_a1z00_17965,
								BgL_sz00_2627, BEOA);
							BgL_a2z00_2631 =
								PROCEDURE_ENTRY(BgL_a2z00_17966) (BgL_a2z00_17966,
								BgL_sz00_2627, BEOA);
							BgL_a3z00_2632 =
								PROCEDURE_ENTRY(BgL_a3z00_17967) (BgL_a3z00_17967,
								BgL_sz00_2627, BEOA);
							BgL_a4z00_2633 =
								PROCEDURE_ENTRY(BgL_a4z00_17968) (BgL_a4z00_17968,
								BgL_sz00_2627, BEOA);
							{	/* Eval/evaluate_comp.scm 889 */
								long BgL_nbpz00_2634;

								BgL_nbpz00_2634 =
									((long) CINT(BgL_bpz00_2629) + BgL_siza7eza7_17969);
								VECTOR_SET(BgL_sz00_2627,
									(int) (((long) 0)), BINT(BgL_nbpz00_2634));
								{	/* Eval/evaluate_comp.scm 889 */
									obj_t BgL_rz00_2635;

									BgL_rz00_2635 =
										PROCEDURE_ENTRY(BgL_cfunz00_17970) (BgL_cfunz00_17970,
										BgL_a1z00_2630, BgL_a2z00_2631, BgL_a3z00_2632,
										BgL_a4z00_2633, BEOA);
									VECTOR_SET(BgL_sz00_2627, (int) (((long) 0)), BgL_bpz00_2629);
									return BgL_rz00_2635;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2319> */
	obj_t BGl_z62zc3anonymousza32319ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17972, obj_t BgL_sz00_17981)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17973;
				obj_t BgL_a1z00_17974;
				obj_t BgL_a2z00_17975;
				obj_t BgL_a3z00_17976;
				obj_t BgL_a4z00_17977;
				obj_t BgL_locz00_17978;
				obj_t BgL_symbzd2funzd2_17979;
				long BgL_siza7eza7_17980;

				BgL_funz00_17973 = PROCEDURE_REF(BgL_envz00_17972, (int) (((long) 0)));
				BgL_a1z00_17974 = PROCEDURE_REF(BgL_envz00_17972, (int) (((long) 1)));
				BgL_a2z00_17975 = PROCEDURE_REF(BgL_envz00_17972, (int) (((long) 2)));
				BgL_a3z00_17976 = PROCEDURE_REF(BgL_envz00_17972, (int) (((long) 3)));
				BgL_a4z00_17977 = PROCEDURE_REF(BgL_envz00_17972, (int) (((long) 4)));
				BgL_locz00_17978 = PROCEDURE_REF(BgL_envz00_17972, (int) (((long) 5)));
				BgL_symbzd2funzd2_17979 =
					PROCEDURE_REF(BgL_envz00_17972, (int) (((long) 6)));
				BgL_siza7eza7_17980 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17972, (int) (((long) 7))));
				{
					obj_t BgL_sz00_2638;

					BgL_sz00_2638 = BgL_sz00_17981;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2640;

						BgL_bpz00_2640 = VECTOR_REF(BgL_sz00_2638, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2641;
							obj_t BgL_a1z00_2642;
							obj_t BgL_a2z00_2643;
							obj_t BgL_a3z00_2644;
							obj_t BgL_a4z00_2645;

							BgL_fz00_2641 =
								PROCEDURE_ENTRY(BgL_funz00_17973) (BgL_funz00_17973,
								BgL_sz00_2638, BEOA);
							BgL_a1z00_2642 =
								PROCEDURE_ENTRY(BgL_a1z00_17974) (BgL_a1z00_17974,
								BgL_sz00_2638, BEOA);
							BgL_a2z00_2643 =
								PROCEDURE_ENTRY(BgL_a2z00_17975) (BgL_a2z00_17975,
								BgL_sz00_2638, BEOA);
							BgL_a3z00_2644 =
								PROCEDURE_ENTRY(BgL_a3z00_17976) (BgL_a3z00_17976,
								BgL_sz00_2638, BEOA);
							BgL_a4z00_2645 =
								PROCEDURE_ENTRY(BgL_a4z00_17977) (BgL_a4z00_17977,
								BgL_sz00_2638, BEOA);
							if (PROCEDUREP(BgL_fz00_2641))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17978,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2641);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2647;

								BgL_ufz00_2647 = PROCEDURE_ATTR(BgL_fz00_2641);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_24208;

									if (STRUCTP(BgL_ufz00_2647))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_24208 =
												(STRUCT_KEY(BgL_ufz00_2647) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_24208 = ((bool_t) 0);
										}
									if (BgL_testz00_24208)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2649;
											obj_t BgL_runz00_2650;
											obj_t BgL_sfz00_2651;

											BgL_arityz00_2649 =
												STRUCT_REF(BgL_ufz00_2647, (int) (((long) 0)));
											BgL_runz00_2650 =
												STRUCT_REF(BgL_ufz00_2647, (int) (((long) 1)));
											BgL_sfz00_2651 =
												STRUCT_REF(BgL_ufz00_2647, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_2649) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2323z00_2654;

														BgL_arg2323z00_2654 =
															((long) CINT(BgL_bpz00_2640) + ((long) 0));
														VECTOR_SET(BgL_sz00_2638,
															(int) (BgL_arg2323z00_2654), BgL_a1z00_2642);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2324z00_2655;

														BgL_arg2324z00_2655 =
															((long) CINT(BgL_bpz00_2640) + ((long) 1));
														VECTOR_SET(BgL_sz00_2638,
															(int) (BgL_arg2324z00_2655), BgL_a2z00_2643);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2325z00_2656;

														BgL_arg2325z00_2656 =
															((long) CINT(BgL_bpz00_2640) + ((long) 2));
														VECTOR_SET(BgL_sz00_2638,
															(int) (BgL_arg2325z00_2656), BgL_a3z00_2644);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2326z00_2657;

														BgL_arg2326z00_2657 =
															((long) CINT(BgL_bpz00_2640) + ((long) 3));
														VECTOR_SET(BgL_sz00_2638,
															(int) (BgL_arg2326z00_2657), BgL_a4z00_2645);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_2649))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_2649))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2328z00_2661;
																		obj_t BgL_arg2329z00_2662;

																		BgL_arg2328z00_2661 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2330z00_2663;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2331z00_2664;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2332z00_2665;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2333z00_2666;

																						BgL_arg2333z00_2666 =
																							MAKE_PAIR(BgL_a4z00_2645, BNIL);
																						BgL_arg2332z00_2665 =
																							MAKE_PAIR(BgL_a3z00_2644,
																							BgL_arg2333z00_2666);
																					}
																					BgL_arg2331z00_2664 =
																						MAKE_PAIR(BgL_a2z00_2643,
																						BgL_arg2332z00_2665);
																				}
																				BgL_list2330z00_2663 =
																					MAKE_PAIR(BgL_a1z00_2642,
																					BgL_arg2331z00_2664);
																			}
																			BgL_arg2329z00_2662 =
																				BgL_list2330z00_2663;
																		}
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2328z00_2661),
																			BgL_arg2329z00_2662);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2334z00_2667;

																		BgL_arg2334z00_2667 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2334z00_2667),
																			BgL_a1z00_2642);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2336z00_2668;
																		obj_t BgL_arg2337z00_2669;

																		BgL_arg2336z00_2668 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2338z00_2670;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2339z00_2671;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2340z00_2672;

																					BgL_arg2340z00_2672 =
																						MAKE_PAIR(BgL_a4z00_2645, BNIL);
																					BgL_arg2339z00_2671 =
																						MAKE_PAIR(BgL_a3z00_2644,
																						BgL_arg2340z00_2672);
																				}
																				BgL_list2338z00_2670 =
																					MAKE_PAIR(BgL_a2z00_2643,
																					BgL_arg2339z00_2671);
																			}
																			BgL_arg2337z00_2669 =
																				BgL_list2338z00_2670;
																		}
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2336z00_2668),
																			BgL_arg2337z00_2669);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2341z00_2673;

																		BgL_arg2341z00_2673 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2341z00_2673),
																			BgL_a1z00_2642);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2342z00_2674;

																		BgL_arg2342z00_2674 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2342z00_2674),
																			BgL_a2z00_2643);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2343z00_2675;
																		obj_t BgL_arg2344z00_2676;

																		BgL_arg2343z00_2675 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2345z00_2677;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2346z00_2678;

																				BgL_arg2346z00_2678 =
																					MAKE_PAIR(BgL_a4z00_2645, BNIL);
																				BgL_list2345z00_2677 =
																					MAKE_PAIR(BgL_a3z00_2644,
																					BgL_arg2346z00_2678);
																			}
																			BgL_arg2344z00_2676 =
																				BgL_list2345z00_2677;
																		}
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2343z00_2675),
																			BgL_arg2344z00_2676);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2347z00_2679;

																		BgL_arg2347z00_2679 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2347z00_2679),
																			BgL_a1z00_2642);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2348z00_2680;

																		BgL_arg2348z00_2680 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2348z00_2680),
																			BgL_a2z00_2643);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2349z00_2681;

																		BgL_arg2349z00_2681 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 2));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2349z00_2681),
																			BgL_a3z00_2644);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2351z00_2682;
																		obj_t BgL_arg2352z00_2683;

																		BgL_arg2351z00_2682 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2353z00_2684;

																			BgL_list2353z00_2684 =
																				MAKE_PAIR(BgL_a4z00_2645, BNIL);
																			BgL_arg2352z00_2683 =
																				BgL_list2353z00_2684;
																		}
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2351z00_2682),
																			BgL_arg2352z00_2683);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2355z00_2685;

																		BgL_arg2355z00_2685 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2355z00_2685),
																			BgL_a1z00_2642);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2356z00_2686;

																		BgL_arg2356z00_2686 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2356z00_2686),
																			BgL_a2z00_2643);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2357z00_2687;

																		BgL_arg2357z00_2687 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 2));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2357z00_2687),
																			BgL_a3z00_2644);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2358z00_2688;

																		BgL_arg2358z00_2688 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 3));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2358z00_2688),
																			BgL_a4z00_2645);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2359z00_2689;

																		BgL_arg2359z00_2689 =
																			(
																			(long) CINT(BgL_bpz00_2640) + ((long) 4));
																		VECTOR_SET(BgL_sz00_2638,
																			(int) (BgL_arg2359z00_2689), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_17978,
																		STRUCT_REF(BgL_ufz00_2647,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_2649));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_17978, STRUCT_REF(BgL_ufz00_2647,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_2649));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_2693;

												BgL_z12denvz12_2693 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_2693,
													BgL_locz00_17978);
												if ((((long) CINT(BgL_bpz00_2640) +
															(long) CINT(BgL_sfz00_2651)) <
														(long) (VECTOR_LENGTH(BgL_sz00_2638))))
													{	/* Eval/evaluate_comp.scm 889 */
														return BgL_runz00_2650;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_2695;

														BgL_nsz00_2695 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2364z00_2697;

															BgL_arg2364z00_2697 =
																((long) CINT(BgL_bpz00_2640) + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_2695, ((long) 2), BgL_sz00_2638,
																BgL_bpz00_2640, BINT(BgL_arg2364z00_2697));
														}
														VECTOR_SET(BgL_nsz00_2695,
															(int) (((long) 1)), BgL_sz00_2638);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2693,
															BgL_nsz00_2695);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_2698;

															BgL_ez00_2698 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_2698, BgL_sz00_2638);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_2699;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_9973;

																	BgL_savedzd2bpzd2_9973 =
																		VECTOR_REF(BgL_nsz00_2695,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_2695,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_9980;

																		BgL_fz00_9980 = BgL_runz00_2650;
																	BgL_recz00_9979:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_9981;

																			BgL_rz00_9981 =
																				PROCEDURE_ENTRY(BgL_fz00_9980)
																				(BgL_fz00_9980, BgL_nsz00_2695, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_24350;

																				if (PROCEDUREP(BgL_rz00_9981))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_9986;

																						BgL_arg1673z00_9986 =
																							PROCEDURE_ATTR(BgL_rz00_9981);
																						if (STRUCTP(BgL_arg1673z00_9986))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_24350 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_9986) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_24350 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_24350 = ((bool_t) 0);
																					}
																				if (BgL_testz00_24350)
																					{
																						obj_t BgL_fz00_24358;

																						BgL_fz00_24358 = BgL_rz00_9981;
																						BgL_fz00_9980 = BgL_fz00_24358;
																						goto BgL_recz00_9979;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_2695,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_9973);
																						BgL_____rz00_2699 = BgL_rz00_9981;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2698);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2693,
																	BgL_sz00_2638);
																return BgL_____rz00_2699;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2641,
													(int) (((long) 4))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2701;

													BgL_nbpz00_2701 =
														((long) CINT(BgL_bpz00_2640) + BgL_siza7eza7_17980);
													VECTOR_SET(BgL_sz00_2638,
														(int) (((long) 0)), BINT(BgL_nbpz00_2701));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_auxz00_24371;

														BgL_auxz00_24371 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_24371,
															BgL_locz00_17978);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2703;

														BgL_rz00_2703 =
															PROCEDURE_ENTRY(BgL_fz00_2641) (BgL_fz00_2641,
															BgL_a1z00_2642, BgL_a2z00_2643, BgL_a3z00_2644,
															BgL_a4z00_2645, BEOA);
														VECTOR_SET(BgL_sz00_2638, (int) (((long) 0)),
															BgL_bpz00_2640);
														return BgL_rz00_2703;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17978, BgL_symbzd2funzd2_17979,
														(int) (((long) 4)), PROCEDURE_ARITY(BgL_fz00_2641));
		}}}}}}}}}
	}



/* &<anonymous:2368> */
	obj_t BGl_z62zc3anonymousza32368ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17982, obj_t BgL_sz00_17991)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17983;
				obj_t BgL_a1z00_17984;
				obj_t BgL_a2z00_17985;
				obj_t BgL_a3z00_17986;
				obj_t BgL_a4z00_17987;
				obj_t BgL_locz00_17988;
				obj_t BgL_symbzd2funzd2_17989;
				long BgL_siza7eza7_17990;

				BgL_funz00_17983 = PROCEDURE_REF(BgL_envz00_17982, (int) (((long) 0)));
				BgL_a1z00_17984 = PROCEDURE_REF(BgL_envz00_17982, (int) (((long) 1)));
				BgL_a2z00_17985 = PROCEDURE_REF(BgL_envz00_17982, (int) (((long) 2)));
				BgL_a3z00_17986 = PROCEDURE_REF(BgL_envz00_17982, (int) (((long) 3)));
				BgL_a4z00_17987 = PROCEDURE_REF(BgL_envz00_17982, (int) (((long) 4)));
				BgL_locz00_17988 = PROCEDURE_REF(BgL_envz00_17982, (int) (((long) 5)));
				BgL_symbzd2funzd2_17989 =
					PROCEDURE_REF(BgL_envz00_17982, (int) (((long) 6)));
				BgL_siza7eza7_17990 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17982, (int) (((long) 7))));
				{
					obj_t BgL_sz00_2705;

					BgL_sz00_2705 = BgL_sz00_17991;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2707;

						BgL_bpz00_2707 = VECTOR_REF(BgL_sz00_2705, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2708;
							obj_t BgL_a1z00_2709;
							obj_t BgL_a2z00_2710;
							obj_t BgL_a3z00_2711;
							obj_t BgL_a4z00_2712;

							BgL_fz00_2708 =
								PROCEDURE_ENTRY(BgL_funz00_17983) (BgL_funz00_17983,
								BgL_sz00_2705, BEOA);
							BgL_a1z00_2709 =
								PROCEDURE_ENTRY(BgL_a1z00_17984) (BgL_a1z00_17984,
								BgL_sz00_2705, BEOA);
							BgL_a2z00_2710 =
								PROCEDURE_ENTRY(BgL_a2z00_17985) (BgL_a2z00_17985,
								BgL_sz00_2705, BEOA);
							BgL_a3z00_2711 =
								PROCEDURE_ENTRY(BgL_a3z00_17986) (BgL_a3z00_17986,
								BgL_sz00_2705, BEOA);
							BgL_a4z00_2712 =
								PROCEDURE_ENTRY(BgL_a4z00_17987) (BgL_a4z00_17987,
								BgL_sz00_2705, BEOA);
							if (PROCEDUREP(BgL_fz00_2708))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17988,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2708);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2714;

								BgL_ufz00_2714 = PROCEDURE_ATTR(BgL_fz00_2708);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_24429;

									if (STRUCTP(BgL_ufz00_2714))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_24429 =
												(STRUCT_KEY(BgL_ufz00_2714) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_24429 = ((bool_t) 0);
										}
									if (BgL_testz00_24429)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2716;
											obj_t BgL_runz00_2717;
											obj_t BgL_sfz00_2718;

											BgL_arityz00_2716 =
												STRUCT_REF(BgL_ufz00_2714, (int) (((long) 0)));
											BgL_runz00_2717 =
												STRUCT_REF(BgL_ufz00_2714, (int) (((long) 1)));
											BgL_sfz00_2718 =
												STRUCT_REF(BgL_ufz00_2714, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_2716) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2372z00_2721;

														BgL_arg2372z00_2721 =
															((long) CINT(BgL_bpz00_2707) + ((long) 0));
														VECTOR_SET(BgL_sz00_2705,
															(int) (BgL_arg2372z00_2721), BgL_a1z00_2709);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2373z00_2722;

														BgL_arg2373z00_2722 =
															((long) CINT(BgL_bpz00_2707) + ((long) 1));
														VECTOR_SET(BgL_sz00_2705,
															(int) (BgL_arg2373z00_2722), BgL_a2z00_2710);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2374z00_2723;

														BgL_arg2374z00_2723 =
															((long) CINT(BgL_bpz00_2707) + ((long) 2));
														VECTOR_SET(BgL_sz00_2705,
															(int) (BgL_arg2374z00_2723), BgL_a3z00_2711);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2375z00_2724;

														BgL_arg2375z00_2724 =
															((long) CINT(BgL_bpz00_2707) + ((long) 3));
														VECTOR_SET(BgL_sz00_2705,
															(int) (BgL_arg2375z00_2724), BgL_a4z00_2712);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_2716))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_2716))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2378z00_2728;
																		obj_t BgL_arg2379z00_2729;

																		BgL_arg2378z00_2728 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2380z00_2730;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2382z00_2731;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2383z00_2732;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2384z00_2733;

																						BgL_arg2384z00_2733 =
																							MAKE_PAIR(BgL_a4z00_2712, BNIL);
																						BgL_arg2383z00_2732 =
																							MAKE_PAIR(BgL_a3z00_2711,
																							BgL_arg2384z00_2733);
																					}
																					BgL_arg2382z00_2731 =
																						MAKE_PAIR(BgL_a2z00_2710,
																						BgL_arg2383z00_2732);
																				}
																				BgL_list2380z00_2730 =
																					MAKE_PAIR(BgL_a1z00_2709,
																					BgL_arg2382z00_2731);
																			}
																			BgL_arg2379z00_2729 =
																				BgL_list2380z00_2730;
																		}
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2378z00_2728),
																			BgL_arg2379z00_2729);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2385z00_2734;

																		BgL_arg2385z00_2734 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2385z00_2734),
																			BgL_a1z00_2709);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2386z00_2735;
																		obj_t BgL_arg2387z00_2736;

																		BgL_arg2386z00_2735 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2388z00_2737;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2389z00_2738;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2390z00_2739;

																					BgL_arg2390z00_2739 =
																						MAKE_PAIR(BgL_a4z00_2712, BNIL);
																					BgL_arg2389z00_2738 =
																						MAKE_PAIR(BgL_a3z00_2711,
																						BgL_arg2390z00_2739);
																				}
																				BgL_list2388z00_2737 =
																					MAKE_PAIR(BgL_a2z00_2710,
																					BgL_arg2389z00_2738);
																			}
																			BgL_arg2387z00_2736 =
																				BgL_list2388z00_2737;
																		}
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2386z00_2735),
																			BgL_arg2387z00_2736);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2391z00_2740;

																		BgL_arg2391z00_2740 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2391z00_2740),
																			BgL_a1z00_2709);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2392z00_2741;

																		BgL_arg2392z00_2741 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2392z00_2741),
																			BgL_a2z00_2710);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2393z00_2742;
																		obj_t BgL_arg2394z00_2743;

																		BgL_arg2393z00_2742 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2395z00_2744;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2396z00_2745;

																				BgL_arg2396z00_2745 =
																					MAKE_PAIR(BgL_a4z00_2712, BNIL);
																				BgL_list2395z00_2744 =
																					MAKE_PAIR(BgL_a3z00_2711,
																					BgL_arg2396z00_2745);
																			}
																			BgL_arg2394z00_2743 =
																				BgL_list2395z00_2744;
																		}
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2393z00_2742),
																			BgL_arg2394z00_2743);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2397z00_2746;

																		BgL_arg2397z00_2746 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2397z00_2746),
																			BgL_a1z00_2709);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2398z00_2747;

																		BgL_arg2398z00_2747 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2398z00_2747),
																			BgL_a2z00_2710);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2399z00_2748;

																		BgL_arg2399z00_2748 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 2));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2399z00_2748),
																			BgL_a3z00_2711);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2400z00_2749;
																		obj_t BgL_arg2401z00_2750;

																		BgL_arg2400z00_2749 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2402z00_2751;

																			BgL_list2402z00_2751 =
																				MAKE_PAIR(BgL_a4z00_2712, BNIL);
																			BgL_arg2401z00_2750 =
																				BgL_list2402z00_2751;
																		}
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2400z00_2749),
																			BgL_arg2401z00_2750);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2403z00_2752;

																		BgL_arg2403z00_2752 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 0));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2403z00_2752),
																			BgL_a1z00_2709);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2404z00_2753;

																		BgL_arg2404z00_2753 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 1));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2404z00_2753),
																			BgL_a2z00_2710);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2405z00_2754;

																		BgL_arg2405z00_2754 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 2));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2405z00_2754),
																			BgL_a3z00_2711);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2406z00_2755;

																		BgL_arg2406z00_2755 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 3));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2406z00_2755),
																			BgL_a4z00_2712);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2407z00_2756;

																		BgL_arg2407z00_2756 =
																			(
																			(long) CINT(BgL_bpz00_2707) + ((long) 4));
																		VECTOR_SET(BgL_sz00_2705,
																			(int) (BgL_arg2407z00_2756), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_17988,
																		STRUCT_REF(BgL_ufz00_2714,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_2716));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_17988, STRUCT_REF(BgL_ufz00_2714,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_2716));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_2760;

												BgL_z12denvz12_2760 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_2707) +
															(long) CINT(BgL_sfz00_2718)) <
														(long) (VECTOR_LENGTH(BgL_sz00_2705))))
													{	/* Eval/evaluate_comp.scm 889 */
														return BgL_runz00_2717;
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_2762;

														BgL_nsz00_2762 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2412z00_2764;

															BgL_arg2412z00_2764 =
																((long) CINT(BgL_bpz00_2707) + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_2762, ((long) 2), BgL_sz00_2705,
																BgL_bpz00_2707, BINT(BgL_arg2412z00_2764));
														}
														VECTOR_SET(BgL_nsz00_2762,
															(int) (((long) 1)), BgL_sz00_2705);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2760,
															BgL_nsz00_2762);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_2765;

															BgL_ez00_2765 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_2765, BgL_sz00_2705);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_2766;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_10194;

																	BgL_savedzd2bpzd2_10194 =
																		VECTOR_REF(BgL_nsz00_2762,
																		(int) (((long) 0)));
																	VECTOR_SET(BgL_nsz00_2762,
																		(int) (((long) 0)), BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_10201;

																		BgL_fz00_10201 = BgL_runz00_2717;
																	BgL_recz00_10200:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_10202;

																			BgL_rz00_10202 =
																				PROCEDURE_ENTRY(BgL_fz00_10201)
																				(BgL_fz00_10201, BgL_nsz00_2762, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_24570;

																				if (PROCEDUREP(BgL_rz00_10202))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1673z00_10207;

																						BgL_arg1673z00_10207 =
																							PROCEDURE_ATTR(BgL_rz00_10202);
																						if (STRUCTP(BgL_arg1673z00_10207))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_24570 =
																									(STRUCT_KEY
																									(BgL_arg1673z00_10207) ==
																									BGl_symbol5591z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_24570 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_24570 = ((bool_t) 0);
																					}
																				if (BgL_testz00_24570)
																					{
																						obj_t BgL_fz00_24578;

																						BgL_fz00_24578 = BgL_rz00_10202;
																						BgL_fz00_10201 = BgL_fz00_24578;
																						goto BgL_recz00_10200;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_2762,
																							(int) (((long) 0)),
																							BgL_savedzd2bpzd2_10194);
																						BgL_____rz00_2766 = BgL_rz00_10202;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2765);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2760,
																	BgL_sz00_2705);
																return BgL_____rz00_2766;
															}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2708,
													(int) (((long) 4))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2768;

													BgL_nbpz00_2768 =
														((long) CINT(BgL_bpz00_2707) + BgL_siza7eza7_17990);
													VECTOR_SET(BgL_sz00_2705,
														(int) (((long) 0)), BINT(BgL_nbpz00_2768));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2769;

														BgL_rz00_2769 =
															PROCEDURE_ENTRY(BgL_fz00_2708) (BgL_fz00_2708,
															BgL_a1z00_2709, BgL_a2z00_2710, BgL_a3z00_2711,
															BgL_a4z00_2712, BEOA);
														VECTOR_SET(BgL_sz00_2705, (int) (((long) 0)),
															BgL_bpz00_2707);
														return BgL_rz00_2769;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17988, BgL_symbzd2funzd2_17989,
														(int) (((long) 4)), PROCEDURE_ARITY(BgL_fz00_2708));
		}}}}}}}}}
	}



/* &<anonymous:2417> */
	obj_t BGl_z62zc3anonymousza32417ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17992, obj_t BgL_sz00_18001)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_17993;
				obj_t BgL_a1z00_17994;
				obj_t BgL_a2z00_17995;
				obj_t BgL_a3z00_17996;
				obj_t BgL_a4z00_17997;
				obj_t BgL_locz00_17998;
				obj_t BgL_symbzd2funzd2_17999;
				long BgL_siza7eza7_18000;

				BgL_funz00_17993 = PROCEDURE_REF(BgL_envz00_17992, (int) (((long) 0)));
				BgL_a1z00_17994 = PROCEDURE_REF(BgL_envz00_17992, (int) (((long) 1)));
				BgL_a2z00_17995 = PROCEDURE_REF(BgL_envz00_17992, (int) (((long) 2)));
				BgL_a3z00_17996 = PROCEDURE_REF(BgL_envz00_17992, (int) (((long) 3)));
				BgL_a4z00_17997 = PROCEDURE_REF(BgL_envz00_17992, (int) (((long) 4)));
				BgL_locz00_17998 = PROCEDURE_REF(BgL_envz00_17992, (int) (((long) 5)));
				BgL_symbzd2funzd2_17999 =
					PROCEDURE_REF(BgL_envz00_17992, (int) (((long) 6)));
				BgL_siza7eza7_18000 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17992, (int) (((long) 7))));
				{
					obj_t BgL_sz00_2773;

					BgL_sz00_2773 = BgL_sz00_18001;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2775;

						BgL_bpz00_2775 = VECTOR_REF(BgL_sz00_2773, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2776;
							obj_t BgL_a1z00_2777;
							obj_t BgL_a2z00_2778;
							obj_t BgL_a3z00_2779;
							obj_t BgL_a4z00_2780;

							BgL_fz00_2776 =
								PROCEDURE_ENTRY(BgL_funz00_17993) (BgL_funz00_17993,
								BgL_sz00_2773, BEOA);
							BgL_a1z00_2777 =
								PROCEDURE_ENTRY(BgL_a1z00_17994) (BgL_a1z00_17994,
								BgL_sz00_2773, BEOA);
							BgL_a2z00_2778 =
								PROCEDURE_ENTRY(BgL_a2z00_17995) (BgL_a2z00_17995,
								BgL_sz00_2773, BEOA);
							BgL_a3z00_2779 =
								PROCEDURE_ENTRY(BgL_a3z00_17996) (BgL_a3z00_17996,
								BgL_sz00_2773, BEOA);
							BgL_a4z00_2780 =
								PROCEDURE_ENTRY(BgL_a4z00_17997) (BgL_a4z00_17997,
								BgL_sz00_2773, BEOA);
							if (PROCEDUREP(BgL_fz00_2776))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_17998,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2776);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2782;

								BgL_ufz00_2782 = PROCEDURE_ATTR(BgL_fz00_2776);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_24646;

									if (STRUCTP(BgL_ufz00_2782))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_24646 =
												(STRUCT_KEY(BgL_ufz00_2782) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_24646 = ((bool_t) 0);
										}
									if (BgL_testz00_24646)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2784;
											obj_t BgL_runz00_2785;
											obj_t BgL_sfz00_2786;

											BgL_arityz00_2784 =
												STRUCT_REF(BgL_ufz00_2782, (int) (((long) 0)));
											BgL_runz00_2785 =
												STRUCT_REF(BgL_ufz00_2782, (int) (((long) 1)));
											BgL_sfz00_2786 =
												STRUCT_REF(BgL_ufz00_2782, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_spz00_2787;

												BgL_spz00_2787 =
													((long) CINT(BgL_bpz00_2775) + BgL_siza7eza7_18000);
												if (((long) CINT(BgL_arityz00_2784) == ((long) 4)))
													{	/* Eval/evaluate_comp.scm 889 */
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2421z00_2789;

															BgL_arg2421z00_2789 =
																(BgL_spz00_2787 + ((long) 0));
															VECTOR_SET(BgL_sz00_2773,
																(int) (BgL_arg2421z00_2789), BgL_a1z00_2777);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2422z00_2790;

															BgL_arg2422z00_2790 =
																(BgL_spz00_2787 + ((long) 1));
															VECTOR_SET(BgL_sz00_2773,
																(int) (BgL_arg2422z00_2790), BgL_a2z00_2778);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2423z00_2791;

															BgL_arg2423z00_2791 =
																(BgL_spz00_2787 + ((long) 2));
															VECTOR_SET(BgL_sz00_2773,
																(int) (BgL_arg2423z00_2791), BgL_a3z00_2779);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2424z00_2792;

															BgL_arg2424z00_2792 =
																(BgL_spz00_2787 + ((long) 3));
															VECTOR_SET(BgL_sz00_2773,
																(int) (BgL_arg2424z00_2792), BgL_a4z00_2780);
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														if (INTEGERP(BgL_arityz00_2784))
															{	/* Eval/evaluate_comp.scm 889 */
																switch ((long) CINT(BgL_arityz00_2784))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2426z00_2796;
																			obj_t BgL_arg2427z00_2797;

																			BgL_arg2426z00_2796 =
																				(BgL_spz00_2787 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2428z00_2798;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2429z00_2799;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2430z00_2800;

																						{	/* Eval/evaluate_comp.scm 889 */
																							obj_t BgL_arg2431z00_2801;

																							BgL_arg2431z00_2801 =
																								MAKE_PAIR(BgL_a4z00_2780, BNIL);
																							BgL_arg2430z00_2800 =
																								MAKE_PAIR(BgL_a3z00_2779,
																								BgL_arg2431z00_2801);
																						}
																						BgL_arg2429z00_2799 =
																							MAKE_PAIR(BgL_a2z00_2778,
																							BgL_arg2430z00_2800);
																					}
																					BgL_list2428z00_2798 =
																						MAKE_PAIR(BgL_a1z00_2777,
																						BgL_arg2429z00_2799);
																				}
																				BgL_arg2427z00_2797 =
																					BgL_list2428z00_2798;
																			}
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2426z00_2796),
																				BgL_arg2427z00_2797);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2433z00_2802;

																			BgL_arg2433z00_2802 =
																				(BgL_spz00_2787 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2433z00_2802),
																				BgL_a1z00_2777);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2434z00_2803;
																			obj_t BgL_arg2436z00_2804;

																			BgL_arg2434z00_2803 =
																				(BgL_spz00_2787 + ((long) 1));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2437z00_2805;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2438z00_2806;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2439z00_2807;

																						BgL_arg2439z00_2807 =
																							MAKE_PAIR(BgL_a4z00_2780, BNIL);
																						BgL_arg2438z00_2806 =
																							MAKE_PAIR(BgL_a3z00_2779,
																							BgL_arg2439z00_2807);
																					}
																					BgL_list2437z00_2805 =
																						MAKE_PAIR(BgL_a2z00_2778,
																						BgL_arg2438z00_2806);
																				}
																				BgL_arg2436z00_2804 =
																					BgL_list2437z00_2805;
																			}
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2434z00_2803),
																				BgL_arg2436z00_2804);
																		} break;
																	case ((long) -3):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2441z00_2808;

																			BgL_arg2441z00_2808 =
																				(BgL_spz00_2787 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2441z00_2808),
																				BgL_a1z00_2777);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2442z00_2809;

																			BgL_arg2442z00_2809 =
																				(BgL_spz00_2787 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2442z00_2809),
																				BgL_a2z00_2778);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2443z00_2810;
																			obj_t BgL_arg2444z00_2811;

																			BgL_arg2443z00_2810 =
																				(BgL_spz00_2787 + ((long) 2));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2445z00_2812;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2446z00_2813;

																					BgL_arg2446z00_2813 =
																						MAKE_PAIR(BgL_a4z00_2780, BNIL);
																					BgL_list2445z00_2812 =
																						MAKE_PAIR(BgL_a3z00_2779,
																						BgL_arg2446z00_2813);
																				}
																				BgL_arg2444z00_2811 =
																					BgL_list2445z00_2812;
																			}
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2443z00_2810),
																				BgL_arg2444z00_2811);
																		} break;
																	case ((long) -4):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2447z00_2814;

																			BgL_arg2447z00_2814 =
																				(BgL_spz00_2787 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2447z00_2814),
																				BgL_a1z00_2777);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2448z00_2815;

																			BgL_arg2448z00_2815 =
																				(BgL_spz00_2787 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2448z00_2815),
																				BgL_a2z00_2778);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2449z00_2816;

																			BgL_arg2449z00_2816 =
																				(BgL_spz00_2787 + ((long) 2));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2449z00_2816),
																				BgL_a3z00_2779);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2451z00_2817;
																			obj_t BgL_arg2452z00_2818;

																			BgL_arg2451z00_2817 =
																				(BgL_spz00_2787 + ((long) 3));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2453z00_2819;

																				BgL_list2453z00_2819 =
																					MAKE_PAIR(BgL_a4z00_2780, BNIL);
																				BgL_arg2452z00_2818 =
																					BgL_list2453z00_2819;
																			}
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2451z00_2817),
																				BgL_arg2452z00_2818);
																		} break;
																	case ((long) -5):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2454z00_2820;

																			BgL_arg2454z00_2820 =
																				(BgL_spz00_2787 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2454z00_2820),
																				BgL_a1z00_2777);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2455z00_2821;

																			BgL_arg2455z00_2821 =
																				(BgL_spz00_2787 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2455z00_2821),
																				BgL_a2z00_2778);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2456z00_2822;

																			BgL_arg2456z00_2822 =
																				(BgL_spz00_2787 + ((long) 2));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2456z00_2822),
																				BgL_a3z00_2779);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2457z00_2823;

																			BgL_arg2457z00_2823 =
																				(BgL_spz00_2787 + ((long) 3));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2457z00_2823),
																				BgL_a4z00_2780);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2459z00_2824;

																			BgL_arg2459z00_2824 =
																				(BgL_spz00_2787 + ((long) 4));
																			VECTOR_SET(BgL_sz00_2773,
																				(int) (BgL_arg2459z00_2824), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_17998,
																			STRUCT_REF(BgL_ufz00_2782,
																				(int) (((long) 3))), (int) (((long) 4)),
																			CINT(BgL_arityz00_2784));
															}}
														else
															{	/* Eval/evaluate_comp.scm 889 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_17998, STRUCT_REF(BgL_ufz00_2782,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_2784));
													}}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_z12denvz12_2828;

													BgL_z12denvz12_2828 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_2828,
														BgL_locz00_17998);
													if (((BgL_spz00_2787 + (long) CINT(BgL_sfz00_2786)) <
															(long) (VECTOR_LENGTH(BgL_sz00_2773))))
														{	/* Eval/evaluate_comp.scm 889 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_2785, BgL_sz00_2773,
																BINT(BgL_spz00_2787));
														}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_nsz00_2830;

															BgL_nsz00_2830 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 889 */
																long BgL_arg2464z00_2832;

																BgL_arg2464z00_2832 =
																	(BgL_spz00_2787 + ((long) 4));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_2830, ((long) 2), BgL_sz00_2773,
																	BINT(BgL_spz00_2787),
																	BINT(BgL_arg2464z00_2832));
															}
															VECTOR_SET(BgL_nsz00_2830,
																(int) (((long) 1)), BgL_sz00_2773);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2828,
																BgL_nsz00_2830);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_ez00_2833;

																BgL_ez00_2833 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2833, BgL_sz00_2773);
																{	/* Eval/evaluate_comp.scm 889 */
																	obj_t BgL_____rz00_2834;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_10413;

																		BgL_savedzd2bpzd2_10413 =
																			VECTOR_REF(BgL_nsz00_2830,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_2830,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_10420;

																			BgL_fz00_10420 = BgL_runz00_2785;
																		BgL_recz00_10419:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_10421;

																				BgL_rz00_10421 =
																					PROCEDURE_ENTRY(BgL_fz00_10420)
																					(BgL_fz00_10420, BgL_nsz00_2830,
																					BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_24772;

																					if (PROCEDUREP(BgL_rz00_10421))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_10426;

																							BgL_arg1673z00_10426 =
																								PROCEDURE_ATTR(BgL_rz00_10421);
																							if (STRUCTP(BgL_arg1673z00_10426))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_24772 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_10426) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_24772 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_24772 = ((bool_t) 0);
																						}
																					if (BgL_testz00_24772)
																						{
																							obj_t BgL_fz00_24780;

																							BgL_fz00_24780 = BgL_rz00_10421;
																							BgL_fz00_10420 = BgL_fz00_24780;
																							goto BgL_recz00_10419;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_2830,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_10413);
																							BgL_____rz00_2834 =
																								BgL_rz00_10421;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_2833);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2828,
																		BgL_sz00_2773);
																	return BgL_____rz00_2834;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2776,
													(int) (((long) 4))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2836;

													BgL_nbpz00_2836 =
														((long) CINT(BgL_bpz00_2775) + BgL_siza7eza7_18000);
													VECTOR_SET(BgL_sz00_2773,
														(int) (((long) 0)), BINT(BgL_nbpz00_2836));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_auxz00_24793;

														BgL_auxz00_24793 = BGL_CURRENT_DYNAMIC_ENV();
														BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_24793,
															BgL_locz00_17998);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2838;

														BgL_rz00_2838 =
															PROCEDURE_ENTRY(BgL_fz00_2776) (BgL_fz00_2776,
															BgL_a1z00_2777, BgL_a2z00_2778, BgL_a3z00_2779,
															BgL_a4z00_2780, BEOA);
														VECTOR_SET(BgL_sz00_2773, (int) (((long) 0)),
															BgL_bpz00_2775);
														return BgL_rz00_2838;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_17998, BgL_symbzd2funzd2_17999,
														(int) (((long) 4)), PROCEDURE_ARITY(BgL_fz00_2776));
		}}}}}}}}}
	}



/* &<anonymous:2469> */
	obj_t BGl_z62zc3anonymousza32469ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18002, obj_t BgL_sz00_18011)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_18003;
				obj_t BgL_a1z00_18004;
				obj_t BgL_a2z00_18005;
				obj_t BgL_a3z00_18006;
				obj_t BgL_a4z00_18007;
				obj_t BgL_locz00_18008;
				obj_t BgL_symbzd2funzd2_18009;
				long BgL_siza7eza7_18010;

				BgL_funz00_18003 = PROCEDURE_REF(BgL_envz00_18002, (int) (((long) 0)));
				BgL_a1z00_18004 = PROCEDURE_REF(BgL_envz00_18002, (int) (((long) 1)));
				BgL_a2z00_18005 = PROCEDURE_REF(BgL_envz00_18002, (int) (((long) 2)));
				BgL_a3z00_18006 = PROCEDURE_REF(BgL_envz00_18002, (int) (((long) 3)));
				BgL_a4z00_18007 = PROCEDURE_REF(BgL_envz00_18002, (int) (((long) 4)));
				BgL_locz00_18008 = PROCEDURE_REF(BgL_envz00_18002, (int) (((long) 5)));
				BgL_symbzd2funzd2_18009 =
					PROCEDURE_REF(BgL_envz00_18002, (int) (((long) 6)));
				BgL_siza7eza7_18010 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18002, (int) (((long) 7))));
				{
					obj_t BgL_sz00_2840;

					BgL_sz00_2840 = BgL_sz00_18011;
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_bpz00_2842;

						BgL_bpz00_2842 = VECTOR_REF(BgL_sz00_2840, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_fz00_2843;
							obj_t BgL_a1z00_2844;
							obj_t BgL_a2z00_2845;
							obj_t BgL_a3z00_2846;
							obj_t BgL_a4z00_2847;

							BgL_fz00_2843 =
								PROCEDURE_ENTRY(BgL_funz00_18003) (BgL_funz00_18003,
								BgL_sz00_2840, BEOA);
							BgL_a1z00_2844 =
								PROCEDURE_ENTRY(BgL_a1z00_18004) (BgL_a1z00_18004,
								BgL_sz00_2840, BEOA);
							BgL_a2z00_2845 =
								PROCEDURE_ENTRY(BgL_a2z00_18005) (BgL_a2z00_18005,
								BgL_sz00_2840, BEOA);
							BgL_a3z00_2846 =
								PROCEDURE_ENTRY(BgL_a3z00_18006) (BgL_a3z00_18006,
								BgL_sz00_2840, BEOA);
							BgL_a4z00_2847 =
								PROCEDURE_ENTRY(BgL_a4z00_18007) (BgL_a4z00_18007,
								BgL_sz00_2840, BEOA);
							if (PROCEDUREP(BgL_fz00_2843))
								{	/* Eval/evaluate_comp.scm 889 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 889 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_18008,
										BGl_string5595z00zz__evaluate_compz00,
										BGl_string5611z00zz__evaluate_compz00, BgL_fz00_2843);
								}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_ufz00_2849;

								BgL_ufz00_2849 = PROCEDURE_ATTR(BgL_fz00_2843);
								{	/* Eval/evaluate_comp.scm 889 */
									bool_t BgL_testz00_24851;

									if (STRUCTP(BgL_ufz00_2849))
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_24851 =
												(STRUCT_KEY(BgL_ufz00_2849) ==
												BGl_symbol5612z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 676 */
											BgL_testz00_24851 = ((bool_t) 0);
										}
									if (BgL_testz00_24851)
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_arityz00_2851;
											obj_t BgL_runz00_2852;
											obj_t BgL_sfz00_2853;

											BgL_arityz00_2851 =
												STRUCT_REF(BgL_ufz00_2849, (int) (((long) 0)));
											BgL_runz00_2852 =
												STRUCT_REF(BgL_ufz00_2849, (int) (((long) 1)));
											BgL_sfz00_2853 =
												STRUCT_REF(BgL_ufz00_2849, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_spz00_2854;

												BgL_spz00_2854 =
													((long) CINT(BgL_bpz00_2842) + BgL_siza7eza7_18010);
												if (((long) CINT(BgL_arityz00_2851) == ((long) 4)))
													{	/* Eval/evaluate_comp.scm 889 */
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2473z00_2856;

															BgL_arg2473z00_2856 =
																(BgL_spz00_2854 + ((long) 0));
															VECTOR_SET(BgL_sz00_2840,
																(int) (BgL_arg2473z00_2856), BgL_a1z00_2844);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2474z00_2857;

															BgL_arg2474z00_2857 =
																(BgL_spz00_2854 + ((long) 1));
															VECTOR_SET(BgL_sz00_2840,
																(int) (BgL_arg2474z00_2857), BgL_a2z00_2845);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2475z00_2858;

															BgL_arg2475z00_2858 =
																(BgL_spz00_2854 + ((long) 2));
															VECTOR_SET(BgL_sz00_2840,
																(int) (BgL_arg2475z00_2858), BgL_a3z00_2846);
														}
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2476z00_2859;

															BgL_arg2476z00_2859 =
																(BgL_spz00_2854 + ((long) 3));
															VECTOR_SET(BgL_sz00_2840,
																(int) (BgL_arg2476z00_2859), BgL_a4z00_2847);
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														if (INTEGERP(BgL_arityz00_2851))
															{	/* Eval/evaluate_comp.scm 889 */
																switch ((long) CINT(BgL_arityz00_2851))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2478z00_2863;
																			obj_t BgL_arg2479z00_2864;

																			BgL_arg2478z00_2863 =
																				(BgL_spz00_2854 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2480z00_2865;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2481z00_2866;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2482z00_2867;

																						{	/* Eval/evaluate_comp.scm 889 */
																							obj_t BgL_arg2483z00_2868;

																							BgL_arg2483z00_2868 =
																								MAKE_PAIR(BgL_a4z00_2847, BNIL);
																							BgL_arg2482z00_2867 =
																								MAKE_PAIR(BgL_a3z00_2846,
																								BgL_arg2483z00_2868);
																						}
																						BgL_arg2481z00_2866 =
																							MAKE_PAIR(BgL_a2z00_2845,
																							BgL_arg2482z00_2867);
																					}
																					BgL_list2480z00_2865 =
																						MAKE_PAIR(BgL_a1z00_2844,
																						BgL_arg2481z00_2866);
																				}
																				BgL_arg2479z00_2864 =
																					BgL_list2480z00_2865;
																			}
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2478z00_2863),
																				BgL_arg2479z00_2864);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2484z00_2869;

																			BgL_arg2484z00_2869 =
																				(BgL_spz00_2854 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2484z00_2869),
																				BgL_a1z00_2844);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2485z00_2870;
																			obj_t BgL_arg2487z00_2871;

																			BgL_arg2485z00_2870 =
																				(BgL_spz00_2854 + ((long) 1));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2488z00_2872;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2489z00_2873;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2490z00_2874;

																						BgL_arg2490z00_2874 =
																							MAKE_PAIR(BgL_a4z00_2847, BNIL);
																						BgL_arg2489z00_2873 =
																							MAKE_PAIR(BgL_a3z00_2846,
																							BgL_arg2490z00_2874);
																					}
																					BgL_list2488z00_2872 =
																						MAKE_PAIR(BgL_a2z00_2845,
																						BgL_arg2489z00_2873);
																				}
																				BgL_arg2487z00_2871 =
																					BgL_list2488z00_2872;
																			}
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2485z00_2870),
																				BgL_arg2487z00_2871);
																		} break;
																	case ((long) -3):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2491z00_2875;

																			BgL_arg2491z00_2875 =
																				(BgL_spz00_2854 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2491z00_2875),
																				BgL_a1z00_2844);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2493z00_2876;

																			BgL_arg2493z00_2876 =
																				(BgL_spz00_2854 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2493z00_2876),
																				BgL_a2z00_2845);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2495z00_2877;
																			obj_t BgL_arg2496z00_2878;

																			BgL_arg2495z00_2877 =
																				(BgL_spz00_2854 + ((long) 2));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2497z00_2879;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2499z00_2880;

																					BgL_arg2499z00_2880 =
																						MAKE_PAIR(BgL_a4z00_2847, BNIL);
																					BgL_list2497z00_2879 =
																						MAKE_PAIR(BgL_a3z00_2846,
																						BgL_arg2499z00_2880);
																				}
																				BgL_arg2496z00_2878 =
																					BgL_list2497z00_2879;
																			}
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2495z00_2877),
																				BgL_arg2496z00_2878);
																		} break;
																	case ((long) -4):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2501z00_2881;

																			BgL_arg2501z00_2881 =
																				(BgL_spz00_2854 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2501z00_2881),
																				BgL_a1z00_2844);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2502z00_2882;

																			BgL_arg2502z00_2882 =
																				(BgL_spz00_2854 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2502z00_2882),
																				BgL_a2z00_2845);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2503z00_2883;

																			BgL_arg2503z00_2883 =
																				(BgL_spz00_2854 + ((long) 2));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2503z00_2883),
																				BgL_a3z00_2846);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2504z00_2884;
																			obj_t BgL_arg2506z00_2885;

																			BgL_arg2504z00_2884 =
																				(BgL_spz00_2854 + ((long) 3));
																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_list2507z00_2886;

																				BgL_list2507z00_2886 =
																					MAKE_PAIR(BgL_a4z00_2847, BNIL);
																				BgL_arg2506z00_2885 =
																					BgL_list2507z00_2886;
																			}
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2504z00_2884),
																				BgL_arg2506z00_2885);
																		} break;
																	case ((long) -5):

																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2508z00_2887;

																			BgL_arg2508z00_2887 =
																				(BgL_spz00_2854 + ((long) 0));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2508z00_2887),
																				BgL_a1z00_2844);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2509z00_2888;

																			BgL_arg2509z00_2888 =
																				(BgL_spz00_2854 + ((long) 1));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2509z00_2888),
																				BgL_a2z00_2845);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2510z00_2889;

																			BgL_arg2510z00_2889 =
																				(BgL_spz00_2854 + ((long) 2));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2510z00_2889),
																				BgL_a3z00_2846);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2511z00_2890;

																			BgL_arg2511z00_2890 =
																				(BgL_spz00_2854 + ((long) 3));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2511z00_2890),
																				BgL_a4z00_2847);
																		}
																		{	/* Eval/evaluate_comp.scm 889 */
																			long BgL_arg2512z00_2891;

																			BgL_arg2512z00_2891 =
																				(BgL_spz00_2854 + ((long) 4));
																			VECTOR_SET(BgL_sz00_2840,
																				(int) (BgL_arg2512z00_2891), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_18008,
																			STRUCT_REF(BgL_ufz00_2849,
																				(int) (((long) 3))), (int) (((long) 4)),
																			CINT(BgL_arityz00_2851));
															}}
														else
															{	/* Eval/evaluate_comp.scm 889 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_18008, STRUCT_REF(BgL_ufz00_2849,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_2851));
													}}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_z12denvz12_2895;

													BgL_z12denvz12_2895 = BGL_CURRENT_DYNAMIC_ENV();
													if (
														((BgL_spz00_2854 +
																(long) CINT(BgL_sfz00_2853)) <
															(long) (VECTOR_LENGTH(BgL_sz00_2840))))
														{	/* Eval/evaluate_comp.scm 889 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_2852, BgL_sz00_2840,
																BINT(BgL_spz00_2854));
														}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_nsz00_2897;

															BgL_nsz00_2897 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 889 */
																long BgL_arg2518z00_2899;

																BgL_arg2518z00_2899 =
																	(BgL_spz00_2854 + ((long) 4));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_2897, ((long) 2), BgL_sz00_2840,
																	BINT(BgL_spz00_2854),
																	BINT(BgL_arg2518z00_2899));
															}
															VECTOR_SET(BgL_nsz00_2897,
																(int) (((long) 1)), BgL_sz00_2840);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2895,
																BgL_nsz00_2897);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_ez00_2900;

																BgL_ez00_2900 = BGL_EXITD_TOP_AS_OBJ();
																BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																	(BgL_ez00_2900, BgL_sz00_2840);
																{	/* Eval/evaluate_comp.scm 889 */
																	obj_t BgL_____rz00_2901;

																	{	/* Eval/evaluate_comp.scm 663 */
																		obj_t BgL_savedzd2bpzd2_10633;

																		BgL_savedzd2bpzd2_10633 =
																			VECTOR_REF(BgL_nsz00_2897,
																			(int) (((long) 0)));
																		VECTOR_SET(BgL_nsz00_2897,
																			(int) (((long) 0)), BINT(((long) 2)));
																		{
																			obj_t BgL_fz00_10640;

																			BgL_fz00_10640 = BgL_runz00_2852;
																		BgL_recz00_10639:
																			{	/* Eval/evaluate_comp.scm 666 */
																				obj_t BgL_rz00_10641;

																				BgL_rz00_10641 =
																					PROCEDURE_ENTRY(BgL_fz00_10640)
																					(BgL_fz00_10640, BgL_nsz00_2897,
																					BEOA);
																				{	/* Eval/evaluate_comp.scm 667 */
																					bool_t BgL_testz00_24976;

																					if (PROCEDUREP(BgL_rz00_10641))
																						{	/* Eval/evaluate_comp.scm 667 */
																							obj_t BgL_arg1673z00_10646;

																							BgL_arg1673z00_10646 =
																								PROCEDURE_ATTR(BgL_rz00_10641);
																							if (STRUCTP(BgL_arg1673z00_10646))
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_24976 =
																										(STRUCT_KEY
																										(BgL_arg1673z00_10646) ==
																										BGl_symbol5591z00zz__evaluate_compz00);
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 647 */
																									BgL_testz00_24976 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							BgL_testz00_24976 = ((bool_t) 0);
																						}
																					if (BgL_testz00_24976)
																						{
																							obj_t BgL_fz00_24984;

																							BgL_fz00_24984 = BgL_rz00_10641;
																							BgL_fz00_10640 = BgL_fz00_24984;
																							goto BgL_recz00_10639;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 667 */
																							VECTOR_SET(BgL_nsz00_2897,
																								(int) (((long) 0)),
																								BgL_savedzd2bpzd2_10633);
																							BgL_____rz00_2901 =
																								BgL_rz00_10641;
																	}}}}}
																	BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																		(BgL_ez00_2900);
																	BGL_ENV_EVSTATE_SET(BgL_z12denvz12_2895,
																		BgL_sz00_2840);
																	return BgL_____rz00_2901;
																}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 889 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_2843,
													(int) (((long) 4))))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_nbpz00_2903;

													BgL_nbpz00_2903 =
														((long) CINT(BgL_bpz00_2842) + BgL_siza7eza7_18010);
													VECTOR_SET(BgL_sz00_2840,
														(int) (((long) 0)), BINT(BgL_nbpz00_2903));
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_rz00_2904;

														BgL_rz00_2904 =
															PROCEDURE_ENTRY(BgL_fz00_2843) (BgL_fz00_2843,
															BgL_a1z00_2844, BgL_a2z00_2845, BgL_a3z00_2846,
															BgL_a4z00_2847, BEOA);
														VECTOR_SET(BgL_sz00_2840, (int) (((long) 0)),
															BgL_bpz00_2842);
														return BgL_rz00_2904;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_18008, BgL_symbzd2funzd2_18009,
														(int) (((long) 4)), PROCEDURE_ARITY(BgL_fz00_2843));
		}}}}}}}}}
	}



/* is-constant-fun? */
	obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185,
		obj_t BgL_symbzd2funzd2_186)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 892 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_gz00_2909;

					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_arg2533z00_2915;
						obj_t BgL_arg2534z00_2916;

						BgL_arg2533z00_2915 =
							(((BgL_ev_globalz00_bglt) CREF(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_modz00);
						BgL_arg2534z00_2916 =
							(((BgL_ev_globalz00_bglt) CREF(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_namez00);
						BgL_gz00_2909 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg2533z00_2915, BgL_arg2534z00_2916);
					}
					if (CBOOL(BgL_gz00_2909))
						{	/* Eval/evaluate_comp.scm 898 */
							bool_t BgL_testz00_25019;

							{	/* Eval/evaluate_comp.scm 898 */
								int BgL_arg2530z00_2914;

								{	/* Eval/evaluate_comp.scm 898 */
									int BgL_res4789z00_10670;

									{	/* Eval/evaluate_comp.scm 898 */
										int BgL_kz00_10669;

										BgL_kz00_10669 = (int) (((long) 0));
										BgL_res4789z00_10670 =
											CINT(VECTOR_REF(BgL_gz00_2909, BgL_kz00_10669));
									}
									BgL_arg2530z00_2914 = BgL_res4789z00_10670;
								}
								BgL_testz00_25019 =
									((long) (BgL_arg2530z00_2914) == ((long) 0));
							}
							if (BgL_testz00_25019)
								{	/* Eval/evaluate_comp.scm 899 */
									obj_t BgL_valz00_2911;

									BgL_valz00_2911 =
										VECTOR_REF(BgL_gz00_2909, (int) (((long) 2)));
									{	/* Eval/evaluate_comp.scm 900 */
										bool_t BgL_testz00_25027;

										if (PROCEDUREP(BgL_valz00_2911))
											{	/* Eval/evaluate_comp.scm 900 */
												BgL_testz00_25027 =
													PROCEDURE_CORRECT_ARITYP(BgL_valz00_2911,
													(int) (BgL_nbargsz00_184));
											}
										else
											{	/* Eval/evaluate_comp.scm 900 */
												BgL_testz00_25027 = ((bool_t) 0);
											}
										if (BgL_testz00_25027)
											{	/* Eval/evaluate_comp.scm 900 */
												return BgL_valz00_2911;
											}
										else
											{	/* Eval/evaluate_comp.scm 900 */
												return BFALSE;
											}
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 898 */
									return BFALSE;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 897 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 903 */
					bool_t BgL_testz00_25032;

					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 904 */
							obj_t BgL_auxz00_25036;

							BgL_auxz00_25036 =
								(((BgL_ev_littz00_bglt) CREF(
										((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
							BgL_testz00_25032 = PROCEDUREP(BgL_auxz00_25036);
						}
					else
						{	/* Eval/evaluate_comp.scm 903 */
							BgL_testz00_25032 = ((bool_t) 0);
						}
					if (BgL_testz00_25032)
						{	/* Eval/evaluate_comp.scm 906 */
							bool_t BgL_testz00_25040;

							{	/* Eval/evaluate_comp.scm 906 */
								obj_t BgL_arg2540z00_2922;

								BgL_arg2540z00_2922 =
									(((BgL_ev_littz00_bglt) CREF(
											((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								BgL_testz00_25040 =
									PROCEDURE_CORRECT_ARITYP(BgL_arg2540z00_2922,
									(int) (BgL_nbargsz00_184));
							}
							if (BgL_testz00_25040)
								{	/* Eval/evaluate_comp.scm 906 */
									return
										(((BgL_ev_littz00_bglt) CREF(
												((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								}
							else
								{	/* Eval/evaluate_comp.scm 908 */
									int BgL_arg2538z00_2920;

									{	/* Eval/evaluate_comp.scm 908 */
										obj_t BgL_arg2539z00_2921;

										BgL_arg2539z00_2921 =
											(((BgL_ev_littz00_bglt) CREF(
													((BgL_ev_littz00_bglt) BgL_funz00_183)))->
											BgL_valuez00);
										BgL_arg2538z00_2920 = PROCEDURE_ARITY(BgL_arg2539z00_2921);
									}
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185,
										BgL_symbzd2funzd2_186, (int) (BgL_nbargsz00_184),
										BgL_arg2538z00_2920);
						}}
					else
						{	/* Eval/evaluate_comp.scm 903 */
							return BFALSE;
						}
				}
		}
	}



/* compile-float-arith */
	obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t
		BgL_exprz00_187, obj_t BgL_stkz00_188)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 911 */
			if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
					BGl_ev_littz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 915 */
					if (INTEGERP(
							(((BgL_ev_littz00_bglt) CREF(
										((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00)))
						{	/* Eval/evaluate_comp.scm 917 */
							obj_t BgL_v1342z00_2930;

							BgL_v1342z00_2930 = create_vector((int) (((long) 2)));
							{	/* Eval/evaluate_comp.scm 917 */
								double BgL_arg2548z00_2931;

								BgL_arg2548z00_2931 =
									(double) (
									(long) CINT(
										(((BgL_ev_littz00_bglt) CREF(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00)));
								{	/* Eval/evaluate_comp.scm 917 */
									int BgL_kz00_10686;
									obj_t BgL_objz00_10687;

									BgL_kz00_10686 = (int) (((long) 1));
									BgL_objz00_10687 = DOUBLE_TO_REAL(BgL_arg2548z00_2931);
									VECTOR_SET(BgL_v1342z00_2930, BgL_kz00_10686,
										BgL_objz00_10687);
							}}
							VECTOR_SET(BgL_v1342z00_2930,
								(int) (((long) 0)), BINT(((long) 1)));
							return BgL_v1342z00_2930;
						}
					else
						{	/* Eval/evaluate_comp.scm 918 */
							bool_t BgL_testz00_25070;

							{	/* Eval/evaluate_comp.scm 918 */
								obj_t BgL_auxz00_25071;

								BgL_auxz00_25071 =
									(((BgL_ev_littz00_bglt) CREF(
											((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00);
								BgL_testz00_25070 = REALP(BgL_auxz00_25071);
							}
							if (BgL_testz00_25070)
								{	/* Eval/evaluate_comp.scm 918 */
									obj_t BgL_v1343z00_2934;

									BgL_v1343z00_2934 = create_vector((int) (((long) 2)));
									{	/* Eval/evaluate_comp.scm 918 */
										obj_t BgL_arg2552z00_2935;

										BgL_arg2552z00_2935 =
											(((BgL_ev_littz00_bglt) CREF(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00);
										VECTOR_SET(BgL_v1343z00_2934, (int) (((long) 1)),
											BgL_arg2552z00_2935);
									}
									VECTOR_SET(BgL_v1343z00_2934,
										(int) (((long) 0)), BINT(((long) 1)));
									return BgL_v1343z00_2934;
								}
							else
								{	/* Eval/evaluate_comp.scm 919 */
									obj_t BgL_v1344z00_2936;

									BgL_v1344z00_2936 = create_vector((int) (((long) 2)));
									{	/* Eval/evaluate_comp.scm 919 */
										obj_t BgL_arg2553z00_2937;

										BgL_arg2553z00_2937 =
											BGl_compz00zz__evaluate_compz00(
											((BgL_ev_exprz00_bglt)
												((BgL_ev_littz00_bglt) BgL_exprz00_187)),
											BgL_stkz00_188);
										VECTOR_SET(BgL_v1344z00_2936, (int) (((long) 1)),
											BgL_arg2553z00_2937);
									}
									VECTOR_SET(BgL_v1344z00_2936,
										(int) (((long) 0)), BINT(((long) 0)));
									return BgL_v1344z00_2936;
								}
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 915 */
					if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
							BGl_ev_varz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 920 */
							if (CBOOL(
									(((BgL_ev_varz00_bglt) CREF(
												((BgL_ev_varz00_bglt) BgL_exprz00_187)))->BgL_effz00)))
								{	/* Eval/evaluate_comp.scm 923 */
									obj_t BgL_v1345z00_2943;

									BgL_v1345z00_2943 = create_vector((int) (((long) 2)));
									VECTOR_SET(BgL_v1345z00_2943,
										(int) (((long) 1)),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									VECTOR_SET(BgL_v1345z00_2943, (int) (((long) 0)),
										BINT(((long) 3)));
									return BgL_v1345z00_2943;
								}
							else
								{	/* Eval/evaluate_comp.scm 924 */
									obj_t BgL_v1346z00_2945;

									BgL_v1346z00_2945 = create_vector((int) (((long) 2)));
									VECTOR_SET(BgL_v1346z00_2945,
										(int) (((long) 1)),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									VECTOR_SET(BgL_v1346z00_2945, (int) (((long) 0)),
										BINT(((long) 2)));
									return BgL_v1346z00_2945;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 920 */
							if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
									BGl_ev_globalz00zz__evaluate_typesz00))
								{	/* Eval/evaluate_comp.scm 927 */
									obj_t BgL_gz00_2949;

									{	/* Eval/evaluate_comp.scm 927 */
										obj_t BgL_arg2567z00_2956;
										obj_t BgL_arg2568z00_2957;

										BgL_arg2567z00_2956 =
											(((BgL_ev_globalz00_bglt) CREF(
													((BgL_ev_globalz00_bglt) BgL_exprz00_187)))->
											BgL_modz00);
										BgL_arg2568z00_2957 =
											(((BgL_ev_globalz00_bglt) CREF(((BgL_ev_globalz00_bglt)
														BgL_exprz00_187)))->BgL_namez00);
										BgL_gz00_2949 =
											BGl_evmodulezd2findzd2globalz00zz__evmodulez00
											(BgL_arg2567z00_2956, BgL_arg2568z00_2957);
									}
									if (CBOOL(BgL_gz00_2949))
										{	/* Eval/evaluate_comp.scm 929 */
											bool_t BgL_testz00_25125;

											{	/* Eval/evaluate_comp.scm 929 */
												int BgL_arg2563z00_2953;

												{	/* Eval/evaluate_comp.scm 929 */
													int BgL_res4796z00_10720;

													{	/* Eval/evaluate_comp.scm 929 */
														int BgL_kz00_10719;

														BgL_kz00_10719 = (int) (((long) 0));
														BgL_res4796z00_10720 =
															CINT(VECTOR_REF(BgL_gz00_2949, BgL_kz00_10719));
													}
													BgL_arg2563z00_2953 = BgL_res4796z00_10720;
												}
												BgL_testz00_25125 =
													(BINT(BgL_arg2563z00_2953) == BINT(((long) 1)));
											}
											if (BgL_testz00_25125)
												{	/* Eval/evaluate_comp.scm 930 */
													obj_t BgL_v1347z00_2951;

													BgL_v1347z00_2951 = create_vector((int) (((long) 2)));
													VECTOR_SET(BgL_v1347z00_2951,
														(int) (((long) 1)), BgL_gz00_2949);
													VECTOR_SET(BgL_v1347z00_2951,
														(int) (((long) 0)), BINT(((long) 4)));
													return BgL_v1347z00_2951;
												}
											else
												{	/* Eval/evaluate_comp.scm 931 */
													obj_t BgL_v1348z00_2952;

													BgL_v1348z00_2952 = create_vector((int) (((long) 2)));
													VECTOR_SET(BgL_v1348z00_2952,
														(int) (((long) 1)), BgL_gz00_2949);
													VECTOR_SET(BgL_v1348z00_2952,
														(int) (((long) 0)), BINT(((long) 5)));
													return BgL_v1348z00_2952;
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 932 */
											obj_t BgL_v1349z00_2954;

											BgL_v1349z00_2954 = create_vector((int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 932 */
												obj_t BgL_arg2564z00_2955;

												BgL_arg2564z00_2955 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt)
														((BgL_ev_globalz00_bglt) BgL_exprz00_187)),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1349z00_2954, (int) (((long) 1)),
													BgL_arg2564z00_2955);
											}
											VECTOR_SET(BgL_v1349z00_2954,
												(int) (((long) 0)), BINT(((long) 0)));
											return BgL_v1349z00_2954;
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 925 */
									if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
											BGl_ev_appz00zz__evaluate_typesz00))
										{	/* Eval/evaluate_comp.scm 935 */
											obj_t BgL_fvalz00_2960;

											{	/* Eval/evaluate_comp.scm 935 */
												BgL_ev_exprz00_bglt BgL_arg2618z00_3008;

												BgL_arg2618z00_3008 =
													(((BgL_ev_appz00_bglt) CREF(
															((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
													BgL_funz00);
												BgL_fvalz00_2960 =
													BGl_globalzd2funzd2valuez00zz__evaluate_compz00
													(BgL_arg2618z00_3008);
											}
											if (
												(BgL_fvalz00_2960 ==
													BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
												{	/* Eval/evaluate_comp.scm 938 */
													obj_t BgL_v1350z00_2962;

													BgL_v1350z00_2962 = create_vector((int) (((long) 3)));
													{	/* Eval/evaluate_comp.scm 938 */
														obj_t BgL_arg2571z00_2963;

														{	/* Eval/evaluate_comp.scm 938 */
															obj_t BgL_arg2572z00_2964;

															{	/* Eval/evaluate_comp.scm 938 */
																obj_t BgL_pairz00_10739;

																BgL_pairz00_10739 =
																	(((BgL_ev_appz00_bglt) CREF(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2572z00_2964 =
																	CAR(CDR(BgL_pairz00_10739));
															}
															BgL_arg2571z00_2963 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2572z00_2964, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1350z00_2962,
															(int) (((long) 2)), BgL_arg2571z00_2963);
													}
													{	/* Eval/evaluate_comp.scm 938 */
														obj_t BgL_arg2576z00_2966;

														{	/* Eval/evaluate_comp.scm 938 */
															obj_t BgL_arg2577z00_2967;

															{	/* Eval/evaluate_comp.scm 938 */
																obj_t BgL_pairz00_10747;

																BgL_pairz00_10747 =
																	(((BgL_ev_appz00_bglt) CREF(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2577z00_2967 = CAR(BgL_pairz00_10747);
															}
															BgL_arg2576z00_2966 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2577z00_2967, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1350z00_2962,
															(int) (((long) 1)), BgL_arg2576z00_2966);
													}
													VECTOR_SET(BgL_v1350z00_2962,
														(int) (((long) 0)), BINT(((long) 6)));
													return BgL_v1350z00_2962;
												}
											else
												{	/* Eval/evaluate_comp.scm 937 */
													if (
														(BgL_fvalz00_2960 ==
															BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
														{	/* Eval/evaluate_comp.scm 940 */
															obj_t BgL_v1351z00_2970;

															BgL_v1351z00_2970 =
																create_vector((int) (((long) 3)));
															{	/* Eval/evaluate_comp.scm 940 */
																obj_t BgL_arg2580z00_2971;

																{	/* Eval/evaluate_comp.scm 940 */
																	obj_t BgL_arg2582z00_2972;

																	{	/* Eval/evaluate_comp.scm 940 */
																		obj_t BgL_pairz00_10755;

																		BgL_pairz00_10755 =
																			(((BgL_ev_appz00_bglt) CREF(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2582z00_2972 =
																			CAR(CDR(BgL_pairz00_10755));
																	}
																	BgL_arg2580z00_2971 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2582z00_2972, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1351z00_2970,
																	(int) (((long) 2)), BgL_arg2580z00_2971);
															}
															{	/* Eval/evaluate_comp.scm 940 */
																obj_t BgL_arg2584z00_2974;

																{	/* Eval/evaluate_comp.scm 940 */
																	obj_t BgL_arg2585z00_2975;

																	{	/* Eval/evaluate_comp.scm 940 */
																		obj_t BgL_pairz00_10763;

																		BgL_pairz00_10763 =
																			(((BgL_ev_appz00_bglt) CREF(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2585z00_2975 =
																			CAR(BgL_pairz00_10763);
																	}
																	BgL_arg2584z00_2974 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2585z00_2975, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1351z00_2970,
																	(int) (((long) 1)), BgL_arg2584z00_2974);
															}
															VECTOR_SET(BgL_v1351z00_2970,
																(int) (((long) 0)), BINT(((long) 7)));
															return BgL_v1351z00_2970;
														}
													else
														{	/* Eval/evaluate_comp.scm 939 */
															if (
																(BgL_fvalz00_2960 ==
																	BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																{	/* Eval/evaluate_comp.scm 942 */
																	obj_t BgL_v1352z00_2978;

																	BgL_v1352z00_2978 =
																		create_vector((int) (((long) 3)));
																	{	/* Eval/evaluate_comp.scm 942 */
																		obj_t BgL_arg2588z00_2979;

																		{	/* Eval/evaluate_comp.scm 942 */
																			obj_t BgL_arg2590z00_2980;

																			{	/* Eval/evaluate_comp.scm 942 */
																				obj_t BgL_pairz00_10771;

																				BgL_pairz00_10771 =
																					(((BgL_ev_appz00_bglt) CREF(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2590z00_2980 =
																					CAR(CDR(BgL_pairz00_10771));
																			}
																			BgL_arg2588z00_2979 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2590z00_2980, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1352z00_2978,
																			(int) (((long) 2)), BgL_arg2588z00_2979);
																	}
																	{	/* Eval/evaluate_comp.scm 942 */
																		obj_t BgL_arg2592z00_2982;

																		{	/* Eval/evaluate_comp.scm 942 */
																			obj_t BgL_arg2593z00_2983;

																			{	/* Eval/evaluate_comp.scm 942 */
																				obj_t BgL_pairz00_10779;

																				BgL_pairz00_10779 =
																					(((BgL_ev_appz00_bglt) CREF(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2593z00_2983 =
																					CAR(BgL_pairz00_10779);
																			}
																			BgL_arg2592z00_2982 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2593z00_2983, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1352z00_2978,
																			(int) (((long) 1)), BgL_arg2592z00_2982);
																	}
																	VECTOR_SET(BgL_v1352z00_2978,
																		(int) (((long) 0)), BINT(((long) 8)));
																	return BgL_v1352z00_2978;
																}
															else
																{	/* Eval/evaluate_comp.scm 941 */
																	if (
																		(BgL_fvalz00_2960 ==
																			BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																		{	/* Eval/evaluate_comp.scm 944 */
																			obj_t BgL_v1353z00_2986;

																			BgL_v1353z00_2986 =
																				create_vector((int) (((long) 3)));
																			{	/* Eval/evaluate_comp.scm 944 */
																				obj_t BgL_arg2597z00_2987;

																				{	/* Eval/evaluate_comp.scm 944 */
																					obj_t BgL_arg2598z00_2988;

																					{	/* Eval/evaluate_comp.scm 944 */
																						obj_t BgL_pairz00_10787;

																						BgL_pairz00_10787 =
																							(((BgL_ev_appz00_bglt) CREF(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2598z00_2988 =
																							CAR(CDR(BgL_pairz00_10787));
																					}
																					BgL_arg2597z00_2987 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2598z00_2988,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1353z00_2986,
																					(int) (((long) 2)),
																					BgL_arg2597z00_2987);
																			}
																			{	/* Eval/evaluate_comp.scm 944 */
																				obj_t BgL_arg2601z00_2990;

																				{	/* Eval/evaluate_comp.scm 944 */
																					obj_t BgL_arg2602z00_2991;

																					{	/* Eval/evaluate_comp.scm 944 */
																						obj_t BgL_pairz00_10795;

																						BgL_pairz00_10795 =
																							(((BgL_ev_appz00_bglt) CREF(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2602z00_2991 =
																							CAR(BgL_pairz00_10795);
																					}
																					BgL_arg2601z00_2990 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2602z00_2991,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1353z00_2986,
																					(int) (((long) 1)),
																					BgL_arg2601z00_2990);
																			}
																			VECTOR_SET(BgL_v1353z00_2986,
																				(int) (((long) 0)), BINT(((long) 9)));
																			return BgL_v1353z00_2986;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 943 */
																			if (
																				(BgL_fvalz00_2960 ==
																					BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 946 */
																					obj_t BgL_v1354z00_2994;

																					BgL_v1354z00_2994 =
																						create_vector((int) (((long) 2)));
																					{	/* Eval/evaluate_comp.scm 946 */
																						obj_t BgL_arg2605z00_2995;

																						{	/* Eval/evaluate_comp.scm 946 */
																							obj_t BgL_arg2607z00_2996;

																							{	/* Eval/evaluate_comp.scm 946 */
																								obj_t BgL_pairz00_10803;

																								BgL_pairz00_10803 =
																									(((BgL_ev_appz00_bglt) CREF(
																											((BgL_ev_appz00_bglt)
																												BgL_exprz00_187)))->
																									BgL_argsz00);
																								BgL_arg2607z00_2996 =
																									CAR(BgL_pairz00_10803);
																							}
																							BgL_arg2605z00_2995 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_arg2607z00_2996),
																								BgL_stkz00_188);
																						}
																						VECTOR_SET(BgL_v1354z00_2994,
																							(int) (((long) 1)),
																							BgL_arg2605z00_2995);
																					}
																					VECTOR_SET(BgL_v1354z00_2994,
																						(int) (((long) 0)),
																						BINT(((long) 10)));
																					return BgL_v1354z00_2994;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 945 */
																					if (
																						(BgL_fvalz00_2960 ==
																							BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
																						{	/* Eval/evaluate_comp.scm 948 */
																							obj_t BgL_v1355z00_2999;

																							BgL_v1355z00_2999 =
																								create_vector(
																								(int) (((long) 3)));
																							{	/* Eval/evaluate_comp.scm 948 */
																								obj_t BgL_arg2610z00_3000;

																								{	/* Eval/evaluate_comp.scm 948 */
																									obj_t BgL_arg2611z00_3001;

																									{	/* Eval/evaluate_comp.scm 948 */
																										obj_t BgL_pairz00_10810;

																										BgL_pairz00_10810 =
																											(((BgL_ev_appz00_bglt)
																												CREF((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2611z00_3001 =
																											CAR(CDR
																											(BgL_pairz00_10810));
																									}
																									BgL_arg2610z00_3000 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2611z00_3001),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1355z00_2999,
																									(int) (((long) 2)),
																									BgL_arg2610z00_3000);
																							}
																							{	/* Eval/evaluate_comp.scm 948 */
																								obj_t BgL_arg2613z00_3003;

																								{	/* Eval/evaluate_comp.scm 948 */
																									obj_t BgL_arg2615z00_3004;

																									{	/* Eval/evaluate_comp.scm 948 */
																										obj_t BgL_pairz00_10817;

																										BgL_pairz00_10817 =
																											(((BgL_ev_appz00_bglt)
																												CREF((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2615z00_3004 =
																											CAR(BgL_pairz00_10817);
																									}
																									BgL_arg2613z00_3003 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2615z00_3004),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1355z00_2999,
																									(int) (((long) 1)),
																									BgL_arg2613z00_3003);
																							}
																							VECTOR_SET(BgL_v1355z00_2999,
																								(int) (((long) 0)),
																								BINT(((long) 11)));
																							return BgL_v1355z00_2999;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 950 */
																							obj_t BgL_v1356z00_3006;

																							BgL_v1356z00_3006 =
																								create_vector(
																								(int) (((long) 2)));
																							{	/* Eval/evaluate_comp.scm 950 */
																								obj_t BgL_arg2617z00_3007;

																								BgL_arg2617z00_3007 =
																									BGl_compz00zz__evaluate_compz00
																									(((BgL_ev_exprz00_bglt) (
																											(BgL_ev_appz00_bglt)
																											BgL_exprz00_187)),
																									BgL_stkz00_188);
																								VECTOR_SET(BgL_v1356z00_3006,
																									(int) (((long) 1)),
																									BgL_arg2617z00_3007);
																							}
																							VECTOR_SET(BgL_v1356z00_3006,
																								(int) (((long) 0)),
																								BINT(((long) 0)));
																							return BgL_v1356z00_3006;
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 951 */
											obj_t BgL_v1357z00_3009;

											BgL_v1357z00_3009 = create_vector((int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 951 */
												obj_t BgL_arg2619z00_3010;

												BgL_arg2619z00_3010 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_exprz00_187),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1357z00_3009, (int) (((long) 1)),
													BgL_arg2619z00_3010);
											}
											VECTOR_SET(BgL_v1357z00_3009,
												(int) (((long) 0)), BINT(((long) 0)));
											return BgL_v1357z00_3009;
										}
								}
						}
				}
		}
	}



/* E */
	obj_t BGl_Ez00zz__evaluate_compz00(obj_t BgL_sz00_19668, obj_t BgL_bcz00_3015)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 968 */
			{	/* Eval/evaluate_comp.scm 955 */
				obj_t BgL_aux1219z00_3018;

				BgL_aux1219z00_3018 = VECTOR_REF(BgL_bcz00_3015, (int) (((long) 0)));
				if (INTEGERP(BgL_aux1219z00_3018))
					{	/* Eval/evaluate_comp.scm 955 */
						switch ((long) CINT(BgL_aux1219z00_3018))
							{
							case ((long) 0):

								{	/* Eval/evaluate_comp.scm 956 */
									obj_t BgL_fun2623z00_3020;

									BgL_fun2623z00_3020 =
										VECTOR_REF(BgL_bcz00_3015, (int) (((long) 1)));
									return
										PROCEDURE_ENTRY(BgL_fun2623z00_3020) (BgL_fun2623z00_3020,
										BgL_sz00_19668, BEOA);
								}
								break;
							case ((long) 1):

								return VECTOR_REF(BgL_bcz00_3015, (int) (((long) 1)));
								break;
							case ((long) 2):

								{	/* Eval/evaluate_comp.scm 958 */
									long BgL_arg2624z00_3021;

									{	/* Eval/evaluate_comp.scm 958 */
										obj_t BgL_arg2625z00_3022;
										obj_t BgL_arg2626z00_3023;

										BgL_arg2625z00_3022 =
											VECTOR_REF(BgL_sz00_19668, (int) (((long) 0)));
										BgL_arg2626z00_3023 =
											VECTOR_REF(BgL_bcz00_3015, (int) (((long) 1)));
										BgL_arg2624z00_3021 =
											(
											(long) CINT(BgL_arg2625z00_3022) +
											(long) CINT(BgL_arg2626z00_3023));
									}
									return
										VECTOR_REF(BgL_sz00_19668, (int) (BgL_arg2624z00_3021));
								} break;
							case ((long) 3):

								{	/* Eval/evaluate_comp.scm 959 */
									obj_t BgL_arg2627z00_3024;

									{	/* Eval/evaluate_comp.scm 959 */
										long BgL_arg2628z00_3025;

										{	/* Eval/evaluate_comp.scm 959 */
											obj_t BgL_arg2629z00_3026;
											obj_t BgL_arg2631z00_3027;

											BgL_arg2629z00_3026 =
												VECTOR_REF(BgL_sz00_19668, (int) (((long) 0)));
											BgL_arg2631z00_3027 =
												VECTOR_REF(BgL_sz00_19668, (int) (((long) 1)));
											BgL_arg2628z00_3025 =
												(
												(long) CINT(BgL_arg2629z00_3026) +
												(long) CINT(BgL_arg2631z00_3027));
										}
										BgL_arg2627z00_3024 =
											VECTOR_REF(BgL_sz00_19668, (int) (BgL_arg2628z00_3025));
									}
									return STRUCT_REF(BgL_arg2627z00_3024, (int) (((long) 0)));
								} break;
							case ((long) 4):

								{	/* Eval/evaluate_comp.scm 960 */
									obj_t BgL_auxz00_25328;

									BgL_auxz00_25328 =
										VECTOR_REF(VECTOR_REF(BgL_bcz00_3015,
											(int) (((long) 1))), (int) (((long) 2)));
									return __EVMEANING_ADDRESS_REF(BgL_auxz00_25328);
								}
								break;
							case ((long) 5):

								return
									VECTOR_REF(VECTOR_REF(BgL_bcz00_3015,
										(int) (((long) 1))), (int) (((long) 2)));
								break;
							case ((long) 6):

								{	/* Eval/evaluate_comp.scm 962 */
									obj_t BgL_arg2636z00_3031;
									obj_t BgL_arg2637z00_3032;

									BgL_arg2636z00_3031 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_19668,
										VECTOR_REF(BgL_bcz00_3015, (int) (((long) 1))));
									BgL_arg2637z00_3032 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_19668,
										VECTOR_REF(BgL_bcz00_3015, (int) (((long) 2))));
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2636z00_3031) +
											REAL_TO_DOUBLE(BgL_arg2637z00_3032)));
								}
								break;
							case ((long) 7):

								{	/* Eval/evaluate_comp.scm 963 */
									obj_t BgL_arg2642z00_3035;
									obj_t BgL_arg2643z00_3036;

									BgL_arg2642z00_3035 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_19668,
										VECTOR_REF(BgL_bcz00_3015, (int) (((long) 1))));
									BgL_arg2643z00_3036 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_19668,
										VECTOR_REF(BgL_bcz00_3015, (int) (((long) 2))));
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2642z00_3035) -
											REAL_TO_DOUBLE(BgL_arg2643z00_3036)));
								}
								break;
							case ((long) 8):

								{	/* Eval/evaluate_comp.scm 964 */
									obj_t BgL_arg2647z00_3039;
									obj_t BgL_arg2648z00_3040;

									BgL_arg2647z00_3039 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_19668,
										VECTOR_REF(BgL_bcz00_3015, (int) (((long) 1))));
									BgL_arg2648z00_3040 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_19668,
										VECTOR_REF(BgL_bcz00_3015, (int) (((long) 2))));
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2647z00_3039) *
											REAL_TO_DOUBLE(BgL_arg2648z00_3040)));
								}
								break;
							case ((long) 9):

								{	/* Eval/evaluate_comp.scm 965 */
									obj_t BgL_arg2652z00_3043;
									obj_t BgL_arg2653z00_3044;

									BgL_arg2652z00_3043 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_19668,
										VECTOR_REF(BgL_bcz00_3015, (int) (((long) 1))));
									BgL_arg2653z00_3044 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_19668,
										VECTOR_REF(BgL_bcz00_3015, (int) (((long) 2))));
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2652z00_3043) /
											REAL_TO_DOUBLE(BgL_arg2653z00_3044)));
								}
								break;
							case ((long) 10):

								{	/* Eval/evaluate_comp.scm 966 */
									obj_t BgL_arg2658z00_3047;

									{	/* Eval/evaluate_comp.scm 966 */
										obj_t BgL_fun2659z00_3048;

										BgL_fun2659z00_3048 =
											VECTOR_REF(BgL_bcz00_3015, (int) (((long) 1)));
										BgL_arg2658z00_3047 =
											PROCEDURE_ENTRY(BgL_fun2659z00_3048) (BgL_fun2659z00_3048,
											BgL_sz00_19668, BEOA);
									}
									return
										DOUBLE_TO_REAL((double) ((long) CINT(BgL_arg2658z00_3047)));
								} break;
							case ((long) 11):

								{	/* Eval/evaluate_comp.scm 967 */
									obj_t BgL_arg2660z00_3049;
									obj_t BgL_arg2661z00_3050;

									{	/* Eval/evaluate_comp.scm 967 */
										obj_t BgL_fun2662z00_3051;

										BgL_fun2662z00_3051 =
											VECTOR_REF(BgL_bcz00_3015, (int) (((long) 1)));
										BgL_arg2660z00_3049 =
											PROCEDURE_ENTRY(BgL_fun2662z00_3051) (BgL_fun2662z00_3051,
											BgL_sz00_19668, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 967 */
										obj_t BgL_fun2663z00_3052;

										BgL_fun2663z00_3052 =
											VECTOR_REF(BgL_bcz00_3015, (int) (((long) 2)));
										BgL_arg2661z00_3050 =
											PROCEDURE_ENTRY(BgL_fun2663z00_3052) (BgL_fun2663z00_3052,
											BgL_sz00_19668, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 967 */
										double BgL_auxz00_25399;

										{	/* Eval/evaluate_comp.scm 967 */
											long BgL_auxz00_25400;

											BgL_auxz00_25400 = (long) CINT(BgL_arg2661z00_3050);
											BgL_auxz00_25399 =
												BGL_F64VREF(BgL_arg2660z00_3049, BgL_auxz00_25400);
										}
										return DOUBLE_TO_REAL(BgL_auxz00_25399);
									}
								}
								break;
							default:
								return
									BGl_errorz00zz__errorz00
									(BGl_string5595z00zz__evaluate_compz00,
									BGl_string5614z00zz__evaluate_compz00,
									VECTOR_REF(BgL_bcz00_3015, (int) (((long) 0))));
					}}
				else
					{	/* Eval/evaluate_comp.scm 955 */
						return
							BGl_errorz00zz__errorz00(BGl_string5595z00zz__evaluate_compz00,
							BGl_string5614z00zz__evaluate_compz00, VECTOR_REF(BgL_bcz00_3015,
								(int) (((long) 0))));
		}}}
	}



/* arith-expression */
	obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_exprz00_191, obj_t BgL_stkz00_192)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 971 */
			{	/* Eval/evaluate_comp.scm 973 */
				obj_t BgL_fvalz00_3056;

				BgL_fvalz00_3056 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) CREF(BgL_exprz00_191))->BgL_funz00));
				{	/* Eval/evaluate_comp.scm 974 */
					bool_t BgL_testz00_25414;

					if (
						(BgL_fvalz00_3056 ==
							BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
						{	/* Eval/evaluate_comp.scm 974 */
							BgL_testz00_25414 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 974 */
							if (
								(BgL_fvalz00_3056 ==
									BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
								{	/* Eval/evaluate_comp.scm 974 */
									BgL_testz00_25414 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 974 */
									if (
										(BgL_fvalz00_3056 ==
											BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
										{	/* Eval/evaluate_comp.scm 974 */
											BgL_testz00_25414 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 974 */
											BgL_testz00_25414 =
												(BgL_fvalz00_3056 ==
												BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00);
										}
								}
						}
					if (BgL_testz00_25414)
						{	/* Eval/evaluate_comp.scm 975 */
							obj_t BgL_bcz00_3058;

							BgL_bcz00_3058 =
								BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
								((obj_t) BgL_exprz00_191), BgL_stkz00_192);
							{	/* Eval/evaluate_comp.scm 976 */
								obj_t BgL_zc3anonymousza32667ze3z83_18029;

								BgL_zc3anonymousza32667ze3z83_18029 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32667ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3anonymousza32667ze3z83_18029,
									(int) (((long) 0)), BgL_bcz00_3058);
								return BgL_zc3anonymousza32667ze3z83_18029;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 974 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &<anonymous:2667> */
	obj_t BGl_z62zc3anonymousza32667ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18030, obj_t BgL_sz00_18032)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 976 */
			{	/* Eval/evaluate_comp.scm 976 */
				obj_t BgL_bcz00_18031;

				BgL_bcz00_18031 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18030, (int) (((long) 0))));
				{
					obj_t BgL_sz00_3059;

					{	/* Eval/evaluate_comp.scm 976 */
						double BgL_auxz00_25432;

						BgL_sz00_3059 = BgL_sz00_18032;
						{	/* Eval/evaluate_comp.scm 976 */
							obj_t BgL_bpz00_10918;

							BgL_bpz00_10918 = VECTOR_REF(BgL_sz00_3059, (int) (((long) 0)));
							BgL_auxz00_25432 =
								REAL_TO_DOUBLE(BGl_Ez00zz__evaluate_compz00(BgL_sz00_3059,
									BgL_bcz00_18031));
						}
						return DOUBLE_TO_REAL(BgL_auxz00_25432);
					}
				}
			}
		}
	}



/* inline-call */
	obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193,
		BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195,
		obj_t BgL_stkz00_196)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1002 */
			{	/* Eval/evaluate_comp.scm 1003 */
				obj_t BgL_valz00_3066;

				BgL_valz00_3066 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194);
				if (CBOOL(BgL_valz00_3066))
					{	/* Eval/evaluate_comp.scm 1005 */
						long BgL_nz00_3067;

						BgL_nz00_3067 = bgl_list_length(BgL_argsz00_195);
						{	/* Eval/evaluate_comp.scm 1006 */
							obj_t BgL__ortest_1225z00_3068;

							if ((BgL_nz00_3067 == ((long) 1)))
								{	/* Eval/evaluate_comp.scm 1007 */
									obj_t BgL_a1z00_3359;

									BgL_a1z00_3359 = CAR(BgL_argsz00_195);
									if (
										(BgL_valz00_3066 ==
											BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
										{	/* Eval/evaluate_comp.scm 1008 */
											obj_t BgL_a1z00_3361;

											BgL_a1z00_3361 =
												BGl_compz00zz__evaluate_compz00(
												((BgL_ev_exprz00_bglt) BgL_a1z00_3359), BgL_stkz00_196);
											{	/* Eval/evaluate_comp.scm 1008 */
												obj_t BgL_zc3anonymousza32787ze3z83_18062;

												BgL_zc3anonymousza32787ze3z83_18062 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3anonymousza32787ze3ze1zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 2)));
												PROCEDURE_SET(BgL_zc3anonymousza32787ze3z83_18062,
													(int) (((long) 0)), BgL_a1z00_3361);
												PROCEDURE_SET(BgL_zc3anonymousza32787ze3z83_18062,
													(int) (((long) 1)), BgL_locz00_193);
												BgL__ortest_1225z00_3068 =
													BgL_zc3anonymousza32787ze3z83_18062;
										}}
									else
										{	/* Eval/evaluate_comp.scm 1008 */
											if (
												(BgL_valz00_3066 ==
													BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
												{	/* Eval/evaluate_comp.scm 1008 */
													obj_t BgL_a1z00_3368;

													BgL_a1z00_3368 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3359),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1008 */
														obj_t BgL_zc3anonymousza32790ze3z83_18063;

														BgL_zc3anonymousza32790ze3z83_18063 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3anonymousza32790ze3ze1zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET(BgL_zc3anonymousza32790ze3z83_18063,
															(int) (((long) 0)), BgL_a1z00_3368);
														PROCEDURE_SET(BgL_zc3anonymousza32790ze3z83_18063,
															(int) (((long) 1)), BgL_locz00_193);
														BgL__ortest_1225z00_3068 =
															BgL_zc3anonymousza32790ze3z83_18063;
												}}
											else
												{	/* Eval/evaluate_comp.scm 1008 */
													if (
														(BgL_valz00_3066 ==
															BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
														{	/* Eval/evaluate_comp.scm 1008 */
															obj_t BgL_a1z00_3375;

															BgL_a1z00_3375 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3359),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1008 */
																obj_t BgL_zc3anonymousza32793ze3z83_18064;

																BgL_zc3anonymousza32793ze3z83_18064 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza32793ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 2)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza32793ze3z83_18064,
																	(int) (((long) 0)), BgL_a1z00_3375);
																PROCEDURE_SET
																	(BgL_zc3anonymousza32793ze3z83_18064,
																	(int) (((long) 1)), BgL_locz00_193);
																BgL__ortest_1225z00_3068 =
																	BgL_zc3anonymousza32793ze3z83_18064;
														}}
													else
														{	/* Eval/evaluate_comp.scm 1008 */
															BgL__ortest_1225z00_3068 = BFALSE;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1006 */
									BgL__ortest_1225z00_3068 = BFALSE;
								}
							if (CBOOL(BgL__ortest_1225z00_3068))
								{	/* Eval/evaluate_comp.scm 1006 */
									return BgL__ortest_1225z00_3068;
								}
							else
								{	/* Eval/evaluate_comp.scm 1006 */
									if ((BgL_nz00_3067 == ((long) 2)))
										{	/* Eval/evaluate_comp.scm 1010 */
											obj_t BgL_a1z00_3070;
											obj_t BgL_a2z00_3071;

											BgL_a1z00_3070 = CAR(BgL_argsz00_195);
											BgL_a2z00_3071 = CAR(CDR(BgL_argsz00_195));
											if (
												(BgL_valz00_3066 ==
													BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
												{	/* Eval/evaluate_comp.scm 1011 */
													obj_t BgL_a1z00_3073;
													obj_t BgL_a2z00_3074;

													BgL_a1z00_3073 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3070),
														BgL_stkz00_196);
													BgL_a2z00_3074 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_a2z00_3071),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1011 */
														obj_t BgL_zc3anonymousza32674ze3z83_18033;

														BgL_zc3anonymousza32674ze3z83_18033 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3anonymousza32674ze3ze1zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 3)));
														PROCEDURE_SET(BgL_zc3anonymousza32674ze3z83_18033,
															(int) (((long) 0)), BgL_a1z00_3073);
														PROCEDURE_SET(BgL_zc3anonymousza32674ze3z83_18033,
															(int) (((long) 1)), BgL_a2z00_3074);
														PROCEDURE_SET(BgL_zc3anonymousza32674ze3z83_18033,
															(int) (((long) 2)), BgL_locz00_193);
														return BgL_zc3anonymousza32674ze3z83_18033;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 1011 */
													if (
														(BgL_valz00_3066 ==
															BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
														{	/* Eval/evaluate_comp.scm 1011 */
															obj_t BgL_a1z00_3083;
															obj_t BgL_a2z00_3084;

															BgL_a1z00_3083 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3070),
																BgL_stkz00_196);
															BgL_a2z00_3084 =
																BGl_compz00zz__evaluate_compz00((
																	(BgL_ev_exprz00_bglt) BgL_a2z00_3071),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1011 */
																obj_t BgL_zc3anonymousza32678ze3z83_18034;

																BgL_zc3anonymousza32678ze3z83_18034 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza32678ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza32678ze3z83_18034,
																	(int) (((long) 0)), BgL_a1z00_3083);
																PROCEDURE_SET
																	(BgL_zc3anonymousza32678ze3z83_18034,
																	(int) (((long) 1)), BgL_a2z00_3084);
																PROCEDURE_SET
																	(BgL_zc3anonymousza32678ze3z83_18034,
																	(int) (((long) 2)), BgL_locz00_193);
																return BgL_zc3anonymousza32678ze3z83_18034;
															}
														}
													else
														{	/* Eval/evaluate_comp.scm 1011 */
															if (
																(BgL_valz00_3066 ==
																	BGl_za2zd2envz70zz__r4_numbers_6_5z00))
																{	/* Eval/evaluate_comp.scm 1011 */
																	obj_t BgL_a1z00_3093;
																	obj_t BgL_a2z00_3094;

																	BgL_a1z00_3093 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt) BgL_a1z00_3070),
																		BgL_stkz00_196);
																	BgL_a2z00_3094 =
																		BGl_compz00zz__evaluate_compz00((
																			(BgL_ev_exprz00_bglt) BgL_a2z00_3071),
																		BgL_stkz00_196);
																	{	/* Eval/evaluate_comp.scm 1011 */
																		obj_t BgL_zc3anonymousza32682ze3z83_18035;

																		BgL_zc3anonymousza32682ze3z83_18035 =
																			MAKE_FX_PROCEDURE
																			(BGl_z62zc3anonymousza32682ze3ze1zz__evaluate_compz00,
																			(int) (((long) 1)), (int) (((long) 3)));
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32682ze3z83_18035,
																			(int) (((long) 0)), BgL_a1z00_3093);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32682ze3z83_18035,
																			(int) (((long) 1)), BgL_a2z00_3094);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32682ze3z83_18035,
																			(int) (((long) 2)), BgL_locz00_193);
																		return BgL_zc3anonymousza32682ze3z83_18035;
																	}
																}
															else
																{	/* Eval/evaluate_comp.scm 1011 */
																	if (
																		(BgL_valz00_3066 ==
																			BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
																		{	/* Eval/evaluate_comp.scm 1011 */
																			obj_t BgL_a1z00_3103;
																			obj_t BgL_a2z00_3104;

																			BgL_a1z00_3103 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt) BgL_a1z00_3070),
																				BgL_stkz00_196);
																			BgL_a2z00_3104 =
																				BGl_compz00zz__evaluate_compz00((
																					(BgL_ev_exprz00_bglt) BgL_a2z00_3071),
																				BgL_stkz00_196);
																			{	/* Eval/evaluate_comp.scm 1011 */
																				obj_t
																					BgL_zc3anonymousza32686ze3z83_18036;
																				BgL_zc3anonymousza32686ze3z83_18036 =
																					MAKE_FX_PROCEDURE
																					(BGl_z62zc3anonymousza32686ze3ze1zz__evaluate_compz00,
																					(int) (((long) 1)),
																					(int) (((long) 3)));
																				PROCEDURE_SET
																					(BgL_zc3anonymousza32686ze3z83_18036,
																					(int) (((long) 0)), BgL_a1z00_3103);
																				PROCEDURE_SET
																					(BgL_zc3anonymousza32686ze3z83_18036,
																					(int) (((long) 1)), BgL_a2z00_3104);
																				PROCEDURE_SET
																					(BgL_zc3anonymousza32686ze3z83_18036,
																					(int) (((long) 2)), BgL_locz00_193);
																				return
																					BgL_zc3anonymousza32686ze3z83_18036;
																			}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 1011 */
																			if (
																				(BgL_valz00_3066 ==
																					BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 1011 */
																					obj_t BgL_a1z00_3113;
																					obj_t BgL_a2z00_3114;

																					BgL_a1z00_3113 =
																						BGl_compz00zz__evaluate_compz00(
																						((BgL_ev_exprz00_bglt)
																							BgL_a1z00_3070), BgL_stkz00_196);
																					BgL_a2z00_3114 =
																						BGl_compz00zz__evaluate_compz00((
																							(BgL_ev_exprz00_bglt)
																							BgL_a2z00_3071), BgL_stkz00_196);
																					{	/* Eval/evaluate_comp.scm 1011 */
																						obj_t
																							BgL_zc3anonymousza32690ze3z83_18037;
																						BgL_zc3anonymousza32690ze3z83_18037
																							=
																							MAKE_FX_PROCEDURE
																							(BGl_z62zc3anonymousza32690ze3ze1zz__evaluate_compz00,
																							(int) (((long) 1)),
																							(int) (((long) 3)));
																						PROCEDURE_SET
																							(BgL_zc3anonymousza32690ze3z83_18037,
																							(int) (((long) 0)),
																							BgL_a1z00_3113);
																						PROCEDURE_SET
																							(BgL_zc3anonymousza32690ze3z83_18037,
																							(int) (((long) 1)),
																							BgL_a2z00_3114);
																						PROCEDURE_SET
																							(BgL_zc3anonymousza32690ze3z83_18037,
																							(int) (((long) 2)),
																							BgL_locz00_193);
																						return
																							BgL_zc3anonymousza32690ze3z83_18037;
																					}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 1011 */
																					if (
																						(BgL_valz00_3066 ==
																							BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
																						{	/* Eval/evaluate_comp.scm 1011 */
																							obj_t BgL_a1z00_3123;
																							obj_t BgL_a2z00_3124;

																							BgL_a1z00_3123 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a1z00_3070),
																								BgL_stkz00_196);
																							BgL_a2z00_3124 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a2z00_3071),
																								BgL_stkz00_196);
																							{	/* Eval/evaluate_comp.scm 1011 */
																								obj_t
																									BgL_zc3anonymousza32694ze3z83_18038;
																								BgL_zc3anonymousza32694ze3z83_18038
																									=
																									MAKE_FX_PROCEDURE
																									(BGl_z62zc3anonymousza32694ze3ze1zz__evaluate_compz00,
																									(int) (((long) 1)),
																									(int) (((long) 3)));
																								PROCEDURE_SET
																									(BgL_zc3anonymousza32694ze3z83_18038,
																									(int) (((long) 0)),
																									BgL_a1z00_3123);
																								PROCEDURE_SET
																									(BgL_zc3anonymousza32694ze3z83_18038,
																									(int) (((long) 1)),
																									BgL_a2z00_3124);
																								PROCEDURE_SET
																									(BgL_zc3anonymousza32694ze3z83_18038,
																									(int) (((long) 2)),
																									BgL_locz00_193);
																								return
																									BgL_zc3anonymousza32694ze3z83_18038;
																							}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 1011 */
																							if (
																								(BgL_valz00_3066 ==
																									BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
																								{	/* Eval/evaluate_comp.scm 1011 */
																									obj_t BgL_a1z00_3133;
																									obj_t BgL_a2z00_3134;

																									BgL_a1z00_3133 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a1z00_3070),
																										BgL_stkz00_196);
																									BgL_a2z00_3134 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a2z00_3071),
																										BgL_stkz00_196);
																									{	/* Eval/evaluate_comp.scm 1011 */
																										obj_t
																											BgL_zc3anonymousza32698ze3z83_18039;
																										BgL_zc3anonymousza32698ze3z83_18039
																											=
																											MAKE_FX_PROCEDURE
																											(BGl_z62zc3anonymousza32698ze3ze1zz__evaluate_compz00,
																											(int) (((long) 1)),
																											(int) (((long) 3)));
																										PROCEDURE_SET
																											(BgL_zc3anonymousza32698ze3z83_18039,
																											(int) (((long) 0)),
																											BgL_a1z00_3133);
																										PROCEDURE_SET
																											(BgL_zc3anonymousza32698ze3z83_18039,
																											(int) (((long) 1)),
																											BgL_a2z00_3134);
																										PROCEDURE_SET
																											(BgL_zc3anonymousza32698ze3z83_18039,
																											(int) (((long) 2)),
																											BgL_locz00_193);
																										return
																											BgL_zc3anonymousza32698ze3z83_18039;
																									}
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 1011 */
																									if (
																										(BgL_valz00_3066 ==
																											BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
																										{	/* Eval/evaluate_comp.scm 1011 */
																											obj_t BgL_a1z00_3143;
																											obj_t BgL_a2z00_3144;

																											BgL_a1z00_3143 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a1z00_3070),
																												BgL_stkz00_196);
																											BgL_a2z00_3144 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a2z00_3071),
																												BgL_stkz00_196);
																											{	/* Eval/evaluate_comp.scm 1011 */
																												obj_t
																													BgL_zc3anonymousza32702ze3z83_18040;
																												BgL_zc3anonymousza32702ze3z83_18040
																													=
																													MAKE_FX_PROCEDURE
																													(BGl_z62zc3anonymousza32702ze3ze1zz__evaluate_compz00,
																													(int) (((long) 1)),
																													(int) (((long) 3)));
																												PROCEDURE_SET
																													(BgL_zc3anonymousza32702ze3z83_18040,
																													(int) (((long) 0)),
																													BgL_a1z00_3143);
																												PROCEDURE_SET
																													(BgL_zc3anonymousza32702ze3z83_18040,
																													(int) (((long) 1)),
																													BgL_a2z00_3144);
																												PROCEDURE_SET
																													(BgL_zc3anonymousza32702ze3z83_18040,
																													(int) (((long) 2)),
																													BgL_locz00_193);
																												return
																													BgL_zc3anonymousza32702ze3z83_18040;
																											}
																										}
																									else
																										{	/* Eval/evaluate_comp.scm 1011 */
																											if (
																												(BgL_valz00_3066 ==
																													BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
																												{	/* Eval/evaluate_comp.scm 1011 */
																													obj_t BgL_a1z00_3153;
																													obj_t BgL_a2z00_3154;

																													BgL_a1z00_3153 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																													BgL_a2z00_3154 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																													{	/* Eval/evaluate_comp.scm 1011 */
																														obj_t
																															BgL_zc3anonymousza32706ze3z83_18041;
																														BgL_zc3anonymousza32706ze3z83_18041
																															=
																															MAKE_FX_PROCEDURE
																															(BGl_z62zc3anonymousza32706ze3ze1zz__evaluate_compz00,
																															(int) (((long)
																																	1)),
																															(int) (((long)
																																	3)));
																														PROCEDURE_SET
																															(BgL_zc3anonymousza32706ze3z83_18041,
																															(int) (((long)
																																	0)),
																															BgL_a1z00_3153);
																														PROCEDURE_SET
																															(BgL_zc3anonymousza32706ze3z83_18041,
																															(int) (((long)
																																	1)),
																															BgL_a2z00_3154);
																														PROCEDURE_SET
																															(BgL_zc3anonymousza32706ze3z83_18041,
																															(int) (((long)
																																	2)),
																															BgL_locz00_193);
																														return
																															BgL_zc3anonymousza32706ze3z83_18041;
																													}
																												}
																											else
																												{	/* Eval/evaluate_comp.scm 1011 */
																													if (
																														(BgL_valz00_3066 ==
																															BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
																														{	/* Eval/evaluate_comp.scm 1011 */
																															obj_t
																																BgL_a1z00_3163;
																															obj_t
																																BgL_a2z00_3164;
																															BgL_a1z00_3163 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																															BgL_a2z00_3164 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																															{	/* Eval/evaluate_comp.scm 1011 */
																																obj_t
																																	BgL_zc3anonymousza32710ze3z83_18042;
																																BgL_zc3anonymousza32710ze3z83_18042
																																	=
																																	MAKE_FX_PROCEDURE
																																	(BGl_z62zc3anonymousza32710ze3ze1zz__evaluate_compz00,
																																	(int) (((long)
																																			1)),
																																	(int) (((long)
																																			3)));
																																PROCEDURE_SET
																																	(BgL_zc3anonymousza32710ze3z83_18042,
																																	(int) (((long)
																																			0)),
																																	BgL_a1z00_3163);
																																PROCEDURE_SET
																																	(BgL_zc3anonymousza32710ze3z83_18042,
																																	(int) (((long)
																																			1)),
																																	BgL_a2z00_3164);
																																PROCEDURE_SET
																																	(BgL_zc3anonymousza32710ze3z83_18042,
																																	(int) (((long)
																																			2)),
																																	BgL_locz00_193);
																																return
																																	BgL_zc3anonymousza32710ze3z83_18042;
																															}
																														}
																													else
																														{	/* Eval/evaluate_comp.scm 1011 */
																															if (
																																(BgL_valz00_3066
																																	==
																																	BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
																																{	/* Eval/evaluate_comp.scm 1011 */
																																	obj_t
																																		BgL_a1z00_3173;
																																	obj_t
																																		BgL_a2z00_3174;
																																	BgL_a1z00_3173
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																	BgL_a2z00_3174
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																	{	/* Eval/evaluate_comp.scm 1011 */
																																		obj_t
																																			BgL_zc3anonymousza32714ze3z83_18043;
																																		BgL_zc3anonymousza32714ze3z83_18043
																																			=
																																			MAKE_FX_PROCEDURE
																																			(BGl_z62zc3anonymousza32714ze3ze1zz__evaluate_compz00,
																																			(int) ((
																																					(long)
																																					1)),
																																			(int) ((
																																					(long)
																																					3)));
																																		PROCEDURE_SET
																																			(BgL_zc3anonymousza32714ze3z83_18043,
																																			(int) ((
																																					(long)
																																					0)),
																																			BgL_a1z00_3173);
																																		PROCEDURE_SET
																																			(BgL_zc3anonymousza32714ze3z83_18043,
																																			(int) ((
																																					(long)
																																					1)),
																																			BgL_a2z00_3174);
																																		PROCEDURE_SET
																																			(BgL_zc3anonymousza32714ze3z83_18043,
																																			(int) ((
																																					(long)
																																					2)),
																																			BgL_locz00_193);
																																		return
																																			BgL_zc3anonymousza32714ze3z83_18043;
																																	}
																																}
																															else
																																{	/* Eval/evaluate_comp.scm 1011 */
																																	if (
																																		(BgL_valz00_3066
																																			==
																																			BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
																																		{	/* Eval/evaluate_comp.scm 1011 */
																																			obj_t
																																				BgL_a1z00_3183;
																																			obj_t
																																				BgL_a2z00_3184;
																																			BgL_a1z00_3183
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																			BgL_a2z00_3184
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																			{	/* Eval/evaluate_comp.scm 1011 */
																																				obj_t
																																					BgL_zc3anonymousza32718ze3z83_18044;
																																				BgL_zc3anonymousza32718ze3z83_18044
																																					=
																																					MAKE_FX_PROCEDURE
																																					(BGl_z62zc3anonymousza32718ze3ze1zz__evaluate_compz00,
																																					(int)
																																					(((long) 1)), (int) (((long) 3)));
																																				PROCEDURE_SET
																																					(BgL_zc3anonymousza32718ze3z83_18044,
																																					(int)
																																					(((long) 0)), BgL_a1z00_3183);
																																				PROCEDURE_SET
																																					(BgL_zc3anonymousza32718ze3z83_18044,
																																					(int)
																																					(((long) 1)), BgL_a2z00_3184);
																																				PROCEDURE_SET
																																					(BgL_zc3anonymousza32718ze3z83_18044,
																																					(int)
																																					(((long) 2)), BgL_locz00_193);
																																				return
																																					BgL_zc3anonymousza32718ze3z83_18044;
																																			}
																																		}
																																	else
																																		{	/* Eval/evaluate_comp.scm 1011 */
																																			if (
																																				(BgL_valz00_3066
																																					==
																																					BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
																																				{	/* Eval/evaluate_comp.scm 1011 */
																																					obj_t
																																						BgL_a1z00_3193;
																																					obj_t
																																						BgL_a2z00_3194;
																																					BgL_a1z00_3193
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																					BgL_a2z00_3194
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																					{	/* Eval/evaluate_comp.scm 1011 */
																																						obj_t
																																							BgL_zc3anonymousza32722ze3z83_18045;
																																						BgL_zc3anonymousza32722ze3z83_18045
																																							=
																																							MAKE_FX_PROCEDURE
																																							(BGl_z62zc3anonymousza32722ze3ze1zz__evaluate_compz00,
																																							(int)
																																							(((long) 1)), (int) (((long) 3)));
																																						PROCEDURE_SET
																																							(BgL_zc3anonymousza32722ze3z83_18045,
																																							(int)
																																							(((long) 0)), BgL_a1z00_3193);
																																						PROCEDURE_SET
																																							(BgL_zc3anonymousza32722ze3z83_18045,
																																							(int)
																																							(((long) 1)), BgL_a2z00_3194);
																																						PROCEDURE_SET
																																							(BgL_zc3anonymousza32722ze3z83_18045,
																																							(int)
																																							(((long) 2)), BgL_locz00_193);
																																						return
																																							BgL_zc3anonymousza32722ze3z83_18045;
																																					}
																																				}
																																			else
																																				{	/* Eval/evaluate_comp.scm 1011 */
																																					if (
																																						(BgL_valz00_3066
																																							==
																																							BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
																																						{	/* Eval/evaluate_comp.scm 1011 */
																																							obj_t
																																								BgL_a1z00_3203;
																																							obj_t
																																								BgL_a2z00_3204;
																																							BgL_a1z00_3203
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																							BgL_a2z00_3204
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																							{	/* Eval/evaluate_comp.scm 1011 */
																																								obj_t
																																									BgL_zc3anonymousza32726ze3z83_18046;
																																								BgL_zc3anonymousza32726ze3z83_18046
																																									=
																																									MAKE_FX_PROCEDURE
																																									(BGl_z62zc3anonymousza32726ze3ze1zz__evaluate_compz00,
																																									(int)
																																									(((long) 1)), (int) (((long) 3)));
																																								PROCEDURE_SET
																																									(BgL_zc3anonymousza32726ze3z83_18046,
																																									(int)
																																									(((long) 0)), BgL_a1z00_3203);
																																								PROCEDURE_SET
																																									(BgL_zc3anonymousza32726ze3z83_18046,
																																									(int)
																																									(((long) 1)), BgL_a2z00_3204);
																																								PROCEDURE_SET
																																									(BgL_zc3anonymousza32726ze3z83_18046,
																																									(int)
																																									(((long) 2)), BgL_locz00_193);
																																								return
																																									BgL_zc3anonymousza32726ze3z83_18046;
																																							}
																																						}
																																					else
																																						{	/* Eval/evaluate_comp.scm 1011 */
																																							if ((BgL_valz00_3066 == BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
																																								{	/* Eval/evaluate_comp.scm 1011 */
																																									obj_t
																																										BgL_a1z00_3213;
																																									obj_t
																																										BgL_a2z00_3214;
																																									BgL_a1z00_3213
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																									BgL_a2z00_3214
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																									{	/* Eval/evaluate_comp.scm 1011 */
																																										obj_t
																																											BgL_zc3anonymousza32730ze3z83_18047;
																																										BgL_zc3anonymousza32730ze3z83_18047
																																											=
																																											MAKE_FX_PROCEDURE
																																											(BGl_z62zc3anonymousza32730ze3ze1zz__evaluate_compz00,
																																											(int)
																																											(((long) 1)), (int) (((long) 3)));
																																										PROCEDURE_SET
																																											(BgL_zc3anonymousza32730ze3z83_18047,
																																											(int)
																																											(((long) 0)), BgL_a1z00_3213);
																																										PROCEDURE_SET
																																											(BgL_zc3anonymousza32730ze3z83_18047,
																																											(int)
																																											(((long) 1)), BgL_a2z00_3214);
																																										PROCEDURE_SET
																																											(BgL_zc3anonymousza32730ze3z83_18047,
																																											(int)
																																											(((long) 2)), BgL_locz00_193);
																																										return
																																											BgL_zc3anonymousza32730ze3z83_18047;
																																									}
																																								}
																																							else
																																								{	/* Eval/evaluate_comp.scm 1011 */
																																									if ((BgL_valz00_3066 == BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
																																										{	/* Eval/evaluate_comp.scm 1011 */
																																											obj_t
																																												BgL_a1z00_3223;
																																											obj_t
																																												BgL_a2z00_3224;
																																											BgL_a1z00_3223
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																											BgL_a2z00_3224
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																											{	/* Eval/evaluate_comp.scm 1011 */
																																												obj_t
																																													BgL_zc3anonymousza32734ze3z83_18048;
																																												BgL_zc3anonymousza32734ze3z83_18048
																																													=
																																													MAKE_FX_PROCEDURE
																																													(BGl_z62zc3anonymousza32734ze3ze1zz__evaluate_compz00,
																																													(int)
																																													(((long) 1)), (int) (((long) 3)));
																																												PROCEDURE_SET
																																													(BgL_zc3anonymousza32734ze3z83_18048,
																																													(int)
																																													(((long) 0)), BgL_a1z00_3223);
																																												PROCEDURE_SET
																																													(BgL_zc3anonymousza32734ze3z83_18048,
																																													(int)
																																													(((long) 1)), BgL_a2z00_3224);
																																												PROCEDURE_SET
																																													(BgL_zc3anonymousza32734ze3z83_18048,
																																													(int)
																																													(((long) 2)), BgL_locz00_193);
																																												return
																																													BgL_zc3anonymousza32734ze3z83_18048;
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate_comp.scm 1011 */
																																											if ((BgL_valz00_3066 == BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
																																												{	/* Eval/evaluate_comp.scm 1011 */
																																													obj_t
																																														BgL_a1z00_3233;
																																													obj_t
																																														BgL_a2z00_3234;
																																													BgL_a1z00_3233
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																													BgL_a2z00_3234
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																													{	/* Eval/evaluate_comp.scm 1011 */
																																														obj_t
																																															BgL_zc3anonymousza32738ze3z83_18049;
																																														BgL_zc3anonymousza32738ze3z83_18049
																																															=
																																															MAKE_FX_PROCEDURE
																																															(BGl_z62zc3anonymousza32738ze3ze1zz__evaluate_compz00,
																																															(int)
																																															(((long) 1)), (int) (((long) 3)));
																																														PROCEDURE_SET
																																															(BgL_zc3anonymousza32738ze3z83_18049,
																																															(int)
																																															(((long) 0)), BgL_a1z00_3233);
																																														PROCEDURE_SET
																																															(BgL_zc3anonymousza32738ze3z83_18049,
																																															(int)
																																															(((long) 1)), BgL_a2z00_3234);
																																														PROCEDURE_SET
																																															(BgL_zc3anonymousza32738ze3z83_18049,
																																															(int)
																																															(((long) 2)), BgL_locz00_193);
																																														return
																																															BgL_zc3anonymousza32738ze3z83_18049;
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate_comp.scm 1011 */
																																													if ((BgL_valz00_3066 == BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
																																														{	/* Eval/evaluate_comp.scm 1011 */
																																															obj_t
																																																BgL_a1z00_3243;
																																															obj_t
																																																BgL_a2z00_3244;
																																															BgL_a1z00_3243
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																															BgL_a2z00_3244
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																															{	/* Eval/evaluate_comp.scm 1011 */
																																																obj_t
																																																	BgL_zc3anonymousza32742ze3z83_18050;
																																																BgL_zc3anonymousza32742ze3z83_18050
																																																	=
																																																	MAKE_FX_PROCEDURE
																																																	(BGl_z62zc3anonymousza32742ze3ze1zz__evaluate_compz00,
																																																	(int)
																																																	(((long) 1)), (int) (((long) 3)));
																																																PROCEDURE_SET
																																																	(BgL_zc3anonymousza32742ze3z83_18050,
																																																	(int)
																																																	(((long) 0)), BgL_a1z00_3243);
																																																PROCEDURE_SET
																																																	(BgL_zc3anonymousza32742ze3z83_18050,
																																																	(int)
																																																	(((long) 1)), BgL_a2z00_3244);
																																																PROCEDURE_SET
																																																	(BgL_zc3anonymousza32742ze3z83_18050,
																																																	(int)
																																																	(((long) 2)), BgL_locz00_193);
																																																return
																																																	BgL_zc3anonymousza32742ze3z83_18050;
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate_comp.scm 1011 */
																																															if ((BgL_valz00_3066 == BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
																																																{	/* Eval/evaluate_comp.scm 1011 */
																																																	obj_t
																																																		BgL_a1z00_3253;
																																																	obj_t
																																																		BgL_a2z00_3254;
																																																	BgL_a1z00_3253
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																	BgL_a2z00_3254
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																	{	/* Eval/evaluate_comp.scm 1011 */
																																																		obj_t
																																																			BgL_zc3anonymousza32746ze3z83_18051;
																																																		BgL_zc3anonymousza32746ze3z83_18051
																																																			=
																																																			MAKE_FX_PROCEDURE
																																																			(BGl_z62zc3anonymousza32746ze3ze1zz__evaluate_compz00,
																																																			(int)
																																																			(((long) 1)), (int) (((long) 3)));
																																																		PROCEDURE_SET
																																																			(BgL_zc3anonymousza32746ze3z83_18051,
																																																			(int)
																																																			(((long) 0)), BgL_a1z00_3253);
																																																		PROCEDURE_SET
																																																			(BgL_zc3anonymousza32746ze3z83_18051,
																																																			(int)
																																																			(((long) 1)), BgL_a2z00_3254);
																																																		PROCEDURE_SET
																																																			(BgL_zc3anonymousza32746ze3z83_18051,
																																																			(int)
																																																			(((long) 2)), BgL_locz00_193);
																																																		return
																																																			BgL_zc3anonymousza32746ze3z83_18051;
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate_comp.scm 1011 */
																																																	if ((BgL_valz00_3066 == BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
																																																		{	/* Eval/evaluate_comp.scm 1011 */
																																																			obj_t
																																																				BgL_a1z00_3263;
																																																			obj_t
																																																				BgL_a2z00_3264;
																																																			BgL_a1z00_3263
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																			BgL_a2z00_3264
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																			{	/* Eval/evaluate_comp.scm 1011 */
																																																				obj_t
																																																					BgL_zc3anonymousza32750ze3z83_18052;
																																																				BgL_zc3anonymousza32750ze3z83_18052
																																																					=
																																																					MAKE_FX_PROCEDURE
																																																					(BGl_z62zc3anonymousza32750ze3ze1zz__evaluate_compz00,
																																																					(int)
																																																					(((long) 1)), (int) (((long) 3)));
																																																				PROCEDURE_SET
																																																					(BgL_zc3anonymousza32750ze3z83_18052,
																																																					(int)
																																																					(((long) 0)), BgL_a1z00_3263);
																																																				PROCEDURE_SET
																																																					(BgL_zc3anonymousza32750ze3z83_18052,
																																																					(int)
																																																					(((long) 1)), BgL_a2z00_3264);
																																																				PROCEDURE_SET
																																																					(BgL_zc3anonymousza32750ze3z83_18052,
																																																					(int)
																																																					(((long) 2)), BgL_locz00_193);
																																																				return
																																																					BgL_zc3anonymousza32750ze3z83_18052;
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate_comp.scm 1011 */
																																																			if ((BgL_valz00_3066 == BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																																																				{	/* Eval/evaluate_comp.scm 1011 */
																																																					obj_t
																																																						BgL_a1z00_3273;
																																																					obj_t
																																																						BgL_a2z00_3274;
																																																					BgL_a1z00_3273
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																					BgL_a2z00_3274
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																					{	/* Eval/evaluate_comp.scm 1011 */
																																																						obj_t
																																																							BgL_zc3anonymousza32754ze3z83_18053;
																																																						BgL_zc3anonymousza32754ze3z83_18053
																																																							=
																																																							MAKE_FX_PROCEDURE
																																																							(BGl_z62zc3anonymousza32754ze3ze1zz__evaluate_compz00,
																																																							(int)
																																																							(((long) 1)), (int) (((long) 3)));
																																																						PROCEDURE_SET
																																																							(BgL_zc3anonymousza32754ze3z83_18053,
																																																							(int)
																																																							(((long) 0)), BgL_a1z00_3273);
																																																						PROCEDURE_SET
																																																							(BgL_zc3anonymousza32754ze3z83_18053,
																																																							(int)
																																																							(((long) 1)), BgL_a2z00_3274);
																																																						PROCEDURE_SET
																																																							(BgL_zc3anonymousza32754ze3z83_18053,
																																																							(int)
																																																							(((long) 2)), BgL_locz00_193);
																																																						return
																																																							BgL_zc3anonymousza32754ze3z83_18053;
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate_comp.scm 1011 */
																																																					if ((BgL_valz00_3066 == BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																																																						{	/* Eval/evaluate_comp.scm 1011 */
																																																							obj_t
																																																								BgL_a1z00_3283;
																																																							obj_t
																																																								BgL_a2z00_3284;
																																																							BgL_a1z00_3283
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																							BgL_a2z00_3284
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																							{	/* Eval/evaluate_comp.scm 1011 */
																																																								obj_t
																																																									BgL_zc3anonymousza32758ze3z83_18054;
																																																								BgL_zc3anonymousza32758ze3z83_18054
																																																									=
																																																									MAKE_FX_PROCEDURE
																																																									(BGl_z62zc3anonymousza32758ze3ze1zz__evaluate_compz00,
																																																									(int)
																																																									(((long) 1)), (int) (((long) 3)));
																																																								PROCEDURE_SET
																																																									(BgL_zc3anonymousza32758ze3z83_18054,
																																																									(int)
																																																									(((long) 0)), BgL_a1z00_3283);
																																																								PROCEDURE_SET
																																																									(BgL_zc3anonymousza32758ze3z83_18054,
																																																									(int)
																																																									(((long) 1)), BgL_a2z00_3284);
																																																								PROCEDURE_SET
																																																									(BgL_zc3anonymousza32758ze3z83_18054,
																																																									(int)
																																																									(((long) 2)), BgL_locz00_193);
																																																								return
																																																									BgL_zc3anonymousza32758ze3z83_18054;
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate_comp.scm 1011 */
																																																							if ((BgL_valz00_3066 == BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
																																																								{	/* Eval/evaluate_comp.scm 1011 */
																																																									obj_t
																																																										BgL_a1z00_3293;
																																																									obj_t
																																																										BgL_a2z00_3294;
																																																									BgL_a1z00_3293
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																									BgL_a2z00_3294
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																									{	/* Eval/evaluate_comp.scm 1011 */
																																																										obj_t
																																																											BgL_zc3anonymousza32762ze3z83_18055;
																																																										BgL_zc3anonymousza32762ze3z83_18055
																																																											=
																																																											MAKE_FX_PROCEDURE
																																																											(BGl_z62zc3anonymousza32762ze3ze1zz__evaluate_compz00,
																																																											(int)
																																																											(((long) 1)), (int) (((long) 3)));
																																																										PROCEDURE_SET
																																																											(BgL_zc3anonymousza32762ze3z83_18055,
																																																											(int)
																																																											(((long) 0)), BgL_a1z00_3293);
																																																										PROCEDURE_SET
																																																											(BgL_zc3anonymousza32762ze3z83_18055,
																																																											(int)
																																																											(((long) 1)), BgL_a2z00_3294);
																																																										PROCEDURE_SET
																																																											(BgL_zc3anonymousza32762ze3z83_18055,
																																																											(int)
																																																											(((long) 2)), BgL_locz00_193);
																																																										return
																																																											BgL_zc3anonymousza32762ze3z83_18055;
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate_comp.scm 1011 */
																																																									if ((BgL_valz00_3066 == BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
																																																										{	/* Eval/evaluate_comp.scm 1011 */
																																																											obj_t
																																																												BgL_a1z00_3303;
																																																											obj_t
																																																												BgL_a2z00_3304;
																																																											BgL_a1z00_3303
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																											BgL_a2z00_3304
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																											{	/* Eval/evaluate_comp.scm 1011 */
																																																												obj_t
																																																													BgL_zc3anonymousza32766ze3z83_18056;
																																																												BgL_zc3anonymousza32766ze3z83_18056
																																																													=
																																																													MAKE_FX_PROCEDURE
																																																													(BGl_z62zc3anonymousza32766ze3ze1zz__evaluate_compz00,
																																																													(int)
																																																													(((long) 1)), (int) (((long) 3)));
																																																												PROCEDURE_SET
																																																													(BgL_zc3anonymousza32766ze3z83_18056,
																																																													(int)
																																																													(((long) 0)), BgL_a1z00_3303);
																																																												PROCEDURE_SET
																																																													(BgL_zc3anonymousza32766ze3z83_18056,
																																																													(int)
																																																													(((long) 1)), BgL_a2z00_3304);
																																																												PROCEDURE_SET
																																																													(BgL_zc3anonymousza32766ze3z83_18056,
																																																													(int)
																																																													(((long) 2)), BgL_locz00_193);
																																																												return
																																																													BgL_zc3anonymousza32766ze3z83_18056;
																																																											}
																																																										}
																																																									else
																																																										{	/* Eval/evaluate_comp.scm 1011 */
																																																											if ((BgL_valz00_3066 == BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
																																																												{	/* Eval/evaluate_comp.scm 1011 */
																																																													obj_t
																																																														BgL_a1z00_3313;
																																																													obj_t
																																																														BgL_a2z00_3314;
																																																													BgL_a1z00_3313
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																													BgL_a2z00_3314
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																													{	/* Eval/evaluate_comp.scm 1011 */
																																																														obj_t
																																																															BgL_zc3anonymousza32770ze3z83_18057;
																																																														BgL_zc3anonymousza32770ze3z83_18057
																																																															=
																																																															MAKE_FX_PROCEDURE
																																																															(BGl_z62zc3anonymousza32770ze3ze1zz__evaluate_compz00,
																																																															(int)
																																																															(((long) 1)), (int) (((long) 3)));
																																																														PROCEDURE_SET
																																																															(BgL_zc3anonymousza32770ze3z83_18057,
																																																															(int)
																																																															(((long) 0)), BgL_a1z00_3313);
																																																														PROCEDURE_SET
																																																															(BgL_zc3anonymousza32770ze3z83_18057,
																																																															(int)
																																																															(((long) 1)), BgL_a2z00_3314);
																																																														PROCEDURE_SET
																																																															(BgL_zc3anonymousza32770ze3z83_18057,
																																																															(int)
																																																															(((long) 2)), BgL_locz00_193);
																																																														return
																																																															BgL_zc3anonymousza32770ze3z83_18057;
																																																													}
																																																												}
																																																											else
																																																												{	/* Eval/evaluate_comp.scm 1011 */
																																																													if ((BgL_valz00_3066 == BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
																																																														{	/* Eval/evaluate_comp.scm 1011 */
																																																															obj_t
																																																																BgL_a1z00_3323;
																																																															obj_t
																																																																BgL_a2z00_3324;
																																																															BgL_a1z00_3323
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																															BgL_a2z00_3324
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																															{	/* Eval/evaluate_comp.scm 1011 */
																																																																obj_t
																																																																	BgL_zc3anonymousza32774ze3z83_18058;
																																																																BgL_zc3anonymousza32774ze3z83_18058
																																																																	=
																																																																	MAKE_FX_PROCEDURE
																																																																	(BGl_z62zc3anonymousza32774ze3ze1zz__evaluate_compz00,
																																																																	(int)
																																																																	(((long) 1)), (int) (((long) 3)));
																																																																PROCEDURE_SET
																																																																	(BgL_zc3anonymousza32774ze3z83_18058,
																																																																	(int)
																																																																	(((long) 0)), BgL_a1z00_3323);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3anonymousza32774ze3z83_18058,
																																																																	(int)
																																																																	(((long) 1)), BgL_a2z00_3324);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3anonymousza32774ze3z83_18058,
																																																																	(int)
																																																																	(((long) 2)), BgL_locz00_193);
																																																																return
																																																																	BgL_zc3anonymousza32774ze3z83_18058;
																																																															}
																																																														}
																																																													else
																																																														{	/* Eval/evaluate_comp.scm 1011 */
																																																															if ((BgL_valz00_3066 == BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
																																																																{	/* Eval/evaluate_comp.scm 1011 */
																																																																	obj_t
																																																																		BgL_a1z00_3333;
																																																																	obj_t
																																																																		BgL_a2z00_3334;
																																																																	BgL_a1z00_3333
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																																	BgL_a2z00_3334
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																																	{	/* Eval/evaluate_comp.scm 1011 */
																																																																		obj_t
																																																																			BgL_zc3anonymousza32778ze3z83_18059;
																																																																		BgL_zc3anonymousza32778ze3z83_18059
																																																																			=
																																																																			MAKE_FX_PROCEDURE
																																																																			(BGl_z62zc3anonymousza32778ze3ze1zz__evaluate_compz00,
																																																																			(int)
																																																																			(((long) 1)), (int) (((long) 3)));
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3anonymousza32778ze3z83_18059,
																																																																			(int)
																																																																			(((long) 0)), BgL_a1z00_3333);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3anonymousza32778ze3z83_18059,
																																																																			(int)
																																																																			(((long) 1)), BgL_a2z00_3334);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3anonymousza32778ze3z83_18059,
																																																																			(int)
																																																																			(((long) 2)), BgL_locz00_193);
																																																																		return
																																																																			BgL_zc3anonymousza32778ze3z83_18059;
																																																																	}
																																																																}
																																																															else
																																																																{	/* Eval/evaluate_comp.scm 1011 */
																																																																	if ((BgL_valz00_3066 == BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
																																																																		{	/* Eval/evaluate_comp.scm 1011 */
																																																																			obj_t
																																																																				BgL_a1z00_3343;
																																																																			obj_t
																																																																				BgL_a2z00_3344;
																																																																			BgL_a1z00_3343
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																																			BgL_a2z00_3344
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																																			{	/* Eval/evaluate_comp.scm 1011 */
																																																																				obj_t
																																																																					BgL_zc3anonymousza32782ze3z83_18060;
																																																																				BgL_zc3anonymousza32782ze3z83_18060
																																																																					=
																																																																					MAKE_FX_PROCEDURE
																																																																					(BGl_z62zc3anonymousza32782ze3ze1zz__evaluate_compz00,
																																																																					(int)
																																																																					(((long) 1)), (int) (((long) 2)));
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3anonymousza32782ze3z83_18060,
																																																																					(int)
																																																																					(((long) 0)), BgL_a1z00_3343);
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3anonymousza32782ze3z83_18060,
																																																																					(int)
																																																																					(((long) 1)), BgL_a2z00_3344);
																																																																				return
																																																																					BgL_zc3anonymousza32782ze3z83_18060;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Eval/evaluate_comp.scm 1011 */
																																																																			if ((BgL_valz00_3066 == BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
																																																																				{	/* Eval/evaluate_comp.scm 1011 */
																																																																					obj_t
																																																																						BgL_a1z00_3351;
																																																																					obj_t
																																																																						BgL_a2z00_3352;
																																																																					BgL_a1z00_3351
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3070), BgL_stkz00_196);
																																																																					BgL_a2z00_3352
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3071), BgL_stkz00_196);
																																																																					{	/* Eval/evaluate_comp.scm 1011 */
																																																																						obj_t
																																																																							BgL_zc3anonymousza32784ze3z83_18061;
																																																																						BgL_zc3anonymousza32784ze3z83_18061
																																																																							=
																																																																							MAKE_FX_PROCEDURE
																																																																							(BGl_z62zc3anonymousza32784ze3ze1zz__evaluate_compz00,
																																																																							(int)
																																																																							(((long) 1)), (int) (((long) 2)));
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3anonymousza32784ze3z83_18061,
																																																																							(int)
																																																																							(((long) 0)), BgL_a1z00_3351);
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3anonymousza32784ze3z83_18061,
																																																																							(int)
																																																																							(((long) 1)), BgL_a2z00_3352);
																																																																						return
																																																																							BgL_zc3anonymousza32784ze3z83_18061;
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Eval/evaluate_comp.scm 1011 */
																																																																					return
																																																																						BFALSE;
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 1009 */
											return BFALSE;
										}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 1004 */
						return BFALSE;
					}
			}
		}
	}



/* &<anonymous:2674> */
	obj_t BGl_z62zc3anonymousza32674ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18065, obj_t BgL_sz00_18069)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18066;
				obj_t BgL_a2z00_18067;
				obj_t BgL_locz00_18068;

				BgL_a1z00_18066 = PROCEDURE_REF(BgL_envz00_18065, (int) (((long) 0)));
				BgL_a2z00_18067 = PROCEDURE_REF(BgL_envz00_18065, (int) (((long) 1)));
				BgL_locz00_18068 = PROCEDURE_REF(BgL_envz00_18065, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3075;

					BgL_sz00_3075 = BgL_sz00_18069;
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_bpz00_3077;

						BgL_bpz00_3077 = VECTOR_REF(BgL_sz00_3075, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_a1z00_3078;
							obj_t BgL_a2z00_3079;

							BgL_a1z00_3078 =
								PROCEDURE_ENTRY(BgL_a1z00_18066) (BgL_a1z00_18066,
								BgL_sz00_3075, BEOA);
							BgL_a2z00_3079 =
								PROCEDURE_ENTRY(BgL_a2z00_18067) (BgL_a2z00_18067,
								BgL_sz00_3075, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_3078))
								{	/* Eval/evaluate_comp.scm 1011 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1011 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5615z00zz__evaluate_compz00,
										BGl_symbol5617z00zz__evaluate_compz00, BgL_a1z00_3078,
										BgL_locz00_18068);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_3079))
								{	/* Eval/evaluate_comp.scm 1011 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1011 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5615z00zz__evaluate_compz00,
										BGl_symbol5617z00zz__evaluate_compz00, BgL_a2z00_3079,
										BgL_locz00_18068);
								}
							return
								BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_3078,
								BgL_a2z00_3079);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2678> */
	obj_t BGl_z62zc3anonymousza32678ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18070, obj_t BgL_sz00_18074)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18071;
				obj_t BgL_a2z00_18072;
				obj_t BgL_locz00_18073;

				BgL_a1z00_18071 = PROCEDURE_REF(BgL_envz00_18070, (int) (((long) 0)));
				BgL_a2z00_18072 = PROCEDURE_REF(BgL_envz00_18070, (int) (((long) 1)));
				BgL_locz00_18073 = PROCEDURE_REF(BgL_envz00_18070, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3085;

					BgL_sz00_3085 = BgL_sz00_18074;
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_bpz00_3087;

						BgL_bpz00_3087 = VECTOR_REF(BgL_sz00_3085, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_a1z00_3088;
							obj_t BgL_a2z00_3089;

							BgL_a1z00_3088 =
								PROCEDURE_ENTRY(BgL_a1z00_18071) (BgL_a1z00_18071,
								BgL_sz00_3085, BEOA);
							BgL_a2z00_3089 =
								PROCEDURE_ENTRY(BgL_a2z00_18072) (BgL_a2z00_18072,
								BgL_sz00_3085, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_3088))
								{	/* Eval/evaluate_comp.scm 1011 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1011 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5619z00zz__evaluate_compz00,
										BGl_symbol5617z00zz__evaluate_compz00, BgL_a1z00_3088,
										BgL_locz00_18073);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_3089))
								{	/* Eval/evaluate_comp.scm 1011 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1011 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5619z00zz__evaluate_compz00,
										BGl_symbol5617z00zz__evaluate_compz00, BgL_a2z00_3089,
										BgL_locz00_18073);
								}
							return
								BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_3088,
								BgL_a2z00_3089);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2682> */
	obj_t BGl_z62zc3anonymousza32682ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18075, obj_t BgL_sz00_18079)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18076;
				obj_t BgL_a2z00_18077;
				obj_t BgL_locz00_18078;

				BgL_a1z00_18076 = PROCEDURE_REF(BgL_envz00_18075, (int) (((long) 0)));
				BgL_a2z00_18077 = PROCEDURE_REF(BgL_envz00_18075, (int) (((long) 1)));
				BgL_locz00_18078 = PROCEDURE_REF(BgL_envz00_18075, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3095;

					BgL_sz00_3095 = BgL_sz00_18079;
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_bpz00_3097;

						BgL_bpz00_3097 = VECTOR_REF(BgL_sz00_3095, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_a1z00_3098;
							obj_t BgL_a2z00_3099;

							BgL_a1z00_3098 =
								PROCEDURE_ENTRY(BgL_a1z00_18076) (BgL_a1z00_18076,
								BgL_sz00_3095, BEOA);
							BgL_a2z00_3099 =
								PROCEDURE_ENTRY(BgL_a2z00_18077) (BgL_a2z00_18077,
								BgL_sz00_3095, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_3098))
								{	/* Eval/evaluate_comp.scm 1011 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1011 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5621z00zz__evaluate_compz00,
										BGl_symbol5617z00zz__evaluate_compz00, BgL_a1z00_3098,
										BgL_locz00_18078);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_3099))
								{	/* Eval/evaluate_comp.scm 1011 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1011 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5621z00zz__evaluate_compz00,
										BGl_symbol5617z00zz__evaluate_compz00, BgL_a2z00_3099,
										BgL_locz00_18078);
								}
							return
								BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_3098,
								BgL_a2z00_3099);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2686> */
	obj_t BGl_z62zc3anonymousza32686ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18080, obj_t BgL_sz00_18084)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18081;
				obj_t BgL_a2z00_18082;
				obj_t BgL_locz00_18083;

				BgL_a1z00_18081 = PROCEDURE_REF(BgL_envz00_18080, (int) (((long) 0)));
				BgL_a2z00_18082 = PROCEDURE_REF(BgL_envz00_18080, (int) (((long) 1)));
				BgL_locz00_18083 = PROCEDURE_REF(BgL_envz00_18080, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3105;

					BgL_sz00_3105 = BgL_sz00_18084;
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_bpz00_3107;

						BgL_bpz00_3107 = VECTOR_REF(BgL_sz00_3105, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_a1z00_3108;
							obj_t BgL_a2z00_3109;

							BgL_a1z00_3108 =
								PROCEDURE_ENTRY(BgL_a1z00_18081) (BgL_a1z00_18081,
								BgL_sz00_3105, BEOA);
							BgL_a2z00_3109 =
								PROCEDURE_ENTRY(BgL_a2z00_18082) (BgL_a2z00_18082,
								BgL_sz00_3105, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_3108))
								{	/* Eval/evaluate_comp.scm 1011 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1011 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5623z00zz__evaluate_compz00,
										BGl_symbol5617z00zz__evaluate_compz00, BgL_a1z00_3108,
										BgL_locz00_18083);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_3109))
								{	/* Eval/evaluate_comp.scm 1011 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1011 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5623z00zz__evaluate_compz00,
										BGl_symbol5617z00zz__evaluate_compz00, BgL_a2z00_3109,
										BgL_locz00_18083);
								}
							return
								BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_3108,
								BgL_a2z00_3109);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2690> */
	obj_t BGl_z62zc3anonymousza32690ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18085, obj_t BgL_sz00_18089)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18086;
				obj_t BgL_a2z00_18087;
				obj_t BgL_locz00_18088;

				BgL_a1z00_18086 = PROCEDURE_REF(BgL_envz00_18085, (int) (((long) 0)));
				BgL_a2z00_18087 = PROCEDURE_REF(BgL_envz00_18085, (int) (((long) 1)));
				BgL_locz00_18088 = PROCEDURE_REF(BgL_envz00_18085, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3115;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26014;

						BgL_sz00_3115 = BgL_sz00_18089;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3117;

							BgL_bpz00_3117 = VECTOR_REF(BgL_sz00_3115, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3118;
								obj_t BgL_a2z00_3119;

								BgL_a1z00_3118 =
									PROCEDURE_ENTRY(BgL_a1z00_18086) (BgL_a1z00_18086,
									BgL_sz00_3115, BEOA);
								BgL_a2z00_3119 =
									PROCEDURE_ENTRY(BgL_a2z00_18087) (BgL_a2z00_18087,
									BgL_sz00_3115, BEOA);
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_3118))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5625z00zz__evaluate_compz00,
											BGl_symbol5617z00zz__evaluate_compz00, BgL_a1z00_3118,
											BgL_locz00_18088);
									}
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_3119))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5625z00zz__evaluate_compz00,
											BGl_symbol5617z00zz__evaluate_compz00, BgL_a2z00_3119,
											BgL_locz00_18088);
									}
								BgL_auxz00_26014 =
									BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_3118,
									BgL_a2z00_3119);
							}
						}
						return BBOOL(BgL_auxz00_26014);
					}
				}
			}
		}
	}



/* &<anonymous:2694> */
	obj_t BGl_z62zc3anonymousza32694ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18090, obj_t BgL_sz00_18094)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18091;
				obj_t BgL_a2z00_18092;
				obj_t BgL_locz00_18093;

				BgL_a1z00_18091 = PROCEDURE_REF(BgL_envz00_18090, (int) (((long) 0)));
				BgL_a2z00_18092 = PROCEDURE_REF(BgL_envz00_18090, (int) (((long) 1)));
				BgL_locz00_18093 = PROCEDURE_REF(BgL_envz00_18090, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3125;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26039;

						BgL_sz00_3125 = BgL_sz00_18094;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3127;

							BgL_bpz00_3127 = VECTOR_REF(BgL_sz00_3125, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3128;
								obj_t BgL_a2z00_3129;

								BgL_a1z00_3128 =
									PROCEDURE_ENTRY(BgL_a1z00_18091) (BgL_a1z00_18091,
									BgL_sz00_3125, BEOA);
								BgL_a2z00_3129 =
									PROCEDURE_ENTRY(BgL_a2z00_18092) (BgL_a2z00_18092,
									BgL_sz00_3125, BEOA);
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_3128))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5627z00zz__evaluate_compz00,
											BGl_symbol5617z00zz__evaluate_compz00, BgL_a1z00_3128,
											BgL_locz00_18093);
									}
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_3129))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5627z00zz__evaluate_compz00,
											BGl_symbol5617z00zz__evaluate_compz00, BgL_a2z00_3129,
											BgL_locz00_18093);
									}
								BgL_auxz00_26039 =
									BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_3128,
									BgL_a2z00_3129);
							}
						}
						return BBOOL(BgL_auxz00_26039);
					}
				}
			}
		}
	}



/* &<anonymous:2698> */
	obj_t BGl_z62zc3anonymousza32698ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18095, obj_t BgL_sz00_18099)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18096;
				obj_t BgL_a2z00_18097;
				obj_t BgL_locz00_18098;

				BgL_a1z00_18096 = PROCEDURE_REF(BgL_envz00_18095, (int) (((long) 0)));
				BgL_a2z00_18097 = PROCEDURE_REF(BgL_envz00_18095, (int) (((long) 1)));
				BgL_locz00_18098 = PROCEDURE_REF(BgL_envz00_18095, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3135;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26064;

						BgL_sz00_3135 = BgL_sz00_18099;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3137;

							BgL_bpz00_3137 = VECTOR_REF(BgL_sz00_3135, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3138;
								obj_t BgL_a2z00_3139;

								BgL_a1z00_3138 =
									PROCEDURE_ENTRY(BgL_a1z00_18096) (BgL_a1z00_18096,
									BgL_sz00_3135, BEOA);
								BgL_a2z00_3139 =
									PROCEDURE_ENTRY(BgL_a2z00_18097) (BgL_a2z00_18097,
									BgL_sz00_3135, BEOA);
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_3138))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5629z00zz__evaluate_compz00,
											BGl_symbol5617z00zz__evaluate_compz00, BgL_a1z00_3138,
											BgL_locz00_18098);
									}
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_3139))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5629z00zz__evaluate_compz00,
											BGl_symbol5617z00zz__evaluate_compz00, BgL_a2z00_3139,
											BgL_locz00_18098);
									}
								BgL_auxz00_26064 =
									BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_3138,
									BgL_a2z00_3139);
							}
						}
						return BBOOL(BgL_auxz00_26064);
					}
				}
			}
		}
	}



/* &<anonymous:2702> */
	obj_t BGl_z62zc3anonymousza32702ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18100, obj_t BgL_sz00_18104)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18101;
				obj_t BgL_a2z00_18102;
				obj_t BgL_locz00_18103;

				BgL_a1z00_18101 = PROCEDURE_REF(BgL_envz00_18100, (int) (((long) 0)));
				BgL_a2z00_18102 = PROCEDURE_REF(BgL_envz00_18100, (int) (((long) 1)));
				BgL_locz00_18103 = PROCEDURE_REF(BgL_envz00_18100, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3145;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26089;

						BgL_sz00_3145 = BgL_sz00_18104;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3147;

							BgL_bpz00_3147 = VECTOR_REF(BgL_sz00_3145, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3148;
								obj_t BgL_a2z00_3149;

								BgL_a1z00_3148 =
									PROCEDURE_ENTRY(BgL_a1z00_18101) (BgL_a1z00_18101,
									BgL_sz00_3145, BEOA);
								BgL_a2z00_3149 =
									PROCEDURE_ENTRY(BgL_a2z00_18102) (BgL_a2z00_18102,
									BgL_sz00_3145, BEOA);
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_3148))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5631z00zz__evaluate_compz00,
											BGl_symbol5617z00zz__evaluate_compz00, BgL_a1z00_3148,
											BgL_locz00_18103);
									}
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_3149))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5631z00zz__evaluate_compz00,
											BGl_symbol5617z00zz__evaluate_compz00, BgL_a2z00_3149,
											BgL_locz00_18103);
									}
								BgL_auxz00_26089 =
									BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_3148,
									BgL_a2z00_3149);
							}
						}
						return BBOOL(BgL_auxz00_26089);
					}
				}
			}
		}
	}



/* &<anonymous:2706> */
	obj_t BGl_z62zc3anonymousza32706ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18105, obj_t BgL_sz00_18109)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18106;
				obj_t BgL_a2z00_18107;
				obj_t BgL_locz00_18108;

				BgL_a1z00_18106 = PROCEDURE_REF(BgL_envz00_18105, (int) (((long) 0)));
				BgL_a2z00_18107 = PROCEDURE_REF(BgL_envz00_18105, (int) (((long) 1)));
				BgL_locz00_18108 = PROCEDURE_REF(BgL_envz00_18105, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3155;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26114;

						BgL_sz00_3155 = BgL_sz00_18109;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3157;

							BgL_bpz00_3157 = VECTOR_REF(BgL_sz00_3155, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3158;
								obj_t BgL_a2z00_3159;

								BgL_a1z00_3158 =
									PROCEDURE_ENTRY(BgL_a1z00_18106) (BgL_a1z00_18106,
									BgL_sz00_3155, BEOA);
								BgL_a2z00_3159 =
									PROCEDURE_ENTRY(BgL_a2z00_18107) (BgL_a2z00_18107,
									BgL_sz00_3155, BEOA);
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_3158))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5633z00zz__evaluate_compz00,
											BGl_symbol5617z00zz__evaluate_compz00, BgL_a1z00_3158,
											BgL_locz00_18108);
									}
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_3159))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5633z00zz__evaluate_compz00,
											BGl_symbol5617z00zz__evaluate_compz00, BgL_a2z00_3159,
											BgL_locz00_18108);
									}
								BgL_auxz00_26114 =
									BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_3158,
									BgL_a2z00_3159);
							}
						}
						return BBOOL(BgL_auxz00_26114);
					}
				}
			}
		}
	}



/* &<anonymous:2710> */
	obj_t BGl_z62zc3anonymousza32710ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18110, obj_t BgL_sz00_18114)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18111;
				obj_t BgL_a2z00_18112;
				obj_t BgL_locz00_18113;

				BgL_a1z00_18111 = PROCEDURE_REF(BgL_envz00_18110, (int) (((long) 0)));
				BgL_a2z00_18112 = PROCEDURE_REF(BgL_envz00_18110, (int) (((long) 1)));
				BgL_locz00_18113 = PROCEDURE_REF(BgL_envz00_18110, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3165;

					{	/* Eval/evaluate_comp.scm 1011 */
						long BgL_auxz00_26139;

						BgL_sz00_3165 = BgL_sz00_18114;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3167;

							BgL_bpz00_3167 = VECTOR_REF(BgL_sz00_3165, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3168;
								obj_t BgL_a2z00_3169;

								BgL_a1z00_3168 =
									PROCEDURE_ENTRY(BgL_a1z00_18111) (BgL_a1z00_18111,
									BgL_sz00_3165, BEOA);
								BgL_a2z00_3169 =
									PROCEDURE_ENTRY(BgL_a2z00_18112) (BgL_a2z00_18112,
									BgL_sz00_3165, BEOA);
								if (INTEGERP(BgL_a1z00_3168))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5635z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a1z00_3168,
											BgL_locz00_18113);
									}
								if (INTEGERP(BgL_a2z00_3169))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5635z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a2z00_3169,
											BgL_locz00_18113);
									}
								BgL_auxz00_26139 =
									((long) CINT(BgL_a1z00_3168) + (long) CINT(BgL_a2z00_3169));
						}}
						return BINT(BgL_auxz00_26139);
					}
				}
			}
		}
	}



/* &<anonymous:2714> */
	obj_t BGl_z62zc3anonymousza32714ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18115, obj_t BgL_sz00_18119)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18116;
				obj_t BgL_a2z00_18117;
				obj_t BgL_locz00_18118;

				BgL_a1z00_18116 = PROCEDURE_REF(BgL_envz00_18115, (int) (((long) 0)));
				BgL_a2z00_18117 = PROCEDURE_REF(BgL_envz00_18115, (int) (((long) 1)));
				BgL_locz00_18118 = PROCEDURE_REF(BgL_envz00_18115, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3175;

					{	/* Eval/evaluate_comp.scm 1011 */
						long BgL_auxz00_26166;

						BgL_sz00_3175 = BgL_sz00_18119;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3177;

							BgL_bpz00_3177 = VECTOR_REF(BgL_sz00_3175, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3178;
								obj_t BgL_a2z00_3179;

								BgL_a1z00_3178 =
									PROCEDURE_ENTRY(BgL_a1z00_18116) (BgL_a1z00_18116,
									BgL_sz00_3175, BEOA);
								BgL_a2z00_3179 =
									PROCEDURE_ENTRY(BgL_a2z00_18117) (BgL_a2z00_18117,
									BgL_sz00_3175, BEOA);
								if (INTEGERP(BgL_a1z00_3178))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5639z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a1z00_3178,
											BgL_locz00_18118);
									}
								if (INTEGERP(BgL_a2z00_3179))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5639z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a2z00_3179,
											BgL_locz00_18118);
									}
								BgL_auxz00_26166 =
									((long) CINT(BgL_a1z00_3178) - (long) CINT(BgL_a2z00_3179));
						}}
						return BINT(BgL_auxz00_26166);
					}
				}
			}
		}
	}



/* &<anonymous:2718> */
	obj_t BGl_z62zc3anonymousza32718ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18120, obj_t BgL_sz00_18124)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18121;
				obj_t BgL_a2z00_18122;
				obj_t BgL_locz00_18123;

				BgL_a1z00_18121 = PROCEDURE_REF(BgL_envz00_18120, (int) (((long) 0)));
				BgL_a2z00_18122 = PROCEDURE_REF(BgL_envz00_18120, (int) (((long) 1)));
				BgL_locz00_18123 = PROCEDURE_REF(BgL_envz00_18120, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3185;

					{	/* Eval/evaluate_comp.scm 1011 */
						long BgL_auxz00_26193;

						BgL_sz00_3185 = BgL_sz00_18124;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3187;

							BgL_bpz00_3187 = VECTOR_REF(BgL_sz00_3185, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3188;
								obj_t BgL_a2z00_3189;

								BgL_a1z00_3188 =
									PROCEDURE_ENTRY(BgL_a1z00_18121) (BgL_a1z00_18121,
									BgL_sz00_3185, BEOA);
								BgL_a2z00_3189 =
									PROCEDURE_ENTRY(BgL_a2z00_18122) (BgL_a2z00_18122,
									BgL_sz00_3185, BEOA);
								if (INTEGERP(BgL_a1z00_3188))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5641z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a1z00_3188,
											BgL_locz00_18123);
									}
								if (INTEGERP(BgL_a2z00_3189))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5641z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a2z00_3189,
											BgL_locz00_18123);
									}
								BgL_auxz00_26193 =
									((long) CINT(BgL_a1z00_3188) * (long) CINT(BgL_a2z00_3189));
						}}
						return BINT(BgL_auxz00_26193);
					}
				}
			}
		}
	}



/* &<anonymous:2722> */
	obj_t BGl_z62zc3anonymousza32722ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18125, obj_t BgL_sz00_18129)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18126;
				obj_t BgL_a2z00_18127;
				obj_t BgL_locz00_18128;

				BgL_a1z00_18126 = PROCEDURE_REF(BgL_envz00_18125, (int) (((long) 0)));
				BgL_a2z00_18127 = PROCEDURE_REF(BgL_envz00_18125, (int) (((long) 1)));
				BgL_locz00_18128 = PROCEDURE_REF(BgL_envz00_18125, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3195;

					{	/* Eval/evaluate_comp.scm 1011 */
						long BgL_auxz00_26220;

						BgL_sz00_3195 = BgL_sz00_18129;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3197;

							BgL_bpz00_3197 = VECTOR_REF(BgL_sz00_3195, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3198;
								obj_t BgL_a2z00_3199;

								BgL_a1z00_3198 =
									PROCEDURE_ENTRY(BgL_a1z00_18126) (BgL_a1z00_18126,
									BgL_sz00_3195, BEOA);
								BgL_a2z00_3199 =
									PROCEDURE_ENTRY(BgL_a2z00_18127) (BgL_a2z00_18127,
									BgL_sz00_3195, BEOA);
								if (INTEGERP(BgL_a1z00_3198))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5643z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a1z00_3198,
											BgL_locz00_18128);
									}
								if (INTEGERP(BgL_a2z00_3199))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5643z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a2z00_3199,
											BgL_locz00_18128);
									}
								BgL_auxz00_26220 =
									((long) CINT(BgL_a1z00_3198) / (long) CINT(BgL_a2z00_3199));
						}}
						return BINT(BgL_auxz00_26220);
					}
				}
			}
		}
	}



/* &<anonymous:2726> */
	obj_t BGl_z62zc3anonymousza32726ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18130, obj_t BgL_sz00_18134)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18131;
				obj_t BgL_a2z00_18132;
				obj_t BgL_locz00_18133;

				BgL_a1z00_18131 = PROCEDURE_REF(BgL_envz00_18130, (int) (((long) 0)));
				BgL_a2z00_18132 = PROCEDURE_REF(BgL_envz00_18130, (int) (((long) 1)));
				BgL_locz00_18133 = PROCEDURE_REF(BgL_envz00_18130, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3205;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26247;

						BgL_sz00_3205 = BgL_sz00_18134;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3207;

							BgL_bpz00_3207 = VECTOR_REF(BgL_sz00_3205, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3208;
								obj_t BgL_a2z00_3209;

								BgL_a1z00_3208 =
									PROCEDURE_ENTRY(BgL_a1z00_18131) (BgL_a1z00_18131,
									BgL_sz00_3205, BEOA);
								BgL_a2z00_3209 =
									PROCEDURE_ENTRY(BgL_a2z00_18132) (BgL_a2z00_18132,
									BgL_sz00_3205, BEOA);
								if (INTEGERP(BgL_a1z00_3208))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5645z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a1z00_3208,
											BgL_locz00_18133);
									}
								if (INTEGERP(BgL_a2z00_3209))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5645z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a2z00_3209,
											BgL_locz00_18133);
									}
								BgL_auxz00_26247 =
									((long) CINT(BgL_a1z00_3208) < (long) CINT(BgL_a2z00_3209));
						}}
						return BBOOL(BgL_auxz00_26247);
					}
				}
			}
		}
	}



/* &<anonymous:2730> */
	obj_t BGl_z62zc3anonymousza32730ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18135, obj_t BgL_sz00_18139)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18136;
				obj_t BgL_a2z00_18137;
				obj_t BgL_locz00_18138;

				BgL_a1z00_18136 = PROCEDURE_REF(BgL_envz00_18135, (int) (((long) 0)));
				BgL_a2z00_18137 = PROCEDURE_REF(BgL_envz00_18135, (int) (((long) 1)));
				BgL_locz00_18138 = PROCEDURE_REF(BgL_envz00_18135, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3215;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26274;

						BgL_sz00_3215 = BgL_sz00_18139;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3217;

							BgL_bpz00_3217 = VECTOR_REF(BgL_sz00_3215, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3218;
								obj_t BgL_a2z00_3219;

								BgL_a1z00_3218 =
									PROCEDURE_ENTRY(BgL_a1z00_18136) (BgL_a1z00_18136,
									BgL_sz00_3215, BEOA);
								BgL_a2z00_3219 =
									PROCEDURE_ENTRY(BgL_a2z00_18137) (BgL_a2z00_18137,
									BgL_sz00_3215, BEOA);
								if (INTEGERP(BgL_a1z00_3218))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5647z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a1z00_3218,
											BgL_locz00_18138);
									}
								if (INTEGERP(BgL_a2z00_3219))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5647z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a2z00_3219,
											BgL_locz00_18138);
									}
								BgL_auxz00_26274 =
									((long) CINT(BgL_a1z00_3218) > (long) CINT(BgL_a2z00_3219));
						}}
						return BBOOL(BgL_auxz00_26274);
					}
				}
			}
		}
	}



/* &<anonymous:2734> */
	obj_t BGl_z62zc3anonymousza32734ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18140, obj_t BgL_sz00_18144)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18141;
				obj_t BgL_a2z00_18142;
				obj_t BgL_locz00_18143;

				BgL_a1z00_18141 = PROCEDURE_REF(BgL_envz00_18140, (int) (((long) 0)));
				BgL_a2z00_18142 = PROCEDURE_REF(BgL_envz00_18140, (int) (((long) 1)));
				BgL_locz00_18143 = PROCEDURE_REF(BgL_envz00_18140, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3225;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26301;

						BgL_sz00_3225 = BgL_sz00_18144;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3227;

							BgL_bpz00_3227 = VECTOR_REF(BgL_sz00_3225, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3228;
								obj_t BgL_a2z00_3229;

								BgL_a1z00_3228 =
									PROCEDURE_ENTRY(BgL_a1z00_18141) (BgL_a1z00_18141,
									BgL_sz00_3225, BEOA);
								BgL_a2z00_3229 =
									PROCEDURE_ENTRY(BgL_a2z00_18142) (BgL_a2z00_18142,
									BgL_sz00_3225, BEOA);
								if (INTEGERP(BgL_a1z00_3228))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5649z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a1z00_3228,
											BgL_locz00_18143);
									}
								if (INTEGERP(BgL_a2z00_3229))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5649z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a2z00_3229,
											BgL_locz00_18143);
									}
								BgL_auxz00_26301 =
									((long) CINT(BgL_a1z00_3228) <= (long) CINT(BgL_a2z00_3229));
						}}
						return BBOOL(BgL_auxz00_26301);
					}
				}
			}
		}
	}



/* &<anonymous:2738> */
	obj_t BGl_z62zc3anonymousza32738ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18145, obj_t BgL_sz00_18149)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18146;
				obj_t BgL_a2z00_18147;
				obj_t BgL_locz00_18148;

				BgL_a1z00_18146 = PROCEDURE_REF(BgL_envz00_18145, (int) (((long) 0)));
				BgL_a2z00_18147 = PROCEDURE_REF(BgL_envz00_18145, (int) (((long) 1)));
				BgL_locz00_18148 = PROCEDURE_REF(BgL_envz00_18145, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3235;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26328;

						BgL_sz00_3235 = BgL_sz00_18149;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3237;

							BgL_bpz00_3237 = VECTOR_REF(BgL_sz00_3235, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3238;
								obj_t BgL_a2z00_3239;

								BgL_a1z00_3238 =
									PROCEDURE_ENTRY(BgL_a1z00_18146) (BgL_a1z00_18146,
									BgL_sz00_3235, BEOA);
								BgL_a2z00_3239 =
									PROCEDURE_ENTRY(BgL_a2z00_18147) (BgL_a2z00_18147,
									BgL_sz00_3235, BEOA);
								if (INTEGERP(BgL_a1z00_3238))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5651z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a1z00_3238,
											BgL_locz00_18148);
									}
								if (INTEGERP(BgL_a2z00_3239))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5651z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a2z00_3239,
											BgL_locz00_18148);
									}
								BgL_auxz00_26328 =
									((long) CINT(BgL_a1z00_3238) >= (long) CINT(BgL_a2z00_3239));
						}}
						return BBOOL(BgL_auxz00_26328);
					}
				}
			}
		}
	}



/* &<anonymous:2742> */
	obj_t BGl_z62zc3anonymousza32742ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18150, obj_t BgL_sz00_18154)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18151;
				obj_t BgL_a2z00_18152;
				obj_t BgL_locz00_18153;

				BgL_a1z00_18151 = PROCEDURE_REF(BgL_envz00_18150, (int) (((long) 0)));
				BgL_a2z00_18152 = PROCEDURE_REF(BgL_envz00_18150, (int) (((long) 1)));
				BgL_locz00_18153 = PROCEDURE_REF(BgL_envz00_18150, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3245;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26355;

						BgL_sz00_3245 = BgL_sz00_18154;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3247;

							BgL_bpz00_3247 = VECTOR_REF(BgL_sz00_3245, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3248;
								obj_t BgL_a2z00_3249;

								BgL_a1z00_3248 =
									PROCEDURE_ENTRY(BgL_a1z00_18151) (BgL_a1z00_18151,
									BgL_sz00_3245, BEOA);
								BgL_a2z00_3249 =
									PROCEDURE_ENTRY(BgL_a2z00_18152) (BgL_a2z00_18152,
									BgL_sz00_3245, BEOA);
								if (INTEGERP(BgL_a1z00_3248))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5653z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a1z00_3248,
											BgL_locz00_18153);
									}
								if (INTEGERP(BgL_a2z00_3249))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5653z00zz__evaluate_compz00,
											BGl_symbol5637z00zz__evaluate_compz00, BgL_a2z00_3249,
											BgL_locz00_18153);
									}
								BgL_auxz00_26355 =
									((long) CINT(BgL_a1z00_3248) == (long) CINT(BgL_a2z00_3249));
						}}
						return BBOOL(BgL_auxz00_26355);
					}
				}
			}
		}
	}



/* &<anonymous:2746> */
	obj_t BGl_z62zc3anonymousza32746ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18155, obj_t BgL_sz00_18159)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18156;
				obj_t BgL_a2z00_18157;
				obj_t BgL_locz00_18158;

				BgL_a1z00_18156 = PROCEDURE_REF(BgL_envz00_18155, (int) (((long) 0)));
				BgL_a2z00_18157 = PROCEDURE_REF(BgL_envz00_18155, (int) (((long) 1)));
				BgL_locz00_18158 = PROCEDURE_REF(BgL_envz00_18155, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3255;

					{	/* Eval/evaluate_comp.scm 1011 */
						double BgL_auxz00_26382;

						BgL_sz00_3255 = BgL_sz00_18159;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3257;

							BgL_bpz00_3257 = VECTOR_REF(BgL_sz00_3255, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3258;
								obj_t BgL_a2z00_3259;

								BgL_a1z00_3258 =
									PROCEDURE_ENTRY(BgL_a1z00_18156) (BgL_a1z00_18156,
									BgL_sz00_3255, BEOA);
								BgL_a2z00_3259 =
									PROCEDURE_ENTRY(BgL_a2z00_18157) (BgL_a2z00_18157,
									BgL_sz00_3255, BEOA);
								if (REALP(BgL_a1z00_3258))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5655z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a1z00_3258,
											BgL_locz00_18158);
									}
								if (REALP(BgL_a2z00_3259))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5655z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a2z00_3259,
											BgL_locz00_18158);
									}
								BgL_auxz00_26382 =
									(REAL_TO_DOUBLE(BgL_a1z00_3258) +
									REAL_TO_DOUBLE(BgL_a2z00_3259));
							}
						}
						return DOUBLE_TO_REAL(BgL_auxz00_26382);
					}
				}
			}
		}
	}



/* &<anonymous:2750> */
	obj_t BGl_z62zc3anonymousza32750ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18160, obj_t BgL_sz00_18164)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18161;
				obj_t BgL_a2z00_18162;
				obj_t BgL_locz00_18163;

				BgL_a1z00_18161 = PROCEDURE_REF(BgL_envz00_18160, (int) (((long) 0)));
				BgL_a2z00_18162 = PROCEDURE_REF(BgL_envz00_18160, (int) (((long) 1)));
				BgL_locz00_18163 = PROCEDURE_REF(BgL_envz00_18160, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3265;

					{	/* Eval/evaluate_comp.scm 1011 */
						double BgL_auxz00_26409;

						BgL_sz00_3265 = BgL_sz00_18164;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3267;

							BgL_bpz00_3267 = VECTOR_REF(BgL_sz00_3265, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3268;
								obj_t BgL_a2z00_3269;

								BgL_a1z00_3268 =
									PROCEDURE_ENTRY(BgL_a1z00_18161) (BgL_a1z00_18161,
									BgL_sz00_3265, BEOA);
								BgL_a2z00_3269 =
									PROCEDURE_ENTRY(BgL_a2z00_18162) (BgL_a2z00_18162,
									BgL_sz00_3265, BEOA);
								if (REALP(BgL_a1z00_3268))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5659z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a1z00_3268,
											BgL_locz00_18163);
									}
								if (REALP(BgL_a2z00_3269))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5659z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a2z00_3269,
											BgL_locz00_18163);
									}
								BgL_auxz00_26409 =
									(REAL_TO_DOUBLE(BgL_a1z00_3268) -
									REAL_TO_DOUBLE(BgL_a2z00_3269));
							}
						}
						return DOUBLE_TO_REAL(BgL_auxz00_26409);
					}
				}
			}
		}
	}



/* &<anonymous:2754> */
	obj_t BGl_z62zc3anonymousza32754ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18165, obj_t BgL_sz00_18169)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18166;
				obj_t BgL_a2z00_18167;
				obj_t BgL_locz00_18168;

				BgL_a1z00_18166 = PROCEDURE_REF(BgL_envz00_18165, (int) (((long) 0)));
				BgL_a2z00_18167 = PROCEDURE_REF(BgL_envz00_18165, (int) (((long) 1)));
				BgL_locz00_18168 = PROCEDURE_REF(BgL_envz00_18165, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3275;

					{	/* Eval/evaluate_comp.scm 1011 */
						double BgL_auxz00_26436;

						BgL_sz00_3275 = BgL_sz00_18169;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3277;

							BgL_bpz00_3277 = VECTOR_REF(BgL_sz00_3275, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3278;
								obj_t BgL_a2z00_3279;

								BgL_a1z00_3278 =
									PROCEDURE_ENTRY(BgL_a1z00_18166) (BgL_a1z00_18166,
									BgL_sz00_3275, BEOA);
								BgL_a2z00_3279 =
									PROCEDURE_ENTRY(BgL_a2z00_18167) (BgL_a2z00_18167,
									BgL_sz00_3275, BEOA);
								if (REALP(BgL_a1z00_3278))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5661z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a1z00_3278,
											BgL_locz00_18168);
									}
								if (REALP(BgL_a2z00_3279))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5661z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a2z00_3279,
											BgL_locz00_18168);
									}
								BgL_auxz00_26436 =
									(REAL_TO_DOUBLE(BgL_a1z00_3278) *
									REAL_TO_DOUBLE(BgL_a2z00_3279));
							}
						}
						return DOUBLE_TO_REAL(BgL_auxz00_26436);
					}
				}
			}
		}
	}



/* &<anonymous:2758> */
	obj_t BGl_z62zc3anonymousza32758ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18170, obj_t BgL_sz00_18174)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18171;
				obj_t BgL_a2z00_18172;
				obj_t BgL_locz00_18173;

				BgL_a1z00_18171 = PROCEDURE_REF(BgL_envz00_18170, (int) (((long) 0)));
				BgL_a2z00_18172 = PROCEDURE_REF(BgL_envz00_18170, (int) (((long) 1)));
				BgL_locz00_18173 = PROCEDURE_REF(BgL_envz00_18170, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3285;

					{	/* Eval/evaluate_comp.scm 1011 */
						double BgL_auxz00_26463;

						BgL_sz00_3285 = BgL_sz00_18174;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3287;

							BgL_bpz00_3287 = VECTOR_REF(BgL_sz00_3285, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3288;
								obj_t BgL_a2z00_3289;

								BgL_a1z00_3288 =
									PROCEDURE_ENTRY(BgL_a1z00_18171) (BgL_a1z00_18171,
									BgL_sz00_3285, BEOA);
								BgL_a2z00_3289 =
									PROCEDURE_ENTRY(BgL_a2z00_18172) (BgL_a2z00_18172,
									BgL_sz00_3285, BEOA);
								if (REALP(BgL_a1z00_3288))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5663z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a1z00_3288,
											BgL_locz00_18173);
									}
								if (REALP(BgL_a2z00_3289))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5663z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a2z00_3289,
											BgL_locz00_18173);
									}
								BgL_auxz00_26463 =
									(REAL_TO_DOUBLE(BgL_a1z00_3288) /
									REAL_TO_DOUBLE(BgL_a2z00_3289));
							}
						}
						return DOUBLE_TO_REAL(BgL_auxz00_26463);
					}
				}
			}
		}
	}



/* &<anonymous:2762> */
	obj_t BGl_z62zc3anonymousza32762ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18175, obj_t BgL_sz00_18179)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18176;
				obj_t BgL_a2z00_18177;
				obj_t BgL_locz00_18178;

				BgL_a1z00_18176 = PROCEDURE_REF(BgL_envz00_18175, (int) (((long) 0)));
				BgL_a2z00_18177 = PROCEDURE_REF(BgL_envz00_18175, (int) (((long) 1)));
				BgL_locz00_18178 = PROCEDURE_REF(BgL_envz00_18175, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3295;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26490;

						BgL_sz00_3295 = BgL_sz00_18179;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3297;

							BgL_bpz00_3297 = VECTOR_REF(BgL_sz00_3295, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3298;
								obj_t BgL_a2z00_3299;

								BgL_a1z00_3298 =
									PROCEDURE_ENTRY(BgL_a1z00_18176) (BgL_a1z00_18176,
									BgL_sz00_3295, BEOA);
								BgL_a2z00_3299 =
									PROCEDURE_ENTRY(BgL_a2z00_18177) (BgL_a2z00_18177,
									BgL_sz00_3295, BEOA);
								if (REALP(BgL_a1z00_3298))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5665z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a1z00_3298,
											BgL_locz00_18178);
									}
								if (REALP(BgL_a2z00_3299))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5665z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a2z00_3299,
											BgL_locz00_18178);
									}
								BgL_auxz00_26490 =
									(REAL_TO_DOUBLE(BgL_a1z00_3298) <
									REAL_TO_DOUBLE(BgL_a2z00_3299));
							}
						}
						return BBOOL(BgL_auxz00_26490);
					}
				}
			}
		}
	}



/* &<anonymous:2766> */
	obj_t BGl_z62zc3anonymousza32766ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18180, obj_t BgL_sz00_18184)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18181;
				obj_t BgL_a2z00_18182;
				obj_t BgL_locz00_18183;

				BgL_a1z00_18181 = PROCEDURE_REF(BgL_envz00_18180, (int) (((long) 0)));
				BgL_a2z00_18182 = PROCEDURE_REF(BgL_envz00_18180, (int) (((long) 1)));
				BgL_locz00_18183 = PROCEDURE_REF(BgL_envz00_18180, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3305;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26517;

						BgL_sz00_3305 = BgL_sz00_18184;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3307;

							BgL_bpz00_3307 = VECTOR_REF(BgL_sz00_3305, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3308;
								obj_t BgL_a2z00_3309;

								BgL_a1z00_3308 =
									PROCEDURE_ENTRY(BgL_a1z00_18181) (BgL_a1z00_18181,
									BgL_sz00_3305, BEOA);
								BgL_a2z00_3309 =
									PROCEDURE_ENTRY(BgL_a2z00_18182) (BgL_a2z00_18182,
									BgL_sz00_3305, BEOA);
								if (REALP(BgL_a1z00_3308))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5667z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a1z00_3308,
											BgL_locz00_18183);
									}
								if (REALP(BgL_a2z00_3309))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5667z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a2z00_3309,
											BgL_locz00_18183);
									}
								BgL_auxz00_26517 =
									(REAL_TO_DOUBLE(BgL_a1z00_3308) >
									REAL_TO_DOUBLE(BgL_a2z00_3309));
							}
						}
						return BBOOL(BgL_auxz00_26517);
					}
				}
			}
		}
	}



/* &<anonymous:2770> */
	obj_t BGl_z62zc3anonymousza32770ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18185, obj_t BgL_sz00_18189)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18186;
				obj_t BgL_a2z00_18187;
				obj_t BgL_locz00_18188;

				BgL_a1z00_18186 = PROCEDURE_REF(BgL_envz00_18185, (int) (((long) 0)));
				BgL_a2z00_18187 = PROCEDURE_REF(BgL_envz00_18185, (int) (((long) 1)));
				BgL_locz00_18188 = PROCEDURE_REF(BgL_envz00_18185, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3315;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26544;

						BgL_sz00_3315 = BgL_sz00_18189;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3317;

							BgL_bpz00_3317 = VECTOR_REF(BgL_sz00_3315, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3318;
								obj_t BgL_a2z00_3319;

								BgL_a1z00_3318 =
									PROCEDURE_ENTRY(BgL_a1z00_18186) (BgL_a1z00_18186,
									BgL_sz00_3315, BEOA);
								BgL_a2z00_3319 =
									PROCEDURE_ENTRY(BgL_a2z00_18187) (BgL_a2z00_18187,
									BgL_sz00_3315, BEOA);
								if (REALP(BgL_a1z00_3318))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5669z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a1z00_3318,
											BgL_locz00_18188);
									}
								if (REALP(BgL_a2z00_3319))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5669z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a2z00_3319,
											BgL_locz00_18188);
									}
								BgL_auxz00_26544 =
									(REAL_TO_DOUBLE(BgL_a1z00_3318) <=
									REAL_TO_DOUBLE(BgL_a2z00_3319));
							}
						}
						return BBOOL(BgL_auxz00_26544);
					}
				}
			}
		}
	}



/* &<anonymous:2774> */
	obj_t BGl_z62zc3anonymousza32774ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18190, obj_t BgL_sz00_18194)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18191;
				obj_t BgL_a2z00_18192;
				obj_t BgL_locz00_18193;

				BgL_a1z00_18191 = PROCEDURE_REF(BgL_envz00_18190, (int) (((long) 0)));
				BgL_a2z00_18192 = PROCEDURE_REF(BgL_envz00_18190, (int) (((long) 1)));
				BgL_locz00_18193 = PROCEDURE_REF(BgL_envz00_18190, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3325;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26571;

						BgL_sz00_3325 = BgL_sz00_18194;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3327;

							BgL_bpz00_3327 = VECTOR_REF(BgL_sz00_3325, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3328;
								obj_t BgL_a2z00_3329;

								BgL_a1z00_3328 =
									PROCEDURE_ENTRY(BgL_a1z00_18191) (BgL_a1z00_18191,
									BgL_sz00_3325, BEOA);
								BgL_a2z00_3329 =
									PROCEDURE_ENTRY(BgL_a2z00_18192) (BgL_a2z00_18192,
									BgL_sz00_3325, BEOA);
								if (REALP(BgL_a1z00_3328))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5671z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a1z00_3328,
											BgL_locz00_18193);
									}
								if (REALP(BgL_a2z00_3329))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5671z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a2z00_3329,
											BgL_locz00_18193);
									}
								BgL_auxz00_26571 =
									(REAL_TO_DOUBLE(BgL_a1z00_3328) >=
									REAL_TO_DOUBLE(BgL_a2z00_3329));
							}
						}
						return BBOOL(BgL_auxz00_26571);
					}
				}
			}
		}
	}



/* &<anonymous:2778> */
	obj_t BGl_z62zc3anonymousza32778ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18195, obj_t BgL_sz00_18199)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18196;
				obj_t BgL_a2z00_18197;
				obj_t BgL_locz00_18198;

				BgL_a1z00_18196 = PROCEDURE_REF(BgL_envz00_18195, (int) (((long) 0)));
				BgL_a2z00_18197 = PROCEDURE_REF(BgL_envz00_18195, (int) (((long) 1)));
				BgL_locz00_18198 = PROCEDURE_REF(BgL_envz00_18195, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3335;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26598;

						BgL_sz00_3335 = BgL_sz00_18199;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_3337;

							BgL_bpz00_3337 = VECTOR_REF(BgL_sz00_3335, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_3338;
								obj_t BgL_a2z00_3339;

								BgL_a1z00_3338 =
									PROCEDURE_ENTRY(BgL_a1z00_18196) (BgL_a1z00_18196,
									BgL_sz00_3335, BEOA);
								BgL_a2z00_3339 =
									PROCEDURE_ENTRY(BgL_a2z00_18197) (BgL_a2z00_18197,
									BgL_sz00_3335, BEOA);
								if (REALP(BgL_a1z00_3338))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5673z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a1z00_3338,
											BgL_locz00_18198);
									}
								if (REALP(BgL_a2z00_3339))
									{	/* Eval/evaluate_comp.scm 1011 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1011 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5673z00zz__evaluate_compz00,
											BGl_symbol5657z00zz__evaluate_compz00, BgL_a2z00_3339,
											BgL_locz00_18198);
									}
								BgL_auxz00_26598 =
									(REAL_TO_DOUBLE(BgL_a1z00_3338) ==
									REAL_TO_DOUBLE(BgL_a2z00_3339));
							}
						}
						return BBOOL(BgL_auxz00_26598);
					}
				}
			}
		}
	}



/* &<anonymous:2782> */
	obj_t BGl_z62zc3anonymousza32782ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18200, obj_t BgL_sz00_18203)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18201;
				obj_t BgL_a2z00_18202;

				BgL_a1z00_18201 = PROCEDURE_REF(BgL_envz00_18200, (int) (((long) 0)));
				BgL_a2z00_18202 = PROCEDURE_REF(BgL_envz00_18200, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3345;

					{	/* Eval/evaluate_comp.scm 1011 */
						bool_t BgL_auxz00_26623;

						BgL_sz00_3345 = BgL_sz00_18203;
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_bpz00_11137;

							BgL_bpz00_11137 = VECTOR_REF(BgL_sz00_3345, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1011 */
								obj_t BgL_a1z00_11138;
								obj_t BgL_a2z00_11139;

								BgL_a1z00_11138 =
									PROCEDURE_ENTRY(BgL_a1z00_18201) (BgL_a1z00_18201,
									BgL_sz00_3345, BEOA);
								BgL_a2z00_11139 =
									PROCEDURE_ENTRY(BgL_a2z00_18202) (BgL_a2z00_18202,
									BgL_sz00_3345, BEOA);
								BgL_auxz00_26623 = (BgL_a1z00_11138 == BgL_a2z00_11139);
						}}
						return BBOOL(BgL_auxz00_26623);
					}
				}
			}
		}
	}



/* &<anonymous:2784> */
	obj_t BGl_z62zc3anonymousza32784ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18204, obj_t BgL_sz00_18207)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_18205;
				obj_t BgL_a2z00_18206;

				BgL_a1z00_18205 = PROCEDURE_REF(BgL_envz00_18204, (int) (((long) 0)));
				BgL_a2z00_18206 = PROCEDURE_REF(BgL_envz00_18204, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3353;

					BgL_sz00_3353 = BgL_sz00_18207;
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_bpz00_11142;

						BgL_bpz00_11142 = VECTOR_REF(BgL_sz00_3353, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_a1z00_11143;
							obj_t BgL_a2z00_11144;

							BgL_a1z00_11143 =
								PROCEDURE_ENTRY(BgL_a1z00_18205) (BgL_a1z00_18205,
								BgL_sz00_3353, BEOA);
							BgL_a2z00_11144 =
								PROCEDURE_ENTRY(BgL_a2z00_18206) (BgL_a2z00_18206,
								BgL_sz00_3353, BEOA);
							return MAKE_PAIR(BgL_a1z00_11143, BgL_a2z00_11144);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2787> */
	obj_t BGl_z62zc3anonymousza32787ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18208, obj_t BgL_sz00_18211)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1008 */
			{	/* Eval/evaluate_comp.scm 1008 */
				obj_t BgL_a1z00_18209;
				obj_t BgL_locz00_18210;

				BgL_a1z00_18209 = PROCEDURE_REF(BgL_envz00_18208, (int) (((long) 0)));
				BgL_locz00_18210 = PROCEDURE_REF(BgL_envz00_18208, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3362;

					BgL_sz00_3362 = BgL_sz00_18211;
					{	/* Eval/evaluate_comp.scm 1008 */
						obj_t BgL_bpz00_3364;

						BgL_bpz00_3364 = VECTOR_REF(BgL_sz00_3362, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1008 */
							obj_t BgL_a1z00_3365;

							BgL_a1z00_3365 =
								PROCEDURE_ENTRY(BgL_a1z00_18209) (BgL_a1z00_18209,
								BgL_sz00_3362, BEOA);
							if (PAIRP(BgL_a1z00_3365))
								{	/* Eval/evaluate_comp.scm 1008 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1008 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5675z00zz__evaluate_compz00,
										BGl_symbol5677z00zz__evaluate_compz00, BgL_a1z00_3365,
										BgL_locz00_18210);
								}
							return CAR(BgL_a1z00_3365);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2790> */
	obj_t BGl_z62zc3anonymousza32790ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18212, obj_t BgL_sz00_18215)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1008 */
			{	/* Eval/evaluate_comp.scm 1008 */
				obj_t BgL_a1z00_18213;
				obj_t BgL_locz00_18214;

				BgL_a1z00_18213 = PROCEDURE_REF(BgL_envz00_18212, (int) (((long) 0)));
				BgL_locz00_18214 = PROCEDURE_REF(BgL_envz00_18212, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3369;

					BgL_sz00_3369 = BgL_sz00_18215;
					{	/* Eval/evaluate_comp.scm 1008 */
						obj_t BgL_bpz00_3371;

						BgL_bpz00_3371 = VECTOR_REF(BgL_sz00_3369, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1008 */
							obj_t BgL_a1z00_3372;

							BgL_a1z00_3372 =
								PROCEDURE_ENTRY(BgL_a1z00_18213) (BgL_a1z00_18213,
								BgL_sz00_3369, BEOA);
							if (PAIRP(BgL_a1z00_3372))
								{	/* Eval/evaluate_comp.scm 1008 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1008 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5679z00zz__evaluate_compz00,
										BGl_symbol5677z00zz__evaluate_compz00, BgL_a1z00_3372,
										BgL_locz00_18214);
								}
							return CDR(BgL_a1z00_3372);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2793> */
	obj_t BGl_z62zc3anonymousza32793ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18216, obj_t BgL_sz00_18219)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1008 */
			{	/* Eval/evaluate_comp.scm 1008 */
				obj_t BgL_a1z00_18217;
				obj_t BgL_locz00_18218;

				BgL_a1z00_18217 = PROCEDURE_REF(BgL_envz00_18216, (int) (((long) 0)));
				BgL_locz00_18218 = PROCEDURE_REF(BgL_envz00_18216, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3376;

					BgL_sz00_3376 = BgL_sz00_18219;
					{	/* Eval/evaluate_comp.scm 1008 */
						obj_t BgL_bpz00_3378;

						BgL_bpz00_3378 = VECTOR_REF(BgL_sz00_3376, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1008 */
							obj_t BgL_a1z00_3379;

							BgL_a1z00_3379 =
								PROCEDURE_ENTRY(BgL_a1z00_18217) (BgL_a1z00_18217,
								BgL_sz00_3376, BEOA);
							{	/* Eval/evaluate_comp.scm 1008 */
								bool_t BgL_testz00_26689;

								if (PAIRP(BgL_a1z00_3379))
									{	/* Eval/evaluate_comp.scm 1017 */
										obj_t BgL_auxz00_26692;

										BgL_auxz00_26692 = CDR(BgL_a1z00_3379);
										BgL_testz00_26689 = PAIRP(BgL_auxz00_26692);
									}
								else
									{	/* Eval/evaluate_comp.scm 1017 */
										BgL_testz00_26689 = ((bool_t) 0);
									}
								if (BgL_testz00_26689)
									{	/* Eval/evaluate_comp.scm 1008 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 1008 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5681z00zz__evaluate_compz00,
											BGl_symbol5677z00zz__evaluate_compz00, BgL_a1z00_3379,
											BgL_locz00_18218);
									}
							}
							return CAR(CDR(BgL_a1z00_3379));
						}
					}
				}
			}
		}
	}



/* bind-frame */
	obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_202,
		obj_t BgL_wherez00_203, long BgL_spz00_204, long BgL_arityz00_205,
		obj_t BgL_valsz00_206, obj_t BgL_locz00_207)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1050 */
			if ((BgL_arityz00_205 < ((long) 0)))
				{	/* Eval/evaluate_comp.scm 1052 */
					long BgL_g1235z00_3385;

					BgL_g1235z00_3385 = (((long) -1) - BgL_arityz00_205);
					{
						long BgL_rz00_3387;
						long BgL_spz00_3388;
						obj_t BgL_lz00_3389;

						BgL_rz00_3387 = BgL_g1235z00_3385;
						BgL_spz00_3388 = BgL_spz00_204;
						BgL_lz00_3389 = BgL_valsz00_206;
					BgL_zc3anonymousza32800ze3z83_3390:
						if ((BgL_rz00_3387 == ((long) 0)))
							{	/* Eval/evaluate_comp.scm 1054 */
								return
									VECTOR_SET(BgL_sz00_202,
									(int) (BgL_spz00_3388), BgL_lz00_3389);
							}
						else
							{	/* Eval/evaluate_comp.scm 1054 */
								if (PAIRP(BgL_lz00_3389))
									{	/* Eval/evaluate_comp.scm 1056 */
										VECTOR_SET(BgL_sz00_202,
											(int) (BgL_spz00_3388), CAR(BgL_lz00_3389));
										{
											obj_t BgL_lz00_26714;
											long BgL_spz00_26712;
											long BgL_rz00_26710;

											BgL_rz00_26710 = (BgL_rz00_3387 - ((long) 1));
											BgL_spz00_26712 = (BgL_spz00_3388 + ((long) 1));
											BgL_lz00_26714 = CDR(BgL_lz00_3389);
											BgL_lz00_3389 = BgL_lz00_26714;
											BgL_spz00_3388 = BgL_spz00_26712;
											BgL_rz00_3387 = BgL_rz00_26710;
											goto BgL_zc3anonymousza32800ze3z83_3390;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1057 */
										long BgL_arg2808z00_3397;

										BgL_arg2808z00_3397 = bgl_list_length(BgL_valsz00_206);
										return
											BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_207,
											BgL_wherez00_203, (int) (BgL_arityz00_205),
											(int) (BgL_arg2808z00_3397));
				}}}}
			else
				{
					long BgL_rz00_3400;
					long BgL_spz00_3401;
					obj_t BgL_lz00_3402;

					BgL_rz00_3400 = BgL_arityz00_205;
					BgL_spz00_3401 = BgL_spz00_204;
					BgL_lz00_3402 = BgL_valsz00_206;
				BgL_zc3anonymousza32809ze3z83_3403:
					if ((BgL_rz00_3400 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 1063 */
							if (NULLP(BgL_lz00_3402))
								{	/* Eval/evaluate_comp.scm 1064 */
									return BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1065 */
									long BgL_arg2818z00_3406;

									BgL_arg2818z00_3406 = bgl_list_length(BgL_valsz00_206);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_207,
										BgL_wherez00_203, (int) (BgL_arityz00_205),
										(int) (BgL_arg2818z00_3406));
						}}
					else
						{	/* Eval/evaluate_comp.scm 1063 */
							if (PAIRP(BgL_lz00_3402))
								{	/* Eval/evaluate_comp.scm 1066 */
									VECTOR_SET(BgL_sz00_202,
										(int) (BgL_spz00_3401), CAR(BgL_lz00_3402));
									{
										obj_t BgL_lz00_26737;
										long BgL_spz00_26735;
										long BgL_rz00_26733;

										BgL_rz00_26733 = (BgL_rz00_3400 - ((long) 1));
										BgL_spz00_26735 = (BgL_spz00_3401 + ((long) 1));
										BgL_lz00_26737 = CDR(BgL_lz00_3402);
										BgL_lz00_3402 = BgL_lz00_26737;
										BgL_spz00_3401 = BgL_spz00_26735;
										BgL_rz00_3400 = BgL_rz00_26733;
										goto BgL_zc3anonymousza32809ze3z83_3403;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 1067 */
									long BgL_arg2833z00_3412;

									BgL_arg2833z00_3412 = bgl_list_length(BgL_valsz00_206);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_207,
										BgL_wherez00_203, (int) (BgL_arityz00_205),
										(int) (BgL_arg2833z00_3412));
		}}}}
	}



/* make-boxes */
	bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_210,
		obj_t BgL_ibza2za2_211, obj_t BgL_bpz00_212)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1164 */
			{
				long BgL_iz00_3416;

				BgL_iz00_3416 = ((long) 0);
			BgL_zc3anonymousza32834ze3z83_3417:
				{	/* Eval/evaluate_comp.scm 1167 */
					long BgL_spz00_3418;

					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_arg2841z00_3423;

						BgL_arg2841z00_3423 =
							VECTOR_REF(BgL_ibza2za2_211, (int) (BgL_iz00_3416));
						BgL_spz00_3418 =
							((long) CINT(BgL_bpz00_212) + (long) CINT(BgL_arg2841z00_3423));
					}
					{	/* Eval/evaluate_comp.scm 1168 */
						obj_t BgL_arg2838z00_3419;

						{	/* Eval/evaluate_comp.scm 1168 */
							obj_t BgL_arg2839z00_3420;

							BgL_arg2839z00_3420 =
								VECTOR_REF(BgL_sz00_210, (int) (BgL_spz00_3418));
							{	/* Eval/evaluate_comp.scm 202 */
								obj_t BgL_newz00_11216;

								BgL_newz00_11216 =
									create_struct(BGl_symbol5605z00zz__evaluate_compz00,
									(int) (((long) 1)));
								{	/* Eval/evaluate_comp.scm 202 */
									int BgL_auxz00_26752;

									BgL_auxz00_26752 = (int) (((long) 0));
									STRUCT_SET(BgL_newz00_11216, BgL_auxz00_26752,
										BgL_arg2839z00_3420);
								}
								BgL_arg2838z00_3419 = BgL_newz00_11216;
						}}
						VECTOR_SET(BgL_sz00_210,
							(int) (BgL_spz00_3418), BgL_arg2838z00_3419);
					}
					{	/* Eval/evaluate_comp.scm 1169 */
						long BgL_niz00_3421;

						BgL_niz00_3421 = (BgL_iz00_3416 + ((long) 1));
						if ((BgL_niz00_3421 < (long) (VECTOR_LENGTH(BgL_ibza2za2_211))))
							{
								long BgL_iz00_26762;

								BgL_iz00_26762 = BgL_niz00_3421;
								BgL_iz00_3416 = BgL_iz00_26762;
								goto BgL_zc3anonymousza32834ze3z83_3417;
							}
						else
							{	/* Eval/evaluate_comp.scm 1170 */
								return ((bool_t) 0);
							}
					}
				}
			}
		}
	}



/* free-collect */
	obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_213,
		obj_t BgL_bpz00_214, obj_t BgL_iza2za2_215)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1172 */
			{	/* Eval/evaluate_comp.scm 1173 */
				obj_t BgL_rz00_3426;

				BgL_rz00_3426 = make_vector(VECTOR_LENGTH(BgL_iza2za2_215), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 1173 */

					{
						long BgL_iz00_3428;

						BgL_iz00_3428 = ((long) 0);
					BgL_zc3anonymousza32842ze3z83_3429:
						if ((BgL_iz00_3428 >= (long) (VECTOR_LENGTH(BgL_iza2za2_215))))
							{	/* Eval/evaluate_comp.scm 1175 */
								return BgL_rz00_3426;
							}
						else
							{	/* Eval/evaluate_comp.scm 1175 */
								{	/* Eval/evaluate_comp.scm 1178 */
									obj_t BgL_arg2844z00_3431;

									{	/* Eval/evaluate_comp.scm 1178 */
										long BgL_arg2845z00_3432;

										{	/* Eval/evaluate_comp.scm 1178 */
											obj_t BgL_arg2846z00_3433;

											BgL_arg2846z00_3433 =
												VECTOR_REF(BgL_iza2za2_215, (int) (BgL_iz00_3428));
											BgL_arg2845z00_3432 =
												(
												(long) CINT(BgL_bpz00_214) +
												(long) CINT(BgL_arg2846z00_3433));
										}
										BgL_arg2844z00_3431 =
											VECTOR_REF(BgL_sz00_213, (int) (BgL_arg2845z00_3432));
									}
									VECTOR_SET(BgL_rz00_3426,
										(int) (BgL_iz00_3428), BgL_arg2844z00_3431);
								}
								{
									long BgL_iz00_26778;

									BgL_iz00_26778 = (BgL_iz00_3428 + ((long) 1));
									BgL_iz00_3428 = BgL_iz00_26778;
									goto BgL_zc3anonymousza32842ze3z83_3429;
								}
							}
					}
				}
			}
		}
	}



/* free-restore */
	bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_216,
		obj_t BgL_valza2za2_217, long BgL_spz00_218)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1181 */
			{	/* Eval/evaluate_comp.scm 1182 */
				long BgL_stopz00_3437;

				BgL_stopz00_3437 =
					(BgL_spz00_218 + (long) (VECTOR_LENGTH(BgL_valza2za2_217)));
				{
					long BgL_iz00_11292;
					long BgL_spz00_11293;

					BgL_iz00_11292 = ((long) 0);
					BgL_spz00_11293 = BgL_spz00_218;
				BgL_recz00_11291:
					if ((BgL_spz00_11293 < BgL_stopz00_3437))
						{	/* Eval/evaluate_comp.scm 1184 */
							VECTOR_SET(BgL_sz00_216,
								(int) (BgL_spz00_11293),
								VECTOR_REF(BgL_valza2za2_217, (int) (BgL_iz00_11292)));
							{
								long BgL_spz00_26791;
								long BgL_iz00_26789;

								BgL_iz00_26789 = (BgL_iz00_11292 + ((long) 1));
								BgL_spz00_26791 = (BgL_spz00_11293 + ((long) 1));
								BgL_spz00_11293 = BgL_spz00_26791;
								BgL_iz00_11292 = BgL_iz00_26789;
								goto BgL_recz00_11291;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 1184 */
							return ((bool_t) 0);
						}
				}
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_proc5683z00zz__evaluate_compz00,
				BGl_ev_exprz00zz__evaluate_typesz00,
				BGl_string5684z00zz__evaluate_compz00);
		}
	}



/* &comp1378 */
	obj_t BGl_z62comp1378z62zz__evaluate_compz00(obj_t BgL_envz00_18305,
		obj_t BgL_ez00_18306, obj_t BgL_stkz00_18307)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 276 */
			{
				BgL_ev_exprz00_bglt BgL_ez00_3449;
				obj_t BgL_stkz00_3450;

				BgL_ez00_3449 = ((BgL_ev_exprz00_bglt) BgL_ez00_18306);
				BgL_stkz00_3450 = BgL_stkz00_18307;
				return
					BGl_errorz00zz__errorz00(BGl_string5595z00zz__evaluate_compz00,
					BGl_string5685z00zz__evaluate_compz00, ((obj_t) BgL_ez00_3449));
			}
		}
	}



/* comp */
	obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35,
		obj_t BgL_stkz00_36)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				obj_t BgL_method1379z00_3453;

				{	/* Eval/evaluate_comp.scm 276 */
					obj_t BgL_res4903z00_11344;

					{	/* Eval/evaluate_comp.scm 276 */
						long BgL_objzd2classzd2numz00_11317;

						{	/* Eval/evaluate_comp.scm 276 */
							long BgL_res4897z00_11320;

							BgL_res4897z00_11320 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_ez00_35));
							BgL_objzd2classzd2numz00_11317 = BgL_res4897z00_11320;
						}
						{	/* Eval/evaluate_comp.scm 276 */
							obj_t BgL_arg4137z00_11318;

							BgL_arg4137z00_11318 =
								PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00,
								(int) (((long) 1)));
							{	/* Eval/evaluate_comp.scm 276 */
								int BgL_offsetz00_11322;

								BgL_offsetz00_11322 = (int) (BgL_objzd2classzd2numz00_11317);
								{	/* Eval/evaluate_comp.scm 276 */
									long BgL_offsetz00_11323;

									BgL_offsetz00_11323 =
										((long) (BgL_offsetz00_11322) - OBJECT_TYPE);
									{	/* Eval/evaluate_comp.scm 276 */
										long BgL_modz00_11324;

										{	/* Eval/evaluate_comp.scm 276 */
											int BgL_arg4139z00_11325;

											BgL_arg4139z00_11325 = (int) (((long) 16));
											{	/* Eval/evaluate_comp.scm 276 */
												long BgL_res4900z00_11335;

												{	/* Eval/evaluate_comp.scm 276 */
													long BgL_auxz00_26805;

													BgL_auxz00_26805 = (long) (BgL_arg4139z00_11325);
													BgL_res4900z00_11335 =
														(BgL_offsetz00_11323 / BgL_auxz00_26805);
												}
												BgL_modz00_11324 = BgL_res4900z00_11335;
										}}
										{	/* Eval/evaluate_comp.scm 276 */
											long BgL_restz00_11326;

											{	/* Eval/evaluate_comp.scm 276 */
												int BgL_arg4138z00_11327;

												BgL_arg4138z00_11327 = (int) (((long) 16));
												{	/* Eval/evaluate_comp.scm 276 */
													long BgL_res4902z00_11339;

													{	/* Eval/evaluate_comp.scm 276 */
														long BgL_auxz00_26809;

														BgL_auxz00_26809 = (long) (BgL_arg4138z00_11327);
														BgL_res4902z00_11339 =
															(BgL_offsetz00_11323 % BgL_auxz00_26809);
													}
													BgL_restz00_11326 = BgL_res4902z00_11339;
											}}
											{	/* Eval/evaluate_comp.scm 276 */

												BgL_res4903z00_11344 =
													VECTOR_REF(VECTOR_REF(BgL_arg4137z00_11318,
														(int) (BgL_modz00_11324)),
													(int) (BgL_restz00_11326));
					}}}}}}}
					BgL_method1379z00_3453 = BgL_res4903z00_11344;
				}
				return
					PROCEDURE_ENTRY(BgL_method1379z00_3453) (BgL_method1379z00_3453,
					((obj_t) BgL_ez00_35), BgL_stkz00_36, BEOA);
			}
		}
	}



/* &comp */
	obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_18308,
		obj_t BgL_ez00_18309, obj_t BgL_stkz00_18310)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				BgL_ev_exprz00_bglt BgL_auxz00_26822;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_18309,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 276 */
						BgL_auxz00_26822 = ((BgL_ev_exprz00_bglt) BgL_ez00_18309);
					}
				else
					{
						obj_t BgL_auxz00_26826;

						BgL_auxz00_26826 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5600z00zz__evaluate_compz00, BINT(((long) 7022)),
							BGl_string5686z00zz__evaluate_compz00,
							BGl_string5602z00zz__evaluate_compz00, BgL_ez00_18309);
						FAILURE(BgL_auxz00_26826, BFALSE, BFALSE);
					}
				return
					BGl_compz00zz__evaluate_compz00(BgL_auxz00_26822, BgL_stkz00_18310);
			}
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_trapz00zz__evaluate_typesz00,
				BGl_proc5687z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_varz00zz__evaluate_typesz00, BGl_proc5689z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setlocalz00zz__evaluate_typesz00,
				BGl_proc5690z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_globalz00zz__evaluate_typesz00,
				BGl_proc5691z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setglobalz00zz__evaluate_typesz00,
				BGl_proc5692z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_defglobalz00zz__evaluate_typesz00,
				BGl_proc5693z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_littz00zz__evaluate_typesz00,
				BGl_proc5694z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc5695z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_orz00zz__evaluate_typesz00, BGl_proc5696z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_andz00zz__evaluate_typesz00, BGl_proc5697z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_prog2z00zz__evaluate_typesz00,
				BGl_proc5698z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letz00zz__evaluate_typesz00, BGl_proc5699z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letza2za2zz__evaluate_typesz00,
				BGl_proc5700z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letrecz00zz__evaluate_typesz00,
				BGl_proc5701z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00,
				BGl_proc5702z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00,
				BGl_proc5703z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00,
				BGl_proc5704z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00,
				BGl_proc5705z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_labelsz00zz__evaluate_typesz00,
				BGl_proc5706z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_gotoz00zz__evaluate_typesz00,
				BGl_proc5707z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_appz00zz__evaluate_typesz00, BGl_proc5708z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_absz00zz__evaluate_typesz00, BGl_proc5709z00zz__evaluate_compz00,
				BGl_string5688z00zz__evaluate_compz00);
		}
	}



/* &comp-ev_abs1427 */
	obj_t BGl_z62compzd2ev_abs1427zb0zz__evaluate_compz00(obj_t BgL_envz00_18505,
		obj_t BgL_ez00_18506, obj_t BgL_stkz00_18507)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1152 */
			{
				BgL_ev_absz00_bglt BgL_ez00_4224;
				obj_t BgL_stkz00_4225;

				BgL_ez00_4224 = ((BgL_ev_absz00_bglt) BgL_ez00_18506);
				BgL_stkz00_4225 = BgL_stkz00_18507;
				{	/* Eval/evaluate_comp.scm 1154 */
					obj_t BgL_ifreesz00_4229;
					obj_t BgL_iboxesz00_4230;
					long BgL_siza7eza7_4231;
					long BgL_siza7ezd2framez75_4232;
					obj_t BgL_nstkz00_4233;

					{	/* Eval/evaluate_comp.scm 1154 */
						obj_t BgL_arg3886z00_5769;

						{	/* Eval/evaluate_comp.scm 1154 */
							obj_t BgL_l1358z00_5770;

							BgL_l1358z00_5770 =
								(((BgL_ev_absz00_bglt) CREF(BgL_ez00_4224))->BgL_freez00);
							if (NULLP(BgL_l1358z00_5770))
								{	/* Eval/evaluate_comp.scm 1154 */
									BgL_arg3886z00_5769 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 1154 */
									obj_t BgL_head1360z00_5772;

									{	/* Eval/evaluate_comp.scm 1154 */
										obj_t BgL_res5042z00_12609;

										BgL_res5042z00_12609 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1360z00_5772 = BgL_res5042z00_12609;
									}
									{
										obj_t BgL_l1358z00_12643;
										obj_t BgL_tail1361z00_12644;

										BgL_l1358z00_12643 = BgL_l1358z00_5770;
										BgL_tail1361z00_12644 = BgL_head1360z00_5772;
									BgL_zc3anonymousza33888ze3z83_12642:
										if (NULLP(BgL_l1358z00_12643))
											{	/* Eval/evaluate_comp.scm 1154 */
												BgL_arg3886z00_5769 = CDR(BgL_head1360z00_5772);
											}
										else
											{	/* Eval/evaluate_comp.scm 1154 */
												obj_t BgL_newtail1362z00_12651;

												{	/* Eval/evaluate_comp.scm 1154 */
													obj_t BgL_arg3891z00_12652;

													BgL_arg3891z00_12652 =
														BGl__indexz00zz__evaluate_compz00(CAR
														(BgL_l1358z00_12643), BgL_stkz00_4225);
													{	/* Eval/evaluate_comp.scm 1154 */
														obj_t BgL_res5048z00_12661;

														BgL_res5048z00_12661 =
															MAKE_PAIR(BgL_arg3891z00_12652, BNIL);
														BgL_newtail1362z00_12651 = BgL_res5048z00_12661;
													}
												}
												SET_CDR(BgL_tail1361z00_12644,
													BgL_newtail1362z00_12651);
												{
													obj_t BgL_tail1361z00_26866;
													obj_t BgL_l1358z00_26864;

													BgL_l1358z00_26864 = CDR(BgL_l1358z00_12643);
													BgL_tail1361z00_26866 = BgL_newtail1362z00_12651;
													BgL_tail1361z00_12644 = BgL_tail1361z00_26866;
													BgL_l1358z00_12643 = BgL_l1358z00_26864;
													goto BgL_zc3anonymousza33888ze3z83_12642;
												}
											}
									}
								}
						}
						BgL_ifreesz00_4229 =
							BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3886z00_5769);
					}
					{	/* Eval/evaluate_comp.scm 1155 */
						obj_t BgL_arg3892z00_5783;

						{	/* Eval/evaluate_comp.scm 1155 */
							obj_t BgL_l1363z00_5784;

							BgL_l1363z00_5784 =
								(((BgL_ev_absz00_bglt) CREF(BgL_ez00_4224))->BgL_boxesz00);
							if (NULLP(BgL_l1363z00_5784))
								{	/* Eval/evaluate_comp.scm 1155 */
									BgL_arg3892z00_5783 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 1155 */
									obj_t BgL_head1365z00_5786;

									{	/* Eval/evaluate_comp.scm 1155 */
										obj_t BgL_res5050z00_12669;

										BgL_res5050z00_12669 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1365z00_5786 = BgL_res5050z00_12669;
									}
									{
										obj_t BgL_l1363z00_5788;
										obj_t BgL_tail1366z00_5789;

										BgL_l1363z00_5788 = BgL_l1363z00_5784;
										BgL_tail1366z00_5789 = BgL_head1365z00_5786;
									BgL_zc3anonymousza33894ze3z83_5790:
										if (NULLP(BgL_l1363z00_5788))
											{	/* Eval/evaluate_comp.scm 1155 */
												BgL_arg3892z00_5783 = CDR(BgL_head1365z00_5786);
											}
										else
											{	/* Eval/evaluate_comp.scm 1155 */
												obj_t BgL_newtail1367z00_5792;

												{	/* Eval/evaluate_comp.scm 1155 */
													obj_t BgL_arg3897z00_5794;

													BgL_arg3897z00_5794 =
														BGl__indexz00zz__evaluate_compz00(CAR
														(BgL_l1363z00_5788),
														(((BgL_ev_absz00_bglt) CREF(BgL_ez00_4224))->
															BgL_varsz00));
													{	/* Eval/evaluate_comp.scm 1155 */
														obj_t BgL_res5052z00_12676;

														BgL_res5052z00_12676 =
															MAKE_PAIR(BgL_arg3897z00_5794, BNIL);
														BgL_newtail1367z00_5792 = BgL_res5052z00_12676;
													}
												}
												SET_CDR(BgL_tail1366z00_5789, BgL_newtail1367z00_5792);
												{
													obj_t BgL_tail1366z00_26882;
													obj_t BgL_l1363z00_26880;

													BgL_l1363z00_26880 = CDR(BgL_l1363z00_5788);
													BgL_tail1366z00_26882 = BgL_newtail1367z00_5792;
													BgL_tail1366z00_5789 = BgL_tail1366z00_26882;
													BgL_l1363z00_5788 = BgL_l1363z00_26880;
													goto BgL_zc3anonymousza33894ze3z83_5790;
												}
											}
									}
								}
						}
						BgL_iboxesz00_4230 =
							BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3892z00_5783);
					}
					BgL_siza7eza7_4231 =
						bgl_list_length(
						(((BgL_ev_absz00_bglt) CREF(BgL_ez00_4224))->BgL_varsz00));
					BgL_siza7ezd2framez75_4232 =
						(
						(long) (
							(((BgL_ev_absz00_bglt) CREF(BgL_ez00_4224))->BgL_siza7eza7)) +
						bgl_list_length(
							(((BgL_ev_absz00_bglt) CREF(BgL_ez00_4224))->BgL_freez00)));
					BgL_nstkz00_4233 =
						BGl_appendzd221011zd2zz__evaluate_compz00(
						(((BgL_ev_absz00_bglt) CREF(BgL_ez00_4224))->BgL_varsz00),
						(((BgL_ev_absz00_bglt) CREF(BgL_ez00_4224))->BgL_freez00));
					{	/* Eval/evaluate_comp.scm 1159 */
						obj_t BgL_bodyz00_4234;

						BgL_bodyz00_4234 =
							BGl_compz00zz__evaluate_compz00(
							(((BgL_ev_absz00_bglt) CREF(BgL_ez00_4224))->BgL_bodyz00),
							BgL_nstkz00_4233);
						{

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_aux1247z00_4236;

								BgL_aux1247z00_4236 =
									(((BgL_ev_absz00_bglt) CREF(BgL_ez00_4224))->BgL_arityz00);
								if (INTEGERP(BgL_aux1247z00_4236))
									{	/* Eval/evaluate_comp.scm 1161 */
										switch ((long) CINT(BgL_aux1247z00_4236))
											{
											case ((long) 0):

												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33344ze3z83_18322;

																BgL_zc3anonymousza33344ze3z83_18322 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33344ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33344ze3z83_18322,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33344ze3z83_18322,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33344ze3z83_18322,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33344ze3z83_18322;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33351ze3z83_18319;

																BgL_zc3anonymousza33351ze3z83_18319 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33351ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33351ze3z83_18319,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33351ze3z83_18319,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33351ze3z83_18319,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33351ze3z83_18319,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33351ze3z83_18319;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33359ze3z83_18316;

																BgL_zc3anonymousza33359ze3z83_18316 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33359ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33359ze3z83_18316,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33359ze3z83_18316,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33359ze3z83_18316,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33359ze3z83_18316,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33359ze3z83_18316,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33359ze3z83_18316;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33366ze3z83_18313;

																BgL_zc3anonymousza33366ze3z83_18313 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33366ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33366ze3z83_18313,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33366ze3z83_18313,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33366ze3z83_18313,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33366ze3z83_18313,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33366ze3z83_18313,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33366ze3z83_18313,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33366ze3z83_18313;
															}
													}
												break;
											case ((long) -1):

												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33379ze3z83_18334;

																BgL_zc3anonymousza33379ze3z83_18334 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33379ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33379ze3z83_18334,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33379ze3z83_18334,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33379ze3z83_18334,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33379ze3z83_18334;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33387ze3z83_18331;

																BgL_zc3anonymousza33387ze3z83_18331 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33387ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33387ze3z83_18331,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33387ze3z83_18331,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33387ze3z83_18331,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33387ze3z83_18331,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33387ze3z83_18331;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33397ze3z83_18328;

																BgL_zc3anonymousza33397ze3z83_18328 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33397ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33397ze3z83_18328,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33397ze3z83_18328,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33397ze3z83_18328,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33397ze3z83_18328,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33397ze3z83_18328,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33397ze3z83_18328;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33405ze3z83_18325;

																BgL_zc3anonymousza33405ze3z83_18325 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33405ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33405ze3z83_18325,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33405ze3z83_18325,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33405ze3z83_18325,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33405ze3z83_18325,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33405ze3z83_18325,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33405ze3z83_18325,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33405ze3z83_18325;
															}
													}
												break;
											case ((long) 1):

												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33417ze3z83_18346;

																BgL_zc3anonymousza33417ze3z83_18346 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33417ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33417ze3z83_18346,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33417ze3z83_18346,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33417ze3z83_18346,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33417ze3z83_18346;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33424ze3z83_18343;

																BgL_zc3anonymousza33424ze3z83_18343 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33424ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33424ze3z83_18343,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33424ze3z83_18343,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33424ze3z83_18343,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33424ze3z83_18343,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33424ze3z83_18343;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33433ze3z83_18340;

																BgL_zc3anonymousza33433ze3z83_18340 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33433ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33433ze3z83_18340,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33433ze3z83_18340,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33433ze3z83_18340,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33433ze3z83_18340,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33433ze3z83_18340,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33433ze3z83_18340;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33441ze3z83_18337;

																BgL_zc3anonymousza33441ze3z83_18337 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33441ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33441ze3z83_18337,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33441ze3z83_18337,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33441ze3z83_18337,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33441ze3z83_18337,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33441ze3z83_18337,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33441ze3z83_18337,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33441ze3z83_18337;
															}
													}
												break;
											case ((long) -2):

												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33454ze3z83_18358;

																BgL_zc3anonymousza33454ze3z83_18358 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33454ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33454ze3z83_18358,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33454ze3z83_18358,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33454ze3z83_18358,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33454ze3z83_18358;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33464ze3z83_18355;

																BgL_zc3anonymousza33464ze3z83_18355 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33464ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33464ze3z83_18355,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33464ze3z83_18355,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33464ze3z83_18355,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33464ze3z83_18355,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33464ze3z83_18355;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33476ze3z83_18352;

																BgL_zc3anonymousza33476ze3z83_18352 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33476ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33476ze3z83_18352,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33476ze3z83_18352,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33476ze3z83_18352,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33476ze3z83_18352,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33476ze3z83_18352,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33476ze3z83_18352;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33487ze3z83_18349;

																BgL_zc3anonymousza33487ze3z83_18349 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33487ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33487ze3z83_18349,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33487ze3z83_18349,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33487ze3z83_18349,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33487ze3z83_18349,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33487ze3z83_18349,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33487ze3z83_18349,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33487ze3z83_18349;
															}
													}
												break;
											case ((long) 2):

												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33502ze3z83_18370;

																BgL_zc3anonymousza33502ze3z83_18370 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33502ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33502ze3z83_18370,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33502ze3z83_18370,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33502ze3z83_18370,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33502ze3z83_18370;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33511ze3z83_18367;

																BgL_zc3anonymousza33511ze3z83_18367 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33511ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33511ze3z83_18367,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33511ze3z83_18367,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33511ze3z83_18367,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33511ze3z83_18367,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33511ze3z83_18367;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33523ze3z83_18364;

																BgL_zc3anonymousza33523ze3z83_18364 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33523ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33523ze3z83_18364,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33523ze3z83_18364,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33523ze3z83_18364,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33523ze3z83_18364,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33523ze3z83_18364,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33523ze3z83_18364;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33533ze3z83_18361;

																BgL_zc3anonymousza33533ze3z83_18361 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33533ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33533ze3z83_18361,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33533ze3z83_18361,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33533ze3z83_18361,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33533ze3z83_18361,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33533ze3z83_18361,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33533ze3z83_18361,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33533ze3z83_18361;
															}
													}
												break;
											case ((long) -3):

												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33549ze3z83_18382;

																BgL_zc3anonymousza33549ze3z83_18382 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33549ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33549ze3z83_18382,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33549ze3z83_18382,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33549ze3z83_18382,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33549ze3z83_18382;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33560ze3z83_18379;

																BgL_zc3anonymousza33560ze3z83_18379 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33560ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33560ze3z83_18379,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33560ze3z83_18379,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33560ze3z83_18379,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33560ze3z83_18379,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33560ze3z83_18379;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33574ze3z83_18376;

																BgL_zc3anonymousza33574ze3z83_18376 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33574ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33574ze3z83_18376,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33574ze3z83_18376,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33574ze3z83_18376,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33574ze3z83_18376,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33574ze3z83_18376,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33574ze3z83_18376;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33585ze3z83_18373;

																BgL_zc3anonymousza33585ze3z83_18373 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33585ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33585ze3z83_18373,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33585ze3z83_18373,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33585ze3z83_18373,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33585ze3z83_18373,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33585ze3z83_18373,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33585ze3z83_18373,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33585ze3z83_18373;
															}
													}
												break;
											case ((long) 3):

												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33601ze3z83_18394;

																BgL_zc3anonymousza33601ze3z83_18394 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33601ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33601ze3z83_18394,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33601ze3z83_18394,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33601ze3z83_18394,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33601ze3z83_18394;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33611ze3z83_18391;

																BgL_zc3anonymousza33611ze3z83_18391 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33611ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33611ze3z83_18391,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33611ze3z83_18391,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33611ze3z83_18391,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33611ze3z83_18391,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33611ze3z83_18391;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33623ze3z83_18388;

																BgL_zc3anonymousza33623ze3z83_18388 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33623ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33623ze3z83_18388,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33623ze3z83_18388,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33623ze3z83_18388,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33623ze3z83_18388,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33623ze3z83_18388,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33623ze3z83_18388;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33633ze3z83_18385;

																BgL_zc3anonymousza33633ze3z83_18385 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33633ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33633ze3z83_18385,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33633ze3z83_18385,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33633ze3z83_18385,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33633ze3z83_18385,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33633ze3z83_18385,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33633ze3z83_18385,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33633ze3z83_18385;
															}
													}
												break;
											case ((long) -4):

												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33649ze3z83_18406;

																BgL_zc3anonymousza33649ze3z83_18406 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33649ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33649ze3z83_18406,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33649ze3z83_18406,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33649ze3z83_18406,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33649ze3z83_18406;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33661ze3z83_18403;

																BgL_zc3anonymousza33661ze3z83_18403 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33661ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33661ze3z83_18403,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33661ze3z83_18403,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33661ze3z83_18403,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33661ze3z83_18403,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33661ze3z83_18403;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33673ze3z83_18400;

																BgL_zc3anonymousza33673ze3z83_18400 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33673ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33673ze3z83_18400,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33673ze3z83_18400,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33673ze3z83_18400,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33673ze3z83_18400,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33673ze3z83_18400,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33673ze3z83_18400;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33684ze3z83_18397;

																BgL_zc3anonymousza33684ze3z83_18397 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33684ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33684ze3z83_18397,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33684ze3z83_18397,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33684ze3z83_18397,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33684ze3z83_18397,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33684ze3z83_18397,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33684ze3z83_18397,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33684ze3z83_18397;
															}
													}
												break;
											case ((long) 4):

												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33699ze3z83_18418;

																BgL_zc3anonymousza33699ze3z83_18418 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33699ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33699ze3z83_18418,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33699ze3z83_18418,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33699ze3z83_18418,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33699ze3z83_18418;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33709ze3z83_18415;

																BgL_zc3anonymousza33709ze3z83_18415 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33709ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33709ze3z83_18415,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33709ze3z83_18415,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33709ze3z83_18415,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33709ze3z83_18415,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33709ze3z83_18415;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33721ze3z83_18412;

																BgL_zc3anonymousza33721ze3z83_18412 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33721ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33721ze3z83_18412,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33721ze3z83_18412,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33721ze3z83_18412,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33721ze3z83_18412,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33721ze3z83_18412,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33721ze3z83_18412;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33732ze3z83_18409;

																BgL_zc3anonymousza33732ze3z83_18409 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33732ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33732ze3z83_18409,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33732ze3z83_18409,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33732ze3z83_18409,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33732ze3z83_18409,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33732ze3z83_18409,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33732ze3z83_18409,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33732ze3z83_18409;
															}
													}
												break;
											case ((long) -5):

												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33747ze3z83_18430;

																BgL_zc3anonymousza33747ze3z83_18430 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33747ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33747ze3z83_18430,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33747ze3z83_18430,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33747ze3z83_18430,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33747ze3z83_18430;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33758ze3z83_18427;

																BgL_zc3anonymousza33758ze3z83_18427 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33758ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33758ze3z83_18427,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33758ze3z83_18427,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33758ze3z83_18427,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33758ze3z83_18427,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33758ze3z83_18427;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33771ze3z83_18424;

																BgL_zc3anonymousza33771ze3z83_18424 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33771ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33771ze3z83_18424,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33771ze3z83_18424,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33771ze3z83_18424,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33771ze3z83_18424,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33771ze3z83_18424,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33771ze3z83_18424;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33783ze3z83_18421;

																BgL_zc3anonymousza33783ze3z83_18421 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33783ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33783ze3z83_18421,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33783ze3z83_18421,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33783ze3z83_18421,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33783ze3z83_18421,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33783ze3z83_18421,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33783ze3z83_18421,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33783ze3z83_18421;
															}
													}
												break;
											default:
											BgL_case_else1246z00_4235:
												if (
													((long) (VECTOR_LENGTH(BgL_ifreesz00_4229)) ==
														((long) 0)))
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33799ze3z83_18442;

																BgL_zc3anonymousza33799ze3z83_18442 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33799ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33799ze3z83_18442,
																	(int) (((long) 0)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33799ze3z83_18442,
																	(int) (((long) 1)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33799ze3z83_18442,
																	(int) (((long) 2)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33799ze3z83_18442;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33819ze3z83_18439;

																BgL_zc3anonymousza33819ze3z83_18439 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33819ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 4)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33819ze3z83_18439,
																	(int) (((long) 0)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33819ze3z83_18439,
																	(int) (((long) 1)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33819ze3z83_18439,
																	(int) (((long) 2)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33819ze3z83_18439,
																	(int) (((long) 3)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33819ze3z83_18439;
															}
													}
												else
													{	/* Eval/evaluate_comp.scm 1161 */
														if (
															((long) (VECTOR_LENGTH(BgL_iboxesz00_4230)) ==
																((long) 0)))
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33841ze3z83_18436;

																BgL_zc3anonymousza33841ze3z83_18436 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33841ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 5)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33841ze3z83_18436,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33841ze3z83_18436,
																	(int) (((long) 1)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33841ze3z83_18436,
																	(int) (((long) 2)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33841ze3z83_18436,
																	(int) (((long) 3)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33841ze3z83_18436,
																	(int) (((long) 4)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33841ze3z83_18436;
															}
														else
															{	/* Eval/evaluate_comp.scm 1161 */
																obj_t BgL_zc3anonymousza33862ze3z83_18433;

																BgL_zc3anonymousza33862ze3z83_18433 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza33862ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 6)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33862ze3z83_18433,
																	(int) (((long) 0)), BgL_ifreesz00_4229);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33862ze3z83_18433,
																	(int) (((long) 1)), BgL_iboxesz00_4230);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33862ze3z83_18433,
																	(int) (((long) 2)), BINT(BgL_siza7eza7_4231));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33862ze3z83_18433,
																	(int) (((long) 3)), ((obj_t) BgL_ez00_4224));
																PROCEDURE_SET
																	(BgL_zc3anonymousza33862ze3z83_18433,
																	(int) (((long) 4)), BgL_bodyz00_4234);
																PROCEDURE_SET
																	(BgL_zc3anonymousza33862ze3z83_18433,
																	(int) (((long) 5)),
																	BINT(BgL_siza7ezd2framez75_4232));
																return BgL_zc3anonymousza33862ze3z83_18433;
															}
													}
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										goto BgL_case_else1246z00_4235;
									}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3747> */
	obj_t BGl_z62zc3anonymousza33747ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18508, obj_t BgL_sz00_18512)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18509;
				obj_t BgL_bodyz00_18510;
				long BgL_siza7ezd2framez75_18511;

				BgL_i1245z00_18509 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18508, (int) (((long) 0))));
				BgL_bodyz00_18510 = PROCEDURE_REF(BgL_envz00_18508, (int) (((long) 1)));
				BgL_siza7ezd2framez75_18511 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18508, (int) (((long) 2))));
				{
					obj_t BgL_sz00_5426;

					BgL_sz00_5426 = BgL_sz00_18512;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5428;

						BgL_bpz00_5428 = VECTOR_REF(BgL_sz00_5426, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18428;

								BgL_runz00_18428 =
									MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18428,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_18509));
								PROCEDURE_SET(BgL_runz00_18428,
									(int) (((long) 1)), BgL_bodyz00_18510);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18429;

									BgL_mainz00_18429 =
										MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18429,
										(int) (((long) 0)), ((obj_t) BgL_i1245z00_18509));
									PROCEDURE_SET(BgL_mainz00_18429,
										(int) (((long) 1)), BgL_bodyz00_18510);
									PROCEDURE_SET(BgL_mainz00_18429,
										(int) (((long) 2)), BgL_runz00_18428);
									PROCEDURE_SET(BgL_mainz00_18429,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_18511));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_17021;

										BgL_objz00_17021 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18428, BgL_objz00_17021);
										BgL_objz00_17021;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3748z00_5431;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3749z00_5432;

											BgL_arg3749z00_5432 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18509))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_17023;

												BgL_framez00_17023 = BINT(BgL_siza7ezd2framez75_18511);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_17025;

													BgL_newz00_17025 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_27708;

														BgL_auxz00_27708 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_17025, BgL_auxz00_27708,
															BgL_arg3749z00_5432);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_27711;

														BgL_auxz00_27711 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_17025, BgL_auxz00_27711,
															BgL_framez00_17023);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_27714;

														BgL_auxz00_27714 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_17025, BgL_auxz00_27714,
															BgL_runz00_18428);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_27719;
														int BgL_auxz00_27717;

														BgL_auxz00_27719 = BINT(((long) -5));
														BgL_auxz00_27717 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_17025, BgL_auxz00_27717,
															BgL_auxz00_27719);
													}
													BgL_arg3748z00_5431 = BgL_newz00_17025;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18429, BgL_arg3748z00_5431);
										BgL_arg3748z00_5431;
									}
									return BgL_mainz00_18429;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main */
	obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_18513,
		obj_t BgL_az00_18518, obj_t BgL_bz00_18519, obj_t BgL_cz00_18520,
		obj_t BgL_dz00_18521, obj_t BgL_lastz00_18522)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18516;
				long BgL_siza7ezd2framez75_18517;

				BgL_runz00_18516 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18513, (int) (((long) 2))));
				BgL_siza7ezd2framez75_18517 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18513, (int) (((long) 3))));
				{
					obj_t BgL_az00_5433;
					obj_t BgL_bz00_5434;
					obj_t BgL_cz00_5435;
					obj_t BgL_dz00_5436;
					obj_t BgL_lastz00_5437;

					BgL_az00_5433 = BgL_az00_18518;
					BgL_bz00_5434 = BgL_bz00_18519;
					BgL_cz00_5435 = BgL_cz00_18520;
					BgL_dz00_5436 = BgL_dz00_18521;
					BgL_lastz00_5437 = BgL_lastz00_18522;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5439;

						BgL_sz00_5439 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5440;

							BgL_bpz00_5440 = VECTOR_REF(BgL_sz00_5439, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_27732;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_16932;

									BgL_nz00_16932 = BINT(BgL_siza7ezd2framez75_18517);
									BgL_testz00_27732 =
										(
										((long) CINT(BgL_bpz00_5440) +
											(long) CINT(BgL_nz00_16932)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5439)));
								}
								if (BgL_testz00_27732)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3752z00_5442;

											BgL_arg3752z00_5442 =
												((long) CINT(BgL_bpz00_5440) + ((long) 0));
											VECTOR_SET(BgL_sz00_5439,
												(int) (BgL_arg3752z00_5442), BgL_az00_5433);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3753z00_5443;

											BgL_arg3753z00_5443 =
												((long) CINT(BgL_bpz00_5440) + ((long) 1));
											VECTOR_SET(BgL_sz00_5439,
												(int) (BgL_arg3753z00_5443), BgL_bz00_5434);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3754z00_5444;

											BgL_arg3754z00_5444 =
												((long) CINT(BgL_bpz00_5440) + ((long) 2));
											VECTOR_SET(BgL_sz00_5439,
												(int) (BgL_arg3754z00_5444), BgL_cz00_5435);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3755z00_5445;

											BgL_arg3755z00_5445 =
												((long) CINT(BgL_bpz00_5440) + ((long) 3));
											VECTOR_SET(BgL_sz00_5439,
												(int) (BgL_arg3755z00_5445), BgL_dz00_5436);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3756z00_5446;

											BgL_arg3756z00_5446 =
												((long) CINT(BgL_bpz00_5440) + ((long) 4));
											VECTOR_SET(BgL_sz00_5439,
												(int) (BgL_arg3756z00_5446), BgL_lastz00_5437);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5447;

											BgL_ez00_5447 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5447, BgL_bpz00_5440);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5448;

												BgL_accz00_5448 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18516, BgL_sz00_5439, BgL_bpz00_5440);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5447);
												VECTOR_SET(BgL_sz00_5439, (int) (((long) 0)),
													BgL_bpz00_5440);
												return BgL_accz00_5448;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5449;

										BgL_nsz00_5449 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5449,
											(int) (((long) 1)), BgL_sz00_5439);
										VECTOR_SET(BgL_nsz00_5449,
											(int) (((long) 2)), BgL_az00_5433);
										VECTOR_SET(BgL_nsz00_5449,
											(int) (((long) 3)), BgL_bz00_5434);
										VECTOR_SET(BgL_nsz00_5449,
											(int) (((long) 4)), BgL_cz00_5435);
										VECTOR_SET(BgL_nsz00_5449,
											(int) (((long) 5)), BgL_dz00_5436);
										VECTOR_SET(BgL_nsz00_5449,
											(int) (((long) 6)), BgL_lastz00_5437);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5450;

											BgL_z12denvz12_5450 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5450, BgL_nsz00_5449);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5451;

												BgL_ez00_5451 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5451, BgL_sz00_5439);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5452;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_16996;

														BgL_savedzd2bpzd2_16996 =
															VECTOR_REF(BgL_nsz00_5449, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5449,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_17003;

															BgL_fz00_17003 = BgL_runz00_18516;
														BgL_recz00_17002:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_17004;

																BgL_rz00_17004 =
																	PROCEDURE_ENTRY(BgL_fz00_17003)
																	(BgL_fz00_17003, BgL_nsz00_5449, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_27792;

																	if (PROCEDUREP(BgL_rz00_17004))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_17009;

																			BgL_arg1673z00_17009 =
																				PROCEDURE_ATTR(BgL_rz00_17004);
																			if (STRUCTP(BgL_arg1673z00_17009))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_27792 =
																						(STRUCT_KEY(BgL_arg1673z00_17009) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_27792 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_27792 = ((bool_t) 0);
																		}
																	if (BgL_testz00_27792)
																		{
																			obj_t BgL_fz00_27800;

																			BgL_fz00_27800 = BgL_rz00_17004;
																			BgL_fz00_17003 = BgL_fz00_27800;
																			goto BgL_recz00_17002;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5449,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_16996);
																			BgL_____rz00_5452 = BgL_rz00_17004;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5451);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5450,
														BgL_sz00_5439);
													return BgL_____rz00_5452;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run */
	obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_18523,
		obj_t BgL_sz00_18526)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18524;
				obj_t BgL_bodyz00_18525;

				BgL_i1245z00_18524 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18523, (int) (((long) 0))));
				BgL_bodyz00_18525 = PROCEDURE_REF(BgL_envz00_18523, (int) (((long) 1)));
				{
					obj_t BgL_sz00_5454;

					BgL_sz00_5454 = BgL_sz00_18526;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5456;

						BgL_bpz00_5456 = VECTOR_REF(BgL_sz00_5454, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_5457;
							obj_t BgL_wherez00_5458;
							obj_t BgL_locz00_5459;

							BgL_z12denvz12_5457 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5458 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18524))->BgL_wherez00);
							BgL_locz00_5459 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18524))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5457, BgL_wherez00_5458,
									BgL_locz00_5459);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_5460;

									BgL_za2za2resza2za2z00_5460 =
										PROCEDURE_ENTRY(BgL_bodyz00_18525) (BgL_bodyz00_18525,
										BgL_sz00_5454, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5457);
									return BgL_za2za2resza2za2z00_5460;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3758> */
	obj_t BGl_z62zc3anonymousza33758ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18527, obj_t BgL_sz00_18532)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18528;
				BgL_ev_absz00_bglt BgL_i1245z00_18529;
				obj_t BgL_bodyz00_18530;
				long BgL_siza7ezd2framez75_18531;

				BgL_iboxesz00_18528 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18527, (int) (((long) 0))));
				BgL_i1245z00_18529 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18527, (int) (((long) 1))));
				BgL_bodyz00_18530 = PROCEDURE_REF(BgL_envz00_18527, (int) (((long) 2)));
				BgL_siza7ezd2framez75_18531 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18527, (int) (((long) 3))));
				{
					obj_t BgL_sz00_5462;

					BgL_sz00_5462 = BgL_sz00_18532;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5464;

						BgL_bpz00_5464 = VECTOR_REF(BgL_sz00_5462, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18425;

								BgL_runz00_18425 =
									MAKE_FX_PROCEDURE(BGl_z62run5498z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18425,
									(int) (((long) 0)), BgL_iboxesz00_18528);
								PROCEDURE_SET(BgL_runz00_18425,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_18529));
								PROCEDURE_SET(BgL_runz00_18425,
									(int) (((long) 2)), BgL_bodyz00_18530);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18426;

									BgL_mainz00_18426 =
										MAKE_VA_PROCEDURE(BGl_z62main5497z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18426,
										(int) (((long) 0)), BgL_iboxesz00_18528);
									PROCEDURE_SET(BgL_mainz00_18426,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_18529));
									PROCEDURE_SET(BgL_mainz00_18426,
										(int) (((long) 2)), BgL_bodyz00_18530);
									PROCEDURE_SET(BgL_mainz00_18426,
										(int) (((long) 3)), BgL_runz00_18425);
									PROCEDURE_SET(BgL_mainz00_18426,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_18531));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_17143;

										BgL_objz00_17143 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18425, BgL_objz00_17143);
										BgL_objz00_17143;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3759z00_5467;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3760z00_5468;

											BgL_arg3760z00_5468 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18529))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_17145;

												BgL_framez00_17145 = BINT(BgL_siza7ezd2framez75_18531);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_17147;

													BgL_newz00_17147 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_27864;

														BgL_auxz00_27864 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_17147, BgL_auxz00_27864,
															BgL_arg3760z00_5468);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_27867;

														BgL_auxz00_27867 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_17147, BgL_auxz00_27867,
															BgL_framez00_17145);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_27870;

														BgL_auxz00_27870 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_17147, BgL_auxz00_27870,
															BgL_runz00_18425);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_27875;
														int BgL_auxz00_27873;

														BgL_auxz00_27875 = BINT(((long) -5));
														BgL_auxz00_27873 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_17147, BgL_auxz00_27873,
															BgL_auxz00_27875);
													}
													BgL_arg3759z00_5467 = BgL_newz00_17147;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18426, BgL_arg3759z00_5467);
										BgL_arg3759z00_5467;
									}
									return BgL_mainz00_18426;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5497 */
	obj_t BGl_z62main5497z62zz__evaluate_compz00(obj_t BgL_envz00_18533,
		obj_t BgL_az00_18539, obj_t BgL_bz00_18540, obj_t BgL_cz00_18541,
		obj_t BgL_dz00_18542, obj_t BgL_lastz00_18543)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18537;
				long BgL_siza7ezd2framez75_18538;

				BgL_runz00_18537 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18533, (int) (((long) 3))));
				BgL_siza7ezd2framez75_18538 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18533, (int) (((long) 4))));
				{
					obj_t BgL_az00_5469;
					obj_t BgL_bz00_5470;
					obj_t BgL_cz00_5471;
					obj_t BgL_dz00_5472;
					obj_t BgL_lastz00_5473;

					BgL_az00_5469 = BgL_az00_18539;
					BgL_bz00_5470 = BgL_bz00_18540;
					BgL_cz00_5471 = BgL_cz00_18541;
					BgL_dz00_5472 = BgL_dz00_18542;
					BgL_lastz00_5473 = BgL_lastz00_18543;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5475;

						BgL_sz00_5475 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5476;

							BgL_bpz00_5476 = VECTOR_REF(BgL_sz00_5475, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_27888;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_17054;

									BgL_nz00_17054 = BINT(BgL_siza7ezd2framez75_18538);
									BgL_testz00_27888 =
										(
										((long) CINT(BgL_bpz00_5476) +
											(long) CINT(BgL_nz00_17054)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5475)));
								}
								if (BgL_testz00_27888)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3763z00_5478;

											BgL_arg3763z00_5478 =
												((long) CINT(BgL_bpz00_5476) + ((long) 0));
											VECTOR_SET(BgL_sz00_5475,
												(int) (BgL_arg3763z00_5478), BgL_az00_5469);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3764z00_5479;

											BgL_arg3764z00_5479 =
												((long) CINT(BgL_bpz00_5476) + ((long) 1));
											VECTOR_SET(BgL_sz00_5475,
												(int) (BgL_arg3764z00_5479), BgL_bz00_5470);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3765z00_5480;

											BgL_arg3765z00_5480 =
												((long) CINT(BgL_bpz00_5476) + ((long) 2));
											VECTOR_SET(BgL_sz00_5475,
												(int) (BgL_arg3765z00_5480), BgL_cz00_5471);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3766z00_5481;

											BgL_arg3766z00_5481 =
												((long) CINT(BgL_bpz00_5476) + ((long) 3));
											VECTOR_SET(BgL_sz00_5475,
												(int) (BgL_arg3766z00_5481), BgL_dz00_5472);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3767z00_5482;

											BgL_arg3767z00_5482 =
												((long) CINT(BgL_bpz00_5476) + ((long) 4));
											VECTOR_SET(BgL_sz00_5475,
												(int) (BgL_arg3767z00_5482), BgL_lastz00_5473);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5483;

											BgL_ez00_5483 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5483, BgL_bpz00_5476);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5484;

												BgL_accz00_5484 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18537, BgL_sz00_5475, BgL_bpz00_5476);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5483);
												VECTOR_SET(BgL_sz00_5475, (int) (((long) 0)),
													BgL_bpz00_5476);
												return BgL_accz00_5484;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5485;

										BgL_nsz00_5485 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5485,
											(int) (((long) 1)), BgL_sz00_5475);
										VECTOR_SET(BgL_nsz00_5485,
											(int) (((long) 2)), BgL_az00_5469);
										VECTOR_SET(BgL_nsz00_5485,
											(int) (((long) 3)), BgL_bz00_5470);
										VECTOR_SET(BgL_nsz00_5485,
											(int) (((long) 4)), BgL_cz00_5471);
										VECTOR_SET(BgL_nsz00_5485,
											(int) (((long) 5)), BgL_dz00_5472);
										VECTOR_SET(BgL_nsz00_5485,
											(int) (((long) 6)), BgL_lastz00_5473);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5486;

											BgL_z12denvz12_5486 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5486, BgL_nsz00_5485);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5487;

												BgL_ez00_5487 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5487, BgL_sz00_5475);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5488;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_17118;

														BgL_savedzd2bpzd2_17118 =
															VECTOR_REF(BgL_nsz00_5485, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5485,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_17125;

															BgL_fz00_17125 = BgL_runz00_18537;
														BgL_recz00_17124:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_17126;

																BgL_rz00_17126 =
																	PROCEDURE_ENTRY(BgL_fz00_17125)
																	(BgL_fz00_17125, BgL_nsz00_5485, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_27948;

																	if (PROCEDUREP(BgL_rz00_17126))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_17131;

																			BgL_arg1673z00_17131 =
																				PROCEDURE_ATTR(BgL_rz00_17126);
																			if (STRUCTP(BgL_arg1673z00_17131))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_27948 =
																						(STRUCT_KEY(BgL_arg1673z00_17131) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_27948 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_27948 = ((bool_t) 0);
																		}
																	if (BgL_testz00_27948)
																		{
																			obj_t BgL_fz00_27956;

																			BgL_fz00_27956 = BgL_rz00_17126;
																			BgL_fz00_17125 = BgL_fz00_27956;
																			goto BgL_recz00_17124;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5485,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_17118);
																			BgL_____rz00_5488 = BgL_rz00_17126;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5487);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5486,
														BgL_sz00_5475);
													return BgL_____rz00_5488;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5498 */
	obj_t BGl_z62run5498z62zz__evaluate_compz00(obj_t BgL_envz00_18544,
		obj_t BgL_sz00_18548)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18545;
				BgL_ev_absz00_bglt BgL_i1245z00_18546;
				obj_t BgL_bodyz00_18547;

				BgL_iboxesz00_18545 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18544, (int) (((long) 0))));
				BgL_i1245z00_18546 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18544, (int) (((long) 1))));
				BgL_bodyz00_18547 = PROCEDURE_REF(BgL_envz00_18544, (int) (((long) 2)));
				{
					obj_t BgL_sz00_5490;

					BgL_sz00_5490 = BgL_sz00_18548;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5492;

						BgL_bpz00_5492 = VECTOR_REF(BgL_sz00_5490, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5490,
							BgL_iboxesz00_18545, BgL_bpz00_5492);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_5493;
							obj_t BgL_wherez00_5494;
							obj_t BgL_locz00_5495;

							BgL_z12denvz12_5493 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5494 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18546))->BgL_wherez00);
							BgL_locz00_5495 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18546))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5493, BgL_wherez00_5494,
									BgL_locz00_5495);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_5496;

									BgL_za2za2resza2za2z00_5496 =
										PROCEDURE_ENTRY(BgL_bodyz00_18547) (BgL_bodyz00_18547,
										BgL_sz00_5490, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5493);
									return BgL_za2za2resza2za2z00_5496;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3771> */
	obj_t BGl_z62zc3anonymousza33771ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18549, obj_t BgL_sz00_18555)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18550;
				long BgL_siza7eza7_18551;
				BgL_ev_absz00_bglt BgL_i1245z00_18552;
				obj_t BgL_bodyz00_18553;
				long BgL_siza7ezd2framez75_18554;

				BgL_ifreesz00_18550 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18549, (int) (((long) 0))));
				BgL_siza7eza7_18551 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18549, (int) (((long) 1))));
				BgL_i1245z00_18552 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18549, (int) (((long) 2))));
				BgL_bodyz00_18553 = PROCEDURE_REF(BgL_envz00_18549, (int) (((long) 3)));
				BgL_siza7ezd2framez75_18554 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18549, (int) (((long) 4))));
				{
					obj_t BgL_sz00_5500;

					BgL_sz00_5500 = BgL_sz00_18555;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5502;

						BgL_bpz00_5502 = VECTOR_REF(BgL_sz00_5500, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_5503;

							BgL_valza2za2_5503 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5500,
								BgL_bpz00_5502, BgL_ifreesz00_18550);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18422;

								BgL_runz00_18422 =
									MAKE_FX_PROCEDURE(BGl_z62run5500z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18422,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18551));
								PROCEDURE_SET(BgL_runz00_18422,
									(int) (((long) 1)), BgL_valza2za2_5503);
								PROCEDURE_SET(BgL_runz00_18422,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_18552));
								PROCEDURE_SET(BgL_runz00_18422,
									(int) (((long) 3)), BgL_bodyz00_18553);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18423;

									BgL_mainz00_18423 =
										MAKE_VA_PROCEDURE(BGl_z62main5499z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18423,
										(int) (((long) 0)), BINT(BgL_siza7eza7_18551));
									PROCEDURE_SET(BgL_mainz00_18423,
										(int) (((long) 1)), BgL_valza2za2_5503);
									PROCEDURE_SET(BgL_mainz00_18423,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_18552));
									PROCEDURE_SET(BgL_mainz00_18423,
										(int) (((long) 3)), BgL_bodyz00_18553);
									PROCEDURE_SET(BgL_mainz00_18423,
										(int) (((long) 4)), BgL_runz00_18422);
									PROCEDURE_SET(BgL_mainz00_18423,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_18554));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_17272;

										BgL_objz00_17272 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18422, BgL_objz00_17272);
										BgL_objz00_17272;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3772z00_5506;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3773z00_5507;

											BgL_arg3773z00_5507 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18552))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_17274;

												BgL_framez00_17274 = BINT(BgL_siza7ezd2framez75_18554);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_17276;

													BgL_newz00_17276 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28034;

														BgL_auxz00_28034 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_17276, BgL_auxz00_28034,
															BgL_arg3773z00_5507);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28037;

														BgL_auxz00_28037 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_17276, BgL_auxz00_28037,
															BgL_framez00_17274);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28040;

														BgL_auxz00_28040 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_17276, BgL_auxz00_28040,
															BgL_runz00_18422);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_28045;
														int BgL_auxz00_28043;

														BgL_auxz00_28045 = BINT(((long) -5));
														BgL_auxz00_28043 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_17276, BgL_auxz00_28043,
															BgL_auxz00_28045);
													}
													BgL_arg3772z00_5506 = BgL_newz00_17276;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18423, BgL_arg3772z00_5506);
										BgL_arg3772z00_5506;
									}
									return BgL_mainz00_18423;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5499 */
	obj_t BGl_z62main5499z62zz__evaluate_compz00(obj_t BgL_envz00_18556,
		obj_t BgL_az00_18563, obj_t BgL_bz00_18564, obj_t BgL_cz00_18565,
		obj_t BgL_dz00_18566, obj_t BgL_lastz00_18567)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18561;
				long BgL_siza7ezd2framez75_18562;

				BgL_runz00_18561 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18556, (int) (((long) 4))));
				BgL_siza7ezd2framez75_18562 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18556, (int) (((long) 5))));
				{
					obj_t BgL_az00_5508;
					obj_t BgL_bz00_5509;
					obj_t BgL_cz00_5510;
					obj_t BgL_dz00_5511;
					obj_t BgL_lastz00_5512;

					BgL_az00_5508 = BgL_az00_18563;
					BgL_bz00_5509 = BgL_bz00_18564;
					BgL_cz00_5510 = BgL_cz00_18565;
					BgL_dz00_5511 = BgL_dz00_18566;
					BgL_lastz00_5512 = BgL_lastz00_18567;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5514;

						BgL_sz00_5514 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5515;

							BgL_bpz00_5515 = VECTOR_REF(BgL_sz00_5514, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_28058;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_17183;

									BgL_nz00_17183 = BINT(BgL_siza7ezd2framez75_18562);
									BgL_testz00_28058 =
										(
										((long) CINT(BgL_bpz00_5515) +
											(long) CINT(BgL_nz00_17183)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5514)));
								}
								if (BgL_testz00_28058)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3776z00_5517;

											BgL_arg3776z00_5517 =
												((long) CINT(BgL_bpz00_5515) + ((long) 0));
											VECTOR_SET(BgL_sz00_5514,
												(int) (BgL_arg3776z00_5517), BgL_az00_5508);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3777z00_5518;

											BgL_arg3777z00_5518 =
												((long) CINT(BgL_bpz00_5515) + ((long) 1));
											VECTOR_SET(BgL_sz00_5514,
												(int) (BgL_arg3777z00_5518), BgL_bz00_5509);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3778z00_5519;

											BgL_arg3778z00_5519 =
												((long) CINT(BgL_bpz00_5515) + ((long) 2));
											VECTOR_SET(BgL_sz00_5514,
												(int) (BgL_arg3778z00_5519), BgL_cz00_5510);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3779z00_5520;

											BgL_arg3779z00_5520 =
												((long) CINT(BgL_bpz00_5515) + ((long) 3));
											VECTOR_SET(BgL_sz00_5514,
												(int) (BgL_arg3779z00_5520), BgL_dz00_5511);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3780z00_5521;

											BgL_arg3780z00_5521 =
												((long) CINT(BgL_bpz00_5515) + ((long) 4));
											VECTOR_SET(BgL_sz00_5514,
												(int) (BgL_arg3780z00_5521), BgL_lastz00_5512);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5522;

											BgL_ez00_5522 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5522, BgL_bpz00_5515);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5523;

												BgL_accz00_5523 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18561, BgL_sz00_5514, BgL_bpz00_5515);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5522);
												VECTOR_SET(BgL_sz00_5514, (int) (((long) 0)),
													BgL_bpz00_5515);
												return BgL_accz00_5523;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5524;

										BgL_nsz00_5524 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5524,
											(int) (((long) 1)), BgL_sz00_5514);
										VECTOR_SET(BgL_nsz00_5524,
											(int) (((long) 2)), BgL_az00_5508);
										VECTOR_SET(BgL_nsz00_5524,
											(int) (((long) 3)), BgL_bz00_5509);
										VECTOR_SET(BgL_nsz00_5524,
											(int) (((long) 4)), BgL_cz00_5510);
										VECTOR_SET(BgL_nsz00_5524,
											(int) (((long) 5)), BgL_dz00_5511);
										VECTOR_SET(BgL_nsz00_5524,
											(int) (((long) 6)), BgL_lastz00_5512);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5525;

											BgL_z12denvz12_5525 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5525, BgL_nsz00_5524);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5526;

												BgL_ez00_5526 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5526, BgL_sz00_5514);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5527;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_17247;

														BgL_savedzd2bpzd2_17247 =
															VECTOR_REF(BgL_nsz00_5524, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5524,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_17254;

															BgL_fz00_17254 = BgL_runz00_18561;
														BgL_recz00_17253:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_17255;

																BgL_rz00_17255 =
																	PROCEDURE_ENTRY(BgL_fz00_17254)
																	(BgL_fz00_17254, BgL_nsz00_5524, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_28118;

																	if (PROCEDUREP(BgL_rz00_17255))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_17260;

																			BgL_arg1673z00_17260 =
																				PROCEDURE_ATTR(BgL_rz00_17255);
																			if (STRUCTP(BgL_arg1673z00_17260))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28118 =
																						(STRUCT_KEY(BgL_arg1673z00_17260) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28118 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_28118 = ((bool_t) 0);
																		}
																	if (BgL_testz00_28118)
																		{
																			obj_t BgL_fz00_28126;

																			BgL_fz00_28126 = BgL_rz00_17255;
																			BgL_fz00_17254 = BgL_fz00_28126;
																			goto BgL_recz00_17253;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5524,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_17247);
																			BgL_____rz00_5527 = BgL_rz00_17255;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5526);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5525,
														BgL_sz00_5514);
													return BgL_____rz00_5527;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5500 */
	obj_t BGl_z62run5500z62zz__evaluate_compz00(obj_t BgL_envz00_18568,
		obj_t BgL_sz00_18573)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_18569;
				obj_t BgL_valza2za2_18570;
				BgL_ev_absz00_bglt BgL_i1245z00_18571;
				obj_t BgL_bodyz00_18572;

				BgL_siza7eza7_18569 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18568, (int) (((long) 0))));
				BgL_valza2za2_18570 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18568, (int) (((long) 1))));
				BgL_i1245z00_18571 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18568, (int) (((long) 2))));
				BgL_bodyz00_18572 = PROCEDURE_REF(BgL_envz00_18568, (int) (((long) 3)));
				{
					obj_t BgL_sz00_5529;

					BgL_sz00_5529 = BgL_sz00_18573;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5531;

						BgL_bpz00_5531 = VECTOR_REF(BgL_sz00_5529, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5529,
							BgL_valza2za2_18570,
							((long) CINT(BgL_bpz00_5531) + BgL_siza7eza7_18569));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_5533;
							obj_t BgL_wherez00_5534;
							obj_t BgL_locz00_5535;

							BgL_z12denvz12_5533 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5534 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18571))->BgL_wherez00);
							BgL_locz00_5535 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18571))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5533, BgL_wherez00_5534,
									BgL_locz00_5535);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_5536;

									BgL_za2za2resza2za2z00_5536 =
										PROCEDURE_ENTRY(BgL_bodyz00_18572) (BgL_bodyz00_18572,
										BgL_sz00_5529, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5533);
									return BgL_za2za2resza2za2z00_5536;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3783> */
	obj_t BGl_z62zc3anonymousza33783ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18574, obj_t BgL_sz00_18581)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18575;
				obj_t BgL_iboxesz00_18576;
				long BgL_siza7eza7_18577;
				BgL_ev_absz00_bglt BgL_i1245z00_18578;
				obj_t BgL_bodyz00_18579;
				long BgL_siza7ezd2framez75_18580;

				BgL_ifreesz00_18575 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18574, (int) (((long) 0))));
				BgL_iboxesz00_18576 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18574, (int) (((long) 1))));
				BgL_siza7eza7_18577 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18574, (int) (((long) 2))));
				BgL_i1245z00_18578 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18574, (int) (((long) 3))));
				BgL_bodyz00_18579 = PROCEDURE_REF(BgL_envz00_18574, (int) (((long) 4)));
				BgL_siza7ezd2framez75_18580 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18574, (int) (((long) 5))));
				{
					obj_t BgL_sz00_5538;

					BgL_sz00_5538 = BgL_sz00_18581;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5540;

						BgL_bpz00_5540 = VECTOR_REF(BgL_sz00_5538, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_5541;

							BgL_valza2za2_5541 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5538,
								BgL_bpz00_5540, BgL_ifreesz00_18575);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18419;

								BgL_runz00_18419 =
									MAKE_FX_PROCEDURE(BGl_z62run5502z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18419,
									(int) (((long) 0)), BgL_iboxesz00_18576);
								PROCEDURE_SET(BgL_runz00_18419,
									(int) (((long) 1)), BINT(BgL_siza7eza7_18577));
								PROCEDURE_SET(BgL_runz00_18419,
									(int) (((long) 2)), BgL_valza2za2_5541);
								PROCEDURE_SET(BgL_runz00_18419,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_18578));
								PROCEDURE_SET(BgL_runz00_18419,
									(int) (((long) 4)), BgL_bodyz00_18579);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18420;

									BgL_mainz00_18420 =
										MAKE_VA_PROCEDURE(BGl_z62main5501z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18420,
										(int) (((long) 0)), BgL_iboxesz00_18576);
									PROCEDURE_SET(BgL_mainz00_18420,
										(int) (((long) 1)), BINT(BgL_siza7eza7_18577));
									PROCEDURE_SET(BgL_mainz00_18420,
										(int) (((long) 2)), BgL_valza2za2_5541);
									PROCEDURE_SET(BgL_mainz00_18420,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_18578));
									PROCEDURE_SET(BgL_mainz00_18420,
										(int) (((long) 4)), BgL_bodyz00_18579);
									PROCEDURE_SET(BgL_mainz00_18420,
										(int) (((long) 5)), BgL_runz00_18419);
									PROCEDURE_SET(BgL_mainz00_18420,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_18580));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_17397;

										BgL_objz00_17397 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18419, BgL_objz00_17397);
										BgL_objz00_17397;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3784z00_5544;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3785z00_5545;

											BgL_arg3785z00_5545 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18578))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_17399;

												BgL_framez00_17399 = BINT(BgL_siza7ezd2framez75_18580);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_17401;

													BgL_newz00_17401 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28216;

														BgL_auxz00_28216 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_17401, BgL_auxz00_28216,
															BgL_arg3785z00_5545);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28219;

														BgL_auxz00_28219 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_17401, BgL_auxz00_28219,
															BgL_framez00_17399);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28222;

														BgL_auxz00_28222 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_17401, BgL_auxz00_28222,
															BgL_runz00_18419);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_28227;
														int BgL_auxz00_28225;

														BgL_auxz00_28227 = BINT(((long) -5));
														BgL_auxz00_28225 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_17401, BgL_auxz00_28225,
															BgL_auxz00_28227);
													}
													BgL_arg3784z00_5544 = BgL_newz00_17401;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18420, BgL_arg3784z00_5544);
										BgL_arg3784z00_5544;
									}
									return BgL_mainz00_18420;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5501 */
	obj_t BGl_z62main5501z62zz__evaluate_compz00(obj_t BgL_envz00_18582,
		obj_t BgL_az00_18590, obj_t BgL_bz00_18591, obj_t BgL_cz00_18592,
		obj_t BgL_dz00_18593, obj_t BgL_lastz00_18594)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18588;
				long BgL_siza7ezd2framez75_18589;

				BgL_runz00_18588 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18582, (int) (((long) 5))));
				BgL_siza7ezd2framez75_18589 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18582, (int) (((long) 6))));
				{
					obj_t BgL_az00_5546;
					obj_t BgL_bz00_5547;
					obj_t BgL_cz00_5548;
					obj_t BgL_dz00_5549;
					obj_t BgL_lastz00_5550;

					BgL_az00_5546 = BgL_az00_18590;
					BgL_bz00_5547 = BgL_bz00_18591;
					BgL_cz00_5548 = BgL_cz00_18592;
					BgL_dz00_5549 = BgL_dz00_18593;
					BgL_lastz00_5550 = BgL_lastz00_18594;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5552;

						BgL_sz00_5552 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5553;

							BgL_bpz00_5553 = VECTOR_REF(BgL_sz00_5552, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_28240;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_17308;

									BgL_nz00_17308 = BINT(BgL_siza7ezd2framez75_18589);
									BgL_testz00_28240 =
										(
										((long) CINT(BgL_bpz00_5553) +
											(long) CINT(BgL_nz00_17308)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5552)));
								}
								if (BgL_testz00_28240)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3788z00_5555;

											BgL_arg3788z00_5555 =
												((long) CINT(BgL_bpz00_5553) + ((long) 0));
											VECTOR_SET(BgL_sz00_5552,
												(int) (BgL_arg3788z00_5555), BgL_az00_5546);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3789z00_5556;

											BgL_arg3789z00_5556 =
												((long) CINT(BgL_bpz00_5553) + ((long) 1));
											VECTOR_SET(BgL_sz00_5552,
												(int) (BgL_arg3789z00_5556), BgL_bz00_5547);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3790z00_5557;

											BgL_arg3790z00_5557 =
												((long) CINT(BgL_bpz00_5553) + ((long) 2));
											VECTOR_SET(BgL_sz00_5552,
												(int) (BgL_arg3790z00_5557), BgL_cz00_5548);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3791z00_5558;

											BgL_arg3791z00_5558 =
												((long) CINT(BgL_bpz00_5553) + ((long) 3));
											VECTOR_SET(BgL_sz00_5552,
												(int) (BgL_arg3791z00_5558), BgL_dz00_5549);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3792z00_5559;

											BgL_arg3792z00_5559 =
												((long) CINT(BgL_bpz00_5553) + ((long) 4));
											VECTOR_SET(BgL_sz00_5552,
												(int) (BgL_arg3792z00_5559), BgL_lastz00_5550);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5560;

											BgL_ez00_5560 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5560, BgL_bpz00_5553);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5561;

												BgL_accz00_5561 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18588, BgL_sz00_5552, BgL_bpz00_5553);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5560);
												VECTOR_SET(BgL_sz00_5552, (int) (((long) 0)),
													BgL_bpz00_5553);
												return BgL_accz00_5561;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5562;

										BgL_nsz00_5562 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5562,
											(int) (((long) 1)), BgL_sz00_5552);
										VECTOR_SET(BgL_nsz00_5562,
											(int) (((long) 2)), BgL_az00_5546);
										VECTOR_SET(BgL_nsz00_5562,
											(int) (((long) 3)), BgL_bz00_5547);
										VECTOR_SET(BgL_nsz00_5562,
											(int) (((long) 4)), BgL_cz00_5548);
										VECTOR_SET(BgL_nsz00_5562,
											(int) (((long) 5)), BgL_dz00_5549);
										VECTOR_SET(BgL_nsz00_5562,
											(int) (((long) 6)), BgL_lastz00_5550);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5563;

											BgL_z12denvz12_5563 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5563, BgL_nsz00_5562);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5564;

												BgL_ez00_5564 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5564, BgL_sz00_5552);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5565;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_17372;

														BgL_savedzd2bpzd2_17372 =
															VECTOR_REF(BgL_nsz00_5562, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5562,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_17379;

															BgL_fz00_17379 = BgL_runz00_18588;
														BgL_recz00_17378:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_17380;

																BgL_rz00_17380 =
																	PROCEDURE_ENTRY(BgL_fz00_17379)
																	(BgL_fz00_17379, BgL_nsz00_5562, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_28300;

																	if (PROCEDUREP(BgL_rz00_17380))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_17385;

																			BgL_arg1673z00_17385 =
																				PROCEDURE_ATTR(BgL_rz00_17380);
																			if (STRUCTP(BgL_arg1673z00_17385))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28300 =
																						(STRUCT_KEY(BgL_arg1673z00_17385) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28300 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_28300 = ((bool_t) 0);
																		}
																	if (BgL_testz00_28300)
																		{
																			obj_t BgL_fz00_28308;

																			BgL_fz00_28308 = BgL_rz00_17380;
																			BgL_fz00_17379 = BgL_fz00_28308;
																			goto BgL_recz00_17378;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5562,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_17372);
																			BgL_____rz00_5565 = BgL_rz00_17380;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5564);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5563,
														BgL_sz00_5552);
													return BgL_____rz00_5565;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5502 */
	obj_t BGl_z62run5502z62zz__evaluate_compz00(obj_t BgL_envz00_18595,
		obj_t BgL_sz00_18601)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18596;
				long BgL_siza7eza7_18597;
				obj_t BgL_valza2za2_18598;
				BgL_ev_absz00_bglt BgL_i1245z00_18599;
				obj_t BgL_bodyz00_18600;

				BgL_iboxesz00_18596 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18595, (int) (((long) 0))));
				BgL_siza7eza7_18597 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18595, (int) (((long) 1))));
				BgL_valza2za2_18598 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18595, (int) (((long) 2))));
				BgL_i1245z00_18599 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18595, (int) (((long) 3))));
				BgL_bodyz00_18600 = PROCEDURE_REF(BgL_envz00_18595, (int) (((long) 4)));
				{
					obj_t BgL_sz00_5567;

					BgL_sz00_5567 = BgL_sz00_18601;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5569;

						BgL_bpz00_5569 = VECTOR_REF(BgL_sz00_5567, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5567,
							BgL_iboxesz00_18596, BgL_bpz00_5569);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5567,
							BgL_valza2za2_18598,
							((long) CINT(BgL_bpz00_5569) + BgL_siza7eza7_18597));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_5571;
							obj_t BgL_wherez00_5572;
							obj_t BgL_locz00_5573;

							BgL_z12denvz12_5571 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5572 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18599))->BgL_wherez00);
							BgL_locz00_5573 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18599))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5571, BgL_wherez00_5572,
									BgL_locz00_5573);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_5574;

									BgL_za2za2resza2za2z00_5574 =
										PROCEDURE_ENTRY(BgL_bodyz00_18600) (BgL_bodyz00_18600,
										BgL_sz00_5567, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5571);
									return BgL_za2za2resza2za2z00_5574;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3699> */
	obj_t BGl_z62zc3anonymousza33699ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18602, obj_t BgL_sz00_18606)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18603;
				obj_t BgL_bodyz00_18604;
				long BgL_siza7ezd2framez75_18605;

				BgL_i1245z00_18603 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18602, (int) (((long) 0))));
				BgL_bodyz00_18604 = PROCEDURE_REF(BgL_envz00_18602, (int) (((long) 1)));
				BgL_siza7ezd2framez75_18605 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18602, (int) (((long) 2))));
				{
					obj_t BgL_sz00_5280;

					BgL_sz00_5280 = BgL_sz00_18606;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5282;

						BgL_bpz00_5282 = VECTOR_REF(BgL_sz00_5280, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18416;

								BgL_runz00_18416 =
									MAKE_FX_PROCEDURE(BGl_z62run5504z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18416,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_18603));
								PROCEDURE_SET(BgL_runz00_18416,
									(int) (((long) 1)), BgL_bodyz00_18604);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18417;

									BgL_mainz00_18417 =
										MAKE_FX_PROCEDURE(BGl_z62main5503z62zz__evaluate_compz00,
										(int) (((long) 4)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18417,
										(int) (((long) 0)), ((obj_t) BgL_i1245z00_18603));
									PROCEDURE_SET(BgL_mainz00_18417,
										(int) (((long) 1)), BgL_bodyz00_18604);
									PROCEDURE_SET(BgL_mainz00_18417,
										(int) (((long) 2)), BgL_runz00_18416);
									PROCEDURE_SET(BgL_mainz00_18417,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_18605));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_16542;

										BgL_objz00_16542 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18416, BgL_objz00_16542);
										BgL_objz00_16542;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3700z00_5285;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3701z00_5286;

											BgL_arg3701z00_5286 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18603))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_16544;

												BgL_framez00_16544 = BINT(BgL_siza7ezd2framez75_18605);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_16546;

													BgL_newz00_16546 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28378;

														BgL_auxz00_28378 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_16546, BgL_auxz00_28378,
															BgL_arg3701z00_5286);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28381;

														BgL_auxz00_28381 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_16546, BgL_auxz00_28381,
															BgL_framez00_16544);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28384;

														BgL_auxz00_28384 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_16546, BgL_auxz00_28384,
															BgL_runz00_18416);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_28389;
														int BgL_auxz00_28387;

														BgL_auxz00_28389 = BINT(((long) 4));
														BgL_auxz00_28387 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_16546, BgL_auxz00_28387,
															BgL_auxz00_28389);
													}
													BgL_arg3700z00_5285 = BgL_newz00_16546;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18417, BgL_arg3700z00_5285);
										BgL_arg3700z00_5285;
									}
									return BgL_mainz00_18417;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5503 */
	obj_t BGl_z62main5503z62zz__evaluate_compz00(obj_t BgL_envz00_18607,
		obj_t BgL_az00_18612, obj_t BgL_bz00_18613, obj_t BgL_cz00_18614,
		obj_t BgL_dz00_18615)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18610;
				long BgL_siza7ezd2framez75_18611;

				BgL_runz00_18610 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18607, (int) (((long) 2))));
				BgL_siza7ezd2framez75_18611 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18607, (int) (((long) 3))));
				{
					obj_t BgL_az00_5287;
					obj_t BgL_bz00_5288;
					obj_t BgL_cz00_5289;
					obj_t BgL_dz00_5290;

					BgL_az00_5287 = BgL_az00_18612;
					BgL_bz00_5288 = BgL_bz00_18613;
					BgL_cz00_5289 = BgL_cz00_18614;
					BgL_dz00_5290 = BgL_dz00_18615;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5292;

						BgL_sz00_5292 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5293;

							BgL_bpz00_5293 = VECTOR_REF(BgL_sz00_5292, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_28402;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_16462;

									BgL_nz00_16462 = BINT(BgL_siza7ezd2framez75_18611);
									BgL_testz00_28402 =
										(
										((long) CINT(BgL_bpz00_5293) +
											(long) CINT(BgL_nz00_16462)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5292)));
								}
								if (BgL_testz00_28402)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3704z00_5295;

											BgL_arg3704z00_5295 =
												((long) CINT(BgL_bpz00_5293) + ((long) 0));
											VECTOR_SET(BgL_sz00_5292,
												(int) (BgL_arg3704z00_5295), BgL_az00_5287);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3705z00_5296;

											BgL_arg3705z00_5296 =
												((long) CINT(BgL_bpz00_5293) + ((long) 1));
											VECTOR_SET(BgL_sz00_5292,
												(int) (BgL_arg3705z00_5296), BgL_bz00_5288);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3706z00_5297;

											BgL_arg3706z00_5297 =
												((long) CINT(BgL_bpz00_5293) + ((long) 2));
											VECTOR_SET(BgL_sz00_5292,
												(int) (BgL_arg3706z00_5297), BgL_cz00_5289);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3707z00_5298;

											BgL_arg3707z00_5298 =
												((long) CINT(BgL_bpz00_5293) + ((long) 3));
											VECTOR_SET(BgL_sz00_5292,
												(int) (BgL_arg3707z00_5298), BgL_dz00_5290);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5299;

											BgL_ez00_5299 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5299, BgL_bpz00_5293);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5300;

												BgL_accz00_5300 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18610, BgL_sz00_5292, BgL_bpz00_5293);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5299);
												VECTOR_SET(BgL_sz00_5292, (int) (((long) 0)),
													BgL_bpz00_5293);
												return BgL_accz00_5300;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5301;

										BgL_nsz00_5301 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5301,
											(int) (((long) 1)), BgL_sz00_5292);
										VECTOR_SET(BgL_nsz00_5301,
											(int) (((long) 2)), BgL_az00_5287);
										VECTOR_SET(BgL_nsz00_5301,
											(int) (((long) 3)), BgL_bz00_5288);
										VECTOR_SET(BgL_nsz00_5301,
											(int) (((long) 4)), BgL_cz00_5289);
										VECTOR_SET(BgL_nsz00_5301,
											(int) (((long) 5)), BgL_dz00_5290);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5302;

											BgL_z12denvz12_5302 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5302, BgL_nsz00_5301);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5303;

												BgL_ez00_5303 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5303, BgL_sz00_5292);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5304;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_16517;

														BgL_savedzd2bpzd2_16517 =
															VECTOR_REF(BgL_nsz00_5301, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5301,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_16524;

															BgL_fz00_16524 = BgL_runz00_18610;
														BgL_recz00_16523:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_16525;

																BgL_rz00_16525 =
																	PROCEDURE_ENTRY(BgL_fz00_16524)
																	(BgL_fz00_16524, BgL_nsz00_5301, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_28456;

																	if (PROCEDUREP(BgL_rz00_16525))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_16530;

																			BgL_arg1673z00_16530 =
																				PROCEDURE_ATTR(BgL_rz00_16525);
																			if (STRUCTP(BgL_arg1673z00_16530))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28456 =
																						(STRUCT_KEY(BgL_arg1673z00_16530) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28456 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_28456 = ((bool_t) 0);
																		}
																	if (BgL_testz00_28456)
																		{
																			obj_t BgL_fz00_28464;

																			BgL_fz00_28464 = BgL_rz00_16525;
																			BgL_fz00_16524 = BgL_fz00_28464;
																			goto BgL_recz00_16523;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5301,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_16517);
																			BgL_____rz00_5304 = BgL_rz00_16525;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5303);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5302,
														BgL_sz00_5292);
													return BgL_____rz00_5304;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5504 */
	obj_t BGl_z62run5504z62zz__evaluate_compz00(obj_t BgL_envz00_18616,
		obj_t BgL_sz00_18619)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18617;
				obj_t BgL_bodyz00_18618;

				BgL_i1245z00_18617 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18616, (int) (((long) 0))));
				BgL_bodyz00_18618 = PROCEDURE_REF(BgL_envz00_18616, (int) (((long) 1)));
				{
					obj_t BgL_sz00_5306;

					BgL_sz00_5306 = BgL_sz00_18619;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5308;

						BgL_bpz00_5308 = VECTOR_REF(BgL_sz00_5306, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_5309;
							obj_t BgL_wherez00_5310;
							obj_t BgL_locz00_5311;

							BgL_z12denvz12_5309 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5310 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18617))->BgL_wherez00);
							BgL_locz00_5311 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18617))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5309, BgL_wherez00_5310,
									BgL_locz00_5311);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_5312;

									BgL_za2za2resza2za2z00_5312 =
										PROCEDURE_ENTRY(BgL_bodyz00_18618) (BgL_bodyz00_18618,
										BgL_sz00_5306, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5309);
									return BgL_za2za2resza2za2z00_5312;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3709> */
	obj_t BGl_z62zc3anonymousza33709ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18620, obj_t BgL_sz00_18625)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18621;
				BgL_ev_absz00_bglt BgL_i1245z00_18622;
				obj_t BgL_bodyz00_18623;
				long BgL_siza7ezd2framez75_18624;

				BgL_iboxesz00_18621 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18620, (int) (((long) 0))));
				BgL_i1245z00_18622 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18620, (int) (((long) 1))));
				BgL_bodyz00_18623 = PROCEDURE_REF(BgL_envz00_18620, (int) (((long) 2)));
				BgL_siza7ezd2framez75_18624 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18620, (int) (((long) 3))));
				{
					obj_t BgL_sz00_5314;

					BgL_sz00_5314 = BgL_sz00_18625;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5316;

						BgL_bpz00_5316 = VECTOR_REF(BgL_sz00_5314, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18413;

								BgL_runz00_18413 =
									MAKE_FX_PROCEDURE(BGl_z62run5506z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18413,
									(int) (((long) 0)), BgL_iboxesz00_18621);
								PROCEDURE_SET(BgL_runz00_18413,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_18622));
								PROCEDURE_SET(BgL_runz00_18413,
									(int) (((long) 2)), BgL_bodyz00_18623);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18414;

									BgL_mainz00_18414 =
										MAKE_FX_PROCEDURE(BGl_z62main5505z62zz__evaluate_compz00,
										(int) (((long) 4)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18414,
										(int) (((long) 0)), BgL_iboxesz00_18621);
									PROCEDURE_SET(BgL_mainz00_18414,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_18622));
									PROCEDURE_SET(BgL_mainz00_18414,
										(int) (((long) 2)), BgL_bodyz00_18623);
									PROCEDURE_SET(BgL_mainz00_18414,
										(int) (((long) 3)), BgL_runz00_18413);
									PROCEDURE_SET(BgL_mainz00_18414,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_18624));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_16655;

										BgL_objz00_16655 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18413, BgL_objz00_16655);
										BgL_objz00_16655;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3710z00_5319;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3711z00_5320;

											BgL_arg3711z00_5320 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18622))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_16657;

												BgL_framez00_16657 = BINT(BgL_siza7ezd2framez75_18624);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_16659;

													BgL_newz00_16659 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28528;

														BgL_auxz00_28528 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_16659, BgL_auxz00_28528,
															BgL_arg3711z00_5320);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28531;

														BgL_auxz00_28531 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_16659, BgL_auxz00_28531,
															BgL_framez00_16657);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28534;

														BgL_auxz00_28534 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_16659, BgL_auxz00_28534,
															BgL_runz00_18413);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_28539;
														int BgL_auxz00_28537;

														BgL_auxz00_28539 = BINT(((long) 4));
														BgL_auxz00_28537 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_16659, BgL_auxz00_28537,
															BgL_auxz00_28539);
													}
													BgL_arg3710z00_5319 = BgL_newz00_16659;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18414, BgL_arg3710z00_5319);
										BgL_arg3710z00_5319;
									}
									return BgL_mainz00_18414;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5505 */
	obj_t BGl_z62main5505z62zz__evaluate_compz00(obj_t BgL_envz00_18626,
		obj_t BgL_az00_18632, obj_t BgL_bz00_18633, obj_t BgL_cz00_18634,
		obj_t BgL_dz00_18635)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18630;
				long BgL_siza7ezd2framez75_18631;

				BgL_runz00_18630 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18626, (int) (((long) 3))));
				BgL_siza7ezd2framez75_18631 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18626, (int) (((long) 4))));
				{
					obj_t BgL_az00_5321;
					obj_t BgL_bz00_5322;
					obj_t BgL_cz00_5323;
					obj_t BgL_dz00_5324;

					BgL_az00_5321 = BgL_az00_18632;
					BgL_bz00_5322 = BgL_bz00_18633;
					BgL_cz00_5323 = BgL_cz00_18634;
					BgL_dz00_5324 = BgL_dz00_18635;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5326;

						BgL_sz00_5326 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5327;

							BgL_bpz00_5327 = VECTOR_REF(BgL_sz00_5326, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_28552;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_16575;

									BgL_nz00_16575 = BINT(BgL_siza7ezd2framez75_18631);
									BgL_testz00_28552 =
										(
										((long) CINT(BgL_bpz00_5327) +
											(long) CINT(BgL_nz00_16575)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5326)));
								}
								if (BgL_testz00_28552)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3714z00_5329;

											BgL_arg3714z00_5329 =
												((long) CINT(BgL_bpz00_5327) + ((long) 0));
											VECTOR_SET(BgL_sz00_5326,
												(int) (BgL_arg3714z00_5329), BgL_az00_5321);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3715z00_5330;

											BgL_arg3715z00_5330 =
												((long) CINT(BgL_bpz00_5327) + ((long) 1));
											VECTOR_SET(BgL_sz00_5326,
												(int) (BgL_arg3715z00_5330), BgL_bz00_5322);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3716z00_5331;

											BgL_arg3716z00_5331 =
												((long) CINT(BgL_bpz00_5327) + ((long) 2));
											VECTOR_SET(BgL_sz00_5326,
												(int) (BgL_arg3716z00_5331), BgL_cz00_5323);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3717z00_5332;

											BgL_arg3717z00_5332 =
												((long) CINT(BgL_bpz00_5327) + ((long) 3));
											VECTOR_SET(BgL_sz00_5326,
												(int) (BgL_arg3717z00_5332), BgL_dz00_5324);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5333;

											BgL_ez00_5333 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5333, BgL_bpz00_5327);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5334;

												BgL_accz00_5334 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18630, BgL_sz00_5326, BgL_bpz00_5327);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5333);
												VECTOR_SET(BgL_sz00_5326, (int) (((long) 0)),
													BgL_bpz00_5327);
												return BgL_accz00_5334;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5335;

										BgL_nsz00_5335 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5335,
											(int) (((long) 1)), BgL_sz00_5326);
										VECTOR_SET(BgL_nsz00_5335,
											(int) (((long) 2)), BgL_az00_5321);
										VECTOR_SET(BgL_nsz00_5335,
											(int) (((long) 3)), BgL_bz00_5322);
										VECTOR_SET(BgL_nsz00_5335,
											(int) (((long) 4)), BgL_cz00_5323);
										VECTOR_SET(BgL_nsz00_5335,
											(int) (((long) 5)), BgL_dz00_5324);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5336;

											BgL_z12denvz12_5336 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5336, BgL_nsz00_5335);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5337;

												BgL_ez00_5337 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5337, BgL_sz00_5326);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5338;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_16630;

														BgL_savedzd2bpzd2_16630 =
															VECTOR_REF(BgL_nsz00_5335, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5335,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_16637;

															BgL_fz00_16637 = BgL_runz00_18630;
														BgL_recz00_16636:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_16638;

																BgL_rz00_16638 =
																	PROCEDURE_ENTRY(BgL_fz00_16637)
																	(BgL_fz00_16637, BgL_nsz00_5335, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_28606;

																	if (PROCEDUREP(BgL_rz00_16638))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_16643;

																			BgL_arg1673z00_16643 =
																				PROCEDURE_ATTR(BgL_rz00_16638);
																			if (STRUCTP(BgL_arg1673z00_16643))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28606 =
																						(STRUCT_KEY(BgL_arg1673z00_16643) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28606 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_28606 = ((bool_t) 0);
																		}
																	if (BgL_testz00_28606)
																		{
																			obj_t BgL_fz00_28614;

																			BgL_fz00_28614 = BgL_rz00_16638;
																			BgL_fz00_16637 = BgL_fz00_28614;
																			goto BgL_recz00_16636;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5335,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_16630);
																			BgL_____rz00_5338 = BgL_rz00_16638;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5337);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5336,
														BgL_sz00_5326);
													return BgL_____rz00_5338;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5506 */
	obj_t BGl_z62run5506z62zz__evaluate_compz00(obj_t BgL_envz00_18636,
		obj_t BgL_sz00_18640)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18637;
				BgL_ev_absz00_bglt BgL_i1245z00_18638;
				obj_t BgL_bodyz00_18639;

				BgL_iboxesz00_18637 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18636, (int) (((long) 0))));
				BgL_i1245z00_18638 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18636, (int) (((long) 1))));
				BgL_bodyz00_18639 = PROCEDURE_REF(BgL_envz00_18636, (int) (((long) 2)));
				{
					obj_t BgL_sz00_5340;

					BgL_sz00_5340 = BgL_sz00_18640;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5342;

						BgL_bpz00_5342 = VECTOR_REF(BgL_sz00_5340, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5340,
							BgL_iboxesz00_18637, BgL_bpz00_5342);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_5343;
							obj_t BgL_wherez00_5344;
							obj_t BgL_locz00_5345;

							BgL_z12denvz12_5343 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5344 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18638))->BgL_wherez00);
							BgL_locz00_5345 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18638))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5343, BgL_wherez00_5344,
									BgL_locz00_5345);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_5346;

									BgL_za2za2resza2za2z00_5346 =
										PROCEDURE_ENTRY(BgL_bodyz00_18639) (BgL_bodyz00_18639,
										BgL_sz00_5340, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5343);
									return BgL_za2za2resza2za2z00_5346;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3721> */
	obj_t BGl_z62zc3anonymousza33721ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18641, obj_t BgL_sz00_18647)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18642;
				long BgL_siza7eza7_18643;
				BgL_ev_absz00_bglt BgL_i1245z00_18644;
				obj_t BgL_bodyz00_18645;
				long BgL_siza7ezd2framez75_18646;

				BgL_ifreesz00_18642 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18641, (int) (((long) 0))));
				BgL_siza7eza7_18643 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18641, (int) (((long) 1))));
				BgL_i1245z00_18644 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18641, (int) (((long) 2))));
				BgL_bodyz00_18645 = PROCEDURE_REF(BgL_envz00_18641, (int) (((long) 3)));
				BgL_siza7ezd2framez75_18646 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18641, (int) (((long) 4))));
				{
					obj_t BgL_sz00_5350;

					BgL_sz00_5350 = BgL_sz00_18647;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5352;

						BgL_bpz00_5352 = VECTOR_REF(BgL_sz00_5350, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_5353;

							BgL_valza2za2_5353 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5350,
								BgL_bpz00_5352, BgL_ifreesz00_18642);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18410;

								BgL_runz00_18410 =
									MAKE_FX_PROCEDURE(BGl_z62run5508z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18410,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18643));
								PROCEDURE_SET(BgL_runz00_18410,
									(int) (((long) 1)), BgL_valza2za2_5353);
								PROCEDURE_SET(BgL_runz00_18410,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_18644));
								PROCEDURE_SET(BgL_runz00_18410,
									(int) (((long) 3)), BgL_bodyz00_18645);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18411;

									BgL_mainz00_18411 =
										MAKE_FX_PROCEDURE(BGl_z62main5507z62zz__evaluate_compz00,
										(int) (((long) 4)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18411,
										(int) (((long) 0)), BINT(BgL_siza7eza7_18643));
									PROCEDURE_SET(BgL_mainz00_18411,
										(int) (((long) 1)), BgL_valza2za2_5353);
									PROCEDURE_SET(BgL_mainz00_18411,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_18644));
									PROCEDURE_SET(BgL_mainz00_18411,
										(int) (((long) 3)), BgL_bodyz00_18645);
									PROCEDURE_SET(BgL_mainz00_18411,
										(int) (((long) 4)), BgL_runz00_18410);
									PROCEDURE_SET(BgL_mainz00_18411,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_18646));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_16775;

										BgL_objz00_16775 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18410, BgL_objz00_16775);
										BgL_objz00_16775;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3722z00_5356;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3723z00_5357;

											BgL_arg3723z00_5357 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18644))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_16777;

												BgL_framez00_16777 = BINT(BgL_siza7ezd2framez75_18646);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_16779;

													BgL_newz00_16779 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28692;

														BgL_auxz00_28692 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_16779, BgL_auxz00_28692,
															BgL_arg3723z00_5357);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28695;

														BgL_auxz00_28695 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_16779, BgL_auxz00_28695,
															BgL_framez00_16777);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28698;

														BgL_auxz00_28698 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_16779, BgL_auxz00_28698,
															BgL_runz00_18410);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_28703;
														int BgL_auxz00_28701;

														BgL_auxz00_28703 = BINT(((long) 4));
														BgL_auxz00_28701 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_16779, BgL_auxz00_28701,
															BgL_auxz00_28703);
													}
													BgL_arg3722z00_5356 = BgL_newz00_16779;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18411, BgL_arg3722z00_5356);
										BgL_arg3722z00_5356;
									}
									return BgL_mainz00_18411;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5507 */
	obj_t BGl_z62main5507z62zz__evaluate_compz00(obj_t BgL_envz00_18648,
		obj_t BgL_az00_18655, obj_t BgL_bz00_18656, obj_t BgL_cz00_18657,
		obj_t BgL_dz00_18658)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18653;
				long BgL_siza7ezd2framez75_18654;

				BgL_runz00_18653 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18648, (int) (((long) 4))));
				BgL_siza7ezd2framez75_18654 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18648, (int) (((long) 5))));
				{
					obj_t BgL_az00_5358;
					obj_t BgL_bz00_5359;
					obj_t BgL_cz00_5360;
					obj_t BgL_dz00_5361;

					BgL_az00_5358 = BgL_az00_18655;
					BgL_bz00_5359 = BgL_bz00_18656;
					BgL_cz00_5360 = BgL_cz00_18657;
					BgL_dz00_5361 = BgL_dz00_18658;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5363;

						BgL_sz00_5363 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5364;

							BgL_bpz00_5364 = VECTOR_REF(BgL_sz00_5363, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_28716;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_16695;

									BgL_nz00_16695 = BINT(BgL_siza7ezd2framez75_18654);
									BgL_testz00_28716 =
										(
										((long) CINT(BgL_bpz00_5364) +
											(long) CINT(BgL_nz00_16695)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5363)));
								}
								if (BgL_testz00_28716)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3726z00_5366;

											BgL_arg3726z00_5366 =
												((long) CINT(BgL_bpz00_5364) + ((long) 0));
											VECTOR_SET(BgL_sz00_5363,
												(int) (BgL_arg3726z00_5366), BgL_az00_5358);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3727z00_5367;

											BgL_arg3727z00_5367 =
												((long) CINT(BgL_bpz00_5364) + ((long) 1));
											VECTOR_SET(BgL_sz00_5363,
												(int) (BgL_arg3727z00_5367), BgL_bz00_5359);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3728z00_5368;

											BgL_arg3728z00_5368 =
												((long) CINT(BgL_bpz00_5364) + ((long) 2));
											VECTOR_SET(BgL_sz00_5363,
												(int) (BgL_arg3728z00_5368), BgL_cz00_5360);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3729z00_5369;

											BgL_arg3729z00_5369 =
												((long) CINT(BgL_bpz00_5364) + ((long) 3));
											VECTOR_SET(BgL_sz00_5363,
												(int) (BgL_arg3729z00_5369), BgL_dz00_5361);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5370;

											BgL_ez00_5370 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5370, BgL_bpz00_5364);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5371;

												BgL_accz00_5371 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18653, BgL_sz00_5363, BgL_bpz00_5364);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5370);
												VECTOR_SET(BgL_sz00_5363, (int) (((long) 0)),
													BgL_bpz00_5364);
												return BgL_accz00_5371;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5372;

										BgL_nsz00_5372 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5372,
											(int) (((long) 1)), BgL_sz00_5363);
										VECTOR_SET(BgL_nsz00_5372,
											(int) (((long) 2)), BgL_az00_5358);
										VECTOR_SET(BgL_nsz00_5372,
											(int) (((long) 3)), BgL_bz00_5359);
										VECTOR_SET(BgL_nsz00_5372,
											(int) (((long) 4)), BgL_cz00_5360);
										VECTOR_SET(BgL_nsz00_5372,
											(int) (((long) 5)), BgL_dz00_5361);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5373;

											BgL_z12denvz12_5373 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5373, BgL_nsz00_5372);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5374;

												BgL_ez00_5374 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5374, BgL_sz00_5363);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5375;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_16750;

														BgL_savedzd2bpzd2_16750 =
															VECTOR_REF(BgL_nsz00_5372, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5372,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_16757;

															BgL_fz00_16757 = BgL_runz00_18653;
														BgL_recz00_16756:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_16758;

																BgL_rz00_16758 =
																	PROCEDURE_ENTRY(BgL_fz00_16757)
																	(BgL_fz00_16757, BgL_nsz00_5372, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_28770;

																	if (PROCEDUREP(BgL_rz00_16758))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_16763;

																			BgL_arg1673z00_16763 =
																				PROCEDURE_ATTR(BgL_rz00_16758);
																			if (STRUCTP(BgL_arg1673z00_16763))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28770 =
																						(STRUCT_KEY(BgL_arg1673z00_16763) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28770 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_28770 = ((bool_t) 0);
																		}
																	if (BgL_testz00_28770)
																		{
																			obj_t BgL_fz00_28778;

																			BgL_fz00_28778 = BgL_rz00_16758;
																			BgL_fz00_16757 = BgL_fz00_28778;
																			goto BgL_recz00_16756;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5372,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_16750);
																			BgL_____rz00_5375 = BgL_rz00_16758;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5374);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5373,
														BgL_sz00_5363);
													return BgL_____rz00_5375;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5508 */
	obj_t BGl_z62run5508z62zz__evaluate_compz00(obj_t BgL_envz00_18659,
		obj_t BgL_sz00_18664)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_18660;
				obj_t BgL_valza2za2_18661;
				BgL_ev_absz00_bglt BgL_i1245z00_18662;
				obj_t BgL_bodyz00_18663;

				BgL_siza7eza7_18660 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18659, (int) (((long) 0))));
				BgL_valza2za2_18661 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18659, (int) (((long) 1))));
				BgL_i1245z00_18662 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18659, (int) (((long) 2))));
				BgL_bodyz00_18663 = PROCEDURE_REF(BgL_envz00_18659, (int) (((long) 3)));
				{
					obj_t BgL_sz00_5377;

					BgL_sz00_5377 = BgL_sz00_18664;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5379;

						BgL_bpz00_5379 = VECTOR_REF(BgL_sz00_5377, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5377,
							BgL_valza2za2_18661,
							((long) CINT(BgL_bpz00_5379) + BgL_siza7eza7_18660));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_5381;
							obj_t BgL_wherez00_5382;
							obj_t BgL_locz00_5383;

							BgL_z12denvz12_5381 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5382 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18662))->BgL_wherez00);
							BgL_locz00_5383 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18662))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5381, BgL_wherez00_5382,
									BgL_locz00_5383);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_5384;

									BgL_za2za2resza2za2z00_5384 =
										PROCEDURE_ENTRY(BgL_bodyz00_18663) (BgL_bodyz00_18663,
										BgL_sz00_5377, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5381);
									return BgL_za2za2resza2za2z00_5384;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3732> */
	obj_t BGl_z62zc3anonymousza33732ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18665, obj_t BgL_sz00_18672)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18666;
				obj_t BgL_iboxesz00_18667;
				long BgL_siza7eza7_18668;
				BgL_ev_absz00_bglt BgL_i1245z00_18669;
				obj_t BgL_bodyz00_18670;
				long BgL_siza7ezd2framez75_18671;

				BgL_ifreesz00_18666 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18665, (int) (((long) 0))));
				BgL_iboxesz00_18667 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18665, (int) (((long) 1))));
				BgL_siza7eza7_18668 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18665, (int) (((long) 2))));
				BgL_i1245z00_18669 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18665, (int) (((long) 3))));
				BgL_bodyz00_18670 = PROCEDURE_REF(BgL_envz00_18665, (int) (((long) 4)));
				BgL_siza7ezd2framez75_18671 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18665, (int) (((long) 5))));
				{
					obj_t BgL_sz00_5386;

					BgL_sz00_5386 = BgL_sz00_18672;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5388;

						BgL_bpz00_5388 = VECTOR_REF(BgL_sz00_5386, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_5389;

							BgL_valza2za2_5389 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5386,
								BgL_bpz00_5388, BgL_ifreesz00_18666);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18407;

								BgL_runz00_18407 =
									MAKE_FX_PROCEDURE(BGl_z62run5510z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18407,
									(int) (((long) 0)), BgL_iboxesz00_18667);
								PROCEDURE_SET(BgL_runz00_18407,
									(int) (((long) 1)), BINT(BgL_siza7eza7_18668));
								PROCEDURE_SET(BgL_runz00_18407,
									(int) (((long) 2)), BgL_valza2za2_5389);
								PROCEDURE_SET(BgL_runz00_18407,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_18669));
								PROCEDURE_SET(BgL_runz00_18407,
									(int) (((long) 4)), BgL_bodyz00_18670);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18408;

									BgL_mainz00_18408 =
										MAKE_FX_PROCEDURE(BGl_z62main5509z62zz__evaluate_compz00,
										(int) (((long) 4)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18408,
										(int) (((long) 0)), BgL_iboxesz00_18667);
									PROCEDURE_SET(BgL_mainz00_18408,
										(int) (((long) 1)), BINT(BgL_siza7eza7_18668));
									PROCEDURE_SET(BgL_mainz00_18408,
										(int) (((long) 2)), BgL_valza2za2_5389);
									PROCEDURE_SET(BgL_mainz00_18408,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_18669));
									PROCEDURE_SET(BgL_mainz00_18408,
										(int) (((long) 4)), BgL_bodyz00_18670);
									PROCEDURE_SET(BgL_mainz00_18408,
										(int) (((long) 5)), BgL_runz00_18407);
									PROCEDURE_SET(BgL_mainz00_18408,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_18671));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_16891;

										BgL_objz00_16891 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18407, BgL_objz00_16891);
										BgL_objz00_16891;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3733z00_5392;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3734z00_5393;

											BgL_arg3734z00_5393 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18669))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_16893;

												BgL_framez00_16893 = BINT(BgL_siza7ezd2framez75_18671);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_16895;

													BgL_newz00_16895 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28868;

														BgL_auxz00_28868 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_16895, BgL_auxz00_28868,
															BgL_arg3734z00_5393);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28871;

														BgL_auxz00_28871 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_16895, BgL_auxz00_28871,
															BgL_framez00_16893);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_28874;

														BgL_auxz00_28874 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_16895, BgL_auxz00_28874,
															BgL_runz00_18407);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_28879;
														int BgL_auxz00_28877;

														BgL_auxz00_28879 = BINT(((long) 4));
														BgL_auxz00_28877 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_16895, BgL_auxz00_28877,
															BgL_auxz00_28879);
													}
													BgL_arg3733z00_5392 = BgL_newz00_16895;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18408, BgL_arg3733z00_5392);
										BgL_arg3733z00_5392;
									}
									return BgL_mainz00_18408;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5509 */
	obj_t BGl_z62main5509z62zz__evaluate_compz00(obj_t BgL_envz00_18673,
		obj_t BgL_az00_18681, obj_t BgL_bz00_18682, obj_t BgL_cz00_18683,
		obj_t BgL_dz00_18684)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18679;
				long BgL_siza7ezd2framez75_18680;

				BgL_runz00_18679 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18673, (int) (((long) 5))));
				BgL_siza7ezd2framez75_18680 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18673, (int) (((long) 6))));
				{
					obj_t BgL_az00_5394;
					obj_t BgL_bz00_5395;
					obj_t BgL_cz00_5396;
					obj_t BgL_dz00_5397;

					BgL_az00_5394 = BgL_az00_18681;
					BgL_bz00_5395 = BgL_bz00_18682;
					BgL_cz00_5396 = BgL_cz00_18683;
					BgL_dz00_5397 = BgL_dz00_18684;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5399;

						BgL_sz00_5399 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5400;

							BgL_bpz00_5400 = VECTOR_REF(BgL_sz00_5399, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_28892;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_16811;

									BgL_nz00_16811 = BINT(BgL_siza7ezd2framez75_18680);
									BgL_testz00_28892 =
										(
										((long) CINT(BgL_bpz00_5400) +
											(long) CINT(BgL_nz00_16811)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5399)));
								}
								if (BgL_testz00_28892)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3737z00_5402;

											BgL_arg3737z00_5402 =
												((long) CINT(BgL_bpz00_5400) + ((long) 0));
											VECTOR_SET(BgL_sz00_5399,
												(int) (BgL_arg3737z00_5402), BgL_az00_5394);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3738z00_5403;

											BgL_arg3738z00_5403 =
												((long) CINT(BgL_bpz00_5400) + ((long) 1));
											VECTOR_SET(BgL_sz00_5399,
												(int) (BgL_arg3738z00_5403), BgL_bz00_5395);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3739z00_5404;

											BgL_arg3739z00_5404 =
												((long) CINT(BgL_bpz00_5400) + ((long) 2));
											VECTOR_SET(BgL_sz00_5399,
												(int) (BgL_arg3739z00_5404), BgL_cz00_5396);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3740z00_5405;

											BgL_arg3740z00_5405 =
												((long) CINT(BgL_bpz00_5400) + ((long) 3));
											VECTOR_SET(BgL_sz00_5399,
												(int) (BgL_arg3740z00_5405), BgL_dz00_5397);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5406;

											BgL_ez00_5406 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5406, BgL_bpz00_5400);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5407;

												BgL_accz00_5407 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18679, BgL_sz00_5399, BgL_bpz00_5400);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5406);
												VECTOR_SET(BgL_sz00_5399, (int) (((long) 0)),
													BgL_bpz00_5400);
												return BgL_accz00_5407;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5408;

										BgL_nsz00_5408 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5408,
											(int) (((long) 1)), BgL_sz00_5399);
										VECTOR_SET(BgL_nsz00_5408,
											(int) (((long) 2)), BgL_az00_5394);
										VECTOR_SET(BgL_nsz00_5408,
											(int) (((long) 3)), BgL_bz00_5395);
										VECTOR_SET(BgL_nsz00_5408,
											(int) (((long) 4)), BgL_cz00_5396);
										VECTOR_SET(BgL_nsz00_5408,
											(int) (((long) 5)), BgL_dz00_5397);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5409;

											BgL_z12denvz12_5409 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5409, BgL_nsz00_5408);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5410;

												BgL_ez00_5410 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5410, BgL_sz00_5399);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5411;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_16866;

														BgL_savedzd2bpzd2_16866 =
															VECTOR_REF(BgL_nsz00_5408, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5408,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_16873;

															BgL_fz00_16873 = BgL_runz00_18679;
														BgL_recz00_16872:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_16874;

																BgL_rz00_16874 =
																	PROCEDURE_ENTRY(BgL_fz00_16873)
																	(BgL_fz00_16873, BgL_nsz00_5408, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_28946;

																	if (PROCEDUREP(BgL_rz00_16874))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_16879;

																			BgL_arg1673z00_16879 =
																				PROCEDURE_ATTR(BgL_rz00_16874);
																			if (STRUCTP(BgL_arg1673z00_16879))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28946 =
																						(STRUCT_KEY(BgL_arg1673z00_16879) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_28946 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_28946 = ((bool_t) 0);
																		}
																	if (BgL_testz00_28946)
																		{
																			obj_t BgL_fz00_28954;

																			BgL_fz00_28954 = BgL_rz00_16874;
																			BgL_fz00_16873 = BgL_fz00_28954;
																			goto BgL_recz00_16872;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5408,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_16866);
																			BgL_____rz00_5411 = BgL_rz00_16874;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5410);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5409,
														BgL_sz00_5399);
													return BgL_____rz00_5411;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5510 */
	obj_t BGl_z62run5510z62zz__evaluate_compz00(obj_t BgL_envz00_18685,
		obj_t BgL_sz00_18691)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18686;
				long BgL_siza7eza7_18687;
				obj_t BgL_valza2za2_18688;
				BgL_ev_absz00_bglt BgL_i1245z00_18689;
				obj_t BgL_bodyz00_18690;

				BgL_iboxesz00_18686 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18685, (int) (((long) 0))));
				BgL_siza7eza7_18687 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18685, (int) (((long) 1))));
				BgL_valza2za2_18688 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18685, (int) (((long) 2))));
				BgL_i1245z00_18689 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18685, (int) (((long) 3))));
				BgL_bodyz00_18690 = PROCEDURE_REF(BgL_envz00_18685, (int) (((long) 4)));
				{
					obj_t BgL_sz00_5413;

					BgL_sz00_5413 = BgL_sz00_18691;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5415;

						BgL_bpz00_5415 = VECTOR_REF(BgL_sz00_5413, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5413,
							BgL_iboxesz00_18686, BgL_bpz00_5415);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5413,
							BgL_valza2za2_18688,
							((long) CINT(BgL_bpz00_5415) + BgL_siza7eza7_18687));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_5417;
							obj_t BgL_wherez00_5418;
							obj_t BgL_locz00_5419;

							BgL_z12denvz12_5417 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5418 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18689))->BgL_wherez00);
							BgL_locz00_5419 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18689))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5417, BgL_wherez00_5418,
									BgL_locz00_5419);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_5420;

									BgL_za2za2resza2za2z00_5420 =
										PROCEDURE_ENTRY(BgL_bodyz00_18690) (BgL_bodyz00_18690,
										BgL_sz00_5413, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5417);
									return BgL_za2za2resza2za2z00_5420;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3649> */
	obj_t BGl_z62zc3anonymousza33649ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18692, obj_t BgL_sz00_18696)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18693;
				obj_t BgL_bodyz00_18694;
				long BgL_siza7ezd2framez75_18695;

				BgL_i1245z00_18693 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18692, (int) (((long) 0))));
				BgL_bodyz00_18694 = PROCEDURE_REF(BgL_envz00_18692, (int) (((long) 1)));
				BgL_siza7ezd2framez75_18695 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18692, (int) (((long) 2))));
				{
					obj_t BgL_sz00_5134;

					BgL_sz00_5134 = BgL_sz00_18696;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5136;

						BgL_bpz00_5136 = VECTOR_REF(BgL_sz00_5134, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18404;

								BgL_runz00_18404 =
									MAKE_FX_PROCEDURE(BGl_z62run5512z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18404,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_18693));
								PROCEDURE_SET(BgL_runz00_18404,
									(int) (((long) 1)), BgL_bodyz00_18694);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18405;

									BgL_mainz00_18405 =
										MAKE_VA_PROCEDURE(BGl_z62main5511z62zz__evaluate_compz00,
										(int) (((long) -4)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18405,
										(int) (((long) 0)), ((obj_t) BgL_i1245z00_18693));
									PROCEDURE_SET(BgL_mainz00_18405,
										(int) (((long) 1)), BgL_bodyz00_18694);
									PROCEDURE_SET(BgL_mainz00_18405,
										(int) (((long) 2)), BgL_runz00_18404);
									PROCEDURE_SET(BgL_mainz00_18405,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_18695));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_16072;

										BgL_objz00_16072 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18404, BgL_objz00_16072);
										BgL_objz00_16072;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3650z00_5139;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3651z00_5140;

											BgL_arg3651z00_5140 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18693))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_16074;

												BgL_framez00_16074 = BINT(BgL_siza7ezd2framez75_18695);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_16076;

													BgL_newz00_16076 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29024;

														BgL_auxz00_29024 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_16076, BgL_auxz00_29024,
															BgL_arg3651z00_5140);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29027;

														BgL_auxz00_29027 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_16076, BgL_auxz00_29027,
															BgL_framez00_16074);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29030;

														BgL_auxz00_29030 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_16076, BgL_auxz00_29030,
															BgL_runz00_18404);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_29035;
														int BgL_auxz00_29033;

														BgL_auxz00_29035 = BINT(((long) -4));
														BgL_auxz00_29033 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_16076, BgL_auxz00_29033,
															BgL_auxz00_29035);
													}
													BgL_arg3650z00_5139 = BgL_newz00_16076;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18405, BgL_arg3650z00_5139);
										BgL_arg3650z00_5139;
									}
									return BgL_mainz00_18405;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5511 */
	obj_t BGl_z62main5511z62zz__evaluate_compz00(obj_t BgL_envz00_18697,
		obj_t BgL_bz00_18702, obj_t BgL_cz00_18703, obj_t BgL_dz00_18704,
		obj_t BgL_lastz00_18705)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18700;
				long BgL_siza7ezd2framez75_18701;

				BgL_runz00_18700 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18697, (int) (((long) 2))));
				BgL_siza7ezd2framez75_18701 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18697, (int) (((long) 3))));
				{
					obj_t BgL_bz00_5141;
					obj_t BgL_cz00_5142;
					obj_t BgL_dz00_5143;
					obj_t BgL_lastz00_5144;

					BgL_bz00_5141 = BgL_bz00_18702;
					BgL_cz00_5142 = BgL_cz00_18703;
					BgL_dz00_5143 = BgL_dz00_18704;
					BgL_lastz00_5144 = BgL_lastz00_18705;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5146;

						BgL_sz00_5146 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5147;

							BgL_bpz00_5147 = VECTOR_REF(BgL_sz00_5146, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_29048;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_15992;

									BgL_nz00_15992 = BINT(BgL_siza7ezd2framez75_18701);
									BgL_testz00_29048 =
										(
										((long) CINT(BgL_bpz00_5147) +
											(long) CINT(BgL_nz00_15992)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5146)));
								}
								if (BgL_testz00_29048)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3655z00_5149;

											BgL_arg3655z00_5149 =
												((long) CINT(BgL_bpz00_5147) + ((long) 0));
											VECTOR_SET(BgL_sz00_5146,
												(int) (BgL_arg3655z00_5149), BgL_bz00_5141);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3656z00_5150;

											BgL_arg3656z00_5150 =
												((long) CINT(BgL_bpz00_5147) + ((long) 1));
											VECTOR_SET(BgL_sz00_5146,
												(int) (BgL_arg3656z00_5150), BgL_cz00_5142);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3657z00_5151;

											BgL_arg3657z00_5151 =
												((long) CINT(BgL_bpz00_5147) + ((long) 2));
											VECTOR_SET(BgL_sz00_5146,
												(int) (BgL_arg3657z00_5151), BgL_dz00_5143);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3659z00_5152;

											BgL_arg3659z00_5152 =
												((long) CINT(BgL_bpz00_5147) + ((long) 3));
											VECTOR_SET(BgL_sz00_5146,
												(int) (BgL_arg3659z00_5152), BgL_lastz00_5144);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5153;

											BgL_ez00_5153 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5153, BgL_bpz00_5147);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5154;

												BgL_accz00_5154 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18700, BgL_sz00_5146, BgL_bpz00_5147);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5153);
												VECTOR_SET(BgL_sz00_5146, (int) (((long) 0)),
													BgL_bpz00_5147);
												return BgL_accz00_5154;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5155;

										BgL_nsz00_5155 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5155,
											(int) (((long) 1)), BgL_sz00_5146);
										VECTOR_SET(BgL_nsz00_5155,
											(int) (((long) 2)), BgL_bz00_5141);
										VECTOR_SET(BgL_nsz00_5155,
											(int) (((long) 3)), BgL_cz00_5142);
										VECTOR_SET(BgL_nsz00_5155,
											(int) (((long) 4)), BgL_dz00_5143);
										VECTOR_SET(BgL_nsz00_5155,
											(int) (((long) 5)), BgL_lastz00_5144);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5156;

											BgL_z12denvz12_5156 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5156, BgL_nsz00_5155);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5157;

												BgL_ez00_5157 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5157, BgL_sz00_5146);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5158;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_16047;

														BgL_savedzd2bpzd2_16047 =
															VECTOR_REF(BgL_nsz00_5155, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5155,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_16054;

															BgL_fz00_16054 = BgL_runz00_18700;
														BgL_recz00_16053:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_16055;

																BgL_rz00_16055 =
																	PROCEDURE_ENTRY(BgL_fz00_16054)
																	(BgL_fz00_16054, BgL_nsz00_5155, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_29102;

																	if (PROCEDUREP(BgL_rz00_16055))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_16060;

																			BgL_arg1673z00_16060 =
																				PROCEDURE_ATTR(BgL_rz00_16055);
																			if (STRUCTP(BgL_arg1673z00_16060))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29102 =
																						(STRUCT_KEY(BgL_arg1673z00_16060) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29102 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_29102 = ((bool_t) 0);
																		}
																	if (BgL_testz00_29102)
																		{
																			obj_t BgL_fz00_29110;

																			BgL_fz00_29110 = BgL_rz00_16055;
																			BgL_fz00_16054 = BgL_fz00_29110;
																			goto BgL_recz00_16053;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5155,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_16047);
																			BgL_____rz00_5158 = BgL_rz00_16055;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5157);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5156,
														BgL_sz00_5146);
													return BgL_____rz00_5158;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5512 */
	obj_t BGl_z62run5512z62zz__evaluate_compz00(obj_t BgL_envz00_18706,
		obj_t BgL_sz00_18709)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18707;
				obj_t BgL_bodyz00_18708;

				BgL_i1245z00_18707 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18706, (int) (((long) 0))));
				BgL_bodyz00_18708 = PROCEDURE_REF(BgL_envz00_18706, (int) (((long) 1)));
				{
					obj_t BgL_sz00_5160;

					BgL_sz00_5160 = BgL_sz00_18709;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5162;

						BgL_bpz00_5162 = VECTOR_REF(BgL_sz00_5160, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_5163;
							obj_t BgL_wherez00_5164;
							obj_t BgL_locz00_5165;

							BgL_z12denvz12_5163 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5164 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18707))->BgL_wherez00);
							BgL_locz00_5165 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18707))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5163, BgL_wherez00_5164,
									BgL_locz00_5165);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_5166;

									BgL_za2za2resza2za2z00_5166 =
										PROCEDURE_ENTRY(BgL_bodyz00_18708) (BgL_bodyz00_18708,
										BgL_sz00_5160, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5163);
									return BgL_za2za2resza2za2z00_5166;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3661> */
	obj_t BGl_z62zc3anonymousza33661ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18710, obj_t BgL_sz00_18715)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18711;
				BgL_ev_absz00_bglt BgL_i1245z00_18712;
				obj_t BgL_bodyz00_18713;
				long BgL_siza7ezd2framez75_18714;

				BgL_iboxesz00_18711 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18710, (int) (((long) 0))));
				BgL_i1245z00_18712 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18710, (int) (((long) 1))));
				BgL_bodyz00_18713 = PROCEDURE_REF(BgL_envz00_18710, (int) (((long) 2)));
				BgL_siza7ezd2framez75_18714 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18710, (int) (((long) 3))));
				{
					obj_t BgL_sz00_5168;

					BgL_sz00_5168 = BgL_sz00_18715;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5170;

						BgL_bpz00_5170 = VECTOR_REF(BgL_sz00_5168, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18401;

								BgL_runz00_18401 =
									MAKE_FX_PROCEDURE(BGl_z62run5514z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18401,
									(int) (((long) 0)), BgL_iboxesz00_18711);
								PROCEDURE_SET(BgL_runz00_18401,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_18712));
								PROCEDURE_SET(BgL_runz00_18401,
									(int) (((long) 2)), BgL_bodyz00_18713);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18402;

									BgL_mainz00_18402 =
										MAKE_VA_PROCEDURE(BGl_z62main5513z62zz__evaluate_compz00,
										(int) (((long) -4)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18402,
										(int) (((long) 0)), BgL_iboxesz00_18711);
									PROCEDURE_SET(BgL_mainz00_18402,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_18712));
									PROCEDURE_SET(BgL_mainz00_18402,
										(int) (((long) 2)), BgL_bodyz00_18713);
									PROCEDURE_SET(BgL_mainz00_18402,
										(int) (((long) 3)), BgL_runz00_18401);
									PROCEDURE_SET(BgL_mainz00_18402,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_18714));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_16185;

										BgL_objz00_16185 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18401, BgL_objz00_16185);
										BgL_objz00_16185;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3662z00_5173;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3663z00_5174;

											BgL_arg3663z00_5174 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18712))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_16187;

												BgL_framez00_16187 = BINT(BgL_siza7ezd2framez75_18714);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_16189;

													BgL_newz00_16189 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29174;

														BgL_auxz00_29174 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_16189, BgL_auxz00_29174,
															BgL_arg3663z00_5174);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29177;

														BgL_auxz00_29177 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_16189, BgL_auxz00_29177,
															BgL_framez00_16187);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29180;

														BgL_auxz00_29180 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_16189, BgL_auxz00_29180,
															BgL_runz00_18401);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_29185;
														int BgL_auxz00_29183;

														BgL_auxz00_29185 = BINT(((long) -4));
														BgL_auxz00_29183 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_16189, BgL_auxz00_29183,
															BgL_auxz00_29185);
													}
													BgL_arg3662z00_5173 = BgL_newz00_16189;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18402, BgL_arg3662z00_5173);
										BgL_arg3662z00_5173;
									}
									return BgL_mainz00_18402;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5513 */
	obj_t BGl_z62main5513z62zz__evaluate_compz00(obj_t BgL_envz00_18716,
		obj_t BgL_bz00_18722, obj_t BgL_cz00_18723, obj_t BgL_dz00_18724,
		obj_t BgL_lastz00_18725)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18720;
				long BgL_siza7ezd2framez75_18721;

				BgL_runz00_18720 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18716, (int) (((long) 3))));
				BgL_siza7ezd2framez75_18721 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18716, (int) (((long) 4))));
				{
					obj_t BgL_bz00_5175;
					obj_t BgL_cz00_5176;
					obj_t BgL_dz00_5177;
					obj_t BgL_lastz00_5178;

					BgL_bz00_5175 = BgL_bz00_18722;
					BgL_cz00_5176 = BgL_cz00_18723;
					BgL_dz00_5177 = BgL_dz00_18724;
					BgL_lastz00_5178 = BgL_lastz00_18725;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5180;

						BgL_sz00_5180 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5181;

							BgL_bpz00_5181 = VECTOR_REF(BgL_sz00_5180, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_29198;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_16105;

									BgL_nz00_16105 = BINT(BgL_siza7ezd2framez75_18721);
									BgL_testz00_29198 =
										(
										((long) CINT(BgL_bpz00_5181) +
											(long) CINT(BgL_nz00_16105)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5180)));
								}
								if (BgL_testz00_29198)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3666z00_5183;

											BgL_arg3666z00_5183 =
												((long) CINT(BgL_bpz00_5181) + ((long) 0));
											VECTOR_SET(BgL_sz00_5180,
												(int) (BgL_arg3666z00_5183), BgL_bz00_5175);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3667z00_5184;

											BgL_arg3667z00_5184 =
												((long) CINT(BgL_bpz00_5181) + ((long) 1));
											VECTOR_SET(BgL_sz00_5180,
												(int) (BgL_arg3667z00_5184), BgL_cz00_5176);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3668z00_5185;

											BgL_arg3668z00_5185 =
												((long) CINT(BgL_bpz00_5181) + ((long) 2));
											VECTOR_SET(BgL_sz00_5180,
												(int) (BgL_arg3668z00_5185), BgL_dz00_5177);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3669z00_5186;

											BgL_arg3669z00_5186 =
												((long) CINT(BgL_bpz00_5181) + ((long) 3));
											VECTOR_SET(BgL_sz00_5180,
												(int) (BgL_arg3669z00_5186), BgL_lastz00_5178);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5187;

											BgL_ez00_5187 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5187, BgL_bpz00_5181);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5188;

												BgL_accz00_5188 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18720, BgL_sz00_5180, BgL_bpz00_5181);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5187);
												VECTOR_SET(BgL_sz00_5180, (int) (((long) 0)),
													BgL_bpz00_5181);
												return BgL_accz00_5188;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5189;

										BgL_nsz00_5189 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5189,
											(int) (((long) 1)), BgL_sz00_5180);
										VECTOR_SET(BgL_nsz00_5189,
											(int) (((long) 2)), BgL_bz00_5175);
										VECTOR_SET(BgL_nsz00_5189,
											(int) (((long) 3)), BgL_cz00_5176);
										VECTOR_SET(BgL_nsz00_5189,
											(int) (((long) 4)), BgL_dz00_5177);
										VECTOR_SET(BgL_nsz00_5189,
											(int) (((long) 5)), BgL_lastz00_5178);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5190;

											BgL_z12denvz12_5190 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5190, BgL_nsz00_5189);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5191;

												BgL_ez00_5191 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5191, BgL_sz00_5180);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5192;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_16160;

														BgL_savedzd2bpzd2_16160 =
															VECTOR_REF(BgL_nsz00_5189, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5189,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_16167;

															BgL_fz00_16167 = BgL_runz00_18720;
														BgL_recz00_16166:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_16168;

																BgL_rz00_16168 =
																	PROCEDURE_ENTRY(BgL_fz00_16167)
																	(BgL_fz00_16167, BgL_nsz00_5189, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_29252;

																	if (PROCEDUREP(BgL_rz00_16168))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_16173;

																			BgL_arg1673z00_16173 =
																				PROCEDURE_ATTR(BgL_rz00_16168);
																			if (STRUCTP(BgL_arg1673z00_16173))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29252 =
																						(STRUCT_KEY(BgL_arg1673z00_16173) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29252 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_29252 = ((bool_t) 0);
																		}
																	if (BgL_testz00_29252)
																		{
																			obj_t BgL_fz00_29260;

																			BgL_fz00_29260 = BgL_rz00_16168;
																			BgL_fz00_16167 = BgL_fz00_29260;
																			goto BgL_recz00_16166;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5189,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_16160);
																			BgL_____rz00_5192 = BgL_rz00_16168;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5191);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5190,
														BgL_sz00_5180);
													return BgL_____rz00_5192;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5514 */
	obj_t BGl_z62run5514z62zz__evaluate_compz00(obj_t BgL_envz00_18726,
		obj_t BgL_sz00_18730)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18727;
				BgL_ev_absz00_bglt BgL_i1245z00_18728;
				obj_t BgL_bodyz00_18729;

				BgL_iboxesz00_18727 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18726, (int) (((long) 0))));
				BgL_i1245z00_18728 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18726, (int) (((long) 1))));
				BgL_bodyz00_18729 = PROCEDURE_REF(BgL_envz00_18726, (int) (((long) 2)));
				{
					obj_t BgL_sz00_5194;

					BgL_sz00_5194 = BgL_sz00_18730;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5196;

						BgL_bpz00_5196 = VECTOR_REF(BgL_sz00_5194, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5194,
							BgL_iboxesz00_18727, BgL_bpz00_5196);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_5197;
							obj_t BgL_wherez00_5198;
							obj_t BgL_locz00_5199;

							BgL_z12denvz12_5197 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5198 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18728))->BgL_wherez00);
							BgL_locz00_5199 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18728))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5197, BgL_wherez00_5198,
									BgL_locz00_5199);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_5200;

									BgL_za2za2resza2za2z00_5200 =
										PROCEDURE_ENTRY(BgL_bodyz00_18729) (BgL_bodyz00_18729,
										BgL_sz00_5194, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5197);
									return BgL_za2za2resza2za2z00_5200;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3673> */
	obj_t BGl_z62zc3anonymousza33673ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18731, obj_t BgL_sz00_18737)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18732;
				long BgL_siza7eza7_18733;
				BgL_ev_absz00_bglt BgL_i1245z00_18734;
				obj_t BgL_bodyz00_18735;
				long BgL_siza7ezd2framez75_18736;

				BgL_ifreesz00_18732 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18731, (int) (((long) 0))));
				BgL_siza7eza7_18733 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18731, (int) (((long) 1))));
				BgL_i1245z00_18734 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18731, (int) (((long) 2))));
				BgL_bodyz00_18735 = PROCEDURE_REF(BgL_envz00_18731, (int) (((long) 3)));
				BgL_siza7ezd2framez75_18736 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18731, (int) (((long) 4))));
				{
					obj_t BgL_sz00_5204;

					BgL_sz00_5204 = BgL_sz00_18737;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5206;

						BgL_bpz00_5206 = VECTOR_REF(BgL_sz00_5204, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_5207;

							BgL_valza2za2_5207 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5204,
								BgL_bpz00_5206, BgL_ifreesz00_18732);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18398;

								BgL_runz00_18398 =
									MAKE_FX_PROCEDURE(BGl_z62run5516z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18398,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18733));
								PROCEDURE_SET(BgL_runz00_18398,
									(int) (((long) 1)), BgL_valza2za2_5207);
								PROCEDURE_SET(BgL_runz00_18398,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_18734));
								PROCEDURE_SET(BgL_runz00_18398,
									(int) (((long) 3)), BgL_bodyz00_18735);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18399;

									BgL_mainz00_18399 =
										MAKE_VA_PROCEDURE(BGl_z62main5515z62zz__evaluate_compz00,
										(int) (((long) -4)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18399,
										(int) (((long) 0)), BINT(BgL_siza7eza7_18733));
									PROCEDURE_SET(BgL_mainz00_18399,
										(int) (((long) 1)), BgL_valza2za2_5207);
									PROCEDURE_SET(BgL_mainz00_18399,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_18734));
									PROCEDURE_SET(BgL_mainz00_18399,
										(int) (((long) 3)), BgL_bodyz00_18735);
									PROCEDURE_SET(BgL_mainz00_18399,
										(int) (((long) 4)), BgL_runz00_18398);
									PROCEDURE_SET(BgL_mainz00_18399,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_18736));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_16305;

										BgL_objz00_16305 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18398, BgL_objz00_16305);
										BgL_objz00_16305;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3674z00_5210;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3675z00_5211;

											BgL_arg3675z00_5211 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18734))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_16307;

												BgL_framez00_16307 = BINT(BgL_siza7ezd2framez75_18736);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_16309;

													BgL_newz00_16309 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29338;

														BgL_auxz00_29338 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_16309, BgL_auxz00_29338,
															BgL_arg3675z00_5211);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29341;

														BgL_auxz00_29341 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_16309, BgL_auxz00_29341,
															BgL_framez00_16307);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29344;

														BgL_auxz00_29344 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_16309, BgL_auxz00_29344,
															BgL_runz00_18398);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_29349;
														int BgL_auxz00_29347;

														BgL_auxz00_29349 = BINT(((long) -4));
														BgL_auxz00_29347 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_16309, BgL_auxz00_29347,
															BgL_auxz00_29349);
													}
													BgL_arg3674z00_5210 = BgL_newz00_16309;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18399, BgL_arg3674z00_5210);
										BgL_arg3674z00_5210;
									}
									return BgL_mainz00_18399;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5515 */
	obj_t BGl_z62main5515z62zz__evaluate_compz00(obj_t BgL_envz00_18738,
		obj_t BgL_bz00_18745, obj_t BgL_cz00_18746, obj_t BgL_dz00_18747,
		obj_t BgL_lastz00_18748)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18743;
				long BgL_siza7ezd2framez75_18744;

				BgL_runz00_18743 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18738, (int) (((long) 4))));
				BgL_siza7ezd2framez75_18744 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18738, (int) (((long) 5))));
				{
					obj_t BgL_bz00_5212;
					obj_t BgL_cz00_5213;
					obj_t BgL_dz00_5214;
					obj_t BgL_lastz00_5215;

					BgL_bz00_5212 = BgL_bz00_18745;
					BgL_cz00_5213 = BgL_cz00_18746;
					BgL_dz00_5214 = BgL_dz00_18747;
					BgL_lastz00_5215 = BgL_lastz00_18748;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5217;

						BgL_sz00_5217 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5218;

							BgL_bpz00_5218 = VECTOR_REF(BgL_sz00_5217, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_29362;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_16225;

									BgL_nz00_16225 = BINT(BgL_siza7ezd2framez75_18744);
									BgL_testz00_29362 =
										(
										((long) CINT(BgL_bpz00_5218) +
											(long) CINT(BgL_nz00_16225)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5217)));
								}
								if (BgL_testz00_29362)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3678z00_5220;

											BgL_arg3678z00_5220 =
												((long) CINT(BgL_bpz00_5218) + ((long) 0));
											VECTOR_SET(BgL_sz00_5217,
												(int) (BgL_arg3678z00_5220), BgL_bz00_5212);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3679z00_5221;

											BgL_arg3679z00_5221 =
												((long) CINT(BgL_bpz00_5218) + ((long) 1));
											VECTOR_SET(BgL_sz00_5217,
												(int) (BgL_arg3679z00_5221), BgL_cz00_5213);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3680z00_5222;

											BgL_arg3680z00_5222 =
												((long) CINT(BgL_bpz00_5218) + ((long) 2));
											VECTOR_SET(BgL_sz00_5217,
												(int) (BgL_arg3680z00_5222), BgL_dz00_5214);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3681z00_5223;

											BgL_arg3681z00_5223 =
												((long) CINT(BgL_bpz00_5218) + ((long) 3));
											VECTOR_SET(BgL_sz00_5217,
												(int) (BgL_arg3681z00_5223), BgL_lastz00_5215);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5224;

											BgL_ez00_5224 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5224, BgL_bpz00_5218);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5225;

												BgL_accz00_5225 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18743, BgL_sz00_5217, BgL_bpz00_5218);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5224);
												VECTOR_SET(BgL_sz00_5217, (int) (((long) 0)),
													BgL_bpz00_5218);
												return BgL_accz00_5225;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5226;

										BgL_nsz00_5226 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5226,
											(int) (((long) 1)), BgL_sz00_5217);
										VECTOR_SET(BgL_nsz00_5226,
											(int) (((long) 2)), BgL_bz00_5212);
										VECTOR_SET(BgL_nsz00_5226,
											(int) (((long) 3)), BgL_cz00_5213);
										VECTOR_SET(BgL_nsz00_5226,
											(int) (((long) 4)), BgL_dz00_5214);
										VECTOR_SET(BgL_nsz00_5226,
											(int) (((long) 5)), BgL_lastz00_5215);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5227;

											BgL_z12denvz12_5227 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5227, BgL_nsz00_5226);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5228;

												BgL_ez00_5228 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5228, BgL_sz00_5217);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5229;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_16280;

														BgL_savedzd2bpzd2_16280 =
															VECTOR_REF(BgL_nsz00_5226, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5226,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_16287;

															BgL_fz00_16287 = BgL_runz00_18743;
														BgL_recz00_16286:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_16288;

																BgL_rz00_16288 =
																	PROCEDURE_ENTRY(BgL_fz00_16287)
																	(BgL_fz00_16287, BgL_nsz00_5226, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_29416;

																	if (PROCEDUREP(BgL_rz00_16288))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_16293;

																			BgL_arg1673z00_16293 =
																				PROCEDURE_ATTR(BgL_rz00_16288);
																			if (STRUCTP(BgL_arg1673z00_16293))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29416 =
																						(STRUCT_KEY(BgL_arg1673z00_16293) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29416 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_29416 = ((bool_t) 0);
																		}
																	if (BgL_testz00_29416)
																		{
																			obj_t BgL_fz00_29424;

																			BgL_fz00_29424 = BgL_rz00_16288;
																			BgL_fz00_16287 = BgL_fz00_29424;
																			goto BgL_recz00_16286;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5226,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_16280);
																			BgL_____rz00_5229 = BgL_rz00_16288;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5228);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5227,
														BgL_sz00_5217);
													return BgL_____rz00_5229;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5516 */
	obj_t BGl_z62run5516z62zz__evaluate_compz00(obj_t BgL_envz00_18749,
		obj_t BgL_sz00_18754)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_18750;
				obj_t BgL_valza2za2_18751;
				BgL_ev_absz00_bglt BgL_i1245z00_18752;
				obj_t BgL_bodyz00_18753;

				BgL_siza7eza7_18750 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18749, (int) (((long) 0))));
				BgL_valza2za2_18751 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18749, (int) (((long) 1))));
				BgL_i1245z00_18752 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18749, (int) (((long) 2))));
				BgL_bodyz00_18753 = PROCEDURE_REF(BgL_envz00_18749, (int) (((long) 3)));
				{
					obj_t BgL_sz00_5231;

					BgL_sz00_5231 = BgL_sz00_18754;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5233;

						BgL_bpz00_5233 = VECTOR_REF(BgL_sz00_5231, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5231,
							BgL_valza2za2_18751,
							((long) CINT(BgL_bpz00_5233) + BgL_siza7eza7_18750));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_5235;
							obj_t BgL_wherez00_5236;
							obj_t BgL_locz00_5237;

							BgL_z12denvz12_5235 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5236 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18752))->BgL_wherez00);
							BgL_locz00_5237 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18752))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5235, BgL_wherez00_5236,
									BgL_locz00_5237);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_5238;

									BgL_za2za2resza2za2z00_5238 =
										PROCEDURE_ENTRY(BgL_bodyz00_18753) (BgL_bodyz00_18753,
										BgL_sz00_5231, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5235);
									return BgL_za2za2resza2za2z00_5238;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3684> */
	obj_t BGl_z62zc3anonymousza33684ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18755, obj_t BgL_sz00_18762)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18756;
				obj_t BgL_iboxesz00_18757;
				long BgL_siza7eza7_18758;
				BgL_ev_absz00_bglt BgL_i1245z00_18759;
				obj_t BgL_bodyz00_18760;
				long BgL_siza7ezd2framez75_18761;

				BgL_ifreesz00_18756 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18755, (int) (((long) 0))));
				BgL_iboxesz00_18757 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18755, (int) (((long) 1))));
				BgL_siza7eza7_18758 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18755, (int) (((long) 2))));
				BgL_i1245z00_18759 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18755, (int) (((long) 3))));
				BgL_bodyz00_18760 = PROCEDURE_REF(BgL_envz00_18755, (int) (((long) 4)));
				BgL_siza7ezd2framez75_18761 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18755, (int) (((long) 5))));
				{
					obj_t BgL_sz00_5240;

					BgL_sz00_5240 = BgL_sz00_18762;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5242;

						BgL_bpz00_5242 = VECTOR_REF(BgL_sz00_5240, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_5243;

							BgL_valza2za2_5243 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5240,
								BgL_bpz00_5242, BgL_ifreesz00_18756);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18395;

								BgL_runz00_18395 =
									MAKE_FX_PROCEDURE(BGl_z62run5518z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18395,
									(int) (((long) 0)), BgL_iboxesz00_18757);
								PROCEDURE_SET(BgL_runz00_18395,
									(int) (((long) 1)), BINT(BgL_siza7eza7_18758));
								PROCEDURE_SET(BgL_runz00_18395,
									(int) (((long) 2)), BgL_valza2za2_5243);
								PROCEDURE_SET(BgL_runz00_18395,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_18759));
								PROCEDURE_SET(BgL_runz00_18395,
									(int) (((long) 4)), BgL_bodyz00_18760);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18396;

									BgL_mainz00_18396 =
										MAKE_VA_PROCEDURE(BGl_z62main5517z62zz__evaluate_compz00,
										(int) (((long) -4)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18396,
										(int) (((long) 0)), BgL_iboxesz00_18757);
									PROCEDURE_SET(BgL_mainz00_18396,
										(int) (((long) 1)), BINT(BgL_siza7eza7_18758));
									PROCEDURE_SET(BgL_mainz00_18396,
										(int) (((long) 2)), BgL_valza2za2_5243);
									PROCEDURE_SET(BgL_mainz00_18396,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_18759));
									PROCEDURE_SET(BgL_mainz00_18396,
										(int) (((long) 4)), BgL_bodyz00_18760);
									PROCEDURE_SET(BgL_mainz00_18396,
										(int) (((long) 5)), BgL_runz00_18395);
									PROCEDURE_SET(BgL_mainz00_18396,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_18761));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_16421;

										BgL_objz00_16421 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18395, BgL_objz00_16421);
										BgL_objz00_16421;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3685z00_5246;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3686z00_5247;

											BgL_arg3686z00_5247 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18759))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_16423;

												BgL_framez00_16423 = BINT(BgL_siza7ezd2framez75_18761);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_16425;

													BgL_newz00_16425 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29514;

														BgL_auxz00_29514 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_16425, BgL_auxz00_29514,
															BgL_arg3686z00_5247);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29517;

														BgL_auxz00_29517 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_16425, BgL_auxz00_29517,
															BgL_framez00_16423);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29520;

														BgL_auxz00_29520 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_16425, BgL_auxz00_29520,
															BgL_runz00_18395);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_29525;
														int BgL_auxz00_29523;

														BgL_auxz00_29525 = BINT(((long) -4));
														BgL_auxz00_29523 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_16425, BgL_auxz00_29523,
															BgL_auxz00_29525);
													}
													BgL_arg3685z00_5246 = BgL_newz00_16425;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18396, BgL_arg3685z00_5246);
										BgL_arg3685z00_5246;
									}
									return BgL_mainz00_18396;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5517 */
	obj_t BGl_z62main5517z62zz__evaluate_compz00(obj_t BgL_envz00_18763,
		obj_t BgL_bz00_18771, obj_t BgL_cz00_18772, obj_t BgL_dz00_18773,
		obj_t BgL_lastz00_18774)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18769;
				long BgL_siza7ezd2framez75_18770;

				BgL_runz00_18769 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18763, (int) (((long) 5))));
				BgL_siza7ezd2framez75_18770 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18763, (int) (((long) 6))));
				{
					obj_t BgL_bz00_5248;
					obj_t BgL_cz00_5249;
					obj_t BgL_dz00_5250;
					obj_t BgL_lastz00_5251;

					BgL_bz00_5248 = BgL_bz00_18771;
					BgL_cz00_5249 = BgL_cz00_18772;
					BgL_dz00_5250 = BgL_dz00_18773;
					BgL_lastz00_5251 = BgL_lastz00_18774;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5253;

						BgL_sz00_5253 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5254;

							BgL_bpz00_5254 = VECTOR_REF(BgL_sz00_5253, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_29538;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_16341;

									BgL_nz00_16341 = BINT(BgL_siza7ezd2framez75_18770);
									BgL_testz00_29538 =
										(
										((long) CINT(BgL_bpz00_5254) +
											(long) CINT(BgL_nz00_16341)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5253)));
								}
								if (BgL_testz00_29538)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3689z00_5256;

											BgL_arg3689z00_5256 =
												((long) CINT(BgL_bpz00_5254) + ((long) 0));
											VECTOR_SET(BgL_sz00_5253,
												(int) (BgL_arg3689z00_5256), BgL_bz00_5248);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3690z00_5257;

											BgL_arg3690z00_5257 =
												((long) CINT(BgL_bpz00_5254) + ((long) 1));
											VECTOR_SET(BgL_sz00_5253,
												(int) (BgL_arg3690z00_5257), BgL_cz00_5249);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3691z00_5258;

											BgL_arg3691z00_5258 =
												((long) CINT(BgL_bpz00_5254) + ((long) 2));
											VECTOR_SET(BgL_sz00_5253,
												(int) (BgL_arg3691z00_5258), BgL_dz00_5250);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3692z00_5259;

											BgL_arg3692z00_5259 =
												((long) CINT(BgL_bpz00_5254) + ((long) 3));
											VECTOR_SET(BgL_sz00_5253,
												(int) (BgL_arg3692z00_5259), BgL_lastz00_5251);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5260;

											BgL_ez00_5260 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5260, BgL_bpz00_5254);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5261;

												BgL_accz00_5261 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18769, BgL_sz00_5253, BgL_bpz00_5254);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5260);
												VECTOR_SET(BgL_sz00_5253, (int) (((long) 0)),
													BgL_bpz00_5254);
												return BgL_accz00_5261;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5262;

										BgL_nsz00_5262 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5262,
											(int) (((long) 1)), BgL_sz00_5253);
										VECTOR_SET(BgL_nsz00_5262,
											(int) (((long) 2)), BgL_bz00_5248);
										VECTOR_SET(BgL_nsz00_5262,
											(int) (((long) 3)), BgL_cz00_5249);
										VECTOR_SET(BgL_nsz00_5262,
											(int) (((long) 4)), BgL_dz00_5250);
										VECTOR_SET(BgL_nsz00_5262,
											(int) (((long) 5)), BgL_lastz00_5251);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5263;

											BgL_z12denvz12_5263 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5263, BgL_nsz00_5262);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5264;

												BgL_ez00_5264 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5264, BgL_sz00_5253);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5265;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_16396;

														BgL_savedzd2bpzd2_16396 =
															VECTOR_REF(BgL_nsz00_5262, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5262,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_16403;

															BgL_fz00_16403 = BgL_runz00_18769;
														BgL_recz00_16402:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_16404;

																BgL_rz00_16404 =
																	PROCEDURE_ENTRY(BgL_fz00_16403)
																	(BgL_fz00_16403, BgL_nsz00_5262, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_29592;

																	if (PROCEDUREP(BgL_rz00_16404))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_16409;

																			BgL_arg1673z00_16409 =
																				PROCEDURE_ATTR(BgL_rz00_16404);
																			if (STRUCTP(BgL_arg1673z00_16409))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29592 =
																						(STRUCT_KEY(BgL_arg1673z00_16409) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29592 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_29592 = ((bool_t) 0);
																		}
																	if (BgL_testz00_29592)
																		{
																			obj_t BgL_fz00_29600;

																			BgL_fz00_29600 = BgL_rz00_16404;
																			BgL_fz00_16403 = BgL_fz00_29600;
																			goto BgL_recz00_16402;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5262,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_16396);
																			BgL_____rz00_5265 = BgL_rz00_16404;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5264);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5263,
														BgL_sz00_5253);
													return BgL_____rz00_5265;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5518 */
	obj_t BGl_z62run5518z62zz__evaluate_compz00(obj_t BgL_envz00_18775,
		obj_t BgL_sz00_18781)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18776;
				long BgL_siza7eza7_18777;
				obj_t BgL_valza2za2_18778;
				BgL_ev_absz00_bglt BgL_i1245z00_18779;
				obj_t BgL_bodyz00_18780;

				BgL_iboxesz00_18776 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18775, (int) (((long) 0))));
				BgL_siza7eza7_18777 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18775, (int) (((long) 1))));
				BgL_valza2za2_18778 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18775, (int) (((long) 2))));
				BgL_i1245z00_18779 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18775, (int) (((long) 3))));
				BgL_bodyz00_18780 = PROCEDURE_REF(BgL_envz00_18775, (int) (((long) 4)));
				{
					obj_t BgL_sz00_5267;

					BgL_sz00_5267 = BgL_sz00_18781;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5269;

						BgL_bpz00_5269 = VECTOR_REF(BgL_sz00_5267, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5267,
							BgL_iboxesz00_18776, BgL_bpz00_5269);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5267,
							BgL_valza2za2_18778,
							((long) CINT(BgL_bpz00_5269) + BgL_siza7eza7_18777));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_5271;
							obj_t BgL_wherez00_5272;
							obj_t BgL_locz00_5273;

							BgL_z12denvz12_5271 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5272 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18779))->BgL_wherez00);
							BgL_locz00_5273 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18779))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5271, BgL_wherez00_5272,
									BgL_locz00_5273);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_5274;

									BgL_za2za2resza2za2z00_5274 =
										PROCEDURE_ENTRY(BgL_bodyz00_18780) (BgL_bodyz00_18780,
										BgL_sz00_5267, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5271);
									return BgL_za2za2resza2za2z00_5274;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3601> */
	obj_t BGl_z62zc3anonymousza33601ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18782, obj_t BgL_sz00_18786)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18783;
				obj_t BgL_bodyz00_18784;
				long BgL_siza7ezd2framez75_18785;

				BgL_i1245z00_18783 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18782, (int) (((long) 0))));
				BgL_bodyz00_18784 = PROCEDURE_REF(BgL_envz00_18782, (int) (((long) 1)));
				BgL_siza7ezd2framez75_18785 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18782, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4996;

					BgL_sz00_4996 = BgL_sz00_18786;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4998;

						BgL_bpz00_4998 = VECTOR_REF(BgL_sz00_4996, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18392;

								BgL_runz00_18392 =
									MAKE_FX_PROCEDURE(BGl_z62run5520z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18392,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_18783));
								PROCEDURE_SET(BgL_runz00_18392,
									(int) (((long) 1)), BgL_bodyz00_18784);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18393;

									BgL_mainz00_18393 =
										MAKE_FX_PROCEDURE(BGl_z62main5519z62zz__evaluate_compz00,
										(int) (((long) 3)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18393,
										(int) (((long) 0)), ((obj_t) BgL_i1245z00_18783));
									PROCEDURE_SET(BgL_mainz00_18393,
										(int) (((long) 1)), BgL_bodyz00_18784);
									PROCEDURE_SET(BgL_mainz00_18393,
										(int) (((long) 2)), BgL_runz00_18392);
									PROCEDURE_SET(BgL_mainz00_18393,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_18785));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_15629;

										BgL_objz00_15629 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18392, BgL_objz00_15629);
										BgL_objz00_15629;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3602z00_5001;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3604z00_5002;

											BgL_arg3604z00_5002 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18783))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_15631;

												BgL_framez00_15631 = BINT(BgL_siza7ezd2framez75_18785);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_15633;

													BgL_newz00_15633 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29670;

														BgL_auxz00_29670 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_15633, BgL_auxz00_29670,
															BgL_arg3604z00_5002);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29673;

														BgL_auxz00_29673 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_15633, BgL_auxz00_29673,
															BgL_framez00_15631);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29676;

														BgL_auxz00_29676 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_15633, BgL_auxz00_29676,
															BgL_runz00_18392);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_29681;
														int BgL_auxz00_29679;

														BgL_auxz00_29681 = BINT(((long) 3));
														BgL_auxz00_29679 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_15633, BgL_auxz00_29679,
															BgL_auxz00_29681);
													}
													BgL_arg3602z00_5001 = BgL_newz00_15633;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18393, BgL_arg3602z00_5001);
										BgL_arg3602z00_5001;
									}
									return BgL_mainz00_18393;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5519 */
	obj_t BGl_z62main5519z62zz__evaluate_compz00(obj_t BgL_envz00_18787,
		obj_t BgL_bz00_18792, obj_t BgL_cz00_18793, obj_t BgL_dz00_18794)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18790;
				long BgL_siza7ezd2framez75_18791;

				BgL_runz00_18790 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18787, (int) (((long) 2))));
				BgL_siza7ezd2framez75_18791 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18787, (int) (((long) 3))));
				{
					obj_t BgL_bz00_5003;
					obj_t BgL_cz00_5004;
					obj_t BgL_dz00_5005;

					BgL_bz00_5003 = BgL_bz00_18792;
					BgL_cz00_5004 = BgL_cz00_18793;
					BgL_dz00_5005 = BgL_dz00_18794;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5007;

						BgL_sz00_5007 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5008;

							BgL_bpz00_5008 = VECTOR_REF(BgL_sz00_5007, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_29694;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_15558;

									BgL_nz00_15558 = BINT(BgL_siza7ezd2framez75_18791);
									BgL_testz00_29694 =
										(
										((long) CINT(BgL_bpz00_5008) +
											(long) CINT(BgL_nz00_15558)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5007)));
								}
								if (BgL_testz00_29694)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3607z00_5010;

											BgL_arg3607z00_5010 =
												((long) CINT(BgL_bpz00_5008) + ((long) 0));
											VECTOR_SET(BgL_sz00_5007,
												(int) (BgL_arg3607z00_5010), BgL_bz00_5003);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3608z00_5011;

											BgL_arg3608z00_5011 =
												((long) CINT(BgL_bpz00_5008) + ((long) 1));
											VECTOR_SET(BgL_sz00_5007,
												(int) (BgL_arg3608z00_5011), BgL_cz00_5004);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3609z00_5012;

											BgL_arg3609z00_5012 =
												((long) CINT(BgL_bpz00_5008) + ((long) 2));
											VECTOR_SET(BgL_sz00_5007,
												(int) (BgL_arg3609z00_5012), BgL_dz00_5005);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5013;

											BgL_ez00_5013 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5013, BgL_bpz00_5008);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5014;

												BgL_accz00_5014 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18790, BgL_sz00_5007, BgL_bpz00_5008);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5013);
												VECTOR_SET(BgL_sz00_5007, (int) (((long) 0)),
													BgL_bpz00_5008);
												return BgL_accz00_5014;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5015;

										BgL_nsz00_5015 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5015,
											(int) (((long) 1)), BgL_sz00_5007);
										VECTOR_SET(BgL_nsz00_5015,
											(int) (((long) 2)), BgL_bz00_5003);
										VECTOR_SET(BgL_nsz00_5015,
											(int) (((long) 3)), BgL_cz00_5004);
										VECTOR_SET(BgL_nsz00_5015,
											(int) (((long) 4)), BgL_dz00_5005);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5016;

											BgL_z12denvz12_5016 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5016, BgL_nsz00_5015);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5017;

												BgL_ez00_5017 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5017, BgL_sz00_5007);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5018;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_15604;

														BgL_savedzd2bpzd2_15604 =
															VECTOR_REF(BgL_nsz00_5015, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5015,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_15611;

															BgL_fz00_15611 = BgL_runz00_18790;
														BgL_recz00_15610:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_15612;

																BgL_rz00_15612 =
																	PROCEDURE_ENTRY(BgL_fz00_15611)
																	(BgL_fz00_15611, BgL_nsz00_5015, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_29742;

																	if (PROCEDUREP(BgL_rz00_15612))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_15617;

																			BgL_arg1673z00_15617 =
																				PROCEDURE_ATTR(BgL_rz00_15612);
																			if (STRUCTP(BgL_arg1673z00_15617))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29742 =
																						(STRUCT_KEY(BgL_arg1673z00_15617) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29742 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_29742 = ((bool_t) 0);
																		}
																	if (BgL_testz00_29742)
																		{
																			obj_t BgL_fz00_29750;

																			BgL_fz00_29750 = BgL_rz00_15612;
																			BgL_fz00_15611 = BgL_fz00_29750;
																			goto BgL_recz00_15610;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5015,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_15604);
																			BgL_____rz00_5018 = BgL_rz00_15612;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5017);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5016,
														BgL_sz00_5007);
													return BgL_____rz00_5018;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5520 */
	obj_t BGl_z62run5520z62zz__evaluate_compz00(obj_t BgL_envz00_18795,
		obj_t BgL_sz00_18798)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18796;
				obj_t BgL_bodyz00_18797;

				BgL_i1245z00_18796 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18795, (int) (((long) 0))));
				BgL_bodyz00_18797 = PROCEDURE_REF(BgL_envz00_18795, (int) (((long) 1)));
				{
					obj_t BgL_sz00_5020;

					BgL_sz00_5020 = BgL_sz00_18798;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5022;

						BgL_bpz00_5022 = VECTOR_REF(BgL_sz00_5020, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_5023;
							obj_t BgL_wherez00_5024;
							obj_t BgL_locz00_5025;

							BgL_z12denvz12_5023 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5024 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18796))->BgL_wherez00);
							BgL_locz00_5025 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18796))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5023, BgL_wherez00_5024,
									BgL_locz00_5025);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_5026;

									BgL_za2za2resza2za2z00_5026 =
										PROCEDURE_ENTRY(BgL_bodyz00_18797) (BgL_bodyz00_18797,
										BgL_sz00_5020, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5023);
									return BgL_za2za2resza2za2z00_5026;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3611> */
	obj_t BGl_z62zc3anonymousza33611ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18799, obj_t BgL_sz00_18804)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18800;
				BgL_ev_absz00_bglt BgL_i1245z00_18801;
				obj_t BgL_bodyz00_18802;
				long BgL_siza7ezd2framez75_18803;

				BgL_iboxesz00_18800 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18799, (int) (((long) 0))));
				BgL_i1245z00_18801 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18799, (int) (((long) 1))));
				BgL_bodyz00_18802 = PROCEDURE_REF(BgL_envz00_18799, (int) (((long) 2)));
				BgL_siza7ezd2framez75_18803 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18799, (int) (((long) 3))));
				{
					obj_t BgL_sz00_5028;

					BgL_sz00_5028 = BgL_sz00_18804;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5030;

						BgL_bpz00_5030 = VECTOR_REF(BgL_sz00_5028, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18389;

								BgL_runz00_18389 =
									MAKE_FX_PROCEDURE(BGl_z62run5522z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18389,
									(int) (((long) 0)), BgL_iboxesz00_18800);
								PROCEDURE_SET(BgL_runz00_18389,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_18801));
								PROCEDURE_SET(BgL_runz00_18389,
									(int) (((long) 2)), BgL_bodyz00_18802);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18390;

									BgL_mainz00_18390 =
										MAKE_FX_PROCEDURE(BGl_z62main5521z62zz__evaluate_compz00,
										(int) (((long) 3)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18390,
										(int) (((long) 0)), BgL_iboxesz00_18800);
									PROCEDURE_SET(BgL_mainz00_18390,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_18801));
									PROCEDURE_SET(BgL_mainz00_18390,
										(int) (((long) 2)), BgL_bodyz00_18802);
									PROCEDURE_SET(BgL_mainz00_18390,
										(int) (((long) 3)), BgL_runz00_18389);
									PROCEDURE_SET(BgL_mainz00_18390,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_18803));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_15733;

										BgL_objz00_15733 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18389, BgL_objz00_15733);
										BgL_objz00_15733;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3613z00_5033;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3614z00_5034;

											BgL_arg3614z00_5034 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18801))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_15735;

												BgL_framez00_15735 = BINT(BgL_siza7ezd2framez75_18803);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_15737;

													BgL_newz00_15737 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29814;

														BgL_auxz00_29814 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_15737, BgL_auxz00_29814,
															BgL_arg3614z00_5034);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29817;

														BgL_auxz00_29817 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_15737, BgL_auxz00_29817,
															BgL_framez00_15735);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29820;

														BgL_auxz00_29820 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_15737, BgL_auxz00_29820,
															BgL_runz00_18389);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_29825;
														int BgL_auxz00_29823;

														BgL_auxz00_29825 = BINT(((long) 3));
														BgL_auxz00_29823 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_15737, BgL_auxz00_29823,
															BgL_auxz00_29825);
													}
													BgL_arg3613z00_5033 = BgL_newz00_15737;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18390, BgL_arg3613z00_5033);
										BgL_arg3613z00_5033;
									}
									return BgL_mainz00_18390;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5521 */
	obj_t BGl_z62main5521z62zz__evaluate_compz00(obj_t BgL_envz00_18805,
		obj_t BgL_bz00_18811, obj_t BgL_cz00_18812, obj_t BgL_dz00_18813)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18809;
				long BgL_siza7ezd2framez75_18810;

				BgL_runz00_18809 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18805, (int) (((long) 3))));
				BgL_siza7ezd2framez75_18810 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18805, (int) (((long) 4))));
				{
					obj_t BgL_bz00_5035;
					obj_t BgL_cz00_5036;
					obj_t BgL_dz00_5037;

					BgL_bz00_5035 = BgL_bz00_18811;
					BgL_cz00_5036 = BgL_cz00_18812;
					BgL_dz00_5037 = BgL_dz00_18813;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5039;

						BgL_sz00_5039 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5040;

							BgL_bpz00_5040 = VECTOR_REF(BgL_sz00_5039, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_29838;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_15662;

									BgL_nz00_15662 = BINT(BgL_siza7ezd2framez75_18810);
									BgL_testz00_29838 =
										(
										((long) CINT(BgL_bpz00_5040) +
											(long) CINT(BgL_nz00_15662)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5039)));
								}
								if (BgL_testz00_29838)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3617z00_5042;

											BgL_arg3617z00_5042 =
												((long) CINT(BgL_bpz00_5040) + ((long) 0));
											VECTOR_SET(BgL_sz00_5039,
												(int) (BgL_arg3617z00_5042), BgL_bz00_5035);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3618z00_5043;

											BgL_arg3618z00_5043 =
												((long) CINT(BgL_bpz00_5040) + ((long) 1));
											VECTOR_SET(BgL_sz00_5039,
												(int) (BgL_arg3618z00_5043), BgL_cz00_5036);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3619z00_5044;

											BgL_arg3619z00_5044 =
												((long) CINT(BgL_bpz00_5040) + ((long) 2));
											VECTOR_SET(BgL_sz00_5039,
												(int) (BgL_arg3619z00_5044), BgL_dz00_5037);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5045;

											BgL_ez00_5045 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5045, BgL_bpz00_5040);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5046;

												BgL_accz00_5046 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18809, BgL_sz00_5039, BgL_bpz00_5040);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5045);
												VECTOR_SET(BgL_sz00_5039, (int) (((long) 0)),
													BgL_bpz00_5040);
												return BgL_accz00_5046;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5047;

										BgL_nsz00_5047 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5047,
											(int) (((long) 1)), BgL_sz00_5039);
										VECTOR_SET(BgL_nsz00_5047,
											(int) (((long) 2)), BgL_bz00_5035);
										VECTOR_SET(BgL_nsz00_5047,
											(int) (((long) 3)), BgL_cz00_5036);
										VECTOR_SET(BgL_nsz00_5047,
											(int) (((long) 4)), BgL_dz00_5037);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5048;

											BgL_z12denvz12_5048 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5048, BgL_nsz00_5047);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5049;

												BgL_ez00_5049 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5049, BgL_sz00_5039);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5050;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_15708;

														BgL_savedzd2bpzd2_15708 =
															VECTOR_REF(BgL_nsz00_5047, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5047,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_15715;

															BgL_fz00_15715 = BgL_runz00_18809;
														BgL_recz00_15714:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_15716;

																BgL_rz00_15716 =
																	PROCEDURE_ENTRY(BgL_fz00_15715)
																	(BgL_fz00_15715, BgL_nsz00_5047, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_29886;

																	if (PROCEDUREP(BgL_rz00_15716))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_15721;

																			BgL_arg1673z00_15721 =
																				PROCEDURE_ATTR(BgL_rz00_15716);
																			if (STRUCTP(BgL_arg1673z00_15721))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29886 =
																						(STRUCT_KEY(BgL_arg1673z00_15721) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_29886 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_29886 = ((bool_t) 0);
																		}
																	if (BgL_testz00_29886)
																		{
																			obj_t BgL_fz00_29894;

																			BgL_fz00_29894 = BgL_rz00_15716;
																			BgL_fz00_15715 = BgL_fz00_29894;
																			goto BgL_recz00_15714;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5047,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_15708);
																			BgL_____rz00_5050 = BgL_rz00_15716;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5049);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5048,
														BgL_sz00_5039);
													return BgL_____rz00_5050;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5522 */
	obj_t BGl_z62run5522z62zz__evaluate_compz00(obj_t BgL_envz00_18814,
		obj_t BgL_sz00_18818)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18815;
				BgL_ev_absz00_bglt BgL_i1245z00_18816;
				obj_t BgL_bodyz00_18817;

				BgL_iboxesz00_18815 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18814, (int) (((long) 0))));
				BgL_i1245z00_18816 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18814, (int) (((long) 1))));
				BgL_bodyz00_18817 = PROCEDURE_REF(BgL_envz00_18814, (int) (((long) 2)));
				{
					obj_t BgL_sz00_5052;

					BgL_sz00_5052 = BgL_sz00_18818;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5054;

						BgL_bpz00_5054 = VECTOR_REF(BgL_sz00_5052, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5052,
							BgL_iboxesz00_18815, BgL_bpz00_5054);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_5055;
							obj_t BgL_wherez00_5056;
							obj_t BgL_locz00_5057;

							BgL_z12denvz12_5055 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5056 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18816))->BgL_wherez00);
							BgL_locz00_5057 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18816))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5055, BgL_wherez00_5056,
									BgL_locz00_5057);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_5058;

									BgL_za2za2resza2za2z00_5058 =
										PROCEDURE_ENTRY(BgL_bodyz00_18817) (BgL_bodyz00_18817,
										BgL_sz00_5052, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5055);
									return BgL_za2za2resza2za2z00_5058;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3623> */
	obj_t BGl_z62zc3anonymousza33623ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18819, obj_t BgL_sz00_18825)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18820;
				long BgL_siza7eza7_18821;
				BgL_ev_absz00_bglt BgL_i1245z00_18822;
				obj_t BgL_bodyz00_18823;
				long BgL_siza7ezd2framez75_18824;

				BgL_ifreesz00_18820 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18819, (int) (((long) 0))));
				BgL_siza7eza7_18821 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18819, (int) (((long) 1))));
				BgL_i1245z00_18822 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18819, (int) (((long) 2))));
				BgL_bodyz00_18823 = PROCEDURE_REF(BgL_envz00_18819, (int) (((long) 3)));
				BgL_siza7ezd2framez75_18824 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18819, (int) (((long) 4))));
				{
					obj_t BgL_sz00_5062;

					BgL_sz00_5062 = BgL_sz00_18825;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5064;

						BgL_bpz00_5064 = VECTOR_REF(BgL_sz00_5062, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_5065;

							BgL_valza2za2_5065 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5062,
								BgL_bpz00_5064, BgL_ifreesz00_18820);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18386;

								BgL_runz00_18386 =
									MAKE_FX_PROCEDURE(BGl_z62run5524z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18386,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18821));
								PROCEDURE_SET(BgL_runz00_18386,
									(int) (((long) 1)), BgL_valza2za2_5065);
								PROCEDURE_SET(BgL_runz00_18386,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_18822));
								PROCEDURE_SET(BgL_runz00_18386,
									(int) (((long) 3)), BgL_bodyz00_18823);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18387;

									BgL_mainz00_18387 =
										MAKE_FX_PROCEDURE(BGl_z62main5523z62zz__evaluate_compz00,
										(int) (((long) 3)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18387,
										(int) (((long) 0)), BINT(BgL_siza7eza7_18821));
									PROCEDURE_SET(BgL_mainz00_18387,
										(int) (((long) 1)), BgL_valza2za2_5065);
									PROCEDURE_SET(BgL_mainz00_18387,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_18822));
									PROCEDURE_SET(BgL_mainz00_18387,
										(int) (((long) 3)), BgL_bodyz00_18823);
									PROCEDURE_SET(BgL_mainz00_18387,
										(int) (((long) 4)), BgL_runz00_18386);
									PROCEDURE_SET(BgL_mainz00_18387,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_18824));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_15844;

										BgL_objz00_15844 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18386, BgL_objz00_15844);
										BgL_objz00_15844;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3624z00_5068;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3625z00_5069;

											BgL_arg3625z00_5069 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18822))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_15846;

												BgL_framez00_15846 = BINT(BgL_siza7ezd2framez75_18824);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_15848;

													BgL_newz00_15848 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29972;

														BgL_auxz00_29972 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_15848, BgL_auxz00_29972,
															BgL_arg3625z00_5069);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29975;

														BgL_auxz00_29975 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_15848, BgL_auxz00_29975,
															BgL_framez00_15846);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_29978;

														BgL_auxz00_29978 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_15848, BgL_auxz00_29978,
															BgL_runz00_18386);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_29983;
														int BgL_auxz00_29981;

														BgL_auxz00_29983 = BINT(((long) 3));
														BgL_auxz00_29981 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_15848, BgL_auxz00_29981,
															BgL_auxz00_29983);
													}
													BgL_arg3624z00_5068 = BgL_newz00_15848;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18387, BgL_arg3624z00_5068);
										BgL_arg3624z00_5068;
									}
									return BgL_mainz00_18387;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5523 */
	obj_t BGl_z62main5523z62zz__evaluate_compz00(obj_t BgL_envz00_18826,
		obj_t BgL_bz00_18833, obj_t BgL_cz00_18834, obj_t BgL_dz00_18835)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18831;
				long BgL_siza7ezd2framez75_18832;

				BgL_runz00_18831 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18826, (int) (((long) 4))));
				BgL_siza7ezd2framez75_18832 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18826, (int) (((long) 5))));
				{
					obj_t BgL_bz00_5070;
					obj_t BgL_cz00_5071;
					obj_t BgL_dz00_5072;

					BgL_bz00_5070 = BgL_bz00_18833;
					BgL_cz00_5071 = BgL_cz00_18834;
					BgL_dz00_5072 = BgL_dz00_18835;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5074;

						BgL_sz00_5074 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5075;

							BgL_bpz00_5075 = VECTOR_REF(BgL_sz00_5074, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_29996;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_15773;

									BgL_nz00_15773 = BINT(BgL_siza7ezd2framez75_18832);
									BgL_testz00_29996 =
										(
										((long) CINT(BgL_bpz00_5075) +
											(long) CINT(BgL_nz00_15773)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5074)));
								}
								if (BgL_testz00_29996)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3628z00_5077;

											BgL_arg3628z00_5077 =
												((long) CINT(BgL_bpz00_5075) + ((long) 0));
											VECTOR_SET(BgL_sz00_5074,
												(int) (BgL_arg3628z00_5077), BgL_bz00_5070);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3629z00_5078;

											BgL_arg3629z00_5078 =
												((long) CINT(BgL_bpz00_5075) + ((long) 1));
											VECTOR_SET(BgL_sz00_5074,
												(int) (BgL_arg3629z00_5078), BgL_cz00_5071);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3630z00_5079;

											BgL_arg3630z00_5079 =
												((long) CINT(BgL_bpz00_5075) + ((long) 2));
											VECTOR_SET(BgL_sz00_5074,
												(int) (BgL_arg3630z00_5079), BgL_dz00_5072);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5080;

											BgL_ez00_5080 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5080, BgL_bpz00_5075);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5081;

												BgL_accz00_5081 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18831, BgL_sz00_5074, BgL_bpz00_5075);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5080);
												VECTOR_SET(BgL_sz00_5074, (int) (((long) 0)),
													BgL_bpz00_5075);
												return BgL_accz00_5081;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5082;

										BgL_nsz00_5082 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5082,
											(int) (((long) 1)), BgL_sz00_5074);
										VECTOR_SET(BgL_nsz00_5082,
											(int) (((long) 2)), BgL_bz00_5070);
										VECTOR_SET(BgL_nsz00_5082,
											(int) (((long) 3)), BgL_cz00_5071);
										VECTOR_SET(BgL_nsz00_5082,
											(int) (((long) 4)), BgL_dz00_5072);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5083;

											BgL_z12denvz12_5083 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5083, BgL_nsz00_5082);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5084;

												BgL_ez00_5084 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5084, BgL_sz00_5074);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5085;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_15819;

														BgL_savedzd2bpzd2_15819 =
															VECTOR_REF(BgL_nsz00_5082, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5082,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_15826;

															BgL_fz00_15826 = BgL_runz00_18831;
														BgL_recz00_15825:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_15827;

																BgL_rz00_15827 =
																	PROCEDURE_ENTRY(BgL_fz00_15826)
																	(BgL_fz00_15826, BgL_nsz00_5082, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_30044;

																	if (PROCEDUREP(BgL_rz00_15827))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_15832;

																			BgL_arg1673z00_15832 =
																				PROCEDURE_ATTR(BgL_rz00_15827);
																			if (STRUCTP(BgL_arg1673z00_15832))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30044 =
																						(STRUCT_KEY(BgL_arg1673z00_15832) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30044 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_30044 = ((bool_t) 0);
																		}
																	if (BgL_testz00_30044)
																		{
																			obj_t BgL_fz00_30052;

																			BgL_fz00_30052 = BgL_rz00_15827;
																			BgL_fz00_15826 = BgL_fz00_30052;
																			goto BgL_recz00_15825;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5082,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_15819);
																			BgL_____rz00_5085 = BgL_rz00_15827;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5084);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5083,
														BgL_sz00_5074);
													return BgL_____rz00_5085;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5524 */
	obj_t BGl_z62run5524z62zz__evaluate_compz00(obj_t BgL_envz00_18836,
		obj_t BgL_sz00_18841)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_18837;
				obj_t BgL_valza2za2_18838;
				BgL_ev_absz00_bglt BgL_i1245z00_18839;
				obj_t BgL_bodyz00_18840;

				BgL_siza7eza7_18837 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18836, (int) (((long) 0))));
				BgL_valza2za2_18838 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18836, (int) (((long) 1))));
				BgL_i1245z00_18839 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18836, (int) (((long) 2))));
				BgL_bodyz00_18840 = PROCEDURE_REF(BgL_envz00_18836, (int) (((long) 3)));
				{
					obj_t BgL_sz00_5087;

					BgL_sz00_5087 = BgL_sz00_18841;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5089;

						BgL_bpz00_5089 = VECTOR_REF(BgL_sz00_5087, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5087,
							BgL_valza2za2_18838,
							((long) CINT(BgL_bpz00_5089) + BgL_siza7eza7_18837));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_5091;
							obj_t BgL_wherez00_5092;
							obj_t BgL_locz00_5093;

							BgL_z12denvz12_5091 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5092 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18839))->BgL_wherez00);
							BgL_locz00_5093 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18839))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5091, BgL_wherez00_5092,
									BgL_locz00_5093);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_5094;

									BgL_za2za2resza2za2z00_5094 =
										PROCEDURE_ENTRY(BgL_bodyz00_18840) (BgL_bodyz00_18840,
										BgL_sz00_5087, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5091);
									return BgL_za2za2resza2za2z00_5094;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3633> */
	obj_t BGl_z62zc3anonymousza33633ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18842, obj_t BgL_sz00_18849)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18843;
				obj_t BgL_iboxesz00_18844;
				long BgL_siza7eza7_18845;
				BgL_ev_absz00_bglt BgL_i1245z00_18846;
				obj_t BgL_bodyz00_18847;
				long BgL_siza7ezd2framez75_18848;

				BgL_ifreesz00_18843 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18842, (int) (((long) 0))));
				BgL_iboxesz00_18844 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18842, (int) (((long) 1))));
				BgL_siza7eza7_18845 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18842, (int) (((long) 2))));
				BgL_i1245z00_18846 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18842, (int) (((long) 3))));
				BgL_bodyz00_18847 = PROCEDURE_REF(BgL_envz00_18842, (int) (((long) 4)));
				BgL_siza7ezd2framez75_18848 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18842, (int) (((long) 5))));
				{
					obj_t BgL_sz00_5096;

					BgL_sz00_5096 = BgL_sz00_18849;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5098;

						BgL_bpz00_5098 = VECTOR_REF(BgL_sz00_5096, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_5099;

							BgL_valza2za2_5099 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5096,
								BgL_bpz00_5098, BgL_ifreesz00_18843);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18383;

								BgL_runz00_18383 =
									MAKE_FX_PROCEDURE(BGl_z62run5526z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18383,
									(int) (((long) 0)), BgL_iboxesz00_18844);
								PROCEDURE_SET(BgL_runz00_18383,
									(int) (((long) 1)), BINT(BgL_siza7eza7_18845));
								PROCEDURE_SET(BgL_runz00_18383,
									(int) (((long) 2)), BgL_valza2za2_5099);
								PROCEDURE_SET(BgL_runz00_18383,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_18846));
								PROCEDURE_SET(BgL_runz00_18383,
									(int) (((long) 4)), BgL_bodyz00_18847);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18384;

									BgL_mainz00_18384 =
										MAKE_FX_PROCEDURE(BGl_z62main5525z62zz__evaluate_compz00,
										(int) (((long) 3)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18384,
										(int) (((long) 0)), BgL_iboxesz00_18844);
									PROCEDURE_SET(BgL_mainz00_18384,
										(int) (((long) 1)), BINT(BgL_siza7eza7_18845));
									PROCEDURE_SET(BgL_mainz00_18384,
										(int) (((long) 2)), BgL_valza2za2_5099);
									PROCEDURE_SET(BgL_mainz00_18384,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_18846));
									PROCEDURE_SET(BgL_mainz00_18384,
										(int) (((long) 4)), BgL_bodyz00_18847);
									PROCEDURE_SET(BgL_mainz00_18384,
										(int) (((long) 5)), BgL_runz00_18383);
									PROCEDURE_SET(BgL_mainz00_18384,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_18848));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_15951;

										BgL_objz00_15951 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18383, BgL_objz00_15951);
										BgL_objz00_15951;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3635z00_5102;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3636z00_5103;

											BgL_arg3636z00_5103 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18846))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_15953;

												BgL_framez00_15953 = BINT(BgL_siza7ezd2framez75_18848);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_15955;

													BgL_newz00_15955 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30142;

														BgL_auxz00_30142 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_15955, BgL_auxz00_30142,
															BgL_arg3636z00_5103);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30145;

														BgL_auxz00_30145 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_15955, BgL_auxz00_30145,
															BgL_framez00_15953);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30148;

														BgL_auxz00_30148 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_15955, BgL_auxz00_30148,
															BgL_runz00_18383);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_30153;
														int BgL_auxz00_30151;

														BgL_auxz00_30153 = BINT(((long) 3));
														BgL_auxz00_30151 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_15955, BgL_auxz00_30151,
															BgL_auxz00_30153);
													}
													BgL_arg3635z00_5102 = BgL_newz00_15955;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18384, BgL_arg3635z00_5102);
										BgL_arg3635z00_5102;
									}
									return BgL_mainz00_18384;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5525 */
	obj_t BGl_z62main5525z62zz__evaluate_compz00(obj_t BgL_envz00_18850,
		obj_t BgL_bz00_18858, obj_t BgL_cz00_18859, obj_t BgL_dz00_18860)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18856;
				long BgL_siza7ezd2framez75_18857;

				BgL_runz00_18856 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18850, (int) (((long) 5))));
				BgL_siza7ezd2framez75_18857 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18850, (int) (((long) 6))));
				{
					obj_t BgL_bz00_5104;
					obj_t BgL_cz00_5105;
					obj_t BgL_dz00_5106;

					BgL_bz00_5104 = BgL_bz00_18858;
					BgL_cz00_5105 = BgL_cz00_18859;
					BgL_dz00_5106 = BgL_dz00_18860;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5108;

						BgL_sz00_5108 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5109;

							BgL_bpz00_5109 = VECTOR_REF(BgL_sz00_5108, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_30166;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_15880;

									BgL_nz00_15880 = BINT(BgL_siza7ezd2framez75_18857);
									BgL_testz00_30166 =
										(
										((long) CINT(BgL_bpz00_5109) +
											(long) CINT(BgL_nz00_15880)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5108)));
								}
								if (BgL_testz00_30166)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3639z00_5111;

											BgL_arg3639z00_5111 =
												((long) CINT(BgL_bpz00_5109) + ((long) 0));
											VECTOR_SET(BgL_sz00_5108,
												(int) (BgL_arg3639z00_5111), BgL_bz00_5104);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3640z00_5112;

											BgL_arg3640z00_5112 =
												((long) CINT(BgL_bpz00_5109) + ((long) 1));
											VECTOR_SET(BgL_sz00_5108,
												(int) (BgL_arg3640z00_5112), BgL_cz00_5105);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3641z00_5113;

											BgL_arg3641z00_5113 =
												((long) CINT(BgL_bpz00_5109) + ((long) 2));
											VECTOR_SET(BgL_sz00_5108,
												(int) (BgL_arg3641z00_5113), BgL_dz00_5106);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5114;

											BgL_ez00_5114 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5114, BgL_bpz00_5109);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5115;

												BgL_accz00_5115 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18856, BgL_sz00_5108, BgL_bpz00_5109);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5114);
												VECTOR_SET(BgL_sz00_5108, (int) (((long) 0)),
													BgL_bpz00_5109);
												return BgL_accz00_5115;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5116;

										BgL_nsz00_5116 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5116,
											(int) (((long) 1)), BgL_sz00_5108);
										VECTOR_SET(BgL_nsz00_5116,
											(int) (((long) 2)), BgL_bz00_5104);
										VECTOR_SET(BgL_nsz00_5116,
											(int) (((long) 3)), BgL_cz00_5105);
										VECTOR_SET(BgL_nsz00_5116,
											(int) (((long) 4)), BgL_dz00_5106);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5117;

											BgL_z12denvz12_5117 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5117, BgL_nsz00_5116);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5118;

												BgL_ez00_5118 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5118, BgL_sz00_5108);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5119;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_15926;

														BgL_savedzd2bpzd2_15926 =
															VECTOR_REF(BgL_nsz00_5116, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5116,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_15933;

															BgL_fz00_15933 = BgL_runz00_18856;
														BgL_recz00_15932:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_15934;

																BgL_rz00_15934 =
																	PROCEDURE_ENTRY(BgL_fz00_15933)
																	(BgL_fz00_15933, BgL_nsz00_5116, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_30214;

																	if (PROCEDUREP(BgL_rz00_15934))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_15939;

																			BgL_arg1673z00_15939 =
																				PROCEDURE_ATTR(BgL_rz00_15934);
																			if (STRUCTP(BgL_arg1673z00_15939))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30214 =
																						(STRUCT_KEY(BgL_arg1673z00_15939) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30214 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_30214 = ((bool_t) 0);
																		}
																	if (BgL_testz00_30214)
																		{
																			obj_t BgL_fz00_30222;

																			BgL_fz00_30222 = BgL_rz00_15934;
																			BgL_fz00_15933 = BgL_fz00_30222;
																			goto BgL_recz00_15932;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5116,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_15926);
																			BgL_____rz00_5119 = BgL_rz00_15934;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5118);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5117,
														BgL_sz00_5108);
													return BgL_____rz00_5119;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5526 */
	obj_t BGl_z62run5526z62zz__evaluate_compz00(obj_t BgL_envz00_18861,
		obj_t BgL_sz00_18867)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18862;
				long BgL_siza7eza7_18863;
				obj_t BgL_valza2za2_18864;
				BgL_ev_absz00_bglt BgL_i1245z00_18865;
				obj_t BgL_bodyz00_18866;

				BgL_iboxesz00_18862 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18861, (int) (((long) 0))));
				BgL_siza7eza7_18863 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18861, (int) (((long) 1))));
				BgL_valza2za2_18864 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18861, (int) (((long) 2))));
				BgL_i1245z00_18865 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18861, (int) (((long) 3))));
				BgL_bodyz00_18866 = PROCEDURE_REF(BgL_envz00_18861, (int) (((long) 4)));
				{
					obj_t BgL_sz00_5121;

					BgL_sz00_5121 = BgL_sz00_18867;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5123;

						BgL_bpz00_5123 = VECTOR_REF(BgL_sz00_5121, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5121,
							BgL_iboxesz00_18862, BgL_bpz00_5123);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5121,
							BgL_valza2za2_18864,
							((long) CINT(BgL_bpz00_5123) + BgL_siza7eza7_18863));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_5125;
							obj_t BgL_wherez00_5126;
							obj_t BgL_locz00_5127;

							BgL_z12denvz12_5125 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5126 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18865))->BgL_wherez00);
							BgL_locz00_5127 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18865))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5125, BgL_wherez00_5126,
									BgL_locz00_5127);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_5128;

									BgL_za2za2resza2za2z00_5128 =
										PROCEDURE_ENTRY(BgL_bodyz00_18866) (BgL_bodyz00_18866,
										BgL_sz00_5121, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5125);
									return BgL_za2za2resza2za2z00_5128;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3549> */
	obj_t BGl_z62zc3anonymousza33549ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18868, obj_t BgL_sz00_18872)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18869;
				obj_t BgL_bodyz00_18870;
				long BgL_siza7ezd2framez75_18871;

				BgL_i1245z00_18869 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18868, (int) (((long) 0))));
				BgL_bodyz00_18870 = PROCEDURE_REF(BgL_envz00_18868, (int) (((long) 1)));
				BgL_siza7ezd2framez75_18871 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18868, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4858;

					BgL_sz00_4858 = BgL_sz00_18872;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4860;

						BgL_bpz00_4860 = VECTOR_REF(BgL_sz00_4858, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18380;

								BgL_runz00_18380 =
									MAKE_FX_PROCEDURE(BGl_z62run5528z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18380,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_18869));
								PROCEDURE_SET(BgL_runz00_18380,
									(int) (((long) 1)), BgL_bodyz00_18870);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18381;

									BgL_mainz00_18381 =
										MAKE_VA_PROCEDURE(BGl_z62main5527z62zz__evaluate_compz00,
										(int) (((long) -3)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18381,
										(int) (((long) 0)), ((obj_t) BgL_i1245z00_18869));
									PROCEDURE_SET(BgL_mainz00_18381,
										(int) (((long) 1)), BgL_bodyz00_18870);
									PROCEDURE_SET(BgL_mainz00_18381,
										(int) (((long) 2)), BgL_runz00_18380);
									PROCEDURE_SET(BgL_mainz00_18381,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_18871));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_15195;

										BgL_objz00_15195 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18380, BgL_objz00_15195);
										BgL_objz00_15195;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3550z00_4863;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3552z00_4864;

											BgL_arg3552z00_4864 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18869))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_15197;

												BgL_framez00_15197 = BINT(BgL_siza7ezd2framez75_18871);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_15199;

													BgL_newz00_15199 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30292;

														BgL_auxz00_30292 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_15199, BgL_auxz00_30292,
															BgL_arg3552z00_4864);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30295;

														BgL_auxz00_30295 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_15199, BgL_auxz00_30295,
															BgL_framez00_15197);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30298;

														BgL_auxz00_30298 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_15199, BgL_auxz00_30298,
															BgL_runz00_18380);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_30303;
														int BgL_auxz00_30301;

														BgL_auxz00_30303 = BINT(((long) -3));
														BgL_auxz00_30301 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_15199, BgL_auxz00_30301,
															BgL_auxz00_30303);
													}
													BgL_arg3550z00_4863 = BgL_newz00_15199;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18381, BgL_arg3550z00_4863);
										BgL_arg3550z00_4863;
									}
									return BgL_mainz00_18381;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5527 */
	obj_t BGl_z62main5527z62zz__evaluate_compz00(obj_t BgL_envz00_18873,
		obj_t BgL_cz00_18878, obj_t BgL_dz00_18879, obj_t BgL_lastz00_18880)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18876;
				long BgL_siza7ezd2framez75_18877;

				BgL_runz00_18876 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18873, (int) (((long) 2))));
				BgL_siza7ezd2framez75_18877 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18873, (int) (((long) 3))));
				{
					obj_t BgL_cz00_4865;
					obj_t BgL_dz00_4866;
					obj_t BgL_lastz00_4867;

					BgL_cz00_4865 = BgL_cz00_18878;
					BgL_dz00_4866 = BgL_dz00_18879;
					BgL_lastz00_4867 = BgL_lastz00_18880;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4869;

						BgL_sz00_4869 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4870;

							BgL_bpz00_4870 = VECTOR_REF(BgL_sz00_4869, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_30316;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_15124;

									BgL_nz00_15124 = BINT(BgL_siza7ezd2framez75_18877);
									BgL_testz00_30316 =
										(
										((long) CINT(BgL_bpz00_4870) +
											(long) CINT(BgL_nz00_15124)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4869)));
								}
								if (BgL_testz00_30316)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3555z00_4872;

											BgL_arg3555z00_4872 =
												((long) CINT(BgL_bpz00_4870) + ((long) 0));
											VECTOR_SET(BgL_sz00_4869,
												(int) (BgL_arg3555z00_4872), BgL_cz00_4865);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3556z00_4873;

											BgL_arg3556z00_4873 =
												((long) CINT(BgL_bpz00_4870) + ((long) 1));
											VECTOR_SET(BgL_sz00_4869,
												(int) (BgL_arg3556z00_4873), BgL_dz00_4866);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3558z00_4874;

											BgL_arg3558z00_4874 =
												((long) CINT(BgL_bpz00_4870) + ((long) 2));
											VECTOR_SET(BgL_sz00_4869,
												(int) (BgL_arg3558z00_4874), BgL_lastz00_4867);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4875;

											BgL_ez00_4875 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4875, BgL_bpz00_4870);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4876;

												BgL_accz00_4876 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18876, BgL_sz00_4869, BgL_bpz00_4870);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4875);
												VECTOR_SET(BgL_sz00_4869, (int) (((long) 0)),
													BgL_bpz00_4870);
												return BgL_accz00_4876;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4877;

										BgL_nsz00_4877 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4877,
											(int) (((long) 1)), BgL_sz00_4869);
										VECTOR_SET(BgL_nsz00_4877,
											(int) (((long) 2)), BgL_cz00_4865);
										VECTOR_SET(BgL_nsz00_4877,
											(int) (((long) 3)), BgL_dz00_4866);
										VECTOR_SET(BgL_nsz00_4877,
											(int) (((long) 4)), BgL_lastz00_4867);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4878;

											BgL_z12denvz12_4878 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4878, BgL_nsz00_4877);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4879;

												BgL_ez00_4879 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4879, BgL_sz00_4869);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4880;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_15170;

														BgL_savedzd2bpzd2_15170 =
															VECTOR_REF(BgL_nsz00_4877, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4877,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_15177;

															BgL_fz00_15177 = BgL_runz00_18876;
														BgL_recz00_15176:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_15178;

																BgL_rz00_15178 =
																	PROCEDURE_ENTRY(BgL_fz00_15177)
																	(BgL_fz00_15177, BgL_nsz00_4877, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_30364;

																	if (PROCEDUREP(BgL_rz00_15178))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_15183;

																			BgL_arg1673z00_15183 =
																				PROCEDURE_ATTR(BgL_rz00_15178);
																			if (STRUCTP(BgL_arg1673z00_15183))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30364 =
																						(STRUCT_KEY(BgL_arg1673z00_15183) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30364 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_30364 = ((bool_t) 0);
																		}
																	if (BgL_testz00_30364)
																		{
																			obj_t BgL_fz00_30372;

																			BgL_fz00_30372 = BgL_rz00_15178;
																			BgL_fz00_15177 = BgL_fz00_30372;
																			goto BgL_recz00_15176;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4877,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_15170);
																			BgL_____rz00_4880 = BgL_rz00_15178;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4879);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4878,
														BgL_sz00_4869);
													return BgL_____rz00_4880;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5528 */
	obj_t BGl_z62run5528z62zz__evaluate_compz00(obj_t BgL_envz00_18881,
		obj_t BgL_sz00_18884)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18882;
				obj_t BgL_bodyz00_18883;

				BgL_i1245z00_18882 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18881, (int) (((long) 0))));
				BgL_bodyz00_18883 = PROCEDURE_REF(BgL_envz00_18881, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4882;

					BgL_sz00_4882 = BgL_sz00_18884;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4884;

						BgL_bpz00_4884 = VECTOR_REF(BgL_sz00_4882, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4885;
							obj_t BgL_wherez00_4886;
							obj_t BgL_locz00_4887;

							BgL_z12denvz12_4885 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4886 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18882))->BgL_wherez00);
							BgL_locz00_4887 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18882))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4885, BgL_wherez00_4886,
									BgL_locz00_4887);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4888;

									BgL_za2za2resza2za2z00_4888 =
										PROCEDURE_ENTRY(BgL_bodyz00_18883) (BgL_bodyz00_18883,
										BgL_sz00_4882, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4885);
									return BgL_za2za2resza2za2z00_4888;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3560> */
	obj_t BGl_z62zc3anonymousza33560ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18885, obj_t BgL_sz00_18890)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18886;
				BgL_ev_absz00_bglt BgL_i1245z00_18887;
				obj_t BgL_bodyz00_18888;
				long BgL_siza7ezd2framez75_18889;

				BgL_iboxesz00_18886 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18885, (int) (((long) 0))));
				BgL_i1245z00_18887 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18885, (int) (((long) 1))));
				BgL_bodyz00_18888 = PROCEDURE_REF(BgL_envz00_18885, (int) (((long) 2)));
				BgL_siza7ezd2framez75_18889 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18885, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4890;

					BgL_sz00_4890 = BgL_sz00_18890;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4892;

						BgL_bpz00_4892 = VECTOR_REF(BgL_sz00_4890, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18377;

								BgL_runz00_18377 =
									MAKE_FX_PROCEDURE(BGl_z62run5530z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18377,
									(int) (((long) 0)), BgL_iboxesz00_18886);
								PROCEDURE_SET(BgL_runz00_18377,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_18887));
								PROCEDURE_SET(BgL_runz00_18377,
									(int) (((long) 2)), BgL_bodyz00_18888);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18378;

									BgL_mainz00_18378 =
										MAKE_VA_PROCEDURE(BGl_z62main5529z62zz__evaluate_compz00,
										(int) (((long) -3)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18378,
										(int) (((long) 0)), BgL_iboxesz00_18886);
									PROCEDURE_SET(BgL_mainz00_18378,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_18887));
									PROCEDURE_SET(BgL_mainz00_18378,
										(int) (((long) 2)), BgL_bodyz00_18888);
									PROCEDURE_SET(BgL_mainz00_18378,
										(int) (((long) 3)), BgL_runz00_18377);
									PROCEDURE_SET(BgL_mainz00_18378,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_18889));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_15299;

										BgL_objz00_15299 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18377, BgL_objz00_15299);
										BgL_objz00_15299;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3561z00_4895;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3562z00_4896;

											BgL_arg3562z00_4896 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18887))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_15301;

												BgL_framez00_15301 = BINT(BgL_siza7ezd2framez75_18889);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_15303;

													BgL_newz00_15303 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30436;

														BgL_auxz00_30436 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_15303, BgL_auxz00_30436,
															BgL_arg3562z00_4896);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30439;

														BgL_auxz00_30439 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_15303, BgL_auxz00_30439,
															BgL_framez00_15301);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30442;

														BgL_auxz00_30442 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_15303, BgL_auxz00_30442,
															BgL_runz00_18377);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_30447;
														int BgL_auxz00_30445;

														BgL_auxz00_30447 = BINT(((long) -3));
														BgL_auxz00_30445 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_15303, BgL_auxz00_30445,
															BgL_auxz00_30447);
													}
													BgL_arg3561z00_4895 = BgL_newz00_15303;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18378, BgL_arg3561z00_4895);
										BgL_arg3561z00_4895;
									}
									return BgL_mainz00_18378;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5529 */
	obj_t BGl_z62main5529z62zz__evaluate_compz00(obj_t BgL_envz00_18891,
		obj_t BgL_cz00_18897, obj_t BgL_dz00_18898, obj_t BgL_lastz00_18899)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18895;
				long BgL_siza7ezd2framez75_18896;

				BgL_runz00_18895 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18891, (int) (((long) 3))));
				BgL_siza7ezd2framez75_18896 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18891, (int) (((long) 4))));
				{
					obj_t BgL_cz00_4897;
					obj_t BgL_dz00_4898;
					obj_t BgL_lastz00_4899;

					BgL_cz00_4897 = BgL_cz00_18897;
					BgL_dz00_4898 = BgL_dz00_18898;
					BgL_lastz00_4899 = BgL_lastz00_18899;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4901;

						BgL_sz00_4901 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4902;

							BgL_bpz00_4902 = VECTOR_REF(BgL_sz00_4901, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_30460;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_15228;

									BgL_nz00_15228 = BINT(BgL_siza7ezd2framez75_18896);
									BgL_testz00_30460 =
										(
										((long) CINT(BgL_bpz00_4902) +
											(long) CINT(BgL_nz00_15228)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4901)));
								}
								if (BgL_testz00_30460)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3566z00_4904;

											BgL_arg3566z00_4904 =
												((long) CINT(BgL_bpz00_4902) + ((long) 0));
											VECTOR_SET(BgL_sz00_4901,
												(int) (BgL_arg3566z00_4904), BgL_cz00_4897);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3567z00_4905;

											BgL_arg3567z00_4905 =
												((long) CINT(BgL_bpz00_4902) + ((long) 1));
											VECTOR_SET(BgL_sz00_4901,
												(int) (BgL_arg3567z00_4905), BgL_dz00_4898);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3569z00_4906;

											BgL_arg3569z00_4906 =
												((long) CINT(BgL_bpz00_4902) + ((long) 2));
											VECTOR_SET(BgL_sz00_4901,
												(int) (BgL_arg3569z00_4906), BgL_lastz00_4899);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4907;

											BgL_ez00_4907 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4907, BgL_bpz00_4902);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4908;

												BgL_accz00_4908 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18895, BgL_sz00_4901, BgL_bpz00_4902);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4907);
												VECTOR_SET(BgL_sz00_4901, (int) (((long) 0)),
													BgL_bpz00_4902);
												return BgL_accz00_4908;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4909;

										BgL_nsz00_4909 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4909,
											(int) (((long) 1)), BgL_sz00_4901);
										VECTOR_SET(BgL_nsz00_4909,
											(int) (((long) 2)), BgL_cz00_4897);
										VECTOR_SET(BgL_nsz00_4909,
											(int) (((long) 3)), BgL_dz00_4898);
										VECTOR_SET(BgL_nsz00_4909,
											(int) (((long) 4)), BgL_lastz00_4899);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4910;

											BgL_z12denvz12_4910 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4910, BgL_nsz00_4909);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4911;

												BgL_ez00_4911 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4911, BgL_sz00_4901);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4912;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_15274;

														BgL_savedzd2bpzd2_15274 =
															VECTOR_REF(BgL_nsz00_4909, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4909,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_15281;

															BgL_fz00_15281 = BgL_runz00_18895;
														BgL_recz00_15280:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_15282;

																BgL_rz00_15282 =
																	PROCEDURE_ENTRY(BgL_fz00_15281)
																	(BgL_fz00_15281, BgL_nsz00_4909, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_30508;

																	if (PROCEDUREP(BgL_rz00_15282))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_15287;

																			BgL_arg1673z00_15287 =
																				PROCEDURE_ATTR(BgL_rz00_15282);
																			if (STRUCTP(BgL_arg1673z00_15287))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30508 =
																						(STRUCT_KEY(BgL_arg1673z00_15287) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30508 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_30508 = ((bool_t) 0);
																		}
																	if (BgL_testz00_30508)
																		{
																			obj_t BgL_fz00_30516;

																			BgL_fz00_30516 = BgL_rz00_15282;
																			BgL_fz00_15281 = BgL_fz00_30516;
																			goto BgL_recz00_15280;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4909,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_15274);
																			BgL_____rz00_4912 = BgL_rz00_15282;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4911);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4910,
														BgL_sz00_4901);
													return BgL_____rz00_4912;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5530 */
	obj_t BGl_z62run5530z62zz__evaluate_compz00(obj_t BgL_envz00_18900,
		obj_t BgL_sz00_18904)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18901;
				BgL_ev_absz00_bglt BgL_i1245z00_18902;
				obj_t BgL_bodyz00_18903;

				BgL_iboxesz00_18901 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18900, (int) (((long) 0))));
				BgL_i1245z00_18902 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18900, (int) (((long) 1))));
				BgL_bodyz00_18903 = PROCEDURE_REF(BgL_envz00_18900, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4914;

					BgL_sz00_4914 = BgL_sz00_18904;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4916;

						BgL_bpz00_4916 = VECTOR_REF(BgL_sz00_4914, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4914,
							BgL_iboxesz00_18901, BgL_bpz00_4916);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4917;
							obj_t BgL_wherez00_4918;
							obj_t BgL_locz00_4919;

							BgL_z12denvz12_4917 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4918 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18902))->BgL_wherez00);
							BgL_locz00_4919 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18902))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4917, BgL_wherez00_4918,
									BgL_locz00_4919);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4920;

									BgL_za2za2resza2za2z00_4920 =
										PROCEDURE_ENTRY(BgL_bodyz00_18903) (BgL_bodyz00_18903,
										BgL_sz00_4914, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4917);
									return BgL_za2za2resza2za2z00_4920;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3574> */
	obj_t BGl_z62zc3anonymousza33574ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18905, obj_t BgL_sz00_18911)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18906;
				long BgL_siza7eza7_18907;
				BgL_ev_absz00_bglt BgL_i1245z00_18908;
				obj_t BgL_bodyz00_18909;
				long BgL_siza7ezd2framez75_18910;

				BgL_ifreesz00_18906 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18905, (int) (((long) 0))));
				BgL_siza7eza7_18907 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18905, (int) (((long) 1))));
				BgL_i1245z00_18908 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18905, (int) (((long) 2))));
				BgL_bodyz00_18909 = PROCEDURE_REF(BgL_envz00_18905, (int) (((long) 3)));
				BgL_siza7ezd2framez75_18910 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18905, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4924;

					BgL_sz00_4924 = BgL_sz00_18911;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4926;

						BgL_bpz00_4926 = VECTOR_REF(BgL_sz00_4924, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4927;

							BgL_valza2za2_4927 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4924,
								BgL_bpz00_4926, BgL_ifreesz00_18906);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18374;

								BgL_runz00_18374 =
									MAKE_FX_PROCEDURE(BGl_z62run5532z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18374,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18907));
								PROCEDURE_SET(BgL_runz00_18374,
									(int) (((long) 1)), BgL_valza2za2_4927);
								PROCEDURE_SET(BgL_runz00_18374,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_18908));
								PROCEDURE_SET(BgL_runz00_18374,
									(int) (((long) 3)), BgL_bodyz00_18909);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18375;

									BgL_mainz00_18375 =
										MAKE_VA_PROCEDURE(BGl_z62main5531z62zz__evaluate_compz00,
										(int) (((long) -3)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18375,
										(int) (((long) 0)), BINT(BgL_siza7eza7_18907));
									PROCEDURE_SET(BgL_mainz00_18375,
										(int) (((long) 1)), BgL_valza2za2_4927);
									PROCEDURE_SET(BgL_mainz00_18375,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_18908));
									PROCEDURE_SET(BgL_mainz00_18375,
										(int) (((long) 3)), BgL_bodyz00_18909);
									PROCEDURE_SET(BgL_mainz00_18375,
										(int) (((long) 4)), BgL_runz00_18374);
									PROCEDURE_SET(BgL_mainz00_18375,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_18910));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_15410;

										BgL_objz00_15410 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18374, BgL_objz00_15410);
										BgL_objz00_15410;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3575z00_4930;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3576z00_4931;

											BgL_arg3576z00_4931 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18908))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_15412;

												BgL_framez00_15412 = BINT(BgL_siza7ezd2framez75_18910);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_15414;

													BgL_newz00_15414 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30594;

														BgL_auxz00_30594 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_15414, BgL_auxz00_30594,
															BgL_arg3576z00_4931);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30597;

														BgL_auxz00_30597 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_15414, BgL_auxz00_30597,
															BgL_framez00_15412);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30600;

														BgL_auxz00_30600 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_15414, BgL_auxz00_30600,
															BgL_runz00_18374);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_30605;
														int BgL_auxz00_30603;

														BgL_auxz00_30605 = BINT(((long) -3));
														BgL_auxz00_30603 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_15414, BgL_auxz00_30603,
															BgL_auxz00_30605);
													}
													BgL_arg3575z00_4930 = BgL_newz00_15414;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18375, BgL_arg3575z00_4930);
										BgL_arg3575z00_4930;
									}
									return BgL_mainz00_18375;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5531 */
	obj_t BGl_z62main5531z62zz__evaluate_compz00(obj_t BgL_envz00_18912,
		obj_t BgL_cz00_18919, obj_t BgL_dz00_18920, obj_t BgL_lastz00_18921)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18917;
				long BgL_siza7ezd2framez75_18918;

				BgL_runz00_18917 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18912, (int) (((long) 4))));
				BgL_siza7ezd2framez75_18918 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18912, (int) (((long) 5))));
				{
					obj_t BgL_cz00_4932;
					obj_t BgL_dz00_4933;
					obj_t BgL_lastz00_4934;

					BgL_cz00_4932 = BgL_cz00_18919;
					BgL_dz00_4933 = BgL_dz00_18920;
					BgL_lastz00_4934 = BgL_lastz00_18921;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4936;

						BgL_sz00_4936 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4937;

							BgL_bpz00_4937 = VECTOR_REF(BgL_sz00_4936, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_30618;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_15339;

									BgL_nz00_15339 = BINT(BgL_siza7ezd2framez75_18918);
									BgL_testz00_30618 =
										(
										((long) CINT(BgL_bpz00_4937) +
											(long) CINT(BgL_nz00_15339)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4936)));
								}
								if (BgL_testz00_30618)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3579z00_4939;

											BgL_arg3579z00_4939 =
												((long) CINT(BgL_bpz00_4937) + ((long) 0));
											VECTOR_SET(BgL_sz00_4936,
												(int) (BgL_arg3579z00_4939), BgL_cz00_4932);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3581z00_4940;

											BgL_arg3581z00_4940 =
												((long) CINT(BgL_bpz00_4937) + ((long) 1));
											VECTOR_SET(BgL_sz00_4936,
												(int) (BgL_arg3581z00_4940), BgL_dz00_4933);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3582z00_4941;

											BgL_arg3582z00_4941 =
												((long) CINT(BgL_bpz00_4937) + ((long) 2));
											VECTOR_SET(BgL_sz00_4936,
												(int) (BgL_arg3582z00_4941), BgL_lastz00_4934);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4942;

											BgL_ez00_4942 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4942, BgL_bpz00_4937);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4943;

												BgL_accz00_4943 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18917, BgL_sz00_4936, BgL_bpz00_4937);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4942);
												VECTOR_SET(BgL_sz00_4936, (int) (((long) 0)),
													BgL_bpz00_4937);
												return BgL_accz00_4943;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4944;

										BgL_nsz00_4944 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4944,
											(int) (((long) 1)), BgL_sz00_4936);
										VECTOR_SET(BgL_nsz00_4944,
											(int) (((long) 2)), BgL_cz00_4932);
										VECTOR_SET(BgL_nsz00_4944,
											(int) (((long) 3)), BgL_dz00_4933);
										VECTOR_SET(BgL_nsz00_4944,
											(int) (((long) 4)), BgL_lastz00_4934);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4945;

											BgL_z12denvz12_4945 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4945, BgL_nsz00_4944);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4946;

												BgL_ez00_4946 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4946, BgL_sz00_4936);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4947;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_15385;

														BgL_savedzd2bpzd2_15385 =
															VECTOR_REF(BgL_nsz00_4944, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4944,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_15392;

															BgL_fz00_15392 = BgL_runz00_18917;
														BgL_recz00_15391:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_15393;

																BgL_rz00_15393 =
																	PROCEDURE_ENTRY(BgL_fz00_15392)
																	(BgL_fz00_15392, BgL_nsz00_4944, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_30666;

																	if (PROCEDUREP(BgL_rz00_15393))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_15398;

																			BgL_arg1673z00_15398 =
																				PROCEDURE_ATTR(BgL_rz00_15393);
																			if (STRUCTP(BgL_arg1673z00_15398))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30666 =
																						(STRUCT_KEY(BgL_arg1673z00_15398) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30666 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_30666 = ((bool_t) 0);
																		}
																	if (BgL_testz00_30666)
																		{
																			obj_t BgL_fz00_30674;

																			BgL_fz00_30674 = BgL_rz00_15393;
																			BgL_fz00_15392 = BgL_fz00_30674;
																			goto BgL_recz00_15391;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4944,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_15385);
																			BgL_____rz00_4947 = BgL_rz00_15393;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4946);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4945,
														BgL_sz00_4936);
													return BgL_____rz00_4947;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5532 */
	obj_t BGl_z62run5532z62zz__evaluate_compz00(obj_t BgL_envz00_18922,
		obj_t BgL_sz00_18927)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_18923;
				obj_t BgL_valza2za2_18924;
				BgL_ev_absz00_bglt BgL_i1245z00_18925;
				obj_t BgL_bodyz00_18926;

				BgL_siza7eza7_18923 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18922, (int) (((long) 0))));
				BgL_valza2za2_18924 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18922, (int) (((long) 1))));
				BgL_i1245z00_18925 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18922, (int) (((long) 2))));
				BgL_bodyz00_18926 = PROCEDURE_REF(BgL_envz00_18922, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4949;

					BgL_sz00_4949 = BgL_sz00_18927;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4951;

						BgL_bpz00_4951 = VECTOR_REF(BgL_sz00_4949, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4949,
							BgL_valza2za2_18924,
							((long) CINT(BgL_bpz00_4951) + BgL_siza7eza7_18923));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4953;
							obj_t BgL_wherez00_4954;
							obj_t BgL_locz00_4955;

							BgL_z12denvz12_4953 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4954 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18925))->BgL_wherez00);
							BgL_locz00_4955 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18925))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4953, BgL_wherez00_4954,
									BgL_locz00_4955);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4956;

									BgL_za2za2resza2za2z00_4956 =
										PROCEDURE_ENTRY(BgL_bodyz00_18926) (BgL_bodyz00_18926,
										BgL_sz00_4949, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4953);
									return BgL_za2za2resza2za2z00_4956;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3585> */
	obj_t BGl_z62zc3anonymousza33585ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18928, obj_t BgL_sz00_18935)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18929;
				obj_t BgL_iboxesz00_18930;
				long BgL_siza7eza7_18931;
				BgL_ev_absz00_bglt BgL_i1245z00_18932;
				obj_t BgL_bodyz00_18933;
				long BgL_siza7ezd2framez75_18934;

				BgL_ifreesz00_18929 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18928, (int) (((long) 0))));
				BgL_iboxesz00_18930 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18928, (int) (((long) 1))));
				BgL_siza7eza7_18931 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18928, (int) (((long) 2))));
				BgL_i1245z00_18932 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18928, (int) (((long) 3))));
				BgL_bodyz00_18933 = PROCEDURE_REF(BgL_envz00_18928, (int) (((long) 4)));
				BgL_siza7ezd2framez75_18934 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18928, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4958;

					BgL_sz00_4958 = BgL_sz00_18935;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4960;

						BgL_bpz00_4960 = VECTOR_REF(BgL_sz00_4958, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4961;

							BgL_valza2za2_4961 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4958,
								BgL_bpz00_4960, BgL_ifreesz00_18929);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18371;

								BgL_runz00_18371 =
									MAKE_FX_PROCEDURE(BGl_z62run5534z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18371,
									(int) (((long) 0)), BgL_iboxesz00_18930);
								PROCEDURE_SET(BgL_runz00_18371,
									(int) (((long) 1)), BINT(BgL_siza7eza7_18931));
								PROCEDURE_SET(BgL_runz00_18371,
									(int) (((long) 2)), BgL_valza2za2_4961);
								PROCEDURE_SET(BgL_runz00_18371,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_18932));
								PROCEDURE_SET(BgL_runz00_18371,
									(int) (((long) 4)), BgL_bodyz00_18933);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18372;

									BgL_mainz00_18372 =
										MAKE_VA_PROCEDURE(BGl_z62main5533z62zz__evaluate_compz00,
										(int) (((long) -3)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18372,
										(int) (((long) 0)), BgL_iboxesz00_18930);
									PROCEDURE_SET(BgL_mainz00_18372,
										(int) (((long) 1)), BINT(BgL_siza7eza7_18931));
									PROCEDURE_SET(BgL_mainz00_18372,
										(int) (((long) 2)), BgL_valza2za2_4961);
									PROCEDURE_SET(BgL_mainz00_18372,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_18932));
									PROCEDURE_SET(BgL_mainz00_18372,
										(int) (((long) 4)), BgL_bodyz00_18933);
									PROCEDURE_SET(BgL_mainz00_18372,
										(int) (((long) 5)), BgL_runz00_18371);
									PROCEDURE_SET(BgL_mainz00_18372,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_18934));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_15517;

										BgL_objz00_15517 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18371, BgL_objz00_15517);
										BgL_objz00_15517;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3586z00_4964;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3587z00_4965;

											BgL_arg3587z00_4965 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18932))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_15519;

												BgL_framez00_15519 = BINT(BgL_siza7ezd2framez75_18934);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_15521;

													BgL_newz00_15521 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30764;

														BgL_auxz00_30764 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_15521, BgL_auxz00_30764,
															BgL_arg3587z00_4965);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30767;

														BgL_auxz00_30767 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_15521, BgL_auxz00_30767,
															BgL_framez00_15519);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30770;

														BgL_auxz00_30770 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_15521, BgL_auxz00_30770,
															BgL_runz00_18371);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_30775;
														int BgL_auxz00_30773;

														BgL_auxz00_30775 = BINT(((long) -3));
														BgL_auxz00_30773 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_15521, BgL_auxz00_30773,
															BgL_auxz00_30775);
													}
													BgL_arg3586z00_4964 = BgL_newz00_15521;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18372, BgL_arg3586z00_4964);
										BgL_arg3586z00_4964;
									}
									return BgL_mainz00_18372;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5533 */
	obj_t BGl_z62main5533z62zz__evaluate_compz00(obj_t BgL_envz00_18936,
		obj_t BgL_cz00_18944, obj_t BgL_dz00_18945, obj_t BgL_lastz00_18946)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18942;
				long BgL_siza7ezd2framez75_18943;

				BgL_runz00_18942 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18936, (int) (((long) 5))));
				BgL_siza7ezd2framez75_18943 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18936, (int) (((long) 6))));
				{
					obj_t BgL_cz00_4966;
					obj_t BgL_dz00_4967;
					obj_t BgL_lastz00_4968;

					BgL_cz00_4966 = BgL_cz00_18944;
					BgL_dz00_4967 = BgL_dz00_18945;
					BgL_lastz00_4968 = BgL_lastz00_18946;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4970;

						BgL_sz00_4970 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4971;

							BgL_bpz00_4971 = VECTOR_REF(BgL_sz00_4970, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_30788;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_15446;

									BgL_nz00_15446 = BINT(BgL_siza7ezd2framez75_18943);
									BgL_testz00_30788 =
										(
										((long) CINT(BgL_bpz00_4971) +
											(long) CINT(BgL_nz00_15446)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4970)));
								}
								if (BgL_testz00_30788)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3590z00_4973;

											BgL_arg3590z00_4973 =
												((long) CINT(BgL_bpz00_4971) + ((long) 0));
											VECTOR_SET(BgL_sz00_4970,
												(int) (BgL_arg3590z00_4973), BgL_cz00_4966);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3592z00_4974;

											BgL_arg3592z00_4974 =
												((long) CINT(BgL_bpz00_4971) + ((long) 1));
											VECTOR_SET(BgL_sz00_4970,
												(int) (BgL_arg3592z00_4974), BgL_dz00_4967);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3594z00_4975;

											BgL_arg3594z00_4975 =
												((long) CINT(BgL_bpz00_4971) + ((long) 2));
											VECTOR_SET(BgL_sz00_4970,
												(int) (BgL_arg3594z00_4975), BgL_lastz00_4968);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4976;

											BgL_ez00_4976 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4976, BgL_bpz00_4971);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4977;

												BgL_accz00_4977 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18942, BgL_sz00_4970, BgL_bpz00_4971);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4976);
												VECTOR_SET(BgL_sz00_4970, (int) (((long) 0)),
													BgL_bpz00_4971);
												return BgL_accz00_4977;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4978;

										BgL_nsz00_4978 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4978,
											(int) (((long) 1)), BgL_sz00_4970);
										VECTOR_SET(BgL_nsz00_4978,
											(int) (((long) 2)), BgL_cz00_4966);
										VECTOR_SET(BgL_nsz00_4978,
											(int) (((long) 3)), BgL_dz00_4967);
										VECTOR_SET(BgL_nsz00_4978,
											(int) (((long) 4)), BgL_lastz00_4968);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4979;

											BgL_z12denvz12_4979 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4979, BgL_nsz00_4978);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4980;

												BgL_ez00_4980 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4980, BgL_sz00_4970);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4981;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_15492;

														BgL_savedzd2bpzd2_15492 =
															VECTOR_REF(BgL_nsz00_4978, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4978,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_15499;

															BgL_fz00_15499 = BgL_runz00_18942;
														BgL_recz00_15498:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_15500;

																BgL_rz00_15500 =
																	PROCEDURE_ENTRY(BgL_fz00_15499)
																	(BgL_fz00_15499, BgL_nsz00_4978, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_30836;

																	if (PROCEDUREP(BgL_rz00_15500))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_15505;

																			BgL_arg1673z00_15505 =
																				PROCEDURE_ATTR(BgL_rz00_15500);
																			if (STRUCTP(BgL_arg1673z00_15505))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30836 =
																						(STRUCT_KEY(BgL_arg1673z00_15505) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30836 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_30836 = ((bool_t) 0);
																		}
																	if (BgL_testz00_30836)
																		{
																			obj_t BgL_fz00_30844;

																			BgL_fz00_30844 = BgL_rz00_15500;
																			BgL_fz00_15499 = BgL_fz00_30844;
																			goto BgL_recz00_15498;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4978,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_15492);
																			BgL_____rz00_4981 = BgL_rz00_15500;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4980);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4979,
														BgL_sz00_4970);
													return BgL_____rz00_4981;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5534 */
	obj_t BGl_z62run5534z62zz__evaluate_compz00(obj_t BgL_envz00_18947,
		obj_t BgL_sz00_18953)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18948;
				long BgL_siza7eza7_18949;
				obj_t BgL_valza2za2_18950;
				BgL_ev_absz00_bglt BgL_i1245z00_18951;
				obj_t BgL_bodyz00_18952;

				BgL_iboxesz00_18948 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18947, (int) (((long) 0))));
				BgL_siza7eza7_18949 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18947, (int) (((long) 1))));
				BgL_valza2za2_18950 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18947, (int) (((long) 2))));
				BgL_i1245z00_18951 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18947, (int) (((long) 3))));
				BgL_bodyz00_18952 = PROCEDURE_REF(BgL_envz00_18947, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4983;

					BgL_sz00_4983 = BgL_sz00_18953;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4985;

						BgL_bpz00_4985 = VECTOR_REF(BgL_sz00_4983, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4983,
							BgL_iboxesz00_18948, BgL_bpz00_4985);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4983,
							BgL_valza2za2_18950,
							((long) CINT(BgL_bpz00_4985) + BgL_siza7eza7_18949));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4987;
							obj_t BgL_wherez00_4988;
							obj_t BgL_locz00_4989;

							BgL_z12denvz12_4987 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4988 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18951))->BgL_wherez00);
							BgL_locz00_4989 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18951))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4987, BgL_wherez00_4988,
									BgL_locz00_4989);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4990;

									BgL_za2za2resza2za2z00_4990 =
										PROCEDURE_ENTRY(BgL_bodyz00_18952) (BgL_bodyz00_18952,
										BgL_sz00_4983, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4987);
									return BgL_za2za2resza2za2z00_4990;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3502> */
	obj_t BGl_z62zc3anonymousza33502ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18954, obj_t BgL_sz00_18958)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18955;
				obj_t BgL_bodyz00_18956;
				long BgL_siza7ezd2framez75_18957;

				BgL_i1245z00_18955 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18954, (int) (((long) 0))));
				BgL_bodyz00_18956 = PROCEDURE_REF(BgL_envz00_18954, (int) (((long) 1)));
				BgL_siza7ezd2framez75_18957 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18954, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4728;

					BgL_sz00_4728 = BgL_sz00_18958;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4730;

						BgL_bpz00_4730 = VECTOR_REF(BgL_sz00_4728, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18368;

								BgL_runz00_18368 =
									MAKE_FX_PROCEDURE(BGl_z62run5536z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18368,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_18955));
								PROCEDURE_SET(BgL_runz00_18368,
									(int) (((long) 1)), BgL_bodyz00_18956);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18369;

									BgL_mainz00_18369 =
										MAKE_FX_PROCEDURE(BGl_z62main5535z62zz__evaluate_compz00,
										(int) (((long) 2)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18369,
										(int) (((long) 0)), ((obj_t) BgL_i1245z00_18955));
									PROCEDURE_SET(BgL_mainz00_18369,
										(int) (((long) 1)), BgL_bodyz00_18956);
									PROCEDURE_SET(BgL_mainz00_18369,
										(int) (((long) 2)), BgL_runz00_18368);
									PROCEDURE_SET(BgL_mainz00_18369,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_18957));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14788;

										BgL_objz00_14788 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18368, BgL_objz00_14788);
										BgL_objz00_14788;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3504z00_4733;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3505z00_4734;

											BgL_arg3505z00_4734 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18955))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14790;

												BgL_framez00_14790 = BINT(BgL_siza7ezd2framez75_18957);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14792;

													BgL_newz00_14792 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30914;

														BgL_auxz00_30914 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14792, BgL_auxz00_30914,
															BgL_arg3505z00_4734);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30917;

														BgL_auxz00_30917 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14792, BgL_auxz00_30917,
															BgL_framez00_14790);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_30920;

														BgL_auxz00_30920 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14792, BgL_auxz00_30920,
															BgL_runz00_18368);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_30925;
														int BgL_auxz00_30923;

														BgL_auxz00_30925 = BINT(((long) 2));
														BgL_auxz00_30923 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14792, BgL_auxz00_30923,
															BgL_auxz00_30925);
													}
													BgL_arg3504z00_4733 = BgL_newz00_14792;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18369, BgL_arg3504z00_4733);
										BgL_arg3504z00_4733;
									}
									return BgL_mainz00_18369;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5535 */
	obj_t BGl_z62main5535z62zz__evaluate_compz00(obj_t BgL_envz00_18959,
		obj_t BgL_cz00_18964, obj_t BgL_dz00_18965)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18962;
				long BgL_siza7ezd2framez75_18963;

				BgL_runz00_18962 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18959, (int) (((long) 2))));
				BgL_siza7ezd2framez75_18963 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18959, (int) (((long) 3))));
				{
					obj_t BgL_cz00_4735;
					obj_t BgL_dz00_4736;

					BgL_cz00_4735 = BgL_cz00_18964;
					BgL_dz00_4736 = BgL_dz00_18965;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4738;

						BgL_sz00_4738 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4739;

							BgL_bpz00_4739 = VECTOR_REF(BgL_sz00_4738, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_30938;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_14726;

									BgL_nz00_14726 = BINT(BgL_siza7ezd2framez75_18963);
									BgL_testz00_30938 =
										(
										((long) CINT(BgL_bpz00_4739) +
											(long) CINT(BgL_nz00_14726)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4738)));
								}
								if (BgL_testz00_30938)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3508z00_4741;

											BgL_arg3508z00_4741 =
												((long) CINT(BgL_bpz00_4739) + ((long) 0));
											VECTOR_SET(BgL_sz00_4738,
												(int) (BgL_arg3508z00_4741), BgL_cz00_4735);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3509z00_4742;

											BgL_arg3509z00_4742 =
												((long) CINT(BgL_bpz00_4739) + ((long) 1));
											VECTOR_SET(BgL_sz00_4738,
												(int) (BgL_arg3509z00_4742), BgL_dz00_4736);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4743;

											BgL_ez00_4743 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4743, BgL_bpz00_4739);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4744;

												BgL_accz00_4744 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18962, BgL_sz00_4738, BgL_bpz00_4739);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4743);
												VECTOR_SET(BgL_sz00_4738, (int) (((long) 0)),
													BgL_bpz00_4739);
												return BgL_accz00_4744;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4745;

										BgL_nsz00_4745 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4745,
											(int) (((long) 1)), BgL_sz00_4738);
										VECTOR_SET(BgL_nsz00_4745,
											(int) (((long) 2)), BgL_cz00_4735);
										VECTOR_SET(BgL_nsz00_4745,
											(int) (((long) 3)), BgL_dz00_4736);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4746;

											BgL_z12denvz12_4746 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4746, BgL_nsz00_4745);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4747;

												BgL_ez00_4747 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4747, BgL_sz00_4738);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4748;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_14763;

														BgL_savedzd2bpzd2_14763 =
															VECTOR_REF(BgL_nsz00_4745, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4745,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14770;

															BgL_fz00_14770 = BgL_runz00_18962;
														BgL_recz00_14769:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14771;

																BgL_rz00_14771 =
																	PROCEDURE_ENTRY(BgL_fz00_14770)
																	(BgL_fz00_14770, BgL_nsz00_4745, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_30980;

																	if (PROCEDUREP(BgL_rz00_14771))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14776;

																			BgL_arg1673z00_14776 =
																				PROCEDURE_ATTR(BgL_rz00_14771);
																			if (STRUCTP(BgL_arg1673z00_14776))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30980 =
																						(STRUCT_KEY(BgL_arg1673z00_14776) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_30980 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_30980 = ((bool_t) 0);
																		}
																	if (BgL_testz00_30980)
																		{
																			obj_t BgL_fz00_30988;

																			BgL_fz00_30988 = BgL_rz00_14771;
																			BgL_fz00_14770 = BgL_fz00_30988;
																			goto BgL_recz00_14769;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4745,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_14763);
																			BgL_____rz00_4748 = BgL_rz00_14771;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4747);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4746,
														BgL_sz00_4738);
													return BgL_____rz00_4748;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5536 */
	obj_t BGl_z62run5536z62zz__evaluate_compz00(obj_t BgL_envz00_18966,
		obj_t BgL_sz00_18969)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_18967;
				obj_t BgL_bodyz00_18968;

				BgL_i1245z00_18967 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18966, (int) (((long) 0))));
				BgL_bodyz00_18968 = PROCEDURE_REF(BgL_envz00_18966, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4750;

					BgL_sz00_4750 = BgL_sz00_18969;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4752;

						BgL_bpz00_4752 = VECTOR_REF(BgL_sz00_4750, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4753;
							obj_t BgL_wherez00_4754;
							obj_t BgL_locz00_4755;

							BgL_z12denvz12_4753 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4754 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18967))->BgL_wherez00);
							BgL_locz00_4755 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18967))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4753, BgL_wherez00_4754,
									BgL_locz00_4755);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4756;

									BgL_za2za2resza2za2z00_4756 =
										PROCEDURE_ENTRY(BgL_bodyz00_18968) (BgL_bodyz00_18968,
										BgL_sz00_4750, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4753);
									return BgL_za2za2resza2za2z00_4756;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3511> */
	obj_t BGl_z62zc3anonymousza33511ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18970, obj_t BgL_sz00_18975)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18971;
				BgL_ev_absz00_bglt BgL_i1245z00_18972;
				obj_t BgL_bodyz00_18973;
				long BgL_siza7ezd2framez75_18974;

				BgL_iboxesz00_18971 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18970, (int) (((long) 0))));
				BgL_i1245z00_18972 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18970, (int) (((long) 1))));
				BgL_bodyz00_18973 = PROCEDURE_REF(BgL_envz00_18970, (int) (((long) 2)));
				BgL_siza7ezd2framez75_18974 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18970, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4758;

					BgL_sz00_4758 = BgL_sz00_18975;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4760;

						BgL_bpz00_4760 = VECTOR_REF(BgL_sz00_4758, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18365;

								BgL_runz00_18365 =
									MAKE_FX_PROCEDURE(BGl_z62run5538z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18365,
									(int) (((long) 0)), BgL_iboxesz00_18971);
								PROCEDURE_SET(BgL_runz00_18365,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_18972));
								PROCEDURE_SET(BgL_runz00_18365,
									(int) (((long) 2)), BgL_bodyz00_18973);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18366;

									BgL_mainz00_18366 =
										MAKE_FX_PROCEDURE(BGl_z62main5537z62zz__evaluate_compz00,
										(int) (((long) 2)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18366,
										(int) (((long) 0)), BgL_iboxesz00_18971);
									PROCEDURE_SET(BgL_mainz00_18366,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_18972));
									PROCEDURE_SET(BgL_mainz00_18366,
										(int) (((long) 2)), BgL_bodyz00_18973);
									PROCEDURE_SET(BgL_mainz00_18366,
										(int) (((long) 3)), BgL_runz00_18365);
									PROCEDURE_SET(BgL_mainz00_18366,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_18974));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14883;

										BgL_objz00_14883 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18365, BgL_objz00_14883);
										BgL_objz00_14883;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3512z00_4763;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3514z00_4764;

											BgL_arg3514z00_4764 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18972))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14885;

												BgL_framez00_14885 = BINT(BgL_siza7ezd2framez75_18974);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14887;

													BgL_newz00_14887 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31052;

														BgL_auxz00_31052 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14887, BgL_auxz00_31052,
															BgL_arg3514z00_4764);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31055;

														BgL_auxz00_31055 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14887, BgL_auxz00_31055,
															BgL_framez00_14885);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31058;

														BgL_auxz00_31058 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14887, BgL_auxz00_31058,
															BgL_runz00_18365);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_31063;
														int BgL_auxz00_31061;

														BgL_auxz00_31063 = BINT(((long) 2));
														BgL_auxz00_31061 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14887, BgL_auxz00_31061,
															BgL_auxz00_31063);
													}
													BgL_arg3512z00_4763 = BgL_newz00_14887;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18366, BgL_arg3512z00_4763);
										BgL_arg3512z00_4763;
									}
									return BgL_mainz00_18366;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5537 */
	obj_t BGl_z62main5537z62zz__evaluate_compz00(obj_t BgL_envz00_18976,
		obj_t BgL_cz00_18982, obj_t BgL_dz00_18983)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_18980;
				long BgL_siza7ezd2framez75_18981;

				BgL_runz00_18980 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18976, (int) (((long) 3))));
				BgL_siza7ezd2framez75_18981 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18976, (int) (((long) 4))));
				{
					obj_t BgL_cz00_4765;
					obj_t BgL_dz00_4766;

					BgL_cz00_4765 = BgL_cz00_18982;
					BgL_dz00_4766 = BgL_dz00_18983;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4768;

						BgL_sz00_4768 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4769;

							BgL_bpz00_4769 = VECTOR_REF(BgL_sz00_4768, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_31076;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_14821;

									BgL_nz00_14821 = BINT(BgL_siza7ezd2framez75_18981);
									BgL_testz00_31076 =
										(
										((long) CINT(BgL_bpz00_4769) +
											(long) CINT(BgL_nz00_14821)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4768)));
								}
								if (BgL_testz00_31076)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3518z00_4771;

											BgL_arg3518z00_4771 =
												((long) CINT(BgL_bpz00_4769) + ((long) 0));
											VECTOR_SET(BgL_sz00_4768,
												(int) (BgL_arg3518z00_4771), BgL_cz00_4765);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3519z00_4772;

											BgL_arg3519z00_4772 =
												((long) CINT(BgL_bpz00_4769) + ((long) 1));
											VECTOR_SET(BgL_sz00_4768,
												(int) (BgL_arg3519z00_4772), BgL_dz00_4766);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4773;

											BgL_ez00_4773 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4773, BgL_bpz00_4769);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4774;

												BgL_accz00_4774 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_18980, BgL_sz00_4768, BgL_bpz00_4769);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4773);
												VECTOR_SET(BgL_sz00_4768, (int) (((long) 0)),
													BgL_bpz00_4769);
												return BgL_accz00_4774;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4775;

										BgL_nsz00_4775 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4775,
											(int) (((long) 1)), BgL_sz00_4768);
										VECTOR_SET(BgL_nsz00_4775,
											(int) (((long) 2)), BgL_cz00_4765);
										VECTOR_SET(BgL_nsz00_4775,
											(int) (((long) 3)), BgL_dz00_4766);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4776;

											BgL_z12denvz12_4776 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4776, BgL_nsz00_4775);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4777;

												BgL_ez00_4777 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4777, BgL_sz00_4768);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4778;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_14858;

														BgL_savedzd2bpzd2_14858 =
															VECTOR_REF(BgL_nsz00_4775, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4775,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14865;

															BgL_fz00_14865 = BgL_runz00_18980;
														BgL_recz00_14864:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14866;

																BgL_rz00_14866 =
																	PROCEDURE_ENTRY(BgL_fz00_14865)
																	(BgL_fz00_14865, BgL_nsz00_4775, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_31118;

																	if (PROCEDUREP(BgL_rz00_14866))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14871;

																			BgL_arg1673z00_14871 =
																				PROCEDURE_ATTR(BgL_rz00_14866);
																			if (STRUCTP(BgL_arg1673z00_14871))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31118 =
																						(STRUCT_KEY(BgL_arg1673z00_14871) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31118 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_31118 = ((bool_t) 0);
																		}
																	if (BgL_testz00_31118)
																		{
																			obj_t BgL_fz00_31126;

																			BgL_fz00_31126 = BgL_rz00_14866;
																			BgL_fz00_14865 = BgL_fz00_31126;
																			goto BgL_recz00_14864;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4775,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_14858);
																			BgL_____rz00_4778 = BgL_rz00_14866;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4777);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4776,
														BgL_sz00_4768);
													return BgL_____rz00_4778;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5538 */
	obj_t BGl_z62run5538z62zz__evaluate_compz00(obj_t BgL_envz00_18984,
		obj_t BgL_sz00_18988)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_18985;
				BgL_ev_absz00_bglt BgL_i1245z00_18986;
				obj_t BgL_bodyz00_18987;

				BgL_iboxesz00_18985 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18984, (int) (((long) 0))));
				BgL_i1245z00_18986 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18984, (int) (((long) 1))));
				BgL_bodyz00_18987 = PROCEDURE_REF(BgL_envz00_18984, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4780;

					BgL_sz00_4780 = BgL_sz00_18988;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4782;

						BgL_bpz00_4782 = VECTOR_REF(BgL_sz00_4780, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4780,
							BgL_iboxesz00_18985, BgL_bpz00_4782);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4783;
							obj_t BgL_wherez00_4784;
							obj_t BgL_locz00_4785;

							BgL_z12denvz12_4783 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4784 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18986))->BgL_wherez00);
							BgL_locz00_4785 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18986))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4783, BgL_wherez00_4784,
									BgL_locz00_4785);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4786;

									BgL_za2za2resza2za2z00_4786 =
										PROCEDURE_ENTRY(BgL_bodyz00_18987) (BgL_bodyz00_18987,
										BgL_sz00_4780, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4783);
									return BgL_za2za2resza2za2z00_4786;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3523> */
	obj_t BGl_z62zc3anonymousza33523ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_18989, obj_t BgL_sz00_18995)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_18990;
				long BgL_siza7eza7_18991;
				BgL_ev_absz00_bglt BgL_i1245z00_18992;
				obj_t BgL_bodyz00_18993;
				long BgL_siza7ezd2framez75_18994;

				BgL_ifreesz00_18990 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18989, (int) (((long) 0))));
				BgL_siza7eza7_18991 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18989, (int) (((long) 1))));
				BgL_i1245z00_18992 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_18989, (int) (((long) 2))));
				BgL_bodyz00_18993 = PROCEDURE_REF(BgL_envz00_18989, (int) (((long) 3)));
				BgL_siza7ezd2framez75_18994 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18989, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4790;

					BgL_sz00_4790 = BgL_sz00_18995;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4792;

						BgL_bpz00_4792 = VECTOR_REF(BgL_sz00_4790, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4793;

							BgL_valza2za2_4793 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4790,
								BgL_bpz00_4792, BgL_ifreesz00_18990);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18362;

								BgL_runz00_18362 =
									MAKE_FX_PROCEDURE(BGl_z62run5540z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18362,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18991));
								PROCEDURE_SET(BgL_runz00_18362,
									(int) (((long) 1)), BgL_valza2za2_4793);
								PROCEDURE_SET(BgL_runz00_18362,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_18992));
								PROCEDURE_SET(BgL_runz00_18362,
									(int) (((long) 3)), BgL_bodyz00_18993);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18363;

									BgL_mainz00_18363 =
										MAKE_FX_PROCEDURE(BGl_z62main5539z62zz__evaluate_compz00,
										(int) (((long) 2)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18363,
										(int) (((long) 0)), BINT(BgL_siza7eza7_18991));
									PROCEDURE_SET(BgL_mainz00_18363,
										(int) (((long) 1)), BgL_valza2za2_4793);
									PROCEDURE_SET(BgL_mainz00_18363,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_18992));
									PROCEDURE_SET(BgL_mainz00_18363,
										(int) (((long) 3)), BgL_bodyz00_18993);
									PROCEDURE_SET(BgL_mainz00_18363,
										(int) (((long) 4)), BgL_runz00_18362);
									PROCEDURE_SET(BgL_mainz00_18363,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_18994));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14985;

										BgL_objz00_14985 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18362, BgL_objz00_14985);
										BgL_objz00_14985;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3524z00_4796;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3525z00_4797;

											BgL_arg3525z00_4797 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_18992))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14987;

												BgL_framez00_14987 = BINT(BgL_siza7ezd2framez75_18994);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14989;

													BgL_newz00_14989 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31204;

														BgL_auxz00_31204 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14989, BgL_auxz00_31204,
															BgL_arg3525z00_4797);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31207;

														BgL_auxz00_31207 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14989, BgL_auxz00_31207,
															BgL_framez00_14987);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31210;

														BgL_auxz00_31210 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14989, BgL_auxz00_31210,
															BgL_runz00_18362);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_31215;
														int BgL_auxz00_31213;

														BgL_auxz00_31215 = BINT(((long) 2));
														BgL_auxz00_31213 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14989, BgL_auxz00_31213,
															BgL_auxz00_31215);
													}
													BgL_arg3524z00_4796 = BgL_newz00_14989;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18363, BgL_arg3524z00_4796);
										BgL_arg3524z00_4796;
									}
									return BgL_mainz00_18363;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5539 */
	obj_t BGl_z62main5539z62zz__evaluate_compz00(obj_t BgL_envz00_18996,
		obj_t BgL_cz00_19003, obj_t BgL_dz00_19004)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19001;
				long BgL_siza7ezd2framez75_19002;

				BgL_runz00_19001 =
					((obj_t) PROCEDURE_REF(BgL_envz00_18996, (int) (((long) 4))));
				BgL_siza7ezd2framez75_19002 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_18996, (int) (((long) 5))));
				{
					obj_t BgL_cz00_4798;
					obj_t BgL_dz00_4799;

					BgL_cz00_4798 = BgL_cz00_19003;
					BgL_dz00_4799 = BgL_dz00_19004;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4801;

						BgL_sz00_4801 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4802;

							BgL_bpz00_4802 = VECTOR_REF(BgL_sz00_4801, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_31228;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_14923;

									BgL_nz00_14923 = BINT(BgL_siza7ezd2framez75_19002);
									BgL_testz00_31228 =
										(
										((long) CINT(BgL_bpz00_4802) +
											(long) CINT(BgL_nz00_14923)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4801)));
								}
								if (BgL_testz00_31228)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3528z00_4804;

											BgL_arg3528z00_4804 =
												((long) CINT(BgL_bpz00_4802) + ((long) 0));
											VECTOR_SET(BgL_sz00_4801,
												(int) (BgL_arg3528z00_4804), BgL_cz00_4798);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3529z00_4805;

											BgL_arg3529z00_4805 =
												((long) CINT(BgL_bpz00_4802) + ((long) 1));
											VECTOR_SET(BgL_sz00_4801,
												(int) (BgL_arg3529z00_4805), BgL_dz00_4799);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4806;

											BgL_ez00_4806 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4806, BgL_bpz00_4802);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4807;

												BgL_accz00_4807 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19001, BgL_sz00_4801, BgL_bpz00_4802);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4806);
												VECTOR_SET(BgL_sz00_4801, (int) (((long) 0)),
													BgL_bpz00_4802);
												return BgL_accz00_4807;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4808;

										BgL_nsz00_4808 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4808,
											(int) (((long) 1)), BgL_sz00_4801);
										VECTOR_SET(BgL_nsz00_4808,
											(int) (((long) 2)), BgL_cz00_4798);
										VECTOR_SET(BgL_nsz00_4808,
											(int) (((long) 3)), BgL_dz00_4799);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4809;

											BgL_z12denvz12_4809 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4809, BgL_nsz00_4808);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4810;

												BgL_ez00_4810 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4810, BgL_sz00_4801);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4811;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_14960;

														BgL_savedzd2bpzd2_14960 =
															VECTOR_REF(BgL_nsz00_4808, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4808,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14967;

															BgL_fz00_14967 = BgL_runz00_19001;
														BgL_recz00_14966:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14968;

																BgL_rz00_14968 =
																	PROCEDURE_ENTRY(BgL_fz00_14967)
																	(BgL_fz00_14967, BgL_nsz00_4808, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_31270;

																	if (PROCEDUREP(BgL_rz00_14968))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14973;

																			BgL_arg1673z00_14973 =
																				PROCEDURE_ATTR(BgL_rz00_14968);
																			if (STRUCTP(BgL_arg1673z00_14973))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31270 =
																						(STRUCT_KEY(BgL_arg1673z00_14973) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31270 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_31270 = ((bool_t) 0);
																		}
																	if (BgL_testz00_31270)
																		{
																			obj_t BgL_fz00_31278;

																			BgL_fz00_31278 = BgL_rz00_14968;
																			BgL_fz00_14967 = BgL_fz00_31278;
																			goto BgL_recz00_14966;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4808,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_14960);
																			BgL_____rz00_4811 = BgL_rz00_14968;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4810);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4809,
														BgL_sz00_4801);
													return BgL_____rz00_4811;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5540 */
	obj_t BGl_z62run5540z62zz__evaluate_compz00(obj_t BgL_envz00_19005,
		obj_t BgL_sz00_19010)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_19006;
				obj_t BgL_valza2za2_19007;
				BgL_ev_absz00_bglt BgL_i1245z00_19008;
				obj_t BgL_bodyz00_19009;

				BgL_siza7eza7_19006 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19005, (int) (((long) 0))));
				BgL_valza2za2_19007 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19005, (int) (((long) 1))));
				BgL_i1245z00_19008 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19005, (int) (((long) 2))));
				BgL_bodyz00_19009 = PROCEDURE_REF(BgL_envz00_19005, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4813;

					BgL_sz00_4813 = BgL_sz00_19010;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4815;

						BgL_bpz00_4815 = VECTOR_REF(BgL_sz00_4813, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4813,
							BgL_valza2za2_19007,
							((long) CINT(BgL_bpz00_4815) + BgL_siza7eza7_19006));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4817;
							obj_t BgL_wherez00_4818;
							obj_t BgL_locz00_4819;

							BgL_z12denvz12_4817 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4818 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19008))->BgL_wherez00);
							BgL_locz00_4819 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19008))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4817, BgL_wherez00_4818,
									BgL_locz00_4819);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4820;

									BgL_za2za2resza2za2z00_4820 =
										PROCEDURE_ENTRY(BgL_bodyz00_19009) (BgL_bodyz00_19009,
										BgL_sz00_4813, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4817);
									return BgL_za2za2resza2za2z00_4820;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3533> */
	obj_t BGl_z62zc3anonymousza33533ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19011, obj_t BgL_sz00_19018)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19012;
				obj_t BgL_iboxesz00_19013;
				long BgL_siza7eza7_19014;
				BgL_ev_absz00_bglt BgL_i1245z00_19015;
				obj_t BgL_bodyz00_19016;
				long BgL_siza7ezd2framez75_19017;

				BgL_ifreesz00_19012 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19011, (int) (((long) 0))));
				BgL_iboxesz00_19013 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19011, (int) (((long) 1))));
				BgL_siza7eza7_19014 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19011, (int) (((long) 2))));
				BgL_i1245z00_19015 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19011, (int) (((long) 3))));
				BgL_bodyz00_19016 = PROCEDURE_REF(BgL_envz00_19011, (int) (((long) 4)));
				BgL_siza7ezd2framez75_19017 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19011, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4822;

					BgL_sz00_4822 = BgL_sz00_19018;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4824;

						BgL_bpz00_4824 = VECTOR_REF(BgL_sz00_4822, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4825;

							BgL_valza2za2_4825 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4822,
								BgL_bpz00_4824, BgL_ifreesz00_19012);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18359;

								BgL_runz00_18359 =
									MAKE_FX_PROCEDURE(BGl_z62run5542z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18359,
									(int) (((long) 0)), BgL_iboxesz00_19013);
								PROCEDURE_SET(BgL_runz00_18359,
									(int) (((long) 1)), BINT(BgL_siza7eza7_19014));
								PROCEDURE_SET(BgL_runz00_18359,
									(int) (((long) 2)), BgL_valza2za2_4825);
								PROCEDURE_SET(BgL_runz00_18359,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_19015));
								PROCEDURE_SET(BgL_runz00_18359,
									(int) (((long) 4)), BgL_bodyz00_19016);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18360;

									BgL_mainz00_18360 =
										MAKE_FX_PROCEDURE(BGl_z62main5541z62zz__evaluate_compz00,
										(int) (((long) 2)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18360,
										(int) (((long) 0)), BgL_iboxesz00_19013);
									PROCEDURE_SET(BgL_mainz00_18360,
										(int) (((long) 1)), BINT(BgL_siza7eza7_19014));
									PROCEDURE_SET(BgL_mainz00_18360,
										(int) (((long) 2)), BgL_valza2za2_4825);
									PROCEDURE_SET(BgL_mainz00_18360,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_19015));
									PROCEDURE_SET(BgL_mainz00_18360,
										(int) (((long) 4)), BgL_bodyz00_19016);
									PROCEDURE_SET(BgL_mainz00_18360,
										(int) (((long) 5)), BgL_runz00_18359);
									PROCEDURE_SET(BgL_mainz00_18360,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_19017));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_15083;

										BgL_objz00_15083 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18359, BgL_objz00_15083);
										BgL_objz00_15083;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3534z00_4828;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3536z00_4829;

											BgL_arg3536z00_4829 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19015))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_15085;

												BgL_framez00_15085 = BINT(BgL_siza7ezd2framez75_19017);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_15087;

													BgL_newz00_15087 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31368;

														BgL_auxz00_31368 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_15087, BgL_auxz00_31368,
															BgL_arg3536z00_4829);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31371;

														BgL_auxz00_31371 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_15087, BgL_auxz00_31371,
															BgL_framez00_15085);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31374;

														BgL_auxz00_31374 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_15087, BgL_auxz00_31374,
															BgL_runz00_18359);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_31379;
														int BgL_auxz00_31377;

														BgL_auxz00_31379 = BINT(((long) 2));
														BgL_auxz00_31377 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_15087, BgL_auxz00_31377,
															BgL_auxz00_31379);
													}
													BgL_arg3534z00_4828 = BgL_newz00_15087;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18360, BgL_arg3534z00_4828);
										BgL_arg3534z00_4828;
									}
									return BgL_mainz00_18360;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5541 */
	obj_t BGl_z62main5541z62zz__evaluate_compz00(obj_t BgL_envz00_19019,
		obj_t BgL_cz00_19027, obj_t BgL_dz00_19028)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19025;
				long BgL_siza7ezd2framez75_19026;

				BgL_runz00_19025 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19019, (int) (((long) 5))));
				BgL_siza7ezd2framez75_19026 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19019, (int) (((long) 6))));
				{
					obj_t BgL_cz00_4830;
					obj_t BgL_dz00_4831;

					BgL_cz00_4830 = BgL_cz00_19027;
					BgL_dz00_4831 = BgL_dz00_19028;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4833;

						BgL_sz00_4833 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4834;

							BgL_bpz00_4834 = VECTOR_REF(BgL_sz00_4833, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_31392;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_15021;

									BgL_nz00_15021 = BINT(BgL_siza7ezd2framez75_19026);
									BgL_testz00_31392 =
										(
										((long) CINT(BgL_bpz00_4834) +
											(long) CINT(BgL_nz00_15021)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4833)));
								}
								if (BgL_testz00_31392)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3539z00_4836;

											BgL_arg3539z00_4836 =
												((long) CINT(BgL_bpz00_4834) + ((long) 0));
											VECTOR_SET(BgL_sz00_4833,
												(int) (BgL_arg3539z00_4836), BgL_cz00_4830);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3541z00_4837;

											BgL_arg3541z00_4837 =
												((long) CINT(BgL_bpz00_4834) + ((long) 1));
											VECTOR_SET(BgL_sz00_4833,
												(int) (BgL_arg3541z00_4837), BgL_dz00_4831);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4838;

											BgL_ez00_4838 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4838, BgL_bpz00_4834);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4839;

												BgL_accz00_4839 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19025, BgL_sz00_4833, BgL_bpz00_4834);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4838);
												VECTOR_SET(BgL_sz00_4833, (int) (((long) 0)),
													BgL_bpz00_4834);
												return BgL_accz00_4839;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4840;

										BgL_nsz00_4840 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4840,
											(int) (((long) 1)), BgL_sz00_4833);
										VECTOR_SET(BgL_nsz00_4840,
											(int) (((long) 2)), BgL_cz00_4830);
										VECTOR_SET(BgL_nsz00_4840,
											(int) (((long) 3)), BgL_dz00_4831);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4841;

											BgL_z12denvz12_4841 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4841, BgL_nsz00_4840);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4842;

												BgL_ez00_4842 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4842, BgL_sz00_4833);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4843;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_15058;

														BgL_savedzd2bpzd2_15058 =
															VECTOR_REF(BgL_nsz00_4840, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4840,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_15065;

															BgL_fz00_15065 = BgL_runz00_19025;
														BgL_recz00_15064:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_15066;

																BgL_rz00_15066 =
																	PROCEDURE_ENTRY(BgL_fz00_15065)
																	(BgL_fz00_15065, BgL_nsz00_4840, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_31434;

																	if (PROCEDUREP(BgL_rz00_15066))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_15071;

																			BgL_arg1673z00_15071 =
																				PROCEDURE_ATTR(BgL_rz00_15066);
																			if (STRUCTP(BgL_arg1673z00_15071))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31434 =
																						(STRUCT_KEY(BgL_arg1673z00_15071) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31434 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_31434 = ((bool_t) 0);
																		}
																	if (BgL_testz00_31434)
																		{
																			obj_t BgL_fz00_31442;

																			BgL_fz00_31442 = BgL_rz00_15066;
																			BgL_fz00_15065 = BgL_fz00_31442;
																			goto BgL_recz00_15064;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4840,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_15058);
																			BgL_____rz00_4843 = BgL_rz00_15066;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4842);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4841,
														BgL_sz00_4833);
													return BgL_____rz00_4843;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5542 */
	obj_t BGl_z62run5542z62zz__evaluate_compz00(obj_t BgL_envz00_19029,
		obj_t BgL_sz00_19035)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19030;
				long BgL_siza7eza7_19031;
				obj_t BgL_valza2za2_19032;
				BgL_ev_absz00_bglt BgL_i1245z00_19033;
				obj_t BgL_bodyz00_19034;

				BgL_iboxesz00_19030 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19029, (int) (((long) 0))));
				BgL_siza7eza7_19031 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19029, (int) (((long) 1))));
				BgL_valza2za2_19032 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19029, (int) (((long) 2))));
				BgL_i1245z00_19033 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19029, (int) (((long) 3))));
				BgL_bodyz00_19034 = PROCEDURE_REF(BgL_envz00_19029, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4845;

					BgL_sz00_4845 = BgL_sz00_19035;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4847;

						BgL_bpz00_4847 = VECTOR_REF(BgL_sz00_4845, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4845,
							BgL_iboxesz00_19030, BgL_bpz00_4847);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4845,
							BgL_valza2za2_19032,
							((long) CINT(BgL_bpz00_4847) + BgL_siza7eza7_19031));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4849;
							obj_t BgL_wherez00_4850;
							obj_t BgL_locz00_4851;

							BgL_z12denvz12_4849 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4850 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19033))->BgL_wherez00);
							BgL_locz00_4851 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19033))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4849, BgL_wherez00_4850,
									BgL_locz00_4851);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4852;

									BgL_za2za2resza2za2z00_4852 =
										PROCEDURE_ENTRY(BgL_bodyz00_19034) (BgL_bodyz00_19034,
										BgL_sz00_4845, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4849);
									return BgL_za2za2resza2za2z00_4852;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3454> */
	obj_t BGl_z62zc3anonymousza33454ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19036, obj_t BgL_sz00_19040)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19037;
				obj_t BgL_bodyz00_19038;
				long BgL_siza7ezd2framez75_19039;

				BgL_i1245z00_19037 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19036, (int) (((long) 0))));
				BgL_bodyz00_19038 = PROCEDURE_REF(BgL_envz00_19036, (int) (((long) 1)));
				BgL_siza7ezd2framez75_19039 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19036, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4598;

					BgL_sz00_4598 = BgL_sz00_19040;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4600;

						BgL_bpz00_4600 = VECTOR_REF(BgL_sz00_4598, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18356;

								BgL_runz00_18356 =
									MAKE_FX_PROCEDURE(BGl_z62run5544z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18356,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_19037));
								PROCEDURE_SET(BgL_runz00_18356,
									(int) (((long) 1)), BgL_bodyz00_19038);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18357;

									BgL_mainz00_18357 =
										MAKE_VA_PROCEDURE(BGl_z62main5543z62zz__evaluate_compz00,
										(int) (((long) -2)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18357,
										(int) (((long) 0)), ((obj_t) BgL_i1245z00_19037));
									PROCEDURE_SET(BgL_mainz00_18357,
										(int) (((long) 1)), BgL_bodyz00_19038);
									PROCEDURE_SET(BgL_mainz00_18357,
										(int) (((long) 2)), BgL_runz00_18356);
									PROCEDURE_SET(BgL_mainz00_18357,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_19039));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14390;

										BgL_objz00_14390 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18356, BgL_objz00_14390);
										BgL_objz00_14390;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3456z00_4603;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3457z00_4604;

											BgL_arg3457z00_4604 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19037))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14392;

												BgL_framez00_14392 = BINT(BgL_siza7ezd2framez75_19039);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14394;

													BgL_newz00_14394 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31512;

														BgL_auxz00_31512 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14394, BgL_auxz00_31512,
															BgL_arg3457z00_4604);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31515;

														BgL_auxz00_31515 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14394, BgL_auxz00_31515,
															BgL_framez00_14392);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31518;

														BgL_auxz00_31518 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14394, BgL_auxz00_31518,
															BgL_runz00_18356);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_31523;
														int BgL_auxz00_31521;

														BgL_auxz00_31523 = BINT(((long) -2));
														BgL_auxz00_31521 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14394, BgL_auxz00_31521,
															BgL_auxz00_31523);
													}
													BgL_arg3456z00_4603 = BgL_newz00_14394;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18357, BgL_arg3456z00_4603);
										BgL_arg3456z00_4603;
									}
									return BgL_mainz00_18357;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5543 */
	obj_t BGl_z62main5543z62zz__evaluate_compz00(obj_t BgL_envz00_19041,
		obj_t BgL_dz00_19046, obj_t BgL_lastz00_19047)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19044;
				long BgL_siza7ezd2framez75_19045;

				BgL_runz00_19044 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19041, (int) (((long) 2))));
				BgL_siza7ezd2framez75_19045 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19041, (int) (((long) 3))));
				{
					obj_t BgL_dz00_4605;
					obj_t BgL_lastz00_4606;

					BgL_dz00_4605 = BgL_dz00_19046;
					BgL_lastz00_4606 = BgL_lastz00_19047;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4608;

						BgL_sz00_4608 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4609;

							BgL_bpz00_4609 = VECTOR_REF(BgL_sz00_4608, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_31536;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_14328;

									BgL_nz00_14328 = BINT(BgL_siza7ezd2framez75_19045);
									BgL_testz00_31536 =
										(
										((long) CINT(BgL_bpz00_4609) +
											(long) CINT(BgL_nz00_14328)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4608)));
								}
								if (BgL_testz00_31536)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3460z00_4611;

											BgL_arg3460z00_4611 =
												((long) CINT(BgL_bpz00_4609) + ((long) 0));
											VECTOR_SET(BgL_sz00_4608,
												(int) (BgL_arg3460z00_4611), BgL_dz00_4605);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3462z00_4612;

											BgL_arg3462z00_4612 =
												((long) CINT(BgL_bpz00_4609) + ((long) 1));
											VECTOR_SET(BgL_sz00_4608,
												(int) (BgL_arg3462z00_4612), BgL_lastz00_4606);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4613;

											BgL_ez00_4613 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4613, BgL_bpz00_4609);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4614;

												BgL_accz00_4614 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19044, BgL_sz00_4608, BgL_bpz00_4609);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4613);
												VECTOR_SET(BgL_sz00_4608, (int) (((long) 0)),
													BgL_bpz00_4609);
												return BgL_accz00_4614;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4615;

										BgL_nsz00_4615 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4615,
											(int) (((long) 1)), BgL_sz00_4608);
										VECTOR_SET(BgL_nsz00_4615,
											(int) (((long) 2)), BgL_dz00_4605);
										VECTOR_SET(BgL_nsz00_4615,
											(int) (((long) 3)), BgL_lastz00_4606);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4616;

											BgL_z12denvz12_4616 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4616, BgL_nsz00_4615);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4617;

												BgL_ez00_4617 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4617, BgL_sz00_4608);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4618;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_14365;

														BgL_savedzd2bpzd2_14365 =
															VECTOR_REF(BgL_nsz00_4615, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4615,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14372;

															BgL_fz00_14372 = BgL_runz00_19044;
														BgL_recz00_14371:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14373;

																BgL_rz00_14373 =
																	PROCEDURE_ENTRY(BgL_fz00_14372)
																	(BgL_fz00_14372, BgL_nsz00_4615, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_31578;

																	if (PROCEDUREP(BgL_rz00_14373))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14378;

																			BgL_arg1673z00_14378 =
																				PROCEDURE_ATTR(BgL_rz00_14373);
																			if (STRUCTP(BgL_arg1673z00_14378))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31578 =
																						(STRUCT_KEY(BgL_arg1673z00_14378) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31578 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_31578 = ((bool_t) 0);
																		}
																	if (BgL_testz00_31578)
																		{
																			obj_t BgL_fz00_31586;

																			BgL_fz00_31586 = BgL_rz00_14373;
																			BgL_fz00_14372 = BgL_fz00_31586;
																			goto BgL_recz00_14371;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4615,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_14365);
																			BgL_____rz00_4618 = BgL_rz00_14373;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4617);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4616,
														BgL_sz00_4608);
													return BgL_____rz00_4618;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5544 */
	obj_t BGl_z62run5544z62zz__evaluate_compz00(obj_t BgL_envz00_19048,
		obj_t BgL_sz00_19051)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19049;
				obj_t BgL_bodyz00_19050;

				BgL_i1245z00_19049 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19048, (int) (((long) 0))));
				BgL_bodyz00_19050 = PROCEDURE_REF(BgL_envz00_19048, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4620;

					BgL_sz00_4620 = BgL_sz00_19051;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4622;

						BgL_bpz00_4622 = VECTOR_REF(BgL_sz00_4620, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4623;
							obj_t BgL_wherez00_4624;
							obj_t BgL_locz00_4625;

							BgL_z12denvz12_4623 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4624 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19049))->BgL_wherez00);
							BgL_locz00_4625 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19049))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4623, BgL_wherez00_4624,
									BgL_locz00_4625);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4626;

									BgL_za2za2resza2za2z00_4626 =
										PROCEDURE_ENTRY(BgL_bodyz00_19050) (BgL_bodyz00_19050,
										BgL_sz00_4620, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4623);
									return BgL_za2za2resza2za2z00_4626;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3464> */
	obj_t BGl_z62zc3anonymousza33464ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19052, obj_t BgL_sz00_19057)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19053;
				BgL_ev_absz00_bglt BgL_i1245z00_19054;
				obj_t BgL_bodyz00_19055;
				long BgL_siza7ezd2framez75_19056;

				BgL_iboxesz00_19053 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19052, (int) (((long) 0))));
				BgL_i1245z00_19054 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19052, (int) (((long) 1))));
				BgL_bodyz00_19055 = PROCEDURE_REF(BgL_envz00_19052, (int) (((long) 2)));
				BgL_siza7ezd2framez75_19056 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19052, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4628;

					BgL_sz00_4628 = BgL_sz00_19057;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4630;

						BgL_bpz00_4630 = VECTOR_REF(BgL_sz00_4628, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18353;

								BgL_runz00_18353 =
									MAKE_FX_PROCEDURE(BGl_z62run5546z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18353,
									(int) (((long) 0)), BgL_iboxesz00_19053);
								PROCEDURE_SET(BgL_runz00_18353,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_19054));
								PROCEDURE_SET(BgL_runz00_18353,
									(int) (((long) 2)), BgL_bodyz00_19055);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18354;

									BgL_mainz00_18354 =
										MAKE_VA_PROCEDURE(BGl_z62main5545z62zz__evaluate_compz00,
										(int) (((long) -2)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18354,
										(int) (((long) 0)), BgL_iboxesz00_19053);
									PROCEDURE_SET(BgL_mainz00_18354,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_19054));
									PROCEDURE_SET(BgL_mainz00_18354,
										(int) (((long) 2)), BgL_bodyz00_19055);
									PROCEDURE_SET(BgL_mainz00_18354,
										(int) (((long) 3)), BgL_runz00_18353);
									PROCEDURE_SET(BgL_mainz00_18354,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_19056));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14485;

										BgL_objz00_14485 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18353, BgL_objz00_14485);
										BgL_objz00_14485;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3465z00_4633;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3466z00_4634;

											BgL_arg3466z00_4634 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19054))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14487;

												BgL_framez00_14487 = BINT(BgL_siza7ezd2framez75_19056);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14489;

													BgL_newz00_14489 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31650;

														BgL_auxz00_31650 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14489, BgL_auxz00_31650,
															BgL_arg3466z00_4634);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31653;

														BgL_auxz00_31653 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14489, BgL_auxz00_31653,
															BgL_framez00_14487);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31656;

														BgL_auxz00_31656 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14489, BgL_auxz00_31656,
															BgL_runz00_18353);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_31661;
														int BgL_auxz00_31659;

														BgL_auxz00_31661 = BINT(((long) -2));
														BgL_auxz00_31659 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14489, BgL_auxz00_31659,
															BgL_auxz00_31661);
													}
													BgL_arg3465z00_4633 = BgL_newz00_14489;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18354, BgL_arg3465z00_4633);
										BgL_arg3465z00_4633;
									}
									return BgL_mainz00_18354;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5545 */
	obj_t BGl_z62main5545z62zz__evaluate_compz00(obj_t BgL_envz00_19058,
		obj_t BgL_dz00_19064, obj_t BgL_lastz00_19065)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19062;
				long BgL_siza7ezd2framez75_19063;

				BgL_runz00_19062 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19058, (int) (((long) 3))));
				BgL_siza7ezd2framez75_19063 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19058, (int) (((long) 4))));
				{
					obj_t BgL_dz00_4635;
					obj_t BgL_lastz00_4636;

					BgL_dz00_4635 = BgL_dz00_19064;
					BgL_lastz00_4636 = BgL_lastz00_19065;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4638;

						BgL_sz00_4638 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4639;

							BgL_bpz00_4639 = VECTOR_REF(BgL_sz00_4638, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_31674;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_14423;

									BgL_nz00_14423 = BINT(BgL_siza7ezd2framez75_19063);
									BgL_testz00_31674 =
										(
										((long) CINT(BgL_bpz00_4639) +
											(long) CINT(BgL_nz00_14423)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4638)));
								}
								if (BgL_testz00_31674)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3470z00_4641;

											BgL_arg3470z00_4641 =
												((long) CINT(BgL_bpz00_4639) + ((long) 0));
											VECTOR_SET(BgL_sz00_4638,
												(int) (BgL_arg3470z00_4641), BgL_dz00_4635);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3471z00_4642;

											BgL_arg3471z00_4642 =
												((long) CINT(BgL_bpz00_4639) + ((long) 1));
											VECTOR_SET(BgL_sz00_4638,
												(int) (BgL_arg3471z00_4642), BgL_lastz00_4636);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4643;

											BgL_ez00_4643 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4643, BgL_bpz00_4639);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4644;

												BgL_accz00_4644 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19062, BgL_sz00_4638, BgL_bpz00_4639);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4643);
												VECTOR_SET(BgL_sz00_4638, (int) (((long) 0)),
													BgL_bpz00_4639);
												return BgL_accz00_4644;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4645;

										BgL_nsz00_4645 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4645,
											(int) (((long) 1)), BgL_sz00_4638);
										VECTOR_SET(BgL_nsz00_4645,
											(int) (((long) 2)), BgL_dz00_4635);
										VECTOR_SET(BgL_nsz00_4645,
											(int) (((long) 3)), BgL_lastz00_4636);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4646;

											BgL_z12denvz12_4646 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4646, BgL_nsz00_4645);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4647;

												BgL_ez00_4647 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4647, BgL_sz00_4638);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4648;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_14460;

														BgL_savedzd2bpzd2_14460 =
															VECTOR_REF(BgL_nsz00_4645, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4645,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14467;

															BgL_fz00_14467 = BgL_runz00_19062;
														BgL_recz00_14466:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14468;

																BgL_rz00_14468 =
																	PROCEDURE_ENTRY(BgL_fz00_14467)
																	(BgL_fz00_14467, BgL_nsz00_4645, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_31716;

																	if (PROCEDUREP(BgL_rz00_14468))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14473;

																			BgL_arg1673z00_14473 =
																				PROCEDURE_ATTR(BgL_rz00_14468);
																			if (STRUCTP(BgL_arg1673z00_14473))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31716 =
																						(STRUCT_KEY(BgL_arg1673z00_14473) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31716 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_31716 = ((bool_t) 0);
																		}
																	if (BgL_testz00_31716)
																		{
																			obj_t BgL_fz00_31724;

																			BgL_fz00_31724 = BgL_rz00_14468;
																			BgL_fz00_14467 = BgL_fz00_31724;
																			goto BgL_recz00_14466;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4645,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_14460);
																			BgL_____rz00_4648 = BgL_rz00_14468;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4647);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4646,
														BgL_sz00_4638);
													return BgL_____rz00_4648;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5546 */
	obj_t BGl_z62run5546z62zz__evaluate_compz00(obj_t BgL_envz00_19066,
		obj_t BgL_sz00_19070)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19067;
				BgL_ev_absz00_bglt BgL_i1245z00_19068;
				obj_t BgL_bodyz00_19069;

				BgL_iboxesz00_19067 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19066, (int) (((long) 0))));
				BgL_i1245z00_19068 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19066, (int) (((long) 1))));
				BgL_bodyz00_19069 = PROCEDURE_REF(BgL_envz00_19066, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4650;

					BgL_sz00_4650 = BgL_sz00_19070;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4652;

						BgL_bpz00_4652 = VECTOR_REF(BgL_sz00_4650, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4650,
							BgL_iboxesz00_19067, BgL_bpz00_4652);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4653;
							obj_t BgL_wherez00_4654;
							obj_t BgL_locz00_4655;

							BgL_z12denvz12_4653 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4654 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19068))->BgL_wherez00);
							BgL_locz00_4655 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19068))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4653, BgL_wherez00_4654,
									BgL_locz00_4655);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4656;

									BgL_za2za2resza2za2z00_4656 =
										PROCEDURE_ENTRY(BgL_bodyz00_19069) (BgL_bodyz00_19069,
										BgL_sz00_4650, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4653);
									return BgL_za2za2resza2za2z00_4656;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3476> */
	obj_t BGl_z62zc3anonymousza33476ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19071, obj_t BgL_sz00_19077)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19072;
				long BgL_siza7eza7_19073;
				BgL_ev_absz00_bglt BgL_i1245z00_19074;
				obj_t BgL_bodyz00_19075;
				long BgL_siza7ezd2framez75_19076;

				BgL_ifreesz00_19072 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19071, (int) (((long) 0))));
				BgL_siza7eza7_19073 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19071, (int) (((long) 1))));
				BgL_i1245z00_19074 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19071, (int) (((long) 2))));
				BgL_bodyz00_19075 = PROCEDURE_REF(BgL_envz00_19071, (int) (((long) 3)));
				BgL_siza7ezd2framez75_19076 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19071, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4660;

					BgL_sz00_4660 = BgL_sz00_19077;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4662;

						BgL_bpz00_4662 = VECTOR_REF(BgL_sz00_4660, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4663;

							BgL_valza2za2_4663 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4660,
								BgL_bpz00_4662, BgL_ifreesz00_19072);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18350;

								BgL_runz00_18350 =
									MAKE_FX_PROCEDURE(BGl_z62run5548z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18350,
									(int) (((long) 0)), BINT(BgL_siza7eza7_19073));
								PROCEDURE_SET(BgL_runz00_18350,
									(int) (((long) 1)), BgL_valza2za2_4663);
								PROCEDURE_SET(BgL_runz00_18350,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_19074));
								PROCEDURE_SET(BgL_runz00_18350,
									(int) (((long) 3)), BgL_bodyz00_19075);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18351;

									BgL_mainz00_18351 =
										MAKE_VA_PROCEDURE(BGl_z62main5547z62zz__evaluate_compz00,
										(int) (((long) -2)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18351,
										(int) (((long) 0)), BINT(BgL_siza7eza7_19073));
									PROCEDURE_SET(BgL_mainz00_18351,
										(int) (((long) 1)), BgL_valza2za2_4663);
									PROCEDURE_SET(BgL_mainz00_18351,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_19074));
									PROCEDURE_SET(BgL_mainz00_18351,
										(int) (((long) 3)), BgL_bodyz00_19075);
									PROCEDURE_SET(BgL_mainz00_18351,
										(int) (((long) 4)), BgL_runz00_18350);
									PROCEDURE_SET(BgL_mainz00_18351,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_19076));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14587;

										BgL_objz00_14587 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18350, BgL_objz00_14587);
										BgL_objz00_14587;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3477z00_4666;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3478z00_4667;

											BgL_arg3478z00_4667 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19074))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14589;

												BgL_framez00_14589 = BINT(BgL_siza7ezd2framez75_19076);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14591;

													BgL_newz00_14591 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31802;

														BgL_auxz00_31802 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14591, BgL_auxz00_31802,
															BgL_arg3478z00_4667);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31805;

														BgL_auxz00_31805 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14591, BgL_auxz00_31805,
															BgL_framez00_14589);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31808;

														BgL_auxz00_31808 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14591, BgL_auxz00_31808,
															BgL_runz00_18350);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_31813;
														int BgL_auxz00_31811;

														BgL_auxz00_31813 = BINT(((long) -2));
														BgL_auxz00_31811 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14591, BgL_auxz00_31811,
															BgL_auxz00_31813);
													}
													BgL_arg3477z00_4666 = BgL_newz00_14591;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18351, BgL_arg3477z00_4666);
										BgL_arg3477z00_4666;
									}
									return BgL_mainz00_18351;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5547 */
	obj_t BGl_z62main5547z62zz__evaluate_compz00(obj_t BgL_envz00_19078,
		obj_t BgL_dz00_19085, obj_t BgL_lastz00_19086)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19083;
				long BgL_siza7ezd2framez75_19084;

				BgL_runz00_19083 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19078, (int) (((long) 4))));
				BgL_siza7ezd2framez75_19084 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19078, (int) (((long) 5))));
				{
					obj_t BgL_dz00_4668;
					obj_t BgL_lastz00_4669;

					BgL_dz00_4668 = BgL_dz00_19085;
					BgL_lastz00_4669 = BgL_lastz00_19086;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4671;

						BgL_sz00_4671 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4672;

							BgL_bpz00_4672 = VECTOR_REF(BgL_sz00_4671, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_31826;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_14525;

									BgL_nz00_14525 = BINT(BgL_siza7ezd2framez75_19084);
									BgL_testz00_31826 =
										(
										((long) CINT(BgL_bpz00_4672) +
											(long) CINT(BgL_nz00_14525)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4671)));
								}
								if (BgL_testz00_31826)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3481z00_4674;

											BgL_arg3481z00_4674 =
												((long) CINT(BgL_bpz00_4672) + ((long) 0));
											VECTOR_SET(BgL_sz00_4671,
												(int) (BgL_arg3481z00_4674), BgL_dz00_4668);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3483z00_4675;

											BgL_arg3483z00_4675 =
												((long) CINT(BgL_bpz00_4672) + ((long) 1));
											VECTOR_SET(BgL_sz00_4671,
												(int) (BgL_arg3483z00_4675), BgL_lastz00_4669);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4676;

											BgL_ez00_4676 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4676, BgL_bpz00_4672);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4677;

												BgL_accz00_4677 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19083, BgL_sz00_4671, BgL_bpz00_4672);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4676);
												VECTOR_SET(BgL_sz00_4671, (int) (((long) 0)),
													BgL_bpz00_4672);
												return BgL_accz00_4677;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4678;

										BgL_nsz00_4678 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4678,
											(int) (((long) 1)), BgL_sz00_4671);
										VECTOR_SET(BgL_nsz00_4678,
											(int) (((long) 2)), BgL_dz00_4668);
										VECTOR_SET(BgL_nsz00_4678,
											(int) (((long) 3)), BgL_lastz00_4669);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4679;

											BgL_z12denvz12_4679 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4679, BgL_nsz00_4678);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4680;

												BgL_ez00_4680 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4680, BgL_sz00_4671);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4681;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_14562;

														BgL_savedzd2bpzd2_14562 =
															VECTOR_REF(BgL_nsz00_4678, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4678,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14569;

															BgL_fz00_14569 = BgL_runz00_19083;
														BgL_recz00_14568:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14570;

																BgL_rz00_14570 =
																	PROCEDURE_ENTRY(BgL_fz00_14569)
																	(BgL_fz00_14569, BgL_nsz00_4678, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_31868;

																	if (PROCEDUREP(BgL_rz00_14570))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14575;

																			BgL_arg1673z00_14575 =
																				PROCEDURE_ATTR(BgL_rz00_14570);
																			if (STRUCTP(BgL_arg1673z00_14575))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31868 =
																						(STRUCT_KEY(BgL_arg1673z00_14575) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_31868 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_31868 = ((bool_t) 0);
																		}
																	if (BgL_testz00_31868)
																		{
																			obj_t BgL_fz00_31876;

																			BgL_fz00_31876 = BgL_rz00_14570;
																			BgL_fz00_14569 = BgL_fz00_31876;
																			goto BgL_recz00_14568;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4678,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_14562);
																			BgL_____rz00_4681 = BgL_rz00_14570;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4680);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4679,
														BgL_sz00_4671);
													return BgL_____rz00_4681;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5548 */
	obj_t BGl_z62run5548z62zz__evaluate_compz00(obj_t BgL_envz00_19087,
		obj_t BgL_sz00_19092)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_19088;
				obj_t BgL_valza2za2_19089;
				BgL_ev_absz00_bglt BgL_i1245z00_19090;
				obj_t BgL_bodyz00_19091;

				BgL_siza7eza7_19088 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19087, (int) (((long) 0))));
				BgL_valza2za2_19089 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19087, (int) (((long) 1))));
				BgL_i1245z00_19090 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19087, (int) (((long) 2))));
				BgL_bodyz00_19091 = PROCEDURE_REF(BgL_envz00_19087, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4683;

					BgL_sz00_4683 = BgL_sz00_19092;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4685;

						BgL_bpz00_4685 = VECTOR_REF(BgL_sz00_4683, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4683,
							BgL_valza2za2_19089,
							((long) CINT(BgL_bpz00_4685) + BgL_siza7eza7_19088));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4687;
							obj_t BgL_wherez00_4688;
							obj_t BgL_locz00_4689;

							BgL_z12denvz12_4687 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4688 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19090))->BgL_wherez00);
							BgL_locz00_4689 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19090))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4687, BgL_wherez00_4688,
									BgL_locz00_4689);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4690;

									BgL_za2za2resza2za2z00_4690 =
										PROCEDURE_ENTRY(BgL_bodyz00_19091) (BgL_bodyz00_19091,
										BgL_sz00_4683, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4687);
									return BgL_za2za2resza2za2z00_4690;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3487> */
	obj_t BGl_z62zc3anonymousza33487ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19093, obj_t BgL_sz00_19100)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19094;
				obj_t BgL_iboxesz00_19095;
				long BgL_siza7eza7_19096;
				BgL_ev_absz00_bglt BgL_i1245z00_19097;
				obj_t BgL_bodyz00_19098;
				long BgL_siza7ezd2framez75_19099;

				BgL_ifreesz00_19094 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19093, (int) (((long) 0))));
				BgL_iboxesz00_19095 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19093, (int) (((long) 1))));
				BgL_siza7eza7_19096 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19093, (int) (((long) 2))));
				BgL_i1245z00_19097 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19093, (int) (((long) 3))));
				BgL_bodyz00_19098 = PROCEDURE_REF(BgL_envz00_19093, (int) (((long) 4)));
				BgL_siza7ezd2framez75_19099 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19093, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4692;

					BgL_sz00_4692 = BgL_sz00_19100;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4694;

						BgL_bpz00_4694 = VECTOR_REF(BgL_sz00_4692, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4695;

							BgL_valza2za2_4695 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4692,
								BgL_bpz00_4694, BgL_ifreesz00_19094);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18347;

								BgL_runz00_18347 =
									MAKE_FX_PROCEDURE(BGl_z62run5550z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18347,
									(int) (((long) 0)), BgL_iboxesz00_19095);
								PROCEDURE_SET(BgL_runz00_18347,
									(int) (((long) 1)), BINT(BgL_siza7eza7_19096));
								PROCEDURE_SET(BgL_runz00_18347,
									(int) (((long) 2)), BgL_valza2za2_4695);
								PROCEDURE_SET(BgL_runz00_18347,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_19097));
								PROCEDURE_SET(BgL_runz00_18347,
									(int) (((long) 4)), BgL_bodyz00_19098);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18348;

									BgL_mainz00_18348 =
										MAKE_VA_PROCEDURE(BGl_z62main5549z62zz__evaluate_compz00,
										(int) (((long) -2)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18348,
										(int) (((long) 0)), BgL_iboxesz00_19095);
									PROCEDURE_SET(BgL_mainz00_18348,
										(int) (((long) 1)), BINT(BgL_siza7eza7_19096));
									PROCEDURE_SET(BgL_mainz00_18348,
										(int) (((long) 2)), BgL_valza2za2_4695);
									PROCEDURE_SET(BgL_mainz00_18348,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_19097));
									PROCEDURE_SET(BgL_mainz00_18348,
										(int) (((long) 4)), BgL_bodyz00_19098);
									PROCEDURE_SET(BgL_mainz00_18348,
										(int) (((long) 5)), BgL_runz00_18347);
									PROCEDURE_SET(BgL_mainz00_18348,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_19099));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14685;

										BgL_objz00_14685 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18347, BgL_objz00_14685);
										BgL_objz00_14685;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3488z00_4698;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3489z00_4699;

											BgL_arg3489z00_4699 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19097))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14687;

												BgL_framez00_14687 = BINT(BgL_siza7ezd2framez75_19099);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14689;

													BgL_newz00_14689 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31966;

														BgL_auxz00_31966 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14689, BgL_auxz00_31966,
															BgL_arg3489z00_4699);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31969;

														BgL_auxz00_31969 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14689, BgL_auxz00_31969,
															BgL_framez00_14687);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_31972;

														BgL_auxz00_31972 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14689, BgL_auxz00_31972,
															BgL_runz00_18347);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_31977;
														int BgL_auxz00_31975;

														BgL_auxz00_31977 = BINT(((long) -2));
														BgL_auxz00_31975 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14689, BgL_auxz00_31975,
															BgL_auxz00_31977);
													}
													BgL_arg3488z00_4698 = BgL_newz00_14689;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18348, BgL_arg3488z00_4698);
										BgL_arg3488z00_4698;
									}
									return BgL_mainz00_18348;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5549 */
	obj_t BGl_z62main5549z62zz__evaluate_compz00(obj_t BgL_envz00_19101,
		obj_t BgL_dz00_19109, obj_t BgL_lastz00_19110)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19107;
				long BgL_siza7ezd2framez75_19108;

				BgL_runz00_19107 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19101, (int) (((long) 5))));
				BgL_siza7ezd2framez75_19108 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19101, (int) (((long) 6))));
				{
					obj_t BgL_dz00_4700;
					obj_t BgL_lastz00_4701;

					BgL_dz00_4700 = BgL_dz00_19109;
					BgL_lastz00_4701 = BgL_lastz00_19110;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4703;

						BgL_sz00_4703 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4704;

							BgL_bpz00_4704 = VECTOR_REF(BgL_sz00_4703, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_31990;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_14623;

									BgL_nz00_14623 = BINT(BgL_siza7ezd2framez75_19108);
									BgL_testz00_31990 =
										(
										((long) CINT(BgL_bpz00_4704) +
											(long) CINT(BgL_nz00_14623)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4703)));
								}
								if (BgL_testz00_31990)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3492z00_4706;

											BgL_arg3492z00_4706 =
												((long) CINT(BgL_bpz00_4704) + ((long) 0));
											VECTOR_SET(BgL_sz00_4703,
												(int) (BgL_arg3492z00_4706), BgL_dz00_4700);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3494z00_4707;

											BgL_arg3494z00_4707 =
												((long) CINT(BgL_bpz00_4704) + ((long) 1));
											VECTOR_SET(BgL_sz00_4703,
												(int) (BgL_arg3494z00_4707), BgL_lastz00_4701);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4708;

											BgL_ez00_4708 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4708, BgL_bpz00_4704);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4709;

												BgL_accz00_4709 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19107, BgL_sz00_4703, BgL_bpz00_4704);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4708);
												VECTOR_SET(BgL_sz00_4703, (int) (((long) 0)),
													BgL_bpz00_4704);
												return BgL_accz00_4709;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4710;

										BgL_nsz00_4710 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4710,
											(int) (((long) 1)), BgL_sz00_4703);
										VECTOR_SET(BgL_nsz00_4710,
											(int) (((long) 2)), BgL_dz00_4700);
										VECTOR_SET(BgL_nsz00_4710,
											(int) (((long) 3)), BgL_lastz00_4701);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4711;

											BgL_z12denvz12_4711 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4711, BgL_nsz00_4710);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4712;

												BgL_ez00_4712 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4712, BgL_sz00_4703);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4713;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_14660;

														BgL_savedzd2bpzd2_14660 =
															VECTOR_REF(BgL_nsz00_4710, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4710,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14667;

															BgL_fz00_14667 = BgL_runz00_19107;
														BgL_recz00_14666:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14668;

																BgL_rz00_14668 =
																	PROCEDURE_ENTRY(BgL_fz00_14667)
																	(BgL_fz00_14667, BgL_nsz00_4710, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_32032;

																	if (PROCEDUREP(BgL_rz00_14668))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14673;

																			BgL_arg1673z00_14673 =
																				PROCEDURE_ATTR(BgL_rz00_14668);
																			if (STRUCTP(BgL_arg1673z00_14673))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32032 =
																						(STRUCT_KEY(BgL_arg1673z00_14673) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32032 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_32032 = ((bool_t) 0);
																		}
																	if (BgL_testz00_32032)
																		{
																			obj_t BgL_fz00_32040;

																			BgL_fz00_32040 = BgL_rz00_14668;
																			BgL_fz00_14667 = BgL_fz00_32040;
																			goto BgL_recz00_14666;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4710,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_14660);
																			BgL_____rz00_4713 = BgL_rz00_14668;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4712);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4711,
														BgL_sz00_4703);
													return BgL_____rz00_4713;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5550 */
	obj_t BGl_z62run5550z62zz__evaluate_compz00(obj_t BgL_envz00_19111,
		obj_t BgL_sz00_19117)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19112;
				long BgL_siza7eza7_19113;
				obj_t BgL_valza2za2_19114;
				BgL_ev_absz00_bglt BgL_i1245z00_19115;
				obj_t BgL_bodyz00_19116;

				BgL_iboxesz00_19112 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19111, (int) (((long) 0))));
				BgL_siza7eza7_19113 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19111, (int) (((long) 1))));
				BgL_valza2za2_19114 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19111, (int) (((long) 2))));
				BgL_i1245z00_19115 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19111, (int) (((long) 3))));
				BgL_bodyz00_19116 = PROCEDURE_REF(BgL_envz00_19111, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4715;

					BgL_sz00_4715 = BgL_sz00_19117;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4717;

						BgL_bpz00_4717 = VECTOR_REF(BgL_sz00_4715, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4715,
							BgL_iboxesz00_19112, BgL_bpz00_4717);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4715,
							BgL_valza2za2_19114,
							((long) CINT(BgL_bpz00_4717) + BgL_siza7eza7_19113));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4719;
							obj_t BgL_wherez00_4720;
							obj_t BgL_locz00_4721;

							BgL_z12denvz12_4719 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4720 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19115))->BgL_wherez00);
							BgL_locz00_4721 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19115))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4719, BgL_wherez00_4720,
									BgL_locz00_4721);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4722;

									BgL_za2za2resza2za2z00_4722 =
										PROCEDURE_ENTRY(BgL_bodyz00_19116) (BgL_bodyz00_19116,
										BgL_sz00_4715, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4719);
									return BgL_za2za2resza2za2z00_4722;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3417> */
	obj_t BGl_z62zc3anonymousza33417ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19118, obj_t BgL_sz00_19122)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19119;
				obj_t BgL_bodyz00_19120;
				long BgL_siza7ezd2framez75_19121;

				BgL_i1245z00_19119 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19118, (int) (((long) 0))));
				BgL_bodyz00_19120 = PROCEDURE_REF(BgL_envz00_19118, (int) (((long) 1)));
				BgL_siza7ezd2framez75_19121 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19118, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4476;

					BgL_sz00_4476 = BgL_sz00_19122;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4478;

						BgL_bpz00_4478 = VECTOR_REF(BgL_sz00_4476, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18344;

								BgL_runz00_18344 =
									MAKE_FX_PROCEDURE(BGl_z62run5552z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18344,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_19119));
								PROCEDURE_SET(BgL_runz00_18344,
									(int) (((long) 1)), BgL_bodyz00_19120);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18345;

									BgL_mainz00_18345 =
										MAKE_FX_PROCEDURE(BGl_z62main5551z62zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18345,
										(int) (((long) 0)), ((obj_t) BgL_i1245z00_19119));
									PROCEDURE_SET(BgL_mainz00_18345,
										(int) (((long) 1)), BgL_bodyz00_19120);
									PROCEDURE_SET(BgL_mainz00_18345,
										(int) (((long) 2)), BgL_runz00_18344);
									PROCEDURE_SET(BgL_mainz00_18345,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_19121));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14019;

										BgL_objz00_14019 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18344, BgL_objz00_14019);
										BgL_objz00_14019;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3418z00_4481;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3419z00_4482;

											BgL_arg3419z00_4482 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19119))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14021;

												BgL_framez00_14021 = BINT(BgL_siza7ezd2framez75_19121);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14023;

													BgL_newz00_14023 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32110;

														BgL_auxz00_32110 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14023, BgL_auxz00_32110,
															BgL_arg3419z00_4482);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32113;

														BgL_auxz00_32113 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14023, BgL_auxz00_32113,
															BgL_framez00_14021);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32116;

														BgL_auxz00_32116 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14023, BgL_auxz00_32116,
															BgL_runz00_18344);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_32121;
														int BgL_auxz00_32119;

														BgL_auxz00_32121 = BINT(((long) 1));
														BgL_auxz00_32119 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14023, BgL_auxz00_32119,
															BgL_auxz00_32121);
													}
													BgL_arg3418z00_4481 = BgL_newz00_14023;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18345, BgL_arg3418z00_4481);
										BgL_arg3418z00_4481;
									}
									return BgL_mainz00_18345;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5551 */
	obj_t BGl_z62main5551z62zz__evaluate_compz00(obj_t BgL_envz00_19123,
		obj_t BgL_dz00_19128)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19126;
				long BgL_siza7ezd2framez75_19127;

				BgL_runz00_19126 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19123, (int) (((long) 2))));
				BgL_siza7ezd2framez75_19127 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19123, (int) (((long) 3))));
				{
					obj_t BgL_dz00_4483;

					BgL_dz00_4483 = BgL_dz00_19128;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4485;

						BgL_sz00_4485 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4486;

							BgL_bpz00_4486 = VECTOR_REF(BgL_sz00_4485, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_32134;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_13966;

									BgL_nz00_13966 = BINT(BgL_siza7ezd2framez75_19127);
									BgL_testz00_32134 =
										(
										((long) CINT(BgL_bpz00_4486) +
											(long) CINT(BgL_nz00_13966)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4485)));
								}
								if (BgL_testz00_32134)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3422z00_4488;

											BgL_arg3422z00_4488 =
												((long) CINT(BgL_bpz00_4486) + ((long) 0));
											VECTOR_SET(BgL_sz00_4485,
												(int) (BgL_arg3422z00_4488), BgL_dz00_4483);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4489;

											BgL_ez00_4489 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4489, BgL_bpz00_4486);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4490;

												BgL_accz00_4490 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19126, BgL_sz00_4485, BgL_bpz00_4486);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4489);
												VECTOR_SET(BgL_sz00_4485, (int) (((long) 0)),
													BgL_bpz00_4486);
												return BgL_accz00_4490;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4491;

										BgL_nsz00_4491 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4491,
											(int) (((long) 1)), BgL_sz00_4485);
										VECTOR_SET(BgL_nsz00_4491,
											(int) (((long) 2)), BgL_dz00_4483);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4492;

											BgL_z12denvz12_4492 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4492, BgL_nsz00_4491);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4493;

												BgL_ez00_4493 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4493, BgL_sz00_4485);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4494;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13994;

														BgL_savedzd2bpzd2_13994 =
															VECTOR_REF(BgL_nsz00_4491, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4491,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14001;

															BgL_fz00_14001 = BgL_runz00_19126;
														BgL_recz00_14000:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14002;

																BgL_rz00_14002 =
																	PROCEDURE_ENTRY(BgL_fz00_14001)
																	(BgL_fz00_14001, BgL_nsz00_4491, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_32170;

																	if (PROCEDUREP(BgL_rz00_14002))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14007;

																			BgL_arg1673z00_14007 =
																				PROCEDURE_ATTR(BgL_rz00_14002);
																			if (STRUCTP(BgL_arg1673z00_14007))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32170 =
																						(STRUCT_KEY(BgL_arg1673z00_14007) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32170 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_32170 = ((bool_t) 0);
																		}
																	if (BgL_testz00_32170)
																		{
																			obj_t BgL_fz00_32178;

																			BgL_fz00_32178 = BgL_rz00_14002;
																			BgL_fz00_14001 = BgL_fz00_32178;
																			goto BgL_recz00_14000;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4491,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13994);
																			BgL_____rz00_4494 = BgL_rz00_14002;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4493);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4492,
														BgL_sz00_4485);
													return BgL_____rz00_4494;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5552 */
	obj_t BGl_z62run5552z62zz__evaluate_compz00(obj_t BgL_envz00_19129,
		obj_t BgL_sz00_19132)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19130;
				obj_t BgL_bodyz00_19131;

				BgL_i1245z00_19130 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19129, (int) (((long) 0))));
				BgL_bodyz00_19131 = PROCEDURE_REF(BgL_envz00_19129, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4496;

					BgL_sz00_4496 = BgL_sz00_19132;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4498;

						BgL_bpz00_4498 = VECTOR_REF(BgL_sz00_4496, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4499;
							obj_t BgL_wherez00_4500;
							obj_t BgL_locz00_4501;

							BgL_z12denvz12_4499 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4500 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19130))->BgL_wherez00);
							BgL_locz00_4501 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19130))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4499, BgL_wherez00_4500,
									BgL_locz00_4501);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4502;

									BgL_za2za2resza2za2z00_4502 =
										PROCEDURE_ENTRY(BgL_bodyz00_19131) (BgL_bodyz00_19131,
										BgL_sz00_4496, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4499);
									return BgL_za2za2resza2za2z00_4502;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3424> */
	obj_t BGl_z62zc3anonymousza33424ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19133, obj_t BgL_sz00_19138)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19134;
				BgL_ev_absz00_bglt BgL_i1245z00_19135;
				obj_t BgL_bodyz00_19136;
				long BgL_siza7ezd2framez75_19137;

				BgL_iboxesz00_19134 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19133, (int) (((long) 0))));
				BgL_i1245z00_19135 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19133, (int) (((long) 1))));
				BgL_bodyz00_19136 = PROCEDURE_REF(BgL_envz00_19133, (int) (((long) 2)));
				BgL_siza7ezd2framez75_19137 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19133, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4504;

					BgL_sz00_4504 = BgL_sz00_19138;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4506;

						BgL_bpz00_4506 = VECTOR_REF(BgL_sz00_4504, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18341;

								BgL_runz00_18341 =
									MAKE_FX_PROCEDURE(BGl_z62run5554z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18341,
									(int) (((long) 0)), BgL_iboxesz00_19134);
								PROCEDURE_SET(BgL_runz00_18341,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_19135));
								PROCEDURE_SET(BgL_runz00_18341,
									(int) (((long) 2)), BgL_bodyz00_19136);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18342;

									BgL_mainz00_18342 =
										MAKE_FX_PROCEDURE(BGl_z62main5553z62zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18342,
										(int) (((long) 0)), BgL_iboxesz00_19134);
									PROCEDURE_SET(BgL_mainz00_18342,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_19135));
									PROCEDURE_SET(BgL_mainz00_18342,
										(int) (((long) 2)), BgL_bodyz00_19136);
									PROCEDURE_SET(BgL_mainz00_18342,
										(int) (((long) 3)), BgL_runz00_18341);
									PROCEDURE_SET(BgL_mainz00_18342,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_19137));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14105;

										BgL_objz00_14105 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18341, BgL_objz00_14105);
										BgL_objz00_14105;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3425z00_4509;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3426z00_4510;

											BgL_arg3426z00_4510 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19135))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14107;

												BgL_framez00_14107 = BINT(BgL_siza7ezd2framez75_19137);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14109;

													BgL_newz00_14109 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32242;

														BgL_auxz00_32242 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14109, BgL_auxz00_32242,
															BgL_arg3426z00_4510);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32245;

														BgL_auxz00_32245 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14109, BgL_auxz00_32245,
															BgL_framez00_14107);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32248;

														BgL_auxz00_32248 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14109, BgL_auxz00_32248,
															BgL_runz00_18341);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_32253;
														int BgL_auxz00_32251;

														BgL_auxz00_32253 = BINT(((long) 1));
														BgL_auxz00_32251 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14109, BgL_auxz00_32251,
															BgL_auxz00_32253);
													}
													BgL_arg3425z00_4509 = BgL_newz00_14109;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18342, BgL_arg3425z00_4509);
										BgL_arg3425z00_4509;
									}
									return BgL_mainz00_18342;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5553 */
	obj_t BGl_z62main5553z62zz__evaluate_compz00(obj_t BgL_envz00_19139,
		obj_t BgL_dz00_19145)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19143;
				long BgL_siza7ezd2framez75_19144;

				BgL_runz00_19143 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19139, (int) (((long) 3))));
				BgL_siza7ezd2framez75_19144 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19139, (int) (((long) 4))));
				{
					obj_t BgL_dz00_4511;

					BgL_dz00_4511 = BgL_dz00_19145;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4513;

						BgL_sz00_4513 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4514;

							BgL_bpz00_4514 = VECTOR_REF(BgL_sz00_4513, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_32266;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_14052;

									BgL_nz00_14052 = BINT(BgL_siza7ezd2framez75_19144);
									BgL_testz00_32266 =
										(
										((long) CINT(BgL_bpz00_4514) +
											(long) CINT(BgL_nz00_14052)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4513)));
								}
								if (BgL_testz00_32266)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3429z00_4516;

											BgL_arg3429z00_4516 =
												((long) CINT(BgL_bpz00_4514) + ((long) 0));
											VECTOR_SET(BgL_sz00_4513,
												(int) (BgL_arg3429z00_4516), BgL_dz00_4511);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4517;

											BgL_ez00_4517 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4517, BgL_bpz00_4514);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4518;

												BgL_accz00_4518 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19143, BgL_sz00_4513, BgL_bpz00_4514);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4517);
												VECTOR_SET(BgL_sz00_4513, (int) (((long) 0)),
													BgL_bpz00_4514);
												return BgL_accz00_4518;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4519;

										BgL_nsz00_4519 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4519,
											(int) (((long) 1)), BgL_sz00_4513);
										VECTOR_SET(BgL_nsz00_4519,
											(int) (((long) 2)), BgL_dz00_4511);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4520;

											BgL_z12denvz12_4520 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4520, BgL_nsz00_4519);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4521;

												BgL_ez00_4521 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4521, BgL_sz00_4513);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4522;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_14080;

														BgL_savedzd2bpzd2_14080 =
															VECTOR_REF(BgL_nsz00_4519, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4519,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14087;

															BgL_fz00_14087 = BgL_runz00_19143;
														BgL_recz00_14086:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14088;

																BgL_rz00_14088 =
																	PROCEDURE_ENTRY(BgL_fz00_14087)
																	(BgL_fz00_14087, BgL_nsz00_4519, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_32302;

																	if (PROCEDUREP(BgL_rz00_14088))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14093;

																			BgL_arg1673z00_14093 =
																				PROCEDURE_ATTR(BgL_rz00_14088);
																			if (STRUCTP(BgL_arg1673z00_14093))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32302 =
																						(STRUCT_KEY(BgL_arg1673z00_14093) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32302 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_32302 = ((bool_t) 0);
																		}
																	if (BgL_testz00_32302)
																		{
																			obj_t BgL_fz00_32310;

																			BgL_fz00_32310 = BgL_rz00_14088;
																			BgL_fz00_14087 = BgL_fz00_32310;
																			goto BgL_recz00_14086;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4519,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_14080);
																			BgL_____rz00_4522 = BgL_rz00_14088;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4521);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4520,
														BgL_sz00_4513);
													return BgL_____rz00_4522;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5554 */
	obj_t BGl_z62run5554z62zz__evaluate_compz00(obj_t BgL_envz00_19146,
		obj_t BgL_sz00_19150)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19147;
				BgL_ev_absz00_bglt BgL_i1245z00_19148;
				obj_t BgL_bodyz00_19149;

				BgL_iboxesz00_19147 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19146, (int) (((long) 0))));
				BgL_i1245z00_19148 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19146, (int) (((long) 1))));
				BgL_bodyz00_19149 = PROCEDURE_REF(BgL_envz00_19146, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4524;

					BgL_sz00_4524 = BgL_sz00_19150;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4526;

						BgL_bpz00_4526 = VECTOR_REF(BgL_sz00_4524, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4524,
							BgL_iboxesz00_19147, BgL_bpz00_4526);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4527;
							obj_t BgL_wherez00_4528;
							obj_t BgL_locz00_4529;

							BgL_z12denvz12_4527 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4528 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19148))->BgL_wherez00);
							BgL_locz00_4529 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19148))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4527, BgL_wherez00_4528,
									BgL_locz00_4529);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4530;

									BgL_za2za2resza2za2z00_4530 =
										PROCEDURE_ENTRY(BgL_bodyz00_19149) (BgL_bodyz00_19149,
										BgL_sz00_4524, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4527);
									return BgL_za2za2resza2za2z00_4530;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3433> */
	obj_t BGl_z62zc3anonymousza33433ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19151, obj_t BgL_sz00_19157)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19152;
				long BgL_siza7eza7_19153;
				BgL_ev_absz00_bglt BgL_i1245z00_19154;
				obj_t BgL_bodyz00_19155;
				long BgL_siza7ezd2framez75_19156;

				BgL_ifreesz00_19152 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19151, (int) (((long) 0))));
				BgL_siza7eza7_19153 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19151, (int) (((long) 1))));
				BgL_i1245z00_19154 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19151, (int) (((long) 2))));
				BgL_bodyz00_19155 = PROCEDURE_REF(BgL_envz00_19151, (int) (((long) 3)));
				BgL_siza7ezd2framez75_19156 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19151, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4534;

					BgL_sz00_4534 = BgL_sz00_19157;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4536;

						BgL_bpz00_4536 = VECTOR_REF(BgL_sz00_4534, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4537;

							BgL_valza2za2_4537 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4534,
								BgL_bpz00_4536, BgL_ifreesz00_19152);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18338;

								BgL_runz00_18338 =
									MAKE_FX_PROCEDURE(BGl_z62run5556z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18338,
									(int) (((long) 0)), BINT(BgL_siza7eza7_19153));
								PROCEDURE_SET(BgL_runz00_18338,
									(int) (((long) 1)), BgL_valza2za2_4537);
								PROCEDURE_SET(BgL_runz00_18338,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_19154));
								PROCEDURE_SET(BgL_runz00_18338,
									(int) (((long) 3)), BgL_bodyz00_19155);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18339;

									BgL_mainz00_18339 =
										MAKE_FX_PROCEDURE(BGl_z62main5555z62zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18339,
										(int) (((long) 0)), BINT(BgL_siza7eza7_19153));
									PROCEDURE_SET(BgL_mainz00_18339,
										(int) (((long) 1)), BgL_valza2za2_4537);
									PROCEDURE_SET(BgL_mainz00_18339,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_19154));
									PROCEDURE_SET(BgL_mainz00_18339,
										(int) (((long) 3)), BgL_bodyz00_19155);
									PROCEDURE_SET(BgL_mainz00_18339,
										(int) (((long) 4)), BgL_runz00_18338);
									PROCEDURE_SET(BgL_mainz00_18339,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_19156));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14198;

										BgL_objz00_14198 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18338, BgL_objz00_14198);
										BgL_objz00_14198;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3434z00_4540;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3435z00_4541;

											BgL_arg3435z00_4541 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19154))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14200;

												BgL_framez00_14200 = BINT(BgL_siza7ezd2framez75_19156);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14202;

													BgL_newz00_14202 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32388;

														BgL_auxz00_32388 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14202, BgL_auxz00_32388,
															BgL_arg3435z00_4541);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32391;

														BgL_auxz00_32391 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14202, BgL_auxz00_32391,
															BgL_framez00_14200);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32394;

														BgL_auxz00_32394 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14202, BgL_auxz00_32394,
															BgL_runz00_18338);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_32399;
														int BgL_auxz00_32397;

														BgL_auxz00_32399 = BINT(((long) 1));
														BgL_auxz00_32397 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14202, BgL_auxz00_32397,
															BgL_auxz00_32399);
													}
													BgL_arg3434z00_4540 = BgL_newz00_14202;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18339, BgL_arg3434z00_4540);
										BgL_arg3434z00_4540;
									}
									return BgL_mainz00_18339;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5555 */
	obj_t BGl_z62main5555z62zz__evaluate_compz00(obj_t BgL_envz00_19158,
		obj_t BgL_dz00_19165)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19163;
				long BgL_siza7ezd2framez75_19164;

				BgL_runz00_19163 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19158, (int) (((long) 4))));
				BgL_siza7ezd2framez75_19164 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19158, (int) (((long) 5))));
				{
					obj_t BgL_dz00_4542;

					BgL_dz00_4542 = BgL_dz00_19165;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4544;

						BgL_sz00_4544 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4545;

							BgL_bpz00_4545 = VECTOR_REF(BgL_sz00_4544, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_32412;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_14145;

									BgL_nz00_14145 = BINT(BgL_siza7ezd2framez75_19164);
									BgL_testz00_32412 =
										(
										((long) CINT(BgL_bpz00_4545) +
											(long) CINT(BgL_nz00_14145)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4544)));
								}
								if (BgL_testz00_32412)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3438z00_4547;

											BgL_arg3438z00_4547 =
												((long) CINT(BgL_bpz00_4545) + ((long) 0));
											VECTOR_SET(BgL_sz00_4544,
												(int) (BgL_arg3438z00_4547), BgL_dz00_4542);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4548;

											BgL_ez00_4548 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4548, BgL_bpz00_4545);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4549;

												BgL_accz00_4549 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19163, BgL_sz00_4544, BgL_bpz00_4545);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4548);
												VECTOR_SET(BgL_sz00_4544, (int) (((long) 0)),
													BgL_bpz00_4545);
												return BgL_accz00_4549;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4550;

										BgL_nsz00_4550 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4550,
											(int) (((long) 1)), BgL_sz00_4544);
										VECTOR_SET(BgL_nsz00_4550,
											(int) (((long) 2)), BgL_dz00_4542);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4551;

											BgL_z12denvz12_4551 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4551, BgL_nsz00_4550);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4552;

												BgL_ez00_4552 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4552, BgL_sz00_4544);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4553;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_14173;

														BgL_savedzd2bpzd2_14173 =
															VECTOR_REF(BgL_nsz00_4550, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4550,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14180;

															BgL_fz00_14180 = BgL_runz00_19163;
														BgL_recz00_14179:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14181;

																BgL_rz00_14181 =
																	PROCEDURE_ENTRY(BgL_fz00_14180)
																	(BgL_fz00_14180, BgL_nsz00_4550, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_32448;

																	if (PROCEDUREP(BgL_rz00_14181))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14186;

																			BgL_arg1673z00_14186 =
																				PROCEDURE_ATTR(BgL_rz00_14181);
																			if (STRUCTP(BgL_arg1673z00_14186))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32448 =
																						(STRUCT_KEY(BgL_arg1673z00_14186) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32448 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_32448 = ((bool_t) 0);
																		}
																	if (BgL_testz00_32448)
																		{
																			obj_t BgL_fz00_32456;

																			BgL_fz00_32456 = BgL_rz00_14181;
																			BgL_fz00_14180 = BgL_fz00_32456;
																			goto BgL_recz00_14179;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4550,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_14173);
																			BgL_____rz00_4553 = BgL_rz00_14181;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4552);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4551,
														BgL_sz00_4544);
													return BgL_____rz00_4553;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5556 */
	obj_t BGl_z62run5556z62zz__evaluate_compz00(obj_t BgL_envz00_19166,
		obj_t BgL_sz00_19171)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_19167;
				obj_t BgL_valza2za2_19168;
				BgL_ev_absz00_bglt BgL_i1245z00_19169;
				obj_t BgL_bodyz00_19170;

				BgL_siza7eza7_19167 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19166, (int) (((long) 0))));
				BgL_valza2za2_19168 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19166, (int) (((long) 1))));
				BgL_i1245z00_19169 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19166, (int) (((long) 2))));
				BgL_bodyz00_19170 = PROCEDURE_REF(BgL_envz00_19166, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4555;

					BgL_sz00_4555 = BgL_sz00_19171;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4557;

						BgL_bpz00_4557 = VECTOR_REF(BgL_sz00_4555, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4555,
							BgL_valza2za2_19168,
							((long) CINT(BgL_bpz00_4557) + BgL_siza7eza7_19167));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4559;
							obj_t BgL_wherez00_4560;
							obj_t BgL_locz00_4561;

							BgL_z12denvz12_4559 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4560 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19169))->BgL_wherez00);
							BgL_locz00_4561 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19169))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4559, BgL_wherez00_4560,
									BgL_locz00_4561);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4562;

									BgL_za2za2resza2za2z00_4562 =
										PROCEDURE_ENTRY(BgL_bodyz00_19170) (BgL_bodyz00_19170,
										BgL_sz00_4555, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4559);
									return BgL_za2za2resza2za2z00_4562;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3441> */
	obj_t BGl_z62zc3anonymousza33441ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19172, obj_t BgL_sz00_19179)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19173;
				obj_t BgL_iboxesz00_19174;
				long BgL_siza7eza7_19175;
				BgL_ev_absz00_bglt BgL_i1245z00_19176;
				obj_t BgL_bodyz00_19177;
				long BgL_siza7ezd2framez75_19178;

				BgL_ifreesz00_19173 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19172, (int) (((long) 0))));
				BgL_iboxesz00_19174 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19172, (int) (((long) 1))));
				BgL_siza7eza7_19175 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19172, (int) (((long) 2))));
				BgL_i1245z00_19176 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19172, (int) (((long) 3))));
				BgL_bodyz00_19177 = PROCEDURE_REF(BgL_envz00_19172, (int) (((long) 4)));
				BgL_siza7ezd2framez75_19178 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19172, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4564;

					BgL_sz00_4564 = BgL_sz00_19179;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4566;

						BgL_bpz00_4566 = VECTOR_REF(BgL_sz00_4564, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4567;

							BgL_valza2za2_4567 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4564,
								BgL_bpz00_4566, BgL_ifreesz00_19173);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18335;

								BgL_runz00_18335 =
									MAKE_FX_PROCEDURE(BGl_z62run5558z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18335,
									(int) (((long) 0)), BgL_iboxesz00_19174);
								PROCEDURE_SET(BgL_runz00_18335,
									(int) (((long) 1)), BINT(BgL_siza7eza7_19175));
								PROCEDURE_SET(BgL_runz00_18335,
									(int) (((long) 2)), BgL_valza2za2_4567);
								PROCEDURE_SET(BgL_runz00_18335,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_19176));
								PROCEDURE_SET(BgL_runz00_18335,
									(int) (((long) 4)), BgL_bodyz00_19177);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18336;

									BgL_mainz00_18336 =
										MAKE_FX_PROCEDURE(BGl_z62main5557z62zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18336,
										(int) (((long) 0)), BgL_iboxesz00_19174);
									PROCEDURE_SET(BgL_mainz00_18336,
										(int) (((long) 1)), BINT(BgL_siza7eza7_19175));
									PROCEDURE_SET(BgL_mainz00_18336,
										(int) (((long) 2)), BgL_valza2za2_4567);
									PROCEDURE_SET(BgL_mainz00_18336,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_19176));
									PROCEDURE_SET(BgL_mainz00_18336,
										(int) (((long) 4)), BgL_bodyz00_19177);
									PROCEDURE_SET(BgL_mainz00_18336,
										(int) (((long) 5)), BgL_runz00_18335);
									PROCEDURE_SET(BgL_mainz00_18336,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_19178));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_14287;

										BgL_objz00_14287 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18335, BgL_objz00_14287);
										BgL_objz00_14287;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3442z00_4570;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3443z00_4571;

											BgL_arg3443z00_4571 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19176))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_14289;

												BgL_framez00_14289 = BINT(BgL_siza7ezd2framez75_19178);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_14291;

													BgL_newz00_14291 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32546;

														BgL_auxz00_32546 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_14291, BgL_auxz00_32546,
															BgL_arg3443z00_4571);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32549;

														BgL_auxz00_32549 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_14291, BgL_auxz00_32549,
															BgL_framez00_14289);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32552;

														BgL_auxz00_32552 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_14291, BgL_auxz00_32552,
															BgL_runz00_18335);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_32557;
														int BgL_auxz00_32555;

														BgL_auxz00_32557 = BINT(((long) 1));
														BgL_auxz00_32555 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_14291, BgL_auxz00_32555,
															BgL_auxz00_32557);
													}
													BgL_arg3442z00_4570 = BgL_newz00_14291;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18336, BgL_arg3442z00_4570);
										BgL_arg3442z00_4570;
									}
									return BgL_mainz00_18336;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5557 */
	obj_t BGl_z62main5557z62zz__evaluate_compz00(obj_t BgL_envz00_19180,
		obj_t BgL_dz00_19188)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19186;
				long BgL_siza7ezd2framez75_19187;

				BgL_runz00_19186 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19180, (int) (((long) 5))));
				BgL_siza7ezd2framez75_19187 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19180, (int) (((long) 6))));
				{
					obj_t BgL_dz00_4572;

					BgL_dz00_4572 = BgL_dz00_19188;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4574;

						BgL_sz00_4574 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4575;

							BgL_bpz00_4575 = VECTOR_REF(BgL_sz00_4574, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_32570;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_14234;

									BgL_nz00_14234 = BINT(BgL_siza7ezd2framez75_19187);
									BgL_testz00_32570 =
										(
										((long) CINT(BgL_bpz00_4575) +
											(long) CINT(BgL_nz00_14234)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4574)));
								}
								if (BgL_testz00_32570)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3446z00_4577;

											BgL_arg3446z00_4577 =
												((long) CINT(BgL_bpz00_4575) + ((long) 0));
											VECTOR_SET(BgL_sz00_4574,
												(int) (BgL_arg3446z00_4577), BgL_dz00_4572);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4578;

											BgL_ez00_4578 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4578, BgL_bpz00_4575);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4579;

												BgL_accz00_4579 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19186, BgL_sz00_4574, BgL_bpz00_4575);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4578);
												VECTOR_SET(BgL_sz00_4574, (int) (((long) 0)),
													BgL_bpz00_4575);
												return BgL_accz00_4579;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4580;

										BgL_nsz00_4580 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4580,
											(int) (((long) 1)), BgL_sz00_4574);
										VECTOR_SET(BgL_nsz00_4580,
											(int) (((long) 2)), BgL_dz00_4572);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4581;

											BgL_z12denvz12_4581 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4581, BgL_nsz00_4580);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4582;

												BgL_ez00_4582 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4582, BgL_sz00_4574);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4583;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_14262;

														BgL_savedzd2bpzd2_14262 =
															VECTOR_REF(BgL_nsz00_4580, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4580,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_14269;

															BgL_fz00_14269 = BgL_runz00_19186;
														BgL_recz00_14268:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_14270;

																BgL_rz00_14270 =
																	PROCEDURE_ENTRY(BgL_fz00_14269)
																	(BgL_fz00_14269, BgL_nsz00_4580, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_32606;

																	if (PROCEDUREP(BgL_rz00_14270))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_14275;

																			BgL_arg1673z00_14275 =
																				PROCEDURE_ATTR(BgL_rz00_14270);
																			if (STRUCTP(BgL_arg1673z00_14275))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32606 =
																						(STRUCT_KEY(BgL_arg1673z00_14275) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32606 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_32606 = ((bool_t) 0);
																		}
																	if (BgL_testz00_32606)
																		{
																			obj_t BgL_fz00_32614;

																			BgL_fz00_32614 = BgL_rz00_14270;
																			BgL_fz00_14269 = BgL_fz00_32614;
																			goto BgL_recz00_14268;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4580,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_14262);
																			BgL_____rz00_4583 = BgL_rz00_14270;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4582);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4581,
														BgL_sz00_4574);
													return BgL_____rz00_4583;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5558 */
	obj_t BGl_z62run5558z62zz__evaluate_compz00(obj_t BgL_envz00_19189,
		obj_t BgL_sz00_19195)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19190;
				long BgL_siza7eza7_19191;
				obj_t BgL_valza2za2_19192;
				BgL_ev_absz00_bglt BgL_i1245z00_19193;
				obj_t BgL_bodyz00_19194;

				BgL_iboxesz00_19190 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19189, (int) (((long) 0))));
				BgL_siza7eza7_19191 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19189, (int) (((long) 1))));
				BgL_valza2za2_19192 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19189, (int) (((long) 2))));
				BgL_i1245z00_19193 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19189, (int) (((long) 3))));
				BgL_bodyz00_19194 = PROCEDURE_REF(BgL_envz00_19189, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4585;

					BgL_sz00_4585 = BgL_sz00_19195;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4587;

						BgL_bpz00_4587 = VECTOR_REF(BgL_sz00_4585, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4585,
							BgL_iboxesz00_19190, BgL_bpz00_4587);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4585,
							BgL_valza2za2_19192,
							((long) CINT(BgL_bpz00_4587) + BgL_siza7eza7_19191));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4589;
							obj_t BgL_wherez00_4590;
							obj_t BgL_locz00_4591;

							BgL_z12denvz12_4589 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4590 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19193))->BgL_wherez00);
							BgL_locz00_4591 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19193))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4589, BgL_wherez00_4590,
									BgL_locz00_4591);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4592;

									BgL_za2za2resza2za2z00_4592 =
										PROCEDURE_ENTRY(BgL_bodyz00_19194) (BgL_bodyz00_19194,
										BgL_sz00_4585, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4589);
									return BgL_za2za2resza2za2z00_4592;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3379> */
	obj_t BGl_z62zc3anonymousza33379ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19196, obj_t BgL_sz00_19200)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19197;
				obj_t BgL_bodyz00_19198;
				long BgL_siza7ezd2framez75_19199;

				BgL_i1245z00_19197 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19196, (int) (((long) 0))));
				BgL_bodyz00_19198 = PROCEDURE_REF(BgL_envz00_19196, (int) (((long) 1)));
				BgL_siza7ezd2framez75_19199 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19196, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4354;

					BgL_sz00_4354 = BgL_sz00_19200;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4356;

						BgL_bpz00_4356 = VECTOR_REF(BgL_sz00_4354, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18332;

								BgL_runz00_18332 =
									MAKE_FX_PROCEDURE(BGl_z62run5560z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18332,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_19197));
								PROCEDURE_SET(BgL_runz00_18332,
									(int) (((long) 1)), BgL_bodyz00_19198);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18333;

									BgL_mainz00_18333 =
										MAKE_VA_PROCEDURE(BGl_z62main5559z62zz__evaluate_compz00,
										(int) (((long) -1)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18333,
										(int) (((long) 0)), ((obj_t) BgL_i1245z00_19197));
									PROCEDURE_SET(BgL_mainz00_18333,
										(int) (((long) 1)), BgL_bodyz00_19198);
									PROCEDURE_SET(BgL_mainz00_18333,
										(int) (((long) 2)), BgL_runz00_18332);
									PROCEDURE_SET(BgL_mainz00_18333,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_19199));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_13657;

										BgL_objz00_13657 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18332, BgL_objz00_13657);
										BgL_objz00_13657;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3380z00_4359;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3381z00_4360;

											BgL_arg3381z00_4360 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19197))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_13659;

												BgL_framez00_13659 = BINT(BgL_siza7ezd2framez75_19199);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_13661;

													BgL_newz00_13661 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32684;

														BgL_auxz00_32684 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_13661, BgL_auxz00_32684,
															BgL_arg3381z00_4360);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32687;

														BgL_auxz00_32687 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_13661, BgL_auxz00_32687,
															BgL_framez00_13659);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32690;

														BgL_auxz00_32690 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_13661, BgL_auxz00_32690,
															BgL_runz00_18332);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_32695;
														int BgL_auxz00_32693;

														BgL_auxz00_32695 = BINT(((long) -1));
														BgL_auxz00_32693 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_13661, BgL_auxz00_32693,
															BgL_auxz00_32695);
													}
													BgL_arg3380z00_4359 = BgL_newz00_13661;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18333, BgL_arg3380z00_4359);
										BgL_arg3380z00_4359;
									}
									return BgL_mainz00_18333;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5559 */
	obj_t BGl_z62main5559z62zz__evaluate_compz00(obj_t BgL_envz00_19201,
		obj_t BgL_lastz00_19206)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19204;
				long BgL_siza7ezd2framez75_19205;

				BgL_runz00_19204 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19201, (int) (((long) 2))));
				BgL_siza7ezd2framez75_19205 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19201, (int) (((long) 3))));
				{
					obj_t BgL_lastz00_4361;

					BgL_lastz00_4361 = BgL_lastz00_19206;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4363;

						BgL_sz00_4363 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4364;

							BgL_bpz00_4364 = VECTOR_REF(BgL_sz00_4363, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_32708;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_13604;

									BgL_nz00_13604 = BINT(BgL_siza7ezd2framez75_19205);
									BgL_testz00_32708 =
										(
										((long) CINT(BgL_bpz00_4364) +
											(long) CINT(BgL_nz00_13604)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4363)));
								}
								if (BgL_testz00_32708)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3385z00_4366;

											BgL_arg3385z00_4366 =
												((long) CINT(BgL_bpz00_4364) + ((long) 0));
											VECTOR_SET(BgL_sz00_4363,
												(int) (BgL_arg3385z00_4366), BgL_lastz00_4361);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4367;

											BgL_ez00_4367 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4367, BgL_bpz00_4364);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4368;

												BgL_accz00_4368 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19204, BgL_sz00_4363, BgL_bpz00_4364);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4367);
												VECTOR_SET(BgL_sz00_4363, (int) (((long) 0)),
													BgL_bpz00_4364);
												return BgL_accz00_4368;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4369;

										BgL_nsz00_4369 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4369,
											(int) (((long) 1)), BgL_sz00_4363);
										VECTOR_SET(BgL_nsz00_4369,
											(int) (((long) 2)), BgL_lastz00_4361);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4370;

											BgL_z12denvz12_4370 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4370, BgL_nsz00_4369);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4371;

												BgL_ez00_4371 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4371, BgL_sz00_4363);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4372;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13632;

														BgL_savedzd2bpzd2_13632 =
															VECTOR_REF(BgL_nsz00_4369, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4369,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_13639;

															BgL_fz00_13639 = BgL_runz00_19204;
														BgL_recz00_13638:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_13640;

																BgL_rz00_13640 =
																	PROCEDURE_ENTRY(BgL_fz00_13639)
																	(BgL_fz00_13639, BgL_nsz00_4369, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_32744;

																	if (PROCEDUREP(BgL_rz00_13640))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_13645;

																			BgL_arg1673z00_13645 =
																				PROCEDURE_ATTR(BgL_rz00_13640);
																			if (STRUCTP(BgL_arg1673z00_13645))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32744 =
																						(STRUCT_KEY(BgL_arg1673z00_13645) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32744 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_32744 = ((bool_t) 0);
																		}
																	if (BgL_testz00_32744)
																		{
																			obj_t BgL_fz00_32752;

																			BgL_fz00_32752 = BgL_rz00_13640;
																			BgL_fz00_13639 = BgL_fz00_32752;
																			goto BgL_recz00_13638;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4369,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13632);
																			BgL_____rz00_4372 = BgL_rz00_13640;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4371);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4370,
														BgL_sz00_4363);
													return BgL_____rz00_4372;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5560 */
	obj_t BGl_z62run5560z62zz__evaluate_compz00(obj_t BgL_envz00_19207,
		obj_t BgL_sz00_19210)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19208;
				obj_t BgL_bodyz00_19209;

				BgL_i1245z00_19208 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19207, (int) (((long) 0))));
				BgL_bodyz00_19209 = PROCEDURE_REF(BgL_envz00_19207, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4374;

					BgL_sz00_4374 = BgL_sz00_19210;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4376;

						BgL_bpz00_4376 = VECTOR_REF(BgL_sz00_4374, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4377;
							obj_t BgL_wherez00_4378;
							obj_t BgL_locz00_4379;

							BgL_z12denvz12_4377 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4378 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19208))->BgL_wherez00);
							BgL_locz00_4379 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19208))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4377, BgL_wherez00_4378,
									BgL_locz00_4379);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4380;

									BgL_za2za2resza2za2z00_4380 =
										PROCEDURE_ENTRY(BgL_bodyz00_19209) (BgL_bodyz00_19209,
										BgL_sz00_4374, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4377);
									return BgL_za2za2resza2za2z00_4380;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3387> */
	obj_t BGl_z62zc3anonymousza33387ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19211, obj_t BgL_sz00_19216)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19212;
				BgL_ev_absz00_bglt BgL_i1245z00_19213;
				obj_t BgL_bodyz00_19214;
				long BgL_siza7ezd2framez75_19215;

				BgL_iboxesz00_19212 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19211, (int) (((long) 0))));
				BgL_i1245z00_19213 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19211, (int) (((long) 1))));
				BgL_bodyz00_19214 = PROCEDURE_REF(BgL_envz00_19211, (int) (((long) 2)));
				BgL_siza7ezd2framez75_19215 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19211, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4382;

					BgL_sz00_4382 = BgL_sz00_19216;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4384;

						BgL_bpz00_4384 = VECTOR_REF(BgL_sz00_4382, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18329;

								BgL_runz00_18329 =
									MAKE_FX_PROCEDURE(BGl_z62run5562z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18329,
									(int) (((long) 0)), BgL_iboxesz00_19212);
								PROCEDURE_SET(BgL_runz00_18329,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_19213));
								PROCEDURE_SET(BgL_runz00_18329,
									(int) (((long) 2)), BgL_bodyz00_19214);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18330;

									BgL_mainz00_18330 =
										MAKE_VA_PROCEDURE(BGl_z62main5561z62zz__evaluate_compz00,
										(int) (((long) -1)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18330,
										(int) (((long) 0)), BgL_iboxesz00_19212);
									PROCEDURE_SET(BgL_mainz00_18330,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_19213));
									PROCEDURE_SET(BgL_mainz00_18330,
										(int) (((long) 2)), BgL_bodyz00_19214);
									PROCEDURE_SET(BgL_mainz00_18330,
										(int) (((long) 3)), BgL_runz00_18329);
									PROCEDURE_SET(BgL_mainz00_18330,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_19215));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_13743;

										BgL_objz00_13743 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18329, BgL_objz00_13743);
										BgL_objz00_13743;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3388z00_4387;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3389z00_4388;

											BgL_arg3389z00_4388 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19213))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_13745;

												BgL_framez00_13745 = BINT(BgL_siza7ezd2framez75_19215);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_13747;

													BgL_newz00_13747 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32816;

														BgL_auxz00_32816 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_13747, BgL_auxz00_32816,
															BgL_arg3389z00_4388);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32819;

														BgL_auxz00_32819 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_13747, BgL_auxz00_32819,
															BgL_framez00_13745);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32822;

														BgL_auxz00_32822 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_13747, BgL_auxz00_32822,
															BgL_runz00_18329);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_32827;
														int BgL_auxz00_32825;

														BgL_auxz00_32827 = BINT(((long) -1));
														BgL_auxz00_32825 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_13747, BgL_auxz00_32825,
															BgL_auxz00_32827);
													}
													BgL_arg3388z00_4387 = BgL_newz00_13747;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18330, BgL_arg3388z00_4387);
										BgL_arg3388z00_4387;
									}
									return BgL_mainz00_18330;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5561 */
	obj_t BGl_z62main5561z62zz__evaluate_compz00(obj_t BgL_envz00_19217,
		obj_t BgL_lastz00_19223)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19221;
				long BgL_siza7ezd2framez75_19222;

				BgL_runz00_19221 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19217, (int) (((long) 3))));
				BgL_siza7ezd2framez75_19222 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19217, (int) (((long) 4))));
				{
					obj_t BgL_lastz00_4389;

					BgL_lastz00_4389 = BgL_lastz00_19223;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4391;

						BgL_sz00_4391 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4392;

							BgL_bpz00_4392 = VECTOR_REF(BgL_sz00_4391, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_32840;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_13690;

									BgL_nz00_13690 = BINT(BgL_siza7ezd2framez75_19222);
									BgL_testz00_32840 =
										(
										((long) CINT(BgL_bpz00_4392) +
											(long) CINT(BgL_nz00_13690)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4391)));
								}
								if (BgL_testz00_32840)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3392z00_4394;

											BgL_arg3392z00_4394 =
												((long) CINT(BgL_bpz00_4392) + ((long) 0));
											VECTOR_SET(BgL_sz00_4391,
												(int) (BgL_arg3392z00_4394), BgL_lastz00_4389);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4395;

											BgL_ez00_4395 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4395, BgL_bpz00_4392);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4396;

												BgL_accz00_4396 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19221, BgL_sz00_4391, BgL_bpz00_4392);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4395);
												VECTOR_SET(BgL_sz00_4391, (int) (((long) 0)),
													BgL_bpz00_4392);
												return BgL_accz00_4396;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4397;

										BgL_nsz00_4397 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4397,
											(int) (((long) 1)), BgL_sz00_4391);
										VECTOR_SET(BgL_nsz00_4397,
											(int) (((long) 2)), BgL_lastz00_4389);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4398;

											BgL_z12denvz12_4398 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4398, BgL_nsz00_4397);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4399;

												BgL_ez00_4399 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4399, BgL_sz00_4391);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4400;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13718;

														BgL_savedzd2bpzd2_13718 =
															VECTOR_REF(BgL_nsz00_4397, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4397,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_13725;

															BgL_fz00_13725 = BgL_runz00_19221;
														BgL_recz00_13724:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_13726;

																BgL_rz00_13726 =
																	PROCEDURE_ENTRY(BgL_fz00_13725)
																	(BgL_fz00_13725, BgL_nsz00_4397, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_32876;

																	if (PROCEDUREP(BgL_rz00_13726))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_13731;

																			BgL_arg1673z00_13731 =
																				PROCEDURE_ATTR(BgL_rz00_13726);
																			if (STRUCTP(BgL_arg1673z00_13731))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32876 =
																						(STRUCT_KEY(BgL_arg1673z00_13731) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_32876 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_32876 = ((bool_t) 0);
																		}
																	if (BgL_testz00_32876)
																		{
																			obj_t BgL_fz00_32884;

																			BgL_fz00_32884 = BgL_rz00_13726;
																			BgL_fz00_13725 = BgL_fz00_32884;
																			goto BgL_recz00_13724;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4397,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13718);
																			BgL_____rz00_4400 = BgL_rz00_13726;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4399);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4398,
														BgL_sz00_4391);
													return BgL_____rz00_4400;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5562 */
	obj_t BGl_z62run5562z62zz__evaluate_compz00(obj_t BgL_envz00_19224,
		obj_t BgL_sz00_19228)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19225;
				BgL_ev_absz00_bglt BgL_i1245z00_19226;
				obj_t BgL_bodyz00_19227;

				BgL_iboxesz00_19225 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19224, (int) (((long) 0))));
				BgL_i1245z00_19226 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19224, (int) (((long) 1))));
				BgL_bodyz00_19227 = PROCEDURE_REF(BgL_envz00_19224, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4402;

					BgL_sz00_4402 = BgL_sz00_19228;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4404;

						BgL_bpz00_4404 = VECTOR_REF(BgL_sz00_4402, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4402,
							BgL_iboxesz00_19225, BgL_bpz00_4404);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4405;
							obj_t BgL_wherez00_4406;
							obj_t BgL_locz00_4407;

							BgL_z12denvz12_4405 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4406 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19226))->BgL_wherez00);
							BgL_locz00_4407 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19226))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4405, BgL_wherez00_4406,
									BgL_locz00_4407);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4408;

									BgL_za2za2resza2za2z00_4408 =
										PROCEDURE_ENTRY(BgL_bodyz00_19227) (BgL_bodyz00_19227,
										BgL_sz00_4402, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4405);
									return BgL_za2za2resza2za2z00_4408;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3397> */
	obj_t BGl_z62zc3anonymousza33397ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19229, obj_t BgL_sz00_19235)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19230;
				long BgL_siza7eza7_19231;
				BgL_ev_absz00_bglt BgL_i1245z00_19232;
				obj_t BgL_bodyz00_19233;
				long BgL_siza7ezd2framez75_19234;

				BgL_ifreesz00_19230 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19229, (int) (((long) 0))));
				BgL_siza7eza7_19231 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19229, (int) (((long) 1))));
				BgL_i1245z00_19232 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19229, (int) (((long) 2))));
				BgL_bodyz00_19233 = PROCEDURE_REF(BgL_envz00_19229, (int) (((long) 3)));
				BgL_siza7ezd2framez75_19234 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19229, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4412;

					BgL_sz00_4412 = BgL_sz00_19235;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4414;

						BgL_bpz00_4414 = VECTOR_REF(BgL_sz00_4412, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4415;

							BgL_valza2za2_4415 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4412,
								BgL_bpz00_4414, BgL_ifreesz00_19230);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18326;

								BgL_runz00_18326 =
									MAKE_FX_PROCEDURE(BGl_z62run5564z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18326,
									(int) (((long) 0)), BINT(BgL_siza7eza7_19231));
								PROCEDURE_SET(BgL_runz00_18326,
									(int) (((long) 1)), BgL_valza2za2_4415);
								PROCEDURE_SET(BgL_runz00_18326,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_19232));
								PROCEDURE_SET(BgL_runz00_18326,
									(int) (((long) 3)), BgL_bodyz00_19233);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18327;

									BgL_mainz00_18327 =
										MAKE_VA_PROCEDURE(BGl_z62main5563z62zz__evaluate_compz00,
										(int) (((long) -1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18327,
										(int) (((long) 0)), BINT(BgL_siza7eza7_19231));
									PROCEDURE_SET(BgL_mainz00_18327,
										(int) (((long) 1)), BgL_valza2za2_4415);
									PROCEDURE_SET(BgL_mainz00_18327,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_19232));
									PROCEDURE_SET(BgL_mainz00_18327,
										(int) (((long) 3)), BgL_bodyz00_19233);
									PROCEDURE_SET(BgL_mainz00_18327,
										(int) (((long) 4)), BgL_runz00_18326);
									PROCEDURE_SET(BgL_mainz00_18327,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_19234));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_13836;

										BgL_objz00_13836 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18326, BgL_objz00_13836);
										BgL_objz00_13836;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3398z00_4418;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3399z00_4419;

											BgL_arg3399z00_4419 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19232))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_13838;

												BgL_framez00_13838 = BINT(BgL_siza7ezd2framez75_19234);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_13840;

													BgL_newz00_13840 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32962;

														BgL_auxz00_32962 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_13840, BgL_auxz00_32962,
															BgL_arg3399z00_4419);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32965;

														BgL_auxz00_32965 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_13840, BgL_auxz00_32965,
															BgL_framez00_13838);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_32968;

														BgL_auxz00_32968 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_13840, BgL_auxz00_32968,
															BgL_runz00_18326);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_32973;
														int BgL_auxz00_32971;

														BgL_auxz00_32973 = BINT(((long) -1));
														BgL_auxz00_32971 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_13840, BgL_auxz00_32971,
															BgL_auxz00_32973);
													}
													BgL_arg3398z00_4418 = BgL_newz00_13840;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18327, BgL_arg3398z00_4418);
										BgL_arg3398z00_4418;
									}
									return BgL_mainz00_18327;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5563 */
	obj_t BGl_z62main5563z62zz__evaluate_compz00(obj_t BgL_envz00_19236,
		obj_t BgL_lastz00_19243)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19241;
				long BgL_siza7ezd2framez75_19242;

				BgL_runz00_19241 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19236, (int) (((long) 4))));
				BgL_siza7ezd2framez75_19242 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19236, (int) (((long) 5))));
				{
					obj_t BgL_lastz00_4420;

					BgL_lastz00_4420 = BgL_lastz00_19243;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4422;

						BgL_sz00_4422 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4423;

							BgL_bpz00_4423 = VECTOR_REF(BgL_sz00_4422, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_32986;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_13783;

									BgL_nz00_13783 = BINT(BgL_siza7ezd2framez75_19242);
									BgL_testz00_32986 =
										(
										((long) CINT(BgL_bpz00_4423) +
											(long) CINT(BgL_nz00_13783)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4422)));
								}
								if (BgL_testz00_32986)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3402z00_4425;

											BgL_arg3402z00_4425 =
												((long) CINT(BgL_bpz00_4423) + ((long) 0));
											VECTOR_SET(BgL_sz00_4422,
												(int) (BgL_arg3402z00_4425), BgL_lastz00_4420);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4426;

											BgL_ez00_4426 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4426, BgL_bpz00_4423);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4427;

												BgL_accz00_4427 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19241, BgL_sz00_4422, BgL_bpz00_4423);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4426);
												VECTOR_SET(BgL_sz00_4422, (int) (((long) 0)),
													BgL_bpz00_4423);
												return BgL_accz00_4427;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4428;

										BgL_nsz00_4428 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4428,
											(int) (((long) 1)), BgL_sz00_4422);
										VECTOR_SET(BgL_nsz00_4428,
											(int) (((long) 2)), BgL_lastz00_4420);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4429;

											BgL_z12denvz12_4429 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4429, BgL_nsz00_4428);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4430;

												BgL_ez00_4430 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4430, BgL_sz00_4422);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4431;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13811;

														BgL_savedzd2bpzd2_13811 =
															VECTOR_REF(BgL_nsz00_4428, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4428,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_13818;

															BgL_fz00_13818 = BgL_runz00_19241;
														BgL_recz00_13817:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_13819;

																BgL_rz00_13819 =
																	PROCEDURE_ENTRY(BgL_fz00_13818)
																	(BgL_fz00_13818, BgL_nsz00_4428, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_33022;

																	if (PROCEDUREP(BgL_rz00_13819))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_13824;

																			BgL_arg1673z00_13824 =
																				PROCEDURE_ATTR(BgL_rz00_13819);
																			if (STRUCTP(BgL_arg1673z00_13824))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33022 =
																						(STRUCT_KEY(BgL_arg1673z00_13824) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33022 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_33022 = ((bool_t) 0);
																		}
																	if (BgL_testz00_33022)
																		{
																			obj_t BgL_fz00_33030;

																			BgL_fz00_33030 = BgL_rz00_13819;
																			BgL_fz00_13818 = BgL_fz00_33030;
																			goto BgL_recz00_13817;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4428,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13811);
																			BgL_____rz00_4431 = BgL_rz00_13819;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4430);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4429,
														BgL_sz00_4422);
													return BgL_____rz00_4431;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5564 */
	obj_t BGl_z62run5564z62zz__evaluate_compz00(obj_t BgL_envz00_19244,
		obj_t BgL_sz00_19249)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_19245;
				obj_t BgL_valza2za2_19246;
				BgL_ev_absz00_bglt BgL_i1245z00_19247;
				obj_t BgL_bodyz00_19248;

				BgL_siza7eza7_19245 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19244, (int) (((long) 0))));
				BgL_valza2za2_19246 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19244, (int) (((long) 1))));
				BgL_i1245z00_19247 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19244, (int) (((long) 2))));
				BgL_bodyz00_19248 = PROCEDURE_REF(BgL_envz00_19244, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4433;

					BgL_sz00_4433 = BgL_sz00_19249;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4435;

						BgL_bpz00_4435 = VECTOR_REF(BgL_sz00_4433, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4433,
							BgL_valza2za2_19246,
							((long) CINT(BgL_bpz00_4435) + BgL_siza7eza7_19245));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4437;
							obj_t BgL_wherez00_4438;
							obj_t BgL_locz00_4439;

							BgL_z12denvz12_4437 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4438 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19247))->BgL_wherez00);
							BgL_locz00_4439 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19247))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4437, BgL_wherez00_4438,
									BgL_locz00_4439);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4440;

									BgL_za2za2resza2za2z00_4440 =
										PROCEDURE_ENTRY(BgL_bodyz00_19248) (BgL_bodyz00_19248,
										BgL_sz00_4433, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4437);
									return BgL_za2za2resza2za2z00_4440;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3405> */
	obj_t BGl_z62zc3anonymousza33405ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19250, obj_t BgL_sz00_19257)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19251;
				obj_t BgL_iboxesz00_19252;
				long BgL_siza7eza7_19253;
				BgL_ev_absz00_bglt BgL_i1245z00_19254;
				obj_t BgL_bodyz00_19255;
				long BgL_siza7ezd2framez75_19256;

				BgL_ifreesz00_19251 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19250, (int) (((long) 0))));
				BgL_iboxesz00_19252 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19250, (int) (((long) 1))));
				BgL_siza7eza7_19253 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19250, (int) (((long) 2))));
				BgL_i1245z00_19254 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19250, (int) (((long) 3))));
				BgL_bodyz00_19255 = PROCEDURE_REF(BgL_envz00_19250, (int) (((long) 4)));
				BgL_siza7ezd2framez75_19256 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19250, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4442;

					BgL_sz00_4442 = BgL_sz00_19257;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4444;

						BgL_bpz00_4444 = VECTOR_REF(BgL_sz00_4442, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4445;

							BgL_valza2za2_4445 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4442,
								BgL_bpz00_4444, BgL_ifreesz00_19251);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18323;

								BgL_runz00_18323 =
									MAKE_FX_PROCEDURE(BGl_z62run5566z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18323,
									(int) (((long) 0)), BgL_iboxesz00_19252);
								PROCEDURE_SET(BgL_runz00_18323,
									(int) (((long) 1)), BINT(BgL_siza7eza7_19253));
								PROCEDURE_SET(BgL_runz00_18323,
									(int) (((long) 2)), BgL_valza2za2_4445);
								PROCEDURE_SET(BgL_runz00_18323,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_19254));
								PROCEDURE_SET(BgL_runz00_18323,
									(int) (((long) 4)), BgL_bodyz00_19255);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18324;

									BgL_mainz00_18324 =
										MAKE_VA_PROCEDURE(BGl_z62main5565z62zz__evaluate_compz00,
										(int) (((long) -1)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18324,
										(int) (((long) 0)), BgL_iboxesz00_19252);
									PROCEDURE_SET(BgL_mainz00_18324,
										(int) (((long) 1)), BINT(BgL_siza7eza7_19253));
									PROCEDURE_SET(BgL_mainz00_18324,
										(int) (((long) 2)), BgL_valza2za2_4445);
									PROCEDURE_SET(BgL_mainz00_18324,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_19254));
									PROCEDURE_SET(BgL_mainz00_18324,
										(int) (((long) 4)), BgL_bodyz00_19255);
									PROCEDURE_SET(BgL_mainz00_18324,
										(int) (((long) 5)), BgL_runz00_18323);
									PROCEDURE_SET(BgL_mainz00_18324,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_19256));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_13925;

										BgL_objz00_13925 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18323, BgL_objz00_13925);
										BgL_objz00_13925;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3406z00_4448;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3407z00_4449;

											BgL_arg3407z00_4449 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19254))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_13927;

												BgL_framez00_13927 = BINT(BgL_siza7ezd2framez75_19256);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_13929;

													BgL_newz00_13929 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33120;

														BgL_auxz00_33120 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_13929, BgL_auxz00_33120,
															BgL_arg3407z00_4449);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33123;

														BgL_auxz00_33123 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_13929, BgL_auxz00_33123,
															BgL_framez00_13927);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33126;

														BgL_auxz00_33126 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_13929, BgL_auxz00_33126,
															BgL_runz00_18323);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_33131;
														int BgL_auxz00_33129;

														BgL_auxz00_33131 = BINT(((long) -1));
														BgL_auxz00_33129 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_13929, BgL_auxz00_33129,
															BgL_auxz00_33131);
													}
													BgL_arg3406z00_4448 = BgL_newz00_13929;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18324, BgL_arg3406z00_4448);
										BgL_arg3406z00_4448;
									}
									return BgL_mainz00_18324;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5565 */
	obj_t BGl_z62main5565z62zz__evaluate_compz00(obj_t BgL_envz00_19258,
		obj_t BgL_lastz00_19266)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19264;
				long BgL_siza7ezd2framez75_19265;

				BgL_runz00_19264 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19258, (int) (((long) 5))));
				BgL_siza7ezd2framez75_19265 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19258, (int) (((long) 6))));
				{
					obj_t BgL_lastz00_4450;

					BgL_lastz00_4450 = BgL_lastz00_19266;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4452;

						BgL_sz00_4452 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4453;

							BgL_bpz00_4453 = VECTOR_REF(BgL_sz00_4452, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_33144;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_13872;

									BgL_nz00_13872 = BINT(BgL_siza7ezd2framez75_19265);
									BgL_testz00_33144 =
										(
										((long) CINT(BgL_bpz00_4453) +
											(long) CINT(BgL_nz00_13872)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4452)));
								}
								if (BgL_testz00_33144)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3410z00_4455;

											BgL_arg3410z00_4455 =
												((long) CINT(BgL_bpz00_4453) + ((long) 0));
											VECTOR_SET(BgL_sz00_4452,
												(int) (BgL_arg3410z00_4455), BgL_lastz00_4450);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_4456;

											BgL_ez00_4456 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_4456, BgL_bpz00_4453);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_4457;

												BgL_accz00_4457 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19264, BgL_sz00_4452, BgL_bpz00_4453);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_4456);
												VECTOR_SET(BgL_sz00_4452, (int) (((long) 0)),
													BgL_bpz00_4453);
												return BgL_accz00_4457;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4458;

										BgL_nsz00_4458 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4458,
											(int) (((long) 1)), BgL_sz00_4452);
										VECTOR_SET(BgL_nsz00_4458,
											(int) (((long) 2)), BgL_lastz00_4450);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4459;

											BgL_z12denvz12_4459 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4459, BgL_nsz00_4458);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4460;

												BgL_ez00_4460 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4460, BgL_sz00_4452);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4461;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13900;

														BgL_savedzd2bpzd2_13900 =
															VECTOR_REF(BgL_nsz00_4458, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4458,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_13907;

															BgL_fz00_13907 = BgL_runz00_19264;
														BgL_recz00_13906:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_13908;

																BgL_rz00_13908 =
																	PROCEDURE_ENTRY(BgL_fz00_13907)
																	(BgL_fz00_13907, BgL_nsz00_4458, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_33180;

																	if (PROCEDUREP(BgL_rz00_13908))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_13913;

																			BgL_arg1673z00_13913 =
																				PROCEDURE_ATTR(BgL_rz00_13908);
																			if (STRUCTP(BgL_arg1673z00_13913))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33180 =
																						(STRUCT_KEY(BgL_arg1673z00_13913) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33180 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_33180 = ((bool_t) 0);
																		}
																	if (BgL_testz00_33180)
																		{
																			obj_t BgL_fz00_33188;

																			BgL_fz00_33188 = BgL_rz00_13908;
																			BgL_fz00_13907 = BgL_fz00_33188;
																			goto BgL_recz00_13906;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4458,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13900);
																			BgL_____rz00_4461 = BgL_rz00_13908;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4460);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4459,
														BgL_sz00_4452);
													return BgL_____rz00_4461;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5566 */
	obj_t BGl_z62run5566z62zz__evaluate_compz00(obj_t BgL_envz00_19267,
		obj_t BgL_sz00_19273)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19268;
				long BgL_siza7eza7_19269;
				obj_t BgL_valza2za2_19270;
				BgL_ev_absz00_bglt BgL_i1245z00_19271;
				obj_t BgL_bodyz00_19272;

				BgL_iboxesz00_19268 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19267, (int) (((long) 0))));
				BgL_siza7eza7_19269 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19267, (int) (((long) 1))));
				BgL_valza2za2_19270 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19267, (int) (((long) 2))));
				BgL_i1245z00_19271 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19267, (int) (((long) 3))));
				BgL_bodyz00_19272 = PROCEDURE_REF(BgL_envz00_19267, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4463;

					BgL_sz00_4463 = BgL_sz00_19273;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4465;

						BgL_bpz00_4465 = VECTOR_REF(BgL_sz00_4463, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4463,
							BgL_iboxesz00_19268, BgL_bpz00_4465);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4463,
							BgL_valza2za2_19270,
							((long) CINT(BgL_bpz00_4465) + BgL_siza7eza7_19269));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4467;
							obj_t BgL_wherez00_4468;
							obj_t BgL_locz00_4469;

							BgL_z12denvz12_4467 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4468 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19271))->BgL_wherez00);
							BgL_locz00_4469 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19271))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4467, BgL_wherez00_4468,
									BgL_locz00_4469);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4470;

									BgL_za2za2resza2za2z00_4470 =
										PROCEDURE_ENTRY(BgL_bodyz00_19272) (BgL_bodyz00_19272,
										BgL_sz00_4463, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4467);
									return BgL_za2za2resza2za2z00_4470;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3344> */
	obj_t BGl_z62zc3anonymousza33344ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19274, obj_t BgL_sz00_19278)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19275;
				obj_t BgL_bodyz00_19276;
				long BgL_siza7ezd2framez75_19277;

				BgL_i1245z00_19275 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19274, (int) (((long) 0))));
				BgL_bodyz00_19276 = PROCEDURE_REF(BgL_envz00_19274, (int) (((long) 1)));
				BgL_siza7ezd2framez75_19277 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19274, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4240;

					BgL_sz00_4240 = BgL_sz00_19278;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4242;

						BgL_bpz00_4242 = VECTOR_REF(BgL_sz00_4240, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18320;

								BgL_runz00_18320 =
									MAKE_FX_PROCEDURE(BGl_z62run5568z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18320,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_19275));
								PROCEDURE_SET(BgL_runz00_18320,
									(int) (((long) 1)), BgL_bodyz00_19276);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18321;

									BgL_mainz00_18321 =
										MAKE_FX_PROCEDURE(BGl_z62main5567z62zz__evaluate_compz00,
										(int) (((long) 0)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18321,
										(int) (((long) 0)), ((obj_t) BgL_i1245z00_19275));
									PROCEDURE_SET(BgL_mainz00_18321,
										(int) (((long) 1)), BgL_bodyz00_19276);
									PROCEDURE_SET(BgL_mainz00_18321,
										(int) (((long) 2)), BgL_runz00_18320);
									PROCEDURE_SET(BgL_mainz00_18321,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_19277));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_13322;

										BgL_objz00_13322 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18320, BgL_objz00_13322);
										BgL_objz00_13322;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3346z00_4245;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3347z00_4246;

											BgL_arg3347z00_4246 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19275))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_13324;

												BgL_framez00_13324 = BINT(BgL_siza7ezd2framez75_19277);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_13326;

													BgL_newz00_13326 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33258;

														BgL_auxz00_33258 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_13326, BgL_auxz00_33258,
															BgL_arg3347z00_4246);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33261;

														BgL_auxz00_33261 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_13326, BgL_auxz00_33261,
															BgL_framez00_13324);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33264;

														BgL_auxz00_33264 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_13326, BgL_auxz00_33264,
															BgL_runz00_18320);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_33269;
														int BgL_auxz00_33267;

														BgL_auxz00_33269 = BINT(((long) 0));
														BgL_auxz00_33267 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_13326, BgL_auxz00_33267,
															BgL_auxz00_33269);
													}
													BgL_arg3346z00_4245 = BgL_newz00_13326;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18321, BgL_arg3346z00_4245);
										BgL_arg3346z00_4245;
									}
									return BgL_mainz00_18321;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5567 */
	obj_t BGl_z62main5567z62zz__evaluate_compz00(obj_t BgL_envz00_19279)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19282;
				long BgL_siza7ezd2framez75_19283;

				BgL_runz00_19282 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19279, (int) (((long) 2))));
				BgL_siza7ezd2framez75_19283 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19279, (int) (((long) 3))));
				{

					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4248;

						BgL_sz00_4248 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4249;

							BgL_bpz00_4249 = VECTOR_REF(BgL_sz00_4248, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_33282;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_13278;

									BgL_nz00_13278 = BINT(BgL_siza7ezd2framez75_19283);
									BgL_testz00_33282 =
										(
										((long) CINT(BgL_bpz00_4249) +
											(long) CINT(BgL_nz00_13278)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4248)));
								}
								if (BgL_testz00_33282)
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_ez00_4251;

										BgL_ez00_4251 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_4251,
											BgL_bpz00_4249);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_accz00_4252;

											BgL_accz00_4252 =
												BGl_catchzd2trampolinezd2zz__evaluate_compz00
												(BgL_runz00_19282, BgL_sz00_4248, BgL_bpz00_4249);
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_4251);
											VECTOR_SET(BgL_sz00_4248, (int) (((long) 0)),
												BgL_bpz00_4249);
											return BgL_accz00_4252;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4253;

										BgL_nsz00_4253 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4253,
											(int) (((long) 1)), BgL_sz00_4248);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4254;

											BgL_z12denvz12_4254 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4254, BgL_nsz00_4253);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4255;

												BgL_ez00_4255 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4255, BgL_sz00_4248);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4256;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13297;

														BgL_savedzd2bpzd2_13297 =
															VECTOR_REF(BgL_nsz00_4253, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4253,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_13304;

															BgL_fz00_13304 = BgL_runz00_19282;
														BgL_recz00_13303:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_13305;

																BgL_rz00_13305 =
																	PROCEDURE_ENTRY(BgL_fz00_13304)
																	(BgL_fz00_13304, BgL_nsz00_4253, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_33312;

																	if (PROCEDUREP(BgL_rz00_13305))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_13310;

																			BgL_arg1673z00_13310 =
																				PROCEDURE_ATTR(BgL_rz00_13305);
																			if (STRUCTP(BgL_arg1673z00_13310))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33312 =
																						(STRUCT_KEY(BgL_arg1673z00_13310) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33312 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_33312 = ((bool_t) 0);
																		}
																	if (BgL_testz00_33312)
																		{
																			obj_t BgL_fz00_33320;

																			BgL_fz00_33320 = BgL_rz00_13305;
																			BgL_fz00_13304 = BgL_fz00_33320;
																			goto BgL_recz00_13303;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4253,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13297);
																			BgL_____rz00_4256 = BgL_rz00_13305;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4255);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4254,
														BgL_sz00_4248);
													return BgL_____rz00_4256;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5568 */
	obj_t BGl_z62run5568z62zz__evaluate_compz00(obj_t BgL_envz00_19284,
		obj_t BgL_sz00_19287)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19285;
				obj_t BgL_bodyz00_19286;

				BgL_i1245z00_19285 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19284, (int) (((long) 0))));
				BgL_bodyz00_19286 = PROCEDURE_REF(BgL_envz00_19284, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4258;

					BgL_sz00_4258 = BgL_sz00_19287;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4260;

						BgL_bpz00_4260 = VECTOR_REF(BgL_sz00_4258, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4261;
							obj_t BgL_wherez00_4262;
							obj_t BgL_locz00_4263;

							BgL_z12denvz12_4261 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4262 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19285))->BgL_wherez00);
							BgL_locz00_4263 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19285))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4261, BgL_wherez00_4262,
									BgL_locz00_4263);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4264;

									BgL_za2za2resza2za2z00_4264 =
										PROCEDURE_ENTRY(BgL_bodyz00_19286) (BgL_bodyz00_19286,
										BgL_sz00_4258, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4261);
									return BgL_za2za2resza2za2z00_4264;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3351> */
	obj_t BGl_z62zc3anonymousza33351ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19288, obj_t BgL_sz00_19293)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19289;
				BgL_ev_absz00_bglt BgL_i1245z00_19290;
				obj_t BgL_bodyz00_19291;
				long BgL_siza7ezd2framez75_19292;

				BgL_iboxesz00_19289 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19288, (int) (((long) 0))));
				BgL_i1245z00_19290 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19288, (int) (((long) 1))));
				BgL_bodyz00_19291 = PROCEDURE_REF(BgL_envz00_19288, (int) (((long) 2)));
				BgL_siza7ezd2framez75_19292 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19288, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4266;

					BgL_sz00_4266 = BgL_sz00_19293;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4268;

						BgL_bpz00_4268 = VECTOR_REF(BgL_sz00_4266, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18317;

								BgL_runz00_18317 =
									MAKE_FX_PROCEDURE(BGl_z62run5570z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18317,
									(int) (((long) 0)), BgL_iboxesz00_19289);
								PROCEDURE_SET(BgL_runz00_18317,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_19290));
								PROCEDURE_SET(BgL_runz00_18317,
									(int) (((long) 2)), BgL_bodyz00_19291);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18318;

									BgL_mainz00_18318 =
										MAKE_FX_PROCEDURE(BGl_z62main5569z62zz__evaluate_compz00,
										(int) (((long) 0)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18318,
										(int) (((long) 0)), BgL_iboxesz00_19289);
									PROCEDURE_SET(BgL_mainz00_18318,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_19290));
									PROCEDURE_SET(BgL_mainz00_18318,
										(int) (((long) 2)), BgL_bodyz00_19291);
									PROCEDURE_SET(BgL_mainz00_18318,
										(int) (((long) 3)), BgL_runz00_18317);
									PROCEDURE_SET(BgL_mainz00_18318,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_19292));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_13399;

										BgL_objz00_13399 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18317, BgL_objz00_13399);
										BgL_objz00_13399;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3352z00_4271;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3353z00_4272;

											BgL_arg3353z00_4272 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19290))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_13401;

												BgL_framez00_13401 = BINT(BgL_siza7ezd2framez75_19292);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_13403;

													BgL_newz00_13403 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33384;

														BgL_auxz00_33384 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_13403, BgL_auxz00_33384,
															BgL_arg3353z00_4272);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33387;

														BgL_auxz00_33387 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_13403, BgL_auxz00_33387,
															BgL_framez00_13401);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33390;

														BgL_auxz00_33390 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_13403, BgL_auxz00_33390,
															BgL_runz00_18317);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_33395;
														int BgL_auxz00_33393;

														BgL_auxz00_33395 = BINT(((long) 0));
														BgL_auxz00_33393 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_13403, BgL_auxz00_33393,
															BgL_auxz00_33395);
													}
													BgL_arg3352z00_4271 = BgL_newz00_13403;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18318, BgL_arg3352z00_4271);
										BgL_arg3352z00_4271;
									}
									return BgL_mainz00_18318;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5569 */
	obj_t BGl_z62main5569z62zz__evaluate_compz00(obj_t BgL_envz00_19294)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19298;
				long BgL_siza7ezd2framez75_19299;

				BgL_runz00_19298 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19294, (int) (((long) 3))));
				BgL_siza7ezd2framez75_19299 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19294, (int) (((long) 4))));
				{

					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4274;

						BgL_sz00_4274 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4275;

							BgL_bpz00_4275 = VECTOR_REF(BgL_sz00_4274, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_33408;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_13355;

									BgL_nz00_13355 = BINT(BgL_siza7ezd2framez75_19299);
									BgL_testz00_33408 =
										(
										((long) CINT(BgL_bpz00_4275) +
											(long) CINT(BgL_nz00_13355)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4274)));
								}
								if (BgL_testz00_33408)
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_ez00_4277;

										BgL_ez00_4277 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_4277,
											BgL_bpz00_4275);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_accz00_4278;

											BgL_accz00_4278 =
												BGl_catchzd2trampolinezd2zz__evaluate_compz00
												(BgL_runz00_19298, BgL_sz00_4274, BgL_bpz00_4275);
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_4277);
											VECTOR_SET(BgL_sz00_4274, (int) (((long) 0)),
												BgL_bpz00_4275);
											return BgL_accz00_4278;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4279;

										BgL_nsz00_4279 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4279,
											(int) (((long) 1)), BgL_sz00_4274);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4280;

											BgL_z12denvz12_4280 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4280, BgL_nsz00_4279);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4281;

												BgL_ez00_4281 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4281, BgL_sz00_4274);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4282;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13374;

														BgL_savedzd2bpzd2_13374 =
															VECTOR_REF(BgL_nsz00_4279, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4279,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_13381;

															BgL_fz00_13381 = BgL_runz00_19298;
														BgL_recz00_13380:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_13382;

																BgL_rz00_13382 =
																	PROCEDURE_ENTRY(BgL_fz00_13381)
																	(BgL_fz00_13381, BgL_nsz00_4279, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_33438;

																	if (PROCEDUREP(BgL_rz00_13382))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_13387;

																			BgL_arg1673z00_13387 =
																				PROCEDURE_ATTR(BgL_rz00_13382);
																			if (STRUCTP(BgL_arg1673z00_13387))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33438 =
																						(STRUCT_KEY(BgL_arg1673z00_13387) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33438 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_33438 = ((bool_t) 0);
																		}
																	if (BgL_testz00_33438)
																		{
																			obj_t BgL_fz00_33446;

																			BgL_fz00_33446 = BgL_rz00_13382;
																			BgL_fz00_13381 = BgL_fz00_33446;
																			goto BgL_recz00_13380;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4279,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13374);
																			BgL_____rz00_4282 = BgL_rz00_13382;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4281);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4280,
														BgL_sz00_4274);
													return BgL_____rz00_4282;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5570 */
	obj_t BGl_z62run5570z62zz__evaluate_compz00(obj_t BgL_envz00_19300,
		obj_t BgL_sz00_19304)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19301;
				BgL_ev_absz00_bglt BgL_i1245z00_19302;
				obj_t BgL_bodyz00_19303;

				BgL_iboxesz00_19301 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19300, (int) (((long) 0))));
				BgL_i1245z00_19302 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19300, (int) (((long) 1))));
				BgL_bodyz00_19303 = PROCEDURE_REF(BgL_envz00_19300, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4284;

					BgL_sz00_4284 = BgL_sz00_19304;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4286;

						BgL_bpz00_4286 = VECTOR_REF(BgL_sz00_4284, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4284,
							BgL_iboxesz00_19301, BgL_bpz00_4286);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_4287;
							obj_t BgL_wherez00_4288;
							obj_t BgL_locz00_4289;

							BgL_z12denvz12_4287 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4288 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19302))->BgL_wherez00);
							BgL_locz00_4289 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19302))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4287, BgL_wherez00_4288,
									BgL_locz00_4289);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_4290;

									BgL_za2za2resza2za2z00_4290 =
										PROCEDURE_ENTRY(BgL_bodyz00_19303) (BgL_bodyz00_19303,
										BgL_sz00_4284, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4287);
									return BgL_za2za2resza2za2z00_4290;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3359> */
	obj_t BGl_z62zc3anonymousza33359ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19305, obj_t BgL_sz00_19311)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19306;
				long BgL_siza7eza7_19307;
				BgL_ev_absz00_bglt BgL_i1245z00_19308;
				obj_t BgL_bodyz00_19309;
				long BgL_siza7ezd2framez75_19310;

				BgL_ifreesz00_19306 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19305, (int) (((long) 0))));
				BgL_siza7eza7_19307 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19305, (int) (((long) 1))));
				BgL_i1245z00_19308 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19305, (int) (((long) 2))));
				BgL_bodyz00_19309 = PROCEDURE_REF(BgL_envz00_19305, (int) (((long) 3)));
				BgL_siza7ezd2framez75_19310 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19305, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4294;

					BgL_sz00_4294 = BgL_sz00_19311;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4296;

						BgL_bpz00_4296 = VECTOR_REF(BgL_sz00_4294, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4297;

							BgL_valza2za2_4297 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4294,
								BgL_bpz00_4296, BgL_ifreesz00_19306);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18314;

								BgL_runz00_18314 =
									MAKE_FX_PROCEDURE(BGl_z62run5572z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18314,
									(int) (((long) 0)), BINT(BgL_siza7eza7_19307));
								PROCEDURE_SET(BgL_runz00_18314,
									(int) (((long) 1)), BgL_valza2za2_4297);
								PROCEDURE_SET(BgL_runz00_18314,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_19308));
								PROCEDURE_SET(BgL_runz00_18314,
									(int) (((long) 3)), BgL_bodyz00_19309);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18315;

									BgL_mainz00_18315 =
										MAKE_FX_PROCEDURE(BGl_z62main5571z62zz__evaluate_compz00,
										(int) (((long) 0)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18315,
										(int) (((long) 0)), BINT(BgL_siza7eza7_19307));
									PROCEDURE_SET(BgL_mainz00_18315,
										(int) (((long) 1)), BgL_valza2za2_4297);
									PROCEDURE_SET(BgL_mainz00_18315,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_19308));
									PROCEDURE_SET(BgL_mainz00_18315,
										(int) (((long) 3)), BgL_bodyz00_19309);
									PROCEDURE_SET(BgL_mainz00_18315,
										(int) (((long) 4)), BgL_runz00_18314);
									PROCEDURE_SET(BgL_mainz00_18315,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_19310));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_13483;

										BgL_objz00_13483 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18314, BgL_objz00_13483);
										BgL_objz00_13483;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3360z00_4300;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3361z00_4301;

											BgL_arg3361z00_4301 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19308))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_13485;

												BgL_framez00_13485 = BINT(BgL_siza7ezd2framez75_19310);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_13487;

													BgL_newz00_13487 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33524;

														BgL_auxz00_33524 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_13487, BgL_auxz00_33524,
															BgL_arg3361z00_4301);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33527;

														BgL_auxz00_33527 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_13487, BgL_auxz00_33527,
															BgL_framez00_13485);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33530;

														BgL_auxz00_33530 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_13487, BgL_auxz00_33530,
															BgL_runz00_18314);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_33535;
														int BgL_auxz00_33533;

														BgL_auxz00_33535 = BINT(((long) 0));
														BgL_auxz00_33533 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_13487, BgL_auxz00_33533,
															BgL_auxz00_33535);
													}
													BgL_arg3360z00_4300 = BgL_newz00_13487;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18315, BgL_arg3360z00_4300);
										BgL_arg3360z00_4300;
									}
									return BgL_mainz00_18315;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5571 */
	obj_t BGl_z62main5571z62zz__evaluate_compz00(obj_t BgL_envz00_19312)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19317;
				long BgL_siza7ezd2framez75_19318;

				BgL_runz00_19317 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19312, (int) (((long) 4))));
				BgL_siza7ezd2framez75_19318 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19312, (int) (((long) 5))));
				{

					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4303;

						BgL_sz00_4303 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4304;

							BgL_bpz00_4304 = VECTOR_REF(BgL_sz00_4303, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_33548;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_13439;

									BgL_nz00_13439 = BINT(BgL_siza7ezd2framez75_19318);
									BgL_testz00_33548 =
										(
										((long) CINT(BgL_bpz00_4304) +
											(long) CINT(BgL_nz00_13439)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4303)));
								}
								if (BgL_testz00_33548)
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_ez00_4306;

										BgL_ez00_4306 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_4306,
											BgL_bpz00_4304);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_accz00_4307;

											BgL_accz00_4307 =
												BGl_catchzd2trampolinezd2zz__evaluate_compz00
												(BgL_runz00_19317, BgL_sz00_4303, BgL_bpz00_4304);
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_4306);
											VECTOR_SET(BgL_sz00_4303, (int) (((long) 0)),
												BgL_bpz00_4304);
											return BgL_accz00_4307;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4308;

										BgL_nsz00_4308 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4308,
											(int) (((long) 1)), BgL_sz00_4303);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4309;

											BgL_z12denvz12_4309 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4309, BgL_nsz00_4308);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4310;

												BgL_ez00_4310 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4310, BgL_sz00_4303);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4311;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13458;

														BgL_savedzd2bpzd2_13458 =
															VECTOR_REF(BgL_nsz00_4308, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4308,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_13465;

															BgL_fz00_13465 = BgL_runz00_19317;
														BgL_recz00_13464:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_13466;

																BgL_rz00_13466 =
																	PROCEDURE_ENTRY(BgL_fz00_13465)
																	(BgL_fz00_13465, BgL_nsz00_4308, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_33578;

																	if (PROCEDUREP(BgL_rz00_13466))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_13471;

																			BgL_arg1673z00_13471 =
																				PROCEDURE_ATTR(BgL_rz00_13466);
																			if (STRUCTP(BgL_arg1673z00_13471))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33578 =
																						(STRUCT_KEY(BgL_arg1673z00_13471) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33578 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_33578 = ((bool_t) 0);
																		}
																	if (BgL_testz00_33578)
																		{
																			obj_t BgL_fz00_33586;

																			BgL_fz00_33586 = BgL_rz00_13466;
																			BgL_fz00_13465 = BgL_fz00_33586;
																			goto BgL_recz00_13464;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4308,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13458);
																			BgL_____rz00_4311 = BgL_rz00_13466;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4310);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4309,
														BgL_sz00_4303);
													return BgL_____rz00_4311;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5572 */
	obj_t BGl_z62run5572z62zz__evaluate_compz00(obj_t BgL_envz00_19319,
		obj_t BgL_sz00_19324)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_19320;
				obj_t BgL_valza2za2_19321;
				BgL_ev_absz00_bglt BgL_i1245z00_19322;
				obj_t BgL_bodyz00_19323;

				BgL_siza7eza7_19320 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19319, (int) (((long) 0))));
				BgL_valza2za2_19321 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19319, (int) (((long) 1))));
				BgL_i1245z00_19322 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19319, (int) (((long) 2))));
				BgL_bodyz00_19323 = PROCEDURE_REF(BgL_envz00_19319, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4313;

					BgL_sz00_4313 = BgL_sz00_19324;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4315;

						BgL_bpz00_4315 = VECTOR_REF(BgL_sz00_4313, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4313,
							BgL_valza2za2_19321,
							((long) CINT(BgL_bpz00_4315) + BgL_siza7eza7_19320));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4317;
							obj_t BgL_wherez00_4318;
							obj_t BgL_locz00_4319;

							BgL_z12denvz12_4317 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4318 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19322))->BgL_wherez00);
							BgL_locz00_4319 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19322))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4317, BgL_wherez00_4318,
									BgL_locz00_4319);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4320;

									BgL_za2za2resza2za2z00_4320 =
										PROCEDURE_ENTRY(BgL_bodyz00_19323) (BgL_bodyz00_19323,
										BgL_sz00_4313, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4317);
									return BgL_za2za2resza2za2z00_4320;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3366> */
	obj_t BGl_z62zc3anonymousza33366ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19325, obj_t BgL_sz00_19332)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19326;
				obj_t BgL_iboxesz00_19327;
				long BgL_siza7eza7_19328;
				BgL_ev_absz00_bglt BgL_i1245z00_19329;
				obj_t BgL_bodyz00_19330;
				long BgL_siza7ezd2framez75_19331;

				BgL_ifreesz00_19326 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19325, (int) (((long) 0))));
				BgL_iboxesz00_19327 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19325, (int) (((long) 1))));
				BgL_siza7eza7_19328 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19325, (int) (((long) 2))));
				BgL_i1245z00_19329 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19325, (int) (((long) 3))));
				BgL_bodyz00_19330 = PROCEDURE_REF(BgL_envz00_19325, (int) (((long) 4)));
				BgL_siza7ezd2framez75_19331 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19325, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4322;

					BgL_sz00_4322 = BgL_sz00_19332;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4324;

						BgL_bpz00_4324 = VECTOR_REF(BgL_sz00_4322, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_4325;

							BgL_valza2za2_4325 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4322,
								BgL_bpz00_4324, BgL_ifreesz00_19326);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18311;

								BgL_runz00_18311 =
									MAKE_FX_PROCEDURE(BGl_z62run5574z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18311,
									(int) (((long) 0)), BgL_iboxesz00_19327);
								PROCEDURE_SET(BgL_runz00_18311,
									(int) (((long) 1)), BINT(BgL_siza7eza7_19328));
								PROCEDURE_SET(BgL_runz00_18311,
									(int) (((long) 2)), BgL_valza2za2_4325);
								PROCEDURE_SET(BgL_runz00_18311,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_19329));
								PROCEDURE_SET(BgL_runz00_18311,
									(int) (((long) 4)), BgL_bodyz00_19330);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18312;

									BgL_mainz00_18312 =
										MAKE_FX_PROCEDURE(BGl_z62main5573z62zz__evaluate_compz00,
										(int) (((long) 0)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18312,
										(int) (((long) 0)), BgL_iboxesz00_19327);
									PROCEDURE_SET(BgL_mainz00_18312,
										(int) (((long) 1)), BINT(BgL_siza7eza7_19328));
									PROCEDURE_SET(BgL_mainz00_18312,
										(int) (((long) 2)), BgL_valza2za2_4325);
									PROCEDURE_SET(BgL_mainz00_18312,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_19329));
									PROCEDURE_SET(BgL_mainz00_18312,
										(int) (((long) 4)), BgL_bodyz00_19330);
									PROCEDURE_SET(BgL_mainz00_18312,
										(int) (((long) 5)), BgL_runz00_18311);
									PROCEDURE_SET(BgL_mainz00_18312,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_19331));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_13563;

										BgL_objz00_13563 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18311, BgL_objz00_13563);
										BgL_objz00_13563;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3368z00_4328;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3369z00_4329;

											BgL_arg3369z00_4329 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19329))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_13565;

												BgL_framez00_13565 = BINT(BgL_siza7ezd2framez75_19331);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_13567;

													BgL_newz00_13567 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33676;

														BgL_auxz00_33676 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_13567, BgL_auxz00_33676,
															BgL_arg3369z00_4329);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33679;

														BgL_auxz00_33679 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_13567, BgL_auxz00_33679,
															BgL_framez00_13565);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33682;

														BgL_auxz00_33682 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_13567, BgL_auxz00_33682,
															BgL_runz00_18311);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														obj_t BgL_auxz00_33687;
														int BgL_auxz00_33685;

														BgL_auxz00_33687 = BINT(((long) 0));
														BgL_auxz00_33685 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_13567, BgL_auxz00_33685,
															BgL_auxz00_33687);
													}
													BgL_arg3368z00_4328 = BgL_newz00_13567;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18312, BgL_arg3368z00_4328);
										BgL_arg3368z00_4328;
									}
									return BgL_mainz00_18312;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5573 */
	obj_t BGl_z62main5573z62zz__evaluate_compz00(obj_t BgL_envz00_19333)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_runz00_19339;
				long BgL_siza7ezd2framez75_19340;

				BgL_runz00_19339 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19333, (int) (((long) 5))));
				BgL_siza7ezd2framez75_19340 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19333, (int) (((long) 6))));
				{

					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_4331;

						BgL_sz00_4331 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_4332;

							BgL_bpz00_4332 = VECTOR_REF(BgL_sz00_4331, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_33700;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_13519;

									BgL_nz00_13519 = BINT(BgL_siza7ezd2framez75_19340);
									BgL_testz00_33700 =
										(
										((long) CINT(BgL_bpz00_4332) +
											(long) CINT(BgL_nz00_13519)) <
										(long) (VECTOR_LENGTH(BgL_sz00_4331)));
								}
								if (BgL_testz00_33700)
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_ez00_4334;

										BgL_ez00_4334 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_4334,
											BgL_bpz00_4332);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_accz00_4335;

											BgL_accz00_4335 =
												BGl_catchzd2trampolinezd2zz__evaluate_compz00
												(BgL_runz00_19339, BgL_sz00_4331, BgL_bpz00_4332);
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_4334);
											VECTOR_SET(BgL_sz00_4331, (int) (((long) 0)),
												BgL_bpz00_4332);
											return BgL_accz00_4335;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_4336;

										BgL_nsz00_4336 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4336,
											(int) (((long) 1)), BgL_sz00_4331);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_4337;

											BgL_z12denvz12_4337 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4337, BgL_nsz00_4336);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_4338;

												BgL_ez00_4338 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_4338, BgL_sz00_4331);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_4339;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13538;

														BgL_savedzd2bpzd2_13538 =
															VECTOR_REF(BgL_nsz00_4336, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_4336,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_13545;

															BgL_fz00_13545 = BgL_runz00_19339;
														BgL_recz00_13544:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_13546;

																BgL_rz00_13546 =
																	PROCEDURE_ENTRY(BgL_fz00_13545)
																	(BgL_fz00_13545, BgL_nsz00_4336, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_33730;

																	if (PROCEDUREP(BgL_rz00_13546))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_13551;

																			BgL_arg1673z00_13551 =
																				PROCEDURE_ATTR(BgL_rz00_13546);
																			if (STRUCTP(BgL_arg1673z00_13551))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33730 =
																						(STRUCT_KEY(BgL_arg1673z00_13551) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33730 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_33730 = ((bool_t) 0);
																		}
																	if (BgL_testz00_33730)
																		{
																			obj_t BgL_fz00_33738;

																			BgL_fz00_33738 = BgL_rz00_13546;
																			BgL_fz00_13545 = BgL_fz00_33738;
																			goto BgL_recz00_13544;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_4336,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13538);
																			BgL_____rz00_4339 = BgL_rz00_13546;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_4338);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_4337,
														BgL_sz00_4331);
													return BgL_____rz00_4339;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5574 */
	obj_t BGl_z62run5574z62zz__evaluate_compz00(obj_t BgL_envz00_19341,
		obj_t BgL_sz00_19347)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19342;
				long BgL_siza7eza7_19343;
				obj_t BgL_valza2za2_19344;
				BgL_ev_absz00_bglt BgL_i1245z00_19345;
				obj_t BgL_bodyz00_19346;

				BgL_iboxesz00_19342 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19341, (int) (((long) 0))));
				BgL_siza7eza7_19343 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19341, (int) (((long) 1))));
				BgL_valza2za2_19344 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19341, (int) (((long) 2))));
				BgL_i1245z00_19345 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19341, (int) (((long) 3))));
				BgL_bodyz00_19346 = PROCEDURE_REF(BgL_envz00_19341, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4341;

					BgL_sz00_4341 = BgL_sz00_19347;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_4343;

						BgL_bpz00_4343 = VECTOR_REF(BgL_sz00_4341, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4341,
							BgL_iboxesz00_19342, BgL_bpz00_4343);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4341,
							BgL_valza2za2_19344,
							((long) CINT(BgL_bpz00_4343) + BgL_siza7eza7_19343));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_4345;
							obj_t BgL_wherez00_4346;
							obj_t BgL_locz00_4347;

							BgL_z12denvz12_4345 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4346 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19345))->BgL_wherez00);
							BgL_locz00_4347 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19345))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4345, BgL_wherez00_4346,
									BgL_locz00_4347);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_4348;

									BgL_za2za2resza2za2z00_4348 =
										PROCEDURE_ENTRY(BgL_bodyz00_19346) (BgL_bodyz00_19346,
										BgL_sz00_4341, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4345);
									return BgL_za2za2resza2za2z00_4348;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3799> */
	obj_t BGl_z62zc3anonymousza33799ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19348, obj_t BgL_sz00_19352)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19349;
				obj_t BgL_bodyz00_19350;
				long BgL_siza7ezd2framez75_19351;

				BgL_i1245z00_19349 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19348, (int) (((long) 0))));
				BgL_bodyz00_19350 = PROCEDURE_REF(BgL_envz00_19348, (int) (((long) 1)));
				BgL_siza7ezd2framez75_19351 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19348, (int) (((long) 2))));
				{
					obj_t BgL_sz00_5580;

					BgL_sz00_5580 = BgL_sz00_19352;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5582;

						BgL_bpz00_5582 = VECTOR_REF(BgL_sz00_5580, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18440;

								BgL_runz00_18440 =
									MAKE_FX_PROCEDURE(BGl_z62run5576z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_18440,
									(int) (((long) 0)), ((obj_t) BgL_i1245z00_19349));
								PROCEDURE_SET(BgL_runz00_18440,
									(int) (((long) 1)), BgL_bodyz00_19350);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18441;

									BgL_mainz00_18441 =
										MAKE_VA_PROCEDURE(BGl_z62main5575z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_18441,
										(int) (((long) 0)), BgL_bodyz00_19350);
									PROCEDURE_SET(BgL_mainz00_18441,
										(int) (((long) 1)), ((obj_t) BgL_i1245z00_19349));
									PROCEDURE_SET(BgL_mainz00_18441,
										(int) (((long) 2)), BgL_runz00_18440);
									PROCEDURE_SET(BgL_mainz00_18441,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_19351));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_12807;

										BgL_objz00_12807 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18440, BgL_objz00_12807);
										BgL_objz00_12807;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3800z00_5585;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3801z00_5586;
											obj_t BgL_arg3802z00_5587;

											BgL_arg3801z00_5586 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19349))->
												BgL_arityz00);
											BgL_arg3802z00_5587 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19349))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_12809;

												BgL_framez00_12809 = BINT(BgL_siza7ezd2framez75_19351);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_12811;

													BgL_newz00_12811 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33809;

														BgL_auxz00_33809 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_12811, BgL_auxz00_33809,
															BgL_arg3802z00_5587);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33812;

														BgL_auxz00_33812 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_12811, BgL_auxz00_33812,
															BgL_framez00_12809);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33815;

														BgL_auxz00_33815 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_12811, BgL_auxz00_33815,
															BgL_runz00_18440);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33818;

														BgL_auxz00_33818 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_12811, BgL_auxz00_33818,
															BgL_arg3801z00_5586);
													}
													BgL_arg3800z00_5585 = BgL_newz00_12811;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18441, BgL_arg3800z00_5585);
										BgL_arg3800z00_5585;
									}
									return BgL_mainz00_18441;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5575 */
	obj_t BGl_z62main5575z62zz__evaluate_compz00(obj_t BgL_envz00_19353,
		obj_t BgL_az00_19358, obj_t BgL_bz00_19359, obj_t BgL_cz00_19360,
		obj_t BgL_dz00_19361, obj_t BgL_restz00_19362)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19355;
				obj_t BgL_runz00_19356;
				long BgL_siza7ezd2framez75_19357;

				BgL_i1245z00_19355 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19353, (int) (((long) 1))));
				BgL_runz00_19356 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19353, (int) (((long) 2))));
				BgL_siza7ezd2framez75_19357 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19353, (int) (((long) 3))));
				{
					obj_t BgL_az00_5588;
					obj_t BgL_bz00_5589;
					obj_t BgL_cz00_5590;
					obj_t BgL_dz00_5591;
					obj_t BgL_restz00_5592;

					BgL_az00_5588 = BgL_az00_19358;
					BgL_bz00_5589 = BgL_bz00_19359;
					BgL_cz00_5590 = BgL_cz00_19360;
					BgL_dz00_5591 = BgL_dz00_19361;
					BgL_restz00_5592 = BgL_restz00_19362;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5594;

						BgL_sz00_5594 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5595;

							BgL_bpz00_5595 = VECTOR_REF(BgL_sz00_5594, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_33834;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_12700;

									BgL_nz00_12700 = BINT(BgL_siza7ezd2framez75_19357);
									BgL_testz00_33834 =
										(
										((long) CINT(BgL_bpz00_5595) +
											(long) CINT(BgL_nz00_12700)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5594)));
								}
								if (BgL_testz00_33834)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3805z00_5597;

											BgL_arg3805z00_5597 =
												((long) CINT(BgL_bpz00_5595) + ((long) 0));
											VECTOR_SET(BgL_sz00_5594,
												(int) (BgL_arg3805z00_5597), BgL_az00_5588);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3806z00_5598;

											BgL_arg3806z00_5598 =
												((long) CINT(BgL_bpz00_5595) + ((long) 1));
											VECTOR_SET(BgL_sz00_5594,
												(int) (BgL_arg3806z00_5598), BgL_bz00_5589);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3807z00_5599;

											BgL_arg3807z00_5599 =
												((long) CINT(BgL_bpz00_5595) + ((long) 2));
											VECTOR_SET(BgL_sz00_5594,
												(int) (BgL_arg3807z00_5599), BgL_cz00_5590);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3808z00_5600;

											BgL_arg3808z00_5600 =
												((long) CINT(BgL_bpz00_5595) + ((long) 3));
											VECTOR_SET(BgL_sz00_5594,
												(int) (BgL_arg3808z00_5600), BgL_dz00_5591);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3809z00_5601;
											long BgL_arg3810z00_5602;
											long BgL_arg3811z00_5603;
											obj_t BgL_arg3812z00_5604;

											BgL_arg3809z00_5601 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19355))->
												BgL_wherez00);
											BgL_arg3810z00_5602 =
												((long) CINT(BgL_bpz00_5595) + ((long) 4));
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_nz00_12737;

												BgL_nz00_12737 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19355))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_12737) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3811z00_5603 =
															((long) CINT(BgL_nz00_12737) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3811z00_5603 =
															((long) CINT(BgL_nz00_12737) - ((long) 4));
											}}
											BgL_arg3812z00_5604 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19355))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_5594,
												BgL_arg3809z00_5601, BgL_arg3810z00_5602,
												BgL_arg3811z00_5603, BgL_restz00_5592,
												BgL_arg3812z00_5604);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5606;

											BgL_ez00_5606 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5606, BgL_bpz00_5595);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5607;

												BgL_accz00_5607 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19356, BgL_sz00_5594, BgL_bpz00_5595);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5606);
												VECTOR_SET(BgL_sz00_5594, (int) (((long) 0)),
													BgL_bpz00_5595);
												return BgL_accz00_5607;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5608;

										BgL_nsz00_5608 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5608,
											(int) (((long) 1)), BgL_sz00_5594);
										VECTOR_SET(BgL_nsz00_5608,
											(int) (((long) 2)), BgL_az00_5588);
										VECTOR_SET(BgL_nsz00_5608,
											(int) (((long) 3)), BgL_bz00_5589);
										VECTOR_SET(BgL_nsz00_5608,
											(int) (((long) 4)), BgL_cz00_5590);
										VECTOR_SET(BgL_nsz00_5608,
											(int) (((long) 5)), BgL_dz00_5591);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3814z00_5609;
											long BgL_arg3815z00_5610;
											obj_t BgL_arg3816z00_5611;

											BgL_arg3814z00_5609 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19355))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_nz00_12767;

												BgL_nz00_12767 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19355))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_12767) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3815z00_5610 =
															((long) CINT(BgL_nz00_12767) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3815z00_5610 =
															((long) CINT(BgL_nz00_12767) - ((long) 4));
											}}
											BgL_arg3816z00_5611 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19355))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_5608,
												BgL_arg3814z00_5609, ((long) 6), BgL_arg3815z00_5610,
												BgL_restz00_5592, BgL_arg3816z00_5611);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5613;

											BgL_z12denvz12_5613 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5613, BgL_nsz00_5608);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5614;

												BgL_ez00_5614 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5614, BgL_sz00_5594);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5615;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_12782;

														BgL_savedzd2bpzd2_12782 =
															VECTOR_REF(BgL_nsz00_5608, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5608,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_12789;

															BgL_fz00_12789 = BgL_runz00_19356;
														BgL_recz00_12788:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_12790;

																BgL_rz00_12790 =
																	PROCEDURE_ENTRY(BgL_fz00_12789)
																	(BgL_fz00_12789, BgL_nsz00_5608, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_33912;

																	if (PROCEDUREP(BgL_rz00_12790))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_12795;

																			BgL_arg1673z00_12795 =
																				PROCEDURE_ATTR(BgL_rz00_12790);
																			if (STRUCTP(BgL_arg1673z00_12795))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33912 =
																						(STRUCT_KEY(BgL_arg1673z00_12795) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_33912 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_33912 = ((bool_t) 0);
																		}
																	if (BgL_testz00_33912)
																		{
																			obj_t BgL_fz00_33920;

																			BgL_fz00_33920 = BgL_rz00_12790;
																			BgL_fz00_12789 = BgL_fz00_33920;
																			goto BgL_recz00_12788;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5608,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_12782);
																			BgL_____rz00_5615 = BgL_rz00_12790;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5614);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5613,
														BgL_sz00_5594);
													return BgL_____rz00_5615;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5576 */
	obj_t BGl_z62run5576z62zz__evaluate_compz00(obj_t BgL_envz00_19363,
		obj_t BgL_sz00_19366)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19364;
				obj_t BgL_bodyz00_19365;

				BgL_i1245z00_19364 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19363, (int) (((long) 0))));
				BgL_bodyz00_19365 = PROCEDURE_REF(BgL_envz00_19363, (int) (((long) 1)));
				{
					obj_t BgL_sz00_5617;

					BgL_sz00_5617 = BgL_sz00_19366;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5619;

						BgL_bpz00_5619 = VECTOR_REF(BgL_sz00_5617, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_5620;
							obj_t BgL_wherez00_5621;
							obj_t BgL_locz00_5622;

							BgL_z12denvz12_5620 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5621 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19364))->BgL_wherez00);
							BgL_locz00_5622 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19364))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5620, BgL_wherez00_5621,
									BgL_locz00_5622);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_5623;

									BgL_za2za2resza2za2z00_5623 =
										PROCEDURE_ENTRY(BgL_bodyz00_19365) (BgL_bodyz00_19365,
										BgL_sz00_5617, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5620);
									return BgL_za2za2resza2za2z00_5623;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3819> */
	obj_t BGl_z62zc3anonymousza33819ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19367, obj_t BgL_sz00_19372)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19368;
				BgL_ev_absz00_bglt BgL_i1245z00_19369;
				obj_t BgL_bodyz00_19370;
				long BgL_siza7ezd2framez75_19371;

				BgL_iboxesz00_19368 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19367, (int) (((long) 0))));
				BgL_i1245z00_19369 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19367, (int) (((long) 1))));
				BgL_bodyz00_19370 = PROCEDURE_REF(BgL_envz00_19367, (int) (((long) 2)));
				BgL_siza7ezd2framez75_19371 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19367, (int) (((long) 3))));
				{
					obj_t BgL_sz00_5625;

					BgL_sz00_5625 = BgL_sz00_19372;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5627;

						BgL_bpz00_5627 = VECTOR_REF(BgL_sz00_5625, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */

							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18437;

								BgL_runz00_18437 =
									MAKE_FX_PROCEDURE(BGl_z62run5578z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_18437,
									(int) (((long) 0)), BgL_iboxesz00_19368);
								PROCEDURE_SET(BgL_runz00_18437,
									(int) (((long) 1)), ((obj_t) BgL_i1245z00_19369));
								PROCEDURE_SET(BgL_runz00_18437,
									(int) (((long) 2)), BgL_bodyz00_19370);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18438;

									BgL_mainz00_18438 =
										MAKE_VA_PROCEDURE(BGl_z62main5577z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_18438,
										(int) (((long) 0)), BgL_iboxesz00_19368);
									PROCEDURE_SET(BgL_mainz00_18438,
										(int) (((long) 1)), BgL_bodyz00_19370);
									PROCEDURE_SET(BgL_mainz00_18438,
										(int) (((long) 2)), ((obj_t) BgL_i1245z00_19369));
									PROCEDURE_SET(BgL_mainz00_18438,
										(int) (((long) 3)), BgL_runz00_18437);
									PROCEDURE_SET(BgL_mainz00_18438,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_19371));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_12947;

										BgL_objz00_12947 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18437, BgL_objz00_12947);
										BgL_objz00_12947;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3820z00_5630;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3821z00_5631;
											obj_t BgL_arg3822z00_5632;

											BgL_arg3821z00_5631 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19369))->
												BgL_arityz00);
											BgL_arg3822z00_5632 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19369))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_12949;

												BgL_framez00_12949 = BINT(BgL_siza7ezd2framez75_19371);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_12951;

													BgL_newz00_12951 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33985;

														BgL_auxz00_33985 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_12951, BgL_auxz00_33985,
															BgL_arg3822z00_5632);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33988;

														BgL_auxz00_33988 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_12951, BgL_auxz00_33988,
															BgL_framez00_12949);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33991;

														BgL_auxz00_33991 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_12951, BgL_auxz00_33991,
															BgL_runz00_18437);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_33994;

														BgL_auxz00_33994 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_12951, BgL_auxz00_33994,
															BgL_arg3821z00_5631);
													}
													BgL_arg3820z00_5630 = BgL_newz00_12951;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18438, BgL_arg3820z00_5630);
										BgL_arg3820z00_5630;
									}
									return BgL_mainz00_18438;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5577 */
	obj_t BGl_z62main5577z62zz__evaluate_compz00(obj_t BgL_envz00_19373,
		obj_t BgL_az00_19379, obj_t BgL_bz00_19380, obj_t BgL_cz00_19381,
		obj_t BgL_dz00_19382, obj_t BgL_restz00_19383)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19376;
				obj_t BgL_runz00_19377;
				long BgL_siza7ezd2framez75_19378;

				BgL_i1245z00_19376 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19373, (int) (((long) 2))));
				BgL_runz00_19377 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19373, (int) (((long) 3))));
				BgL_siza7ezd2framez75_19378 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19373, (int) (((long) 4))));
				{
					obj_t BgL_az00_5633;
					obj_t BgL_bz00_5634;
					obj_t BgL_cz00_5635;
					obj_t BgL_dz00_5636;
					obj_t BgL_restz00_5637;

					BgL_az00_5633 = BgL_az00_19379;
					BgL_bz00_5634 = BgL_bz00_19380;
					BgL_cz00_5635 = BgL_cz00_19381;
					BgL_dz00_5636 = BgL_dz00_19382;
					BgL_restz00_5637 = BgL_restz00_19383;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5639;

						BgL_sz00_5639 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5640;

							BgL_bpz00_5640 = VECTOR_REF(BgL_sz00_5639, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_34010;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_12840;

									BgL_nz00_12840 = BINT(BgL_siza7ezd2framez75_19378);
									BgL_testz00_34010 =
										(
										((long) CINT(BgL_bpz00_5640) +
											(long) CINT(BgL_nz00_12840)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5639)));
								}
								if (BgL_testz00_34010)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3825z00_5642;

											BgL_arg3825z00_5642 =
												((long) CINT(BgL_bpz00_5640) + ((long) 0));
											VECTOR_SET(BgL_sz00_5639,
												(int) (BgL_arg3825z00_5642), BgL_az00_5633);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3826z00_5643;

											BgL_arg3826z00_5643 =
												((long) CINT(BgL_bpz00_5640) + ((long) 1));
											VECTOR_SET(BgL_sz00_5639,
												(int) (BgL_arg3826z00_5643), BgL_bz00_5634);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3827z00_5644;

											BgL_arg3827z00_5644 =
												((long) CINT(BgL_bpz00_5640) + ((long) 2));
											VECTOR_SET(BgL_sz00_5639,
												(int) (BgL_arg3827z00_5644), BgL_cz00_5635);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3828z00_5645;

											BgL_arg3828z00_5645 =
												((long) CINT(BgL_bpz00_5640) + ((long) 3));
											VECTOR_SET(BgL_sz00_5639,
												(int) (BgL_arg3828z00_5645), BgL_dz00_5636);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3829z00_5646;
											long BgL_arg3830z00_5647;
											long BgL_arg3831z00_5648;
											obj_t BgL_arg3832z00_5649;

											BgL_arg3829z00_5646 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19376))->
												BgL_wherez00);
											BgL_arg3830z00_5647 =
												((long) CINT(BgL_bpz00_5640) + ((long) 4));
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_nz00_12877;

												BgL_nz00_12877 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19376))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_12877) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3831z00_5648 =
															((long) CINT(BgL_nz00_12877) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3831z00_5648 =
															((long) CINT(BgL_nz00_12877) - ((long) 4));
											}}
											BgL_arg3832z00_5649 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19376))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_5639,
												BgL_arg3829z00_5646, BgL_arg3830z00_5647,
												BgL_arg3831z00_5648, BgL_restz00_5637,
												BgL_arg3832z00_5649);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5651;

											BgL_ez00_5651 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5651, BgL_bpz00_5640);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5652;

												BgL_accz00_5652 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19377, BgL_sz00_5639, BgL_bpz00_5640);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5651);
												VECTOR_SET(BgL_sz00_5639, (int) (((long) 0)),
													BgL_bpz00_5640);
												return BgL_accz00_5652;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5653;

										BgL_nsz00_5653 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5653,
											(int) (((long) 1)), BgL_sz00_5639);
										VECTOR_SET(BgL_nsz00_5653,
											(int) (((long) 2)), BgL_az00_5633);
										VECTOR_SET(BgL_nsz00_5653,
											(int) (((long) 3)), BgL_bz00_5634);
										VECTOR_SET(BgL_nsz00_5653,
											(int) (((long) 4)), BgL_cz00_5635);
										VECTOR_SET(BgL_nsz00_5653,
											(int) (((long) 5)), BgL_dz00_5636);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3834z00_5654;
											long BgL_arg3835z00_5655;
											obj_t BgL_arg3836z00_5656;

											BgL_arg3834z00_5654 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19376))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_nz00_12907;

												BgL_nz00_12907 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19376))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_12907) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3835z00_5655 =
															((long) CINT(BgL_nz00_12907) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3835z00_5655 =
															((long) CINT(BgL_nz00_12907) - ((long) 4));
											}}
											BgL_arg3836z00_5656 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19376))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_5653,
												BgL_arg3834z00_5654, ((long) 6), BgL_arg3835z00_5655,
												BgL_restz00_5637, BgL_arg3836z00_5656);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5658;

											BgL_z12denvz12_5658 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5658, BgL_nsz00_5653);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5659;

												BgL_ez00_5659 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5659, BgL_sz00_5639);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5660;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_12922;

														BgL_savedzd2bpzd2_12922 =
															VECTOR_REF(BgL_nsz00_5653, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5653,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_12929;

															BgL_fz00_12929 = BgL_runz00_19377;
														BgL_recz00_12928:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_12930;

																BgL_rz00_12930 =
																	PROCEDURE_ENTRY(BgL_fz00_12929)
																	(BgL_fz00_12929, BgL_nsz00_5653, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_34088;

																	if (PROCEDUREP(BgL_rz00_12930))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_12935;

																			BgL_arg1673z00_12935 =
																				PROCEDURE_ATTR(BgL_rz00_12930);
																			if (STRUCTP(BgL_arg1673z00_12935))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_34088 =
																						(STRUCT_KEY(BgL_arg1673z00_12935) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_34088 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_34088 = ((bool_t) 0);
																		}
																	if (BgL_testz00_34088)
																		{
																			obj_t BgL_fz00_34096;

																			BgL_fz00_34096 = BgL_rz00_12930;
																			BgL_fz00_12929 = BgL_fz00_34096;
																			goto BgL_recz00_12928;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5653,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_12922);
																			BgL_____rz00_5660 = BgL_rz00_12930;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5659);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5658,
														BgL_sz00_5639);
													return BgL_____rz00_5660;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5578 */
	obj_t BGl_z62run5578z62zz__evaluate_compz00(obj_t BgL_envz00_19384,
		obj_t BgL_sz00_19388)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19385;
				BgL_ev_absz00_bglt BgL_i1245z00_19386;
				obj_t BgL_bodyz00_19387;

				BgL_iboxesz00_19385 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19384, (int) (((long) 0))));
				BgL_i1245z00_19386 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19384, (int) (((long) 1))));
				BgL_bodyz00_19387 = PROCEDURE_REF(BgL_envz00_19384, (int) (((long) 2)));
				{
					obj_t BgL_sz00_5662;

					BgL_sz00_5662 = BgL_sz00_19388;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5664;

						BgL_bpz00_5664 = VECTOR_REF(BgL_sz00_5662, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5662,
							BgL_iboxesz00_19385, BgL_bpz00_5664);
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_z12denvz12_5665;
							obj_t BgL_wherez00_5666;
							obj_t BgL_locz00_5667;

							BgL_z12denvz12_5665 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5666 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19386))->BgL_wherez00);
							BgL_locz00_5667 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19386))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1161 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5665, BgL_wherez00_5666,
									BgL_locz00_5667);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_za2za2resza2za2z00_5668;

									BgL_za2za2resza2za2z00_5668 =
										PROCEDURE_ENTRY(BgL_bodyz00_19387) (BgL_bodyz00_19387,
										BgL_sz00_5662, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5665);
									return BgL_za2za2resza2za2z00_5668;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3841> */
	obj_t BGl_z62zc3anonymousza33841ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19389, obj_t BgL_sz00_19395)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19390;
				long BgL_siza7eza7_19391;
				BgL_ev_absz00_bglt BgL_i1245z00_19392;
				obj_t BgL_bodyz00_19393;
				long BgL_siza7ezd2framez75_19394;

				BgL_ifreesz00_19390 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19389, (int) (((long) 0))));
				BgL_siza7eza7_19391 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19389, (int) (((long) 1))));
				BgL_i1245z00_19392 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19389, (int) (((long) 2))));
				BgL_bodyz00_19393 = PROCEDURE_REF(BgL_envz00_19389, (int) (((long) 3)));
				BgL_siza7ezd2framez75_19394 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19389, (int) (((long) 4))));
				{
					obj_t BgL_sz00_5672;

					BgL_sz00_5672 = BgL_sz00_19395;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5674;

						BgL_bpz00_5674 = VECTOR_REF(BgL_sz00_5672, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_5675;

							BgL_valza2za2_5675 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5672,
								BgL_bpz00_5674, BgL_ifreesz00_19390);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18434;

								BgL_runz00_18434 =
									MAKE_FX_PROCEDURE(BGl_z62run5580z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_18434,
									(int) (((long) 0)), BINT(BgL_siza7eza7_19391));
								PROCEDURE_SET(BgL_runz00_18434,
									(int) (((long) 1)), BgL_valza2za2_5675);
								PROCEDURE_SET(BgL_runz00_18434,
									(int) (((long) 2)), ((obj_t) BgL_i1245z00_19392));
								PROCEDURE_SET(BgL_runz00_18434,
									(int) (((long) 3)), BgL_bodyz00_19393);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18435;

									BgL_mainz00_18435 =
										MAKE_VA_PROCEDURE(BGl_z62main5579z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_18435,
										(int) (((long) 0)), BINT(BgL_siza7eza7_19391));
									PROCEDURE_SET(BgL_mainz00_18435,
										(int) (((long) 1)), BgL_valza2za2_5675);
									PROCEDURE_SET(BgL_mainz00_18435,
										(int) (((long) 2)), BgL_bodyz00_19393);
									PROCEDURE_SET(BgL_mainz00_18435,
										(int) (((long) 3)), ((obj_t) BgL_i1245z00_19392));
									PROCEDURE_SET(BgL_mainz00_18435,
										(int) (((long) 4)), BgL_runz00_18434);
									PROCEDURE_SET(BgL_mainz00_18435,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_19394));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_13094;

										BgL_objz00_13094 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18434, BgL_objz00_13094);
										BgL_objz00_13094;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3842z00_5678;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3843z00_5679;
											obj_t BgL_arg3844z00_5680;

											BgL_arg3843z00_5679 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19392))->
												BgL_arityz00);
											BgL_arg3844z00_5680 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19392))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_13096;

												BgL_framez00_13096 = BINT(BgL_siza7ezd2framez75_19394);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_13098;

													BgL_newz00_13098 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_34175;

														BgL_auxz00_34175 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_13098, BgL_auxz00_34175,
															BgL_arg3844z00_5680);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_34178;

														BgL_auxz00_34178 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_13098, BgL_auxz00_34178,
															BgL_framez00_13096);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_34181;

														BgL_auxz00_34181 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_13098, BgL_auxz00_34181,
															BgL_runz00_18434);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_34184;

														BgL_auxz00_34184 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_13098, BgL_auxz00_34184,
															BgL_arg3843z00_5679);
													}
													BgL_arg3842z00_5678 = BgL_newz00_13098;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18435, BgL_arg3842z00_5678);
										BgL_arg3842z00_5678;
									}
									return BgL_mainz00_18435;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5579 */
	obj_t BGl_z62main5579z62zz__evaluate_compz00(obj_t BgL_envz00_19396,
		obj_t BgL_az00_19403, obj_t BgL_bz00_19404, obj_t BgL_cz00_19405,
		obj_t BgL_dz00_19406, obj_t BgL_restz00_19407)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19400;
				obj_t BgL_runz00_19401;
				long BgL_siza7ezd2framez75_19402;

				BgL_i1245z00_19400 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19396, (int) (((long) 3))));
				BgL_runz00_19401 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19396, (int) (((long) 4))));
				BgL_siza7ezd2framez75_19402 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19396, (int) (((long) 5))));
				{
					obj_t BgL_az00_5681;
					obj_t BgL_bz00_5682;
					obj_t BgL_cz00_5683;
					obj_t BgL_dz00_5684;
					obj_t BgL_restz00_5685;

					BgL_az00_5681 = BgL_az00_19403;
					BgL_bz00_5682 = BgL_bz00_19404;
					BgL_cz00_5683 = BgL_cz00_19405;
					BgL_dz00_5684 = BgL_dz00_19406;
					BgL_restz00_5685 = BgL_restz00_19407;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5687;

						BgL_sz00_5687 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5688;

							BgL_bpz00_5688 = VECTOR_REF(BgL_sz00_5687, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_34200;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_12987;

									BgL_nz00_12987 = BINT(BgL_siza7ezd2framez75_19402);
									BgL_testz00_34200 =
										(
										((long) CINT(BgL_bpz00_5688) +
											(long) CINT(BgL_nz00_12987)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5687)));
								}
								if (BgL_testz00_34200)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3847z00_5690;

											BgL_arg3847z00_5690 =
												((long) CINT(BgL_bpz00_5688) + ((long) 0));
											VECTOR_SET(BgL_sz00_5687,
												(int) (BgL_arg3847z00_5690), BgL_az00_5681);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3848z00_5691;

											BgL_arg3848z00_5691 =
												((long) CINT(BgL_bpz00_5688) + ((long) 1));
											VECTOR_SET(BgL_sz00_5687,
												(int) (BgL_arg3848z00_5691), BgL_bz00_5682);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3849z00_5692;

											BgL_arg3849z00_5692 =
												((long) CINT(BgL_bpz00_5688) + ((long) 2));
											VECTOR_SET(BgL_sz00_5687,
												(int) (BgL_arg3849z00_5692), BgL_cz00_5683);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3850z00_5693;

											BgL_arg3850z00_5693 =
												((long) CINT(BgL_bpz00_5688) + ((long) 3));
											VECTOR_SET(BgL_sz00_5687,
												(int) (BgL_arg3850z00_5693), BgL_dz00_5684);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3851z00_5694;
											long BgL_arg3852z00_5695;
											long BgL_arg3853z00_5696;
											obj_t BgL_arg3854z00_5697;

											BgL_arg3851z00_5694 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19400))->
												BgL_wherez00);
											BgL_arg3852z00_5695 =
												((long) CINT(BgL_bpz00_5688) + ((long) 4));
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_nz00_13024;

												BgL_nz00_13024 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19400))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_13024) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3853z00_5696 =
															((long) CINT(BgL_nz00_13024) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3853z00_5696 =
															((long) CINT(BgL_nz00_13024) - ((long) 4));
											}}
											BgL_arg3854z00_5697 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19400))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_5687,
												BgL_arg3851z00_5694, BgL_arg3852z00_5695,
												BgL_arg3853z00_5696, BgL_restz00_5685,
												BgL_arg3854z00_5697);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5699;

											BgL_ez00_5699 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5699, BgL_bpz00_5688);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5700;

												BgL_accz00_5700 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19401, BgL_sz00_5687, BgL_bpz00_5688);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5699);
												VECTOR_SET(BgL_sz00_5687, (int) (((long) 0)),
													BgL_bpz00_5688);
												return BgL_accz00_5700;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5701;

										BgL_nsz00_5701 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5701,
											(int) (((long) 1)), BgL_sz00_5687);
										VECTOR_SET(BgL_nsz00_5701,
											(int) (((long) 2)), BgL_az00_5681);
										VECTOR_SET(BgL_nsz00_5701,
											(int) (((long) 3)), BgL_bz00_5682);
										VECTOR_SET(BgL_nsz00_5701,
											(int) (((long) 4)), BgL_cz00_5683);
										VECTOR_SET(BgL_nsz00_5701,
											(int) (((long) 5)), BgL_dz00_5684);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3856z00_5702;
											long BgL_arg3857z00_5703;
											obj_t BgL_arg3858z00_5704;

											BgL_arg3856z00_5702 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19400))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_nz00_13054;

												BgL_nz00_13054 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19400))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_13054) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3857z00_5703 =
															((long) CINT(BgL_nz00_13054) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3857z00_5703 =
															((long) CINT(BgL_nz00_13054) - ((long) 4));
											}}
											BgL_arg3858z00_5704 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19400))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_5701,
												BgL_arg3856z00_5702, ((long) 6), BgL_arg3857z00_5703,
												BgL_restz00_5685, BgL_arg3858z00_5704);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5706;

											BgL_z12denvz12_5706 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5706, BgL_nsz00_5701);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5707;

												BgL_ez00_5707 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5707, BgL_sz00_5687);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5708;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13069;

														BgL_savedzd2bpzd2_13069 =
															VECTOR_REF(BgL_nsz00_5701, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5701,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_13076;

															BgL_fz00_13076 = BgL_runz00_19401;
														BgL_recz00_13075:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_13077;

																BgL_rz00_13077 =
																	PROCEDURE_ENTRY(BgL_fz00_13076)
																	(BgL_fz00_13076, BgL_nsz00_5701, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_34278;

																	if (PROCEDUREP(BgL_rz00_13077))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_13082;

																			BgL_arg1673z00_13082 =
																				PROCEDURE_ATTR(BgL_rz00_13077);
																			if (STRUCTP(BgL_arg1673z00_13082))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_34278 =
																						(STRUCT_KEY(BgL_arg1673z00_13082) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_34278 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_34278 = ((bool_t) 0);
																		}
																	if (BgL_testz00_34278)
																		{
																			obj_t BgL_fz00_34286;

																			BgL_fz00_34286 = BgL_rz00_13077;
																			BgL_fz00_13076 = BgL_fz00_34286;
																			goto BgL_recz00_13075;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5701,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13069);
																			BgL_____rz00_5708 = BgL_rz00_13077;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5707);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5706,
														BgL_sz00_5687);
													return BgL_____rz00_5708;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5580 */
	obj_t BGl_z62run5580z62zz__evaluate_compz00(obj_t BgL_envz00_19408,
		obj_t BgL_sz00_19413)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				long BgL_siza7eza7_19409;
				obj_t BgL_valza2za2_19410;
				BgL_ev_absz00_bglt BgL_i1245z00_19411;
				obj_t BgL_bodyz00_19412;

				BgL_siza7eza7_19409 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19408, (int) (((long) 0))));
				BgL_valza2za2_19410 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19408, (int) (((long) 1))));
				BgL_i1245z00_19411 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19408, (int) (((long) 2))));
				BgL_bodyz00_19412 = PROCEDURE_REF(BgL_envz00_19408, (int) (((long) 3)));
				{
					obj_t BgL_sz00_5710;

					BgL_sz00_5710 = BgL_sz00_19413;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5712;

						BgL_bpz00_5712 = VECTOR_REF(BgL_sz00_5710, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5710,
							BgL_valza2za2_19410,
							((long) CINT(BgL_bpz00_5712) + BgL_siza7eza7_19409));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_5714;
							obj_t BgL_wherez00_5715;
							obj_t BgL_locz00_5716;

							BgL_z12denvz12_5714 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5715 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19411))->BgL_wherez00);
							BgL_locz00_5716 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19411))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5714, BgL_wherez00_5715,
									BgL_locz00_5716);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_5717;

									BgL_za2za2resza2za2z00_5717 =
										PROCEDURE_ENTRY(BgL_bodyz00_19412) (BgL_bodyz00_19412,
										BgL_sz00_5710, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5714);
									return BgL_za2za2resza2za2z00_5717;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3862> */
	obj_t BGl_z62zc3anonymousza33862ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19414, obj_t BgL_sz00_19421)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_ifreesz00_19415;
				obj_t BgL_iboxesz00_19416;
				long BgL_siza7eza7_19417;
				BgL_ev_absz00_bglt BgL_i1245z00_19418;
				obj_t BgL_bodyz00_19419;
				long BgL_siza7ezd2framez75_19420;

				BgL_ifreesz00_19415 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19414, (int) (((long) 0))));
				BgL_iboxesz00_19416 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19414, (int) (((long) 1))));
				BgL_siza7eza7_19417 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19414, (int) (((long) 2))));
				BgL_i1245z00_19418 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19414, (int) (((long) 3))));
				BgL_bodyz00_19419 = PROCEDURE_REF(BgL_envz00_19414, (int) (((long) 4)));
				BgL_siza7ezd2framez75_19420 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19414, (int) (((long) 5))));
				{
					obj_t BgL_sz00_5719;

					BgL_sz00_5719 = BgL_sz00_19421;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5721;

						BgL_bpz00_5721 = VECTOR_REF(BgL_sz00_5719, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_valza2za2_5722;

							BgL_valza2za2_5722 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5719,
								BgL_bpz00_5721, BgL_ifreesz00_19415);
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_runz00_18431;

								BgL_runz00_18431 =
									MAKE_FX_PROCEDURE(BGl_z62run5582z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_18431,
									(int) (((long) 0)), BgL_iboxesz00_19416);
								PROCEDURE_SET(BgL_runz00_18431,
									(int) (((long) 1)), BINT(BgL_siza7eza7_19417));
								PROCEDURE_SET(BgL_runz00_18431,
									(int) (((long) 2)), BgL_valza2za2_5722);
								PROCEDURE_SET(BgL_runz00_18431,
									(int) (((long) 3)), ((obj_t) BgL_i1245z00_19418));
								PROCEDURE_SET(BgL_runz00_18431,
									(int) (((long) 4)), BgL_bodyz00_19419);
								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_mainz00_18432;

									BgL_mainz00_18432 =
										MAKE_VA_PROCEDURE(BGl_z62main5581z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_18432,
										(int) (((long) 0)), BgL_iboxesz00_19416);
									PROCEDURE_SET(BgL_mainz00_18432,
										(int) (((long) 1)), BINT(BgL_siza7eza7_19417));
									PROCEDURE_SET(BgL_mainz00_18432,
										(int) (((long) 2)), BgL_valza2za2_5722);
									PROCEDURE_SET(BgL_mainz00_18432,
										(int) (((long) 3)), BgL_bodyz00_19419);
									PROCEDURE_SET(BgL_mainz00_18432,
										(int) (((long) 4)), ((obj_t) BgL_i1245z00_19418));
									PROCEDURE_SET(BgL_mainz00_18432,
										(int) (((long) 5)), BgL_runz00_18431);
									PROCEDURE_SET(BgL_mainz00_18432,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_19420));
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_objz00_13237;

										BgL_objz00_13237 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_18431, BgL_objz00_13237);
										BgL_objz00_13237;
									}
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_arg3863z00_5725;

										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3864z00_5726;
											obj_t BgL_arg3865z00_5727;

											BgL_arg3864z00_5726 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19418))->
												BgL_arityz00);
											BgL_arg3865z00_5727 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19418))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_framez00_13239;

												BgL_framez00_13239 = BINT(BgL_siza7ezd2framez75_19420);
												{	/* Eval/evaluate_comp.scm 676 */
													obj_t BgL_newz00_13241;

													BgL_newz00_13241 =
														create_struct(BGl_symbol5612z00zz__evaluate_compz00,
														(int) (((long) 4)));
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_34377;

														BgL_auxz00_34377 = (int) (((long) 3));
														STRUCT_SET(BgL_newz00_13241, BgL_auxz00_34377,
															BgL_arg3865z00_5727);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_34380;

														BgL_auxz00_34380 = (int) (((long) 2));
														STRUCT_SET(BgL_newz00_13241, BgL_auxz00_34380,
															BgL_framez00_13239);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_34383;

														BgL_auxz00_34383 = (int) (((long) 1));
														STRUCT_SET(BgL_newz00_13241, BgL_auxz00_34383,
															BgL_runz00_18431);
													}
													{	/* Eval/evaluate_comp.scm 676 */
														int BgL_auxz00_34386;

														BgL_auxz00_34386 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_13241, BgL_auxz00_34386,
															BgL_arg3864z00_5726);
													}
													BgL_arg3863z00_5725 = BgL_newz00_13241;
										}}}
										PROCEDURE_ATTR_SET(BgL_mainz00_18432, BgL_arg3863z00_5725);
										BgL_arg3863z00_5725;
									}
									return BgL_mainz00_18432;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5581 */
	obj_t BGl_z62main5581z62zz__evaluate_compz00(obj_t BgL_envz00_19422,
		obj_t BgL_az00_19430, obj_t BgL_bz00_19431, obj_t BgL_cz00_19432,
		obj_t BgL_dz00_19433, obj_t BgL_restz00_19434)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				BgL_ev_absz00_bglt BgL_i1245z00_19427;
				obj_t BgL_runz00_19428;
				long BgL_siza7ezd2framez75_19429;

				BgL_i1245z00_19427 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19422, (int) (((long) 4))));
				BgL_runz00_19428 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19422, (int) (((long) 5))));
				BgL_siza7ezd2framez75_19429 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19422, (int) (((long) 6))));
				{
					obj_t BgL_az00_5728;
					obj_t BgL_bz00_5729;
					obj_t BgL_cz00_5730;
					obj_t BgL_dz00_5731;
					obj_t BgL_restz00_5732;

					BgL_az00_5728 = BgL_az00_19430;
					BgL_bz00_5729 = BgL_bz00_19431;
					BgL_cz00_5730 = BgL_cz00_19432;
					BgL_dz00_5731 = BgL_dz00_19433;
					BgL_restz00_5732 = BgL_restz00_19434;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_sz00_5734;

						BgL_sz00_5734 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1161 */
							obj_t BgL_bpz00_5735;

							BgL_bpz00_5735 = VECTOR_REF(BgL_sz00_5734, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1161 */
								bool_t BgL_testz00_34402;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_nz00_13130;

									BgL_nz00_13130 = BINT(BgL_siza7ezd2framez75_19429);
									BgL_testz00_34402 =
										(
										((long) CINT(BgL_bpz00_5735) +
											(long) CINT(BgL_nz00_13130)) <
										(long) (VECTOR_LENGTH(BgL_sz00_5734)));
								}
								if (BgL_testz00_34402)
									{	/* Eval/evaluate_comp.scm 1161 */
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3868z00_5737;

											BgL_arg3868z00_5737 =
												((long) CINT(BgL_bpz00_5735) + ((long) 0));
											VECTOR_SET(BgL_sz00_5734,
												(int) (BgL_arg3868z00_5737), BgL_az00_5728);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3869z00_5738;

											BgL_arg3869z00_5738 =
												((long) CINT(BgL_bpz00_5735) + ((long) 1));
											VECTOR_SET(BgL_sz00_5734,
												(int) (BgL_arg3869z00_5738), BgL_bz00_5729);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3870z00_5739;

											BgL_arg3870z00_5739 =
												((long) CINT(BgL_bpz00_5735) + ((long) 2));
											VECTOR_SET(BgL_sz00_5734,
												(int) (BgL_arg3870z00_5739), BgL_cz00_5730);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											long BgL_arg3871z00_5740;

											BgL_arg3871z00_5740 =
												((long) CINT(BgL_bpz00_5735) + ((long) 3));
											VECTOR_SET(BgL_sz00_5734,
												(int) (BgL_arg3871z00_5740), BgL_dz00_5731);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3872z00_5741;
											long BgL_arg3873z00_5742;
											long BgL_arg3874z00_5743;
											obj_t BgL_arg3875z00_5744;

											BgL_arg3872z00_5741 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19427))->
												BgL_wherez00);
											BgL_arg3873z00_5742 =
												((long) CINT(BgL_bpz00_5735) + ((long) 4));
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_nz00_13167;

												BgL_nz00_13167 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19427))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_13167) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3874z00_5743 =
															((long) CINT(BgL_nz00_13167) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3874z00_5743 =
															((long) CINT(BgL_nz00_13167) - ((long) 4));
											}}
											BgL_arg3875z00_5744 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19427))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_5734,
												BgL_arg3872z00_5741, BgL_arg3873z00_5742,
												BgL_arg3874z00_5743, BgL_restz00_5732,
												BgL_arg3875z00_5744);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_ez00_5746;

											BgL_ez00_5746 = BGL_EXITD_TOP_AS_OBJ();
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_ez00_5746, BgL_bpz00_5735);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_accz00_5747;

												BgL_accz00_5747 =
													BGl_catchzd2trampolinezd2zz__evaluate_compz00
													(BgL_runz00_19428, BgL_sz00_5734, BgL_bpz00_5735);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_ez00_5746);
												VECTOR_SET(BgL_sz00_5734, (int) (((long) 0)),
													BgL_bpz00_5735);
												return BgL_accz00_5747;
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1161 */
										obj_t BgL_nsz00_5748;

										BgL_nsz00_5748 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5748,
											(int) (((long) 1)), BgL_sz00_5734);
										VECTOR_SET(BgL_nsz00_5748,
											(int) (((long) 2)), BgL_az00_5728);
										VECTOR_SET(BgL_nsz00_5748,
											(int) (((long) 3)), BgL_bz00_5729);
										VECTOR_SET(BgL_nsz00_5748,
											(int) (((long) 4)), BgL_cz00_5730);
										VECTOR_SET(BgL_nsz00_5748,
											(int) (((long) 5)), BgL_dz00_5731);
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_arg3877z00_5749;
											long BgL_arg3878z00_5750;
											obj_t BgL_arg3879z00_5751;

											BgL_arg3877z00_5749 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19427))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_nz00_13197;

												BgL_nz00_13197 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19427))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_13197) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3878z00_5750 =
															((long) CINT(BgL_nz00_13197) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1046 */
														BgL_arg3878z00_5750 =
															((long) CINT(BgL_nz00_13197) - ((long) 4));
											}}
											BgL_arg3879z00_5751 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19427))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_5748,
												BgL_arg3877z00_5749, ((long) 6), BgL_arg3878z00_5750,
												BgL_restz00_5732, BgL_arg3879z00_5751);
										}
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_z12denvz12_5753;

											BgL_z12denvz12_5753 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5753, BgL_nsz00_5748);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_ez00_5754;

												BgL_ez00_5754 = BGL_EXITD_TOP_AS_OBJ();
												BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
													(BgL_ez00_5754, BgL_sz00_5734);
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_____rz00_5755;

													{	/* Eval/evaluate_comp.scm 663 */
														obj_t BgL_savedzd2bpzd2_13212;

														BgL_savedzd2bpzd2_13212 =
															VECTOR_REF(BgL_nsz00_5748, (int) (((long) 0)));
														VECTOR_SET(BgL_nsz00_5748,
															(int) (((long) 0)), BINT(((long) 2)));
														{
															obj_t BgL_fz00_13219;

															BgL_fz00_13219 = BgL_runz00_19428;
														BgL_recz00_13218:
															{	/* Eval/evaluate_comp.scm 666 */
																obj_t BgL_rz00_13220;

																BgL_rz00_13220 =
																	PROCEDURE_ENTRY(BgL_fz00_13219)
																	(BgL_fz00_13219, BgL_nsz00_5748, BEOA);
																{	/* Eval/evaluate_comp.scm 667 */
																	bool_t BgL_testz00_34480;

																	if (PROCEDUREP(BgL_rz00_13220))
																		{	/* Eval/evaluate_comp.scm 667 */
																			obj_t BgL_arg1673z00_13225;

																			BgL_arg1673z00_13225 =
																				PROCEDURE_ATTR(BgL_rz00_13220);
																			if (STRUCTP(BgL_arg1673z00_13225))
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_34480 =
																						(STRUCT_KEY(BgL_arg1673z00_13225) ==
																						BGl_symbol5591z00zz__evaluate_compz00);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 647 */
																					BgL_testz00_34480 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			BgL_testz00_34480 = ((bool_t) 0);
																		}
																	if (BgL_testz00_34480)
																		{
																			obj_t BgL_fz00_34488;

																			BgL_fz00_34488 = BgL_rz00_13220;
																			BgL_fz00_13219 = BgL_fz00_34488;
																			goto BgL_recz00_13218;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 667 */
																			VECTOR_SET(BgL_nsz00_5748,
																				(int) (((long) 0)),
																				BgL_savedzd2bpzd2_13212);
																			BgL_____rz00_5755 = BgL_rz00_13220;
													}}}}}
													BGl_exitdzd2popzd2protectz12z12zz__bexitz00
														(BgL_ez00_5754);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_5753,
														BgL_sz00_5734);
													return BgL_____rz00_5755;
												}
											}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* &run5582 */
	obj_t BGl_z62run5582z62zz__evaluate_compz00(obj_t BgL_envz00_19435,
		obj_t BgL_sz00_19441)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1161 */
			{	/* Eval/evaluate_comp.scm 1161 */
				obj_t BgL_iboxesz00_19436;
				long BgL_siza7eza7_19437;
				obj_t BgL_valza2za2_19438;
				BgL_ev_absz00_bglt BgL_i1245z00_19439;
				obj_t BgL_bodyz00_19440;

				BgL_iboxesz00_19436 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19435, (int) (((long) 0))));
				BgL_siza7eza7_19437 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19435, (int) (((long) 1))));
				BgL_valza2za2_19438 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19435, (int) (((long) 2))));
				BgL_i1245z00_19439 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_19435, (int) (((long) 3))));
				BgL_bodyz00_19440 = PROCEDURE_REF(BgL_envz00_19435, (int) (((long) 4)));
				{
					obj_t BgL_sz00_5757;

					BgL_sz00_5757 = BgL_sz00_19441;
					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_bpz00_5759;

						BgL_bpz00_5759 = VECTOR_REF(BgL_sz00_5757, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5757,
							BgL_iboxesz00_19436, BgL_bpz00_5759);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5757,
							BgL_valza2za2_19438,
							((long) CINT(BgL_bpz00_5759) + BgL_siza7eza7_19437));
						{	/* Eval/evaluate_comp.scm 1082 */
							obj_t BgL_z12denvz12_5761;
							obj_t BgL_wherez00_5762;
							obj_t BgL_locz00_5763;

							BgL_z12denvz12_5761 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5762 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19439))->BgL_wherez00);
							BgL_locz00_5763 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1245z00_19439))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1082 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5761, BgL_wherez00_5762,
									BgL_locz00_5763);
								{	/* Eval/evaluate_comp.scm 1082 */
									obj_t BgL_za2za2resza2za2z00_5764;

									BgL_za2za2resza2za2z00_5764 =
										PROCEDURE_ENTRY(BgL_bodyz00_19440) (BgL_bodyz00_19440,
										BgL_sz00_5757, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5761);
									return BgL_za2za2resza2za2z00_5764;
								}
							}
						}
					}
				}
			}
		}
	}



/* &comp-ev_app1425 */
	obj_t BGl_z62compzd2ev_app1425zb0zz__evaluate_compz00(obj_t BgL_envz00_19442,
		obj_t BgL_ez00_19443, obj_t BgL_stkz00_19444)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1031 */
			{
				BgL_ev_appz00_bglt BgL_ez00_4168;
				obj_t BgL_stkz00_4169;

				BgL_ez00_4168 = ((BgL_ev_appz00_bglt) BgL_ez00_19443);
				BgL_stkz00_4169 = BgL_stkz00_19444;
				{	/* Eval/evaluate_comp.scm 1033 */
					obj_t BgL__ortest_1231z00_4173;

					BgL__ortest_1231z00_4173 =
						BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ez00_4168,
						BgL_stkz00_4169);
					if (CBOOL(BgL__ortest_1231z00_4173))
						{	/* Eval/evaluate_comp.scm 1033 */
							return BgL__ortest_1231z00_4173;
						}
					else
						{	/* Eval/evaluate_comp.scm 1034 */
							obj_t BgL__ortest_1232z00_4174;

							BgL__ortest_1232z00_4174 =
								BGl_inlinezd2callzd2zz__evaluate_compz00(
								(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->BgL_locz00),
								(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->BgL_funz00),
								(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->BgL_argsz00),
								BgL_stkz00_4169);
							if (CBOOL(BgL__ortest_1232z00_4174))
								{	/* Eval/evaluate_comp.scm 1034 */
									return BgL__ortest_1232z00_4174;
								}
							else
								{	/* Eval/evaluate_comp.scm 1034 */
									if (
										(bgl_list_length(
												(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
													BgL_argsz00)) > ((long) 4)))
										{	/* Eval/evaluate_comp.scm 1035 */
											return
												BGl_compzd2oldzd2callz00zz__evaluate_compz00
												(BgL_ez00_4168, BgL_stkz00_4169);
										}
									else
										{	/* Eval/evaluate_comp.scm 1037 */
											obj_t BgL_fz00_4176;
											long BgL_siza7eza7_4177;
											obj_t BgL_symbzd2funzd2_4178;

											BgL_fz00_4176 =
												BGl_compz00zz__evaluate_compz00(
												(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
													BgL_funz00), BgL_stkz00_4169);
											BgL_siza7eza7_4177 = bgl_list_length(BgL_stkz00_4169);
											BgL_symbzd2funzd2_4178 =
												BGl_uncompilez00zz__evaluate_uncompz00(
												(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
													BgL_funz00));
											if (NULLP((((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
														BgL_argsz00)))
												{	/* Eval/evaluate_comp.scm 1038 */
													return
														BGl_compzd2call0zd2zz__evaluate_compz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
															BgL_locz00),
														(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
															BgL_funz00), BgL_symbzd2funzd2_4178,
														BgL_fz00_4176,
														(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
															BgL_tailzf3zf3), BgL_stkz00_4169,
														BgL_siza7eza7_4177);
												}
											else
												{	/* Eval/evaluate_comp.scm 1040 */
													obj_t BgL_a1z00_4183;
													obj_t BgL_argsz00_4184;

													{	/* Eval/evaluate_comp.scm 1040 */
														obj_t BgL_arg3328z00_4210;

														BgL_arg3328z00_4210 =
															CAR(
															(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
																BgL_argsz00));
														BgL_a1z00_4183 =
															BGl_compz00zz__evaluate_compz00((
																(BgL_ev_exprz00_bglt) BgL_arg3328z00_4210),
															BgL_stkz00_4169);
													}
													BgL_argsz00_4184 =
														CDR(
														(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
															BgL_argsz00));
													if (NULLP(BgL_argsz00_4184))
														{	/* Eval/evaluate_comp.scm 1040 */
															return
																BGl_compzd2call1zd2zz__evaluate_compz00(
																(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
																	BgL_locz00),
																(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
																	BgL_funz00), BgL_symbzd2funzd2_4178,
																BgL_fz00_4176,
																(((BgL_ev_appz00_bglt) CREF(BgL_ez00_4168))->
																	BgL_tailzf3zf3), BgL_stkz00_4169,
																BgL_siza7eza7_4177, BgL_a1z00_4183);
														}
													else
														{	/* Eval/evaluate_comp.scm 1040 */
															obj_t BgL_a2z00_4189;
															obj_t BgL_argsz00_4190;

															{	/* Eval/evaluate_comp.scm 1040 */
																obj_t BgL_arg3327z00_4209;

																BgL_arg3327z00_4209 = CAR(BgL_argsz00_4184);
																BgL_a2z00_4189 =
																	BGl_compz00zz__evaluate_compz00(
																	((BgL_ev_exprz00_bglt) BgL_arg3327z00_4209),
																	BgL_stkz00_4169);
															}
															BgL_argsz00_4190 = CDR(BgL_argsz00_4184);
															if (NULLP(BgL_argsz00_4190))
																{	/* Eval/evaluate_comp.scm 1040 */
																	return
																		BGl_compzd2call2zd2zz__evaluate_compz00(
																		(((BgL_ev_appz00_bglt)
																				CREF(BgL_ez00_4168))->BgL_locz00),
																		(((BgL_ev_appz00_bglt)
																				CREF(BgL_ez00_4168))->BgL_funz00),
																		BgL_symbzd2funzd2_4178, BgL_fz00_4176,
																		(((BgL_ev_appz00_bglt)
																				CREF(BgL_ez00_4168))->BgL_tailzf3zf3),
																		BgL_stkz00_4169, BgL_siza7eza7_4177,
																		BgL_a1z00_4183, BgL_a2z00_4189);
																}
															else
																{	/* Eval/evaluate_comp.scm 1040 */
																	obj_t BgL_a3z00_4195;
																	obj_t BgL_argsz00_4196;

																	{	/* Eval/evaluate_comp.scm 1040 */
																		obj_t BgL_arg3325z00_4208;

																		BgL_arg3325z00_4208 = CAR(BgL_argsz00_4190);
																		BgL_a3z00_4195 =
																			BGl_compz00zz__evaluate_compz00(
																			((BgL_ev_exprz00_bglt)
																				BgL_arg3325z00_4208), BgL_stkz00_4169);
																	}
																	BgL_argsz00_4196 = CDR(BgL_argsz00_4190);
																	if (NULLP(BgL_argsz00_4196))
																		{	/* Eval/evaluate_comp.scm 1040 */
																			return
																				BGl_compzd2call3zd2zz__evaluate_compz00(
																				(((BgL_ev_appz00_bglt)
																						CREF(BgL_ez00_4168))->BgL_locz00),
																				(((BgL_ev_appz00_bglt)
																						CREF(BgL_ez00_4168))->BgL_funz00),
																				BgL_symbzd2funzd2_4178, BgL_fz00_4176,
																				(((BgL_ev_appz00_bglt)
																						CREF(BgL_ez00_4168))->
																					BgL_tailzf3zf3), BgL_stkz00_4169,
																				BgL_siza7eza7_4177, BgL_a1z00_4183,
																				BgL_a2z00_4189, BgL_a3z00_4195);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 1040 */
																			obj_t BgL_a4z00_4201;
																			obj_t BgL_argsz00_4202;

																			{	/* Eval/evaluate_comp.scm 1040 */
																				obj_t BgL_arg3324z00_4207;

																				BgL_arg3324z00_4207 =
																					CAR(BgL_argsz00_4196);
																				BgL_a4z00_4201 =
																					BGl_compz00zz__evaluate_compz00(
																					((BgL_ev_exprz00_bglt)
																						BgL_arg3324z00_4207),
																					BgL_stkz00_4169);
																			}
																			BgL_argsz00_4202 = CDR(BgL_argsz00_4196);
																			if (NULLP(BgL_argsz00_4202))
																				{	/* Eval/evaluate_comp.scm 1040 */
																					return
																						BGl_compzd2call4zd2zz__evaluate_compz00
																						((((BgL_ev_appz00_bglt)
																								CREF(BgL_ez00_4168))->
																							BgL_locz00),
																						(((BgL_ev_appz00_bglt)
																								CREF(BgL_ez00_4168))->
																							BgL_funz00),
																						BgL_symbzd2funzd2_4178,
																						BgL_fz00_4176,
																						(((BgL_ev_appz00_bglt)
																								CREF(BgL_ez00_4168))->
																							BgL_tailzf3zf3), BgL_stkz00_4169,
																						BgL_siza7eza7_4177, BgL_a1z00_4183,
																						BgL_a2z00_4189, BgL_a3z00_4195,
																						BgL_a4z00_4201);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 1040 */
																					return
																						BGl_errorz00zz__errorz00
																						(BGl_string5595z00zz__evaluate_compz00,
																						BGl_string5710z00zz__evaluate_compz00,
																						BGl_string5711z00zz__evaluate_compz00);
																				}
																		}
																}
														}
												}
										}
								}
						}
				}
			}
		}
	}



/* &comp-ev_goto1423 */
	obj_t BGl_z62compzd2ev_goto1423zb0zz__evaluate_compz00(obj_t BgL_envz00_19445,
		obj_t BgL_ez00_19446, obj_t BgL_stkz00_19447)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 597 */
			{
				BgL_ev_gotoz00_bglt BgL_ez00_4125;
				obj_t BgL_stkz00_4126;

				BgL_ez00_4125 = ((BgL_ev_gotoz00_bglt) BgL_ez00_19446);
				BgL_stkz00_4126 = BgL_stkz00_19447;
				{	/* Eval/evaluate_comp.scm 600 */
					obj_t BgL_slotz00_4130;
					long BgL_siza7eza7_4131;
					obj_t BgL_lstkz00_4132;

					BgL_slotz00_4130 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
						((obj_t)
							(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_4125))->BgL_labelz00)),
						(((BgL_ev_labelsz00_bglt) CREF(
									(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_4125))->
										BgL_labelsz00)))->BgL_envz00));
					BgL_siza7eza7_4131 = bgl_list_length(BgL_stkz00_4126);
					BgL_lstkz00_4132 =
						(((BgL_ev_labelsz00_bglt) CREF(
								(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_4125))->BgL_labelsz00)))->
						BgL_stkz00);
					{	/* Eval/evaluate_comp.scm 602 */
						long BgL_llstkz00_4133;
						obj_t BgL_substkz00_4134;
						obj_t BgL_boxesz00_4135;

						BgL_llstkz00_4133 = bgl_list_length(BgL_lstkz00_4132);
						BgL_substkz00_4134 =
							BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_4132,
							BgL_stkz00_4126);
						{	/* Eval/evaluate_comp.scm 602 */
							obj_t BgL_pairz00_12560;

							BgL_pairz00_12560 =
								BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
								((obj_t)
									(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_4125))->BgL_labelz00)),
								(((BgL_ev_labelsz00_bglt) CREF(
											(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_4125))->
												BgL_labelsz00)))->BgL_boxesz00));
							BgL_boxesz00_4135 = CDR(BgL_pairz00_12560);
						}
						if (BGl_needzd2shiftzd2zz__evaluate_compz00(
								(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_4125))->BgL_argsz00),
								BgL_substkz00_4134))
							{	/* Eval/evaluate_comp.scm 605 */
								obj_t BgL_argsz00_4137;
								long BgL_nbargsz00_4138;

								BgL_argsz00_4137 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_4125))->BgL_argsz00),
									BgL_stkz00_4126);
								BgL_nbargsz00_4138 =
									bgl_list_length((((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_4125))->
										BgL_argsz00));
								{	/* Eval/evaluate_comp.scm 606 */
									obj_t BgL_zc3anonymousza33264ze3z83_18445;

									BgL_zc3anonymousza33264ze3z83_18445 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza33264ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_zc3anonymousza33264ze3z83_18445,
										(int) (((long) 0)), BINT(BgL_siza7eza7_4131));
									PROCEDURE_SET(BgL_zc3anonymousza33264ze3z83_18445,
										(int) (((long) 1)), BINT(BgL_llstkz00_4133));
									PROCEDURE_SET(BgL_zc3anonymousza33264ze3z83_18445,
										(int) (((long) 2)), ((obj_t) BgL_ez00_4125));
									PROCEDURE_SET(BgL_zc3anonymousza33264ze3z83_18445,
										(int) (((long) 3)), BgL_argsz00_4137);
									PROCEDURE_SET(BgL_zc3anonymousza33264ze3z83_18445,
										(int) (((long) 4)), BgL_boxesz00_4135);
									PROCEDURE_SET(BgL_zc3anonymousza33264ze3z83_18445,
										(int) (((long) 5)), BINT(BgL_nbargsz00_4138));
									PROCEDURE_SET(BgL_zc3anonymousza33264ze3z83_18445,
										(int) (((long) 6)), BgL_slotz00_4130);
									return BgL_zc3anonymousza33264ze3z83_18445;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 611 */
								obj_t BgL_argsz00_4149;

								BgL_argsz00_4149 =
									BGl_recz00zz__evaluate_compz00(BgL_stkz00_4126,
									(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_4125))->BgL_argsz00),
									(BgL_siza7eza7_4131 - BgL_llstkz00_4133));
								{	/* Eval/evaluate_comp.scm 612 */
									obj_t BgL_zc3anonymousza33270ze3z83_18446;

									BgL_zc3anonymousza33270ze3z83_18446 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza33270ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_zc3anonymousza33270ze3z83_18446,
										(int) (((long) 0)), BINT(BgL_llstkz00_4133));
									PROCEDURE_SET(BgL_zc3anonymousza33270ze3z83_18446,
										(int) (((long) 1)), ((obj_t) BgL_ez00_4125));
									PROCEDURE_SET(BgL_zc3anonymousza33270ze3z83_18446,
										(int) (((long) 2)), BgL_argsz00_4149);
									PROCEDURE_SET(BgL_zc3anonymousza33270ze3z83_18446,
										(int) (((long) 3)), BgL_boxesz00_4135);
									PROCEDURE_SET(BgL_zc3anonymousza33270ze3z83_18446,
										(int) (((long) 4)), BgL_slotz00_4130);
									return BgL_zc3anonymousza33270ze3z83_18446;
								}
							}
					}
				}
			}
		}
	}



/* &<anonymous:3264> */
	obj_t BGl_z62zc3anonymousza33264ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19448, obj_t BgL_sz00_19456)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 606 */
			{	/* Eval/evaluate_comp.scm 606 */
				long BgL_siza7eza7_19449;
				long BgL_llstkz00_19450;
				BgL_ev_gotoz00_bglt BgL_i1143z00_19451;
				obj_t BgL_argsz00_19452;
				obj_t BgL_boxesz00_19453;
				long BgL_nbargsz00_19454;
				obj_t BgL_slotz00_19455;

				BgL_siza7eza7_19449 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19448, (int) (((long) 0))));
				BgL_llstkz00_19450 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19448, (int) (((long) 1))));
				BgL_i1143z00_19451 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_19448, (int) (((long) 2))));
				BgL_argsz00_19452 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19448, (int) (((long) 3))));
				BgL_boxesz00_19453 =
					PROCEDURE_REF(BgL_envz00_19448, (int) (((long) 4)));
				BgL_nbargsz00_19454 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19448, (int) (((long) 5))));
				BgL_slotz00_19455 = PROCEDURE_REF(BgL_envz00_19448, (int) (((long) 6)));
				{
					obj_t BgL_sz00_4139;

					BgL_sz00_4139 = BgL_sz00_19456;
					{	/* Eval/evaluate_comp.scm 606 */
						obj_t BgL_bpz00_4141;

						BgL_bpz00_4141 = VECTOR_REF(BgL_sz00_4139, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 607 */
							long BgL_spz00_4142;
							long BgL_lspz00_4143;

							BgL_spz00_4142 =
								((long) CINT(BgL_bpz00_4141) + BgL_siza7eza7_19449);
							BgL_lspz00_4143 =
								((long) CINT(BgL_bpz00_4141) + BgL_llstkz00_19450);
							BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
								(BgL_sz00_4139, BgL_argsz00_19452, BgL_boxesz00_19453,
								BgL_spz00_4142,
								(((BgL_ev_gotoz00_bglt) CREF(BgL_i1143z00_19451))->BgL_locz00));
							{	/* Eval/evaluate_comp.scm 609 */
								long BgL_arg3266z00_4145;

								BgL_arg3266z00_4145 = (BgL_spz00_4142 + BgL_nbargsz00_19454);
								BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_4139,
									BgL_lspz00_4143, BgL_sz00_4139, BINT(BgL_spz00_4142),
									BINT(BgL_arg3266z00_4145));
							}
							return CDR(BgL_slotz00_19455);
						}
					}
				}
			}
		}
	}



/* &<anonymous:3270> */
	obj_t BGl_z62zc3anonymousza33270ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19457, obj_t BgL_sz00_19463)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 612 */
			{	/* Eval/evaluate_comp.scm 612 */
				long BgL_llstkz00_19458;
				BgL_ev_gotoz00_bglt BgL_i1143z00_19459;
				obj_t BgL_argsz00_19460;
				obj_t BgL_boxesz00_19461;
				obj_t BgL_slotz00_19462;

				BgL_llstkz00_19458 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19457, (int) (((long) 0))));
				BgL_i1143z00_19459 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_19457, (int) (((long) 1))));
				BgL_argsz00_19460 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19457, (int) (((long) 2))));
				BgL_boxesz00_19461 =
					PROCEDURE_REF(BgL_envz00_19457, (int) (((long) 3)));
				BgL_slotz00_19462 = PROCEDURE_REF(BgL_envz00_19457, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4150;

					BgL_sz00_4150 = BgL_sz00_19463;
					{	/* Eval/evaluate_comp.scm 612 */
						obj_t BgL_bpz00_4152;

						BgL_bpz00_4152 = VECTOR_REF(BgL_sz00_4150, (int) (((long) 0)));
						BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
							(BgL_sz00_4150, BgL_argsz00_19460, BgL_boxesz00_19461,
							((long) CINT(BgL_bpz00_4152) + BgL_llstkz00_19458),
							(((BgL_ev_gotoz00_bglt) CREF(BgL_i1143z00_19459))->BgL_locz00));
						return CDR(BgL_slotz00_19462);
					}
				}
			}
		}
	}



/* &comp-ev_labels1421 */
	obj_t BGl_z62compzd2ev_labels1421zb0zz__evaluate_compz00(obj_t
		BgL_envz00_19464, obj_t BgL_ez00_19465, obj_t BgL_stkz00_19466)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 565 */
			{
				BgL_ev_labelsz00_bglt BgL_ez00_4079;
				obj_t BgL_stkz00_4080;

				BgL_ez00_4079 = ((BgL_ev_labelsz00_bglt) BgL_ez00_19465);
				BgL_stkz00_4080 = BgL_stkz00_19466;
				((((BgL_ev_labelsz00_bglt) CREF(BgL_ez00_4079))->BgL_stkz00) =
					((obj_t) BgL_stkz00_4080), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 572 */
					obj_t BgL_envz00_4085;

					{	/* Eval/evaluate_comp.scm 572 */
						obj_t BgL_l1324z00_4103;

						BgL_l1324z00_4103 =
							(((BgL_ev_labelsz00_bglt) CREF(BgL_ez00_4079))->BgL_varsz00);
						if (NULLP(BgL_l1324z00_4103))
							{	/* Eval/evaluate_comp.scm 572 */
								BgL_envz00_4085 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 572 */
								obj_t BgL_head1326z00_4105;

								{	/* Eval/evaluate_comp.scm 572 */
									obj_t BgL_res5019z00_12470;

									BgL_res5019z00_12470 = MAKE_PAIR(BNIL, BNIL);
									BgL_head1326z00_4105 = BgL_res5019z00_12470;
								}
								{
									obj_t BgL_l1324z00_12504;
									obj_t BgL_tail1327z00_12505;

									BgL_l1324z00_12504 = BgL_l1324z00_4103;
									BgL_tail1327z00_12505 = BgL_head1326z00_4105;
								BgL_zc3anonymousza33256ze3z83_12503:
									if (NULLP(BgL_l1324z00_12504))
										{	/* Eval/evaluate_comp.scm 572 */
											BgL_envz00_4085 = CDR(BgL_head1326z00_4105);
										}
									else
										{	/* Eval/evaluate_comp.scm 572 */
											obj_t BgL_newtail1328z00_12512;

											{	/* Eval/evaluate_comp.scm 572 */
												obj_t BgL_arg3259z00_12513;

												{	/* Eval/evaluate_comp.scm 572 */
													obj_t BgL_vz00_12514;

													BgL_vz00_12514 = CAR(BgL_l1324z00_12504);
													BgL_arg3259z00_12513 =
														MAKE_PAIR(BgL_vz00_12514,
														BGl_symbol5712z00zz__evaluate_compz00);
												}
												{	/* Eval/evaluate_comp.scm 572 */
													obj_t BgL_res5025z00_12522;

													BgL_res5025z00_12522 =
														MAKE_PAIR(BgL_arg3259z00_12513, BNIL);
													BgL_newtail1328z00_12512 = BgL_res5025z00_12522;
												}
											}
											SET_CDR(BgL_tail1327z00_12505, BgL_newtail1328z00_12512);
											{
												obj_t BgL_tail1327z00_34721;
												obj_t BgL_l1324z00_34719;

												BgL_l1324z00_34719 = CDR(BgL_l1324z00_12504);
												BgL_tail1327z00_34721 = BgL_newtail1328z00_12512;
												BgL_tail1327z00_12505 = BgL_tail1327z00_34721;
												BgL_l1324z00_12504 = BgL_l1324z00_34719;
												goto BgL_zc3anonymousza33256ze3z83_12503;
											}
										}
								}
							}
					}
					((((BgL_ev_labelsz00_bglt) CREF(BgL_ez00_4079))->BgL_envz00) =
						((obj_t) BgL_envz00_4085), BUNSPEC);
					{	/* Eval/evaluate_comp.scm 575 */
						obj_t BgL_g1332z00_4087;

						BgL_g1332z00_4087 =
							(((BgL_ev_labelsz00_bglt) CREF(BgL_ez00_4079))->BgL_valsz00);
						{
							obj_t BgL_ll1329z00_4089;
							obj_t BgL_ll1330z00_4090;

							BgL_ll1329z00_4089 = BgL_envz00_4085;
							BgL_ll1330z00_4090 = BgL_g1332z00_4087;
						BgL_zc3anonymousza33244ze3z83_4091:
							if (NULLP(BgL_ll1329z00_4089))
								{	/* Eval/evaluate_comp.scm 575 */
									((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 575 */
									{	/* Eval/evaluate_comp.scm 577 */
										obj_t BgL_slotz00_4093;
										obj_t BgL_valz00_4094;

										BgL_slotz00_4093 = CAR(BgL_ll1329z00_4089);
										BgL_valz00_4094 = CAR(BgL_ll1330z00_4090);
										{	/* Eval/evaluate_comp.scm 578 */
											obj_t BgL_arg3246z00_4095;

											{	/* Eval/evaluate_comp.scm 578 */
												obj_t BgL_arg3249z00_4096;

												{	/* Eval/evaluate_comp.scm 578 */
													obj_t BgL_arg3250z00_4097;
													obj_t BgL_arg3251z00_4098;

													BgL_arg3250z00_4097 = CDR(BgL_valz00_4094);
													BgL_arg3251z00_4098 =
														BGl_appendzd221011zd2zz__evaluate_compz00
														(BgL_stkz00_4080, CAR(BgL_valz00_4094));
													BgL_arg3249z00_4096 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_arg3250z00_4097),
														BgL_arg3251z00_4098);
												}
												{	/* Eval/evaluate_comp.scm 567 */
													obj_t BgL_objz00_12534;

													BgL_objz00_12534 =
														BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00;
													PROCEDURE_ATTR_SET(BgL_arg3249z00_4096,
														BgL_objz00_12534);
													BgL_objz00_12534;
												}
												BgL_arg3246z00_4095 = BgL_arg3249z00_4096;
											}
											SET_CDR(BgL_slotz00_4093, BgL_arg3246z00_4095);
										}
									}
									{
										obj_t BgL_ll1330z00_34737;
										obj_t BgL_ll1329z00_34735;

										BgL_ll1329z00_34735 = CDR(BgL_ll1329z00_4089);
										BgL_ll1330z00_34737 = CDR(BgL_ll1330z00_4090);
										BgL_ll1330z00_4090 = BgL_ll1330z00_34737;
										BgL_ll1329z00_4089 = BgL_ll1329z00_34735;
										goto BgL_zc3anonymousza33244ze3z83_4091;
									}
								}
						}
					}
				}
				{	/* Eval/evaluate_comp.scm 582 */
					obj_t BgL_bodyz00_4116;

					BgL_bodyz00_4116 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_labelsz00_bglt) CREF(BgL_ez00_4079))->BgL_bodyz00),
						BgL_stkz00_4080);
					{	/* Eval/evaluate_comp.scm 583 */
						obj_t BgL_zc3anonymousza33260ze3z83_18448;

						BgL_zc3anonymousza33260ze3z83_18448 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33260ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza33260ze3z83_18448,
							(int) (((long) 0)), BgL_bodyz00_4116);
						return BgL_zc3anonymousza33260ze3z83_18448;
					}
				}
			}
		}
	}



/* &<anonymous:3260> */
	obj_t BGl_z62zc3anonymousza33260ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19467, obj_t BgL_sz00_19469)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 583 */
			{	/* Eval/evaluate_comp.scm 583 */
				obj_t BgL_bodyz00_19468;

				BgL_bodyz00_19468 = PROCEDURE_REF(BgL_envz00_19467, (int) (((long) 0)));
				{
					obj_t BgL_sz00_4117;

					BgL_sz00_4117 = BgL_sz00_19469;
					{	/* Eval/evaluate_comp.scm 583 */
						obj_t BgL_bpz00_12539;

						BgL_bpz00_12539 = VECTOR_REF(BgL_sz00_4117, (int) (((long) 0)));
						{
							obj_t BgL_fz00_12545;

							BgL_fz00_12545 = BgL_bodyz00_19468;
						BgL_recz00_12544:
							{	/* Eval/evaluate_comp.scm 590 */
								obj_t BgL_rz00_12546;

								BgL_rz00_12546 =
									PROCEDURE_ENTRY(BgL_fz00_12545) (BgL_fz00_12545,
									BgL_sz00_4117, BEOA);
								{	/* Eval/evaluate_comp.scm 592 */
									bool_t BgL_testz00_34755;

									if (PROCEDUREP(BgL_rz00_12546))
										{	/* Eval/evaluate_comp.scm 592 */
											obj_t BgL_arg1637z00_12549;

											BgL_arg1637z00_12549 = PROCEDURE_ATTR(BgL_rz00_12546);
											if (STRUCTP(BgL_arg1637z00_12549))
												{	/* Eval/evaluate_comp.scm 562 */
													BgL_testz00_34755 =
														(STRUCT_KEY(BgL_arg1637z00_12549) ==
														BGl_symbol5589z00zz__evaluate_compz00);
												}
											else
												{	/* Eval/evaluate_comp.scm 562 */
													BgL_testz00_34755 = ((bool_t) 0);
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 592 */
											BgL_testz00_34755 = ((bool_t) 0);
										}
									if (BgL_testz00_34755)
										{
											obj_t BgL_fz00_34763;

											BgL_fz00_34763 = BgL_rz00_12546;
											BgL_fz00_12545 = BgL_fz00_34763;
											goto BgL_recz00_12544;
										}
									else
										{	/* Eval/evaluate_comp.scm 592 */
											return BgL_rz00_12546;
										}
								}
							}
						}
					}
				}
			}
		}
	}



/* &comp-ev_synchronize1419 */
	obj_t BGl_z62compzd2ev_synchroniza7e1419z17zz__evaluate_compz00(obj_t
		BgL_envz00_19470, obj_t BgL_ez00_19471, obj_t BgL_stkz00_19472)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 545 */
			{
				BgL_ev_synchroniza7eza7_bglt BgL_ez00_4057;
				obj_t BgL_stkz00_4058;

				BgL_ez00_4057 = ((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_19471);
				BgL_stkz00_4058 = BgL_stkz00_19472;
				{	/* Eval/evaluate_comp.scm 547 */
					obj_t BgL_mutexz00_4062;
					obj_t BgL_prelockz00_4063;
					obj_t BgL_bodyz00_4064;

					BgL_mutexz00_4062 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_ez00_4057))->
							BgL_mutexz00), BgL_stkz00_4058);
					BgL_prelockz00_4063 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
								CREF(BgL_ez00_4057))->BgL_prelockz00), BgL_stkz00_4058);
					BgL_bodyz00_4064 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
								CREF(BgL_ez00_4057))->BgL_bodyz00), BgL_stkz00_4058);
					{	/* Eval/evaluate_comp.scm 550 */
						obj_t BgL_zc3anonymousza33237ze3z83_18450;

						BgL_zc3anonymousza33237ze3z83_18450 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33237ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3anonymousza33237ze3z83_18450,
							(int) (((long) 0)), BgL_mutexz00_4062);
						PROCEDURE_SET(BgL_zc3anonymousza33237ze3z83_18450,
							(int) (((long) 1)), ((obj_t) BgL_ez00_4057));
						PROCEDURE_SET(BgL_zc3anonymousza33237ze3z83_18450,
							(int) (((long) 2)), BgL_prelockz00_4063);
						PROCEDURE_SET(BgL_zc3anonymousza33237ze3z83_18450,
							(int) (((long) 3)), BgL_bodyz00_4064);
						return BgL_zc3anonymousza33237ze3z83_18450;
					}
				}
			}
		}
	}



/* &<anonymous:3237> */
	obj_t BGl_z62zc3anonymousza33237ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19473, obj_t BgL_sz00_19478)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 550 */
			{	/* Eval/evaluate_comp.scm 550 */
				obj_t BgL_mutexz00_19474;
				BgL_ev_synchroniza7eza7_bglt BgL_i1140z00_19475;
				obj_t BgL_prelockz00_19476;
				obj_t BgL_bodyz00_19477;

				BgL_mutexz00_19474 =
					PROCEDURE_REF(BgL_envz00_19473, (int) (((long) 0)));
				BgL_i1140z00_19475 =
					((BgL_ev_synchroniza7eza7_bglt)
					PROCEDURE_REF(BgL_envz00_19473, (int) (((long) 1))));
				BgL_prelockz00_19476 =
					PROCEDURE_REF(BgL_envz00_19473, (int) (((long) 2)));
				BgL_bodyz00_19477 = PROCEDURE_REF(BgL_envz00_19473, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4065;

					BgL_sz00_4065 = BgL_sz00_19478;
					{	/* Eval/evaluate_comp.scm 550 */
						obj_t BgL_bpz00_4067;

						BgL_bpz00_4067 = VECTOR_REF(BgL_sz00_4065, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 551 */
							obj_t BgL_mz00_4068;

							BgL_mz00_4068 =
								PROCEDURE_ENTRY(BgL_mutexz00_19474) (BgL_mutexz00_19474,
								BgL_sz00_4065, BEOA);
							{	/* Eval/evaluate_comp.scm 552 */
								bool_t BgL_testz00_34798;

								{	/* Eval/evaluate_comp.scm 552 */
									bool_t BgL_res5016z00_12458;

									BgL_res5016z00_12458 = BGL_MUTEXP(BgL_mz00_4068);
									BgL_testz00_34798 = BgL_res5016z00_12458;
								}
								if (BgL_testz00_34798)
									{	/* Eval/evaluate_comp.scm 553 */
										obj_t BgL_pz00_4070;

										BgL_pz00_4070 =
											PROCEDURE_ENTRY(BgL_prelockz00_19476)
											(BgL_prelockz00_19476, BgL_sz00_4065, BEOA);
										{	/* Eval/evaluate_comp.scm 555 */
											obj_t BgL_za2za2resza2za2z00_4072;

											if (PAIRP(BgL_pz00_4070))
												{	/* Eval/evaluate_comp.scm 556 */
													obj_t BgL_top5849z00_34807;

													BgL_top5849z00_34807 = BGL_EXITD_TOP_AS_OBJ();
													BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_4068, BgL_pz00_4070);
													BGL_EXITD_PUSH_PROTECT(BgL_top5849z00_34807,
														BgL_mz00_4068);
													BUNSPEC;
													{	/* Eval/evaluate_comp.scm 556 */
														obj_t BgL_tmp5848z00_34806;

														BgL_tmp5848z00_34806 =
															PROCEDURE_ENTRY(BgL_bodyz00_19477)
															(BgL_bodyz00_19477, BgL_sz00_4065, BEOA);
														BGL_EXITD_POP_PROTECT(BgL_top5849z00_34807);
														BUNSPEC;
														BGL_MUTEX_UNLOCK(BgL_mz00_4068);
														BgL_za2za2resza2za2z00_4072 = BgL_tmp5848z00_34806;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 557 */
													obj_t BgL_top5851z00_34818;

													BgL_top5851z00_34818 = BGL_EXITD_TOP_AS_OBJ();
													BGL_MUTEX_LOCK(BgL_mz00_4068);
													BGL_EXITD_PUSH_PROTECT(BgL_top5851z00_34818,
														BgL_mz00_4068);
													BUNSPEC;
													{	/* Eval/evaluate_comp.scm 557 */
														obj_t BgL_tmp5850z00_34817;

														BgL_tmp5850z00_34817 =
															PROCEDURE_ENTRY(BgL_bodyz00_19477)
															(BgL_bodyz00_19477, BgL_sz00_4065, BEOA);
														BGL_EXITD_POP_PROTECT(BgL_top5851z00_34818);
														BUNSPEC;
														BGL_MUTEX_UNLOCK(BgL_mz00_4068);
														BgL_za2za2resza2za2z00_4072 = BgL_tmp5850z00_34817;
													}
												}
											VECTOR_SET(BgL_sz00_4065,
												(int) (((long) 0)), BgL_bpz00_4067);
											return BgL_za2za2resza2za2z00_4072;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 552 */
										return
											BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_string5714z00zz__evaluate_compz00,
											BGl_string5715z00zz__evaluate_compz00, BgL_mz00_4068,
											(((BgL_ev_synchroniza7eza7_bglt)
													CREF(BgL_i1140z00_19475))->BgL_locz00));
									}
							}
						}
					}
				}
			}
		}
	}



/* &comp-ev_with-handler1417 */
	obj_t BGl_z62compzd2ev_withzd2handler1417z62zz__evaluate_compz00(obj_t
		BgL_envz00_19479, obj_t BgL_ez00_19480, obj_t BgL_stkz00_19481)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 536 */
			{
				BgL_ev_withzd2handlerzd2_bglt BgL_ez00_4021;
				obj_t BgL_stkz00_4022;

				BgL_ez00_4021 = ((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_19480);
				BgL_stkz00_4022 = BgL_stkz00_19481;
				{	/* Eval/evaluate_comp.scm 538 */
					obj_t BgL_handlerz00_4026;
					obj_t BgL_bodyz00_4027;

					BgL_handlerz00_4026 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_ez00_4021))->
							BgL_handlerz00), BgL_stkz00_4022);
					BgL_bodyz00_4027 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_withzd2handlerzd2_bglt)
								CREF(BgL_ez00_4021))->BgL_bodyz00), BgL_stkz00_4022);
					{	/* Eval/evaluate_comp.scm 539 */
						obj_t BgL_zc3anonymousza33227ze3z83_18454;

						BgL_zc3anonymousza33227ze3z83_18454 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33227ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza33227ze3z83_18454,
							(int) (((long) 0)), BgL_handlerz00_4026);
						PROCEDURE_SET(BgL_zc3anonymousza33227ze3z83_18454,
							(int) (((long) 1)), BgL_bodyz00_4027);
						return BgL_zc3anonymousza33227ze3z83_18454;
					}
				}
			}
		}
	}



/* &<anonymous:3227> */
	obj_t BGl_z62zc3anonymousza33227ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19482, obj_t BgL_sz00_19485)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 539 */
			{	/* Eval/evaluate_comp.scm 539 */
				obj_t BgL_handlerz00_19483;
				obj_t BgL_bodyz00_19484;

				BgL_handlerz00_19483 =
					PROCEDURE_REF(BgL_envz00_19482, (int) (((long) 0)));
				BgL_bodyz00_19484 = PROCEDURE_REF(BgL_envz00_19482, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4028;

					BgL_sz00_4028 = BgL_sz00_19485;
					{	/* Eval/evaluate_comp.scm 539 */
						obj_t BgL_bpz00_4030;

						BgL_bpz00_4030 = VECTOR_REF(BgL_sz00_4028, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 540 */
							obj_t BgL_hz00_4031;

							BgL_hz00_4031 =
								PROCEDURE_ENTRY(BgL_handlerz00_19483) (BgL_handlerz00_19483,
								BgL_sz00_4028, BEOA);
							{	/* Eval/evaluate_comp.scm 542 */
								obj_t BgL_za2za2resza2za2z00_4033;

								{	/* Eval/evaluate_comp.scm 542 */
									obj_t BgL_res1130z00_4034;

									BgL_res1130z00_4034 = MAKE_CELL(BUNSPEC);
									if (CBOOL(BGl_zc3exitza33229ze3z83zz__evaluate_compz00
											(BgL_sz00_4028, BgL_bodyz00_19484, BgL_res1130z00_4034)))
										{	/* Eval/evaluate_comp.scm 542 */
											BgL_za2za2resza2za2z00_4033 =
												PROCEDURE_ENTRY(BgL_hz00_4031) (BgL_hz00_4031,
												CELL_REF(BgL_res1130z00_4034), BEOA);
										}
									else
										{	/* Eval/evaluate_comp.scm 542 */
											BgL_za2za2resza2za2z00_4033 =
												CELL_REF(BgL_res1130z00_4034);
										}
								}
								VECTOR_SET(BgL_sz00_4028, (int) (((long) 0)), BgL_bpz00_4030);
								return BgL_za2za2resza2za2z00_4033;
							}
						}
					}
				}
			}
		}
	}



/* <exit:3229> */
	obj_t BGl_zc3exitza33229ze3z83zz__evaluate_compz00(obj_t BgL_sz00_19667,
		obj_t BgL_bodyz00_19666, obj_t BgL_res1130z00_19665)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 542 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1133z00_4038;

			if (SET_EXIT(BgL_an_exit1133z00_4038))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1133z00_4038 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 542 */

						PUSH_EXIT(BgL_an_exit1133z00_4038, ((long) 1));
						{	/* Eval/evaluate_comp.scm 542 */
							obj_t BgL_an_exitd1134z00_4039;

							BgL_an_exitd1134z00_4039 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 542 */
								bool_t BgL_res1136z00_4042;

								{	/* Eval/evaluate_comp.scm 542 */
									obj_t BgL_ohs1128z00_4043;

									BgL_ohs1128z00_4043 = BGL_ERROR_HANDLER_GET();
									{	/* Eval/evaluate_comp.scm 542 */
										obj_t BgL_exitd1137z00_4044;

										BgL_exitd1137z00_4044 = ((obj_t) (&exitd));
										{
											obj_t BgL_zc3anonymousza33234ze3z83_18452;

											BgL_zc3anonymousza33234ze3z83_18452 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza33234ze3ze1zz__evaluate_compz00,
												(int) (((long) 0)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3anonymousza33234ze3z83_18452,
												(int) (((long) 0)), BgL_ohs1128z00_4043);
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_exitd1137z00_4044,
												BgL_zc3anonymousza33234ze3z83_18452);
											{	/* Eval/evaluate_comp.scm 542 */
												bool_t BgL_tmp1139z00_4046;

												{	/* Eval/evaluate_comp.scm 542 */
													obj_t BgL_arg3230z00_4047;

													{	/* Eval/evaluate_comp.scm 542 */
														obj_t BgL_zc3anonymousza33233ze3z83_18453;

														BgL_zc3anonymousza33233ze3z83_18453 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3anonymousza33233ze3ze1zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET(BgL_zc3anonymousza33233ze3z83_18453,
															(int) (((long) 0)), BgL_res1130z00_19665);
														PROCEDURE_SET(BgL_zc3anonymousza33233ze3z83_18453,
															(int) (((long) 1)), BgL_an_exitd1134z00_4039);
														BgL_arg3230z00_4047 =
															MAKE_PAIR(BgL_zc3anonymousza33233ze3z83_18453,
															BgL_ohs1128z00_4043);
													}
													BGL_ERROR_HANDLER_SET(BgL_arg3230z00_4047);
													BUNSPEC;
												}
												{	/* Eval/evaluate_comp.scm 542 */
													obj_t BgL_auxz00_19486;

													BgL_auxz00_19486 =
														PROCEDURE_ENTRY(BgL_bodyz00_19666)
														(BgL_bodyz00_19666, BgL_sz00_19667, BEOA);
													CELL_SET(BgL_res1130z00_19665, BgL_auxz00_19486);
												}
												BgL_tmp1139z00_4046 = ((bool_t) 0);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_exitd1137z00_4044);
												BGL_ERROR_HANDLER_SET(BgL_ohs1128z00_4043);
												BUNSPEC;
												BgL_res1136z00_4042 = BgL_tmp1139z00_4046;
								}}}}
								POP_EXIT();
								return BBOOL(BgL_res1136z00_4042);
							}
						}
					}
				}
		}
	}



/* &<anonymous:3233> */
	obj_t BGl_z62zc3anonymousza33233ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19487, obj_t BgL_ez00_19490)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 542 */
			{	/* Eval/evaluate_comp.scm 542 */
				obj_t BgL_res1130z00_19488;
				obj_t BgL_an_exitd1134z00_19489;

				BgL_res1130z00_19488 =
					PROCEDURE_REF(BgL_envz00_19487, (int) (((long) 0)));
				BgL_an_exitd1134z00_19489 =
					PROCEDURE_REF(BgL_envz00_19487, (int) (((long) 1)));
				{
					obj_t BgL_ez00_4049;

					BgL_ez00_4049 = BgL_ez00_19490;
					CELL_SET(BgL_res1130z00_19488, BgL_ez00_4049);
					return
						BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1134z00_19489,
						BTRUE);
				}
			}
		}
	}



/* &<anonymous:3234> */
	obj_t BGl_z62zc3anonymousza33234ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19492)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 542 */
			{
				obj_t BgL_ohs1128z00_19493;

				BgL_ohs1128z00_19493 =
					PROCEDURE_REF(BgL_envz00_19492, (int) (((long) 0)));
				{

					BGL_ERROR_HANDLER_SET(BgL_ohs1128z00_19493);
					return BUNSPEC;
				}
			}
		}
	}



/* &comp-ev_unwind-prote1415 */
	obj_t BGl_z62compzd2ev_unwindzd2prote1415z62zz__evaluate_compz00(obj_t
		BgL_envz00_19494, obj_t BgL_ez00_19495, obj_t BgL_stkz00_19496)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 527 */
			{
				BgL_ev_unwindzd2protectzd2_bglt BgL_ez00_4002;
				obj_t BgL_stkz00_4003;

				BgL_ez00_4002 = ((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_19495);
				BgL_stkz00_4003 = BgL_stkz00_19496;
				{	/* Eval/evaluate_comp.scm 529 */
					obj_t BgL_ez00_4007;
					obj_t BgL_bodyz00_4008;

					BgL_ez00_4007 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_ez00_4002))->BgL_ez00),
						BgL_stkz00_4003);
					BgL_bodyz00_4008 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_unwindzd2protectzd2_bglt)
								CREF(BgL_ez00_4002))->BgL_bodyz00), BgL_stkz00_4003);
					{	/* Eval/evaluate_comp.scm 530 */
						obj_t BgL_zc3anonymousza33223ze3z83_18457;

						BgL_zc3anonymousza33223ze3z83_18457 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33223ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza33223ze3z83_18457,
							(int) (((long) 0)), BgL_bodyz00_4008);
						PROCEDURE_SET(BgL_zc3anonymousza33223ze3z83_18457,
							(int) (((long) 1)), BgL_ez00_4007);
						return BgL_zc3anonymousza33223ze3z83_18457;
					}
				}
			}
		}
	}



/* &<anonymous:3223> */
	obj_t BGl_z62zc3anonymousza33223ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19497, obj_t BgL_sz00_19500)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 530 */
			{	/* Eval/evaluate_comp.scm 530 */
				obj_t BgL_bodyz00_19498;
				obj_t BgL_ez00_19499;

				BgL_bodyz00_19498 = PROCEDURE_REF(BgL_envz00_19497, (int) (((long) 0)));
				BgL_ez00_19499 = PROCEDURE_REF(BgL_envz00_19497, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4009;

					BgL_sz00_4009 = BgL_sz00_19500;
					{	/* Eval/evaluate_comp.scm 530 */
						obj_t BgL_bpz00_4011;

						BgL_bpz00_4011 = VECTOR_REF(BgL_sz00_4009, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 532 */
							obj_t BgL_exitd1124z00_4013;

							BgL_exitd1124z00_4013 = BGL_EXITD_TOP_AS_OBJ();
							{	/* Eval/evaluate_comp.scm 533 */
								obj_t BgL_zc3anonymousza33224ze3z83_18456;

								BgL_zc3anonymousza33224ze3z83_18456 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza33224ze3ze1zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3anonymousza33224ze3z83_18456,
									(int) (((long) 0)), BgL_sz00_4009);
								PROCEDURE_SET(BgL_zc3anonymousza33224ze3z83_18456,
									(int) (((long) 1)), BgL_bpz00_4011);
								PROCEDURE_SET(BgL_zc3anonymousza33224ze3z83_18456,
									(int) (((long) 2)), BgL_bodyz00_19498);
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
									(BgL_exitd1124z00_4013, BgL_zc3anonymousza33224ze3z83_18456);
								{	/* Eval/evaluate_comp.scm 532 */
									obj_t BgL_tmp1126z00_4015;

									BgL_tmp1126z00_4015 =
										PROCEDURE_ENTRY(BgL_ez00_19499) (BgL_ez00_19499,
										BgL_sz00_4009, BEOA);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00
										(BgL_exitd1124z00_4013);
									VECTOR_SET(BgL_sz00_4009, (int) (((long) 0)), BgL_bpz00_4011);
									PROCEDURE_ENTRY(BgL_bodyz00_19498) (BgL_bodyz00_19498,
										BgL_sz00_4009, BEOA);
									return BgL_tmp1126z00_4015;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3224> */
	obj_t BGl_z62zc3anonymousza33224ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19501)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 532 */
			{	/* Eval/evaluate_comp.scm 533 */
				obj_t BgL_sz00_19502;
				obj_t BgL_savedzd2bpzd2_19503;
				obj_t BgL_bodyz00_19504;

				BgL_sz00_19502 = PROCEDURE_REF(BgL_envz00_19501, (int) (((long) 0)));
				BgL_savedzd2bpzd2_19503 =
					PROCEDURE_REF(BgL_envz00_19501, (int) (((long) 1)));
				BgL_bodyz00_19504 = PROCEDURE_REF(BgL_envz00_19501, (int) (((long) 2)));
				{

					VECTOR_SET(BgL_sz00_19502,
						(int) (((long) 0)), BgL_savedzd2bpzd2_19503);
					return
						PROCEDURE_ENTRY(BgL_bodyz00_19504) (BgL_bodyz00_19504,
						BgL_sz00_19502, BEOA);
				}
			}
		}
	}



/* &comp-ev_bind-exit1412 */
	obj_t BGl_z62compzd2ev_bindzd2exit1412z62zz__evaluate_compz00(obj_t
		BgL_envz00_19505, obj_t BgL_ez00_19506, obj_t BgL_stkz00_19507)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 516 */
			{
				BgL_ev_bindzd2exitzd2_bglt BgL_ez00_3975;
				obj_t BgL_stkz00_3976;

				BgL_ez00_3975 = ((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_19506);
				BgL_stkz00_3976 = BgL_stkz00_19507;
				{	/* Eval/evaluate_comp.scm 518 */
					long BgL_siza7eza7_3980;
					obj_t BgL_nstkz00_3981;

					BgL_siza7eza7_3980 = bgl_list_length(BgL_stkz00_3976);
					{	/* Eval/evaluate_comp.scm 518 */
						obj_t BgL_arg3221z00_3999;

						{	/* Eval/evaluate_comp.scm 518 */
							BgL_ev_varz00_bglt BgL_arg3222z00_4000;

							BgL_arg3222z00_4000 =
								(((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_ez00_3975))->
								BgL_varz00);
							BgL_arg3221z00_3999 =
								MAKE_PAIR(((obj_t) BgL_arg3222z00_4000), BNIL);
						}
						BgL_nstkz00_3981 =
							BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_3976,
							BgL_arg3221z00_3999);
					}
					{	/* Eval/evaluate_comp.scm 519 */
						obj_t BgL_bodyz00_3982;
						obj_t BgL_effzf3zf3_3983;

						BgL_bodyz00_3982 =
							BGl_compz00zz__evaluate_compz00(
							(((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_ez00_3975))->BgL_bodyz00),
							BgL_nstkz00_3981);
						BgL_effzf3zf3_3983 =
							(((BgL_ev_varz00_bglt) CREF((((BgL_ev_bindzd2exitzd2_bglt)
											CREF(BgL_ez00_3975))->BgL_varz00)))->BgL_effz00);
						{	/* Eval/evaluate_comp.scm 520 */
							obj_t BgL_zc3anonymousza33216ze3z83_18460;

							BgL_zc3anonymousza33216ze3z83_18460 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza33216ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3anonymousza33216ze3z83_18460,
								(int) (((long) 0)), BINT(BgL_siza7eza7_3980));
							PROCEDURE_SET(BgL_zc3anonymousza33216ze3z83_18460,
								(int) (((long) 1)), BgL_effzf3zf3_3983);
							PROCEDURE_SET(BgL_zc3anonymousza33216ze3z83_18460,
								(int) (((long) 2)), BgL_bodyz00_3982);
							return BgL_zc3anonymousza33216ze3z83_18460;
						}
					}
				}
			}
		}
	}



/* &<anonymous:3216> */
	obj_t BGl_z62zc3anonymousza33216ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19508, obj_t BgL_sz00_19512)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 520 */
			{	/* Eval/evaluate_comp.scm 520 */
				long BgL_siza7eza7_19509;
				obj_t BgL_effzf3zf3_19510;
				obj_t BgL_bodyz00_19511;

				BgL_siza7eza7_19509 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19508, (int) (((long) 0))));
				BgL_effzf3zf3_19510 =
					PROCEDURE_REF(BgL_envz00_19508, (int) (((long) 1)));
				BgL_bodyz00_19511 = PROCEDURE_REF(BgL_envz00_19508, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3984;

					BgL_sz00_3984 = BgL_sz00_19512;
					{	/* Eval/evaluate_comp.scm 520 */
						obj_t BgL_bpz00_3986;

						BgL_bpz00_3986 = VECTOR_REF(BgL_sz00_3984, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 522 */
							obj_t BgL_za2za2resza2za2z00_3988;

							BgL_za2za2resza2za2z00_3988 =
								BGl_zc3exitza33217ze3z83zz__evaluate_compz00(BgL_bodyz00_19511,
								BgL_sz00_3984, BgL_effzf3zf3_19510, BgL_siza7eza7_19509,
								BgL_bpz00_3986);
							VECTOR_SET(BgL_sz00_3984, (int) (((long) 0)), BgL_bpz00_3986);
							return BgL_za2za2resza2za2z00_3988;
						}
					}
				}
			}
		}
	}



/* <exit:3217> */
	obj_t BGl_zc3exitza33217ze3z83zz__evaluate_compz00(obj_t BgL_bodyz00_19664,
		obj_t BgL_sz00_19663, obj_t BgL_effzf3zf3_19662, long BgL_siza7eza7_19661,
		obj_t BgL_bpz00_19660)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 522 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1119z00_3990;

			if (SET_EXIT(BgL_an_exit1119z00_3990))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1119z00_3990 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 522 */

						PUSH_EXIT(BgL_an_exit1119z00_3990, ((long) 1));
						{	/* Eval/evaluate_comp.scm 522 */
							obj_t BgL_an_exitd1120z00_3991;

							BgL_an_exitd1120z00_3991 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 522 */
								obj_t BgL_exitz00_18459;

								BgL_exitz00_18459 =
									MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_exitz00_18459,
									(int) (((long) 0)), BgL_an_exitd1120z00_3991);
								{	/* Eval/evaluate_comp.scm 523 */
									obj_t BgL_res1122z00_3994;

									{	/* Eval/evaluate_comp.scm 523 */
										long BgL_arg3218z00_3995;
										obj_t BgL_arg3219z00_3996;

										BgL_arg3218z00_3995 =
											((long) CINT(BgL_bpz00_19660) + BgL_siza7eza7_19661);
										if (CBOOL(BgL_effzf3zf3_19662))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_12431;

												BgL_newz00_12431 =
													create_struct(BGl_symbol5605z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_auxz00_34996;

													BgL_auxz00_34996 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12431, BgL_auxz00_34996,
														BgL_exitz00_18459);
												}
												BgL_arg3219z00_3996 = BgL_newz00_12431;
											}
										else
											{	/* Eval/evaluate_comp.scm 523 */
												BgL_arg3219z00_3996 = BgL_exitz00_18459;
											}
										VECTOR_SET(BgL_sz00_19663,
											(int) (BgL_arg3218z00_3995), BgL_arg3219z00_3996);
									}
									BgL_res1122z00_3994 =
										PROCEDURE_ENTRY(BgL_bodyz00_19664) (BgL_bodyz00_19664,
										BgL_sz00_19663, BEOA);
									POP_EXIT();
									return BgL_res1122z00_3994;
								}
							}
						}
					}
				}
		}
	}



/* &exit */
	obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_19513,
		obj_t BgL_val1121z00_19515)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 522 */
			{	/* Eval/evaluate_comp.scm 522 */
				obj_t BgL_an_exitd1120z00_19514;

				BgL_an_exitd1120z00_19514 =
					PROCEDURE_REF(BgL_envz00_19513, (int) (((long) 0)));
				{
					obj_t BgL_val1121z00_3992;

					BgL_val1121z00_3992 = BgL_val1121z00_19515;
					return
						BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1120z00_19514,
						BgL_val1121z00_3992);
				}
			}
		}
	}



/* &comp-ev_letrec1409 */
	obj_t BGl_z62compzd2ev_letrec1409zb0zz__evaluate_compz00(obj_t
		BgL_envz00_19516, obj_t BgL_ez00_19517, obj_t BgL_stkz00_19518)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 487 */
			{
				BgL_ev_letrecz00_bglt BgL_ez00_3876;
				obj_t BgL_stkz00_3877;

				BgL_ez00_3876 = ((BgL_ev_letrecz00_bglt) BgL_ez00_19517);
				BgL_stkz00_3877 = BgL_stkz00_19518;
				{	/* Eval/evaluate_comp.scm 489 */
					long BgL_siza7eza7_3881;
					obj_t BgL_nstkz00_3882;

					BgL_siza7eza7_3881 = bgl_list_length(BgL_stkz00_3877);
					{	/* Eval/evaluate_comp.scm 489 */
						obj_t BgL_arg3215z00_3973;

						BgL_arg3215z00_3973 =
							(((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_ez00_3876)))->BgL_varsz00);
						BgL_nstkz00_3882 =
							BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_3877,
							BgL_arg3215z00_3973);
					}
					{	/* Eval/evaluate_comp.scm 490 */
						obj_t BgL_cvalsz00_3883;
						obj_t BgL_bodyz00_3884;

						{	/* Eval/evaluate_comp.scm 490 */
							obj_t BgL_l1310z00_3959;

							BgL_l1310z00_3959 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_3876)))->BgL_valsz00);
							if (NULLP(BgL_l1310z00_3959))
								{	/* Eval/evaluate_comp.scm 490 */
									BgL_cvalsz00_3883 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 490 */
									obj_t BgL_head1312z00_3961;

									{	/* Eval/evaluate_comp.scm 490 */
										obj_t BgL_res4975z00_12071;

										BgL_res4975z00_12071 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1312z00_3961 = BgL_res4975z00_12071;
									}
									{
										obj_t BgL_l1310z00_12105;
										obj_t BgL_tail1313z00_12106;

										BgL_l1310z00_12105 = BgL_l1310z00_3959;
										BgL_tail1313z00_12106 = BgL_head1312z00_3961;
									BgL_zc3anonymousza33199ze3z83_12104:
										if (NULLP(BgL_l1310z00_12105))
											{	/* Eval/evaluate_comp.scm 490 */
												BgL_cvalsz00_3883 = CDR(BgL_head1312z00_3961);
											}
										else
											{	/* Eval/evaluate_comp.scm 490 */
												obj_t BgL_newtail1314z00_12113;

												{	/* Eval/evaluate_comp.scm 490 */
													obj_t BgL_arg3213z00_12114;

													{	/* Eval/evaluate_comp.scm 490 */
														obj_t BgL_vz00_12115;

														BgL_vz00_12115 = CAR(BgL_l1310z00_12105);
														BgL_arg3213z00_12114 =
															BGl_compz00zz__evaluate_compz00(
															((BgL_ev_exprz00_bglt) BgL_vz00_12115),
															BgL_nstkz00_3882);
													}
													{	/* Eval/evaluate_comp.scm 490 */
														obj_t BgL_res4981z00_12123;

														BgL_res4981z00_12123 =
															MAKE_PAIR(BgL_arg3213z00_12114, BNIL);
														BgL_newtail1314z00_12113 = BgL_res4981z00_12123;
													}
												}
												SET_CDR(BgL_tail1313z00_12106,
													BgL_newtail1314z00_12113);
												{
													obj_t BgL_tail1313z00_35028;
													obj_t BgL_l1310z00_35026;

													BgL_l1310z00_35026 = CDR(BgL_l1310z00_12105);
													BgL_tail1313z00_35028 = BgL_newtail1314z00_12113;
													BgL_tail1313z00_12106 = BgL_tail1313z00_35028;
													BgL_l1310z00_12105 = BgL_l1310z00_35026;
													goto BgL_zc3anonymousza33199ze3z83_12104;
												}
											}
									}
								}
						}
						{	/* Eval/evaluate_comp.scm 491 */
							BgL_ev_exprz00_bglt BgL_arg3214z00_3972;

							BgL_arg3214z00_3972 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_3876)))->BgL_bodyz00);
							BgL_bodyz00_3884 =
								BGl_compz00zz__evaluate_compz00(BgL_arg3214z00_3972,
								BgL_nstkz00_3882);
						}
						{	/* Eval/evaluate_comp.scm 492 */
							bool_t BgL_testz00_35032;

							{
								obj_t BgL_l1315z00_3951;

								BgL_l1315z00_3951 =
									(((BgL_ev_binderz00_bglt) CREF(
											((BgL_ev_binderz00_bglt) BgL_ez00_3876)))->BgL_valsz00);
							BgL_zc3anonymousza33188ze3z83_3952:
								if (NULLP(BgL_l1315z00_3951))
									{	/* Eval/evaluate_comp.scm 492 */
										BgL_testz00_35032 = ((bool_t) 1);
									}
								else
									{	/* Eval/evaluate_comp.scm 492 */
										bool_t BgL_testz00_35035;

										{	/* Eval/evaluate_comp.scm 492 */
											obj_t BgL_vz00_3957;

											BgL_vz00_3957 = CAR(BgL_l1315z00_3951);
											BgL_testz00_35035 =
												BGl_isazf3zf3zz__objectz00(BgL_vz00_3957,
												BGl_ev_absz00zz__evaluate_typesz00);
										}
										if (BgL_testz00_35035)
											{
												obj_t BgL_l1315z00_35038;

												BgL_l1315z00_35038 = CDR(BgL_l1315z00_3951);
												BgL_l1315z00_3951 = BgL_l1315z00_35038;
												goto BgL_zc3anonymousza33188ze3z83_3952;
											}
										else
											{	/* Eval/evaluate_comp.scm 492 */
												BgL_testz00_35032 = ((bool_t) 0);
											}
									}
							}
							if (BgL_testz00_35032)
								{	/* Eval/evaluate_comp.scm 493 */
									obj_t BgL_zc3anonymousza33152ze3z83_18463;

									BgL_zc3anonymousza33152ze3z83_18463 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza33152ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 3)));
									PROCEDURE_SET(BgL_zc3anonymousza33152ze3z83_18463,
										(int) (((long) 0)), BINT(BgL_siza7eza7_3881));
									PROCEDURE_SET(BgL_zc3anonymousza33152ze3z83_18463,
										(int) (((long) 1)), BgL_cvalsz00_3883);
									PROCEDURE_SET(BgL_zc3anonymousza33152ze3z83_18463,
										(int) (((long) 2)), BgL_bodyz00_3884);
									return BgL_zc3anonymousza33152ze3z83_18463;
								}
							else
								{	/* Eval/evaluate_comp.scm 503 */
									obj_t BgL_zc3anonymousza33169ze3z83_18462;

									BgL_zc3anonymousza33169ze3z83_18462 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza33169ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 3)));
									PROCEDURE_SET(BgL_zc3anonymousza33169ze3z83_18462,
										(int) (((long) 0)), BINT(BgL_siza7eza7_3881));
									PROCEDURE_SET(BgL_zc3anonymousza33169ze3z83_18462,
										(int) (((long) 1)), BgL_cvalsz00_3883);
									PROCEDURE_SET(BgL_zc3anonymousza33169ze3z83_18462,
										(int) (((long) 2)), BgL_bodyz00_3884);
									return BgL_zc3anonymousza33169ze3z83_18462;
								}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3152> */
	obj_t BGl_z62zc3anonymousza33152ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19519, obj_t BgL_sz00_19523)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 493 */
			{	/* Eval/evaluate_comp.scm 493 */
				long BgL_siza7eza7_19520;
				obj_t BgL_cvalsz00_19521;
				obj_t BgL_bodyz00_19522;

				BgL_siza7eza7_19520 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19519, (int) (((long) 0))));
				BgL_cvalsz00_19521 =
					PROCEDURE_REF(BgL_envz00_19519, (int) (((long) 1)));
				BgL_bodyz00_19522 = PROCEDURE_REF(BgL_envz00_19519, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3886;

					BgL_sz00_3886 = BgL_sz00_19523;
					{	/* Eval/evaluate_comp.scm 493 */
						obj_t BgL_bpz00_3888;

						BgL_bpz00_3888 = VECTOR_REF(BgL_sz00_3886, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 494 */
							long BgL_g1113z00_3889;

							BgL_g1113z00_3889 =
								((long) CINT(BgL_bpz00_3888) + BgL_siza7eza7_19520);
							{
								obj_t BgL_lz00_12179;
								long BgL_iz00_12180;

								BgL_lz00_12179 = BgL_cvalsz00_19521;
								BgL_iz00_12180 = BgL_g1113z00_3889;
							BgL_recz00_12178:
								if (NULLP(BgL_lz00_12179))
									{	/* Eval/evaluate_comp.scm 495 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 495 */
										{	/* Eval/evaluate_comp.scm 496 */
											obj_t BgL_arg3156z00_12186;

											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_12192;

												BgL_newz00_12192 =
													create_struct(BGl_symbol5605z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_auxz00_35078;

													BgL_auxz00_35078 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12192, BgL_auxz00_35078,
														BUNSPEC);
												}
												BgL_arg3156z00_12186 = BgL_newz00_12192;
											}
											VECTOR_SET(BgL_sz00_3886,
												(int) (BgL_iz00_12180), BgL_arg3156z00_12186);
										}
										{
											long BgL_iz00_35085;
											obj_t BgL_lz00_35083;

											BgL_lz00_35083 = CDR(BgL_lz00_12179);
											BgL_iz00_35085 = (BgL_iz00_12180 + ((long) 1));
											BgL_iz00_12180 = BgL_iz00_35085;
											BgL_lz00_12179 = BgL_lz00_35083;
											goto BgL_recz00_12178;
										}
									}
							}
						}
						{	/* Eval/evaluate_comp.scm 498 */
							long BgL_g1114z00_3899;

							BgL_g1114z00_3899 =
								((long) CINT(BgL_bpz00_3888) + BgL_siza7eza7_19520);
							{
								obj_t BgL_lz00_3901;
								long BgL_iz00_3902;

								BgL_lz00_3901 = BgL_cvalsz00_19521;
								BgL_iz00_3902 = BgL_g1114z00_3899;
							BgL_zc3anonymousza33160ze3z83_3903:
								if (NULLP(BgL_lz00_3901))
									{	/* Eval/evaluate_comp.scm 499 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 499 */
										{	/* Eval/evaluate_comp.scm 500 */
											obj_t BgL_arg3162z00_3905;
											obj_t BgL_arg3163z00_3906;

											BgL_arg3162z00_3905 =
												VECTOR_REF(BgL_sz00_3886, (int) (BgL_iz00_3902));
											{	/* Eval/evaluate_comp.scm 500 */
												obj_t BgL_fun3164z00_3907;

												BgL_fun3164z00_3907 = CAR(BgL_lz00_3901);
												BgL_arg3163z00_3906 =
													PROCEDURE_ENTRY(BgL_fun3164z00_3907)
													(BgL_fun3164z00_3907, BgL_sz00_3886, BEOA);
											}
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_auxz00_35098;

												BgL_auxz00_35098 = (int) (((long) 0));
												STRUCT_SET(BgL_arg3162z00_3905, BgL_auxz00_35098,
													BgL_arg3163z00_3906);
										}}
										{
											long BgL_iz00_35103;
											obj_t BgL_lz00_35101;

											BgL_lz00_35101 = CDR(BgL_lz00_3901);
											BgL_iz00_35103 = (BgL_iz00_3902 + ((long) 1));
											BgL_iz00_3902 = BgL_iz00_35103;
											BgL_lz00_3901 = BgL_lz00_35101;
											goto BgL_zc3anonymousza33160ze3z83_3903;
										}
									}
							}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_19522) (BgL_bodyz00_19522,
							BgL_sz00_3886, BEOA);
					}
				}
			}
		}
	}



/* &<anonymous:3169> */
	obj_t BGl_z62zc3anonymousza33169ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19524, obj_t BgL_sz00_19528)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 503 */
			{	/* Eval/evaluate_comp.scm 503 */
				long BgL_siza7eza7_19525;
				obj_t BgL_cvalsz00_19526;
				obj_t BgL_bodyz00_19527;

				BgL_siza7eza7_19525 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19524, (int) (((long) 0))));
				BgL_cvalsz00_19526 =
					PROCEDURE_REF(BgL_envz00_19524, (int) (((long) 1)));
				BgL_bodyz00_19527 = PROCEDURE_REF(BgL_envz00_19524, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3911;

					BgL_sz00_3911 = BgL_sz00_19528;
					{	/* Eval/evaluate_comp.scm 503 */
						obj_t BgL_bpz00_3913;

						BgL_bpz00_3913 = VECTOR_REF(BgL_sz00_3911, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 504 */
							long BgL_g1115z00_3914;

							BgL_g1115z00_3914 =
								((long) CINT(BgL_bpz00_3913) + BgL_siza7eza7_19525);
							{
								obj_t BgL_lz00_12270;
								long BgL_iz00_12271;

								BgL_lz00_12270 = BgL_cvalsz00_19526;
								BgL_iz00_12271 = BgL_g1115z00_3914;
							BgL_recz00_12269:
								if (NULLP(BgL_lz00_12270))
									{	/* Eval/evaluate_comp.scm 505 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 505 */
										{	/* Eval/evaluate_comp.scm 506 */
											obj_t BgL_arg3172z00_12277;

											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_12283;

												BgL_newz00_12283 =
													create_struct(BGl_symbol5605z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_auxz00_35124;

													BgL_auxz00_35124 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12283, BgL_auxz00_35124,
														BUNSPEC);
												}
												BgL_arg3172z00_12277 = BgL_newz00_12283;
											}
											VECTOR_SET(BgL_sz00_3911,
												(int) (BgL_iz00_12271), BgL_arg3172z00_12277);
										}
										{
											long BgL_iz00_35131;
											obj_t BgL_lz00_35129;

											BgL_lz00_35129 = CDR(BgL_lz00_12270);
											BgL_iz00_35131 = (BgL_iz00_12271 + ((long) 1));
											BgL_iz00_12271 = BgL_iz00_35131;
											BgL_lz00_12270 = BgL_lz00_35129;
											goto BgL_recz00_12269;
										}
									}
							}
						}
						{	/* Eval/evaluate_comp.scm 508 */
							obj_t BgL_rvalsz00_3924;

							if (NULLP(BgL_cvalsz00_19526))
								{	/* Eval/evaluate_comp.scm 508 */
									BgL_rvalsz00_3924 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 508 */
									obj_t BgL_head1321z00_3938;

									{	/* Eval/evaluate_comp.scm 508 */
										obj_t BgL_res5001z00_12300;

										BgL_res5001z00_12300 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1321z00_3938 = BgL_res5001z00_12300;
									}
									{
										obj_t BgL_l1319z00_12334;
										obj_t BgL_tail1322z00_12335;

										BgL_l1319z00_12334 = BgL_cvalsz00_19526;
										BgL_tail1322z00_12335 = BgL_head1321z00_3938;
									BgL_zc3anonymousza33184ze3z83_12333:
										if (NULLP(BgL_l1319z00_12334))
											{	/* Eval/evaluate_comp.scm 508 */
												BgL_rvalsz00_3924 = CDR(BgL_head1321z00_3938);
											}
										else
											{	/* Eval/evaluate_comp.scm 508 */
												obj_t BgL_newtail1323z00_12342;

												{	/* Eval/evaluate_comp.scm 508 */
													obj_t BgL_arg3187z00_12343;

													{	/* Eval/evaluate_comp.scm 508 */
														obj_t BgL_vz00_12344;

														BgL_vz00_12344 = CAR(BgL_l1319z00_12334);
														BgL_arg3187z00_12343 =
															PROCEDURE_ENTRY(BgL_vz00_12344) (BgL_vz00_12344,
															BgL_sz00_3911, BEOA);
													}
													{	/* Eval/evaluate_comp.scm 508 */
														obj_t BgL_res5007z00_12352;

														BgL_res5007z00_12352 =
															MAKE_PAIR(BgL_arg3187z00_12343, BNIL);
														BgL_newtail1323z00_12342 = BgL_res5007z00_12352;
													}
												}
												SET_CDR(BgL_tail1322z00_12335,
													BgL_newtail1323z00_12342);
												{
													obj_t BgL_tail1322z00_35148;
													obj_t BgL_l1319z00_35146;

													BgL_l1319z00_35146 = CDR(BgL_l1319z00_12334);
													BgL_tail1322z00_35148 = BgL_newtail1323z00_12342;
													BgL_tail1322z00_12335 = BgL_tail1322z00_35148;
													BgL_l1319z00_12334 = BgL_l1319z00_35146;
													goto BgL_zc3anonymousza33184ze3z83_12333;
												}
											}
									}
								}
							{	/* Eval/evaluate_comp.scm 509 */
								long BgL_g1116z00_3925;

								BgL_g1116z00_3925 =
									((long) CINT(BgL_bpz00_3913) + BgL_siza7eza7_19525);
								{
									obj_t BgL_lz00_12400;
									long BgL_iz00_12401;

									BgL_lz00_12400 = BgL_rvalsz00_3924;
									BgL_iz00_12401 = BgL_g1116z00_3925;
								BgL_recz00_12399:
									if (NULLP(BgL_lz00_12400))
										{	/* Eval/evaluate_comp.scm 510 */
											((bool_t) 0);
										}
									else
										{	/* Eval/evaluate_comp.scm 510 */
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_auxz00_35158;
												int BgL_auxz00_35156;
												obj_t BgL_auxz00_35153;

												BgL_auxz00_35158 = CAR(BgL_lz00_12400);
												BgL_auxz00_35156 = (int) (((long) 0));
												BgL_auxz00_35153 =
													VECTOR_REF(BgL_sz00_3911, (int) (BgL_iz00_12401));
												STRUCT_SET(BgL_auxz00_35153, BgL_auxz00_35156,
													BgL_auxz00_35158);
											}
											{
												long BgL_iz00_35163;
												obj_t BgL_lz00_35161;

												BgL_lz00_35161 = CDR(BgL_lz00_12400);
												BgL_iz00_35163 = (BgL_iz00_12401 + ((long) 1));
												BgL_iz00_12401 = BgL_iz00_35163;
												BgL_lz00_12400 = BgL_lz00_35161;
												goto BgL_recz00_12399;
											}
										}
								}
							}
							return
								PROCEDURE_ENTRY(BgL_bodyz00_19527) (BgL_bodyz00_19527,
								BgL_sz00_3911, BEOA);
						}
					}
				}
			}
		}
	}



/* &comp-ev_let*1406 */
	obj_t BGl_z62compzd2ev_letza21406z12zz__evaluate_compz00(obj_t
		BgL_envz00_19529, obj_t BgL_ez00_19530, obj_t BgL_stkz00_19531)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 474 */
			{
				BgL_ev_letza2za2_bglt BgL_ez00_3832;
				obj_t BgL_stkz00_3833;

				BgL_ez00_3832 = ((BgL_ev_letza2za2_bglt) BgL_ez00_19530);
				BgL_stkz00_3833 = BgL_stkz00_19531;
				{	/* Eval/evaluate_comp.scm 476 */
					long BgL_siza7eza7_3837;
					obj_t BgL_nstkz00_3838;

					BgL_siza7eza7_3837 = bgl_list_length(BgL_stkz00_3833);
					{	/* Eval/evaluate_comp.scm 476 */
						obj_t BgL_arg3150z00_3874;

						BgL_arg3150z00_3874 =
							(((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_ez00_3832)))->BgL_varsz00);
						BgL_nstkz00_3838 =
							BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_3833,
							BgL_arg3150z00_3874);
					}
					{	/* Eval/evaluate_comp.scm 477 */
						obj_t BgL_valsz00_3839;
						obj_t BgL_bodyz00_3840;

						{	/* Eval/evaluate_comp.scm 477 */
							obj_t BgL_l1305z00_3860;

							BgL_l1305z00_3860 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_3832)))->BgL_valsz00);
							if (NULLP(BgL_l1305z00_3860))
								{	/* Eval/evaluate_comp.scm 477 */
									BgL_valsz00_3839 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 477 */
									obj_t BgL_head1307z00_3862;

									{	/* Eval/evaluate_comp.scm 477 */
										obj_t BgL_res4964z00_11987;

										BgL_res4964z00_11987 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1307z00_3862 = BgL_res4964z00_11987;
									}
									{
										obj_t BgL_l1305z00_12021;
										obj_t BgL_tail1308z00_12022;

										BgL_l1305z00_12021 = BgL_l1305z00_3860;
										BgL_tail1308z00_12022 = BgL_head1307z00_3862;
									BgL_zc3anonymousza33144ze3z83_12020:
										if (NULLP(BgL_l1305z00_12021))
											{	/* Eval/evaluate_comp.scm 477 */
												BgL_valsz00_3839 = CDR(BgL_head1307z00_3862);
											}
										else
											{	/* Eval/evaluate_comp.scm 477 */
												obj_t BgL_newtail1309z00_12029;

												{	/* Eval/evaluate_comp.scm 477 */
													obj_t BgL_arg3147z00_12030;

													{	/* Eval/evaluate_comp.scm 477 */
														obj_t BgL_vz00_12031;

														BgL_vz00_12031 = CAR(BgL_l1305z00_12021);
														BgL_arg3147z00_12030 =
															BGl_compz00zz__evaluate_compz00(
															((BgL_ev_exprz00_bglt) BgL_vz00_12031),
															BgL_nstkz00_3838);
													}
													{	/* Eval/evaluate_comp.scm 477 */
														obj_t BgL_res4970z00_12039;

														BgL_res4970z00_12039 =
															MAKE_PAIR(BgL_arg3147z00_12030, BNIL);
														BgL_newtail1309z00_12029 = BgL_res4970z00_12039;
													}
												}
												SET_CDR(BgL_tail1308z00_12022,
													BgL_newtail1309z00_12029);
												{
													obj_t BgL_tail1308z00_35188;
													obj_t BgL_l1305z00_35186;

													BgL_l1305z00_35186 = CDR(BgL_l1305z00_12021);
													BgL_tail1308z00_35188 = BgL_newtail1309z00_12029;
													BgL_tail1308z00_12022 = BgL_tail1308z00_35188;
													BgL_l1305z00_12021 = BgL_l1305z00_35186;
													goto BgL_zc3anonymousza33144ze3z83_12020;
												}
											}
									}
								}
						}
						{	/* Eval/evaluate_comp.scm 478 */
							BgL_ev_exprz00_bglt BgL_arg3148z00_3873;

							BgL_arg3148z00_3873 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_3832)))->BgL_bodyz00);
							BgL_bodyz00_3840 =
								BGl_compz00zz__evaluate_compz00(BgL_arg3148z00_3873,
								BgL_nstkz00_3838);
						}
						{	/* Eval/evaluate_comp.scm 479 */
							obj_t BgL_zc3anonymousza33125ze3z83_18465;

							BgL_zc3anonymousza33125ze3z83_18465 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza33125ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_zc3anonymousza33125ze3z83_18465,
								(int) (((long) 0)), BINT(BgL_siza7eza7_3837));
							PROCEDURE_SET(BgL_zc3anonymousza33125ze3z83_18465,
								(int) (((long) 1)), ((obj_t) BgL_ez00_3832));
							PROCEDURE_SET(BgL_zc3anonymousza33125ze3z83_18465,
								(int) (((long) 2)), BgL_valsz00_3839);
							PROCEDURE_SET(BgL_zc3anonymousza33125ze3z83_18465,
								(int) (((long) 3)), BgL_bodyz00_3840);
							return BgL_zc3anonymousza33125ze3z83_18465;
						}
					}
				}
			}
		}
	}



/* &<anonymous:3125> */
	obj_t BGl_z62zc3anonymousza33125ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19532, obj_t BgL_sz00_19537)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 479 */
			{	/* Eval/evaluate_comp.scm 479 */
				long BgL_siza7eza7_19533;
				BgL_ev_letza2za2_bglt BgL_i1110z00_19534;
				obj_t BgL_valsz00_19535;
				obj_t BgL_bodyz00_19536;

				BgL_siza7eza7_19533 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19532, (int) (((long) 0))));
				BgL_i1110z00_19534 =
					((BgL_ev_letza2za2_bglt)
					PROCEDURE_REF(BgL_envz00_19532, (int) (((long) 1))));
				BgL_valsz00_19535 = PROCEDURE_REF(BgL_envz00_19532, (int) (((long) 2)));
				BgL_bodyz00_19536 = PROCEDURE_REF(BgL_envz00_19532, (int) (((long) 3)));
				{
					obj_t BgL_sz00_3841;

					BgL_sz00_3841 = BgL_sz00_19537;
					{	/* Eval/evaluate_comp.scm 479 */
						obj_t BgL_bpz00_3843;

						BgL_bpz00_3843 = VECTOR_REF(BgL_sz00_3841, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 480 */
							long BgL_g1111z00_3844;

							BgL_g1111z00_3844 =
								((long) CINT(BgL_bpz00_3843) + BgL_siza7eza7_19533);
							{
								obj_t BgL_lz00_3847;
								long BgL_iz00_3848;
								obj_t BgL_bza2za2_3849;

								BgL_lz00_3847 = BgL_valsz00_19535;
								BgL_iz00_3848 = BgL_g1111z00_3844;
								BgL_bza2za2_3849 =
									(((BgL_ev_letza2za2_bglt) CREF(BgL_i1110z00_19534))->
									BgL_boxesz00);
							BgL_zc3anonymousza33127ze3z83_3850:
								if (NULLP(BgL_lz00_3847))
									{	/* Eval/evaluate_comp.scm 481 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 481 */
										{	/* Eval/evaluate_comp.scm 482 */
											obj_t BgL_valz00_3852;

											{	/* Eval/evaluate_comp.scm 482 */
												obj_t BgL_fun3132z00_3855;

												BgL_fun3132z00_3855 = CAR(BgL_lz00_3847);
												BgL_valz00_3852 =
													PROCEDURE_ENTRY(BgL_fun3132z00_3855)
													(BgL_fun3132z00_3855, BgL_sz00_3841, BEOA);
											}
											{	/* Eval/evaluate_comp.scm 483 */
												obj_t BgL_arg3130z00_3853;

												if (CBOOL(CAR(BgL_bza2za2_3849)))
													{	/* Eval/evaluate_comp.scm 202 */
														obj_t BgL_newz00_12053;

														BgL_newz00_12053 =
															create_struct
															(BGl_symbol5605z00zz__evaluate_compz00,
															(int) (((long) 1)));
														{	/* Eval/evaluate_comp.scm 202 */
															int BgL_auxz00_35232;

															BgL_auxz00_35232 = (int) (((long) 0));
															STRUCT_SET(BgL_newz00_12053, BgL_auxz00_35232,
																BgL_valz00_3852);
														}
														BgL_arg3130z00_3853 = BgL_newz00_12053;
													}
												else
													{	/* Eval/evaluate_comp.scm 483 */
														BgL_arg3130z00_3853 = BgL_valz00_3852;
													}
												VECTOR_SET(BgL_sz00_3841,
													(int) (BgL_iz00_3848), BgL_arg3130z00_3853);
										}}
										{
											obj_t BgL_bza2za2_35241;
											long BgL_iz00_35239;
											obj_t BgL_lz00_35237;

											BgL_lz00_35237 = CDR(BgL_lz00_3847);
											BgL_iz00_35239 = (BgL_iz00_3848 + ((long) 1));
											BgL_bza2za2_35241 = CDR(BgL_bza2za2_3849);
											BgL_bza2za2_3849 = BgL_bza2za2_35241;
											BgL_iz00_3848 = BgL_iz00_35239;
											BgL_lz00_3847 = BgL_lz00_35237;
											goto BgL_zc3anonymousza33127ze3z83_3850;
										}
									}
							}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_19536) (BgL_bodyz00_19536,
							BgL_sz00_3841, BEOA);
					}
				}
			}
		}
	}



/* &comp-ev_let1404 */
	obj_t BGl_z62compzd2ev_let1404zb0zz__evaluate_compz00(obj_t BgL_envz00_19538,
		obj_t BgL_ez00_19539, obj_t BgL_stkz00_19540)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 455 */
			{
				BgL_ev_letz00_bglt BgL_ez00_3781;
				obj_t BgL_stkz00_3782;

				BgL_ez00_3781 = ((BgL_ev_letz00_bglt) BgL_ez00_19539);
				BgL_stkz00_3782 = BgL_stkz00_19540;
				{	/* Eval/evaluate_comp.scm 457 */
					long BgL_siza7eza7_3786;
					obj_t BgL_nstkz00_3787;

					BgL_siza7eza7_3786 = bgl_list_length(BgL_stkz00_3782);
					{	/* Eval/evaluate_comp.scm 457 */
						obj_t BgL_arg3124z00_3830;

						BgL_arg3124z00_3830 =
							(((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_ez00_3781)))->BgL_varsz00);
						BgL_nstkz00_3787 =
							BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_3782,
							BgL_arg3124z00_3830);
					}
					{	/* Eval/evaluate_comp.scm 458 */
						obj_t BgL_valsz00_3788;
						obj_t BgL_iboxesz00_3789;
						obj_t BgL_bodyz00_3790;

						{	/* Eval/evaluate_comp.scm 459 */
							obj_t BgL_arg3113z00_3815;

							BgL_arg3113z00_3815 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_3781)))->BgL_valsz00);
							BgL_valsz00_3788 =
								BGl_compzd2withzd2pushz00zz__evaluate_compz00
								(BgL_arg3113z00_3815, BgL_stkz00_3782);
						}
						{	/* Eval/evaluate_comp.scm 460 */
							obj_t BgL_l1300z00_3816;

							BgL_l1300z00_3816 =
								(((BgL_ev_letz00_bglt) CREF(BgL_ez00_3781))->BgL_boxesz00);
							if (NULLP(BgL_l1300z00_3816))
								{	/* Eval/evaluate_comp.scm 460 */
									BgL_iboxesz00_3789 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 460 */
									obj_t BgL_head1302z00_3818;

									{	/* Eval/evaluate_comp.scm 460 */
										obj_t BgL_res4947z00_11848;

										BgL_res4947z00_11848 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1302z00_3818 = BgL_res4947z00_11848;
									}
									{
										obj_t BgL_l1300z00_11882;
										obj_t BgL_tail1303z00_11883;

										BgL_l1300z00_11882 = BgL_l1300z00_3816;
										BgL_tail1303z00_11883 = BgL_head1302z00_3818;
									BgL_zc3anonymousza33115ze3z83_11881:
										if (NULLP(BgL_l1300z00_11882))
											{	/* Eval/evaluate_comp.scm 460 */
												BgL_iboxesz00_3789 = CDR(BgL_head1302z00_3818);
											}
										else
											{	/* Eval/evaluate_comp.scm 460 */
												obj_t BgL_newtail1304z00_11890;

												{	/* Eval/evaluate_comp.scm 460 */
													obj_t BgL_arg3121z00_11891;

													BgL_arg3121z00_11891 =
														BGl__indexz00zz__evaluate_compz00(CAR
														(BgL_l1300z00_11882), BgL_nstkz00_3787);
													{	/* Eval/evaluate_comp.scm 460 */
														obj_t BgL_res4953z00_11900;

														BgL_res4953z00_11900 =
															MAKE_PAIR(BgL_arg3121z00_11891, BNIL);
														BgL_newtail1304z00_11890 = BgL_res4953z00_11900;
													}
												}
												SET_CDR(BgL_tail1303z00_11883,
													BgL_newtail1304z00_11890);
												{
													obj_t BgL_tail1303z00_35268;
													obj_t BgL_l1300z00_35266;

													BgL_l1300z00_35266 = CDR(BgL_l1300z00_11882);
													BgL_tail1303z00_35268 = BgL_newtail1304z00_11890;
													BgL_tail1303z00_11883 = BgL_tail1303z00_35268;
													BgL_l1300z00_11882 = BgL_l1300z00_35266;
													goto BgL_zc3anonymousza33115ze3z83_11881;
												}
											}
									}
								}
						}
						{	/* Eval/evaluate_comp.scm 461 */
							BgL_ev_exprz00_bglt BgL_arg3123z00_3829;

							BgL_arg3123z00_3829 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_3781)))->BgL_bodyz00);
							BgL_bodyz00_3790 =
								BGl_compz00zz__evaluate_compz00(BgL_arg3123z00_3829,
								BgL_nstkz00_3787);
						}
						{	/* Eval/evaluate_comp.scm 462 */
							obj_t BgL_zc3anonymousza33095ze3z83_18467;

							BgL_zc3anonymousza33095ze3z83_18467 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza33095ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_zc3anonymousza33095ze3z83_18467,
								(int) (((long) 0)), BINT(BgL_siza7eza7_3786));
							PROCEDURE_SET(BgL_zc3anonymousza33095ze3z83_18467,
								(int) (((long) 1)), BgL_valsz00_3788);
							PROCEDURE_SET(BgL_zc3anonymousza33095ze3z83_18467,
								(int) (((long) 2)), BgL_iboxesz00_3789);
							PROCEDURE_SET(BgL_zc3anonymousza33095ze3z83_18467,
								(int) (((long) 3)), BgL_bodyz00_3790);
							return BgL_zc3anonymousza33095ze3z83_18467;
						}
					}
				}
			}
		}
	}



/* &<anonymous:3095> */
	obj_t BGl_z62zc3anonymousza33095ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19541, obj_t BgL_sz00_19546)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 462 */
			{	/* Eval/evaluate_comp.scm 462 */
				long BgL_siza7eza7_19542;
				obj_t BgL_valsz00_19543;
				obj_t BgL_iboxesz00_19544;
				obj_t BgL_bodyz00_19545;

				BgL_siza7eza7_19542 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_19541, (int) (((long) 0))));
				BgL_valsz00_19543 =
					((obj_t) PROCEDURE_REF(BgL_envz00_19541, (int) (((long) 1))));
				BgL_iboxesz00_19544 =
					PROCEDURE_REF(BgL_envz00_19541, (int) (((long) 2)));
				BgL_bodyz00_19545 = PROCEDURE_REF(BgL_envz00_19541, (int) (((long) 3)));
				{
					obj_t BgL_sz00_3791;

					BgL_sz00_3791 = BgL_sz00_19546;
					{	/* Eval/evaluate_comp.scm 462 */
						obj_t BgL_bpz00_3793;

						BgL_bpz00_3793 = VECTOR_REF(BgL_sz00_3791, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 463 */
							long BgL_g1109z00_3794;

							BgL_g1109z00_3794 =
								((long) CINT(BgL_bpz00_3793) + BgL_siza7eza7_19542);
							{
								obj_t BgL_lz00_11942;
								long BgL_iz00_11943;

								BgL_lz00_11942 = BgL_valsz00_19543;
								BgL_iz00_11943 = BgL_g1109z00_3794;
							BgL_recz00_11941:
								if (NULLP(BgL_lz00_11942))
									{	/* Eval/evaluate_comp.scm 464 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 464 */
										{	/* Eval/evaluate_comp.scm 465 */
											obj_t BgL_arg3099z00_11950;

											{	/* Eval/evaluate_comp.scm 465 */
												obj_t BgL_fun3100z00_11951;

												BgL_fun3100z00_11951 = CAR(BgL_lz00_11942);
												BgL_arg3099z00_11950 =
													PROCEDURE_ENTRY(BgL_fun3100z00_11951)
													(BgL_fun3100z00_11951, BgL_sz00_3791, BEOA);
											}
											VECTOR_SET(BgL_sz00_3791,
												(int) (BgL_iz00_11943), BgL_arg3099z00_11950);
										}
										{
											long BgL_iz00_35310;
											obj_t BgL_lz00_35308;

											BgL_lz00_35308 = CDR(BgL_lz00_11942);
											BgL_iz00_35310 = (BgL_iz00_11943 + ((long) 1));
											BgL_iz00_11943 = BgL_iz00_35310;
											BgL_lz00_11942 = BgL_lz00_35308;
											goto BgL_recz00_11941;
										}
									}
							}
						}
						{
							obj_t BgL_lz00_3806;

							BgL_lz00_3806 = BgL_iboxesz00_19544;
						BgL_zc3anonymousza33103ze3z83_3807:
							if (NULLP(BgL_lz00_3806))
								{	/* Eval/evaluate_comp.scm 468 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 468 */
									{	/* Eval/evaluate_comp.scm 469 */
										long BgL_iz00_3809;

										BgL_iz00_3809 =
											(
											(long) CINT(BgL_bpz00_3793) +
											(long) CINT(CAR(BgL_lz00_3806)));
										{	/* Eval/evaluate_comp.scm 470 */
											obj_t BgL_arg3105z00_3810;

											{	/* Eval/evaluate_comp.scm 470 */
												obj_t BgL_arg3106z00_3811;

												BgL_arg3106z00_3811 =
													VECTOR_REF(BgL_sz00_3791, (int) (BgL_iz00_3809));
												{	/* Eval/evaluate_comp.scm 202 */
													obj_t BgL_newz00_11973;

													BgL_newz00_11973 =
														create_struct(BGl_symbol5605z00zz__evaluate_compz00,
														(int) (((long) 1)));
													{	/* Eval/evaluate_comp.scm 202 */
														int BgL_auxz00_35322;

														BgL_auxz00_35322 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_11973, BgL_auxz00_35322,
															BgL_arg3106z00_3811);
													}
													BgL_arg3105z00_3810 = BgL_newz00_11973;
											}}
											VECTOR_SET(BgL_sz00_3791,
												(int) (BgL_iz00_3809), BgL_arg3105z00_3810);
									}}
									{
										obj_t BgL_lz00_35327;

										BgL_lz00_35327 = CDR(BgL_lz00_3806);
										BgL_lz00_3806 = BgL_lz00_35327;
										goto BgL_zc3anonymousza33103ze3z83_3807;
									}
								}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_19545) (BgL_bodyz00_19545,
							BgL_sz00_3791, BEOA);
					}
				}
			}
		}
	}



/* &comp-ev_prog21402 */
	obj_t BGl_z62compzd2ev_prog21402zb0zz__evaluate_compz00(obj_t
		BgL_envz00_19547, obj_t BgL_ez00_19548, obj_t BgL_stkz00_19549)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 449 */
			{
				BgL_ev_prog2z00_bglt BgL_ez00_3768;
				obj_t BgL_stkz00_3769;

				BgL_ez00_3768 = ((BgL_ev_prog2z00_bglt) BgL_ez00_19548);
				BgL_stkz00_3769 = BgL_stkz00_19549;
				{	/* Eval/evaluate_comp.scm 451 */
					obj_t BgL_e1z00_3773;
					obj_t BgL_e2z00_3774;

					BgL_e1z00_3773 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_prog2z00_bglt) CREF(BgL_ez00_3768))->BgL_e1z00),
						BgL_stkz00_3769);
					BgL_e2z00_3774 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_prog2z00_bglt)
								CREF(BgL_ez00_3768))->BgL_e2z00), BgL_stkz00_3769);
					{	/* Eval/evaluate_comp.scm 452 */
						obj_t BgL_zc3anonymousza33092ze3z83_18469;

						BgL_zc3anonymousza33092ze3z83_18469 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33092ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza33092ze3z83_18469,
							(int) (((long) 0)), BgL_e1z00_3773);
						PROCEDURE_SET(BgL_zc3anonymousza33092ze3z83_18469,
							(int) (((long) 1)), BgL_e2z00_3774);
						return BgL_zc3anonymousza33092ze3z83_18469;
					}
				}
			}
		}
	}



/* &<anonymous:3092> */
	obj_t BGl_z62zc3anonymousza33092ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19550, obj_t BgL_sz00_19553)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 452 */
			{	/* Eval/evaluate_comp.scm 452 */
				obj_t BgL_e1z00_19551;
				obj_t BgL_e2z00_19552;

				BgL_e1z00_19551 = PROCEDURE_REF(BgL_envz00_19550, (int) (((long) 0)));
				BgL_e2z00_19552 = PROCEDURE_REF(BgL_envz00_19550, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3775;

					BgL_sz00_3775 = BgL_sz00_19553;
					{	/* Eval/evaluate_comp.scm 452 */
						obj_t BgL_bpz00_11841;

						BgL_bpz00_11841 = VECTOR_REF(BgL_sz00_3775, (int) (((long) 0)));
						PROCEDURE_ENTRY(BgL_e1z00_19551) (BgL_e1z00_19551, BgL_sz00_3775,
							BEOA);
						return PROCEDURE_ENTRY(BgL_e2z00_19552) (BgL_e2z00_19552,
							BgL_sz00_3775, BEOA);
					}
				}
			}
		}
	}



/* &comp-ev_and1400 */
	obj_t BGl_z62compzd2ev_and1400zb0zz__evaluate_compz00(obj_t BgL_envz00_19554,
		obj_t BgL_ez00_19555, obj_t BgL_stkz00_19556)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 439 */
			{
				BgL_ev_andz00_bglt BgL_ez00_3735;
				obj_t BgL_stkz00_3736;

				BgL_ez00_3735 = ((BgL_ev_andz00_bglt) BgL_ez00_19555);
				BgL_stkz00_3736 = BgL_stkz00_19556;
				{	/* Eval/evaluate_comp.scm 441 */
					obj_t BgL_argsz00_3740;

					{	/* Eval/evaluate_comp.scm 441 */
						obj_t BgL_l1295z00_3754;

						BgL_l1295z00_3754 =
							(((BgL_ev_listz00_bglt) CREF(
									((BgL_ev_listz00_bglt) BgL_ez00_3735)))->BgL_argsz00);
						if (NULLP(BgL_l1295z00_3754))
							{	/* Eval/evaluate_comp.scm 441 */
								BgL_argsz00_3740 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 441 */
								obj_t BgL_head1297z00_3756;

								{	/* Eval/evaluate_comp.scm 441 */
									obj_t BgL_res4936z00_11746;

									BgL_res4936z00_11746 = MAKE_PAIR(BNIL, BNIL);
									BgL_head1297z00_3756 = BgL_res4936z00_11746;
								}
								{
									obj_t BgL_l1295z00_11780;
									obj_t BgL_tail1298z00_11781;

									BgL_l1295z00_11780 = BgL_l1295z00_3754;
									BgL_tail1298z00_11781 = BgL_head1297z00_3756;
								BgL_zc3anonymousza33080ze3z83_11779:
									if (NULLP(BgL_l1295z00_11780))
										{	/* Eval/evaluate_comp.scm 441 */
											BgL_argsz00_3740 = CDR(BgL_head1297z00_3756);
										}
									else
										{	/* Eval/evaluate_comp.scm 441 */
											obj_t BgL_newtail1299z00_11788;

											{	/* Eval/evaluate_comp.scm 441 */
												obj_t BgL_arg3091z00_11789;

												{	/* Eval/evaluate_comp.scm 441 */
													obj_t BgL_ez00_11790;

													BgL_ez00_11790 = CAR(BgL_l1295z00_11780);
													BgL_arg3091z00_11789 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_ez00_11790),
														BgL_stkz00_3736);
												}
												{	/* Eval/evaluate_comp.scm 441 */
													obj_t BgL_res4942z00_11798;

													BgL_res4942z00_11798 =
														MAKE_PAIR(BgL_arg3091z00_11789, BNIL);
													BgL_newtail1299z00_11788 = BgL_res4942z00_11798;
												}
											}
											SET_CDR(BgL_tail1298z00_11781, BgL_newtail1299z00_11788);
											{
												obj_t BgL_tail1298z00_35374;
												obj_t BgL_l1295z00_35372;

												BgL_l1295z00_35372 = CDR(BgL_l1295z00_11780);
												BgL_tail1298z00_35374 = BgL_newtail1299z00_11788;
												BgL_tail1298z00_11781 = BgL_tail1298z00_35374;
												BgL_l1295z00_11780 = BgL_l1295z00_35372;
												goto BgL_zc3anonymousza33080ze3z83_11779;
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 442 */
						obj_t BgL_zc3anonymousza33072ze3z83_18471;

						BgL_zc3anonymousza33072ze3z83_18471 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33072ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza33072ze3z83_18471,
							(int) (((long) 0)), BgL_argsz00_3740);
						return BgL_zc3anonymousza33072ze3z83_18471;
					}
				}
			}
		}
	}



/* &<anonymous:3072> */
	obj_t BGl_z62zc3anonymousza33072ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19557, obj_t BgL_sz00_19559)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 442 */
			{	/* Eval/evaluate_comp.scm 442 */
				obj_t BgL_argsz00_19558;

				BgL_argsz00_19558 = PROCEDURE_REF(BgL_envz00_19557, (int) (((long) 0)));
				{
					obj_t BgL_sz00_3741;

					BgL_sz00_3741 = BgL_sz00_19559;
					{	/* Eval/evaluate_comp.scm 442 */
						obj_t BgL_bpz00_3743;

						BgL_bpz00_3743 = VECTOR_REF(BgL_sz00_3741, (int) (((long) 0)));
						{
							obj_t BgL_lz00_11825;
							obj_t BgL_rz00_11826;

							BgL_lz00_11825 = BgL_argsz00_19558;
							BgL_rz00_11826 = BTRUE;
						BgL_recz00_11824:
							if (NULLP(BgL_lz00_11825))
								{	/* Eval/evaluate_comp.scm 444 */
									return BgL_rz00_11826;
								}
							else
								{	/* Eval/evaluate_comp.scm 446 */
									obj_t BgL_vz00_11833;

									{	/* Eval/evaluate_comp.scm 446 */
										obj_t BgL_fun3078z00_11834;

										BgL_fun3078z00_11834 = CAR(BgL_lz00_11825);
										BgL_vz00_11833 =
											PROCEDURE_ENTRY(BgL_fun3078z00_11834)
											(BgL_fun3078z00_11834, BgL_sz00_3741, BEOA);
									}
									if (CBOOL(BgL_vz00_11833))
										{
											obj_t BgL_rz00_35396;
											obj_t BgL_lz00_35394;

											BgL_lz00_35394 = CDR(BgL_lz00_11825);
											BgL_rz00_35396 = BgL_vz00_11833;
											BgL_rz00_11826 = BgL_rz00_35396;
											BgL_lz00_11825 = BgL_lz00_35394;
											goto BgL_recz00_11824;
										}
									else
										{	/* Eval/evaluate_comp.scm 447 */
											return BFALSE;
										}
								}
						}
					}
				}
			}
		}
	}



/* &comp-ev_or1398 */
	obj_t BGl_z62compzd2ev_or1398zb0zz__evaluate_compz00(obj_t BgL_envz00_19560,
		obj_t BgL_ez00_19561, obj_t BgL_stkz00_19562)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 430 */
			{
				BgL_ev_orz00_bglt BgL_ez00_3704;
				obj_t BgL_stkz00_3705;

				BgL_ez00_3704 = ((BgL_ev_orz00_bglt) BgL_ez00_19561);
				BgL_stkz00_3705 = BgL_stkz00_19562;
				{	/* Eval/evaluate_comp.scm 432 */
					obj_t BgL_argsz00_3709;

					{	/* Eval/evaluate_comp.scm 432 */
						obj_t BgL_l1290z00_3721;

						BgL_l1290z00_3721 =
							(((BgL_ev_listz00_bglt) CREF(
									((BgL_ev_listz00_bglt) BgL_ez00_3704)))->BgL_argsz00);
						if (NULLP(BgL_l1290z00_3721))
							{	/* Eval/evaluate_comp.scm 432 */
								BgL_argsz00_3709 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 432 */
								obj_t BgL_head1292z00_3723;

								{	/* Eval/evaluate_comp.scm 432 */
									obj_t BgL_res4927z00_11680;

									BgL_res4927z00_11680 = MAKE_PAIR(BNIL, BNIL);
									BgL_head1292z00_3723 = BgL_res4927z00_11680;
								}
								{
									obj_t BgL_l1290z00_11714;
									obj_t BgL_tail1293z00_11715;

									BgL_l1290z00_11714 = BgL_l1290z00_3721;
									BgL_tail1293z00_11715 = BgL_head1292z00_3723;
								BgL_zc3anonymousza33068ze3z83_11713:
									if (NULLP(BgL_l1290z00_11714))
										{	/* Eval/evaluate_comp.scm 432 */
											BgL_argsz00_3709 = CDR(BgL_head1292z00_3723);
										}
									else
										{	/* Eval/evaluate_comp.scm 432 */
											obj_t BgL_newtail1294z00_11722;

											{	/* Eval/evaluate_comp.scm 432 */
												obj_t BgL_arg3071z00_11723;

												{	/* Eval/evaluate_comp.scm 432 */
													obj_t BgL_ez00_11724;

													BgL_ez00_11724 = CAR(BgL_l1290z00_11714);
													BgL_arg3071z00_11723 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_ez00_11724),
														BgL_stkz00_3705);
												}
												{	/* Eval/evaluate_comp.scm 432 */
													obj_t BgL_res4933z00_11732;

													BgL_res4933z00_11732 =
														MAKE_PAIR(BgL_arg3071z00_11723, BNIL);
													BgL_newtail1294z00_11722 = BgL_res4933z00_11732;
												}
											}
											SET_CDR(BgL_tail1293z00_11715, BgL_newtail1294z00_11722);
											{
												obj_t BgL_tail1293z00_35412;
												obj_t BgL_l1290z00_35410;

												BgL_l1290z00_35410 = CDR(BgL_l1290z00_11714);
												BgL_tail1293z00_35412 = BgL_newtail1294z00_11722;
												BgL_tail1293z00_11715 = BgL_tail1293z00_35412;
												BgL_l1290z00_11714 = BgL_l1290z00_35410;
												goto BgL_zc3anonymousza33068ze3z83_11713;
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 433 */
						obj_t BgL_zc3anonymousza33062ze3z83_18473;

						BgL_zc3anonymousza33062ze3z83_18473 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33062ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza33062ze3z83_18473,
							(int) (((long) 0)), BgL_argsz00_3709);
						return BgL_zc3anonymousza33062ze3z83_18473;
					}
				}
			}
		}
	}



/* &<anonymous:3062> */
	obj_t BGl_z62zc3anonymousza33062ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19563, obj_t BgL_sz00_19565)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 433 */
			{	/* Eval/evaluate_comp.scm 433 */
				obj_t BgL_argsz00_19564;

				BgL_argsz00_19564 = PROCEDURE_REF(BgL_envz00_19563, (int) (((long) 0)));
				{
					obj_t BgL_sz00_3710;

					BgL_sz00_3710 = BgL_sz00_19565;
					{	/* Eval/evaluate_comp.scm 433 */
						obj_t BgL_bpz00_3712;

						BgL_bpz00_3712 = VECTOR_REF(BgL_sz00_3710, (int) (((long) 0)));
						{
							obj_t BgL_lz00_3714;

							BgL_lz00_3714 = BgL_argsz00_19564;
						BgL_zc3anonymousza33063ze3z83_3715:
							if (NULLP(BgL_lz00_3714))
								{	/* Eval/evaluate_comp.scm 435 */
									return BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 437 */
									obj_t BgL__ortest_1104z00_3717;

									{	/* Eval/evaluate_comp.scm 437 */
										obj_t BgL_fun3066z00_3719;

										BgL_fun3066z00_3719 = CAR(BgL_lz00_3714);
										BgL__ortest_1104z00_3717 =
											PROCEDURE_ENTRY(BgL_fun3066z00_3719) (BgL_fun3066z00_3719,
											BgL_sz00_3710, BEOA);
									}
									if (CBOOL(BgL__ortest_1104z00_3717))
										{	/* Eval/evaluate_comp.scm 437 */
											return BgL__ortest_1104z00_3717;
										}
									else
										{
											obj_t BgL_lz00_35432;

											BgL_lz00_35432 = CDR(BgL_lz00_3714);
											BgL_lz00_3714 = BgL_lz00_35432;
											goto BgL_zc3anonymousza33063ze3z83_3715;
										}
								}
						}
					}
				}
			}
		}
	}



/* &comp-ev_if1396 */
	obj_t BGl_z62compzd2ev_if1396zb0zz__evaluate_compz00(obj_t BgL_envz00_19566,
		obj_t BgL_ez00_19567, obj_t BgL_stkz00_19568)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 424 */
			{
				BgL_ev_ifz00_bglt BgL_ez00_3688;
				obj_t BgL_stkz00_3689;

				BgL_ez00_3688 = ((BgL_ev_ifz00_bglt) BgL_ez00_19567);
				BgL_stkz00_3689 = BgL_stkz00_19568;
				{	/* Eval/evaluate_comp.scm 426 */
					obj_t BgL_pz00_3693;
					obj_t BgL_tz00_3694;
					obj_t BgL_ez00_3695;

					BgL_pz00_3693 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_ifz00_bglt) CREF(BgL_ez00_3688))->BgL_pz00),
						BgL_stkz00_3689);
					BgL_tz00_3694 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
								CREF(BgL_ez00_3688))->BgL_tz00), BgL_stkz00_3689);
					BgL_ez00_3695 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
								CREF(BgL_ez00_3688))->BgL_ez00), BgL_stkz00_3689);
					{	/* Eval/evaluate_comp.scm 427 */
						obj_t BgL_zc3anonymousza33057ze3z83_18475;

						BgL_zc3anonymousza33057ze3z83_18475 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33057ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 3)));
						PROCEDURE_SET(BgL_zc3anonymousza33057ze3z83_18475,
							(int) (((long) 0)), BgL_ez00_3695);
						PROCEDURE_SET(BgL_zc3anonymousza33057ze3z83_18475,
							(int) (((long) 1)), BgL_tz00_3694);
						PROCEDURE_SET(BgL_zc3anonymousza33057ze3z83_18475,
							(int) (((long) 2)), BgL_pz00_3693);
						return BgL_zc3anonymousza33057ze3z83_18475;
					}
				}
			}
		}
	}



/* &<anonymous:3057> */
	obj_t BGl_z62zc3anonymousza33057ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19569, obj_t BgL_sz00_19573)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 427 */
			{	/* Eval/evaluate_comp.scm 427 */
				obj_t BgL_ez00_19570;
				obj_t BgL_tz00_19571;
				obj_t BgL_pz00_19572;

				BgL_ez00_19570 = PROCEDURE_REF(BgL_envz00_19569, (int) (((long) 0)));
				BgL_tz00_19571 = PROCEDURE_REF(BgL_envz00_19569, (int) (((long) 1)));
				BgL_pz00_19572 = PROCEDURE_REF(BgL_envz00_19569, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3696;

					BgL_sz00_3696 = BgL_sz00_19573;
					{	/* Eval/evaluate_comp.scm 427 */
						obj_t BgL_bpz00_11672;

						BgL_bpz00_11672 = VECTOR_REF(BgL_sz00_3696, (int) (((long) 0)));
						if (CBOOL(PROCEDURE_ENTRY(BgL_pz00_19572) (BgL_pz00_19572,
									BgL_sz00_3696, BEOA)))
							{	/* Eval/evaluate_comp.scm 428 */
								return
									PROCEDURE_ENTRY(BgL_tz00_19571) (BgL_tz00_19571,
									BgL_sz00_3696, BEOA);
							}
						else
							{	/* Eval/evaluate_comp.scm 428 */
								return
									PROCEDURE_ENTRY(BgL_ez00_19570) (BgL_ez00_19570,
									BgL_sz00_3696, BEOA);
							}
					}
				}
			}
		}
	}



/* &comp-ev_litt1394 */
	obj_t BGl_z62compzd2ev_litt1394zb0zz__evaluate_compz00(obj_t BgL_envz00_19574,
		obj_t BgL_ez00_19575, obj_t BgL_stkz00_19576)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 419 */
			{
				BgL_ev_littz00_bglt BgL_ez00_3679;
				obj_t BgL_stkz00_3680;

				BgL_ez00_3679 = ((BgL_ev_littz00_bglt) BgL_ez00_19575);
				BgL_stkz00_3680 = BgL_stkz00_19576;
				{	/* Eval/evaluate_comp.scm 421 */
					obj_t BgL_zc3anonymousza33056ze3z83_18477;

					BgL_zc3anonymousza33056ze3z83_18477 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza33056ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3anonymousza33056ze3z83_18477, (int) (((long) 0)),
						((obj_t) BgL_ez00_3679));
					return BgL_zc3anonymousza33056ze3z83_18477;
				}
			}
		}
	}



/* &<anonymous:3056> */
	obj_t BGl_z62zc3anonymousza33056ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19577, obj_t BgL_sz00_19579)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 421 */
			{	/* Eval/evaluate_comp.scm 421 */
				BgL_ev_littz00_bglt BgL_i1101z00_19578;

				BgL_i1101z00_19578 =
					((BgL_ev_littz00_bglt)
					PROCEDURE_REF(BgL_envz00_19577, (int) (((long) 0))));
				{
					obj_t BgL_sz00_11667;

					BgL_sz00_11667 = BgL_sz00_19579;
					{	/* Eval/evaluate_comp.scm 421 */
						obj_t BgL_bpz00_11669;

						BgL_bpz00_11669 = VECTOR_REF(BgL_sz00_11667, (int) (((long) 0)));
						return
							(((BgL_ev_littz00_bglt) CREF(BgL_i1101z00_19578))->BgL_valuez00);
					}
				}
			}
		}
	}



/* &comp-ev_defglobal1392 */
	obj_t BGl_z62compzd2ev_defglobal1392zb0zz__evaluate_compz00(obj_t
		BgL_envz00_19580, obj_t BgL_ez00_19581, obj_t BgL_stkz00_19582)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 388 */
			{
				BgL_ev_defglobalz00_bglt BgL_ez00_3640;
				obj_t BgL_stkz00_3641;

				BgL_ez00_3640 = ((BgL_ev_defglobalz00_bglt) BgL_ez00_19581);
				BgL_stkz00_3641 = BgL_stkz00_19582;
				{	/* Eval/evaluate_comp.scm 390 */
					obj_t BgL_ez00_3645;

					{	/* Eval/evaluate_comp.scm 390 */
						BgL_ev_exprz00_bglt BgL_arg3055z00_3677;

						BgL_arg3055z00_3677 =
							(((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_ez00_3640)))->BgL_ez00);
						BgL_ez00_3645 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3055z00_3677,
							BgL_stkz00_3641);
					}
					{	/* Eval/evaluate_comp.scm 391 */
						obj_t BgL_zc3anonymousza33011ze3z83_18479;

						BgL_zc3anonymousza33011ze3z83_18479 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33011ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza33011ze3z83_18479,
							(int) (((long) 0)), ((obj_t) BgL_ez00_3640));
						PROCEDURE_SET(BgL_zc3anonymousza33011ze3z83_18479,
							(int) (((long) 1)), BgL_ez00_3645);
						return BgL_zc3anonymousza33011ze3z83_18479;
					}
				}
			}
		}
	}



/* &<anonymous:3011> */
	obj_t BGl_z62zc3anonymousza33011ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19583, obj_t BgL_sz00_19586)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 391 */
			{	/* Eval/evaluate_comp.scm 391 */
				BgL_ev_defglobalz00_bglt BgL_i1098z00_19584;
				obj_t BgL_ez00_19585;

				BgL_i1098z00_19584 =
					((BgL_ev_defglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_19583, (int) (((long) 0))));
				BgL_ez00_19585 = PROCEDURE_REF(BgL_envz00_19583, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3646;

					BgL_sz00_3646 = BgL_sz00_19586;
					{	/* Eval/evaluate_comp.scm 391 */
						obj_t BgL_bpz00_3648;

						BgL_bpz00_3648 = VECTOR_REF(BgL_sz00_3646, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 392 */
							obj_t BgL_gz00_3649;

							{	/* Eval/evaluate_comp.scm 392 */
								obj_t BgL_arg3053z00_3675;
								obj_t BgL_arg3054z00_3676;

								BgL_arg3053z00_3675 =
									(((BgL_ev_setglobalz00_bglt) CREF(
											((BgL_ev_setglobalz00_bglt) BgL_i1098z00_19584)))->
									BgL_modz00);
								BgL_arg3054z00_3676 =
									(((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
												BgL_i1098z00_19584)))->BgL_namez00);
								BgL_gz00_3649 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00
									(BgL_arg3053z00_3675, BgL_arg3054z00_3676);
							}
							if (CBOOL(BgL_gz00_3649))
								{	/* Eval/evaluate_comp.scm 394 */
									{

										{	/* Eval/evaluate_comp.scm 396 */
											int BgL_aux1100z00_3651;

											{	/* Eval/evaluate_comp.scm 396 */
												int BgL_res4925z00_11612;

												{	/* Eval/evaluate_comp.scm 396 */
													int BgL_kz00_11611;

													BgL_kz00_11611 = (int) (((long) 0));
													BgL_res4925z00_11612 =
														CINT(VECTOR_REF(BgL_gz00_3649, BgL_kz00_11611));
												}
												BgL_aux1100z00_3651 = BgL_res4925z00_11612;
											}
											switch ((long) (BgL_aux1100z00_3651))
												{
												case ((long) 0):

													{	/* Eval/evaluate_comp.scm 398 */
														obj_t BgL_arg3013z00_3653;
														obj_t BgL_arg3014z00_3654;

														BgL_arg3013z00_3653 =
															(((BgL_ev_setglobalz00_bglt) CREF(
																	((BgL_ev_setglobalz00_bglt)
																		BgL_i1098z00_19584)))->BgL_locz00);
														BgL_arg3014z00_3654 =
															(((BgL_ev_setglobalz00_bglt)
																CREF(((BgL_ev_setglobalz00_bglt)
																		BgL_i1098z00_19584)))->BgL_namez00);
														BGl_everrorz00zz__everrorz00(BgL_arg3013z00_3653,
															BGl_string5716z00zz__evaluate_compz00,
															BGl_string5717z00zz__evaluate_compz00,
															BgL_arg3014z00_3654);
													} break;
												case ((long) 1):

													{	/* Eval/evaluate_comp.scm 400 */
														obj_t BgL_arg3016z00_3655;
														obj_t BgL_arg3017z00_3656;

														BgL_arg3016z00_3655 =
															(((BgL_ev_setglobalz00_bglt) CREF(
																	((BgL_ev_setglobalz00_bglt)
																		BgL_i1098z00_19584)))->BgL_locz00);
														BgL_arg3017z00_3656 =
															(((BgL_ev_setglobalz00_bglt)
																CREF(((BgL_ev_setglobalz00_bglt)
																		BgL_i1098z00_19584)))->BgL_namez00);
														{	/* Eval/evaluate_comp.scm 400 */
															obj_t BgL_list3018z00_3657;

															{	/* Eval/evaluate_comp.scm 400 */
																obj_t BgL_arg3020z00_3658;

																{	/* Eval/evaluate_comp.scm 400 */
																	obj_t BgL_arg3021z00_3659;

																	BgL_arg3021z00_3659 =
																		MAKE_PAIR(BgL_arg3017z00_3656, BNIL);
																	BgL_arg3020z00_3658 =
																		MAKE_PAIR
																		(BGl_string5718z00zz__evaluate_compz00,
																		BgL_arg3021z00_3659);
																}
																BgL_list3018z00_3657 =
																	MAKE_PAIR
																	(BGl_string5595z00zz__evaluate_compz00,
																	BgL_arg3020z00_3658);
															}
															BGl_evwarningz00zz__everrorz00
																(BgL_arg3016z00_3655, BgL_list3018z00_3657);
													}}
													{	/* Eval/evaluate_comp.scm 402 */
														obj_t BgL_arg3022z00_3660;
														obj_t BgL_arg3023z00_3661;

														BgL_arg3022z00_3660 =
															VECTOR_REF(BgL_gz00_3649, (int) (((long) 2)));
														BgL_arg3023z00_3661 =
															PROCEDURE_ENTRY(BgL_ez00_19585) (BgL_ez00_19585,
															BgL_sz00_3646, BEOA);
														__EVMEANING_ADDRESS_SET(BgL_arg3022z00_3660,
															BgL_arg3023z00_3661);
													} break;
												case ((long) 2):

													{	/* Eval/evaluate_comp.scm 404 */
														obj_t BgL_arg3033z00_3662;

														BgL_arg3033z00_3662 =
															PROCEDURE_ENTRY(BgL_ez00_19585) (BgL_ez00_19585,
															BgL_sz00_3646, BEOA);
														VECTOR_SET(BgL_gz00_3649, (int) (((long) 2)),
															BgL_arg3033z00_3662);
													} break;
												case ((long) 3):

													{	/* Eval/evaluate_comp.scm 406 */
														obj_t BgL_arg3035z00_3663;

														BgL_arg3035z00_3663 =
															PROCEDURE_ENTRY(BgL_ez00_19585) (BgL_ez00_19585,
															BgL_sz00_3646, BEOA);
														VECTOR_SET(BgL_gz00_3649, (int) (((long) 2)),
															BgL_arg3035z00_3663);
													}
													{	/* Eval/evaluate_comp.scm 407 */
														int BgL_tagz00_11627;

														BgL_tagz00_11627 = (int) (((long) 2));
														VECTOR_SET(BgL_gz00_3649,
															(int) (((long) 0)), BINT(BgL_tagz00_11627));
													} break;
												case ((long) 4):

													{	/* Eval/evaluate_comp.scm 409 */
														obj_t BgL_arg3036z00_3664;

														BgL_arg3036z00_3664 =
															PROCEDURE_ENTRY(BgL_ez00_19585) (BgL_ez00_19585,
															BgL_sz00_3646, BEOA);
														VECTOR_SET(BgL_gz00_3649, (int) (((long) 2)),
															BgL_arg3036z00_3664);
													}
													{	/* Eval/evaluate_comp.scm 410 */
														int BgL_tagz00_11637;

														BgL_tagz00_11637 = (int) (((long) 5));
														VECTOR_SET(BgL_gz00_3649,
															(int) (((long) 0)), BINT(BgL_tagz00_11637));
													} break;
												default:
													{	/* Eval/evaluate_comp.scm 412 */
														obj_t BgL_arg3038z00_3665;
														obj_t BgL_arg3039z00_3666;

														BgL_arg3038z00_3665 =
															(((BgL_ev_setglobalz00_bglt) CREF(
																	((BgL_ev_setglobalz00_bglt)
																		BgL_i1098z00_19584)))->BgL_locz00);
														BgL_arg3039z00_3666 =
															(((BgL_ev_setglobalz00_bglt)
																CREF(((BgL_ev_setglobalz00_bglt)
																		BgL_i1098z00_19584)))->BgL_namez00);
														BGl_everrorz00zz__everrorz00(BgL_arg3038z00_3665,
															BGl_string5716z00zz__evaluate_compz00,
															BGl_string5717z00zz__evaluate_compz00,
															BgL_arg3039z00_3666);
													}
												}
										}
									}
									return
										(((BgL_ev_setglobalz00_bglt) CREF(
												((BgL_ev_setglobalz00_bglt) BgL_i1098z00_19584)))->
										BgL_namez00);
								}
							else
								{	/* Eval/evaluate_comp.scm 414 */
									obj_t BgL_gz00_3667;

									{	/* Eval/evaluate_comp.scm 414 */
										obj_t BgL_arg3048z00_3672;
										obj_t BgL_arg3049z00_3673;
										obj_t BgL_arg3052z00_3674;

										BgL_arg3048z00_3672 =
											(((BgL_ev_setglobalz00_bglt) CREF(
													((BgL_ev_setglobalz00_bglt) BgL_i1098z00_19584)))->
											BgL_namez00);
										BgL_arg3049z00_3673 =
											(((BgL_ev_setglobalz00_bglt)
												CREF(((BgL_ev_setglobalz00_bglt) BgL_i1098z00_19584)))->
											BgL_modz00);
										BgL_arg3052z00_3674 =
											(((BgL_ev_setglobalz00_bglt)
												CREF(((BgL_ev_setglobalz00_bglt) BgL_i1098z00_19584)))->
											BgL_locz00);
										{	/* Eval/evaluate_comp.scm 414 */
											obj_t BgL_v1368z00_11644;

											BgL_v1368z00_11644 = create_vector((int) (((long) 5)));
											VECTOR_SET(BgL_v1368z00_11644,
												(int) (((long) 4)), BgL_arg3052z00_3674);
											VECTOR_SET(BgL_v1368z00_11644,
												(int) (((long) 3)), BgL_arg3049z00_3673);
											VECTOR_SET(BgL_v1368z00_11644,
												(int) (((long) 2)), BUNSPEC);
											VECTOR_SET(BgL_v1368z00_11644,
												(int) (((long) 1)), BgL_arg3048z00_3672);
											VECTOR_SET(BgL_v1368z00_11644,
												(int) (((long) 0)), BINT(((long) 2)));
											BgL_gz00_3667 = BgL_v1368z00_11644;
									}}
									{	/* Eval/evaluate_comp.scm 415 */
										obj_t BgL_arg3040z00_3668;

										BgL_arg3040z00_3668 =
											PROCEDURE_ENTRY(BgL_ez00_19585) (BgL_ez00_19585,
											BgL_sz00_3646, BEOA);
										VECTOR_SET(BgL_gz00_3667, (int) (((long) 2)),
											BgL_arg3040z00_3668);
									}
									{	/* Eval/evaluate_comp.scm 416 */
										obj_t BgL_arg3042z00_3669;
										obj_t BgL_arg3044z00_3670;
										obj_t BgL_arg3045z00_3671;

										BgL_arg3042z00_3669 =
											(((BgL_ev_setglobalz00_bglt) CREF(
													((BgL_ev_setglobalz00_bglt) BgL_i1098z00_19584)))->
											BgL_modz00);
										BgL_arg3044z00_3670 =
											(((BgL_ev_setglobalz00_bglt)
												CREF(((BgL_ev_setglobalz00_bglt) BgL_i1098z00_19584)))->
											BgL_namez00);
										BgL_arg3045z00_3671 =
											(((BgL_ev_setglobalz00_bglt)
												CREF(((BgL_ev_setglobalz00_bglt) BgL_i1098z00_19584)))->
											BgL_locz00);
										BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00
											(BgL_arg3042z00_3669, BgL_arg3044z00_3670, BgL_gz00_3667,
											BgL_arg3045z00_3671);
									}
									return
										(((BgL_ev_setglobalz00_bglt) CREF(
												((BgL_ev_setglobalz00_bglt) BgL_i1098z00_19584)))->
										BgL_namez00);
								}
						}
					}
				}
			}
		}
	}



/* &comp-ev_setglobal1390 */
	obj_t BGl_z62compzd2ev_setglobal1390zb0zz__evaluate_compz00(obj_t
		BgL_envz00_19587, obj_t BgL_ez00_19588, obj_t BgL_stkz00_19589)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 365 */
			{
				BgL_ev_setglobalz00_bglt BgL_ez00_3597;
				obj_t BgL_stkz00_3598;

				BgL_ez00_3597 = ((BgL_ev_setglobalz00_bglt) BgL_ez00_19588);
				BgL_stkz00_3598 = BgL_stkz00_19589;
				{	/* Eval/evaluate_comp.scm 367 */
					obj_t BgL_gz00_3602;
					obj_t BgL_ez00_3603;

					BgL_gz00_3602 =
						BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
						(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->BgL_modz00),
						(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->BgL_namez00));
					{	/* Eval/evaluate_comp.scm 367 */
						BgL_ev_exprz00_bglt BgL_arg3010z00_3638;

						BgL_arg3010z00_3638 =
							(((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_ez00_3597)))->BgL_ez00);
						BgL_ez00_3603 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3010z00_3638,
							BgL_stkz00_3598);
					}
					if (CBOOL(BgL_gz00_3602))
						{

							{	/* Eval/evaluate_comp.scm 369 */
								int BgL_aux1097z00_3605;

								{	/* Eval/evaluate_comp.scm 369 */
									int BgL_res4924z00_11567;

									{	/* Eval/evaluate_comp.scm 369 */
										int BgL_kz00_11566;

										BgL_kz00_11566 = (int) (((long) 0));
										BgL_res4924z00_11567 =
											CINT(VECTOR_REF(BgL_gz00_3602, BgL_kz00_11566));
									}
									BgL_aux1097z00_3605 = BgL_res4924z00_11567;
								}
								switch ((long) (BgL_aux1097z00_3605))
									{
									case ((long) 1):

										{	/* Eval/evaluate_comp.scm 371 */
											obj_t BgL_zc3anonymousza32965ze3z83_18482;

											BgL_zc3anonymousza32965ze3z83_18482 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza32965ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 2)));
											PROCEDURE_SET(BgL_zc3anonymousza32965ze3z83_18482,
												(int) (((long) 0)), BgL_gz00_3602);
											PROCEDURE_SET(BgL_zc3anonymousza32965ze3z83_18482,
												(int) (((long) 1)), BgL_ez00_3603);
											return BgL_zc3anonymousza32965ze3z83_18482;
										}
										break;
									case ((long) 0):
									case ((long) 4):
									case ((long) 5):

										return
											BGl_everrorz00zz__everrorz00(
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->
												BgL_locz00), BGl_string5716z00zz__evaluate_compz00,
											BGl_string5717z00zz__evaluate_compz00,
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->
												BgL_namez00));
										break;
									default:
										{	/* Eval/evaluate_comp.scm 376 */
											obj_t BgL_zc3anonymousza32970ze3z83_18483;

											BgL_zc3anonymousza32970ze3z83_18483 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza32970ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 2)));
											PROCEDURE_SET(BgL_zc3anonymousza32970ze3z83_18483,
												(int) (((long) 0)), BgL_ez00_3603);
											PROCEDURE_SET(BgL_zc3anonymousza32970ze3z83_18483,
												(int) (((long) 1)), BgL_gz00_3602);
											return BgL_zc3anonymousza32970ze3z83_18483;
										}
									}
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 377 */
							obj_t BgL_slotz00_3618;

							BgL_slotz00_3618 = MAKE_CELL(BFALSE);
							if (BGl_evmodulezf3zf3zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->
										BgL_modz00)))
								{	/* Eval/evaluate_comp.scm 379 */
									obj_t BgL_gz00_3620;

									{	/* Eval/evaluate_comp.scm 379 */
										obj_t BgL_arg2979z00_3624;
										obj_t BgL_arg2980z00_3625;
										obj_t BgL_arg2981z00_3626;

										BgL_arg2979z00_3624 =
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->
											BgL_namez00);
										BgL_arg2980z00_3625 =
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->
											BgL_modz00);
										BgL_arg2981z00_3626 =
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->
											BgL_locz00);
										{	/* Eval/evaluate_comp.scm 379 */
											obj_t BgL_v1368z00_11579;

											BgL_v1368z00_11579 = create_vector((int) (((long) 5)));
											VECTOR_SET(BgL_v1368z00_11579,
												(int) (((long) 4)), BgL_arg2981z00_3626);
											VECTOR_SET(BgL_v1368z00_11579,
												(int) (((long) 3)), BgL_arg2980z00_3625);
											VECTOR_SET(BgL_v1368z00_11579,
												(int) (((long) 2)), BUNSPEC);
											VECTOR_SET(BgL_v1368z00_11579,
												(int) (((long) 1)), BgL_arg2979z00_3624);
											VECTOR_SET(BgL_v1368z00_11579,
												(int) (((long) 0)), BINT(((long) 2)));
											BgL_gz00_3620 = BgL_v1368z00_11579;
									}}
									{	/* Eval/evaluate_comp.scm 380 */
										int BgL_tagz00_11596;

										BgL_tagz00_11596 = (int) (((long) 3));
										VECTOR_SET(BgL_gz00_3620,
											(int) (((long) 0)), BINT(BgL_tagz00_11596));
									}
									BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
										(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->
											BgL_modz00),
										(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->
											BgL_namez00), BgL_gz00_3620,
										(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_3597))->
											BgL_locz00));
								}
							else
								{	/* Eval/evaluate_comp.scm 378 */
									BFALSE;
								}
							{	/* Eval/evaluate_comp.scm 382 */
								obj_t BgL_zc3anonymousza32983ze3z83_18481;

								BgL_zc3anonymousza32983ze3z83_18481 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32983ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3anonymousza32983ze3z83_18481,
									(int) (((long) 0)), ((obj_t) BgL_ez00_3597));
								PROCEDURE_SET(BgL_zc3anonymousza32983ze3z83_18481,
									(int) (((long) 1)), BgL_slotz00_3618);
								PROCEDURE_SET(BgL_zc3anonymousza32983ze3z83_18481,
									(int) (((long) 2)), BgL_ez00_3603);
								return BgL_zc3anonymousza32983ze3z83_18481;
							}
						}
				}
			}
		}
	}



/* &<anonymous:2965> */
	obj_t BGl_z62zc3anonymousza32965ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19590, obj_t BgL_sz00_19593)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 371 */
			{	/* Eval/evaluate_comp.scm 371 */
				obj_t BgL_gz00_19591;
				obj_t BgL_ez00_19592;

				BgL_gz00_19591 = PROCEDURE_REF(BgL_envz00_19590, (int) (((long) 0)));
				BgL_ez00_19592 = PROCEDURE_REF(BgL_envz00_19590, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3607;

					BgL_sz00_3607 = BgL_sz00_19593;
					{	/* Eval/evaluate_comp.scm 371 */
						obj_t BgL_bpz00_11568;

						BgL_bpz00_11568 = VECTOR_REF(BgL_sz00_3607, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 372 */
							obj_t BgL_arg2966z00_11569;
							obj_t BgL_arg2967z00_11570;

							BgL_arg2966z00_11569 =
								VECTOR_REF(BgL_gz00_19591, (int) (((long) 2)));
							BgL_arg2967z00_11570 =
								PROCEDURE_ENTRY(BgL_ez00_19592) (BgL_ez00_19592, BgL_sz00_3607,
								BEOA);
							return __EVMEANING_ADDRESS_SET(BgL_arg2966z00_11569,
								BgL_arg2967z00_11570);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2970> */
	obj_t BGl_z62zc3anonymousza32970ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19594, obj_t BgL_sz00_19597)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 376 */
			{	/* Eval/evaluate_comp.scm 376 */
				obj_t BgL_ez00_19595;
				obj_t BgL_gz00_19596;

				BgL_ez00_19595 = PROCEDURE_REF(BgL_envz00_19594, (int) (((long) 0)));
				BgL_gz00_19596 = PROCEDURE_REF(BgL_envz00_19594, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3614;

					BgL_sz00_3614 = BgL_sz00_19597;
					{	/* Eval/evaluate_comp.scm 376 */
						obj_t BgL_bpz00_11555;

						BgL_bpz00_11555 = VECTOR_REF(BgL_sz00_3614, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 376 */
							obj_t BgL_arg2971z00_11556;

							BgL_arg2971z00_11556 =
								PROCEDURE_ENTRY(BgL_ez00_19595) (BgL_ez00_19595, BgL_sz00_3614,
								BEOA);
							return VECTOR_SET(BgL_gz00_19596, (int) (((long) 2)),
								BgL_arg2971z00_11556);
		}}}}}
	}



/* &<anonymous:2983> */
	obj_t BGl_z62zc3anonymousza32983ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19598, obj_t BgL_sz00_19602)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 382 */
			{	/* Eval/evaluate_comp.scm 382 */
				BgL_ev_setglobalz00_bglt BgL_i1095z00_19599;
				obj_t BgL_slotz00_19600;
				obj_t BgL_ez00_19601;

				BgL_i1095z00_19599 =
					((BgL_ev_setglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_19598, (int) (((long) 0))));
				BgL_slotz00_19600 = PROCEDURE_REF(BgL_envz00_19598, (int) (((long) 1)));
				BgL_ez00_19601 = PROCEDURE_REF(BgL_envz00_19598, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3628;

					BgL_sz00_3628 = BgL_sz00_19602;
					{	/* Eval/evaluate_comp.scm 382 */
						obj_t BgL_bpz00_3630;

						BgL_bpz00_3630 = VECTOR_REF(BgL_sz00_3628, (int) (((long) 0)));
						if (CBOOL(CELL_REF(BgL_slotz00_19600)))
							{	/* Eval/evaluate_comp.scm 383 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 383 */
								{	/* Eval/evaluate_comp.scm 384 */
									obj_t BgL_auxz00_19603;

									BgL_auxz00_19603 =
										BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
										(((BgL_ev_setglobalz00_bglt) CREF(BgL_i1095z00_19599))->
											BgL_modz00),
										(((BgL_ev_setglobalz00_bglt) CREF(BgL_i1095z00_19599))->
											BgL_namez00));
									CELL_SET(BgL_slotz00_19600, BgL_auxz00_19603);
								}
								if (CBOOL(CELL_REF(BgL_slotz00_19600)))
									{	/* Eval/evaluate_comp.scm 385 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 385 */
										BGl_everrorz00zz__everrorz00(
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_i1095z00_19599))->
												BgL_locz00), BGl_string5595z00zz__evaluate_compz00,
											BGl_string5719z00zz__evaluate_compz00,
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_i1095z00_19599))->
												BgL_namez00));
									}
							}
						{	/* Eval/evaluate_comp.scm 386 */
							obj_t BgL_arg3001z00_3635;

							BgL_arg3001z00_3635 =
								PROCEDURE_ENTRY(BgL_ez00_19601) (BgL_ez00_19601, BgL_sz00_3628,
								BEOA);
							{	/* Eval/evaluate_comp.scm 386 */
								obj_t BgL_evalzd2globalzd2_11602;

								BgL_evalzd2globalzd2_11602 = CELL_REF(BgL_slotz00_19600);
								return
									VECTOR_SET(BgL_evalzd2globalzd2_11602,
									(int) (((long) 2)), BgL_arg3001z00_3635);
		}}}}}}
	}



/* &comp-ev_global1388 */
	obj_t BGl_z62compzd2ev_global1388zb0zz__evaluate_compz00(obj_t
		BgL_envz00_19604, obj_t BgL_varz00_19605, obj_t BgL_stkz00_19606)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 339 */
			{
				BgL_ev_globalz00_bglt BgL_varz00_3555;
				obj_t BgL_stkz00_3556;

				BgL_varz00_3555 = ((BgL_ev_globalz00_bglt) BgL_varz00_19605);
				BgL_stkz00_3556 = BgL_stkz00_19606;
				{	/* Eval/evaluate_comp.scm 341 */
					obj_t BgL_gz00_3560;

					BgL_gz00_3560 =
						BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
						(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_3555))->BgL_modz00),
						(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_3555))->BgL_namez00));
					if (CBOOL(BgL_gz00_3560))
						{	/* Eval/evaluate_comp.scm 343 */
							bool_t BgL_testz00_35726;

							{	/* Eval/evaluate_comp.scm 343 */
								int BgL_arg2941z00_3569;

								{	/* Eval/evaluate_comp.scm 343 */
									int BgL_res4920z00_11502;

									{	/* Eval/evaluate_comp.scm 343 */
										int BgL_kz00_11501;

										BgL_kz00_11501 = (int) (((long) 0));
										BgL_res4920z00_11502 =
											CINT(VECTOR_REF(BgL_gz00_3560, BgL_kz00_11501));
									}
									BgL_arg2941z00_3569 = BgL_res4920z00_11502;
								}
								BgL_testz00_35726 =
									(BINT(BgL_arg2941z00_3569) == BINT(((long) 1)));
							}
							if (BgL_testz00_35726)
								{	/* Eval/evaluate_comp.scm 344 */
									obj_t BgL_zc3anonymousza32937ze3z83_18485;

									BgL_zc3anonymousza32937ze3z83_18485 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza32937ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3anonymousza32937ze3z83_18485,
										(int) (((long) 0)), BgL_gz00_3560);
									return BgL_zc3anonymousza32937ze3z83_18485;
								}
							else
								{	/* Eval/evaluate_comp.scm 346 */
									obj_t BgL_zc3anonymousza32939ze3z83_18486;

									BgL_zc3anonymousza32939ze3z83_18486 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza32939ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3anonymousza32939ze3z83_18486,
										(int) (((long) 0)), BgL_gz00_3560);
									return BgL_zc3anonymousza32939ze3z83_18486;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 348 */
							obj_t BgL_slotz00_3570;

							BgL_slotz00_3570 = MAKE_CELL(BFALSE);
							if (BGl_evmodulezf3zf3zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_3555))->
										BgL_modz00)))
								{	/* Eval/evaluate_comp.scm 350 */
									obj_t BgL_gz00_3572;

									{	/* Eval/evaluate_comp.scm 350 */
										obj_t BgL_arg2946z00_3576;
										obj_t BgL_arg2947z00_3577;
										obj_t BgL_arg2948z00_3578;

										BgL_arg2946z00_3576 =
											(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_3555))->
											BgL_namez00);
										BgL_arg2947z00_3577 =
											(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_3555))->
											BgL_modz00);
										BgL_arg2948z00_3578 =
											(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_3555))->
											BgL_locz00);
										{	/* Eval/evaluate_comp.scm 350 */
											obj_t BgL_v1368z00_11519;

											BgL_v1368z00_11519 = create_vector((int) (((long) 5)));
											VECTOR_SET(BgL_v1368z00_11519,
												(int) (((long) 4)), BgL_arg2948z00_3578);
											VECTOR_SET(BgL_v1368z00_11519,
												(int) (((long) 3)), BgL_arg2947z00_3577);
											VECTOR_SET(BgL_v1368z00_11519,
												(int) (((long) 2)), BUNSPEC);
											VECTOR_SET(BgL_v1368z00_11519,
												(int) (((long) 1)), BgL_arg2946z00_3576);
											VECTOR_SET(BgL_v1368z00_11519,
												(int) (((long) 0)), BINT(((long) 2)));
											BgL_gz00_3572 = BgL_v1368z00_11519;
									}}
									{	/* Eval/evaluate_comp.scm 351 */
										int BgL_tagz00_11536;

										BgL_tagz00_11536 = (int) (((long) 3));
										VECTOR_SET(BgL_gz00_3572,
											(int) (((long) 0)), BINT(BgL_tagz00_11536));
									}
									BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
										(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_3555))->
											BgL_modz00),
										(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_3555))->
											BgL_namez00), BgL_gz00_3572,
										(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_3555))->
											BgL_locz00));
								}
							else
								{	/* Eval/evaluate_comp.scm 349 */
									BFALSE;
								}
							{	/* Eval/evaluate_comp.scm 353 */
								obj_t BgL_zc3anonymousza32950ze3z83_18487;

								BgL_zc3anonymousza32950ze3z83_18487 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32950ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_zc3anonymousza32950ze3z83_18487,
									(int) (((long) 0)), ((obj_t) BgL_varz00_3555));
								PROCEDURE_SET(BgL_zc3anonymousza32950ze3z83_18487,
									(int) (((long) 1)), BgL_slotz00_3570);
								return BgL_zc3anonymousza32950ze3z83_18487;
							}
						}
				}
			}
		}
	}



/* &<anonymous:2937> */
	obj_t BGl_z62zc3anonymousza32937ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19607, obj_t BgL_sz00_19609)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 344 */
			{	/* Eval/evaluate_comp.scm 344 */
				obj_t BgL_gz00_19608;

				BgL_gz00_19608 = PROCEDURE_REF(BgL_envz00_19607, (int) (((long) 0)));
				{
					obj_t BgL_sz00_3562;

					BgL_sz00_3562 = BgL_sz00_19609;
					{	/* Eval/evaluate_comp.scm 344 */
						obj_t BgL_bpz00_11503;

						BgL_bpz00_11503 = VECTOR_REF(BgL_sz00_3562, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 345 */
							obj_t BgL_auxz00_35783;

							BgL_auxz00_35783 = VECTOR_REF(BgL_gz00_19608, (int) (((long) 2)));
							return __EVMEANING_ADDRESS_REF(BgL_auxz00_35783);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2939> */
	obj_t BGl_z62zc3anonymousza32939ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19610, obj_t BgL_sz00_19612)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 346 */
			{	/* Eval/evaluate_comp.scm 346 */
				obj_t BgL_gz00_19611;

				BgL_gz00_19611 = PROCEDURE_REF(BgL_envz00_19610, (int) (((long) 0)));
				{
					obj_t BgL_sz00_3566;

					BgL_sz00_3566 = BgL_sz00_19612;
					{	/* Eval/evaluate_comp.scm 346 */
						obj_t BgL_bpz00_11510;

						BgL_bpz00_11510 = VECTOR_REF(BgL_sz00_3566, (int) (((long) 0)));
						return VECTOR_REF(BgL_gz00_19611, (int) (((long) 2)));
		}}}}
	}



/* &<anonymous:2950> */
	obj_t BGl_z62zc3anonymousza32950ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19613, obj_t BgL_sz00_19616)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 353 */
			{	/* Eval/evaluate_comp.scm 353 */
				BgL_ev_globalz00_bglt BgL_i1094z00_19614;
				obj_t BgL_slotz00_19615;

				BgL_i1094z00_19614 =
					((BgL_ev_globalz00_bglt)
					PROCEDURE_REF(BgL_envz00_19613, (int) (((long) 0))));
				BgL_slotz00_19615 = PROCEDURE_REF(BgL_envz00_19613, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3580;

					BgL_sz00_3580 = BgL_sz00_19616;
					{	/* Eval/evaluate_comp.scm 353 */
						obj_t BgL_bpz00_3582;

						BgL_bpz00_3582 = VECTOR_REF(BgL_sz00_3580, (int) (((long) 0)));
						if (CBOOL(CELL_REF(BgL_slotz00_19615)))
							{	/* Eval/evaluate_comp.scm 354 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 354 */
								{	/* Eval/evaluate_comp.scm 355 */
									obj_t BgL_auxz00_19617;

									BgL_auxz00_19617 =
										BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
										(((BgL_ev_globalz00_bglt) CREF(BgL_i1094z00_19614))->
											BgL_modz00),
										(((BgL_ev_globalz00_bglt) CREF(BgL_i1094z00_19614))->
											BgL_namez00));
									CELL_SET(BgL_slotz00_19615, BgL_auxz00_19617);
								}
								if (CBOOL(CELL_REF(BgL_slotz00_19615)))
									{	/* Eval/evaluate_comp.scm 356 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 356 */
										BGl_everrorz00zz__everrorz00(
											(((BgL_ev_globalz00_bglt) CREF(BgL_i1094z00_19614))->
												BgL_locz00), BGl_string5595z00zz__evaluate_compz00,
											BGl_string5719z00zz__evaluate_compz00,
											(((BgL_ev_globalz00_bglt) CREF(BgL_i1094z00_19614))->
												BgL_namez00));
									}
							}
						{	/* Eval/evaluate_comp.scm 357 */
							obj_t BgL_vz00_3587;

							{	/* Eval/evaluate_comp.scm 357 */
								obj_t BgL_evalzd2globalzd2_11542;

								BgL_evalzd2globalzd2_11542 = CELL_REF(BgL_slotz00_19615);
								BgL_vz00_3587 =
									VECTOR_REF(BgL_evalzd2globalzd2_11542, (int) (((long) 2)));
							}
							if ((BgL_vz00_3587 == BUNSPEC))
								{	/* Eval/evaluate_comp.scm 359 */
									int BgL_tz00_3589;

									{	/* Eval/evaluate_comp.scm 359 */
										int BgL_res4921z00_11548;

										{	/* Eval/evaluate_comp.scm 359 */
											obj_t BgL_evalzd2globalzd2_11545;

											BgL_evalzd2globalzd2_11545 = CELL_REF(BgL_slotz00_19615);
											{	/* Eval/evaluate_comp.scm 359 */
												int BgL_kz00_11547;

												BgL_kz00_11547 = (int) (((long) 0));
												BgL_res4921z00_11548 =
													CINT(VECTOR_REF(BgL_evalzd2globalzd2_11545,
														BgL_kz00_11547));
										}}
										BgL_tz00_3589 = BgL_res4921z00_11548;
									}
									{	/* Eval/evaluate_comp.scm 360 */
										bool_t BgL_testz00_35817;

										if (((long) (BgL_tz00_3589) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 360 */
												BgL_testz00_35817 = ((bool_t) 1);
											}
										else
											{	/* Eval/evaluate_comp.scm 360 */
												BgL_testz00_35817 =
													((long) (BgL_tz00_3589) == ((long) 4));
											}
										if (BgL_testz00_35817)
											{	/* Eval/evaluate_comp.scm 360 */
												return
													BGl_everrorz00zz__everrorz00(
													(((BgL_ev_globalz00_bglt) CREF(BgL_i1094z00_19614))->
														BgL_locz00), BGl_string5595z00zz__evaluate_compz00,
													BGl_string5720z00zz__evaluate_compz00,
													(((BgL_ev_globalz00_bglt) CREF(BgL_i1094z00_19614))->
														BgL_namez00));
											}
										else
											{	/* Eval/evaluate_comp.scm 360 */
												return BgL_vz00_3587;
											}
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 358 */
									return BgL_vz00_3587;
								}
						}
					}
				}
			}
		}
	}



/* &comp-ev_setlocal1386 */
	obj_t BGl_z62compzd2ev_setlocal1386zb0zz__evaluate_compz00(obj_t
		BgL_envz00_19618, obj_t BgL_ez00_19619, obj_t BgL_stkz00_19620)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 321 */
			{
				BgL_ev_setlocalz00_bglt BgL_ez00_3532;
				obj_t BgL_stkz00_3533;

				BgL_ez00_3532 = ((BgL_ev_setlocalz00_bglt) BgL_ez00_19619);
				BgL_stkz00_3533 = BgL_stkz00_19620;
				{	/* Eval/evaluate_comp.scm 323 */
					obj_t BgL_iz00_3537;
					obj_t BgL_ez00_3538;

					{	/* Eval/evaluate_comp.scm 323 */
						BgL_ev_varz00_bglt BgL_arg2934z00_3552;

						BgL_arg2934z00_3552 =
							(((BgL_ev_setlocalz00_bglt) CREF(BgL_ez00_3532))->BgL_vz00);
						BgL_iz00_3537 =
							BGl__indexz00zz__evaluate_compz00(
							((obj_t) BgL_arg2934z00_3552), BgL_stkz00_3533);
					}
					{	/* Eval/evaluate_comp.scm 323 */
						BgL_ev_exprz00_bglt BgL_arg2935z00_3553;

						BgL_arg2935z00_3553 =
							(((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_ez00_3532)))->BgL_ez00);
						BgL_ez00_3538 =
							BGl_compz00zz__evaluate_compz00(BgL_arg2935z00_3553,
							BgL_stkz00_3533);
					}
					if (CBOOL(
							(((BgL_ev_varz00_bglt) CREF(
										(((BgL_ev_setlocalz00_bglt) CREF(BgL_ez00_3532))->
											BgL_vz00)))->BgL_effz00)))
						{	/* Eval/evaluate_comp.scm 326 */
							obj_t BgL_zc3anonymousza32912ze3z83_18489;

							BgL_zc3anonymousza32912ze3z83_18489 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza32912ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_zc3anonymousza32912ze3z83_18489,
								(int) (((long) 0)), BgL_iz00_3537);
							PROCEDURE_SET(BgL_zc3anonymousza32912ze3z83_18489,
								(int) (((long) 1)), BgL_ez00_3538);
							return BgL_zc3anonymousza32912ze3z83_18489;
						}
					else
						{	/* Eval/evaluate_comp.scm 328 */
							obj_t BgL_zc3anonymousza32928ze3z83_18490;

							BgL_zc3anonymousza32928ze3z83_18490 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza32928ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_zc3anonymousza32928ze3z83_18490,
								(int) (((long) 0)), BgL_iz00_3537);
							PROCEDURE_SET(BgL_zc3anonymousza32928ze3z83_18490,
								(int) (((long) 1)), BgL_ez00_3538);
							return BgL_zc3anonymousza32928ze3z83_18490;
						}
				}
			}
		}
	}



/* &<anonymous:2912> */
	obj_t BGl_z62zc3anonymousza32912ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19621, obj_t BgL_sz00_19624)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 326 */
			{	/* Eval/evaluate_comp.scm 326 */
				obj_t BgL_iz00_19622;
				obj_t BgL_ez00_19623;

				BgL_iz00_19622 = PROCEDURE_REF(BgL_envz00_19621, (int) (((long) 0)));
				BgL_ez00_19623 = PROCEDURE_REF(BgL_envz00_19621, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3541;

					BgL_sz00_3541 = BgL_sz00_19624;
					{	/* Eval/evaluate_comp.scm 326 */
						obj_t BgL_bpz00_11472;

						BgL_bpz00_11472 = VECTOR_REF(BgL_sz00_3541, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 327 */
							obj_t BgL_arg2925z00_11473;
							obj_t BgL_arg2926z00_11474;

							{	/* Eval/evaluate_comp.scm 327 */
								long BgL_arg2927z00_11475;

								BgL_arg2927z00_11475 =
									((long) CINT(BgL_bpz00_11472) + (long) CINT(BgL_iz00_19622));
								BgL_arg2925z00_11473 =
									VECTOR_REF(BgL_sz00_3541, (int) (BgL_arg2927z00_11475));
							}
							BgL_arg2926z00_11474 =
								PROCEDURE_ENTRY(BgL_ez00_19623) (BgL_ez00_19623, BgL_sz00_3541,
								BEOA);
							{	/* Eval/evaluate_comp.scm 202 */
								obj_t BgL_xz00_19681;

								{	/* Eval/evaluate_comp.scm 202 */
									int BgL_auxz00_35866;

									BgL_auxz00_35866 = (int) (((long) 0));
									BgL_xz00_19681 =
										STRUCT_SET(BgL_arg2925z00_11473, BgL_auxz00_35866,
										BgL_arg2926z00_11474);
								}
								return BUNSPEC;
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2928> */
	obj_t BGl_z62zc3anonymousza32928ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19625, obj_t BgL_sz00_19628)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 328 */
			{	/* Eval/evaluate_comp.scm 328 */
				obj_t BgL_iz00_19626;
				obj_t BgL_ez00_19627;

				BgL_iz00_19626 = PROCEDURE_REF(BgL_envz00_19625, (int) (((long) 0)));
				BgL_ez00_19627 = PROCEDURE_REF(BgL_envz00_19625, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3547;

					BgL_sz00_3547 = BgL_sz00_19628;
					{	/* Eval/evaluate_comp.scm 328 */
						obj_t BgL_bpz00_11488;

						BgL_bpz00_11488 = VECTOR_REF(BgL_sz00_3547, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 329 */
							long BgL_arg2929z00_11489;
							obj_t BgL_arg2930z00_11490;

							BgL_arg2929z00_11489 =
								((long) CINT(BgL_bpz00_11488) + (long) CINT(BgL_iz00_19626));
							BgL_arg2930z00_11490 =
								PROCEDURE_ENTRY(BgL_ez00_19627) (BgL_ez00_19627, BgL_sz00_3547,
								BEOA);
							return VECTOR_SET(BgL_sz00_3547, (int) (BgL_arg2929z00_11489),
								BgL_arg2930z00_11490);
		}}}}}
	}



/* &comp-ev_var1384 */
	obj_t BGl_z62compzd2ev_var1384zb0zz__evaluate_compz00(obj_t BgL_envz00_19629,
		obj_t BgL_varz00_19630, obj_t BgL_stkz00_19631)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 316 */
			{
				BgL_ev_varz00_bglt BgL_varz00_3472;
				obj_t BgL_stkz00_3473;

				BgL_varz00_3472 = ((BgL_ev_varz00_bglt) BgL_varz00_19630);
				BgL_stkz00_3473 = BgL_stkz00_19631;
				{	/* Eval/evaluate_comp.scm 317 */
					obj_t BgL_iz00_3476;

					BgL_iz00_3476 =
						BGl__indexz00zz__evaluate_compz00(
						((obj_t) BgL_varz00_3472), BgL_stkz00_3473);
					{

						if (INTEGERP(BgL_iz00_3476))
							{	/* Eval/evaluate_comp.scm 319 */
								switch ((long) CINT(BgL_iz00_3476))
									{
									case ((long) 0):

										if (CBOOL(
												(((BgL_ev_varz00_bglt) CREF(BgL_varz00_3472))->
													BgL_effz00)))
											{	/* Eval/evaluate_comp.scm 319 */
												return BGl_proc5721z00zz__evaluate_compz00;
											}
										else
											{	/* Eval/evaluate_comp.scm 319 */
												return BGl_proc5722z00zz__evaluate_compz00;
											}
										break;
									case ((long) 1):

										if (CBOOL(
												(((BgL_ev_varz00_bglt) CREF(BgL_varz00_3472))->
													BgL_effz00)))
											{	/* Eval/evaluate_comp.scm 319 */
												return BGl_proc5723z00zz__evaluate_compz00;
											}
										else
											{	/* Eval/evaluate_comp.scm 319 */
												return BGl_proc5724z00zz__evaluate_compz00;
											}
										break;
									case ((long) 2):

										if (CBOOL(
												(((BgL_ev_varz00_bglt) CREF(BgL_varz00_3472))->
													BgL_effz00)))
											{	/* Eval/evaluate_comp.scm 319 */
												return BGl_proc5725z00zz__evaluate_compz00;
											}
										else
											{	/* Eval/evaluate_comp.scm 319 */
												return BGl_proc5726z00zz__evaluate_compz00;
											}
										break;
									case ((long) 3):

										if (CBOOL(
												(((BgL_ev_varz00_bglt) CREF(BgL_varz00_3472))->
													BgL_effz00)))
											{	/* Eval/evaluate_comp.scm 319 */
												return BGl_proc5727z00zz__evaluate_compz00;
											}
										else
											{	/* Eval/evaluate_comp.scm 319 */
												return BGl_proc5728z00zz__evaluate_compz00;
											}
										break;
									default:
									BgL_case_else1089z00_3478:
										if (CBOOL(
												(((BgL_ev_varz00_bglt) CREF(BgL_varz00_3472))->
													BgL_effz00)))
											{	/* Eval/evaluate_comp.scm 319 */
												obj_t BgL_zc3anonymousza32894ze3z83_18501;

												BgL_zc3anonymousza32894ze3z83_18501 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3anonymousza32894ze3ze1zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 1)));
												PROCEDURE_SET(BgL_zc3anonymousza32894ze3z83_18501,
													(int) (((long) 0)), BgL_iz00_3476);
												return BgL_zc3anonymousza32894ze3z83_18501;
											}
										else
											{	/* Eval/evaluate_comp.scm 319 */
												obj_t BgL_zc3anonymousza32900ze3z83_18500;

												BgL_zc3anonymousza32900ze3z83_18500 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3anonymousza32900ze3ze1zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 1)));
												PROCEDURE_SET(BgL_zc3anonymousza32900ze3z83_18500,
													(int) (((long) 0)), BgL_iz00_3476);
												return BgL_zc3anonymousza32900ze3z83_18500;
											}
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 319 */
								goto BgL_case_else1089z00_3478;
							}
					}
				}
			}
		}
	}



/* &<anonymous:2887> */
	obj_t BGl_z62zc3anonymousza32887ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19632, obj_t BgL_sz00_19633)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 319 */
			{
				obj_t BgL_sz00_3512;

				BgL_sz00_3512 = BgL_sz00_19633;
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_11450;

					BgL_bpz00_11450 = VECTOR_REF(BgL_sz00_3512, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_arg2888z00_11451;

						{	/* Eval/evaluate_comp.scm 319 */
							long BgL_arg2890z00_11452;

							BgL_arg2890z00_11452 =
								((long) CINT(BgL_bpz00_11450) + ((long) 3));
							BgL_arg2888z00_11451 =
								VECTOR_REF(BgL_sz00_3512, (int) (BgL_arg2890z00_11452));
						}
						return STRUCT_REF(BgL_arg2888z00_11451, (int) (((long) 0)));
		}}}}
	}



/* &<anonymous:2891> */
	obj_t BGl_z62zc3anonymousza32891ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19634, obj_t BgL_sz00_19635)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 319 */
			{
				obj_t BgL_sz00_3517;

				BgL_sz00_3517 = BgL_sz00_19635;
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_11463;

					BgL_bpz00_11463 = VECTOR_REF(BgL_sz00_3517, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2892z00_11464;

						BgL_arg2892z00_11464 = ((long) CINT(BgL_bpz00_11463) + ((long) 3));
						return VECTOR_REF(BgL_sz00_3517, (int) (BgL_arg2892z00_11464));
		}}}}
	}



/* &<anonymous:2880> */
	obj_t BGl_z62zc3anonymousza32880ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19636, obj_t BgL_sz00_19637)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 319 */
			{
				obj_t BgL_sz00_3502;

				BgL_sz00_3502 = BgL_sz00_19637;
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_11428;

					BgL_bpz00_11428 = VECTOR_REF(BgL_sz00_3502, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_arg2882z00_11429;

						{	/* Eval/evaluate_comp.scm 319 */
							long BgL_arg2883z00_11430;

							BgL_arg2883z00_11430 =
								((long) CINT(BgL_bpz00_11428) + ((long) 2));
							BgL_arg2882z00_11429 =
								VECTOR_REF(BgL_sz00_3502, (int) (BgL_arg2883z00_11430));
						}
						return STRUCT_REF(BgL_arg2882z00_11429, (int) (((long) 0)));
		}}}}
	}



/* &<anonymous:2884> */
	obj_t BGl_z62zc3anonymousza32884ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19638, obj_t BgL_sz00_19639)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 319 */
			{
				obj_t BgL_sz00_3507;

				BgL_sz00_3507 = BgL_sz00_19639;
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_11441;

					BgL_bpz00_11441 = VECTOR_REF(BgL_sz00_3507, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2885z00_11442;

						BgL_arg2885z00_11442 = ((long) CINT(BgL_bpz00_11441) + ((long) 2));
						return VECTOR_REF(BgL_sz00_3507, (int) (BgL_arg2885z00_11442));
		}}}}
	}



/* &<anonymous:2874> */
	obj_t BGl_z62zc3anonymousza32874ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19640, obj_t BgL_sz00_19641)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 319 */
			{
				obj_t BgL_sz00_3492;

				BgL_sz00_3492 = BgL_sz00_19641;
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_11406;

					BgL_bpz00_11406 = VECTOR_REF(BgL_sz00_3492, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_arg2875z00_11407;

						{	/* Eval/evaluate_comp.scm 319 */
							long BgL_arg2876z00_11408;

							BgL_arg2876z00_11408 =
								((long) CINT(BgL_bpz00_11406) + ((long) 1));
							BgL_arg2875z00_11407 =
								VECTOR_REF(BgL_sz00_3492, (int) (BgL_arg2876z00_11408));
						}
						return STRUCT_REF(BgL_arg2875z00_11407, (int) (((long) 0)));
		}}}}
	}



/* &<anonymous:2877> */
	obj_t BGl_z62zc3anonymousza32877ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19642, obj_t BgL_sz00_19643)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 319 */
			{
				obj_t BgL_sz00_3497;

				BgL_sz00_3497 = BgL_sz00_19643;
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_11419;

					BgL_bpz00_11419 = VECTOR_REF(BgL_sz00_3497, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2878z00_11420;

						BgL_arg2878z00_11420 = ((long) CINT(BgL_bpz00_11419) + ((long) 1));
						return VECTOR_REF(BgL_sz00_3497, (int) (BgL_arg2878z00_11420));
		}}}}
	}



/* &<anonymous:2868> */
	obj_t BGl_z62zc3anonymousza32868ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19644, obj_t BgL_sz00_19645)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 319 */
			{
				obj_t BgL_sz00_3482;

				BgL_sz00_3482 = BgL_sz00_19645;
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_11384;

					BgL_bpz00_11384 = VECTOR_REF(BgL_sz00_3482, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_arg2869z00_11385;

						{	/* Eval/evaluate_comp.scm 319 */
							long BgL_arg2870z00_11386;

							BgL_arg2870z00_11386 =
								((long) CINT(BgL_bpz00_11384) + ((long) 0));
							BgL_arg2869z00_11385 =
								VECTOR_REF(BgL_sz00_3482, (int) (BgL_arg2870z00_11386));
						}
						return STRUCT_REF(BgL_arg2869z00_11385, (int) (((long) 0)));
		}}}}
	}



/* &<anonymous:2871> */
	obj_t BGl_z62zc3anonymousza32871ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19646, obj_t BgL_sz00_19647)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 319 */
			{
				obj_t BgL_sz00_3487;

				BgL_sz00_3487 = BgL_sz00_19647;
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_11397;

					BgL_bpz00_11397 = VECTOR_REF(BgL_sz00_3487, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2872z00_11398;

						BgL_arg2872z00_11398 = ((long) CINT(BgL_bpz00_11397) + ((long) 0));
						return VECTOR_REF(BgL_sz00_3487, (int) (BgL_arg2872z00_11398));
		}}}}
	}



/* &<anonymous:2894> */
	obj_t BGl_z62zc3anonymousza32894ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19648, obj_t BgL_sz00_19650)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_19649;

				BgL_iz00_19649 = PROCEDURE_REF(BgL_envz00_19648, (int) (((long) 0)));
				{
					obj_t BgL_sz00_3522;

					BgL_sz00_3522 = BgL_sz00_19650;
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_bpz00_11362;

						BgL_bpz00_11362 = VECTOR_REF(BgL_sz00_3522, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 319 */
							obj_t BgL_arg2898z00_11363;

							{	/* Eval/evaluate_comp.scm 319 */
								long BgL_arg2899z00_11364;

								BgL_arg2899z00_11364 =
									((long) CINT(BgL_bpz00_11362) + (long) CINT(BgL_iz00_19649));
								BgL_arg2898z00_11363 =
									VECTOR_REF(BgL_sz00_3522, (int) (BgL_arg2899z00_11364));
							}
							return STRUCT_REF(BgL_arg2898z00_11363, (int) (((long) 0)));
		}}}}}
	}



/* &<anonymous:2900> */
	obj_t BGl_z62zc3anonymousza32900ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19651, obj_t BgL_sz00_19653)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_19652;

				BgL_iz00_19652 = PROCEDURE_REF(BgL_envz00_19651, (int) (((long) 0)));
				{
					obj_t BgL_sz00_3527;

					BgL_sz00_3527 = BgL_sz00_19653;
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_bpz00_11375;

						BgL_bpz00_11375 = VECTOR_REF(BgL_sz00_3527, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 319 */
							long BgL_arg2910z00_11376;

							BgL_arg2910z00_11376 =
								((long) CINT(BgL_bpz00_11375) + (long) CINT(BgL_iz00_19652));
							return VECTOR_REF(BgL_sz00_3527, (int) (BgL_arg2910z00_11376));
		}}}}}
	}



/* &comp-ev_trap1382 */
	obj_t BGl_z62compzd2ev_trap1382zb0zz__evaluate_compz00(obj_t BgL_envz00_19654,
		obj_t BgL_ez00_19655, obj_t BgL_stkz00_19656)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 289 */
			{
				BgL_ev_trapz00_bglt BgL_ez00_3454;
				obj_t BgL_stkz00_3455;

				BgL_ez00_3454 = ((BgL_ev_trapz00_bglt) BgL_ez00_19655);
				BgL_stkz00_3455 = BgL_stkz00_19656;
				{	/* Eval/evaluate_comp.scm 291 */
					obj_t BgL_ez00_3459;

					{	/* Eval/evaluate_comp.scm 291 */
						BgL_ev_exprz00_bglt BgL_arg2865z00_3470;

						BgL_arg2865z00_3470 =
							(((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_ez00_3454)))->BgL_ez00);
						BgL_ez00_3459 =
							BGl_compz00zz__evaluate_compz00(BgL_arg2865z00_3470,
							BgL_stkz00_3455);
					}
					{	/* Eval/evaluate_comp.scm 292 */
						obj_t BgL_zc3anonymousza32859ze3z83_18503;

						BgL_zc3anonymousza32859ze3z83_18503 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32859ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32859ze3z83_18503,
							(int) (((long) 0)), BgL_ez00_3459);
						return BgL_zc3anonymousza32859ze3z83_18503;
					}
				}
			}
		}
	}



/* &<anonymous:2859> */
	obj_t BGl_z62zc3anonymousza32859ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_19657, obj_t BgL_sz00_19659)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 292 */
			{	/* Eval/evaluate_comp.scm 292 */
				obj_t BgL_ez00_19658;

				BgL_ez00_19658 = PROCEDURE_REF(BgL_envz00_19657, (int) (((long) 0)));
				{
					obj_t BgL_sz00_3460;

					BgL_sz00_3460 = BgL_sz00_19659;
					{	/* Eval/evaluate_comp.scm 292 */
						obj_t BgL_bpz00_3462;

						BgL_bpz00_3462 = VECTOR_REF(BgL_sz00_3460, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 293 */
							obj_t BgL_cmdz00_3463;

							BgL_cmdz00_3463 =
								PROCEDURE_ENTRY(BgL_ez00_19658) (BgL_ez00_19658, BgL_sz00_3460,
								BEOA);
							if ((BgL_cmdz00_3463 == BGl_symbol5729z00zz__evaluate_compz00))
								{	/* Eval/evaluate_comp.scm 294 */
									return BgL_bpz00_3462;
								}
							else
								{	/* Eval/evaluate_comp.scm 294 */
									if (
										(BgL_cmdz00_3463 == BGl_symbol5731z00zz__evaluate_compz00))
										{	/* Eval/evaluate_comp.scm 294 */
											return BGl_reset_profilez00zz__evaluate_compz00();
										}
									else
										{	/* Eval/evaluate_comp.scm 294 */
											if (
												(BgL_cmdz00_3463 ==
													BGl_symbol5733z00zz__evaluate_compz00))
												{	/* Eval/evaluate_comp.scm 294 */
													return BGl_get_profilez00zz__evaluate_compz00();
												}
											else
												{	/* Eval/evaluate_comp.scm 294 */
													if (
														(BgL_cmdz00_3463 ==
															BGl_symbol5735z00zz__evaluate_compz00))
														{	/* Eval/evaluate_comp.scm 294 */
															return
																VECTOR_SET
																(BGl_findzd2statezd2zz__evaluate_compz00(),
																(int) (((long) 0)), BINT(((long) 2)));
														}
													else
														{	/* Eval/evaluate_comp.scm 294 */
															return
																BGl_errorz00zz__errorz00
																(BGl_string5595z00zz__evaluate_compz00,
																BGl_string5737z00zz__evaluate_compz00,
																BgL_cmdz00_3463);
														}
												}
										}
								}
						}
					}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 477830603),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 430898742),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 171970731),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 515402798),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 15272113),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 1047446),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 316564000),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 467924967),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 454272164),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					381113196), BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					231310901), BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460263214),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 482314420),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					47127928), BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882), BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 434147503),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 261215800),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)
					116655667), BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007149),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 23062368),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 6183155),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)
					20669940), BSTRING_TO_STRING(BGl_string5738z00zz__evaluate_compz00));
		}
	}

#ifdef __cplusplus
}
#endif
