/*===========================================================================*/
/*   (Eval/evaluate_types.scm)                                               */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c +rm -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Eval/evaluate_types.scm -indent -o objs/obj_u/Eval/evaluate_types.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static BgL_ev_binderz00_bglt BGl_z62lambda1765z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1929z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_symbol2560z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2565z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1930z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1934z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1773z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1935z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_gotoz00_bglt
		BGl_z62zc3anonymousza31887ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1777z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1778z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2570z00zz__evaluate_typesz00 = BUNSPEC;
	extern obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	static obj_t BGl_symbol2575z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1941z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1942z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1782z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1783z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_absz00_bglt BGl_z62lambda1948z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2583z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2588z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_absz00_bglt BGl_z62lambda1950z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_letz00_bglt BGl_z62lambda1791z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_letz00_bglt BGl_z62lambda1793z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1959z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_symbol2598z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1960z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_letrecz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1966z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1967z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1973z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1974z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_letz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1980z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1981z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1988z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1989z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zz__evaluate_typesz00();
	static BgL_ev_exprz00_bglt BGl_z62lambda1994z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1995z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	static BgL_ev_prog2z00_bglt
		BGl_z62zc3anonymousza31541ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_withzd2handlerzd2_bglt
		BGl_z62zc3anonymousza31703ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_labelsz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_methodzd2initzd2zz__evaluate_typesz00();
	BGL_EXPORTED_DEF obj_t BGl_ev_absz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_andz00_bglt
		BGl_z62zc3anonymousza31528ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_ifz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_letza2za2_bglt
		BGl_z62zc3anonymousza31813ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_letrecz00_bglt
		BGl_z62zc3anonymousza31830ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_exprz00_bglt
		BGl_z62zc3anonymousza31385ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_defglobalz00_bglt
		BGl_z62zc3anonymousza31653ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_hookz00_bglt
		BGl_z62zc3anonymousza31564ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_gotoz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1400z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1405z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1406z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1411z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1412z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_globalz00_bglt BGl_z62lambda1418z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_trapz00_bglt
		BGl_z62zc3anonymousza31584ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_orz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_varz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_globalz00_bglt BGl_z62lambda1420z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1426z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1427z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_listz00_bglt
		BGl_z62zc3anonymousza31496ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	extern obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1431z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1432z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1436z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1437z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_andz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_littz00_bglt BGl_z62lambda1444z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_setlocalz00_bglt
		BGl_z62lambda1607z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_littz00_bglt BGl_z62lambda1446z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2400z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2405z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2409z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_varz00_bglt BGl_z62lambda1613z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1614z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1453z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1454z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2414z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2418z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_ifz00_bglt BGl_z62lambda1460z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_setglobalz00_bglt
		BGl_z62lambda1622z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static BgL_ev_ifz00_bglt BGl_z62lambda1462z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_setglobalz00_bglt
		BGl_z62lambda1624z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3anonymousza31961ze3ze1zz__evaluate_typesz00(obj_t);
	static BgL_ev_binderz00_bglt
		BGl_z62zc3anonymousza31767ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_appz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2422z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2426z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1631z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1470z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1632z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1471z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1636z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1637z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1479z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_symbol2431z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2435z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1800z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1801z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1480z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1642z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1643z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1484z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1485z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_letza2za2_bglt BGl_z62lambda1809z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_defglobalz00_bglt
		BGl_z62lambda1649z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol2440z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2603z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2445z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_letza2za2_bglt BGl_z62lambda1811z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_defglobalz00_bglt
		BGl_z62lambda1651z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_listz00_bglt BGl_z62lambda1492z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_listz00_bglt BGl_z62lambda1494z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1818z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1819z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_bindzd2exitzd2_bglt
		BGl_z62lambda1659z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2612z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2450z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2454z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2618z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2458z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_bindzd2exitzd2_bglt
		BGl_z62lambda1661z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_letrecz00_bglt BGl_z62lambda1826z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_letrecz00_bglt BGl_z62lambda1828z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1667z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1668z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2622z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2463z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2629z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_varz00_bglt BGl_z62lambda1672z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31982ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1673z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1836z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1838z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1679z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2470z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2633z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2475z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2639z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2479z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1681z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1846z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1847z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1687z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1688z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2646z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2484z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1852z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1853z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1692z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1693z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_defglobalz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31968ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1858z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1859z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_withzd2handlerzd2_bglt
		BGl_z62lambda1699z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2654z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2495z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2659z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1865z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1866z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2664z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2669z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1871z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1872z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1876z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1877z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2671z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_globalz00_bglt
		BGl_z62zc3anonymousza31422ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_symbol2679z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_gotoz00_bglt BGl_z62lambda1883z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_gotoz00_bglt BGl_z62lambda1885z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2683z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00();
	static obj_t BGl_z62zc3anonymousza31407ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1891z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1892z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1896z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1897z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2690z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2692z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zz__evaluate_typesz00();
	BGL_EXPORTED_DEF obj_t BGl_ev_prog2z00zz__evaluate_typesz00 = BUNSPEC;
	extern obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t,
		bool_t, bool_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 =
		BUNSPEC;
	static BgL_ev_orz00_bglt
		BGl_z62zc3anonymousza31517ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_letza2za2zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31802ze3ze1zz__evaluate_typesz00(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_trapz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_setlocalz00_bglt
		BGl_z62zc3anonymousza31609ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31820ze3ze1zz__evaluate_typesz00(obj_t);
	static BgL_ev_synchroniza7eza7_bglt
		BGl_z62zc3anonymousza31731ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_setglobalz00_bglt
		BGl_z62zc3anonymousza31626ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_littz00_bglt
		BGl_z62zc3anonymousza31448ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_setglobalz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2000z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2001z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2006z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2007z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_ifz00_bglt
		BGl_z62zc3anonymousza31465ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2011z62zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_hookz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2012z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2017z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2018z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_labelsz00_bglt
		BGl_z62zc3anonymousza31840ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_varz00_bglt
		BGl_z62zc3anonymousza31395ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_bindzd2exitzd2_bglt
		BGl_z62zc3anonymousza31663ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	BGL_EXPORTED_DEF obj_t BGl_ev_globalz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_binderz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_listz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_littz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1501z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1502z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31860ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00();
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
	static BgL_ev_orz00_bglt BGl_z62lambda1512z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_orz00_bglt BGl_z62lambda1514z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62zc3anonymousza31683ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 =
		BUNSPEC;
	static BgL_ev_andz00_bglt BGl_z62lambda1524z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_andz00_bglt BGl_z62lambda1526z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_appz00_bglt
		BGl_z62zc3anonymousza31919ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	extern obj_t BGl_objectz00zz__objectz00;
	static BgL_ev_absz00_bglt
		BGl_z62zc3anonymousza31952ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_prog2z00_bglt BGl_z62lambda1536z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t);
	static BgL_ev_prog2z00_bglt BGl_z62lambda1539z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_withzd2handlerzd2_bglt
		BGl_z62lambda1701z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1380z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1382z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1547z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1709z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31848ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1548z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_exprz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2500z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2504z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2508z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1710z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1552z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1391z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1553z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1715z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1716z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1393z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_hookz00_bglt BGl_z62lambda1559z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1399z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_symbol2513z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_hookz00_bglt BGl_z62lambda1562z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_synchroniza7eza7_bglt
		BGl_z62lambda1724z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static BgL_ev_synchroniza7eza7_bglt
		BGl_z62lambda1728z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2522z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2528z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2366z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2368z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1570z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1571z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1737z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31867ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1738z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_trapz00_bglt BGl_z62lambda1579z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_symbol2533z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2372z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2374z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2539z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2379z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_varz00_bglt BGl_z62lambda1902z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1903z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_trapz00_bglt BGl_z62lambda1582z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1744z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1745z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1907z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_letz00_bglt
		BGl_z62zc3anonymousza31795ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1908z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2543z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2383z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2385z00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_setlocalz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1750z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1751z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31990ze3ze1zz__evaluate_typesz00(obj_t);
	static BgL_ev_appz00_bglt BGl_z62lambda1915z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_appz00_bglt BGl_z62lambda1917z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1756z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1757z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_setlocalz00_bglt
		BGl_z62lambda1596z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2550z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2390z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2556z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2394z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1923z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1924z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_binderz00_bglt BGl_z62lambda1763z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31975ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2402z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72694za7,
		BGl_z62zc3anonymousza31422ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2403z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1420za7622695z00,
		BGl_z62lambda1420z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2404z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1418za7622696z00,
		BGl_z62lambda1418z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2407z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1454za7622697z00,
		BGl_z62lambda1454z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2408z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1453za7622698z00,
		BGl_z62lambda1453z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2411z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72699za7,
		BGl_z62zc3anonymousza31448ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2412z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1446za7622700z00,
		BGl_z62lambda1446z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2413z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1444za7622701z00,
		BGl_z62lambda1444z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2501z00zz__evaluate_typesz00,
		BgL_bgl_string2501za700za7za7_2702za7, "ev_defglobal", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2416z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1471za7622703z00,
		BGl_z62lambda1471z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2417z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1470za7622704z00,
		BGl_z62lambda1470z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2505z00zz__evaluate_typesz00,
		BgL_bgl_string2505za700za7za7_2705za7, "body", 4);
	      DEFINE_STRING(BGl_string2509z00zz__evaluate_typesz00,
		BgL_bgl_string2509za700za7za7_2706za7, "var", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2420z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1480za7622707z00,
		BGl_z62lambda1480z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2421z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1479za7622708z00,
		BGl_z62lambda1479z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2424z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1485za7622709z00,
		BGl_z62lambda1485z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2425z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1484za7622710z00,
		BGl_z62lambda1484z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2514z00zz__evaluate_typesz00,
		BgL_bgl_string2514za700za7za7_2711za7, "ev_bind-exit", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2428z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72712za7,
		BGl_z62zc3anonymousza31465ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2429z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1462za7622713z00,
		BGl_z62lambda1462z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2430z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1460za7622714z00,
		BGl_z62lambda1460z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2433z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1502za7622715z00,
		BGl_z62lambda1502z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2434z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1501za7622716z00,
		BGl_z62lambda1501z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2523z00zz__evaluate_typesz00,
		BgL_bgl_string2523za700za7za7_2717za7, "ev_unwind-protect", 17);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2437z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72718za7,
		BGl_z62zc3anonymousza31496ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2438z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1494za7622719z00,
		BGl_z62lambda1494z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2439z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1492za7622720z00,
		BGl_z62lambda1492z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2529z00zz__evaluate_typesz00,
		BgL_bgl_string2529za700za7za7_2721za7, "handler", 7);
	      DEFINE_STRING(BGl_string2367z00zz__evaluate_typesz00,
		BgL_bgl_string2367za700za7za7_2722za7, "ev_expr", 7);
	      DEFINE_STRING(BGl_string2369z00zz__evaluate_typesz00,
		BgL_bgl_string2369za700za7za7_2723za7, "__evaluate_types", 16);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2600z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72724za7,
		BGl_z62zc3anonymousza31867ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2601z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1866za7622725z00,
		BGl_z62lambda1866z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2602z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1865za7622726z00,
		BGl_z62lambda1865z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2442z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72727za7,
		BGl_z62zc3anonymousza31517ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2605z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1872za7622728z00,
		BGl_z62lambda1872z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2443z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1514za7622729z00,
		BGl_z62lambda1514z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2606z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1871za7622730z00,
		BGl_z62lambda1871z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2444z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1512za7622731z00,
		BGl_z62lambda1512z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2607z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1877za7622732z00,
		BGl_z62lambda1877z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2608z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1876za7622733z00,
		BGl_z62lambda1876z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2609z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72734za7,
		BGl_z62zc3anonymousza31840ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2534z00zz__evaluate_typesz00,
		BgL_bgl_string2534za700za7za7_2735za7, "ev_with-handler", 15);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2447z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72736za7,
		BGl_z62zc3anonymousza31528ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2448z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1526za7622737z00,
		BGl_z62lambda1526z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2373z00zz__evaluate_typesz00,
		BgL_bgl_string2373za700za7za7_2738za7, "type", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2449z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1524za7622739z00,
		BGl_z62lambda1524z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2375z00zz__evaluate_typesz00,
		BgL_bgl_string2375za700za7za7_2740za7, "obj", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2610z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1838za7622741z00,
		BGl_z62lambda1838z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2611z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1836za7622742z00,
		BGl_z62lambda1836z62zz__evaluate_typesz00, 0L, BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2614z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1892za7622743z00,
		BGl_z62lambda1892z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2452z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1548za7622744z00,
		BGl_z62lambda1548z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2615z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1891za7622745z00,
		BGl_z62lambda1891z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2540z00zz__evaluate_typesz00,
		BgL_bgl_string2540za700za7za7_2746za7, "prelock", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2453z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1547za7622747z00,
		BGl_z62lambda1547z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2616z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1897za7622748z00,
		BGl_z62lambda1897z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2617z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1896za7622749z00,
		BGl_z62lambda1896z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2380z00zz__evaluate_typesz00,
		BgL_bgl_string2380za700za7za7_2750za7, "eff", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2456z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1553za7622751z00,
		BGl_z62lambda1553z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2544z00zz__evaluate_typesz00,
		BgL_bgl_string2544za700za7za7_2752za7, "mutex", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2457z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1552za7622753z00,
		BGl_z62lambda1552z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2384z00zz__evaluate_typesz00,
		BgL_bgl_string2384za700za7za7_2754za7, "name", 4);
	      DEFINE_STRING(BGl_string2386z00zz__evaluate_typesz00,
		BgL_bgl_string2386za700za7za7_2755za7, "symbol", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2620z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1903za7622756z00,
		BGl_z62lambda1903z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2621z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1902za7622757z00,
		BGl_z62lambda1902z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2460z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72758za7,
		BGl_z62zc3anonymousza31541ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2461z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1539za7622759z00,
		BGl_z62lambda1539z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2624z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1908za7622760z00,
		BGl_z62lambda1908z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2462z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1536za7622761z00,
		BGl_z62lambda1536z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2625z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1907za7622762z00,
		BGl_z62lambda1907z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2626z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72763za7,
		BGl_z62zc3anonymousza31887ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2551z00zz__evaluate_typesz00,
		BgL_bgl_string2551za700za7za7_2764za7, "ev_synchronize", 14);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2627z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1885za7622765z00,
		BGl_z62lambda1885z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2465z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1571za7622766z00,
		BGl_z62lambda1571z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2628z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1883za7622767z00,
		BGl_z62lambda1883z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2466z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1570za7622768z00,
		BGl_z62lambda1570z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2391z00zz__evaluate_typesz00,
		BgL_bgl_string2391za700za7za7_2769za7, "ev_var", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2467z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72770za7,
		BGl_z62zc3anonymousza31564ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2468z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1562za7622771z00,
		BGl_z62lambda1562z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2469z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1559za7622772z00,
		BGl_z62lambda1559z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2557z00zz__evaluate_typesz00,
		BgL_bgl_string2557za700za7za7_2773za7, "vals", 4);
	      DEFINE_STRING(BGl_string2395z00zz__evaluate_typesz00,
		BgL_bgl_string2395za700za7za7_2774za7, "mod", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2631z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1924za7622775z00,
		BGl_z62lambda1924z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2632z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1923za7622776z00,
		BGl_z62lambda1923z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2472z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72777za7,
		BGl_z62zc3anonymousza31584ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2635z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1930za7622778z00,
		BGl_z62lambda1930z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2473z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1582za7622779z00,
		BGl_z62lambda1582z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2636z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1929za7622780z00,
		BGl_z62lambda1929z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2561z00zz__evaluate_typesz00,
		BgL_bgl_string2561za700za7za7_2781za7, "vars", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2474z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1579za7622782z00,
		BGl_z62lambda1579z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2637z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1935za7622783z00,
		BGl_z62lambda1935z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2638z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1934za7622784z00,
		BGl_z62lambda1934z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2477z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1614za7622785z00,
		BGl_z62lambda1614z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2478z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1613za7622786z00,
		BGl_z62lambda1613z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2566z00zz__evaluate_typesz00,
		BgL_bgl_string2566za700za7za7_2787za7, "ev_binder", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2641z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1942za7622788z00,
		BGl_z62lambda1942z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2642z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1941za7622789z00,
		BGl_z62lambda1941z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2643z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72790za7,
		BGl_z62zc3anonymousza31919ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2481z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72791za7,
		BGl_z62zc3anonymousza31609ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2644z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1917za7622792z00,
		BGl_z62lambda1917z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2482z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1607za7622793z00,
		BGl_z62lambda1607z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2645z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1915za7622794z00,
		BGl_z62lambda1915z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2483z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1596za7622795z00,
		BGl_z62lambda1596z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2571z00zz__evaluate_typesz00,
		BgL_bgl_string2571za700za7za7_2796za7, "boxes", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2648z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72797za7,
		BGl_z62zc3anonymousza31961ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2486z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1632za7622798z00,
		BGl_z62lambda1632z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2649z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1960za7622799z00,
		BGl_z62lambda1960z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2487z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1631za7622800z00,
		BGl_z62lambda1631z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2488z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1637za7622801z00,
		BGl_z62lambda1637z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2576z00zz__evaluate_typesz00,
		BgL_bgl_string2576za700za7za7_2802za7, "ev_let", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2489z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1636za7622803z00,
		BGl_z62lambda1636z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2650z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1959za7622804z00,
		BGl_z62lambda1959z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2651z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72805za7,
		BGl_z62zc3anonymousza31968ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2652z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1967za7622806z00,
		BGl_z62lambda1967z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2490z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1643za7622807z00,
		BGl_z62lambda1643z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2653z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1966za7622808z00,
		BGl_z62lambda1966z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2491z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1642za7622809z00,
		BGl_z62lambda1642z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2492z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72810za7,
		BGl_z62zc3anonymousza31626ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2493z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1624za7622811z00,
		BGl_z62lambda1624z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2656z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72812za7,
		BGl_z62zc3anonymousza31975ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2494z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1622za7622813z00,
		BGl_z62lambda1622z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2657z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1974za7622814z00,
		BGl_z62lambda1974z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2658z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1973za7622815z00,
		BGl_z62lambda1973z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2584z00zz__evaluate_typesz00,
		BgL_bgl_string2584za700za7za7_2816za7, "ev_let*", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2497z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72817za7,
		BGl_z62zc3anonymousza31653ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2498z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1651za7622818z00,
		BGl_z62lambda1651z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2499z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1649za7622819z00,
		BGl_z62lambda1649z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2589z00zz__evaluate_typesz00,
		BgL_bgl_string2589za700za7za7_2820za7, "ev_letrec", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2661z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72821za7,
		BGl_z62zc3anonymousza31982ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2662z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1981za7622822z00,
		BGl_z62lambda1981z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2663z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1980za7622823z00,
		BGl_z62lambda1980z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2666z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72824za7,
		BGl_z62zc3anonymousza31990ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2667z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1989za7622825z00,
		BGl_z62lambda1989z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2668z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1988za7622826z00,
		BGl_z62lambda1988z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2599z00zz__evaluate_typesz00,
		BgL_bgl_string2599za700za7za7_2827za7, "stk", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2673z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1995za7622828z00,
		BGl_z62lambda1995z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2674z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1994za7622829z00,
		BGl_z62lambda1994z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2675z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2001za7622830z00,
		BGl_z62lambda2001z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2676z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2000za7622831z00,
		BGl_z62lambda2000z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2677z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2007za7622832z00,
		BGl_z62lambda2007z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2678z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2006za7622833z00,
		BGl_z62lambda2006z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2681z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2012za7622834z00,
		BGl_z62lambda2012z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2682z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2011za7622835z00,
		BGl_z62lambda2011z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2685z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2018za7622836z00,
		BGl_z62lambda2018z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2686z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2017za7622837z00,
		BGl_z62lambda2017z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2687z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72838za7,
		BGl_z62zc3anonymousza31952ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2688z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1950za7622839z00,
		BGl_z62lambda1950z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2689z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1948za7622840z00,
		BGl_z62lambda1948z62zz__evaluate_typesz00, 0L, BUNSPEC, 10);
	      DEFINE_STRING(BGl_string2401z00zz__evaluate_typesz00,
		BgL_bgl_string2401za700za7za7_2841za7, "loc", 3);
	      DEFINE_STRING(BGl_string2406z00zz__evaluate_typesz00,
		BgL_bgl_string2406za700za7za7_2842za7, "ev_global", 9);
	      DEFINE_STRING(BGl_string2410z00zz__evaluate_typesz00,
		BgL_bgl_string2410za700za7za7_2843za7, "value", 5);
	      DEFINE_STRING(BGl_string2415z00zz__evaluate_typesz00,
		BgL_bgl_string2415za700za7za7_2844za7, "ev_litt", 7);
	      DEFINE_STRING(BGl_string2419z00zz__evaluate_typesz00,
		BgL_bgl_string2419za700za7za7_2845za7, "e", 1);
	      DEFINE_STRING(BGl_string2423z00zz__evaluate_typesz00,
		BgL_bgl_string2423za700za7za7_2846za7, "t", 1);
	      DEFINE_STRING(BGl_string2427z00zz__evaluate_typesz00,
		BgL_bgl_string2427za700za7za7_2847za7, "p", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2502z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1668za7622848z00,
		BGl_z62lambda1668z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2503z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1667za7622849z00,
		BGl_z62lambda1667z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2506z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1673za7622850z00,
		BGl_z62lambda1673z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2507z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1672za7622851z00,
		BGl_z62lambda1672z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2432z00zz__evaluate_typesz00,
		BgL_bgl_string2432za700za7za7_2852za7, "ev_if", 5);
	      DEFINE_STRING(BGl_string2436z00zz__evaluate_typesz00,
		BgL_bgl_string2436za700za7za7_2853za7, "args", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2510z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72854za7,
		BGl_z62zc3anonymousza31663ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2511z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1661za7622855z00,
		BGl_z62lambda1661z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2512z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1659za7622856z00,
		BGl_z62lambda1659z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2515z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1688za7622857z00,
		BGl_z62lambda1688z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2516z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1687za7622858z00,
		BGl_z62lambda1687z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2441z00zz__evaluate_typesz00,
		BgL_bgl_string2441za700za7za7_2859za7, "ev_list", 7);
	      DEFINE_STRING(BGl_string2604z00zz__evaluate_typesz00,
		BgL_bgl_string2604za700za7za7_2860za7, "env", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2517z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1693za7622861z00,
		BGl_z62lambda1693z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2518z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1692za7622862z00,
		BGl_z62lambda1692z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2519z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72863za7,
		BGl_z62zc3anonymousza31683ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2446z00zz__evaluate_typesz00,
		BgL_bgl_string2446za700za7za7_2864za7, "ev_or", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2520z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1681za7622865z00,
		BGl_z62lambda1681z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2521z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1679za7622866z00,
		BGl_z62lambda1679z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2524z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1710za7622867z00,
		BGl_z62lambda1710z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2525z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1709za7622868z00,
		BGl_z62lambda1709z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2363z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72869za7,
		BGl_z62zc3anonymousza31385ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2613z00zz__evaluate_typesz00,
		BgL_bgl_string2613za700za7za7_2870za7, "ev_labels", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2526z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1716za7622871z00,
		BGl_z62lambda1716z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2451z00zz__evaluate_typesz00,
		BgL_bgl_string2451za700za7za7_2872za7, "ev_and", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2364z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1382za7622873z00,
		BGl_z62lambda1382z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2527z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1715za7622874z00,
		BGl_z62lambda1715z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2365z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1380za7622875z00,
		BGl_z62lambda1380z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2455z00zz__evaluate_typesz00,
		BgL_bgl_string2455za700za7za7_2876za7, "e2", 2);
	      DEFINE_STRING(BGl_string2619z00zz__evaluate_typesz00,
		BgL_bgl_string2619za700za7za7_2877za7, "labels", 6);
	      DEFINE_STRING(BGl_string2459z00zz__evaluate_typesz00,
		BgL_bgl_string2459za700za7za7_2878za7, "e1", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2530z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72879za7,
		BGl_z62zc3anonymousza31703ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2531z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1701za7622880z00,
		BGl_z62lambda1701z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2532z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1699za7622881z00,
		BGl_z62lambda1699z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2370z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1400za7622882z00,
		BGl_z62lambda1400z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2371z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1399za7622883z00,
		BGl_z62lambda1399z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2535z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1738za7622884z00,
		BGl_z62lambda1738z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2623z00zz__evaluate_typesz00,
		BgL_bgl_string2623za700za7za7_2885za7, "label", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2536z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1737za7622886z00,
		BGl_z62lambda1737z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2537z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1745za7622887z00,
		BGl_z62lambda1745z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2538z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1744za7622888z00,
		BGl_z62lambda1744z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2376z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72889za7,
		BGl_z62zc3anonymousza31407ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2464z00zz__evaluate_typesz00,
		BgL_bgl_string2464za700za7za7_2890za7, "ev_prog2", 8);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2377z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1406za7622891z00,
		BGl_z62lambda1406z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2378z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1405za7622892z00,
		BGl_z62lambda1405z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2541z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1751za7622893z00,
		BGl_z62lambda1751z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2542z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1750za7622894z00,
		BGl_z62lambda1750z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2630z00zz__evaluate_typesz00,
		BgL_bgl_string2630za700za7za7_2895za7, "ev_goto", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2381z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1412za7622896z00,
		BGl_z62lambda1412z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2382z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1411za7622897z00,
		BGl_z62lambda1411z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2545z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1757za7622898z00,
		BGl_z62lambda1757z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2546z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1756za7622899z00,
		BGl_z62lambda1756z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2471z00zz__evaluate_typesz00,
		BgL_bgl_string2471za700za7za7_2900za7, "ev_hook", 7);
	      DEFINE_STRING(BGl_string2634z00zz__evaluate_typesz00,
		BgL_bgl_string2634za700za7za7_2901za7, "tail?", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2547z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72902za7,
		BGl_z62zc3anonymousza31731ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2548z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1728za7622903z00,
		BGl_z62lambda1728z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2549z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1724za7622904z00,
		BGl_z62lambda1724z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2387z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72905za7,
		BGl_z62zc3anonymousza31395ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2388z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1393za7622906z00,
		BGl_z62lambda1393z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2476z00zz__evaluate_typesz00,
		BgL_bgl_string2476za700za7za7_2907za7, "ev_trap", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2389z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1391za7622908z00,
		BGl_z62lambda1391z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2552z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1773za7622909z00,
		BGl_z62lambda1773z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2640z00zz__evaluate_typesz00,
		BgL_bgl_string2640za700za7za7_2910za7, "fun", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2553z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1772za7622911z00,
		BGl_z62lambda1772z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2554z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1778za7622912z00,
		BGl_z62lambda1778z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2392z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1427za7622913z00,
		BGl_z62lambda1427z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2555z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1777za7622914z00,
		BGl_z62lambda1777z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2480z00zz__evaluate_typesz00,
		BgL_bgl_string2480za700za7za7_2915za7, "v", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2393z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1426za7622916z00,
		BGl_z62lambda1426z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2558z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1783za7622917z00,
		BGl_z62lambda1783z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2396z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1432za7622918z00,
		BGl_z62lambda1432z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2559z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1782za7622919z00,
		BGl_z62lambda1782z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2397z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1431za7622920z00,
		BGl_z62lambda1431z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2647z00zz__evaluate_typesz00,
		BgL_bgl_string2647za700za7za7_2921za7, "ev_app", 6);
	      DEFINE_STRING(BGl_string2485z00zz__evaluate_typesz00,
		BgL_bgl_string2485za700za7za7_2922za7, "ev_setlocal", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2398z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1437za7622923z00,
		BGl_z62lambda1437z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2399z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1436za7622924z00,
		BGl_z62lambda1436z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2562z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72925za7,
		BGl_z62zc3anonymousza31767ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2563z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1765za7622926z00,
		BGl_z62lambda1765z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2564z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1763za7622927z00,
		BGl_z62lambda1763z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2567z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72928za7,
		BGl_z62zc3anonymousza31802ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2655z00zz__evaluate_typesz00,
		BgL_bgl_string2655za700za7za7_2929za7, "inner", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2568z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1801za7622930z00,
		BGl_z62lambda1801z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2569z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1800za7622931z00,
		BGl_z62lambda1800z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2496z00zz__evaluate_typesz00,
		BgL_bgl_string2496za700za7za7_2932za7, "ev_setglobal", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2572z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72933za7,
		BGl_z62zc3anonymousza31795ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2660z00zz__evaluate_typesz00,
		BgL_bgl_string2660za700za7za7_2934za7, "free", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2573z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1793za7622935z00,
		BGl_z62lambda1793z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2574z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1791za7622936z00,
		BGl_z62lambda1791z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2577z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72937za7,
		BGl_z62zc3anonymousza31820ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2665z00zz__evaluate_typesz00,
		BgL_bgl_string2665za700za7za7_2938za7, "bind", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2578z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1819za7622939z00,
		BGl_z62lambda1819z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2579z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1818za7622940z00,
		BGl_z62lambda1818z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2580z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72941za7,
		BGl_z62zc3anonymousza31813ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2581z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1811za7622942z00,
		BGl_z62lambda1811z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2582z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1809za7622943z00,
		BGl_z62lambda1809z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2670z00zz__evaluate_typesz00,
		BgL_bgl_string2670za700za7za7_2944za7, "size", 4);
	      DEFINE_STRING(BGl_string2672z00zz__evaluate_typesz00,
		BgL_bgl_string2672za700za7za7_2945za7, "int", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2585z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72946za7,
		BGl_z62zc3anonymousza31830ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2586z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1828za7622947z00,
		BGl_z62lambda1828z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2587z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1826za7622948z00,
		BGl_z62lambda1826z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2590z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72949za7,
		BGl_z62zc3anonymousza31848ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2591z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1847za7622950z00,
		BGl_z62lambda1847z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2592z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1846za7622951z00,
		BGl_z62lambda1846z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2680z00zz__evaluate_typesz00,
		BgL_bgl_string2680za700za7za7_2952za7, "arity", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2593z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1853za7622953z00,
		BGl_z62lambda1853z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2594z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1852za7622954z00,
		BGl_z62lambda1852z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2595z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72955za7,
		BGl_z62zc3anonymousza31860ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2596z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1859za7622956z00,
		BGl_z62lambda1859z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2684z00zz__evaluate_typesz00,
		BgL_bgl_string2684za700za7za7_2957za7, "where", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2597z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1858za7622958z00,
		BGl_z62lambda1858z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2691z00zz__evaluate_typesz00,
		BgL_bgl_string2691za700za7za7_2959za7, "ev_abs", 6);
	      DEFINE_STRING(BGl_string2693z00zz__evaluate_typesz00,
		BgL_bgl_string2693za700za7za7_2960za7, "_", 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long
		BgL_checksumz00_4047, char *BgL_fromz00_4048)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_typesz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 =
						BBOOL(((bool_t) 0));
					BGl_cnstzd2initzd2zz__evaluate_typesz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
					BGl_objectzd2initzd2zz__evaluate_typesz00();
					return BGl_toplevelzd2initzd2zz__evaluate_typesz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			BGl_symbol2366z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2367z00zz__evaluate_typesz00);
			BGl_symbol2368z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2369z00zz__evaluate_typesz00);
			BGl_symbol2372z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2373z00zz__evaluate_typesz00);
			BGl_symbol2374z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2375z00zz__evaluate_typesz00);
			BGl_symbol2379z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2380z00zz__evaluate_typesz00);
			BGl_symbol2383z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2384z00zz__evaluate_typesz00);
			BGl_symbol2385z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2386z00zz__evaluate_typesz00);
			BGl_symbol2390z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2391z00zz__evaluate_typesz00);
			BGl_symbol2394z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2395z00zz__evaluate_typesz00);
			BGl_symbol2400z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2401z00zz__evaluate_typesz00);
			BGl_symbol2405z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2406z00zz__evaluate_typesz00);
			BGl_symbol2409z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2410z00zz__evaluate_typesz00);
			BGl_symbol2414z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2415z00zz__evaluate_typesz00);
			BGl_symbol2418z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2419z00zz__evaluate_typesz00);
			BGl_symbol2422z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2423z00zz__evaluate_typesz00);
			BGl_symbol2426z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2427z00zz__evaluate_typesz00);
			BGl_symbol2431z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2432z00zz__evaluate_typesz00);
			BGl_symbol2435z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2436z00zz__evaluate_typesz00);
			BGl_symbol2440z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2441z00zz__evaluate_typesz00);
			BGl_symbol2445z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2446z00zz__evaluate_typesz00);
			BGl_symbol2450z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2451z00zz__evaluate_typesz00);
			BGl_symbol2454z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2455z00zz__evaluate_typesz00);
			BGl_symbol2458z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2459z00zz__evaluate_typesz00);
			BGl_symbol2463z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2464z00zz__evaluate_typesz00);
			BGl_symbol2470z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2471z00zz__evaluate_typesz00);
			BGl_symbol2475z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2476z00zz__evaluate_typesz00);
			BGl_symbol2479z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2480z00zz__evaluate_typesz00);
			BGl_symbol2484z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2485z00zz__evaluate_typesz00);
			BGl_symbol2495z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2496z00zz__evaluate_typesz00);
			BGl_symbol2500z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2501z00zz__evaluate_typesz00);
			BGl_symbol2504z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2505z00zz__evaluate_typesz00);
			BGl_symbol2508z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2509z00zz__evaluate_typesz00);
			BGl_symbol2513z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2514z00zz__evaluate_typesz00);
			BGl_symbol2522z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2523z00zz__evaluate_typesz00);
			BGl_symbol2528z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2529z00zz__evaluate_typesz00);
			BGl_symbol2533z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2534z00zz__evaluate_typesz00);
			BGl_symbol2539z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2540z00zz__evaluate_typesz00);
			BGl_symbol2543z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2544z00zz__evaluate_typesz00);
			BGl_symbol2550z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2551z00zz__evaluate_typesz00);
			BGl_symbol2556z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2557z00zz__evaluate_typesz00);
			BGl_symbol2560z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2561z00zz__evaluate_typesz00);
			BGl_symbol2565z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2566z00zz__evaluate_typesz00);
			BGl_symbol2570z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2571z00zz__evaluate_typesz00);
			BGl_symbol2575z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2576z00zz__evaluate_typesz00);
			BGl_symbol2583z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2584z00zz__evaluate_typesz00);
			BGl_symbol2588z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2589z00zz__evaluate_typesz00);
			BGl_symbol2598z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2599z00zz__evaluate_typesz00);
			BGl_symbol2603z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2604z00zz__evaluate_typesz00);
			BGl_symbol2612z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2613z00zz__evaluate_typesz00);
			BGl_symbol2618z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2619z00zz__evaluate_typesz00);
			BGl_symbol2622z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2623z00zz__evaluate_typesz00);
			BGl_symbol2629z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2630z00zz__evaluate_typesz00);
			BGl_symbol2633z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2634z00zz__evaluate_typesz00);
			BGl_symbol2639z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2640z00zz__evaluate_typesz00);
			BGl_symbol2646z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2647z00zz__evaluate_typesz00);
			BGl_symbol2654z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2655z00zz__evaluate_typesz00);
			BGl_symbol2659z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2660z00zz__evaluate_typesz00);
			BGl_symbol2664z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2665z00zz__evaluate_typesz00);
			BGl_symbol2669z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2670z00zz__evaluate_typesz00);
			BGl_symbol2671z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2672z00zz__evaluate_typesz00);
			BGl_symbol2679z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2680z00zz__evaluate_typesz00);
			BGl_symbol2683z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2684z00zz__evaluate_typesz00);
			BGl_symbol2690z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2691z00zz__evaluate_typesz00);
			return (BGl_symbol2692z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2693z00zz__evaluate_typesz00), BUNSPEC);
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			{	/* Eval/evaluate_types.scm 49 */
				obj_t BgL_arg1378z00_1007;
				obj_t BgL_arg1379z00_1008;

				{	/* Eval/evaluate_types.scm 49 */
					obj_t BgL_v1281z00_1018;

					BgL_v1281z00_1018 = create_vector((int) (((long) 0)));
					BgL_arg1378z00_1007 = BgL_v1281z00_1018;
				}
				{	/* Eval/evaluate_types.scm 49 */
					obj_t BgL_v1282z00_1019;

					BgL_v1282z00_1019 = create_vector((int) (((long) 0)));
					BgL_arg1379z00_1008 = BgL_v1282z00_1019;
				}
				BGl_ev_exprz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2366z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00, BGl_objectz00zz__objectz00,
					((long) 36682), BGl_proc2365z00zz__evaluate_typesz00,
					BGl_proc2364z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2363z00zz__evaluate_typesz00, BFALSE, BgL_arg1378z00_1007,
					BgL_arg1379z00_1008);
			}
			{	/* Eval/evaluate_types.scm 51 */
				obj_t BgL_arg1389z00_1026;
				obj_t BgL_arg1390z00_1027;

				{	/* Eval/evaluate_types.scm 51 */
					obj_t BgL_v1283z00_1040;

					BgL_v1283z00_1040 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1283z00_1040,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2372z00zz__evaluate_typesz00,
							BGl_proc2371z00zz__evaluate_typesz00,
							BGl_proc2370z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1283z00_1040, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2379z00zz__evaluate_typesz00,
							BGl_proc2378z00zz__evaluate_typesz00,
							BGl_proc2377z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2376z00zz__evaluate_typesz00,
							BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1283z00_1040, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2383z00zz__evaluate_typesz00,
							BGl_proc2382z00zz__evaluate_typesz00,
							BGl_proc2381z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2385z00zz__evaluate_typesz00));
					BgL_arg1389z00_1026 = BgL_v1283z00_1040;
				}
				{	/* Eval/evaluate_types.scm 51 */
					obj_t BgL_v1284z00_1074;

					BgL_v1284z00_1074 = create_vector((int) (((long) 0)));
					BgL_arg1390z00_1027 = BgL_v1284z00_1074;
				}
				BGl_ev_varz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2390z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 7285),
					BGl_proc2389z00zz__evaluate_typesz00,
					BGl_proc2388z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2387z00zz__evaluate_typesz00, BFALSE, BgL_arg1389z00_1026,
					BgL_arg1390z00_1027);
			}
			{	/* Eval/evaluate_types.scm 55 */
				obj_t BgL_arg1416z00_1081;
				obj_t BgL_arg1417z00_1082;

				{	/* Eval/evaluate_types.scm 55 */
					obj_t BgL_v1285z00_1095;

					BgL_v1285z00_1095 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1285z00_1095,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2394z00zz__evaluate_typesz00,
							BGl_proc2393z00zz__evaluate_typesz00,
							BGl_proc2392z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1285z00_1095, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2383z00zz__evaluate_typesz00,
							BGl_proc2397z00zz__evaluate_typesz00,
							BGl_proc2396z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2385z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1285z00_1095, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2400z00zz__evaluate_typesz00,
							BGl_proc2399z00zz__evaluate_typesz00,
							BGl_proc2398z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1416z00_1081 = BgL_v1285z00_1095;
				}
				{	/* Eval/evaluate_types.scm 55 */
					obj_t BgL_v1286z00_1126;

					BgL_v1286z00_1126 = create_vector((int) (((long) 0)));
					BgL_arg1417z00_1082 = BgL_v1286z00_1126;
				}
				BGl_ev_globalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2405z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 59175),
					BGl_proc2404z00zz__evaluate_typesz00,
					BGl_proc2403z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2402z00zz__evaluate_typesz00, BFALSE, BgL_arg1416z00_1081,
					BgL_arg1417z00_1082);
			}
			{	/* Eval/evaluate_types.scm 60 */
				obj_t BgL_arg1442z00_1133;
				obj_t BgL_arg1443z00_1134;

				{	/* Eval/evaluate_types.scm 60 */
					obj_t BgL_v1287z00_1145;

					BgL_v1287z00_1145 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1287z00_1145,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2409z00zz__evaluate_typesz00,
							BGl_proc2408z00zz__evaluate_typesz00,
							BGl_proc2407z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1442z00_1133 = BgL_v1287z00_1145;
				}
				{	/* Eval/evaluate_types.scm 60 */
					obj_t BgL_v1288z00_1156;

					BgL_v1288z00_1156 = create_vector((int) (((long) 0)));
					BgL_arg1443z00_1134 = BgL_v1288z00_1156;
				}
				BGl_ev_littz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2414z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 42418),
					BGl_proc2413z00zz__evaluate_typesz00,
					BGl_proc2412z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2411z00zz__evaluate_typesz00, BFALSE, BgL_arg1442z00_1133,
					BgL_arg1443z00_1134);
			}
			{	/* Eval/evaluate_types.scm 62 */
				obj_t BgL_arg1458z00_1163;
				obj_t BgL_arg1459z00_1164;

				{	/* Eval/evaluate_types.scm 62 */
					obj_t BgL_v1289z00_1177;

					BgL_v1289z00_1177 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1289z00_1177,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2418z00zz__evaluate_typesz00,
							BGl_proc2417z00zz__evaluate_typesz00,
							BGl_proc2416z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1289z00_1177, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2422z00zz__evaluate_typesz00,
							BGl_proc2421z00zz__evaluate_typesz00,
							BGl_proc2420z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1289z00_1177, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2426z00zz__evaluate_typesz00,
							BGl_proc2425z00zz__evaluate_typesz00,
							BGl_proc2424z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1458z00_1163 = BgL_v1289z00_1177;
				}
				{	/* Eval/evaluate_types.scm 62 */
					obj_t BgL_v1290z00_1208;

					BgL_v1290z00_1208 = create_vector((int) (((long) 0)));
					BgL_arg1459z00_1164 = BgL_v1290z00_1208;
				}
				BGl_ev_ifz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2431z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 19099),
					BGl_proc2430z00zz__evaluate_typesz00,
					BGl_proc2429z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2428z00zz__evaluate_typesz00, BFALSE, BgL_arg1458z00_1163,
					BgL_arg1459z00_1164);
			}
			{	/* Eval/evaluate_types.scm 66 */
				obj_t BgL_arg1490z00_1215;
				obj_t BgL_arg1491z00_1216;

				{	/* Eval/evaluate_types.scm 66 */
					obj_t BgL_v1291z00_1227;

					BgL_v1291z00_1227 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1291z00_1227,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2435z00zz__evaluate_typesz00,
							BGl_proc2434z00zz__evaluate_typesz00,
							BGl_proc2433z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1490z00_1215 = BgL_v1291z00_1227;
				}
				{	/* Eval/evaluate_types.scm 66 */
					obj_t BgL_v1292z00_1238;

					BgL_v1292z00_1238 = create_vector((int) (((long) 0)));
					BgL_arg1491z00_1216 = BgL_v1292z00_1238;
				}
				BGl_ev_listz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 39617),
					BGl_proc2439z00zz__evaluate_typesz00,
					BGl_proc2438z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2437z00zz__evaluate_typesz00, BFALSE, BgL_arg1490z00_1215,
					BgL_arg1491z00_1216);
			}
			{	/* Eval/evaluate_types.scm 68 */
				obj_t BgL_arg1509z00_1245;
				obj_t BgL_arg1511z00_1246;

				{	/* Eval/evaluate_types.scm 68 */
					obj_t BgL_v1293z00_1257;

					BgL_v1293z00_1257 = create_vector((int) (((long) 0)));
					BgL_arg1509z00_1245 = BgL_v1293z00_1257;
				}
				{	/* Eval/evaluate_types.scm 68 */
					obj_t BgL_v1294z00_1258;

					BgL_v1294z00_1258 = create_vector((int) (((long) 0)));
					BgL_arg1511z00_1246 = BgL_v1294z00_1258;
				}
				BGl_ev_orz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2445z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_listz00zz__evaluate_typesz00, ((long) 50334),
					BGl_proc2444z00zz__evaluate_typesz00,
					BGl_proc2443z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2442z00zz__evaluate_typesz00, BFALSE, BgL_arg1509z00_1245,
					BgL_arg1511z00_1246);
			}
			{	/* Eval/evaluate_types.scm 69 */
				obj_t BgL_arg1522z00_1265;
				obj_t BgL_arg1523z00_1266;

				{	/* Eval/evaluate_types.scm 69 */
					obj_t BgL_v1295z00_1277;

					BgL_v1295z00_1277 = create_vector((int) (((long) 0)));
					BgL_arg1522z00_1265 = BgL_v1295z00_1277;
				}
				{	/* Eval/evaluate_types.scm 69 */
					obj_t BgL_v1296z00_1278;

					BgL_v1296z00_1278 = create_vector((int) (((long) 0)));
					BgL_arg1523z00_1266 = BgL_v1296z00_1278;
				}
				BGl_ev_andz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2450z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_listz00zz__evaluate_typesz00, ((long) 26888),
					BGl_proc2449z00zz__evaluate_typesz00,
					BGl_proc2448z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2447z00zz__evaluate_typesz00, BFALSE, BgL_arg1522z00_1265,
					BgL_arg1523z00_1266);
			}
			{	/* Eval/evaluate_types.scm 70 */
				obj_t BgL_arg1532z00_1285;
				obj_t BgL_arg1535z00_1286;

				{	/* Eval/evaluate_types.scm 70 */
					obj_t BgL_v1297z00_1298;

					BgL_v1297z00_1298 = create_vector((int) (((long) 2)));
					VECTOR_SET(BgL_v1297z00_1298,
						(int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2454z00zz__evaluate_typesz00,
							BGl_proc2453z00zz__evaluate_typesz00,
							BGl_proc2452z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1297z00_1298, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2458z00zz__evaluate_typesz00,
							BGl_proc2457z00zz__evaluate_typesz00,
							BGl_proc2456z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1532z00_1285 = BgL_v1297z00_1298;
				}
				{	/* Eval/evaluate_types.scm 70 */
					obj_t BgL_v1298z00_1319;

					BgL_v1298z00_1319 = create_vector((int) (((long) 0)));
					BgL_arg1535z00_1286 = BgL_v1298z00_1319;
				}
				BGl_ev_prog2z00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2463z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 14177),
					BGl_proc2462z00zz__evaluate_typesz00,
					BGl_proc2461z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2460z00zz__evaluate_typesz00, BFALSE, BgL_arg1532z00_1285,
					BgL_arg1535z00_1286);
			}
			{	/* Eval/evaluate_types.scm 73 */
				obj_t BgL_arg1557z00_1326;
				obj_t BgL_arg1558z00_1327;

				{	/* Eval/evaluate_types.scm 73 */
					obj_t BgL_v1299z00_1338;

					BgL_v1299z00_1338 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1299z00_1338,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2418z00zz__evaluate_typesz00,
							BGl_proc2466z00zz__evaluate_typesz00,
							BGl_proc2465z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1557z00_1326 = BgL_v1299z00_1338;
				}
				{	/* Eval/evaluate_types.scm 73 */
					obj_t BgL_v1300z00_1349;

					BgL_v1300z00_1349 = create_vector((int) (((long) 0)));
					BgL_arg1558z00_1327 = BgL_v1300z00_1349;
				}
				BGl_ev_hookz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2470z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 32125),
					BGl_proc2469z00zz__evaluate_typesz00,
					BGl_proc2468z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2467z00zz__evaluate_typesz00, BFALSE, BgL_arg1557z00_1326,
					BgL_arg1558z00_1327);
			}
			{	/* Eval/evaluate_types.scm 75 */
				obj_t BgL_arg1577z00_1356;
				obj_t BgL_arg1578z00_1357;

				{	/* Eval/evaluate_types.scm 75 */
					obj_t BgL_v1301z00_1368;

					BgL_v1301z00_1368 = create_vector((int) (((long) 0)));
					BgL_arg1577z00_1356 = BgL_v1301z00_1368;
				}
				{	/* Eval/evaluate_types.scm 75 */
					obj_t BgL_v1302z00_1369;

					BgL_v1302z00_1369 = create_vector((int) (((long) 0)));
					BgL_arg1578z00_1357 = BgL_v1302z00_1369;
				}
				BGl_ev_trapz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2475z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 24451),
					BGl_proc2474z00zz__evaluate_typesz00,
					BGl_proc2473z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2472z00zz__evaluate_typesz00, BFALSE, BgL_arg1577z00_1356,
					BgL_arg1578z00_1357);
			}
			{	/* Eval/evaluate_types.scm 76 */
				obj_t BgL_arg1594z00_1376;
				obj_t BgL_arg1595z00_1377;

				{	/* Eval/evaluate_types.scm 76 */
					obj_t BgL_v1303z00_1389;

					BgL_v1303z00_1389 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1303z00_1389,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2479z00zz__evaluate_typesz00,
							BGl_proc2478z00zz__evaluate_typesz00,
							BGl_proc2477z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					BgL_arg1594z00_1376 = BgL_v1303z00_1389;
				}
				{	/* Eval/evaluate_types.scm 76 */
					obj_t BgL_v1304z00_1400;

					BgL_v1304z00_1400 = create_vector((int) (((long) 0)));
					BgL_arg1595z00_1377 = BgL_v1304z00_1400;
				}
				BGl_ev_setlocalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2484z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 37950),
					BGl_proc2483z00zz__evaluate_typesz00,
					BGl_proc2482z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2481z00zz__evaluate_typesz00, BFALSE, BgL_arg1594z00_1376,
					BgL_arg1595z00_1377);
			}
			{	/* Eval/evaluate_types.scm 78 */
				obj_t BgL_arg1620z00_1407;
				obj_t BgL_arg1621z00_1408;

				{	/* Eval/evaluate_types.scm 78 */
					obj_t BgL_v1305z00_1422;

					BgL_v1305z00_1422 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1305z00_1422,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2394z00zz__evaluate_typesz00,
							BGl_proc2487z00zz__evaluate_typesz00,
							BGl_proc2486z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1305z00_1422, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2383z00zz__evaluate_typesz00,
							BGl_proc2489z00zz__evaluate_typesz00,
							BGl_proc2488z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2385z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1305z00_1422, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2400z00zz__evaluate_typesz00,
							BGl_proc2491z00zz__evaluate_typesz00,
							BGl_proc2490z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1620z00_1407 = BgL_v1305z00_1422;
				}
				{	/* Eval/evaluate_types.scm 78 */
					obj_t BgL_v1306z00_1453;

					BgL_v1306z00_1453 = create_vector((int) (((long) 0)));
					BgL_arg1621z00_1408 = BgL_v1306z00_1453;
				}
				BGl_ev_setglobalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2495z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 62117),
					BGl_proc2494z00zz__evaluate_typesz00,
					BGl_proc2493z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2492z00zz__evaluate_typesz00, BFALSE, BgL_arg1620z00_1407,
					BgL_arg1621z00_1408);
			}
			{	/* Eval/evaluate_types.scm 82 */
				obj_t BgL_arg1647z00_1460;
				obj_t BgL_arg1648z00_1461;

				{	/* Eval/evaluate_types.scm 82 */
					obj_t BgL_v1307z00_1475;

					BgL_v1307z00_1475 = create_vector((int) (((long) 0)));
					BgL_arg1647z00_1460 = BgL_v1307z00_1475;
				}
				{	/* Eval/evaluate_types.scm 82 */
					obj_t BgL_v1308z00_1476;

					BgL_v1308z00_1476 = create_vector((int) (((long) 0)));
					BgL_arg1648z00_1461 = BgL_v1308z00_1476;
				}
				BGl_ev_defglobalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2500z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_setglobalz00zz__evaluate_typesz00, ((long) 36158),
					BGl_proc2499z00zz__evaluate_typesz00,
					BGl_proc2498z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2497z00zz__evaluate_typesz00, BFALSE, BgL_arg1647z00_1460,
					BgL_arg1648z00_1461);
			}
			{	/* Eval/evaluate_types.scm 83 */
				obj_t BgL_arg1657z00_1483;
				obj_t BgL_arg1658z00_1484;

				{	/* Eval/evaluate_types.scm 83 */
					obj_t BgL_v1309z00_1496;

					BgL_v1309z00_1496 = create_vector((int) (((long) 2)));
					VECTOR_SET(BgL_v1309z00_1496,
						(int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2504z00zz__evaluate_typesz00,
							BGl_proc2503z00zz__evaluate_typesz00,
							BGl_proc2502z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1309z00_1496, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2508z00zz__evaluate_typesz00,
							BGl_proc2507z00zz__evaluate_typesz00,
							BGl_proc2506z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					BgL_arg1657z00_1483 = BgL_v1309z00_1496;
				}
				{	/* Eval/evaluate_types.scm 83 */
					obj_t BgL_v1310z00_1517;

					BgL_v1310z00_1517 = create_vector((int) (((long) 0)));
					BgL_arg1658z00_1484 = BgL_v1310z00_1517;
				}
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2513z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 10723),
					BGl_proc2512z00zz__evaluate_typesz00,
					BGl_proc2511z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2510z00zz__evaluate_typesz00, BFALSE, BgL_arg1657z00_1483,
					BgL_arg1658z00_1484);
			}
			{	/* Eval/evaluate_types.scm 86 */
				obj_t BgL_arg1677z00_1524;
				obj_t BgL_arg1678z00_1525;

				{	/* Eval/evaluate_types.scm 86 */
					obj_t BgL_v1311z00_1537;

					BgL_v1311z00_1537 = create_vector((int) (((long) 2)));
					VECTOR_SET(BgL_v1311z00_1537,
						(int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2504z00zz__evaluate_typesz00,
							BGl_proc2516z00zz__evaluate_typesz00,
							BGl_proc2515z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1311z00_1537, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2418z00zz__evaluate_typesz00,
							BGl_proc2518z00zz__evaluate_typesz00,
							BGl_proc2517z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1677z00_1524 = BgL_v1311z00_1537;
				}
				{	/* Eval/evaluate_types.scm 86 */
					obj_t BgL_v1312z00_1558;

					BgL_v1312z00_1558 = create_vector((int) (((long) 0)));
					BgL_arg1678z00_1525 = BgL_v1312z00_1558;
				}
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2522z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 59644),
					BGl_proc2521z00zz__evaluate_typesz00,
					BGl_proc2520z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2519z00zz__evaluate_typesz00, BFALSE, BgL_arg1677z00_1524,
					BgL_arg1678z00_1525);
			}
			{	/* Eval/evaluate_types.scm 89 */
				obj_t BgL_arg1697z00_1565;
				obj_t BgL_arg1698z00_1566;

				{	/* Eval/evaluate_types.scm 89 */
					obj_t BgL_v1313z00_1578;

					BgL_v1313z00_1578 = create_vector((int) (((long) 2)));
					VECTOR_SET(BgL_v1313z00_1578,
						(int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2504z00zz__evaluate_typesz00,
							BGl_proc2525z00zz__evaluate_typesz00,
							BGl_proc2524z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1313z00_1578, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2528z00zz__evaluate_typesz00,
							BGl_proc2527z00zz__evaluate_typesz00,
							BGl_proc2526z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1697z00_1565 = BgL_v1313z00_1578;
				}
				{	/* Eval/evaluate_types.scm 89 */
					obj_t BgL_v1314z00_1599;

					BgL_v1314z00_1599 = create_vector((int) (((long) 0)));
					BgL_arg1698z00_1566 = BgL_v1314z00_1599;
				}
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2533z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 54033),
					BGl_proc2532z00zz__evaluate_typesz00,
					BGl_proc2531z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2530z00zz__evaluate_typesz00, BFALSE, BgL_arg1697z00_1565,
					BgL_arg1698z00_1566);
			}
			{	/* Eval/evaluate_types.scm 92 */
				obj_t BgL_arg1721z00_1606;
				obj_t BgL_arg1723z00_1607;

				{	/* Eval/evaluate_types.scm 92 */
					obj_t BgL_v1315z00_1621;

					BgL_v1315z00_1621 = create_vector((int) (((long) 4)));
					VECTOR_SET(BgL_v1315z00_1621,
						(int) (((long) 3)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2504z00zz__evaluate_typesz00,
							BGl_proc2536z00zz__evaluate_typesz00,
							BGl_proc2535z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1315z00_1621, (int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2539z00zz__evaluate_typesz00,
							BGl_proc2538z00zz__evaluate_typesz00,
							BGl_proc2537z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1315z00_1621, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2543z00zz__evaluate_typesz00,
							BGl_proc2542z00zz__evaluate_typesz00,
							BGl_proc2541z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1315z00_1621, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2400z00zz__evaluate_typesz00,
							BGl_proc2546z00zz__evaluate_typesz00,
							BGl_proc2545z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1721z00_1606 = BgL_v1315z00_1621;
				}
				{	/* Eval/evaluate_types.scm 92 */
					obj_t BgL_v1316z00_1662;

					BgL_v1316z00_1662 = create_vector((int) (((long) 0)));
					BgL_arg1723z00_1607 = BgL_v1316z00_1662;
				}
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2550z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 40653),
					BGl_proc2549z00zz__evaluate_typesz00,
					BGl_proc2548z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2547z00zz__evaluate_typesz00, BFALSE, BgL_arg1721z00_1606,
					BgL_arg1723z00_1607);
			}
			{	/* Eval/evaluate_types.scm 97 */
				obj_t BgL_arg1761z00_1669;
				obj_t BgL_arg1762z00_1670;

				{	/* Eval/evaluate_types.scm 97 */
					obj_t BgL_v1317z00_1683;

					BgL_v1317z00_1683 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1317z00_1683,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2504z00zz__evaluate_typesz00,
							BGl_proc2553z00zz__evaluate_typesz00,
							BGl_proc2552z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1317z00_1683, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2556z00zz__evaluate_typesz00,
							BGl_proc2555z00zz__evaluate_typesz00,
							BGl_proc2554z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1317z00_1683, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2560z00zz__evaluate_typesz00,
							BGl_proc2559z00zz__evaluate_typesz00,
							BGl_proc2558z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1761z00_1669 = BgL_v1317z00_1683;
				}
				{	/* Eval/evaluate_types.scm 97 */
					obj_t BgL_v1318z00_1714;

					BgL_v1318z00_1714 = create_vector((int) (((long) 0)));
					BgL_arg1762z00_1670 = BgL_v1318z00_1714;
				}
				BGl_ev_binderz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2565z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 50341),
					BGl_proc2564z00zz__evaluate_typesz00,
					BGl_proc2563z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2562z00zz__evaluate_typesz00, BFALSE, BgL_arg1761z00_1669,
					BgL_arg1762z00_1670);
			}
			{	/* Eval/evaluate_types.scm 101 */
				obj_t BgL_arg1789z00_1721;
				obj_t BgL_arg1790z00_1722;

				{	/* Eval/evaluate_types.scm 101 */
					obj_t BgL_v1319z00_1736;

					BgL_v1319z00_1736 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1319z00_1736,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2570z00zz__evaluate_typesz00,
							BGl_proc2569z00zz__evaluate_typesz00,
							BGl_proc2568z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2567z00zz__evaluate_typesz00,
							BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1789z00_1721 = BgL_v1319z00_1736;
				}
				{	/* Eval/evaluate_types.scm 101 */
					obj_t BgL_v1320z00_1750;

					BgL_v1320z00_1750 = create_vector((int) (((long) 0)));
					BgL_arg1790z00_1722 = BgL_v1320z00_1750;
				}
				BGl_ev_letz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2575z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 20484),
					BGl_proc2574z00zz__evaluate_typesz00,
					BGl_proc2573z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2572z00zz__evaluate_typesz00, BFALSE, BgL_arg1789z00_1721,
					BgL_arg1790z00_1722);
			}
			{	/* Eval/evaluate_types.scm 103 */
				obj_t BgL_arg1807z00_1757;
				obj_t BgL_arg1808z00_1758;

				{	/* Eval/evaluate_types.scm 103 */
					obj_t BgL_v1321z00_1772;

					BgL_v1321z00_1772 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1321z00_1772,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2570z00zz__evaluate_typesz00,
							BGl_proc2579z00zz__evaluate_typesz00,
							BGl_proc2578z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2577z00zz__evaluate_typesz00,
							BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1807z00_1757 = BgL_v1321z00_1772;
				}
				{	/* Eval/evaluate_types.scm 103 */
					obj_t BgL_v1322z00_1786;

					BgL_v1322z00_1786 = create_vector((int) (((long) 0)));
					BgL_arg1808z00_1758 = BgL_v1322z00_1786;
				}
				BGl_ev_letza2za2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2583z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 9906),
					BGl_proc2582z00zz__evaluate_typesz00,
					BGl_proc2581z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2580z00zz__evaluate_typesz00, BFALSE, BgL_arg1807z00_1757,
					BgL_arg1808z00_1758);
			}
			{	/* Eval/evaluate_types.scm 105 */
				obj_t BgL_arg1824z00_1793;
				obj_t BgL_arg1825z00_1794;

				{	/* Eval/evaluate_types.scm 105 */
					obj_t BgL_v1323z00_1807;

					BgL_v1323z00_1807 = create_vector((int) (((long) 0)));
					BgL_arg1824z00_1793 = BgL_v1323z00_1807;
				}
				{	/* Eval/evaluate_types.scm 105 */
					obj_t BgL_v1324z00_1808;

					BgL_v1324z00_1808 = create_vector((int) (((long) 0)));
					BgL_arg1825z00_1794 = BgL_v1324z00_1808;
				}
				BGl_ev_letrecz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2588z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 43956),
					BGl_proc2587z00zz__evaluate_typesz00,
					BGl_proc2586z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2585z00zz__evaluate_typesz00, BFALSE, BgL_arg1824z00_1793,
					BgL_arg1825z00_1794);
			}
			{	/* Eval/evaluate_types.scm 106 */
				obj_t BgL_arg1834z00_1815;
				obj_t BgL_arg1835z00_1816;

				{	/* Eval/evaluate_types.scm 106 */
					obj_t BgL_v1325z00_1832;

					BgL_v1325z00_1832 = create_vector((int) (((long) 6)));
					VECTOR_SET(BgL_v1325z00_1832,
						(int) (((long) 5)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2570z00zz__evaluate_typesz00,
							BGl_proc2592z00zz__evaluate_typesz00,
							BGl_proc2591z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2590z00zz__evaluate_typesz00,
							BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1325z00_1832, (int) (((long) 4)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2504z00zz__evaluate_typesz00,
							BGl_proc2594z00zz__evaluate_typesz00,
							BGl_proc2593z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1325z00_1832, (int) (((long) 3)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2598z00zz__evaluate_typesz00,
							BGl_proc2597z00zz__evaluate_typesz00,
							BGl_proc2596z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2595z00zz__evaluate_typesz00,
							BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1325z00_1832, (int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2603z00zz__evaluate_typesz00,
							BGl_proc2602z00zz__evaluate_typesz00,
							BGl_proc2601z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2600z00zz__evaluate_typesz00,
							BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1325z00_1832, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2556z00zz__evaluate_typesz00,
							BGl_proc2606z00zz__evaluate_typesz00,
							BGl_proc2605z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1325z00_1832, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2560z00zz__evaluate_typesz00,
							BGl_proc2608z00zz__evaluate_typesz00,
							BGl_proc2607z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1834z00_1815 = BgL_v1325z00_1832;
				}
				{	/* Eval/evaluate_types.scm 106 */
					obj_t BgL_v1326z00_1902;

					BgL_v1326z00_1902 = create_vector((int) (((long) 0)));
					BgL_arg1835z00_1816 = BgL_v1326z00_1902;
				}
				BGl_ev_labelsz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2612z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 51941),
					BGl_proc2611z00zz__evaluate_typesz00,
					BGl_proc2610z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2609z00zz__evaluate_typesz00, BFALSE, BgL_arg1834z00_1815,
					BgL_arg1835z00_1816);
			}
			{	/* Eval/evaluate_types.scm 114 */
				obj_t BgL_arg1881z00_1909;
				obj_t BgL_arg1882z00_1910;

				{	/* Eval/evaluate_types.scm 114 */
					obj_t BgL_v1327z00_1924;

					BgL_v1327z00_1924 = create_vector((int) (((long) 4)));
					VECTOR_SET(BgL_v1327z00_1924,
						(int) (((long) 3)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2435z00zz__evaluate_typesz00,
							BGl_proc2615z00zz__evaluate_typesz00,
							BGl_proc2614z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1327z00_1924, (int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2618z00zz__evaluate_typesz00,
							BGl_proc2617z00zz__evaluate_typesz00,
							BGl_proc2616z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_labelsz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1327z00_1924, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2622z00zz__evaluate_typesz00,
							BGl_proc2621z00zz__evaluate_typesz00,
							BGl_proc2620z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1327z00_1924, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2400z00zz__evaluate_typesz00,
							BGl_proc2625z00zz__evaluate_typesz00,
							BGl_proc2624z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1881z00_1909 = BgL_v1327z00_1924;
				}
				{	/* Eval/evaluate_types.scm 114 */
					obj_t BgL_v1328z00_1965;

					BgL_v1328z00_1965 = create_vector((int) (((long) 0)));
					BgL_arg1882z00_1910 = BgL_v1328z00_1965;
				}
				BGl_ev_gotoz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2629z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 25746),
					BGl_proc2628z00zz__evaluate_typesz00,
					BGl_proc2627z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2626z00zz__evaluate_typesz00, BFALSE, BgL_arg1881z00_1909,
					BgL_arg1882z00_1910);
			}
			{	/* Eval/evaluate_types.scm 119 */
				obj_t BgL_arg1913z00_1972;
				obj_t BgL_arg1914z00_1973;

				{	/* Eval/evaluate_types.scm 119 */
					obj_t BgL_v1329z00_1987;

					BgL_v1329z00_1987 = create_vector((int) (((long) 4)));
					VECTOR_SET(BgL_v1329z00_1987,
						(int) (((long) 3)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2633z00zz__evaluate_typesz00,
							BGl_proc2632z00zz__evaluate_typesz00,
							BGl_proc2631z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1329z00_1987, (int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2435z00zz__evaluate_typesz00,
							BGl_proc2636z00zz__evaluate_typesz00,
							BGl_proc2635z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1329z00_1987, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2639z00zz__evaluate_typesz00,
							BGl_proc2638z00zz__evaluate_typesz00,
							BGl_proc2637z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1329z00_1987, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2400z00zz__evaluate_typesz00,
							BGl_proc2642z00zz__evaluate_typesz00,
							BGl_proc2641z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1913z00_1972 = BgL_v1329z00_1987;
				}
				{	/* Eval/evaluate_types.scm 119 */
					obj_t BgL_v1330z00_2028;

					BgL_v1330z00_2028 = create_vector((int) (((long) 0)));
					BgL_arg1914z00_1973 = BgL_v1330z00_2028;
				}
				BGl_ev_appz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2646z00zz__evaluate_typesz00,
					BGl_symbol2368z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 55822),
					BGl_proc2645z00zz__evaluate_typesz00,
					BGl_proc2644z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2643z00zz__evaluate_typesz00, BFALSE, BgL_arg1913z00_1972,
					BgL_arg1914z00_1973);
			}
			{	/* Eval/evaluate_types.scm 122 */
				obj_t BgL_arg1946z00_2035;
				obj_t BgL_arg1947z00_2036;

				{	/* Eval/evaluate_types.scm 122 */
					obj_t BgL_v1331z00_2056;

					BgL_v1331z00_2056 = create_vector((int) (((long) 10)));
					VECTOR_SET(BgL_v1331z00_2056,
						(int) (((long) 9)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2570z00zz__evaluate_typesz00,
							BGl_proc2650z00zz__evaluate_typesz00,
							BGl_proc2649z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2648z00zz__evaluate_typesz00,
							BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_2056, (int) (((long) 8)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2654z00zz__evaluate_typesz00,
							BGl_proc2653z00zz__evaluate_typesz00,
							BGl_proc2652z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2651z00zz__evaluate_typesz00,
							BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_2056, (int) (((long) 7)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2659z00zz__evaluate_typesz00,
							BGl_proc2658z00zz__evaluate_typesz00,
							BGl_proc2657z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2656z00zz__evaluate_typesz00,
							BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_2056, (int) (((long) 6)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2664z00zz__evaluate_typesz00,
							BGl_proc2663z00zz__evaluate_typesz00,
							BGl_proc2662z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2661z00zz__evaluate_typesz00,
							BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_2056, (int) (((long) 5)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2669z00zz__evaluate_typesz00,
							BGl_proc2668z00zz__evaluate_typesz00,
							BGl_proc2667z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2666z00zz__evaluate_typesz00,
							BGl_symbol2671z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_2056, (int) (((long) 4)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2504z00zz__evaluate_typesz00,
							BGl_proc2674z00zz__evaluate_typesz00,
							BGl_proc2673z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_2056, (int) (((long) 3)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2560z00zz__evaluate_typesz00,
							BGl_proc2676z00zz__evaluate_typesz00,
							BGl_proc2675z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_2056, (int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2679z00zz__evaluate_typesz00,
							BGl_proc2678z00zz__evaluate_typesz00,
							BGl_proc2677z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_2056, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2683z00zz__evaluate_typesz00,
							BGl_proc2682z00zz__evaluate_typesz00,
							BGl_proc2681z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_2056, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2400z00zz__evaluate_typesz00,
							BGl_proc2686z00zz__evaluate_typesz00,
							BGl_proc2685z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2374z00zz__evaluate_typesz00));
					BgL_arg1946z00_2035 = BgL_v1331z00_2056;
				}
				{	/* Eval/evaluate_types.scm 122 */
					obj_t BgL_v1332z00_2172;

					BgL_v1332z00_2172 = create_vector((int) (((long) 0)));
					BgL_arg1947z00_2036 = BgL_v1332z00_2172;
				}
				return (BGl_ev_absz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2690z00zz__evaluate_typesz00,
						BGl_symbol2368z00zz__evaluate_typesz00,
						BGl_ev_exprz00zz__evaluate_typesz00, ((long) 22827),
						BGl_proc2689z00zz__evaluate_typesz00,
						BGl_proc2688z00zz__evaluate_typesz00, BFALSE,
						BGl_proc2687z00zz__evaluate_typesz00, BFALSE, BgL_arg1946z00_2035,
						BgL_arg1947z00_2036), BUNSPEC);
		}}
	}



/* &<anonymous:1952> */
	BgL_ev_absz00_bglt BGl_z62zc3anonymousza31952ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3400, obj_t BgL_new1194z00_3401)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			{
				BgL_ev_absz00_bglt BgL_new1194z00_2054;

				BgL_new1194z00_2054 = ((BgL_ev_absz00_bglt) BgL_new1194z00_3401);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1194z00_2054))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1194z00_2054))->BgL_wherez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1194z00_2054))->BgL_arityz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1194z00_2054))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4425;

					{	/* Eval/evaluate_types.scm 122 */
						obj_t BgL_classz00_2999;

						BgL_classz00_2999 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 122 */
							obj_t BgL__ortest_1280z00_3000;

							BgL__ortest_1280z00_3000 = BGL_CLASS_NIL(BgL_classz00_2999);
							if (CBOOL(BgL__ortest_1280z00_3000))
								{	/* Eval/evaluate_types.scm 122 */
									BgL_auxz00_4425 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_3000);
								}
							else
								{	/* Eval/evaluate_types.scm 122 */
									BgL_auxz00_4425 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2999));
								}
						}
					}
					((((BgL_ev_absz00_bglt) CREF(BgL_new1194z00_2054))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4425), BUNSPEC);
				}
				((((BgL_ev_absz00_bglt) CREF(BgL_new1194z00_2054))->BgL_siza7eza7) =
					((int) (int) (((long) 0))), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1194z00_2054))->BgL_bindz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1194z00_2054))->BgL_freez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1194z00_2054))->BgL_innerz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1194z00_2054))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1194z00_2054;
			}
		}
	}



/* &lambda1950 */
	BgL_ev_absz00_bglt BGl_z62lambda1950z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3402)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			{

				{	/* Eval/evaluate_types.scm 122 */
					BgL_ev_absz00_bglt BgL_new1193z00_2052;

					BgL_new1193z00_2052 =
						((BgL_ev_absz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_absz00_bgl))));
					{	/* Eval/evaluate_types.scm 122 */
						long BgL_arg1951z00_2053;

						{	/* Eval/evaluate_types.scm 122 */
							long BgL_res2326z00_2996;

							BgL_res2326z00_2996 =
								BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
							BgL_arg1951z00_2053 = BgL_res2326z00_2996;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1193z00_2052), BgL_arg1951z00_2053);
					}
					{	/* Eval/evaluate_types.scm 122 */
						BgL_objectz00_bglt BgL_auxz00_4444;

						BgL_auxz00_4444 = ((BgL_objectz00_bglt) BgL_new1193z00_2052);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4444, BFALSE);
					}
					return BgL_new1193z00_2052;
				}
			}
		}
	}



/* &lambda1948 */
	BgL_ev_absz00_bglt BGl_z62lambda1948z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3403, obj_t BgL_loc1183z00_3404, obj_t BgL_where1184z00_3405,
		obj_t BgL_arity1185z00_3406, obj_t BgL_vars1186z00_3407,
		obj_t BgL_body1187z00_3408, obj_t BgL_siza7e1188za7_3409,
		obj_t BgL_bind1189z00_3410, obj_t BgL_free1190z00_3411,
		obj_t BgL_inner1191z00_3412, obj_t BgL_boxes1192z00_3413)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			{
				obj_t BgL_loc1183z00_2037;
				obj_t BgL_where1184z00_2038;
				obj_t BgL_arity1185z00_2039;
				obj_t BgL_vars1186z00_2040;
				BgL_ev_exprz00_bglt BgL_body1187z00_2041;
				int BgL_siza7e1188za7_2042;
				obj_t BgL_bind1189z00_2043;
				obj_t BgL_free1190z00_2044;
				obj_t BgL_inner1191z00_2045;
				obj_t BgL_boxes1192z00_2046;

				BgL_loc1183z00_2037 = BgL_loc1183z00_3404;
				BgL_where1184z00_2038 = BgL_where1184z00_3405;
				BgL_arity1185z00_2039 = BgL_arity1185z00_3406;
				BgL_vars1186z00_2040 = BgL_vars1186z00_3407;
				BgL_body1187z00_2041 = ((BgL_ev_exprz00_bglt) BgL_body1187z00_3408);
				BgL_siza7e1188za7_2042 = CINT(BgL_siza7e1188za7_3409);
				BgL_bind1189z00_2043 = BgL_bind1189z00_3410;
				BgL_free1190z00_2044 = BgL_free1190z00_3411;
				BgL_inner1191z00_2045 = BgL_inner1191z00_3412;
				BgL_boxes1192z00_2046 = BgL_boxes1192z00_3413;
				{	/* Eval/evaluate_types.scm 122 */
					BgL_ev_absz00_bglt BgL_new1247z00_2988;

					{	/* Eval/evaluate_types.scm 122 */
						BgL_ev_absz00_bglt BgL_new1246z00_2989;

						BgL_new1246z00_2989 =
							((BgL_ev_absz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_absz00_bgl))));
						{	/* Eval/evaluate_types.scm 122 */
							long BgL_arg1949z00_2990;

							{	/* Eval/evaluate_types.scm 122 */
								long BgL_res2325z00_2992;

								BgL_res2325z00_2992 =
									BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
								BgL_arg1949z00_2990 = BgL_res2325z00_2992;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1246z00_2989),
								BgL_arg1949z00_2990);
						}
						{	/* Eval/evaluate_types.scm 122 */
							BgL_objectz00_bglt BgL_auxz00_4451;

							BgL_auxz00_4451 = ((BgL_objectz00_bglt) BgL_new1246z00_2989);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4451, BFALSE);
						}
						BgL_new1247z00_2988 = BgL_new1246z00_2989;
					}
					((((BgL_ev_absz00_bglt) CREF(BgL_new1247z00_2988))->BgL_locz00) =
						((obj_t) BgL_loc1183z00_2037), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1247z00_2988))->BgL_wherez00) =
						((obj_t) BgL_where1184z00_2038), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1247z00_2988))->BgL_arityz00) =
						((obj_t) BgL_arity1185z00_2039), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1247z00_2988))->BgL_varsz00) =
						((obj_t) BgL_vars1186z00_2040), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1247z00_2988))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1187z00_2041), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1247z00_2988))->BgL_siza7eza7) =
						((int) BgL_siza7e1188za7_2042), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1247z00_2988))->BgL_bindz00) =
						((obj_t) BgL_bind1189z00_2043), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1247z00_2988))->BgL_freez00) =
						((obj_t) BgL_free1190z00_2044), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1247z00_2988))->BgL_innerz00) =
						((obj_t) BgL_inner1191z00_2045), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1247z00_2988))->BgL_boxesz00) =
						((obj_t) BgL_boxes1192z00_2046), BUNSPEC);
					return BgL_new1247z00_2988;
				}
			}
		}
	}



/* &lambda2018 */
	obj_t BGl_z62lambda2018z62zz__evaluate_typesz00(obj_t BgL_envz00_3414,
		obj_t BgL_oz00_3415, obj_t BgL_vz00_3416)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3415)))->BgL_locz00) =
				((obj_t) BgL_vz00_3416), BUNSPEC);
		}
	}



/* &lambda2017 */
	obj_t BGl_z62lambda2017z62zz__evaluate_typesz00(obj_t BgL_envz00_3417,
		obj_t BgL_oz00_3418)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3418)))->BgL_locz00);
		}
	}



/* &lambda2012 */
	obj_t BGl_z62lambda2012z62zz__evaluate_typesz00(obj_t BgL_envz00_3419,
		obj_t BgL_oz00_3420, obj_t BgL_vz00_3421)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3420)))->BgL_wherez00) =
				((obj_t) BgL_vz00_3421), BUNSPEC);
		}
	}



/* &lambda2011 */
	obj_t BGl_z62lambda2011z62zz__evaluate_typesz00(obj_t BgL_envz00_3422,
		obj_t BgL_oz00_3423)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3423)))->BgL_wherez00);
		}
	}



/* &lambda2007 */
	obj_t BGl_z62lambda2007z62zz__evaluate_typesz00(obj_t BgL_envz00_3424,
		obj_t BgL_oz00_3425, obj_t BgL_vz00_3426)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3425)))->BgL_arityz00) =
				((obj_t) BgL_vz00_3426), BUNSPEC);
		}
	}



/* &lambda2006 */
	obj_t BGl_z62lambda2006z62zz__evaluate_typesz00(obj_t BgL_envz00_3427,
		obj_t BgL_oz00_3428)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3428)))->BgL_arityz00);
		}
	}



/* &lambda2001 */
	obj_t BGl_z62lambda2001z62zz__evaluate_typesz00(obj_t BgL_envz00_3429,
		obj_t BgL_oz00_3430, obj_t BgL_vz00_3431)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3430)))->BgL_varsz00) =
				((obj_t) BgL_vz00_3431), BUNSPEC);
		}
	}



/* &lambda2000 */
	obj_t BGl_z62lambda2000z62zz__evaluate_typesz00(obj_t BgL_envz00_3432,
		obj_t BgL_oz00_3433)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3433)))->BgL_varsz00);
		}
	}



/* &lambda1995 */
	obj_t BGl_z62lambda1995z62zz__evaluate_typesz00(obj_t BgL_envz00_3434,
		obj_t BgL_oz00_3435, obj_t BgL_vz00_3436)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3435)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3436)), BUNSPEC);
		}
	}



/* &lambda1994 */
	BgL_ev_exprz00_bglt BGl_z62lambda1994z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3437, obj_t BgL_oz00_3438)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3438)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1990> */
	obj_t BGl_z62zc3anonymousza31990ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3439)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return BINT(((long) 0));
		}
	}



/* &lambda1989 */
	obj_t BGl_z62lambda1989z62zz__evaluate_typesz00(obj_t BgL_envz00_3440,
		obj_t BgL_oz00_3441, obj_t BgL_vz00_3442)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			{	/* Eval/evaluate_types.scm 122 */
				int BgL_vz00_3891;

				BgL_vz00_3891 = CINT(BgL_vz00_3442);
				return
					((((BgL_ev_absz00_bglt) CREF(
								((BgL_ev_absz00_bglt) BgL_oz00_3441)))->BgL_siza7eza7) =
					((int) BgL_vz00_3891), BUNSPEC);
		}}
	}



/* &lambda1988 */
	obj_t BGl_z62lambda1988z62zz__evaluate_typesz00(obj_t BgL_envz00_3443,
		obj_t BgL_oz00_3444)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				BINT(
				(((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3444)))->BgL_siza7eza7));
		}
	}



/* &<anonymous:1982> */
	obj_t BGl_z62zc3anonymousza31982ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3445)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}
	}



/* &lambda1981 */
	obj_t BGl_z62lambda1981z62zz__evaluate_typesz00(obj_t BgL_envz00_3446,
		obj_t BgL_oz00_3447, obj_t BgL_vz00_3448)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3447)))->BgL_bindz00) =
				((obj_t) BgL_vz00_3448), BUNSPEC);
		}
	}



/* &lambda1980 */
	obj_t BGl_z62lambda1980z62zz__evaluate_typesz00(obj_t BgL_envz00_3449,
		obj_t BgL_oz00_3450)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3450)))->BgL_bindz00);
		}
	}



/* &<anonymous:1975> */
	obj_t BGl_z62zc3anonymousza31975ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3451)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}
	}



/* &lambda1974 */
	obj_t BGl_z62lambda1974z62zz__evaluate_typesz00(obj_t BgL_envz00_3452,
		obj_t BgL_oz00_3453, obj_t BgL_vz00_3454)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3453)))->BgL_freez00) =
				((obj_t) BgL_vz00_3454), BUNSPEC);
		}
	}



/* &lambda1973 */
	obj_t BGl_z62lambda1973z62zz__evaluate_typesz00(obj_t BgL_envz00_3455,
		obj_t BgL_oz00_3456)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3456)))->BgL_freez00);
		}
	}



/* &<anonymous:1968> */
	obj_t BGl_z62zc3anonymousza31968ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3457)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}
	}



/* &lambda1967 */
	obj_t BGl_z62lambda1967z62zz__evaluate_typesz00(obj_t BgL_envz00_3458,
		obj_t BgL_oz00_3459, obj_t BgL_vz00_3460)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3459)))->BgL_innerz00) =
				((obj_t) BgL_vz00_3460), BUNSPEC);
		}
	}



/* &lambda1966 */
	obj_t BGl_z62lambda1966z62zz__evaluate_typesz00(obj_t BgL_envz00_3461,
		obj_t BgL_oz00_3462)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3462)))->BgL_innerz00);
		}
	}



/* &<anonymous:1961> */
	obj_t BGl_z62zc3anonymousza31961ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3463)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}
	}



/* &lambda1960 */
	obj_t BGl_z62lambda1960z62zz__evaluate_typesz00(obj_t BgL_envz00_3464,
		obj_t BgL_oz00_3465, obj_t BgL_vz00_3466)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3465)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3466), BUNSPEC);
		}
	}



/* &lambda1959 */
	obj_t BGl_z62lambda1959z62zz__evaluate_typesz00(obj_t BgL_envz00_3467,
		obj_t BgL_oz00_3468)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3468)))->BgL_boxesz00);
		}
	}



/* &<anonymous:1919> */
	BgL_ev_appz00_bglt BGl_z62zc3anonymousza31919ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3469, obj_t BgL_new1181z00_3470)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			{
				BgL_ev_appz00_bglt BgL_new1181z00_1985;

				BgL_new1181z00_1985 = ((BgL_ev_appz00_bglt) BgL_new1181z00_3470);
				((((BgL_ev_appz00_bglt) CREF(BgL_new1181z00_1985))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4511;

					{	/* Eval/evaluate_types.scm 119 */
						obj_t BgL_classz00_2956;

						BgL_classz00_2956 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 119 */
							obj_t BgL__ortest_1280z00_2957;

							BgL__ortest_1280z00_2957 = BGL_CLASS_NIL(BgL_classz00_2956);
							if (CBOOL(BgL__ortest_1280z00_2957))
								{	/* Eval/evaluate_types.scm 119 */
									BgL_auxz00_4511 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2957);
								}
							else
								{	/* Eval/evaluate_types.scm 119 */
									BgL_auxz00_4511 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2956));
								}
						}
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1181z00_1985))->BgL_funz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4511), BUNSPEC);
				}
				((((BgL_ev_appz00_bglt) CREF(BgL_new1181z00_1985))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_appz00_bglt) CREF(BgL_new1181z00_1985))->BgL_tailzf3zf3) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1181z00_1985;
			}
		}
	}



/* &lambda1917 */
	BgL_ev_appz00_bglt BGl_z62lambda1917z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3471)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			{

				{	/* Eval/evaluate_types.scm 119 */
					BgL_ev_appz00_bglt BgL_new1180z00_1983;

					BgL_new1180z00_1983 =
						((BgL_ev_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_appz00_bgl))));
					{	/* Eval/evaluate_types.scm 119 */
						long BgL_arg1918z00_1984;

						{	/* Eval/evaluate_types.scm 119 */
							long BgL_res2324z00_2953;

							BgL_res2324z00_2953 =
								BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
							BgL_arg1918z00_1984 = BgL_res2324z00_2953;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1180z00_1983), BgL_arg1918z00_1984);
					}
					{	/* Eval/evaluate_types.scm 119 */
						BgL_objectz00_bglt BgL_auxz00_4526;

						BgL_auxz00_4526 = ((BgL_objectz00_bglt) BgL_new1180z00_1983);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4526, BFALSE);
					}
					return BgL_new1180z00_1983;
				}
			}
		}
	}



/* &lambda1915 */
	BgL_ev_appz00_bglt BGl_z62lambda1915z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3472, obj_t BgL_loc1176z00_3473, obj_t BgL_fun1177z00_3474,
		obj_t BgL_args1178z00_3475, obj_t BgL_tailzf31179zf3_3476)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			{
				obj_t BgL_loc1176z00_1974;
				BgL_ev_exprz00_bglt BgL_fun1177z00_1975;
				obj_t BgL_args1178z00_1976;
				obj_t BgL_tailzf31179zf3_1977;

				BgL_loc1176z00_1974 = BgL_loc1176z00_3473;
				BgL_fun1177z00_1975 = ((BgL_ev_exprz00_bglt) BgL_fun1177z00_3474);
				BgL_args1178z00_1976 = BgL_args1178z00_3475;
				BgL_tailzf31179zf3_1977 = BgL_tailzf31179zf3_3476;
				{	/* Eval/evaluate_types.scm 119 */
					BgL_ev_appz00_bglt BgL_new1245z00_2945;

					{	/* Eval/evaluate_types.scm 119 */
						BgL_ev_appz00_bglt BgL_new1243z00_2946;

						BgL_new1243z00_2946 =
							((BgL_ev_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_appz00_bgl))));
						{	/* Eval/evaluate_types.scm 119 */
							long BgL_arg1916z00_2947;

							{	/* Eval/evaluate_types.scm 119 */
								long BgL_res2323z00_2949;

								BgL_res2323z00_2949 =
									BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
								BgL_arg1916z00_2947 = BgL_res2323z00_2949;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1243z00_2946),
								BgL_arg1916z00_2947);
						}
						{	/* Eval/evaluate_types.scm 119 */
							BgL_objectz00_bglt BgL_auxz00_4533;

							BgL_auxz00_4533 = ((BgL_objectz00_bglt) BgL_new1243z00_2946);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4533, BFALSE);
						}
						BgL_new1245z00_2945 = BgL_new1243z00_2946;
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1245z00_2945))->BgL_locz00) =
						((obj_t) BgL_loc1176z00_1974), BUNSPEC);
					((((BgL_ev_appz00_bglt) CREF(BgL_new1245z00_2945))->BgL_funz00) =
						((BgL_ev_exprz00_bglt) BgL_fun1177z00_1975), BUNSPEC);
					((((BgL_ev_appz00_bglt) CREF(BgL_new1245z00_2945))->BgL_argsz00) =
						((obj_t) BgL_args1178z00_1976), BUNSPEC);
					((((BgL_ev_appz00_bglt) CREF(BgL_new1245z00_2945))->BgL_tailzf3zf3) =
						((obj_t) BgL_tailzf31179zf3_1977), BUNSPEC);
					return BgL_new1245z00_2945;
				}
			}
		}
	}



/* &lambda1942 */
	obj_t BGl_z62lambda1942z62zz__evaluate_typesz00(obj_t BgL_envz00_3477,
		obj_t BgL_oz00_3478, obj_t BgL_vz00_3479)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) CREF(
							((BgL_ev_appz00_bglt) BgL_oz00_3478)))->BgL_locz00) =
				((obj_t) BgL_vz00_3479), BUNSPEC);
		}
	}



/* &lambda1941 */
	obj_t BGl_z62lambda1941z62zz__evaluate_typesz00(obj_t BgL_envz00_3480,
		obj_t BgL_oz00_3481)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) CREF(
						((BgL_ev_appz00_bglt) BgL_oz00_3481)))->BgL_locz00);
		}
	}



/* &lambda1935 */
	obj_t BGl_z62lambda1935z62zz__evaluate_typesz00(obj_t BgL_envz00_3482,
		obj_t BgL_oz00_3483, obj_t BgL_vz00_3484)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) CREF(
							((BgL_ev_appz00_bglt) BgL_oz00_3483)))->BgL_funz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3484)), BUNSPEC);
		}
	}



/* &lambda1934 */
	BgL_ev_exprz00_bglt BGl_z62lambda1934z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3485, obj_t BgL_oz00_3486)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) CREF(
						((BgL_ev_appz00_bglt) BgL_oz00_3486)))->BgL_funz00);
		}
	}



/* &lambda1930 */
	obj_t BGl_z62lambda1930z62zz__evaluate_typesz00(obj_t BgL_envz00_3487,
		obj_t BgL_oz00_3488, obj_t BgL_vz00_3489)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) CREF(
							((BgL_ev_appz00_bglt) BgL_oz00_3488)))->BgL_argsz00) =
				((obj_t) BgL_vz00_3489), BUNSPEC);
		}
	}



/* &lambda1929 */
	obj_t BGl_z62lambda1929z62zz__evaluate_typesz00(obj_t BgL_envz00_3490,
		obj_t BgL_oz00_3491)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) CREF(
						((BgL_ev_appz00_bglt) BgL_oz00_3491)))->BgL_argsz00);
		}
	}



/* &lambda1924 */
	obj_t BGl_z62lambda1924z62zz__evaluate_typesz00(obj_t BgL_envz00_3492,
		obj_t BgL_oz00_3493, obj_t BgL_vz00_3494)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) CREF(
							((BgL_ev_appz00_bglt) BgL_oz00_3493)))->BgL_tailzf3zf3) =
				((obj_t) BgL_vz00_3494), BUNSPEC);
		}
	}



/* &lambda1923 */
	obj_t BGl_z62lambda1923z62zz__evaluate_typesz00(obj_t BgL_envz00_3495,
		obj_t BgL_oz00_3496)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) CREF(
						((BgL_ev_appz00_bglt) BgL_oz00_3496)))->BgL_tailzf3zf3);
		}
	}



/* &<anonymous:1887> */
	BgL_ev_gotoz00_bglt
		BGl_z62zc3anonymousza31887ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3497,
		obj_t BgL_new1174z00_3498)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			{
				BgL_ev_gotoz00_bglt BgL_new1174z00_1922;

				BgL_new1174z00_1922 = ((BgL_ev_gotoz00_bglt) BgL_new1174z00_3498);
				((((BgL_ev_gotoz00_bglt) CREF(BgL_new1174z00_1922))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_varz00_bglt BgL_auxz00_4559;

					{	/* Eval/evaluate_types.scm 114 */
						obj_t BgL_classz00_2929;

						BgL_classz00_2929 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 114 */
							obj_t BgL__ortest_1280z00_2930;

							BgL__ortest_1280z00_2930 = BGL_CLASS_NIL(BgL_classz00_2929);
							if (CBOOL(BgL__ortest_1280z00_2930))
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4559 =
										((BgL_ev_varz00_bglt) BgL__ortest_1280z00_2930);
								}
							else
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4559 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2929));
								}
						}
					}
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1174z00_1922))->BgL_labelz00) =
						((BgL_ev_varz00_bglt) BgL_auxz00_4559), BUNSPEC);
				}
				{
					BgL_ev_labelsz00_bglt BgL_auxz00_4567;

					{	/* Eval/evaluate_types.scm 114 */
						obj_t BgL_classz00_2931;

						BgL_classz00_2931 = BGl_ev_labelsz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 114 */
							obj_t BgL__ortest_1280z00_2932;

							BgL__ortest_1280z00_2932 = BGL_CLASS_NIL(BgL_classz00_2931);
							if (CBOOL(BgL__ortest_1280z00_2932))
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4567 =
										((BgL_ev_labelsz00_bglt) BgL__ortest_1280z00_2932);
								}
							else
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4567 =
										((BgL_ev_labelsz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2931));
								}
						}
					}
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1174z00_1922))->BgL_labelsz00) =
						((BgL_ev_labelsz00_bglt) BgL_auxz00_4567), BUNSPEC);
				}
				((((BgL_ev_gotoz00_bglt) CREF(BgL_new1174z00_1922))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1174z00_1922;
			}
		}
	}



/* &lambda1885 */
	BgL_ev_gotoz00_bglt BGl_z62lambda1885z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3499)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			{

				{	/* Eval/evaluate_types.scm 114 */
					BgL_ev_gotoz00_bglt BgL_new1173z00_1920;

					BgL_new1173z00_1920 =
						((BgL_ev_gotoz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_gotoz00_bgl))));
					{	/* Eval/evaluate_types.scm 114 */
						long BgL_arg1886z00_1921;

						{	/* Eval/evaluate_types.scm 114 */
							long BgL_res2322z00_2926;

							BgL_res2322z00_2926 =
								BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00);
							BgL_arg1886z00_1921 = BgL_res2322z00_2926;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1173z00_1920), BgL_arg1886z00_1921);
					}
					{	/* Eval/evaluate_types.scm 114 */
						BgL_objectz00_bglt BgL_auxz00_4581;

						BgL_auxz00_4581 = ((BgL_objectz00_bglt) BgL_new1173z00_1920);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4581, BFALSE);
					}
					return BgL_new1173z00_1920;
				}
			}
		}
	}



/* &lambda1883 */
	BgL_ev_gotoz00_bglt BGl_z62lambda1883z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3500, obj_t BgL_loc1169z00_3501, obj_t BgL_label1170z00_3502,
		obj_t BgL_labels1171z00_3503, obj_t BgL_args1172z00_3504)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			{
				obj_t BgL_loc1169z00_1911;
				BgL_ev_varz00_bglt BgL_label1170z00_1912;
				BgL_ev_labelsz00_bglt BgL_labels1171z00_1913;
				obj_t BgL_args1172z00_1914;

				BgL_loc1169z00_1911 = BgL_loc1169z00_3501;
				BgL_label1170z00_1912 = ((BgL_ev_varz00_bglt) BgL_label1170z00_3502);
				BgL_labels1171z00_1913 =
					((BgL_ev_labelsz00_bglt) BgL_labels1171z00_3503);
				BgL_args1172z00_1914 = BgL_args1172z00_3504;
				{	/* Eval/evaluate_types.scm 114 */
					BgL_ev_gotoz00_bglt BgL_new1242z00_2918;

					{	/* Eval/evaluate_types.scm 114 */
						BgL_ev_gotoz00_bglt BgL_new1241z00_2919;

						BgL_new1241z00_2919 =
							((BgL_ev_gotoz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_gotoz00_bgl))));
						{	/* Eval/evaluate_types.scm 114 */
							long BgL_arg1884z00_2920;

							{	/* Eval/evaluate_types.scm 114 */
								long BgL_res2321z00_2922;

								BgL_res2321z00_2922 =
									BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00);
								BgL_arg1884z00_2920 = BgL_res2321z00_2922;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1241z00_2919),
								BgL_arg1884z00_2920);
						}
						{	/* Eval/evaluate_types.scm 114 */
							BgL_objectz00_bglt BgL_auxz00_4588;

							BgL_auxz00_4588 = ((BgL_objectz00_bglt) BgL_new1241z00_2919);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4588, BFALSE);
						}
						BgL_new1242z00_2918 = BgL_new1241z00_2919;
					}
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1242z00_2918))->BgL_locz00) =
						((obj_t) BgL_loc1169z00_1911), BUNSPEC);
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1242z00_2918))->BgL_labelz00) =
						((BgL_ev_varz00_bglt) BgL_label1170z00_1912), BUNSPEC);
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1242z00_2918))->BgL_labelsz00) =
						((BgL_ev_labelsz00_bglt) BgL_labels1171z00_1913), BUNSPEC);
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1242z00_2918))->BgL_argsz00) =
						((obj_t) BgL_args1172z00_1914), BUNSPEC);
					return BgL_new1242z00_2918;
				}
			}
		}
	}



/* &lambda1908 */
	obj_t BGl_z62lambda1908z62zz__evaluate_typesz00(obj_t BgL_envz00_3505,
		obj_t BgL_oz00_3506, obj_t BgL_vz00_3507)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) CREF(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3506)))->BgL_locz00) =
				((obj_t) BgL_vz00_3507), BUNSPEC);
		}
	}



/* &lambda1907 */
	obj_t BGl_z62lambda1907z62zz__evaluate_typesz00(obj_t BgL_envz00_3508,
		obj_t BgL_oz00_3509)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) CREF(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3509)))->BgL_locz00);
		}
	}



/* &lambda1903 */
	obj_t BGl_z62lambda1903z62zz__evaluate_typesz00(obj_t BgL_envz00_3510,
		obj_t BgL_oz00_3511, obj_t BgL_vz00_3512)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) CREF(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3511)))->BgL_labelz00) =
				((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_vz00_3512)), BUNSPEC);
		}
	}



/* &lambda1902 */
	BgL_ev_varz00_bglt BGl_z62lambda1902z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3513, obj_t BgL_oz00_3514)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) CREF(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3514)))->BgL_labelz00);
		}
	}



/* &lambda1897 */
	obj_t BGl_z62lambda1897z62zz__evaluate_typesz00(obj_t BgL_envz00_3515,
		obj_t BgL_oz00_3516, obj_t BgL_vz00_3517)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) CREF(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3516)))->BgL_labelsz00) =
				((BgL_ev_labelsz00_bglt) ((BgL_ev_labelsz00_bglt) BgL_vz00_3517)),
				BUNSPEC);
		}
	}



/* &lambda1896 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1896z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3518, obj_t BgL_oz00_3519)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) CREF(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3519)))->BgL_labelsz00);
		}
	}



/* &lambda1892 */
	obj_t BGl_z62lambda1892z62zz__evaluate_typesz00(obj_t BgL_envz00_3520,
		obj_t BgL_oz00_3521, obj_t BgL_vz00_3522)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) CREF(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3521)))->BgL_argsz00) =
				((obj_t) BgL_vz00_3522), BUNSPEC);
		}
	}



/* &lambda1891 */
	obj_t BGl_z62lambda1891z62zz__evaluate_typesz00(obj_t BgL_envz00_3523,
		obj_t BgL_oz00_3524)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) CREF(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3524)))->BgL_argsz00);
		}
	}



/* &<anonymous:1840> */
	BgL_ev_labelsz00_bglt
		BGl_z62zc3anonymousza31840ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3525,
		obj_t BgL_new1167z00_3526)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			{
				BgL_ev_labelsz00_bglt BgL_new1167z00_1830;

				BgL_new1167z00_1830 = ((BgL_ev_labelsz00_bglt) BgL_new1167z00_3526);
				((((BgL_ev_labelsz00_bglt) CREF(BgL_new1167z00_1830))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) CREF(BgL_new1167z00_1830))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) CREF(BgL_new1167z00_1830))->BgL_envz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) CREF(BgL_new1167z00_1830))->BgL_stkz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4619;

					{	/* Eval/evaluate_types.scm 106 */
						obj_t BgL_classz00_2904;

						BgL_classz00_2904 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 106 */
							obj_t BgL__ortest_1280z00_2905;

							BgL__ortest_1280z00_2905 = BGL_CLASS_NIL(BgL_classz00_2904);
							if (CBOOL(BgL__ortest_1280z00_2905))
								{	/* Eval/evaluate_types.scm 106 */
									BgL_auxz00_4619 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2905);
								}
							else
								{	/* Eval/evaluate_types.scm 106 */
									BgL_auxz00_4619 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2904));
								}
						}
					}
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1167z00_1830))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4619), BUNSPEC);
				}
				((((BgL_ev_labelsz00_bglt) CREF(BgL_new1167z00_1830))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1167z00_1830;
			}
		}
	}



/* &lambda1838 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1838z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3527)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			{

				{	/* Eval/evaluate_types.scm 106 */
					BgL_ev_labelsz00_bglt BgL_new1166z00_1828;

					BgL_new1166z00_1828 =
						((BgL_ev_labelsz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_labelsz00_bgl))));
					{	/* Eval/evaluate_types.scm 106 */
						long BgL_arg1839z00_1829;

						{	/* Eval/evaluate_types.scm 106 */
							long BgL_res2320z00_2901;

							BgL_res2320z00_2901 =
								BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00);
							BgL_arg1839z00_1829 = BgL_res2320z00_2901;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1166z00_1828), BgL_arg1839z00_1829);
					}
					{	/* Eval/evaluate_types.scm 106 */
						BgL_objectz00_bglt BgL_auxz00_4633;

						BgL_auxz00_4633 = ((BgL_objectz00_bglt) BgL_new1166z00_1828);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4633, BFALSE);
					}
					return BgL_new1166z00_1828;
				}
			}
		}
	}



/* &lambda1836 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1836z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3528, obj_t BgL_vars1160z00_3529, obj_t BgL_vals1161z00_3530,
		obj_t BgL_env1162z00_3531, obj_t BgL_stk1163z00_3532,
		obj_t BgL_body1164z00_3533, obj_t BgL_boxes1165z00_3534)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			{
				obj_t BgL_vars1160z00_1817;
				obj_t BgL_vals1161z00_1818;
				obj_t BgL_env1162z00_1819;
				obj_t BgL_stk1163z00_1820;
				BgL_ev_exprz00_bglt BgL_body1164z00_1821;
				obj_t BgL_boxes1165z00_1822;

				BgL_vars1160z00_1817 = BgL_vars1160z00_3529;
				BgL_vals1161z00_1818 = BgL_vals1161z00_3530;
				BgL_env1162z00_1819 = BgL_env1162z00_3531;
				BgL_stk1163z00_1820 = BgL_stk1163z00_3532;
				BgL_body1164z00_1821 = ((BgL_ev_exprz00_bglt) BgL_body1164z00_3533);
				BgL_boxes1165z00_1822 = BgL_boxes1165z00_3534;
				{	/* Eval/evaluate_types.scm 106 */
					BgL_ev_labelsz00_bglt BgL_new1240z00_2893;

					{	/* Eval/evaluate_types.scm 106 */
						BgL_ev_labelsz00_bglt BgL_new1239z00_2894;

						BgL_new1239z00_2894 =
							((BgL_ev_labelsz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_labelsz00_bgl))));
						{	/* Eval/evaluate_types.scm 106 */
							long BgL_arg1837z00_2895;

							{	/* Eval/evaluate_types.scm 106 */
								long BgL_res2319z00_2897;

								BgL_res2319z00_2897 =
									BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00);
								BgL_arg1837z00_2895 = BgL_res2319z00_2897;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1239z00_2894),
								BgL_arg1837z00_2895);
						}
						{	/* Eval/evaluate_types.scm 106 */
							BgL_objectz00_bglt BgL_auxz00_4640;

							BgL_auxz00_4640 = ((BgL_objectz00_bglt) BgL_new1239z00_2894);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4640, BFALSE);
						}
						BgL_new1240z00_2893 = BgL_new1239z00_2894;
					}
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1240z00_2893))->BgL_varsz00) =
						((obj_t) BgL_vars1160z00_1817), BUNSPEC);
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1240z00_2893))->BgL_valsz00) =
						((obj_t) BgL_vals1161z00_1818), BUNSPEC);
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1240z00_2893))->BgL_envz00) =
						((obj_t) BgL_env1162z00_1819), BUNSPEC);
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1240z00_2893))->BgL_stkz00) =
						((obj_t) BgL_stk1163z00_1820), BUNSPEC);
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1240z00_2893))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1164z00_1821), BUNSPEC);
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1240z00_2893))->BgL_boxesz00) =
						((obj_t) BgL_boxes1165z00_1822), BUNSPEC);
					return BgL_new1240z00_2893;
				}
			}
		}
	}



/* &lambda1877 */
	obj_t BGl_z62lambda1877z62zz__evaluate_typesz00(obj_t BgL_envz00_3535,
		obj_t BgL_oz00_3536, obj_t BgL_vz00_3537)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) CREF(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3536)))->BgL_varsz00) =
				((obj_t) BgL_vz00_3537), BUNSPEC);
		}
	}



/* &lambda1876 */
	obj_t BGl_z62lambda1876z62zz__evaluate_typesz00(obj_t BgL_envz00_3538,
		obj_t BgL_oz00_3539)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3539)))->BgL_varsz00);
		}
	}



/* &lambda1872 */
	obj_t BGl_z62lambda1872z62zz__evaluate_typesz00(obj_t BgL_envz00_3540,
		obj_t BgL_oz00_3541, obj_t BgL_vz00_3542)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) CREF(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3541)))->BgL_valsz00) =
				((obj_t) BgL_vz00_3542), BUNSPEC);
		}
	}



/* &lambda1871 */
	obj_t BGl_z62lambda1871z62zz__evaluate_typesz00(obj_t BgL_envz00_3543,
		obj_t BgL_oz00_3544)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3544)))->BgL_valsz00);
		}
	}



/* &<anonymous:1867> */
	obj_t BGl_z62zc3anonymousza31867ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3545)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return BNIL;
		}
	}



/* &lambda1866 */
	obj_t BGl_z62lambda1866z62zz__evaluate_typesz00(obj_t BgL_envz00_3546,
		obj_t BgL_oz00_3547, obj_t BgL_vz00_3548)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) CREF(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3547)))->BgL_envz00) =
				((obj_t) BgL_vz00_3548), BUNSPEC);
		}
	}



/* &lambda1865 */
	obj_t BGl_z62lambda1865z62zz__evaluate_typesz00(obj_t BgL_envz00_3549,
		obj_t BgL_oz00_3550)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3550)))->BgL_envz00);
		}
	}



/* &<anonymous:1860> */
	obj_t BGl_z62zc3anonymousza31860ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3551)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return BNIL;
		}
	}



/* &lambda1859 */
	obj_t BGl_z62lambda1859z62zz__evaluate_typesz00(obj_t BgL_envz00_3552,
		obj_t BgL_oz00_3553, obj_t BgL_vz00_3554)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) CREF(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3553)))->BgL_stkz00) =
				((obj_t) BgL_vz00_3554), BUNSPEC);
		}
	}



/* &lambda1858 */
	obj_t BGl_z62lambda1858z62zz__evaluate_typesz00(obj_t BgL_envz00_3555,
		obj_t BgL_oz00_3556)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3556)))->BgL_stkz00);
		}
	}



/* &lambda1853 */
	obj_t BGl_z62lambda1853z62zz__evaluate_typesz00(obj_t BgL_envz00_3557,
		obj_t BgL_oz00_3558, obj_t BgL_vz00_3559)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) CREF(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3558)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3559)), BUNSPEC);
		}
	}



/* &lambda1852 */
	BgL_ev_exprz00_bglt BGl_z62lambda1852z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3560, obj_t BgL_oz00_3561)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3561)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1848> */
	obj_t BGl_z62zc3anonymousza31848ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3562)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return BNIL;
		}
	}



/* &lambda1847 */
	obj_t BGl_z62lambda1847z62zz__evaluate_typesz00(obj_t BgL_envz00_3563,
		obj_t BgL_oz00_3564, obj_t BgL_vz00_3565)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) CREF(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3564)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3565), BUNSPEC);
		}
	}



/* &lambda1846 */
	obj_t BGl_z62lambda1846z62zz__evaluate_typesz00(obj_t BgL_envz00_3566,
		obj_t BgL_oz00_3567)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3567)))->BgL_boxesz00);
		}
	}



/* &<anonymous:1830> */
	BgL_ev_letrecz00_bglt
		BGl_z62zc3anonymousza31830ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3568,
		obj_t BgL_new1158z00_3569)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{
				BgL_ev_letrecz00_bglt BgL_new1158z00_1805;

				BgL_new1158z00_1805 = ((BgL_ev_letrecz00_bglt) BgL_new1158z00_3569);
				((((BgL_ev_binderz00_bglt) CREF(
								((BgL_ev_binderz00_bglt) BgL_new1158z00_1805)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
									BgL_new1158z00_1805)))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4679;

					{	/* Eval/evaluate_types.scm 105 */
						obj_t BgL_classz00_2873;

						BgL_classz00_2873 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 105 */
							obj_t BgL__ortest_1280z00_2874;

							BgL__ortest_1280z00_2874 = BGL_CLASS_NIL(BgL_classz00_2873);
							if (CBOOL(BgL__ortest_1280z00_2874))
								{	/* Eval/evaluate_types.scm 105 */
									BgL_auxz00_4679 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2874);
								}
							else
								{	/* Eval/evaluate_types.scm 105 */
									BgL_auxz00_4679 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2873));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1158z00_1805)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4679), BUNSPEC);
				}
				return BgL_new1158z00_1805;
			}
		}
	}



/* &lambda1828 */
	BgL_ev_letrecz00_bglt BGl_z62lambda1828z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3570)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{

				{	/* Eval/evaluate_types.scm 105 */
					BgL_ev_letrecz00_bglt BgL_new1157z00_1803;

					BgL_new1157z00_1803 =
						((BgL_ev_letrecz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_letrecz00_bgl))));
					{	/* Eval/evaluate_types.scm 105 */
						long BgL_arg1829z00_1804;

						{	/* Eval/evaluate_types.scm 105 */
							long BgL_res2318z00_2870;

							BgL_res2318z00_2870 =
								BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00);
							BgL_arg1829z00_1804 = BgL_res2318z00_2870;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1157z00_1803), BgL_arg1829z00_1804);
					}
					{	/* Eval/evaluate_types.scm 105 */
						BgL_objectz00_bglt BgL_auxz00_4693;

						BgL_auxz00_4693 = ((BgL_objectz00_bglt) BgL_new1157z00_1803);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4693, BFALSE);
					}
					return BgL_new1157z00_1803;
				}
			}
		}
	}



/* &lambda1826 */
	BgL_ev_letrecz00_bglt BGl_z62lambda1826z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3571, obj_t BgL_vars1154z00_3572, obj_t BgL_vals1155z00_3573,
		obj_t BgL_body1156z00_3574)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{
				obj_t BgL_vars1154z00_1795;
				obj_t BgL_vals1155z00_1796;
				BgL_ev_exprz00_bglt BgL_body1156z00_1797;

				BgL_vars1154z00_1795 = BgL_vars1154z00_3572;
				BgL_vals1155z00_1796 = BgL_vals1155z00_3573;
				BgL_body1156z00_1797 = ((BgL_ev_exprz00_bglt) BgL_body1156z00_3574);
				{	/* Eval/evaluate_types.scm 105 */
					BgL_ev_letrecz00_bglt BgL_new1238z00_2862;

					{	/* Eval/evaluate_types.scm 105 */
						BgL_ev_letrecz00_bglt BgL_new1237z00_2863;

						BgL_new1237z00_2863 =
							((BgL_ev_letrecz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_letrecz00_bgl))));
						{	/* Eval/evaluate_types.scm 105 */
							long BgL_arg1827z00_2864;

							{	/* Eval/evaluate_types.scm 105 */
								long BgL_res2317z00_2866;

								BgL_res2317z00_2866 =
									BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00);
								BgL_arg1827z00_2864 = BgL_res2317z00_2866;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1237z00_2863),
								BgL_arg1827z00_2864);
						}
						{	/* Eval/evaluate_types.scm 105 */
							BgL_objectz00_bglt BgL_auxz00_4700;

							BgL_auxz00_4700 = ((BgL_objectz00_bglt) BgL_new1237z00_2863);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4700, BFALSE);
						}
						BgL_new1238z00_2862 = BgL_new1237z00_2863;
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1238z00_2862)))->
							BgL_varsz00) = ((obj_t) BgL_vars1154z00_1795), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1238z00_2862)))->BgL_valsz00) =
						((obj_t) BgL_vals1155z00_1796), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1238z00_2862)))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1156z00_1797), BUNSPEC);
					return BgL_new1238z00_2862;
				}
			}
		}
	}



/* &<anonymous:1813> */
	BgL_ev_letza2za2_bglt
		BGl_z62zc3anonymousza31813ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3575,
		obj_t BgL_new1152z00_3576)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 103 */
			{
				BgL_ev_letza2za2_bglt BgL_new1152z00_1770;

				BgL_new1152z00_1770 = ((BgL_ev_letza2za2_bglt) BgL_new1152z00_3576);
				((((BgL_ev_binderz00_bglt) CREF(
								((BgL_ev_binderz00_bglt) BgL_new1152z00_1770)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
									BgL_new1152z00_1770)))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4714;

					{	/* Eval/evaluate_types.scm 103 */
						obj_t BgL_classz00_2860;

						BgL_classz00_2860 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 103 */
							obj_t BgL__ortest_1280z00_2861;

							BgL__ortest_1280z00_2861 = BGL_CLASS_NIL(BgL_classz00_2860);
							if (CBOOL(BgL__ortest_1280z00_2861))
								{	/* Eval/evaluate_types.scm 103 */
									BgL_auxz00_4714 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2861);
								}
							else
								{	/* Eval/evaluate_types.scm 103 */
									BgL_auxz00_4714 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2860));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1152z00_1770)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4714), BUNSPEC);
				}
				((((BgL_ev_letza2za2_bglt) CREF(BgL_new1152z00_1770))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1152z00_1770;
			}
		}
	}



/* &lambda1811 */
	BgL_ev_letza2za2_bglt BGl_z62lambda1811z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3577)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 103 */
			{

				{	/* Eval/evaluate_types.scm 103 */
					BgL_ev_letza2za2_bglt BgL_new1151z00_1768;

					BgL_new1151z00_1768 =
						((BgL_ev_letza2za2_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_letza2za2_bgl))));
					{	/* Eval/evaluate_types.scm 103 */
						long BgL_arg1812z00_1769;

						{	/* Eval/evaluate_types.scm 103 */
							long BgL_res2316z00_2857;

							BgL_res2316z00_2857 =
								BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00);
							BgL_arg1812z00_1769 = BgL_res2316z00_2857;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1151z00_1768), BgL_arg1812z00_1769);
					}
					{	/* Eval/evaluate_types.scm 103 */
						BgL_objectz00_bglt BgL_auxz00_4729;

						BgL_auxz00_4729 = ((BgL_objectz00_bglt) BgL_new1151z00_1768);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4729, BFALSE);
					}
					return BgL_new1151z00_1768;
				}
			}
		}
	}



/* &lambda1809 */
	BgL_ev_letza2za2_bglt BGl_z62lambda1809z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3578, obj_t BgL_vars1147z00_3579, obj_t BgL_vals1148z00_3580,
		obj_t BgL_body1149z00_3581, obj_t BgL_boxes1150z00_3582)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 103 */
			{
				obj_t BgL_vars1147z00_1759;
				obj_t BgL_vals1148z00_1760;
				BgL_ev_exprz00_bglt BgL_body1149z00_1761;
				obj_t BgL_boxes1150z00_1762;

				BgL_vars1147z00_1759 = BgL_vars1147z00_3579;
				BgL_vals1148z00_1760 = BgL_vals1148z00_3580;
				BgL_body1149z00_1761 = ((BgL_ev_exprz00_bglt) BgL_body1149z00_3581);
				BgL_boxes1150z00_1762 = BgL_boxes1150z00_3582;
				{	/* Eval/evaluate_types.scm 103 */
					BgL_ev_letza2za2_bglt BgL_new1236z00_2849;

					{	/* Eval/evaluate_types.scm 103 */
						BgL_ev_letza2za2_bglt BgL_new1235z00_2850;

						BgL_new1235z00_2850 =
							((BgL_ev_letza2za2_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_letza2za2_bgl))));
						{	/* Eval/evaluate_types.scm 103 */
							long BgL_arg1810z00_2851;

							{	/* Eval/evaluate_types.scm 103 */
								long BgL_res2315z00_2853;

								BgL_res2315z00_2853 =
									BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00);
								BgL_arg1810z00_2851 = BgL_res2315z00_2853;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1235z00_2850),
								BgL_arg1810z00_2851);
						}
						{	/* Eval/evaluate_types.scm 103 */
							BgL_objectz00_bglt BgL_auxz00_4736;

							BgL_auxz00_4736 = ((BgL_objectz00_bglt) BgL_new1235z00_2850);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4736, BFALSE);
						}
						BgL_new1236z00_2849 = BgL_new1235z00_2850;
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1236z00_2849)))->
							BgL_varsz00) = ((obj_t) BgL_vars1147z00_1759), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1236z00_2849)))->BgL_valsz00) =
						((obj_t) BgL_vals1148z00_1760), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1236z00_2849)))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1149z00_1761), BUNSPEC);
					((((BgL_ev_letza2za2_bglt) CREF(BgL_new1236z00_2849))->BgL_boxesz00) =
						((obj_t) BgL_boxes1150z00_1762), BUNSPEC);
					return BgL_new1236z00_2849;
				}
			}
		}
	}



/* &<anonymous:1820> */
	obj_t BGl_z62zc3anonymousza31820ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3583)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 103 */
			return BNIL;
		}
	}



/* &lambda1819 */
	obj_t BGl_z62lambda1819z62zz__evaluate_typesz00(obj_t BgL_envz00_3584,
		obj_t BgL_oz00_3585, obj_t BgL_vz00_3586)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 103 */
			return
				((((BgL_ev_letza2za2_bglt) CREF(
							((BgL_ev_letza2za2_bglt) BgL_oz00_3585)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3586), BUNSPEC);
		}
	}



/* &lambda1818 */
	obj_t BGl_z62lambda1818z62zz__evaluate_typesz00(obj_t BgL_envz00_3587,
		obj_t BgL_oz00_3588)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 103 */
			return
				(((BgL_ev_letza2za2_bglt) CREF(
						((BgL_ev_letza2za2_bglt) BgL_oz00_3588)))->BgL_boxesz00);
		}
	}



/* &<anonymous:1795> */
	BgL_ev_letz00_bglt BGl_z62zc3anonymousza31795ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3589, obj_t BgL_new1145z00_3590)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 101 */
			{
				BgL_ev_letz00_bglt BgL_new1145z00_1734;

				BgL_new1145z00_1734 = ((BgL_ev_letz00_bglt) BgL_new1145z00_3590);
				((((BgL_ev_binderz00_bglt) CREF(
								((BgL_ev_binderz00_bglt) BgL_new1145z00_1734)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
									BgL_new1145z00_1734)))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4755;

					{	/* Eval/evaluate_types.scm 101 */
						obj_t BgL_classz00_2844;

						BgL_classz00_2844 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 101 */
							obj_t BgL__ortest_1280z00_2845;

							BgL__ortest_1280z00_2845 = BGL_CLASS_NIL(BgL_classz00_2844);
							if (CBOOL(BgL__ortest_1280z00_2845))
								{	/* Eval/evaluate_types.scm 101 */
									BgL_auxz00_4755 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2845);
								}
							else
								{	/* Eval/evaluate_types.scm 101 */
									BgL_auxz00_4755 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2844));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1145z00_1734)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4755), BUNSPEC);
				}
				((((BgL_ev_letz00_bglt) CREF(BgL_new1145z00_1734))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1145z00_1734;
			}
		}
	}



/* &lambda1793 */
	BgL_ev_letz00_bglt BGl_z62lambda1793z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3591)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 101 */
			{

				{	/* Eval/evaluate_types.scm 101 */
					BgL_ev_letz00_bglt BgL_new1144z00_1732;

					BgL_new1144z00_1732 =
						((BgL_ev_letz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_letz00_bgl))));
					{	/* Eval/evaluate_types.scm 101 */
						long BgL_arg1794z00_1733;

						{	/* Eval/evaluate_types.scm 101 */
							long BgL_res2314z00_2841;

							BgL_res2314z00_2841 =
								BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00);
							BgL_arg1794z00_1733 = BgL_res2314z00_2841;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1144z00_1732), BgL_arg1794z00_1733);
					}
					{	/* Eval/evaluate_types.scm 101 */
						BgL_objectz00_bglt BgL_auxz00_4770;

						BgL_auxz00_4770 = ((BgL_objectz00_bglt) BgL_new1144z00_1732);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4770, BFALSE);
					}
					return BgL_new1144z00_1732;
				}
			}
		}
	}



/* &lambda1791 */
	BgL_ev_letz00_bglt BGl_z62lambda1791z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3592, obj_t BgL_vars1140z00_3593, obj_t BgL_vals1141z00_3594,
		obj_t BgL_body1142z00_3595, obj_t BgL_boxes1143z00_3596)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 101 */
			{
				obj_t BgL_vars1140z00_1723;
				obj_t BgL_vals1141z00_1724;
				BgL_ev_exprz00_bglt BgL_body1142z00_1725;
				obj_t BgL_boxes1143z00_1726;

				BgL_vars1140z00_1723 = BgL_vars1140z00_3593;
				BgL_vals1141z00_1724 = BgL_vals1141z00_3594;
				BgL_body1142z00_1725 = ((BgL_ev_exprz00_bglt) BgL_body1142z00_3595);
				BgL_boxes1143z00_1726 = BgL_boxes1143z00_3596;
				{	/* Eval/evaluate_types.scm 101 */
					BgL_ev_letz00_bglt BgL_new1234z00_2833;

					{	/* Eval/evaluate_types.scm 101 */
						BgL_ev_letz00_bglt BgL_new1233z00_2834;

						BgL_new1233z00_2834 =
							((BgL_ev_letz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_letz00_bgl))));
						{	/* Eval/evaluate_types.scm 101 */
							long BgL_arg1792z00_2835;

							{	/* Eval/evaluate_types.scm 101 */
								long BgL_res2313z00_2837;

								BgL_res2313z00_2837 =
									BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00);
								BgL_arg1792z00_2835 = BgL_res2313z00_2837;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1233z00_2834),
								BgL_arg1792z00_2835);
						}
						{	/* Eval/evaluate_types.scm 101 */
							BgL_objectz00_bglt BgL_auxz00_4777;

							BgL_auxz00_4777 = ((BgL_objectz00_bglt) BgL_new1233z00_2834);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4777, BFALSE);
						}
						BgL_new1234z00_2833 = BgL_new1233z00_2834;
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1234z00_2833)))->
							BgL_varsz00) = ((obj_t) BgL_vars1140z00_1723), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1234z00_2833)))->BgL_valsz00) =
						((obj_t) BgL_vals1141z00_1724), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1234z00_2833)))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1142z00_1725), BUNSPEC);
					((((BgL_ev_letz00_bglt) CREF(BgL_new1234z00_2833))->BgL_boxesz00) =
						((obj_t) BgL_boxes1143z00_1726), BUNSPEC);
					return BgL_new1234z00_2833;
				}
			}
		}
	}



/* &<anonymous:1802> */
	obj_t BGl_z62zc3anonymousza31802ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3597)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 101 */
			return BNIL;
		}
	}



/* &lambda1801 */
	obj_t BGl_z62lambda1801z62zz__evaluate_typesz00(obj_t BgL_envz00_3598,
		obj_t BgL_oz00_3599, obj_t BgL_vz00_3600)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 101 */
			return
				((((BgL_ev_letz00_bglt) CREF(
							((BgL_ev_letz00_bglt) BgL_oz00_3599)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3600), BUNSPEC);
		}
	}



/* &lambda1800 */
	obj_t BGl_z62lambda1800z62zz__evaluate_typesz00(obj_t BgL_envz00_3601,
		obj_t BgL_oz00_3602)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 101 */
			return
				(((BgL_ev_letz00_bglt) CREF(
						((BgL_ev_letz00_bglt) BgL_oz00_3602)))->BgL_boxesz00);
		}
	}



/* &<anonymous:1767> */
	BgL_ev_binderz00_bglt
		BGl_z62zc3anonymousza31767ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3603,
		obj_t BgL_new1138z00_3604)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 97 */
			{
				BgL_ev_binderz00_bglt BgL_new1138z00_1681;

				BgL_new1138z00_1681 = ((BgL_ev_binderz00_bglt) BgL_new1138z00_3604);
				((((BgL_ev_binderz00_bglt) CREF(BgL_new1138z00_1681))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt) CREF(BgL_new1138z00_1681))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4794;

					{	/* Eval/evaluate_types.scm 97 */
						obj_t BgL_classz00_2828;

						BgL_classz00_2828 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 97 */
							obj_t BgL__ortest_1280z00_2829;

							BgL__ortest_1280z00_2829 = BGL_CLASS_NIL(BgL_classz00_2828);
							if (CBOOL(BgL__ortest_1280z00_2829))
								{	/* Eval/evaluate_types.scm 97 */
									BgL_auxz00_4794 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2829);
								}
							else
								{	/* Eval/evaluate_types.scm 97 */
									BgL_auxz00_4794 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2828));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) CREF(BgL_new1138z00_1681))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4794), BUNSPEC);
				}
				return BgL_new1138z00_1681;
			}
		}
	}



/* &lambda1765 */
	BgL_ev_binderz00_bglt BGl_z62lambda1765z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3605)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 97 */
			{

				{	/* Eval/evaluate_types.scm 97 */
					BgL_ev_binderz00_bglt BgL_new1137z00_1679;

					BgL_new1137z00_1679 =
						((BgL_ev_binderz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_binderz00_bgl))));
					{	/* Eval/evaluate_types.scm 97 */
						long BgL_arg1766z00_1680;

						{	/* Eval/evaluate_types.scm 97 */
							long BgL_res2312z00_2825;

							BgL_res2312z00_2825 =
								BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00);
							BgL_arg1766z00_1680 = BgL_res2312z00_2825;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1137z00_1679), BgL_arg1766z00_1680);
					}
					{	/* Eval/evaluate_types.scm 97 */
						BgL_objectz00_bglt BgL_auxz00_4807;

						BgL_auxz00_4807 = ((BgL_objectz00_bglt) BgL_new1137z00_1679);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4807, BFALSE);
					}
					return BgL_new1137z00_1679;
				}
			}
		}
	}



/* &lambda1763 */
	BgL_ev_binderz00_bglt BGl_z62lambda1763z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3606, obj_t BgL_vars1133z00_3607, obj_t BgL_vals1134z00_3608,
		obj_t BgL_body1135z00_3609)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 97 */
			{
				obj_t BgL_vars1133z00_1671;
				obj_t BgL_vals1134z00_1672;
				BgL_ev_exprz00_bglt BgL_body1135z00_1673;

				BgL_vars1133z00_1671 = BgL_vars1133z00_3607;
				BgL_vals1134z00_1672 = BgL_vals1134z00_3608;
				BgL_body1135z00_1673 = ((BgL_ev_exprz00_bglt) BgL_body1135z00_3609);
				{	/* Eval/evaluate_types.scm 97 */
					BgL_ev_binderz00_bglt BgL_new1232z00_2817;

					{	/* Eval/evaluate_types.scm 97 */
						BgL_ev_binderz00_bglt BgL_new1231z00_2818;

						BgL_new1231z00_2818 =
							((BgL_ev_binderz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_binderz00_bgl))));
						{	/* Eval/evaluate_types.scm 97 */
							long BgL_arg1764z00_2819;

							{	/* Eval/evaluate_types.scm 97 */
								long BgL_res2311z00_2821;

								BgL_res2311z00_2821 =
									BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00);
								BgL_arg1764z00_2819 = BgL_res2311z00_2821;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1231z00_2818),
								BgL_arg1764z00_2819);
						}
						{	/* Eval/evaluate_types.scm 97 */
							BgL_objectz00_bglt BgL_auxz00_4814;

							BgL_auxz00_4814 = ((BgL_objectz00_bglt) BgL_new1231z00_2818);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4814, BFALSE);
						}
						BgL_new1232z00_2817 = BgL_new1231z00_2818;
					}
					((((BgL_ev_binderz00_bglt) CREF(BgL_new1232z00_2817))->BgL_varsz00) =
						((obj_t) BgL_vars1133z00_1671), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(BgL_new1232z00_2817))->BgL_valsz00) =
						((obj_t) BgL_vals1134z00_1672), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(BgL_new1232z00_2817))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1135z00_1673), BUNSPEC);
					return BgL_new1232z00_2817;
				}
			}
		}
	}



/* &lambda1783 */
	obj_t BGl_z62lambda1783z62zz__evaluate_typesz00(obj_t BgL_envz00_3610,
		obj_t BgL_oz00_3611, obj_t BgL_vz00_3612)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 97 */
			return
				((((BgL_ev_binderz00_bglt) CREF(
							((BgL_ev_binderz00_bglt) BgL_oz00_3611)))->BgL_varsz00) =
				((obj_t) BgL_vz00_3612), BUNSPEC);
		}
	}



/* &lambda1782 */
	obj_t BGl_z62lambda1782z62zz__evaluate_typesz00(obj_t BgL_envz00_3613,
		obj_t BgL_oz00_3614)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 97 */
			return
				(((BgL_ev_binderz00_bglt) CREF(
						((BgL_ev_binderz00_bglt) BgL_oz00_3614)))->BgL_varsz00);
		}
	}



/* &lambda1778 */
	obj_t BGl_z62lambda1778z62zz__evaluate_typesz00(obj_t BgL_envz00_3615,
		obj_t BgL_oz00_3616, obj_t BgL_vz00_3617)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 97 */
			return
				((((BgL_ev_binderz00_bglt) CREF(
							((BgL_ev_binderz00_bglt) BgL_oz00_3616)))->BgL_valsz00) =
				((obj_t) BgL_vz00_3617), BUNSPEC);
		}
	}



/* &lambda1777 */
	obj_t BGl_z62lambda1777z62zz__evaluate_typesz00(obj_t BgL_envz00_3618,
		obj_t BgL_oz00_3619)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 97 */
			return
				(((BgL_ev_binderz00_bglt) CREF(
						((BgL_ev_binderz00_bglt) BgL_oz00_3619)))->BgL_valsz00);
		}
	}



/* &lambda1773 */
	obj_t BGl_z62lambda1773z62zz__evaluate_typesz00(obj_t BgL_envz00_3620,
		obj_t BgL_oz00_3621, obj_t BgL_vz00_3622)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 97 */
			return
				((((BgL_ev_binderz00_bglt) CREF(
							((BgL_ev_binderz00_bglt) BgL_oz00_3621)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3622)), BUNSPEC);
		}
	}



/* &lambda1772 */
	BgL_ev_exprz00_bglt BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3623, obj_t BgL_oz00_3624)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 97 */
			return
				(((BgL_ev_binderz00_bglt) CREF(
						((BgL_ev_binderz00_bglt) BgL_oz00_3624)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1731> */
	BgL_ev_synchroniza7eza7_bglt
		BGl_z62zc3anonymousza31731ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3625,
		obj_t BgL_new1131z00_3626)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			{
				BgL_ev_synchroniza7eza7_bglt BgL_new1131z00_1619;

				BgL_new1131z00_1619 =
					((BgL_ev_synchroniza7eza7_bglt) BgL_new1131z00_3626);
				((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1131z00_1619))->
						BgL_locz00) = ((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4835;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_2802;

						BgL_classz00_2802 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 92 */
							obj_t BgL__ortest_1280z00_2803;

							BgL__ortest_1280z00_2803 = BGL_CLASS_NIL(BgL_classz00_2802);
							if (CBOOL(BgL__ortest_1280z00_2803))
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4835 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2803);
								}
							else
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4835 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2802));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1131z00_1619))->
							BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4835), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4843;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_2804;

						BgL_classz00_2804 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 92 */
							obj_t BgL__ortest_1280z00_2805;

							BgL__ortest_1280z00_2805 = BGL_CLASS_NIL(BgL_classz00_2804);
							if (CBOOL(BgL__ortest_1280z00_2805))
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4843 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2805);
								}
							else
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4843 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2804));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1131z00_1619))->
							BgL_prelockz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4843), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4851;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_2806;

						BgL_classz00_2806 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 92 */
							obj_t BgL__ortest_1280z00_2807;

							BgL__ortest_1280z00_2807 = BGL_CLASS_NIL(BgL_classz00_2806);
							if (CBOOL(BgL__ortest_1280z00_2807))
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4851 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2807);
								}
							else
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4851 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2806));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1131z00_1619))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4851), BUNSPEC);
				}
				return BgL_new1131z00_1619;
			}
		}
	}



/* &lambda1728 */
	BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1728z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3627)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			{

				{	/* Eval/evaluate_types.scm 92 */
					BgL_ev_synchroniza7eza7_bglt BgL_new1129z00_1617;

					BgL_new1129z00_1617 =
						((BgL_ev_synchroniza7eza7_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_synchroniza7eza7_bgl))));
					{	/* Eval/evaluate_types.scm 92 */
						long BgL_arg1730z00_1618;

						{	/* Eval/evaluate_types.scm 92 */
							long BgL_res2310z00_2799;

							BgL_res2310z00_2799 =
								BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
							BgL_arg1730z00_1618 = BgL_res2310z00_2799;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1129z00_1617), BgL_arg1730z00_1618);
					}
					{	/* Eval/evaluate_types.scm 92 */
						BgL_objectz00_bglt BgL_auxz00_4864;

						BgL_auxz00_4864 = ((BgL_objectz00_bglt) BgL_new1129z00_1617);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4864, BFALSE);
					}
					return BgL_new1129z00_1617;
				}
			}
		}
	}



/* &lambda1724 */
	BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1724z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3628, obj_t BgL_loc1125z00_3629, obj_t BgL_mutex1126z00_3630,
		obj_t BgL_prelock1127z00_3631, obj_t BgL_body1128z00_3632)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			{
				obj_t BgL_loc1125z00_1608;
				BgL_ev_exprz00_bglt BgL_mutex1126z00_1609;
				BgL_ev_exprz00_bglt BgL_prelock1127z00_1610;
				BgL_ev_exprz00_bglt BgL_body1128z00_1611;

				BgL_loc1125z00_1608 = BgL_loc1125z00_3629;
				BgL_mutex1126z00_1609 = ((BgL_ev_exprz00_bglt) BgL_mutex1126z00_3630);
				BgL_prelock1127z00_1610 =
					((BgL_ev_exprz00_bglt) BgL_prelock1127z00_3631);
				BgL_body1128z00_1611 = ((BgL_ev_exprz00_bglt) BgL_body1128z00_3632);
				{	/* Eval/evaluate_types.scm 92 */
					BgL_ev_synchroniza7eza7_bglt BgL_new1230z00_2791;

					{	/* Eval/evaluate_types.scm 92 */
						BgL_ev_synchroniza7eza7_bglt BgL_new1229z00_2792;

						BgL_new1229z00_2792 =
							((BgL_ev_synchroniza7eza7_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_synchroniza7eza7_bgl))));
						{	/* Eval/evaluate_types.scm 92 */
							long BgL_arg1727z00_2793;

							{	/* Eval/evaluate_types.scm 92 */
								long BgL_res2309z00_2795;

								BgL_res2309z00_2795 =
									BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
								BgL_arg1727z00_2793 = BgL_res2309z00_2795;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1229z00_2792),
								BgL_arg1727z00_2793);
						}
						{	/* Eval/evaluate_types.scm 92 */
							BgL_objectz00_bglt BgL_auxz00_4871;

							BgL_auxz00_4871 = ((BgL_objectz00_bglt) BgL_new1229z00_2792);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4871, BFALSE);
						}
						BgL_new1230z00_2791 = BgL_new1229z00_2792;
					}
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1230z00_2791))->
							BgL_locz00) = ((obj_t) BgL_loc1125z00_1608), BUNSPEC);
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1230z00_2791))->
							BgL_mutexz00) =
						((BgL_ev_exprz00_bglt) BgL_mutex1126z00_1609), BUNSPEC);
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1230z00_2791))->
							BgL_prelockz00) =
						((BgL_ev_exprz00_bglt) BgL_prelock1127z00_1610), BUNSPEC);
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1230z00_2791))->
							BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1128z00_1611), BUNSPEC);
					return BgL_new1230z00_2791;
				}
			}
		}
	}



/* &lambda1757 */
	obj_t BGl_z62lambda1757z62zz__evaluate_typesz00(obj_t BgL_envz00_3633,
		obj_t BgL_oz00_3634, obj_t BgL_vz00_3635)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) CREF(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3634)))->BgL_locz00) =
				((obj_t) BgL_vz00_3635), BUNSPEC);
		}
	}



/* &lambda1756 */
	obj_t BGl_z62lambda1756z62zz__evaluate_typesz00(obj_t BgL_envz00_3636,
		obj_t BgL_oz00_3637)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) CREF(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3637)))->BgL_locz00);
		}
	}



/* &lambda1751 */
	obj_t BGl_z62lambda1751z62zz__evaluate_typesz00(obj_t BgL_envz00_3638,
		obj_t BgL_oz00_3639, obj_t BgL_vz00_3640)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) CREF(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3639)))->BgL_mutexz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3640)), BUNSPEC);
		}
	}



/* &lambda1750 */
	BgL_ev_exprz00_bglt BGl_z62lambda1750z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3641, obj_t BgL_oz00_3642)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) CREF(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3642)))->BgL_mutexz00);
		}
	}



/* &lambda1745 */
	obj_t BGl_z62lambda1745z62zz__evaluate_typesz00(obj_t BgL_envz00_3643,
		obj_t BgL_oz00_3644, obj_t BgL_vz00_3645)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) CREF(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3644)))->
					BgL_prelockz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3645)), BUNSPEC);
		}
	}



/* &lambda1744 */
	BgL_ev_exprz00_bglt BGl_z62lambda1744z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3646, obj_t BgL_oz00_3647)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) CREF(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3647)))->BgL_prelockz00);
		}
	}



/* &lambda1738 */
	obj_t BGl_z62lambda1738z62zz__evaluate_typesz00(obj_t BgL_envz00_3648,
		obj_t BgL_oz00_3649, obj_t BgL_vz00_3650)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) CREF(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3649)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3650)), BUNSPEC);
		}
	}



/* &lambda1737 */
	BgL_ev_exprz00_bglt BGl_z62lambda1737z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3651, obj_t BgL_oz00_3652)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) CREF(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3652)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1703> */
	BgL_ev_withzd2handlerzd2_bglt
		BGl_z62zc3anonymousza31703ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3653,
		obj_t BgL_new1123z00_3654)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			{
				BgL_ev_withzd2handlerzd2_bglt BgL_new1123z00_1576;

				BgL_new1123z00_1576 =
					((BgL_ev_withzd2handlerzd2_bglt) BgL_new1123z00_3654);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4900;

					{	/* Eval/evaluate_types.scm 89 */
						obj_t BgL_classz00_2775;

						BgL_classz00_2775 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 89 */
							obj_t BgL__ortest_1280z00_2776;

							BgL__ortest_1280z00_2776 = BGL_CLASS_NIL(BgL_classz00_2775);
							if (CBOOL(BgL__ortest_1280z00_2776))
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_4900 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2776);
								}
							else
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_4900 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2775));
								}
						}
					}
					((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1123z00_1576))->
							BgL_handlerz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4900), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4908;

					{	/* Eval/evaluate_types.scm 89 */
						obj_t BgL_classz00_2777;

						BgL_classz00_2777 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 89 */
							obj_t BgL__ortest_1280z00_2778;

							BgL__ortest_1280z00_2778 = BGL_CLASS_NIL(BgL_classz00_2777);
							if (CBOOL(BgL__ortest_1280z00_2778))
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_4908 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2778);
								}
							else
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_4908 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2777));
								}
						}
					}
					((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1123z00_1576))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4908), BUNSPEC);
				}
				return BgL_new1123z00_1576;
			}
		}
	}



/* &lambda1701 */
	BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1701z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3655)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			{

				{	/* Eval/evaluate_types.scm 89 */
					BgL_ev_withzd2handlerzd2_bglt BgL_new1122z00_1574;

					BgL_new1122z00_1574 =
						((BgL_ev_withzd2handlerzd2_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_withzd2handlerzd2_bgl))));
					{	/* Eval/evaluate_types.scm 89 */
						long BgL_arg1702z00_1575;

						{	/* Eval/evaluate_types.scm 89 */
							long BgL_res2308z00_2772;

							BgL_res2308z00_2772 =
								BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
							BgL_arg1702z00_1575 = BgL_res2308z00_2772;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1122z00_1574), BgL_arg1702z00_1575);
					}
					{	/* Eval/evaluate_types.scm 89 */
						BgL_objectz00_bglt BgL_auxz00_4921;

						BgL_auxz00_4921 = ((BgL_objectz00_bglt) BgL_new1122z00_1574);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4921, BFALSE);
					}
					return BgL_new1122z00_1574;
				}
			}
		}
	}



/* &lambda1699 */
	BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1699z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3656, obj_t BgL_handler1119z00_3657, obj_t BgL_body1120z00_3658)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			{
				BgL_ev_exprz00_bglt BgL_handler1119z00_1567;
				BgL_ev_exprz00_bglt BgL_body1120z00_1568;

				BgL_handler1119z00_1567 =
					((BgL_ev_exprz00_bglt) BgL_handler1119z00_3657);
				BgL_body1120z00_1568 = ((BgL_ev_exprz00_bglt) BgL_body1120z00_3658);
				{	/* Eval/evaluate_types.scm 89 */
					BgL_ev_withzd2handlerzd2_bglt BgL_new1228z00_2764;

					{	/* Eval/evaluate_types.scm 89 */
						BgL_ev_withzd2handlerzd2_bglt BgL_new1227z00_2765;

						BgL_new1227z00_2765 =
							((BgL_ev_withzd2handlerzd2_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_withzd2handlerzd2_bgl))));
						{	/* Eval/evaluate_types.scm 89 */
							long BgL_arg1700z00_2766;

							{	/* Eval/evaluate_types.scm 89 */
								long BgL_res2307z00_2768;

								BgL_res2307z00_2768 =
									BGL_CLASS_INDEX
									(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
								BgL_arg1700z00_2766 = BgL_res2307z00_2768;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1227z00_2765),
								BgL_arg1700z00_2766);
						}
						{	/* Eval/evaluate_types.scm 89 */
							BgL_objectz00_bglt BgL_auxz00_4928;

							BgL_auxz00_4928 = ((BgL_objectz00_bglt) BgL_new1227z00_2765);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4928, BFALSE);
						}
						BgL_new1228z00_2764 = BgL_new1227z00_2765;
					}
					((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1228z00_2764))->
							BgL_handlerz00) =
						((BgL_ev_exprz00_bglt) BgL_handler1119z00_1567), BUNSPEC);
					((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1228z00_2764))->
							BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1120z00_1568), BUNSPEC);
					return BgL_new1228z00_2764;
				}
			}
		}
	}



/* &lambda1716 */
	obj_t BGl_z62lambda1716z62zz__evaluate_typesz00(obj_t BgL_envz00_3659,
		obj_t BgL_oz00_3660, obj_t BgL_vz00_3661)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			return
				((((BgL_ev_withzd2handlerzd2_bglt) CREF(
							((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3660)))->
					BgL_handlerz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3661)), BUNSPEC);
		}
	}



/* &lambda1715 */
	BgL_ev_exprz00_bglt BGl_z62lambda1715z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3662, obj_t BgL_oz00_3663)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			return
				(((BgL_ev_withzd2handlerzd2_bglt) CREF(
						((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3663)))->BgL_handlerz00);
		}
	}



/* &lambda1710 */
	obj_t BGl_z62lambda1710z62zz__evaluate_typesz00(obj_t BgL_envz00_3664,
		obj_t BgL_oz00_3665, obj_t BgL_vz00_3666)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			return
				((((BgL_ev_withzd2handlerzd2_bglt) CREF(
							((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3665)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3666)), BUNSPEC);
		}
	}



/* &lambda1709 */
	BgL_ev_exprz00_bglt BGl_z62lambda1709z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3667, obj_t BgL_oz00_3668)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			return
				(((BgL_ev_withzd2handlerzd2_bglt) CREF(
						((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3668)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1683> */
	BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62zc3anonymousza31683ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3669,
		obj_t BgL_new1117z00_3670)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			{
				BgL_ev_unwindzd2protectzd2_bglt BgL_new1117z00_1535;

				BgL_new1117z00_1535 =
					((BgL_ev_unwindzd2protectzd2_bglt) BgL_new1117z00_3670);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4945;

					{	/* Eval/evaluate_types.scm 86 */
						obj_t BgL_classz00_2754;

						BgL_classz00_2754 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 86 */
							obj_t BgL__ortest_1280z00_2755;

							BgL__ortest_1280z00_2755 = BGL_CLASS_NIL(BgL_classz00_2754);
							if (CBOOL(BgL__ortest_1280z00_2755))
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_4945 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2755);
								}
							else
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_4945 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2754));
								}
						}
					}
					((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1117z00_1535))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4945), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4953;

					{	/* Eval/evaluate_types.scm 86 */
						obj_t BgL_classz00_2756;

						BgL_classz00_2756 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 86 */
							obj_t BgL__ortest_1280z00_2757;

							BgL__ortest_1280z00_2757 = BGL_CLASS_NIL(BgL_classz00_2756);
							if (CBOOL(BgL__ortest_1280z00_2757))
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_4953 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2757);
								}
							else
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_4953 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2756));
								}
						}
					}
					((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1117z00_1535))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4953), BUNSPEC);
				}
				return BgL_new1117z00_1535;
			}
		}
	}



/* &lambda1681 */
	BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1681z62zz__evaluate_typesz00(obj_t BgL_envz00_3671)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			{

				{	/* Eval/evaluate_types.scm 86 */
					BgL_ev_unwindzd2protectzd2_bglt BgL_new1116z00_1533;

					BgL_new1116z00_1533 =
						((BgL_ev_unwindzd2protectzd2_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_unwindzd2protectzd2_bgl))));
					{	/* Eval/evaluate_types.scm 86 */
						long BgL_arg1682z00_1534;

						{	/* Eval/evaluate_types.scm 86 */
							long BgL_res2306z00_2751;

							BgL_res2306z00_2751 =
								BGL_CLASS_INDEX
								(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
							BgL_arg1682z00_1534 = BgL_res2306z00_2751;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1116z00_1533), BgL_arg1682z00_1534);
					}
					{	/* Eval/evaluate_types.scm 86 */
						BgL_objectz00_bglt BgL_auxz00_4966;

						BgL_auxz00_4966 = ((BgL_objectz00_bglt) BgL_new1116z00_1533);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4966, BFALSE);
					}
					return BgL_new1116z00_1533;
				}
			}
		}
	}



/* &lambda1679 */
	BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1679z62zz__evaluate_typesz00(obj_t BgL_envz00_3672,
		obj_t BgL_e1114z00_3673, obj_t BgL_body1115z00_3674)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			{
				BgL_ev_exprz00_bglt BgL_e1114z00_1526;
				BgL_ev_exprz00_bglt BgL_body1115z00_1527;

				BgL_e1114z00_1526 = ((BgL_ev_exprz00_bglt) BgL_e1114z00_3673);
				BgL_body1115z00_1527 = ((BgL_ev_exprz00_bglt) BgL_body1115z00_3674);
				{	/* Eval/evaluate_types.scm 86 */
					BgL_ev_unwindzd2protectzd2_bglt BgL_new1226z00_2743;

					{	/* Eval/evaluate_types.scm 86 */
						BgL_ev_unwindzd2protectzd2_bglt BgL_new1225z00_2744;

						BgL_new1225z00_2744 =
							((BgL_ev_unwindzd2protectzd2_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_unwindzd2protectzd2_bgl))));
						{	/* Eval/evaluate_types.scm 86 */
							long BgL_arg1680z00_2745;

							{	/* Eval/evaluate_types.scm 86 */
								long BgL_res2305z00_2747;

								BgL_res2305z00_2747 =
									BGL_CLASS_INDEX
									(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
								BgL_arg1680z00_2745 = BgL_res2305z00_2747;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1225z00_2744),
								BgL_arg1680z00_2745);
						}
						{	/* Eval/evaluate_types.scm 86 */
							BgL_objectz00_bglt BgL_auxz00_4973;

							BgL_auxz00_4973 = ((BgL_objectz00_bglt) BgL_new1225z00_2744);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4973, BFALSE);
						}
						BgL_new1226z00_2743 = BgL_new1225z00_2744;
					}
					((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1226z00_2743))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_e1114z00_1526), BUNSPEC);
					((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1226z00_2743))->
							BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1115z00_1527), BUNSPEC);
					return BgL_new1226z00_2743;
				}
			}
		}
	}



/* &lambda1693 */
	obj_t BGl_z62lambda1693z62zz__evaluate_typesz00(obj_t BgL_envz00_3675,
		obj_t BgL_oz00_3676, obj_t BgL_vz00_3677)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			return
				((((BgL_ev_unwindzd2protectzd2_bglt) CREF(
							((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3676)))->BgL_ez00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3677)), BUNSPEC);
		}
	}



/* &lambda1692 */
	BgL_ev_exprz00_bglt BGl_z62lambda1692z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3678, obj_t BgL_oz00_3679)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			return
				(((BgL_ev_unwindzd2protectzd2_bglt) CREF(
						((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3679)))->BgL_ez00);
		}
	}



/* &lambda1688 */
	obj_t BGl_z62lambda1688z62zz__evaluate_typesz00(obj_t BgL_envz00_3680,
		obj_t BgL_oz00_3681, obj_t BgL_vz00_3682)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			return
				((((BgL_ev_unwindzd2protectzd2_bglt) CREF(
							((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3681)))->
					BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3682)), BUNSPEC);
		}
	}



/* &lambda1687 */
	BgL_ev_exprz00_bglt BGl_z62lambda1687z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3683, obj_t BgL_oz00_3684)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			return
				(((BgL_ev_unwindzd2protectzd2_bglt) CREF(
						((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3684)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1663> */
	BgL_ev_bindzd2exitzd2_bglt
		BGl_z62zc3anonymousza31663ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3685,
		obj_t BgL_new1112z00_3686)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			{
				BgL_ev_bindzd2exitzd2_bglt BgL_new1112z00_1494;

				BgL_new1112z00_1494 =
					((BgL_ev_bindzd2exitzd2_bglt) BgL_new1112z00_3686);
				{
					BgL_ev_varz00_bglt BgL_auxz00_4990;

					{	/* Eval/evaluate_types.scm 83 */
						obj_t BgL_classz00_2733;

						BgL_classz00_2733 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 83 */
							obj_t BgL__ortest_1280z00_2734;

							BgL__ortest_1280z00_2734 = BGL_CLASS_NIL(BgL_classz00_2733);
							if (CBOOL(BgL__ortest_1280z00_2734))
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_4990 =
										((BgL_ev_varz00_bglt) BgL__ortest_1280z00_2734);
								}
							else
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_4990 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2733));
								}
						}
					}
					((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1112z00_1494))->
							BgL_varz00) = ((BgL_ev_varz00_bglt) BgL_auxz00_4990), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4998;

					{	/* Eval/evaluate_types.scm 83 */
						obj_t BgL_classz00_2735;

						BgL_classz00_2735 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 83 */
							obj_t BgL__ortest_1280z00_2736;

							BgL__ortest_1280z00_2736 = BGL_CLASS_NIL(BgL_classz00_2735);
							if (CBOOL(BgL__ortest_1280z00_2736))
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_4998 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2736);
								}
							else
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_4998 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2735));
								}
						}
					}
					((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1112z00_1494))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4998), BUNSPEC);
				}
				return BgL_new1112z00_1494;
			}
		}
	}



/* &lambda1661 */
	BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1661z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3687)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			{

				{	/* Eval/evaluate_types.scm 83 */
					BgL_ev_bindzd2exitzd2_bglt BgL_new1110z00_1492;

					BgL_new1110z00_1492 =
						((BgL_ev_bindzd2exitzd2_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_bindzd2exitzd2_bgl))));
					{	/* Eval/evaluate_types.scm 83 */
						long BgL_arg1662z00_1493;

						{	/* Eval/evaluate_types.scm 83 */
							long BgL_res2304z00_2730;

							BgL_res2304z00_2730 =
								BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
							BgL_arg1662z00_1493 = BgL_res2304z00_2730;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1110z00_1492), BgL_arg1662z00_1493);
					}
					{	/* Eval/evaluate_types.scm 83 */
						BgL_objectz00_bglt BgL_auxz00_5011;

						BgL_auxz00_5011 = ((BgL_objectz00_bglt) BgL_new1110z00_1492);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5011, BFALSE);
					}
					return BgL_new1110z00_1492;
				}
			}
		}
	}



/* &lambda1659 */
	BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1659z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3688, obj_t BgL_var1108z00_3689, obj_t BgL_body1109z00_3690)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			{
				BgL_ev_varz00_bglt BgL_var1108z00_1485;
				BgL_ev_exprz00_bglt BgL_body1109z00_1486;

				BgL_var1108z00_1485 = ((BgL_ev_varz00_bglt) BgL_var1108z00_3689);
				BgL_body1109z00_1486 = ((BgL_ev_exprz00_bglt) BgL_body1109z00_3690);
				{	/* Eval/evaluate_types.scm 83 */
					BgL_ev_bindzd2exitzd2_bglt BgL_new1224z00_2722;

					{	/* Eval/evaluate_types.scm 83 */
						BgL_ev_bindzd2exitzd2_bglt BgL_new1223z00_2723;

						BgL_new1223z00_2723 =
							((BgL_ev_bindzd2exitzd2_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_bindzd2exitzd2_bgl))));
						{	/* Eval/evaluate_types.scm 83 */
							long BgL_arg1660z00_2724;

							{	/* Eval/evaluate_types.scm 83 */
								long BgL_res2303z00_2726;

								BgL_res2303z00_2726 =
									BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
								BgL_arg1660z00_2724 = BgL_res2303z00_2726;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1223z00_2723),
								BgL_arg1660z00_2724);
						}
						{	/* Eval/evaluate_types.scm 83 */
							BgL_objectz00_bglt BgL_auxz00_5018;

							BgL_auxz00_5018 = ((BgL_objectz00_bglt) BgL_new1223z00_2723);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5018, BFALSE);
						}
						BgL_new1224z00_2722 = BgL_new1223z00_2723;
					}
					((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1224z00_2722))->
							BgL_varz00) =
						((BgL_ev_varz00_bglt) BgL_var1108z00_1485), BUNSPEC);
					((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1224z00_2722))->
							BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1109z00_1486), BUNSPEC);
					return BgL_new1224z00_2722;
				}
			}
		}
	}



/* &lambda1673 */
	obj_t BGl_z62lambda1673z62zz__evaluate_typesz00(obj_t BgL_envz00_3691,
		obj_t BgL_oz00_3692, obj_t BgL_vz00_3693)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			return
				((((BgL_ev_bindzd2exitzd2_bglt) CREF(
							((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3692)))->BgL_varz00) =
				((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_vz00_3693)), BUNSPEC);
		}
	}



/* &lambda1672 */
	BgL_ev_varz00_bglt BGl_z62lambda1672z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3694, obj_t BgL_oz00_3695)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			return
				(((BgL_ev_bindzd2exitzd2_bglt) CREF(
						((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3695)))->BgL_varz00);
		}
	}



/* &lambda1668 */
	obj_t BGl_z62lambda1668z62zz__evaluate_typesz00(obj_t BgL_envz00_3696,
		obj_t BgL_oz00_3697, obj_t BgL_vz00_3698)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			return
				((((BgL_ev_bindzd2exitzd2_bglt) CREF(
							((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3697)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3698)), BUNSPEC);
		}
	}



/* &lambda1667 */
	BgL_ev_exprz00_bglt BGl_z62lambda1667z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3699, obj_t BgL_oz00_3700)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			return
				(((BgL_ev_bindzd2exitzd2_bglt) CREF(
						((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3700)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1653> */
	BgL_ev_defglobalz00_bglt
		BGl_z62zc3anonymousza31653ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3701,
		obj_t BgL_new1106z00_3702)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 82 */
			{
				BgL_ev_defglobalz00_bglt BgL_new1106z00_1473;

				BgL_new1106z00_1473 = ((BgL_ev_defglobalz00_bglt) BgL_new1106z00_3702);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5035;

					{	/* Eval/evaluate_types.scm 82 */
						obj_t BgL_classz00_2714;

						BgL_classz00_2714 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 82 */
							obj_t BgL__ortest_1280z00_2715;

							BgL__ortest_1280z00_2715 = BGL_CLASS_NIL(BgL_classz00_2714);
							if (CBOOL(BgL__ortest_1280z00_2715))
								{	/* Eval/evaluate_types.scm 82 */
									BgL_auxz00_5035 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2715);
								}
							else
								{	/* Eval/evaluate_types.scm 82 */
									BgL_auxz00_5035 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2714));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1106z00_1473)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5035), BUNSPEC);
				}
				((((BgL_ev_setglobalz00_bglt) CREF(
								((BgL_ev_setglobalz00_bglt) BgL_new1106z00_1473)))->
						BgL_locz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
									BgL_new1106z00_1473)))->BgL_namez00) =
					((obj_t) BGl_symbol2692z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
									BgL_new1106z00_1473)))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1106z00_1473;
			}
		}
	}



/* &lambda1651 */
	BgL_ev_defglobalz00_bglt BGl_z62lambda1651z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3703)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 82 */
			{

				{	/* Eval/evaluate_types.scm 82 */
					BgL_ev_defglobalz00_bglt BgL_new1105z00_1471;

					BgL_new1105z00_1471 =
						((BgL_ev_defglobalz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_defglobalz00_bgl))));
					{	/* Eval/evaluate_types.scm 82 */
						long BgL_arg1652z00_1472;

						{	/* Eval/evaluate_types.scm 82 */
							long BgL_res2302z00_2711;

							BgL_res2302z00_2711 =
								BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00);
							BgL_arg1652z00_1472 = BgL_res2302z00_2711;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1105z00_1471), BgL_arg1652z00_1472);
					}
					{	/* Eval/evaluate_types.scm 82 */
						BgL_objectz00_bglt BgL_auxz00_5055;

						BgL_auxz00_5055 = ((BgL_objectz00_bglt) BgL_new1105z00_1471);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5055, BFALSE);
					}
					return BgL_new1105z00_1471;
				}
			}
		}
	}



/* &lambda1649 */
	BgL_ev_defglobalz00_bglt BGl_z62lambda1649z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3704, obj_t BgL_e1101z00_3705, obj_t BgL_loc1102z00_3706,
		obj_t BgL_name1103z00_3707, obj_t BgL_mod1104z00_3708)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 82 */
			{
				BgL_ev_exprz00_bglt BgL_e1101z00_1462;
				obj_t BgL_loc1102z00_1463;
				obj_t BgL_name1103z00_1464;
				obj_t BgL_mod1104z00_1465;

				BgL_e1101z00_1462 = ((BgL_ev_exprz00_bglt) BgL_e1101z00_3705);
				BgL_loc1102z00_1463 = BgL_loc1102z00_3706;
				BgL_name1103z00_1464 = BgL_name1103z00_3707;
				BgL_mod1104z00_1465 = BgL_mod1104z00_3708;
				{	/* Eval/evaluate_types.scm 82 */
					BgL_ev_defglobalz00_bglt BgL_new1222z00_2703;

					{	/* Eval/evaluate_types.scm 82 */
						BgL_ev_defglobalz00_bglt BgL_new1221z00_2704;

						BgL_new1221z00_2704 =
							((BgL_ev_defglobalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_defglobalz00_bgl))));
						{	/* Eval/evaluate_types.scm 82 */
							long BgL_arg1650z00_2705;

							{	/* Eval/evaluate_types.scm 82 */
								long BgL_res2301z00_2707;

								BgL_res2301z00_2707 =
									BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00);
								BgL_arg1650z00_2705 = BgL_res2301z00_2707;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1221z00_2704),
								BgL_arg1650z00_2705);
						}
						{	/* Eval/evaluate_types.scm 82 */
							BgL_objectz00_bglt BgL_auxz00_5062;

							BgL_auxz00_5062 = ((BgL_objectz00_bglt) BgL_new1221z00_2704);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5062, BFALSE);
						}
						BgL_new1222z00_2703 = BgL_new1221z00_2704;
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1222z00_2703)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1101z00_1462), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
										BgL_new1222z00_2703)))->BgL_locz00) =
						((obj_t) BgL_loc1102z00_1463), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
										BgL_new1222z00_2703)))->BgL_namez00) =
						((obj_t) BgL_name1103z00_1464), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
										BgL_new1222z00_2703)))->BgL_modz00) =
						((obj_t) BgL_mod1104z00_1465), BUNSPEC);
					return BgL_new1222z00_2703;
				}
			}
		}
	}



/* &<anonymous:1626> */
	BgL_ev_setglobalz00_bglt
		BGl_z62zc3anonymousza31626ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3709,
		obj_t BgL_new1099z00_3710)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			{
				BgL_ev_setglobalz00_bglt BgL_new1099z00_1420;

				BgL_new1099z00_1420 = ((BgL_ev_setglobalz00_bglt) BgL_new1099z00_3710);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5074;

					{	/* Eval/evaluate_types.scm 78 */
						obj_t BgL_classz00_2701;

						BgL_classz00_2701 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 78 */
							obj_t BgL__ortest_1280z00_2702;

							BgL__ortest_1280z00_2702 = BGL_CLASS_NIL(BgL_classz00_2701);
							if (CBOOL(BgL__ortest_1280z00_2702))
								{	/* Eval/evaluate_types.scm 78 */
									BgL_auxz00_5074 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2702);
								}
							else
								{	/* Eval/evaluate_types.scm 78 */
									BgL_auxz00_5074 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2701));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1099z00_1420)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5074), BUNSPEC);
				}
				((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1099z00_1420))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1099z00_1420))->BgL_namez00) =
					((obj_t) BGl_symbol2692z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1099z00_1420))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1099z00_1420;
			}
		}
	}



/* &lambda1624 */
	BgL_ev_setglobalz00_bglt BGl_z62lambda1624z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3711)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			{

				{	/* Eval/evaluate_types.scm 78 */
					BgL_ev_setglobalz00_bglt BgL_new1098z00_1418;

					BgL_new1098z00_1418 =
						((BgL_ev_setglobalz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_setglobalz00_bgl))));
					{	/* Eval/evaluate_types.scm 78 */
						long BgL_arg1625z00_1419;

						{	/* Eval/evaluate_types.scm 78 */
							long BgL_res2300z00_2698;

							BgL_res2300z00_2698 =
								BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00);
							BgL_arg1625z00_1419 = BgL_res2300z00_2698;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1098z00_1418), BgL_arg1625z00_1419);
					}
					{	/* Eval/evaluate_types.scm 78 */
						BgL_objectz00_bglt BgL_auxz00_5091;

						BgL_auxz00_5091 = ((BgL_objectz00_bglt) BgL_new1098z00_1418);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5091, BFALSE);
					}
					return BgL_new1098z00_1418;
				}
			}
		}
	}



/* &lambda1622 */
	BgL_ev_setglobalz00_bglt BGl_z62lambda1622z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3712, obj_t BgL_e1094z00_3713, obj_t BgL_loc1095z00_3714,
		obj_t BgL_name1096z00_3715, obj_t BgL_mod1097z00_3716)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			{
				BgL_ev_exprz00_bglt BgL_e1094z00_1409;
				obj_t BgL_loc1095z00_1410;
				obj_t BgL_name1096z00_1411;
				obj_t BgL_mod1097z00_1412;

				BgL_e1094z00_1409 = ((BgL_ev_exprz00_bglt) BgL_e1094z00_3713);
				BgL_loc1095z00_1410 = BgL_loc1095z00_3714;
				BgL_name1096z00_1411 = BgL_name1096z00_3715;
				BgL_mod1097z00_1412 = BgL_mod1097z00_3716;
				{	/* Eval/evaluate_types.scm 78 */
					BgL_ev_setglobalz00_bglt BgL_new1220z00_2690;

					{	/* Eval/evaluate_types.scm 78 */
						BgL_ev_setglobalz00_bglt BgL_new1219z00_2691;

						BgL_new1219z00_2691 =
							((BgL_ev_setglobalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_setglobalz00_bgl))));
						{	/* Eval/evaluate_types.scm 78 */
							long BgL_arg1623z00_2692;

							{	/* Eval/evaluate_types.scm 78 */
								long BgL_res2299z00_2694;

								BgL_res2299z00_2694 =
									BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00);
								BgL_arg1623z00_2692 = BgL_res2299z00_2694;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1219z00_2691),
								BgL_arg1623z00_2692);
						}
						{	/* Eval/evaluate_types.scm 78 */
							BgL_objectz00_bglt BgL_auxz00_5098;

							BgL_auxz00_5098 = ((BgL_objectz00_bglt) BgL_new1219z00_2691);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5098, BFALSE);
						}
						BgL_new1220z00_2690 = BgL_new1219z00_2691;
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1220z00_2690)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1094z00_1409), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1220z00_2690))->
							BgL_locz00) = ((obj_t) BgL_loc1095z00_1410), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1220z00_2690))->
							BgL_namez00) = ((obj_t) BgL_name1096z00_1411), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1220z00_2690))->
							BgL_modz00) = ((obj_t) BgL_mod1097z00_1412), BUNSPEC);
					return BgL_new1220z00_2690;
				}
			}
		}
	}



/* &lambda1643 */
	obj_t BGl_z62lambda1643z62zz__evaluate_typesz00(obj_t BgL_envz00_3717,
		obj_t BgL_oz00_3718, obj_t BgL_vz00_3719)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			return
				((((BgL_ev_setglobalz00_bglt) CREF(
							((BgL_ev_setglobalz00_bglt) BgL_oz00_3718)))->BgL_locz00) =
				((obj_t) BgL_vz00_3719), BUNSPEC);
		}
	}



/* &lambda1642 */
	obj_t BGl_z62lambda1642z62zz__evaluate_typesz00(obj_t BgL_envz00_3720,
		obj_t BgL_oz00_3721)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) CREF(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3721)))->BgL_locz00);
		}
	}



/* &lambda1637 */
	obj_t BGl_z62lambda1637z62zz__evaluate_typesz00(obj_t BgL_envz00_3722,
		obj_t BgL_oz00_3723, obj_t BgL_vz00_3724)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			return
				((((BgL_ev_setglobalz00_bglt) CREF(
							((BgL_ev_setglobalz00_bglt) BgL_oz00_3723)))->BgL_namez00) =
				((obj_t) BgL_vz00_3724), BUNSPEC);
		}
	}



/* &lambda1636 */
	obj_t BGl_z62lambda1636z62zz__evaluate_typesz00(obj_t BgL_envz00_3725,
		obj_t BgL_oz00_3726)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) CREF(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3726)))->BgL_namez00);
		}
	}



/* &lambda1632 */
	obj_t BGl_z62lambda1632z62zz__evaluate_typesz00(obj_t BgL_envz00_3727,
		obj_t BgL_oz00_3728, obj_t BgL_vz00_3729)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			return
				((((BgL_ev_setglobalz00_bglt) CREF(
							((BgL_ev_setglobalz00_bglt) BgL_oz00_3728)))->BgL_modz00) =
				((obj_t) BgL_vz00_3729), BUNSPEC);
		}
	}



/* &lambda1631 */
	obj_t BGl_z62lambda1631z62zz__evaluate_typesz00(obj_t BgL_envz00_3730,
		obj_t BgL_oz00_3731)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) CREF(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3731)))->BgL_modz00);
		}
	}



/* &<anonymous:1609> */
	BgL_ev_setlocalz00_bglt
		BGl_z62zc3anonymousza31609ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3732,
		obj_t BgL_new1092z00_3733)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 76 */
			{
				BgL_ev_setlocalz00_bglt BgL_new1092z00_1387;

				BgL_new1092z00_1387 = ((BgL_ev_setlocalz00_bglt) BgL_new1092z00_3733);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5119;

					{	/* Eval/evaluate_types.scm 76 */
						obj_t BgL_classz00_2677;

						BgL_classz00_2677 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 76 */
							obj_t BgL__ortest_1280z00_2678;

							BgL__ortest_1280z00_2678 = BGL_CLASS_NIL(BgL_classz00_2677);
							if (CBOOL(BgL__ortest_1280z00_2678))
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5119 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2678);
								}
							else
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5119 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2677));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1092z00_1387)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5119), BUNSPEC);
				}
				{
					BgL_ev_varz00_bglt BgL_auxz00_5128;

					{	/* Eval/evaluate_types.scm 76 */
						obj_t BgL_classz00_2679;

						BgL_classz00_2679 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 76 */
							obj_t BgL__ortest_1280z00_2680;

							BgL__ortest_1280z00_2680 = BGL_CLASS_NIL(BgL_classz00_2679);
							if (CBOOL(BgL__ortest_1280z00_2680))
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5128 =
										((BgL_ev_varz00_bglt) BgL__ortest_1280z00_2680);
								}
							else
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5128 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2679));
								}
						}
					}
					((((BgL_ev_setlocalz00_bglt) CREF(BgL_new1092z00_1387))->BgL_vz00) =
						((BgL_ev_varz00_bglt) BgL_auxz00_5128), BUNSPEC);
				}
				return BgL_new1092z00_1387;
			}
		}
	}



/* &lambda1607 */
	BgL_ev_setlocalz00_bglt BGl_z62lambda1607z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3734)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 76 */
			{

				{	/* Eval/evaluate_types.scm 76 */
					BgL_ev_setlocalz00_bglt BgL_new1091z00_1385;

					BgL_new1091z00_1385 =
						((BgL_ev_setlocalz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_setlocalz00_bgl))));
					{	/* Eval/evaluate_types.scm 76 */
						long BgL_arg1608z00_1386;

						{	/* Eval/evaluate_types.scm 76 */
							long BgL_res2298z00_2674;

							BgL_res2298z00_2674 =
								BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00);
							BgL_arg1608z00_1386 = BgL_res2298z00_2674;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1091z00_1385), BgL_arg1608z00_1386);
					}
					{	/* Eval/evaluate_types.scm 76 */
						BgL_objectz00_bglt BgL_auxz00_5141;

						BgL_auxz00_5141 = ((BgL_objectz00_bglt) BgL_new1091z00_1385);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5141, BFALSE);
					}
					return BgL_new1091z00_1385;
				}
			}
		}
	}



/* &lambda1596 */
	BgL_ev_setlocalz00_bglt BGl_z62lambda1596z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3735, obj_t BgL_e1089z00_3736, obj_t BgL_v1090z00_3737)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 76 */
			{
				BgL_ev_exprz00_bglt BgL_e1089z00_1378;
				BgL_ev_varz00_bglt BgL_v1090z00_1379;

				BgL_e1089z00_1378 = ((BgL_ev_exprz00_bglt) BgL_e1089z00_3736);
				BgL_v1090z00_1379 = ((BgL_ev_varz00_bglt) BgL_v1090z00_3737);
				{	/* Eval/evaluate_types.scm 76 */
					BgL_ev_setlocalz00_bglt BgL_new1218z00_2666;

					{	/* Eval/evaluate_types.scm 76 */
						BgL_ev_setlocalz00_bglt BgL_new1217z00_2667;

						BgL_new1217z00_2667 =
							((BgL_ev_setlocalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_setlocalz00_bgl))));
						{	/* Eval/evaluate_types.scm 76 */
							long BgL_arg1606z00_2668;

							{	/* Eval/evaluate_types.scm 76 */
								long BgL_res2297z00_2670;

								BgL_res2297z00_2670 =
									BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00);
								BgL_arg1606z00_2668 = BgL_res2297z00_2670;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1217z00_2667),
								BgL_arg1606z00_2668);
						}
						{	/* Eval/evaluate_types.scm 76 */
							BgL_objectz00_bglt BgL_auxz00_5148;

							BgL_auxz00_5148 = ((BgL_objectz00_bglt) BgL_new1217z00_2667);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5148, BFALSE);
						}
						BgL_new1218z00_2666 = BgL_new1217z00_2667;
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1218z00_2666)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1089z00_1378), BUNSPEC);
					((((BgL_ev_setlocalz00_bglt) CREF(BgL_new1218z00_2666))->BgL_vz00) =
						((BgL_ev_varz00_bglt) BgL_v1090z00_1379), BUNSPEC);
					return BgL_new1218z00_2666;
				}
			}
		}
	}



/* &lambda1614 */
	obj_t BGl_z62lambda1614z62zz__evaluate_typesz00(obj_t BgL_envz00_3738,
		obj_t BgL_oz00_3739, obj_t BgL_vz00_3740)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 76 */
			return
				((((BgL_ev_setlocalz00_bglt) CREF(
							((BgL_ev_setlocalz00_bglt) BgL_oz00_3739)))->BgL_vz00) =
				((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_vz00_3740)), BUNSPEC);
		}
	}



/* &lambda1613 */
	BgL_ev_varz00_bglt BGl_z62lambda1613z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3741, obj_t BgL_oz00_3742)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 76 */
			return
				(((BgL_ev_setlocalz00_bglt) CREF(
						((BgL_ev_setlocalz00_bglt) BgL_oz00_3742)))->BgL_vz00);
		}
	}



/* &<anonymous:1584> */
	BgL_ev_trapz00_bglt
		BGl_z62zc3anonymousza31584ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3743,
		obj_t BgL_new1087z00_3744)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 75 */
			{
				BgL_ev_trapz00_bglt BgL_new1087z00_1366;

				BgL_new1087z00_1366 = ((BgL_ev_trapz00_bglt) BgL_new1087z00_3744);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5161;

					{	/* Eval/evaluate_types.scm 75 */
						obj_t BgL_classz00_2661;

						BgL_classz00_2661 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 75 */
							obj_t BgL__ortest_1280z00_2662;

							BgL__ortest_1280z00_2662 = BGL_CLASS_NIL(BgL_classz00_2661);
							if (CBOOL(BgL__ortest_1280z00_2662))
								{	/* Eval/evaluate_types.scm 75 */
									BgL_auxz00_5161 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2662);
								}
							else
								{	/* Eval/evaluate_types.scm 75 */
									BgL_auxz00_5161 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2661));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1087z00_1366)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5161), BUNSPEC);
				}
				return BgL_new1087z00_1366;
			}
		}
	}



/* &lambda1582 */
	BgL_ev_trapz00_bglt BGl_z62lambda1582z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3745)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 75 */
			{

				{	/* Eval/evaluate_types.scm 75 */
					BgL_ev_trapz00_bglt BgL_new1086z00_1364;

					BgL_new1086z00_1364 =
						((BgL_ev_trapz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_trapz00_bgl))));
					{	/* Eval/evaluate_types.scm 75 */
						long BgL_arg1583z00_1365;

						{	/* Eval/evaluate_types.scm 75 */
							long BgL_res2296z00_2658;

							BgL_res2296z00_2658 =
								BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00);
							BgL_arg1583z00_1365 = BgL_res2296z00_2658;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1086z00_1364), BgL_arg1583z00_1365);
					}
					{	/* Eval/evaluate_types.scm 75 */
						BgL_objectz00_bglt BgL_auxz00_5175;

						BgL_auxz00_5175 = ((BgL_objectz00_bglt) BgL_new1086z00_1364);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5175, BFALSE);
					}
					return BgL_new1086z00_1364;
				}
			}
		}
	}



/* &lambda1579 */
	BgL_ev_trapz00_bglt BGl_z62lambda1579z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3746, obj_t BgL_e1085z00_3747)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 75 */
			{
				BgL_ev_exprz00_bglt BgL_e1085z00_1358;

				BgL_e1085z00_1358 = ((BgL_ev_exprz00_bglt) BgL_e1085z00_3747);
				{	/* Eval/evaluate_types.scm 75 */
					BgL_ev_trapz00_bglt BgL_new1216z00_2650;

					{	/* Eval/evaluate_types.scm 75 */
						BgL_ev_trapz00_bglt BgL_new1215z00_2651;

						BgL_new1215z00_2651 =
							((BgL_ev_trapz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_trapz00_bgl))));
						{	/* Eval/evaluate_types.scm 75 */
							long BgL_arg1581z00_2652;

							{	/* Eval/evaluate_types.scm 75 */
								long BgL_res2295z00_2654;

								BgL_res2295z00_2654 =
									BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00);
								BgL_arg1581z00_2652 = BgL_res2295z00_2654;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1215z00_2651),
								BgL_arg1581z00_2652);
						}
						{	/* Eval/evaluate_types.scm 75 */
							BgL_objectz00_bglt BgL_auxz00_5182;

							BgL_auxz00_5182 = ((BgL_objectz00_bglt) BgL_new1215z00_2651);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5182, BFALSE);
						}
						BgL_new1216z00_2650 = BgL_new1215z00_2651;
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1216z00_2650)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1085z00_1358), BUNSPEC);
					return BgL_new1216z00_2650;
				}
			}
		}
	}



/* &<anonymous:1564> */
	BgL_ev_hookz00_bglt
		BGl_z62zc3anonymousza31564ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3748,
		obj_t BgL_new1083z00_3749)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 73 */
			{
				BgL_ev_hookz00_bglt BgL_new1083z00_1336;

				BgL_new1083z00_1336 = ((BgL_ev_hookz00_bglt) BgL_new1083z00_3749);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5188;

					{	/* Eval/evaluate_types.scm 73 */
						obj_t BgL_classz00_2648;

						BgL_classz00_2648 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 73 */
							obj_t BgL__ortest_1280z00_2649;

							BgL__ortest_1280z00_2649 = BGL_CLASS_NIL(BgL_classz00_2648);
							if (CBOOL(BgL__ortest_1280z00_2649))
								{	/* Eval/evaluate_types.scm 73 */
									BgL_auxz00_5188 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2649);
								}
							else
								{	/* Eval/evaluate_types.scm 73 */
									BgL_auxz00_5188 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2648));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) CREF(BgL_new1083z00_1336))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5188), BUNSPEC);
				}
				return BgL_new1083z00_1336;
			}
		}
	}



/* &lambda1562 */
	BgL_ev_hookz00_bglt BGl_z62lambda1562z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3750)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 73 */
			{

				{	/* Eval/evaluate_types.scm 73 */
					BgL_ev_hookz00_bglt BgL_new1082z00_1334;

					BgL_new1082z00_1334 =
						((BgL_ev_hookz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_hookz00_bgl))));
					{	/* Eval/evaluate_types.scm 73 */
						long BgL_arg1563z00_1335;

						{	/* Eval/evaluate_types.scm 73 */
							long BgL_res2294z00_2645;

							BgL_res2294z00_2645 =
								BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00);
							BgL_arg1563z00_1335 = BgL_res2294z00_2645;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1082z00_1334), BgL_arg1563z00_1335);
					}
					{	/* Eval/evaluate_types.scm 73 */
						BgL_objectz00_bglt BgL_auxz00_5201;

						BgL_auxz00_5201 = ((BgL_objectz00_bglt) BgL_new1082z00_1334);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5201, BFALSE);
					}
					return BgL_new1082z00_1334;
				}
			}
		}
	}



/* &lambda1559 */
	BgL_ev_hookz00_bglt BGl_z62lambda1559z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3751, obj_t BgL_e1081z00_3752)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 73 */
			{
				BgL_ev_exprz00_bglt BgL_e1081z00_1328;

				BgL_e1081z00_1328 = ((BgL_ev_exprz00_bglt) BgL_e1081z00_3752);
				{	/* Eval/evaluate_types.scm 73 */
					BgL_ev_hookz00_bglt BgL_new1214z00_2637;

					{	/* Eval/evaluate_types.scm 73 */
						BgL_ev_hookz00_bglt BgL_new1213z00_2638;

						BgL_new1213z00_2638 =
							((BgL_ev_hookz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_hookz00_bgl))));
						{	/* Eval/evaluate_types.scm 73 */
							long BgL_arg1561z00_2639;

							{	/* Eval/evaluate_types.scm 73 */
								long BgL_res2293z00_2641;

								BgL_res2293z00_2641 =
									BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00);
								BgL_arg1561z00_2639 = BgL_res2293z00_2641;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1213z00_2638),
								BgL_arg1561z00_2639);
						}
						{	/* Eval/evaluate_types.scm 73 */
							BgL_objectz00_bglt BgL_auxz00_5208;

							BgL_auxz00_5208 = ((BgL_objectz00_bglt) BgL_new1213z00_2638);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5208, BFALSE);
						}
						BgL_new1214z00_2637 = BgL_new1213z00_2638;
					}
					((((BgL_ev_hookz00_bglt) CREF(BgL_new1214z00_2637))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1081z00_1328), BUNSPEC);
					return BgL_new1214z00_2637;
				}
			}
		}
	}



/* &lambda1571 */
	obj_t BGl_z62lambda1571z62zz__evaluate_typesz00(obj_t BgL_envz00_3753,
		obj_t BgL_oz00_3754, obj_t BgL_vz00_3755)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 73 */
			return
				((((BgL_ev_hookz00_bglt) CREF(
							((BgL_ev_hookz00_bglt) BgL_oz00_3754)))->BgL_ez00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3755)), BUNSPEC);
		}
	}



/* &lambda1570 */
	BgL_ev_exprz00_bglt BGl_z62lambda1570z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3756, obj_t BgL_oz00_3757)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 73 */
			return
				(((BgL_ev_hookz00_bglt) CREF(
						((BgL_ev_hookz00_bglt) BgL_oz00_3757)))->BgL_ez00);
		}
	}



/* &<anonymous:1541> */
	BgL_ev_prog2z00_bglt
		BGl_z62zc3anonymousza31541ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3758,
		obj_t BgL_new1079z00_3759)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			{
				BgL_ev_prog2z00_bglt BgL_new1079z00_1296;

				BgL_new1079z00_1296 = ((BgL_ev_prog2z00_bglt) BgL_new1079z00_3759);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5218;

					{	/* Eval/evaluate_types.scm 70 */
						obj_t BgL_classz00_2630;

						BgL_classz00_2630 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 70 */
							obj_t BgL__ortest_1280z00_2631;

							BgL__ortest_1280z00_2631 = BGL_CLASS_NIL(BgL_classz00_2630);
							if (CBOOL(BgL__ortest_1280z00_2631))
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5218 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2631);
								}
							else
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5218 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2630));
								}
						}
					}
					((((BgL_ev_prog2z00_bglt) CREF(BgL_new1079z00_1296))->BgL_e1z00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5218), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5226;

					{	/* Eval/evaluate_types.scm 70 */
						obj_t BgL_classz00_2632;

						BgL_classz00_2632 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 70 */
							obj_t BgL__ortest_1280z00_2633;

							BgL__ortest_1280z00_2633 = BGL_CLASS_NIL(BgL_classz00_2632);
							if (CBOOL(BgL__ortest_1280z00_2633))
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5226 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2633);
								}
							else
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5226 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2632));
								}
						}
					}
					((((BgL_ev_prog2z00_bglt) CREF(BgL_new1079z00_1296))->BgL_e2z00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5226), BUNSPEC);
				}
				return BgL_new1079z00_1296;
			}
		}
	}



/* &lambda1539 */
	BgL_ev_prog2z00_bglt BGl_z62lambda1539z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3760)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			{

				{	/* Eval/evaluate_types.scm 70 */
					BgL_ev_prog2z00_bglt BgL_new1078z00_1294;

					BgL_new1078z00_1294 =
						((BgL_ev_prog2z00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_prog2z00_bgl))));
					{	/* Eval/evaluate_types.scm 70 */
						long BgL_arg1540z00_1295;

						{	/* Eval/evaluate_types.scm 70 */
							long BgL_res2292z00_2627;

							BgL_res2292z00_2627 =
								BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00);
							BgL_arg1540z00_1295 = BgL_res2292z00_2627;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1078z00_1294), BgL_arg1540z00_1295);
					}
					{	/* Eval/evaluate_types.scm 70 */
						BgL_objectz00_bglt BgL_auxz00_5239;

						BgL_auxz00_5239 = ((BgL_objectz00_bglt) BgL_new1078z00_1294);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5239, BFALSE);
					}
					return BgL_new1078z00_1294;
				}
			}
		}
	}



/* &lambda1536 */
	BgL_ev_prog2z00_bglt BGl_z62lambda1536z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3761, obj_t BgL_e11076z00_3762, obj_t BgL_e21077z00_3763)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			{
				BgL_ev_exprz00_bglt BgL_e11076z00_1287;
				BgL_ev_exprz00_bglt BgL_e21077z00_1288;

				BgL_e11076z00_1287 = ((BgL_ev_exprz00_bglt) BgL_e11076z00_3762);
				BgL_e21077z00_1288 = ((BgL_ev_exprz00_bglt) BgL_e21077z00_3763);
				{	/* Eval/evaluate_types.scm 70 */
					BgL_ev_prog2z00_bglt BgL_new1212z00_2619;

					{	/* Eval/evaluate_types.scm 70 */
						BgL_ev_prog2z00_bglt BgL_new1211z00_2620;

						BgL_new1211z00_2620 =
							((BgL_ev_prog2z00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_prog2z00_bgl))));
						{	/* Eval/evaluate_types.scm 70 */
							long BgL_arg1538z00_2621;

							{	/* Eval/evaluate_types.scm 70 */
								long BgL_res2291z00_2623;

								BgL_res2291z00_2623 =
									BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00);
								BgL_arg1538z00_2621 = BgL_res2291z00_2623;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1211z00_2620),
								BgL_arg1538z00_2621);
						}
						{	/* Eval/evaluate_types.scm 70 */
							BgL_objectz00_bglt BgL_auxz00_5246;

							BgL_auxz00_5246 = ((BgL_objectz00_bglt) BgL_new1211z00_2620);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5246, BFALSE);
						}
						BgL_new1212z00_2619 = BgL_new1211z00_2620;
					}
					((((BgL_ev_prog2z00_bglt) CREF(BgL_new1212z00_2619))->BgL_e1z00) =
						((BgL_ev_exprz00_bglt) BgL_e11076z00_1287), BUNSPEC);
					((((BgL_ev_prog2z00_bglt) CREF(BgL_new1212z00_2619))->BgL_e2z00) =
						((BgL_ev_exprz00_bglt) BgL_e21077z00_1288), BUNSPEC);
					return BgL_new1212z00_2619;
				}
			}
		}
	}



/* &lambda1553 */
	obj_t BGl_z62lambda1553z62zz__evaluate_typesz00(obj_t BgL_envz00_3764,
		obj_t BgL_oz00_3765, obj_t BgL_vz00_3766)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			return
				((((BgL_ev_prog2z00_bglt) CREF(
							((BgL_ev_prog2z00_bglt) BgL_oz00_3765)))->BgL_e1z00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3766)), BUNSPEC);
		}
	}



/* &lambda1552 */
	BgL_ev_exprz00_bglt BGl_z62lambda1552z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3767, obj_t BgL_oz00_3768)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			return
				(((BgL_ev_prog2z00_bglt) CREF(
						((BgL_ev_prog2z00_bglt) BgL_oz00_3768)))->BgL_e1z00);
		}
	}



/* &lambda1548 */
	obj_t BGl_z62lambda1548z62zz__evaluate_typesz00(obj_t BgL_envz00_3769,
		obj_t BgL_oz00_3770, obj_t BgL_vz00_3771)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			return
				((((BgL_ev_prog2z00_bglt) CREF(
							((BgL_ev_prog2z00_bglt) BgL_oz00_3770)))->BgL_e2z00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3771)), BUNSPEC);
		}
	}



/* &lambda1547 */
	BgL_ev_exprz00_bglt BGl_z62lambda1547z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3772, obj_t BgL_oz00_3773)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			return
				(((BgL_ev_prog2z00_bglt) CREF(
						((BgL_ev_prog2z00_bglt) BgL_oz00_3773)))->BgL_e2z00);
		}
	}



/* &<anonymous:1528> */
	BgL_ev_andz00_bglt BGl_z62zc3anonymousza31528ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3774, obj_t BgL_new1074z00_3775)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 69 */
			{
				BgL_ev_andz00_bglt BgL_new1074z00_1275;

				BgL_new1074z00_1275 = ((BgL_ev_andz00_bglt) BgL_new1074z00_3775);
				((((BgL_ev_listz00_bglt) CREF(
								((BgL_ev_listz00_bglt) BgL_new1074z00_1275)))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1074z00_1275;
			}
		}
	}



/* &lambda1526 */
	BgL_ev_andz00_bglt BGl_z62lambda1526z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3776)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 69 */
			{

				{	/* Eval/evaluate_types.scm 69 */
					BgL_ev_andz00_bglt BgL_new1073z00_1273;

					BgL_new1073z00_1273 =
						((BgL_ev_andz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_andz00_bgl))));
					{	/* Eval/evaluate_types.scm 69 */
						long BgL_arg1527z00_1274;

						{	/* Eval/evaluate_types.scm 69 */
							long BgL_res2290z00_2610;

							BgL_res2290z00_2610 =
								BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00);
							BgL_arg1527z00_1274 = BgL_res2290z00_2610;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1073z00_1273), BgL_arg1527z00_1274);
					}
					{	/* Eval/evaluate_types.scm 69 */
						BgL_objectz00_bglt BgL_auxz00_5270;

						BgL_auxz00_5270 = ((BgL_objectz00_bglt) BgL_new1073z00_1273);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5270, BFALSE);
					}
					return BgL_new1073z00_1273;
				}
			}
		}
	}



/* &lambda1524 */
	BgL_ev_andz00_bglt BGl_z62lambda1524z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3777, obj_t BgL_args1072z00_3778)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 69 */
			{
				obj_t BgL_args1072z00_1267;

				BgL_args1072z00_1267 = BgL_args1072z00_3778;
				{	/* Eval/evaluate_types.scm 69 */
					BgL_ev_andz00_bglt BgL_new1210z00_2602;

					{	/* Eval/evaluate_types.scm 69 */
						BgL_ev_andz00_bglt BgL_new1209z00_2603;

						BgL_new1209z00_2603 =
							((BgL_ev_andz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_andz00_bgl))));
						{	/* Eval/evaluate_types.scm 69 */
							long BgL_arg1525z00_2604;

							{	/* Eval/evaluate_types.scm 69 */
								long BgL_res2289z00_2606;

								BgL_res2289z00_2606 =
									BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00);
								BgL_arg1525z00_2604 = BgL_res2289z00_2606;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1209z00_2603),
								BgL_arg1525z00_2604);
						}
						{	/* Eval/evaluate_types.scm 69 */
							BgL_objectz00_bglt BgL_auxz00_5277;

							BgL_auxz00_5277 = ((BgL_objectz00_bglt) BgL_new1209z00_2603);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5277, BFALSE);
						}
						BgL_new1210z00_2602 = BgL_new1209z00_2603;
					}
					((((BgL_ev_listz00_bglt) CREF(
									((BgL_ev_listz00_bglt) BgL_new1210z00_2602)))->BgL_argsz00) =
						((obj_t) BgL_args1072z00_1267), BUNSPEC);
					return BgL_new1210z00_2602;
				}
			}
		}
	}



/* &<anonymous:1517> */
	BgL_ev_orz00_bglt BGl_z62zc3anonymousza31517ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3779, obj_t BgL_new1070z00_3780)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 68 */
			{
				BgL_ev_orz00_bglt BgL_new1070z00_1255;

				BgL_new1070z00_1255 = ((BgL_ev_orz00_bglt) BgL_new1070z00_3780);
				((((BgL_ev_listz00_bglt) CREF(
								((BgL_ev_listz00_bglt) BgL_new1070z00_1255)))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1070z00_1255;
			}
		}
	}



/* &lambda1514 */
	BgL_ev_orz00_bglt BGl_z62lambda1514z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3781)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 68 */
			{

				{	/* Eval/evaluate_types.scm 68 */
					BgL_ev_orz00_bglt BgL_new1069z00_1253;

					BgL_new1069z00_1253 =
						((BgL_ev_orz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_orz00_bgl))));
					{	/* Eval/evaluate_types.scm 68 */
						long BgL_arg1516z00_1254;

						{	/* Eval/evaluate_types.scm 68 */
							long BgL_res2288z00_2599;

							BgL_res2288z00_2599 =
								BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00);
							BgL_arg1516z00_1254 = BgL_res2288z00_2599;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1069z00_1253), BgL_arg1516z00_1254);
					}
					{	/* Eval/evaluate_types.scm 68 */
						BgL_objectz00_bglt BgL_auxz00_5289;

						BgL_auxz00_5289 = ((BgL_objectz00_bglt) BgL_new1069z00_1253);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5289, BFALSE);
					}
					return BgL_new1069z00_1253;
				}
			}
		}
	}



/* &lambda1512 */
	BgL_ev_orz00_bglt BGl_z62lambda1512z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3782, obj_t BgL_args1068z00_3783)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 68 */
			{
				obj_t BgL_args1068z00_1247;

				BgL_args1068z00_1247 = BgL_args1068z00_3783;
				{	/* Eval/evaluate_types.scm 68 */
					BgL_ev_orz00_bglt BgL_new1208z00_2591;

					{	/* Eval/evaluate_types.scm 68 */
						BgL_ev_orz00_bglt BgL_new1207z00_2592;

						BgL_new1207z00_2592 =
							((BgL_ev_orz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_orz00_bgl))));
						{	/* Eval/evaluate_types.scm 68 */
							long BgL_arg1513z00_2593;

							{	/* Eval/evaluate_types.scm 68 */
								long BgL_res2287z00_2595;

								BgL_res2287z00_2595 =
									BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00);
								BgL_arg1513z00_2593 = BgL_res2287z00_2595;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1207z00_2592),
								BgL_arg1513z00_2593);
						}
						{	/* Eval/evaluate_types.scm 68 */
							BgL_objectz00_bglt BgL_auxz00_5296;

							BgL_auxz00_5296 = ((BgL_objectz00_bglt) BgL_new1207z00_2592);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5296, BFALSE);
						}
						BgL_new1208z00_2591 = BgL_new1207z00_2592;
					}
					((((BgL_ev_listz00_bglt) CREF(
									((BgL_ev_listz00_bglt) BgL_new1208z00_2591)))->BgL_argsz00) =
						((obj_t) BgL_args1068z00_1247), BUNSPEC);
					return BgL_new1208z00_2591;
				}
			}
		}
	}



/* &<anonymous:1496> */
	BgL_ev_listz00_bglt
		BGl_z62zc3anonymousza31496ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3784,
		obj_t BgL_new1066z00_3785)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 66 */
			{
				BgL_ev_listz00_bglt BgL_new1066z00_1225;

				BgL_new1066z00_1225 = ((BgL_ev_listz00_bglt) BgL_new1066z00_3785);
				((((BgL_ev_listz00_bglt) CREF(BgL_new1066z00_1225))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1066z00_1225;
			}
		}
	}



/* &lambda1494 */
	BgL_ev_listz00_bglt BGl_z62lambda1494z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3786)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 66 */
			{

				{	/* Eval/evaluate_types.scm 66 */
					BgL_ev_listz00_bglt BgL_new1065z00_1223;

					BgL_new1065z00_1223 =
						((BgL_ev_listz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_listz00_bgl))));
					{	/* Eval/evaluate_types.scm 66 */
						long BgL_arg1495z00_1224;

						{	/* Eval/evaluate_types.scm 66 */
							long BgL_res2286z00_2588;

							BgL_res2286z00_2588 =
								BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00);
							BgL_arg1495z00_1224 = BgL_res2286z00_2588;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1065z00_1223), BgL_arg1495z00_1224);
					}
					{	/* Eval/evaluate_types.scm 66 */
						BgL_objectz00_bglt BgL_auxz00_5307;

						BgL_auxz00_5307 = ((BgL_objectz00_bglt) BgL_new1065z00_1223);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5307, BFALSE);
					}
					return BgL_new1065z00_1223;
				}
			}
		}
	}



/* &lambda1492 */
	BgL_ev_listz00_bglt BGl_z62lambda1492z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3787, obj_t BgL_args1064z00_3788)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 66 */
			{
				obj_t BgL_args1064z00_1217;

				BgL_args1064z00_1217 = BgL_args1064z00_3788;
				{	/* Eval/evaluate_types.scm 66 */
					BgL_ev_listz00_bglt BgL_new1206z00_2580;

					{	/* Eval/evaluate_types.scm 66 */
						BgL_ev_listz00_bglt BgL_new1205z00_2581;

						BgL_new1205z00_2581 =
							((BgL_ev_listz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_listz00_bgl))));
						{	/* Eval/evaluate_types.scm 66 */
							long BgL_arg1493z00_2582;

							{	/* Eval/evaluate_types.scm 66 */
								long BgL_res2285z00_2584;

								BgL_res2285z00_2584 =
									BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00);
								BgL_arg1493z00_2582 = BgL_res2285z00_2584;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1205z00_2581),
								BgL_arg1493z00_2582);
						}
						{	/* Eval/evaluate_types.scm 66 */
							BgL_objectz00_bglt BgL_auxz00_5314;

							BgL_auxz00_5314 = ((BgL_objectz00_bglt) BgL_new1205z00_2581);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5314, BFALSE);
						}
						BgL_new1206z00_2580 = BgL_new1205z00_2581;
					}
					((((BgL_ev_listz00_bglt) CREF(BgL_new1206z00_2580))->BgL_argsz00) =
						((obj_t) BgL_args1064z00_1217), BUNSPEC);
					return BgL_new1206z00_2580;
				}
			}
		}
	}



/* &lambda1502 */
	obj_t BGl_z62lambda1502z62zz__evaluate_typesz00(obj_t BgL_envz00_3789,
		obj_t BgL_oz00_3790, obj_t BgL_vz00_3791)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 66 */
			return
				((((BgL_ev_listz00_bglt) CREF(
							((BgL_ev_listz00_bglt) BgL_oz00_3790)))->BgL_argsz00) =
				((obj_t) BgL_vz00_3791), BUNSPEC);
		}
	}



/* &lambda1501 */
	obj_t BGl_z62lambda1501z62zz__evaluate_typesz00(obj_t BgL_envz00_3792,
		obj_t BgL_oz00_3793)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 66 */
			return
				(((BgL_ev_listz00_bglt) CREF(
						((BgL_ev_listz00_bglt) BgL_oz00_3793)))->BgL_argsz00);
		}
	}



/* &<anonymous:1465> */
	BgL_ev_ifz00_bglt BGl_z62zc3anonymousza31465ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3794, obj_t BgL_new1062z00_3795)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			{
				BgL_ev_ifz00_bglt BgL_new1062z00_1175;

				BgL_new1062z00_1175 = ((BgL_ev_ifz00_bglt) BgL_new1062z00_3795);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5322;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_2571;

						BgL_classz00_2571 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 62 */
							obj_t BgL__ortest_1280z00_2572;

							BgL__ortest_1280z00_2572 = BGL_CLASS_NIL(BgL_classz00_2571);
							if (CBOOL(BgL__ortest_1280z00_2572))
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5322 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2572);
								}
							else
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5322 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2571));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1062z00_1175))->BgL_pz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5322), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5330;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_2573;

						BgL_classz00_2573 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 62 */
							obj_t BgL__ortest_1280z00_2574;

							BgL__ortest_1280z00_2574 = BGL_CLASS_NIL(BgL_classz00_2573);
							if (CBOOL(BgL__ortest_1280z00_2574))
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5330 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2574);
								}
							else
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5330 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2573));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1062z00_1175))->BgL_tz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5330), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5338;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_2575;

						BgL_classz00_2575 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 62 */
							obj_t BgL__ortest_1280z00_2576;

							BgL__ortest_1280z00_2576 = BGL_CLASS_NIL(BgL_classz00_2575);
							if (CBOOL(BgL__ortest_1280z00_2576))
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5338 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1280z00_2576);
								}
							else
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5338 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2575));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1062z00_1175))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5338), BUNSPEC);
				}
				return BgL_new1062z00_1175;
			}
		}
	}



/* &lambda1462 */
	BgL_ev_ifz00_bglt BGl_z62lambda1462z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3796)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			{

				{	/* Eval/evaluate_types.scm 62 */
					BgL_ev_ifz00_bglt BgL_new1061z00_1173;

					BgL_new1061z00_1173 =
						((BgL_ev_ifz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_ifz00_bgl))));
					{	/* Eval/evaluate_types.scm 62 */
						long BgL_arg1464z00_1174;

						{	/* Eval/evaluate_types.scm 62 */
							long BgL_res2284z00_2568;

							BgL_res2284z00_2568 =
								BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00);
							BgL_arg1464z00_1174 = BgL_res2284z00_2568;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1061z00_1173), BgL_arg1464z00_1174);
					}
					{	/* Eval/evaluate_types.scm 62 */
						BgL_objectz00_bglt BgL_auxz00_5351;

						BgL_auxz00_5351 = ((BgL_objectz00_bglt) BgL_new1061z00_1173);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5351, BFALSE);
					}
					return BgL_new1061z00_1173;
				}
			}
		}
	}



/* &lambda1460 */
	BgL_ev_ifz00_bglt BGl_z62lambda1460z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3797, obj_t BgL_p1058z00_3798, obj_t BgL_t1059z00_3799,
		obj_t BgL_e1060z00_3800)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			{
				BgL_ev_exprz00_bglt BgL_p1058z00_1165;
				BgL_ev_exprz00_bglt BgL_t1059z00_1166;
				BgL_ev_exprz00_bglt BgL_e1060z00_1167;

				BgL_p1058z00_1165 = ((BgL_ev_exprz00_bglt) BgL_p1058z00_3798);
				BgL_t1059z00_1166 = ((BgL_ev_exprz00_bglt) BgL_t1059z00_3799);
				BgL_e1060z00_1167 = ((BgL_ev_exprz00_bglt) BgL_e1060z00_3800);
				{	/* Eval/evaluate_types.scm 62 */
					BgL_ev_ifz00_bglt BgL_new1204z00_2560;

					{	/* Eval/evaluate_types.scm 62 */
						BgL_ev_ifz00_bglt BgL_new1203z00_2561;

						BgL_new1203z00_2561 =
							((BgL_ev_ifz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_ifz00_bgl))));
						{	/* Eval/evaluate_types.scm 62 */
							long BgL_arg1461z00_2562;

							{	/* Eval/evaluate_types.scm 62 */
								long BgL_res2283z00_2564;

								BgL_res2283z00_2564 =
									BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00);
								BgL_arg1461z00_2562 = BgL_res2283z00_2564;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1203z00_2561),
								BgL_arg1461z00_2562);
						}
						{	/* Eval/evaluate_types.scm 62 */
							BgL_objectz00_bglt BgL_auxz00_5358;

							BgL_auxz00_5358 = ((BgL_objectz00_bglt) BgL_new1203z00_2561);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5358, BFALSE);
						}
						BgL_new1204z00_2560 = BgL_new1203z00_2561;
					}
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1204z00_2560))->BgL_pz00) =
						((BgL_ev_exprz00_bglt) BgL_p1058z00_1165), BUNSPEC);
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1204z00_2560))->BgL_tz00) =
						((BgL_ev_exprz00_bglt) BgL_t1059z00_1166), BUNSPEC);
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1204z00_2560))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1060z00_1167), BUNSPEC);
					return BgL_new1204z00_2560;
				}
			}
		}
	}



/* &lambda1485 */
	obj_t BGl_z62lambda1485z62zz__evaluate_typesz00(obj_t BgL_envz00_3801,
		obj_t BgL_oz00_3802, obj_t BgL_vz00_3803)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			return
				((((BgL_ev_ifz00_bglt) CREF(
							((BgL_ev_ifz00_bglt) BgL_oz00_3802)))->BgL_pz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3803)), BUNSPEC);
		}
	}



/* &lambda1484 */
	BgL_ev_exprz00_bglt BGl_z62lambda1484z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3804, obj_t BgL_oz00_3805)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) CREF(
						((BgL_ev_ifz00_bglt) BgL_oz00_3805)))->BgL_pz00);
		}
	}



/* &lambda1480 */
	obj_t BGl_z62lambda1480z62zz__evaluate_typesz00(obj_t BgL_envz00_3806,
		obj_t BgL_oz00_3807, obj_t BgL_vz00_3808)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			return
				((((BgL_ev_ifz00_bglt) CREF(
							((BgL_ev_ifz00_bglt) BgL_oz00_3807)))->BgL_tz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3808)), BUNSPEC);
		}
	}



/* &lambda1479 */
	BgL_ev_exprz00_bglt BGl_z62lambda1479z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3809, obj_t BgL_oz00_3810)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) CREF(
						((BgL_ev_ifz00_bglt) BgL_oz00_3810)))->BgL_tz00);
		}
	}



/* &lambda1471 */
	obj_t BGl_z62lambda1471z62zz__evaluate_typesz00(obj_t BgL_envz00_3811,
		obj_t BgL_oz00_3812, obj_t BgL_vz00_3813)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			return
				((((BgL_ev_ifz00_bglt) CREF(
							((BgL_ev_ifz00_bglt) BgL_oz00_3812)))->BgL_ez00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3813)), BUNSPEC);
		}
	}



/* &lambda1470 */
	BgL_ev_exprz00_bglt BGl_z62lambda1470z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3814, obj_t BgL_oz00_3815)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) CREF(
						((BgL_ev_ifz00_bglt) BgL_oz00_3815)))->BgL_ez00);
		}
	}



/* &<anonymous:1448> */
	BgL_ev_littz00_bglt
		BGl_z62zc3anonymousza31448ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3816,
		obj_t BgL_new1056z00_3817)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 60 */
			{
				BgL_ev_littz00_bglt BgL_new1056z00_1143;

				BgL_new1056z00_1143 = ((BgL_ev_littz00_bglt) BgL_new1056z00_3817);
				((((BgL_ev_littz00_bglt) CREF(BgL_new1056z00_1143))->BgL_valuez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1056z00_1143;
			}
		}
	}



/* &lambda1446 */
	BgL_ev_littz00_bglt BGl_z62lambda1446z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3818)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 60 */
			{

				{	/* Eval/evaluate_types.scm 60 */
					BgL_ev_littz00_bglt BgL_new1055z00_1141;

					BgL_new1055z00_1141 =
						((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_littz00_bgl))));
					{	/* Eval/evaluate_types.scm 60 */
						long BgL_arg1447z00_1142;

						{	/* Eval/evaluate_types.scm 60 */
							long BgL_res2282z00_2548;

							BgL_res2282z00_2548 =
								BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
							BgL_arg1447z00_1142 = BgL_res2282z00_2548;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1055z00_1141), BgL_arg1447z00_1142);
					}
					{	/* Eval/evaluate_types.scm 60 */
						BgL_objectz00_bglt BgL_auxz00_5388;

						BgL_auxz00_5388 = ((BgL_objectz00_bglt) BgL_new1055z00_1141);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5388, BFALSE);
					}
					return BgL_new1055z00_1141;
				}
			}
		}
	}



/* &lambda1444 */
	BgL_ev_littz00_bglt BGl_z62lambda1444z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3819, obj_t BgL_value1054z00_3820)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 60 */
			{
				obj_t BgL_value1054z00_1135;

				BgL_value1054z00_1135 = BgL_value1054z00_3820;
				{	/* Eval/evaluate_types.scm 60 */
					BgL_ev_littz00_bglt BgL_new1202z00_2540;

					{	/* Eval/evaluate_types.scm 60 */
						BgL_ev_littz00_bglt BgL_new1201z00_2541;

						BgL_new1201z00_2541 =
							((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_littz00_bgl))));
						{	/* Eval/evaluate_types.scm 60 */
							long BgL_arg1445z00_2542;

							{	/* Eval/evaluate_types.scm 60 */
								long BgL_res2281z00_2544;

								BgL_res2281z00_2544 =
									BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
								BgL_arg1445z00_2542 = BgL_res2281z00_2544;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1201z00_2541),
								BgL_arg1445z00_2542);
						}
						{	/* Eval/evaluate_types.scm 60 */
							BgL_objectz00_bglt BgL_auxz00_5395;

							BgL_auxz00_5395 = ((BgL_objectz00_bglt) BgL_new1201z00_2541);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5395, BFALSE);
						}
						BgL_new1202z00_2540 = BgL_new1201z00_2541;
					}
					((((BgL_ev_littz00_bglt) CREF(BgL_new1202z00_2540))->BgL_valuez00) =
						((obj_t) BgL_value1054z00_1135), BUNSPEC);
					return BgL_new1202z00_2540;
				}
			}
		}
	}



/* &lambda1454 */
	obj_t BGl_z62lambda1454z62zz__evaluate_typesz00(obj_t BgL_envz00_3821,
		obj_t BgL_oz00_3822, obj_t BgL_vz00_3823)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 60 */
			return
				((((BgL_ev_littz00_bglt) CREF(
							((BgL_ev_littz00_bglt) BgL_oz00_3822)))->BgL_valuez00) =
				((obj_t) BgL_vz00_3823), BUNSPEC);
		}
	}



/* &lambda1453 */
	obj_t BGl_z62lambda1453z62zz__evaluate_typesz00(obj_t BgL_envz00_3824,
		obj_t BgL_oz00_3825)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 60 */
			return
				(((BgL_ev_littz00_bglt) CREF(
						((BgL_ev_littz00_bglt) BgL_oz00_3825)))->BgL_valuez00);
		}
	}



/* &<anonymous:1422> */
	BgL_ev_globalz00_bglt
		BGl_z62zc3anonymousza31422ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3826,
		obj_t BgL_new1052z00_3827)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			{
				BgL_ev_globalz00_bglt BgL_new1052z00_1093;

				BgL_new1052z00_1093 = ((BgL_ev_globalz00_bglt) BgL_new1052z00_3827);
				((((BgL_ev_globalz00_bglt) CREF(BgL_new1052z00_1093))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_globalz00_bglt) CREF(BgL_new1052z00_1093))->BgL_namez00) =
					((obj_t) BGl_symbol2692z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_globalz00_bglt) CREF(BgL_new1052z00_1093))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1052z00_1093;
			}
		}
	}



/* &lambda1420 */
	BgL_ev_globalz00_bglt BGl_z62lambda1420z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3828)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			{

				{	/* Eval/evaluate_types.scm 55 */
					BgL_ev_globalz00_bglt BgL_new1051z00_1091;

					BgL_new1051z00_1091 =
						((BgL_ev_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_globalz00_bgl))));
					{	/* Eval/evaluate_types.scm 55 */
						long BgL_arg1421z00_1092;

						{	/* Eval/evaluate_types.scm 55 */
							long BgL_res2280z00_2534;

							BgL_res2280z00_2534 =
								BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00);
							BgL_arg1421z00_1092 = BgL_res2280z00_2534;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1051z00_1091), BgL_arg1421z00_1092);
					}
					{	/* Eval/evaluate_types.scm 55 */
						BgL_objectz00_bglt BgL_auxz00_5411;

						BgL_auxz00_5411 = ((BgL_objectz00_bglt) BgL_new1051z00_1091);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5411, BFALSE);
					}
					return BgL_new1051z00_1091;
				}
			}
		}
	}



/* &lambda1418 */
	BgL_ev_globalz00_bglt BGl_z62lambda1418z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3829, obj_t BgL_loc1048z00_3830, obj_t BgL_name1049z00_3831,
		obj_t BgL_mod1050z00_3832)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			{
				obj_t BgL_loc1048z00_1083;
				obj_t BgL_name1049z00_1084;
				obj_t BgL_mod1050z00_1085;

				BgL_loc1048z00_1083 = BgL_loc1048z00_3830;
				BgL_name1049z00_1084 = BgL_name1049z00_3831;
				BgL_mod1050z00_1085 = BgL_mod1050z00_3832;
				{	/* Eval/evaluate_types.scm 55 */
					BgL_ev_globalz00_bglt BgL_new1200z00_2526;

					{	/* Eval/evaluate_types.scm 55 */
						BgL_ev_globalz00_bglt BgL_new1199z00_2527;

						BgL_new1199z00_2527 =
							((BgL_ev_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_globalz00_bgl))));
						{	/* Eval/evaluate_types.scm 55 */
							long BgL_arg1419z00_2528;

							{	/* Eval/evaluate_types.scm 55 */
								long BgL_res2279z00_2530;

								BgL_res2279z00_2530 =
									BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00);
								BgL_arg1419z00_2528 = BgL_res2279z00_2530;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1199z00_2527),
								BgL_arg1419z00_2528);
						}
						{	/* Eval/evaluate_types.scm 55 */
							BgL_objectz00_bglt BgL_auxz00_5418;

							BgL_auxz00_5418 = ((BgL_objectz00_bglt) BgL_new1199z00_2527);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5418, BFALSE);
						}
						BgL_new1200z00_2526 = BgL_new1199z00_2527;
					}
					((((BgL_ev_globalz00_bglt) CREF(BgL_new1200z00_2526))->BgL_locz00) =
						((obj_t) BgL_loc1048z00_1083), BUNSPEC);
					((((BgL_ev_globalz00_bglt) CREF(BgL_new1200z00_2526))->BgL_namez00) =
						((obj_t) BgL_name1049z00_1084), BUNSPEC);
					((((BgL_ev_globalz00_bglt) CREF(BgL_new1200z00_2526))->BgL_modz00) =
						((obj_t) BgL_mod1050z00_1085), BUNSPEC);
					return BgL_new1200z00_2526;
				}
			}
		}
	}



/* &lambda1437 */
	obj_t BGl_z62lambda1437z62zz__evaluate_typesz00(obj_t BgL_envz00_3833,
		obj_t BgL_oz00_3834, obj_t BgL_vz00_3835)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			return
				((((BgL_ev_globalz00_bglt) CREF(
							((BgL_ev_globalz00_bglt) BgL_oz00_3834)))->BgL_locz00) =
				((obj_t) BgL_vz00_3835), BUNSPEC);
		}
	}



/* &lambda1436 */
	obj_t BGl_z62lambda1436z62zz__evaluate_typesz00(obj_t BgL_envz00_3836,
		obj_t BgL_oz00_3837)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) CREF(
						((BgL_ev_globalz00_bglt) BgL_oz00_3837)))->BgL_locz00);
		}
	}



/* &lambda1432 */
	obj_t BGl_z62lambda1432z62zz__evaluate_typesz00(obj_t BgL_envz00_3838,
		obj_t BgL_oz00_3839, obj_t BgL_vz00_3840)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			return
				((((BgL_ev_globalz00_bglt) CREF(
							((BgL_ev_globalz00_bglt) BgL_oz00_3839)))->BgL_namez00) =
				((obj_t) BgL_vz00_3840), BUNSPEC);
		}
	}



/* &lambda1431 */
	obj_t BGl_z62lambda1431z62zz__evaluate_typesz00(obj_t BgL_envz00_3841,
		obj_t BgL_oz00_3842)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) CREF(
						((BgL_ev_globalz00_bglt) BgL_oz00_3842)))->BgL_namez00);
		}
	}



/* &lambda1427 */
	obj_t BGl_z62lambda1427z62zz__evaluate_typesz00(obj_t BgL_envz00_3843,
		obj_t BgL_oz00_3844, obj_t BgL_vz00_3845)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			return
				((((BgL_ev_globalz00_bglt) CREF(
							((BgL_ev_globalz00_bglt) BgL_oz00_3844)))->BgL_modz00) =
				((obj_t) BgL_vz00_3845), BUNSPEC);
		}
	}



/* &lambda1426 */
	obj_t BGl_z62lambda1426z62zz__evaluate_typesz00(obj_t BgL_envz00_3846,
		obj_t BgL_oz00_3847)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) CREF(
						((BgL_ev_globalz00_bglt) BgL_oz00_3847)))->BgL_modz00);
		}
	}



/* &<anonymous:1395> */
	BgL_ev_varz00_bglt BGl_z62zc3anonymousza31395ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3848, obj_t BgL_new1046z00_3849)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			{
				BgL_ev_varz00_bglt BgL_new1046z00_1038;

				BgL_new1046z00_1038 = ((BgL_ev_varz00_bglt) BgL_new1046z00_3849);
				((((BgL_ev_varz00_bglt) CREF(BgL_new1046z00_1038))->BgL_namez00) =
					((obj_t) BGl_symbol2692z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_varz00_bglt) CREF(BgL_new1046z00_1038))->BgL_effz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_varz00_bglt) CREF(BgL_new1046z00_1038))->BgL_typez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1046z00_1038;
			}
		}
	}



/* &lambda1393 */
	BgL_ev_varz00_bglt BGl_z62lambda1393z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3850)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			{

				{	/* Eval/evaluate_types.scm 51 */
					BgL_ev_varz00_bglt BgL_new1045z00_1036;

					BgL_new1045z00_1036 =
						((BgL_ev_varz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_varz00_bgl))));
					{	/* Eval/evaluate_types.scm 51 */
						long BgL_arg1394z00_1037;

						{	/* Eval/evaluate_types.scm 51 */
							long BgL_res2278z00_2514;

							BgL_res2278z00_2514 =
								BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00);
							BgL_arg1394z00_1037 = BgL_res2278z00_2514;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1045z00_1036), BgL_arg1394z00_1037);
					}
					{	/* Eval/evaluate_types.scm 51 */
						BgL_objectz00_bglt BgL_auxz00_5444;

						BgL_auxz00_5444 = ((BgL_objectz00_bglt) BgL_new1045z00_1036);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5444, BFALSE);
					}
					return BgL_new1045z00_1036;
				}
			}
		}
	}



/* &lambda1391 */
	BgL_ev_varz00_bglt BGl_z62lambda1391z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3851, obj_t BgL_name1042z00_3852, obj_t BgL_eff1043z00_3853,
		obj_t BgL_type1044z00_3854)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			{
				obj_t BgL_name1042z00_1028;
				obj_t BgL_eff1043z00_1029;
				obj_t BgL_type1044z00_1030;

				BgL_name1042z00_1028 = BgL_name1042z00_3852;
				BgL_eff1043z00_1029 = BgL_eff1043z00_3853;
				BgL_type1044z00_1030 = BgL_type1044z00_3854;
				{	/* Eval/evaluate_types.scm 51 */
					BgL_ev_varz00_bglt BgL_new1198z00_2506;

					{	/* Eval/evaluate_types.scm 51 */
						BgL_ev_varz00_bglt BgL_new1197z00_2507;

						BgL_new1197z00_2507 =
							((BgL_ev_varz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_varz00_bgl))));
						{	/* Eval/evaluate_types.scm 51 */
							long BgL_arg1392z00_2508;

							{	/* Eval/evaluate_types.scm 51 */
								long BgL_res2277z00_2510;

								BgL_res2277z00_2510 =
									BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00);
								BgL_arg1392z00_2508 = BgL_res2277z00_2510;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1197z00_2507),
								BgL_arg1392z00_2508);
						}
						{	/* Eval/evaluate_types.scm 51 */
							BgL_objectz00_bglt BgL_auxz00_5451;

							BgL_auxz00_5451 = ((BgL_objectz00_bglt) BgL_new1197z00_2507);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5451, BFALSE);
						}
						BgL_new1198z00_2506 = BgL_new1197z00_2507;
					}
					((((BgL_ev_varz00_bglt) CREF(BgL_new1198z00_2506))->BgL_namez00) =
						((obj_t) BgL_name1042z00_1028), BUNSPEC);
					((((BgL_ev_varz00_bglt) CREF(BgL_new1198z00_2506))->BgL_effz00) =
						((obj_t) BgL_eff1043z00_1029), BUNSPEC);
					((((BgL_ev_varz00_bglt) CREF(BgL_new1198z00_2506))->BgL_typez00) =
						((obj_t) BgL_type1044z00_1030), BUNSPEC);
					return BgL_new1198z00_2506;
				}
			}
		}
	}



/* &lambda1412 */
	obj_t BGl_z62lambda1412z62zz__evaluate_typesz00(obj_t BgL_envz00_3855,
		obj_t BgL_oz00_3856, obj_t BgL_vz00_3857)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return
				((((BgL_ev_varz00_bglt) CREF(
							((BgL_ev_varz00_bglt) BgL_oz00_3856)))->BgL_namez00) =
				((obj_t) BgL_vz00_3857), BUNSPEC);
		}
	}



/* &lambda1411 */
	obj_t BGl_z62lambda1411z62zz__evaluate_typesz00(obj_t BgL_envz00_3858,
		obj_t BgL_oz00_3859)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) CREF(
						((BgL_ev_varz00_bglt) BgL_oz00_3859)))->BgL_namez00);
		}
	}



/* &<anonymous:1407> */
	obj_t BGl_z62zc3anonymousza31407ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3860)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return BBOOL(((bool_t) 0));
		}
	}



/* &lambda1406 */
	obj_t BGl_z62lambda1406z62zz__evaluate_typesz00(obj_t BgL_envz00_3861,
		obj_t BgL_oz00_3862, obj_t BgL_vz00_3863)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return
				((((BgL_ev_varz00_bglt) CREF(
							((BgL_ev_varz00_bglt) BgL_oz00_3862)))->BgL_effz00) =
				((obj_t) BgL_vz00_3863), BUNSPEC);
		}
	}



/* &lambda1405 */
	obj_t BGl_z62lambda1405z62zz__evaluate_typesz00(obj_t BgL_envz00_3864,
		obj_t BgL_oz00_3865)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) CREF(
						((BgL_ev_varz00_bglt) BgL_oz00_3865)))->BgL_effz00);
		}
	}



/* &lambda1400 */
	obj_t BGl_z62lambda1400z62zz__evaluate_typesz00(obj_t BgL_envz00_3866,
		obj_t BgL_oz00_3867, obj_t BgL_vz00_3868)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return
				((((BgL_ev_varz00_bglt) CREF(
							((BgL_ev_varz00_bglt) BgL_oz00_3867)))->BgL_typez00) =
				((obj_t) BgL_vz00_3868), BUNSPEC);
		}
	}



/* &lambda1399 */
	obj_t BGl_z62lambda1399z62zz__evaluate_typesz00(obj_t BgL_envz00_3869,
		obj_t BgL_oz00_3870)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) CREF(
						((BgL_ev_varz00_bglt) BgL_oz00_3870)))->BgL_typez00);
		}
	}



/* &<anonymous:1385> */
	BgL_ev_exprz00_bglt
		BGl_z62zc3anonymousza31385ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3871,
		obj_t BgL_new1040z00_3872)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 49 */
			return ((BgL_ev_exprz00_bglt) BgL_new1040z00_3872);
		}
	}



/* &lambda1382 */
	BgL_ev_exprz00_bglt BGl_z62lambda1382z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3873)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 49 */
			{

				{	/* Eval/evaluate_types.scm 49 */
					BgL_ev_exprz00_bglt BgL_new1039z00_1014;

					BgL_new1039z00_1014 =
						((BgL_ev_exprz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_exprz00_bgl))));
					{	/* Eval/evaluate_types.scm 49 */
						long BgL_arg1384z00_1015;

						{	/* Eval/evaluate_types.scm 49 */
							long BgL_res2276z00_2494;

							BgL_res2276z00_2494 =
								BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00);
							BgL_arg1384z00_1015 = BgL_res2276z00_2494;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1039z00_1014), BgL_arg1384z00_1015);
					}
					{	/* Eval/evaluate_types.scm 49 */
						BgL_objectz00_bglt BgL_auxz00_5475;

						BgL_auxz00_5475 = ((BgL_objectz00_bglt) BgL_new1039z00_1014);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5475, BFALSE);
					}
					return BgL_new1039z00_1014;
				}
			}
		}
	}



/* &lambda1380 */
	BgL_ev_exprz00_bglt BGl_z62lambda1380z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3874)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 49 */
			{

				{	/* Eval/evaluate_types.scm 49 */
					BgL_ev_exprz00_bglt BgL_new1196z00_1010;

					{	/* Eval/evaluate_types.scm 49 */
						BgL_ev_exprz00_bglt BgL_new1195z00_1011;

						BgL_new1195z00_1011 =
							((BgL_ev_exprz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_exprz00_bgl))));
						{	/* Eval/evaluate_types.scm 49 */
							long BgL_arg1381z00_1012;

							{	/* Eval/evaluate_types.scm 49 */
								long BgL_res2275z00_2490;

								BgL_res2275z00_2490 =
									BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00);
								BgL_arg1381z00_1012 = BgL_res2275z00_2490;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1195z00_1011),
								BgL_arg1381z00_1012);
						}
						{	/* Eval/evaluate_types.scm 49 */
							BgL_objectz00_bglt BgL_auxz00_5482;

							BgL_auxz00_5482 = ((BgL_objectz00_bglt) BgL_new1195z00_1011);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5482, BFALSE);
						}
						BgL_new1196z00_1010 = BgL_new1195z00_1011;
					}
					return BgL_new1196z00_1010;
				}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 477830603),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 430898742),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 171970731),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 515402798),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 15272113),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 1047446),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 316564000),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 454272164),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					381113196),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					231310901),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460263214),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 482314420),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					47127928), BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 434147503),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 261215800),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
			return BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)
					116655667),
				BSTRING_TO_STRING(BGl_string2369z00zz__evaluate_typesz00));
		}
	}

#ifdef __cplusplus
}
#endif
